Package: terra
Type: Package
Title: Spatial Data Analysis
Version: 1.9-25
Date: 2026-05-04
Depends: R (>= 3.5.0), methods
Suggests: parallel, tinytest, ncdf4, sf (>= 0.9-8), deldir, XML,
        leaflet (>= 2.2.1), htmlwidgets, future, future.apply
LinkingTo: Rcpp
Imports: Rcpp (>= 1.0-10)
SystemRequirements: C++17, GDAL (>= 2.2.3), GEOS (>= 3.4.0), PROJ (>=
        4.9.3), TBB, sqlite3
Encoding: UTF-8
Language: en-US
Maintainer: Robert J. Hijmans <r.hijmans@gmail.com>
Description: Methods for spatial data analysis with vector (points, lines, polygons) and raster (grid) data. Methods for vector data include geometric operations such as intersect and buffer. Raster methods include local, focal, global, zonal and geometric operations. The predict and interpolate methods facilitate the use of regression type (interpolation, machine learning) models for spatial prediction, including with satellite remote sensing data. Processing of very large files is supported. See the manual and tutorials on <https://rspatial.org/> to get started.
License: GPL (>= 3)
URL: https://rspatial.org/, https://rspatial.github.io/terra/
BugReports: https://github.com/rspatial/terra/issues
LazyLoad: yes
Authors@R: c(
	person("Robert J.", "Hijmans", role=c("cre", "aut"),  
			email="r.hijmans@gmail.com", comment=c(ORCID="0000-0001-5872-2872")),			
    person("Andrew", "Brown", role="aut", comment=c(ORCID="0000-0002-4565-533X")),
    person("Márcia", "Barbosa", role="aut", comment=c(ORCID="0000-0001-8972-7713")),
    person("Krzysztof", "Dyba", role="ctb", comment=c(ORCID="0000-0002-8614-3816")),
    person("Roger", "Bivand", role="ctb", comment=c(ORCID="0000-0003-2392-6140")),
    person("Michael", "Chirico", role="ctb", comment=c(ORCID="0000-0003-0787-087X")),
    person("Emanuele", "Cordano", role="ctb",comment=c(ORCID="0000-0002-3508-5898")),
    person("Edzer", "Pebesma", role="ctb", comment=c(ORCID="0000-0001-8049-7069")),
    person("Barry", "Rowlingson", role="ctb", comment=c(ORCID="0000-0002-8586-6625")),
    person("Michael D.", "Sumner", role="ctb", comment=c(ORCID="0000-0002-2471-7511")))
NeedsCompilation: yes
Packaged: 2026-05-04 17:42:14 UTC; rhijm
Author: Robert J. Hijmans [cre, aut] (ORCID:
    <https://orcid.org/0000-0001-5872-2872>),
  Andrew Brown [aut] (ORCID: <https://orcid.org/0000-0002-4565-533X>),
  Márcia Barbosa [aut] (ORCID: <https://orcid.org/0000-0001-8972-7713>),
  Krzysztof Dyba [ctb] (ORCID: <https://orcid.org/0000-0002-8614-3816>),
  Roger Bivand [ctb] (ORCID: <https://orcid.org/0000-0003-2392-6140>),
  Michael Chirico [ctb] (ORCID: <https://orcid.org/0000-0003-0787-087X>),
  Emanuele Cordano [ctb] (ORCID: <https://orcid.org/0000-0002-3508-5898>),
  Edzer Pebesma [ctb] (ORCID: <https://orcid.org/0000-0001-8049-7069>),
  Barry Rowlingson [ctb] (ORCID: <https://orcid.org/0000-0002-8586-6625>),
  Michael D. Sumner [ctb] (ORCID:
    <https://orcid.org/0000-0002-2471-7511>)
Repository: CRAN
Date/Publication: 2026-05-06 07:50:02 UTC

# Author: Robert J. Hijmans
# Date :  December 2020
# Version 1.0
# License GPL v3


setMethod("inext", signature(x="SpatVector"),
	function(x, e, y=NULL, gap=0) {
	# the area used for scaling
		gap <- rep_len(gap, 2)
		e <- as.vector(e) + c(gap[1], -gap[1], gap[2], -gap[2])
		stopifnot((e[2] > e[1]) && (e[4] > e[3]))
		ex <- ext(x)
		x <- shift(x, e[1] - ex[1], e[3] - ex[3])
		ve <- ext(x)
		fx <- (e[2] - e[1]) / (ve[2] - ve[1])
		fy <- (e[4] - e[3]) / (ve[4] - ve[3])

		if (!is.null(y)) {
			y <- shift(y, e[1] - ex[1], e[3] - ex[3])
			rescale(y, fx=fx, fy=fy, e[1], e[3])
		} else {
			rescale(x, fx=fx, fy=fy, e[1], e[3])
		}
	}
)	


.inset <- function(x, e, loc="", scale=0.2, background="white", perimeter=TRUE, pper, box=NULL, pbox, add=TRUE, xpd=NA, offset=0.1, ...) {

	usr <- unlist(get.clip()[1:4])
	if (missing(e)) {
		e <- ext(usr)
		xe <- ext(x)
		r <- diff(xe[1:2]) / diff(xe[3:4])
		n <- scale * diff(e[1:2])
		e[2] <- e[1] + n
		e[3] <- e[4] - n / r
	}

	#offset <- 0.9
	offset <- 1 - offset
	offset <- max(0.1, min(1, offset))
	scale  <- offset * min(e / ext(x))

	y  <- rescale(x, scale)
	ey <- ext(y)
	xy <- c(mean(ey[1:2]), mean(ey[3:4]))
	xybox <- c(mean(e[1:2]), mean(e[3:4]))
	dx <- xybox[1] - xy[1]
	dy <- xybox[2] - xy[2]
	y  <- shift(y, dx, dy)
	if (!is.null(box)) {
		ex <- ext(x)
		box <- rescale(as.polygons(box), scale, x0=ex[1]+diff(ex[1:2])/2, y0=ex[3]+diff(ex[3:4])/2)
		box <- shift(box, dx, dy)
	}

	if ((loc != "") && (loc != "topleft")) {
		stopifnot(loc %in% c("bottomright", "bottom", "bottomleft", "left", "topleft", "top", "topright", "right", "center"))

		ex <- ext(x)
		if (grepl("top", loc)) {
			dy <- usr[4] - e[4]
		} else if (grepl("bottom", loc)) {
			dy <- usr[3] - e[3]
		} else {
			dy <- (usr[3] + diff(usr[3:4])/2) - (e[3] + diff(e[3:4])/2)
		}
		if (grepl("left", loc)) {
			dx <- usr[1] - e[1]
		} else if (grepl("right", loc)) {
			dx <- usr[2] - e[2]
		} else {
			dx <- (usr[1] + diff(usr[1:2])/2) - (e[1] + diff(e[1:2])/2)
		}
		y <- shift(y, dx, dy)
		e <- shift(e, dx, dy)
		if (!is.null(box)) {
			box <- shift(box, dx, dy)
		}
	}
	
	if (add) {
		if (!is.na(background)) {
			polys(as.polygons(e), col=background, lty=0, xpd=xpd)
		}
		plot(y, ..., axes=FALSE, legend=FALSE, add=TRUE, xpd=xpd)

		if (isTRUE(perimeter)) {
			if (missing(pper) || !is.list(pper)) {
				pper <- list()
			}
			#pper$x <- ext(y)
			pper$x <- e
			pper$xpd <- xpd
			do.call(lines, pper)
			#lines(e, col=perimeter)
		}

		if (!is.null(box)) {
			if (missing(pbox) || !is.list(pbox)) {
				pbox <- list()
			}
			pbox$x <- box
			pbox$xpd <- xpd
			do.call(lines, pbox)
		}
	}
	
	invisible(y)
}


setMethod("inset", signature(x="SpatVector"),
	function(x, e, loc="", scale=0.2, background="white", perimeter=TRUE, box=NULL, pper, pbox, offset=0.1, add=TRUE, ...) {
		.inset(x, e, loc=loc, scale=scale, background=background, perimeter=perimeter, pper=pper, box=box, pbox=pbox, offset=offset, add=add, ...)
	}
)


setMethod("inset", signature(x="SpatRaster"),
	function(x, e, loc="", scale=0.2, background="white", perimeter=TRUE, box=NULL, pper, pbox, offset=0.1, add=TRUE, ...) {
		.inset(x, e, loc=loc, scale=scale, background=background, perimeter=perimeter, pper=pper, box=box, pbox=pbox, offset=offset, add=add, ...)
	}
)

replace_with_label <- function(x, v, colnr) {
	ff <- is.factor(x)
	if (any(ff)) {
		cgs <- cats(x)
		for (f in which(ff)) {
			cg <- cgs[[f]]
			if (length(ff) == 1) {
				r <- 1:nrow(v)
			} else {
				r <- which(v[,1] == f)
			}
			i <- match(v[r,colnr], cg[,1])
			act <- activeCat(x, f) + 1
			if (!inherits(cg[[act]], "numeric")) {
				v[r, colnr] <- as.character(factor(cg[i, act], levels=unique(cg[[act]])))
			} else {
				v[r, colnr] <- cg[i, act]
			}
		}
	}
	v
}


setMethod("zonal", signature(x="SpatRaster", z="SpatRaster"),
	function(x, z, fun="mean", ..., w=NULL, wide=TRUE, as.raster=FALSE, filename="", overwrite=FALSE, wopt=list())  {

		group <- FALSE
		made_unique <- FALSE
		grast <- rast()
		nlz <- nlyr(z)
		znms <- names(z)
		if (nlz == 1) {
			group <- FALSE
		} else if ((!as.raster) && (nlz == 2)) {
			grast <- z[[2]]
			z <- z[[1]]
			group <- TRUE
		} else {
			ff <- is.factor(z)
			if (any(ff)) {
				levs <- levels(z)
				levels(z) <- NULL
			}
			z <- unique(z, as.raster=TRUE)
			made_unique <- TRUE
		}
		txtfun <- .makeTextFun(fun)
		if (inherits(txtfun, "character") && 
			(txtfun %in% c("max", "min", "mean", "sum", "notNA", "isNA"))) {

			if ((nlyr(z) > 1) && (nlyr(x) > 1)) {
				error("zonal", "x and z cannot both have more than one layer")
			}
			na.rm <- isTRUE(list(...)$na.rm)
			opt <- spatOptions()
			if (!is.null(w)) {
				if (txtfun != "mean") {
					error("zonal", "fun must be 'mean' when using weights")
				}
				sdf <- x@pntr$zonal_weighted(z@pntr, w@pntr, na.rm, opt)			
			} else {
				sdf <- x@pntr$zonal(z@pntr, grast@pntr, txtfun, na.rm, opt)
			}
			sdf <- messages(sdf, "zonal")
			out <- .getSpatDF(sdf)
			nz <- 1
			if (group) {
				out$layer <- out$layer + 1
				out <- replace_with_label(z, out, 2)
				out <- replace_with_label(grast, out, 3)
				if (nlyr(x) > 1) {
					out <- split(out[-1], out$layer)
					out <- Reduce(function(x, y) merge(x=x, y=y, by=1:2, all=TRUE), out)
					out <- out[order(out[,1], out[,2]), ]
				} else {
					out <- out[,-1]
				}
				colnames(out) <- c(znms, names(x))
				nz <- 2
			} else if (!as.raster) {
				if (made_unique) { # && (!as.raster)) {
					ulevs <- cats(z)[[1]][, -c(1:2)]
					if (any(ff)) {
						for (f in which(ff)) {
							i <- match(ulevs[,f], levs[[f]][,1])
							ulevs[,f] <- levs[[f]][i,2]
						}
					}
					out <- cbind(ulevs, out[,-1,drop=FALSE])
					nz <- ncol(ulevs)
				} else {
					out <- replace_with_label(z, out, 1)
					colnames(out)[1] <- znms
				}
			}
			colnames(out) <- make.unique(colnames(out))
		} else {
			if (!is.null(w)) {
				error("zonal", "can only use weights when fun=mean")
			}
			compareGeom(x, z, lyrs=FALSE, crs=FALSE, ext=TRUE, rowcol=TRUE)
			#if (nlyr(z) > 1) {
			#	warn("zonal", "z can only have one layer with this function")
			#	z <- z[[1]]
			#}

			fun <- match.fun(fun)
			nl <- nlyr(x)
			nms <- names(x)
			if (group) {
				gzx <- c(grast, z, x)
				v <- as.data.frame(gzx, na.rm=FALSE)
				out <- stats::aggregate(v[,-c(1:2)], v[,1:2], fun, ...)
				colnames(out)[-c(1:2)] <- nms			
			} else {
				for (i in 1:nl) {
					xz <- c(x[[i]], z)
					v <- as.data.frame(xz, na.rm=FALSE)
					d <- stats::aggregate(v[,1], v[,2,drop=FALSE], fun, ...)
					colnames(d)[2] <- nms[i]
					if (i == 1) {
						out <- d
					} else {
						out <- merge(out, d, by=1)				
					}
				}
			}
		}		
		if (as.raster) {
			if (is.null(wopt$names) && (nlyr(x) == 1)) {
				wopt$names <- names(x)
			}
			levels(z) <- NULL
			out <- subst(z, out[,1], out[,-1], filename=filename, wopt=wopt)
		}		
		if (wide) {
			if (group) {
				nms <- names(out)
				isch <- inherits(out[,2], "character")
				#out <- stats::reshape(out, direction="wide", idvar=nms[c(1,3)], timevar=nms[2])
				out <- stats::reshape(out, direction="wide", idvar=nms[1], timevar=nms[2])
				if (isch) {
					colnames(out) <- gsub(paste0("^", nms[3], "."), "", colnames(out))
				}
				if (inherits(txtfun, "character") && (txtfun == "sum")) {
					out[is.na(out)] <- 0
				}
			}
		} else { #if (nz == 1){
			nls <- as.character(1:nlyr(x))
			colnames(out)[-1] <- nls
			if (colnames(out)[1] == "layer") colnames(out)[1] <- "zone"
			out <- stats::reshape(out, direction="long", varying=nls, timevar="layer",v.names="value")
			out <- out[, c(2,1,3)]
			rownames(out) <- NULL
		}
		out
	}
)


setMethod("zonal", signature(x="SpatRaster", z="SpatVector"),
	function(x, z, fun="mean", na.rm=FALSE, w=NULL, weights=FALSE, exact=FALSE, touches=FALSE, small=TRUE, as.raster=FALSE, as.polygons=FALSE, wide=TRUE, filename="", wopt=list())  {
		opt <- spatOptions()
		txtfun <- .makeTextFun(fun)
		if (!inherits(txtfun, "character")) {
			error("zonal", "this 'fun' is not supported. You can use extract instead")
		} else {
			if (txtfun == "table") {
				if (!is.null(w)) {
					error("cannot use 'w' when 'fun=table'")
				}
				v <- x@pntr$zonal_poly_table(z@pntr, weights[1], exact[1], touches[1], small[1], na.rm, opt)
				messages(x, "zonal")

				v <- lapply(v, function(i) if (length(i) == 0) NA else i)
				v <- lapply(1:length(v), function(i) cbind(i, matrix(v[[i]], ncol=2)))
				v <- do.call(rbind, v)
				v <- as.data.frame(v)
				colnames(v) <- c("zone", "value", "count")
				ff <- is.factor(x)[1]
				if (ff) {
					cg <- cats(x)[[1]]
					i <- match(v$value, cg[,1])
					act <- activeCat(x, 1) + 1
					v$value <- cg[i, act]
				}
				if (as.polygons | wide) {
					nms <- names(v)
					uz <- unique(v$zone)
					v <- v[!is.na(v$value), ]
					if (nrow(v) == 0) return(v)					
					v <- stats::reshape(v, direction="wide", idvar=nms[1], timevar=nms[2])
					names(v) <- gsub("count.", "", names(v))
					v[is.na(v)] <- 0
					rownames(v) <- NULL
					uz <- uz[!(uz %in% v$zone)]
					if (length(uz) > 0) {
						r <- v[rep(1, length(uz)), ]
						r[, 1] <- uz
						r[, -1] <- 0
						v <- rbind(v, r)
						v <- v[order(v$zone), ]
					}
					v
				}
				if (as.polygons) {
					values(z) <- v
					return(z)
				}
				return(v)
			} else {
				if (is.null(w)) {
					out <- x@pntr$zonal_poly(z@pntr, txtfun, weights[1], exact[1], touches[1], small[1], na.rm, opt)
				} else {
					if (txtfun != "mean") {
						error("zonal", "fun must be 'mean' when using weights")
					}
					out <- x@pntr$zonal_poly_weighted(z@pntr, w@pntr, weights[1], exact[1], touches[1], small[1], na.rm, opt)
				}
				messages(out, "zonal")
				out <- .getSpatDF(out)
			}
		}
		if (as.raster) {
			if (is.null(wopt$names)) {
				wopt$names <- names(x)
			}
			x <- rasterize(z, x, 1:nrow(z))
			subst(x, 1:nrow(out), out, filename=filename, wopt=wopt)
		} else if (as.polygons) {
			cbind(z, out)	
		} else {
			out
		}
	}
)


setMethod("zonal", signature(x="SpatVector", z="SpatVector"),
	function(x, z, fun=mean, ..., weighted=FALSE, as.polygons=FALSE)  {
		if (geomtype(z) != "polygons") {
			error("zonal", "x must be points, and z must be polygons")
		}
		if (nrow(x) == 0) {
			error("zonal", "x is empty")
		}
		isn <- which(sapply(values(x[1,]), is.numeric))
		if (!any(isn)) {
			error("zonal", "x has no numeric variables (attributes) to aggregate")
		}
		x <- x[,isn]
		if (geomtype(x) == "points") {
			r <- !relate(x, z, "disjoint", pairs=FALSE)
			i <- apply(r, 1, function(i) if(any(i)) which(i) else (NA))
			if (length(i) == 0) {
				error("zonal", "there are no points in x that overlap with the polygons in z")
			}
			a <- aggregate(values(x), data.frame(zone=i), fun, ...)
		} else {
			if (as.polygons) {
				zz <- z
				values(zz) <- data.frame(zone = 1:nrow(zz))
				i <- intersect(zz, x)
			} else {
				values(z) <- data.frame(zone = 1:nrow(z))
				i <- intersect(z, x)
			}
			if (nrow(i) == 0) {
				error("zonal", "the intersection of x and z is empty")
			}
			v <- values(i)
			if (weighted) {
				if (geomtype(i) == "lines") {
					v$w <- perim(i)
				} else {
					v$w <- expanse(i)
				}
				s <- split(v, v$zone)
				n <- ncol(v)-2
				s <- lapply(s, function(d) {
						out <- rep(NA, n)
						for (i in 2:n) {
							out[i-1] <- weighted.mean(d[[i]], w = d$w)
						}
						out
					})
				a <- data.frame(as.integer(names(s)), do.call(rbind, s))
				colnames(a) <- names(v)[-ncol(v)]
			} else {
				a <- aggregate(v[,-1,drop=FALSE], v[,1,drop=FALSE], fun, ...)
			}
		}
		if (as.polygons) {
			f <- basename(tempfile())
			z[[f]] <- 1:nrow(z)
			names(a)[1] = f
			a <- merge(z, a, by=f, all.x=TRUE)
			a[[f]] <- NULL
		}
		a
	}
)


setMethod("global", signature(x="SpatRaster"),
	function(x, fun="mean", weights=NULL, maxcell=Inf, ...)  {

		nms <- names(x)
		nms <- make.unique(nms)
		txtfun <- .makeTextFun(fun)

		opt <- spatOptions()
		if (!is.null(weights)) {
			stopifnot(inherits(weights, "SpatRaster"))
			stopifnot(txtfun %in% c("mean", "sum"))
			na.rm <- isTRUE(list(...)$na.rm)
			tptr <- x@pntr$global_weighted_mean(weights@pntr, txtfun, na.rm, opt)
			messages(tptr, "global")
			res <- .getSpatDF(tptr)
			rownames(res) <- nms
			return(res)
		}

		if (inherits(txtfun, "character")) {		
			if (any(is.na(txtfun))) error("global", "fun cannot be NA")
			if (any(txtfun %in% c("anynotNA", "anyNA"))) {
				if (length(txtfun) > 1) error("global", "'anynotNA' and 'anyNA' can not be combined with other functions'")
				tptr <- x@pntr$globalTF(txtfun, opt)
				messages(tptr, "global")
				res <- .getSpatDF(tptr)
				rownames(res) <- nms
				return(res)			
			}
			if (all(txtfun %in% c("prod", "max", "min", "mean", "sum", "range", "rms", "sd", "std", "sdpop", "notNA", "isNA"))) {
				txtfun[txtfun == "sdpop"] <- "std"
				i <- grep("range", txtfun)
				if (length(i) > 0) {
					txtfun <- txtfun[-i]
					txtfun <- c(txtfun, "min", "max")
				}
				txtfun <- unique(txtfun)
				na.rm <- isTRUE(list(...)$na.rm)
				#if (isTRUE(list(...)$old)) {
				#	ptr <- x@pntr$global(txtfun, na.rm, opt)			
				#} else {
				tptr <- x@pntr$mglobal(txtfun, na.rm, opt)
				#}
				messages(tptr, "global")
				res <- .getSpatDF(tptr)
				rownames(res) <- nms
				return(res)
			}
		}

		nl <- nlyr(x)
		res <- list()
		if (is.finite(maxcell)) {
			maxcell <- round(maxcell)
			if (maxcell < 1) error("global", "maxcell should be positive")
			x <- spatSample(x, maxcell, "regular", as.raster=TRUE)
		}
		for (i in 1:nl) {
			res[[i]] <- fun(values(x[[i]]), ...)
		}
		res <- do.call(rbind, res)
		res <- data.frame(res)

		# more efficient but more risky:
		#apply(data.frame(x), 2, fun, ...)

		if ((ncol(res) == 1) && (colnames(res) == "res")) {
			colnames(res) <- "global"
		}

		rownames(res) <- nms
		res
	}
)



setMethod("freq", signature(x="SpatRaster"),
	function(x, digits=0, value=NULL, bylayer=TRUE, usenames=FALSE, zones=NULL, wide=FALSE, touches=FALSE) {
		
		if (!hasValues(x)) {
			warn("freq", "SpatRaster x has no cell values")
			d <- data.frame(layer=0, value=0.0, count=0)
			return(d[0,])
		}

		if (!is.null(zones)) {
			vna <- (!is.null(value) && is.na(value[1]))
#			if (vna) levels(x) <- NULL
			if (inherits(zones, "SpatVector")) {
				out <- vector("list", nrow(zones))
				for (i in 1:nrow(zones)) {
					z <- zones[i,]
					e <- align(ext(z), x, snap="near")
					if (!is.null(intersect(e, ext(x)))) {
						r <- crop(x, zones[i,], mask=TRUE, touches=touches, snap="out")
						if (vna) {
							ra <- rasterize(zones[i,], r, NA, background=0, touches=touches)
							r <- cover(ra, r)
						}
						f <- freq(r, digits=digits, value=value, bylayer=bylayer, usenames=usenames, zones=NULL)
						if (nrow(f) > 0) {
							f$zone <- i	
							out[[i]] <- f
						}
					}
				}
			} else if (inherits(zones, "SpatRaster")) {
				if (!hasValues(zones)) {
					error("freq", "zones SpatRaster has no cell values")
				}
				compareGeom(x, zones, crs=FALSE)
				if (nlyr(zones) > 1) zones <- zones[[1]]
				u <- unlist(unique(zones))
				out <- vector("list", length(u))
				for (i in 1:length(u)) {
					r <- mask(x, zones, maskvalues=u[i], inverse=TRUE)
					f <- freq(r, digits=digits, value=value, bylayer=bylayer, usenames=usenames, zones=NULL, wide=FALSE)
					if (nrow(f) > 0) {
						f$zone <- u[i]	
						out[[i]] <- f
					}
				}
			} else {
				error("freq", "zones must be a SpatVector or a SpatRaster")
			}
			out <- do.call(rbind, out)
			if (is.null(out)) return(out)
			out <- out[!is.na(out$count), ]
			if (nrow(out) == 0) return(out)
			out <- out[order(out$layer), ]
			if (wide) {
				out$count[is.na(out$count)] <- 0
				if (vna) {
					out$value <- "NA"
				}
				out <- stats::reshape(out, idvar=c("layer", "zone"), timevar="value", direction="wide")
				colnames(out) <- gsub("count.", "", colnames(out))
				out[is.na(out)] <- 0
			}
			return(out)
		}

		opt <- spatOptions()
		if (!bylayer) usenames <- FALSE

		if (!is.null(value)) {
			value <- unique(value)
			if (length(value) > 1) {
				error("freq", "value must have a length of one")
			}
			if (is.character(value)) {
				value <- value[value != ""]
				if (length(value) == 0) {
					error("freq", "no valid value")
				}
				ff <- is.factor(x)
				if (!any(ff)) {
					error("freq", "a character value is only meaningful for categorical rasters")
				}
				f <- freq(x[[ff]])
				if (usenames) {
					f$layer <- names(x)[f$layer]
				}
				f <- f[f$label == value,]
				return(f)
			}

			if (is.na(digits)) {
				v <- x@pntr$count(value, bylayer[1], FALSE, 0, opt)
			} else {
				v <- x@pntr$count(value, bylayer[1], TRUE, digits, opt)
				value <- round(value, digits)
			}
			if (bylayer) {
				v <- data.frame(layer=1:nlyr(x), value=value, count=v)
			} else {
				v <- data.frame(value=value, count=v)
			}

		} else {
			if (is.na(digits)) {
				v <- x@pntr$freq(bylayer[1], FALSE, 0, opt)
			} else {
				v <- x@pntr$freq(bylayer[1], TRUE, digits, opt)
			}
			v <- lapply(v, function(i) if (length(i) == 0) NA else i)

			v <- lapply(1:length(v), function(i) cbind(i, matrix(v[[i]], ncol=2)))
			v <- do.call(rbind, v)
			v <- as.data.frame(v)
			colnames(v) <- c("layer", "value", "count")
			ff <- is.factor(x)
			if (any(ff)) {
				cgs <- cats(x)
				v <- data.frame(v)
				for (f in which(ff)) {
					cg <- cgs[[f]]
					j <- which(v[,1] == f)
					i <- match(v[j,2], cg[,1])
					act <- activeCat(x, f) + 1
					if (!inherits(cg[[act]], "numeric")) {
						v[j, 2] <- as.character(factor(cg[i, act], levels=unique(cg[[act]])))
					} else {
						v[j, 2] <- cg[i, act]
					}
				}
			}
			if (!bylayer) {
#				if (nlyr(x) > 1)
#					v <- aggregate(v[,"count",drop=FALSE], v[,"value", drop=FALSE], sum)
#				} 
				v <- v[,-1]
			}
		}
		if (usenames) {
			v$layer <- names(x)[v$layer]
		}
		if (wide) {
			v$count[is.na(v$count)] <- 0
			if ((!is.null(value)) && is.na(value)) {
				v$value <- "NA"
			}
			v <- stats::reshape(v, idvar="layer", timevar="value", direction="wide")
			colnames(v) <- gsub("count.", "", colnames(v))
			v[is.na(v)] <- 0
		}
	
		v[!is.na(v$count), ]
	}
)





setMethod ("expanse", "SpatRaster",
	function(x, unit="m", transform=TRUE, byValue=FALSE, zones=NULL, wide=FALSE, usenames=FALSE) {
		opt <- spatOptions()
		if (!is.null(zones)) {
			if (!inherits(zones, "SpatRaster")) {
				error("expanse", "zones must be a SpatRaster")
			}
			compareGeom(x, zones, lyrs=FALSE, crs=FALSE, ext=TRUE, rowcol=TRUE)
			v <- x@pntr$sum_area_group(zones@pntr, unit[1], transform[1], byValue[1], opt)
			messages(x)
			v <- lapply(v, function(i) matrix(i, ncol=4, byrow=TRUE))
			v <- data.frame(do.call(rbind, v))
			colnames(v) <- c("layer", "value", "zone", "area")
			v[,1] <- v[,1] + 1
			if (byValue) {
				v <- replace_with_label(x, v, 2)	
				v <- replace_with_label(zones, v, 3)	
			} else {
				v <- replace_with_label(zones, v, 3)	
				v$value <- NULL
			}
			if (wide) {
				if (byValue) {
					v <- stats::reshape(v, idvar=c("layer", "zone"), timevar="value", direction="wide")
					colnames(v) <- gsub("area.", "", colnames(v))
				} else {
					v <- stats::reshape(v, idvar=c("layer"), timevar="zone", direction="wide")
					colnames(v) <- gsub("area.", "", colnames(v))
				}
				v[is.na(v)] <- 0
			}
		} else {
			v <- x@pntr$sum_area(unit, isTRUE(transform[1]), isTRUE(byValue[1]), opt)
			x <- messages(x, "expanse")
			if (byValue) {
				v <- lapply(1:length(v), function(i) cbind(i, matrix(v[[i]], ncol=2, byrow=TRUE)))
				v <- data.frame(do.call(rbind, v))
				colnames(v) <- c("layer", "value", "area")
				v <- replace_with_label(x, v, 2)	
			} else {
				v <- v[[1]]
				v <- data.frame(layer=1:length(v), area=v)
			}
			if (wide) {
				if (byValue) {
					v <- stats::reshape(v, idvar="layer", timevar="value", direction="wide")
					colnames(v) <- gsub("area.", "", colnames(v))
				}
				v[is.na(v)] <- 0
			}
		}
		if (usenames) {
			v$layer <- names(x)[v$layer]
		}
		v
	}
)

setMethod("blocks", signature(x="SpatRaster"),
	function(x, n=4) {
		opt <- spatOptions("", FALSE, ncopies=n)
		b <- x@pntr$getBlockSizeR(opt)
		b$row <- b$row + 1
		b
	}
)



setMethod("writeStart", signature(x="SpatRaster", filename="character"),
	function(x, filename="", overwrite=FALSE, n=4, sources="", ...) {
		filename <- path.expand(trimws(filename[1]))
		filename <- enc2utf8(filename)
		opt <- spatOptions(filename, overwrite, ncopies=n, ...)
		ok <- x@pntr$writeStart(opt, unique(sources))
		messages(x, "writeStart")
		b <- x@pntr$getBlockSizeWrite()
		b$row <- b$row + 1
		b
	}
)


setMethod("writeStop", signature(x="SpatRaster"),
	function(x) {
		success <- x@pntr$writeStop()
		messages(x, "writeStop")
		f <- sources(x)
		if (f != "") {
			x <- rast(f)
		}
		return(x)
	}
)

setMethod("writeValues", signature(x="SpatRaster", v="vector"),
	function(x, v, start, nrows) {
		success <- x@pntr$writeValues(v, start-1, nrows)
		messages(x, "writeValues")
		invisible(success)
	}
)


setMethod("writeRaster", signature(x="SpatRaster", filename="character"),
function(x, filename="", overwrite=FALSE, ...) {
	filename <- trimws(filename)
	stopifnot(filename != "")
	filename <- enc2utf8(filename)

	ftp <- list(...)$filetype[1]
	fext <- tools::file_ext(filename)
	if (any(fext %in% c("nc", "cdf")) && (is.null(ftp) || isTRUE(ftp=="netCDF"))) {
		warn("writeRaster", "consider writeCDF to write ncdf files")
	} 
	#else if ((length(fext)==1) && (any(fext == "rds")) && ((is.null(ftp)) || isTRUE(ftp=="RDS"))) {
	#	if ((!overwrite) && file.exists(filename)) {
	#		error("writeRaster", "Use 'overwrite=TRUE' to overwrite an existing file")
	#	}
	#	return(saveRDS(x, filename))
	#}
	opt <- spatOptions(filename, overwrite, ...)
	x@pntr <- x@pntr$writeRaster(opt)
	x <- messages(x, "writeRaster")
	invisible(rast(filename))
}
)


setMethod("update", signature(object="SpatRaster"),
	function(object, crs=FALSE, extent=FALSE, names=FALSE, cells=NULL, values=NULL, layer=0) {
		if (!is.null(cells) || !is.null(values)) {
			if (is.null(cells) || is.null(values)) {
				error("update", "provide both 'cells' and 'values'")
			}
			if (is.character(layer)) {
				layer <- match(layer, names(object))
				if (any(is.na(layer))) {
					error("update", "invalid layer name")
				}
			}
			layer <- round(layer)
			if (all(layer > 0)) {
				layers <- as.integer(layer - 1)
			} else {
				layers <- integer(0)
			}
			opt <- spatOptions()
			ok <- object@pntr$update_values(as.double(cells - 1), as.double(values), layers, opt)
			messages(object, "update")
		}
		if (crs || extent || names) {
			opt <- spatOptions()
			ok <- object@pntr$update_meta(names, crs, extent, opt)
			messages(object, "update")
		}
		invisible(object)
	}
)



get_filetype <- function(filename) {  
	fn <- tolower(filename)
	ext <- tools::file_ext(fn)
	ext2 <- gsub("^[^.]*\\.(.*).*$", "\\1", fn)
	if ((ext == "shp") || (ext == "shz") || (ext == "zip" && ext2 == "shp.zip")) {
		"ESRI Shapefile"
	} else if ((ext == "") || (ext == "gpkg") || (ext == "zip" && ext2 == "gpkg.zip")) {
		"GPKG"
	} else if (ext == "gdb") {
		"OpenFileGDB"
	} else if (ext == "gml") {
		"GML"
	} else if ((ext == "json") || (ext == "geojson")) {
		"GeoJSON"
	} else if (ext == "cdf") {
		"netCDF"
	} else if (ext == "svg") {
		"SVG"
	} else if (ext == "kml") {
		"KML"
	} else if (ext == "vct") {
		"Idrisi"
	} else if (ext == "rds") {
		"rds"
	} else if (ext == "tab") {
		"MapInfo File"
	} else if (ext == "gpx") {
		"GPX"
	} else {
		error("writeVector", "cannot guess filetype from filename")
	}
}

setMethod("writeVector", signature(x="SpatVector", filename="character"),
function(x, filename, filetype=NULL, layer=NULL, insert=FALSE, overwrite=FALSE, options="ENCODING=UTF-8") {

	filename <- path.expand(trimws(filename[1]))
	filename <- enc2utf8(filename)
	if (filename == "") {
		error("writeVector", "provide a filename")
	}
	if (is.null(filetype)) {
		filetype <- get_filetype(filename)
		if (filetype == "rds") {
			return(saveRDS(x, filename))
		}
	}
	if (is.null(layer)) layer <- tools::file_path_sans_ext(basename(filename))
	layer <- trimws(layer)

	if (is.null(options)) { options <- ""[0] }

	if (filetype == "ESRI Shapefile") {
		nms <- names(x)
		i <- nchar(nms) > 10
		if (any(i)) {
			nms[i] <- substr(nms[i], 1, 10)
			testnms <- make.unique(nms, sep="")
			if (!all(testnms == nms)) {
				i <- which(i)
				newnms <- substr(nms[i], 1, 9)
				newnms <- make.unique(newnms, sep="")
				j <- which(nchar(newnms) == 9)
				newnms[j] <- paste0(newnms[j], "0")
				nms[i] <- newnms
			}
			x@pntr <- x@pntr$deepcopy()
			names(x) <- nms
		}
	}
	success <- x@pntr$write(filename, layer, filetype, insert[1], overwrite[1], options)
	messages(x, "writeVector")
	invisible(TRUE)
}
)



# setMethod("writeVector", signature(x="SpatVectorProxy", filename="character"),
# function(x, filename, filetype=NULL, layer=NULL, insert=FALSE, overwrite=FALSE, options="ENCODING=UTF-8") {
	# filename <- trimws(filename)
	# filename <- enc2utf8(filename)
	# if (filename == "") {
		# error("writeVector", "provide a filename")
	# }
	# if (is.null(filetype)) {
		# filetype <- get_filetype(filename)
	# }
	# if (is.null(layer)) layer <- tools::file_path_sans_ext(basename(filename))
	# layer <- trimws(layer)

	# if (is.null(options)) { options <- ""[0] }

	# if (filetype == "ESRI Shapefile") {
		# nms <- names(x)
		# i <- nchar(nms) > 10
		# if (any(i)) {
			# nms[i] <- substr(nms[i], 1, 10)
			# testnms <- make.unique(nms, sep="")
			# if (!all(testnms == nms)) {
				# i <- which(i)
				# newnms <- substr(nms[i], 1, 9)
				# newnms <- make.unique(newnms, sep="")
				# j <- which(nchar(newnms) == 9)
				# newnms[j] <- paste0(newnms[j], "0")
				# nms[i] <- newnms
			# }
			# x@pntr <- x@pntr$deepcopy()
			# names(x) <- nms
		# }
	# }
	# success <- x@pntr$write_proxy(filename, layer, filetype, insert[1], FALSE, overwrite[1], options)
	# messages(x, "writeVector")
	# invisible(TRUE)
# }
# )

# Author: Robert J. Hijmans
# Date : December 2017
# Version 1.0
# License GPL v3

setMethod("readStart", signature(x="SpatRaster"),
	function(x) {
		success <- x@pntr$readStart()
		messages(x, "readStart")
		if (!success) error("readStart,SpatRaster", "cannot open file for reading")
		invisible(success)
	}
)

setMethod("readStart", signature(x="SpatRasterDataset"),
	function(x) {
		success <- x@pntr$readStart()
		messages(x, "readStart")
		if (!success) error("readStart,SpatRasterDataset", "cannot open file for reading")
		invisible(success)
	}
)

#setMethod("readStart", signature(x="SpatRasterDataset"),
#	function(x, ...) {
#		nsd <- length(x)
#		for (i in 1:nsd) {
#			y <- x[i]
#			success <- readStart(y)
#			x[i] <- y
#		}
#		messages(x, "readStart")
#		invisible(success)
#	}
#)


setMethod("readStop", signature(x="SpatRaster"),
	function(x) {
		success <- x@pntr$readStop()
		messages(x, "readStop")
		invisible(success)
	}
)

setMethod("readStop", signature(x="SpatRasterDataset"),
	function(x) {
		success <- x@pntr$readStop()
		messages(x, "readStop")
		invisible(success)
	}
)

setMethod("toMemory", signature(x="SpatRaster"),
	function(x) {
		x@pntr <- x@pntr$deepcopy()
		x@pntr$readAll()
		messages(x, "toMemory")
	}
)

setMethod("toMemory", signature(x="SpatRasterDataset"),
	function(x) {
		x@pntr <- x@pntr$deepcopy()
		x@pntr$readAll()
		messages(x, "toMemory")
	}
)

# Author: Robert J. Hijmans
# Date : January 2009 - December 2011
# Version 1.0
# License GPL v3


#.getClicks <- function(...) {
#	res <- list()
#	while(TRUE) {
#		loc <- graphics::locator(1, ...)
#		if (is.null(loc)) break
#		res <- c(res, loc)
#	}
#	matrix(res, ncol=2, byrow=TRUE)
#}

RStudio_warning <- function() {
	if (isTRUE(.terra_environment$RStudio_warned)) return()
	if (Sys.getenv("RSTUDIO_USER_IDENTITY") != "") {
		warn("'click', 'draw', 'zoom', and 'sel' may not work properly\nwith the default RStudio plotting window. See ?click")
	}
	try(.terra_environment$RStudio_warned <- TRUE, silent=TRUE)
}


.getCellFromClick <- function(x, n, type, id, ...) {
	#loc <- graphics::locator(n, type, ...)
	#xyCoords <- cbind(x=loc$x, y=loc$y)
	xyCoords <- RS_locator(n, type, ...)
	if (id) {
		text(xyCoords, labels=1:n)
	}
	cells <- cellFromXY(x, xyCoords)
	cells <- unique(stats::na.omit(cells))
	if (length(cells) == 0 ) {
		error("click", "no valid cells selected")
	}
	cells
}



do_click <- function(type="p", id=FALSE, i=1, pch=20, ...) {
	p <- graphics::locator(1)
	if (is.null(p)) return(p) # ESC
	points(p$x, p$y, type=type, pch=pch, ...)
	if (id) {
		text(p$x, p$y, labels=i, pos=4, ...)
	}
	cbind(x=p$x, y=p$y)
}


setMethod("click", signature(x="missing"),
	function(x, n=10, id=FALSE, type="p", show=TRUE, ...) {
	
		RStudio_warning()
	
		#loc <- graphics::locator(n, type, ...)
		#cbind(x=loc$x, y=loc$y)
		n <- max(1, round(n))
		X <- NULL
		if (show) {
			on.exit(return(invisible(X)))
		} else {
			on.exit(return(X))
		}
		for (i in 1:n) {
			x <- do_click(type=type, id=id, i=i, ...)
			if (is.null(x)) break
			X <- rbind(X, x)
			if (show) {
				rownames(x) <- i
				print(x); 
				utils::flush.console()
			}
		}
	}
)


setMethod("click", signature(x="SpatRaster"),
	function(x, n=10, id=FALSE, xy=FALSE, cell=FALSE, type="p", show=TRUE, ...) {

	RStudio_warning()

	n <- max(round(n), 1)
	values <- NULL
	if (show) {
		on.exit(return(invisible(values)))
	} else {
		on.exit(return(values))
	}

	for (i in 1:n) {
		p <- do_click(type=type, id=id, i=i, ...)
		if (is.null(p)) break
		celln <- cellFromXY(x, p)
		if (is.na(celln)) next
		value <- x[celln]
		if (cell) {
			value <- data.frame(cell=celln, value)
		}
		if (xy) {
			p <- xyFromCell(x, celln)
			colnames(p) <- c("x", "y")
			value <- data.frame(p, value)
		}
		if (show) {
			rownames(value) <- i
			print(value)
			utils::flush.console()
		}
#		if (is.null(dim(value))) {
#			value <- matrix(value)
#			colnames(value) <- names(x)
#		}
		values <- rbind(values, value)
	}
})



setMethod("click", signature(x="SpatVector"),
	function(x, n=10, id=FALSE, xy=FALSE, type="p", show=TRUE, ...) {

		RStudio_warning()

		n <- max(round(n), 1)
		values <- xys <- NULL
		if (show) {
			on.exit(return(invisible(values)))
		} else {
			on.exit(return(values))
		}

		for (i in 1:n) {
			p <- do_click(type=type, id=id, i=i, ...)
			if (is.null(p)) break
			e <- extract(x, vect(p))
			if (xy) {
				e <- cbind(e[,1], x=p$x, y=p$y, e[,-1,drop=FALSE])
			}
			names(e)[1] <- "ID"
			if (show) {
				rownames(e) <- i
				if (!id) {
					print(e[,-1])
				} else {
					print(e)
				}
				utils::flush.console()
			}
			values <- rbind(values, e)
		}
	}
)

..gaps <- function(x) {
	p <- as.polygons(floor(ext(x)+1), crs=crs(x))
	e <- disagg(erase(p, x))
	if (nrow(e) > 1) {
		xmin = ext(p)[1]
		i <- sapply(1:nrow(e), function(i) ext(e[i])[1] > xmin)
		e <- e[i]
		x <- rbind(x, e)
	}
	x
}


clean_further <- function(x, tolerance=0.0001) {
	out <- as.lines(x)
	out <- snap(out, tolerance)
	out <- makeNodes(out)
	out <- mergeLines(out)
	as.polygons(out)
}

clean <- function(x) {
	g <- gaps(x)
	out <- erase(x)
	out <- rbind(out, g)
	g <- gaps(out)
	rbind(out, g)
}


mergebyborder <- function(x, field) {
	i <- is.na(x[[field, drop=TRUE]])
	if (!any(i)) return(x)
	s <- sharedPaths(x)
	s$length <- perim(s)
	from <- x[i]
	x <- x[!i]

	for (i in 1:nrow(from)) {


	}
}



centerline <- function(p) {
	v <- as.points(voronoi(p, tolerance=0))
	v <- intersect(v, p)
	v
}



#library(terra); messages = terra:::messages
#p <- vect(system.file("ex/lux.shp", package="terra"))
#h <- convHull(p[-12], "NAME_1")
#x <- clean(h)
#y <- clean_further(x)

#hh <- rbind(h, h)
#e <- erase(hh)
#g <- gaps(e)

#v1 = as.polygons(ext(0,1,0,1))
#v2 = as.polygons(ext(1.01,2,0,1))
#v <- rbind(v1, v2)
#s = snap(v)

# Author: Robert J. Hijmans
# Date : October 2022
# Version 1.0
# License GPL v3


check_ngb_pars <- function(algo, pars, fill, caller="rasterizeWin") {
	#p <- c("Power", "Smoothing", "Radius", "Radius1", "Radius2", "Angle", "nMaxPoints", "nMinPoints")
	n <- tolower(names(pars))
	if (length(n) == 0) error(caller, "parameters are not named") 
	if (algo %in%  c("min", "max", "range", "mean", "count", "distto", "distbetween")) {
		pex <- c("Radius1", "Radius2", "Angle", "MinPoints")
	} else if (algo == "invdistpow") {
		pex <- c("Power", "Smoothing", "Radius1", "Radius2", "Angle", "MaxPoints", "MinPoints")
	} else if (algo == "invdistpownear") {
		pex <- c("Power", "Smoothing", "Radius", "MaxPoints", "MinPoints")
	} else if (algo == "nearest") {
		pex <- c("Radius1", "Radius2", "Angle")
	} else if (algo == "linear") {
		pex <- c("Radius")
	} else {
		error(caller, "invalid algorithm name")
	}
	if (length(n) != length(pex)) error(caller, paste("expected 4 parameters for", algo, "got",  length(n)))
	if (!all(n %in% tolower(pex)))error(caller, paste("parameters needed for", algo, ":\n  ", paste(pex, collapse=",")))
	c(pars[match(n, tolower(pex))], fill)
}


get_z <- function(y, field, caller="rasterizeWin") {
	if (inherits(field, "character")) {
		if (length(field) == 0) {
			error(caller, "field name missing")
		}
		if (!all(field %in% names(y))) {
			f <- paste(field[!(field %in% names(y))], collapse=", ")
			error(caller, paste(f, " is not a name in y"))
		}
		z <- y[, field, drop=TRUE]
		#if (any(!sapply(z, is.numeric))) {
		#	error(caller, paste("fields must be numeric"))
		#}
	} else {
		#if (!is.numeric(field)) {
		#	error(caller, paste(field, "is not numeric"))
		#}
		z <- data.frame(field=rep_len(field, nrow(y)))
	}
	z
}

get_rad <- function(r, caller="rasterizeWin") {
	if (length(r) == 1) {
		c(r, r, 0)
	} else if (length(r) == 2) {
		c(r, 0)
	} else if (length(r) == 3) {
		r[3] = r[3] %% 360
		if (r[3] < 0) r[3] = r[3] + 360;
		r
	} else {
		error(caller, "radius argument should have length 1, 2, or 3")
	}
}


rastWinR <- function(x, y, win, pars, fun, nl, cvars, filename, wopt, ...) {

	out <- rast(x, nlyr=nl)
	rb <- rast(out)
	e <- ext(out)
	hy <- yres(out)/2

	opt <- spatOptions()
	b <- writeStart(out, filename, n=12, sources="", wopt=wopt)
	if ((ncol(y) == 3) && (is.numeric(y[,3]))) {
		for (i in 1:b$n) {
			e$ymax <- yFromRow(out, b$row[i]) + hy
			e$ymin <- yFromRow(out, b$row[i]  + b$nrows[i] - 1) - hy
			rbe <- crop(rb, e)
			if (win == "rectangle") {
				p <- rbe@pntr$winrect(y[,1], y[,2], y[,3], pars, opt)
			} else {
				p <- rbe@pntr$wincircle(y[,1], y[,2], y[,3], pars, opt)
			}

			if ((pars[4] > 1) && (length(p[[1]]) > 0)) {
				a <- aggregate(p[[1]], p[1], length)
				a <- a[a[,2] >= pars[4], 1]
				a <- p[[1]] %in% a
				p[[1]] <- p[[1]][a]
				p[[2]] <- p[[2]][a]
			} 

			if (length(p[[1]]) > 0) {
				p <- aggregate(p[2], p[1], fun, ...)
				v <- matrix(pars[5], ncell(rbe), nl)
				v[p[,1]+1, ] <- p[,-1]
				writeValues(out, v, b$row[i], b$nrows[i])
			} else {
				writeValues(out, rep(pars[5], ncell(rbe) * nl), b$row[i], b$nrows[i])
			}
		}
	} else {
		id <- 1:nrow(y)
		for (i in 1:b$n) {
			e$ymax <- yFromRow(out, b$row[i]) + hy
			e$ymin <- yFromRow(out, b$row[i]  + b$nrows[i] - 1) - hy
			rbe <- crop(rb, e)
			if (win == "rectangle") {
				p <- rbe@pntr$winrect(y[,1], y[,2], id, pars, opt)
			} else {
				p <- rbe@pntr$wincircle(y[,1], y[,2], id, pars, opt)
			}

			if ((pars[4] > 1) && (length(p[[1]]) > 0)) {
				a <- aggregate(p[[1]], p[1], length)
				a <- a[a[,2] >= pars[4], 1]
				a <- p[[1]] %in% a
				p[[1]] <- p[[1]][a]
				p[[2]] <- p[[2]][a]
			} 
	
			if (length(p[[1]]) > 0) {
				py <- y[p[[2]],3:ncol(y)]
				v <- matrix(pars[5], ncell(rbe), nl)
				if (cvars) {
					#u <- unique(p[[1]])
					#if (usedots) {
					#	p <- sapply(u, function(i) fun(py[p[[1]]==i, ,drop=FALSE], ...))
					#} else {
					#	p <- sapply(u, function(i) fun(py[p[[1]]==i, ,drop=FALSE]))
					#}
					p <- split(py, p[[1]])
					p <- sapply(p, fun, ...)
					if (!is.null(dim(p))) {
						p <- t(as.matrix(p))
						u <- rownames(p)
					} else {
						u <- names(p)
					}
					u <- as.numeric(u)
					v[u+1, ] <- p
				} else {
					p <- aggregate(py, p[1], fun, ...)
					v[p[,1]+1, ] <- as.matrix(p[,-1])
				}
				writeValues(out, v, b$row[i], b$nrows[i])
			} else {
				writeValues(out, rep(pars[5], ncell(rbe) * nl), b$row[i], b$nrows[i])
			}
		}
	}
	writeStop(out)
}


rastBufR <- function(x, y, win, pars, fun, nl, cvars, filename, wopt, ...) {
	w <- pars[1]
	z <- y[,-c(1:2), drop=FALSE]
	y <- vect(y[,1:2,drop=FALSE], geom=c("x", "y"))
	out <- rast(x, nlyr=1)
	rb <- rast(out)
	if (!is.lonlat(x)) {
		ngb <- max(round(w/yres(x)), round(w/xres(x)))
		if (ngb <= 5) {
			m <- matrix(1, 2*round(w/yres(x))+1, 2*round(w/xres(x))+1)
			rb <- rasterize(y, rb)
			rb <- focal(rb, m, "sum", na.rm=TRUE)
		} 
	}
	out <- rast(x, nlyr=nl)
	ncs <- ncol(out)
	e <- ext(out)
	hy <- yres(out)/2
	off <- 0
	b <- writeStart(out, filename, n=12, sources="", wopt=wopt)

	for (i in 1:b$n) {
		e$ymax <- yFromRow(out, b$row[i]) + hy
		e$ymin <- yFromRow(out, b$row[i] + b$nrows[i] - 1) - hy
		rbe <- crop(rb, e)
		buf <- as.polygons(rbe, dissolve=FALSE)
		buf <- buffer(buf, w)
		r <- relate(buf, y, "intersects", pairs=TRUE)
		if ((pars[4] > 1) && (nrow(r) > 0)) {
			a <- aggregate(r[,1], list(r[,1]), length)
			a <- a[a[,2] >= pars[4], 1]
			r <- r[r[,1] %in% a, ]
		} 
		if (nrow(r) > 0) {
			v <- matrix(pars[5], ncell(rbe), nl)
			if ((ncol(z) == 1) || (!cvars)) {
				f <- aggregate(z[r[,2],,drop=FALSE], list(r[,1]), fun, ...)
				v[f[,1], ] <- f[,-1]
				writeValues(out, v, b$row[i], b$nrows[i])
			} else {
				#u <- unique(r[,1])
				#p <- z[r[,2], ,drop=FALSE]
				#if (usedots) {
				#	p <- sapply(u, function(i) fun(p[r[,1]==i, ,drop=FALSE], ...))
				#} else {
				#	p <- sapply(u, function(i) fun(p[r[,1]==i, ,drop=FALSE]))
				#}
				#if (!is.null(dim(p))) p <- t(p)
				#v[u, ] <- as.matrix(p)

				py <- z[r[,2], ,drop=FALSE]
				s <- split(py, r[,1])
				p <- sapply(s, fun, ...)
				if (!is.null(dim(p))) {
					p <- t(as.matrix(p))
					u <- as.numeric(rownames(p))
				} else {
					u <- as.numeric(names(p))
				}
				v[u, ] <- p
				writeValues(out, v, b$row[i], b$nrows[i])
			}
		} else {
			writeValues(out, rep(pars[5], ncell(rbe) * nl), b$row[i], b$nrows[i])
		}
	}
	writeStop(out)
}


setMethod("rasterizeWin", signature(x="data.frame", y="SpatRaster"),
	function(x, y, win="circle", pars, fun, ..., cvars=FALSE, minPoints=1, fill=NA, filename="", wopt=list()) {

		pars <- c(get_rad(pars), minPoints[1], fill[1])
		if (ncol(x) < 3) {
			error("rasterizeNGB", "expecting a matrix with at least three columns")
		}
		win <- match.arg(tolower(win), c("circle", "ellipse", "rectangle", "buffer"))

#		usedots <- length(list(...)) > 0
		if (ncol(x) == 3) cvars = FALSE
		if (inherits(fun, "character")) {
			if (fun[1] == "count") {
				fun <- length
				pars[5] = 0
			}
			nl <- ncol(x)-2
		} else {
			if (cvars) {
				i <- min(10, nrow(x))
				v <- x[1:i, -c(1:2)]
				test <- sapply(list(v), fun, ...)
				nl <- length(test)
			} else {
				test <- sapply(list(1:5), fun, ...)
				nl <- length(test) * (ncol(x)-2)
			}
		}

		if (win == "buffer") {
			rastBufR(y, x, win, pars=pars, fun=fun, nl=nl, cvars=cvars, filename=filename, wopt=wopt, ...)
		} else {
			if (win == "circle") {
				pars[2] = pars[1]
				pars[3] = 0;
			}
			algo <- .makeTextFun(fun)
			#algos <- c("min", "max", "range", "mean", "count", "distto", "distbetween")
			algos <- c("distto", "distbetween")
			builtin <- FALSE
			if (inherits(algo, "character") && (algo %in% algos)) {
				if (win == "rectangle") {
					error("rasterizeWin", paste(fun, "not yet available for 'win=rectangle'"))
				} else {
					opt <- spatOptions(filename, wopt=wopt)
					x@pntr <- x@pntr$rasterizeWindow(x[,1], x[,2], x[,3], algo, pars, opt)
					return(messages(x, "rasterizeWin"))
				}
			} 
			rastWinR(x=y, y=x, win=win, pars=pars, fun=fun, nl=nl, cvars=cvars, filename=filename, wopt=wopt, ...)
		}
	}
)

setMethod("rasterizeWin", signature(x="SpatVector", y="SpatRaster"),
	function(x, y, field, win="circle", pars, fun, ..., cvars=FALSE, minPoints=1, fill=NA, filename="", wopt=list()) {
		if (geomtype(x) != "points") {
			error("rasterizeWin", "SpatVector y must have a point geometry")
		}
		x <- cbind(crds(x), get_z(x, field, "rasterizeWin"))
		rasterizeWin(x, y, win=win, pars=pars, fun=fun, minPoints=minPoints, fill=fill, cvars=cvars, filename=filename, wopt=wopt, ...)
	}
)




setMethod("interpNear", signature(x="SpatRaster", y="matrix"),
	function(x, y, radius, interpolate=FALSE, fill=NA, filename="", ...) {

		if (ncol(y) != 3) {
			error("interpNear", "expecting a matrix with three columns")
		}
		if (!is.numeric(y)) {
			error("interpNear", "values must be numeric")
		}

		if (interpolate) {
			algo <- "linear"
			pars <- c(radius[1], fill)
		} else {
			algo <- "nearest"	
			pars <- c(get_rad(radius, "interpNear"), fill)
		}

		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$rasterizeWindow(y[,1], y[,2], y[,3], algo, pars, opt)
		messages(x, "interpNear")
	}
)


setMethod("interpNear", signature(x="SpatRaster", y="SpatVector"),
	function(x, y, field, radius, interpolate=FALSE, fill=NA, filename="", ...) {
		if (geomtype(y) != "points") {
			error("interpNear", "SpatVector y must have a point geometry")
		}
		y <- cbind(crds(y), get_z(y, field, "interpNear"))
		y <- as.matrix(y)
		interpNear(x, y, radius=radius, interpolate=interpolate, fill=fill, filename=filename, ...)
	}
)


setMethod("interpIDW", signature(x="SpatRaster", y="matrix"),
	function(x, y, radius, power=2, smooth=0, maxPoints=Inf, minPoints=1, near=TRUE, fill=NA, filename="", ...) {

		if (ncol(y) != 3) {
			error("interpIDW", "expecting a matrix with three columns")
		}
		if (!is.numeric(y)) {
			error("interpIDW", "values must be numeric")
		}

		if (near) {
			algo <- "invdistpownear"
			pars <- c(power, smooth, radius[1], maxPoints, minPoints, fill)
		} else {
			algo <- "invdistpow"
			pars <- c(power, smooth, get_rad(radius, "interpIDW"), maxPoints, minPoints, fill)
		}

		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$rasterizeWindow(y[,1], y[,2], y[,3], algo, pars, opt)
		messages(x, "interpIDW")
	}
)


setMethod("interpIDW", signature(x="SpatRaster", y="SpatVector"),
	function(x, y, field, radius, power=2, smooth=0, maxPoints=Inf, minPoints=1, near=TRUE, fill=NA, filename="", ...) {
		if (geomtype(y) != "points") {
			error("interpIDW", "SpatVector y must have a point geometry")
		}
		y <- cbind(crds(y), get_z(y, field, "interpIDW"))
		y <- as.matrix(y)
		interpIDW(x, y, radius, power=power, smooth=smooth, maxPoints=maxPoints, minPoints=minPoints, near=near, fill=fill, filename=filename, ...)
	}
)

set.clip <- function(clp, geo) {
	# remove non-existing ones
	x <- grDevices::dev.list()
	x <- paste(names(x), x, sep="_")
	e <- .terra_environment$devs
	e <- e[e[,1] %in% x, ]

	graphics::clip(clp[1], clp[2], clp[3], clp[4])

	d <- grDevices::dev.cur()
	d <- data.frame(dev=paste(names(d), d[[1]], sep="_"), rbind(clp), geo=geo, row.names="")
	# remove one with the same name/number 
	e <- e[!(e[,1] %in% d[1]), ]
	e <- rbind(e, d)
	.terra_environment$devs <- e
}

get.clip <- function() {
	d <- grDevices::dev.cur()
	dev <- paste(names(d), d[[1]], sep="_")
	e <- .terra_environment$devs
	i <- match(dev, e[,1])[1]
	if (is.na(i)) {
		NULL
	} else {
		e[i[1],-1]
	}
}

reset.clip <- function() {
	g <- get.clip()
	if (!is.null(g)) {
		graphics::clip(g[[1]], g[[2]], g[[3]], g[[4]])
	}
}


map_extent <- function() {
	get.clip()
}

# Author: Robert J. Hijmans
# Date :  October 2017
# Version 1.0
# License GPL v3

point_on_border <- function(r, x, y, tolerance = sqrt(.Machine$double.eps)) {
    v <- h <- (x >= xmin(r)) & (x <= xmax(r)) & (y >= ymin(r)) & (y <= ymax(r))
    v[v] <- ((x[v] - xmin(r)) %% res(r)[1]) < tolerance
    h[h] <- ((y[h] - ymin(r)) %% res(r)[2]) < tolerance
    h | v
}


setMethod("yFromRow", signature(object="SpatRaster", row="numeric"),
	function(object, row) {
		object@pntr$yFromRow(row - 1)
	}
)

setMethod("yFromRow", signature(object="SpatRaster", row="missing"),
	function(object, row) {
	  row <- seq_len(object@pntr$nrow())
		object@pntr$yFromRow(row - 1)
	}
)

setMethod("xFromCol", signature(object="SpatRaster", col="numeric"),
	function(object, col) {
		object@pntr$xFromCol(col - 1)
	}
)
setMethod("xFromCol", signature(object="SpatRaster", col="missing"),
	function(object, col) {
	  col <- seq_len(object@pntr$ncol())
		object@pntr$xFromCol(col - 1)
	}
)

setMethod("colFromX", signature(object="SpatRaster", x="numeric"),
	function(object, x)	{
		cols <- object@pntr$colFromX(x) + 1
		cols[cols==0] <- NA
		cols
	}
)

setMethod("rowFromY", signature(object="SpatRaster", y="numeric"),
	function(object, y)	{
		rows <- object@pntr$rowFromY(y) + 1
		rows[rows==0] <- NA
		rows
	}
)

setMethod("cellFromXY", signature(object="SpatRaster", xy="matrix"),
	function(object, xy) {
		stopifnot(ncol(xy) == 2)
		#.checkXYnames(colnames(xy))
		object@pntr$cellFromXY(as.numeric(xy[,1]), as.numeric(xy[,2]), as.numeric(NA)) + 1
	}
)

setMethod("cellFromXY", signature(object="SpatRaster", xy="data.frame"),
	function(object, xy) {
		stopifnot(ncol(xy) == 2)
		#.checkXYnames(colnames(xy))
		object@pntr$cellFromXY(as.numeric(xy[,1]), as.numeric(xy[,2]), as.numeric(NA)) + 1
	}
)



setMethod("cellFromRowCol", signature(object="SpatRaster", row="numeric", col="numeric"),
	function(object, row, col) {
		object@pntr$cellFromRowCol(row-1, col-1) + 1
	}
)

setMethod("cellFromRowColCombine", signature(object="SpatRaster", row="numeric", col="numeric"),
	function(object, row, col) {
		object@pntr$cellFromRowColCombine(row-1, col-1) + 1
	}
)

setMethod("rowColCombine", signature(object="SpatRaster", row="numeric", col="numeric"),
	function(object, row, col) {
		cell <- object@pntr$cellFromRowColCombine(row-1, col-1)
		rc <- object@pntr$rowColFromCell(cell)
		rc <- do.call(cbind, rc)
		rc[rc < 0] <- NA
		rc+1
	}
)


setMethod("xyFromCell", signature(object="SpatRaster", cell="numeric"),
	function(object, cell) {
		xy <- object@pntr$xyFromCell(cell-1)
		xy <- do.call(cbind, xy)
		colnames(xy) <- c("x", "y")
		xy
	}
)

setMethod("yFromCell", signature(object="SpatRaster", cell="numeric"),
	function(object, cell) {
		xyFromCell(object, cell)[,2]
	}

)

setMethod("xFromCell", signature(object="SpatRaster", cell="numeric"),
	function(object, cell) {
		xyFromCell(object, cell)[,1]
	}
)

setMethod("rowColFromCell", signature(object="SpatRaster", cell="numeric"),
	function(object, cell) {
		rc <- object@pntr$rowColFromCell(cell-1)
		rc <- do.call(cbind, rc)
		rc[rc < 0] <- NA
		rc+1
	}
)

setMethod("rowFromCell", signature(object="SpatRaster", cell="numeric"),
	function(object, cell) {
		rowColFromCell(object, cell)[,1]
	}
)

setMethod("colFromCell", signature(object="SpatRaster", cell="numeric"),
	function(object, cell) {
		rowColFromCell(object, cell)[,2]
	}
)


.rep_fun <- function(v, n, N, m) {
	if (is.null(v)) {
		v
	} else if (n == 1) {
		replicate(N, v, FALSE)
	} else if (n == N) {
		as.list(v)
	} else if ((n == m) && all(v==(1:m))) {
		NULL
	} else {
		error("rcl", "if one argument is a list, the others should be a list,\n       or a vector of length 1, or have the length of the list argument")
	}
}


setMethod(rcl, signature(x="SpatRaster"),
	function(x, row=NULL, col=NULL, lyr=NULL) {

		lr <- is.list(row)
		lc <- is.list(col)
		ll <- is.list(lyr)
		ln <- sum(lr, lc, ll)
		if (ln > 0) {
			nr <- length(row)
			nc <- length(col)
			nl <- length(lyr)
			N <- unique(c(nr, nc, nl)[c(lr, lc, ll)])
			if (length(N) > 1) {
				N <- max(N)
				islst <- which(c(lr, lc, ll))
				for (i in islst) {
					if (i == 1) {
						row <- rep_len(row, N)
					} else if (i == 2) {
						col <- rep_len(col, N)
					} else {
						lyr <- rep_len(lyr, N)
					}
				}
			}
			notlst <- which(!c(lr, lc, ll))
			for (i in notlst) {
				if (i == 1) {
					row <- .rep_fun(row, nr, N, nrow(x))
				} else if (i == 2) {
					col <- .rep_fun(col, nc, N, ncol(x))
				} else {
					lyr <- .rep_fun(lyr, nl, N, nlyr(x))
				}
			}
			out <- lapply(1:N, function(i) { rcl(x, row[[i]], col[[i]], lyr[[i]]) })
			do.call(rbind, out)
		} else {
			hr <- !is.null(row)
			hc <- !is.null(col)
			hl <- !is.null(lyr)
			n <- sum(hr, hc, hl)

			if (hl) {
				lyr[!c(lyr %in% 1:nlyr(x))] <- NA 
			}
			if (n == 0) {
				out <- rowColFromCell(x, 1:ncell(x))
				out <- cbind(out[,1], out[,2], rep(1:nlyr(x), each=nrow(out)))
				colnames(out) <- c("row", "col", "lyr")
				return(out)
			} else if (hr & hc & hl) {
				out <- rowColCombine(x, row, col)
				out <- cbind(out[,1], out[,2], rep(lyr, each=nrow(out)))
			} else if (!hc) {
				out <- rowColCombine(x, row, 1:ncol(x))
				if (hl) {
					out <- cbind(out[,1], out[,2], rep(lyr, each=nrow(out)))
				} else {
					out <- cbind(out[,1], out[,2], rep(1:nlyr(x), each=nrow(out)))
				}
			} else if (!hr) {
				out <- rowColCombine(x, 1:nrow(x), col)
				if (hl) {
					out <- cbind(out[,1], out[,2], rep(lyr, each=nrow(out)))
				} else {
					out <- cbind(out[,1], out[,2], rep(1:nlyr(x), each=nrow(out)))
				}
			} else if (!hl) {
				out <- rowColCombine(x, row, col)
				out <- cbind(out[,1], out[,2], rep(1:nlyr(x), each=nrow(out)))
			}
			colnames(out) <- c("row", "col", "lyr")
			out
		}
	}
)

#if (!isGeneric("#")) { setGeneric("#", function(x, ...) standardGeneric("#")) }
#if (!isGeneric("prcomp")) {setGeneric("prcomp", function(x, ...) standardGeneric("princomp"))}

## ADDED BY ecor
if (!isGeneric("watershed")) {setGeneric("watershed", function(x, ...) standardGeneric("watershed"))}
if (!isGeneric("pitfinder")) {setGeneric("pitfinder", function(x, ...) standardGeneric("pitfinder"))}
if (!isGeneric("NIDP")) {setGeneric("NIDP", function(x, ...) standardGeneric("NIDP"))}
if (!isGeneric("flowAccumulation")) {setGeneric("flowAccumulation", function(x, ...) standardGeneric("flowAccumulation"))}
if (!isGeneric("flowDir")) {setGeneric("flowDir", function(x, ...) standardGeneric("flowDir"))}
if (!isGeneric("pitfiller")) {setGeneric("pitfiller", function(x, pit, ...) standardGeneric("pitfiller"))}

if (!isGeneric("tessellate")) {setGeneric("tessellate", function(x, ...) standardGeneric("tessellate"))}

if (!isGeneric("snapTo")) {setGeneric("snapTo", function(x, y, ...) standardGeneric("snapTo"))}

if (!isGeneric("agitate")) {setGeneric("agitate", function(x, ...) standardGeneric("agitate"))}

if (!isGeneric("nany")) {setGeneric("nany", function(x, ...) standardGeneric("nany"))}
if (!isGeneric("chunk")) {setGeneric("chunk", function(x, ...) standardGeneric("chunk"))}
if (!isGeneric("thresh")) {setGeneric("thresh", function(x, ...) standardGeneric("thresh"))}
if (!isGeneric("divide")) {setGeneric("divide", function(x, ...) standardGeneric("divide"))}

if (!isGeneric("bestMatch")) {setGeneric("bestMatch", function(x, y, ...) standardGeneric("bestMatch"))}
if (!isGeneric("k_means")) {setGeneric("k_means", function(x, ...) standardGeneric("k_means"))}
if (!isGeneric("princomp")) {setGeneric("princomp", function(x, ...) standardGeneric("princomp"))}
if (!isGeneric("extractRange")) { setGeneric("extractRange", function(x, y, ...) standardGeneric("extractRange"))}

if (!isGeneric("getTileExtents")) {setGeneric("getTileExtents", function(x, ...) standardGeneric("getTileExtents"))}

if (!isGeneric("layerCor")) {setGeneric("layerCor", function(x, ...) standardGeneric("layerCor"))}

if (!isGeneric("metags")) {setGeneric("metags", function(x, ...) standardGeneric("metags"))}
if (!isGeneric("metags<-")) {setGeneric("metags<-", function(x, ..., value) standardGeneric("metags<-"))}

if (!isGeneric("forceCCW")) {setGeneric("forceCCW", function(x, ...) standardGeneric("forceCCW"))}
if (!isGeneric("addCats")) {setGeneric("addCats", function(x, ...) standardGeneric("addCats"))}
if (!isGeneric("regress")) {setGeneric("regress", function(y, x, ...) standardGeneric("regress"))}

if (!isGeneric("panel")) {setGeneric("panel", function(x, ...) standardGeneric("panel"))}
#if (!isGeneric("colSums")) {setGeneric("colSums", function(x, ...) standardGeneric("colSums"))}	
#if (!isGeneric("rowSums")) {setGeneric("rowSums", function(x, ...) standardGeneric("rowSums"))}	
#if (!isGeneric("colMeans")) {setGeneric("colMeans", function(x, ...) standardGeneric("colMeans"))}	
#if (!isGeneric("rowMeans")) {setGeneric("rowMeans", function(x, ...) standardGeneric("rowMeans"))}	

if (!isGeneric("logic")) {setGeneric("logic", function(x, ...) standardGeneric("logic"))}
if (!isGeneric("compare")) {setGeneric("compare", function(x, y, ...) standardGeneric("compare"))}

if (!isGeneric("meta")) {setGeneric("meta", function(x, ...) standardGeneric("meta"))}

if (!isGeneric("rangeFill")) {setGeneric("rangeFill", function(x, ...) standardGeneric("rangeFill"))}
if (!isGeneric("roll")) {setGeneric("roll", function(x, ...) standardGeneric("roll"))}
if (!isGeneric("elongate")) {setGeneric("elongate", function(x, ...) standardGeneric("elongate"))}

if (!isGeneric("update")) {setGeneric("update", function(object, ...) standardGeneric("update"))}

if (!isGeneric("viewshed")) {setGeneric("viewshed", function(x, ...) standardGeneric("viewshed"))}
if (!isGeneric("sieve")) {setGeneric("sieve", function(x, ...) standardGeneric("sieve"))}

if (!isGeneric("rasterizeWin")) {setGeneric("rasterizeWin", function(x, y, ...) standardGeneric("rasterizeWin"))}
if (!isGeneric("interpNear")) {setGeneric("interpNear", function(x, y, ...) standardGeneric("interpNear"))}
if (!isGeneric("interpIDW")) {setGeneric("interpIDW", function(x, y, ...) standardGeneric("interpIDW"))}

if (!isGeneric("normalize.longitude")) {setGeneric("normalize.longitude", function(x, ...) standardGeneric("normalize.longitude"))}

if (!isGeneric("allNA")) {setGeneric("allNA", function(x, ...) standardGeneric("allNA"))}
if (!isGeneric("noNA")) {setGeneric("noNA", function(x, ...) standardGeneric("noNA"))}
if (!isGeneric("countNA")) {setGeneric("countNA", function(x, ...) standardGeneric("countNA"))}

if (!isGeneric("scoff")) {setGeneric("scoff", function(x, ...) standardGeneric("scoff"))}
if (!isGeneric("scoff<-")) {setGeneric("scoff<-", function(x, ..., value) standardGeneric("scoff<-"))}

if (!isGeneric("blocks")) {setGeneric("blocks", function(x, ...) standardGeneric("blocks"))}
if (!isGeneric("droplevels")) {setGeneric("droplevels", function(x, ...) standardGeneric("droplevels"))}
if (!isGeneric("simplifyLevels")) {setGeneric("simplifyLevels", function(x, ...) standardGeneric("simplifyLevels"))}

if (!isGeneric("str")) { setGeneric("str", function(object, ...) standardGeneric("str"))}

if (!isGeneric("plet")) { setGeneric("plet", function(x, ...) standardGeneric("plet"))}

if (!isGeneric("combineGeoms")) {setGeneric("combineGeoms", function(x, y, ...) standardGeneric("combineGeoms"))}
if (!isGeneric("concats")) {setGeneric("concats", function(x, ...) standardGeneric("concats"))}
if (!isGeneric("has.colors")) {setGeneric("has.colors", function(x, ...) standardGeneric("has.colors"))}
if (!isGeneric("has.RGB")) {setGeneric("has.RGB", function(x, ...) standardGeneric("has.RGB"))}
if (!isGeneric("has.z")) {setGeneric("has.z", function(x, ...) standardGeneric("has.z"))}

if (!isGeneric("emptyGeoms")) {setGeneric("emptyGeoms", function(x, ...) standardGeneric("emptyGeoms"))}

if (!isGeneric("serialize")) {setGeneric("serialize", function(object, connection, ascii = FALSE, xdr = TRUE, version = NULL,  refhook = NULL) standardGeneric("serialize"))}

if (!isGeneric("saveRDS")) {setGeneric("saveRDS", function (object, file="", ascii=FALSE, version=NULL, compress=TRUE, refhook=NULL) standardGeneric("saveRDS"))}


if (!isGeneric("query")) {setGeneric("query", function(x, ...) standardGeneric("query"))}

if (!isGeneric("set.values")) {setGeneric("set.values", function(x, ...) standardGeneric("set.values"))}
if (!isGeneric("set.ext")) {setGeneric("set.ext", function(x, ...) standardGeneric("set.ext"))}
if (!isGeneric("set.names")) {setGeneric("set.names", function(x, ...) standardGeneric("set.names"))}
if (!isGeneric("set.crs")) {setGeneric("set.crs", function(x, ...) standardGeneric("set.crs"))}
if (!isGeneric("set.RGB")) {setGeneric("set.RGB", function(x, ...) standardGeneric("set.RGB"))}
if (!isGeneric("set.window")) {setGeneric("set.window", function(x, ...) standardGeneric("set.window"))}


if (!isGeneric("math")) { setGeneric("math", function(x, ...) standardGeneric("math")) }

if (!isGeneric("all.equal")) { setGeneric("all.equal", function(target, current, ...) standardGeneric("all.equal")) }
if (!isGeneric("impose")) { setGeneric("impose", function(x, ...) standardGeneric("impose")) }
if (!isGeneric("density")) { setGeneric("density", function(x, ...) standardGeneric("density"))}
if (!isGeneric("densify")) { setGeneric("densify", function(x, ...) standardGeneric("densify"))}


if (!isGeneric("selectHighest")) {setGeneric("selectHighest", function(x, ...) standardGeneric("selectHighest"))}
if (!isGeneric("focal3D")) { setGeneric("focal3D", function(x, ...) standardGeneric("focal3D")) }
if (!isGeneric("focalReg")) { setGeneric("focalReg", function(x, ...) standardGeneric("focalReg")) }
if (!isGeneric("focalCpp")) { setGeneric("focalCpp", function(x, ...) standardGeneric("focalCpp")) }
if (!isGeneric("focalPairs")) { setGeneric("focalPairs", function(x, ...) standardGeneric("focalPairs")) }

if (!isGeneric("clearance")) {setGeneric("clearance", function(x, ...) standardGeneric("clearance"))}
if (!isGeneric("width")) {setGeneric("width", function(x, ...) standardGeneric("width"))}
if (!isGeneric("simplifyGeom")) {setGeneric("simplifyGeom", function(x, ...) standardGeneric("simplifyGeom"))}
if (!isGeneric("thinNodes")) {setGeneric("thinNodes", function(x, ...) standardGeneric("thinNodes"))}
if (!isGeneric("mergeLines")) {setGeneric("mergeLines", function(x, ...) standardGeneric("mergeLines"))}
if (!isGeneric("mergeTime")) {setGeneric("mergeTime", function(x, ...) standardGeneric("mergeTime"))}
if (!isGeneric("fillTime")) {setGeneric("fillTime", function(x, ...) standardGeneric("fillTime"))}
if (!isGeneric("makeNodes")) {setGeneric("makeNodes", function(x, ...) standardGeneric("makeNodes"))}
if (!isGeneric("removeDupNodes")) {setGeneric("removeDupNodes", function(x, ...) standardGeneric("removeDupNodes"))}
if (!isGeneric("snap")) {setGeneric("snap", function(x, ...) standardGeneric("snap"))}

if (!isGeneric("weighted.mean")) {setGeneric("weighted.mean", function(x, w, ...) standardGeneric("weighted.mean"))}

if (!isGeneric("split")) {setGeneric("split", function(x, f, drop = FALSE, ...) standardGeneric("split"))}
if (!isGeneric("cellSize")) {setGeneric("cellSize", function(x, ...) standardGeneric("cellSize"))}
if (!isGeneric("surfArea")) {setGeneric("surfArea", function(x, ...) standardGeneric("surfArea"))}

if (!isGeneric("na.omit")) {setGeneric("na.omit", function(object, ...) standardGeneric("na.omit"))}
if (!isGeneric("catalyze")) {setGeneric("catalyze", function(x, ...) standardGeneric("catalyze"))}
if (!isGeneric("activeCat")) {setGeneric("activeCat", function(x, ...) standardGeneric("activeCat"))}
if (!isGeneric("activeCat<-")) {setGeneric("activeCat<-", function(x, ..., value) standardGeneric("activeCat<-"))}

if (!isGeneric("sharedPaths")) {setGeneric("sharedPaths", function(x, ...) standardGeneric("sharedPaths"))}
if (!isGeneric("isTRUE")) {setGeneric("isTRUE", function(x) standardGeneric("isTRUE"))}
if (!isGeneric("subst")) {setGeneric("subst", function(x, ...) standardGeneric("subst"))}

if (!isGeneric("colorize")) {setGeneric("colorize", function(x, ...) standardGeneric("colorize"))}

if (!isGeneric("RGB")) {setGeneric("RGB", function(x, ...) standardGeneric("RGB"))}
if (!isGeneric("RGB<-")) {setGeneric("RGB<-", function(x, ..., value) standardGeneric("RGB<-"))}

if (!isGeneric("autocor")) {setGeneric("autocor", function(x, ...) standardGeneric("autocor"))}
if (!isGeneric("delaunay")) {setGeneric("delaunay", function(x, ...) standardGeneric("delaunay"))}
if (!isGeneric("voronoi")) {setGeneric("voronoi", function(x, ...) standardGeneric("voronoi"))}
if (!isGeneric("hull")) {setGeneric("hull", function(x, ...) standardGeneric("hull"))}

if (!isGeneric("convHull")) {setGeneric("convHull", function(x, ...) standardGeneric("convHull"))}
if (!isGeneric("minRect")) {setGeneric("minRect", function(x, ...) standardGeneric("minRect"))}
if (!isGeneric("minCircle")) {setGeneric("minCircle", function(x, ...) standardGeneric("minCircle"))}

#if (!isGeneric("which.related")) {setGeneric("which.related", function(x, y, ...) standardGeneric("which.related"))}
if (!isGeneric("is.related")) {setGeneric("is.related", function(x, y, ...) standardGeneric("is.related"))}
if (!isGeneric("relate")) {setGeneric("relate", function(x, y, ...) standardGeneric("relate"))}
if (!isGeneric("intersect")) {setGeneric("intersect", function(x, y) standardGeneric("intersect"))}

if (!isGeneric("not.na")) {setGeneric("not.na", function(x, ...) standardGeneric("not.na"))}

if (!isGeneric("erase")) {setGeneric("erase", function(x, y, ...) standardGeneric("erase"))}
if (!isGeneric("gaps")) {setGeneric("gaps", function(x, ...) standardGeneric("gaps"))}
if (!isGeneric("is.rotated")) {setGeneric("is.rotated", function(x, ...) standardGeneric("is.rotated"))}
if (!isGeneric("has.geoloc")) {setGeneric("has.geoloc", function(x, ...) standardGeneric("has.geoloc"))}
if (!isGeneric("geoloc")) {setGeneric("geoloc", function(x, ...) standardGeneric("geoloc"))}
if (!isGeneric("is.flipped")) {setGeneric("is.flipped", function(x, ...) standardGeneric("is.flipped"))}

if (!isGeneric("is.num")) {setGeneric("is.num", function(x) standardGeneric("is.num"))}
if (!isGeneric("is.int")) {setGeneric("is.int", function(x) standardGeneric("is.int"))}
if (!isGeneric("as.int")) {setGeneric("as.int", function(x, ...) standardGeneric("as.int"))}
if (!isGeneric("is.bool")) {setGeneric("is.bool", function(x) standardGeneric("is.bool"))}
if (!isGeneric("as.bool")) {setGeneric("as.bool", function(x, ...) standardGeneric("as.bool"))}
if (!isGeneric("nearby")) {setGeneric("nearby", function(x, ...) standardGeneric("nearby"))}
if (!isGeneric("nearest")) {setGeneric("nearest", function(x, ...) standardGeneric("nearest"))}
if (!isGeneric("cartogram")) {setGeneric("cartogram", function(x, ...) standardGeneric("cartogram"))}
if (!isGeneric("dots")) {setGeneric("dots", function(x, ...) standardGeneric("dots"))}
if (!isGeneric("crds")) {setGeneric("crds", function(x, ...) standardGeneric("crds"))}
if (!isGeneric("symdif")) {setGeneric("symdif", function(x, y, ...) standardGeneric("symdif"))}
if (!isGeneric("median")) {setGeneric("median", function(x, na.rm) standardGeneric("median"))}
if (!isGeneric("polys")) {setGeneric("polys", function(x,...) standardGeneric("polys"))}
if (!isGeneric("centroids")) {setGeneric("centroids", function(x, ...) standardGeneric("centroids"))}
if (!isGeneric("coltab")) {setGeneric("coltab", function(x, ...) standardGeneric("coltab"))}
if (!isGeneric("coltab<-")) { setGeneric("coltab<-", function(x, ..., value) standardGeneric("coltab<-")) }
if (!isGeneric("deepcopy")) { setGeneric("deepcopy", function(x, ...) standardGeneric("deepcopy")) }
if (!isGeneric("window")) {setGeneric("window", function(x, ...) standardGeneric("window"))}
if (!isGeneric("window<-")) {setGeneric("window<-", function(x, ..., value) standardGeneric("window<-"))}
if (!isGeneric("NAflag")) {setGeneric("NAflag", function(x, ...) standardGeneric("NAflag"))}
if (!isGeneric("NAflag<-")) {setGeneric("NAflag<-", function(x, ..., value) standardGeneric("NAflag<-"))}
if (!isGeneric("app")) { setGeneric("app", function(x, ...) standardGeneric("app"))}
if (!isGeneric("lapp")) { setGeneric("lapp", function(x, ...) standardGeneric("lapp"))}
if (!isGeneric("rapp")) { setGeneric("rapp", function(x, ...) standardGeneric("rapp"))}
if (!isGeneric("tapp")) { setGeneric("tapp", function(x, ...) standardGeneric("tapp"))}
if (!isGeneric("sapp")) { setGeneric("sapp", function(x, ...) standardGeneric("sapp"))}
if (!isGeneric("xpp")) { setGeneric("xapp", function(x, y, ...) standardGeneric("xapp"))}

if (!isGeneric("add<-")) {setGeneric("add<-", function(x, value) standardGeneric("add<-"))}
if (!isGeneric("align")) { setGeneric("align", function(x, y, ...) standardGeneric("align"))}
if (!isGeneric("as.contour")) {setGeneric("as.contour", function(x,...) standardGeneric("as.contour"))}
if (!isGeneric("as.lines")) {setGeneric("as.lines", function(x,...) standardGeneric("as.lines"))}
if (!isGeneric("as.points")) {setGeneric("as.points", function(x,...) standardGeneric("as.points"))}
if (!isGeneric("netw")) {setGeneric("netw", function(x, ...) standardGeneric("netw"))}
if (!isGeneric("net_nodes")) {setGeneric("net_nodes", function(x, ...) standardGeneric("net_nodes"))}
if (!isGeneric("net_edges")) {setGeneric("net_edges", function(x, ...) standardGeneric("net_edges"))}
if (!isGeneric("net_nnodes")) {setGeneric("net_nnodes", function(x, ...) standardGeneric("net_nnodes"))}
if (!isGeneric("net_nedges")) {setGeneric("net_nedges", function(x, ...) standardGeneric("net_nedges"))}
if (!isGeneric("net_directed")) {setGeneric("net_directed", function(x, ...) standardGeneric("net_directed"))}
if (!isGeneric("net_weights")) {setGeneric("net_weights", function(x, ...) standardGeneric("net_weights"))}
if (!isGeneric("net_weights<-")) {setGeneric("net_weights<-", function(x, value) standardGeneric("net_weights<-"))}
if (!isGeneric("shortestPath")) {setGeneric("shortestPath", function(x, ...) standardGeneric("shortestPath"))}
if (!isGeneric("as.polygons")) {setGeneric("as.polygons", function(x,...) standardGeneric("as.polygons"))}
if (!isGeneric("classify")) { setGeneric("classify", function(x, ...) standardGeneric("classify")) }
if (!isGeneric("cells")) { setGeneric("cells", function(x, y, ...) standardGeneric("cells")) }
if (!isGeneric("tighten")) {setGeneric("tighten", function(x, ...) standardGeneric("tighten"))}
if (!isGeneric("compareGeom")) {setGeneric("compareGeom", function(x,y,...) standardGeneric("compareGeom"))}
if (!isGeneric("crosstab")) { setGeneric("crosstab", function(x, y, ...) standardGeneric("crosstab")) }
if (!isGeneric("describe")) { setGeneric("describe", function(x, ...) standardGeneric("describe"))}
if (!isGeneric("depth")) {setGeneric("depth", function(x,...) standardGeneric("depth"))}
if (!isGeneric("depth<-")) {setGeneric("depth<-", function(x, value) standardGeneric("depth<-"))}
if (!isGeneric("depthName")) {setGeneric("depthName", function(x,...) standardGeneric("depthName"))}
if (!isGeneric("depthName<-")) {setGeneric("depthName<-", function(x, value) standardGeneric("depthName<-"))}
if (!isGeneric("depthUnit")) {setGeneric("depthUnit", function(x,...) standardGeneric("depthUnit"))}
if (!isGeneric("depthUnit<-")) {setGeneric("depthUnit<-", function(x, value) standardGeneric("depthUnit<-"))}
if (!isGeneric("draw")) {setGeneric("draw", function(x,...) standardGeneric("draw"))}
if (!isGeneric("ext")) { setGeneric("ext", function(x, ...)	standardGeneric("ext"))}
if (!isGeneric("ext<-")) { setGeneric("ext<-", function(x, value) standardGeneric("ext<-")) }
if (!isGeneric("fillHoles") ) { setGeneric("fillHoles", function(x, ...) standardGeneric("fillHoles")) }
if (!isGeneric("geomtype")) {setGeneric("geomtype", function(x, ...) standardGeneric("geomtype"))}
if (!isGeneric("datatype")) {setGeneric("datatype", function(x, ...) standardGeneric("datatype"))}
if (!isGeneric("global")) {setGeneric("global", function(x, ...) standardGeneric("global"))}
if (!isGeneric("makeValid")) {setGeneric("makeValid", function(x,...) standardGeneric("makeValid"))}
if (!isGeneric("is.valid")) {setGeneric("is.valid", function(x,...) standardGeneric("is.valid"))}
if (!isGeneric("is.empty")) {setGeneric("is.empty", function(x,...) standardGeneric("is.empty"))}
if (!isGeneric("is.points")) {setGeneric("is.points", function(x,...) standardGeneric("is.points"))}
if (!isGeneric("is.lines")) {setGeneric("is.lines", function(x,...) standardGeneric("is.lines"))}
if (!isGeneric("is.polygons")) {setGeneric("is.polygons", function(x,...) standardGeneric("is.polygons"))}
if (!isGeneric("makeTiles")) {setGeneric("makeTiles", function(x,...) standardGeneric("makeTiles"))}
if (!isGeneric("vrt")) {setGeneric("vrt", function(x,...) standardGeneric("vrt"))}
if (!isGeneric("isTRUE")) { setGeneric("isTRUE", function(x) standardGeneric("isTRUE"))}
if (!isGeneric("isFALSE")) { setGeneric("isFALSE", function(x) standardGeneric("isFALSE"))}
if (!isGeneric("varnames")) {setGeneric("varnames", function(x,...) standardGeneric("varnames"))}
if (!isGeneric("varnames<-")) {setGeneric("varnames<-", function(x, value) standardGeneric("varnames<-"))}
if (!isGeneric("log")) {setGeneric("log", function(x,...) standardGeneric("log"))}
if (!isGeneric("longnames")) {setGeneric("longnames", function(x,...) standardGeneric("longnames"))}
if (!isGeneric("longnames<-")) {setGeneric("longnames<-", function(x, value) standardGeneric("longnames<-"))}
if (!isGeneric("hasMinMax")) {setGeneric("hasMinMax", function(x) standardGeneric("hasMinMax"))}
if (!isGeneric("minmax")) {setGeneric("minmax", function(x, ...) standardGeneric("minmax"))}
if (!isGeneric("nsrc")) { setGeneric("nsrc", function(x) standardGeneric("nsrc")) }
if (!isGeneric("perim")) {setGeneric("perim", function(x, ...) standardGeneric("perim"))}
if (!isGeneric("nseg")) {setGeneric("nseg", function(x, ...) standardGeneric("nseg"))}
if (!isGeneric("project")) {setGeneric("project", function(x,...) standardGeneric("project"))}
if (!isGeneric("wrapCache")) {setGeneric("wrapCache", function(x, ...) standardGeneric("wrapCache"))}
if (!isGeneric("wrap")) {setGeneric("wrap", function(x, ...) standardGeneric("wrap"))}
if (!isGeneric("unwrap")) {setGeneric("unwrap", function(x, ...) standardGeneric("unwrap"))}
if (!isGeneric("cats")) { setGeneric("cats", function(x, ...) standardGeneric("cats")) }
if (!isGeneric("categories")) { setGeneric("categories", function(x, ...) standardGeneric("categories")) }
if (!isGeneric("set.cats")) { setGeneric("set.cats", function(x, ...) standardGeneric("set.cats")) }
if (!isGeneric("as.raster")) { setGeneric("as.raster", function(x, ...) standardGeneric("as.raster"))}
if (!isGeneric("rast") ) { setGeneric("rast", function(x, ...) standardGeneric("rast")) }
if (!isGeneric("rev") ) { setGeneric("rev", function(x) standardGeneric("rev")) }
if (!isGeneric("sds") ) { setGeneric("sds", function(x, ...) standardGeneric("sds")) }
if (!isGeneric("sprc") ) { setGeneric("sprc", function(x, ...) standardGeneric("sprc")) }
if (!isGeneric("svc") ) { setGeneric("svc", function(x, ...) standardGeneric("svc")) }
if (!isGeneric("sel")) {setGeneric("sel", function(x, ...) standardGeneric("sel"))}
if (!isGeneric("segregate")) {setGeneric("segregate", function(x, ...) standardGeneric("segregate"))}
if (!isGeneric("selectRange")) {setGeneric("selectRange", function(x, ...) standardGeneric("selectRange"))}
if (!isGeneric("setValues")) {setGeneric("setValues", function(x, values, ...) standardGeneric("setValues"))}
if (!isGeneric("expanse")) {setGeneric("expanse", function(x, ...) standardGeneric("expanse"))}
if (!isGeneric("size")) {setGeneric("size", function(x, ...) standardGeneric("size"))}
if (!isGeneric("inMemory")) {setGeneric("inMemory", function(x, ...) standardGeneric("inMemory"))}
if (!isGeneric("sources")) {setGeneric("sources", function(x, ...) standardGeneric("sources"))}
if (!isGeneric("spatSample")) { setGeneric("spatSample", function(x, ...) standardGeneric("spatSample"))}
if (!isGeneric("terrain")) {setGeneric("terrain", function(x, ...) standardGeneric("terrain"))}
if (!isGeneric("thin")) {setGeneric("thin", function(x, ...) standardGeneric("thin"))}
if (!isGeneric("has.time")) {setGeneric("has.time", function(x,...) standardGeneric("has.time"))}
if (!isGeneric("time")) {setGeneric("time", function(x,...) standardGeneric("time"))}
if (!isGeneric("time<-")) {setGeneric("time<-", function(x, ..., value) standardGeneric("time<-"))}
if (!isGeneric("timeInfo")) {setGeneric("timeInfo", function(x,...) standardGeneric("timeInfo"))}
if (!isGeneric("nlyr")) { setGeneric("nlyr", function(x) standardGeneric("nlyr")) }
if (!isGeneric("nlyr<-")) { setGeneric("nlyr<-", function(x, ..., value) standardGeneric("nlyr<-")) }
if (!isGeneric("linearUnits")) {setGeneric("linearUnits", function(x, ...) standardGeneric("linearUnits"))}
if (!isGeneric("units")) {setGeneric("units", function(x) standardGeneric("units"))}
if (!isGeneric("units<-")) {setGeneric("units<-", function(x,value) standardGeneric("units<-"))}
if (!isGeneric("vect") ) { setGeneric("vect", function(x, ...) standardGeneric("vect")) }
if (!isGeneric("writeCDF")) {setGeneric("writeCDF", function(x, filename, ...) standardGeneric("writeCDF"))}
if (!isGeneric("writeVector")) {setGeneric("writeVector", function(x, filename, ...) standardGeneric("writeVector"))}
if (!isGeneric("writeNetwork")) {setGeneric("writeNetwork", function(x, filename, ...) standardGeneric("writeNetwork"))}
## shared with "raster"
if (!isGeneric("%in%")) { setGeneric("%in%", function(x, table)	standardGeneric("%in%")) }
if (!isGeneric("adjacent")) {setGeneric("adjacent", function(x, ...) standardGeneric("adjacent"))}
if (!isGeneric("animate")) { setGeneric("animate", function(x, ...) standardGeneric("animate")) }
if (!isGeneric("approximate")) {setGeneric("approximate", function(x, ...) standardGeneric("approximate"))}

if (!isGeneric("as.data.frame")) { setGeneric("as.data.frame", function(x, row.names = NULL, optional = FALSE, ...) standardGeneric("as.data.frame")) }

if (!isGeneric("as.list")) { setGeneric("as.list", function(x, ...) standardGeneric("as.list"))}
if (!isGeneric("as.factor")) {setGeneric("as.factor", function(x) standardGeneric("as.factor"))}

if (!isGeneric("atan2")) { setGeneric("atan2", function(y, x) standardGeneric("atan2"))}
if (!isGeneric("atan_2")) { setGeneric("atan_2", function(y, x, ...) standardGeneric("atan_2"))}
if (!isGeneric("barplot")) {setGeneric("barplot", function(height,...) standardGeneric("barplot"))}
#if (!isGeneric("bndbox")) {setGeneric("bndbox", function(obj) standardGeneric("bndbox"))}
if (!isGeneric("boundaries")) {	setGeneric("boundaries", function(x, ...) standardGeneric("boundaries"))}
if (!isGeneric("boxplot")) { setGeneric("boxplot", function(x, ...) standardGeneric("boxplot"))}
if (!isGeneric("buffer")) {setGeneric("buffer", function(x, ...) standardGeneric("buffer"))}
if (!isGeneric("clamp")) { setGeneric("clamp", function(x, ...) standardGeneric("clamp")) }
if (!isGeneric("clamp_ts")) { setGeneric("clamp_ts", function(x, ...) standardGeneric("clamp_ts")) }
if (!isGeneric("click")) {setGeneric("click", function(x, ...)standardGeneric("click"))}
if (!isGeneric("contour")) { setGeneric("contour", function(x,...) standardGeneric("contour"))}
if (!isGeneric("cover")) {setGeneric("cover", function(x, y, ...) standardGeneric("cover"))}
if (!isGeneric("crop")) { setGeneric("crop", function(x, y, ...) standardGeneric("crop")) }
if (!isGeneric("crs")) { setGeneric("crs", function(x, ...)	standardGeneric("crs")) }
if (!isGeneric("crs<-")) { setGeneric("crs<-", function(x, ..., value) standardGeneric("crs<-")) }
if (!isGeneric("density")) { setGeneric("density", function(x, ...) standardGeneric("density"))}
if (!isGeneric("aggregate")) {setGeneric("aggregate", function(x, ...) standardGeneric("aggregate"))}
if (!isGeneric("disagg")) {setGeneric("disagg", function(x, ...) standardGeneric("disagg"))}
if (!isGeneric("costDist")) {setGeneric("costDist", function(x, ...)standardGeneric("costDist"))}
if (!isGeneric("gridDist")) {setGeneric("gridDist", function(x, ...)standardGeneric("gridDist"))}
if (!isGeneric("furdist")) {setGeneric("furdist", function(x, y, ...)standardGeneric("furdist"))}
if (!isGeneric("distance")) {setGeneric("distance", function(x, y, ...)standardGeneric("distance"))}
if (!isGeneric("direction")) {setGeneric("direction", function(x, ...)standardGeneric("direction"))}
if (!isGeneric("extract")) { setGeneric("extract", function(x, y, ...) standardGeneric("extract"))}
if (!isGeneric("extend")) {setGeneric("extend", function(x, y, ...) standardGeneric("extend"))}
if (!isGeneric("flip")) {setGeneric("flip", function(x, ...) standardGeneric("flip")) }
if (!isGeneric("focal")) { setGeneric("focal", function(x, ...) standardGeneric("focal")) }
if (!isGeneric("focalValues")) { setGeneric("focalValues", function(x, ...) standardGeneric("focalValues")) }
if (!isGeneric("freq")) { setGeneric("freq", function(x, ...) standardGeneric("freq")) }
if (!isGeneric("geom")) { setGeneric("geom", function(x,...) standardGeneric("geom"))}
if (!isGeneric("hasValues")) {setGeneric("hasValues", function(x, ...) standardGeneric("hasValues")) }
if (!isGeneric("head")) { setGeneric("head", function(x, ...) standardGeneric("head"))}
if (!isGeneric("ifel")) {setGeneric("ifel", function(test, ...) standardGeneric("ifel"))}
if (!isGeneric("image")) {setGeneric("image", function(x, ...)standardGeneric("image"))}
if (!isGeneric("init")) {setGeneric("init", function(x, ...) standardGeneric("init"))}
if (!isGeneric("inset")) {setGeneric("inset", function(x, ...) standardGeneric("inset"))}
if (!isGeneric("inext")) {setGeneric("inext", function(x, ...) standardGeneric("inext"))}
if (!isGeneric("interpolate")) { setGeneric("interpolate", function(object, ...) standardGeneric("interpolate"))}
if (!isGeneric("is.factor")) {setGeneric("is.factor", function(x) standardGeneric("is.factor"))}
if (!isGeneric("is.lonlat")) { setGeneric("is.lonlat", function(x, ...) standardGeneric("is.lonlat"))}
if (!isGeneric("mask")) { setGeneric("mask", function(x, mask, ...) standardGeneric("mask")) }
if (!isGeneric("match")) { setGeneric("match", function(x, table, nomatch=NA_integer_, incomparables=NULL)		standardGeneric("match"))}
if (!isGeneric("modal")) {setGeneric("modal", function(x, ...) standardGeneric("modal"))}
if (!isGeneric("mosaic")) {setGeneric("mosaic", function(x, y, ...) standardGeneric("mosaic"))}
if (!isGeneric("blend")) {setGeneric("blend", function(x, y, ...) standardGeneric("blend"))}

if (!isGeneric("ncell")) { setGeneric("ncell", function(x) standardGeneric("ncell")) }
if (!isGeneric("nrow")) { setGeneric("nrow", function(x) standardGeneric("nrow")) }
if (!isGeneric("ncol")) { setGeneric("nrow", function(x) standardGeneric("nrow")) }
if (!isGeneric("ncol<-")) { setGeneric("ncol<-", function(x, ..., value) standardGeneric("ncol<-")) }
if (!isGeneric("nrow<-")) { setGeneric("nrow<-", function(x, ..., value) standardGeneric("nrow<-")) }
if (!isGeneric("origin")) {	setGeneric("origin", function(x, ...) standardGeneric("origin")) }
if (!isGeneric("origin<-")) {setGeneric("origin<-", function(x, value)	standardGeneric("origin<-"))}
if (!isGeneric("pairs")) { setGeneric("pairs", function(x, ...)	standardGeneric("pairs"))}
if (!isGeneric("patches")) {setGeneric("patches", function(x, ...) standardGeneric("patches"))}
if (!isGeneric("persp")) { setGeneric("persp", function(x,...) standardGeneric("persp")) }
if (!isGeneric("plot")) { setGeneric("plot", function(x, y,...) standardGeneric("plot"))}
if (!isGeneric("plotRGB")) { setGeneric("plotRGB", function(x, ...)standardGeneric("plotRGB"))}
if (!isGeneric("predict")) {setGeneric("predict", function(object, ...) standardGeneric("predict"))}
if (!isGeneric("quantile")) {setGeneric("quantile", function(x, ...)standardGeneric("quantile"))}
if (!isGeneric("rasterize")) {setGeneric("rasterize", function(x, y, ...) standardGeneric("rasterize"))}
if (!isGeneric("rasterizeGeom")) {setGeneric("rasterizeGeom", function(x, y, ...) standardGeneric("rasterizeGeom"))}
if (!isGeneric("readStart")) {setGeneric("readStart", function(x, ...) standardGeneric("readStart"))}
if (!isGeneric("readStop")) {setGeneric("readStop", function(x)	standardGeneric("readStop"))}
if (!isGeneric("toMemory")) {setGeneric("toMemory", function(x, ...) standardGeneric("toMemory"))}
if (!isGeneric("res")) { setGeneric("res", function(x) standardGeneric("res")) }
if (!isGeneric("res<-")) { setGeneric("res<-", function(x, value) standardGeneric("res<-")) }
if (!isGeneric("rectify")) {setGeneric("rectify", function(x, ...) standardGeneric("rectify"))}
if (!isGeneric("resample")) { setGeneric("resample", function(x, y, ...) standardGeneric("resample"))}
if (!isGeneric("spin")) {setGeneric("spin", function(x, ...) standardGeneric("spin"))}
if (!isGeneric("rotate")) {setGeneric("rotate", function(x, ...) standardGeneric("rotate"))}
if (!isGeneric("rescale")) {setGeneric("rescale", function(x, ...) standardGeneric("rescale"))}
#if (!isGeneric("select")) {setGeneric("select", function(x, ...) standardGeneric("select"))}
if (!isGeneric("setMinMax")) {setGeneric("setMinMax", function(x, ...) standardGeneric("setMinMax"))}
if (!isGeneric("scale")) {setGeneric("scale", function(x, center=TRUE, scale=TRUE) standardGeneric("scale"))}
if (!isGeneric("scale_linear")) { setGeneric("scale_linear", function(x, ...) standardGeneric("scale_linear"))}
if (!isGeneric("shift")) {setGeneric("shift", function(x, ...) standardGeneric("shift"))}
if (!isGeneric("stdev")) { setGeneric("stdev", function(x, ...) standardGeneric("stdev")) }
if (!isGeneric("subset")) {setGeneric("subset", function(x, ...) standardGeneric("subset")) }
if (!isGeneric("summary")) {setGeneric("summary", function(object, ...) standardGeneric("summary")) }
if (!isGeneric("t")) { setGeneric("t", function(x) standardGeneric("t"))}
if (!isGeneric("tail")) { setGeneric("tail", function(x, ...) standardGeneric("tail"))}
if (!isGeneric("text")) { setGeneric("text", function(x, ...) standardGeneric("text")) }
if (!isGeneric("trans")) { setGeneric("trans", function(x, ...) standardGeneric("trans"))}
if (!isGeneric("trim")) { setGeneric("trim", function(x, ...) standardGeneric("trim")) }
if (!isGeneric("xres")) { setGeneric("xres", function(x) standardGeneric("xres")) }
if (!isGeneric("yres")) { setGeneric("yres", function(x) standardGeneric("yres")) }
if (!isGeneric("zonal")) {setGeneric("zonal", function(x, z, ...) standardGeneric("zonal"))}
if (!isGeneric("rcl")) { setGeneric("rcl", function(x, ...) standardGeneric("rcl")) }

if (!isGeneric("yFromRow")) { setGeneric("yFromRow", function(object, row) standardGeneric("yFromRow")) }
if (!isGeneric("xFromCol")) { setGeneric("xFromCol", function(object, col) standardGeneric("xFromCol")) }
if (!isGeneric("colFromX")) { setGeneric("colFromX", function(object, x) standardGeneric("colFromX")) }
if (!isGeneric("rowFromY")) { setGeneric("rowFromY", function(object, y) standardGeneric("rowFromY")) }
if (!isGeneric("cellFromXY")) { setGeneric("cellFromXY", function(object, xy) standardGeneric("cellFromXY")) }
if (!isGeneric("cellFromRowCol")) { setGeneric("cellFromRowCol", function(object, row, col, ...) standardGeneric("cellFromRowCol")) }
if (!isGeneric("rowColCombine")) { setGeneric("rowColCombine", function(object, row, col, ...) standardGeneric("rowColCombine")) }
if (!isGeneric("cellFromRowColCombine")) { setGeneric("cellFromRowColCombine", function(object, row, col, ...) standardGeneric("cellFromRowColCombine")) }
if (!isGeneric("xyFromCell")) { setGeneric("xyFromCell", function(object, cell, ...) standardGeneric("xyFromCell")) }
if (!isGeneric("yFromCell")) { setGeneric("yFromCell", function(object, cell) standardGeneric("yFromCell")) }
if (!isGeneric("xFromCell")) { setGeneric("xFromCell", function(object, cell) standardGeneric("xFromCell")) }
if (!isGeneric("rowColFromCell")) { setGeneric("rowColFromCell", function(object, cell) standardGeneric("rowColFromCell")) }
if (!isGeneric("rowFromCell")) { setGeneric("rowFromCell", function(object, cell) standardGeneric("rowFromCell")) }
if (!isGeneric("colFromCell")) { setGeneric("colFromCell", function(object, cell) standardGeneric("colFromCell")) }
if (!isGeneric("readStart")) { setGeneric("readStart", function(x, ...) standardGeneric("readStart")) }
if (!isGeneric("readValues")) { setGeneric("readValues", function(x, ...) standardGeneric("readValues")) }
if (!isGeneric("readStop")) { setGeneric("readStop", function(x, ...) standardGeneric("readStop")) }
if (!isGeneric("setMinMax")) {setGeneric("setMinMax", function(x, ...) standardGeneric("setMinMax")) }
if (!isGeneric("stretch")) {setGeneric("stretch", function(x, ...) standardGeneric("stretch")) }
if (!isGeneric("union")) {setGeneric("union", function(x, y)standardGeneric("union"))}
if (!isGeneric("unique")) { setGeneric("unique", function(x, incomparables=FALSE, ...) standardGeneric("unique")) }
if (!isGeneric("values")) { setGeneric("values", function(x, ...) standardGeneric("values")) }
if (!isGeneric("values<-")) { setGeneric("values<-", function(x, value) standardGeneric("values<-"))}
if (!isGeneric("where.max")) {setGeneric("where.max", function(x, ...) standardGeneric("where.max"))}
if (!isGeneric("where.min")) {setGeneric("where.min", function(x, ...) standardGeneric("where.min"))}
if (!isGeneric("which.max")) {setGeneric("which.max", function(x) standardGeneric("which.max"))}
if (!isGeneric("which.min")) {setGeneric("which.min", function(x) standardGeneric("which.min"))}
if (!isGeneric("which.lyr")) {setGeneric("which.lyr", function(x) standardGeneric("which.lyr"))}
if (!isGeneric("writeStart")) {	setGeneric("writeStart", function(x, filename, ...)	standardGeneric("writeStart")) }
if (!isGeneric("writeStop")) { setGeneric("writeStop", function(x, ...) standardGeneric("writeStop")) }
if (!isGeneric("writeValues")) { setGeneric("writeValues", function(x, v, ...) standardGeneric("writeValues")) }
if (!isGeneric("writeRaster")) {setGeneric("writeRaster", function(x, filename, ...) standardGeneric("writeRaster"))}
if (!isGeneric("xmin")) {setGeneric("xmin", function(x) standardGeneric("xmin"))}
if (!isGeneric("xmax")) {setGeneric("xmax", function(x)	standardGeneric("xmax"))}
if (!isGeneric("ymin")) {setGeneric("ymin", function(x)	standardGeneric("ymin"))}
if (!isGeneric("ymax")) {setGeneric("ymax", function(x)	standardGeneric("ymax"))}
if (!isGeneric("xmin<-")) { setGeneric("xmin<-", function(x, ..., value) standardGeneric("xmin<-"))}
if (!isGeneric("xmax<-")) { setGeneric("xmax<-", function(x, ..., value) standardGeneric("xmax<-"))}
if (!isGeneric("ymin<-")) { setGeneric("ymin<-", function(x, ..., value) standardGeneric("ymin<-"))}
if (!isGeneric("ymax<-")) { setGeneric("ymax<-", function(x, ..., value) standardGeneric("ymax<-"))}
if (!isGeneric("zoom")) {setGeneric("zoom", function(x, ...)standardGeneric("zoom"))}

setMethod("droplevels", signature(x="SpatRaster"),
	function(x, level=NULL, layer=1) {
		if (is.null(level)) {
			x@pntr <- x@pntr$droplevels()
			messages(x)
		} else {
			if (is.character(layer)) {
				layer <- match(layer, names(x))
				if (any(is.na(layer))) {
					error("droplevels", "invalid layer")
				}
			}
			x[[layer]][x[[layer]] %in%  level] <- NA
			x@pntr <- x@pntr$droplevels()
			messages(x)
		}
	}
)

setMethod("simplifyLevels", signature(x="SpatRaster"),
	function(x, filename="", overwrite=FALSE, ...) {

		f <- function(r) {
			v <- levels(r)[[1]]
			s <- split(v, v[,2])
			i <- sapply(s, nrow) > 1
			if (any(i)) {
				s <- s[i]
				s <- lapply(s, function(i) cbind(i[-1,1], i[1,1])) 
				s <- do.call(rbind, s)
			}	
			y <- classify(x, s)
			v <- v[-s[,1], ]
			levels(y) <- v
			y
		}
		out <- rast(lapply(x, f))
		if (filename != "") {
			out <- writeRaster(out, filename, overwrite=overwrite, ...)
		}	
		out
	}
)


setMethod("is.factor", signature(x="SpatRaster"),
	function(x) {
		x@pntr$hasCategories()
	}
)

setMethod("as.factor", signature(x="SpatRaster"),
	function(x) {
		x@pntr = x@pntr$makeCategorical(-1, spatOptions())
		messages(x)
		#if (!hasValues(x)) {
		#	error("as.factor", "x has no values")
		#}
		#x <- round(x)
		#u <- unique(x, TRUE)
		#for (i in 1:nlyr(x)) {
		#	set.cats(x, i, data.frame(ID=u[[i]], label=u[[i]], stringsAsFactors=FALSE))
		#}
		#x
	}
)


setMethod("levels", signature(x="SpatRaster"),
	function(x) {
		x <- x@pntr$getCategories()
		lapply(x, function(i) {
			d <- .getSpatDF(i$df)
			if (ncol(d) == 0) return("")
			d[, c(1, max(1, i$index+1))]
		})
	}
)


setMethod("levels<-", signature(x="SpatRaster"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		if (is.null(value)) {
			x@pntr$removeCategories(-1)
			return(messages(x, "levels<-"))
		} else if (inherits(value, "list")) {
			for (i in 1:length(value)) {
				set.cats(x, i, value[[i]])
			}
		} else {
			set.cats(x, 1, value)
		}
		x
	}
)


combineLevels <- function(x, assign=TRUE) {
	if (nlyr(x) == 1) return(x)
	nms <- names(x)
    lv <- levels(x)
	lv <- lv[sapply(lv, is.data.frame)]
	un <- unique(sapply(lv, names))
	if (length(un) > 2) {
		lv <- lapply(lv, function(i) { colnames(i) <- colnames(lv[[1]]); i})
	}
	lv <- try(do.call(rbind, lv), silent=TRUE)
	if (inherits(lv, "try-error")) { # should not happen anymore
		error("panel", "cannot use combine categories")
	}
	lv <- unique(lv)
	if (length(unique(lv[,1])) < nrow(lv)) {
		error("panel", "cannot combine conflicting categories")			
	}
	lv <- lv[order(lv[,1]), ]
	if (assign) {
		x <- categories(x, 0, lv)
		names(x) <- nms 
		x
	} else {
		lv
	}
}


setMethod ("set.cats" , "SpatRaster",
	function(x, layer=1, value, active=1) {

		if (missing(value)) {
			error("set.cats", "value cannot be missing")
			#return(invisible(x@pntr$setCatIndex(layer-1, index)))
		}

		if (is.character(layer)) {
			layer <- match(layer, names(x))
			if (any(is.na(layer))) {
				error("set.cats", "invalid layer")
			}
		}
		layer <- round(layer)

		if (length(layer) > 1) {
			if (!is.list(value)) {
				error("set.cats", "value should be a list")
			}
			if (length(layer) != length(value)) {
				error("set.cats", "length(value) != length(value)")
			}
			index <- rep_len(active, nlyr(x))
			for (i in 1:length(layer)) {
				ok <- set.cats(x, layer[i], value[[i]], index[i])
				x <- messages(x, "set.cats")
			}
			return(invisible(ok))
		} 

		if (layer < 1) {
			if (layer != 0) {
				error("set.cats", "layer must be >= 0")
			}
			if (nlyr(x) == 1) {
				layer <- 1
			} else {
				if (is.data.frame(value)) {
					value <- replicate(nlyr(x), value, simplify=FALSE)
				} else {
					if (!is.list(value)) {
						error("set.cats", "value should be a list")
					}
					if (length(value) != nlyr(x)) {
						error("set.cats", "length(value) != nlyr(x)")
					}
				}
				index <- rep_len(active, nlyr(x))
				for (i in 1:length(value)) {
					if (!is.null(value[[i]])) {
						ok <- set.cats(x, i, value[[i]], index[i])
						x <- messages(x, "set.cats")
					}
				}
				return(invisible(ok))
			}
		}
		layer <- layer[1]
		if (is.character(layer)) {
			i <- match(layer, names(x))[1]
			if (length(i) == 0) {
				error("set.cats", layer, " is not in names(x)")
			}
			layer <- i
		} else {
			stopifnot(layer > 0 && layer <= nlyr(x))
		}

		if (inherits(value, "list")) {
			value <- value[[1]]
		}
		if (is.null(value)) {
			x@pntr$removeCategories(layer-1)
			messages(x, "set.cats")
			return(invisible(TRUE))
		}

		setname <- FALSE
		if (!is.data.frame(value)) {
			if (is.vector(value) || is.factor(value)) {
				if ((length(value) == 1) && value[1] == "") {
					return(invisible(""))
				}
				warn("set.cats", "setting categories like this is deprecated; use a two-column data.frame instead")
				value <- data.frame(value=0:(length(value)-1), category=value, stringsAsFactors=FALSE)
			} else {
				error("set.cats", "value should be a data.frame")
			}
		} else {
			setname <- TRUE
			if (ncol(value) == 1) {
				error("set.cats", "value should have at least two columns")
			} else {
				if (!is.numeric(value[[1]])) {
					error("set.cats", "the first column of 'value' must be numeric")
				}
				value[,1] <- round(value[[1]])
				if (length(unique(value[[1]])) != nrow(value)) {
					error("set.cats", "duplicate values (IDs) supplied")
				}
			}
		}
		value[[1]] <- as.integer(value[[1]])
		for (i in seq_along(value)) {
			if (is.factor(value[[i]])) {
				value[[i]] <- as.character(value[[i]])
			}
		}

		index <- max(1, min(ncol(value), active))
		if (setname) {
			nms <- names(x)
			cn <- colnames(value)[index+1]
			if (!(tolower(cn) %in% c("histogram", "count", "red", "green", "blue", "alpha", "opacity", "r", "g", "b", "a"))) {
				nms[layer] <- cn
				if (! x@pntr$setNames(nms, FALSE)) {
					error("names<-", "cannot set name")
				}
			}
		}
		if (any(is.na(value[[1]]))) {
			error("set.cats", "you cannot associate a category with NA")
		}
		if (any(table(value[[1]]) > 1)) {
			error("set.cats", "you cannot have duplicate IDs")
		}

		value <- .makeSpatDF(value)
		ok <- x@pntr$setCategories(layer-1, value, index)
		x <- messages(x, "set.cats")
		invisible(ok)
	}
)



setMethod ("categories" , "SpatRaster",
	function(x, layer=1, value, active=1, ...) {
		#... to accept but ignore old argument "index"
		x@pntr <- x@pntr$deepcopy()
		set.cats(x, layer, value, active)
		x
	}
)


setMethod ("activeCat" , "SpatRaster",
	function(x, layer=1) {
		layer <- layer[1]
		if (is.character(layer)) {
			layer = which(layer == names(x))[1]
			if (is.na(layer)) {
				error("activeCat", "invalid layer name")
			}
		}
		if (layer < 1) {
			sapply(1:nlyr(x), function(i) x@pntr$getCatIndex(i-1))
		} else {
			if (!is.factor(x)[layer]) {
				return(NA)
			}
			x@pntr$getCatIndex(layer-1)
		}
	}
)

setMethod("activeCat<-" , "SpatRaster",
	function(x, layer=1, value) {
		if (missing(value)) {
			value <- layer[1]
			layer <- 1
		} else {
			layer <- layer[1]
		}
		if ((layer < 1) | (layer > nlyr(x))) {
			error("activeCat", "invalid layer")
		}
		if (!is.factor(x)[layer]) {
			error("activeCat", "layer is not categorical")
		}
		if (is.character(value)) {
			g <- cats(x)[[layer]]
			value <- which(value == names(g))[1] - 1
			if (is.na(value)) {
				error("activeCat", "invalid category name")
			}
		}
		x <- deepcopy(x)
		if (!x@pntr$setCatIndex(layer-1, value)) {
			error("activeCat", "invalid category index")
		}
		x
	}
)

setMethod("cats" , "SpatRaster",
	function(x, layer) {
		if (!missing(layer)) {
			x <- subset(x, layer, NSE=FALSE)
		}
		cats <- x@pntr$getCategories()
		lapply(1:nlyr(x), function(i) {
			if (cats[[i]]$df$nrow == 0) {
				return(NULL)
			}
			.getSpatDF(cats[[i]]$df)
		})
	}
)


# superseded by levels(x)[[layer]]
..active_cats <- function(x, layer) {
	ff <- is.factor(x)
	if (!any(ff)) {
		return (lapply(ff, function(i) NULL))
	}
	cats <- x@pntr$getCategories()
	x <- lapply(1:length(cats), function(i) {
		if (cats[[i]]$df$nrow == 0) return(NULL)
		r <- .getSpatDF(cats[[i]]$df)
		a <- activeCat(x, i)
		if (a < 0) return(NULL)
		r[, c(1, a+1)]
	})

	if (!missing(layer)) {
		x[[layer]]
	} else {
		x
	}
}


setMethod ("as.numeric", "SpatRaster",
	function(x, index=NULL, filename="", ...) {
		if (!any(is.factor(x))) {
			x <- deepcopy(x)
			x@pntr$setValueType(0)
			return(x)
		}
		if (nlyr(x) > 1) {
			x <- lapply(1:nlyr(x), function(i) as.numeric(x[[i]], index=index))
			x <- rast(x)
			if (filename != "") {
				x <- writeRaster(x, filename, ...)
			}
			return(x)
		}
		g <- cats(x)[[1]]
		if (!is.null(index)) {
			if (is.character(index)) {
				index <- match(index, colnames(g))
				if (is.na(index)) {
					error("as.numeric", "index is not category name")				
				}
				if (index == 1) {
					levels(x) <- NULL
					x@pntr$setValueType(0)
					if (filename != "") {
						x <- writeRaster(x, filename, ...)
					}
					return(x)
				}		
			} else {
				index <- round(index[1])
				if (!((index >= 1) & (index < ncol(g)))) {
					error("as.numeric", "index out of range")
				}
				index <- index + 1
			}
		} else {
			index <- activeCat(x, 1)
			if (index <= 1) {
				levels(x) <- NULL
				x@pntr$setValueType(0)
				if (filename != "") {
					x <- writeRaster(x, filename, ...)
				}
				return(x)
			}
		}
		from <- g[,1]
		to <- g[,index]
		if (!is.numeric(to)) {
			suppressWarnings(toto <- as.numeric(to))
			if (sum(is.na(toto) > sum(is.na(to)))) {
				to <- as.integer(as.factor(to))
			} else {
				to <- toto
			}
		}
		m <- cbind(from, to)
		m <- m[!is.na(m[,1]), ,drop=FALSE]
		classify(x, m, names=names(g)[index], filename, ...)
	}
)



catLayer <- function(x, index, ...) {
		stopifnot(nlyr(x) == 1)
		if (!is.factor(x)) return(x)
		g <- cats(x)[[1]]
		if (!is.null(index)) {
			if (!((index > 1) & (index <= ncol(g)))) {
				error("as.numeric", "invalid index")
			}
		} else {
			index <- set.cats(x, 1)
		}
		from <- g[,1]
		toc <- g[,index]

		addFact <- FALSE
		if (!is.numeric(toc)) {
			addFact <- TRUE
			ton <- as.integer(as.factor(toc))
		} else {
			ton <- toc
		}
		m <- cbind(from, ton)
		m <- m[!is.na(m[,1]), ,drop=FALSE]
		x <- classify(x, m, names=names(g)[index], ...)
		if (addFact) {
			fact <- unique(data.frame(ton, toc))
			names(fact) <- c("ID", names(g)[index])
			fact <- fact[order(fact[,1]), ]
			set.cats(x, 1, fact)
		}
		x
}



setMethod("catalyze", "SpatRaster",
	function(x, filename="", ...) {
		g <- cats(x)
		from_vals <- NULL
		to_vals_list <- list()
		nms <- NULL

		for (i in 1:nlyr(x)) {
			gg <- g[[i]]
			if (nrow(gg) > 0) {
				nms <- colnames(gg)[-1]
				from_vals <- as.numeric(gg[, 1])
				for (j in 2:ncol(gg)) {
					to_vals <- gg[, j]
					if (!is.numeric(to_vals)) {
						suppressWarnings(toto <- as.numeric(to_vals))
						if (sum(is.na(toto)) > sum(is.na(to_vals))) {
							to_vals <- as.integer(as.factor(to_vals))
						} else {
							to_vals <- toto
						}
					}
					to_vals_list[[length(to_vals_list) + 1]] <- as.numeric(to_vals)
				}
				break
			}
		}

		if (length(to_vals_list) > 0 && !is.null(from_vals)) {
			opt <- spatOptions(filename, ...)
			x@pntr <- x@pntr$lookup_catalyze(from_vals, to_vals_list, opt)
			if (!is.null(nms)) names(x) <- nms
			messages(x)
		} else {
			messages(x)
		}
		x
	}
)



setMethod("concats", "SpatRaster",
	function(x, y, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr = x@pntr$combineCats(y@pntr, opt)
		messages(x, "concats")
	}
)

setMethod("addCats", "SpatRaster",
	function(x, value, merge=FALSE, layer=1) {
		if (!(is.factor(x)[layer])) {
			error("addCat", "the layer has no categories to add to")
		}
		cts <- cats(x)[[layer]]
		nact <- ncol(cts)
		if (merge) {
			if (ncol(value) < 2) {
				error("addCat", "'value' must have at least two columns when using 'merge=TRUE'")
			}
			cts <- merge(cts, value, by=1, all.x=TRUE)
			cts <- cts[order(cts[,1]), ]
		} else {
			if (nrow(cts) != nrow(value)) {
				error("addCat", "the number of categories does not match")
			}
			cts <- cbind(cts, value)
		}
		categories(x, layer=layer, cts, active=nact)
	}
)

setClass("Packed", contains="VIRTUAL")

setMethod("show", signature(object="Packed"),
	function(object) {
		print(paste("This is a", class(object), "object. Use 'terra::unwrap()' to unpack it"))
	}
)


setClass("PackedSpatExtent", contains="Packed",
	representation (
		extent = "numeric"
	),
	prototype (
		extent = numeric()
	)
)


setClass("PackedSpatVector", contains="Packed",
	representation (
		type = "character",
		crs = "character",
		coordinates = "matrix",
		index = "matrix",
		attributes = "data.frame"
	),
	prototype (
		type= "",
		crs = ""
	)
)


setClass("PackedSpatRaster", contains="Packed",
	representation (
		definition = "character",
		values = "matrix",
		attributes = "list"
	),
	prototype (
		attributes = list()
	)
)



setClass("PackedSpatRasterDC", contains="Packed",
	representation (
		type = "character",
		rasters = "list"
	),
	prototype (
		rasters = list()
	)
)



setMethod("wrap", signature(x="SpatVector"),
	function(x) {
		vd <- methods::new("PackedSpatVector")
		vd@type <- geomtype(x)
		vd@crs <- as.character(crs(x))
		#stopifnot(vd@type %in% c("points", "lines", "polygons"))
		g <- geom(x)
		if ("z" %in% colnames(g)) {
			vd@coordinates <- g[, c("x", "y", "z"), drop=FALSE]
		} else {
			vd@coordinates <- g[, c("x", "y"), drop=FALSE]
		}
		j <- c(1, 2, grep("hole", colnames(g)))
		g <- g[ , j, drop=FALSE]
		i <- which(!duplicated(g))
		vd@index <- cbind(g[i, ,drop=FALSE], start=i)
		vd@attributes <- as.data.frame(x)
		vd
	}
)


setMethod("unwrap", signature(x="PackedSpatVector"),
	function(x) {
		p <- methods::new("SpatVector")
		p@pntr <- SpatVector$new()
		if (!is.na(x@crs)) {
			crs(p, warn=FALSE) <- x@crs
		}
		if (nrow(x@coordinates) == 0) {
			return(p)
		}

		n <- ncol(x@index)
		reps <- diff(c(x@index[,n], nrow(x@coordinates)+1))
		i <- rep(1:nrow(x@index), reps)
		z <- if (ncol(x@coordinates) > 2) as.double(x@coordinates[,3]) else double(0)
		if (n == 2) {
			p@pntr$setGeometry(x@type, x@index[i,1], x@index[i,2], x@coordinates[,1], x@coordinates[,2], rep(0, nrow(x@coordinates)), z)
		} else {
			p@pntr$setGeometry(x@type, x@index[i,1], x@index[i,2], x@coordinates[,1], x@coordinates[,2], x@index[i,3], z)
		}
		if (nrow(x@attributes) > 0) {
			values(p) <- x@attributes
		}
		messages(p, "pack")
	}
)

setMethod("vect", signature(x="PackedSpatVector"),
	function(x) {
		unwrap(x)
	}
)




setMethod("as.character", signature(x="SpatRaster"),
	function(x) {
		e <- as.vector(ext(x))
		d <- crs(x, describe=TRUE)
		if (!(is.na(d$authority) || is.na(d$code))) {
			crs <- paste0(", crs='", d$authority, ":", d$code, "'")
		} else {
			d <- crs(x)
			crs <- ifelse(d=="", ", crs=''", paste0(", crs='", d, "'"))
			crs <- gsub("\n[ ]+", "", crs)
		}
		nms <- paste0(", names=c('", paste(names(x), collapse="', '"), "')")
		paste0("rast(",
				"ncols=", ncol(x),
				", nrows=", nrow(x),
				", nlyrs=", nlyr(x),
				", xmin=",e[1],
				", xmax=",e[2],
				", ymin=",e[3],
				", ymax=",e[4],
				nms,
				crs, ")"
		)
	}
)
#eval(parse(text=as.character(s)))

writeSources <- function(x, fsource, ftarget, overwrite, ...) {
	fex <- file.exists(ftarget)
	if (isFALSE(overwrite) && (any(fex))) {
		error("wrap", "file(s) exist(s) and 'overwrite=FALSE'")
	}
	mem <- fsource == ""
	for (i in 1:length(mem)) {
		r <- subsetSource(x, i)
		if (mem[i]) {
			writeRaster(r, ftarget[i], overwrite=TRUE, ...)
		} else {
			ff <- r@pntr$getAllFiles();
			if (length(ff) > 1) {
				target_noex <- tools::file_path_sans_ext(basename(ftarget[i]))
				source_noex <- tools::file_path_sans_ext(basename(fsource[i]))
				fftarget <- file.path(dirname(ftarget[i]), gsub(source_noex, target_noex, basename(ff)))
				file.copy(ff, fftarget)
			} else {
				file.copy(fsource[i], ftarget[i])
			}
		}
	}
}


finalizeWrap <- function(x, r, mem) {

	if (any(is.factor(x))) {
		r@attributes$levels <- cats(x)
		r@attributes$levindex <- activeCat(x, 0)
	}
	if (any(has.colors(x))) {
		r@attributes$colors <- coltab(x)
	}
	
	v <- time(x)
	if (any(!is.na(v))) {
		r@attributes$time <- v
		r@attributes$tinfo <- timeInfo(x)
	}
	v <- units(x)
	if (all(v != "")) {
		r@attributes$units <- v
	}
	v <- depth(x)
	if (!all(v == 0)) {
		r@attributes$depth <- v
	}
	
	v <- varnames(x)
	if (!all(v == "")) {
		if (mem) {
			v <- unique(v)
			if (length(v) == 1) {
				r@attributes$varnames <- v		
			}
		} else {
			r@attributes$varnames <- v		
		}
	}

	v <- longnames(x)
	if (!all(v == "")) {
		if (mem) {
			v <- unique(v)
			if (length(v) == 1) {
				r@attributes$longnames <- v		
			}
		} else {
			r@attributes$longnames <- v		
		}
	}
	r
}

setMethod("wrapCache", signature(x="SpatRaster"),
	function(x, filename=NULL, path=NULL, overwrite=FALSE, ...) {
		r <- methods::new("PackedSpatRaster")
		r@definition <- as.character(x)

		xs <- sources(x, TRUE, TRUE)
		s <- xs$source
		if (!is.null(filename)) {
			if ((length(filename) != 1) && (nrow(xs) != length(filename))) {
				error("wrap", "length(files) does not match the number of sources")
			}
			if (any(filename == "")) {
				error("wrap", "filenames cannot be empty")
			}
			filename <- file.path(normalizePath(dirname(filename), mustWork=TRUE), basename(filename))
			if (length(filename) == 1) {
				if (is.logical(overwrite)) {
					writeRaster(x, filename, overwrite=overwrite, ...)
				} else if (!file.exists(filename)) {
					writeRaster(x, filename, overwrite=FALSE, ...)				
				}
			} else {
				writeSources(x, s, filename, overwrite, ...)
			}
			xs$source <- filename 
		} else if (!is.null(path)) {
			path <- normalizePath(path, mustWork=TRUE)
			fnames <- file.path(path, basename(s))
			i <- s == ""
			if (any(i)) {
				fnames[i] <- file.path(path, paste0(basename(tempfile()), "_", 1:sum(i), ".tif"))
			}
			writeSources(x, s, fnames, overwrite)
			xs$source <- fnames 
		} else {
			error("wrapCache", "both path and files are NULL")
		}
		r@attributes$sources <- xs
		finalizeWrap(x, r, FALSE)		
	}
)

setMethod("wrap", signature(x="SpatExtent"),
	function(x) {
		r <- methods::new("PackedSpatExtent")
		r@extent <- as.vector(x)
		r
	}
)

setMethod("unwrap", signature(x="PackedSpatExtent"),
	function(x) {
		ext(x@extent)
	}
)

setMethod("ext", signature(x="PackedSpatExtent"),
	function(x) {
		ext(x@extent)
	}
)

	

setMethod("wrap", signature(x="SpatRaster"),
	function(x, proxy=FALSE) {
		r <- methods::new("PackedSpatRaster")
		r@definition <- as.character(x)

		opt <- spatOptions(ncopies=2)
		can <- (!proxy) && x@pntr$canProcessInMemory(opt)

		s <- sources(x)
		mem <- (can || all(s == ""))
		if (mem) {
			r@values <- values(x)
		} else if (all(s != "")) {
			xs <- sources(x, TRUE, TRUE)
			r@attributes$sources <- xs
		} else {
			fname <- paste0(tempfile(), ".tif")
			if (!is.null(path)) {
				path <- normalizePath(path, mustWork=TRUE)
				fname <- file.path(path, basename(fname))
			}
			x <- writeRaster(x, fname)
			r@attributes$filename <- fname
		}
	
		finalizeWrap(x, r, mem)
	}
)


setMethod("unwrap", signature(x="PackedSpatRaster"),
	function(x) {

		r <- eval(parse(text=x@definition))
		if (!is.null(x@attributes$filename)) { # single file, all layers
			rr <- rast(x@attributes$filename)
			ext(rr) <- ext(r)
			crs(rr, warn=FALSE) <- crs(r)
			names(rr) <- names(r)
			r <- rr
		} else if (!is.null(x@attributes$sources)) {
			s <- x@attributes$sources
			u <- unique(s$sid)
			rr <- lapply(1:length(u), function(i) {
					ss <- s[s$sid == i, ]
					r <- rast(ss[1,2])
					r[[ss[,3]]]
				})
			rr <- rast(rr)
			ext(rr) <- ext(r)
			crs(rr, warn=FALSE) <- crs(r)
			names(rr) <- names(r)
			r <- rr
		} else {
			values(r) <- x@values
		}

		if (length(x@attributes) > 0) {
			nms <- names(x@attributes)
			if ("time" %in% nms) {
				tinfo <- x@attributes$tinfo
				if (!is.null(tinfo)) {
					time(r, tinfo$step) <- x@attributes$time
				} else {
					time(r) <- x@attributes$time
				}
			}
			if (any(nms %in% c("levels", "units", "depth"))) {
				time(r) <- x@attributes$time
				units(r) <- x@attributes$units	
				depth(r) <- x@attributes$depth
				if (!is.null(x@attributes$levels)) {
					lyrnms <- names(r)
					if (is.null(x@attributes$levindex)) x@attributes$levindex <- 1
					set.cats(r, layer=0, x@attributes$levels, active=x@attributes$levindex)
					names(r) <- lyrnms
				}
			}
			if (any(nms=="colors")) {
				for (i in seq_along(x@attributes$colors)) {
					if (!is.null(x@attributes$colors[[i]])) {
						d <- .makeSpatDF(x@attributes$colors[[i]])
						if (!r@pntr$setColors(i-1, d)) messages("cols<-", r)
					}
				}
			}
			if (!is.null(x@attributes$varnames)) {
				varnames(r) <- x@attributes$varnames
			}
			if (!is.null(x@attributes$longnames)) {
				longnames(r) <- x@attributes$longnames
			}
		}
		r
	}
)


setMethod("wrap", signature(x="SpatRasterDataset"),
	function(x, proxy=FALSE) {
		r <- methods::new("PackedSpatRasterDC")
		r@type <- "SpatRasterDataset"
		r@rasters <- lapply(x, wrap)
		r
	}
)

setMethod("wrap", signature(x="SpatRasterCollection"),
	function(x, proxy=FALSE) {
		r <- methods::new("PackedSpatRasterDC")
		r@type <- "SpatRasterCollection"
		r@rasters <- lapply(x, wrap)
		r
	}
)

setMethod("unwrap", signature(x="PackedSpatRasterDC"),
	function(x) {
		type <- x@type
		x <- lapply(x@rasters, unwrap)
		if (type == "SpatRasterCollection") {
			sprc(x)
		} else {
			sds(x)
		}
	}
)



setMethod("rast", signature(x="PackedSpatRaster"),
	function(x) {
		unwrap(x)
	}
)

setMethod("unwrap", signature(x="ANY"),
	function(x) {
		x
	}
)


setMethod("serialize", signature(object="SpatExtent"),
	function(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL) {
		serialize(wrap(object), connection=connection, ascii = ascii, xdr = xdr, version = version, refhook = refhook)
	}
)


setMethod("saveRDS", signature(object="SpatExtent"),
	function(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL) {
		saveRDS(wrap(object), file=file, ascii = ascii, version = version, compress=compress, refhook = refhook)
	}
)


setMethod("serialize", signature(object="SpatVector"),
	function(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL) {
		object = wrap(object)
		serialize(object, connection=connection, ascii = ascii, xdr = xdr, version = version, refhook = refhook)
	}
)


setMethod("saveRDS", signature(object="SpatVector"),
	function(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL) {
		object = wrap(object)
		saveRDS(object, file=file, ascii = ascii, version = version, compress=compress, refhook = refhook)
	}
)


setMethod("serialize", signature(object="SpatRaster"),
	function(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL) {
		object <- wrap(object, proxy=TRUE)
		serialize(object, connection=connection, ascii = ascii, xdr = xdr, version = version, refhook = refhook)
	}
)

setMethod("serialize", signature(object="SpatRasterDataset"),
	function(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL) {
		object <- wrap(object, proxy=TRUE)
		serialize(object, connection=connection, ascii = ascii, xdr = xdr, version = version, refhook = refhook)
	}
)

setMethod("serialize", signature(object="SpatRasterCollection"),
	function(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL) {
		object <- wrap(object, proxy=TRUE)
		serialize(object, connection=connection, ascii = ascii, xdr = xdr, version = version, refhook = refhook)
	}
)


setMethod("unserialize", signature(connection="ANY"),
	function(connection, refhook = NULL) {
		x <- base::unserialize(connection, refhook)
		unwrap(x)
	}
)



setMethod("saveRDS", signature(object="SpatRaster"),
	function(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL) {
		object <- wrap(object)
		saveRDS(object, file=file, ascii = ascii, version = version, compress=compress, refhook = refhook)
	}
)

setMethod("saveRDS", signature(object="SpatRasterDataset"),
	function(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL) {
		object <- wrap(object)
		saveRDS(object, file=file, ascii = ascii, version = version, compress=compress, refhook = refhook)
	}
)

setMethod("saveRDS", signature(object="SpatRasterCollection"),
	function(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL) {
		object <- wrap(object)
		saveRDS(object, file=file, ascii = ascii, version = version, compress=compress, refhook = refhook)
	}
)


setMethod("readRDS", signature(file="character"),
	function (file = "", refhook = NULL) {
		x <- base::readRDS(file=file, refhook=refhook)
		unwrap(x)
	}
)



#setMethod("wrap", signature(x="Spatial"),
#	function(x) {
#		pv <- .packVector(x)
#		if (methods::.hasSlot(x, "data")) {
#			pv@attributes <- x@data
#		}
#		pv
#	}
#)

..assume_lonlat <- function(pr) {
	(pr$usr[1] > -300) && (pr$usr[2] < 300) && (pr$yaxp[1] > -200) && (pr$yaxp[2] < 200)
}

.get_dd <- function(pr, lonlat, d=NULL) {
	if (lonlat) {
		lat <- mean(pr$usr[3:4])
		if (is.null(d)) {
			dx <- (pr$usr[2] - pr$usr[1]) / 6
			d <- as.vector(distance(cbind(0, lat), cbind(dx, lat), TRUE))
			d <- max(1, 5 * round(d/5000))
		}
		p <- cbind(0, lat)
		dd <- .destPoint(p, d * 1000)
		dd <- c(dd[1,1], d)
	} else {
		if (is.null(d)) {
			d <- (pr$usr[2] - pr$usr[1]) / 6
			digits <- floor(log10(d)) + 1
			d <- round(d, -(digits-1))
		}
		dd <- c(d, d)
	}
	dd
}

.get_xy <- function(xy, dx=0, dy=0, pr, defpos="bottomleft", caller="") {
    if (is.null(xy)) {
		xy <- defpos
	}
	if (!is.character(xy)) {
		return( cbind(xy[1], xy[2]) )
	}
	xy <- tolower(xy)
	parrange <- c(pr$usr[2] - pr$usr[1], pr$usr[4] - pr$usr[3])
	pad=c(5,5) / 100
	if (xy == "bottom") {
		xy <- c(pr$usr[1]+0.5*parrange[1]-0.5*dx, pr$usr[3]+(pad[2]*parrange[2])) + c(0,dy)
	} else if (xy == "bottomleft") {
		xy <- c(pr$usr[1]+(pad[1]*parrange[1]), pr$usr[3]+(pad[2]*parrange[2])) + c(0,dy)
	} else if (xy == "bottomright") {
		xy <- c(pr$usr[2]-(pad[1]*parrange[1]), pr$usr[3]+(pad[2]*parrange[2])) - c(dx,-dy)
	} else if (xy == "topright") {
		xy <- c(pr$usr[2]-(pad[1]*parrange[1]), pr$usr[4]-(pad[2]*parrange[2])) - c(dx,dy)
	} else if (xy == "top") {
		xy <- c(pr$usr[1]+0.5*parrange[1]-0.5*dx, pr$usr[4]-(pad[2]*parrange[2])) - c(0,dy)
	} else if (xy == "topleft") {
		xy <- c(pr$usr[1]+(pad[1]*parrange[1]), pr$usr[4]-(pad[2]*parrange[2])) - c(0,dy)
	} else if (xy == "left") {
		xy <- c(pr$usr[1]+(pad[1]*parrange[1]), pr$usr[3]+0.5*parrange[2]-0.5*dy)
	} else if (xy == "right") {
		xy <- c(pr$usr[2]-(pad[1]*parrange[1])-dx, pr$usr[3]+0.5*parrange[2]-0.5*dy)
	} else {
		error(caller, 'xy must be a coordinate pair (two numbers) or one of "bottomleft", "bottom", "bottomright", topleft", "top", "topright"')
	}
	xy
}

.destPoint <- function (p, d, b=90, r=6378137) {
    toRad <- pi/180
    lon1 <- p[, 1] * toRad
    lat1 <- p[, 2] * toRad
    b <- b * toRad
    lat2 <- asin(sin(lat1) * cos(d/r) + cos(lat1) * sin(d/r) * cos(b))
    lon2 <- lon1 + atan2(sin(b) * sin(d/r) * cos(lat1), cos(d/r) - sin(lat1) * sin(lat2))
    lon2 <- (lon2 + pi)%%(2 * pi) - pi
    cbind(lon2, lat2)/toRad
}




add_N <- function(x, y, asp, label, type=0, user="", angle=0, cex=1, srt=0, xpd=TRUE, ...) {

	type <- type[1]
	if (type == 0) { symbol = user[1]
	} else if (type == 2) { symbol = "\u27A2"
	} else if (type == 3) { symbol = "\u2799"
	} else if (type == 4) { symbol = "\u27B2"
	} else if (type == 5) { symbol = "\u27BE"
	} else if (type == 6) { symbol = "\u27B8"
	} else if (type == 7) { symbol = "\u27BB"
	} else if (type == 8) { symbol = "\u27B5"
	} else if (type == 9) { symbol = "\u279F"
	} else if (type == 10) { symbol = "\u261B"
	} else if (type == 11) { symbol = "\u2708"
	} else { symbol = "\u2629"}
	if (type == 11) {
		rangle <- 45 - angle
		mcex <- 1.5
	} else {
		rangle <- 90 - angle
		mcex <- 3
	}
	text(x, y, symbol, cex=cex*mcex, srt=rangle, xpd=xpd, ...)
	xs <- graphics::strwidth(symbol,cex=cex*3)
	ys <- graphics::strheight(symbol,cex=cex*3)
	b <- pi * angle / 180
	rxs <- (abs(xs * cos(b)) + abs(ys * sin(b)))# / asp
	rys <- (abs(xs * sin(b)) + abs(ys * cos(b)))# * asp
#	xoff <- (rxs - xs) / 2
#	yoff <- rys + 0.05 * graphics::strheight(label,cex=cex)
	xoff = 0.1 * rxs
	yoff = 0.8 * rys *  max(0.5, abs(cos(angle)))

    if (type == 4) {
        .halo(x+xoff, y-0.2*yoff, label, cex = cex, srt = srt, xpd = xpd, ...)
	} else if (type == 10) {
        .halo(x+xoff, y-yoff, label, cex = cex, srt = srt, xpd = xpd, ...)
    } else {
        text(x+xoff, y+yoff, label, cex = cex, srt = srt, xpd = xpd, ...)
    }
}


north <- function(xy=NULL, type=1, label="N", angle=0, d, head=0.1, xpd=TRUE, ...) {
	pr <- graphics::par()
	pr$usr <- unlist(get.clip()[1:4])
	pa <- c(pr$usr[2] - pr$usr[1], pr$usr[4] - pr$usr[3])
	asp <- pa[2]/pa[1]
	if (missing(d))	{
		d <- 0.07 * pa[2]
	}
	xy <- .get_xy(xy, 0, d, pr, "topright", caller="north")

	if (inherits(type, "character")) {
		usertype <- type
		type = 0
	} else {
		type <- round(type)
		usertype <- ""
	}
	if (type == 1) {
		if (angle != 0) {
			b <- angle * pi / 180;
			p2 <- xy + c(d * sin(b), d * cos(b))
			b <- b + pi
			p1 <- xy + c(d * sin(b), d * cos(b))
			if ((p2[1] - p1[1]) > (d/asp)) {
				m <- xy[1] #p1[1] + (p2[1] - p1[1]) / 2
				slope = (p2[2] - p1[2])/(p2[1] - p1[1])
				newx <- m - 0.5 * d / asp
				p1[2] <- p1[2] + (newx-p1[1]) * slope
				p1[1] <- newx
				newx <- m + 0.5 * d / asp
				p2[2] <- p2[2] - (p2[1]-newx) * slope
				p2[1] <- newx
			}
		} else {
			p1 <- xy - c(0,d)
			p2 <- xy + c(0,d)
		}

		lwd <- list(...)$lwd + 2
		if (is.null(lwd)) lwd <- 3
		graphics::arrows(p1[1], p1[2], p2[1], p2[2], length=head, lwd=lwd, col="white", xpd=xpd)
		graphics::arrows(p1[1], p1[2], p2[1], p2[2], length=head, xpd=xpd, ...)
		if (label != "") {
			if (is.null(list(...)$hw)) {
				.halo(xy[1], xy[2], label, hw=.2, xpd=xpd, ... )
			} else {
				.halo(xy[1], xy[2], label, xpd=xpd, ... )
			}
		}
	} else {
		add_N(xy[1], xy[2], asp=asp, label=label, angle=angle, type=type, user=usertype, xpd=xpd, ...)
	}
}

.sbar_bg <- function(xy, d, below, labels, bg, ytop=0, cex=1, ...){
	h <- graphics::strheight("A", cex=cex)
	pad <- h * 0.5
	n <- length(labels)
	lpos <- seq(xy[1], xy[1] + d, length.out=n)
	lw <- graphics::strwidth(labels, cex=cex) / 2
	x0 <- min(lpos - lw) - pad
	x1 <- max(lpos + lw) + pad
	y0 <- xy[2] - pad
	y1 <- xy[2] + ytop + 2 * h + pad
	if (nchar(below) > 0) y0 <- y0 - 2 * h
	graphics::rect(x0, y0, x1, y1, col=bg, border=bg, xpd=TRUE)
}


add_text <- function(halo=FALSE, ...) {
	if (halo) {
		halo(...)
	} else {
		text(...)
	}
}


sbar <- function(d, xy=NULL, type="line", divs=2, below="", lonlat=NULL, labels, adj=c(0.5, -1), lwd=2, xpd=TRUE, ticks=FALSE, scaleby=1, halo=TRUE, col="black", fill=c("black", "white"), border="black", bg=NULL, ...){


	stopifnot(type %in% c("line", "bar"))
	pr <- graphics::par()
	clp <- get.clip()
	pr$usr <- unlist(clp[,1:4])
	if (is.null(lonlat)) {
		lonlat <- isTRUE(clp[[5]])
	}
	fill <- rep(fill, length.out=2)


	if (missing(d)) {
		labels <- NULL
		d <- NULL
	}
	dd <- .get_dd(pr, lonlat, d)
	d <- dd[2]
	dd <- dd[1]

	xy <- .get_xy(xy, dd, 0, pr, "bottomleft", caller="sbar")

	if (type == "line") {
		if (missing(labels) || is.null(labels)) {
			ds <- d / scaleby
			if (divs > 2) {
				labels <- c(0, round(ds/2, 1), ds)
			} else {
				labels <- paste(ds)
			}
		}
		if (length(labels) == 1) labels <- c("", labels, "")
		tadd <- 0
		if (!isFALSE(ticks)) {
			if (isTRUE(ticks)) {
				tadd <- dd / (15 * diff(pr$usr[1:2]) / diff(pr$usr[3:4]))
			} else {
				tadd <- ticks
			}
		}
		tadd <- max(graphics::strheight("0", cex=1)/5, tadd)
		if (!is.null(bg)) .sbar_bg(xy, dd, below, labels, bg, ytop=tadd, ...)

		if (halo) {
			lines(matrix(c(xy[1], xy[2], xy[1]+dd, xy[2]), byrow=T, nrow=2), lwd=lwd+1, xpd=xpd, col="white")
		}
		lines(matrix(c(xy[1], xy[2], xy[1]+dd, xy[2]), byrow=T, nrow=2), lwd=lwd, xpd=xpd, col=fill[1], ...)
		
		if (missing(adj)) {
			adj <- c(0.5, -0.2-lwd/20 )
		}
		if (!isFALSE(ticks)) {
			if (length(labels) == 3) {
				xtick <- c(xy[1], xy[1]+dd/2, xy[1]+dd)			
			} else {
				xtick <- c(xy[1], xy[1]+dd)
			}
			for (i in 1:length(xtick)) {
				lines(rbind(c(xtick[i], xy[2]), c(xtick[i], xy[2]+tadd)), lwd=ceiling(lwd/2), xpd=TRUE, ...)
			}
		}
		add_text(xy[1]+c(0,dd/2,dd),xy[2]+tadd, labels=labels, xpd=xpd, adj=adj, halo=halo, col=col, ...)

	} else if (type == "bar") {
		stopifnot(divs > 0)
		if (missing(adj)) {
			adj <- c(0.5, -1)
		}
		lwd <- dd / 25

		if (divs==2) {
			if (missing(labels) || is.null(labels)) {
				labels <- c("0", "", d/scaleby)
			}
			if (!is.null(bg)) .sbar_bg(xy, dd, below, labels, bg, ytop=lwd, ...)

			half <- xy[1] + dd / 2
			if (halo) {
				graphics::polygon(c(xy[1], xy[1], xy[1]+dd, xy[1]+dd), 
								  c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col="white", xpd=xpd, border="white", lwd=3)
			}
			
			graphics::polygon(c(xy[1], xy[1], half, half), c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col=fill[1], xpd=xpd, border=border)
			graphics::polygon(c(half, half, xy[1]+dd, xy[1]+dd ), c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col=fill[2], xpd=xpd, border=border)

			add_text(xy[1], xy[2], labels=labels[1], xpd=xpd, adj=adj, halo=halo, col=col, ...)
			add_text(xy[1]+0.5*dd, xy[2], labels=labels[2], xpd=xpd, adj=adj, halo=halo, col=col,...)
			add_text(xy[1]+dd, xy[2], labels=labels[3], xpd=xpd, adj=adj, halo=halo, col=col,...)
		} else {
			if (missing(labels) || is.null(labels)) {
				ds <- d / scaleby
				labels <- c("0", round(0.5*ds), ds)
			}
			if (!is.null(bg)) .sbar_bg(xy, dd, below, labels, bg, ytop=lwd, ...)

			q1 <- xy[1] + dd / 4
			half <- xy[1] + dd / 2
			q3 <- xy[1] + 3 * dd / 4
			end <- xy[1] + dd
			graphics::polygon(c(xy[1], xy[1], q1, q1), c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col=fill[1], xpd=xpd, border=border)
			graphics::polygon(c(q1, q1, half, half), c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col=fill[2], xpd=xpd, border=border)
			graphics::polygon(c(half, half, q3, q3 ), c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col=fill[1], xpd=xpd, border=border)
			graphics::polygon(c(q3, q3, end, end), c(xy[2], xy[2]+lwd, xy[2]+lwd, xy[2]), col=fill[2], xpd=xpd, border=border)
			add_text(xy[1], xy[2], labels=labels[1], xpd=xpd, adj=adj, halo=halo, col=col, ...)
			add_text(half, xy[2], labels=labels[2], xpd=xpd, adj=adj, halo=halo, col=col,...)
			add_text(end, xy[2],labels=labels[3], xpd=xpd, adj=adj, halo=halo, col=col,...)
		}
	}
	if (below != "") {
		adj[2] <- -adj[2]
		if (type == "line") {
			xy[2] <- xy[2] - graphics::strheight("1")/1.5
		} else {
			xy[2] <- xy[2] - graphics::strheight("1")/4		
		}
		add_text(xy[1]+(dd/2), xy[2], xpd=xpd, labels=below, adj=adj, halo=halo, col=col, ...)
	}
}

# Author: Robert J. Hijmans
# Date : February 2012
# Version 1.0
# Licence GPL v3


setMethod("approximate", signature(x="SpatRaster"),
function(x, method="linear", yleft, yright, rule=1, f=0, ties=mean, z=NULL, NArule=1, filename="", ...) {

	out <- rast(x, keeptime=TRUE)
	nl <- nlyr(out)
	if (nl < 2) {
		warning('cannot interpolate with a single layer')
		return(x)
	}

	if (is.null(z)) {
		xout <- time(x)
		if (any(is.na(xout))) {
			xout <- 1:nl
		}
	} else {
		if (length(z)!= nl) {
			error("approximate", "length of z does not match nlyr(x)")
		}
		xout <- z
	}

	ifelse((missing(yleft) & missing(yright)), ylr <- 0L, ifelse(missing(yleft), ylr <- 1L, ifelse(missing(yright), ylr <- 2L, ylr <- 3L)))

    nc <- ncol(out)

	readStart(x)
	on.exit(readStop(x))
	b <- writeStart(out, filename, sources=sources(x), ...)
	for (i in 1:b$n) {
		v <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
		s <- .rowSums(is.na(v), nrow(v), nl)

		if (isTRUE(NArule==1)) {
			j <- s == (nl-1) # one non-NA only
			if (length(j) > 0 ) {
				v[j, ] <- apply(v[j,,drop=FALSE ], 1, max, na.rm=TRUE)
			}
		}
		j <- (s < nl-1) # need at least two
		if (length(j) > 0 ) {
			if (ylr==0) {
				v[j,] <- t( apply(v[j,,drop=FALSE], 1, function(x) stats::approx(x=xout, y=x, xout=xout, method=method, rule=rule, f=f, ties=ties)$y ) )
			} else if (ylr==1) {
				v[j,] <- t( apply(v[j,,drop=FALSE], 1, function(x) stats::approx(x=xout, y=x, xout=xout, method=method, yright=yright, rule=rule, f=f, ties=ties)$y ) )
			} else if (ylr==2) {
				v[j,] <- t( apply(v[j,,drop=FALSE], 1, function(x) stats::approx(x=xout, y=x, xout=xout, method=method, yleft=yleft, rule=rule, f=f, ties=ties)$y ) )
			} else {
				v[j,] <- t( apply(v[j,,drop=FALSE], 1, function(x) stats::approx(x=xout, y=x, xout=xout, method=method, yright=yright, yleft=yleft, rule=rule, f=f, ties=ties)$y ) )
			}
		}
		writeValues(out, v, b$row[i], b$nrows[i])
	}
	writeStop(out)
}
)

.terra_environment <- new.env(parent=emptyenv())

.create_options <- function() {
	opt <- methods::new("SpatOptions")
	opt@pntr <- SpatOptions$new()
	# check=T does not exist in ancient R
	tmpdir <- try(tempdir(check = TRUE), silent=TRUE)
	opt@pntr$tempdir <- normalizePath(tempdir(), winslash="/")

	# respect the CRAN check limit on the number of cores
	chk <- tolower(Sys.getenv("_R_CHECK_LIMIT_CORES_", ""))
	if (chk %in% c("true", "warn")) {
		opt@pntr$threads <- 2
	}

	.terra_environment$options <- opt
	.terra_environment$devs <- NULL
	.terra_environment$RStudio_warned <- FALSE

	x <- options("terra_default")[[1]]
	if (!is.null(x)) {
		do.call(terraOptions, x)
	}

}

# resolve a "threads" argument to a thread count.
# TRUE means "multi-threaded": use the terraOptions("threads") cap, falling
# back to the number of available cores if that is 0 (no cap).
# FALSE means single-threaded (0). A number is used as-is.
.resolve_threads <- function(threads) {
	if (is.logical(threads)) {
		if (isTRUE(threads)) {
			thr <- .terra_environment$options@pntr$threads
			if (thr == 0) {
				thr <- tryCatch(parallel::detectCores(), error=function(e) NA)
				if (is.na(thr)) thr <- 8
			}
			thr
		} else {
			0
		}
	} else {
		threads <- suppressWarnings(round(as.numeric(threads[1])))
		if (is.na(threads) || (threads < 0)) 0 else threads
	}
}

.option_names <- function() {
	c("progress", "progressbar", "tempdir", "memfrac", "memmax", "memmin", "datatype", "filetype", "filenames", "overwrite", "todisk", "names", "verbose", "NAflag", "statistics", "steps", "ncopies", "tolerance", "tmpfile", "threads", "scale", "offset", "parallel") #, "append")
}


.setOptions <- function(x, wopt) {

	nms <- names(wopt)
	g <- which(nms == "gdal")
	if (length(g) > 0) {
		gopt <- unlist(wopt[g])
		wopt <- wopt[-g]
		nms <- nms[-g]
		i <- grep("=", gopt)
		gopt <- gopt[i]
		gopt <- gsub(" ", "", gopt)
		x$gdal_options <- gopt
	}

	i <- which(nms == "metadata")
	if (length(i) > 0) {
		m <- try(parse_tags(wopt[[i]], "USER_TAGS"))
		if (!inherits(m, "try-error")) {
			if (NROW(m) > 0) {
				x$metadata <- apply(m, 1, function(i) paste(i, collapse="_#_"))
			}
		}
		wopt <- wopt[-i]
		nms <- nms[-i]
	}

	s <- nms %in% .option_names()

	if (any(!s)) {
		bad <- paste(nms[!s], collapse=",")
		error("write", "unknown option(s): ", bad)
	}



	if (any(s)) {
		nms <- nms[s]
		wopt <- wopt[s]
		i <- which(nms == "threads")
		if (length(i) > 0) {
			wopt[[i]] <- .resolve_threads(wopt[[i]])
		}
		i <- which(nms == "names")
		if (length(i) > 0) {
			namevs <- trimws(unlist(strsplit(as.character(wopt[[i]]), ",")))
			x[["names"]] <- namevs
			wopt <- wopt[-i]
			nms <- nms[-i]
		}
		if ("tempdir" %in% nms) {
			i <- which(nms == "tempdir")
			if (!dir.exists(wopt[[i]])) {
				warn("options", "you cannot set the tempdir to a path that does not exist")
				wopt <- wopt[-i]
				nms <- nms[-i]
			}
		}

		for (i in seq_along(nms)) {
			x[[nms[i]]] <- wopt[[i]]
		}
	}
	if (x$has_warning()) {
		warn("options", paste(x$getWarnings(), collapse="\n"))
	}
	if (x$has_error()) {
		error("options", x$getError())
	}
	x
}


defaultOptions <- function() {
	## work around onLoad problem
	if (is.null(.terra_environment$options)) .create_options()
	.terra_environment$options@pntr$deepcopy()
}

spatOptions <- function(filename="", overwrite=FALSE, ..., wopt=NULL) {

	wopt <- c(list(...), wopt)

	## work around onLoad problem
	if (is.null(.terra_environment$options)) .create_options()

	opt <- .terra_environment$options@pntr$deepcopy()
	opt$tmpfile <- paste0(gsub("^file", "", basename(tempfile())),  "_", Sys.getpid())
	filename <- .fullFilename(filename, mustExist=TRUE)
	if (!is.null(unlist(wopt))) {
		wopt$filenames <- filename
		wopt$overwrite <- overwrite[1]
		opt <- .setOptions(opt, wopt)
	} else {
		opt$filenames <- filename
		opt$overwrite <- overwrite[1]
	}
	#messages(opt)
	#opt$todisk <- TRUE
	opt
}

#..getOptions <- function() {
#	spatOptions("", TRUE, list())
#}

#..showOptions <- function(opt) {
#	cat("Options for package 'terra'\n")
#	cat("memfrac     :" , opt$memfrac, "\n")
#	cat("tempdir     :" , opt$tempdir, "\n")
#	cat("datatype    :" , opt$def_datatype, "\n")
#	cat("filetype    :" , opt$def_filetype, "\n")
#	cat("progress    :" , opt$progress, "\n")
#	cat("verbose     :" , opt$verbose, "\n")
#	if (opt$todisk) {
#		cat("todisk      :" , opt$todisk, "\n")
#	}
#}


.getOptions <- function() {
	opt <- spatOptions()
	nms <- names(opt)
	nms <- nms[!grepl("^\\.", nms)]
	nms <- nms[!(nms %in% c("initialize", "messages", "getClass", "finalize", "datatype_set", "tmpfile", "statistics", "gdal_options", "scale", "offset", "filenames", "NAflag"))]
	defnms <- grepl("^def_", nms)
	nms <- nms[!defnms]
	out <- sapply(nms, function(n) eval(parse(text=paste0("opt$", n))))
	out$memmin <- 8 * out$memmin / (1024^3)
	if (out$memmax > 0) {
		out$memmax <- 8 * out$memmax / (1024^3)
	} 
	out
}

.showOptions <- function(opt, print=TRUE) {
	out <- .getOptions()
	if (!print) return(out)
	nms <- c("memfrac", "tempdir", "datatype", "progress", "todisk", "verbose", "tolerance", "memmin", "memmax", "parallel", "threads")
	p <- out[names(out) %in% nms]
	if (p$memmax <= 0) p$memmax <- NULL
	nms <- names(p)
	for (i in seq_along(nms)) {
		cat(paste0(substr(paste(nms[i], "         "), 1, 10), ": ", p[i], "\n"))
	}
	invisible(out)
}


.default_option_names <- function() {
	c("datatype", "filetype") #, "verbose")
}


terraOptions <- function(..., print=TRUE) {
	dots <- list(...)
	if (is.null(.terra_environment$options)) .create_options()
	opt <- .terra_environment$options@pntr

	if (length(dots) == 0) {
		return(.showOptions(opt, print=print))
	}
	
	nms <- names(dots)
	ok <- nms %in% .option_names()
	if (any(!ok)) {
		bad <- paste(nms[!ok], collapse=", ")
		warn("terraOptions<-", paste("unknown option(s):", bad))
		dots <- dots[ok]
		nms <- nms[ok]			
		if (length(dots) == 0) return(invisible())
	}

	if ("tempdir" %in% nms) {
		i <- which(nms == "tempdir")
		dots[i] <- path.expand(trimws(dots[i]))
		if (!dir.exists(dots[[i]])) {
			warn("options", "you cannot set the tempdir to a path that does not exist")
			dots <- dots[-i]
			nms <- nms[-i]
			if (length(dots) == 0) return(invisible())
		}
	}

	d <- nms %in% .default_option_names()
	dnms <- paste0("def_", nms)
	for (i in 1:length(nms)) {
		if (d[i]) {
			opt[[ dnms[i] ]] <- dots[[ i ]]
		} else {
			opt[[ nms[i] ]] <- dots[[ i ]]
		}
	}
		
	if ("memfrac" %in% nms) {
		if (dots$memfrac > 0.9) {
			warn("terraOptions", "memfrac > 0.9")
		}
	}
	.terra_environment$options@pntr <- opt
}

# tests for focal() with cores= dispatch (R-fun path) and the TBB-aware
# focalValues() implementation.

# CRAN's --as-cran limits worker processes to 2; everything below stays
# within that ceiling.

# ---- focalValues: parallel result must equal sequential ----
old <- terra::terraOptions(print=FALSE)

# global lonlat raster (exercises the wrap-around branch)
r_glob <- terra::rast(ncols=20L, nrows=15L, vals=seq_len(20L*15L))
terra::terraOptions(parallel=FALSE, threads=0L)
seq_glob <- terra::focalValues(r_glob, w=3L, fill=-9)
terra::terraOptions(parallel=TRUE, threads=2L)
par_glob <- terra::focalValues(r_glob, w=3L, fill=-9)
expect_identical(seq_glob, par_glob)

# projected raster (no wrap-around; exercises the interior std::copy fast path)
r_proj <- terra::rast(ncols=40L, nrows=30L,
                       xmin=0, xmax=4000, ymin=0, ymax=3000,
                       crs="EPSG:32631", vals=seq_len(40L*30L))
terra::terraOptions(parallel=FALSE, threads=0L)
seq_proj <- terra::focalValues(r_proj, w=5L, fill=-1)
terra::terraOptions(parallel=TRUE, threads=2L)
par_proj <- terra::focalValues(r_proj, w=5L, fill=-1)
expect_identical(seq_proj, par_proj)

# restore options
terra::terraOptions(parallel=old$parallel, threads=old$threads)


# ---- focal() with R fun + cores= ----
# small enough to stay quick under tinytest, big enough that the per-block
# parallel path is engaged (.focal_split_chunks splits when nrow >= 64*ncores).
nr <- 80L; nc <- 80L
r <- terra::rast(nrows=nr, ncols=nc, xmin=0, xmax=nc*100, ymin=0, ymax=nr*100,
                  crs="EPSG:32631", vals=seq_len(nr*nc))

# scalar-output user fun
f_scalar <- function(x) sum(x, na.rm=TRUE) / max(1L, sum(!is.na(x)))
ref <- terra::values(terra::focal(r, w=5, fun=f_scalar, cores=1))
got <- terra::values(terra::focal(r, w=5, fun=f_scalar, cores=2))
ok  <- !is.na(ref) & !is.na(got)
expect_true(max(abs(ref[ok] - got[ok])) < 1e-10)

# vector-output user fun (transp branch)
f_vec <- function(x) c(min=min(x, na.rm=TRUE), max=max(x, na.rm=TRUE))
ref <- terra::values(terra::focal(r, w=5, fun=f_vec, cores=1))
got <- terra::values(terra::focal(r, w=5, fun=f_vec, cores=2))
ok  <- !is.na(ref) & !is.na(got)
expect_true(max(abs(ref[ok] - got[ok])) < 1e-10)

# multi-layer
r2  <- c(r, r * 2L)
ref <- terra::values(terra::focal(r2, w=5, fun=f_scalar, cores=1))
got <- terra::values(terra::focal(r2, w=5, fun=f_scalar, cores=2))
ok  <- !is.na(ref) & !is.na(got)
expect_true(max(abs(ref[ok] - got[ok])) < 1e-10)

# weights matrix path (dow=TRUE, msz != prod(w) when NA in weights)
wm  <- matrix(c(0,1,0,1,1,1,0,1,0), 3L, 3L)
ref <- terra::values(terra::focal(r, w=wm, fun=f_scalar, cores=1))
got <- terra::values(terra::focal(r, w=wm, fun=f_scalar, cores=2))
ok  <- !is.na(ref) & !is.na(got)
expect_true(max(abs(ref[ok] - got[ok])) < 1e-10)

# user-supplied cluster object (so we don't pay setup cost in users' loops)
if (requireNamespace("parallel", quietly=TRUE)) {
	cl <- parallel::makeCluster(2L)
	got <- terra::values(terra::focal(r, w=5, fun=f_scalar, cores=cl))
	parallel::stopCluster(cl)
	ok  <- !is.na(ref) & !is.na(got)
	# `ref` here is the weighted-window result; recompute scalar reference
	ref <- terra::values(terra::focal(r, w=5, fun=f_scalar, cores=1))
	ok  <- !is.na(ref) & !is.na(got)
	expect_true(max(abs(ref[ok] - got[ok])) < 1e-10)
}

# Verify SpatRaster$focal2 produces identical output to $focal
# for every code path (plain box, separable, generic, NA policies).

.spatOpts <- function() terra:::spatOptions("", FALSE, list())

f1 <- function(x, w, m, fillvalue, narm, naonly, naomit, fun, expand) {
	r <- x
	r@pntr <- x@pntr$focal(w, m, fillvalue, narm, naonly, naomit, fun, expand, .spatOpts())
	as.vector(values(r))
}
f2 <- function(x, w, m, fillvalue, narm, naonly, naomit, fun, expand) {
	r <- x
	r@pntr <- x@pntr$focal2(w, m, fillvalue, narm, naonly, naomit, fun, expand, .spatOpts())
	as.vector(values(r))
}

cmp <- function(x, w, m, fun, ..., fillvalue=NA, narm=FALSE, naonly=FALSE, naomit=FALSE, expand=FALSE) {
	a <- f1(x, w, m, fillvalue, narm, naonly, naomit, fun, expand)
	b <- f2(x, w, m, fillvalue, narm, naonly, naomit, fun, expand)
	expect_equal(a, b, info=paste("fun=", fun, "narm=", narm, "expand=", expand, ...))
}


# ── small 3x3 raster with the original tinytest scenarios ─────────────────────

set.seed(1)

m <- matrix(0,3,3)
m[c(4,6)] <- c(1,-1)
r <- rast(nrows=3, ncols=3, vals=1:9, crs="+proj=merc")

# rank-1 weighted (m has positive and negative weights, but is rank-1)
cmp(r, c(3,3), as.vector(t(m)), "sum", narm=TRUE)
cmp(r, c(3,3), as.vector(t(m)), "sum", narm=FALSE, fillvalue=0)
cmp(r, c(3,3), as.vector(t(t(m))), "sum", narm=TRUE)

# plain uniform
m1 <- matrix(1,3,3)
cmp(r, c(3,3), as.vector(t(m1)), "sum", narm=TRUE)
cmp(r, c(3,3), as.vector(t(m1)), "sum", narm=FALSE)
cmp(r, c(3,3), as.vector(t(m1)), "sum", narm=FALSE, fillvalue=0)
cmp(r, c(3,3), as.vector(t(m1)), "mean", narm=TRUE)
cmp(r, c(3,3), as.vector(t(m1)), "mean", narm=FALSE)


# ── lon/lat 3x3 (boundary should fill with NA, not wrap because not global) ──

r <- rast(nrow=3, ncol=3, vals=1:9)
m1 <- as.vector(t(matrix(1,3,3)))
cmp(r, c(3,3), m1, "sum",  narm=TRUE)
cmp(r, c(3,3), m1, "sum",  narm=FALSE)
cmp(r, c(3,3), m1, "mean", narm=TRUE)
cmp(r, c(3,3), m1, "mean", narm=FALSE)
cmp(r, c(3,3), m1, "max",  narm=TRUE)


# ── global raster: column wrap ───────────────────────────────────────────────

rg <- rast(nrow=3, ncol=4, vals=1:12)        # default ext is global lonlat
cmp(rg, c(3,3), m1, "sum",  narm=TRUE)
cmp(rg, c(3,3), m1, "sum",  narm=FALSE)
cmp(rg, c(3,3), m1, "mean", narm=TRUE)


# ── expand boundary ──────────────────────────────────────────────────────────

r <- rast(nrows=4, ncols=5, vals=1:20, crs="+proj=merc")
cmp(r, c(3,3), m1, "sum",  narm=FALSE, expand=TRUE)
cmp(r, c(3,3), m1, "mean", narm=FALSE, expand=TRUE)
cmp(r, c(3,3), m1, "sum",  narm=TRUE,  expand=TRUE)


# ── larger raster, larger window, with NAs and different policies ────────────

r <- rast(ncols=20, nrows=15, vals=1:300, crs="+proj=merc")
v <- values(r); v[c(7, 31, 122, 200, 250)] <- NA; values(r) <- v

m_plain <- rep(1, 25)                                  # 5x5 uniform
m_gauss <- as.vector(outer(c(1,2,4,2,1)/10, c(1,2,4,2,1)/10))   # rank-1 weighted

# plain box
for (narm in c(TRUE, FALSE)) {
	for (fillvalue in list(NA, 0)) {
		cmp(r, c(5,5), m_plain, "sum",  narm=narm, fillvalue=fillvalue)
		cmp(r, c(5,5), m_plain, "mean", narm=narm, fillvalue=fillvalue)
	}
}
# separable rank-1
for (narm in c(TRUE, FALSE)) {
	cmp(r, c(5,5), m_gauss, "sum",  narm=narm, fillvalue=0)
	cmp(r, c(5,5), m_gauss, "mean", narm=narm, fillvalue=0)
}
# expand boundary, plain
cmp(r, c(5,5), m_plain, "sum",  narm=TRUE,  expand=TRUE)
cmp(r, c(5,5), m_plain, "mean", narm=FALSE, expand=TRUE)

# na.policy="only" / "omit" pass-through
cmp(r, c(5,5), m_plain, "sum",  narm=TRUE, naonly=TRUE)
cmp(r, c(5,5), m_plain, "mean", narm=TRUE, naomit=TRUE)

# generic fallback (max) — plain window but non-sum/mean
cmp(r, c(5,5), m_plain, "max",  narm=TRUE)
cmp(r, c(5,5), m_plain, "modal", narm=TRUE)


# ── multi-layer ──────────────────────────────────────────────────────────────

r2 <- c(r, r * 2, r + 5)
cmp(r2, c(5,5), m_plain, "sum",  narm=TRUE)
cmp(r2, c(5,5), m_plain, "mean", narm=FALSE, fillvalue=0)
cmp(r2, c(5,5), m_gauss, "sum",  narm=TRUE,  fillvalue=0)

# Validate that the TBB-parallel paths in classify() (lookup_apply +
# reclass_vector_range) and subst() (lookup_apply + replaceValues) produce the
# same results as the sequential fallback. The C++ kernels only switch to the
# parallel path when the per-block work is >= 16384 cells, so we use a 200x200
# raster (40000 cells) to make sure the TBB branch is actually exercised.

set.seed(1)
nr <- 200L; nc <- 200L
v_in <- sample(1L:6L, nr*nc, replace=TRUE)
r <- rast(nrows=nr, ncols=nc, vals=v_in)


run_with_parallel <- function(par, threads, expr) {
	old <- terraOptions(print=FALSE)
	on.exit(terraOptions(parallel = old$parallel, threads = old$threads), add=TRUE)
	terraOptions(parallel = par, threads = threads)
	force(eval(expr, parent.frame()))
}


# ---- subst (lookup_apply path) ----

ref_sub <- run_with_parallel(FALSE, 0L,
	quote(subst(r, 1:3, 101:103)))
par_sub <- run_with_parallel(TRUE, 4L,
	quote(subst(r, 1:3, 101:103)))
expect_equal(values(par_sub), values(ref_sub))


# subst with 'others' (forces the alternate branch in lookup_apply)
ref_sub2 <- run_with_parallel(FALSE, 0L,
	quote(subst(r, 1:3, 101:103, others=-1)))
par_sub2 <- run_with_parallel(TRUE, 4L,
	quote(subst(r, 1:3, 101:103, others=-1)))
expect_equal(values(par_sub2), values(ref_sub2))


# ---- classify is-becomes (lookup_apply path) ----

rcl_ib <- matrix(c(1,11, 2,12, 3,13), ncol=2, byrow=TRUE)
ref_cl_ib <- run_with_parallel(FALSE, 0L,
	quote(classify(r, rcl_ib, others=NA)))
par_cl_ib <- run_with_parallel(TRUE, 4L,
	quote(classify(r, rcl_ib, others=NA)))
expect_equal(values(par_cl_ib), values(ref_cl_ib))


# ---- classify from-to-becomes (reclass_vector_range path) ----

rcl_ftb <- matrix(c(0,2,1, 2,5,2, 5,8,3), ncol=3, byrow=TRUE)
ref_cl_ftb <- run_with_parallel(FALSE, 0L,
	quote(classify(r, rcl_ftb, include.lowest=TRUE, right=TRUE)))
par_cl_ftb <- run_with_parallel(TRUE, 4L,
	quote(classify(r, rcl_ftb, include.lowest=TRUE, right=TRUE)))
expect_equal(values(par_cl_ftb), values(ref_cl_ftb))


# left-closed variant (different code path inside reclass_vector_range)
ref_cl_lc <- run_with_parallel(FALSE, 0L,
	quote(classify(r, rcl_ftb, include.lowest=TRUE, right=FALSE)))
par_cl_lc <- run_with_parallel(TRUE, 4L,
	quote(classify(r, rcl_ftb, include.lowest=TRUE, right=FALSE)))
expect_equal(values(par_cl_lc), values(ref_cl_lc))


# ---- multi-output subst (replaceValues 'mout' path) ----

ref_mout <- run_with_parallel(FALSE, 0L,
	quote(subst(r, from=1:3, to=cbind(c(101,102,103), c(201,202,203)))))
par_mout <- run_with_parallel(TRUE, 4L,
	quote(subst(r, from=1:3, to=cbind(c(101,102,103), c(201,202,203)))))
expect_equal(values(par_mout), values(ref_mout))


# ---- multi-input subst (replaceValues 'min' path) ----

r2 <- c(r, r * 2L)
from_mat <- matrix(c(1,2, 2,4, 3,6), ncol=2, byrow=TRUE)
ref_min <- run_with_parallel(FALSE, 0L,
	quote(subst(r2, from=from_mat, to=c(901, 902, 903))))
par_min <- run_with_parallel(TRUE, 4L,
	quote(subst(r2, from=from_mat, to=c(901, 902, 903))))
expect_equal(values(par_min), values(ref_min))

setMethod("panel", signature(x="SpatRaster"),
	function(x, main, loc.main="topleft", nc, nr, maxnl=16, maxcell=500000, 
		box=FALSE, pax=list(), plg=list(), range=NULL, halo=TRUE, type=NULL, ...)  {

		if (!is.null(type)) {
			type <- match.arg(tolower(type), c("classes", "continuous", "interval"))
		}

#		dots <- list(...)
#		if (!is.null(dots$type)) {
#			error("panel", "you cannot set the plot type")
#		}
#		if (!is.null(dots$breaks)) {
#			error("panel", "you cannot use argument 'breaks'")
#		}
		categorical <- FALSE
		if (is.null(type) && any(is.factor(x))) {
			x <- combineLevels(x)
			categorical <- TRUE
		}

		nl <- max(1, min(nlyr(x), maxnl))

		if (nl==1) {
			out <- plot(x, 1, maxcell=maxcell, main=main[1], ...)
			return(invisible(out))
		}

		nrnc <- .get_nrnc(nr, nc, nl)
		old.par <- graphics::par(no.readonly = TRUE)
		on.exit(graphics::par(old.par))
		mar <- rep(0.33, 4)
		m <- matrix((1:prod(nrnc))+1, nrow=nrnc[1], ncol=nrnc[2], byrow=TRUE)
		m <- rbind(1, cbind(1, m, max(m)+1), 1)
		w <- c(0.05, rep(0.8/nrnc[2], nrnc[2]), 0.15)
		h <- c(0.05, rep(0.94/nrnc[1], nrnc[1]), 0.05)
		graphics::layout(m, w, h)
		plot(0, type="n", axes=FALSE, xlab="", ylab="")

		maxcell <- maxcell/nl

		if (missing("main")) {
			tm <- time(x)
			if (!any(is.na(tm))) {
				main <- as.character(time(x))
			} else {
				main <- names(x)
			}
		} else {
			main <- rep_len(main, nl)
		}
		legend <- rep(FALSE , nl)
		legi <- max(1, ceiling(nrnc[1] / 2)) * nrnc[2]
		legend[legi] <- TRUE		
		left <- c(0,2)[(((1:nl)-1) %% nrnc[2] == 0)+1]
		b <- ((1:nl) > ((nrnc[1]-1) * nrnc[2]))+1
		i <- (prod(nrnc) - nl)
		if (i > 0) {
			b[((nrnc[1]-2) * nrnc[2]) + ((nrnc[2]-(i-1)):nrnc[2])] <- 2
		}
		bottom <- c(0,1)[b]

		if (!categorical) {
			x <- spatSample(x, maxcell, method="regular", as.raster=TRUE, warn=FALSE)
			r <- as.matrix(x)
			if (is.null(range)) {
				if (all(hasMinMax(x))) {
					range <- range(minmax(x, FALSE))
					if (any(is.nan(range) | is.infinite(range))) {
						r <- as.matrix(x)
						r[is.infinite(r)] <- NA
						range <- range(r, na.rm=TRUE)
					}
				} else {
					r[is.infinite(r)] <- NA
					range <- range(r, na.rm=TRUE)
				}
			}
			r <- na.omit(unique(as.vector(r)))
			if (is.null(type)) {
				if (length(r) > 10) {
					type <- "continuous"
				} else {
					type <- "classes"
				}
			}
			if (type == "classes") {
				levs <- data.frame(ID=1:length(r), sort(r))
				colnames(levs)[2] <- names(x)[1]
				x <- categories(x, 0, levs)
				categorical <- TRUE
			}
		}
		if (is.null(plg$size)) plg$size <- max(1, nrnc[1] * 0.66)
		if (is.null(plg$cex))  plg$cex  <- 1.25 
		plg$yshift <- (nrnc[1] %% 2 == 0) 

		for (i in 1:nl) {
			pax$side <- c(bottom[i], left[i])
			if (categorical) {
				plot(x[[i]], 1, main=main[i], mar=mar, legend=legend[i], pax=pax, box=box, 
					loc.main=loc.main, halo=halo, plg=plg, type="classes", all_levels=TRUE, maxcell=Inf, ...)
			} else {
				plot(x, i, main=main[i], mar=mar, legend=legend[i], range=range, pax=pax, box=box, 
					loc.main=loc.main, halo=halo, plg=plg, type=type, maxcell=Inf, ...)
			}
		}
	}
)

unloadGDALdrivers <- function(x) {
	.removeDriver(x)
}

proj_ok <- function() {
	.proj_conf_test()
}


projNetwork <- function(enable, url="") {
	if (missing(enable)) {
		as.logical(.PROJ_network(-1, ""))
	} else {
		if (enable) {
			out <- .PROJ_network(1, url)
			if (out != "") {
				message("PROJ network enabled. Using CDN URL: ", out)
			} else {
				message("PROJ network enabled")
			}
		} else {
			.PROJ_network(0, "")
			message("PROJ network disabled")
		}
		invisible(NULL)
	}
}


projPaths <- function(paths, with_proj = TRUE) {
	if (missing(paths)) {
		.get_proj_search_paths()
	} else {
		paths <- as.character(paths)
		.set_proj_search_paths(paths, with_proj)
		invisible(.get_proj_search_paths())
	}
}


fileBlocksize <- function(x) {
	v <- x@pntr$getFileBlocksize()
	m <- matrix(v, ncol=2)
	colnames(m) <- c("rows", "cols")
	m
}


clearVSIcache <- function() {
	.clearVSIcache(TRUE)
}

gdalCache <- function(size=NA) {
	vsi <- FALSE # vsi not working
	if (is.null(size) || is.na(size)) {
		.getGDALCacheSizeMB(vsi)
	} else if (size > 0) {
		.setGDALCacheSizeMB(size, vsi)
	}
}


getGDALconfig <- function(option) {
	sapply(option, .gdal_getconfig)
}

setGDALconfig <- function(option, value="") {
	value <- rep_len(value, length(option))
	for (i in 1:length(option)) {
		if (grepl("=", option[i])) {
			opt <- trimws(unlist(strsplit(option[i], "="))[1:2])
			.gdal_setconfig(opt[1], opt[2])
		} else {
			.gdal_setconfig(trimws(option[i]), trimws(value[i]))
		}
	}
}


libVersion <- function(lib="all", parse=FALSE) {
	lib <- tolower(lib)
	if (lib=="gdal") {
		out <- .gdal_version()
	} else if (lib=="proj") {
		out <- proj_version()
	} else if (lib=="geos") {
		out <- .geos_version()
	} else if (lib=="TBB") {
		return(.have_TBB())
	} else {
		out <- data.frame(gdal=.gdal_version(), proj=proj_version(), geos=.geos_version(), TBB=.have_TBB())
	}
	if (parse) {
		if (lib=="all") {
			out$TBB <- NULL
		} else if (lib == "tbb") {
			return(out)
		}
		nms <- names(out)
		out <- unlist(out)
		out <- data.frame(matrix(as.numeric(unlist(strsplit(out, "\\."))), ncol=3, byrow=TRUE), row.names=nms)
		names(out) <- c("major", "minor", "sub")
	}
	out
}




gdal <- function(warn=NA, drivers=FALSE, ...) {
	if (!is.na(warn)) {
		warn <- as.integer(warn)
		stopifnot(warn %in% (1:4))
		.set_gdal_warnings(warn)
	} else if (drivers) {
		x <- .gdaldrivers()
		x <- do.call(cbind, x)
		x <- data.frame(x)
		x[,2] = c(FALSE, TRUE)[as.integer(x[,2])+1]
		x[,3] = c(FALSE, TRUE)[as.integer(x[,3])+1]
		x[,4] = c("read", "read/write", "read/write")[as.integer(x[,4])+1]
		colnames(x) <- c("name", "raster", "vector", "can", "vsi", "long.name")
		x[,5] <- x[,5] == 1
		x <- x[order(x$name), ]
		rownames(x) <- NULL
		x
	} else {
		dots <- list(...)
		if (length(dots) > 0) {
			libVersion(dots[1])
		} else {
			libVersion("gdal")		
		}
	}
}



.describe_sds <- function(x, print=FALSE) {
	x <- .sdinfo(x)
	if (length(x[[1]]) == 1 & length(x[[2]]) == 0) {
		error("gdal (sds)", x[[1]])
	}
	names(x) <- c("name", "var", "desc", "nrow", "ncol", "nlyr")
	m <- do.call(cbind, x)
	m <- data.frame(id=1:nrow(m), m, stringsAsFactors=FALSE)
	ii <- which(colnames(m) %in% c("nrow", "ncol", "nlyr"))
	for (i in ii) m[,i] <- as.integer(m[,i])
	if (print) {
		print(m)
		invisible(m)
	} else {
		m
	}
}



.meta_sds <- function(x, parse=FALSE, ...) {
	if (parse) {
		m <- .parsedsdsmetadata(x)
		m <- do.call(cbind, m)
		if (nrow(m) > 0) {
			m <- data.frame(1:nrow(m), m, stringsAsFactors=FALSE)
		} else {
			m <- data.frame(0[0], m, stringsAsFactors=FALSE)
		}
		for (i in 5:7) m[,i] <- as.integer(m[,i])
		colnames(m) <- c("id", "name", "var", "desc", "nrow", "ncol", "nlyr")
	} else {
		m <- .sdsmetadata(x)
	}
	m
}

mdinfo_simplify <- function(p) {
	p <- gsub('\"', "", strsplit(p, "\n")[[1]])
	p <- p[-c(1, length(p))]
	p <- gsub("^  ", "", p)
	p <- gsub(",$", "", p)
	  
	s <- grep("\\[", p)[-1]
	e <- grep("]", p)
	i <- which(s > e[-length(e)])[1]
	e <- e[-i]
	if (max(e-s) < 8) {
		for (i in 1:length(s)) {
			p[s[i]] <- paste0(p[s[i]], paste(trimws(p[(s[i]+1):e[i]]), collapse=""))
		}
		s <- s + 1
		r <- unlist(lapply(1:length(s), function(i) s[i]:e[i]))
		p <- p[-r]
	}
	p
}

ar_info <- function(x, what="describe", simplify=TRUE, filter=TRUE, array="") {
	what <- match.arg(tolower(what), c("describe", "arrays", "dimensions"))
	if (what == "describe") {
		p <- .gdalmdinfo(x, ""[0])
		if (simplify) {
			pp <- try(mdinfo_simplify(p), silent=TRUE)
			if (!inherits(pp, "try-error")) {
				p <- pp
			}
		}
		return(p)
	} else if (what == "arrays") {
		.arnames(x, filter);
	} else if (what == "dimensions") {
		d <- .dimfo(x, array)
		if (d$size[1] == -99) {
			error("descar", d$name[1])
		}
		data.frame(d);
	}
}


setMethod("describe", signature(x="character"),
	function(x, sds=FALSE, meta=FALSE, parse=FALSE, options="", print=FALSE, open_opt="") {

		x <- .fullFilename(x[1], FALSE)
		#x <- x[1]
		if (meta) {
			if (sds) {
				return(.meta_sds(x, parse))
			} else {
				return(.metadata(x))
			}
		}

		if (sds) {
			return(.describe_sds(x, print=print))
		}
		options <- unique(trimws(options))
		options <- options[options != ""]
		if (length(options) > 0) {
			options <- paste0("-", options)
			options <- gsub("^--", "-", options)
		}
		open_opt <- unique(trimws(open_opt))
		open_opt <- open_opt[open_opt != ""]
		g <- .gdalinfo(x, options, open_opt)

		if (g == "") {
			add <- ifelse(!file.exists(x), "\n", "\nThe file does not exist\n")
			x <- paste0("GDAL cannot open: ", x, add)
		}
		y <- unlist(strsplit(g, "\n"))
		if (print) {
			cat(g, "\n")
			invisible(y)
		} else {
			return(y)
		}
	}
)

setMethod("describe", signature(x="SpatRaster"),
	function(x, source=1, ...) {
		if (!hasValues(x)) return(NULL)
		source <- round(source)
		if ((source < 1) || (source > nsrc(x))) {
			error("describe", "source should be >= 1 and <= nsrc()")
		}
		describe(sources(x)[source])
	}
)

# tests for tile_apply()

f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)


# numeric tile spec: x * 2 should reproduce r * 2 cell-for-cell 

out2 <- tile_apply(r, function(x) x * 2, tiles=50)
expect_inherits(out2, "SpatRaster")
expect_equal(dim(out2), dim(r))

v_in <- values(r)
v_out <- values(out2)
ok <- !is.na(v_in) & !is.na(v_out)
expect_true(sum(ok) > 0)
expect_equal(v_out[ok], 2 * v_in[ok])


# tiles given as a 4-column matrix (from getTileExtents) 

m <- getTileExtents(r, 50)
out_m <- tile_apply(r, function(x) x + 1, tiles=m)
expect_equal(dim(out_m), dim(r))
v <- values(out_m)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] + 1)


# tiles given as a list of SpatExtents

elist <- lapply(seq_len(nrow(m)), function(i) ext(m[i, ]))
out_list <- tile_apply(r, function(x) x + 1, tiles=elist)
expect_equal(dim(out_list), dim(r))
v <- values(out_list)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] + 1)


# tiles given as a SpatRaster template

tpl <- rast(ext(r), nrows=2, ncols=2, crs=crs(r))
out_tpl <- tile_apply(r, function(x) x * 2, tiles=tpl)
expect_equal(dim(out_tpl), dim(r))


# extra `...` arguments are forwarded by name

out_dots <- tile_apply(r, function(x, k) x * k, tiles=50, k=3)
v <- values(out_dots)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] * 3)


# single-tile shortcut (no mosaic call) 

out_one <- tile_apply(r, function(x) x + 0, tiles=ext(r))
expect_equal(dim(out_one), dim(r))


# focal: buffered tiles + overlap_fun = "mean" assembles via mosaic ─
# (per-tile output includes buffered cells; mean blending across overlap.)

tiles_buf <- getTileExtents(r, 50, buffer=5)
out_focal <- tile_apply(r,
	function(x) focal(x, w=5, fun="mean", na.rm=TRUE),
	tiles=tiles_buf, overlap_fun="mean")
expect_equal(dim(out_focal), dim(r))
expect_true(any(!is.na(values(out_focal))))


# memory-safe assembly: default returns a VRT-backed SpatRaster 
out_vrt <- tile_apply(r, function(x) x * 2, tiles=50)
expect_equal(as.vector(minmax(out_vrt)), c(282, 1094))

v <- values(out_vrt)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(as.vector(table(ok)), c(3942, 4608))

expect_true(grepl("\\.vrt$", sources(out_vrt)[1]))


# memory-safe assembly: filename materialises a single output file

ftif_seq <- file.path(tempdir(), "tile_apply_test_seq.tif")
unlink(ftif_seq)
out_file <- tile_apply(r, function(x) x + 1, tiles=50,
	filename=ftif_seq, overwrite=TRUE)
expect_true(file.exists(ftif_seq))
expect_equal(normalizePath(sources(out_file)[1], "/"),
			 normalizePath(ftif_seq, "/"))
v <- values(out_file)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] + 1)
unlink(ftif_seq)


# overlap_fun = "first" via mosaic equals input on non-overlapping tiles

out_first <- tile_apply(r, function(x) x + 0, tiles=50, overlap_fun="first")
expect_equal(dim(out_first), dim(r))
v <- values(out_first)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok])


# auto buffer: focal(buffer=2) matches a full-raster focal exactly ──
# (per-tile output is cropped to the un-buffered tile extent, so the VRT path
#  yields the same answer as running focal on the whole raster. We write the
#  intermediates as FLT8S so the comparison is bit-exact; with the default
#  FLT4S a ~1e-5 roundtrip difference is normal.)
# cores=2 (not 4) so we stay within R CMD check --as-cran's
# _R_CHECK_LIMIT_CORES_ ceiling of 2 worker processes.

ref_focal <- focal(r, w=5, fun="mean", na.rm=TRUE)
out_buf <- tile_apply(r,
	function(x) focal(x, w=5, fun="mean", na.rm=TRUE),
	buffer=2, cores=2, wopt=list(datatype="FLT8S"))
expect_equal(dim(out_buf), dim(r))
v_ref <- values(ref_focal); v_out <- values(out_buf)
ok <- !is.na(v_ref) & !is.na(v_out)
expect_equal(v_out[ok], v_ref[ok])

# without buffer, multi-tile auto path produces seam artefacts at tile edges
out_nobuf <- tile_apply(r,
	function(x) focal(x, w=5, fun="mean", na.rm=TRUE),
	buffer=0, cores=2, wopt=list(datatype="FLT8S"))
v_nb <- values(out_nobuf)
ok <- !is.na(v_ref) & !is.na(v_nb)
expect_true(max(abs(v_ref[ok] - v_nb[ok])) > 0)


# auto buffer: works in parallel and via filename

ftif_buf <- file.path(tempdir(), "tile_apply_test_buf.tif")
unlink(ftif_buf)
out_bp <- tile_apply(r,
	function(x) focal(x, w=5, fun="mean", na.rm=TRUE),
	buffer=2, cores=2, filename=ftif_buf, overwrite=TRUE,
	wopt=list(datatype="FLT8S"))
expect_true(file.exists(ftif_buf))
v_bp <- values(out_bp); ok <- !is.na(v_ref) & !is.na(v_bp)
expect_equal(v_bp[ok], v_ref[ok])
unlink(ftif_buf)


# buffer is ignored (with a warning) when tiles is supplied explicitly

expect_warning(
	out_bw <- tile_apply(r, function(x) x + 1, tiles=50, buffer=3),
	pattern="buffer.*only used when 'tiles' is NULL"
)
v <- values(out_bw)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] + 1)


# auto tiles: tiles=NULL uses GDAL block size + cores-aware sizing

# elev.tif's GDAL block is one strip (43 rows x 95 cols), so the auto path
# produces ~2 tiles regardless of cores (the one-block floor wins).
out_auto <- tile_apply(r, function(x) x * 2)
expect_inherits(out_auto, "SpatRaster")
expect_equal(dim(out_auto), dim(r))
v <- values(out_auto)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], 2 * v_in[ok])

# auto tiles with `cores>1` should still produce a correct mosaic
out_auto2 <- tile_apply(r, function(x) x + 1, cores=2)
expect_equal(dim(out_auto2), dim(r))
v <- values(out_auto2)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] + 1)

# auto tiles: scaling with cores on a larger in-memory raster

big <- rast(nrows=2000, ncols=2000, vals=1)
m1 <- getTileExtents(big, cores=1)
m4 <- getTileExtents(big, cores=4)
expect_inherits(m1, "matrix")
expect_equal(ncol(m1), 4L)
# more workers must not produce fewer tiles
expect_true(nrow(m4) >= nrow(m1))
# at least cores * 1 tiles for parallelism
expect_true(nrow(m4) >= 4)

# auto tiles: align to GDAL block size on a tiled GeoTIFF

ftif <- file.path(tempdir(), "tile_apply_test_tiled.tif")
writeRaster(big, ftif, overwrite=TRUE,
	gdal=c("TILED=YES", "BLOCKXSIZE=128", "BLOCKYSIZE=128"))
if (file.exists(ftif)) {
	tiled <- rast(ftif)

	# fileBlocksize should report the tile size we set
	fb <- fileBlocksize(tiled)
	expect_equal(as.integer(fb[1, "rows"]), 128L)
	expect_equal(as.integer(fb[1, "cols"]), 128L)

	# Auto tile extents should align to whole 128x128 blocks. Interior (non-
	# edge) tiles all share the same nominal width/height; that nominal size
	# must be a multiple of 128. Edge tiles may be smaller.
	m_auto <- getTileExtents(tiled, cores=4)
	xres_t <- xres(tiled); yres_t <- yres(tiled)
	tile_w_cells <- round((m_auto[, "xmax"] - m_auto[, "xmin"]) / xres_t)
	tile_h_cells <- round((m_auto[, "ymax"] - m_auto[, "ymin"]) / yres_t)
	nominal_w <- max(tile_w_cells)
	nominal_h <- max(tile_h_cells)
	expect_equal(nominal_w %% 128L, 0L)
	expect_equal(nominal_h %% 128L, 0L)
	# and we should get at least as many tiles for more cores
	m_auto1 <- getTileExtents(tiled, cores=1)
	expect_true(nrow(m_auto) >= nrow(m_auto1))

	rm(tiled)
	unlink(ftif)
}


# error handling

expect_error(tile_apply("not a raster", function(x) x, tiles=50))
expect_error(tile_apply(r, function(x) values(x), tiles=50))   # fun must return a SpatRaster

# x with a window already set is rejected (use a window inside r's extent)
rw <- r
window(rw) <- ext(5.8, 6.0, 49.5, 49.8)
expect_true(window(rw))
expect_error(tile_apply(rw, function(x) x, tiles=50))

# multi-source SpatRaster (window() returns a length > 1 logical) (#2150)
r2 <- c(r, r)
expect_equal(length(window(r2)), 2)
out_ml <- tile_apply(r2, function(x) x * 2, tiles=50)
expect_equal(nlyr(out_ml), 2)
v_ml <- values(out_ml)
ok <- !is.na(v_ml[,1]) & !is.na(v_in)
expect_equal(v_ml[ok, 1], 2 * v_in[ok])
expect_equal(v_ml[ok, 2], 2 * v_in[ok])


# parallel run ─
# Wrapped in tryCatch so a worker that cannot start does not break the suite.

if (requireNamespace("parallel", quietly=TRUE)) {
	tried <- tryCatch({
		out_par <- tile_apply(r, function(x) x * 2, tiles=50, cores=2)
		TRUE
	}, error = function(e) FALSE)
	if (tried) {
		v_par <- values(out_par)
		ok <- !is.na(v_par) & !is.na(v_in)
		expect_equal(v_par[ok], 2 * v_in[ok])

		# named extra args forwarded across workers
		out_par2 <- tile_apply(r, function(x, k) x * k, tiles=50, cores=2, k=7)
		v <- values(out_par2)
		ok <- !is.na(v) & !is.na(v_in)
		expect_equal(v[ok], 7 * v_in[ok])

		# user-supplied cluster object honored (not stopped by tile_apply)
		cl <- parallel::makeCluster(2)
		out_par3 <- tile_apply(r, function(x) x + 1, tiles=50, cores=cl)
		expect_inherits(out_par3, "SpatRaster")
		# cluster should still be alive after the call
		expect_silent(parallel::clusterCall(cl, function() 1L))
		parallel::stopCluster(cl)

		# parallel + filename: workers stream pixels straight to disk
		ftif_par <- file.path(tempdir(), "tile_apply_test_par.tif")
		unlink(ftif_par)
		out_par_f <- tile_apply(r, function(x) x * 3, tiles=50, cores=2,
			filename=ftif_par, overwrite=TRUE)
		expect_true(file.exists(ftif_par))
		v <- values(out_par_f)
		ok <- !is.na(v) & !is.na(v_in)
		expect_equal(v[ok], 3 * v_in[ok])
		unlink(ftif_par)


		# in-memory dispatch: when sources(x) are all empty, tile_apply
		# ships per-tile raster slices to workers instead of wrapping the
		# whole raster. Result must still match a sequential run cell-for-
		# cell, both with and without buffered tiles.
		mem_r <- rast(nrows=80, ncols=120, vals=runif(80*120))
		expect_true(all(sources(mem_r) == ""))

		out_mem_seq <- tile_apply(mem_r, function(x) x + 1, tiles=30,
			wopt=list(datatype="FLT8S"))
		out_mem_par <- tile_apply(mem_r, function(x) x + 1, tiles=30, cores=2,
			wopt=list(datatype="FLT8S"))
		expect_equal(as.vector(values(out_mem_par)),
					 as.vector(values(out_mem_seq)))

		# named extra args still forwarded on the slice path
		out_mem_par_k <- tile_apply(mem_r, function(x, k) x * k,
			tiles=30, cores=2, k=4, wopt=list(datatype="FLT8S"))
		expect_equal(as.vector(values(out_mem_par_k)),
					 as.vector(values(mem_r)) * 4)

		# buffered focal in parallel on an in-memory raster matches the
		# whole-raster focal exactly (FLT8S to avoid roundtrip noise).
		ref_focal_mem <- focal(mem_r, w=3, fun="mean", na.rm=TRUE)
		out_mem_buf <- tile_apply(mem_r,
			function(x) focal(x, w=3, fun="mean", na.rm=TRUE),
			buffer=1, cores=2, wopt=list(datatype="FLT8S"))
		v_ref <- values(ref_focal_mem); v_out <- values(out_mem_buf)
		ok <- !is.na(v_ref) & !is.na(v_out)
		expect_equal(v_out[ok], v_ref[ok])
	}
}

# GNM (GDAL Geographic Network Model) round-trip tests for SpatNetwork.
# Exercises writeNetwork() (write side) and netw(<filename>) (read side).

#v <- terra::gdal() 
#if ((v >= "3.1.0") && (v < "3.13.1") && "GNMFile" %in% terra::gdal(drivers = TRUE)$name) {


if (terra::gdal() >= "3.1.0" && "GNMFile" %in% terra::gdal(drivers = TRUE)$name) {

	# --- a small undirected, weighted test network --------------------
	a <- vect("LINESTRING(0 0, 10 10)", crs = "EPSG:32633")
	b <- vect("LINESTRING(0 10, 10 0)", crs = "EPSG:32633")
	roads <- rbind(a, b)
	roads$name <- c("A", "B")
	net <- netw(roads)

	# Round-trip: write, read, and compare.
	dst <- file.path(tempdir(), paste0("gnm_test_", as.integer(runif(1)*1e9)))
	on.exit(unlink(dst, recursive = TRUE, force = TRUE), add = TRUE)
	expect_silent(ok <- writeNetwork(net, dst))
	expect_true(isTRUE(ok))
	expect_true(dir.exists(dst))

	# GNMFile uses ESRI Shapefile under the hood by default; the system
	# layers (_gnm_meta, _gnm_graph, _gnm_features, _gnm_srs.prj) and
	# the class layers (nodes, edges) should all be present.
	files <- list.files(dst)
	expect_true("_gnm_graph.dbf" %in% files)
	expect_true("_gnm_meta.dbf"  %in% files)
	expect_true("_gnm_srs.prj"   %in% files)
	expect_true("nodes.shp"      %in% files)
	expect_true("edges.shp"      %in% files)

	# `netw(<filename>)` is the (only) read entry point.
	net2 <- netw(dst)
	expect_inherits(net2, "SpatNetwork")
	expect_equal(net_nnodes(net2), net_nnodes(net))
	expect_equal(net_nedges(net2), net_nedges(net))
	expect_equal(net_directed(net2), net_directed(net))
	expect_equal(sort(net_weights(net2)), sort(net_weights(net)))

	# CRS preserved (verbatim WKT may not match, but the EPSG-recognised
	# representation should round-trip).
	expect_true(nzchar(crs(net2)))
	expect_equal(crs(net2, describe = TRUE)$code,
	             crs(net,  describe = TRUE)$code)

	# Shortest paths should agree.
	sp1 <- shortestPath(net,  from = 1, to = 4)$distance
	sp2 <- shortestPath(net2, from = 1, to = 4)$distance
	expect_equal(sp1, sp2)

	# --- directed network --------------------------------------------
	ndir <- netw(roads, directed = TRUE)
	dst2 <- file.path(tempdir(), paste0("gnm_dir_", as.integer(runif(1)*1e9)))
	on.exit(unlink(dst2, recursive = TRUE, force = TRUE), add = TRUE)
	expect_silent(writeNetwork(ndir, dst2))
	ndir2 <- netw(dst2)
	expect_true(net_directed(ndir2))

	# --- error paths --------------------------------------------------

	# writing twice without overwrite must error
	expect_error(writeNetwork(net, dst))
	# but with overwrite=TRUE works
	expect_true(isTRUE(writeNetwork(net, dst, overwrite = TRUE)))

	# reading a missing path errors
	expect_error(netw(file.path(tempdir(), "definitely_not_a_gnm")))

	# bogus filetype is rejected
	expect_error(writeNetwork(net, dst, filetype = "Bogus", overwrite = TRUE))
}

## from htmltools for future use with knitr
## method = c(package, genname, class).
#registerMethods <- function(methods) {
#	lapply(methods, function(method) {
#		pkg <- method[[1]]
#		generic <- method[[2]]
#		class <- method[[3]]
#		func <- get(paste(generic, class, sep="."))
#		if (pkg %in% loadedNamespaces()) {
#			registerS3method(generic, class, func, envir = asNamespace(pkg))
#		}
#		setHook(
#			packageEvent(pkg, "onLoad"),
#				function(...) {
#					registerS3method(generic, class, func, envir = asNamespace(pkg))
#				}
#			)
#		}
#	)
#}



.gdinit <- function() {
	path = ""
	proj_path <- system.file("proj", package="terra")
	gdal_path <- system.file("gdal", package="terra")
	
	has_proj <- dir.exists(proj_path) && (file.exists(file.path(proj_path, "proj.db")) || file.exists(file.path(proj_path, "nad.lst")))
	has_gdal <- dir.exists(gdal_path)
	
	if (has_proj) {
		projPaths(proj_path, TRUE)
	}
	
	.gdalinit(path, ifelse(has_gdal, gdal_path, ""))
	
	if (libVersion("gdal") == "3.6.0") {
		message("Using GDAL version 3.6.0 which was retracted because it cannot write large GPKG files")
	}
	if (!proj_ok()) {
		message("There appears to be a problem with the PROJ installation")
	}
}

loadModule("spat", TRUE)

.onLoad <- function(libname, pkgname) {
	.gdinit()
	#registerMethods(list(c(package, genname, class)))
}


.onAttach <- function(libname, pkgname) {
	packageStartupMessage("terra ", utils::packageVersion("terra"))
	.create_options()

	if (length(grep(.geos_version(FALSE, TRUE), .geos_version(TRUE))) != 1) {
		packageStartupMessage("WARNING: different compile-time and run-time versions of GEOS")
		packageStartupMessage("Compiled with:", .geos_version(FALSE, TRUE))
		packageStartupMessage(" Running with:", .geos_version(TRUE, TRUE))
		packageStartupMessage("\nYou should reinstall package 'terra'\n")
	}
#	terraOptions(todisk=TRUE, steps=2)
#	terraOptions(memfrac=0)
}

setMethod("princomp", signature(x="SpatRaster"),
	function(x, cor=FALSE, fix_sign=TRUE, use="pairwise.complete.obs", maxcell=Inf) {

		if (!hasValues(x)) {
			error("princomp", "x has no values")
		}
		if (nlyr(x) < 2) {
			error("princomp", "The number of layers of x must be > 1")
		}
		xcov <- layerCor(x, fun="cov", use=use, asSample=FALSE, maxcell=maxcell)
		if (any(is.na(xcov[["covariance"]]))) {
			error("princomp", "the covariance matrix has missing values")		
		}

		model <- princomp(covmat=xcov$covariance, cor=cor, fix_sign=fix_sign)
		model$center <- diag(xcov$mean)
		n <- diag(xcov$n)
		if (cor) {
		## scale as population sd
			S <- diag(xcov$covariance)
			model$scale <- sqrt(S)
		}
		model$n.obs <- stats::as.dist(xcov$n)
		model
	}
)



setMethod("prcomp", signature(x="SpatRaster"),
	function(x, retx = TRUE, center = TRUE, scale. = FALSE, tol = NULL, rank. = NULL, maxcell=Inf) {
		d <- na.omit(spatSample(x, maxcell, "regular"))
		p <- prcomp(d, retx=retx, center=center, scale.=scale., tol=tol, rank.=rank.)
		nms <- names(p$center)
		nms <- nms[!(nms %in% names(x))]
		if (length(nms) > 0) {
			warn("prcomp", "names were changed to make them valid. See 'valid.names'")
		}
		p
	}
)

# Author: Robert J. Hijmans
# Date :  August 2009
# Version 0.9
# License GPL v3

parfun <- function(cls, d, fun, model, ...) {
	nr <- nrow(d)
	nc <- length(cls)
	s <- split(d, rep(1:nc, each=ceiling(nr/nc), length.out=nr))
	p <- parallel::clusterApply(cls, s, function(i, ...) fun(model, i, ...), ...)
	if (!is.null(dim(p[[1]]))) {
		do.call(rbind, p)
	} else {
		unlist(p)
	}
}


.runModel <- function(model, fun, d, nl, const, na.rm, index, cores, ...) {
	doPar <- !is.null(cores)
	if (!is.data.frame(d)) {
		d <- data.frame(d)
	}
	nrd <- nrow(d)
	if (!is.null(const)) {
		d <- lapply(1:nrow(const), function(i) {
			cbind(d, const[rep(i, nrow(d)), , drop=FALSE])
		})
		d <- do.call(rbind, d)
	}
	if (na.rm) {
		n <- nrow(d)
		i <- rowSums(is.na(d)) == 0
		d <- d[i,,drop=FALSE]
		if (nrow(d) > 0) {
			if (doPar) {
				r <- parfun(cores, d, fun, model, ...)
			} else {
				r <- fun(model, d, ...)
			}
			if (is.list(r)) {
				r <- as.data.frame(r)
				# data.frame(lapply) instead of sapply to catch a one-row case
				r <- data.frame(lapply(r, as.numeric))
			} else if (is.factor(r)) {
				r <- as.integer(r)
			} 
			r <- as.matrix(r)
			if (!all(i)) {
				m <- matrix(NA, nrow=n, ncol=ncol(r))
				m[i,] <- r
				colnames(m) <- colnames(r)
				r <- m
			}
		} else {
			if (!is.null(index)) {
				r <- matrix(NA, nrow=n, ncol=length(index))
				index <- NULL
			} else {
				r <- matrix(NA, nrow=n, ncol=nl)
			}
		}
	} else {
		if (doPar) {
			r <- parfun(cores, d, fun, model, ...)
		} else {
			r <- fun(model, d, ...)
		}
		if (is.list(r)) {
			r <- as.data.frame(r)
			r <- data.frame(lapply(r, as.numeric))
		} else if (is.factor(r)) {
			r <- as.integer(r)
		} else if (is.data.frame(r)) {
			r <- sapply(r, as.numeric)
		}
		r <- as.matrix(r)
	}
	if (inherits(model, "gstat")) {
		if (ncol(r) > 2) {
			nr <- max(nrow(d), 5)
			xy <- as.matrix(d[1:nr,1:2])
			if (all(xy == r[1:nr, 1:2])) {
				r <- r[,-c(1:2)]   # x, y
			}
		}
	}
	if (!is.null(index)) {
		r <- r[, index, drop=FALSE]
	}
	if (!is.null(const)) {
		r <- do.call(cbind, split(r, rep(1:nrow(const), each=nrd)))
	}

	r
}

#r <- .runModel(model, fun, d, nl, const, na.rm, index, cores=NULL)


.getFactors <- function(model, fun, d, nl, const, na.rm, index, ...) {
	if (!is.data.frame(d)) {
		d <- data.frame(d)
	}
	nrd <- nrow(d)
	if (!is.null(const)) {
		d <- lapply(1:nrow(const), function(i) {
			cbind(d, const[rep(i, nrow(d)), , drop=FALSE])
		})
		d <- do.call(rbind, d)
	}
	
	if (na.rm) {
		n <- nrow(d)
		i <- rowSums(is.na(d)) == 0
		d <- d[i,,drop=FALSE]
	}
	if (nrow(d) > 0) {
		r <- fun(model, d, ...)
	} else {
		return(NULL)
	}

	if (inherits(model, "gstat")) {
		nr <- max(nrow(d), 5)
		xy <- d[1:nr,1:2]
		if (all(xy == r[1:nr, 1:2])) {
			r <- r[,-c(1:2)]   # x, y
		}
	}

	if (is.factor(r)) {
		levs <- levels(r)
		data.frame(value=1:length(levs), class=levs)
	} else if (is.list(r) || is.data.frame(r)) {
		r <- as.data.frame(r)
		out <- lapply(r, levels)
		for (i in 1:length(out)) {
			if (!is.null(out[[i]])) {
				out[[i]] <- data.frame(value=1:length(out[[i]]), label=out[[i]])
			}
		}
		out
	} else {
		NULL
	}
}


find_dims <- function(object, model, nc, fun, const, na.rm, index, ...) {
	nr <- nrow(object)
	nl <- 1
	testrow <- round(0.51*nr)
	rnr <- 1
	if (nc==1) rnr <- min(nr, 20) - testrow + 1
	d <- readValues(object, testrow, rnr, 1, nc, TRUE, TRUE)
	nrd <- nrow(d)
	cn <- NULL
	levs <- NULL

	all_const <- const
	const <- const[1,,drop=FALSE]

	if (!is.null(index)) {
		nl <- length(index)
		r <- .runModel(model, fun, d, nl, const, na.rm, index, cores=NULL, ...)
		rdim <- dim(r)
		if (is.null(rdim)) {
			cn <- ""
		} else {
			cn <- colnames(r)
		}
	} else {
		allna <- FALSE
		if (na.rm) {
			allna <- all(nrow(stats::na.omit(d)) == 0)
			if (allna) {
				testrow <- ceiling(testrow - 0.25*nr)
				d <- readValues(object, testrow, rnr, 1, nc, TRUE, TRUE)
				allna <- all(nrow(stats::na.omit(d)) == 0)
			}
			if (allna) {
				testrow <- floor(testrow + 0.5*nr)
				if ((testrow + rnr) > nr) rnr = nr - testrow + 1
				d <- readValues(object, testrow, rnr, 1, nc, TRUE, TRUE)
				allna <- all(nrow(stats::na.omit(d)) == 0)
			}
			if (allna && (ncell(object) < 1000)) {
				d <- readValues(object, 1, nr, 1, nc, TRUE, TRUE)
				allna <- all(nrow(stats::na.omit(d)) == 0)
				#if (allna) {
				#	error("predict", "all predictor values are NA")
				#}
			}
			if (allna) {
				d <- spatSample(object, min(1000, ncell(object)), "regular", warn=FALSE)
				allna <- all(nrow(stats::na.omit(d)) == 0)
			}
			if (allna) {
				d[] <- stats::runif(prod(dim(d)))
			}
		}
		r <- .runModel(model, fun, d, nl, const, na.rm, index, cores=NULL, ...)
		if (ncell(object) > 1) {
			rdim <- dim(r)
			if (is.null(rdim)) {
				nl <- 1
				cn <- ""
			} else {
				if (isTRUE(any(rdim == 1))) {
					nl <- 1
					cn <- colnames(r)[1]
				} else {
					nl <- ncol(r)
					cn <- colnames(r)
				}
			}
		} else {
			nl <- length(r)
		}
		levs <- .getFactors(model, fun, d, nl, const, na.rm, index, ...)
	}

	out <- rast(object, nlyrs=nl)
	if (!all(sapply(levs, is.null))) levels(out) <- levs
	if (length(cn) == nl) names(out) <- make.names(cn, TRUE)

	if (NROW(all_const) > 1) {
		oldnl <- nl
		nl <- nl * nrow(all_const)
		nms <- names(out)
		newnms <- apply(all_const, 1, function(x) paste0(names(all_const), x, collapse="_"))
		newnms <- apply(cbind(rep(nms, nrow(all_const)), newnms), 1, function(x) paste0(x, collapse="."))
		nlyr(out) <- nl
		names(out) <- newnms
	}
	out
}


setMethod("predict", signature(object="SpatRaster"),
	function(object, model, fun=predict, ..., const=NULL, na.rm=FALSE, index=NULL, cores=1, cpkgs=NULL, filename="", overwrite=FALSE, wopt=list()) {

		debugr <- isTRUE(wopt$debug)
		wopt$debug <- NULL

		nms <- names(object)
		if (length(unique(nms)) != length(nms)) {
			tab <- table(nms)
			error("predict", "duplicate names in SpatRaster: ", tab[tab>1])
		}

		nc <- ncol(object)
		#tomat <- FALSE
		readStart(object)
		on.exit(readStop(object))
		out <- find_dims(object, model, nc, fun, const, na.rm, index, ...)
		nl <- nlyr(out)
		
		doclust <- FALSE
		if (inherits(cores, "cluster")) {
			doclust <- TRUE
		} else if (cores > 1) {
			doclust <- TRUE
			cores <- parallel::makeCluster(cores)
			on.exit(parallel::stopCluster(cores), add=TRUE)
		}
		if (doclust) {
			parallel::clusterExport(cores, c("model", "fun"), environment())
			if (!is.null(cpkgs)) {
				parallel::clusterExport(cores, "cpkgs", environment())
				parallel::clusterCall(cores, function() for (i in 1:length(cpkgs)) {library(cpkgs[i], character.only=TRUE) })
			}
			export_args(cores, ..., caller="predict")
			
		} else {
			cores <- NULL
		}
		b <- writeStart(out, filename, overwrite, wopt=wopt, n=max(nlyr(out), nlyr(object))*4, sources=sources(object))
		for (i in 1:b$n) {
			d <- readValues(object, b$row[i], b$nrows[i], 1, nc, TRUE, TRUE)
			r <- .runModel(model, fun, d, nl, const, na.rm, index, cores=cores, ...)
			if (prod(NROW(r), NCOL(r)) != prod(b$nrows[i], nc, nl)) {
				msg <- "the number of values returned by 'fun' (model predict function) does not match the input."
				if (!na.rm) msg <- paste(msg, "Try na.rm=TRUE?")
				if (debugr) {
					str(b)
					message(paste("step", i, "(Error, debug=TRUE)"))
					message(msg)
					message("returning input/output and blocks")
					return(list(blocks=b, input=d, output=r))
				}
				error("predict", msg)
			}
			writeValues(out, r, b$row[i], b$nrows[i])
		}
		writeStop(out)
#		return(out)
	}
)

.km_regular <- function(x, n, ...) {
	x <- x[[1]]
	crs(x) <- "local" # for the search_radius
	z <- init(x, "xy")
	if (hasValues(x)) {
		z <- mask(z, x)
	}
	km <- k_means(z, n, ...)
	kpols <- as.polygons(km)
	a <- centroids(kpols, inside=FALSE)
	cds <- crds(a)
	cells <- cellFromXY(x, cds)
	i <- is.na(x[cells])
	if (any(i)) {
		j <- which(i)
		opt <- spatOptions()
		zz <- deepcopy(x)
		crs(zz) <- crs(kpols) <- "local" 
		for (k in j) {
			y <- crop(zz, kpols[k], mask=TRUE)
			ye <- as.vector(ext(y))
			sr <- max(diff(ye[1:2]), diff(ye[3:4]))
			e <- y@pntr$extractBuffer(cds[k,1], cds[k,2], sr, opt)
			if (!is.na(e[[1]])) {
				cells[k] <- cellFromXY(x, xyFromCell(y, e[[3]] + 1))
			} else {
				b <- centroids(kpols[k], inside=TRUE)
				bcds <- crds(b)
				cells[k] <- cellFromXY(x, bcds)
			}
		}
	}
	cells
}


regular_exact <- function(r, size) {
	size <- round(size)
	stopifnot(size > 0)
	if (size >= ncell(r)) {
		return(xyFromCell(r, 1:ncell(r)))
	}
	x <- (ymax(r) - ymin(r)) / (xmax(r) - xmin(r))
	if (x < 1) {
		nc <- min(max(1, size * 1/(1 + 1/x)), ncol(r))
		nr <- (size / nc)
	} else {
		nr <- min(max(1, size * 1/(1 + x)), nrow(r))
		nc <- (size / nr)
	}

	addrow <- addcol <- 0
	floor <- TRUE

	if ((nc%%1) >= (nr%%1)) {
		nc <- round(nc)
		if ((nc * ceiling(nr)) <= size) {
			nr <- ceiling(nr)
			floor <- FALSE
		} else {
			nr <- floor(nr)
			if ((nr * nc) > size) {
				nc <- nc-1
			}
		}
		d <- size - nr * nc
		if (d > 0) {
			if (floor) {
				addcol <- d
			} else {
				addrow <- d 
			}
		}
	} else {
		nr <- round(nr)
		if ((nr * ceiling(nc)) <= size) {
			nc <- ceiling(nc)
			floor <- FALSE
		} else {
			nc <- floor(nc)
			if ((nr * nc) > size) {
				nr <- nr-1
			}
		}
		d <- size - nr * nc
		if (d > 0) {
			if (floor) {
				addcol <- d
			} else {
				addrow <- d	
			}
		}
	}

	if (addcol > 0) {
		ncs <- rep(nr, nc+1)
		b <- (nr+addcol)/2
		ncs[1] <- ceiling(b)
		ncs[nc+1] <- floor(b)
		nc=ncs
	} else if (addrow > 0) {
		nrs <- rep(nc, nr+1)
		b <- (nc+addrow)/2
		nrs[1] <- ceiling(b)
		nrs[nr+1] <- floor(b)
		nr=nrs
	}
	nnr <- length(nr)
	nnc <- length(nc)
	
	if ((nnr == 1) && (nnc == 1)) {
		dx <- (xmax(r) - xmin(r)) / nc
		x <- xmin(r) + dx/2 + (0:(nc-1)) * dx 
		dy <- (ymax(r) - ymin(r)) / nr
		y <- ymin(r) + dy/2 + (0:(nr-1)) * dy 
		expand.grid(x=x, y=y)
	} else if (nnc == 1) {	
		dy <- (ymax(r) - ymin(r)) / nnr
		y <- ymin(r) + dy/2 + (0:(nnr-1)) * dy 
		out <- vector("list", nnr)
		for (i in 1:nnr) {
			dx <- (xmax(r) - xmin(r)) / nr[i]
			x <- xmin(r) + dx/2 + (0:(nr[i]-1)) * dx 
			out[[i]] <- expand.grid(x=x, y=y[i])
		}
		do.call(rbind, out)
	} else {
		dx <- (xmax(r) - xmin(r)) / nnc
		x <- xmin(r) + dx/2 + (0:(nnc-1)) * dx 
		out <- vector("list", nnc)
		for (i in 1:nnc) {
			dy <- (ymax(r) - ymin(r)) / nc[i]
			y <- ymin(r) + dy/2 + (0:(nc[i]-1)) * dy 
			out[[i]] <- expand.grid(x=x[i], y=y)
		}
		do.call(rbind, out)
	}
}



sampleWeights <- function(x, size, replace=FALSE, as.df=TRUE, as.points=FALSE, values=TRUE, cells=FALSE, xy=FALSE, ext=NULL) {

	if (nlyr(x) > 1) {
		x <- x[[1]]
		warn("spatSample", "only the first layer of x is used")
	}
	if (!hasValues(x)) {
		error("spatSample", "x has no values")
	}

	if (!is.null(ext)) {
		x <- crop(x, ext)
	}
	x <- classify(x, cbind(-Inf, 0, NA))
	res <- as.data.frame(x, cells=cells, xy=(xy | as.points))
	if (!replace) {
		if (size >= nrow(res)) {
			i <- 1:nrow(res)
		} else {
			i <- sample.int(nrow(res), size, prob=res[,ncol(res)], replace=replace)
		}
	} else {
		i <- sample.int(nrow(res), size, prob=res[,ncol(res)], replace=replace)
	}
	res <- res[i, , drop=FALSE]
	if (!values) res <- res[ , 1:(cells + 2*(xy | as.points)), drop=FALSE]
	if (as.points) {
		res <- vect(res, c("x", "y"), crs=crs(x))
		if (!xy) {
			res$x <- NULL
			res$y <- NULL
		}
	} #else if (as.df) {
		#res <- data.frame(res)
	#}
	res
}


sampleStratMemory <- function(x, size, replace, lonlat, ext=NULL, weights=NULL, warn=TRUE, each) {
	if (!is.null(ext)) {
		xold <- rast(x)
		x <- crop(x, ext)
		cells <- cells(xold, ext)
		if (!is.null(weights)) {
			weights <- crop(weights, ext)
		}
	} else {
		cells <- 1:ncell(x)	
	}
	
	doprob <- TRUE
	prob <- NULL
	if (!is.null(weights)) {
		if (!inherits(weights, "SpatRaster")) {
			error("spatSample", "weights must be a SpatRaster")
		}
		if (!compareGeom(x, weights)) {
			error("spatSample", "geometry of weights does not match the geometry of x")
		}
		v <- na.omit(cbind(cell=cells, values(x), values(weights)))		
	} else if (lonlat) {
		v <- cbind(cell=cells, values(x), abs(cos(pi * values(init(x, "y")) / 360)))
	} else {
		v <- cbind(cell=cells, values(x))
		doprob <- FALSE
	}

	v <- v[!is.na(v[,2]), ]
	uv <- sort(unique(v[,2]))
	nuv <- length(uv)
	if (each) {
		sz <- rep(size, nuv)
	} else {	
		sz <- rep(floor(size / nuv), nuv)
		d <- size - sum(sz)
		i <- sample(nuv, d)
		sz[i] <- sz[i] + 1
	}
	ys <- vector(mode="list", length=nuv)
		
	for (i in seq_len(length(uv))) {
		if (sz[i] == 0) next
		vv <- v[v[,2] == uv[i], ,drop=FALSE]
		if (doprob) prob <- vv[,3]
		if (replace) {
			s <- sample.int(nrow(vv), sz[i], prob=prob, replace=TRUE)
		} else {
			s <- sample.int(nrow(vv), min(sz[i], nrow(vv)), prob=prob, replace=FALSE)
		}
		ys[[i]] <- vv[s,-3]
	}
	ys <- do.call(rbind, ys)

	if (warn) {
		ta <- tapply(ys[,1], ys[,2], length)
		sz <- sz[sz > 0]
		ta <- names(ta)[ta < sz]
		if (length(ta) > 0) {
			warn("spatSample", 'fewer samples than requested are available for group(s): ', paste(ta, collapse=', '))
		}
	}

	ys
}



sampleStratified_old <- function(x, size, replace=FALSE, as.df=TRUE, as.points=FALSE, values=TRUE, cells=TRUE, xy=FALSE, ext=NULL, warn=TRUE, exp=5, weights=NULL, exhaustive=FALSE, lonlat, each) {

	if (nlyr(x) > 1) {
		x <- x[[1]]
		warn("spatSample", "only the first layer of x is used")
	}
	if (!hasValues(x)) {
		error("spatSample", "x has no values")
	}


	if ((blocks(x, n=4)$n == 1) || exhaustive) {
		res <- sampleStratMemory(x, size, replace, lonlat, ext, weights, warn, each=each)
	} else {
		f <- unique(x)[,1]
		exp <- max(1, exp)
		ss <- exp * size * length(f)

		if (is.null(weights)) {
			if ((!lonlat) && (ss > (0.8 * ncell(x)))) {
				if (!is.null(ext)) {
					x <- crop(x, ext)
				}
				sr <- cbind(1:ncell(x), values(x))
				colnames(sr) <- c("cell", names(x))
			} else {
				sr <- spatSample(x, ss, "random", replace=replace, na.rm=TRUE, ext=ext, cells=TRUE, values=TRUE, warn=FALSE)
			}
		} else {
			if (!inherits(weights, "SpatRaster")) {
				error("spatSample", "weights must be a SpatRaster")
			}
			if (!compareGeom(x, weights)) {
				error("spatSample", "geometry of weights does not match the geometry of x")
			}
			sr <- vector("list", length=length(f))
			for (i in 1:length(f)) {
				r <- x == f[i]
				r <- mask(weights, r, maskvalue=TRUE, inverse=TRUE)
				sr[[i]] <- sampleWeights(r, size, replace=replace, values=FALSE, cells=TRUE, ext=ext)
			}
			sr <- unlist(sr)
			sr <- cbind(cell=sr, extract(x, sr))
		}
		uv <- unique(sr[,2])
		nuv <- length(uv)
		if (each) {
			sz <- rep(size, nuv)
		} else {
			sz <- rep(floor(size / nuv), nuv)
			d <- size - sum(sz)
			i <- sample(nuv, d)
			sz[i] <- sz[i] + 1
		}
		ys <- vector(mode="list", length=length(uv))
		for (i in seq_len(length(uv))) {
			y <- sr[sr[, 2] == uv[i], ,drop=FALSE]
			if (nrow(y) > sz[i]) {
				y <- y[sample.int(nrow(y), sz[i]),  ,drop=FALSE]
			}
			ys[[i]] <- y
		}
		res <- do.call(rbind, ys)
		colnames(res) <- c('cell', names(x))

		if (warn) {
			ta <- table(res[,2])
			sz <- sz[sz > 0]
			ta <- names(ta[ta < sz])
			tb <- f[!(f %in% unique(res[,2]))]
			tba <- c(tb, ta)
			if ((length(tba) > 0)) {
				warn("spatSample", "fewer samples than requested for group(s): ", paste(tba, collapse=", "))
			}
		}
	}

	if ((!xy) && (!as.points)) cells <- TRUE
	if (xy) {
		pts <- xyFromCell(x, res[,1])
		res <- cbind(res[,1,drop=FALSE], pts, res[,2,drop=FALSE])
	}
	if (!values) {
		res <- res[,1:(1 + 2*(xy|as.points)), drop=FALSE]
	} else if (is.factor(x)[1] && as.df) {
		# last column is the stratum value from the first layer
		j <- ncol(res)
		res <- data.frame(res)
		res[[j]] <- set_factors(res[, j, drop=FALSE], TRUE, levels(x)[1], TRUE)[[1]]
	}

	if (as.points) {
		if (!xy) {
			pts <- xyFromCell(x, res[,1])
		}
		res <- vect(pts, crs=crs(x), atts=data.frame(res))
	} else if (as.df) {
		res <- data.frame(res)
	}
	if (!cells) {
		res <- res[,-1,drop=FALSE]
	}
	res
}


.seed <- function() {
  sample.int(.Machine$integer.max, 1)
}


.sampleCellsMemory <- function(x, size, replace, lonlat, ext=NULL) {
	if (!is.null(ext)) {
		x <- crop(x, ext)
	}
	if (nlyr(x) > 1) {
		x <- subst(anyNA(x), 1, NA)
	}

	v <- values(x, mat=FALSE)
	nona <- which(!is.na(v))
	rm(v)
	if (length(nona) == 0L) return(integer())
	ssize <- if (replace) size else min(size, length(nona))

	if (lonlat) {
		nc <- ncol(x)
		rows <- ((nona - 1L) %/% nc) + 1L
		w_row <- abs(cos(pi * yFromRow(x, seq_len(nrow(x))) / 180))
		i <- sample.int(length(nona), ssize, prob=w_row[rows], replace=replace)
	} else {
		i <- sample.int(length(nona), ssize, replace=replace)
	}
	nona[i]
}


.sampleCellsRandom <- function(x, size, replace, na.rm=FALSE, ext=NULL, exp=5) {
	r <- rast(x)
	lonlat <- is.lonlat(r, perhaps=TRUE, warn=TRUE)
	if (!is.null(ext)) {
		r <- crop(rast(r), ext)
	}

	if ((!replace) && (size >= ncell(r))) {
		cells <- 1:ncell(r)
	} else {
		if (na.rm) {
			esize <- size * exp
		} else {
			esize <- size
		}
		# Only use the in-memory exact-weighted sampler for large rasters
		# with a small requested sample, as the rejection-sampling branches below are much faster
		if (na.rm && (blocks(x, n=4)$n == 1) && (ncell(x) <= 50 * esize)) {
			cells <- .sampleCellsMemory(x, esize, replace, lonlat, ext)
		} else if (lonlat) {
			m <- ifelse(replace, 1.5, 2)
			n <- m * esize
			y <- yFromRow(r, 1:nrow(r))
			rows <- sample.int(nrow(r), n, replace=TRUE, prob=abs(cos(pi*y/180)))
			cols <- sample.int(ncol(r), n, replace=TRUE)
			cells <- cellFromRowCol(r, rows, cols)
			if (!replace) {
				cells <- unique(cells)
			}
		} else {
			if (!replace) esize <- min(ncell(r), esize)
			cells <- sample.int(ncell(r), esize, replace=replace)
		}
	}
	if (!is.null(ext)) {
		cells <- cellFromXY(x, xyFromCell(r, cells))
	}
	if (na.rm) {
		v <- rowSums(is.na(x[cells])) == 0
		cells <- cells[v]
	}
	if (length(cells) > size) {
		cells <- cells[1:size]
	}
	cells
}

.sampleCellsStratified <- function(x, size, each=TRUE, replace=FALSE, ext=NULL) {
	if (!is.null(ext)) {
		r <- rast(x)
		if (window(x)) {
			ext <- intersect(ext(x), ext)
		}
		window(x) <- ext
	}
	s <- x@pntr$sampleStratifiedCells(size, each, replace, .seed(), spatOptions())
	s[[1]] <- s[[1]] + 1
	if (!is.null(ext)) {
		s[[1]] <- cellFromXY(x, xyFromCell(r, s[[1]]))
	}
	out <- do.call(cbind, s)
	colnames(out) <- c("cell", names(x)[1])
	out
}




.sampleCellsRegular <- function(x, size, ext=NULL, exact=FALSE) {
	r <- rast(x)
	lonlat <- is.lonlat(r, perhaps=TRUE, warn=TRUE)
	if (!is.null(ext)) {
		r <- crop(rast(r), ext)
	}

	if (prod(size) >= ncell(r)) {
		cells <- 1:ncell(r)
	} else {
		if (TRUE) { # skipping lonlat adjustment for now
			if (exact) {
				xy <- regular_exact(r, size)	
			} else {
				xy <- spatSample(ext(r), size, "regular", lonlat, FALSE)
			}
			cells <- cellFromXY(r, xy)		
		} else {
			if (lonlat) {
				#ratio <- ncol(r)/nrow(r)
				e <- ext(r)
				r1 = e$xmax - e$xmin;
				r2 = e$ymax - e$ymin;
				halfy = e$ymin + r2/2;

				# beware that -180 is the same as 180; and that latitude can only go from -90:90 therefore:
				dx = distance(cbind(e$xmin, halfy), cbind(e$xmin + 1, halfy), TRUE, TRUE) * min(180.0, r1);
				dy = distance(cbind(0, e$ymin), cbind(0, e$ymax), TRUE, TRUE);
				ratio = dy/dx;
				n <- sqrt(size)
				#nx <- max(1, (round(n*ratio)))
				#ny <- max(1, (round(n/ratio)))
				nx <- min(max(1, round(n/ratio)), ncol(r))
				ny <- min(max(1, round(n*ratio)), nrow(r))

				xi <- ncol(r) / nx
				yi <- nrow(r) / ny
				rows <- unique(round(seq(.5*yi, nrow(r), yi)))
				w <- cos(pi*yFromRow(r, rows)/180)
				w <- w * length(w)/sum(w)
				xi <- xi / w
				xi <- pmax(1,pmin(xi, ncol(r)))
				z <- list()

				# needs refinement:
				global <- diff(e[1:2]) > 355

				if (global) {
					xi <- round(ncol(r) / round(ncol(r) / xi))
					for (i in 1:length(rows)) {
						if (xi[i] == 1) {
							cols <- 1:ncol(r)
						} else {
							cols <- seq(xi[i]/2, ncol(r)-1, xi[i])
						}
						z[[i]] <- cbind(rows[i], cols)
					}
				} else {
	#				xi <- round(ncol(r) / (round((ncol(r) / xi))+1))
					for (i in 1:length(rows)) {
						cols <- seq(xi[i]/2, ncol(r), xi[i])
						z[[i]] <- cbind(rows[i], cols)
					}
				}
				z <- do.call(rbind, z)
				cells <- cellFromRowCol(r, z[,1], z[,2])
			} else {
				f <- sqrt(size / ncell(r))
				nr <- ceiling(nrow(r) * f)
				nc <- ceiling(ncol(r) * f);
				xstep <- ncol(r) / nc
				ystep <- nrow(r) / nr
				xsamp <- seq(0.5*xstep, ncol(r), xstep)
				ysamp <- seq(0.5*ystep, nrow(r), ystep)
				xy <- expand.grid(ysamp, xsamp)
				cells <- cellFromRowCol(r, xy[,1], xy[,2])
			}
		}
	}
	if (!is.null(ext)) {
		cells <- cellFromXY(x, xyFromCell(r, cells))
	}
	cells
}



set_factors <- function(x, ff, cts, asdf) {
	if (!asdf) return(x)
	
	if (any(ff)) {
		x <- data.frame(x)
		for (i in which(ff)) {
			ct <- cts[[i]]
			m <- match(x[[i]], ct[,1])
			if (!inherits(ct[[2]], "numeric")) {
				x[[i]] <- factor(ct[m,2], levels=unique(ct[[2]]))
			} else {
				x[[i]] <- ct[m,2]
			}
		}
	}
	data.frame(x)
}



.sampleCellsExhaustive <- function(x, size, replace, ext=NULL, weights=NULL, warn=TRUE) {

	if (!is.null(ext)) {
		x <- crop(x, ext)
	}
	rx <- rast(x)
	x <- cells(x)
	if (length(x) < size) {
		if (!replace) {
			warn("spatSample", "fewer samples than requested are available")
			return(x)
		}
		size <- length(x)
	}
	
	if (!is.null(weights)) {
		if (!inherits(weights, "SpatRaster")) {
			error("spatSample", "weights must be a SpatRaster")
		}
		weights <- weights[[1]]
		if (!is.null(ext)) {
			weights <- crop(weights, ext)
		}
		if (!compareGeom(x, weights)) {
			error("spatSample", "geometry of weights does not match the geometry of x")
		}
		weights <- weights[x]
		s <- sample.int(x, size, prob=weights, replace=replace)

	} else if (is.lonlat(rx)) {	
		y <- xyFromCell(rx, x)[,2]
		weights <- abs(cos(pi * y / 180))
		s <- sample(x, size, prob=weights, replace=replace)
	} else {
		s <- sample(x, size, replace=replace)
	}
	s
}

sampleRaster <- function(x, size, method, replace, ext=NULL, warn, overview=FALSE) {
#	hadWin <- hasWin <- FALSE
	if (!is.null(ext)) {
#		hasWin <- TRUE
#		hadWin <- window(x)
#		oldWin <- ext(x)
		w <- intersect(ext(x), ext(ext))
		if (is.null(w)) {
			error("sampleRaster", "x and ext do not intersect")
		}
		x <- deepcopy(x)
		window(x) <- w
	}
	if (method == "regular") {
		if (length(size) > 1) {
			x@pntr <- x@pntr$sampleRowColRaster(size[1], size[2], warn[1])
		} else {
			x@pntr <- x@pntr$sampleRegularRaster(size, overview)
		}
	} else if (method == "random") {
		x@pntr <- x@pntr$sampleRandomRaster(size, replace, .seed())
	} else {
		error("spatSample", "method must be 'regular' or 'random' if as.raster=TRUE")
	}
#	if (hasWin) {
#		window(x) <- NULL
#		if (any(hadWin)) {
#			window(x) <- oldWin
#		}
#	}
	messages(x, "spatSample")
}


add_cxyp <- function(x, cnrs, cells, xy, as.points, values, na.rm) {

	if (na.rm) {
		if (values) {
			vals <- x[cnrs]
			i <- rowSums(is.na(vals)) == 0
			vals <- vals[i, , drop=FALSE]
		} else if (hasValues(x)) {
			tmpvals <- x[cnrs]
			i <- rowSums(is.na(tmpvals)) == 0
		} 
		cnrs <- cnrs[i]
	} else if (values) {
		vals <- x[cnrs]
	}
	out <- NULL
	if (cells) {
		out <- matrix(cnrs, ncol=1)
		colnames(out) <- "cell"
	}
	if (xy) {
		out <- cbind(out, xyFromCell(x, cnrs))
	}
	if (values) {
		if (is.null(out)) {
			out <- vals
		} else {
			out <- cbind(out, vals)		
		}
	}
	if (as.points) {
		if (xy) {
			out <- data.frame(out)
			v <- vect(out, geom=c("x", "y"), crs=crs(x), keepgeom=TRUE)
		} else {
			crds <- xyFromCell(x, cnrs)
			# crds is a matrix, no geom argument
			v <- vect(crds, crs=crs(x))
			values(v) <- out
		}
		return(v)
	}
	out
}



sampleRandom <- function(x, size, replace=FALSE, na.rm=FALSE, as.raster=FALSE, as.df=TRUE, as.points=FALSE, values=TRUE, cells=FALSE, xy=FALSE, ext=NULL, warn=TRUE, weights=NULL, exp=5, exhaustive=FALSE) {

	ff <- is.factor(x)
	lv <- levels(x)
	size <- size[1]

	cvals <- NULL
	if (cells || xy || as.points) {
		if (exhaustive && na.rm) {
			cnrs <- .sampleCellsExhaustive(x, size, replace, ext, weights=NULL, warn=FALSE)
		} else {
			cnrs <- .sampleCellsRandom(x, size, replace, na.rm, ext, exp=exp)
		}
		
		if ((length(cnrs) < size) && warn) {
			warn("spatSample", "fewer cells returned than requested")
		} else if (length(cnrs) > size) {
			cnrs <- cnrs[1:size]
		}

		out <- add_cxyp(x, cnrs, cells, xy, as.points, values, na.rm)
		return(out)
	}
	if (!hasValues(x)) {
		error("spatSample", "SpatRaster has no values")
	}

	if (!is.null(ext)) {
		if (window(x)) {
			x <- crop(x, ext)
		} else {
			window(x) <- ext
		}
	}

	if (exhaustive && na.rm) {
		cnrs <- .sampleCellsExhaustive(x, size, replace, ext=NULL, weights=NULL, warn=FALSE)
		out <- x[cnrs]	
	} else {
		#v <- x@pntr$sampleRandomValues(size, replace, seed)
		
		if (size > 0.75 * ncell(x)) {
			if (na.rm) {
				out <- stats::na.omit(values(x))
				attr(out, "na.action") <- NULL
				if (nrow(out) < size) {
					if (replace) {
						out <- out[sample.int(nrow(out), size, replace=TRUE), ,drop=FALSE]
					} else {
						warn("spatSample", "more non-NA cells requested than available")
					}
				} else {
					out <- out[sample.int(nrow(out), size), ,drop=FALSE]
				}
			} else {
				out <- values(x)
				out <- out[sample.int(nrow(out), size, replace=replace), ,drop=FALSE]
			}
			out <- set_factors(out, ff, lv, as.df)
			return(out)
		} # else {
		if (na.rm) {
			scells <- NULL
			ssize <- size*2
			for (i in 1:10) {
				scells <- c(scells, .sampleCellsRandom(x, ssize, replace, na.rm))
				if ((i>1) && (!replace)) {
					scells <- unique(scells)
				}
				out <- extractCells(x, scells, raw=!as.df)   
				out <- stats::na.omit(out)
				if (nrow(out) >= size) {
					out <- out[1:size, ,drop=FALSE]
					attr(out, "na.action") <- NULL
					rownames(out) <- NULL
					break
				}
			}
		} else {
			scells <- .sampleCellsRandom(x, size, replace, na.rm=FALSE)
			out <- extractCells(x, scells, raw=!as.df)   
		}
		if (NROW(out) < size) {
			if (warn) warn("spatSample", "fewer values returned than requested")
		} else if (is.null(dim(out))) {
			out = out[1:size]
		} else {
			out = out[1:size, ,drop=FALSE]
		}
		#out <- set_factors(out, ff, lv, as.df)
		return(out)
	}
}


sampleStratified2 <- function(x, size, replace=FALSE, as.df=TRUE, as.points=FALSE, values=TRUE, cells=FALSE, xy=FALSE, ext=NULL, warn=TRUE, each=TRUE) {


	ff <- is.factor(x)
	lv <- levels(x)
	size <- size[1]
	vc <- .sampleCellsStratified(x, size, each, replace, ext)
	

	if (each) {
		uc <- unique(vc[,2])
		if ((length(uc) * size) > nrow(vc)) {
			warn("spatSample", paste("not all classes have", size, "cells"))
		}
	} else if (size > nrow(vc)) {
		warn("spatSample", paste("not all classes had sufficient cells"))
	}

	# stratified sampling category labels
	strat_vals <- function() {
		vals <- vc[, 2, drop=FALSE]
		if (isTRUE(ff[1]) && as.df) {
			vals <- set_factors(vals, TRUE, lv[1], TRUE)
		}
		vals
	}

	if (cells || xy || as.points) {
		out <- add_cxyp(x, vc[,1], cells, xy, as.points, values=FALSE, na.rm=FALSE)
		if (values) out <- cbind(out, strat_vals())
		return(out)
	} else if (values) {
		if (isTRUE(ff[1]) && as.df) {
			return(data.frame(cell=vc[,1], strat_vals(), check.names=FALSE))
		}
	} else {
		vc <- vc[,1,drop=FALSE]
	}
	return(vc)
}


sampleRegular <- function(x, size, replace=FALSE, na.rm=FALSE, as.raster=FALSE, as.df=TRUE, as.points=FALSE, values=TRUE, cells=FALSE, xy=FALSE, ext=NULL, exact=FALSE) {

	ff <- is.factor(x)
	lv <- levels(x)

	if (length(size) > 2) {
		error("spatSample", "size argument should have length 1 or 2")
	}

	if (length(size)==2) {
		exact <- FALSE
	}

	if (cells || xy || as.points) {
		if (exact) {
			pxy <- regular_exact(x, size)
			cnrs <- cellFromXY(x, pxy)
		} else if (length(size) == 2) {
			cnrs <- x@pntr$sampleRowCol(size[1], size[2])
		} else {
			cnrs <- .sampleCellsRegular(x, size, ext, exact=exact)
		}
		return(add_cxyp(x, cnrs, cells, xy, as.points, values, na.rm))
	}
	
	if (!hasValues(x)) {
		error("spatSample", "SpatRaster has no values")
	}

	if (!is.null(ext)) x <- crop(x, ext)

	if (exact && (length(size) == 1)) {
		xy <- regular_exact(x, size)
		v <- extract(x, xy, ID=FALSE)
	} else {
		opt <- spatOptions()
		if (length(size) > 1) {
			v <- x@pntr$sampleRowColValues(size[1], size[2], opt)
		} else {
			v <- x@pntr$sampleRegularValues(size, opt)
		}
		x <- messages(x, "spatSample")
			
		if (length(v) > 0) {
			v <- do.call(cbind, v)
			colnames(v) <- names(x)
		}
		v <- set_factors(v, ff, lv, as.df)
	}
	if (na.rm) {
		v <- na.omit(v)
	}
	return(v)
}


sampleRegularKM <- function(x, size, as.df=TRUE, as.points=FALSE, values=TRUE, cells=FALSE, xy=FALSE, ext=NULL, ...) {

	ff <- is.factor(x)
	lv <- levels(x)
	cnrs <- .km_regular(x, size, ...)

	if (cells || xy || as.points) {
		return(add_cxyp(x, cnrs, cells, xy, as.points, values, na.rm=FALSE))
	}
	
	if (!hasValues(x)) {
		error("spatSample", "SpatRaster has no values")
	}

	if (!is.null(ext)) x <- crop(x, ext)
	x[cnrs]
}



setMethod("spatSample", signature(x="SpatRaster"),
	function(x, size, method="random", replace=FALSE, na.rm=FALSE, as.raster=FALSE, as.df=TRUE, as.points=FALSE, as.mask=FALSE, values=hasValues(x), cells=FALSE, xy=FALSE, ext=NULL, warn=TRUE, weights=NULL, exp=5, exhaustive=FALSE, exact=FALSE, each=TRUE,...) {

		if (method == "display") return(sampleRaster(x, size, "regular", FALSE, ext=ext, warn=FALSE, overview=TRUE))
		method <- match.arg(tolower(method), c("random", "regular", "spread", "stratified", "weights"))

		if (as.mask) {
			as.raster <- FALSE
			as.points <- TRUE
			as.df <- FALSE
			values <- TRUE
			xy <- FALSE
			cells <- FALSE
		}

		if (!as.points) {
			if (!(values || cells || xy)) {
				error("spatSample", "at least one of 'values', 'cells', or 'xy' must be TRUE; or 'as.points' must be TRUE")
			}
		}

		exp <- max(c(1, exp), na.rm=TRUE)
		size <- round(size)
		if (isTRUE(any(size < 1)) || isTRUE(any(is.na(size)))) {
			error("spatSample", "sample size must be a positive integer")
		}

		if ((!replace) && (method != "regular")) {
			if (length(size) > 1) {
				error("spatSample", "sample size must be a single number")
			}
			if (warn && (size > ncell(x))) {
				warn("spatSample", "requested sample size is larger than the number of cells")
				size <- ncell(x)
			}
		}

		if (as.raster) return(sampleRaster(x, size, method, replace, ext, warn))

		lonlat <- is.lonlat(x, perhaps=TRUE, warn=FALSE)
		if (lonlat) exact <- FALSE

		if (method == "regular") {
			out <- sampleRegular(x, size, replace=replace, na.rm=na.rm, as.df=as.df, as.points=as.points, values=values, cells=cells, xy=xy, ext=ext, exact=exact)
		} else if (method == "spread") {
			out <- sampleRegularKM(x, size, as.df=as.df, as.points=as.points, values=values, cells=cells, xy=xy, ext=ext, ...)
		} else if (method == "stratified") {
			if (!is.null(weights)) {  # use old method
				out <- sampleStratified_old(x, size, replace=replace, as.df=as.df, as.points=as.points, cells=cells, values=values, xy=xy, ext=ext, warn=warn, exp=exp, weights=weights, exhaustive=exhaustive, lonlat=lonlat, each=each)
			} else {  # new method
				out <- sampleStratified2(x, size, replace=replace, as.df=as.df, as.points=as.points, values=values, cells=cells, xy=xy, ext=ext, warn=warn, each=each)
			}
		} else if (!is.null(weights)) {  # should also implement for random
			error("spatSample", "argument weights is only used when method='stratified'")
		} else if (method == "random") {
			out <- sampleRandom(x, size, replace=replace, na.rm=na.rm, as.df=as.df, as.points=as.points, values=values, cells=cells, xy=xy, ext=ext, warn=warn, exp=exp, exhaustive=exhaustive)
		} else if (method == "weights") {
			out <- try(sampleWeights(x, size, replace=replace, as.df=as.df, values=values, as.points=as.points, cells=cells, xy=xy, ext=ext) )
			if (inherits(out, "try-error")) {
				error("spatSample", "weighted sample failed. Perhaps the data set is too big")
			}
		}
		if (as.mask) {
			out <- rasterize(out, rast(x), names(x))
		}
		out
	}
)


setMethod("spatSample", signature(x="SpatExtent"),
	function(x, size, method="random", lonlat, as.points=FALSE, exact=FALSE) {
		if (missing(lonlat)) {
			error("spatSample", "provide a lonlat argument")
		}
		if (lonlat) {
			stopifnot(x$ymax <= 90 || x$ymin >= -90)
		}
		method <- match.arg(method, c("regular", "random"))
		size <- round(size)
		stopifnot(size > 0)
		if (method=="random") {
			s <- x@pntr$sampleRandom(size, lonlat, .seed())
		} else if (exact) {
			s <- regular_exact(x, size)
			colnames(s) <- c("x", "y")
			if (as.points) {
				s <- vect(s)
			}
			return(s)
		} else {
			s <- x@pntr$sampleRegular(size, lonlat)
		}
		s <- do.call(cbind, s)
		colnames(s) <- c("x", "y")
		if (as.points) {
			s <- vect(s)
		}
		s
	}
)





.grid_sample <- function(xy, n=1, r, chess="") {

	cell <- cellFromXY(r, xy)
    uc <- unique(stats::na.omit(cell))

	chess <- trimws(chess)
	if (chess != "") {
		chess <- match.arg(tolower(chess), c("white", "black"))
		nc <- ncol(r)
		if (nc %% 2 == 1) {
			if (chess=="white") {
				tf <- 1:ceiling(ncell(r)/2) * 2 - 1
			} else {
				tf <- 1:ceiling((ncell(r)-1)/2) * 2
			}
		} else {
			nr <- nrow(r)
			row1 <- 1:(ceiling(nr / 2)) * 2 - 1
			row2 <- row1 + 1
			row2 <- row2[row2 <= nr]

			if (chess=="white") {
				col1 <- 1:(ceiling(nc / 2)) * 2 - 1
				col2 <- col1 + 1
				col2 <- col2[col2 <= nc]
			} else {
				col1 <- 1:(ceiling(nc / 2)) * 2
				col2 <- col1 - 1
				col1 <- col1[col1 <= nc]
			}

			cells1 <- cellFromRowColCombine(r, row1, col1)
			cells2 <- cellFromRowColCombine(r, row2, col2)
			tf <- c(cells1, cells2)
		}
		uc <- uc[uc %in% tf]
	}

    cell <- cellFromXY(r, xy)
    cell <- cbind(1:nrow(xy), cell, stats::runif(nrow(xy)))
	cell <- stats::na.omit(cell)

    cell <- cell[order(cell[,3]), ]
    sel <- list()
    for (i in seq_along(uc)) {
        ss <- subset(cell, cell[,2] == uc[i])
        sel[[i]] <- ss[1:min(n, nrow(ss)), 1]
    }
	unlist(sel)
}


#coordinates <- function(x) {
#	do.call(cbind, x@pntr$coordinates())
#}

get_field_name <- function(x, nms, sender="") {
	x <- x[1]
	if (is.numeric(x)) {
		x <- round(x)
		if (x > 0 && x <= length(nms)) {
			x = nms[x]
		} else {
			error(sender, "invalid index. there are ", length(nms), " columns")
		}
	} else if (is.character(x)) {
		if (!(x %in% nms)) {
			error(sender, "invalid name")
		}
	}
	x
}


setMethod("spatSample", signature(x="SpatVector"),
	function(x, size, method="random", strata=NULL, chess="") {
		method = match.arg(tolower(method), c("regular", "random"))
		size <- round(size)
		stopifnot(size > 0)
		gtype <- geomtype(x)
		if (gtype %in% c("lines", "polygons")) {
			if (!is.null(strata)) {
				if (length(strata) == 1) {
					if (is.character(strata)) {
						stopifnot(strata %in% names(x))
					} else  {
						stopifnot((strata > 0) && (strata < ncol(x)))
					}
					strata <- x[[strata, drop=TRUE]]
				} else if (length(strata) != length(x)) {
					stop("length of strata must be 1 or length(x)")
				}
				s <- stats::na.omit(unique(strata))
				n <- length(size)
				if (n==1) {
					n <- rep_len(n, length(s))
				} else if (length(s) != n) {
					stop("length of strata must be 1 or length(na.omit(unique(strata)))")
				}
				r <- lapply(s, function(s) {
					spatSample(x[strata == s, ], size, method, NULL, "")
				})
				r <- do.call(rbind, r)
				return(r)
			}
			out <- vect()
			if (length(size) == 1) {
				out@pntr <- x@pntr$sample(size, method[1], .seed())
			} else {
				out@pntr <- x@pntr$sampleGeom(size, method[1], .seed())	
			}
			messages(x, "spatSample")
			return(messages(out, "spatSample"))
		} else if (grepl(gtype, "points")) {
			if (!is.null(strata)) {
				if (inherits(strata, "SpatRaster")) {
					xy <- crds(x)
					i <- .grid_sample(xy, size[1], rast(strata), chess)
					if (is.null(i)) {
						warn("spatSample", "empty sample")
						i <- 0
					}
					return(x[i,])
				} else {
					error("spatSample", "not yet implemented for these strata")
				}
			} else {
				error("spatSample", "use `sample` to sample (point) geometries")
			}
		}
	}
)

setMethod("agitate", signature(x="SpatVector"),
	function(x, maxdist) {
		stopifnot(geomtype(x) == "points")
		stopifnot(maxdist >= 0)
		if (maxdist == 0) return(x)
		xy <- crds(x)
		y <- vect(xy, crs=crs(x))
		b <- terra::buffer(y, width=maxdist)	
		if (any(is.na(xy))) {
			b$id <- 1:nrow(b)
			s <- terra::spatSample(b, rep(1, nrow(b)))
			d <- as.data.frame(s, geom="xy")
			i <- match(b$id, d$id)
			out <- d[i, c("x", "y")]
		} else {
			s <- terra::crds(terra::spatSample(b, rep(1, nrow(b))))
			out <- data.frame(s)
		}
		out <- vect(out, crs=crs(x))
		values(out) <- values(x)
		out
	}
)


setMethod("agitate", signature(x="ANY"),
	function(x, ...) {
		jitter(x, ...)
	}
)

# comment

setMethod("animate", signature(x="SpatRaster"),
function(x, pause=0.25, main, range=NULL, maxcell=50000, n=1, ...) {
	
	if (missing(main)) {
		main <- names(x)
	}
#	x <- spatSample(x, size=maxcell, method="regular", as.raster=TRUE, warn=FALSE)
	x <- sampleRaster(x, maxcell, method="regular", replace=FALSE, ext=NULL, warn=FALSE, overview=TRUE)

    if (is.null(range)) {
		range <- range(minmax(x, compute=TRUE))
    } else if (any(is.na(range))) {
		range <- NULL
    }

	n <- max(1, round(n))
    for (reps in 1:n) {
		for (i in 1:nlyr(x)) {
			plot(x[[i]], main = main[i], range=range, maxcell=Inf, ...)
			grDevices::dev.flush()
			grDevices::dev.hold()
			Sys.sleep(pause)
		}
	}
	g <- grDevices::dev.flush()
}
)

setMethod("animate", signature(x="SpatVector"),
function(x, pause=0.25, main, n=1, vars=NULL, range=NULL, add=NULL, ...) {

	n <- max(1, round(n))
		
	if (!is.null(vars)) {

		if (is.numeric(vars)) {
			vars <- names(x)[vars]
		} else {
			stopifnot(vars %in% names(x))
		}

		if (missing(main)) {
			main <- vars
		} else {
			main <- rep_len(main, length(vars))
		}

		if (is.null(range)) {
			v <- values(x[,vars])
			d <- sapply(v, is.numeric)
			if (all(d)) {
				range <- range(v)
			} 
		} else if (any(is.na(range))) {
			range <- NULL
		}

		for (reps in 1:n) {
			for (i in 1:length(vars)) {
				plot(x, vars[i], main=main[i], ...)
				grDevices::dev.flush()
				grDevices::dev.hold()
				Sys.sleep(pause)
			}
		}
		
	} else {

		if (missing(main)) {
			main <- ""
		}

		if (isTRUE(add)) n <- 1	
		for (reps in 1:n) {
			if ((reps == 1) && (isTRUE(add)) && (is.null(grDevices::dev.list()))) {
				plot(ext(x), border=NA, ...)
			}
			for (i in 1:nrow(x)) {
				addd <- if (is.null(add)) i != 1 else add 
				plot(x[i, ], ext=ext(x), add=addd, ...)
				grDevices::dev.flush()
				grDevices::dev.hold()
				Sys.sleep(pause)
			}
		}
	}
	g <- grDevices::dev.flush()
}
)

setMethod("animate", signature(x="SpatVectorCollection"),
          function(x, pause=0.25, n=1, vars=NULL, range=NULL, ext=NULL, add=NULL, ...) {

            n <- max(1, round(n))
            if (is.null(ext)) ext <- ext(x)

            if (isTRUE(add)) n <- 1
            for (reps in 1:n) {
              if ((reps == 1) && (isTRUE(add)) && (is.null(grDevices::dev.list()))) {
                plot(ext, border=NA, ...)
              }
              for (i in 1:length(x)) {
                addd <- if (is.null(add)) i != 1 else add
                plot(x[[i]], ext=ext, add=addd, ...)
                grDevices::dev.flush()
                grDevices::dev.hold()
                Sys.sleep(pause)
              }
            }
            g <- grDevices::dev.flush()
          }
)

zebra <- function(cex=1, x=NULL, y=NULL, width=NULL, col=c("black", "white")) {

	clip <- get.clip()
	axs <- unlist(clip)[1:4]
	if (is.null(width)) {
		width <- rep(min(axs[2]-axs[1], axs[4]-axs[3]) / 100, 2) * cex
		if (clip$geo) {
			asp <- 1/cos((mean(axs[3:4]) * pi)/180)
			width[2] <- width[2] / asp
		} 
	} else {
		width <- rep(width, length.out=2)
	}
	
	if (is.null(x)) {
		x <- g.grid.at(1L, NULL, axp=graphics::par("xaxp"), usr2=graphics::par("usr")[1:2])
		#x = graphics::.grid.at(1L, NULL, log=FALSE, equilogs=TRUE, axp=par("xaxp"), usr2=par("usr")[1:2])
	} 
	if (is.null(y)) {
		y <- g.grid.at(2L, NULL, axp=graphics::par("yaxp"), usr2=graphics::par("usr")[1:2])
		#y = graphics:::.grid.at(2L, NULL, log=FALSE, equilogs=TRUE, axp=par("yaxp"), usr2=par("usr")[1:2])
	}
	
	x <- sort(unique(c(axs[1:2], x)))
	x <- x[x >= axs[1] & x <= axs[2]]
	y <- sort(unique(c(axs[3:4], y)))
	y <- y[y >= axs[3] & y <= axs[4]]
	
	v1 <- vect(lapply(1:(length(y)-1), function(i) {
			as.polygons(ext(axs[1], axs[1]+width[1], y[i], y[i+1]))
		}))
	v1$col <- rep(col, length.out=nrow(v1))
	v2 <- shift(v1, axs[2]-axs[1]-width[1], 0)
	
	h1 <- vect(lapply(1:(length(x)-1), function(i) {
			as.polygons(ext(x[i], x[i+1], axs[3], axs[3]+width[2]))
		}))
		
	h1$col <- rep(col, length.out=nrow(h1))
	h2 <- shift(h1, 0, axs[4]-axs[3]-width[2])
	
	z <- rbind(v1, v2, h1, h2)
	polys(z, col=z$col, border=NA, xpd=TRUE)
	e <- c(axs[1] + width[1], axs[2] - width[1], axs[3] + width[2], axs[4] - width[2])
	lines(ext(e), xpd=TRUE)
	lines(ext(axs), xpd=TRUE)
	try(set.clip(e, clip$geo))
}


retro_labels <- function(x, lat=TRUE) {
	if ((is.null(x)) || (!is.numeric(x))) {
		return(x)
	}

	# Determine the hemisphere from the sign of the input, do not use floor directly
	if (lat) {
		h <- c("S", "", "N")[sign(x) + 2]
		a <- abs(x)
	} else {
		# Wrap longitude to (-180, 180]; display 180 (not -180).
		w <- ((x + 180) %% 360) - 180
		w[w == -180] <- 180
		h <- c("W", "", "E")[sign(w) + 2]
		h[abs(w) == 180] <- ""
		a <- abs(w)
	}

	if ((length(x) > 1) && (min(diff(x)) <= 1/120)) {
		d <- floor(a)
		m <- floor(60 * (a - d))
		s <- round(3600 * (a - d - m/60))
	} else {
		d <- floor(a)
		m <- round(60 * (a - d))
		s <- 0
	}

	i <- (s == 0) & (m == 0)
	j <- (s == 0) & (m != 0)

	m <- formatC(m, width=2, flag="0")
	s <- formatC(s, width=2, flag="0")
	r <- paste0(d, "\u00B0" , m, "'", s, '"', h)
	r[i] <- paste0(d[i], "\u00B0" , h[i])
	r[j] <- paste0(d[j], "\u00B0" , m[j], "'", h[j])
	r
}


.plot.axes <- function(x) {

	if (x$clip) {
		usr <- x$lim
	} else {
		usr <- graphics::par("usr")
	}

	if (x$xlab != "") {
		posx <- usr[1] + diff(usr[1:2])/2
		text(posx, usr[3], x$xlab, pos=1, offset=x$axs$line.lab, cex=x$axs$cex.lab, xpd=TRUE)
	}
	if (x$ylab != "") {
		posy <- usr[3] + diff(usr[3:4])/2
		text(usr[1], posy, x$ylab, pos=2, offset=x$axs$line.lab, srt=90, cex=x$axs$cex.lab, xpd=TRUE)
	}
	

	if (!x$axes) {
		return(x)
	}

	if (is.null(x$axs$cex.axis)) {
		x$axs$cex.axis = 1
	}
	x$axs$cex.axis <- x$axs$cex.axis * 0.7
	
	if (is.null(x$axs$mgp)) {
		x$axs$mgp = c(2, .25, .3)
	}
	if (is.null(x$axs$tcl)) {
		x$axs$tcl <- -0.25
	}
	if ((!x$clip) & x$draw_grid) {
		x$axs$tck <- 1
		x$axs$mgp <- c(2, .15, .2)
	}

	xlab <- ylab <- NULL
	if (!is.null(x$axs$labels)) {
		xlab <- ylab <- x$axs$labels
		x$axs$labels <- NULL
	}
	if (!is.null(x$axs$xlabs)) {
		xlab <- x$axs$xlabs
		x$axs$xlabs <- NULL
	}
	if (!is.null(x$axs$ylabs)) {
		ylab <- x$axs$ylabs
		x$axs$ylabs <- NULL
	}
	
	xat <- yat <- NULL
	# na.omit(x$axs$at) breaks eva3dm
	if (!is.null(x$axs$at)) {
		xat <- yat <- (x$axs$at)
	}
	if (!is.null(x$axs$xat)) {
		xat <- (x$axs$xat)
		x$axs$xat <- NULL
	}
	if (!is.null(x$axs$yat)) {
		yat <- (x$axs$yat)
		x$axs$yat <- NULL
	}

	sides <- unique(x$axs$side)
	if (!is.null(sides)) sides <- round(sides)
	sides <- sides[sides > 0 & sides < 5]
	if (is.null(sides)) {
		x$axs$side <- sides <- 1:2
	}

	ticks <- x$axs$tick 
	if (is.null(ticks)) {
		x$axs$tick <- ticks <- sides
	}
	labs <- x$axs$lab
	if (is.null(labs)) {
		x$axs$lab <- labs <- sides
	}

	
	y <- x$axs
	retro <- isTRUE(y$retro) 
	if (retro && (!x$lonlat)) {
		warn("plot", "'retro' labels can only be used with lon/lat data")
		retro <- FALSE
	}
	y$retro <- y$lab <- y$tick <- NULL
	y$line <- NA
	y$outer <- FALSE
	y$line.lab <- NULL
	if (is.null(y$col)) y$col <- "gray"
	if (x$clip) {
		lnpts <- crds(as.points(ext(x$lim)))
		lnpts <- rbind(lnpts[4,], lnpts)
	} else {
		lnpts <- crds(as.points(ext(usr)))
		lnpts <- rbind(lnpts[4,], lnpts)
	}
	for (s in 1:4) {
		y$side <- s
		y$mgp <- x$axs$mgp
		y$labels <- NULL
		if (s %in% c(1,3)) {
			ur <- usr[2] - usr[1]
			edg <- c(usr[1]-10*ur, usr[2]+10*ur)
			if (is.null(xat)) {
				axt <- graphics::axTicks(s)
				y$at <- axt[axt >= usr[1] & axt <= usr[2]]
			} else {
				i <- (!is.na(xat)) & (xat >= usr[1]) & (xat <= usr[2])
				y$at <- xat[i]
				xlab <- xlab[i]
			}
			if (is.null(xlab)) {
				y$labels <- if (retro) retro_labels(y$at, lat=FALSE) else y$at
			} else {
				y$labels <- xlab
			}
			y$pos <- ifelse(s==1, usr[3], usr[4])

			if (x$clip && x$draw_grid && s == 1) {
				clp <- get.clip()
				if (!is.null(clp)) {
					for (i in seq_along(y$at)) {
						lines(rbind(c(y$at[i], clp[3]), c(y$at[i], clp[4])), col=y$col, lty=y$lty, lwd=y$lwd)
					}
				}
			}
		} else {
			ur <- usr[4] - usr[3]
			edg <- c(usr[3]-10*ur, usr[4]+10*ur)
			if (is.null(yat)) {
				axt <- graphics::axTicks(s)
				y$at <- axt[axt >= usr[3] & axt <= usr[4]]
			} else {
				i <- (!is.na(yat)) & (yat >= usr[3]) & (yat <= usr[4])
				y$at <- yat[i]
				ylab <- ylab[i]
			}
			if (is.null(ylab)) {
				y$labels <- if (retro) retro_labels(y$at, lat=TRUE) else y$at
			} else {
				y$labels <- ylab
			}
			y$pos <- ifelse(s==2, usr[1], usr[2])

			if (x$clip && x$draw_grid && s == 2) {
				clp <- get.clip()
				if (!is.null(clp)) {
					for (i in seq_along(y$at)) {
						lines(rbind(c(clp[1], y$at[i]), c(clp[2], y$at[i])), lty=y$lty, col=y$col, lwd=y$lwd)
					}
				}
			}
			y$mgp[2] <- y$mgp[3]
		}
		z <- y
		z$lwd <- 0

		if (s %in% labs) {			
			z$lwd.ticks <- 0
			do.call(graphics::axis, z)
		}
		z$labels <- FALSE
		if (s %in% ticks) {
			z$lwd <- 0
			z$lwd.ticks <- y$lwd.ticks
			if (is.null(z$lwd.ticks)) z$lwd.ticks <- 1
			do.call(graphics::axis, z)
		}
		if (s %in% sides) {
			lin <- lnpts[s:(s+1), ]
			if (is.null(y$lty)) {
				lty <- 1
			} else {
				lty <- y$lty
			}
			lines(lin, lwd=y$lwd, lty=lty, col=y$col)
		
			#d <- diff(edg) * 10
			#z$at <- edg + c(-d, d)
			#z$lwd.ticks <- 0
			#z$lwd <- y$lwd
			#do.call(graphics::axis, z)
		} 
	}
	
	x$axs$xat <- xat 
	x$axs$yat <- yat
	x
}

# Author: Robert J. Hijmans
# Date : December 2017
# Version 1.0
# License GPL v3


# Split a per-block focal-values matrix `v` (cells along rows, msz along cols)
# into `k` contiguous row-chunks. Each chunk is dispatched to a single worker;
# this keeps the user's `fun` and the (potentially large) chunk together and
# avoids per-cell parLapply overhead.
.focal_split_chunks <- function(v, k) {
	n <- nrow(v)
	if (is.null(n) || n < 2L || k <= 1L) return(list(v))
	k <- min(k, n)
	starts <- floor(seq.int(1, n + 1, length.out = k + 1L))
	lapply(seq_len(k), function(i) v[starts[i]:(starts[i+1L] - 1L), , drop = FALSE])
}

# Per-chunk worker: apply user fun over rows of `chunk`. Bundling extra args via
# `.dots` (instead of `...`) so the function serialises cleanly.
.focal_chunk_apply <- function(chunk, .ufun, .dots) {
	if (length(.dots)) {
		do.call(apply, c(list(chunk, 1L, .ufun), .dots))
	} else {
		apply(chunk, 1L, .ufun)
	}
}

# Combine a list of per-chunk apply() results into the same shape that
# `apply(v, 1, fun, ...)` would return on the full block. `transp` matches
# the meaning used in the focal() R-fun path.
.focal_combine <- function(parts, transp) {
	if (length(parts) == 1L) return(parts[[1L]])
	first <- parts[[1L]]
	if (is.matrix(first)) {
		# fun returns vector / matrix per cell -> apply gives matrix with cells along columns
		do.call(cbind, parts)
	} else {
		# fun returns scalar per cell -> each chunk is a vector
		unlist(parts, use.names = FALSE)
	}
}


setMethod("focal", signature(x="SpatRaster"),
function(x, w=3, fun="sum", ..., na.policy="all", fillvalue=NA, expand=FALSE, silent=TRUE, cores=1, cpkgs=NULL, filename="", overwrite=FALSE, wopt=list())  {

	dots <- list(...)
	if (is.null(dots$new)) {
		new <- TRUE
	} else {
		new <- isTRUE(dots$new)
	}

	#if (!is.null(dots$na.only)) {
	#	warn("focal", "use 'na.policy' instead of 'na.only'")
	#	na.policy <- "only"
	#}
	na.policy <- match.arg(tolower(na.policy), c("all", "only", "omit"))
	na.only <- na.policy == "only"
	na.omit <- na.policy == "omit"

	if (!is.numeric(w)) {
		error("focal", "w should be numeric vector or matrix")
	}
	txtfun <- .makeTextFun(fun)

	if (is.matrix(w)) {
		m <- as.vector(t(w))
		#if (!all(m %in% c(0, 1, NA))) {
			#if (isTRUE(list(...)$na.rm)) {
			#	if (txtfun != "sum") {
					# error("focal", 'with "na.rm=TRUE" and weights other than 0, 1, or NA, only fun="sum" is allowed')
			#	}
			#}
		#}
		w <- dim(w)
	} else {
		w <- rep_len(w, 2)
		stopifnot(all(w > 0))
		m <- rep(1, prod(w))
	}
	cpp <- FALSE

	if (is.character(txtfun)) {
		if (is.null(wopt$names)) {
			wopt$names <- paste0("focal_", txtfun)
		}
		opt <- spatOptions(filename, overwrite, wopt=wopt)
		if (na.only) {
			narm <- TRUE
		} else {
			narm <- isTRUE(dots$na.rm)
		}
		if (new) {
			x@pntr <- x@pntr$focal2(w, m, fillvalue, narm, na.only, na.omit, txtfun, expand, opt)
		} else {
			x@pntr <- x@pntr$focal(w, m, fillvalue, narm, na.only, na.omit, txtfun, expand, opt)
		}
		messages(x, "focal")
		return(x)

	} else {
		if (expand) {
			warn("focal", "expand is ignored for functions that are not 'built-in'")
		}
		checkNA <- na.only || na.omit

		msz <- prod(w)
		dow <- !isTRUE(all(m == 1))
		if (any(is.na(m))) {
			k <- !is.na(m)
			mm <- m[k]
			msz <- sum(k)
		}

		v <- focalValues(x, w, trunc(nrow(x)/2), 1)[ncol(x)/2, ,drop=FALSE]
		if (dow) {
			if (any(is.na(m))) {
				v <- v[,k,drop=FALSE] * mm
			} else {
				v <- v * m
			}
		}
		test <- try(apply(v, 1, fun, ...), silent=silent)
		if (inherits(test, "try-error")) {
			error("focal", "test failed")
		}

		# Resolve the `cores` argument. For the R-fun path we parallelise the
		# per-block apply() across local processes (PSOCK or future). The
		# C++/built-in path is already TBB-parallel and ignores `cores`.
		# `.is_future_plan` / `.tile_apply_dispatch` come from tile_apply.R.
		if (.is_future_plan(cores)) {
			if (!requireNamespace("future", quietly=TRUE) ||
				!requireNamespace("future.apply", quietly=TRUE)) {
				error("focal", "a future plan was passed but 'future' and 'future.apply' are not installed")
			}
			oplan <- future::plan(cores)
			on.exit(future::plan(oplan), add=TRUE)
			cores <- "future"
		}
		disp <- .tile_apply_dispatch(cores)
		ncores <- disp$ncores
		par_kind <- disp$kind
		cl <- disp$cl
		owns_cl <- disp$owns_cl

		if (par_kind == "cluster" && is.null(cl)) {
			if (!requireNamespace("parallel", quietly=TRUE)) {
				error("focal", "'parallel' package is required for cores>1")
			}
			cl <- parallel::makeCluster(ncores)
			owns_cl <- TRUE
			# load any extra packages on workers (the user fun may need them).
			# `terra` itself is not needed -- workers only see numeric matrices.
			if (length(cpkgs)) {
				ok <- parallel::clusterCall(cl, function(pkgs) {
					for (p in pkgs) suppressPackageStartupMessages(
						library(p, character.only = TRUE))
					TRUE
				}, as.character(cpkgs))
			}
		}
		if (owns_cl) {
			on.exit({
				try(parallel::stopCluster(cl), silent=TRUE)
			}, add=TRUE)
		}

		readStart(x)
		on.exit(readStop(x), add=TRUE)
		nl <- nlyr(x)
		outnl <- nl * length(test)
		out <- rast(x, nlyr=outnl)

		transp <- FALSE
		nms <- NULL
		if (isTRUE(nrow(test) > 1)) {
			transp <- TRUE
			nms <- rownames(test)
			if (nl > 1) {
				nms <- paste0(rep(names(x), each=nl), "_", rep(nms, nl))
			}
		} else if (isTRUE(ncol(test) > 1)) {
			nms <- colnames(test)
			if (nl > 1) {
				nms <- paste0(rep(names(x), each=nl), "_", rep(nms, nl))
			}
		} else {
			nms <- names(x)
			if (nl > 1) {
				nms <- paste0(rep(names(x), each=nl), "_", rep(1:length(test), nl))
			}
		}
		if (length(nms) == nlyr(out)) {
			names(out) <- nms
		}
		b <- writeStart(out, filename, overwrite, n=msz+2, sources=sources(x), wopt=wopt)
		opt <- spatOptions()

		# Threshold below which falling back to single-process apply() is faster
		# than splitting & shipping chunks to workers.
		min_rows_for_par <- max(256L, 64L * ncores)

		for (i in 1:b$n) {
			vv <- NULL
			for (j in 1:nl) {
				if (nl > 1) {
					v <- x[[j]]@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt)
				} else {
					v <- x@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt)
				}
				if (dow) {
					if (any(is.na(m))) {
						v <- v[k] * mm
					} else {
						v <- v * m
					}
				}
				v <- matrix(v, ncol=msz, byrow=TRUE)

				if (par_kind != "seq" && nrow(v) >= min_rows_for_par) {
					chunks <- .focal_split_chunks(v, ncores)
					if (par_kind == "cluster") {
						parts <- parallel::parLapplyLB(cl, chunks,
							.focal_chunk_apply, .ufun=fun, .dots=dots)
					} else {  # future
						parts <- future.apply::future_lapply(chunks,
							.focal_chunk_apply, .ufun=fun, .dots=dots, future.seed=TRUE)
					}
					v <- .focal_combine(parts, transp)
				} else {
					v <- apply(v, 1, fun, ...)
				}
				if (transp) {
					v <- t(v)
				}

				if (checkNA) {
					if (nl > 1) {
						mv <- readValues(x[[j]], b$row[i], b$nrows[i])
					} else {
						mv <- readValues(x, b$row[i], b$nrows[i])
					}
					
					if (na.only) {
						k <- !is.na(mv)
					} else {
						k <- is.na(mv)
					}
					v[k] <- mv[k]
				}
				if (nl > 1) {
					if (outnl > 1) {
						vv <- cbind(vv, v)
					} else {
						vv <- c(vv, v)
					}
				}
			}
			if (nl > 1) {
				writeValues(out, vv, b$row[i], b$nrows[i])
			} else {
				writeValues(out, v, b$row[i], b$nrows[i])
			}
		}
		out <- writeStop(out)
		return(out)
	}
}
)

setMethod("focal3D", signature(x="SpatRaster"),
function(x, w=3, fun=mean, ..., na.policy="all", fillvalue=NA, pad=FALSE, padvalue=fillvalue, expand=FALSE, silent=TRUE, filename="", overwrite=FALSE, wopt=list()) {


	na.policy <- match.arg(tolower(na.policy), c("all", "only", "omit"))
	na.only <- na.policy == "only"
	na.omit <- na.policy == "omit"
	checkNA <- na.only || na.omit

	if (!(inherits(w, "numeric") || inherits(w, "array"))) {
		error("focal3D", "w should be numeric vector or array")
	}

	if (is.array(w)) {
		if (length(dim(w)) != 3) {
			error("focal3D", "the weights array must have three dimensions")
		}
		m <- as.vector(w)
		w <- dim(w)
	} else {
		w <- rep_len(w, 3)
		stopifnot(all(w > 0))
		m <- rep(1, prod(w))
	}

	if (w[3] > nlyr(x)) {
		error("focal3D", "the third weights dimension is larger than nlyr(x)")
	}
	if (any((w[1:2] %% 2) == 0)) {
		error("focal3D", "w must be odd sized in the first two dimensions")
	}

	msz <- prod(w)
	dow <- !isTRUE(all(m == 1))
	rna <- FALSE
	if (any(is.na(m))) {
		rna <- TRUE
		kna <- !is.na(m)
		m <- m[kna]
		msz <- sum(kna)
	}

	opt <- spatOptions()
	halfway <- floor(w[3]/2)
	v <- lapply(1:w[3], function(i) focalValues(x[[i]], w[1:2], trunc(nrow(x)/2), 1)[ncol(x)/2, ,drop=FALSE])
	v <- t(do.call(cbind, v))
	if (dow) {
		if (rna) {
			v <- v[kna,,drop=FALSE] * m
		} else {
			v <- v * m
		}
	}
	vout <- try(apply(v, 2, fun, ...), silent=silent)
	if (inherits(vout, "try-error")) {
		error("focal", "test failed")
	}

	readStart(x)
	on.exit(readStop(x))
	nl <- nlyr(x)
	transp <- FALSE
	nms <- NULL
	if (isTRUE(nrow(vout) > 1)) {
		transp <- TRUE
		nms <- rownames(vout)
	} else if (isTRUE(ncol(vout) > 1)) {
		nms <- colnames(vout)
	}

	if (pad || expand) {
		startlyr = 1;
		endlyr = nl;
		outnl <- nl * length(vout)
	} else {
		startlyr = halfway+1;
		endlyr = nl-halfway;
		outnl <- (1+endlyr-startlyr) * length(vout)
	}

	out <- rast(x, nlyr=outnl)
	if (!is.null(nms)) {
		if (length(nms) <= outnl) {
			names(out) <- rep_len(nms, outnl) 
		}
	}
	b <- writeStart(out, filename, overwrite, n=msz+2, sources=sources(x), wopt=wopt)

	nread <- prod(w[1:2])

	for (i in 1:b$n) {
		nc <- b$nrows[i]*ncol(x)
		vv <- NULL
		if (expand) {
			v <- list(matrix(x[[1]]@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt), ncol=nc))
			v <- do.call(rbind, rep(v, halfway+1))
			for (k in 2:(1+halfway)) {
				v <- rbind(v,  matrix(x[[k]]@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt), ncol=nc))
			}
		} else if (pad) {
			v <- matrix(padvalue, ncol=b$nrows[i]*ncol(x), nrow=nread*halfway)
			for (k in 1:(1+halfway)) {
				v <- rbind(v,  matrix(x[[k]]@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt), ncol=nc))
			}
		} else {
			v <- lapply(1:w[3],
				function(k) {
					y <- x[[k]]
					z <- y@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt)
					y <- messages(y, "focal3D")
					matrix(z, ncol=nc)
				})
				
			v <- do.call(rbind, v)
		}
		for (j in startlyr:endlyr) {
			if (j > startlyr) {
				v <- v[-c(1:nread), ]
				k <- j + halfway
				if (k > nl) {
					if (pad) {
						v <- rbind(v, matrix(padvalue, nrow=nread, ncol=ncol(v)))
					} else {
						v <- rbind(v, v[(nrow(v)-nread):nrow(v), ])
					}
				} else {
					v <- rbind(v, matrix(x[[k]]@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt), ncol=ncol(v)))
				}
			}
			if (dow) {
				if (rna) {
					vout <- apply(v[kna,] * m, 2, fun, ...)
				} else {
					vout <- apply(v * m, 2, fun, ...)
				}
			} else {
				vout <- apply(v, 2, fun,...)
			}

			if (transp) {
				vout <- t(vout)
			}
			if (checkNA) {
				mv <- readValues(x[[j]], b$row[i], b$nrows[i])
				if (na.only) {
					k <- !is.na(mv)
				} else {
					k <- is.na(mv)
				}
				vout[k] <- mv[k]
			}
			vv <- c(vv, as.vector(vout))
		}
		writeValues(out, vv, b$row[i], b$nrows[i])
	}
	out <- writeStop(out)
	return(out)
}
)



setMethod("focalCpp", signature(x="SpatRaster"),
function(x, w=3, fun, ..., fillvalue=NA, silent=TRUE, filename="", overwrite=FALSE, wopt=list())  {

	if (!(all(c("ni", "nw") %in% names(formals(fun))))) {
		error("focalRaw", 'fun must have an argument "ni"')
	}

	if (!is.numeric(w)) {
		error("focal", "w should be numeric vector or matrix")
	}
	if (is.matrix(w)) {
		m <- as.vector(t(w))
		w <- dim(w)
	} else {
		w <- rep_len(w, 2)
		stopifnot(all(w > 0))
		m <- rep(1, prod(w))
	}

	msz <- prod(w)
	readStart(x)
	on.exit(readStop(x))
	dow <- !isTRUE(all(m == 1))
	if (any(is.na(m))) {
		k <- !is.na(m)
		mm <- m[k]
		msz <- sum(k)
	}

	opt <- spatOptions()
	nl <- nlyr(x)
	v <- x@pntr$focalValues(w, fillvalue, max(0, trunc(nrow(x)/2)), 1, opt)[1:prod(w)]
	if (dow) {
		if (any(is.na(m))) {
			v <- v[k] * mm
		} else {
			v <- v * m
		}
	}
	test <- try(fun(v, ..., ni=1, nw=msz), silent=silent)
	if (inherits(test, "try-error")) {
		error("focalCpp", "test failed")
	}
	outnl <- nl * length(test)
	if (is.null(wopt$names )) {
		wopt$names <- colnames(test)
	}
	out <- rast(x, nlyr=outnl)
	b <- writeStart(out, filename, overwrite, n=msz*2, sources=sources(x), wopt=wopt)

	nc <- ncol(out)
	for (i in 1:b$n) {
		vv <- NULL
		for (j in 1:nl) {
			if (nl > 1) {
				v <- x[[j]]@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt)
			} else {
				v <- x@pntr$focalValues(w, fillvalue, b$row[i]-1, b$nrows[i], opt)
			}
			sst <- messages(x)
			if (dow) {
				if (any(is.na(m))) {
					v <- v[k] * mm
				} else {
					v <- v * m
				}
			}
			v <- fun(v, ..., ni=b$nrows[i]*nc, nw=msz)
			if (nl > 1) {
				if (outnl > 1) {
					vv <- rbind(vv, v)
				} else {
					vv <- c(vv, v)
				}
			}
		}
		if (nl > 1) {
			writeValues(out, vv, b$row[i], b$nrows[i])
		} else {
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	}
	writeStop(out)
}
)


.getRegFun <- function(fun, weighted=FALSE, wopt, nmsx, nl, na.rm=FALSE, intercept=TRUE, ...) {

	ols <- function(x, y, ...) {
		if (any(is.na(x)) || any(is.na(y)) || (NROW(y) < (NCOL(x) + 1))) { 
			return(rep(NA, NCOL(x)+1))
		}
		stats::.lm.fit(cbind(1, x), y)$coefficients
	}

	ols_noi <- function(x, y, ...) {
		if (any(is.na(x)) || any(is.na(y)) || (NROW(y) < (NCOL(x)))) { 
			return(rep(NA, NCOL(x)))
		}
		stats::.lm.fit(as.matrix(x), y)$coefficients
	}

	ols_narm <- function(x, y, ...) {
		v <- stats::na.omit(cbind(y, x))
		if (nrow(v) < (NCOL(x) + 1)) {
			return( cbind(rep(NA, NCOL(x)+1)) )
		}
		stats::.lm.fit(cbind(1, v[,-1]), v[,1])$coefficients
	}
	
	ols_noi_narm <- function(x, y, ...) {
		v <- stats::na.omit(cbind(y, x))
		if (nrow(v) < (NCOL(x))) {
			return( cbind(rep(NA, NCOL(x))) )
		}
		stats::.lm.fit(v[,-1,drop=FALSE], v[,1])$coefficients
	}

	weighted_ols <- function(x, y, weights, ...) {
		if (any(is.na(x)) || any(is.na(y)) || any(is.na(weights)) || (NROW(y) < (NCOL(x) + 1))) { 
			return(rep(NA, NCOL(x)+1))
		}
		stats::lm.wfit(cbind(1, x), y, weights)$coefficients		
	}

	weighted_ols_noi <- function(x, y, weights, ...) {
		if (any(is.na(x)) || any(is.na(y)) || any(is.na(weights)) || (NROW(y) < (NCOL(x) + 1))) { 
			return(rep(NA, NCOL(x)))
		}
		stats::lm.wfit(as.matrix(x), y, weights)$coefficients		
	}

	weighted_ols_narm <- function(x, y, weights, ...) {
		v <- stats::na.omit(cbind(y, weights, x))
		if (nrow(v) < (NCOL(x) + 1)) {
			return(rep(NA, NCOL(x)+1))
		}
		stats::lm.wfit(cbind(1, v[,-c(1:2)]), v[,1], v[,2])$coefficients		
	}	

	weighted_ols_noi_narm <- function(x, y, weights, ...) {
		v <- stats::na.omit(cbind(y, weights, x))
		if (nrow(v) < (NCOL(x))) {
			return(rep(NA, NCOL(x)))
		}
		stats::lm.wfit(v[,-c(1:2), drop=FALSE], v[,1], v[,2])$coefficients		
	}	


	fun <- tolower(fun[1])
	if (fun != "ols") {
		return(list(fun=fun, wopt=wopt))
	}

	intercept <- isTRUE(intercept)
	
	if (intercept) {
		if (weighted) {
			if (na.rm) {
				fun <- weighted_ols_narm
			} else {
				fun <- weighted_ols				
			}
		} else {
			if (na.rm) {
				fun = ols_narm
			} else {
				fun = ols				
			}
		}
		if (is.null(wopt$names )) {
			wopt$names <- c("intercept", nmsx[-1])
		}
	} else {
		if (weighted) {
			if (na.rm) {
				fun <- weighted_ols_noi_narm
			} else {
				fun <- weighted_ols_noi				
			}
		} else {
			if (na.rm) {
				fun = ols_noi_narm
			} else {
				fun = ols_noi				
			}
		}
		if (is.null(wopt$names )) {
			wopt$names <- nmsx[-1]
		}
		nl = nl-1
	}

	list(fun=fun, wopt=wopt, nl=nl, intercept=intercept, na.rm=na.rm)
}

setMethod("focalReg", signature(x="SpatRaster"),
function(x, w=3, fun="ols", ..., fillvalue=NA, filename="", overwrite=FALSE, wopt=list()) {

	nl <- nlyr(x)
	if (nl < 2) error("focalReg", "x must have at least 2 layers")

	if (!is.numeric(w)) {
		error("focalReg", "w should be numeric vector or matrix")
	}

	weighted <- FALSE
	if (is.matrix(w)) {
		m <- as.vector(t(w))
		m[m==0] <- NA
		test <- stats::na.omit(m)
		if (length(test) == 0) {
			error("focalReg", "all values in w are NA and/or zero")
		}
		if (any(test != 1)) {
			weighted <- TRUE
			message("the focal values are used as weights")
		} 
		w <- dim(w)
	} else {
		w <- rep_len(w, 2)
		stopifnot(all(w > 0))
		m <- rep(1, prod(w))
	}

	msz <- prod(w)
	if (msz < 2) {
		error("the effective weight matrix must have positive dimensions, and at least one must be > 1")
	}

	hasnam <- FALSE
	if (any(is.na(m))) {
		hasnam <- TRUE
		k <- !is.na(m)
		msz <- sum(k)
		weights <- m[k]
	} else if (weighted) {
		weights <- m	
	}

	if (is.character(fun)) {
		funopt <- .getRegFun(fun, weighted, wopt, names(x), nlyr(x), ...) 
		fun <- funopt$fun
		wopt <- funopt$wopt
		outnl <- funopt$nl
	} else {
		# need to test
		X <- matrix(sample(msz * (nl-1), replace=TRUE), ncol=nl-1)
		if (weighted) {
			out <- fun(1:msz, X, weights=weights, ...)
		} else {
			out <- fun(1:msz, X, ...)		
		}
		outnl <- length(out)
		if (is.null(wopt$names) && (length(names(out)) == outnl)) {
			wopt$names <- names(out)
		}
	}
	out <- rast(x, nlyr=outnl)
	
	b <- writeStart(out, filename, n=msz+2, sources=sources(x), wopt=wopt)
	ry <- x[[1]]
	rx <- x[[-1]]

	if (nl == 2) {
		for (i in 1:b$n) {
			Y <- focalValues(ry, w, b$row[i], b$nrows[i], fillvalue)
			X <- focalValues(rx, w, b$row[i], b$nrows[i], fillvalue)
			if (hasnam) {
				Y <- Y[,k,drop=FALSE]
				X <- X[,k,drop=FALSE]
			}
			if (weighted) {
				v <- t(sapply(1:nrow(Y), function(i) fun(X[i,], Y[i,], weights, ...)))			
			} else {
				v <- t(sapply(1:nrow(Y), function(i) fun(X[i,], Y[i,], ...)))
			}
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	} else {

		for (i in 1:b$n) {
			Y <- focalValues(ry, w, b$row[i], b$nrows[i], fillvalue)
			if (hasnam) {
				Y <- Y[,k,drop=FALSE]
			}
			X <- list()
			for (j in 1:(nl-1)) {
				X[[j]] <- focalValues(rx[[j]], w, b$row[i], b$nrows[i], fillvalue)
				if (hasnam) {
					X[[j]] <- X[[j]][,k]
				}
			}
			v <- list()
			for (p in 1:nrow(Y)) {
				xlst <- list()
				for (j in 1:(nl-1)) {
					xlst[[j]] <- X[[j]][p,]
				}
				pX <- do.call(cbind, xlst)
				if (weighted) {
					v[[p]] <- fun(pX, Y[p,], weights=weights, ...)
				} else {
					v[[p]] <- fun(pX, Y[p,], ...)
				}
			}
			v <- t(do.call(cbind, v))
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	}

	out <- writeStop(out)
	return(out)
}
)


setMethod("focalPairs", signature(x="SpatRaster"),
function(x, w=3, fun, ..., fillvalue=NA, filename="", overwrite=FALSE, wopt=list()) {

	pearson <- function(x, y, ...) { 
		.pearson(x, y, FALSE)
	}
	pearson_narm <- function(x, y, ...) { 
		.pearson(x, y, TRUE)
	}

	weighted_pearson <- function(x, y, weights, ...) { 
		.weighted_pearson(x, y, weights, FALSE)
	}
	weighted_pearson_narm <- function(x, y, weights, ...) { 
		.weighted_pearson(x, y, weights, TRUE)
	}
	
	nl <- nlyr(x)
	if (nl < 2) error("focalPairs", "x must have at least 2 layers")

	if (!is.numeric(w)) {
		error("focalPairs", "w should be a numeric vector or matrix")
	}
	weighted <- FALSE
	if (is.matrix(w)) {
		m <- as.vector(t(w))
		m[m==0] <- NA
		test <- stats::na.omit(m)
		if (length(test) == 0) {
			error("focalPairs", "all values in w are NA and/or zero")
		}
		if (any(test != 1)) {
			weighted <- TRUE
			message("the focal values are used as weights")
		} 
		w <- dim(w)
	} else {
		w <- rep_len(w, 2)
		stopifnot(all(w > 0))
		m <- rep(1, prod(w))
	}
	msz <- prod(w)

	hasnam <- FALSE
	if (any(is.na(m))) {
		hasnam <- TRUE
		k <- !is.na(m)
		msz <- sum(k)
		weights <- m[k]
	} else if (weighted) {
		weights <- m	
	}

	if (msz < 2) {
		error("focalPairs", "the effective weight matrix must have positive dimensions, and at least one must be > 1")
	}

	if (is.character(fun)) {
		narm <- isTRUE(list(...)$na.rm)
		fun <- tolower(fun[1])
		if (fun == "pearson") {
			if (weighted) {
				if (narm) {
					fun = weighted_pearson_narm
				} else {
					fun = weighted_pearson
				}
			} else {
				if (narm) {
					fun = pearson_narm
				} else {
					fun = pearson
				}
			}
		}
	}
	
	if (weighted) {
		test <- try(do.call(fun, list(1:prod(w), prod(w):1, weights=rep(1, prod(w)), ...)))
		if (inherits(test, "try-error")) {
			error("focalPairs", "'fun' does not work. Does it have a 'weights' argument?")
		}
	} else {
		test <- try(do.call(fun, list(1:prod(w), prod(w):1, ...)))
		if (inherits(test, "try-error")) {
			error("focalPairs", "'fun' does not work. Does it have two arguments (one for each layer)?")
		}
	}
	if (is.null(wopt$names )) {
		wopt$names <- colnames(test)
		wopt$overwrite <- overwrite
	}

	outnl <- (nlyr(x) - 1) * length(test)
	out <- rast(x, nlyr=outnl)

	b <- writeStart(out, filename, n=msz+2, sources=sources(x), wopt=wopt)

	for (i in 1:b$n) {
		v <- list()
		Y <- focalValues(x[[1]], w, b$row[i], b$nrows[i], fillvalue)
		if (hasnam) {
			Y <- Y[,k,drop=FALSE]
		}
		for (j in 2:nlyr(x)) {
			X <- Y
			Y <- focalValues(x[[j]], w, b$row[i], b$nrows[i], fillvalue)
			if (hasnam) {
				Y <- Y[,k,drop=FALSE]
			} 
			if (weighted) {
				v[[j-1]] <- t(sapply(1:nrow(Y), function(i) fun(X[i,], Y[i,], weights=weights, ...)))
			} else {
				v[[j-1]] <- t(sapply(1:nrow(Y), function(i) fun(X[i,], Y[i,], ...)))
			}
		}
		v <- do.call(cbind, v)
		writeValues(out, v, b$row[i], b$nrows[i])
	}
	out <- writeStop(out)
	return(out)
}
)




	# ..ols <- function(x, y, ...) {
		# v <- cbind(y, x)
		# if (any(is.na(v))) return( cbind(rep(NA, NCOL(x)+1)) )
		# X <- cbind(1, v[,-1])
		# XtX <- t(X) %*% X
		# if (det(XtX) == 0) {
			# return(rep(NA, NCOL(y)+1))
		# }
		# invXtX <- solve(XtX) %*% t(X)
		# invXtX %*% v[,1]
	# }

	# ..ols_noi <- function(x, y, ...) {
		# v <- cbind(y, x)
		# if (any(is.na(v))) return( cbind (rep(NA, NCOL(x))) )
		# X <- v[,-1,drop=FALSE]
		# XtX <- t(X) %*% X
		# if (det(XtX) == 0) {
			# return(rep(NA, ncol(y)+1))
		# }
		# invXtX <- solve(XtX) %*% t(X)
		# invXtX %*% v[,1]
	# }

	# ..ols_narm <- function(x, y, ...) {
		# v <- na.omit(cbind(y, x))
		# if (nrow(v) < (NCOL(x) + 1)) {
			# return( cbind(rep(NA, NCOL(x)+1)) )
		# }
		# X <- cbind(1, v[,-1])
		# XtX <- t(X) %*% X
		# if (det(XtX) == 0) {
			# return(NA)
		# }
		# invXtX <- solve(XtX) %*% t(X)
		# invXtX %*% v[,1]
	# }
	
	# ..ols_noi_narm <- function(x, y, ...) {
		# v <- na.omit(cbind(y, x))
		# if (nrow(v) < NCOL(x)) {
			# return( cbind(rep(NA, NCOL(y))) )
		# }
		# X <- v[,-1,drop=FALSE]
		# XtX <- t(X) %*% X
		# if (det(XtX) == 0) {
			# return(NA)
		# }
		# invXtX <- solve(XtX) %*% t(X)
		# invXtX %*% v[,1]
	# }

	# ..weighted_ols <- function(x, y, weights, ...) {
		# if (any(is.na(x)) || any(is.na(y))) { 
			# return(rep(NA, NCOL(x)+1))
		# }
		# stats::coefficients(stats::glm(y~x, weights=weights))
	# }

	# ..weighted_ols_noi <- function(x, y, weights, ...) {
		# if (any(is.na(x)) || any(is.na(y))) { 
			# return(rep(NA, NCOL(x)))
		# }	
		# stats::coefficients(stats::glm(y ~ -1 + ., weights=weights))
	# }

	# ..weighted_ols_narm <- function(x, y, weights, ...) {
		# v <- na.omit(data.frame(y=y, x, weights=weights))
		# if (nrow(v) < (NCOL(x) + 1)) {
			# return(rep(NA, NCOL(x)+1))
		# }
		# weights <- v$weights
		# v$weights <- NULL
		# stats::coefficients(stats::glm(y ~ ., data=v, weights=weights))
	# }	

	# ..weighted_ols_noi_narm <- function(x, y, weights, ...) {
		# v <- na.omit(data.frame(y=y, x, weights=weights))
		# if (nrow(v) < (NCOL(x))) {
			# return(rep(NA, NCOL(x)))
		# }
		# weights <- v$weights
		# v$weights <- NULL
		# stats::coefficients(stats::glm(y ~ -1 + ., data=v, weights=weights))
	# }	

# Author: Robert J. Hijmans
# License GPL v3

getCatIDs <- function(x, table, sender="%in%") {
	if (!is.factor(x)) {
		error(sender, "Can only match character values if x is categorical")
	}
	if (nlyr(x) != 1) {
		error(sender, "cannot match with multiple layers --- this should not happen, please report")
	}
	d <- cats(x)[[1]]
	m <- stats::na.omit(match(table, d[,2]))
	d[m,1]
}


setMethod("match", signature(x="SpatRaster"),
	function(x, table, nomatch=NA, incomparables=NULL) {
		table <- unique(table)
		if (is.character(table)) {
			table <- getCatIDs(x, table, sender="match")
			if (length(table) == 0) {
				return(as.logical(x*0))
			}
		}
		app(x, function(i) match(i, table, nomatch, incomparables))
	}
)


setMethod("%in%", signature(x="SpatRaster"),
	function(x, table) {

		table <- unique(table)
		if (is.character(table)) {
			if (nlyr(x) > 1) {
				return(rast(lapply(x, function(i) i %in% table)))
			}
			table <- getCatIDs(x, table)
			if (length(table) == 0) {
				return(as.logical(x*0))
			}
		}
		opt <- spatOptions("", FALSE, list())
		x@pntr <- x@pntr$is_in(table, opt)
		messages(x, "%in%")
	}
)

#setMethod("%in%", signature(x="SpatRaster", table="ANY"),
#	function(x, table) {
#		out <- rast(x)
#		readStart(x)
#		on.exit(readStop(x))
#		nc <- ncol(out)
#		b <- writeStart(out, filename="", overwrite=FALSE, sources=sources(x), wopt=list())
#		for (i in 1:b$n) {
#			v <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
#			v <- v %in% table
#			writeValues(out, v, b$row[i], b$nrows[i])
#		}
#		writeStop(out)
#	}
#)

# Author: Robert J. Hijmans
# Date : April 2011 / Jan 2021
# Version 1.0
# License GPL v3


.checkngb <- function(ngb, mustBeOdd=FALSE) {
	ngb <- as.integer(round(ngb))
	if (length(ngb) == 1) {
		ngb <- c(ngb, ngb)
	} else if (length(ngb) > 2) {
		error("autocor", "ngb should be a single value or two values")
	}
	if (min(ngb) < 1) { stop("ngb should be larger than 1") }
	if (mustBeOdd) {
		if (any(ngb %% 2 == 0)) {
			error("autocor", "neighborhood size must be an odd number")
		}
	}
	return(ngb)
}


.getFilter <- function(w, warn=TRUE) {
	if (!is.matrix(w)) {
		w <- .checkngb(w)
		w <- matrix(1, nrow=w[1], ncol=(w[2]))
		w[ceiling(dim(w)[1]/2), ceiling(dim(w)[2]/2)] <- 0
	} else {
		if (w[ceiling(dim(w)[1]/2), ceiling(dim(w)[2]/2)] != 0) {
			if (warn) {
				warning('central cell of weights matrix (filter) was set to zero')
			}
			w[ceiling(dim(w)[1]/2), ceiling(dim(w)[2]/2)] <- 0
		}
		stopifnot(all(w >= 0))
	}
	if (min(dim(w) %% 2)==0) {
		stop('dimensions of weights matrix (filter) must be uneven')
	}
	w
}



setMethod("autocor", signature(x="numeric"),
	function(x, w, method="moran") {
		method <- match.arg(tolower(method), c("moran", "geary", "gi", "gi*", "mean", "locmor"))

		if (all(is.na(x))) {
			error("autocor", "all values are NA")
		}
		if (any(is.na(w))) {
			error("autocor", "NA value(s) in the weight matrix")
		}

		d <- dim(w)
		n <- length(x)
		if ((d[1] != d[2]) || (d[1] != n)) {
			error("autocor", "w must be a square matrix with sides the size of x")
		}

		if (method %in% c("moran", "geary", "locmor", "gi")) {
			if (any(as.numeric(diag(w)) != 0)) {
				warn("autocor", paste("it is unexpected that a weight matrix for", method, "has diagonal values that are not zero"))
			}
		} else if (method %in% c("gi*")) {
			if (any(as.numeric(diag(w)) == 0)) {
				warn("autocor", paste("it is unexpected that a weight matrix for", method, "has diagonal values that are zero"))
			}
		}


		if (method == "moran") {
			dx <- x - mean(x, na.rm=TRUE)
			pm <- matrix(rep(dx, each=n) * dx, ncol=n)
			(n / sum(dx^2)) * sum(pm * w) / sum(w)
		} else if (method == "geary") { # geary
			dx <- x - mean(x, na.rm=TRUE)
			pm <- matrix(rep(dx, each=n) - dx, ncol=n)^2
			((n-1)/sum((dx)^2)) * sum(w * pm) / (2 * sum(w))
		} else if (method == "gi") {
			if (any(as.numeric(diag(w)) != 0)) {
				warn("autocor", "it is unexpected that a weight matrix for Gi has diagonal values that are not zero")
			}
			diag(w) <- 0
			sumxminx <- sum(x, na.rm=TRUE) - x
			Gi <- colSums(x * w) / sumxminx
			Ei <- rowSums(w) / (n-1)

			# variance following spdep::localG
			xibar <- sumxminx/(n - 1)
		    si2 <- (sum(x^2) - x^2)/(n - 1) - xibar^2
			VG <- si2 * (((n - 1) * rowSums(w^2) - rowSums(w)^2)/(n - 2))
			VG <- VG/((sumxminx)^2)

			(Gi-Ei)/sqrt(VG)

		} else if (method == "gi*") {

			if (any(as.numeric(diag(w)) == 0)) {
				warn("autocor", "it is unexpected that a weight matrix for Gi* has diagonal values that are zero")
			}
			Gi <- colSums(x * w) / sum(x)
			Ei <- rowSums(w) / n
			# variance following spdep::localG
			si2 <- sum(scale(x, scale = FALSE)^2)/n
			VG <- (si2 * ((n * rowSums(w^2) - rowSums(w)^2)/(n - 1))) / (sum(x)^2)

			(Gi-Ei)/sqrt(VG)

		} else if (method == "locmor") {
			if (any(as.numeric(diag(w)) != 0)) {
				warn("autocor", "it is unexpected that a weight matrix for local Moran has diagonal values that are not zero")
			}
			z <- x - mean(x, na.rm=TRUE)
			mp <- z / ( (sum(z^2, na.rm=TRUE) / length(x)) )
			mp * apply(w, 1, function(i) {
					sum(z * i, na.rm=TRUE)
				} )

		} else if (method == "mean") {
			j <- is.na(x)
			x[j] <- 0
			w[j,j] <- 0
			m <- apply(w, 1, function(i) {
					sum(x * i) / sum(i)}
				)
			m[j] <- NA
			m
		}
 	}
)



setMethod("autocor", signature(x="SpatRaster"),
	function(x, w=matrix(c(1,1,1,1,0,1,1,1,1),3), method="moran", global=TRUE, standardize=FALSE) {

		method <- match.arg(tolower(method), c("moran", "geary"))

		if (nlyr(x) > 1) {
			warn("autocor", "only the first layer of x is used")
			x <- x[[1]]
		}

		if (global) {
			if (method == "moran") {
				z <- x - unlist(global(x, "mean", na.rm=TRUE))
				zz <- ifel(is.na(x), NA, 1)
				W <- focal(zz, w=w, fun="sum", na.rm=TRUE, na.policy="omit")
				wZiZj <- focal(z, w=w, fun="sum", na.rm=TRUE)
				if (standardize) {
					wZiZj <- wZiZj / W
				}
				wZiZj <- wZiZj * z
				wZiZj <- unlist(global(wZiZj, "sum", na.rm=TRUE))
				z2 <- unlist(global(z*z, "sum", na.rm=TRUE))
				if (standardize) {
					m <- wZiZj / z2
				} else {
					n <- ncell(z) - unlist(global(z, "isNA"))
					NS0 <- n / unlist(global(W, "sum", na.rm=TRUE))
					m <- NS0 * wZiZj / z2
				}
				names(m) <- names(x)
				m
			} else { # geary
				w <- .getFilter(w, warn=FALSE)
				i <- trunc(length(w)/2)+1
				n <- ncell(x) - unlist(global(x, "isNA"))
				fun <- function(x,...) sum((x-x[i])^2, ...)
				f <- focal(x, w=dim(w), fun=fun, na.rm=TRUE)
				xx <- ifel(is.na(x), NA, 1)
				W <- focal(xx, w=w, na.rm=TRUE)
				if (standardize) {
					Eij <- unlist(global(f / W, "sum", na.rm=TRUE))
					z <- 2 * n *
						unlist(global((x - unlist(global(x, "mean", na.rm=TRUE)))^2, "sum", na.rm=TRUE))
				} else {
					Eij <- unlist(global(f, "sum", na.rm=TRUE))
					z <- 2 * unlist(global(W, "sum", na.rm=TRUE)) *
						unlist(global((x - unlist(global(x, "mean", na.rm=TRUE)))^2, "sum", na.rm=TRUE))
				}
				g <- (n-1)*Eij/z
				names(g) <- names(x)
				g
			}
		} else { # local
			if (method == "moran") {
				z <- x - unlist(global(x, "mean", na.rm=TRUE))
				zz <- ifel(is.na(x), NA, 1)
				W  <- focal(zz, w=w, na.rm=TRUE)
				lz <- focal(z, w=w, na.rm=TRUE) / W

				##n <- ncell(x) - unlist(global(is.na(x), "sum"))
				s2 <- unlist(global(x, "sd", na.rm=TRUE)^2)
				m <- (z / s2) * lz
				names(m) <- names(x)
				m
			} else {
				w <- .getFilter(w)
				i <- trunc(length(w)/2)+1
				fun <- function(x,...) sum((x-x[i])^2, ...)
				Eij <- focal(x, w=dim(w), fun=fun, na.rm=TRUE)
				s2 <- unlist(global(x, "sd", na.rm=TRUE))^2
				##n <- ncell(x) - unlist(global(is.na(x), "sum"))
				g <- Eij / s2
				names(g) <- names(x)
				g
			}
		}
	}
)

# setMethod("arith", signature(x="SpatRaster"),
## not exported
arith <- function(x, fun, ..., filename="", overwrite=FALSE, wopt=list())  {

	out <- rast(x)
	nc <- ncol(x)
	readStart(x)
	on.exit(readStop(x))

# # test the shape of the output by testing with one row
	v <- readValues(x, round(0.5*nrow(x)), 1, 1, nc, mat=TRUE)
	r <- try(fun(as.vector(v), ...))
	if (inherits(r, "try-error")) {
		error("arith", "'fun' is not valid")
	}
	if (!is.vector(r)) {
		error("arith", "'fun' does not return a vector")
	}
	if (!(is.numeric(r) | is.logical(r))) {
		error("arith", "'fun' does not return a numeric vector")
	}
	if (length(r) != length(v)) {
		error("arith", "'fun' does not return the same number of values as the input")
	}

	b <- writeStart(out, filename, overwrite, sources=sources(x), wopt=wopt)
	for (i in 1:b$n) {
		v <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
		v <- fun(as.vector(v), ...)
		writeValues(out, v, b$row[i], b$nrows[i])
	}
	writeStop(out)
}

# )

setMethod("cartogram", signature(x="SpatVector"),
	function(x, var, type="nc", inside=FALSE, exp=1)  {
		if (geomtype(x) != "polygons") {
			error("cartogram", "x must be polygons")
		}
		type <- tolower(type[1])
		type <- match.arg(type, c("nc", "circles"))
		stopifnot(var %in% names(x))
		v <- as.numeric(as.vector(x[[var, drop=TRUE]]))
		i <- !is.na(v)
		x <- x[i]
		v <- v[i]

		i <- v > 0
		x <- x[i]
		v <- v[i]
		
		if (nrow(x) == 0) return(vect("POLYGON EMPTY"))

		f <- v / max(v)
		if (exp <= 0) exp <- 1
		exp <- sqrt(exp)
		cntrds <- centroids(x, inside=inside)
		if (type == "circles") {
			w <- max(width(buffer(cntrds, width(x))))
			ff <- exp * (sqrt(f / pi) * w/4)
			buffer(cntrds, ff)
		} else {
			cxy <- crds(cntrds)
			s <- sqrt(expanse(x))
			ff <- s[which.max(f)] / s
			ff <- ff * sqrt(f) * exp
			r <- lapply(1:length(v), function(i) {
				rescale(x[i,], ff[i], x0=cxy[i,1], y0=cxy[i,2])
			})
			do.call(rbind, r)
		}
	}
)

# Author: Robert J. Hijmans
# Date : June 2019
# Version 1.0
# License GPL v3

setMethod("merge", signature(x="SpatVector", y="data.frame"),
	function(x, y, ...) {
		v <- values(x)
		v$unique_nique_ique_que_e <- 1:nrow(v)
		m <- merge(v, y, ...)
		m <- m[order(m$unique_nique_ique_que_e), ]
		x <- x[stats::na.omit(m$unique_nique_ique_que_e), ]
		m$unique_nique_ique_que_e <- NULL
		if (nrow(m) > nrow(x)) {
			error("merge", "using 'all.y=TRUE' is not allowed. Should it be?")
		}
		values(x) <- m
		x
	}
)

setMethod("merge", signature(x="SpatVector", y="SpatVector"),
	function(x, y, ...) {
		merge(x, data.frame(y), ...)
	}
)


setMethod("merge", signature(x="SpatRasterCollection", "missing"),
	function(x, first=TRUE, na.rm=TRUE, algo=1, method=NULL, filename="", ...) {
		opt <- spatOptions(filename, ...)
		out <- rast()
		if (is.null(method)) method = ""
		out@pntr <- x@pntr$merge(first[1], na.rm, algo, method, opt)
		if (algo == 3) {
			messages(opt, "merge")
		}
		messages(x, "merge")
		messages(out, "merge")
	}
)

setMethod("merge", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, ..., first=TRUE, na.rm=TRUE, algo=1, method=NULL, filename="", overwrite=FALSE, wopt=list()) {
		rc <- sprc(x, y, ...)
		merge(rc, first=first, na.rm=na.rm, algo=algo, method=method, filename=filename, overwrite=overwrite, wopt=wopt)
	}
)



setMethod("mosaic", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, ..., fun="mean", filename="", overwrite=FALSE, wopt=list()) {
		fun <- .makeTextFun(fun)
		if (!inherits(fun, "character")) {
			error("mosaic", "function 'fun' is not valid")
		}
		opt <- spatOptions(filename, overwrite, wopt=wopt)
		rc <- sprc(x, y, ...)
		x@pntr <- rc@pntr$mosaic(fun, opt)
		messages(x, "mosaic")
	}
)

setMethod("mosaic", signature(x="SpatRasterCollection", "missing"),
	function(x, fun="mean", filename="", ...) {
		opt <- spatOptions(filename, ...)
		out <- rast()
		fun <- .makeTextFun(fun)
		if (!inherits(fun, "character")) {
			error("mosaic", "function 'fun' is not valid")
		}
		out@pntr <- x@pntr$mosaic(fun, opt)
		messages(out, "mosaic")
	}
)

# Author: Robert J. Hijmans
# Date : October 2018
# Version 1.0
# License GPL v3

error <- function(f, emsg="", ...) {
	stop("[", f, "] ", emsg, ..., call.=FALSE)
}

warn <- function(f, wmsg="", ...) {
	warning("[", f, "] ", wmsg, ..., call.=FALSE)
}


messages <- function(x, f="") {
	#g <- gc(verbose=FALSE)
	if (methods::.hasSlot(x, "pntr")) {
		if (x@pntr$has_warning()) {
			warn(f, paste(unique(x@pntr$getWarnings()), collapse="\n"))
		}
		if (x@pntr$has_error()) {
			error(f, x@pntr$getError())
		}
	} else {
		if (x$has_warning()) {
			warn(f, paste(unique(x$getWarnings()), collapse="\n"))
		}
		if (x$has_error()) {
			error(f, x$getError())
		}
	}
	x
}

mem_info <- function(x, n=1, print=TRUE) {
	#print=TRUE
	n <- max(0,n)
	opt <- spatOptions()
	opt$ncopies = n;
	v <- x@pntr$mem_needs(opt)
	gb <- 1024^3 / 8  #
	v[1:2] <- v[1:2] / gb
	memmin <- opt$memmin
	memmax <- opt$memmax
	if (print) {
		cat("\n------------------------")
		cat("\nMemory (GB) ")
		cat("\n------------------------")

		cat(paste("\ncheck threshold :", opt$memmin / gb, "(memmin)"))
		if (memmax > 0) {
			cat(paste("\navailable       :",  round(v[2], 2), "(memmax)"))
		} else {
			cat(paste("\navailable       :",  round(v[2], 2)))
		}
		cat(paste0("\nallowed (", round(100* v[3]) , "%)   : ", round(v[3] * v[2], 2)))

		cat(paste0("\nneeded (n=", n, ")   ", ifelse(n<10, " : ", ": "), round(v[1], 2)))
		cat("\n------------------------")
		cat(paste("\nproc in memory  :", round(v[5]) != 0))
		cat(paste("\nnr chunks       :", ceiling(nrow(x)/v[4])))
		cat("\n------------------------\n")
	}
	names(v) <- c("needed", "available", "memfrac", "chunk_rows", "fits_mem")
	if (print) {
		invisible(v)
	} else {
		v
	}
}


free_RAM <- function() {
	opt <- spatOptions()
	x <- rast()
	v <- x@pntr$mem_needs(opt)
	v[2] / 128
}

make_extract_index <- function(v, vmx, name="i") {

	caller <- paste0("`[`(", name, ")")
	if (inherits(v, "SpatRaster")) {
		error(caller, paste("index", name, "cannot be a SpatRaster"))
	} 
	if (inherits(v, "SpatVector")) {
		error(caller, paste("index", name, "cannot be a SpatVector"))
	}
	if (inherits(v, "SpatExtent")) {
		error(caller, paste("index", name, "cannot be a SpatExtent"))
	}

	if (!is.numeric(v)) {
		if (inherits(v, "data.frame")) {
			if (ncol(v) == 1) {
				v <- v[,1,drop=TRUE]
			} else if ((name == "i") && (ncol(v) == 2)) {
				v <- cellFromRowCol(x, v[,1], v[,2])
			} else {
				error(caller, paste("index", name, "has", ncol(v), "columns"))
			}
		} else if (inherits(v, "matrix")) {
			if (ncol(v) == 1) {
				v <- v[,1]
			} else {
				error(caller, paste("index", name, "is not numeric and has", ncol(v), "columns"))
			}
		}

		if (!is.vector(v)) {
			error(caller, paste("the type of index", name, "is unexpected:", class(v)[1]))
		}
		if (is.factor(v) || is.character(v)) {
			error(caller, paste("the type of index", name, "cannot be a factor or character"))
		}
		if (is.logical(v)) {
			v <- which(v)
		} 
		if (!is.numeric(v)) {
			error(caller, paste("the type of index", name, "is unexpected:", class(v)[1]))
		}
	}
	if (inherits(v, "matrix")) {
		if (ncol(v) == 1) {
			v <- v[,1]
		} else {
			error(caller, paste("index", name, "has unexpected dimensions:", paste(dim(v), collapse=", ")))
		}
	}
	positive_indices(v, vmx, FALSE, caller=caller)
}



.extract_spatraster <- function(x, i, drop) {

	if (!hasValues(i)) {
		error("`[`", "the index SpatRaster must have values")
	}

	if (nlyr(i) > 1) {
		error("`[`", "the index SpatRaster can only have one layer")
	}

	if (!compareGeom(x, i, crs=FALSE, stopOnError=FALSE)) {
		if (!drop) {
			return(crop(x, i))
		}
		i <- cells(x, ext(i))
		return (x[i, drop=drop])
	}
	if (drop) {
		i <- which(values(i)==1)
		values(x)[i, ,drop=FALSE]
	} else {
		if (is.bool(i)) {
			mask(x, i, maskvalues=FALSE)
		} else {
			mask(x, i)
		}
	}
}


.extract_spatextent <- function(x, i, drop) {
	x <- crop(x, i)
	if (drop) {
		values(x)
	} else {
		x
	}
}



.extract_spatvector <- function(x, i, drop) {
	if (drop) {
		extract(x, i, data.frame=TRUE)[ , -1, drop=FALSE]
	} else {
		crop(x, i, mask=TRUE)
	}
}



.extract_row <- function(x, i, drop=TRUE) {
	if (!drop) {
		e <- ext_from_rc(x, min(i), max(i), 1, ncol(x))
		return(crop(x, e))
	}
	i <- cellFromRowColCombine(x, i, 1:ncol(x))
	.extract_cell(x, i, drop=TRUE)
}


.extract_col <- function(x, j, drop=TRUE) {
	if (!drop) {
		e <- ext_from_rc(x, 1, nrow(x), min(j), max(j))
		return(crop(x, e))
	}
	i <- cellFromRowColCombine(x, 1:nrow(x), j)
	.extract_cell(x, i, drop=TRUE)
}

.extract_rowcol <- function(x, i, j, drop=TRUE) {
	if (!drop) {
		e <- ext_from_rc(x, min(i), max(i), min(j), max(j))
		return(crop(x, e))
	}
	i <- cellFromRowColCombine(x, i, j)
	.extract_cell(x, i, drop=TRUE)
}



.extract_cell <- function(x, i, drop=TRUE, raw=FALSE) {
	if (!drop) {
		rc <- rowColFromCell(x, i)
		e <- ext_from_rc(x, min(rc[,1]), max(rc[,1]), min(rc[,2]), max(rc[,2]))
		y <- crop(x, e)
		y[-cellFromXY(y, xyFromCell(x, i))] <- NA
		y
	} else {
		opt <- spatOptions()
		e <- x@pntr$extractCell(i-1, opt)
		x <- messages(x, "extract")
		e <- do.call(cbind, e)
		colnames(e) <- names(x)
		if (raw) {
			return(e)
		}
		.makeDataFrame(x, e)
	}
}


.extract_cell_layer <- function(x, i, lyrs, drop) {
	if (drop) {
		opt <- spatOptions()
		e <- x@pntr$extractCell(i-1, opt)
		messages(x, "extract")
		e <- do.call(cbind, e)
		colnames(e) <- names(x)
		e <- .makeDataFrame(x, e)
		e[cbind(1:length(i), lyrs)]
	} else {
		rc <- rowColFromCell(x, i)
		e <- ext_from_rc(x, min(rc[,1]), max(rc[,1]), min(rc[,2]), max(rc[,2]))
		x <- x[unique(lyrs)]
		crop(x, e)
	}
}



setMethod("[", c("SpatRaster", "ANY", "ANY", "ANY"),
	function(x, i, j, k, drop=TRUE) {

		m <- c(missing(i), missing(j), missing(k))
		if (!m[3]) {
			if (is.logical(k) && length(k) == 1) {
				drop <- k
				m[3] <- TRUE
			}
		}

		s <- rep(FALSE, 3)
		if (!m[1]) s[1] <- is.list(i)
		if (!m[2]) s[2] <- is.list(j)
		if (!m[3]) s[3] <- is.list(k)

		if (any(s)) {
			if (m[1]) i <- NULL 
			if (m[2]) j <- NULL 
			if (m[3]) k <- NULL 
			m <- c(FALSE, TRUE, TRUE)
			i <- rcl(x, row=i, col=j, lyr=k)
		}


		if ((!m[1]) && (inherits(i, "matrix"))) {
			if (ncol(i) == 1) {
				i <- i[,1]
			} else if (ncol(i) == 2) {
				i <- cellFromRowCol(x, i[,1], i[,2])
				m[2:3] <- TRUE
			} else if (ncol(i) == 3) {
				k <- i[,3]
				i <- cellFromRowCol(x, i[,1], i[,2])
				uk <- unique(k)
				if (length(uk) == 1) {
					x <- x[[uk]]
					m[2:3] <- TRUE
				} else {
					return(.extract_cell_layer(x, i, k, drop))
				}
			} else {
				error("`[<-`", paste("index i has", ncol(i), "columns"))
			}
		} 

		if (!m[3]) {
			if (is.logical(k) && length(k) == 1) {
				drop <- k
				m[3] <- TRUE
			} else {
				if (inherits(k, "character")) {
					k <- match(k, names(x))
					if (any(is.na(k))) {
						error("`[`(k)", "invalid layer name(s)")
					}
				} else {
					k <- make_extract_index(k, nlyr(x), "k")
				}
				x <- x[[k]]
			}
		}
		if ((!m[1]) && (inherits(i, "character"))) {
			# partial matching of layer names
			i <- grep(i, names(x))
			x <- subset(x, i, NSE=FALSE)
			if (m[2]) return(x)
			m[1] <- TRUE
		}


		if (m[1] && m[2]) {
			if (drop) {
				return(values(x, mat=TRUE))
			} else {
				return(deepcopy(x))
			}
		} 

		if (!m[1]) { # i not missing
			if (inherits(i, "SpatRaster")) {
				return(.extract_spatraster(x, i, drop))
			} 
			if (inherits(i, "SpatVector")) {
				return(.extract_spatvector(x, i, drop))
			}
			if (inherits(i, "SpatVector")) {
				return(.extract_spatextent(x, i, drop))
			}

			theCall <- sys.call(-1)
			narg <- length(theCall)-length(match.call(call=theCall))
			if ((narg==0) && m[2]) {
				# cell
				i <- make_extract_index(i, ncell(x), "i")
				return(.extract_cell(x, i, drop=drop))
			} else if (m[2]) {
				# row
				i <- make_extract_index(i, nrow(x), "i")
				return(.extract_row(x, i, drop=drop))
			} else {
				#row,col
				i <- make_extract_index(i, nrow(x), "i")
				j <- make_extract_index(j, ncol(x), "j")
				return(.extract_rowcol(x, i, j, drop=drop))
			}
		} else { #if (!m[2]) {
			#col
			j <- make_extract_index(j, ncol(x), "j")
			return(.extract_col(x, j, drop=drop))
		}
	} 
)



setMethod("[", c("SpatVector", "SpatVector", "missing"),
function(x, i, j) {
	#r <- !relate(x, i, "disjoint")
	#r <- which(apply(r, 1, any))
	r <- is.related(x, i, "intersects")
	x[r, ]
})


setMethod("[", c("SpatVector", "SpatExtent", "missing"),
function(x, i, j) {
	x[as.polygons(i)]
})

# Author: Robert J. Hijmans
# Date :  January 2009
# Version 0.9
# License GPL v3



character_crs <- function(x, caller="") {

	if (!inherits(x, "character")) {
		if (is.atomic(x)) {
			# for logical NA 
			x <- as.character(x)
		} else {
			x <- crs(x)
		}
	}

	if (is.na(x)) {
		""
	} else {
		if (tolower(x) == "local") {
			x <- 'LOCAL_CS["Cartesian (Meter)", LOCAL_DATUM["Local Datum",0], UNIT["Meter",1.0], AXIS["X",EAST], AXIS["Y",NORTH]]'
		} else if (tolower(x) == "lonlat") {
			x <- "+proj=longlat"
		}
		x
	}
}



is.proj <- function(crs) {
	substr(crs, 1, 6) == "+proj="
}

.check_proj4_datum <- function(crs) {
	crs <- trimws(tolower(crs))
	if (!is.proj(crs)) return()
	x <- trimws(unlist(strsplit(crs, "\\+")))
	d <- grep("datum=", x, value=TRUE)
	if (length(d) > 0) {
		d <- gsub("datum=", "", d)
		if (!(d %in% c("wgs84", "nad83", "nad27"))) {
			warn("crs<-", "Only the WGS84, NAD83 and NAD27 datums can be used with a PROJ.4 string. Use WKT2, authority:code, or +towgs84= instead")
		}
	}
	#d <- grep("towgs84=", x, value=TRUE)
	#if (length(d) > 0) {
	#	warn("crs<-", "+towgs84 parameters in a PROJ4 string are ignored")
	#}
}


.proj4 <- function(x) {
	x@pntr$get_crs("proj4")
}

.name_from_wkt <- function(wkt) {
	s = strsplit(wkt, ",")[[1]][1]
	strsplit(s, "\"")[[1]][[2]]
}

.name_or_proj4 <- function(x) {
	if (inherits(x, "SpatVectorProxy")) {
		tptr <- x@pntr$v
	} else if (inherits(x, "Rcpp_SpatRaster")) {
		tptr <- x	
	} else {
		tptr <- x@pntr
	}
	wkt <- tptr$get_crs("wkt")
	d <- .srs_describe(wkt)
	r <- tptr$get_crs("proj4")
	if (!(d$name %in% c(NA, "unknown", "unnamed"))) {
		if (substr(r, 1, 13) == "+proj=longlat") {
			r <- paste("lon/lat", d$name)
		} else {
			r <- d$name
		}
		if (!is.na(d$code)) {
			r <- paste0(r, " (", d$authority, ":", d$code, ")")
		}
	}
	if (r == "") {
		rr <- try(.name_from_wkt(wkt), silent=TRUE)
		if (!inherits(rr, "try-error")) {
			r <- rr
		}
	}
	r
}



.srs_describe <- function(srs) {
	info <- .SRSinfo(srs)
	names(info) <- c("name", "authority", "code", "area", "extent")
	d <- data.frame(t(info), stringsAsFactors=FALSE)
	d$area <- gsub("\\.$", "", d$area)
	d[d == ""] <- NA
	if (is.na(d$extent)) {
		d$extent <- list(c(NA, NA, NA, NA))
	} else {
		d$extent <- list(as.numeric(unlist(strsplit(d$extent, ","))))
	}
	d
}



.get_CRS <- function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
	if (describe) {
		d <- .srs_describe(x@pntr$get_crs("wkt"))
		if (proj) {
			d$proj <- x@pntr$get_crs("proj4")
		}
		d
	} else if (proj) {
		x@pntr$get_crs("proj4")
	} else {
		r <- x@pntr$get_crs("wkt")
		if (parse) {
			unlist(strsplit(r, "\n"))
		} else {
			r
		}
	}
}


setMethod("crs", signature("character"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		x <- rast(crs=x)
		.get_CRS(x, proj=proj, describe=describe, parse=parse)
	}
)

setMethod("crs", signature("SpatExtent"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		return("")
	}
)

setMethod("crs", signature("SpatRaster"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		.get_CRS(x, proj=proj, describe=describe, parse=parse)
	}
)

setMethod("crs", signature("SpatRasterDataset"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		if (length(x) > 0) {
			.get_CRS(x[[1]], proj=proj, describe=describe, parse=parse)
		} else {
			NULL
		}
	}
)



.txtCRS <- function(x, warn=TRUE) {
	if (inherits(x, "SpatVector") | inherits(x, "SpatRaster")) {
		x <- crs(x)
	}
	if (isTRUE(is.null(x) || is.na(x))) {
		x <- ""
	} else if (inherits(x, "CRS")) {
		if (warn) warn("crs", "expected a character string, not a CRS object")
		y <- attr(x, "comment")
		if (is.null(y)) {
			y <- x@projargs
			if (is.na(y)) y <- ""
		}
		x <- y
	} else if (is.character(x)) {
		if (length(x) == 0) {
			x <- ""
 		} else {
			x <- x[1]
			lowx <- tolower(x)
			if (lowx == "local") {
				x = 'LOCAL_CS["Cartesian (Meter)", LOCAL_DATUM["Local Datum",0], UNIT["Meter",1.0], AXIS["X",EAST], AXIS["Y",NORTH]]'
			} else if (lowx == "lonlat") {
				x <- "+proj=longlat"
			}
		}
	} else {
		error("crs", "I do not know what to do with this argument (expected a character string)")
	}
	.check_proj4_datum(x)
	x
}

crs_msg <- "Replacing a CRS only makes sense if the original was wrong.\nIf your goal is to transform the data to the new CRS, use `project` instead."

setMethod("crs<-", signature("SpatRaster", "ANY"),
	function(x, warn=FALSE, value) {
		if (missing(value)) {
			value <- warn
			warn <- FALSE
		}
		value <- .txtCRS(value)
		if (warn && (crs(x) != "") && (value != "")) {
			message(crs_msg)
		}
		x@pntr <- x@pntr$deepcopy()
		x@pntr$set_crs(value)
		messages(x, "crs<-")
	}
)

setMethod("set.crs", signature("SpatRaster"),
	function(x, value) {
		value <- .txtCRS(value)
		x@pntr$set_crs(value)
		messages(x, "set_crs")
		invisible(TRUE)
	}
)



#setMethod("crs<-", signature("SpatRaster", "character"),
#	function(x, ..., value) {
#		x@pntr$set_crs(value[1])
#		messages(x, "crs<-")
#	}
#)


setMethod("crs", signature("SpatVector"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		.get_CRS(x, proj=proj, describe=describe, parse=parse)
	}
)

setMethod("crs", signature("SpatVectorProxy"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		v <- vect()
		v@pntr <- x@pntr$v
		.get_CRS(v, proj=proj, describe=describe, parse=parse)
	}
)

setMethod("crs", signature("SpatVectorCollection"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		if (length(x) > 0) {
			.get_CRS(x[[1]], proj=proj, describe=describe, parse=parse)
		} else {
			NULL
		}
	}
)

setMethod("crs", signature("sf"),
  function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
	  xcrs <- attr(x[[ attr(x, "sf_column") ]], "crs")$wkt
	  x <- vect(cbind(0,0), crs=xcrs)
	  .get_CRS(x, proj=proj, describe=describe, parse=parse)
  }
)

setMethod("crs<-", signature("SpatVector", "ANY"),
	function(x, warn=FALSE, value) {
		if (missing(value)) {
			value <- warn
			warn <- FALSE
		}
		value <- .txtCRS(value)
		if (warn && (crs(x) != "") && (value != "")) {
			message(crs_msg)
		}
		x@pntr <- x@pntr$deepcopy()
		x@pntr$set_crs(value)
		messages(x, "crs<-")
	}
)


setMethod("set.crs", signature("SpatVector"),
	function(x, value) {
		value <- .txtCRS(value)
		x@pntr$set_crs(value)
		messages(x, "set_crs")
	}
)


setMethod("is.lonlat", signature("SpatRaster"),
	function(x, perhaps=FALSE, warn=TRUE, global=FALSE) {
		if (perhaps) {
			ok <- x@pntr$isLonLat()
			if (ok) {
				if (warn) {
					messages(x, "is.lonlat")
				} else {
					 w <- x@pntr$getWarnings()
				}
				if (global) {
					return(x@pntr$isGlobalLonLat())
				} else {
					return(ok)
				}
			} 
			ok <- x@pntr$couldBeLonLat()
			if (ok) {
				if (warn) {
					messages(x, "is.lonlat")
				} else {
					x@pntr$getWarnings()
				}
				if (global) {
					ok <- x@pntr$isGlobalLonLat()
				}
			}
			if (ok && warn) {
				warn("is.lonlat", "assuming lon/lat crs")
			}
		} else {
			ok <- x@pntr$isLonLat()
			if (ok) {
				if (warn) {	
					messages(x, "is.lonlat")
				} else {
					x@pntr$getWarnings()
				}
				if (global) {
					ok <- x@pntr$isGlobalLonLat()
				}
			} else if (crs(x) == "") {
				ok <- NA
				warn("is.lonlat", "unknown crs")
			}
		}
		ok
	}
)


setMethod("is.lonlat", signature("SpatVector"),
	function(x, perhaps=FALSE, warn=TRUE) {
		if (perhaps) {
			ok <- x@pntr$isLonLat()
			if (ok) {
				messages(x, "is.lonlat")
				return(ok)
			} 
			ok <- x@pntr$couldBeLonLat()
			if (ok) {
				messages(x, "is.lonlat")
			}
			if (ok && warn) {
				warn("is.lonlat", "assuming lon/lat crs")
			}
		} else {
			ok <- x@pntr$isLonLat()
			if (ok) {
				messages(x, "is.lonlat")
			} else if (crs(x) == "") {
				ok <- NA
				warn("is.lonlat", "unknown crs")
			}
		}
		ok
	}
)

setMethod("is.lonlat", signature("character"),
	function(x, perhaps=FALSE, warn=TRUE) {
		x <- rast(crs=x)
		is.lonlat(x, perhaps=perhaps, warn=warn)
	}
)

same.crs <- function(x, y) {
	if (!is.character(x)) {
		x <- crs(x)
	}
	if (!is.character(y)) {
		y <- crs(y)
	}
	if (inherits(x, "CRS")) {
           if (!is.null(comment(x))) {
			x <- comment(x)
		} else {
			x <- x@projargs
           } 
	}
	if (inherits(y, "CRS")) {
           if (!is.null(comment(y))) {
			y <- comment(y)
		} else {
			y <- y@projargs
           } 
	}
	if (is.na(x)) x <- ""
	if (is.na(y)) x <- ""
	if (!is.character(x)) {
		x <- as.character(x)
	}
	if (!is.character(y)) {
		y <- as.character(y)
	}
	.sameSRS(x, y)
}


proj_pipelines <- function(from, to, authority="", AOI=NULL, use="NONE", grid_availability="USED",
		desired_accuracy=-1.0, strict_containment=FALSE) {

	if (!is.character(from)) {
		from <- crs(from)
	}
	if (!is.character(to)) {
		to <- crs(to)
	}
	if (is.na(from) || from == "") {
		error("proj_pipelines", "from is empty or NA")
	}
	if (is.na(to) || to == "") {
		error("proj_pipelines", "to is empty or NA")
	}
	if (is.null(AOI)) {
		AOI <- numeric(0)
	} else {
		AOI <- try(ext(AOI), silent=TRUE)
		if (inherits(AOI, "try-error")) {
			error("project", "AOI must be or have a SpatExtent")
		}
		AOI <- as.vector(AOI)[c(1,3,2,4)]
	}
	
	out <- .proj_pipelines(from, to, authority, as.numeric(AOI), as.character(use),
		grid_availability, desired_accuracy, isTRUE(strict_containment), FALSE)

	out <- data.frame(out)
	attr(out, "from") <- from
	attr(out, "to") <- to
	
	out
}

r <- rast(nrow = 10, ncol = 10, xmin = 0, ymin = 0, xmax = 10, ymax = 10,  crs = "EPSG:4326")
values(r) <- 1:100
target <- "+proj=laea +lat_0=45 +lon_0=-100 +x_0=0 +y_0=0 +datum=WGS84 +units=m +no_defs"
x <- project(r, target, method = "bilinear", res = 1e5)
tmp <- rast(crs = target, extent = ext(x), resolution = 1e5)
y <- project(r, tmp)
expect_true(all.equal(x, y))

## pipelines 
## basic: returns a data.frame with expected columns
pp <- proj_pipelines("EPSG:4326", "EPSG:32632")

## first pipeline should be instantiable with 0 grids needed
expect_true(pp$instantiable[1])
expect_equal(pp$grid_count[1], 0)
expect_true(nchar(pp$definition[1]) > 0)

## accuracy == 0 for an exact same-datum transformation
#CI OSX fail
#expect_equal(pp$accuracy[1], 0)

## accepts SpatRaster input
r <- rast(ncols=10, nrows=10, crs="EPSG:4326")
pp2 <- proj_pipelines(r, "EPSG:3857")
expect_true(nrow(pp2) >= 1)

## grid_availability="DISCARD" reduces results
pp_all  <- proj_pipelines("EPSG:5070", "EPSG:4326")
pp_disc <- proj_pipelines("EPSG:5070", "EPSG:4326", grid_availability="DISCARD")
expect_true(nrow(pp_disc) <= nrow(pp_all))
expect_true(nrow(pp_disc) >= 1)

## AOI constrains results
pp_aoi <- proj_pipelines("EPSG:5070", "EPSG:4326", AOI=ext(-100, -90, 30, 40))
expect_true(nrow(pp_aoi) >= 1)
expect_true(nrow(pp_aoi) <= nrow(pp_all))

## invalid CRS
expect_error(proj_pipelines("INVALID", "EPSG:4326"))
expect_error(proj_pipelines("EPSG:4326", "INVALID"))


### 

a <- rast(ncols=40, nrows=40, xmin=-120, xmax=-60, ymin=20, ymax=60, crs="EPSG:4326")
values(a) <- 1:ncell(a)
b <- rast(ncols=94, nrows=124, ext=c(-2562000, 3768000, -364000, 4470000), crs="EPSG:5070")
pp <- proj_pipelines("EPSG:4326", "EPSG:5070")

w1 <- project(a, b, pipe=pp[1,])
w2 <- project(a, b, pipe=pp[2,])
w3 <- project(a, crs(b), pipe=pp[2,])
w4 <- project(a, pipe=pp[2,])

#expect_true(all.equal(w1, w2))
#expect_true(all.equal(w3, w4))

r <- rast(ncols=40, nrows=40, xmin=-80, xmax=-56.5, ymin=45, ymax=62, crs="EPSG:4326")
values(r) <- 1:ncell(r)
vr <- as.polygons(r)
p1 <- project(vr, pipe=pp[1,])
p2 <- project(vr, pipe=pp[2,])
p3 <- project(vr, pipe=pp[3,])

p1b <- project(vr, "EPSG:5070", pipe=pp[1,])
p3b <- project(vr, "EPSG:5070", pipe=pp[3,])

# to be merged with the vector variant.
.generic.interval <- function(out, Z) {
	if (is.null(out$breaks)) {
		out$breaks <- 5
	}
	if (length(out$breaks) == 1) {
		out$breaks <- .get_breaks(Z, out$breaks, out$breakby, out$range)
	}

	if (!is.null(out$leg$digits)) {
#		out$leg$legend <- substr(formatC(levs, digits=digits, format = "f", flag="#"), 1, digits+1)
		fz <- cut(as.numeric(Z), out$breaks, include.lowest=TRUE, right=FALSE, dig.lab=out$leg$digits)
	} else {
		fz <- cut(as.numeric(Z), out$breaks, include.lowest=TRUE, right=FALSE)
	}


	out$vcut <- as.integer(fz)
	levs <- levels(fz)
	nlevs <- length(levs)

	cols <- out$cols
	ncols <- length(cols)
	if (nlevs < ncols) {
		i <- trunc((ncols / nlevs) * 1:nlevs)
		cols <- cols[i]
	} else {
		cols <- rep_len(cols, nlevs)
	}
	
	#out$cols <- cols
	out$leg$fill <- cols
	#out$leg$levels <- levels(fz)
	if (!is.null(out$leg$legend)) {
		stopifnot(length(out$leg$legend) == nlevs)
	} else {
		levs <- gsub("]", "", gsub(")", "", gsub("\\[", "", levs)))
		levs <- paste(levs, collapse=",")
		m <- matrix(as.numeric(unlist(strsplit(levs, ","))), ncol=2, byrow=TRUE)
		if (!is.null(out$leg$digits)) {
			m <- prettyNumbs(m, out$leg$digits)
		}
		m <- apply(m, 1, function(i) paste(i, collapse=" - "))
		m <- gsub("-Inf -", "<=", m)
		i <- grep("- Inf", m)
		if (length(i) == 1) {
			m[i] <- gsub("- Inf", "", m[i])
			m[i] <- paste(">", m[i])				
		}	
		out$leg$legend <- m
	}
	out$leg$digits <- NULL
	out
}


.get_nudge <- function(a) {
	if (is.null(a)) {
		a <- rep(0, 4)
	} else if (length(a) == 0) {
		a <- rep(0, 4)
	} else if (length(a) == 1) {
		a <- c(a, a, 0, 0)
	} else if (length(a) == 2) {
		a <- c(a[1], a[1], a[2], a[2])		
	} else if (length(a) == 3) {
		a <- c(a[1], a[2], a[3], a[3])		
	} 
	a
}

.nudge_ext <- function(x, e) {
	a <- .get_nudge(x$leg[["nudge"]]) 
	e <- x$leg[["ext"]]
	e$xmin <- e$xmin + a[1]
	e$xmax <- e$xmax + a[2]
	e$ymin <- e$ymin + a[3]
	e$ymax <- e$ymax + a[4]
	e$dy <- e$dy + a[4]-a[3]
	e$dx <- e$dx + a[2]-a[1]
	x$leg$ext <- e
	x
}

.nudge_xy <- function(xy, a) {
	a <- .get_nudge(a) 
	xy[1] <- xy[1] + a[1]
	xy[2] <- xy[2] + a[3]
	xy
}



prettyNumbs <- function(x, digits) {
	x <- formatC(x, digits=digits, format = "f", flag="#")
	x <- substr(x, 1, digits+1)
	gsub("\\.$", "", x)
}


add_more <- function(fun, i) {
	if (!is.null(fun) && is.function(fun)) {
		if (!is.null(formals(fun))) {
			fun(i)
		} else {
			fun()
		}
	}
}


hexcols <- function(out) {

	get_col <- function(cols, alpha) {
		if (isTRUE(alpha < 255)) {
			grDevices::rgb(t(grDevices::col2rgb(cols, alpha=TRUE)), alpha=alpha, maxColorValue=255)
		} else {
			i <- !grepl("^#", cols)
			cols[i] <- grDevices::rgb(t(grDevices::col2rgb(cols[i], alpha=FALSE)), maxColorValue=255)	
			cols
		}
	}

	if (NCOL(out$cols) == 1) {
		out$cols <- get_col(out$cols, out$alpha)
	} else if (NCOL(out$cols) == 2) {
		out$cols[,2] <- get_col(out$cols[,2], out$alpha)
	} else if (NCOL(out$cols) == 3) {
		out$cols[,3] <- get_col(out$cols[,3], out$alpha)
	}
	
	out

}


.default.pal <- function() {
	opt.pal <- options("terra.pal")[[1]]
	if (is.null(opt.pal))  {
		map.pal("viridis", 100)
	} else {
		opt.pal
	}
}

.get_nrnc <- function(nr, nc, nl) {
	if (missing(nc)) {
		nc <- ceiling(sqrt(nl))
	} else {
		nc <- max(1, min(nl, round(nc)))
	}
	if (missing(nr)) {
		nr <- ceiling(nl / nc)
	} else {
		nr <- max(1, min(nl, round(nr)))
		nc <- ceiling(nl / nr)
	}
	c(nr, nc)
}



.get_breaks <- function(x, n, method, r=NULL) {
	#x <- x[!is.na(x)]
	
	if (is.function(method)) {
		if (!is.null(r)) {
			if (!is.na(r[1])) { 
				x[ x < r[1] ] <- NA
			} 
			if (!is.na(r[2])) { 
				x[ x > r[2] ] <- NA
			} 
		}
		breaks <- method(x)
	} else if (method[1]=="cases") {
		if (!is.null(r)) {
			if (!is.na(r[1])) { 
				x[ x < r[1] ] <- NA
			} 
			if (!is.na(r[2])) { 
				x[ x > r[2] ] <- NA
			} 
		}
		n <- n+1
		i <- seq(0, 1, length.out=n)
		breaks <- quantile(x, i, na.rm=TRUE)
		breaks <- unique(breaks)
		n <- min(n, length(breaks))               # adapt when not enough unique values
		if ((breaks[1] %% 1) != 0) {
			breaks[1] <- breaks[1] - 0.000001
		}
		if ((breaks[n] %% 1) != 0) {
			breaks[n] <- breaks[n] + 0.000001
		}
	} else { # if (method=="eqint") {
		if (is.null(r)) {
			r <- c(min(x, na.rm=TRUE), max(x, na.rm=TRUE))
		} else if (any(is.na(r))) {
			if (is.na(r[1])) r[1] <- min(x, na.rm=TRUE)
			if (is.na(r[2])) r[2] <- max(x, na.rm=TRUE)
		}
		small <- 1e-16
		if ((r[1] %% 1) != 0) { r[1] <- r[1] - small }
		if ((r[2] %% 1) != 0) { r[2] <- r[2] + small }
		breaks <- seq(r[1] , r[2], length.out=n+1)
	}
	unique(breaks)
}



get_mar <- function(out, is_raster=TRUE) {

	if (is.null(out$mar)) {
		out$mar <- c(2, 2, 2, 2)
		if (out$legend_draw) {
			w <- ifelse(is_raster, 5, 7)
			out$mar <- c(2, 2, 2, w)
			if (is.null(out$leg$ext)) {
				if (is.null(out$leg$x)) {
					out$leg$x <- "default"
				} else if (out$legend_type == "continuous") {
					if (inherits(out$leg[["x"]], "character")) {
						if (out$leg$x == "top") {
							out$mar <- c(2, 2, w-1, 2)
						} else if (out$leg$x == "bottom") {
							out$mar <- c(w, 2, 2, 2)
						} else if (out$leg$x == "left") {
							out$mar <- c(2, w, 2, 1)
						} else {
							out$mar <- c(2, 2, 2, w)
						}
					}
				}	
			} 
		}
	} else {
		out$mar <- rep_len(out$mar, 4)
	}
	
	out
}

# Author: Robert J. Hijmans
# Date :  June 2019
# Version 1.0
# License GPL v3


setMethod("dots", signature(x="SpatVector"),
	function(x, field, size,  ...) {
		reset.clip()

		n <- length(x)
		if (n < 1) return(NULL)
		#method <- match.arg(tolower(method), c("regular", "random"))
		if (is.character(field)) {
			stopifnot(field %in% names(x))
		} else {
			stopifnot(field > 0 && field <= ncol(x))
		}
		stopifnot(is.numeric(x[[field,drop=TRUE]]))
		field <- x[[field,drop=TRUE]]
		size <- size[1]
		stopifnot(size > 0)
		d <- round(field / size)
		d[d < 1 | is.na(d)] <- 0
		i <- d > 0;
		if (sum(i) == 0) {
			error("dots", "'size' is too small")
		}
		s <- spatSample(x[i], d[i], method="random")
		if (.Device  != "null device") {
			try(points(s, ...), silent=TRUE)
		}
		invisible(s)
	}
)



.plotLines <- function(x, out, lty=1, lwd=1, ...) {

	n <- nrow(x)
	if (n == 0) return(out)
#	cols <- out$cols
#	if (is.null(cols)) cols = rep("black", n)

#	g <- lapply(x@pntr$linesList(), function(i) { names(i)=c("x", "y"); i } )

#	g <- geom(x, df=TRUE)
#	g <- split(g, g[,1])
#	g <- lapply(g, function(x) split(x[,3:4], x[,2]))
#	n <- length(g)

	g <- x@pntr$linesList()
	lty <- rep_len(lty, n)
	lwd <- rep_len(lwd, n)
	for (i in 1:n) {
		if (!is.null(g[[i]])) {
			names(g[[i]]) = c("x", "y")
			graphics::plot.xy(g[[i]], type="l", lty=lty[i], col=out$main_cols[i], lwd=lwd[i], ...)
		}
	}

#	for (i in 1:n) {
#		for (j in 1:length(g[[i]])) {
#			lines(g[[i]][[j]], col=out$main_cols[i], lwd=lwd[i], lty=lty[i], ...)
#		}
#	}


	out$leg$lwd <- lwd
	out$leg$lty <- lty
	out
}

.plotPolygons <- function(x, out, lty=1, lwd=1, density=NULL, angle=45, ...) {


	n <- nrow(x)
	if (n == 0) return(out)
	if ((length(out$main_cols) == 0) && (length(out$main_border) <= 1) 
			&& (length(lty) <= 1) && (length(lwd) <= 1) && (is.null(density))) {
		if (is.null(out$leg$border)) out$leg$border <- "black"
		lines(x, col=out$leg$border, lty=lty, lwd=lwd, ...)
		return(out)
	}

#		cols <- .getCols(length(x), col, alpha)
#		out <- list(main_cols=cols)

	if (!is.null(out$leg$border)) {
		out$leg$border <- rep_len(out$leg$border, n)
	} else {
		out$leg$border <- NA
	}
	if (!is.null(density)) {
		out$leg$density <- rep_len(density, n)
		out$leg$angle <- rep_len(angle, n)
	}
	if (!is.null(lty)) out$leg$lty <- rep_len(lty, n)
	if (!is.null(lwd)) out$leg$lwd <- rep_len(lwd, n)

	if (!is.null(out$main_cols)) {
		out$main_cols <- rep_len(out$main_cols, n)
	}
	if (!is.null(out$main_border)) {
		out$main_border <- rep_len(out$main_border, n)
	}

#	g <- geom(x, df=TRUE)
#	g <- split(g, g[,1])
#	g <- lapply(g, function(y) split(y[,3:5], y[,2]))
#	w <- getOption("warn")
#	on.exit(options("warn" = w))
#	for (i in 1:length(g)) {
#		gg <- g[[i]]
#		for (j in 1:length(gg)) {
#			a <- gg[[j]]
#			if (any(is.na(a))) next
#			if (any(a[,3] > 0)) {
#				a <- split(a[,1:2,drop=FALSE], a[,3])
#				a <- lapply(a, function(i) rbind(i, NA))
#				a <- do.call(rbind, a )
#				a <- a[-nrow(a), ]
#				# g[[i]][[1]] <- a
#			}

	g <- x@pntr$polygonsList()
	if (is.null(out$leg$density)) {
		for (i in seq_along(g)) {
			for (j in seq_along(g[[i]])) {
				if (any(is.na(g[[i]][[j]]))) next
				graphics::polypath(g[[i]][[j]][[1]], g[[i]][[j]][[2]], col=out$main_cols[i], rule = "evenodd", border=out$main_border[i], lwd=out$leg$lwd[i], lty=out$leg$lty[i], ...)
			}
		}
	} else {
		for (i in 1:length(g)) {
			for (j in seq_along(g[[i]])) {
				if (any(is.na(g[[i]][[j]]))) next
				graphics::polygon(g[[i]][[j]][[1]], g[[i]][[j]][[2]], col=out$main_cols[i], density=out$leg$density[i], angle=out$leg$angle[i], border=NA, lwd=out$leg$lwd[i], lty=out$leg$lty[i], ...)
				graphics::polypath(g[[i]][[j]][[1]], g[[i]][[j]][[2]], col=NA, rule="evenodd", border=out$main_border[i], lwd=out$leg$lwd[i], lty=out$leg$lty[i], ...)
			}
		}
	}
	invisible(out)
}


.vplot <- function(x, out, xlab="", ylab="", pch=16, lty=1, lwd=1, ...) {

	reset.clip()

	if (out$leg$geomtype == "points") {
		points(x, col=out$main_cols, cex=out$cex, pch=pch, ...)
		if (is.null(out$leg$pch)) out$leg$pch <- pch
		if (is.null(out$leg$pt.cex)) out$leg$pt.cex = out$cex
	} else if (out$leg$geomtype == "polygons") {
		out <- .plotPolygons(x, out, density=out$leg$density, angle=out$leg$angle, lty=lty, lwd=lwd, ...)
	} else {
		# out <- .plotLines(x, out, ...)
		lines(x, col=out$main_cols, lty=lty, lwd=lwd, ...)
		if (is.null(out$leg$lwd)) out$leg$lwd = lwd
		if (is.null(out$leg$lty)) out$leg$lty = lty
	}
	out
}


.apply_alpha <- function(cols, alpha) {
	if (!is.null(alpha)) {
		if (alpha[1] < 1 && alpha[1] >= 0) {
			cols <- grDevices::rgb(t(grDevices::col2rgb(cols)), alpha=alpha[1]*255, maxColorValue=255)
		}
	}
	cols
}

.getCols <- function(n, cols, alpha=NULL) {
	if (is.null(cols)) { 
		return(cols)
	}
	if (inherits(cols, "function")) {
		cols <- cols(n)
	} else {
		ncols <- length(cols)
		if (ncols > n) {
			steps <- ncols/n
			i <- round(seq(1, ncols, steps))
			cols <- cols[i]
		} else if (ncols < n) {
			cols <- rep_len(cols, n)
		}
	}
	.apply_alpha(cols, alpha)
}

.vect.legend.none <- function(out) {
	#if (out$leg$geomtype == "points") {
	#	out$main_cols <- .getCols(out$ngeom, out$cols, 1)
	#} else {
	#	out$cols <- .getCols(out$ngeom, out$cols)
	#}
	out$main_cols <- out$cols
	out$main_border <- out$leg$border
	out
}

.vect.legend.classes <- function(out) {
	
	if (isTRUE(out$leg$sort)) {
		out$uv <- sort(out$uv) # done by legend: decreasing=out$leg$reverse)
	} else {
		out$uv <- out$uv[!is.na(out$uv)]
	}

	if (NCOL(out$cols) == 2) {
		i <- match(out$uv, out$cols[,1])
		out$cols <- .apply_alpha(out$cols[i,2], out$alpha)
	} else if (!is.null(names(out$cols))) {
		i <- match(out$uv, names(out$cols))
		out$cols <- .apply_alpha(out$cols[i], out$alpha)
	} else {
		out$cols <- .getCols(length(out$uv), out$cols, out$alpha)
	}
	
	i <- match(out$v, out$uv)
	out$main_cols <- out$cols[i]
	out$leg$border <- rep_len(out$leg$border, length(out$cols))
	out$main_border <- out$leg$border[i]

	if (!is.null(out$colNA)) {
		out$main_cols[is.na(out$main_cols)] <- out$colNA
	}

	out$levels <- out$uv
	out$leg$legend <- out$uv
	nlevs <- length(out$uv)

	cols <- out$cols
	ncols <- length(cols)
	if (nlevs < ncols) {
		i <- trunc((ncols / nlevs) * 1:nlevs)
		cols <- cols[i]
	} else {
		cols <- rep_len(cols, nlevs)
	}
	out$leg$fill <- cols
	out$legend_type <- "classes"

	if (is.null(out$leg$x)) { # && is.null(out$leg$ext)) {
		out$leg$x <- "default"
	}

	out
}


.vect.legend.continuous <- function(out) {

	z <- stats::na.omit(out$v)
	n <- length(z)
	if (n == 0) error("plot", "no values")
	if (!is.numeric(out$v)) {
		out$v <- as.integer(as.factor(out$v))
		z <- stats::na.omit(out$v)
		n <- length(z)
	}
	#out$range <- range(z)
	
	interval <- (out$range[2]-out$range[1])/(length(out$cols)-1)
	breaks <- out$range[1] + interval * (0:(length(out$cols)-1))
	
	out$legend_type <- "continuous"
	if (is.null(out$levels)) {
		out$levels <- 5
	}
	if (is.null(out$leg$digits)) {
		dif <- diff(out$range)
		if (dif == 0) {
			out$leg$digits <- 0;
		} else {
			out$leg$digits <- max(0, -floor(log10(dif/10)))
		}
	}

#	if (is.null(out$leg$loc)) out$leg$loc <- "right"

	brks <- seq(out$range[1], out$range[2], length.out = length(out$cols))
	grps <- cut(out$v, breaks = brks, include.lowest = TRUE)
	out$main_cols <- out$cols[grps]
	out$leg$border <- rep_len(out$leg$border, length(out$cols))
	out$main_border <- out$leg$border[grps]

	out
}


.vect.legend.interval <- function(out, dig.lab=3, ...) {

	nmx <- length(out$uv)
	if (!is.numeric(out$v)) {
		out$v <- as.integer(as.factor(out$v))
	}

	if (is.null(out$breaks)) {
		out$breaks <- min(5, nmx)
	}

	if (length(out$breaks) == 1) {
		out$breaks <- .get_breaks(out$v, out$breaks, out$breakby, out$range)
	}

	fz <- cut(out$v, out$breaks, include.lowest=TRUE, right=FALSE, dig.lab=dig.lab)
	out$vcut <- as.integer(fz)
	levs <- levels(fz)
	nlevs <- length(levs)

#	cols <- out$cols
#	ncols <- length(cols)
#	if (nlevs < ncols) {
#		i <- trunc((ncols / nlevs) * 1:nlevs)
#		cols <- cols[i]
#	} else {
#		cols <- rep_len(cols, nlevs)
#	}
	
	if (out$legend_type == "classes" && nlevs > length(out$cols)) {
		# more classes than colors: cycle from beginning
		cols_idx <- rep_len(out$cols, nlevs)
	} else {
		# else sample the colors
		cols_idx <- trunc(seq(1, length(out$cols), length.out = nlevs))
	}
	out$leg$fill <- out$cols <- out$cols[cols_idx]
	out$legend_type <- "classes"

	if (!is.null(out$leg$legend)) {
		if (length(out$leg$legend) != nlevs) {
			warn("plot", "legend does not match number of levels")
			out$leg$legend <- rep_len(out$leg$legend, nlevs)
		}
	} else {
		levs <- gsub("]", "", gsub(")", "", gsub("\\[", "", levs)))
		levs <- paste(levs, collapse=",")
		m <- matrix(as.numeric(unlist(strsplit(levs, ","))), ncol=2, byrow=TRUE)
		m <- apply(m, 1, function(i) paste(i, collapse=" - "))
		out$leg$legend <- m
	}

	if (is.null(out$leg$x)) { # && is.null(out$leg$ext)) {
		out$leg$x <- "default"
	}
	out$main_cols <- out$cols[out$vcut]
	out$leg$border <- rep_len(out$leg$border, length(out$cols))
	out$main_border <- out$leg$border[out$vcut]
	if (!is.null(out$colNA)) {
		out$main_cols[is.na(out$main_cols)] <- out$colNA
	}
	out
}


.plot.vect.map <- function(x, out, ...) {

	if ((!out$add) & (!out$legend_only)) {
		if (out$zebra) {
			width <- rep(min(diff(out$lim[1:2]), diff(out$lim[3:4])) / 100, 2) * out$zebra.cex
			if (out$lonlat) {
				asp <- 1/cos((mean(out$lim[3:4]) * pi)/180)
				width[2] <- width[2] / asp
			}
			out$lim[1:2] <- out$lim[1:2] + c(-width[1], width[1])
			out$lim[3:4] <- out$lim[3:4] + c(-width[2], width[2])
		}
		if (!any(is.na(out$mar))) { graphics::par(mar=out$mar) }
		plot(out$lim[1:2], out$lim[3:4], type="n", xlab="", ylab="", asp=out$asp, xaxs="i", yaxs="i", axes=FALSE, main="")
		if (!is.null(out$background)) {
			graphics::rect(out$lim[1], out$lim[3], out$lim[2], out$lim[4], col=out$background, border=x$box)
		}
	} else {
		x$zebra <- FALSE
	}
	if (isTRUE(out$blank)) return(out)
	
	nuq <- length(out$uv)
	if (out$legend_type == "none") {
		out <- .vect.legend.none(out)
	} else if (out$legend_type == "classes") {
		out <- .vect.legend.classes(out)
	} else if (out$legend_type == "interval") {
		if (nuq < 2) {
			out <- .vect.legend.classes(out, ...)
		} else {
			out <- .vect.legend.interval(out, dig.lab=out$dig.lab)
		}
	} else if (out$legend_type == "depends") {
		if (!is.null(out$breaks)) {
			out <- .vect.legend.interval(out, dig.lab=out$dig.lab)			
		} else if (nuq < 11) {
			out <- .vect.legend.classes(out)
		} else if (!is.numeric(out$uv)) {
			#if (nuq < 21)
			out <- .vect.legend.classes(out)
		} else {
			out <- .vect.legend.interval(out, dig.lab=out$dig.lab)
		}
	} else {
		if (nuq == 1) {
			out <- .vect.legend.classes(out)
		} else {
			out <- .vect.legend.continuous(out)
			out$leg$density <- NULL
		}
	}
	if (!out$legend_only) {
		if (!out$add) {
			try(set.clip(out$lim, out$lonlat))
		}
		out <- .plot.axes(out)
		out <- .vplot(x, out, ...)
	}


	if (out$legend_draw) {
		if (out$legend_type == "continuous") {
			out$legpars <- do.call(.plot.cont.legend, list(x=out))
		} else {
			if (out$add) {
				if (out$clip) {
					out$leg$plotlim <- unlist(get.clip()[1:4])
				} else {
					out$leg$plotlim <- graphics::par("usr")
				}
				if (is.null(out$leg$plotlim)) {
					out$leg$plotlim <- out$lim			
				}
			} else {
				if (out$clip) {
					out$leg$plotlim <- out$lim
				} else {
					out$leg$plotlim <- graphics::par("usr")
				}
			}
			out$legpars <- do.call(.plot.class.legend, out$leg)
		}
	}

	if (out$zebra) {
		zebra(width=width, x=out$axs$xat, y=out$axs$yat, col=out$zebra.col)
		out$lim[1:2] <- out$lim[1:2] + c(width[1], -width[1])
		out$lim[3:4] <- out$lim[3:4] + c(width[2], -width[2])
	}

	if (isTRUE(out$box)) { 
		if (out$clip) {
			lines(ext(out$lim))	
		} else {
			lines(ext(graphics::par("usr")))		
		}
	}
	
	plot_main(out)

#	if (out$main != "") {
#		posx <- out$lim[1] + diff(out$lim[1:2])/2
#		text(posx, out$lim[4], out$main, pos=3, offset=out$line.main, cex=out$cex.main, 
#			font=out$font.main, col=out$col.main, xpd=TRUE)
#	}

	if (!out$add) {
		try(set.clip(out$lim, out$lonlat))
	}
	out
}


.prep.vect.data <- function(x, y, type=NULL, cols=NULL, mar=NULL, legend=TRUE,
	legend.only=FALSE, levels=NULL, add=FALSE, range=NULL, fill_range=FALSE, breaks=NULL, breakby="eqint",
	xlim=NULL, ylim=NULL, colNA=NA, alpha=NULL, axes=TRUE, buffer=TRUE, background=NULL,
	pax=list(), plg=list(), ext=NULL, grid=FALSE, zebra=FALSE, zebra.cex=1, zebra.col=c("black", "white"), 
	las=0, sort=TRUE, reverse=FALSE, values=NULL,
	box=TRUE, xlab="", ylab="", cex.lab=0.8, line.lab=1.5, yaxs="i", xaxs="i", 
	main="", cex.main=1.2, line.main=0.5, font.main=graphics::par()$font.main, col.main = graphics::par()$col.main, loc.main=NULL, 
    sub = "", font.sub=1, cex.sub=0.8*cex.main, line.sub =1.75,  col.sub=col.main, loc.sub=NULL,
	halo=FALSE, hc="white", hw=0.1, 
	density=NULL, angle=45, border="black", dig.lab=3, cex=1, clip=TRUE, leg_i=1, asp=NULL, xpd=NULL, 
#catch and kill
	decreasing=FALSE, font=NULL,
	...) {

	# backwards compatibility
	reverse <- isTRUE(reverse) || isTRUE(decreasing)

	out <- list()
	out$blank <- FALSE
	if ((y == "") && (is.null(values))) {
		if (is.null(type)) type <- "none"
		if (type == "n") {
			out$blank <- TRUE
		}
		type <- "none"
		plg <- list()
	}
	
	e <- as.vector(ext(x))
	if (any(is.na(e))) {
		error("plot", "SpatVector has no valid geometries")
	}
	if (e[1] == e[2]) {
		e[1] = e[1] - 0.5
		e[2] = e[2] + 0.5
	}
	if (e[3] == e[4]) {
		e[3] = e[3] - 0.5
		e[4] = e[4] + 0.5
	}
	
	out$lim <- out$ext <- e
	if ((!is.null(ext)) || (!is.null(xlim)) || (!is.null(ylim))) {
		if (!is.null(ext)) {
			ext <- ext(ext)
			if (!is.null(xlim) | !is.null(ylim)) {
				x <- crop(x, ext)
			} else {
				x <- x[ext, ]
			}
			out$ext <- as.vector(ext(x))
			out$lim <- as.vector(ext)
		}
		if (!is.null(xlim)) {
			stopifnot(length(xlim) == 2)
			out$lim[1:2] <- sort(xlim)
		}
		if (!is.null(ylim)) {
			stopifnot(length(ylim) == 2)
			out$lim[3:4] <- sort(ylim)
		}
	} else if ((!add) && is.null(xpd)) {
		xpd <- TRUE
	}
	out$ngeom <- nrow(x)
	out$clip <- isTRUE(clip)

	if (buffer) {
		dx <- diff(out$lim[1:2]) / 50
		dy <- diff(out$lim[3:4]) / 50
		out$lim[1:2] <- out$lim[1:2] + c(-dx, dx)
		out$lim[3:4] <- out$lim[3:4] + c(-dy, dy)
	}
	
	out$main <- main
#	if ((!is.expression(main)) && (is.null(out$main) || any(is.na(out$main)))) out$main <- ""

	out$halo.main <- halo
	out$halo.main.hc <- hc
	out$halo.main.hw <- hw

	out$cex.main  <- cex.main
	out$loc.main  <- loc.main
	out$font.main <- font.main
	out$col.main  <- col.main
	out$line.main <- line.main

	out$sub <- sub
	out$loc.sub <- loc.sub
	out$cex.sub <- cex.sub
	out$font.sub <- font.sub
	out$col.sub <- col.sub
	out$line.sub <- line.sub

	out$dig.lab <- dig.lab

	out$box <- isTRUE(box)
	out$zebra <- isTRUE(zebra)
	out$zebra.cex <- zebra.cex
	out$zebra.col <- zebra.col
	
	out$add <- isTRUE(add)
	out$axes <- isTRUE(axes)
	out$xlab <- xlab
	out$ylab <- ylab
	out$axs <- as.list(pax)
	out$cex <- cex
	if (is.null(out$axs$las)) out$axs$las <- las
	if (is.null(out$axs$cex.lab)) out$axs$cex.lab <- cex.lab
	if (is.null(out$axs$line.lab)) out$axs$line.lab <- line.lab
	
	out$draw_grid <- isTRUE(grid)
	out$leg <- as.list(plg)
	out$leg$geomtype <- geomtype(x)
	
	out$leg$density <- density
	out$leg$angle <- angle
	out$leg$border <- border
	
	
	if (is.null(asp)) {
		out$lonlat <- is.lonlat(x, perhaps=TRUE, warn=FALSE)
		if (out$lonlat) {
			out$asp <- 1/cos((mean(out$ext[3:4]) * pi)/180)
		} else {
			out$asp <- 1
		}
	} else {
		out$asp <- asp
		out$lonlat <- FALSE
	}
	
	out$breaks <- breaks
	out$breakby <- breakby
	out$background <- background
	if (is.null(values)) {
		v <- unlist(x[, y, drop=TRUE], use.names=FALSE)
	} else {
		if (inherits(values, "data.frame")) {
			if (ncol(values) == 2) {
				xname = names(values)[1]
				if (xname %in% names(x)) {
					i <- match(x[[xname,drop=TRUE]], values[[1]])
					v <- values[[2]][i]
				} else {
					error("plot", paste(xname, "is not a name in x"))
				}
			} else {
				values <- values[[1]]
			}
		} else {
			v <- as.vector(values)
		}
		v <- rep_len(v, nrow(x))
	}
	if (is.factor(v)) v <- as.character(v)
	if (is.numeric(v)) {
		v[!is.finite(v)] <- NA
	}
	out$fill_range <- isTRUE(fill_range)
	out$range_filled <- c(FALSE, FALSE)
	if (!is.null(range)) {
		range <- sort(range)
		if (out$fill_range) {
			i <- v < range[1]
			if (any(i)) {
				v[i] <- range[1]
				out$range_filled[1] <- TRUE
			}
			i <- v > range[2]
			if (any(i)) {
				v[i] <- range[2]
				out$range_filled[2] <- TRUE
			}
		} else {
			v[v < range[1]] <- NA
			v[v > range[2]] <- NA
		}
		if (all(is.na(v))) {
			v <- NULL
			y <- ""
			type = "none"
		} else {
			out$range <- range
		}
		out$range_set <- TRUE
	} else {
		if (!is.null(v)) {
			out$range <- range(v, na.rm=TRUE)
		}
		out$range_set <- FALSE
		out$fill_range <- FALSE
	}
	out$v <- v

	if (!is.logical(sort)) {
		out$uv <- unique(sort)
		out$leg$sort <- FALSE
		out$leg$reverse <- FALSE
	} else {
		out$uv <- unique(out$v)
		if (is.factor(out$v)) {
			out$uv <- levels(out$v)[levels(out$v) %in% out$uv]
		}
		out$leg$sort <- isTRUE(sort)
		out$leg$reverse <- isTRUE(reverse)
	}

	if (is.null(type)) {
		type <- "depends"
	} else {
		type <- match.arg(type, c("continuous", "classes", "interval", "depends", "none"))
	}
	out$levels <- levels
	
	if (type=="none") {
		legend <- FALSE
		legend_only <- FALSE
	}
	out$legend_type <- type

	if (is.null(cols)) {
		if (type == "none") {
			if (out$leg$geomtype %in% c("lines", "points")) {
				cols <- "black"
			}
		} else {
			cols <- .default.pal()
#			cols <- rev(grDevices::rainbow(100, start=.1, end=0.9))
		}
	}
	if (!is.null(alpha)) {
		alpha <- clamp(alpha[1], 0, 1)
		cols <- grDevices::rgb(t(grDevices::col2rgb(cols)), alpha=alpha*255, maxColorValue=255)
	} else {
		alpha <- 1
	}

	out$alpha <- alpha
	out$cols <- cols
	out$legend_draw <- isTRUE(legend)
	out$legend_only <- isTRUE(legend.only)
	out$leg$leg_i <- leg_i

	out$mar <- mar
	out <- get_mar(out)

#	if (is.null(mar)) {
#		if (out$legend_draw) {
#			mar=c(3.1, 3.1, 2.1, 7.1)
#		} else {
#			mar=c(3.1, 3.1, 2.1, 2.1)
#		}
#	}
#	out$mar <- rep_len(mar, 4)
	out$skipNA <- TRUE
	if (!is.null(colNA)) {
		if (!is.na(colNA)) {
			out$colNA <- grDevices::rgb(t(grDevices::col2rgb(colNA)), alpha=alpha*255, maxColorValue=255)
			out$r[is.na(out$r)] <- out$colNA
			out$skipNA <- FALSE
 		} else {
			out$colNA <- NULL
		}
	}

	.plot.vect.map(x, out, xpd=xpd, ...)
}


setMethod("plot", signature(x="SpatVector", y="character"),

function(x, y, col=NULL, type=NULL, mar=NULL, legend=TRUE, axes=!add, plg=list(), pax=list(), 
	main="", range=NULL, fill_range=FALSE, breaks=NULL, breakby="eqint", fun=NULL, colNA=NA, alpha=NULL,
	grid=FALSE, zebra=FALSE, ext=NULL, sort=TRUE, reverse=FALSE, nr, nc, add=FALSE, buffer=TRUE, background=NULL,
	box=axes, clip=TRUE, ...) {


		old.mar <- graphics::par()$mar
		on.exit(graphics::par(mar=old.mar))

		if (nrow(x) == 0) {
			error("plot", "SpatVector has zero geometries")
		}
		if (add) reset.clip()

		y <- trimws(y)
		if (any(is.na(match(y, c("", names(x)))))) {
			i <- is.na(match(y, names(x)))
			error("plot", paste(paste(y[i], collapse=",")), " is not a name in x")
		}
		nrnc <- c(1,1)
		if (length(y) > 1) {
			nrnc <- .get_nrnc(nr, nc, length(y))
			old.par <- graphics::par(no.readonly =TRUE)
			on.exit(graphics::par(old.par))
			graphics::par(mfrow=nrnc)
		}
		if (is.character(legend)) {
			plg$x <- legend
			legend <- TRUE
		}


		for (i in 1:length(y)) {
			if (length(y) > 1) {
				if (missing("main")) {
					main <- y
				} else {
					main <- rep_len(main, length(y))
				}
				newrow <- (nrnc[2] == 1) | ((i %% nrnc[2]) == 1)
				lastrow <- i > (prod(nrnc) - nrnc[2])
				if (lastrow) {
					if (newrow) {
						pax$side <- 1:2
					} else {
						pax$side <- 1
					}
				} else if (newrow) {
					pax$side <- 2
				} else {
					pax$side <- 0
				}
			} else if (missing("main")) {
				main <- ""
			}

			if (missing(col)) col <- NULL

			out <- .prep.vect.data(x, y[i], type=type, cols=col, mar=mar, plg=plg, pax=pax, legend=isTRUE(legend), add=add, axes=axes, main=main[i], range=range, fill_range=fill_range, breaks=breaks, breakby=breakby, buffer=buffer, background=background,
			grid=grid, zebra=zebra, ext=ext, sort=sort, reverse=reverse, colNA=colNA, alpha=alpha, box=box, clip=clip, leg_i=i,  ...)

			add_more(fun, i)

		}
		invisible(out)
	}
)


setMethod("plot", signature(x="SpatVector", y="numeric"),
	function(x, y, ...)  {
		y <- round(y)
		if (any(y > ncol(x))) {
			error("plot", paste("x only has", ncol(x), " columns"))
		}
		y[y<0] <- 0
		y <- c("", names(x))[y+1]
		out <- plot(x, y, ...)
		invisible(out)
	}
)


#setMethod("plot", signature(x="SpatVector", y="data.frame"),
#	function(x, y, values=NULL, ...)  {
#		out <- plot(x, "", values=y, ...)
#		invisible(out)
#	}
#)

setMethod("plot", signature(x="SpatVector", y="missing"),
	function(x, y, values=NULL, ...)  {
		invisible( plot(x, "", values=values, ...) )
	}
)


setMethod("plot", signature(x="SpatVectorProxy", y="missing"),
	function(x, y, ...)  {
		plot(ext(x), ...)
	}
)



setMethod("plot", signature(x="SpatVectorCollection", y="missing"),
	function(x, y, main, mar=NULL, nc, nr, maxnl=16, col=NULL, ...) {
		nl <- max(1, min(length(x), maxnl))

		if (nl==1) {
			if (missing(main)) main = ""
			out <- plot(x[1], main=main[1], mar=mar, ...)
			return(invisible(out))
		}

		nrnc <- .get_nrnc(nr, nc, nl)
		old.par <- graphics::par(no.readonly = TRUE)
		on.exit(graphics::par(old.par))
		if (is.null(mar)) {
			mar=c(1.5, 1, 2.5, 3)
		}
		graphics::par(mfrow=nrnc)

		if (missing("main")) {
			main <- names(x)
		} else {
			main <- rep_len(main, nl)
		}
		if (is.list(col)) {
			col <- rep_len(col, nl)
			for (i in 1:nl) {
				plot(x[i], main=main[i], mar=mar, col=col[[i]], ...)
			}
		} else {
			for (i in 1:nl) {
				plot(x[i], main=main[i], mar=mar, ...)
			}
		}
	}
)

setMethod("plot", signature(x="SpatVectorCollection", y="numeric"),
	function(x, y, main, mar=NULL, ext=NULL, ...) {
		y <- round(y)
		if ((y > 0) && (y <= length(x))) {
			if (is.null(ext)) ext <- ext(x)
			plot(x[y], main=main, mar=mar, ext=ext, ...)
		} else {
			error("plot", "y should be between 1 and length(x)")
		}
	}
)

.txt.loc <- function(x, main=TRUE) {
	if (main) {
		cex <- "cex.main"
		loc <- "loc.main"
	} else {
		cex <- "cex.sub"
		loc <- "loc.sub"
	}
	if (isTRUE(x$clip)) {
		dxy <- graphics::par("cxy") * x[[cex]]
		if (grepl("right", x[[loc]])) {
			px <- x$lim[2]
			pos <- 2
		} else {
			px <- x$lim[1]
			pos <- 4	
		}
		if (grepl("bottom", x[[loc]])) {
			py <- x$lim[3] + dxy[2]/2
		} else {
			py <- x$lim[4] - dxy[2]/2
		}
	} else {
		dxy <- graphics::par("cxy") * x[[cex]]
		usr <- graphics::par("usr")
		if (grepl("right", x[[loc]])) {
			px <- usr[2]
			pos <- 2
		} else {
			px <- usr[1]
			pos <- 4	
		}
		if (grepl("bottom", x[[loc]])) {
			py <- usr[3] + dxy[2]/2
		} else {
			py <- usr[4] - dxy[2]/2
		}
	}
	out <- c(px, py, pos)
	names(out) <- NULL
	out
}


legend_cont <- function(x="right", y=NULL, legend, col,
	size=NULL, title=NULL, at=NULL, digits=NULL, ...) {

	if (inherits(legend, "SpatRaster")) {
		mm <- minmax(legend)
		rng <- c(mm[1,1], mm[2,1])
	} else {
		rng <- range(legend, na.rm=TRUE)
	}
	stopifnot(length(rng) == 2)

	if (missing(col)) col <- .default.pal()
	col <- grDevices::rgb(t(grDevices::col2rgb(col)), maxColorValue=255)

	out <- list()
	out$cols <- col
	out$range <- rng
	out$levels <- 5
	out$fill_range <- TRUE
	out$range_filled <- c(FALSE, FALSE)
	e <- unlist(get.clip())
	usr <- graphics::par("usr")
	tol <- max(abs(usr)) * .Machine$double.eps * 100
	if (!is.null(e) &&
		e[1] >= usr[1] - tol && e[2] <= usr[2] + tol &&
		e[3] >= usr[3] - tol && e[4] <= usr[4] + tol) {
		out$clip <- TRUE
		out$lim <- e[1:4]
	} else {
		out$clip <- FALSE
		out$lim <- usr
	}
	out$axs <- list(lab=NULL)

	out$leg <- list(...)
	horiz <- isTRUE(out$leg$horiz) || (is.character(x) && x %in% c("top", "bottom"))
	if (is.numeric(x)) {
		if (length(x) == 2) {
			out$leg$x <- sort(x)
		} else if (horiz && length(x) == 1) {
			w <- diff(out$lim[1:2]) * 0.6
			out$leg$x <- c(x, x + w)
		} else {
			out$leg$x <- x
		}
	} else {
		out$leg$x <- x
	}
	if (is.numeric(x) && !is.null(y)) {
		if (length(y) == 2) {
			out$leg$y <- sort(y)
		} else if (!horiz && length(y) == 1) {
			h <- diff(out$lim[3:4]) * 0.6
			out$leg$y <- c(y - h, y)
		} else {
			out$leg$y <- y
		}
	} else {
		out$leg$y <- y
	}
	if (!is.null(size)) out$leg$size <- size
	if (!is.null(title)) out$leg$title <- title
	if (!is.null(at)) out$leg$at <- at
	if (is.null(out$leg$reverse)) out$leg$reverse <- FALSE
	if (is.null(out$leg$digits)) {
		if (!is.null(digits)) {
			out$leg$digits <- digits
		} else {
			dif <- diff(rng)
			if ((dif == 0) || (length(dif) == 0)) {
				out$leg$digits <- 0
			} else {
				out$leg$digits <- max(0, -floor(log10(dif / 10)))
			}
		}
	}

	.plot.cont.legend(out)
	invisible(out)
}


add_legend <- function(x, y, xpd=TRUE, ...) {
	if (inherits(x, "character")) {
		e <- unlist(get.clip())
		if (!is.null(e)) {
			rct <- graphics::legend(x=x, y=y, plot=FALSE, xpd=xpd, ...)$rect
			xy <- get_legxy(rct, e[1:4], x, NULL)
			graphics::legend(x=xy[1], y=xy[2], xpd=xpd, ...)
		} else {
			graphics::legend(x=x, y=y, xpd=xpd, ...)
		}
	} else {
		graphics::legend(x=x, y=y, xpd=xpd, ...)
	}
}


add_box <- function(...) {
	e <- unlist(get.clip())
	if (!is.null(e)) {
		bx <- rbind(
			cbind(e[1], e[3:4]),
			cbind(e[2], e[4:3]),
			cbind(e[1], e[3])
		)
		if (is.null(list(...)$xpd)) {
			lines(bx, xpd=TRUE, ...)
		} else {
			lines(bx, ...)		
		}
	}
}

## adapted from graphics::grid 
g.grid.at <- function (side, n, axp, usr2) {
	if (is.null(n)) {
		stopifnot(is.numeric(ax <- axp), length(ax) == 3L)
		graphics::axTicks(side, axp=ax, usr=usr2, log=FALSE)
	} else if (!is.na(n) && (n <- as.integer(n)) >= 1L) {
		at <- seq.int(usr2[1L], usr2[2L], length.out = n + 1L)
		at[-c(1L, n + 1L)]
	}
}

add_grid <- function(nx=NULL, ny=nx, col="lightgray", lty="dotted", lwd=1) {

	p <- unlist(get.clip())
	reset.clip()

    atx <- if (is.null(nx) || (!is.na(nx) && nx >= 1)) 
        g.grid.at(1L, nx, axp=graphics::par("xaxp"), usr2 = p[1:2])
    aty <- if (is.null(ny) || (!is.na(ny) && ny >= 1)) 
        g.grid.at(2L, ny, axp = graphics::par("yaxp"), usr2 = p[3:4])
    graphics::abline(v = atx, h = aty, col = col, lty = lty, lwd = lwd)
    invisible(list(atx = atx, aty = aty))
}

add_abline <- function(h=NULL, v=NULL, ...) {
	p <- unlist(get.clip())
	reset.clip()
	if (!is.null(h)) {
		lines(as.lines(cbind(p[1], p[2], h, h)), ...)
	}
	if (!is.null(v)) {
		lines(as.lines(cbind(v, v, p[3], p[4])), ...)	
	}
}

	
add_mtext <- function(text, side=3, line=0, adj=0.5, ...) {

	stopifnot(side %in% 1:4)

	p <- unlist(get.clip())
	h <- graphics::strheight(text, units="user", ...)
	adj <- c(adj[1], 0.5)

	srt <- 0
	if (side == 1) {
		x <- p[1] + adj[1] * (p[2] - p[1])
		y <- p[3] - h - line * h
	} else if (side == 2) {
		x <- p[1] - 1.25 * h - line * h
		y <- p[3] + adj[1] * (p[4] - p[3])
		srt <- 90
	} else if (side == 3) {
		x <- p[1] + adj[1] * (p[2] - p[1])
		y <- p[4] + h + line * h
	} else {
		x <- p[2] + 1.25 * h + line * h
		y <- p[3] + adj[1] * (p[4] - p[3])
		srt <- 270
	}

	# flip adj because for rotated side4
	a <- if (side == 4) c(1 - adj[1], adj[2]) else adj
	text(x=x, y=y, labels=text, xpd=TRUE, srt=srt, adj=a, ...)
}


plot_main <- function(x) {
		if (isTRUE(x$main != "")) {
			pos <- 3
			if (is.null(x$loc.main)) {
				if (isTRUE(x$clip)) {
					x$loc.main <- c(x$lim[1] + diff(x$lim[1:2]) / 2, x$lim[4])
				} else {
					usr <- graphics::par("usr")			
					x$loc.main <- c(usr[1] + diff(usr[1:2]) / 2, usr[4])			
				}
			} else if (inherits(x$loc.main, "character")) {
				xyp <- .txt.loc(x)
				x$loc.main <- xyp[1:2]
				pos <- xyp[3]
			}	
			if (isTRUE(x$halo.main)) {
				.halo(x$loc.main[1], x$loc.main[2], x$main, pos=pos, offset=x$line.main, cex=x$cex.main, 
					font=x$font.main, col=x$col.main, xpd=TRUE, hc=x$halo.main.hc, hw=x$halo.main.hw)
			} else {
				text(x$loc.main[1], x$loc.main[2], x$main, pos=pos, offset=x$line.main, cex=x$cex.main, 
					font=x$font.main, col=x$col.main, xpd=TRUE)
			}
		}
		if (isTRUE(x$sub != "")) { 
			pos <- 1
			if (is.null(x$loc.sub)) {
				if (isTRUE(x$clip)) {
					x$loc.sub <- c(x$lim[1] + diff(x$lim[1:2]) / 2, x$lim[3])
				} else {
					usr <- graphics::par("usr")			
					x$loc.sub <- c(usr[1] + diff(usr[1:2]) / 2, usr[3])			
				}
			} else if (inherits(x$loc.sub, "character")) {
				xyp <- .txt.loc(x, FALSE)
				x$loc.sub <- xyp[1:2]
				pos <- xyp[3]
			}
			if (isTRUE(x$halo.main)) {
				.halo(x$loc.sub[1], x$loc.sub[2], x$sub, pos=pos, offset=x$line.sub, cex=x$cex.sub, 
					font=x$font.sub, col=x$col.sub, xpd=TRUE, hc=x$halo.sub.hc, hw=x$halo.sub.hw)
			} else {
				text(x$loc.sub[1], x$loc.sub[2], x$sub, pos=pos, offset=x$line.sub, cex=x$cex.sub, 
					font=x$font.sub, col=x$col.sub, xpd=TRUE)
			}
		}
}

setMethod("set.window", signature(x="SpatRaster"),
	function(x, value)  {
		try(value <- ext(value), silent=TRUE)
		if (inherits(value, "SpatExtent")) {
			window(x) <- NULL
			value <- intersect(ext(x), value)
			if (is.null(value)) {
				error("window<-,SpatRaster", "cannot set a window that does not overlap with x")			
			}
			if (!(x@pntr$setWindow(value@pntr))) {
				error("window<-,SpatRaster", "cannot set this window")
			}
		} else if (is.null(value) || isTRUE(is.na(value))) {
			x@pntr$removeWindow()
		} else {
			error("window<-", "'value' should be or have a SpatExtent, or be NULL or NA")
		}
		x
	}
)


setMethod("window<-", signature(x="SpatRaster"),
	function(x, value)  {
		set.window(deepcopy(x), value)
	}
)


setMethod("window", signature(x="SpatRaster"),
	function(x)  {
		x@pntr$hasWindow()
	}
)

# Author: Robert J. Hijmans
# Date:  October 2018
# Version 1.0
# License GPL v3


format_ym <- function(x) {
	y <- floor(x)
	m <- round((x-y) * 12 + 1)
	m <- month.abb[m]
	paste(y, m, sep="-")
}

yearweek <- function(d) {
	y <- as.integer(strftime(d, format = "%Y"))
	w <- strftime(d, format = "%V")
	m <- strftime(d, format = "%m")
	i <- w > "51" & m=="01"
	y[i] <- y[i] - 1
	i <- w=="01" & m=="12"
	y[i] <- y[i] + 1
	yy <- as.character(y)
	i <- nchar(yy) < 4
	yy[i] <- formatC(y[i], width=4, flag="0")	
	paste0(yy, w)
}

setMethod("has.time", signature(x="SpatRaster"),
	function(x) {
		x@pntr$hasTime
	}
)


setMethod("timeInfo", signature(x="SpatRaster"),
	function(x) {
		time <- x@pntr$hasTime
		if (time) {
			step <- x@pntr$timestep
			if (step == "seconds") {
				data.frame(time=time, step=step, zone=x@pntr$timezone)
			} else {
				data.frame(time=time, step=step, zone="")
			}
		} else {
			data.frame(time=time, step="", zone="")
		}
	}
)


setMethod("timeInfo", signature(x="SpatRasterDataset"),
	function(x) {
		t(sapply(x, timeInfo))
	}
)


time_as_seconds <- function(x) {
	d <- x@pntr$time
	d <- strptime("1970-01-01", "%Y-%m-%d", tz="UTC") + d
	tz <- x@pntr$timezone
	if (!(tz %in% c("", "UTC"))) {
		attr(d, "tzone") = tz
	}
	d
}


#setMethod("time", signature(x="SpatVector"),
#	function(x, format="") {
#		cls <- sapply(values(x[1,]), function(i) { a = class(i); a[length(a)] })
#		i <- which(cls %in% c("Date", "POSIXt"))[1]
#		if (is.na(i)) {
#			return(rep(NA, nrow(x)))
#		} else {
#			d <- x[,i,drop=TRUE][,,drop=TRUE]
#			if (format != "") {
#				steps <- c("seconds", "days", "months", "years", "yearmonths")
#				format <- match.arg(tolower(format), steps)
#				if (!(format %in% steps)) {
#					error("time", "not a valid time format")
#				}
#				tstep <- ifelse(cls[i]=="Date", "days", "seconds")
#				if (format == "seconds") {
#					if (tstep != "seconds") {
#						error("time", "cannot extract seconds from Dates")
#					}
#					d
#				} else if (format == "days") {
#					as.Date(d)
#				} else if (format == "yearmonths") {
#					y <- as.integer(format(d, "%Y"))
#					y + (as.integer(format(d, "%m"))-1)/12
#				} else if (format == "months") {
#					as.integer(format(d, "%m"))
#				} else if (format == "years") {
#					as.integer(format(d, "%Y"))
#				}
#			} else {
#				d
#			}
#		}
#	}
#)

setMethod("time", signature(x="SpatRaster"),
	function(x, format="") {
		if (!x@pntr$hasTime) {
			return(rep(NA, nlyr(x)))
		}
		d <- x@pntr$time
		d[d == -2^63] <- NA
		tstep <- x@pntr$timestep
		
		if (format != "") {
			steps <- c("seconds", "days", "months", "years", "yearmonths", "raw")
			format <- match.arg(tolower(format), steps)
			if (format == "raw") return(d)
			
			if ((format == "months") && (tstep == "years")) {
				error("time", "cannot extract months from years-time")
			} else if ((format == "years") && (tstep %in% c("months"))) {
				error("time", "cannot extract years from months-time")
			} else if ((format == "yearmonths") && (tstep %in% c("months", "years"))) {
				error("time", "cannot extract yearmonths from this type of time data")
			} else if ((format == "seconds") && (tstep != "seconds")) {
				error("time", "cannot extract seconds from this type of time data")
			} else if ((format == "days") && (!(tstep %in% c("seconds", "days")))) {
				error("time", "cannot extract days from this type of time data")
			}
		} else if (tstep == "raw") {
			return(d)
		} else {
			format = tstep
		}
		
		
		tz <- x@pntr$timezone
		tz[tz == ""] <- "UTC"
		d <- strptime("1970-01-01", "%Y-%m-%d", tz="UTC") + d
		attr(d, "tzone") = tz
		if (format == "seconds") {
			return(d)
		}
		
		if (format == "days") {
		# first use format to avoid time zone trouble #1896
		#	as.Date(format(d, "%Y-%m-%d"))
		# above does not work with negative years. #1951	
			as.Date(d, tz=tz)
		} else if (format == "yearmonths") {
			y <- as.integer(format(d, "%Y"))
			y + (as.integer(format(d, "%m"))-1)/12
		} else if (format == "months") {
			as.integer(format(d, "%m"))
		} else if (format == "years") {
			as.integer(format(d, "%Y"))
#		} else if (format == "yearweeks") {
#			yearweek(as.Date(d))
		} else { # ???
			d
		}
	}
)

setMethod("time", signature(x="SpatRasterDataset"),
	function(x, format="") {
		lapply(x,time, format=format)
	}
)

posix_from_ym <- function(y, m) {
	y <- floor(y)
	i <- ((y < 0) | (y > 9999))
	if (any(i)) {
		d <- paste(paste(rep("1900", length(y)), m, "15", sep="-"), "12:00:00")
		d[!i] <- paste(paste(y[!i], m, "15", sep="-"), "12:00:00")
		d <- as.POSIXlt(d, format="%Y-%m-%d %H:%M:%S", tz="UTC")
		for (j in i) {
			d$year[j] = y[j] - 1900
		}
		d
	} else {
		d <- paste(paste(y, m, "15", sep="-"), "12:00:00")
		as.POSIXlt(d, format="%Y-%m-%d %H:%M:%S", tz="UTC")
	}
}


setMethod("time<-", signature(x="SpatRaster"),
	function(x, tstep="", value)  {
		if (missing(value)) {
			value <- tstep
			tstep <- ""
		}
		x@pntr <- x@pntr$deepcopy()
		if (is.null(value)) {
			x@pntr$setTime(0[0], "remove", "")
			return(x)
		}
		if (inherits(value, "character")) {
			error("time<-", "value cannot be a character type")
		}
		if (length(value) != nlyr(x)) {
			error("time<-", "length(value) != nlyr(x)")
		}
		if (tstep != "") {
			tstep = match.arg(as.character(tstep), c("seconds", "days", "months", "years", "yearmonths", "raw"))
		}
		## may not be necessary
		if (tstep == "seconds") tstep = ""
		
		tzone <- "UTC"
		stept <- ""
		if (inherits(value, "Date")) {
			value <- as.POSIXlt(value)
			if (tstep == "") stept <- "days"
		} else if (inherits(value, "POSIXt")) {
			if (tstep == "") stept <- "seconds"
			tzone <- attr(value[1], "tzone")[1]
			if (is.null(tzone)) tzone = "UTC"
		} else if (inherits(value, "yearmon")) {
			value <- as.numeric(value)
			year <- floor(value)
			month <- round(12 * (value - year) + 1)
			value <- posix_from_ym(value, month)
			if (tstep == "") stept <- "yearmonths"
		} 
		
		if (stept == "") {
			stept = tstep
			if (tstep == "years") {
				if (is.numeric(value)) {
					value <- posix_from_ym(value, "6")
				} else {
					value <- as.integer(strftime(value, format = "%Y", tz=tzone))
					value <- posix_from_ym(value, "6")
				}
			} else if (tstep == "months") {
				if (is.numeric(value)) {
					value <- floor(value)
				} else {
					value <- as.integer(strftime(value, format = "%m", tz=tzone))
				}
				if (!all(value %in% 1:12)) {
					error("date<-", "months should be between 1 and 12")
				}
				value <- posix_from_ym(1970, value)
			} else if (tstep == "yearmonths") {
				if (is.numeric(value)) {
					y <- as.integer(substr(value, 1, 4))
					m <- value - (y * 100)
				} else {
					y <- as.integer(strftime(value, format = "%Y", tz=tzone))
					m <- as.integer(strftime(value, format = "%m", tz=tzone))
				}
				if (!all(m %in% 1:12)) {
					error("date<-", "months should be between 1 and 12")
				}
				value <- posix_from_ym(y, m)
			#} else if (tstep == "days") {
			#	print(value)
			#	value <- as.Date(value)
			#	stept = tstep
			} else if (tstep == "") {
				stept <- "raw"
			}
		}
		if (any(is.na(value))) {
			if (!all(is.na(value))) {
				error("time<-", "NAs are not allowed in time values (unless they are all NA)")
			}
			value <- value[0]
			stept <- "remove"
		}
		
		if (!x@pntr$setTime(as.numeric(value), stept, tzone)) {
			error("time<-", "cannot set these values")
		}
		return(x)
	}
)


setMethod("time<-", signature(x="SpatRasterDataset"),
	function(x, tstep="", value)  {

		if (missing(value)) {
			value <- tstep
			tstep <- ""
		}

		tstep <- rep_len(tstep, length(x))

		if (is.list(value)) {
			if (length(x) != length(value)) {
				error("time<-", "the list should have the same length as 'x'")
			}
			z <- lapply(1:length(x), function(i) { 
				time(x[i], tstep=tstep[i]) <- value[[i]]
			})
			
		} else {
			if (length(unique(nlyr(x))) > 1) {
				error("time<-", "not all SpatRasters have the same number of layers")
			}
			z <- lapply(1:length(x), function(i) { 
				time(x[i], tstep=tstep[i]) <- value
			})
		}
		x
	}
)


setMethod("depth", signature(x="SpatRaster"),
	function(x) {
		x@pntr$depth
	}
)

setMethod("depthName", signature(x="SpatRaster"),
	function(x) {
		x@pntr$get_depth_name()
	}
)

setMethod("depthName<-", signature(x="SpatRaster"),
	function(x, value) {
		x <- deepcopy(x)
		x@pntr$set_depth_name(value)
		x
	}
)


setMethod("depthUnit", signature(x="SpatRaster"),
	function(x) {
		x@pntr$get_depth_unit()
	}
)

setMethod("depthUnit<-", signature(x="SpatRaster"),
	function(x, value) {
		x <- deepcopy(x)
		x@pntr$set_depth_unit(value)
		x
	}
)

setMethod("depth<-", signature(x="SpatRaster"),
	function(x, value)  {
		if (is.null(value)) {
			x@pntr$setDepth(0[0])
			return(x)
		}
		value <- as.numeric(value)
		if (any(is.na(value))) {
			error("depth<-", "NAs are not allowed")
		}
		if (! x@pntr$setDepth(value)) {
			error("depth<-", "cannot set these  values")
		}
		return(x)
	}
)

setMethod("linearUnits", signature(x="SpatRaster"),
	function(x) {
		.getLinearUnits(crs(x))
	}
)

setMethod("linearUnits", signature(x="SpatVector"),
	function(x) {
		.getLinearUnits(crs(x))
	}
)

setMethod("units", signature(x="SpatRaster"),
	function(x) {
		x@pntr$units
	}
)

setMethod("units<-", signature(x="SpatRaster"),
	function(x, value)  {
		if (is.null(value) || all(is.na(value))) {
			value <- ""
		} else {
			value <- as.character(value)
		}
		if (! x@pntr$set_units(value)) {
			error("units<-", "cannot set these  values")
		}
		return(x)
	}
)


setMethod("units", signature(x="SpatRasterDataset"),
	function(x) {
		x@pntr$units
	}
)

setMethod("units<-", signature(x="SpatRasterDataset"),
	function(x, value)  {
		value <- as.character(value)
		x@pntr$units <- value
		return(x)
	}
)

# Author: Robert J. Hijmans
# Date :  April 2010
# Version 0.9
# License GPL v3


.as.raster.rgb <- function(out, x) {

	if (is.null(out$rgb$scale)) {
		scale <- 255
		if ( all(hasMinMax(x)) ) {
			rng <- minmax(x)[, 1:3]
			scale <- max(max(rng[2]), 255)
		}
	} else {
		scale <- out$rgb$scale
	}
	
	if (!is.null(out$rgb$zlim)) {
		if (length(out$rgb$zlim) == 2) {
			out$rgb$zlim <- sort(out$rgb$zlim)
			if (isTRUE(out$rgb$zcol)) {
				x <- clamp(x, out$rgb$zlim[1], out$rgb$zlim[2], values=TRUE)
			} else { #if (is.na(zlimcol)) {
				x <- clamp(x, out$rgb$zlim[1], out$rgb$zlim[2], values=FALSE)
			}
		} else if (NROW(out$rgb$zlim) == 3 & NCOL(out$rgb$zlim) == 2) {
			for (i in 1:3) {
				zmin <- min(out$rgb$zlim[i,])
				zmax <- max(out$rgb$zlim[i,])
				if (isTRUE(out$rgb$zcol)) {
					x[[i]] <- clamp(x[[i]], zmin, zmax, values=TRUE)
				} else { #if (is.na(zlimcol)) {
					x[[i]] <- clamp(x[[i]], zmin, zmax, values=FALSE)
				}
			}
		} else {
			error('zlim should be a vector of two numbers or a 3x2 matrix (one row for each color)')
		}
	}

	if (!is.null(out$rgb$stretch)) {
		if (out$rgb$stretch == "lin") {
			if ((!is.null(out$rgb$zlim)) && (length(out$rgb$zlim) == 2)) {
				x <- stretch(x, smin=out$rgb$zlim[1], smax=out$rgb$zlim[2])
			} else {
				x <- stretch(x, minq=0.02, maxq=0.98)
			}
		} else {
			x <- stretch(x, histeq=TRUE, scale=255)
		}
		scale <- 255
	}

	RGB <- values(x)
	RGB <- stats::na.omit(RGB)
	naind <- as.vector( attr(RGB, "na.action") )

	if (ncol(RGB) == 4) {
		alpha <- RGB[,4]
		RGB <- RGB[,-4]
	} else {
		# out$alpha is canonical 0..255; rescale to match maxColorValue=scale
		# so a fully-opaque alpha (255) means full opacity regardless of
		# the data scale (e.g. scale=3000 for Sentinel-2 reflectance).
		alpha <- out$alpha * scale / 255
	}

	if (!is.null(naind)) {
		bg <- grDevices::col2rgb(out$rgb$colNA)
		if (is.null(out$rgb$bgalpha)) out$rgb$bgalpha <- 255
		bg <- grDevices::rgb(bg[1], bg[2], bg[3], alpha=out$rgb$bgalpha, maxColorValue=255)
		z <- rep( bg, times=ncell(x))
		z[-naind] <- grDevices::rgb(RGB[,1], RGB[,2], RGB[,3], alpha=alpha, maxColorValue=scale)
	} else {
		z <- grDevices::rgb(RGB[,1], RGB[,2], RGB[,3], alpha=alpha, maxColorValue=scale)
	}
	
	out$r <- matrix(z, nrow=nrow(x), ncol=ncol(x), byrow=TRUE)
	out
}

# ..linStretch <- function (x) {
    # v <- stats::quantile(x, c(0.02, 0.98), na.rm = TRUE)
    # temp <- (255 * (x - v[1]))/(v[2] - v[1])
    # temp[temp < 0] <- 0
    # temp[temp > 255] <- 255
    # return(temp)
# }

# # Histogram equalization stretch
# ..eqStretch <- function(x){
	# ecdfun <- stats::ecdf(x)
	# ecdfun(x)*255
# }

# ..rgbstretch <- function(RGB, stretch, caller="") {
	# stretch = tolower(stretch)
	# if (stretch == 'lin') {
		# RGB[,1] <- ..linStretch(RGB[,1])
		# RGB[,2] <- ..linStretch(RGB[,2])
		# RGB[,3] <- ..linStretch(RGB[,3])
	# } else if (stretch == 'hist') {
		# RGB[,1] <- ..eqStretch(RGB[,1])
		# RGB[,2] <- ..eqStretch(RGB[,2])
		# RGB[,3] <- ..eqStretch(RGB[,3])
	# } else if (stretch != '') {
		# warn(caller, "invalid stretch value")
	# }
	# RGB
# }

# Author: Robert J. Hijmans
# Date : June 2013
# Version 1.0
# License GPL v3


.circular.weight <- function(rs, d, fillNA=FALSE) {
	nx <- 1 + 2 * floor(d/rs[1])
	ny <- 1 + 2 * floor(d/rs[2])
	m <- matrix(ncol=nx, nrow=ny)
	m[ceiling(ny/2), ceiling(nx/2)] <- 1
	if ((nx != 1) || (ny != 1)) {
		x <- rast(m, crs="+proj=utm +zone=1 +datum=WGS84")
		ext(x) <- c(xmin=0, xmax=nx*rs[1], ymin=0, ymax=ny*rs[2])
		d <- as.matrix(distance(x), wide=TRUE) <= d
		m <- d / sum(d)
	}
	if (fillNA) {
		m[m <= 0] <- NA
	}
	m
}



.Gauss.weight <- function(rs, sigma) {
	if (length(sigma) == 1) {
		d <- 3 * sigma
	} else {
		d <- sigma[2]
		sigma <- sigma[1]
	}
	nx <- 1 + 2 * floor(d/rs[1])
	ny <- 1 + 2 * floor(d/rs[2])
	m <- matrix(ncol=nx, nrow=ny)
	xr <- (nx * rs[1]) / 2
	yr <- (ny * rs[2]) / 2
	r <- rast(m, crs="+proj=utm +zone=1 +datum=WGS84")
	ext(r) <- c(xmin=-xr[1], xmax=xr[1], ymin=-yr[1], ymax=yr[1])
	p <- xyFromCell(r, 1:ncell(r))^2
# according to http://en.wikipedia.org/wiki/Gaussian_filter
	m <- 1/(2*pi*sigma^2) * exp(-(p[,1]+p[,2])/(2*sigma^2))
	m <- matrix(m, ncol=nx, nrow=ny, byrow=TRUE)
# sum of weights should add up to 1
	m / sum(m)
}


.rectangle.weight <- function(rs, d) {
	d <- rep(d, length.out=2)
	nx <- 1 + 2 * floor(d[1]/rs[1])
	ny <- 1 + 2 * floor(d[2]/rs[2])
	m <- matrix(1, ncol=nx, nrow=ny)
	m / sum(m)
}



focalMat <- function(x, d, type=c("circle", "Gauss", "rectangle"), fillNA=FALSE) {
	type <- match.arg(type)
	x <- res(x)
	if (type == 'circle') {
		.circular.weight(x, d[1], fillNA)
	} else if (type == 'Gauss') {
		if (!length(d) %in% 1:2) {
			error("focalMath", "if type=Gauss, d should be a vector of length 1 or 2")
		}
		.Gauss.weight(x, d)
	} else {
		.rectangle.weight(x, d)
	}
}

# Value checks for local / cell-based raster functions (man/*.Rd).

r <- rast(nrows = 9, ncols = 9, xmin = 0, xmax = 1, ymin = 0, ymax = 1, crs = "local")
values(r) <- 1:ncell(r)
v <- values(r)[, 1]

## clamp
cl <- clamp(r, lower = 10, upper = 50)
expect_equal(as.vector(values(cl)), pmin(pmax(v, 10), 50))

## subst
sb <- subst(r, from = c(1, 2), to = c(NA, NA))
vv <- v
vv[v %in% c(1, 2)] <- NA
expect_equal(as.vector(values(sb)), vv)

## init — cell index
ini <- init(r, fun = "cell")
expect_equal(as.vector(values(ini)), as.numeric(1:ncell(r)))

## segregate — three binary layers for r < 20
sg <- segregate(r < 20)
expect_equal(nlyr(sg), 2L)
expect_equal(sum(values(sg)[]), ncell(r))

## cover — first layer wins where not NA
r2 <- r * 2
cv <- cover(r, r2)
expect_equal(as.vector(values(cv)), v)

## roll — constant stack, rolling mean equals constant
r1 <- rast(nrows = 3, ncols = 3, crs = "local", vals = 1)
stk <- c(r1, r1, r1, r1, r1)
rl <- roll(stk, 3, "mean", circular = TRUE)
expect_true(max(abs(values(rl)[] - 1), na.rm = TRUE) < 1e-10)

## diff — second minus first layer
expect_equal(as.vector(values(diff(c(r, r * 2)))), v)

## modal — identical layers
md <- modal(c(r, r, r))
expect_equal(as.vector(values(md)), v)

## thresh — mean split vs manual classify
tr <- thresh(r, method = "mean", as.raster = TRUE)
mu <- unlist(global(r, "mean", na.rm = TRUE))[1]
br <- ifel(r > mu, 1, 0)
expect_equal(as.numeric(values(tr)), as.numeric(values(br)))

## scale_linear — [0, 1] range
scl <- scale_linear(r, min = 0, max = 1)
mn <- min(v)
mx <- max(v)
expect_equal(as.vector(values(scl)), (v - mn) / (mx - mn))

## focalMat — circle weights (d in map units relative to resolution)
fm <- focalMat(r, d = 3 * res(r)[1], type = "circle")
expect_equal(dim(fm), c(7L, 7L))
expect_true(sum(fm) > 0)

## which.lyr — first layer where condition is true
wly <- which.lyr(c(r > 0, r > 10000))
expect_true(all(as.vector(values(wly)) == 1, na.rm = TRUE))

## selectRange / extractRange
idx <- classify(r, rbind(c(-Inf, 40, 1), c(40, Inf, 2)))
sr <- selectRange(c(r, r * 2, r * 3), idx)
exp_sr <- ifelse(values(idx)[, 1] == 1, v, 2 * v)
expect_equal(as.vector(values(sr)), exp_sr)
xy <- data.frame(x = c(0.15, 0.5), y = c(0.15, 0.5))
stk <- c(r, r * 2, r * 3)
er <- extractRange(stk, xy, first = 1, last = 3)
ex <- extract(stk, xy)
expect_equal(as.numeric(unlist(er[[1]][1, ])), as.numeric(ex[1, -1]))

## selectHighest — five largest cells marked
sh <- selectHighest(r, n = 5)
expect_equal(sum(sh[] == 1, na.rm = TRUE), 5)

## classify — two-column lookup (from test_classify.R pattern)
set.seed(1)
rcin <- rast(nrows = 10, ncols = 10, vals = sample(1:5, 100, replace = TRUE))
rcl <- data.frame(from = 1:3, to = 11:13)
rco <- classify(rcin, rcl)
vi <- as.vector(values(rcin))
vo <- as.vector(values(rco))
expect_equal(vo[vi == 1], rep(11, sum(vi == 1)))
expect_equal(vo[vi == 2], rep(12, sum(vi == 2)))
expect_equal(vo[vi == 3], rep(13, sum(vi == 3)))
expect_equal(vo[vi > 3], vi[vi > 3])

## not.na / as.bool
expect_equal(sum(not.na(r)[]), ncell(r))
expect_equal(sum(as.bool(r > 40)[]), sum(v > 40))

## divide — total cell value mass conserved across zones
set.seed(0)
dv <- divide(r, n = 2, as.raster = TRUE)
zs <- zonal(r, dv, sum, na.rm = TRUE)
expect_equal(sum(zs[, 2]), sum(v))
expect_true(nrow(zs) >= 2)

## approximate — NA filled from neighbouring layers
ra <- rast(ncols = 3, nrows = 3, crs = "local", vals = 1:9)
rb <- ra * 1.1
ra[5] <- NA
ap <- approximate(c(ra, rb))
expect_false(is.na(values(ap)[5, 1]))

## sum across layers (per-cell)
rs <- app(c(r, r2), sum)
expect_equal(as.vector(values(rs)), v + 2 * v)

# Author: Robert J. Hijmans, r.hijmans@gmail.com
# Date : November 2022
# Version 1
# License GPL v3

graticule <- function(lon=30, lat=30, crs="") {

	if (crs == "") {
		crs <- "+proj=longlat"
	}
	
	if (length(lon) == 1) {
		lon <- seq(-180, 180, lon)
	} else {
		lon <- sort(lon)
	}
	
	if (length(lat) == 1) {
		lat <- seq(-90, 90, lat)
	} else {
		lat <- sort(lat)
	}

	interval <- 100 #should depend on extent
	
	y <- cbind(rep(1:length(lon), each=2), rep(lon, each=2), range(lat))
	vy <- vect(y, "lines", crs="+proj=longlat")
	vy <- densify(vy, interval*1000, TRUE)
	values(vy) <- data.frame(h=FALSE, lon=lon)

	rlon <- range(lon)
	rlon <- c(rlon[1], rlon[1] + (rlon[2]-rlon[1])/2, rlon[2])
	x <- cbind(rep(1:length(lat), each=3), rlon, rep(lat, each=3))
	vx <- vect(x, "lines", crs="local")
	vx <- densify(vx, interval/110, TRUE)
	values(vx) <- data.frame(h=TRUE, lat=lat)
	crs(vx, warn=FALSE) <- "+proj=longlat"
	
	v <- rbind(vy, vx)
	
	e <- as.polygons(ext(v), crs=crs(v))
	e <- densify(e, interval*1000, TRUE)
	
	if (!is.lonlat(crs, FALSE, FALSE)) {
		v <- project(v, crs)
		e <- project(e, crs)
	}

	g <- new("SpatGraticule")
	g@pntr <- v@pntr
	g@box <- e@pntr 
	g
}


#setMethod("project", signature(x="SpatGraticule"),
#	function(x, y) {
#		v <- vect(x)
#		v <- project(v, y)
#		x@pntr <- v@pntr
#		v@pntr <- x@box
#		v <- project(v, y)
#		x@box <- v@pntr
#		x
#	}
#)

setMethod("crop", signature(x="SpatGraticule"),
	function(x, y) {
		v <- vect(x)

		v <- crop(v, y)
		x@pntr <- v@pntr

		v@pntr <- x@box
		v <- crop(v, y)
		x@box <- v@pntr
		x
	}
)

setMethod("erase", signature(x="SpatGraticule", y="SpatVector"),
	function(x, y) {

		v <- vect(x)
		y <- project(y, v)

		v <- erase(v, y)
		x@pntr <- v@pntr

		v@pntr <- x@box
		v <- erase(v, y)
		x@box <- v@pntr
		x
	}
)


grat_tick <- function(x, direction, tick.length) {

	y <- crds(x)
	if (direction == "left") {
		y[,1] <- y[,1] - tick.length 
	} else if (direction == "right") {
		y[,1] <- y[,1] + tick.length 
	} else if (direction == "top") {
		y[,2] <- y[,2] + tick.length 
	} else {
		y[,2] <- y[,2] - tick.length 
	}
	lines(x, vect(y), xpd=TRUE)

}


grat_labels <- function(x, retro, atlon, atlat, labloc, cex, col, offlon, offlat, vfont=NULL, font=NULL, tickmarks=FALSE, ...) {

	v <- vect(x)
	if (tickmarks) {
		cw <- graphics::strwidth("A")
		offlat <- 2 * offlat
		offlon <- 2 * offlon
	}
	
	left <- right <- top <- bottom <- FALSE
	labloc <- rep_len(labloc, 2)
	if (!is.na(labloc[1])) {
		if (labloc[1] == 1) {
			bottom <- TRUE
		} else if (labloc[1] == 2) {
			top <- TRUE
		} else {
			bottom <- TRUE
			top <- TRUE	
		}
	}
	if (!is.na(labloc[2])) {
		if (labloc[2] == 1) {
			left <- TRUE
		} else if (labloc[2] == 2) {
			right <- TRUE
		} else {
			left <- TRUE
			right <- TRUE	
		}
	}
	if (left || right) {
		s <- sign(offlat)+2
		x <- v[v$h, ]
		g <- geom(x)
		if (retro) {
			labs <- retro_labels(x$lat, lat=TRUE)
		} else {
			labs <- paste0(x$lat,"\u00B0")		
		}	
		if (!is.null(atlat)) {
			atlat <- round(stats::na.omit(atlat))
			atlat <- atlat[(atlat > 0) & (atlat <= length(labs))] 
		}
		if (left) {
			a <- vect(g[match(unique(g[,1]), g[,1]), 3:4])
			a$labs <- labs
			if (!is.null(atlat)) {
				a <- a[atlat, ]
			}
			pos <- c(4,0,2)[s]
			if (pos == 0) pos <- NULL
			text(a, labels="labs", pos=pos, offset=abs(offlat), cex=cex, halo=TRUE, xpd=TRUE, col=col)
			if (tickmarks) {
				grat_tick(a, "left", cw * abs(offlat))
			}
		}
		if (right) {
			g <- g[nrow(g):1, ]
			a <- vect(g[match(unique(g[,1]), g[,1]), 3:4])
			a$labs <- rev(labs)
			if (!is.null(atlat)) {
				a <- a[atlat, ]
			}
			pos <- c(2,0,4)[s]			
			if (pos == 0) pos <- NULL
			text(a, labels="labs", pos=pos, offset=abs(offlat), cex=cex, halo=TRUE, xpd=TRUE, col=col)
			if (tickmarks) {
				grat_tick(a, "right", cw * abs(offlat))
			}
		}
	}
	if (top || bottom) {
		s <- sign(offlon)+2
		x <- v[!v$h, ]
		g <- geom(x)
		if (retro) {
			labs <- retro_labels(x$lon, lat=FALSE)
		} else {
			labs <- paste0(x$lon,"\u00B0")		
		}
		if (!is.null(atlon)) {
			atlon <- round(stats::na.omit(atlon))
			atlon <- atlon[(atlon > 0) & (atlon <= length(labs))] 
		}
		if (bottom) {
			a <- vect(g[match(unique(g[,1]), g[,1]), 3:4])
			a$labs <- labs
			if (!is.null(atlon)) {
				a <- a[atlon, ]
			}
			pos <- c(3,0,1)[s]
			if (pos == 0) pos <- NULL
			text(a, labels="labs", pos=pos, offset=abs(offlon), cex=cex, halo=TRUE, xpd=TRUE, col=col)
			if (tickmarks) {
				grat_tick(a, "bottom", cw * abs(offlon))
			}
		}
		if (top) {
			g <- g[nrow(g):1, ]
			a <- vect(g[match(unique(g[,1]), g[,1]), 3:4])
			a$labs <- rev(labs)
			if (!is.null(atlon)) {
				a <- a[atlon, ]
			}
			pos <- c(1,0,3)[s]
			if (pos == 0) pos <- NULL
			text(a, labels="labs", pos=pos, offset=abs(offlon), cex=cex, halo=TRUE, xpd=TRUE, col=col)
			if (tickmarks) {
				grat_tick(a, "top", cw * abs(offlon))
			}
		}
	}	
}	



setMethod("plot", signature(x="SpatGraticule", y="missing"),
	function(x, y, background=NULL, col="black", mar=NULL, labels=TRUE, retro=FALSE, lab.loc=c(1,1), lab.lon=NULL, lab.lat=NULL, lab.cex=.65, lab.col="black", off.lat=0.25, off.lon=0.25, box=FALSE, box.col="black", tickmarks=FALSE, add=FALSE, ...) {
		b <- vect()
		b@pntr <- x@box
		if (!is.null(mar)) mar <- rep_len(mar, 4)
		if (!is.null(background)) {
			plot(b, col=background, border=NA, axes=FALSE, mar=mar, add=add)
		} else {
			if (!add) {
				plot(ext(b), border=NA, axes=FALSE, mar=mar)
			}
		}
		lines(x, col=col, ...)
		if (box) {
			lwd <- list(...)$lwd
			if (is.null(lwd)) lwd=1;
			lines(b, lty=1, col=box.col, lwd=lwd)
		}
		if (labels) grat_labels(x, isTRUE(retro[1]), lab.lon, lab.lat, lab.loc, lab.cex[1], lab.col[1], off.lon, off.lat, tickmarks=tickmarks, ...)
	}
)


setMethod("lines", signature(x="SpatGraticule"),
	function(x, ...) {
		lines(vect(x), ...)
	}
)

transform <- function(xy, m) {
	newX = m[1] * xy[,1] + m[3] * xy[,2] + m[5]
	newY = m[2] * xy[,1] + m[4] * xy[,2] + m[6]
	cbind(newX, newY)
}

oneline <- function(x, id) {
	x <- trimws(gsub('^m', "", x))
	ss <- trimws(unlist(strsplit(x, "m ")))
	out <- list()
	for (j in 1:length(ss)) {
		v <- unlist(utils::read.table(text=ss[j], sep=" "))
		vv <- as.numeric(unlist(strsplit(v, ",")))
		vv <- matrix(vv, ncol=2, byrow=TRUE)
		if (j > 1) {
			vv[1,] <- vv[1,] + a[1,]
		}
		a <- apply(vv, 2, cumsum)
		out[[j]] <- a
	}
	out <- lapply(1:length(out), function(p) cbind(id=id, part=p, out[[p]], hole=0))
	out <- do.call(rbind, out)
	out[,4] <- -out[,4]
	#out[,3:4] <- transform(out[,3:4], m)
	out
}


oneline2 <- function(x, id) {
	x <- trimws(gsub('^M', "", x))
	ss <- trimws(unlist(strsplit(x, "ZM")))
	out <- list()
	for (j in 1:length(ss)) {
		v <- unlist(strsplit(ss[j], "L"))
		v <- unlist(strsplit(v, "C"))
		v <- unlist(strsplit(v, " "))
		v <- gsub("Z", "", v)
		vv <- as.numeric(unlist(strsplit(v, ",")))
		vv <- matrix(vv, ncol=2, byrow=TRUE)
		out[[j]] <- vv
	}
	out <- lapply(1:length(out), function(p) cbind(id=id, part=p, out[[p]], hole=0))
	do.call(rbind, out)
	#out[,3:4] <- transform(out[,3:4], m)
}

readSVG <- function(f) {
	doc <- XML::htmlParse(f)
	p <- XML::xpathSApply(doc, "//path", XML::xmlGetAttr, "d")
	s <- list()
	for (i in 1:length(p)) {
		s[[i]] <- oneline2(p[i], i)
	}
	ss <- do.call(rbind, s)
	v <- vect(ss, type="polygons")

	a <- XML::xpathSApply(doc, "//path", XML::xmlAttrs)
	a <- unique(unlist(sapply(a, names)))
	a <- a[-grep(":", a)]
	a <- a[a != "d"]
	if (length(a) > 0) {
		att <- list()
		for (i in 1:length(a)) {
			z <- XML::xpathSApply(doc, "//path", XML::xmlGetAttr, a[i])
			att[[i]] <- sapply(z, function(i) if (is.null(i)) NA else i, USE.NAMES = FALSE)
		}
		names(att) <- a
		values(v) <- data.frame(att)
	}
	v
}

setMethod ("has.colors" , "SpatRaster",
	function(x) {
		x@pntr$hasColors()
	}
)



setMethod ("coltab" , "SpatRaster",
	function(x) {
		hascols <- x@pntr$hasColors()
		if (any(hascols)) {
			d <- x@pntr$getColors()
			d <- lapply(d, .getSpatDF)
			d[!hascols] <- list(NULL)
		} else {
			d <- vector("list", length(hascols))
		}
		d
	}
)


setMethod ("coltab<-" , "SpatRaster",
	function(x, ..., layer=1, value) {
		
		x@pntr <- x@pntr$deepcopy()
		if (inherits(value, "list")) {
			for (i in seq_along(value)) {
				layer <- i-1
				if (is.null(value[[i]])) {
					x@pntr$removeColors(layer)
				}
				if (inherits(value[[i]], "character")) {
					value[[i]] <- data.frame(t(grDevices::col2rgb(value[[i]], alpha=TRUE)), stringsAsFactors=FALSE)
				} else if (inherits(value[[i]], "matrix")) {
					value[[i]] <- data.frame(value[[i]])
				}
				if (!inherits(value[[i]], "data.frame")) {
					error("coltab<-", "cannot process these color values")
				}
				if (ncol(value[[i]]) == 2) {
					value[[i]] <- data.frame(values=value[[i]][,1], t(grDevices::col2rgb(value[[i]][,2], alpha=TRUE)), stringsAsFactors=FALSE)
				} 
				value[[i]][, 1] <- as.integer(value[[i]][, 1])
				for (j in 2:ncol(value[[i]])) {
					value[[i]][, j] <- as.integer(clamp(value[[i]][, j], 0, 255))
				}
				value[[i]][is.na(value[[i]])] <- 255

				d <- .makeSpatDF(value[[i]])
				if (!x@pntr$setColors(layer, d)) {
					messages(x, "cols<-")
				}
			}
		} else {
			if (inherits(layer, "character")) {
				layer <- match(layer, names(x))
				if (is.na(layer)) {
					error("coltab", "not a valid layer name")
				}
			}
			layer <- layer[1]-1
			if (is.null(value)) {
				x@pntr$removeColors(layer)
				return(x)
			}

			if (inherits(value, "character")) {
				value <- data.frame(t(grDevices::col2rgb(value, alpha=TRUE)), stringsAsFactors=FALSE)
			} else if (inherits(value, "matrix")) {
				value <- data.frame(value)
			}
			if (!inherits(value, "data.frame")) {
				error("coltab<-", "cannot process these color values")
			}
			if (ncol(value) == 2) {
				value <- data.frame(values=value[,1], t(grDevices::col2rgb(value[,2], alpha=TRUE)), stringsAsFactors=FALSE)
			} #else {
			#	nms <- tolower(names(value))
			#	if (!(grepl("value", nms))) {
			#		value <- cbind(values=(1:nrow(value))-1, value)
			#	}
			#	#value <- value[1:256,]
			#	if (ncol(value) == 4) {
			#		value <- cbind(value, alpha=255)
			#	}
			#}
			value[, 1] <- as.integer(value[, 1])
			for (i in 2:ncol(value)) {
				value[, i] <- as.integer(clamp(value[, i], 0, 255))
			}
			value[is.na(value)] <- 255
			d <- .makeSpatDF(value)
			if (!x@pntr$setColors(layer, d)) {
				messages(x, "cols<-")
			}
		}
		x
	}
)




make.RGB <- function(x, col=grDevices::rainbow(25), breaks=NULL, alpha=FALSE, colNA="white", zlim=NULL, zlimcol=NULL, ext=NULL, filename="", ...) { 

	getCols <- function(x, col, breaks=NULL, r=NULL, colNA=NA) {
		if (!is.null(breaks)) {
			breaks <- sort(breaks)
			x <- as.numeric(cut(x, breaks, include.lowest=TRUE))
			
		} else {
			x <- (x - r[1])/ (r[2] - r[1])
			x <- round(x * (length(col)-1) + 1)
		}
		x <- col[x]
		if (!is.na(colNA)) {
			x[is.na(x)] <- grDevices::rgb(t(grDevices::col2rgb(colNA)), maxColorValue=255)
		}
		x
	}

	if (!is.null(ext)) {
		x <- crop(x, ext)
	}
	
	if (alpha) {
		out <- rast(x, nl=4)
		RGB(out) <- 1:4
	} else {
		out <- rast(x, nl=3)
		RGB(out) <- 1:3
	}
	names(out) <- c('red', 'green', 'blue', 'alpha')[1:nlyr(out)]

	
	r <- minmax(x, TRUE)[,1]
	if (is.null(breaks)) {
		zrange <- range(r, zlim, na.rm=TRUE)
	} else {
		zrange <- range(r, zlim, breaks, na.rm=TRUE)
	}
	if (zrange[1] == zrange[2]) {
		zrange[1] <- zrange[1] - 0.001
		zrange[2] <- zrange[2] + 0.001
	}

	tr <- writeStart(out, filename=filename, ...)
		
	for (i in 1:tr$n) {
		v <- values(x, row=tr$row[i], nrows=tr$nrows[i])
		
		if (!is.null(zlim)) {
			if (!is.null(zlimcol)) {
				v[v < zlim[1]] <- zlim[1]
				v[v > zlim[2]] <- zlim[2]
			} else { #if (is.na(zlimcol)) {
				v[v < zlim[1] | v > zlim[2]] <- NA
			} 
		}
		v <- getCols(v, col, breaks, zrange, colNA)
		v <- grDevices::col2rgb(as.vector(v), alpha=alpha)
		writeValues(out, t(v), tr$row[i], tr$nrows[i])
	}
	writeStop(out)
}

# Author: Robert J. Hijmans
# Date :  July 2019
# Version 1.0
# License GPL v3

setMethod("lines", signature(x="SpatExtent"),
	function(x, col="black", alpha=1, ...)  {
		e <- as.vector(x)
		p <- rbind(c(e[1],e[3]), c(e[1],e[4]), c(e[2],e[4]), c(e[2],e[3]), c(e[1],e[3]))
		col <- .getCols(1, col, alpha)
		graphics::lines(p, col=col, ...)
	}
)

setMethod("polys", signature(x="SpatExtent"),
	function(x, col="black", alpha=1, ...)  {
		polys(as.polygons(x), col=col, alpha=alpha, ...)
	}
)

setMethod("plot", signature(x="SpatExtent", y="missing"),
	function(x, ...)  {
		if (!is.valid(x)) {
			error("plot", "invalid SpatExtent")
		}
		plot(as.polygons(x), ...)
	}
)

setMethod("points", signature(x="SpatExtent"),
	function(x, col="black", alpha=1, ...)  {
		e <- as.vector(x)
		p <- rbind(c(e[1],e[3]), c(e[1],e[4]), c(e[2],e[4]), c(e[2],e[3]), c(e[1],e[3]))
		col <- .getCols(4, col, alpha)
		graphics::points(p, col=col, ...)
	}
)

# Author: Emanuele Cordano
# Date : October 2023
# Version 1.0
# License GPL v3

setMethod("watershed", signature(x="SpatRaster"), 
    function(x, pourpoint, filename="", ...) { 
        opt <- spatOptions(filename, ...)		
		cell <- cellFromXY(x, pourpoint)
		if (is.na(cell)) error("watershed", "pourpoint not on raster")
        x@pntr <- x@pntr$watershed2(as.integer(cell-1), opt)
        messages(x, "watershed") ## EC 20210318
    }
)

setMethod("pitfinder", signature(x="SpatRaster"), 
    function(x,pits_on_boundary=TRUE,filename="", ...) { 
        opt <- spatOptions(filename, ...)
        x@pntr <- x@pntr$pitfinder2(as.integer(pits_on_boundary),opt)

        messages(x, "pitfinder") ## EC 20210318
    }
)

setMethod("NIDP", signature(x="SpatRaster"), 
    function(x, filename="", ...) { 
        opt <- spatOptions(filename, ...)
        x@pntr <- x@pntr$NIDP2(opt)
        messages(x, "NIDP") ## EC 20231031
    }
)

setMethod("flowAccumulation", signature(x="SpatRaster"), 
    function(x, weight=NULL, filename="", ...) { 
		opt <- spatOptions(filename, ...)
		if (is.null(weight)) {      
			x@pntr <- x@pntr$flowAccu2(opt)
	    } else {
			x@pntr <- x@pntr$flowAccu2_weight(weight@pntr, opt)
		} 
		messages(x, "flowAccumulation") 
    }      
)

setMethod("flowDir", signature(x="SpatRaster"), 
	function(x, lambda=0.5, deviation_type=c("ltd","lad"), max_iters=10^6, filename="", ...) { 
		## http://www.idrologia.unimore.it/orlandini/web-archive/seminars/nyc-2008-2.pdf
		## ltd least transverse deviation
		## lad least angular deviation
		deviation_type <- match.arg(tolower(deviation_type), c("ltd", "lad"))	
		use_lad <- deviation_type=="lad"
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$d8ltd(lambda, use_lad, max_iters, opt)
		names(x) <- sprintf("flowdir_%s_l=%s", deviation_type[1], as.character(lambda))
		messages(x, "flowDir") ## EC 20210318
	}
)


setMethod("pitfiller", signature(x="SpatRaster"), 
	function(x, pit, flowdir=NULL, niter=10, lambda=0, deviation_type="lad", max_iters=10^6, U=1, D=300, beta=0.9, theta_exp=0.5,filename="",...) { 
		deviation_type <- match.arg(tolower(deviation_type), c("ltd", "lad")) 
		use_lad = deviation_type == "lad"
		if (is.character(flowdir)) flowdir <- rast(flowdir)
		if (is.null(flowdir)) {
		  flowdir <- flowDir(x,deviation_type=deviation_type,lambda=lambda,max_iters=max_iters)
		}
		flowdir <- mask(flowdir, pit>0, maskvalue=TRUE) 
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$pitfillerm(pit@pntr, flowdir@pntr, niter, lambda, use_lad, max_iters, U, D, beta, theta_exp, opt)
		messages(x, "pitfiller") ## EC 20210318
	}
)

# Author: Robert J. Hijmans
# Date : December 2011
# Version 1.0
# License GPL v3



setMethod("sel", signature(x="SpatRaster"),
	function(x, ...) {
		e <- draw(...)
		int <- intersect(e, ext(x))
		if (is.null(int)) {
			x <- NULL
		} else {
			x <- crop(x, e)
		}
		x
	}
)


setMethod("sel", signature(x="SpatVector"),
	function(x, use="rec", show=TRUE, col="cyan", draw=TRUE, ...) {
		use <- substr(tolower(use), 1, 3)
		use <- match.arg(use, c("rec", "pol"))
		scol <- ifelse(draw, "red", NA)
		if (use == "rec") {
			e <- draw(col=scol)
		#	e <- as.polygons(e)
		} else {
			e <- draw("pol", col=scol)
		}
		i <- is.related(x, e, "intersects")
		x <- x[i, ]
		if (show) {
			if (geomtype(x) == "points" || geomtype(x) == "multipoints") {
				points(x, col=col, ...)
			} else {
				lines(x, col=col, ...)
			}
		}
		x
	}
)

# Author: Robert J. Hijmans
# Date :  June 2017
# Version 1.0
# License GPL v3


## all deprecated (old versions)

get_basename <- function(x, n=150) {
	x <- basename(x)
	large <- nchar(x) > n
	x[large] <- paste0(substr(x[large], 1, n), "~")
	x
}



.show_ext <- function(object) {
	e <- as.vector(object)
	e <- paste(e, collapse=", ")
	cat("SpatExtent :", e, "(xmin, xmax, ymin, ymax)\n")
}


.show_vectcol <- function(object) {
	cat(" class       :", class(object), "\n")
	cat(" length      :", length(object), "\n")
	n <- nn <- length(object)
	if (n > 15) {
		nn <- 15
	}
	if (n > 0) {
		for (i in 1:nn) {
			v <- object[i]
			if (i==1) {
				cat(" geometry    : ", geomtype(v), " (", nrow(v) , ")\n", sep="")
			} else {
				cat("               ", geomtype(v), " (", nrow(v) , ")\n", sep="")
			}
		}
		if (n > nn) {
			cat("               ", "   and ", n-nn, "more\n", sep="")
		}
		crs <- .name_or_proj4(object[1])
		if (crs != "") cat(" crs (first) :", crs,	 "\n")
		nms <- names(object)
		if (length(nms) > 10) {
			nms <- c(nms[1:9], "...")
		}
		nms <- paste(nms, collapse=", ")
		cat(" names       :", nms, "\n")
	}
}



.show_vect <- function(object) {
	e <- as.vector(ext(object))
	d <- dim(object)
	cat(" class       :", class(object), "\n")
	cat(" geometry    :", geomtype(object), "\n")
	cat(" dimensions  : ", d[1], ", ", d[2], "  (geometries, attributes)\n", sep="" )
	cat(" extent      : ", e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
	if (object@pntr$source != "") {
		if (object@pntr$layer != tools::file_path_sans_ext(get_basename(object@pntr$source))) {
			cat(" source      : ", get_basename(object@pntr$source), " (", object@pntr$layer, ")\n", sep="")
		} else {
			cat(" source      : ", get_basename(object@pntr$source), "\n", sep="")
		}
	}
	cat(" coord. ref. :", .name_or_proj4(object), "\n")
	if (d[2] > 0) {
		nr <- min(d[1], 3)
		dd <- as.data.frame(object)[1:nr, , drop=FALSE]
		printDF(dd, 3, TRUE)
	}
}




.show_vectproxy <- function(object) {
	e <- as.vector(ext(object))
	d <- dim(object)
	cat(" class       : SpatVectorProxy\n")
	cat(" geometry    :", geomtype(object), "\n")
	cat(" dimensions  : ", d[1], ", ", d[2], "  (geometries, attributes)\n", sep="" )
	cat(" extent      : ", e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
	if (object@pntr$v$layer != tools::file_path_sans_ext(get_basename(object@pntr$v$source))) {
		cat(" source      : ", get_basename(object@pntr$v$source), " (", object@pntr$v$layer, ")\n", sep="")
	} else {
		cat(" source      : ", get_basename(object@pntr$v$source), "\n", sep="")
	}
	cat(" coord. ref. :", .name_or_proj4(object), "\n")
	dd <- get.data.frame(object)
	printDF(dd, 0, TRUE)
}




.show_rast <- function(object) {
	cat("class       :" , class(object), "\n")

	d <- dim(object)
	cat("size        : ", d[1], ", ", d[2], ", ", d[3], "  (nrow, ncol, nlyr)\n", sep="" )
	#cat ("ncell       :" , ncell(object), "\n")

	nsr <- nsrc(object)
	if ((nsr == 1) && (object@pntr$is_multidim)) {
		dnms <- paste(rev(object@pntr$dim_names()[[1]]), collapse=", ")
		dsz <- paste(rev(object@pntr$dim_size()[[1]]), collapse=", ")
		cat("dimensions  : ", dnms, " (", dsz, "}\n", sep="" )
	}

	xyres <- res(object)
	cat("resolution  : " , xyres[1], ", ", xyres[2], "  (x, y)\n", sep="")
	hw <- window(object)
	if (any(hw)) {
		w <- as.vector(ext(object))
		if (all(hw)) {
			txt <- "window      : "
		} else {
			txt <- "extent (win): "
		}
		cat(txt, w[1], ", ", w[2], ", ", w[3], ", ", w[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
		#e <- as.vector(object@pntr$source[[1]]$window$full_extent$vector)
		#cat("full extent : " , e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
	} else {
		e <- as.vector(ext(object))
		cat("extent      : " , e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
	}


	cat("coord. ref. :" , .name_or_proj4(object), "\n")


	if (hasValues(object)) {

		mnr <- 6
		ln <- names(object)
		nl <- d[3]

		if (nl > mnr) {
			ln <- c(ln[1:mnr], "...")
		}
		lnmx <- 60 / min(mnr, length(ln))
		b <- nchar(ln) > (lnmx+2)
		if (isTRUE(any(b))) {
			mid <- floor(lnmx/2)
			ln[b] <- paste(substr(ln[b], 1, mid), "~", substr(ln[b], nchar(ln[b])-mid+1, nchar(ln[b])), sep="")
		}

		m <- inMemory(object)

		f <- sources(object)
		nf <- nchar(f)
		if (any(nf > 256)) {
			for (i in 1:length(nf)) {
				if (nf[i] > 256) {
					f[i] <- unlist(strsplit(f[i], "\\?"))[1]
					if (nchar(f[i]) > 256) {
						f[i] <- substr(f[i], nf[i]-255, nf[i])
					}
				}
			}
		}
		hdf5 <- substr(f, 1, 5) == "HDF5:"
		f[!hdf5] <- get_basename(f[!hdf5])
		if (any(hdf5)) {
			ff <- strsplit(f[hdf5], "://")
			ff <- sapply(ff, function(i) paste(get_basename(i), collapse="://"))
			ff <- gsub('\"', "", ff)
			f[hdf5] <- ff
		}
		#f <- gsub("\\", "/", f, fixed=TRUE)
		f <- gsub("\"", "", f)
		sources <- rep("memory", length(m))
		sources[!m] <- f[!m]

		if (all(m)) {
			cat("source(s)   : memory\n")
		} else {
			if (nsr > 1) {
				mxsrc <- 3
				lbs <- .nlyrBySource(object)
				lbsprint <- paste0(" (", lbs, " layers)")
				lbsprint[lbs == 1] <- ""
				cat("sources     :", sources[1], lbsprint[1], "\n")
				for (i in 2:(min(mxsrc, nsr))) {
					cat("             ", sources[i], lbsprint[i], "\n")
				}
				if (nsr > mxsrc) {
					if (nsr == (mxsrc+1)) {
						cat("             ", sources[mxsrc+1], lbsprint[mxsrc+1], "\n")
					} else {
						cat("             ", "... and", nsr-mxsrc, "more sources\n")
					}
				}
			} else {
				cat("source      :", sources[1], "\n")
			}
		}
		rgbtype <- object@pntr$rgbtype
		if (rgbtype != "") {
			rdgb <- RGB(object)
			if (is.null(rdgb)) rdgb <- 1:3
			cat(paste("colors", toupper(object@pntr$rgbtype), " :"), paste(rdgb, collapse=", "), "\n")
		}
		hasct <- object@pntr$hasColors()
		if (any(hasct)) {
			cat("color table :", paste(which(hasct), collapse=", "), "\n")
		}


		varnms <- varnames(object)
		fnms <- tools::file_path_sans_ext(f)
		if (any(fnms != varnms) && all(varnms != "")) {
			longnms <- longnames(object)
			i <- longnms != ""
			if (any(i)) {
				varnms[i] <- paste0(varnms[i], " (", longnms[i], ")")
			}
			if (nsr == 1) {
				cat("varname     :", varnms[1], "\n")
			} else {
				cat("varnames    :", varnms[1], "\n")
				for (i in 2:(min(nsr, 3))) {
					cat("             ", varnms[i], "\n")
				}
			}
			if (nsr > 3) {
				cat("              ...\n")
			}
		}
		uts <- units(object)
		utsu <- unique(uts)
		if (all(utsu == "")) {
			uts <- utsu			
			hasunits <- FALSE
		} else {
			hasunits <- TRUE
			if (length(utsu) > 1) {
				if (nl > mnr) {
					uts <- c(uts[1:mnr], "...")
				} 
			} else {
				uts <- utsu
			}
		}

		hMM <- hasMinMax(object)
		isB <- is.bool(object)
		if (any(hMM) || any(is.factor(object))) {
			#r <- minmax(object)
			rr <- r <- rbind(object@pntr$range_min, object@pntr$range_max)
			r[,!hMM] <- c(Inf, -Inf)
			#sc <- scoff(object)
			#r <- r * sc[,1] + sc[,2]
			r <- sapply(data.frame(r), format)
			minv <- r[1,]
			maxv <- r[2,]
			if (any(isB)) {
				minv[isB] <- ifelse(minv[isB]=="0", "FALSE", "TRUE")
				maxv[isB] <- ifelse(maxv[isB]=="0", "FALSE", "TRUE")
			}
			minv <- gsub("Inf", " ? ", minv)
			maxv <- gsub("-Inf", "  ? ", maxv)
			minv[!hMM] <- gsub("NaN", " ? ", minv[!hMM])
			maxv[!hMM] <- gsub("NaN", " ? ", maxv[!hMM])
			minv[hw] <- paste0(">", minv[hw])
			maxv[hw] <- paste0(maxv[hw],"<")
			if (nl > mnr) {
				minv <- c(minv[1:mnr], "...")
				maxv <- c(maxv[1:mnr], "...")
			}
			isf <- is.factor(object)
			if (any(isf)) {
				cats <- levels(object)
				for (i in which(isf)) {
					if (i > mnr) break
					levs <- cats[[i]]
					if (any(is.na(rr[,i]))) next
					j <- match(rr[,i], levs[,1])
					levs <- levs[j, 2]
					if (length(levs) > 1) {
						if (nchar(levs[1]) > 40) {
							minv[i] <- paste0(substr(levs[1], 1, 39), "~")
						} else {
							minv[i] <- levs[1]							
						}
						if (nchar(levs[2]) > 40) {
							maxv[i] <- paste0(substr(levs[2], 1, 39), "~")						
						} else {
							maxv[i] <- levs[2]
						}
					}
				}
			}
			u8 <- Encoding(ln) == "UTF-8"
			wln <- nchar(ln)

			if (isTRUE((length(uts) == 1) && (nl > 1))) {
				nu <- 1
			} else {
				nu <- nchar(uts)
			}

			if (any(u8)) {
				# for Chinese: wln <- wln + u8 * wln
				w <- pmax(wln, nchar(minv), nchar(maxv), nu, na.rm = TRUE)
				m <- rbind(paste0(rep(" ", max(wln)), collapse=""), minv, maxv)
				if (hasunits) m <- rbind(m, uts)
				# a loop because "width" is not recycled by format
				for (i in 1:ncol(m)) {
					m[,i] <- format(m[,i], width=w[i], justify="right")
					addsp <- w[i] - nchar(ln[i])
					m[1,i] <- paste0(paste0(rep(" ", addsp), collapse=""), ln[i])
				}
			} else {
				w <- pmax(wln, nchar(minv), nchar(maxv), nu, na.rm = TRUE)
				m <- rbind(ln, minv, maxv)
				if (hasunits) m <- rbind(m, uts)
				# a loop because "width" is not recycled by format
				for (i in 1:ncol(m)) {
					m[,i] <- format(m[,i], width=w[i], justify="right")
				}
			}
			if (ncol(m) == 1) {
				if (is.factor(object)) {
					if (activeCat(object) > -1) {
						g <- cats(object)[[1]]
						cat("categories  :", paste(colnames(g)[-1], collapse=", "), "\n")
					}
				}
				cat("name        :", paste(m[1,], collapse=", "), "\n")
				cat("min value   :", paste(m[2,], collapse=", "), "\n")
				cat("max value   :", paste(m[3,], collapse=", "), "\n")
			} else {
				cat("names       :", paste(m[1,], collapse=", "), "\n")
				cat("min values  :", paste(m[2,], collapse=", "), "\n")
				cat("max values  :", paste(m[3,], collapse=", "), "\n")
			}
			if (hasunits) {
				if ((length(uts) == 1) && (ncol(m) > 1)) {
					cat("unit        :", uts, "\n")					
				} else {
					cat("unit        :", paste(m[4,], collapse=", "), "\n")
				}
			}
		} else {
			if (isTRUE((length(uts) == 1) && (nl > 1))) {
				nu <- 1
			} else {
				nu <- nchar(uts)
			}
			w <- pmax(nchar(ln), nu)
			m <- rbind(ln, uts)
			for (i in 1:ncol(m)) {
				m[,i]   <- format(m[,i], width=w[i], justify="right")
			}
			if (ncol(m) == 1) {
				cat("name        :", paste(m[1,], collapse=", "), "\n")
			} else {
				cat("names       :", paste(m[1,], collapse=", "), "\n")
			}
			if (hasunits) {
				if ((length(uts) == 1) && (ncol(m) > 1)) {
					cat("unit        :", uts, "\n")					
				} else {
					cat("unit        :", paste(m[2,], collapse=", "), "\n")
				}
			}
		}

	}
	if (object@pntr$hasDepth) {
		dname <- depthName(object)
		dunit <- depthUnit(object)
		if (dname == "depth") {
			if (dunit == "") {
				dname <- ""
			} else {
				dname <- paste0("[", dunit, "]: ") 
			}
		} else {
			if ((dunit == "") || (dunit == "unknown")) {
				dname <- paste0(dname, ": ")
			} else {
				dname <- paste0(dname, " [", dunit, "]: ")
			}
		}
		
		label <- "depth       : "
		dpth <- unique(depth(object))
		if (length(dpth) > 1) {
			rd <- range(dpth)
			dpth <- paste0(label, paste(rd, collapse=" to "), " (", dname, length(dpth), " steps)")
		} else {
			dpth <- paste0(label, dpth)			
		}
		cat(dpth, "\n")		
	}

	if (object@pntr$hasTime) {
		label <- "time        "
		tms <- time(object)
		rtim <- range(tms, na.rm=TRUE)
		tims <- object@pntr$timestep
		if (tims == "yearmonths") {
			rtim <- format_ym(rtim)
			label <- "time (ymnts)"
		} else if (tims == "months") {
			rtim <- month.abb[rtim]
			label <- "time (mnts) "
		} else if (tims == "years") {
			label <- "time (years)"
		} else if (tims == "days") {
			label <- "time (days) "
		} else if (tims == "raw") {
			label <- "time (raw)  "
		}
		utim <- unique(rtim)
		add_steps <- FALSE
		if (length(utim) > 1) {
			ptim <- paste0(label, ": ", paste(rtim, collapse=" to "))
			add_steps <- TRUE
		} else {
			ptim <- paste0(label, ": ", as.character(utim))
		}
		if (tims == "seconds") {
			tz <- format(utim[1], format="%Z")
			ptim <- paste(ptim, tz)
		}
		if (add_steps) {
			ptim <- paste0(ptim, " (", length(unique(tms[!is.na(tms)])), " steps)")
		}
		cat(ptim, "\n")
	}

	# else {
	#	cat("data sources:", "no data\n")
	#	cat("names       :", paste(ln, collapse=", "), "\n")
	# }
}


.show_sds <- function(object) {


	.sources <- function(x) {
		#m <- inMemory(x)
		f <- sources(x)
		f <- gsub("\"", "", get_basename(f))
		i <- grep(":", f)
		if (length(i) > 0) {
			for (j in i) {
				ff <- try(get_basename( strsplit(f[j], ':')[[1]][1]), silent=TRUE)
				if (!inherits(ff, "try-error")) {
					f[j] <- ff
				}
			}
		}
		f[f==""] <- "memory"
		unique(f)
	}



	cat("class       :" , class(object), "\n")
	ns <- length(object)
	cat("subdatasets :", ns, "\n")
	if (ns == 0) return()

	d <- dim(object)
	cat("dimensions  :", paste(d, collapse=", "), "(nrow, ncol)\n")
	nss <- nlyr(object)
	if (length(nss) > 10) {
		nss = c(as.character(nss[1:9], "..."))
	}
	cat("nlyr        :", paste(nss, collapse=", "), "\n")

	xyres <- res(object)
	cat("resolution  : " , xyres[1], ", ", xyres[2], "  (x, y)\n", sep="")
	e <- as.vector(ext(object))
	cat("extent      : " , e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")

	cat("coord. ref. :" , .name_or_proj4(object), "\n")

	s <- .sources(object)
	if (length(s) > 6) {
		s <- c(s[1:6], "...")
	}
	cat("source(s)   :", paste(s, collapse=", "), "\n")

	ln <- names(object)
	if (any(ln != "")) {
		if (length(ln) > 6) {
			ln <- c(ln[1:6], "...")		
		}
		cat("names       :", paste(ln, collapse=", "), "\n")
	}
}




.show_sprc <- function(object) {
	cat("class       :" , class(object), "\n")
	nr <- length(object)
	cat("length      :", nr, "\n")
	d <- (t(dim(object)))
	d[] <- as.character(d)
	if (ncol(d) > 14) {
		d <- d[,1:15]
		d[,15] <- "..."
	}
	for (i in 1:ncol(d)) {
		d[,i] <- format(d[,i], width=max(nchar(d[,i])), justify="right")
	}
	cat("nrow        :", paste(d[1,], collapse=", "), "\n")
	cat("ncol        :", paste(d[2,], collapse=", "), "\n")
	cat("nlyr        :", paste(d[3,], collapse=", "), "\n")
	
	e <- as.vector(ext(object))
	cat("extent      : " , e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
	
	
	crs <- .name_or_proj4(object@pntr$x[[1]])
	if (crs != "") cat("crs (first) :", crs,	 "\n")
	ln <- names(object)
	if (any(ln != "")) {
		if (length(ln) > 6) {
			ln = c(ln[1:6], "...")		
		}
		cat("names       :", paste(ln, collapse=", "), "\n")
	}
}

# Author: Robert J. Hijmans
# Date :  September 2018
# Version 1.0
# License GPL v3

#to do
#"gamma", "lgamma", "digamma", "trigamma")

setMethod("log", signature(x="SpatRaster"),
    function(x, base=exp(1)){
		opt <- spatOptions()
		if (base == exp(1)) {
			x@pntr <- x@pntr$math("log", opt)
		} else if (base == 2) {
			x@pntr <- x@pntr$math("log2", opt)
		} else if (base == 10) {
			x@pntr <- x@pntr$math("log10", opt)
		} else {
			x <- app(x, function(i) log(i, base))
		}
		x
	}
)


#? "gamma", "lgamma", "digamma", "trigamma"
setMethod("Math", signature(x="SpatRaster"),
    function(x){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		if (substr(oper, 1, 3) == "cum") {
			x@pntr <- x@pntr$cum(substr(oper, 4, 10), FALSE, opt)
		} else if (oper %in% c("acos", "acosh", "asin", "asinh", "atan", "atanh", "cos", "cosh", "cospi", "sin", "sinh", "sinpi", "tan", "tanh", "tanpi")) {
			x@pntr <- x@pntr$trig(oper, opt)
		} else {
			x@pntr <- x@pntr$math(oper, opt)
		}
		messages(x, oper)
	}
)



setMethod("math", signature(x="SpatRaster"),
    function(x, fun, digits=0, filename="", overwrite=FALSE, ...){
		if (!is.character(fun)) {
			error("math", "fun must be a character value")
		}
		fun = fun[1]
		opt <- spatOptions(filename, overwrite, ...)
		if (substr(fun, 1, 3) == "cum") {
			x@pntr <- x@pntr$cum(substr(fun, 4, 10), FALSE, "", FALSE)
		} else if (fun %in% c("acos", "acosh", "asin", "asinh", "atan", "atanh", "cos", "cosh", "cospi", "sin", "sinh", "sinpi", "tan", "tanh", "tanpi")) {
			x@pntr <- x@pntr$trig(fun, opt)
		} else if (fun %in% c("abs", "sign", "sqrt", "ceiling", "floor", "trunc", "log", "log10", "log2")) {		x@pntr <- x@pntr$math(fun, opt)
		} else if (fun %in% c("round", "signif")) {
			x@pntr <- x@pntr$math2(fun, digits, opt)
		} else {
			error("math", "unknown function")
		}
		messages(x, fun)
	}
)



setMethod("Math2", signature(x="SpatRaster"),
    function(x, digits=0){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		x@pntr <- x@pntr$math2(oper, digits, opt)
		messages(x, oper)
	}
)


setMethod("Math", signature(x="SpatExtent"),
    function(x){
		oper <- as.vector(.Generic)[1]
		if (oper == "floor") {
			x@pntr <- x@pntr$floor()
		} else if (oper == "ceiling") {
			x@pntr <- x@pntr$ceil()
		} else {
			error(oper, "not implemented for SpatExtent")
		}
		if (!is.valid(x)) {
			error(oper, "invalid extent")
		}
		return(x)
	}
)

setMethod("Math2", signature(x="SpatExtent"),
    function(x, digits=0){
		oper <- as.vector(.Generic)[1]
		if (oper == "round") {
			x@pntr <- x@pntr$round(digits)
			if (!is.valid(x)) {
				error(oper, "invalid extent")
			}
			return(x)
		} else {
			error(oper, "not implemented for SpatExtent")
		}
	}
)

setMethod("Math2", signature(x="SpatVector"),
    function(x, digits=4){
		oper <- as.vector(.Generic)[1]
		if (oper == "round") {
			x@pntr <- x@pntr$round(digits)
			return(x)
		} else {
			error(oper, "not implemented for SpatVector")
		}
	}
)

# Author: Robert J. Hijmans
# Date : April 2023
# Version 1.0
# License GPL v3



.reg_constX <- function(formula, X, na.rm=FALSE, nl) {
	formula <- eval(stats::as.formula(formula))
	nas <- eval(rep(NA, nl))
	d <- data.frame(x=X, y=X)
	mm <- eval(stats::model.matrix(formula, data=d))
	if (na.rm) {
		ols <- function(y, ...) {
			m <- stats::na.omit(cbind(y, mm))
			if (nrow(m) == 0) {
				return(nas)
			}
			stats::.lm.fit(m[,-1,drop=FALSE], m[,1])$coefficients
		}
	} else {
		ols <- function(y, ...) {
			if (any(is.na(y))) {
				return(nas)
			}
			stats::.lm.fit(mm, y)$coefficients
		}
	}
	ols
}



setMethod("regress", signature(y="SpatRaster", x="numeric"),
function(y, x, formula=y~x, na.rm=FALSE, cores=1, filename="", overwrite=FALSE, ...) {

	if (any(is.na(x))) {
		error("regress", "y cannot have NAs")
	}
	formula <- stats::as.formula(formula)
	dat <- data.frame(x=x, y=1)
	mm <- stats::model.matrix(formula, data=dat)
	outnl <- ncol(mm)		
	regfun <- .reg_constX(formula, X=x, na.rm=na.rm, nl=outnl)
	
	out <- rast(y)
	nlyr(out) <- outnl
	names(out) <- colnames(mm)
	nc <- ncol(y)
	readStart(y)
	on.exit(readStop(y))

	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	}

	ncops <- nlyr(y) / nlyr(out)
	ncops <- ifelse(ncops > 1, ceiling(ncops), 1) * 4
	b <- writeStart(out, filename, overwrite, n=ncops, sources=sources(y), ...)

	if (doclust) {
		ncores <- length(cores)
		#export_args(cores, ...)
		for (i in 1:b$n) {
			v <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
			icsz <- max(min(100, ceiling(b$nrows[i] / ncores)), b$nrows[i])
			r <- parallel::parRapply(cores, v, regfun, chunk.size=icsz)
			if (nlyr(out) > 1) {
				r <- matrix(r, ncol=nlyr(out), byrow=TRUE)
			}
			writeValues(out, r, b$row[i], b$nrows[i])
		}
	} else {
		for (i in 1:b$n) {
			v <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
			r <- apply(v, 1, regfun)
			writeValues(out, t(r), b$row[i], b$nrows[i])
		}
	}
	writeStop(out)
})



.reg_mod <- function(formula, na.rm=FALSE, nl) {
	formula <- eval(stats::as.formula(formula))
	nas <- eval(rep(NA, nl))
	yi <- eval(1:nl)
	xi <- eval((nl+1):(nl+nl))
	if (na.rm) {
		ols <- function(v, ...) {
			d  <- data.frame(matrix(v, ncol=2, dimnames=list(NULL, c("y", "x"))))
			mm <- eval(stats::model.matrix(formula, data=d))
			m  <- stats::na.omit(cbind(d$y, mm))
			if (nrow(m) == 0) {
				return(nas)
			}
			stats::.lm.fit(m[,-1,drop=FALSE], m[,1])$coefficients
		}
	} else {
		ols <- function(v, ...) {
			if (any(is.na(v))) {
				return(nas)
			}
			d  <- data.frame(matrix(v, ncol=2, dimnames=list(NULL, c("y", "x"))))
			mm <- eval(stats::model.matrix(formula, data=d))
			stats::.lm.fit(mm, d$y)$coefficients
		}
	}
	ols
}


setMethod("regress", signature(x="SpatRaster", y="SpatRaster"),
function(y, x, formula=y~x, na.rm=FALSE, cores=1, filename="", overwrite=FALSE, ...) {

	if (nlyr(y) != nlyr(x)) {
		error("regress", "nlyr(x) != nlyr(y)")
	}
	formula <- stats::as.formula(formula)
	dat <- data.frame(x=1:nlyr(x), y=1)
	mm <- stats::model.matrix(formula, data=dat)
	outnl <- ncol(mm)		
	
	regfun <- .reg_mod(formula, na.rm=na.rm, nl=outnl)
	
	out <- rast(y)
	nlyr(out) <- outnl
	names(out) <- colnames(mm)
	nc <- ncol(y)
	y <- c(y, x)
	readStart(y)
	on.exit(readStop(y))

	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	}

	ncops <- nlyr(y) / nlyr(out)
	ncops <- ifelse(ncops > 1, ceiling(ncops), 1) * 4
	b <- writeStart(out, filename, overwrite, n=ncops, sources=sources(y), ...)

	if (doclust) {
		ncores <- length(cores)
		#export_args(cores, ...)
		for (i in 1:b$n) {
			v <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
			icsz <- max(min(100, ceiling(b$nrows[i] / ncores)), b$nrows[i])
			r <- parallel::parRapply(cores, v, regfun, chunk.size=icsz)
			if (nlyr(out) > 1) {
				r <- matrix(r, ncol=nlyr(out), byrow=TRUE)
			}
			writeValues(out, r, b$row[i], b$nrows[i])
		}
	} else {
		for (i in 1:b$n) {
			v <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
			r <- apply(v, 1, regfun)
			writeValues(out, t(r), b$row[i], b$nrows[i])
		}
	}
	writeStop(out)
})



.reg_constMM <- function(mm, na.rm=FALSE) {
	outnl <- ncol(mm)
	nas <- rep(NA_real_, outnl)
	if (na.rm) {
		function(y, ...) {
			ok <- !is.na(y)
			if (!any(ok)) return(nas)
			if (sum(ok) < outnl) return(nas)
			stats::.lm.fit(mm[ok, , drop=FALSE], y[ok])$coefficients
		}
	} else {
		function(y, ...) {
			if (any(is.na(y))) return(nas)
			stats::.lm.fit(mm, y)$coefficients
		}
	}
}


setMethod("regress", signature(y="SpatRaster", x="data.frame"),
function(y, x, formula=NULL, na.rm=FALSE, cores=1, filename="", overwrite=FALSE, ...) {

	if (nrow(x) != nlyr(y)) {
		error("regress", "nrow(x) must equal nlyr(y)")
	}
	if (ncol(x) == 0) {
		error("regress", "x must have at least one column")
	}
	if (anyNA(x)) {
		error("regress", "x cannot have NAs")
	}

	# Default formula: regress against every column of x.
	if (is.null(formula)) {
		formula <- stats::as.formula(
			paste("y ~", paste(names(x), collapse=" + "))
		)
	} else {
		formula <- stats::as.formula(formula)
	}

	# Drop the LHS to make the formula one-sided.
	if (length(formula) == 3L) {
		formula <- formula[-2L]
	}
	mm <- stats::model.matrix(formula, data=x)
	if (nrow(mm) != nlyr(y)) {
		error("regress", paste0("model.matrix produced ", nrow(mm),
			" rows; expected ", nlyr(y), " (one per layer). Check `formula` and `x`."))
	}
	outnl <- ncol(mm)

	regfun <- .reg_constMM(mm, na.rm=na.rm)

	out <- rast(y)
	nlyr(out) <- outnl
	names(out) <- colnames(mm)
	nc <- ncol(y)
	readStart(y)
	on.exit(readStop(y))

	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	}

	ncops <- nlyr(y) / nlyr(out)
	ncops <- ifelse(ncops > 1, ceiling(ncops), 1) * 4
	b <- writeStart(out, filename, overwrite, n=ncops, sources=sources(y), ...)

	if (doclust) {
		ncores <- length(cores)
		for (i in 1:b$n) {
			v <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
			icsz <- max(min(100, ceiling(b$nrows[i] / ncores)), b$nrows[i])
			r <- parallel::parRapply(cores, v, regfun, chunk.size=icsz)
			if (nlyr(out) > 1) {
				r <- matrix(r, ncol=nlyr(out), byrow=TRUE)
			}
			writeValues(out, r, b$row[i], b$nrows[i])
		}
	} else {
		for (i in 1:b$n) {
			v <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
			r <- apply(v, 1, regfun)
			writeValues(out, t(r), b$row[i], b$nrows[i])
		}
	}
	writeStop(out)
})

.makeSpatDF <- function(d) {
	x <- methods::new("Rcpp_SpatDataFrame")
	nms <- colnames(d)
	for (i in 1:ncol(d)) {
		if (inherits(d[[i]], "character")) {
			s <- d[[i]]
			s[is.na(s)] <- "____NA_+"
			x$add_column_string(enc2utf8(s), nms[i])
		} else if (inherits(d[[i]], "integer")) {
			v <- d[[i]]
			# min long (should query what it is on the system?)
			v[is.na(v)] <- -2147483648
			x$add_column_long(v, nms[i])
		} else if (inherits(d[[i]], "logical")) {
			v <- as.integer(d[[i]])
			v[is.na(v)] <- 2
			x$add_column_bool(v, nms[i])
		} else if (inherits(d[[i]], "numeric")) {
			x$add_column_double(d[[i]], nms[i])
		} else if (inherits(d[[i]], "Date")) {
			x$add_column_time(as.numeric(as.POSIXlt(d[[i]])), nms[i], "days", "")
		} else if (inherits(d[[i]], "factor")) {
			f <- .makeSpatFactor(d[[i]])
			x$add_column_factor(f, nms[i])
		} else if (inherits(d[[i]], "POSIXt")) {
			tz <- if (nrow(d) > 0) { attr(d[[i]][1], "tzone") } else { "" }
			if (is.null(tz)) tz <- ""
			x$add_column_time(as.numeric(d[[i]]), nms[i], "seconds", tz)
		} else {
			v <- try(as.character(d[[i]]))
			if (!inherits(v, "try-error")) {
				x$add_column_string(enc2utf8(v), nms[i])
			}
		}
	}
	x
}


.getSpatDF <- function(x, check.names = FALSE, stringsAsFactors=FALSE, ...) {
	d <- x$values()

	f <- sapply(d, class) == "Rcpp_SpatFactor"
	if (any(f)) {
		f <- which(f)
		for (i in f) {
			d[[i]] <- .getSpatFactor(d[[i]])
		}
	}
	d <- data.frame(d, check.names=check.names, stringsAsFactors=stringsAsFactors, ...)
	if (ncol(d) == 0) return(d)

	s <- which(sapply(d, function(i) inherits(i, "character")))
	for (i in s) {
		d[[i]][d[[i]]=="NA"] <- NA
		Encoding(d[[i]]) <- "UTF-8"
	}
	#ints <- which(x$itype == 1)
	#for (i in ints) d[[i]] <- suppressWarnings(as.integer(d[[i]]))
	#bools <- which(x$itype == 3)
	#for (i in bools) d[[i]] <- suppressWarnings(as.logical(d[[i]]))
	times <- x$itype == 4
	if (any(times)) {
		steps <- x$get_timesteps()
		zones <- x$get_timezones()
		for (i in which(times)) {
			d[[i]] <- strptime("1970-01-01", "%Y-%m-%d", tz = "UTC") + d[[i]]
			if (!(zones[i] %in% c("", "UTC"))) {
				attr(d[[i]], "tzone") = zones[i]
			}
			if (steps[i] == "days") {
				d[[i]] <- as.Date(d[[i]])
			} 
		}
	}
	d
}


.makeSpatFactor <- function(x) {
	i <- as.integer(x)
	i[is.na(i)] <- 0
	SpatFactor$new(i, levels(x), is.ordered(x))
}

.getSpatFactor <- function(x) {
	i <- x$values
	i[i==0] <- NA
	if (isTRUE(x$ordered)) {
		ordered(x$labels[i], x$labels)	
	} else {
		factor(x$labels[i], x$labels)
	}
}

# Author: Robert J. Hijmans
# Date : November 2018
# Version 1.0
# License GPL v3


.big_number_warning <- function() {
# this warning should be given by C
	warn("big number", "cell numbers larger than ", 2^.Machine$double.digits, " are approximate")
}


ext_from_rc <- function(x, r1, r2, c1, c2){
	e <- as.vector(ext(x))
	r <- res(x)
	c1 <- min(max(c1, 1), ncol(x))
	c2 <- min(max(c2, 1), ncol(x))
	if (c1 > c2) {
		tmp <- c1
		c1 <- c2
		c2 <- tmp
	}
	r1 <- min(max(r1, 1), nrow(x))
	r2 <- min(max(r2, 1), nrow(x))
	if (r1 > r2) {
		tmp <- r1
		r1 <- r2
		r2 <- tmp
	}

	xn <- xFromCol(x, c1) - 0.5 * r[1]
	xx <- xFromCol(x, c2) + 0.5 * r[1]
	yx <- yFromRow(x, r1) + 0.5 * r[2]
	yn <- yFromRow(x, r2) - 0.5 * r[2]
	ext(c(sort(c(xn, xx))), sort(c(yn, yx)))
}


getLyrNrs <- function(layer, nms, n) { 
	nl <- length(nms)
	if (is.numeric(layer)) {
		layer <- round(layer)
		if (min(layer, na.rm=TRUE) < 1 || max(layer, na.rm=TRUE) > nl) {
			error("extract", "layer should be between 1 and nlyr(x)")
		}
	} else {
		layer <- match(layer, nms)
	}
	if (any(is.na(layer))) {
#		error("extract", "names in argument 'layer' do not match names(x)")
	}
	rep_len(layer, n)
}


extractCells <- function(x, y, raw=FALSE) {
	opt <- spatOptions()
	e <- x@pntr$extractCell(y-1, opt)
	e <- do.call(cbind, e)
	colnames(e) <- names(x)
	if (!raw) {
		e <- .makeDataFrame(x, e)
	}
	e
}


use_layer <- function(e, y, layer, nl, keepID) {
 	if (is.null(layer)) {
		return(e)
	}
	layer <- getLyrNrs(layer, colnames(e)[-1], nrow(y)) 
	idx <- cbind(1:nrow(e), layer[e[,1]] + 1)
	ee <- data.frame(e[,1,drop=FALSE], layer=colnames(e)[idx[,2]], value=e[idx])
	if (ncol(e) > (nl+1)) {
		ee <- cbind(ee, e[,(nl+2):ncol(e), drop=FALSE])
	} 
	if (!keepID) {
		ee <- ee[,-1]
	}
	ee
}


extract_table <- function(x, y, ID=FALSE, weights=FALSE, exact=FALSE, touches=FALSE, small=TRUE, na.rm=FALSE, wide=FALSE, ...) {
	if (weights && exact) {
		exact = FALSE
	}
	one_tab <- function(i) {
		e <- extract(x, y[i,], ID=FALSE, weights=weights, exact=exact, touches=touches, small=small, na.rm=na.rm)
		if (nrow(e) == 0) return(NULL)
		if (!(weights | exact)) {
			e$w_e_i_g_h_t123 <- 1
		}
		nms <- names(e)
		a <- aggregate(e[nms[length(nms)]], e[, c(nms[-length(nms)]), drop=FALSE], sum, na.rm=na.rm)
		colnames(a)[ncol(a)] <- "count"
		if (nrow(a) == 0) {
			return(NULL)
			#a <- a[1,]
			#a$count <- NULL 
			#a$count <- NA
		}
		cbind(ID=i, a)
	}
	# use a loop to keep mem consumption low
	out <- lapply(1:nrow(y), function(i) one_tab(i))
	out <- do.call(rbind, out)
	rownames(out) <- NULL
	if (wide && nlyr(x) == 1) {
		nms <- names(out)
		out <- stats::reshape(out, direction="wide", idvar=nms[1], timevar=nms[2:(ncol(out)-1)])
		out[is.na(out)] <- 0
		if (nrow(out) < nrow(y)) {
			mr <- (1:nrow(y))[!(1:nrow(y)) %in% out[,1]]
			r <- out[rep(1, length(mr)), ]
			r[, 1] <- mr
			r[, -1] <- 0
			out <- rbind(out, r)
			out <- out[order(out[,1]), ]
		}
		rownames(out) <- 1:nrow(out)
		out
	} else if ((!ID) & (!is.null(out))) {
		split(out[,-1, drop=FALSE], out[,1])		
	} else {
		out
	}
}



extract_fun <- function(x, y, fun, ID=TRUE, weights=FALSE, exact=FALSE, touches=FALSE, small=TRUE, layer=NULL, bind=FALSE, na.rm=FALSE) {

	nl <- nlyr(x)
	nf <- length(fun)
	if ((nf > 1) & (!is.null(layer))) {
		error("extract", "you cannot use argument 'layer' when using multiple functions")
	}

	opt <- spatOptions()
	e <- x@pntr$extractVectorFlat(y@pntr, fun, na.rm, touches[1], small[1], "", FALSE, FALSE, weights, exact, opt)
	x <- messages(x, "extract")
	e <- data.frame(matrix(e, ncol=nl*nf, byrow=TRUE))
	if (nf == 1) {
		colnames(e) <- names(x)
	} else {
		colnames(e) <- apply(cbind(rep(fun, each=nl), names(x)), 1, function(i) paste(i, collapse="_"))
	}
	if (!is.null(layer)) {
		e <- cbind(ID=1:nrow(e), e)
		e <- use_layer(e, y, layer, nlyr(x), ID)
		if (!ID || bind) {
			e$ID <- NULL
		}
		ID <- FALSE
	} 
	if (bind) {
		if (nrow(e) == nrow(y)) {
			e <- data.frame(e)
			e <- cbind(y, e)
		} else {
			#? can this occur?
			warn("extract", "cannot return a SpatVector because the number of records extracted does not match he number of rows in y (perhaps you need to use a summarizing function")
		}
	} else if (ID) {
		e <- cbind(ID=1:nrow(e), e)
	}
	e
}


do_fun <- function(e, fun, ...) {		
	fun <- match.fun(fun)
	e <- aggregate(e[,-1,drop=FALSE], e[,1,drop=FALSE], fun, ...)
	m <- sapply(e, NCOL)
	if (any(m > 1)) {
		cn <- names(e)
		e  <- do.call(cbind, as.list(e))
		i <- rep(1, length(cn))
		i[m>1] <- m[m>1]
		cn <- rep(cn, i)
		cn <- make.names(cn, TRUE)
		if (length(cn) == ncol(e)) {
			colnames(e) <- cn
		}
	}
	e
}


setMethod("extract", signature(x="SpatRaster", y="SpatVector"),
function(x, y, fun=NULL, method="simple", cells=FALSE, xy=FALSE, ID=TRUE, weights=FALSE, exact=FALSE, touches=is.lines(y), small=TRUE, layer=NULL, bind=FALSE, raw=FALSE, search_radius=0, wide=FALSE, ...) {

	geo <- geomtype(y)
	if (!is.null(layer)) {
		if (length(layer) > nrow(y)) {
			error("extract", "length(layer) > nrow(y)")
		} else { # recycle
			if (is.numeric(layer)) {
				layer <- round(layer)
				if (min(layer, na.rm=TRUE) < 1 || max(layer, na.rm=TRUE) > nlyr(x)) {
					error("extract", "layer should be between 1 and nlyr(x)")
				}
			}
			#x <- x[[unique(layer)]]
			#if (is.numeric(layer)) { # Match new layer order
			#  layer <- match(layer, unique(layer))
			#}
			layer <- rep(layer, length.out=nrow(y))
		}
		#keepID <- ID
		#ID <- TRUE
	}

	opt <- terra:::spatOptions()

	if (geo == "points") {
		if (search_radius > 0) {
			pts <- crds(y)
			e <- x@pntr$extractBuffer(pts[,1], pts[,2], search_radius, opt)
			messages(x, "extract")
			e <- do.call(cbind, e)
			colnames(e) <- c(names(x)[1], "distance", "cell")		
			e[,3] <- e[,3] + 1
			if (xy) {
				e <- cbind(xyFromCell(x, e[,3]), e)
			}
			if (!raw) {
				e <- cbind(.makeDataFrame(x, e[,1,drop=FALSE]), e[,2:3])
			}
			if (bind) {
				e <- data.frame(e)
				e <- cbind(y, e)
			} else if (ID) {
				e <- cbind(ID=1:nrow(e), e) 
			}
			return(e)
		} else if (weights || exact) {
			method <- "bilinear"
			weights <- FALSE
			exact <- FALSE
		} 
		# method <- match.arg(tolower(method), c("simple", "bilinear"))
	} else if (!is.null(fun)) { # nothing to summarize for points
		txtfun <- .makeTextFun(fun)
		if (inherits(txtfun, "character")) {
			if (any(txtfun == "table")) {
				if (length(fun) > 1) {
					warn("extract", "'table' cannot be combined with other functions")
				}
				if (!is.null(layer)) {
					warn("extract", "argument 'layer' is ignored when 'fun=table'")
				}
				if (bind) wide <- TRUE
				if (nlyr(x) > 1) wide <- FALSE
				e <- extract_table(x, y, ID=ID, weights=weights, exact=exact, touches=touches, small=small, wide=wide, ...)
				if (wide) {
					if (!ID) {
						e <- e[,-1]
					}
					if (bind) {
						e <- cbind(y, e[,-1])
					}
				}
			} else {
				e <- extract_fun(x, y, txtfun, ID=ID, weights=weights, exact=exact, touches=touches, small=small, bind=bind, layer=layer, ...)
			}
			return(e)
		} else if (weights || exact) {
			error("extract", "if 'weights' or 'exact' is TRUE, you can only use functions mean, sum, min, max and table")
		}
		xy <- cells <- FALSE
		raw <- TRUE
	} 
	
	if (is.null(layer)) {
		e <- x@pntr$extractVectorFlat(y@pntr, "", FALSE, touches[1], small[1], method, isTRUE(cells[1]), isTRUE(xy[1]), isTRUE(weights[1]), isTRUE(exact[1]), opt)
		x <- messages(x, "extract")
		nc <- nl <- nlyr(x)
		cn <- c("ID", names(x))
	} else {

		lyrs <- unique(layer) 
		if ((geo == "points") && (!isTRUE(cells[1])) && (!isTRUE(xy[1])) &&
				((nrow(y) * length(lyrs)) <= 2^26)) {
			# extract all used layers with a single call and then select the 
			# requested layer for each point. Much faster than one call per layer,
			# especially for files with compressed chunks (#2145)
			xlyr <- x[[lyrs]]
			e <- xlyr@pntr$extractVectorFlat(y@pntr, "", FALSE, touches[1], small[1], method, FALSE, FALSE, FALSE, FALSE, opt)
			messages(xlyr, "extract")
			e <- matrix(e, ncol=length(lyrs))
			e <- e[cbind(1:nrow(e), match(layer, lyrs))]
			xlyr <- xlyr[[1]]
		} else {
			e <- rep(NA, length(layer))
			yy <- y[,0]
			for (lyr in lyrs) {
				xlyr <- x[[lyr]]
				i <- which(layer == lyr)
				ylyr <- yy[i]
				e[i] <- xlyr@pntr$extractVectorFlat(ylyr@pntr, "", FALSE, touches[1], small[1], method, isTRUE(cells[1]), isTRUE(xy[1]), isTRUE(weights[1]), isTRUE(exact[1]), opt)
			}
		}
		nc <- nl <- 1
		cn <- c("ID", "value")
		x <- rast(xlyr) # for .makeDataFrame
	}

	if (cells) {
		cn <- c(cn, "cell")
		nc <- nc + 1
	}
	if (xy) {
		cn <- c(cn, "x", "y")
		nc <- nc + 2
	}
	if (weights) {
		cn <- c(cn, "weight")
		nc <- nc + 1
	} else if (exact) {
		cn <- c(cn, "fraction")
		nc <- nc + 1
	}
	if (geo == "points") {
		## this was? should be fixed upstream
		if (nc == nl) {
			e <- matrix(e, ncol=nc)
		} else {
			e <- matrix(e, ncol=nc, byrow=TRUE)
		}
		e <- cbind(1:nrow(e), e)
		if (nrow(e) > nrow(y)) { #multipoint
			g <- geom(y)
			e[,1] <- g[,1]
		}
	} else {
		e <- matrix(e, ncol=nc+1, byrow=TRUE)
	}
	colnames(e) <- cn
	if (!is.null(fun)) {
		e <- as.data.frame(e)
		e <- do_fun(e, fun, ...)
	}
	
	if (cells) {
		cncell <- cn =="cell"
		e[, cncell] <- e[, cncell] + 1
	}

	if (!raw) {
		if (method != "simple") {
			e <- as.data.frame(e)
		} else {
			id <- data.frame(e[,1,drop=FALSE])
			e <- cbind(id, .makeDataFrame(x, e[,-1,drop=FALSE]))
		}
	}
	
#	e <- use_layer(e, y, layer, nl, keepID)

	if (bind) {
		if (nrow(e) == nrow(y)) {
			e <- data.frame(e)
			e <- cbind(y, e[,-1,drop=FALSE])
		} else {
			warn("extract", "cannot return a SpatVector because the number of records extracted does not match the number of rows in y (perhaps you need to use a summarizing function)")
		}
	} else if (!ID) {
		e <- e[,-1,drop=FALSE]
	}
	e
})



setMethod("extract", signature(x="SpatRaster", y="sf"),
	function(x, y, fun=NULL, method="simple", cells=FALSE, xy=FALSE, ID=TRUE, weights=FALSE, exact=FALSE, touches=is.lines(y), layer=NULL, bind=FALSE, ...) {
		y <- vect(y)
		extract(x, y, fun=fun, method=method, cells=cells, xy=xy, ID=ID, weights=weights, exact=exact, touches=touches, layer=layer, bind=bind, ...)
	}
)


setMethod("extract", signature(x="SpatRaster", y="data.frame"),
function(x, y, ...) {
	if (ncol(y) != 2) {
		error("extract", "extract expects a 2 column data.frame of x/y or lon/lat coordinates")
	}
	v <- vect(y, colnames(y), quiet=TRUE)
	if ((crs(v) != "") && is.lonlat(v, warn=FALSE) && is.lonlat(x, warn=FALSE)) {
		crs(v) <- NULL
	}
	extract(x, v, ...)
})


setMethod("extract", signature(x="SpatRaster", y="numeric"),
function(x, y, xy=FALSE, raw=FALSE) {

	if (isTRUE((length(y)  == 2) && (any((y%%1)!=0)))) {
		warn("extract", "a vector of two decimal values is interpreted as referring to cell numbers, not to coordinates")
	}

	if (isTRUE(any((y < 1) | (y > ncell(x))))) {
		warn("extract", "out of range cell numbers detected")	
	}

	y <- round(y)
	v <- .extract_cell(x, y, drop=TRUE, raw=raw)
	if (xy) {
		v <- cbind(xyFromCell(x, y), v)
	}
	v
})

setMethod("extract", signature(x="SpatRaster", y="matrix"),
function(x, y, cells=FALSE, method="simple") {
	.checkXYnames(colnames(y))
	method <- match.arg(tolower(method), c("simple", "bilinear"))
	if (method != "simple") {
		y <- vect(y)
		return(extract(x, y, method=method, ID=FALSE))
	}
	y <- cellFromXY(x, y)
	if (cells) {
		cbind(cell=y, extract(x, y))
	} else {
		extract(x, y)
	}
})

setMethod("extract", signature(x="SpatRaster", y="SpatExtent"),
function(x, y, cells=FALSE, xy=FALSE) {
	y <- cells(x, y)
	v <- extract(x, y, xy=xy)
	if (cells) {
		v <- cbind(cell=y, v)
	}
	v
}
)


setMethod("extract", c("SpatVector", "SpatVector"),
function(x, y, count=FALSE) {

	e <- relate(y, x, "coveredby", pairs=TRUE, na.rm=FALSE)
	if (count) {
		if ((geomtype(x) == "polygons") && (geomtype(y) == "points")) {
			tab <- as.data.frame(table(e[,2]))
			i <- match(tab[,1], 1:nrow(x))
			count <- rep(NA, nrow(x))
			count[i] <- tab[,2]
			return(count)
		} else {
			error("extract", "count=TRUE is for point (y) in polygons (x) only")
		}
	}
	if (ncol(x) > 0) {
		d <- as.data.frame(x)
		e <- data.frame(id.y=e[,1], d[e[,2], ,drop=FALSE])
		rownames(e) <- NULL
	} else {
		colnames(e) <- c("id.y", "id.x")
	}
	e
})


setMethod("extract", signature(x="SpatVector", y="matrix"),
function(x, y) {
	stopifnot(ncol(y) == 2)
	.checkXYnames(colnames(y))
	y <- vect(y)
	extract(x, y)
})

setMethod("extract", signature(x="SpatVector", y="data.frame"),
function(x, y) {
	extract(x, as.matrix(y))
})


setMethod("extract", signature(x="SpatRasterCollection", y="ANY"),
function(x, y, ...) {
	lapply(x, function(r) extract(r, y, ...))
}
)

setMethod("extract", signature(x="SpatRasterDataset", y="ANY"),
function(x, y, ...) {
	lapply(x, function(r) extract(r, y, ...))
}
)




extractAlong <- function(x, y, ID=TRUE, cells=FALSE, xy=FALSE, online=FALSE, bilinear=TRUE) { 

	stopifnot(inherits(x, "SpatRaster"))
	if (inherits(y, "sf")) {
		y <- vect(y)
	} else {
		stopifnot(inherits(y, "SpatVector"))
	}
	stopifnot(geomtype(y) == "lines")
	
	spbb <- as.matrix(ext(y))
	rsbb <- as.matrix(ext(x))
	addres <- 2 * max(res(x))
	nlns <- nrow(y)
	res <- vector(mode = "list", length = nlns)

	if (spbb[1,1] > rsbb[1,2] | spbb[1,2] < rsbb[1,1] | spbb[2,1] > rsbb[2,2] | spbb[2,2] < rsbb[2,1]) {
		res <- data.frame(matrix(ncol=nlyr(x)+4, nrow=0))
		colnames(res) <- c("ID", "cell", "x", "y", names(x))
		if (!cells) res$cell <- NULL
		if (!xy) {
			res$x <- NULL
			res$y <- NULL
		}
		if (!ID) res$ID <- NULL
		return(res)
	}
	
	rr <- rast(x)
	g <- data.frame(geom(y))
	
	for (i in 1:nlns) {
		yp <- g[g$geom == i, ]
		nparts <- max(yp$part)
		vv <- NULL
		for (j in 1:nparts) {
			pp <- as.matrix(yp[yp$part==j, c("x", "y"), ])
			for (k in 1:(nrow(pp)-1)) {
				ppp <- pp[k:(k+1), ]
				spbb <- t(ppp)
				if (! (spbb[1,1] > rsbb[1,2] | spbb[1,2] < rsbb[1,1] | spbb[2,1] > rsbb[2,2] | spbb[2,2] < rsbb[2,1]) ) {
					lns <- vect(ppp, "lines")
					rc <- crop(rr, ext(lns) + addres)
					rc <- rasterize(lns, rc, touches=TRUE)
					cxy <- crds(rc)
					v <- cbind(row=rowFromY(rr, cxy[,2]), col=colFromX(rr, cxy[,1]))
					#up or down?
					updown <- c(1,-1)[(ppp[1,2] < ppp[2,2]) + 1]
					rightleft <- c(-1,1)[(ppp[1,1] < ppp[2,1]) + 1]

					v <- v[order(updown*v[,1], rightleft*v[,2]), ]
					vv <- rbind(vv, v)
				}
			} 
		}
		if (!is.null(vv)) {
			cell <- cellFromRowCol(rr, vv[,1], vv[,2])
			res[[i]] <- data.frame(i, cell)
		}
	}
	
	res <- do.call(rbind, res)
	if (is.null(res)) {
		if (xy) {
			res <- data.frame(matrix(ncol=nlyr(x)+4, nrow=0))		
			colnames(res) <- c("ID", "cell", "x", "y", names(x))
		} else {
			res <- data.frame(matrix(ncol=nlyr(x)+2, nrow=0))
			colnames(res) <- c("ID", "cell", names(x))
		}
	} else {
		colnames(res) <- c("ID", "cell")
		if (xy) {
			xycrd <- xyFromCell(x, res$cell)
			method <- "simple"
			if (online) {
				pts <- vect(xycrd, crs="local")
				crs(y) <- "local"
				n <- nearest(pts, y)
				xycrd <- crds(n)
				if (bilinear) method <- "bilinear"
				res <- data.frame(res, xycrd, extract(x, xycrd, method=method))
			} else {
				res <- data.frame(res, xycrd, extract(x, res$cell))
			}
		} else {
			res <- data.frame(res, extract(x, res$cell))		
		}
	}

	if (!cells) res$cell <- NULL
	if (!ID) res$ID <- NULL
	
	res

}


setMethod("extractRange", signature(x="SpatRaster", y="ANY"),
	function(x, y, first, last, lyr_fun=NULL, geom_fun=NULL, ID=FALSE, na.rm=TRUE, bind=FALSE, ...) {
		
		first <- getLyrNrs(first, names(x), NROW(y)) + 1 
		last  <- getLyrNrs(last,  names(x), NROW(y)) + 1
		if (inherits(y, "SpatVector")) {
			e <- extract(x, y, geom_fun, ID=TRUE, na.rm=na.rm, bind=FALSE, ...)
			if (nrow(e) != nrow(y)) {
				error("extractRange", "geom_fun must return a single value for each geometry/layer")
			}
		} else {
			e <- data.frame(extract(x, y, ID=TRUE, ...))
		}
		a <- lapply(1:nrow(e), function(i) e[i, c(first[i]:last[i]), drop=FALSE])
		if (!is.null(lyr_fun)) {
			a <- sapply(a, lyr_fun, na.rm=na.rm)
		}
		if (isTRUE(ID)) {
			if (is.list(a)) {
				a <- lapply(1:length(a), function(i) cbind(ID=i, a[[i]]))
			} else {
				a <- data.frame(ID=1:NROW(a), value=a)
			}
		}
		if (isTRUE(bind)) {
			if (is.list(a)) {
				warn("extractRange", "cannot bind these values")
			} else {
				if (is.vector(a)) {
					a <- data.frame(value=a)
				}
				a <- cbind(y, a)
			}
		}
		a
	}
)

# Author: Robert J. Hijmans
# Date :  April 2026
# Version 0.1
# License GPL v3


# Coerce tile extents to a list of `list(outer=, inner=)` pairs of plain
# numeric vectors (xmin, xmax, ymin, ymax). The worker reads values on
# `outer`, then the result of `fun` is cropped to `inner` before writing,
# so the per-tile output rasters never overlap and assemble cleanly with
# vrt(). For all the explicit `tiles` shapes we trust the caller (outer ==
# inner); for the auto path we expand each inner tile by `buffer` cells,
# clamped to x's extent.
.tile_apply_extents <- function(x, tiles, cores=1, buffer=0) {

	pair <- function(o, i) list(outer = as.numeric(o), inner = as.numeric(i))
	identity_pairs <- function(m) {
		lapply(seq_len(nrow(m)), function(j) {
			v <- as.numeric(m[j, ])
			pair(v, v)
		})
	}

	if (is.null(tiles)) {
		# auto path: choose tiles, optionally with a read buffer
		inner <- getTileExtents(x, cores=cores)
		if (any(buffer > 0)) {
			outer <- getTileExtents(x, cores=cores, buffer=buffer)
			# clamp outer to the raster extent so window<- never gets a
			# read window that falls outside x.
			rext <- as.vector(ext(x))   # xmin, xmax, ymin, ymax
			out <- lapply(seq_len(nrow(inner)), function(j) {
				o <- as.numeric(outer[j, ])
				o[1] <- max(o[1], rext[1])
				o[2] <- min(o[2], rext[2])
				o[3] <- max(o[3], rext[3])
				o[4] <- min(o[4], rext[4])
				pair(o, as.numeric(inner[j, ]))
			})
			return(out)
		}
		return(identity_pairs(inner))
	}

	if (inherits(tiles, "SpatExtent")) {
		v <- as.vector(tiles)
		return(list(pair(v, v)))
	}
	if (is.list(tiles)) {
		if (length(tiles) == 0) {
			error("tile_apply", "'tiles' is empty")
		}
		out <- lapply(tiles, function(t) {
			if (inherits(t, "SpatExtent")) {
				v <- as.vector(t); pair(v, v)
			} else if (is.numeric(t) && length(t) == 4) {
				v <- as.numeric(t); pair(v, v)
			} else {
				error("tile_apply", "list elements of 'tiles' must be a SpatExtent or a length-4 numeric (xmin, xmax, ymin, ymax)")
			}
		})
		return(out)
	}
	if (is.matrix(tiles)) {
		if (ncol(tiles) != 4) {
			error("tile_apply", "matrix 'tiles' must have 4 columns: xmin, xmax, ymin, ymax")
		}
		return(identity_pairs(tiles))
	}
	if (inherits(tiles, "SpatRaster") || inherits(tiles, "SpatVector") || is.numeric(tiles)) {
		m <- getTileExtents(x, tiles)
		return(identity_pairs(m))
	}
	error("tile_apply", "'tiles' must be NULL/missing (auto from block size), a SpatExtent, a list of SpatExtents, a 4-column matrix of extents, a SpatRaster or SpatVector defining tile geometry, or a numeric (rows, cols)")
}


# wrap any terra object so that it can travel across worker boundaries.
# Recurses into plain lists so users can pass e.g. a list of SpatExtents.
.tile_apply_wrap <- function(v) {
	if (inherits(v, c("SpatRaster", "SpatVector", "SpatRasterDataset",
					  "SpatRasterCollection", "SpatVectorCollection",
					  "SpatExtent", "SpatVectorProxy", "SpatGraticule"))) {
		return(wrap(v))
	}
	if (is.list(v) && !is.object(v)) {
		return(lapply(v, .tile_apply_wrap))
	}
	v
}

.tile_apply_unwrap <- function(v) {
	if (inherits(v, "Packed")) {
		unwrap(v)
	} else if (is.list(v) && !is.object(v)) {
		lapply(v, .tile_apply_unwrap)
	} else {
		v
	}
}


# Per-tile worker for the file-backed dispatch path. Defined at file scope
# (not as a closure) so it serializes cleanly across PSOCK/forked/future
# workers without dragging tile_apply()'s local environment along. Argument
# names must NOT collide with parLapply() args (cl, X, fun, chunk.size).
# `.px` is the whole packed raster, shared across jobs; the worker windows
# it down to `.job$outer` before invoking `fun`.
.tile_apply_worker <- function(.job, .px, .ufun, .args, .wopt) {
	.unw <- function(a) {
		if (inherits(a, "Packed")) terra::unwrap(a)
		else if (is.list(a) && !is.object(a)) lapply(a, .unw)
		else a
	}
	x <- terra::unwrap(.px)
	terra::window(x) <- terra::ext(.job$outer)
	.args <- lapply(.args, .unw)
	r <- do.call(.ufun, c(list(x), .args))
	if (!inherits(r, "SpatRaster")) {
		stop("'fun' must return a SpatRaster for every tile")
	}
	# crop to the inner (un-buffered) extent so per-tile outputs do not
	# overlap and assemble cleanly with vrt()
	if (!identical(.job$outer, .job$inner)) {
		r <- terra::crop(r, terra::ext(.job$inner), snap="near")
	}
	terra::writeRaster(r, filename=.job$file, overwrite=TRUE, wopt=.wopt)
	.job$file
}


# Per-tile worker for the in-memory dispatch path. The job carries its own
# pre-cropped, packed raster slice (`.job$px`), so the worker only receives
# the pixels it needs and does not have to set a window.
.tile_apply_worker_slice <- function(.job, .ufun, .args, .wopt) {
	.unw <- function(a) {
		if (inherits(a, "Packed")) terra::unwrap(a)
		else if (is.list(a) && !is.object(a)) lapply(a, .unw)
		else a
	}
	x <- terra::unwrap(.job$px)
	.args <- lapply(.args, .unw)
	r <- do.call(.ufun, c(list(x), .args))
	if (!inherits(r, "SpatRaster")) {
		stop("'fun' must return a SpatRaster for every tile")
	}
	if (!identical(.job$outer, .job$inner)) {
		r <- terra::crop(r, terra::ext(.job$inner), snap="near")
	}
	terra::writeRaster(r, filename=.job$file, overwrite=TRUE, wopt=.wopt)
	.job$file
}


# Detect future-related `cores` values without calling the strategy: a bare
# strategy function (e.g. future::multisession) is class "future"+"function";
# a tweaked strategy (e.g. future::multisession(workers=2)) is "tweaked"+
# "future". Both should route through future.apply.
.is_future_plan <- function(cores) {
	inherits(cores, c("FutureStrategy", "tweaked")) ||
	(inherits(cores, "future") && is.function(cores))
}


# Inspect `cores` and decide which dispatch path to use. Returns a named
# list with: $kind in {"seq","cluster","future"}, $ncores (int), $cl (cluster
# or NULL), $owns_cl (TRUE iff we created the cluster and must stop it).
# The future-plan setup (installing/restoring the plan) is handled in
# tile_apply() so that on.exit is attached to the right frame; here we only
# resolve the worker count.
.tile_apply_dispatch <- function(cores) {
	if (inherits(cores, "cluster")) {
		return(list(kind="cluster", ncores=length(cores), cl=cores, owns_cl=FALSE))
	}
	if (is.character(cores) && length(cores) == 1 &&
		tolower(cores) %in% c("future", "future.apply")) {
		if (!requireNamespace("future", quietly=TRUE) ||
			!requireNamespace("future.apply", quietly=TRUE)) {
			error("tile_apply", "cores='future' requires the 'future' and 'future.apply' packages")
		}
		return(list(kind="future", ncores=max(1L, future::nbrOfWorkers()),
					cl=NULL, owns_cl=FALSE))
	}
	n <- max(as.integer(cores)[1], 1L)
	if (n > 1L) {
		return(list(kind="cluster", ncores=n, cl=NULL, owns_cl=TRUE))
	}
	list(kind="seq", ncores=1L, cl=NULL, owns_cl=FALSE)
}


tile_apply <- function(x, fun, cores=1, cpkgs=NULL, tiles=NULL, buffer=0, ...,
					   filename="", overwrite=FALSE, wopt=list(),
					   overlap_fun=NULL) {

	if (!inherits(x, "SpatRaster")) {
		error("tile_apply", "'x' must be a SpatRaster")
	}
	if (any(window(x))) {
		error("tile_apply", "'x' already has a window set; remove it first with 'window(x) <- NULL'")
	}
	fun <- match.fun(fun)

	# `buffer` is only honoured with auto tiles. For explicit tiles the caller
	# already controls overlap (e.g. via getTileExtents(buffer=...)).
	if (!is.null(tiles) && any(buffer > 0)) {
		warn("tile_apply", "'buffer' is only used when 'tiles' is NULL; ignoring it")
		buffer <- 0
	}

	# If the caller passed a future plan/strategy via cores=, install it
	# now and restore on exit -- so subsequent dispatch and tile sizing see
	# the new nbrOfWorkers(). After installation, the dispatch path becomes
	# the regular "future" string path.
	if (.is_future_plan(cores)) {
		if (!requireNamespace("future", quietly=TRUE) ||
			!requireNamespace("future.apply", quietly=TRUE)) {
			error("tile_apply", "a future plan was passed but 'future' and 'future.apply' are not installed")
		}
		oplan <- future::plan(cores)
		on.exit(future::plan(oplan), add=TRUE)
		cores <- "future"
	}

	# resolve dispatch + cores up-front so the auto tile sizer knows about it
	disp <- .tile_apply_dispatch(cores)
	ncores <- disp$ncores

	exts <- .tile_apply_extents(x, tiles, cores=ncores, buffer=buffer)
	ntiles <- length(exts)
	if (ntiles == 0) {
		error("tile_apply", "no tiles to process")
	}

	# Per-call temp directory for intermediate per-tile files. Always written to disk
	tdir <- tempfile(pattern="tile_apply_")
	dir.create(tdir, recursive=TRUE, showWarnings=FALSE)
	tile_files <- file.path(tdir, sprintf("tile_%05d.tif", seq_len(ntiles)))
	keep_tiles <- FALSE  # set TRUE only when the result is a VRT backed by them
	on.exit({
		if (!keep_tiles) unlink(tdir, recursive=TRUE)
	}, add=TRUE)

	# When all of x's sources are in memory, ship a per-tile slice instead
	# of the whole raster. This avoids serialising values(x) once per worker
	# (or once per chunk) and removes the need for window<- inside the
	# worker. For file-backed sources we keep the path-based contract:
	# workers parallel-read their own tile via window<-, which is strictly
	# cheaper than crop()ing on the parent and pushing pixels to workers.
	in_memory <- length(sources(x)) > 0 && all(sources(x) == "")

	build_jobs <- function() {
		if (in_memory) {
			mapply(function(p, f) {
				tile <- crop(x, ext(p$outer), snap="near")
				list(px = wrap(tile), outer = p$outer,
					 inner = p$inner, file = f)
			}, exts, tile_files, SIMPLIFY=FALSE)
		} else {
			mapply(function(p, f) list(outer=p$outer, inner=p$inner, file=f),
				   exts, tile_files, SIMPLIFY=FALSE)
		}
	}

	if (disp$kind == "cluster") {
		cl <- disp$cl
		if (is.null(cl)) {
			cl <- parallel::makeCluster(disp$ncores)
		}
		if (disp$owns_cl) {
			on.exit(parallel::stopCluster(cl), add=TRUE)
		}

		# every worker needs terra
		parallel::clusterCall(cl, function() {
			suppressPackageStartupMessages(library(terra))
			invisible(NULL)
		})
		if (!is.null(cpkgs)) {
			cpkgs <- as.character(cpkgs)
			parallel::clusterCall(cl, function(pkgs) {
				for (p in pkgs) suppressPackageStartupMessages(library(p, character.only=TRUE))
				invisible(NULL)
			}, cpkgs)
		}

		# wrap any terra objects in `...` so they survive serialization
		args <- lapply(list(...), .tile_apply_wrap)
		jobs <- build_jobs()

		if (in_memory) {
			out_files <- unlist(parallel::parLapply(cl, jobs,
				.tile_apply_worker_slice,
				.ufun=fun, .args=args, .wopt=wopt))
		} else {
			# wrap x once; the workers re-open it from filenames
			px <- wrap(x)
			out_files <- unlist(parallel::parLapply(cl, jobs,
				.tile_apply_worker,
				.px=px, .ufun=fun, .args=args, .wopt=wopt))
		}
	} else if (disp$kind == "future") {
		# Plan was already installed up-front (if the caller passed one).
		# We just dispatch to future.apply::future_lapply with the same
		# wrap/unwrap contract as the cluster path.
		args <- lapply(list(...), .tile_apply_wrap)
		jobs <- build_jobs()
		fpkgs <- unique(c("terra", as.character(cpkgs)))

		if (in_memory) {
			out_files <- unlist(future.apply::future_lapply(jobs,
				.tile_apply_worker_slice,
				.ufun=fun, .args=args, .wopt=wopt,
				future.packages=fpkgs, future.seed=TRUE))
		} else {
			px <- wrap(x)
			out_files <- unlist(future.apply::future_lapply(jobs,
				.tile_apply_worker,
				.px=px, .ufun=fun, .args=args, .wopt=wopt,
				future.packages=fpkgs, future.seed=TRUE))
		}
	} else {
		# sequential path - same disk-streaming contract as the workers
		args <- list(...)
		for (i in seq_len(ntiles)) {
			p <- exts[[i]]
			y <- deepcopy(x)
			window(y) <- ext(p$outer)
			r <- do.call(fun, c(list(y), args))
			if (!inherits(r, "SpatRaster")) {
				error("tile_apply", "'fun' must return a SpatRaster for every tile")
			}
			if (!identical(p$outer, p$inner)) {
				r <- crop(r, ext(p$inner), snap="near")
			}
			writeRaster(r, filename=tile_files[i],
						overwrite=TRUE, wopt=wopt)
			rm(r, y); gc(verbose=FALSE)
		}
		out_files <- tile_files
	}

	# Single tile shortcut: just promote the one tile file.
	if (length(out_files) == 1) {
		if (nzchar(filename)) {
			ok <- file.copy(out_files, filename, overwrite=overwrite)
			if (!isTRUE(ok)) {
				error("tile_apply", "could not copy tile output to 'filename'")
			}
			return(rast(filename))
		}
		# to survives the on.exit cleanup
		stable <- tempfile(fileext=".tif")
		file.rename(out_files, stable)
		return(rast(stable))
	}

	if (is.null(overlap_fun)) {
		# VRT for non-overlapping tiles
		vrtfile <- file.path(tdir, "all.vrt")
		v <- vrt(out_files, filename=vrtfile, overwrite=TRUE)
		if (nzchar(filename)) {
			out <- writeRaster(v, filename=filename,
							   overwrite=overwrite, wopt=wopt)
		} else {
			# tile files BACK this VRT - keep them around for the session
			keep_tiles <- TRUE
			out <- v
		}
	} else {
		rcoll <- sprc(lapply(out_files, rast))
		out <- mosaic(rcoll, fun=overlap_fun, filename=filename, overwrite=overwrite, wopt=wopt)
	}

	out
}

# tests for future integration: tile_apply(cores="future"|plan), future_app(),
# future_focal(). All gated on the optional packages being installed so the
# CRAN check passes when they are not.

if (!requireNamespace("future", quietly=TRUE) ||
	!requireNamespace("future.apply", quietly=TRUE)) {
	exit_file("future / future.apply not installed; skipping")
}

f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
v_in <- values(r)


# helper: install a sequential plan for the duration of the file (so we
# never spawn worker processes and stay well under R CMD check --as-cran's
# 2-core limit). Restored on exit().
old_plan <- future::plan(future::sequential)
on.exit(future::plan(old_plan), add=TRUE)


# tile_apply(cores="future") with the active sequential plan: equivalent
# to a single-process tile_apply() but exercising the future.apply path.

out_seq <- tile_apply(r, function(x) x * 2, tiles=50, cores=1L)
out_fut <- tile_apply(r, function(x) x * 2, tiles=50, cores="future")
expect_inherits(out_fut, "SpatRaster")
expect_equal(dim(out_fut), dim(r))
v_seq <- values(out_seq); v_fut <- values(out_fut)
ok <- !is.na(v_seq) & !is.na(v_fut)
expect_true(sum(ok) > 0)
expect_equal(v_seq[ok], v_fut[ok])


# tile_apply with a future strategy passed via cores= (no parens).
# This installs the plan for the duration of the call and restores it.
out_plan <- tile_apply(r, function(x) x + 1, tiles=50,
					   cores=future::sequential)
expect_inherits(out_plan, "SpatRaster")
v <- values(out_plan)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] + 1)
# the plan we set up-front should be restored after the call
expect_inherits(future::plan(), "sequential")


# extra `...` args travel across the future boundary (named, like cluster path)
out_dots <- tile_apply(r, function(x, k) x * k, tiles=50, cores="future", k=4)
v <- values(out_dots)
ok <- !is.na(v) & !is.na(v_in)
expect_equal(v[ok], v_in[ok] * 4)

get_groups <- function(x, y) {
	j <- 1
	outx <- outy <- list()

	for (i in 1:length(x)) {
		if (is.na(x[i])) next
		gx <- stats::na.omit(x[x[i] == x] )
		gy <- y[x %in% gx]
		nx <- ny <- 0
		while(TRUE) {
			if (nx == length(gx)) break
			ny <- length(gy)
			nx <- length(gx)
			if ((ny == length(y) || (nx == length(x)))) break
			ux <- unique( x[y %in% gy] )
			gy <- y[x %in% ux]
			gx <- x[y %in% gy]
		}
		x[x %in% gx] <- NA
		y[y %in% gy] <- NA
		outx[[j]] <- gx
		outy[[j]] <- gy
		j <- j + 1
	}
	list(outx, outy)
}


connect_dateline <- function(x) {
	east <- west <- c()
	for (i in 1:nrow(x)) {
		e <- ext(x[i,])
		if (xmin(e) <= -180) {
			west <- c(west, i)
		} else if (xmax(e) >= 180) {
			east <- c(east, i)
		}
	}
	if ((length(east) == 0) || (length(west) == 0)) {
		return(x)
	}

	xx <- shift(x[west,], 360, 0)
	yy <- x[east, ]
	#zz <- x[-c(east, west), ]
	px <- py <- c()
	hasDF <- ncol(x) > 0
	for (i in 1:nrow(xx)) {
		for (j in 1:nrow(yy)) {
			if (hasDF) {
				if (all(as.data.frame(xx[i,]) != as.data.frame(yy[j,]))) {
					next
				}
			}
			if (is.related(xx[i,], yy[j,], "touches")) {
				px <- c(px, i)
				py <- c(py, j)
			}
		}
	}
	if ((length(px) == 0)) {
		return(x)
	}

	px <- west[px]
	py <- east[py]

	groups <- get_groups(px, py)
	xg <- groups[[1]]
	yg <- groups[[2]]
	vvv <- list()
	for (i in 1:length(xg)) {
		vvv[[i]] <- aggregate(x[unique(c(xg[[i]], yg[[i]])), ], dissolve=TRUE)
	}
	out <- x[-(unique(unlist(groups))), ]
	out <- c(vvv, out)
	do.call(rbind, out)
}

# Author: Robert J. Hijmans
# Date : June 2020
# Version 1.0
# License GPL v3


setMethod("cells", signature(x="SpatRaster", y="missing"),
	function(x, y) {
		if (hasValues(x)) {
			opt <- spatOptions()
			x@pntr$cells_notna_novalues(opt) + 1
		} else {
			# is this useful?
			1:ncell(x)
		}
	}
)

setMethod("cells", signature(x="SpatRaster", y="numeric"),
	function(x, y, pairs=FALSE) {
		opt <- spatOptions()
		v <- x@pntr$is_in_cells(y, pairs, opt)
		x <- messages(x, "cells")
		if (pairs) {
			v <- lapply(v, function(i) {
				m <- matrix(i, ncol=2)
				m[,1] <- m[,1] + 1
				colnames(m) <- c("cell", "value")
				m
			})
		} else {
			v <- lapply(v, function(i) i+1)
		}
		names(v) <- names(x)
		v
	}
)


setMethod("cells", signature("SpatRaster", "SpatVector"),
	function(x, y, method="simple", weights=FALSE, exact=FALSE, touches=is.lines(y), small=TRUE) {
		method = match.arg(tolower(method), c("simple", "bilinear"))
		opt <- spatOptions()
		d <- x@pntr$vectCells(y@pntr, touches[1], small[1], method[1], weights[1], exact[1], opt)
		if (geomtype(y) == "points") {
			d <- matrix(d, nrow=nrow(y), byrow=TRUE)
			d <- cbind(1:nrow(y), d)
			if (method == "bilinear") {
				colnames(d) <- c("ID", "c1", "c2", "c3", "c4", "w1", "w2", "w3", "w4")
				d[,2:5] <- d[,2:5] + 1
			} else {
				colnames(d) <- c("ID", "cell")
				d[,2] <- d[,2] + 1
			}
			return (d)
		}
		cn <- c("ID", "cell")
		if (weights[1] || exact[1]) {
			d <- matrix(d, ncol=3)
			cn <- c(cn, "weights")
		} else {
			d <- matrix(d, ncol=2)
		}
		d[,1:2] <- d[,1:2] + 1
		colnames(d) <- cn
		d
	}
)


#setMethod("cells", signature("SpatRaster", "SpatExtent"),
#	function(x, y, ...) {
#		p <- as.polygons(y, crs=crs(x))
#		cells(x, p)[,2]
#	}
#)

#setMethod("cells", signature("SpatRaster", "SpatExtent"),
#	function(x, y, ...) {
#		e <- align(y, x)
#		s <- res(x)/2
#		e <- as.vector(y) + c(s[1], -s[1], s[2], -s[2])
#		r <- rowFromY(x, e[4:3])-1
#		c <- colFromX(x, e[1:2])
#		cc <- c[1]:c[2]
#		rr <- (r[1]:r[2]) * ncol(x)
#		rep(rr, each=length(cc)) + cc
#	}
#)


setMethod("cells", signature("SpatRaster", "SpatExtent"),
	function(x, y) {
		opt <- spatOptions()
		x@pntr$extCells(y@pntr) + 1
	}
)

# Author: Robert J. Hijmans
# Date :  June 2019
# Version 1.0
# License GPL v3


.scatterPlotRaster <- function(x, y, maxcell=100000, warn=TRUE, cex, xlab, ylab, nc, nr, 
	maxnl=16, main, add=FALSE, smooth=FALSE, gridded=FALSE, ncol=25, nrow=25, asp=NA,
	ramp=grDevices::colorRampPalette(c("white", grDevices::blues9)), ...) {

	compareGeom(x, y, lyrs=FALSE, crs=FALSE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE)
	nlx <- nlyr(x)
	nly <- nlyr(y)

	maxnl <- max(1, round(maxnl))
	nl <- min(max(nlx, nly), maxnl)
	if (nl > maxnl) {
		nl <- maxnl
		if (nlx > maxnl) {
			x <- x[[1:maxnl]]
			nlx <- maxnl
		}
		if (nly > maxnl) {
			y <- y[[1:maxnl]]
			nly <- maxnl
		}
	}

	if (nlx < nly) {
		x <- x[[rep_len(1:nlx, nly)]]
		nlx <- nly
	} else if (nly < nlx) {
		y <- y[[rep_len(1:nly, nlx)]]	
		nly <- nlx
	}


	if (missing(main)) {
		main <- ""
	}

	if (missing(xlab)) {
		ln1 <- names(x)
	} else {
		ln1 <- xlab
		if (length(ln1) == 1) {
			ln1 <- rep(ln1, nlx)
		}
	}
	if (missing(ylab)) {
		ln2 <- names(y)
	} else {
		ln2 <- ylab
		if (length(ln1) == 1) {
			ln2 <- rep(ln2, nly)
		}
	}
	cells <- ncell(x)


	if (gridded | smooth) {
#			if ((ncell(x) * (nlx + nly)) < .maxmemory()) {
		if ((ncell(x) * (nlx + nly)) < 1000000) {
			maxcell <- ncell(x)
		}
		if (smooth) {
			dots <- list(...)
			if (!is.null(dots$col)) { 
				if (is.function(dots$col)) {
					ramp <- grDevices::colorRampPalette(dots$col)
				} else {
					warn("plot<SpatRaster,SpatRaster>", "when smooth=TRUE, col must be a function")
				}
			}
		}
	}

	x <- as.matrix(spatSample(c(x,y), size=maxcell, method="regular", as.raster=FALSE, warn=FALSE))
	# y <- as.matrix(spatSample(y, size=maxcell, method="regular", as.raster=FALSE))

	y <- x[,c((nlx+1):ncol(x))]
	x <- x[,1:nlx]


	if (warn & (NROW(x) < cells)) {
		warn("plot", 'plot used a sample of ', round(100*NROW(x)/cells, 1), '% of the cells. You can use "maxcell" to increase the sample)')
	}

	if (missing(cex)) {
		if (NROW(x) < 100) {
			cex <- 1
		} else if (NROW(x) < 1000) {
			cex <- 0.5
		} else {
			cex <- 0.2
		}
	}

	if (nlx != nly) {
		# recycling
		d <- cbind(as.vector(x), as.vector(y))
		x <- matrix(d[,1], ncol=nl)
		y <- matrix(d[,2], ncol=nl)
		lab <- vector(length=nl)
		lab[] <- ln1
		ln1 <- lab
		lab[] <- ln2
		ln2 <- lab
	}

	if (nl > 1) {

		old.par <- graphics::par(no.readonly = TRUE)
		on.exit(graphics::par(old.par))
		px <- trunc(sqrt(nl))
		py <- ceiling(nl / px)
		graphics::par(mfrow=c(px, py), mar=c(3, 3, 1, 1))

		if (smooth) {
			for (i in 1:nl) {
				graphics::smoothScatter(x[,i], y[,i], main=main[i], xlab=ln1[i], ylab=ln2[i], add=add, asp=asp, colramp=ramp, ...)
			}				
		} else if (gridded) {
			for (i in 1:nl) {
				.plotdens(x[,i], y[,i], nc=ncol, nr=nrow, main=main[i], xlab=ln1[i], ylab=ln2[i], add=add, asp=asp, ...)
			}		
		} else {
			if (add) {
				for (i in 1:nl) {
					graphics::points(x[,i], y[,i], cex=cex, ...)
				}
			} else {
				for (i in 1:nl) {
					plot(x[,i], y[,i], cex=cex, xlab=ln1[i], ylab=ln2[i], main=main[i], asp=asp, ...)
				}
			}
		} 
	} else  {
		if (smooth) {
			graphics::smoothScatter(x, y, main=main[1], xlab=ln1[1], ylab=ln2[1], add=add, asp=asp, colramp=ramp, ...)
		} else if (gridded) {
			.plotdens(x, y, nc=ncol, nr=nrow, main=main[1], xlab=ln1[1], ylab=ln2[1], add=add, asp=asp, ...)
		} else {
			if (add) {
				graphics::points(x, y, cex=cex, ...)
			} else {
				plot(x, y, cex=cex, xlab=ln1[1], ylab=ln2[1], main=main[1], asp=asp, ...)
			}
		}
	}
}


setMethod("plot", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, maxcell=100000, warn=TRUE, nc, nr, maxnl=16, smooth=FALSE, gridded=FALSE, ncol=25, nrow=25, ...) {

		nl <- max(nlyr(x), nlyr(y))
		if (missing(nc)) {
			nc <- ceiling(sqrt(nl))
		} else {
			nc <- max(1, min(nl, round(nc)))
		}
		if (missing(nr)) {
			nr <- ceiling(nl / nc)
		} else {
			nr <- max(1, min(nl, round(nr)))
			nc <- ceiling(nl / nr)
		}


		.scatterPlotRaster(x, y, maxcell=maxcell, warn=warn, nc=nc, nr=nr, maxnl=maxnl, gridded=gridded, smooth=smooth, ncol=ncol, nrow=nrow, ...)
	}
)



.plotdens <- function(x, y, nc, nr, xlim=NULL, ylim=NULL, asp=NULL, ...) {
	xy <- stats::na.omit(cbind(x,y))
	if (nrow(xy) == 0) {
		error("plot (density)", "only NA values (in this sample?)")
	}
	r <- apply(xy, 2, range)
	rx <- r[,1]
	if (rx[1] == rx[2]) {
		rx[1] <- rx[1] - 0.5
		rx[2] <- rx[2] + 0.5
	}
	ry <- r[,2]
	if (ry[1] == ry[2]) {
		ry[1] <- ry[1] - 0.5
		ry[2] <- ry[2] + 0.5
	}

	out <- rast(xmin=rx[1], xmax=rx[2], ymin=ry[1], ymax=ry[2], ncol=nc, nrow=nr, crs="+proj=utm +zone=1 +datum=WGS84")
	colnames(xy) <- c("x", "y")
	out <- rasterize(vect(xy), out, fun=function(x, ...) length(x), background=NA)
	if (!is.null(xlim) | !is.null(ylim)) {
		if (is.null(xlim)) xlim <- c(xmin(x), xmax(x))
		if (is.null(ylim)) ylim <- c(ymin(x), ymax(x))
		e <- extent(xlim, ylim)
		out <- extend(crop(out, e), e, value=0)
	}
	plot(out, maxcell=nc*nr, asp=asp, ...)
}

setMethod("geomtype", signature(x="SpatVector"),
	function(x){
		x@pntr$type()
	}
)
setMethod("geomtype", signature(x="SpatVectorProxy"),
	function(x){
		x@pntr$v$type()
	}
)


setMethod("datatype", signature(x="SpatVector"),
	function(x){
		x@pntr$df$get_datatypes()
	}
)


setMethod("is.lines", signature(x="SpatVector"),
	function(x) {
		geomtype(x) == "lines"
	}
)

setMethod("is.polygons", signature(x="SpatVector"),
	function(x) {
		geomtype(x) == "polygons"
	}
)
setMethod("is.points", signature(x="SpatVector"),
	function(x) {
		grepl("points", geomtype(x))
	}
)


setMethod("has.z", signature(x="SpatVector"),
	function(x) {
		x@pntr$has_z()
	}
)


setMethod("geomtype", signature(x="Spatial"),
	function(x){
		type <- sub("spatial", "", as.vector(tolower(class(x)[1])))
		type <- sub("dataframe", "", type)
		if (type %in% c("grid", "pixels")) type <- "raster"
		type
	}
)

setMethod("geom", signature(x="SpatVector"),
	function(x, wkt=FALSE, hex=FALSE, wkb=FALSE, df=FALSE, list=FALSE, xnm="x", ynm="y"){
		if (hex) {
			x@pntr$hex()
		} else if (wkt) {
			x@pntr$wkt()
		} else if (list) {
			x@pntr$get_geometryList(xnm, ynm)
		} else if (wkb) {
			x@pntr$wkb_raw()
		}	else {
			g <- x@pntr$get_geometry()
			g <- do.call(cbind, g)
			colnames(g) <- c("geom", "part", "x", "y", "hole", "z")[1:ncol(g)]
			if (df) {
				data.frame(g)
			} else {
				g
			}
		}
	}
)

setMethod("crds", signature(x="SpatVector"),
	function(x, df=FALSE, list=FALSE){
		if (list) {
			gt <- geomtype(x) 
			if (gt == "lines") {
				x@pntr$linesNA()
			} else if (gt == "polygons") {
				x@pntr$polygonsList()			
			} else {
				x@pntr$coordinates()
			}
		} else {
			g <- x@pntr$coordinates()
			g <- do.call(cbind, g)
			colnames(g) <- c("x", "y", "z")[1:ncol(g)]
			if (df) {
				data.frame(g)
			} else {
				g
			}
		}
	}
)


setMethod("crds", signature(x="SpatRaster"),
	function(x, df=FALSE, na.rm=TRUE, na.all=FALSE){
#		crds( as.points(x, values=(hasValues(x) || (na.rm)), na.rm=na.rm, na.all=na.all), df=df)
		opt <- spatOptions()
		out <- x@pntr$crds(na.rm, na.all, opt)
		messages(x)
		if (df) {
			out <- data.frame(out)
		} else {
			out <- do.call(cbind, out)
		}
		colnames(out) <- c("x", "y")
		out
	}
)


setMethod("dim", signature(x="SpatVector"),
	function(x){
		c(nrow(x), ncol(x))
	}
)

setMethod("dim", signature(x="SpatVectorProxy"),
	function(x){
		c(x@pntr$v$geom_count, x@pntr$v$ncol())
	}
)


as.data.frame.SpatVector <- function(x, row.names=NULL, optional=FALSE, geom=NULL, ...) {
	d <- .getSpatDF(x@pntr$df, ...)
	# fix empty names
	colnames(d)[1:ncol(x)] <- x@pntr$names
	if (!is.null(geom)) {
		geom <- match.arg(toupper(geom), c("WKT", "HEX", "XY"))
		if (geom == "XY") {
			if (!grepl("points", geomtype(x))) {
				error("as.data.frame", 'geom="XY" is only valid for point geometries')
			}
			if (nrow(d) > 0) {
				d <- cbind(d, crds(x))
			} else {
				d <- data.frame(crds(x), ...)
			}
		} else {
			g <- geom(x, wkt=geom=="WKT", hex=geom=="HEX")
			if (nrow(d) > 0) {
				d$geometry <- g
			} else {
				d <- data.frame(geometry=g, stringsAsFactors=FALSE, ...)
			}
		}
	}
	d
}
setMethod("as.data.frame", signature(x="SpatVector"), as.data.frame.SpatVector)


get.data.frame <- function(x) {
	v <- vect()
	v@pntr <- x@pntr$v
	d <- as.data.frame(v)
	d[0,,drop=FALSE]
}


as.list.SpatVector <- function(x, geom=NULL, ...) {
	as.list(as.data.frame(x, geom=geom))
}
setMethod("as.list", signature(x="SpatVector"), as.list.SpatVector)



setMethod ("expanse", "SpatVector",
	function(x, unit="m", transform=TRUE) {
		a <- x@pntr$area(unit, transform, double());
		x <- messages(x, "expanse");
		return(abs(a))
	}
)


setMethod("perim", signature(x="SpatVector"),
	function(x) {
		p <- x@pntr$length();
		x <- messages(x, "perim");
		p
	}
)

setMethod("nseg", signature(x="SpatVector"),
	function(x) {
		p <- x@pntr$nsegments();
		x <- messages(x, "nseg");
		p
	}
)

setMethod("length", signature(x="SpatVector"),
	function(x) {
		x@pntr$size()
	}
)


setMethod("fillHoles", signature(x="SpatVector"),
	function(x, inverse=FALSE) {
		if (inverse) {
			x@pntr <- x@pntr$get_holes()
		} else {
			x@pntr <- x@pntr$remove_holes()
		}
		messages(x, "fillHoles")
	}
)

setMethod("fillHoles", signature(x="SpatRaster"),
	function(x, nearest=FALSE) {
		fh <- function(r) {
			p <- as.polygons(r)
			h <- fillHoles(p, TRUE)
			if (nrow(h) > 0) {
				r <- rasterize(h, r, names(h)[1], update=TRUE)
			}
			if (nearest) {
				a <- aggregate(fillHoles(p))
				ah <- fillHoles(a, TRUE)
				if (nrow(ah) > 0) {
					for (i in 1:nrow(ah)) {
						cls <- cells(x, ah[i])[,2]
						xy <- vect(xyFromCell(x, cls), crs=crs(x))
						r[cls] <- unlist(p[[1]])[nearest(xy, p, centroids=FALSE)$to_id]
					}
				}	
			}	
			messages(r, "fillHoles")
		}
		if (nlyr(x) > 1) {
			rast(lapply(1:nlyr(x), function(i) fh(x[[i]])))
		} else {
			fh(x)
		}
	}
)


#setMethod("eliminate", signature(x="SpatVector"),
#	function(x, y) {
#		x@pntr <- x@pntr$eliminate(y@pntr)
#		messages(x)
#	}
#)



setMethod("centroids", signature(x="SpatVector"),
	function(x, inside=FALSE, correct=FALSE) {
		if (correct) {
			x@pntr <- x@pntr$corrected_centroid(TRUE, isTRUE(inside))
		} else if (inside) {
			x@pntr <- x@pntr$point_on_surface(TRUE)
		} else {
			x@pntr <- x@pntr$centroid(TRUE)
		}
		messages(x, "centroids")
	}
)



setMethod("densify", signature(x="SpatVector"),
	function(x, interval, equalize=TRUE, flat=FALSE) {
		x@pntr <- x@pntr$densify(interval, equalize, flat)
		messages(x, "densify")
	}
)

setMethod("normalize.longitude", signature(x="SpatVector"),
	function(x) {
		if (nrow(x) == 0) return(deepcopy(x))
		nc <- ncol(x)
		fname <- "uuu-_123_uqq_-agg_-id123"
		x[[fname]] <- 1:nrow(x)
		d <- values(x)
		out <- x[,fname]
		out@pntr <- out@pntr$normalize_longitude()
		out <- messages(out)
		a <- aggregate(out, fname, count=FALSE)
		if (nc > 0) {
			a <- merge(a, d, by=fname)
		}
		a[[fname]] <- NULL
		a
	}
)

.cpp_funs <- c("sum", "mean", "median", "modal", "which", "which.min", "which.max", "min", "max", "prod", "any", "all", "none", "sd", "std", "first")

setMethod("sapp", signature(x="SpatRaster"),
function(x, fun, ..., filename="", overwrite=FALSE, wopt=list())  {
	x <- lapply(x, function(r) fun(r, ...))
	x <- rast(x)
	if (filename[1] != "") {
		writeRaster(x, filename, overwrite, wopt=wopt)
	} else {
		tighten(x)
	}
}
)



setMethod("sapp", signature(x="SpatRasterDataset"),
function(x, fun, ..., filename="", overwrite=FALSE, wopt=list())  {
	x <- lapply(as.list(x), function(r) app(r, fun, ...))
	x <- rast(x)
	if (filename != "") {
		writeRaster(x, filename, overwrite, wopt=wopt)
	} else {
		tighten(x)
	}
}
)


export_args <- function(cores, ..., caller="app") {
	vals <- list(...)
	if (length(vals) < 1) return(NULL)
	nms <- names(vals)
	if (any(nms == "")) {
		error(caller, "additional arguments must be named when using multiple cores")
	}
	for (i in seq_along(vals)) {
		assign(nms[i], force(vals[i])) 
	}
	parallel::clusterExport(cores, nms, envir=environment())
}

## similar from predict
#	dots <- list(...)
#	if (length(dots) > 0) {
#		nms <- names(dots)
#		dotsenv <- new.env()
#		lapply(1:length(dots), function(i) assign(nms[i], dots[[i]], envir=dotsenv))
#		parallel::clusterExport(cls, nms, dotsenv)
#	}


setMethod("app", signature(x="SpatRaster"),
function(x, fun, ..., cores=1, filename="", overwrite=FALSE, wopt=list())  {

	txtfun <- .makeTextFun(fun)
	if (inherits(txtfun, "character")) {
		if (txtfun %in% .cpp_funs) {
			opt <- spatOptions(filename, overwrite, wopt=wopt)
			na.rm <- isTRUE(list(...)$na.rm)
			x@pntr <- x@pntr$summary(txtfun, na.rm, opt)
			return(messages(x, "app"))
		}
	}
	fun <- match.fun(fun)
	out <- rast(x)
	nlyr(out) <- 1
	nc <- ncol(x)
	readStart(x)
	on.exit(readStop(x))
	nl <- nlyr(x)

	dots <- list(...)
	if (length(dots) > 0) {
		test <- any(sapply(dots, function(i) inherits(i, "SpatRaster")))
		if (test) {
			error("app", "additional arguments cannot be a SpatRaster")
		}
	}
	
	if (any(is.factor(x))) {
		warn("app", "factors are coerced to numeric")
	}
	
# figure out the shape of the output by testing with up to 13 cells
	teststart <- max(1, 0.5 * nc - 6)
	testend <- min(teststart + 12, nc)
	ntest <- 1 + testend - teststart

	v <- readValues(x, round(0.51*nrow(x)), 1, teststart, ntest, mat=TRUE)
	usefun <- FALSE
	if (nl==1) {
		r <- fun(v, ...)
		usefun <- TRUE
	} else {
		r <- try(apply(v, 1, fun, ...), silent=TRUE)
		if (inherits(r, "try-error")) {
			rr <- try(fun(v, ...), silent=TRUE)
			if (inherits(rr, "try-error")) {
				error("app", paste0("cannot use this function\n", attr(r, "condition")))
			} else {
				usefun <- TRUE
				r <- rr
			}
		}
	}
	if (is.list(r)) {
		if (length(unique(sapply(r, length))) >  1) {
			error("app", "'fun' returns a list (should be numeric or matrix).\nPerhaps because returned values have different lengths due to NAs in input?")
		} else {
			error("app", "'fun' returns a list (should be numeric or matrix)")
		}
	}
	trans <- FALSE
	if (NCOL(r) > 1) {
		#? if ((ncol(r) %% ntest) == 0) {
		if (ncol(r) == ntest) {
			nlyr(out) <- nrow(r)
			trans <- TRUE
			nms <- rownames(r)
		} else if (nrow(r) == ntest) {
			nlyr(out) <- ncol(r)
			nms <- colnames(r)
		} else {
			error("app", "the number of values returned by 'fun' is not appropriate\n(it should be the product of the number of cells and and a positive integer)")
		}
		if (is.null(wopt$names)) {
			wopt$names <- nms
		}
	} else {
		if ((length(r) %% ntest) != 0) {
			error("app", "the number of values returned by 'fun' is not appropriate")
		} else {
			nlyr(out) <- length(r) / ntest
		}
	}

	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	}

	ncops <- nlyr(x) / nlyr(out)
	ncops <- ifelse(ncops > 1, ceiling(ncops), 1) * 4
	b <- writeStart(out, filename, overwrite, wopt=wopt, n=ncops, sources=sources(x))

	if (doclust) {
		ncores <- length(cores)
		export_args(cores, ...)
		for (i in 1:b$n) {
			v <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
			icsz <- max(min(100, ceiling(b$nrows[i] / ncores)), b$nrows[i])
			r <- parallel::parRapply(cores, v, fun, ..., chunk.size=icsz)
			if (nlyr(out) > 1) {
				r <- matrix(r, ncol=nlyr(out), byrow=TRUE)
			}
			writeValues(out, r, b$row[i], b$nrows[i])
		}
	} else {
		if (usefun) {
			for (i in 1:b$n) {
				v <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
				r <- fun(v, ...)
				if (trans) {
					r <- t(r)
				}
				writeValues(out, r, b$row[i], b$nrows[i])
			}
		} else {
			for (i in 1:b$n) {
				v <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
				r <- apply(v, 1, fun, ...)
				if (trans) {
					r <- t(r)
					#r <- as.vector(r)
				}
				writeValues(out, r, b$row[i], b$nrows[i])
			}
		}
	}
	writeStop(out)
}
)



.app_test_stack <- function(v, fun, ncols, ...) {
# figure out the shape of the output
	nms = ""
	nr <- nrow(v[[1]])
	v <- lapply(v, as.vector)
	v <- do.call(cbind, v)
	r <- apply(v, 1, fun, ...)
	if (inherits(r, "try-error")) {
		nl <- -1
	}

	trans <- FALSE
	if (NCOL(r) > 1) {
		#? if ((ncol(r) %% nc) == 0) {
		if (ncol(r) == ncols) {
			nl <- nrow(r)
			trans <- TRUE
		} else if (nrow(r) == ncols) {
			nl <- ncol(r)
		} else {
			error("app", "cannot handle 'fun'")
		}
	} else if (length(r) >= nr) {
		if ((length(r) %% nr) == 0) {
			nl <- length(r) / nr
		} else {
			nl <- -1
		}
	} else {
		nl <- -1
	}
	if (is.matrix(r)) {
		nms <- colnames(r)
	}
	list(nl=nl, trans=trans, names=nms)
}



.app_test_stack <- function(v, fun, ncols, ...) {
# figure out the shape of the output
	nms = ""
	nr <- nrow(v[[1]])
	v <- lapply(v, as.vector)
	v <- do.call(cbind, v)
	r <- apply(v, 1, fun, ...)
	if (inherits(r, "try-error")) {
		nl <- -1
	}

	trans <- FALSE
	if (NCOL(r) > 1) {
		#? if ((ncol(r) %% nc) == 0) {
		if (ncol(r) == ncols) {
			nl <- nrow(r)
			trans <- TRUE
		} else if (nrow(r) == ncols) {
			nl <- ncol(r)
		} else {
			error("app", "'fun' is not appropriate")
		}
	} else if (length(r) >= nr) {
		if ((length(r) %% nr) == 0) {
			nl <- length(r) / nr
		} else {
			nl <- -1
		}
	} else {
		nl <- -1
	}
	if (is.matrix(r)) {
		nms <- colnames(r)
	}
	list(nl=nl, trans=trans, names=nms)
}



setMethod("app", signature(x="SpatRasterDataset"),
function(x, fun, ..., cores=1, filename="", overwrite=FALSE, wopt=list())  {

	txtfun <- .makeTextFun(match.fun(fun))
	if (inherits(txtfun, "character")) {
		if (txtfun %in% .cpp_funs) {
			opt <- spatOptions(filename, overwrite, wopt=wopt)
			narm <- isTRUE(list(...)$na.rm)
			r <- rast()
			r@pntr <- x@pntr$summary(txtfun, narm, opt)
			return (messages(r, "app") )
		}
	}

	if (missing(fun)) error("app", "'fun' is missing")

	ncx <- ncol(x[1])
	nrx <- nrow(x[1])
	readStart(x)
	on.exit(readStop(x))

	v <- lapply(1:length(x), function(i) readValues(x[i], round(0.51*nrx), 1, 1, ncx, mat=TRUE))
	test <- .app_test_stack(v, fun, ncx, ...)
	if (test$nl < 1) error("app", "cannot find 'fun'")
	out <- rast(x[1], nlyrs=test$nl)
	if (length(test$names == test$nl)) {
		if (is.null(wopt$names)) wopt$names <- test$names
	}

	nc <- (nlyr(x[1]) * length(x)) / nlyr(out)
	nc <- ifelse(nc > 1, ceiling(nc), 1) * 3
	b <- writeStart(out, filename, overwrite, wopt=wopt, n=nc, sources=unlist(sources(x)))


	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	} else {
		doclust <- FALSE
	}

	if (doclust) {
		ncores <- length(cores)
		export_args(cores, ...)
		for (i in 1:b$n) {
			v <- lapply(1:length(x), function(s) as.vector(readValues(x[s], b$row[i], b$nrows[i], 1, ncx, mat=TRUE)))
			v <- do.call(cbind, v)
			icsz <- max(min(100, ceiling(b$nrows[i] / ncores)), b$nrows[i])
			r <- parallel::parRapply(cores, v, fun, ..., chunk.size=icsz)
			if (test$trans) {
				r <- t(r)
			}
			writeValues(out, r, b$row[i], b$nrows[i])

		}
	} else {
		for (i in 1:b$n) {
			v <- lapply(1:length(x), function(s) as.vector(readValues(x[s], b$row[i], b$nrows[i], 1, ncx, mat=TRUE)))
			r <- apply(do.call(cbind, v), 1, fun, ...)
			if (test$trans) {
				r <- t(r)
			}
			writeValues(out, r, b$row[i], b$nrows[i])
		}
	}
	#readStop(x)
	writeStop(out)
}
)

# Author: Robert J. Hijmans
# Date :  June 2008
# Version 1.0
# License GPL v3


setMethod("hist", signature(x="SpatRaster"),
	function(x, layer, maxcell=1000000, plot=TRUE, maxnl=16, main, ...) {

		if (missing(layer)) {
			y <- 1:nlyr(x)
		} else if (is.character(layer)) {
			y <- match(layer, names(x))
			maxnl <- Inf
		} else {
			y <- layer
			maxnl <- Inf
		}

		y <- as.integer(round(y))
		y <- stats::na.omit(y)
		y <- y[ y >= 1 & y <= nlyr(x) ]
		nl <- length(y)

		if (nl == 0) {
			error("hist", "no valid layers selected")
		}

		if (missing(main)) {
			main=names(x)
		}

		if (nl > 1)	{
			res <- list()
			if (nl > maxnl) {
				warn(paste("hist", "only the first", maxnl, "layers are used (see argument maxnl)"))
				nl <- maxnl
				y <- y[1:maxnl]
			}

			nc <- ceiling(sqrt(nl))
			nr <- ceiling(nl / nc)
			mfrow <- graphics::par("mfrow")
			spots <- mfrow[1] * mfrow[2]
			if (spots < nl) {
				old.par <- graphics::par(no.readonly =TRUE)
				on.exit(graphics::par(old.par))
				graphics::par(mfrow=c(nr, nc))
			}
			for (i in 1:length(y)) {
				res[[i]] = .hist1(x[[ y[i] ]], maxcell=maxcell, main=main[y[i]], plot=plot, ...)
			}

		} else if (nl==1) {
			if (nlyr(x) > 1) {
				x <- x[[y]]
				main <- main[y]
			}
			res <- .hist1(x, maxcell=maxcell, main=main, plot=plot, ...)
		}
		if (plot) {
			return(invisible(res))
		} else {
			return(res)
		}
	}
)



.hist1 <- function(x, maxcell, main, plot, ...){

	stopifnot(hasValues(x))

	if ( ncell(x) <= maxcell ) {
		v <- stats::na.omit(values(x))
	} else {
		# TO DO: make a function that does this by block and combines  all data into a single histogram
		v <- spatSample(x, maxcell, method="regular", as.df=FALSE, as.raster=FALSE, warn=FALSE)
		msg <- paste("a sample of ", round(100 * length(v) / ncell(x)), "% of the cells was used", sep="")
		if (any(is.na(v))) {
			v <- stats::na.omit(v)
			msg <- paste(msg, " (of which ", 100 - round(100 * length(v) / maxcell ), "% was NA)", sep="")
		}
		warn("hist", msg)
	}

	if (nrow(v) == 0) {
		error("hist", "all (sampled) values are NA")
	}

#	if (.shortDataType(x) == 'LOG') {
#		v <- v * 1
#	}

	if (plot) {
		out <- hist(v, main=main, plot=plot, ...)
	} else {
		out <- hist(v, plot=plot, ...)
	}
	out$xname <- names(x)
	out
}

# Author: Robert J. Hijmans
# Date :  August 2009
# Version 0.9
# License GPL v3


setMethod("interpolate", signature(object="SpatRaster"),
	function(object, model, fun=predict, ..., xyNames=c("x", "y"), factors=NULL, const=NULL, index=NULL, cores=1, cpkgs=NULL, na.rm=FALSE, filename="", overwrite=FALSE, wopt=list()) {

		out <- rast(object)
		hv <- hasValues(object)
		nms <- c(xyNames, names(object))
		if (length(unique(nms)) != length(nms)) {
			tab <- table(nms)
			error("interpolate", "duplicate names: ", tab[tab>1])
		}
		nc <- ncol(out)
		testrow <- round(0.51*nrow(object))
		ntest <- min(nc, 500)
		xy <- xyFromCell(out, cellFromRowCol(out, testrow, 1):cellFromRowCol(out, testrow, ntest))
		colnames(xy) <- xyNames
		if (hv) {
			readStart(object)
			on.exit(readStop(object))
			d <- readValues(object, testrow, 1, 1, ntest, TRUE, TRUE)
			xy <- cbind(xy, d)
		}
		r <- .runModel(model, fun, xy, 1, const, (na.rm & hv), index, cores=NULL, ...)
		rdim <- dim(r)
		if (!is.null(rdim)) {
			if (rdim[1] == 1) {
				nl <- rdim[1]
			} else {
				nl <- rdim[2]
			}
		} else {
			nl <- 1
		}
		out <- rast(object, nlyrs=nl)
		cn <- colnames(r)
		if (length(cn) == nl) names(out) <- make.names(cn, TRUE)

		doclust <- FALSE
		if (inherits(cores, "cluster")) {
			doclust <- TRUE
		} else if (cores > 1) {
			doclust <- TRUE
			cores <- parallel::makeCluster(cores)
			on.exit(parallel::stopCluster(cores), add=TRUE)
		}
		if (doclust) {
			parallel::clusterExport(cores, c("model", "fun"), environment())
			if (!is.null(cpkgs)) {
				parallel::clusterExport(cores, "cpkgs", environment())
				parallel::clusterCall(cores, function() for (i in 1:length(cpkgs)) {library(cpkgs[i], character.only=TRUE) })
			}
			export_args(cores, ..., caller="interpolate")			
		} else {
			cores <- NULL
		}
		
		b <- writeStart(out, filename, overwrite, sources=sources(object), wopt=wopt)
		for (i in 1:b$n) {
			xy <- xyFromCell(out, cellFromRowCol(out, b$row[i], 1):cellFromRowCol(out, b$row[i]+b$nrows[i]-1, nc))
			colnames(xy) <- xyNames
			if (hv) {
				d <- readValues(object, b$row[i], b$nrows[i], 1, nc, TRUE, TRUE)
				xy <- cbind(xy, d)
			}
			v <- .runModel(model, fun, xy, nl, const, (na.rm & hv), index, cores=cores, ...)
			writeValues(out, v, b$row[i], b$nrows[i])
		}
		writeStop(out)
	}
)

.get.leg.coords <- function(x) {

	if (is.null(x$leg$ext)) {
		if (x$clip) {
			p <- x$leg$ext <- x$lim
		} else {
			p <- x$leg$ext <- graphics::par("usr")		
		}
	} else {
		p <- as.vector(x$leg$ext)
	}
	xmin <- p[1]
	xmax <- p[2]
	ymin <- p[3]
	ymax <- p[4]
	flip <- x$leg$reverse
	
	if (!is.null(x$leg$shrink)) {
		s <- x$leg$shrink
		if ((s[1] <= 1) & (s[1] >= 0.5)) {
			s[1] <- 2*(s[1] - 0.5)
		} else if (s[1] < 0.5) {
			s[1] <- (2*(0.5 - s[1]))
			flip <- TRUE
		}
		x$leg$size <- s
	} 
	
	if (is.null(x$leg$size)) {
		x$leg$size <- c(1,1)
	} else if (length(x$leg$size) == 1) {
		x$leg$size <- c(x$leg$size, 1)
	}
	x$leg$size <- abs(x$leg$size)

	if (!is.null(x$leg$main)) {
		n <- length(x$leg$main)
		x$leg$size[1] <- min(x$leg$size[1], (1 - .05*n))
	}

	if (x$leg$horiz) {
		rhalf <- (xmax - xmin) / 2
		xmid <- xmin + rhalf
		xd <- rhalf * x$leg$size[1]
		xmin <- xmid - xd 
		xmax <- xmid + xd
		
#		yd <- (ymax - ymin) * x$leg$size[1]/1.5
#		ymin <- ymin + yd
#		ymax <- ymax - yd

		yd <- ymax - ymin
		if (isTRUE(x$leg$x[1] == "top")) {
			ymax <- ymin + yd * x$leg$size[2] 		
		} else {
			ymin <- ymax - yd * x$leg$size[2] 
		}
		if (flip) {
			tmp <- xmin
			xmin <- xmax
			xmax <- tmp
		}
	} else {

#		rhalf <- (ymax - ymin) / 2
#		ymid <- ymin + rhalf
#		yd <- rhalf * x$leg$size[1]
#		ymin <- ymid - yd 
#		ymax <- ymid + yd

		rng <- (ymax - ymin) * x$leg$size[1]
		ymin <- ymax - rng  

		xd <- xmax - xmin
		#xmin <- xmin + xd * x$leg$size[2]/5
		#xmax <- xmax - xd * x$leg$size[2]/5
		xmax <- xmin + xd * x$leg$size[2] 
		
		if (flip) {
			tmp <- ymin
			ymin <- ymax
			ymax <- tmp
		}
    }
	dx <- xmax - xmin
	dy <- ymax - ymin

	x$leg$ext <- data.frame(xmin=xmin, xmax=xmax, ymin=ymin, ymax=ymax, dx=dx, dy=dy)
	.nudge_ext(x)
}


.line.usr <- function(line, side) {
## https://stackoverflow.com/questions/30765866/get-margin-line-locations-in-log-space/30835971#30835971

	lh <- graphics::par("cin")[2] * graphics::par("cex") * graphics::par("lheight")
	x_off <- diff(graphics::grconvertX(c(0, lh), "inches", "npc"))
	y_off <- diff(graphics::grconvertY(c(0, lh), "inches", "npc"))
	if (side == 1) {
		graphics::grconvertY(-line * y_off, "npc", "user")
	} else if (side ==2) {
		graphics::grconvertX(-line * x_off, "npc", "user")
	} else if (side ==3) {
		graphics::grconvertY(1 + line * y_off, "npc", "user")
	} else {
		graphics::grconvertX(1 + line * x_off, "npc", "user")
	}
}


.get.leg.extent <- function(x) {

	if (!is.null(x$leg[["ext"]])) {
		x$leg$x <- x$leg$ext
		x$leg$ext <- NULL
	}
	if (inherits(x$leg[["x"]], "SpatExtent")) {
		e <- as.vector(x$leg$x)
		x$leg$x <- e[1]
		x$leg$y <- c(e[3:4])
		if (is.null(x$leg$horiz)) {
			if (diff(p[1:2]) > diff(p[3:4])) {
				x$leg$horiz <- TRUE
			} else {
				x$leg$horiz <- TRUE
			}
		}
	}
		
	loc <- x$leg[["x"]]
	if (x$clip) {
		usr <- x$lim
	} else {
		usr <- graphics::par("usr")
	}
	xmin <- usr[1]
	xmax <- usr[2]
	ymin <- usr[3]
	ymax <- usr[4]

	dxy <- graphics::par("cxy") * graphics::par("cex")
	p <- NULL
	if (is.character(loc)) {
		if (loc == "left") {
			#s <- .line.usr(trunc(graphics::par("mar")[2]), 2)
			#p <- c(s+4*dxy[1], s+5*dxy[1], ymin, ymax)	
			if (any(2 %in% x$axs$lab)) {
				p <- c(xmin-4*dxy[1], xmin-3*dxy[1], ymin, ymax)			
			} else {
				p <- c(xmin-2*dxy[1], xmin-dxy[1], ymin, ymax)
			}
		} else if (loc == "bottom") {
			s <- .line.usr(trunc(graphics::par("mar")[1]), 1)
			p <- c(xmin, xmax, s+1.75*dxy[2], s+2.25*dxy[2])
		} else if (loc == "top") {
			p <- c(xmin, xmax, ymax+.6*dxy[2], ymax+1*dxy[2])
		} else if (loc == "topright") {
			p <- c(xmax+dxy[1], xmax+2*dxy[1], ymin + (ymax-ymin) / 2, ymax)
			x$leg$x <- "right"
		} else if (loc == "bottomright") {
			p <- c(xmax+dxy[1], xmax+2*dxy[1], ymin, ymax - (ymax-ymin) / 2)
			x$leg$x <- "right"
		} else { #if (loc == "right" or "default" 
			p <- c(xmax+dxy[1], xmax+2*dxy[1], ymin, ymax)
			if (isTRUE(x$leg$yshift)) {
				hy <- (ymax - ymin) / 2
				p[3:4] <- p[3:4] - hy
			}
		}
	} else {
		X <- x$leg[["x"]]	
		Y <- x$leg[["y"]]
		if (is.null(X) || (length(X)==0)) {
			if (x$leg$horiz) {
				X <- c(xmin+dxy[1], xmax-dxy[1])			
			} else {
				X <- c(xmax+dxy[1], xmax+2*dxy[1])
			}
		} else if (length(X) == 1) {
			if (x$leg$horiz) {
				X <- c(X, xmax-dxy[1])
			} else {
				X <- c(X, X+dxy[1])			
			}
		}
		if (is.null(Y) || (length(Y) == 0)) {
			if (length(X) >= 4) {
				Y <- X[3:4]
				X <- X[1:2]
			} else {
				if (x$leg$horiz) {
					s <- .line.usr(trunc(graphics::par("mar")[1]), 1)
					Y <- c(s+1.75*dxy[2], s+2.25*dxy[2])
				} else {
					Y <- c(ymin+dxy[2], ymax-dxy[2])
				}
			}
		} else if (length(Y) == 1) {
			if (x$leg$horiz) {
				Y <- c(Y, Y+.5*dxy[2])
			} else {
				Y <- c(ymin + (ymax-ymin)/50, Y) 			
			}
		}
		p <- c(X[1:2], Y[1:2])
		if (any(is.na(p))) stop("plot", "legend coordinates cannot be NA")
	}

	x$leg$ext <- p
	x$leg$user <- FALSE
	.get.leg.coords(x)
}




.plot.cont.legend <- function(x, ...) {

	accepted <- c("in", "out", "none", "middle", "through", "throughout")
	if (!is.null(x$leg[["tic"]])) {
		tics <- accepted[pmatch(x$leg$tic[1], accepted[-6], 6)]
	} else if (!is.null(x$leg[["tick"]])) {
		tics <- accepted[pmatch(x$leg$tick[1], accepted[-6], 6)]
	} else {
		tics <- "throughout"
	}

	if (!is.null(x$leg[["tic.box.col"]])) {
		ticboxcol <- x$leg$tic.box.col[1]
	} else if (!is.null(x$leg[["tick.box.col"]])) {
		ticboxcol <- x$leg$tick.box.col[1]
	} else {
		ticboxcol <- "black"
	}
	if (!is.null(x$leg[["tic.col"]])) {
		ticcol <- x$leg$tic.col[1]
	} else if (!is.null(x$leg[["tick.col"]])) {
		ticcol <- x$leg$tick.col[1]
	} else {
		ticcol <- "black"
	}
	if (!is.null(x$leg[["tic.lwd"]])) {
		ticlwd <- x$leg$tic.lwd[1]
	} else if (!is.null(x$leg[["tick.lwd"]])) {
		ticlwd <- x$leg$tick.lwd[1]
	} else {
		ticlwd <- 1
	}
	boxlwd <- 1 # lwdd?

	x$leg$horiz <- isTRUE(x$leg$horiz)
	if (is.null(x$leg[["x"]])) {
		x$leg$x <- "right"
	} else if (is.character(x$leg[["x"]])) {
		if (!(x$leg$x %in% c("left", "right", "top", "bottom", "topright", "bottomright"))) {
			x$leg$x <- "right"	
		} else if (x$leg$x %in% c("top", "bottom")) {
			x$leg$horiz <- TRUE
		}
	}

	x <- .get.leg.extent(x)

	if (is.null(x$leg[["cex"]])) {
		cex <- 1
	} else {
		cex <- x$leg$cex
	}
	cex <- cex * 0.8
	
	if (!is.null(x$leg[["rotate"]])) {
		srt <- ifelse(isTRUE(x$leg$rotate), 90, 0)
	} else if (!is.null(x$leg$srt)) {
		srt <- x$leg$srt
	} else {
		srt <- 0	
	}
	
	cols <- rev(x[["cols"]])
	nc <- length(cols)

	zlim <- x[["range"]]
	zz <- x$leg[["at"]]
	if (is.null(zz)) {
		if (is.null(x[["levels"]])){
			x$levels <- 5
		}
		zz <- pretty(zlim, n =(x$levels+1))
		zz <- zz[zz >= zlim[1] & zz <= zlim[2]]
	}
	zztxt <- x$leg[["labels"]]
	if (is.null(zztxt)) {
		form <- x$leg[["format"]]
		if (is.null(form)) form <- "f"
		zztxt <- trimws(formatC(zz, digits=x$leg[["digits"]], format = form))
		if (x$fill_range) {
			if (isTRUE(x$range_filled[1])) zztxt[1] <- paste0("< ", zztxt[1])		
			if (isTRUE(x$range_filled[2])) zztxt[length(zztxt)] <- paste0("> ", zztxt[length(zztxt)])		
		}
	}

	e <- x$leg[["ext"]]
	P <- x$leg[["x"]]
	if (is.numeric(P)) {
		if (isTRUE(x$leg$horiz)) {
			P <- "bottom"		
		} else {
			P <- "right"
		}
	}

		
	ticklength <- x$leg[["tick.length"]]
	if (is.null(ticklength)) ticklength <- 1

	if (!is.null(x$leg$bg)) {
		strh <- graphics::strheight("M", cex=cex)
		lw <- max(graphics::strwidth(zztxt, cex=cex))
		toff <- 0.5 * strh
		has_title <- isTRUE("title" %in% names(x$leg))
		pad <- strh * 0.8
		if (P == "right") {
			bg_x0 <- e$xmin - pad
			bg_x1 <- e$xmax + e$dx * 0.2 + toff + lw + pad
			bg_y0 <- e$ymin - pad
			bg_y1 <- e$ymax + pad
			if (has_title) bg_y1 <- bg_y1 + 2 * strh
		} else if (P == "left") {
			bg_x0 <- e$xmin - e$dx * 0.2 - toff - lw - pad
			bg_x1 <- e$xmax + pad
			bg_y0 <- e$ymin - pad
			bg_y1 <- e$ymax + pad
			if (has_title) bg_y1 <- bg_y1 + 2 * strh
		} else if (P == "bottom") {
			bg_x0 <- e$xmin - pad
			bg_x1 <- e$xmax + pad
			bg_y0 <- e$ymin - e$dy - strh - pad
			bg_y1 <- e$ymax + pad
			if (has_title) bg_y1 <- bg_y1 + 2 * strh
		} else {
			bg_x0 <- e$xmin - pad
			bg_x1 <- e$xmax + pad
			bg_y0 <- e$ymin - pad
			bg_y1 <- e$ymax + 1.5 * e$dy + strh + pad
			if (has_title) bg_y1 <- bg_y1 + 2 * strh
		}
		graphics::rect(bg_x0, bg_y0, bg_x1, bg_y1,
			col=x$leg$bg, border=x$leg$bg, xpd=NA)
	}

	if (P %in% c("left", "right")) {
		Y <- seq(e$ymin, e$ymax, length.out=nc+1)
		graphics::rect(e$xmin, Y[-(nc + 1)], e$xmax, Y[-1], col=rev(cols), border=NA, xpd=NA, lwd=boxlwd)
		ypos <- e$ymin + (zz - zlim[1])/(zlim[2] - zlim[1]) * e$dy
		if (P == "right") {
			if (tics == "throughout") {
				graphics::segments(e$xmin, ypos, e$xmax+e$dx*0.25*ticklength, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "through") {
				graphics::segments(e$xmin, ypos, e$xmax, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "middle") {
				graphics::segments(e$xmin+e$dx*0.25, ypos, e$xmax-e$dx*0.25, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "in") {
				graphics::segments(e$xmax-e$dx*0.25, ypos, e$xmax, ypos, xpd=NA, col=ticcol, lwd=ticlwd)			
			} else if (tics == "out") {
				graphics::segments(e$xmax, ypos, e$xmax+e$dx*0.25*ticklength, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			}
			text(e$xmax+e$dx*0.2, ypos, zztxt, pos=4, xpd=NA, cex=cex, srt=srt, font=x$leg$font, col=x$leg$col, ...)
		} else {
			if (tics == "throughout") {
				graphics::segments(e$xmin-e$dx*0.25*ticklength, ypos, e$xmax, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "through") {
				graphics::segments(e$xmin, ypos, e$xmax, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "middle") {
				graphics::segments(e$xmin+e$dx*0.25, ypos, e$xmax-e$dx*0.25, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "in") {
				graphics::segments(e$xmin, ypos, e$xmin+e$dx*0.25, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "out") {
				graphics::segments(e$xmin-e$dx*0.25*ticklength, ypos, e$xmin, ypos, xpd=NA, col=ticcol, lwd=ticlwd)
			}
			text(e$xmin-e$dx*0.2, ypos, zztxt, pos=2, xpd=NA, cex=cex, srt=srt, font=x$leg$font, col=x$leg$col, ...)
		}
	} else { # top, bottom
		X <- seq(e$xmin, e$xmax, length.out=nc+1)
		graphics::rect(X[-(nc + 1)], e$ymin, X[-1], e$ymax, col=rev(cols), border=NA, xpd=NA, lwd=boxlwd)
		xpos <- e$xmin + (zz - zlim[1])/(zlim[2] - zlim[1]) * e$dx
		
		if (P == "bottom") {
			if (tics == "throughout") {
				graphics::segments(xpos, e$ymin-e$dy*0.25*ticklength, xpos, e$ymax, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "through") {
				graphics::segments(xpos, e$ymin, xpos, e$ymax, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "middle") {
				graphics::segments(xpos, e$ymax-e$dy*0.25, xpos, e$ymin+e$dy*0.25, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "in") {
				graphics::segments(xpos, e$ymin+e$dy*0.25, xpos, e$ymin, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "out") {
				graphics::segments(xpos, e$ymin-e$dy*0.25*ticklength, xpos, e$ymin, xpd=NA, col=ticcol, lwd=ticlwd)
			}
			text(xpos, e$ymin-e$dy, zztxt, pos=NULL, xpd=NA, cex=cex, srt=srt, font=x$leg$font, col=x$leg$col, ...)
		} else {
			if (tics == "throughout") {
				graphics::segments(xpos, e$ymin, xpos, e$ymax+e$dy*0.25*ticklength, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "through") {
				graphics::segments(xpos, e$ymin, xpos, e$ymax, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "middle") {
				graphics::segments(xpos, e$ymax-e$dy*0.25, xpos, e$ymin+e$dy*0.25, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "in") {
				graphics::segments(xpos, e$ymax, xpos, e$ymax-e$dy*0.25, xpd=NA, col=ticcol, lwd=ticlwd)
			} else if (tics == "out") {
				graphics::segments(xpos, e$ymax, xpos, e$ymax+e$dy*0.25*ticklength, xpd=NA, col=ticcol, lwd=ticlwd)
			}
			text(xpos, e$ymax+1.5*e$dy, zztxt, pos=NULL, xpd=NA, cex=cex, srt=srt, font=x$leg$font, col=x$leg$col, ...)
		}
	}
	graphics::rect(e$xmin, e$ymin, e$xmax, e$ymax, border=ticboxcol, xpd=NA)


    if (isTRUE("title" %in% names(x$leg))) {
		leg_i <- x$leg$leg_i
		if (is.null(leg_i)) leg_i = 1
	    if (leg_i <= length(x$leg$title)) {
			legtitle <- x$leg$title[leg_i]
		} else {
			legtitle <- x$leg$title[1]		
		}
		if ((is.null(x$leg[["title.x"]])) || (is.null(x$leg[["title.y"]]))) {
			#e <- x$leg$ext
			x$leg$title.y <- e$ymax
			if (x$leg$horiz) {
				x$leg$title.x <- e$xmin + (e$xmax - e$xmin) / 2
				if (identical(P, "top")) {
					x$leg$title.y <- e$ymax + 2 * (e$ymax - e$ymin)
				}
			} else {
				x$leg$title.x <- e$xmax	
			}
			if (length(legtitle) > 1) { # or perhaps !inherits(legtitle, "expression")
				if (x$leg$horiz) {
					legtitle <- paste(legtitle, collapse=" ")
				} else {
					legtitle <- paste(legtitle, collapse="\n")		
				}
			} 
		}
		pos <- 3
		if (!is.null(x$leg[["title.pos"]])) pos <- x$leg$title.pos

		# offset=.5*graphics::strheight("a",cex=x$leg$title.cex)
		text(x=x$leg$title.x, y=x$leg$title.y, labels=legtitle, pos=pos, cex=x$leg$title.cex, xpd=NA, adj=x$leg$title.adj, font=x$leg$title.font, col=x$leg$title.col, srt=x$leg$title.srt)
	}
	x
}

#Author: Robert J. Hijmans
#Date : April 2015
#Version 1.0
#Licence GPL v3


setMethod("rowSums", signature(x="SpatRaster"), 
	function(x, na.rm = FALSE, dims = 1L, ...) {
	
		nl <- nlyr(x)
		nc <- ncol(x)
		readStart(x)
		on.exit(readStop(x))
		b <- blocks(x, n=4)
		s <- vector("list", b$n)
		for (i in 1:b$n) {
			v <- readValues(x, row=b$row[i], nrows=b$nrows[i])
			s[[i]] <- .colSums(v, nc, b$nrows[i]*nl, na.rm=na.rm)
		}
		s <- t(matrix(unlist(s), nrow=nl, byrow=TRUE))
		colnames(s) <- names(x)
		s
	}
)


setMethod("colSums", signature(x="SpatRaster"), 
	function(x, na.rm = FALSE, dims = 1L, ...) {
		nl <- nlyr(x)
		nc <- ncol(x)
		readStart(x)
		on.exit(readStop(x))
		b <- blocks(x, n=4)
		s <- matrix(nrow=b$n, ncol=nc*nl) 
		for (i in 1:b$n) {
			v <- readValues(x, row=b$row[i], nrows=b$nrows[i], mat=TRUE)
			for (j in 1:nl) {
				k <- (j-1) * nc + 1
				k <- k:(k+nc-1)
				s[i, k] <- .colSums(matrix(v[,j], nrow=b$nrows[i], byrow=TRUE), b$nrows[i], nc, na.rm=na.rm)
			}
		}
		s <- matrix(.colSums(s, nrow(s), ncol(s), na.rm=na.rm), ncol=nl)
		colnames(s) <- names(x)
		return(s)
	}
)



setMethod("rowMeans", signature(x="SpatRaster"), 
	function(x, na.rm = FALSE, dims = 1L, ...) {
	
		nl <- nlyr(x)
		nc <- ncol(x)
		readStart(x)
		on.exit(readStop(x))
		b <- blocks(x, n=4)
		s <- vector("list", b$n)
		for (i in 1:b$n) {
			v <- readValues(x, row=b$row[i], nrows=b$nrows[i])
			s[[i]] <- .colMeans(v, nc, b$nrows[i]*nl, na.rm=na.rm)
		}
		s <- t(matrix(unlist(s), nrow=nl, byrow=TRUE))
		colnames(s) <- names(x)
		s
	}
)


setMethod("colMeans", signature(x="SpatRaster"), 
	function(x, na.rm = FALSE, dims = 1L, ...) {
		nl <- nlyr(x)
		nc <- ncol(x)
		readStart(x)
		on.exit(readStop(x))
		b <- blocks(x, n=4)
		s <- matrix(nrow=b$n, ncol=nc*nl) 
		for (i in 1:b$n) {
			v <- readValues(x, row=b$row[i], nrows=b$nrows[i], mat=TRUE)
			for (j in 1:nl) {
				k <- (j-1) * nc + 1
				k <- k:(k+nc-1)
				s[i, k] <- .colMeans(matrix(v[,j], nrow=b$nrows[i], byrow=TRUE), b$nrows[i], nc, na.rm=na.rm)
			}
		}
		s <- matrix(.colSums(s, nrow(s), ncol(s), na.rm=na.rm), ncol=nl)
		colnames(s) <- names(x)
		return(s)
	}
)

setMethod("meta", signature(x="SpatRaster"),
	function(x, layers=FALSE) {
		f <- function(i) {
			if (length(i) == 0) {
				matrix(ncol=2, nrow=0)
			} else {
				matrix(unlist(regmatches(i, regexpr("=", i), invert=TRUE)), ncol=2, byrow=TRUE)
			}
		}
		lapply(x@pntr$metadata(layers), f)
	}
)


setMethod("metags", signature(x="SpatRaster"),
	function(x, layer=NULL, name=NULL) {
		if (!is.null(layer)) {
			if (is.character(layer)) layer = match(layer, names(x))
			v <- x@pntr$getLyrTags(layer-1)
			out <- matrix(v, ncol=3, byrow=TRUE, dimnames = list(NULL, c("layer", "name", "value")))
			out <- data.frame(out)
			out$layer <- as.numeric(out$layer) + 1
			if (!is.null(name)) {
				out <- out[out$name == name, , drop=FALSE]
			} 
		} else {
			out <- do.call(cbind, x@pntr$getTags())
			if (is.null(out)) return(out)
			colnames(out) <- c("domain", "name", "value")
			out <- data.frame(out)
			if (!is.null(name)) {
				out <- out[out$name == name, ]
			} 
			out <- out[, c(2,3,1)]
		}
		out
	}
)


parse_tags <- function(value, domain) {
	if (NCOL(value) == 1) {
		if (!is.null(names(value)) && (!any(grepl("=", value)))) {
			value <- cbind(names(value), value)	
		} else {	
			
			val <- strsplit(value, "=")
			i <- sapply(val, length) == 1
			if (sum(i) > 0) {
				j <- which(i)
				for (i in j) val[[i]] <- c(val[[i]], "")
			}
			i <- sapply(val, length) == 2
			val <- do.call(rbind, val[i])

			dom <- strsplit(val[,1], ":")
			n <- sapply(dom, length) 
			i <- n == 1
			if (sum(i) > 0) {
				for (i in which(i)) dom[[i]] <- c("", dom[[i]])
			}
			n <- sapply(dom, length) 
			i <- n > 2
			if (sum(i) > 0) {
				for (i in which(i)) dom[[i]] <- c(dom[[i]][1], paste(dom[[i]][2:length(dom[[i]])], collapse=":"))
			}
			i <- sapply(dom, length) == 2
			dom <- do.call(rbind, dom[i])
			value <- cbind(dom, val[,2])
		}
	} else if (NCOL(value) == 3) {
		value <- value[, c(3,1,2), drop=FALSE]
	} else if (NCOL(value) > 3) {
		error("metags<-", "expecting a vector with 'name=value' or a two/three column matrix")
	} 
	if (NCOL(value) == 2) value <- cbind(domain, value) 
	value[is.na(value[,2]), 2] <- ""
	na.omit(value)
}



setMethod("metags<-", signature(x="SpatRaster"),
	function(x, ..., layer=NULL, domain="", value) {
		if (is.null(value)) {
			if (!is.null(layer)) {
				if (is.character(layer)) layer = match(layer, names(x))
				value <- metags(x, layer)
			} else {
				value <- metags(x)[, c(3,1:2)]
			}
			value[,3] <- ""
			#value[is.na(value)] <- ""
		} else {
			value <- parse_tags(value, domain)
		}
		x <- deepcopy(x)
		if (NROW(value) > 0) {
			if (!is.null(layer)) {
				if (is.character(layer)) layer = match(layer, names(x))
				x@pntr$addLyrTags(layer-1, value[,2], value[,3])
			} else {
				sapply(1:nrow(value), function(i) {
						# name, value, domain
						x@pntr$addTag(value[i,2], value[i,3], value[i,1])
					})
			}
		}
		x
	}
)



setMethod("metags", signature(x="SpatRasterDataset"),
	function(x, dataset=NULL, name=NULL) {
		if (!is.null(dataset)) {
			if (is.character(dataset)) layer = match(dataset, names(x))		
			return(metags(x[[dataset]], name=name))
		} else {
			v <- x@pntr$getTags()
			m <- matrix(v, ncol=2, byrow=TRUE, dimnames = list(NULL, c("name", "value")))
			out <- m[,2]
			names(out) <- m[,1]
			if (!is.null(name)) {
				out <- out[name]
			} 
		}
		out
	}
)


setMethod("metags<-", signature(x="SpatRasterDataset"),
	function(x, ..., dataset=NULL, value) {
		if (is.null(value)) {
			if (!is.null(dataset)) {
				if (is.character(dataset)) layer = match(dataset, names(x))		
				value <- matrix(x[[dataset]]@pntr$getTags(), ncol=2, byrow=TRUE)
			} else {
				value <- matrix(x@pntr$getTags(), ncol=2, byrow=TRUE)
			}
			value[,2] <- ""
			value[is.na(value)] <- ""
		} else if (NCOL(value) == 1) {
			if (!is.null(names(value)) && (!any(grepl("=", value)))) {
				value <- cbind(names(value), value)	
			} else {	
				value <- strsplit(value, "=")
				i <- sapply(value, length) == 1
				if (length(i) > 0) {
					j <- which(i)
					for (i in j) value[[i]] <- c(value[[i]], "")
				}
				i <- sapply(value, length) == 2
				value <- do.call(rbind, value[i])
			}
		} else if (NCOL(value) != 2) {
			error("metags<-", "expecting a vector with 'name=value' or a two column matrix")
		}
		value[is.na(value[,2]), 2] <- ""
		value <- na.omit(value)
		x@pntr <- x@pntr$deepcopy()
		if (NROW(value) > 0) {
			if (!is.null(dataset)) {
				if (is.character(dataset)) layer = match(dataset, names(x))		
				x[[dataset]]@pntr$addTag(value[,1], value[,2])
			} else {
				sapply(1:nrow(value), function(i) {
						x@pntr$addTag(value[i,1], value[i,2])
					})
			}
		}
		x
	}
)


setMethod("metags", signature(x="SpatRasterCollection"),
	function(x, dataset=NULL, name=NULL) {
		if (!is.null(dataset)) {
			return(metags(x[[dataset]], name=name))
		} else {
			v <- x@pntr$getTags()
			m <- matrix(v, ncol=2, byrow=TRUE, dimnames = list(NULL, c("name", "value")))
			out <- m[,2]
			names(out) <- m[,1]
			if (!is.null(name)) {
				out <- out[name]
			} 
		}
		out
	}
)


setMethod("metags<-", signature(x="SpatRasterCollection"),
	function(x, ..., dataset=NULL, value) {
		if (is.null(value)) {
			if (!is.null(dataset)) {
				value <- matrix(x[[dataset]]@pntr$getTags(), ncol=2, byrow=TRUE)
			} else {
				value <- matrix(x@pntr$getTags(), ncol=2, byrow=TRUE)
			}
			value[,2] <- ""
			value[is.na(value)] <- ""
		} else if (NCOL(value) == 1) {
			if (!is.null(names(value)) && (!any(grepl("=", value)))) {
				value <- cbind(names(value), value)	
			} else {	
				value <- strsplit(value, "=")
				i <- sapply(value, length) == 1
				if (length(i) > 0) {
					j <- which(i)
					for (i in j) value[[i]] <- c(value[[i]], "")
				}
				i <- sapply(value, length) == 2
				value <- do.call(rbind, value[i])
			}
		} else if (NCOL(value) != 2) {
			error("metags<-", "expecting a vector with 'name=value' or a two column matrix")
		}
		value[is.na(value[,2]), 2] <- ""
		value <- na.omit(value)
		x@pntr <- x@pntr$deepcopy()
		if (NROW(value) > 0) {
			if (!is.null(dataset)) {
				x[[dataset]]@pntr$addTag(value[,1], value[,2])
			} else {
				sapply(1:nrow(value), function(i) {
						x@pntr$addTag(value[i,1], value[i,2])
					})
			}
		}
		x
	}
)

# Author: Robert Hijmans
# November 2009
# License GPL3


movingFun <- function(x, n, fun=mean, type="around", circular=FALSE, na.rm=FALSE, ...)  { 
	n <- round(abs(n))
    if (n == 0) { stop("n == 0")  }
    x = as.vector(x)
	lng <- length(x)
	if (type == "around") {
		hn <- floor(n/2)
		if (circular) {
			x <- c(x[(lng-hn+1):lng], x, x[1:hn])
		} else { 
			x <- c(rep(NA, hn), x, rep(NA, hn)) 
		}
	} else if (type == "to") {
		if (circular) { 
			x <- c(x[(lng-n+2):lng], x)
		} else { 
			x <- c(rep(NA, n-1), x) 
		}
	} else if (type == "from") {
		if (circular) { 
			x <- c(x,  x[1:n])
		} else { 
			x <- c(x, rep(NA, n))	
		}
	} else {
		stop('unknown type; should be "around", "to", or "from"')
	}
	m <- matrix(ncol=n, nrow=lng)
    for (i in 1:n) { m[,i] <- x[i:(lng+i-1)] }
	if (na.rm) {
		apply(m, MARGIN=1, FUN=fun, na.rm=na.rm, ...)
	} else {
		apply(m, MARGIN=1, FUN=fun, ...)	
	}
}


.roll <- function(x, n) {
# by Josh O'Brien
    x[(seq_along(x) - (n+1)) %% length(x) + 1]
}


setMethod("roll", signature(x="numeric"),
	function(x, n, fun=mean, type="around", circular=FALSE, na.rm=FALSE, ...) {
		movingFun(x, n, fun, type=type, circular=circular, na.rm=na.rm, ...)
	}
)



setMethod("roll", signature(x="SpatRaster"),
	function(x, n, fun="mean", type="around", circular=FALSE, na.rm=FALSE, filename="", ..., wopt=list()) {
		txtfun <- .makeTextFun(match.fun(fun))
		if (inherits(txtfun, "character")) {
			if (txtfun %in% .cpp_funs) {
				opt <- spatOptions(filename, ...)
				x@pntr <- x@pntr$roll(n, txtfun, type, circular, na.rm, opt)
				return (messages(x, "roll")	)
			}
		} else {
			f <- function(i) {
				movingFun(i, n, fun, type=type, circular=circular, na.rm=na.rm, ...)
			}
			app(x, f, filename=filename, ..., wopt=wopt)
		}
	}
)

# Author: Robert J. Hijmans
# Date : May 2020
# Version 1.0
# License GPL v3

.lapp_test <- function(v, fun, usenames, ...) {
# figure out the shape of the output
	nms = ""
	nr <- nrow(v)
	if (!usenames) colnames(v) <- NULL
	vtst <- try(do.call(fun, c(v, list(...))), silent=FALSE)
	if (inherits(vtst, "try-error")) {
		nl <- -1
		msg <- "cannot use 'fun'"
	}
	if (length(vtst) >= nr) {
		if ((length(vtst) %% nr) == 0) {
			nl <- length(vtst) / nr
		} else {
			if (is.null(dim(vtst))) {
				msg <- paste0("cannot use 'fun'. The number of values returned is not divisible by the number of input cells (returning: ", length(vtst), ", expecting :", nr, ")")
			} else {
				msg <- paste0("cannot use 'fun'. The number of rows returned is not divisible by the number of input cells (returning: ", nrow(vtst), ", expecting: ", nr, ")")
			}
			nl <- -1
		}
	} else {
		if (is.null(dim(vtst))) {
			msg <- paste0("cannot use 'fun'. The number of values returned is less than the number of input cells.\n(returning: ", length(vtst), ", expecting: ", nr, ")\nPerhaps the function is not properly vectorized")
		} else {
			msg <- paste("cannot use 'fun'. The number of rows returned is less than the number of input cells.\n(returning:", nrow(vtst), ", expecting:", nr, ")\nPerhaps the function is not properly vectorized")
		}
		nl <- -1
	}
	if (nl < 0) {
		error("lapp", msg)
	}
	if (is.matrix(vtst)) {
		nms <- colnames(vtst)
	}
	list(nl=nl, names=nms)
}


setMethod("lapp", signature(x="SpatRaster"),
function(x, fun, ..., usenames=FALSE, cores=1, filename="", overwrite=FALSE, wopt=list())  {

	fun <- match.fun(fun)
	dots <- list(...)
	if (any(sapply(dots, function(i) inherits(i, "SpatRaster")))) {
		error("lapp", "only 'x' can be a SpatRaster")
		# otherwise .lapp_test may crash!
	}

#	if (usenames) {
#		fnames <- names(formals(fun))
#		i <- names(x) %in% fnames
#		if (!all(i)) {
#			warn("lapp", paste(paste(names(x)[!i], collapse=","), "are not used", collapse=", "))
#			x <- x[[names(x) %in% fnames]]
#		}
#	}


	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	}

	readStart(x)
	on.exit(readStop(x), add=TRUE)
	ncx <- ncol(x)
	v <- readValues(x, round(0.51*nrow(x)), 1, 1, ncx, dataframe=TRUE)
	test <- .lapp_test(v, fun, usenames, ...)
	if (test$nl < 1) error("lapp", "cannot use 'fun'. The number of values returned is not divisible by the number of input cells")
	out <- rast(x, nlyrs=test$nl)
	if (length(test$names == test$nl)) {
		if (is.null(wopt$names)) wopt$names <- test$names
	}
	b <- writeStart(out, filename, overwrite, sources=sources(x), wopt=wopt)
	expected <- test$nl * ncx

	if (doclust) {
		ncores <- length(cores)
		export_args(cores, ..., caller="lapp")		
		cfun <- function(i, ...)  do.call(fun, i, ...)
		parallel::clusterExport(cores, "cfun", environment())
		for (i in 1:b$n) {
			v <- readValues(x, b$row[i], b$nrows[i], 1, ncx, dataframe=TRUE)
			if (!usenames) colnames(v) <- NULL
			v <- split(v, rep(1:ncores, each=ceiling(nrow(v) / ncores))[1:nrow(v)])
			v <- unlist(parallel::parLapply(cores, v, cfun, ...))
			if (length(v) != (expected * b$nrows[i])) {
				out <- writeStop(out)
				error("lapp", "output length of fun is not correct")
			}
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	} else {
		for (i in 1:b$n) {
			v <- readValues(x, b$row[i], b$nrows[i], 1, ncx, dataframe=TRUE)
			if (!usenames) colnames(v) <- NULL
			v <- do.call(fun, c(v, list(...)))
			if (length(v) != (expected * b$nrows[i])) {
				out <- writeStop(out)
				error("lapp", "output length of fun is not correct")
			}
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	}
	out <- writeStop(out)
	return(out)
}
)




.lapp_test_stack_call <- function(v, fun, recycle, ...) {
# figure out the shape of the output
	nms <- msg <- ""
	nr <- nrow(v[[1]])
	if (recycle) {
		v <- lapply(v, as.vector)
	}
	vtst <- try(do.call(fun, c(v, list(...))), silent=FALSE)
#	vtst2 <- try(apply(v, fun, ...), silent=TRUE)

	if (inherits(vtst, "try-error")) {
		nl <- -1
		msg <- "cannot use 'fun'"
	}
	if (length(vtst) >= nr) {
		if ((length(vtst) %% nr) == 0) {
			nl <- length(vtst) / nr
		} else {
			if (is.null(dim(vtst))) {
				msg <- paste0("cannot use 'fun'. The number of values returned is not divisible by the number of input cells (returning: ", length(vtst), ", expecting :", nr, ")")
			} else {
				msg <- paste0("cannot use 'fun'. The number of rows returned is not divisible by the number of input cells (returning: ", nrow(vtst), ", expecting: ", nr, ")")
			}
			nl <- -1
		}
	} else {
		if (is.null(dim(vtst))) {
			msg <- paste0("cannot use 'fun'. The number of values returned is less than the number of input cells.\n(returning: ", length(vtst), ", expecting: ", nr, ")\nPerhaps the function is not properly vectorized.")
		} else {
			msg <- paste("cannot use 'fun'. The number of rows returned is less than the number of input cells.\n(returning:", nrow(vtst), ", expecting:", nr, ")\nPerhaps the function is not properly vectorized.")
		}
		nl <- -1
	}
	if (nl > 0) {
		if (is.matrix(vtst)) {
			nms <- colnames(vtst)
		}
	}
	list(nl=nl, names=nms, msg=msg)
}



.lapp_test_stack_mapp <- function(v, fun, recycle, ...) {
# figure out the shape of the output
	nms <- msg <- ""
	nr <- nrow(v[[1]])
	if (recycle) {
		v <- lapply(v, as.vector)
	}
	v <- lapply(v, function(i) data.frame(t(i)))
	vtst <- try(do.call(mapply, c(v, list(...), FUN=fun)), silent=FALSE)
	if (inherits(vtst, "try-error")) {
		return(list(nl=-10, names="", msg="cannot use 'fun'", trans=FALSE))
	}
	trans <- FALSE
	if (!is.null(dim(vtst))) {
		trans <- TRUE
		vtst <- as.vector(t(vtst))
	}
	if (length(vtst) >= nr) {
		if ((length(vtst) %% nr) == 0) {
			nl <- length(vtst) / nr
		} else {
			if (is.null(dim(vtst))) {
				msg <- paste0("cannot use 'fun'. The number of values returned is not divisible by the number of input cells (returning: ", length(vtst), ", expecting :", nr, ")")
			} else {
				msg <- paste0("cannot use 'fun'. The number of rows returned is not divisible by the number of input cells (returning: ", nrow(vtst), ", expecting: ", nr, ")")
			}
			nl <- -1
		}
	} else {
		if (is.null(dim(vtst))) {
			msg <- paste0("cannot use 'fun'. The number of values returned is less than the number of input cells.\n(returning: ", length(vtst), ", expecting: ", nr, ")\nPerhaps the function is not properly vectorized.")
		} else {
			msg <- paste("cannot use 'fun'. The number of rows returned is less than the number of input cells.\n(returning:", nrow(vtst), ", expecting:", nr, ")\nPerhaps the function is not properly vectorized.")
		}
		nl <- -10
	}
	if (nl > 0) {
		if (is.matrix(vtst)) {
			nms <- colnames(vtst)
		}
	}
	list(nl=nl, names=nms, msg=msg, trans=trans)
}


setMethod("lapp", signature(x="SpatRasterDataset"),
function(x, fun, ..., usenames=FALSE, recycle=FALSE, cores=1, filename="", overwrite=FALSE, wopt=list())  {

	fun <- match.fun(fun)
	dots <- list(...)
	if (any(sapply(dots, function(i) inherits(i, "SpatRasterDataset")))) {
		error("lapp", "only 'x' can be a SpatRasterDataset")
		# otherwise .lapp_test_stack fails
	}

	ncx <- ncol(x[1])
	nrx <- nrow(x[1])
	readStart(x)
	on.exit(readStop(x))

	nms <- names(x)
	v <- lapply(1:length(x), function(i) readValues(x[i], round(0.51*nrx), 1, 1, ncx, mat=TRUE))
	if (usenames) names(v) <- nms
	mapp <- FALSE
	trans <- FALSE
	test <- .lapp_test_stack_call(v, fun, recycle, ...)
	if (test$nl < 1) {
		oldtst <- test
		test <- .lapp_test_stack_mapp(v, fun, recycle, ...)
		if (test$nl == 0) {
			error("lapp", paste0(oldtst$msg, "\n", test$msg))
		}
		mapp <- TRUE
		trans <- test$trans
	}
	
	out <- rast(x[1])
	nlyr(out) <- test$nl
	if (length(test$names == test$nl)) {
		if (is.null(wopt$names)) wopt$names <- test$names
	}
	nltot <- sum(nlyr(x)) + nlyr(out)
	fact <- max(4, 4 * nltot / nlyr(out))
	b <- writeStart(out, filename, overwrite, sources=unlist(sources(x)), wopt=wopt, n=fact)

	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores), add=TRUE)
	}
	if (mapp) {
		if (doclust) {
			warn("lapp", "no parallel method for this case")
		}
		for (i in 1:b$n) {
			v <- readValues(x, b$row[i], b$nrows[i], 1, ncx, mat=TRUE)
			if (recycle) {
				v <- lapply(v, as.vector)
			}
			if (usenames) {
				names(v) <- nms
			}
			v <- lapply(v, function(j) data.frame(t(j)))
			v <- do.call(mapply, c(v, list(...), FUN=fun))
			if (test$trans) {
				v <- as.vector(t(v))
			}
			writeValues(out, v, b$row[i], b$nrows[i])
		} 
	} else {
		if (doclust) {
			ncores <- length(cores)
			export_args(cores, ..., caller="lapp")		
			cfun <- function(i, ...)  do.call(fun, i, ...)
			parallel::clusterExport(cores, "cfun", environment())

			for (i in 1:b$n) {
				v <- readValues(x, b$row[i], b$nrows[i], 1, ncx, mat=TRUE)
				if (usenames) { names(v) <- nms } else  { names(v) <- NULL }
				
				if (recycle) {
					repl <- max(sapply(v, function(j) prod(dim(j))))
					v <- lapply(v, function(j) rep_len(as.vector(j), repl))
					j <- split(1:length(v[[1]]), rep(1:ncores, each=ceiling(length(v[[1]]) / ncores))[1:length(v[[1]])])
					v <- parallel::parLapply(cores, 1:ncores, function(x, ...) cfun(lapply(v, function(d) d[j[[x]]]), ...))
				} else {
					j <- split(1:nrow(v[[1]]), rep(1:ncores, each=ceiling(nrow(v[[1]]) / ncores))[1:nrow(v[[1]])])
					v <- parallel::parLapply(cores, 1:ncores, function(x, ...) cfun(lapply(v, function(d) d[j[[x]], , drop=FALSE]), ...))
				}

				v <- unlist(v)
				if (length(v) != (b$nrows[i] * test$nl * ncx)) {
					out <- writeStop(out)
					error("lapp", "output length of fun is not correct")
				}
				writeValues(out, v, b$row[i], b$nrows[i])
			}
		} else {
		
			for (i in 1:b$n) {
				v <- readValues(x, b$row[i], b$nrows[i], 1, ncx, mat=TRUE)

				if (recycle) {
					v <- lapply(v, as.vector)
				}
				if (usenames) {
					names(v) <- nms
				}
				v <- do.call(fun, c(v, list(...)))
				writeValues(out, v, b$row[i], b$nrows[i])
			}
		}
	}
	writeStop(out)
}
)

# KML ExtendedData for OGR "KML" driver (e.g. Windows) vs "LIBKML" (many Linux builds).
# GDAL KML often only fills Name/Description; remaining fields sit in XML. See #1954.

.full_kml_filename <- function(x) {
	x <- enc2utf8(trimws(x[1]))
	if (grepl("\\.(kml|kmz)$", x, ignore.case = TRUE)) {
		x
	} else {
		NULL
	}
}


.vect_kml_source_for_xml <- function(x) {
	x <- enc2utf8(trimws(x[1]))
	# undo the VSI routing added by .vect_vsify to recover the local path or URL
	x <- sub("^/vsizip/", "", x)
	x <- sub("^/vsicurl/", "", x)
	x
}


# local-name() XPaths work for all common KML xmlns layouts; the XML package then
# warns about default namespaces — suppressed inside .read_kml_extended_table.
.kml_has_geometry <- function(pm) {
	length(XML::getNodeSet(
		pm,
		paste(
			".//*[local-name()='Polygon' or local-name()='Point' or local-name()='LineString'",
			"or local-name()='MultiGeometry' or local-name()='Track'",
			"or local-name()='MultiTrack' or local-name()='Model']"
		)
	)) > 0
}


.parse_kml_placemark_attrs <- function(pm) {
	out <- list()
	getv <- function(nodes) {
		if (length(nodes)) XML::xmlValue(nodes[[1]]) else ""
	}
	nodes <- XML::getNodeSet(pm, "./*[local-name()='name']")
	if (length(nodes)) {
		out[["Name"]] <- getv(nodes)
	}
	nodes <- XML::getNodeSet(pm, "./*[local-name()='description']")
	if (length(nodes)) {
		out[["Description"]] <- getv(nodes)
	}
	for (sd in XML::getNodeSet(pm, ".//*[local-name()='SimpleData']")) {
		nm <- XML::xmlGetAttr(sd, "name")
		if (!is.na(nm) && nzchar(nm)) {
			out[[nm]] <- XML::xmlValue(sd)
		}
	}
	for (d in XML::getNodeSet(pm, ".//*[local-name()='Data']")) {
		nm <- XML::xmlGetAttr(d, "name")
		if (is.na(nm) || !nzchar(nm)) {
			next
		}
		vn <- XML::getNodeSet(d, "./*[local-name()='value']")
		out[[nm]] <- if (length(vn)) XML::xmlValue(vn[[1]]) else ""
	}
	out
}


.read_kml_extended_table <- function(filename) {
	suppressWarnings({
		doc <- XML::xmlParse(filename)
		pms <- XML::getNodeSet(doc, "//*[local-name()='Placemark']")
		if (length(pms) < 1) {
			return(NULL)
		}
		rows <- list()
		for (i in seq_along(pms)) {
			if (.kml_has_geometry(pms[[i]])) {
				rows[[length(rows) + 1L]] <- .parse_kml_placemark_attrs(pms[[i]])
			}
		}
		if (length(rows) < 1) {
			return(NULL)
		}
		alln <- unique(unlist(lapply(rows, names)))
		mat <- matrix(NA_character_, nrow = length(rows), ncol = length(alln))
		colnames(mat) <- alln
		for (i in seq_along(rows)) {
			r <- rows[[i]]
			for (nm in names(r)) {
				j <- match(nm, alln)
				if (!is.na(j)) {
					mat[i, j] <- r[[nm]]
				}
			}
		}
		out <- as.data.frame(mat, stringsAsFactors = FALSE)
	})
	out
}


# Unzip KMZ to a temp dir; return list(path=inner_kml, dir=tempdir) or NULL.
# dir must be unlinked after parsing. Prefer doc.kml (Google Earth convention).
.kml_extract_from_kmz <- function(kmz_path) {
	if (!file.exists(kmz_path)) {
		return(NULL)
	}
	zl <- try(utils::unzip(kmz_path, list = TRUE), silent = TRUE)
	if (inherits(zl, "try-error") || !is.data.frame(zl) || !length(zl$Name)) {
		return(NULL)
	}
	inzip <- zl$Name[grepl("\\.kml$", zl$Name, ignore.case = TRUE)]
	if (!length(inzip)) {
		return(NULL)
	}
	td <- tempfile("terra_kmz_")
	dir.create(td)
	st <- try(utils::unzip(kmz_path, exdir = td), silent = TRUE)
	if (inherits(st, "try-error")) {
		unlink(td, recursive = TRUE)
		return(NULL)
	}
	fls <- list.files(td, pattern = "\\.kml$", full.names = TRUE,
		recursive = TRUE, ignore.case = TRUE)
	if (!length(fls)) {
		unlink(td, recursive = TRUE)
		return(NULL)
	}
	docf <- fls[tolower(basename(fls)) == "doc.kml"]
	kmlf <- if (length(docf)) docf[[1]] else sort(fls)[1]
	list(path = kmlf, dir = td)
}


# Remove LIBKML placemark fields that the KML driver does not produce, unless they have values.
.kml_drop_empty_libkml <- function(df) {
	if (!is.data.frame(df) || ncol(df) == 0L) {
		return(df)
	}
	libkml <- c("id", "timestamp", "begin", "end", "altitudemode", "tessellate",
		"extrude", "visibility", "draworder", "icon", "snippet", "heading",
		"tilt", "roll", "range", "model")
	drop <- vapply(seq_along(df), function(i) {
		(tolower(names(df)[i]) %in% libkml) && all(is.na(df[[i]]))
	}, logical(1))
	if (any(drop)) {
		df <- df[, !drop, drop = FALSE]
	}
	df
}


# Extract HTML <description> attributes if present
.kml_split_description <- function(df) {
	if (!is.data.frame(df) || nrow(df) == 0L) {
		return(NULL)
	}
	dcol <- which(tolower(names(df)) == "description")
	if (length(dcol) != 1L) {
		return(NULL)
	}
	desc <- as.character(df[[dcol]])
	n <- length(desc)

	extract <- function(rx) {
		mm <- regmatches(desc, gregexpr(rx, desc, perl = TRUE, ignore.case = TRUE))
		lens <- lengths(mm)
		if (sum(lens) == 0L) {
			return(NULL)
		}
		flat <- unlist(mm, use.names = FALSE)
		g <- regmatches(flat, regexec(rx, flat, perl = TRUE, ignore.case = TRUE))
		key <- vapply(g, function(z) if (length(z) >= 3L) z[2] else NA_character_, character(1))
		val <- vapply(g, function(z) if (length(z) >= 3L) z[3] else NA_character_, character(1))
		key <- sub(":\\s*$", "", trimws(key))
		list(row = rep(seq_len(n), lens), key = key, val = trimws(val))
	}

	# (1) "<b>KEY:</b> <i>VALUE</i><br/>" (also without the <i> wrapper)
	rx1 <- "<b>\\s*([^<>]+?)\\s*:?\\s*</b>\\s*(?:<i>)?\\s*([^<]*?)\\s*(?:</i>)?\\s*(?:<br\\s*/?>|$)"
	# (2) two-cell table rows "<td>KEY</td><td>VALUE</td>"
	rx2 <- "<t[dh][^>]*>\\s*([^<]*?)\\s*</t[dh]>\\s*<t[dh][^>]*>\\s*([^<]*?)\\s*</t[dh]>"
	pp <- extract(rx1)
	if (is.null(pp) || all(is.na(pp$key) | !nzchar(pp$key))) {
		pp <- extract(rx2)
	}
	if (is.null(pp)) {
		return(NULL)
	}
	keep <- !is.na(pp$key) & nzchar(pp$key)
	pp$row <- pp$row[keep]; pp$key <- pp$key[keep]; pp$val <- pp$val[keep]
	if (!length(pp$key)) {
		return(NULL)
	}
	# only split when the layout is consistent: most features parse, and no
	# feature repeats a key (which would signal free-text, not a record)
	per_row <- split(pp$key, pp$row)
	if (any(vapply(per_row, anyDuplicated, integer(1)) > 0L)) {
		return(NULL)
	}
	if (length(per_row) < max(1L, 0.9 * n)) {
		return(NULL)
	}
	ref <- unique(pp$key)
	if (!length(ref)) {
		return(NULL)
	}
	newcols <- matrix(NA_character_, nrow = n, ncol = length(ref), dimnames = list(NULL, ref))
	newcols[cbind(pp$row, match(pp$key, ref))] <- pp$val
	newcols <- as.data.frame(newcols, stringsAsFactors = FALSE)
	other <- .kml_drop_empty_libkml(df[, -dcol, drop = FALSE])
	if (ncol(other)) cbind(other, newcols) else newcols
}


.try_kml_extended_attributes <- function(v, x, kml.extended = NULL) {
	if (!inherits(v, "SpatVector")) {
		return(v)
	}
	if (is.null(.full_kml_filename(x))) {
		return(v)
	}
	if (isFALSE(kml.extended)) {
		return(v)
	}
	# First try to split an HTML <description> column that holds the attributes
	# (no XML package or source re-read needed).
	split <- try(.kml_split_description(values(v)), silent = TRUE)
	if (!inherits(split, "try-error") && !is.null(split) && nrow(split) == nrow(v)) {
		names(split) <- make.names(names(split), unique = TRUE)
		split[] <- lapply(split, utils::type.convert, as.is = TRUE)
		values(v) <- split
		return(v)
	}

	# Always attempt merge when kml.extended is NULL or TRUE. LIBKML (linux)
	# KML (R Windows) does not
	if (!requireNamespace("XML", quietly = TRUE)) {
		if (isTRUE(kml.extended) || ncol(v) <= 2) {
			warn("vect", "install package 'XML' to use kml.extended; or set kml.extended=FALSE")
		}
		return(v)
	}

	fn <- .vect_kml_source_for_xml(x)
	tf <- NULL
	parse_path <- fn
	if (grepl("^https?://", fn, ignore.case = TRUE)) {
		url_base <- sub("[?#].*$", "", fn)
		ext <- if (grepl("\\.kmz$", url_base, ignore.case = TRUE)) {
			".kmz"
		} else {
			".kml"
		}
		tf <- tempfile(fileext = ext)
		on.exit(unlink(tf), add = TRUE)
		st <- try(utils::download.file(fn, tf, mode = "wb", quiet = TRUE), silent = TRUE)
		if (inherits(st, "try-error") || !isTRUE(st == 0L) || !file.exists(tf)) {
			warn("vect", "kml.extended: failed to download KML/KMZ for XML parsing")
			return(v)
		}
		parse_path <- tf
	} else {
		nx <- suppressWarnings(normalizePath(fn, winslash = "/", mustWork = FALSE))
		parse_path <- if (!is.na(nx) && nzchar(nx) && file.exists(nx)) nx else fn
		if (!file.exists(parse_path)) {
			return(v)
		}
	}

	kmz_work <- NULL
	if (grepl("\\.kmz$", parse_path, ignore.case = TRUE)) {
		kmz_work <- .kml_extract_from_kmz(parse_path)
		if (is.null(kmz_work)) {
			warn("vect", "kml.extended: could not extract KML from KMZ")
			return(v)
		}
		parse_path <- kmz_work$path
		on.exit(unlink(kmz_work$dir, recursive = TRUE), add = TRUE)
	}

	tab <- try(.read_kml_extended_table(parse_path), silent = TRUE)
	if (inherits(tab, "try-error") || is.null(tab)) {
		return(v)
	}
	if (nrow(tab) != nrow(v)) {
		warn("vect", paste0(
			"kml.extended: ", nrow(tab), " KML placemark(s) vs ", nrow(v),
			" GDAL feature(s); attributes not replaced"
		))
		return(v)
	}
	names(tab) <- make.names(names(tab), unique = TRUE)
	tab[] <- lapply(tab, utils::type.convert, as.is = FALSE)
	values(v) <- tab
	v
}


.vect_kml_merge_extended <- function(v, x, kml.extended, proxy, what) {
	if (isTRUE(proxy) || nzchar(what)) {
		return(v)
	}
	.try_kml_extended_attributes(v, x, kml.extended)
}

set.seed(500)
r <- rast(ext=c(0, 3, 0, 3), ncol = 3, nrow = 3, nlyr=2, vals=runif(18))
pts <- cbind(c(0.5, 1.5), c(0.5, 1.5))
vct <- terra::vect(pts)
e <- terra::extract(r, vct, ID = FALSE)
expect_equal(e[,1], c(0.5121819, 0.81227813))
e <- terra::extract(r, vct, ID = FALSE, fun=sum)
expect_equal(e[,1], c(0.5121819, 0.81227813))


# multiple sources and band subset/order
s <- rast(system.file("ex/logo.tif", package="terra"))
e <- extract(c(s[[2:3]], s/10, s[[3:1]]), cbind(41.5, 52.5))
expect_equal(as.vector(unlist(e)), c(146, 185, 13.7, 14.6, 18.5, 185, 146, 137))
 

f <- system.file("ex/lux.shp", package="terra")
y <- vect(f)[1:2,]

elev <- rast(system.file("ex/elev.tif", package = "terra"))
e <- extract(elev, y, fun=mean, na.rm=TRUE, ID=TRUE)
expect_equal(e[,2], c(467.10517, 333.86294))

e <- extract(elev, y, fun=mean, exact=TRUE, na.rm=TRUE, ID=FALSE)
expect_equal(e[,1], c(467.379239, 334.685564))

e <- extract(elev, y, fun=mean, weights=TRUE, na.rm=TRUE, ID=TRUE)
expect_equal(e[,2], c(467.3933629, 334.65513085))

e <- extract(elev, 1, raw=TRUE)
expect_true(inherits(e, "array"))

x <- rast(y, res=.2)
values(x) <- 1:ncell(x)
expect_equal(cells(x, y), cbind(ID=c(1,2), cell=c(1,4)))
expect_equal(as.vector(cells(x, y, weights=TRUE)), c(1, 1, 1, 2, 2, 2, 1, 2, 4, 2, 3, 4, 0.521988, 0.414648, 0.043812, 0.000240, 0.072960, 0.491532))

expect_equivalent(unlist(extract(x, y, ID=TRUE)), c(1,2,1,4))
expect_equivalent(unlist(extract(x, y, cells=TRUE, weights=TRUE, ID=TRUE)), c(1, 1, 1, 2, 2, 2, 1, 2, 4, 2, 3, 4, 1, 2, 4, 2, 3, 4, 0.521988, 0.414648, 0.043812, 0.000240, 0.072960, 0.491532))


r <- rast(nrows=5, ncols=5, xmin=0, xmax=1, ymin=0, ymax=1, names="test")
r[c(2,7)] <- c(15, 20)
rr <- c(r, r/2)
names(rr)[2] <- "half"
xy <- cbind(x=0.3, y=c(0.9, 0.7))

v <- vect(xy)
e <- extract(r, v, ID=TRUE)
expect_equal(e, data.frame(ID=1:2, test=c(15,20)))
ee <- extract(rr, v, ID=TRUE)
expect_equal(ee, data.frame(ID=1:2, test=c(15,20), half=c(7.5, 10)))

e <- extract(r, v, cell=TRUE, ID=TRUE)
expect_equal(e, data.frame(ID=1:2, test=c(15,20), cell=c(2,7)))
ee <- extract(rr, v, cell=TRUE, ID=FALSE)
expect_equal(ee, data.frame(test=c(15,20), half=c(7.5, 10), cell=c(2,7)))

ee <- extract(rr, v, cell=TRUE, xy=TRUE, ID=TRUE)
expect_equal(ee, data.frame(ID=1:2, test=c(15,20), half=c(7.5, 10), cell=c(2,7), xy))

ee <- extract(rr, v, xy=TRUE, ID=TRUE)
expect_equal(ee, data.frame(ID=1:2, test=c(15,20), half=c(7.5, 10), xy))

f <- system.file("ex/meuse.tif", package="terra")
r <- rast(f)
xy <- cbind(179000, 330000)
xy <- rbind(xy-100, xy, xy+1000)
e <- extract(r, xy)
expect_equal(e[,1] , c(378, 251, 208))

vxy <- vect(xy)
e <- extract(r, vxy, ID=FALSE, method="bilinear")
expect_equal(e[,1] , c(378.00, 270.75, 197.25))

e <- extract(r, vxy, method="bilinear", cells=TRUE, ID=FALSE)
expect_equal(unlist(e, use.names=FALSE), c(378.00, 270.75, 197.25,8173.00,8016.00,6041.00))
 
r <- rast(nrows = 10, ncols = 10, nlyrs = 1, vals = 1:100, names = "temp")
x1 <- rbind(c(-145,-10), c(-145,-5), c(-140, -5), c(-140,-10))
x2 <- rbind(c(-10,0), c(140,60), c(160,0), c(140,-55))
z <- rbind(cbind(object=1, part=1, x1, hole=0), cbind(object=3, part=1, x2, hole=0))
colnames(z)[3:4] <- c('x', 'y')
p <- vect(z, "polygons", crs=crs(r))
rr <- c(r, r*2)
test <- terra::extract(r, p, ID=TRUE, fun = mean)
expect_equal(as.vector(as.matrix(test)), c(1,2,51.5,53))

test <- terra::extract(rr, p, fun = mean, ID=TRUE)
expect_equal(as.vector(as.matrix(test)), c(1,2,51.5,53,103,106))

test <- terra::extract(r, p, fun = mean, exact=TRUE, ID=TRUE)
expect_equal(round(as.vector(as.matrix(test)),5), c(1,2, 51.80006, 52.21312))

test <- terra::extract(rr, p, fun = mean, exact=TRUE, ID=TRUE)
expect_equal(round(as.vector(as.matrix(test)),5), c(1,2, 51.80006, 52.21312, 103.60012, 104.42623))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(100, 100, NaN, 100)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))


r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(100, NaN, 100, 100)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(100, 100, 100, NaN)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))


r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(NaN, 100, 100, 100)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(NaN, NaN, 100, 100)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(NaN, 100, NaN, 100)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(NaN, 100, 100, NaN)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(100, NaN, NaN, 100)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))

r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(100, NaN, 100, NaN)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))


r <- terra::rast(nrow = 2, ncol = 2, nlyrs = 1, xmin = -100, xmax = 100, ymin = -100, ymax = 100)
terra::values(r) <- c(100, 100, NaN, NaN)

expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 0.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = 45.0, Y = -45.0), method = "bilinear")$lyr.1), c(100.0))
expect_equal(round(terra::extract(r, data.frame(X = -45.0, Y = 45.0), method = "bilinear")$lyr.1), c(100.0))


# v <- vect(system.file("ex/lux.shp", package="terra"))[1:2,]
# z <- rast(v, resolution=.1, names="test")
# values(z) <- 1:ncell(z)
# ee <- extract(z, v, as.list=TRUE)
# expect_equal(rapply(ee, mean), c(5.20,16.75))


# x <- c(z, z*2, z/3)
# names(x) <- letters[1:3]
# ee <- extract(x, v, as.list=TRUE)
# m <- matrix(rapply(ee, mean), ncol=nlyr(x), byrow=TRUE)
# expect_equal(round(as.vector(t(m)),6), c(5.200000, 10.400000,  1.733333, 16.750000, 33.500000,  5.583333))

m = rast(nrow = 2, ncol = 2, vals=1:4)
expect_equal(cells(m), 1:4)


v <- vect(system.file("ex/lux.shp", package="terra"))
r <- rast(system.file("ex/elev.tif", package="terra"))

fun <- function(x, ...) c(min(x, ...), mean(x, ...), max(x, ...))
e <- extract(r, v, fun, na.rm=TRUE)[6,]
expect_equivalent(round(e, 4), c(6, 164, 314.9969, 403))

e <- extract(r, v, quantile, na.rm=TRUE)[12,]
expect_equivalent(round(e), c(12, 213, 274, 317, 352, 413))

fun <- c("min", "max")
e <- extract(r, v[1:2, ], fun, na.rm=TRUE)
expect_equivalent(unlist(e), c(1, 2, 339, 195, 547, 514))

x <- rast(ncol=4, nrow=4, nlyr=3, extent=ext(-2, 2, -2, 2))
values(x) <- rbind(11:13)
xy <- data.frame(x=-1:1,y=-1:1)
e <- extract(x, xy, ID=TRUE, layer=1:3)
expect_equal(e$value, 11:13)

e <- extract(x, xy, ID=TRUE, layer=3:1)
expect_equal(e$value, 13:11)

e <- extract(x, xy, ID=TRUE, layer=c(3, 1, 2))
expect_equal(e$value, c(13, 11, 12))

e <- extract(x, xy, ID=TRUE, layer=c(1, 1, 1))
expect_equal(e$value, c(11, 11, 11))

e <- extract(x, xy, ID=TRUE, layer=c(2, 2, 2))
expect_equal(e$value, c(12, 12, 12))

e <- extract(x, xy, ID=TRUE, layer=c(1, 2, 2))
expect_equal(e$value, c(11, 12, 12))

e <- extract(x, xy, ID=TRUE, layer=c(2, 2, 1))
expect_equal(e$value, c(12, 12, 11))

e <- extract(x, xy, ID=TRUE, layer=c(3, 3, 2))
expect_equal(e$value, c(13, 13, 12))

e <- extract(x, xy[1,], ID=TRUE, layer=1)
expect_equal(e$value, 11)

e <- extract(x, xy[1,], ID=TRUE, layer=2)
expect_equal(e$value, 12)

expect_error(
	e <- extract(x, xy, ID=TRUE, layer=2:4),
	"\\[extract\\] layer should be between 1 and nlyr\\(x\\)"
)
expect_error(
	e <- extract(x, xy, ID=TRUE, layer=4:2),
	"\\[extract\\] layer should be between 1 and nlyr\\(x\\)"
)

# Check nameless layers
names(x) <- NULL

e <- extract(x, xy, ID=TRUE, layer=1:3)
expect_equal(e$value, 11:13)

e <- extract(x, xy, ID=TRUE, layer=3:1)
expect_equal(e$value, 13:11)

e <- extract(x, xy, ID=TRUE, layer=c(3, 1, 2))
expect_equal(e$value, c(13, 11, 12))

e <- extract(x, xy, ID=TRUE, layer=c(1, 1, 1))
expect_equal(e$value, c(11, 11, 11))

e <- extract(x, xy, ID=TRUE, layer=c(2, 2, 2))
expect_equal(e$value, c(12, 12, 12))

e <- extract(x, xy, ID=TRUE, layer=c(1, 2, 2))
expect_equal(e$value, c(11, 12, 12))

e <- extract(x, xy, ID=TRUE, layer=c(2, 2, 1))
expect_equal(e$value, c(12, 12, 11))

e <- extract(x, xy, ID=TRUE, layer=c(3, 3, 2))
# expect_equal(e$value, c(13, 13, 12))

e <- extract(x, xy[1,], ID=TRUE, layer=1)
expect_equal(e$value, 11)

e <- extract(x, xy[1,], ID=TRUE, layer=2)
# expect_equal(e$value, 12)

expect_error(
	e <- extract(x, xy, ID=TRUE, layer=2:4),
	"\\[extract\\] layer should be between 1 and nlyr\\(x\\)"
)
expect_error(
	e <- extract(x, xy, ID=TRUE, layer=4:2),
	"\\[extract\\] layer should be between 1 and nlyr\\(x\\)"
)


r_win <- terra::rast(system.file("ex/elev.tif", package = "terra"), win = v[12])
pnt <- centroids(v[12], inside = TRUE)
expect_equal(extract(r, pnt, ID=FALSE)[[1]], 307)
expect_equal(extract(r_win, pnt, ID=FALSE)[[1]], 307)

xy <- data.frame(x=c(50,80), y=c(30, 60))
e <- extractRange(s, xy, first=1:2, last=3:2, lyr_fun=sum)
expect_equal(e, c(522, 67))
e <- extractRange(s, xy, first=1:2, last=3:2, lyr_fun=sum, ID=T)
expect_equal(e, data.frame(ID=1:2, value=c(522, 67)))
 

# KML ExtendedData parsing (#1954) when OGR KML driver omits fields

if (!requireNamespace("XML", quietly = TRUE)) {
	exit_file("No XML package")
}

{ # one block for on.exit 

	kml <- c(
		"<?xml version=\"1.0\" encoding=\"UTF-8\"?>",
		"<kml xmlns=\"http://www.opengis.net/kml/2.2\"><Document>",
		"<Placemark><name>PN</name>",
		"<ExtendedData><SchemaData>",
		"<SimpleData name=\"id\">7</SimpleData>",
		"<SimpleData name=\"camp_id\">c1</SimpleData>",
		"</SchemaData></ExtendedData>",
		"<Polygon><outerBoundaryIs><LinearRing>",
		"<coordinates>0,0,0 1,0,0 1,1,0 0,1,0 0,0,0</coordinates>",
		"</LinearRing></outerBoundaryIs></Polygon>",
		"</Placemark></Document></kml>"
	)
	f <- tempfile(fileext = ".kml")
	on.exit(unlink(f), add = TRUE)
	writeLines(kml, f, useBytes = TRUE)

	tab <- terra:::.read_kml_extended_table(f)
	expect_true(is.data.frame(tab))
	expect_equal(nrow(tab), 1L)
	expect_true("Name" %in% names(tab))
	expect_true(any(grepl("id", names(tab), ignore.case = TRUE)))

	# KMZ wrap (needs working zip in utils::zip)
	zf <- tempfile(fileext = ".kmz")
	on.exit(unlink(zf), add = TRUE)
	writeLines(kml, f, useBytes = TRUE)
	tr <- try(utils::zip(zf, f), silent = TRUE)
	if (!inherits(tr, "try-error") && file.exists(zf)) {
		ex <- terra:::.kml_extract_from_kmz(zf)
		expect_true(!is.null(ex))
		expect_true(file.exists(ex$path))
		tab2 <- terra:::.read_kml_extended_table(ex$path)
		expect_equal(nrow(tab2), 1L)
		unlink(ex$dir, recursive = TRUE)
	}
}

f <- system.file("ex/nouragues.nc", package = "terra")

xy <- cbind(-52.67, 4.08)

## --- md=FALSE, single subds (t2m) -------------------------------------------
r1 <- rast(f, subds = "t2m")
expect_equal(nlyr(r1), 48)
expect_equal(dim(r1), c(3L, 3L, 48L))

v1 <- values(r1)
expect_equivalent(v1[1, 1], 296.9571, tolerance = 1e-3)
expect_equivalent(v1[9, 1], 297.0769, tolerance = 1e-3)
expect_equivalent(v1[1, 48], 296.9695, tolerance = 1e-3)

e1 <- extract(r1, xy)
expect_equivalent(as.numeric(e1[1, 1]), 297.0172, tolerance = 1e-3)


## --- md=TRUE, single subds (t2m) --------------------------------------------
r2 <- rast(f, subds = "t2m", md = TRUE)
expect_equal(nlyr(r2), 48)
expect_equal(dim(r2), c(3L, 3L, 48L))

v2 <- values(r2)
expect_equivalent(v2[1, 1], 296.9571, tolerance = 1e-3)
expect_equivalent(v2[9, 1], 297.0769, tolerance = 1e-3)

e2 <- extract(r2, xy)
expect_equivalent(as.numeric(e2[1, 1]), 297.0172, tolerance = 1e-3)

## md=TRUE and md=FALSE must give identical values and extracts
expect_equal(v1, v2)
expect_equal(e1, e2)


## --- md=FALSE, all vars (no subds) ------------------------------------------
rall <- rast(f)
expect_equal(nlyr(rall), 336)
expect_equal(dim(rall), c(3L, 3L, 336L))
expect_true(all(c("d2m", "sp", "ssrd", "t2m", "tp", "u10", "v10") %in%
                unique(varnames(rall))))

va <- values(rall)
expect_equivalent(va[1, 1], 295.4049, tolerance = 1e-3)

ea <- extract(rall, xy)
expect_equal(ncol(ea), 336)


## --- md=TRUE, all vars -------------------------------------------------------
rall2 <- rast(f, md = TRUE)
expect_equal(nlyr(rall2), 336)
expect_equal(dim(rall2), dim(rall))

va2 <- values(rall2)
expect_equal(va, va2)

ea2 <- extract(rall2, xy)
expect_equal(ea, ea2)


## --- md=FALSE vs md=TRUE: same values after aligning by layer name ----------
r_f <- rast(f, subds = "t2m", md = FALSE)
r_t <- rast(f, subds = "t2m", md = TRUE)
vf <- values(r_f)
vt <- values(r_t)
expect_equivalent(vf[, names(r_t)], vt, tolerance = 1e-6)

ef <- extract(r_f, xy)
et <- extract(r_t, xy)
expect_equivalent(ef[, names(et)], et, tolerance = 1e-6)

ra_f <- rast(f, md = FALSE)
ra_t <- rast(f, md = TRUE)
vaf <- values(ra_f)
vat <- values(ra_t)
expect_equivalent(vaf[, names(ra_t)], vat, tolerance = 1e-6)

eaf <- extract(ra_f, xy)
eat <- extract(ra_t, xy)
expect_equivalent(eaf[, names(eat)], eat, tolerance = 1e-6)


## --- SpatRasterDataset -------------------------------------------------------
d <- sds(f)
expect_equal(length(d), 7)
expect_true(all(c("u10", "v10", "d2m", "t2m", "sp", "tp", "ssrd") %in% names(d)))

du <- d["u10"]
expect_equal(nlyr(du), 48)
expect_equal(dim(du), c(3L, 3L, 48L))

dv <- values(du)
expect_equivalent(dv[1, 1], -1.2086, tolerance = 1e-3)
expect_equivalent(dv[9, 48], -1.0656, tolerance = 1e-3)

de <- extract(du, xy)
expect_equivalent(as.numeric(de[1, 1]), -1.1612, tolerance = 1e-3)

x <- rast(system.file("ex/logo.tif", package="terra"))
y <- rast(system.file("ex/logo.tif", package="terra")) * 1
e <- ext(c(35,55,35,55))
z <- crop(x, e)

window(x) <- e
window(y) <- e
a <- c(z, y, x) 

set.seed(1)
s <- spatSample(x, 4, cell=TRUE)
set.seed(1)
expect_equal(s, spatSample(y, 4, cell=TRUE))
set.seed(1)
expect_equal(s, spatSample(z, 4, cell=TRUE))
set.seed(1)
expect_equal(cbind(s,s[,-1], s[,-1]), spatSample(a, 4, cell=TRUE))

expect_equal(values(x), values(y))
expect_equal(values(x), values(z))

xy <- 10 * cbind(-1:6, -1:6)

e1 <- extract(x, xy)
e2 <- extract(y, xy)
e3 <- extract(z, xy)
e4 <- extract(a, xy)
e <- cbind(e1, e2, e3) 

expect_equal(e1, e2)
expect_equal(e1, e3)
expect_equivalent(e, e4)

setMethod("lines", signature(x="SpatRaster"),
function(x, mx=10000, ...) {
		reset.clip()
		if(prod(dim(x)) > mx) {
			error("lines", "too many lines (you can increase the value of mx or use as.polygons)")
		}
		v <- as.polygons(x[[1]], dissolve=FALSE, values=FALSE)
		lines(v, ...)
	}
)


setMethod("points", signature(x="SpatRaster"),
function(x, ...) {
		reset.clip()
		p <- as.points(x[[1]])
		points(p, ...)
	}
)

setMethod("polys", signature(x="SpatRaster"),
function(x, mx=10000, dissolve=TRUE, ...) {
		reset.clip()
		if(prod(dim(x)) > mx) {
			error("lines", "too many lines (you can increase the value of mx or use as.polygons)")
		}
		p <- as.polygons(x[[1]], dissolve=dissolve)
		polys(p, ...)
	}
)


setMethod("lines", signature(x="SpatVector"),
	function(x, y=NULL, col, lwd=1, lty=1, arrows=FALSE, alpha=1, legend=FALSE, ...)  {
		reset.clip()
		n <- nrow(x)
		if (n == 0) return(invisible(NULL))
		gtype <- geomtype(x)
		if (!is.null(y)) {
			if (!inherits(y, "SpatVector")) {
				plot(as.lines(x), y, add=TRUE, col=col, lwd=lwd, ly=lty, alpha=alpha, legend=legend, ...)
			} else {
				stopifnot(inherits(y, "SpatVector"))
				if (missing(col)) col <- "black"
				ytype <- geomtype(y)
				if ((ytype != "points") || (gtype != "points")) {
					error("lines", "when supplying two SpatVectors, both must have point geometry")
				}
				stopifnot(nrow(x) == nrow(y))
				p1 <- geom(x)[, c("x", "y"), drop=FALSE]
				p2 <- geom(y)[, c("x", "y"), drop=FALSE]
				if (arrows) {
					arrows(p1[,1], p1[,2], p2[,1], p2[,2], col=col, lwd=lwd, lty=lty, ...)
				} else {
					a <- as.vector(t(cbind(p1[,1], p2[,1], NA)))
					b <- as.vector(t(cbind(p1[,2], p2[,2], NA)))
					lines(cbind(a, b), col=col, lwd=lwd, lty=lty, ...)
				}
			}
		} else {
			if (gtype == "polygons") {
				x <- as.lines(x) 
			}
			if (missing(col)) col <- "black"
			if ((length(col) == 1) && (length(lty)==1) && (length(lwd)==1)) {
				col <- .getCols(1, col, alpha)
				g <- x@pntr$linesNA()
				names(g) <- c("x", "y")
				graphics::plot.xy(g, type="l", lty=lty, col=col, lwd=lwd, ...)
			} else {
				col <- .getCols(n, col, alpha)
				lwd <- rep_len(lwd, n)
				lty <- rep_len(lty, n)
#				g <- lapply(x@pntr$linesList(), function(i) { names(i)=c("x", "y"); i } )
				g <- x@pntr$linesList()
				for (i in 1:n) {
					if (length(g[[i]]) > 0) {
						names(g[[i]]) = c("x", "y")
						graphics::plot.xy(g[[i]], type="l", lty=lty[i], col=col[i], lwd=lwd[i])
					}
				}
			}
			#g <- geom(x, df=TRUE)
			#g <- split(g, g[,1])
			#if (gtype == "polygons") {
			#	g <- lapply(g, function(x) split(x, x[,c(2,5)]))
			#} else {
			#	g <- lapply(g, function(x) split(x, x[,2]))
			#}
			#for (i in 1:length(g)) {
			#	for (j in 1:length(g[[i]])) {
			#		lines(g[[i]][[j]][,3:4], col=col[i], lwd=lwd[i], lty=lty[i], ...)
			#	}
			#}
		}
	}
)


setMethod("points", signature(x="SpatVector"),
	function(x, y=NULL, col, cex=0.7, pch=16, alpha=1, jitter=0, legend=FALSE, ...)  {
		reset.clip()
		n <- length(x)
		if (n == 0) return(invisible(NULL))
		if (!is.null(y)) {
			stopifnot(inherits(x, "SpatVector"))
			if (geomtype(x) != "points") {
				x <- as.points(x)
			}
			plot(x, y, add=TRUE, col=col, cex=cex, pch=pch, alpha=alpha, legend=legend, ...)
		} else {
			if (missing(col)) col <- "black"
			if ((length(col) == 1) && (length(cex)==1) && (length(pch)==1)) {
				col <- .getCols(1, col, alpha)
				#graphics::points(g[,3:4], col=col,  pch=pch, cex=cex,...)
				g <- crds(x)
				if (isTRUE(jitter > 0)) {
					g <- jitter(g, factor = jitter)
				}			
				graphics::plot.xy(list(x=g[,1], y=g[,2]), type="p", pch=pch, col=col, cex=cex, ...)
			} else {
				if (missing(col)) col <- "black"
				col <- .getCols(n, col, alpha)
				cex <- rep_len(cex, n)
				pch <- rep_len(pch, n)
				g <- geom(x, df=TRUE)
				if (isTRUE(jitter > 0)) {
					g[,3:4] <- jitter(g[,3:4], factor = jitter)
				}			
				if (nrow(g) > g[nrow(g), 1]) {
					g <- split(g[,3:4], g[,1])
					for (i in 1:n) {
						#graphics::points(g[[i]], col=col[i], pch=pch[i], cex=cex[i], ...)
						graphics::plot.xy(list(x=g[[i]][,1], y=g[[i]][,2]), type="p", pch=pch[i], col=col[i], cex=cex[i], ...)
					}
				} else {
					graphics::plot.xy(list(x=g[,3], y=g[,4]), type="p", pch=pch, col=col, cex=cex, ...)
				}
			}
		}
	}
)


setMethod("polys", signature(x="SpatVector"),
	function(x, y=NULL, col, border="black", lwd=1, lty=1, alpha=1, legend=FALSE, ...)  {
		reset.clip()
		gtype <- geomtype(x)
		if (gtype != "polygons") {
			error("polys", "expecting polygons")
		}
		if (!is.null(y)) {
			plot(x, y, add=TRUE, col=col, border=border, lwd=lwd, lty=lty, alpha=alpha, legend=legend, ...)
		} else if (missing(col)) {
			col <- NULL
		} else {
			col <- .getCols(length(x), col, alpha)
		}
		out <- list(main_cols=col)
		out$main_border <- border
		p <- .plotPolygons(x, out, lwd=lwd, lty=lty, ...)
	}
)

		
setMethod("points", signature(x="sf"),
function(x, ...) {
		points(vect(x), ...)
	}
)				
		
setMethod("lines", signature(x="sf"),
function(x, ...) {
		lines(vect(x), ...)
	}
)

setMethod("polys", signature(x="sf"),
function(x, ...) {
		polys(vect(x), ...)
	}
)

setMethod("length", signature(x="SpatVectorCollection"),
	function(x) {
		x@pntr$size()
	}
)

setMethod("svc", signature(x="missing"),
	function(x) {
		v <- methods::new("SpatVectorCollection")
		v@pntr <- SpatVectorCollection$new()
		v
	}
)

setMethod("svc", signature(x="character"),
	function(x, layer="", query="", dialect="", extent=NULL, filter=NULL) {

		if (is.null(filter)) {
			filter <- SpatVector$new()
		} else {
			filter <- filter@pntr
		}
		if (is.null(extent)) {
			extent <- double()
		} else {
			extent <- as.vector(ext(extent))
		}
	
		v <- methods::new("SpatVectorCollection")
		v@pntr <- SpatVectorCollection$new(x, layer, query, dialect, extent, filter)	
		v
	}
)



setMethod("svc", signature(x="SpatVector"),
	function(x, ...) {
		r <- methods::new("SpatVectorCollection")
		r@pntr <- SpatVectorCollection$new()
		r@pntr$push_back(x@pntr)
		dots <- list(...)
		if (length(dots) > 0) {
			for (i in 1:length(dots)) {
				if (inherits(dots[[i]], "SpatVector")) {
					r@pntr$push_back(dots[[i]]@pntr)
				} else {
					warn("svc", "cannot add objects of class: ", class(dots[[i]]))
				}
			}
		}
		messages(r, "svc")
	}
)


setMethod("svc", signature(x="sf"),
	function(x) {
		.svc_from_sf(x)
	}
)


setMethod("svc", signature(x="list"),
	function(x) {
		r <- methods::new("SpatVectorCollection")
		r@pntr <- SpatVectorCollection$new()
		for (i in seq_along(x)) {
			if (inherits(x[[i]], "SpatVector")) {
				r@pntr$push_back(x[[i]]@pntr)
			}
		}
		r <- messages(r, "svc")
		names(r) <- names(x)
		r
	}
)


setReplaceMethod("[", c("SpatVectorCollection", "numeric", "missing"),
	function(x, i, j, value) {
		stopifnot(inherits(value, "SpatVector"))
		if (any(!is.finite(i)) || any(i<1)) {
			error("`[<-`", "invalid index")
		}
		i <- sort(i)
		for (j in i) {
			if (j == (length(x)+1)) {
				x@pntr$push_back(value@pntr)
			} else {
				x@pntr$replace(value@pntr, j-1)
			}
		}
		messages(x, "`[<-`")
	}
)


setMethod("[", c("SpatVectorCollection", "numeric", "missing"),
function(x, i, j, drop=TRUE) {
	if (isTRUE(any(i < 0))) {
		i <- (1:length(x))[i]
	}
	if (drop && (length(i) == 1)) {
		tptr <- x@pntr$get(i-1)
		x <- methods::new("SpatVector")
		x@pntr <- tptr
	} else {
		x@pntr <- x@pntr$subset(i-1)
	}
	messages(x, "`[`")
})



setMethod("[[", c("SpatVectorCollection", "ANY", "missing"),
function(x, i, j, drop=TRUE) {
	if (inherits(i, "character")) {
		i <- na.omit(match(i, names(x)))
		if (length(i) == 0) {
			error("[[", "no matching names")
		}
	}
	x[i, drop=drop]
})



setMethod("$", c("SpatVectorCollection"),
function(x, name) {
	i <- na.omit(grep(name, names(x)))
	if (length(i) == 0) {
		error("$", "no matching names")
	}
	x[i,drop=TRUE]
})


setMethod("[[", c("SpatVectorCollection", "numeric", "missing"),
function(x, i, j, drop=TRUE) {
	x[i,drop=drop]
})


setMethod("c", signature(x="SpatVector"),
	function(x, ...) {
		svc(x, ...)
	}
)

setMethod("c", signature(x="SpatVectorCollection"),
	function(x, ...) {

		x@pntr <- x@pntr$subset(0:(x@pntr$size()-1) ) ## deep copy
		dots <- list(...)
		for (i in seq_along(dots)) {
			if (inherits(dots[[i]], "SpatVectorCollection")) {
				for (j in 1:length(dots[[i]])) {
					x@pntr$push_back(dots[[i]][[j]]@pntr)
				}
			} else if (inherits(dots[[i]], "SpatVector")) {
				x@pntr$push_back(dots[[i]]@pntr)
			} else {
				error("c", "arguments must be SpatVector or SpatVectorCollection")
			}
		}
		messages(x, "c")
	}
)

# Author: Robert J. Hijmans
# Date :  September 2018
# Version 1.0
# License GPL v3


setMethod("Arith", signature(e1="SpatExtent", e2="numeric"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		if (oper == "%%") {
			e1@pntr <- e1@pntr$align(e2[1], "")
		} else if (oper == "+") {
			e2 <- rep_len(e2, 4)
			e2[c(1,3)] <- -e2[c(1,3)]
			e1 <- ext(as.vector(e1) + e2)
		} else if (oper == "-") {
			e2 <- rep_len(e2, 4)
			e2[c(1,3)] <- -e2[c(1,3)]
			e1 <- ext(as.vector(e1) - e2)
		} else if (oper == "*") {
			e2 <- abs(rep_len(e2, 4))
			e1 <- as.vector(e1)
			dx <- (e1[2] - e1[1])
			dy <- (e1[4] - e1[3])
			mx <- e1[1] + dx/2
			my <- e1[3] + dy/2
			e1[1] <- mx - (dx/2)*e2[1]
			e1[2] <- mx + (dx/2)*e2[2]
			e1[3] <- my - (dy/2)*e2[3]
			e1[4] <- my + (dy/2)*e2[4]
			e1 <- ext(e1)
		} else if (oper == "/") {
			e2 <- abs(rep_len(e2, 4))
			e1 <- as.vector(e1)
			dx <- (e1[2] - e1[1])
			dy <- (e1[4] - e1[3])
			mx <- e1[1] + dx/2
			my <- e1[3] + dy/2
			e1[1] <- mx - dx/(2*e2[1])
			e1[2] <- mx + dx/(2*e2[2])
			e1[3] <- my - dy/(2*e2[3])
			e1[4] <- my + dy/(2*e2[4])
			e1 <- ext(e1)
		} else {
			error(oper, "only +, -, *, / and %% are supported")
		}
		if (!is.valid(e1)) {
			error(oper, "this would create an invalid extent")
		}
		e1
	}
)


setMethod("Arith", signature(e1="numeric", e2="SpatExtent"),
    function(e1, e2) {
		oper <- as.vector(.Generic)[1]
		if (oper == "%%") {
			error("%%", "only 'Spatextent %% numeric' (in that order) is supported")
		} else if (oper == "+") {
			return(e2 + e1)
		} else if (oper == "-") {
			error("-", "only 'Spatextent - numeric' (in that order) is supported")
		} else if (oper == "*") {
			return(e2 * e1)
		} else if (oper == "/") {
			error("/", "only 'Spatextent / numeric' (in that order) is supported")
		} else {
			error(oper, "only +, -, *, / and %% are supported")
		}
		if (!is.valid(e1)) {
			error(oper, "this would create an invalid extent")
		}
		e1
	}
)


setMethod("Arith", signature(e1="SpatExtent", e2="SpatExtent"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		if (oper == "+") {
			e1@pntr <- e1@pntr$deepcopy()
			e1@pntr$union(e2@pntr)
		} else if (oper == "*") {
			e1@pntr <- e1@pntr$intersect(e2@pntr)
		} else if (oper == "/") {
			d <- c(diff(e1[1:2]) / diff(e2[1:2]), diff(e1[3:4]) / diff(e2[3:4]))
			names(d) <- c("x", "y")
			return(d)
		} else {
			error(oper, "only +, *, and / are supported for SpatExtent")
		}
		if (!is.valid(e1)) {
			error(oper, "this would create an invalid extent")
		}
		e1
	}
)



setMethod("Arith", signature(e1="SpatVector", e2="SpatVector"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		if (geomtype(e1) != geomtype(e2)) {
			error(oper, "geometry types do not match")
		}
		if (oper == "+") {
			e1 <- union(e1, e2)
		} else if (oper == "*") {
			e1 <- intersect(e1, e2)
		} else if (oper == "-") {
			e1 <- erase(e1, e2)
		} else {
			error(oper, "only operators +, *, and - are supported for SpatVector")
		}
		messages(e1, oper)
	}
)




setMethod("Arith", signature(e1="SpatRaster", e2="SpatRaster"),
    function(e1, e2){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		e1@pntr <- e1@pntr$arith_rast(e2@pntr, oper, FALSE, opt)
		messages(e1, oper)
	}
)


setMethod("Arith", signature(e1="SpatRaster", e2="numeric"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_numb(e2, oper, FALSE, FALSE, opt)
		messages(e1, oper)
	}
)

setMethod("Arith", signature(e1="SpatRaster", e2="logical"),
    function(e1, e2){
		methods::callGeneric(e1, as.integer(e2))
	}
)

setMethod("Arith", signature(e1="SpatRaster", e2="missing"),
    function(e1, e2){
		methods::callGeneric(0, e1)
	}
)

setMethod("Arith", signature(e1="numeric", e2="SpatRaster"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e2@pntr <- e2@pntr$arith_numb(e1, oper, TRUE, FALSE, opt)
		messages(e2, oper)
	}
)

setMethod("Arith", signature(e1="logical", e2="SpatRaster"),
    function(e1, e2){
		methods::callGeneric(as.integer(e1), e2)
	}
)

setMethod("Arith", signature(e1="SpatRaster", e2="matrix"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_m(as.vector(e2), oper, dim(e2)[1:2], FALSE, opt)
		messages(e1, oper)
	}
)

setMethod("Arith", signature(e1="matrix", e2="SpatRaster"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_m(as.vector(e2), oper, dim(e2)[1:2], TRUE, opt)
		messages(e1, oper)
	}
)



setMethod("Compare", signature(e1="SpatRaster", e2="SpatRaster"),
    function(e1, e2){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		e1@pntr <- e1@pntr$arith_rast(e2@pntr, oper, FALSE, opt)
		messages(e1, oper)
	}
)


setMethod("Compare", signature(e1="SpatRaster", e2="numeric"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_numb(e2, oper, FALSE, FALSE, opt)
		messages(e1, oper)
	}
)


setMethod("Compare", signature(e1="numeric", e2="SpatRaster"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e2@pntr <- e2@pntr$arith_numb(e1, oper, TRUE, FALSE, opt)
		messages(e2, oper)
	}
)

setMethod("Compare", signature(e1="SpatRaster", e2="matrix"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_m(as.vector(e2), oper, dim(e2)[1:2], FALSE, opt)
		messages(e1, oper)
	}
)

setMethod("Compare", signature(e1="matrix", e2="SpatRaster"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_m(as.vector(e2), oper, dim(e2)[1:2], TRUE, opt)
		messages(e1, oper)
	}
)


getFactTable <- function(x, table, sender="%in%") {
	if (!is.factor(x)) {
		error(sender, "Can only match character values if x is categorical")
	}
	if (nlyr(x) != 1) {
		error(sender, "matching with character values is only supported for single layer SpatRaster")
	}
	d <- levels(x)[[1]]
	m <- stats::na.omit(match(table, d[,2]))
	if (length(m) == 0) {
		return(as.logical(x*0))
	}
	d[m,1]
}

setMethod("Compare", signature(e1="SpatRaster", e2="character"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		if (oper != "==") {
			error(oper, "only '==' is supported with categorical comparisons")
		}
		if (nlyr(e1) > 1) {
			return(rast(lapply(e1, function(x) x == e2)))
		}

		e2 <- getCatIDs(e1, e2, "==")
		if (length(e2) == 0) {
			return(as.logical(e1*0))
		}
		if (length(e2) != 1) {
			error(oper, "comparisons only supported for single values (see %in% and match)")
		}
		opt <- spatOptions()
		e1@pntr <- e1@pntr$arith_numb(e2, oper, TRUE, FALSE, opt)
		messages(e1, oper)
	}
)



setMethod("Logic", signature(e1="SpatRaster", e2="SpatRaster"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		opt <- spatOptions()
		e1@pntr <- e1@pntr$logic_rast(e2@pntr, oper, opt)
		messages(e1, oper)
	}
)

setMethod("Logic", signature(e1="SpatRaster", e2="numeric"),
    function(e1, e2){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		e2 <- as.logical(e2)
		e1@pntr <- e1@pntr$logic_numb(e2, oper, opt)
		messages(e1, oper)
	}
)


setMethod("Logic", signature(e1="numeric", e2="SpatRaster"),
    function(e1, e2){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		e1 <- as.logical(e1)
		e2@pntr <- e2@pntr$logic_numb(e1, oper, opt)
		messages(e2, oper)
	}
)

setMethod("Logic", signature(e1="SpatRaster", e2="logical"),
    function(e1, e2){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		e1@pntr <- e1@pntr$logic_numb(e2, oper, opt)
		messages(e1, oper)
	}
)


setMethod("Logic", signature(e1="logical", e2="SpatRaster"),
    function(e1, e2){
		opt <- spatOptions()
		oper <- as.vector(.Generic)[1]
		e2@pntr <- e2@pntr$logic_numb(e1, oper, opt)
		messages(e2, oper)
	}
)


setMethod("!", signature(x="SpatRaster"),
	function(x) {
		x == 0
	}
)

setMethod("not.na", signature(x="SpatRaster"),
	function(x, falseNA=FALSE, filename="", ...) {
		opt <- spatOptions(filename=filename, ...)
		x@pntr <- x@pntr$is_wrapper("isnotnan", falseNA, opt)
		messages(x, "not.na")
	}
)


setMethod("isTRUE", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("is_true", FALSE, opt)
		messages(x, "isTRUE")
	}
)


setMethod("isFALSE", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("is_false", FALSE, opt)
		messages(x, "isFALSE")
	}
)

setMethod("as.logical", signature(x="SpatRaster"),
	function(x) {
		isTRUE(x)
	}
)


setMethod("is.bool", signature(x="SpatRaster"),
	function(x) {
		x@pntr$valueType(FALSE) == 3
	}
)
setMethod("is.int", signature(x="SpatRaster"),
	function(x) {
		(x@pntr$valueType(FALSE) == 1) & (!x@pntr$hasCategories())
	}
)

setMethod("is.num", signature(x="SpatRaster"),
	function(x) {
		(x@pntr$valueType(FALSE) < 2) & (!x@pntr$hasCategories())
	}
)


setMethod("as.bool", signature(x="SpatRaster"),
	function(x, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$is_wrapper("is_true", FALSE, opt)
		messages(x, "as.boolean")
	}
)

setMethod("as.int", signature(x="SpatRaster"),
	function(x, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$math("trunc", opt)
		messages(x, "as.int")
	}
)

setMethod("as.integer", signature(x="SpatRaster"),
	function(x, filename="", ...) {
		as.int(x, filename, x)
	}
)


setMethod("is.na", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("isnan", FALSE, opt)
		messages(x, "is.na")
	}
)

setMethod("countNA", signature(x="SpatRaster"),
	function(x, n=0) {
		opt <- spatOptions()
		n <- round(n)
		if (n == 1) {
			x@pntr <- x@pntr$is_wrapper("anynan", FALSE, opt)
		} else {
			x@pntr <- x@pntr$countnan(n, opt)
		}
		messages(x, "countNA")
	}
)


setMethod("nany", signature(x="ANY"),
	function(x, ...) {
		!any(x, ...)
	}
)



setMethod("anyNA", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("anynan", FALSE, opt)
		messages(x, "anyNA")
	}
)

setMethod("noNA", signature(x="SpatRaster"),
	function(x, falseNA=FALSE) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("nonan", falseNA, opt)
		messages(x, "noNA")
	}
)


setMethod("allNA", signature(x="SpatRaster"),
	function(x, falseNA=FALSE) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("allnan", falseNA, opt)
		messages(x, "allNA")
	}
)

setMethod("is.nan", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("isnan", FALSE, opt)
		messages(x, "is.nan")
	}
)

setMethod("is.finite", signature(x="SpatExtent"),
	function(x) {
		all(is.finite(as.vector(x)))
	}
)

setMethod("is.finite", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("isfinite", FALSE, opt)
		messages(x, "is.finite")
	}
)

setMethod("is.infinite", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$is_wrapper("isinfinite", FALSE, opt)
		messages(x, "is.infinite")
	}
)


.summarize <- function(x, ..., fun, na.rm=FALSE, filename="", overwrite=FALSE, wopt=list(), par=FALSE) {

	dots <- list(...)
	add <- NULL
	cls <- FALSE
	if (length(dots) > 0) {
		cls <- sapply(dots, function(i) inherits(i, "SpatRaster"))
		if (!all(cls)) {
			add <- dots[!cls]
			if (!is.null(names(add))) {
				error(fun, "additional arguments cannot be names (except for `filename`, `overwrite` and `wopt`)")
			}
			i <- sapply(add, function(x) class(x) %in% c("logical", "integer", "numeric"))
			add <- unlist(add[i], use.names = FALSE)
			if (any(!i)) {
				error(fun, "invalid argument(s)")
			}
		}
	}
	if (any(cls) | par) {
		x <- sds(c(list(x), dots[cls]))
	}

	opt <- spatOptions(filename, overwrite, wopt=wopt)
	r <- rast()
	if (is.null(add)) {
		r@pntr <- x@pntr$summary(fun, na.rm, opt)
	} else {
		r@pntr <- x@pntr$summary_numb(fun, add, na.rm, opt)
	}
	messages(r, fun)
	r
}


setMethod("which.max", "SpatRaster",
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$summary("which.max", TRUE, opt)
		messages(x, "which.max")
	}
)

setMethod("which.min", "SpatRaster",
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$summary("which.min", TRUE, opt)
		messages(x, "which.min")
	}
)


setMethod("which.lyr", "SpatRaster",
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$summary("which", TRUE, opt)
		messages(x, "which.lyr")
	}
)

wherefun <- function(out, list, values) {
	if (list) {
		if (values) {
			lapply(out, function(i) {
				m <- matrix(i, ncol=2)
				m[,1] <- m[,1] + 1
				colnames(m) <- c("cell", "value")
				m
			})
		} else {
			lapply(out, function(i) {i + 1})
		}
	} else {
		if (values) {
			out <- lapply(1:length(out), function(i) {
				m <- matrix(out[[i]], ncol=2)
				m[,1] <- m[,1] + 1
				cbind(i, m)
			})
			out <- do.call(rbind, out)
			colnames(out) <- c("layer", "cell", "value")
		} else {
			out <- lapply(1:length(out), function(i) {cbind(i, out[[i]] + 1)})
			out <- do.call(rbind, out)
			colnames(out) <- c("layer", "cell")
		}
		out
	}
}


setMethod("where.max", "SpatRaster",
	function(x, values=TRUE, list=FALSE) {
		opt <- spatOptions()
		out <- x@pntr$where("max", values, opt)
		x <- messages(x, "where.max")
		wherefun(out, list, values)
	}
)

setMethod("where.min", "SpatRaster",
	function(x, values=TRUE, list=FALSE) {
		opt <- spatOptions()
		out <- x@pntr$where("min", values, opt)
		x <- messages(x, "where.min")
		wherefun(out, list, values)
	}
)




setMethod("Summary", signature(x="SpatRaster"),
	function(x, ..., na.rm=FALSE){
		fun <- as.character(sys.call()[[1L]])
		.summarize(x, ..., fun=fun, na.rm=na.rm)
	}
)

setMethod("Summary", signature(x="SpatVector"),
	function(x, ..., na.rm=FALSE){
		apply(values(x), 2, sys.call()[[1L]], ...)
	}
)


setMethod("nany", signature(x="SpatRaster"),
	function(x, ..., na.rm=FALSE) {
		.summarize(x, ..., fun="none", na.rm=na.rm)
	}
)


setMethod("Summary", signature(x="SpatExtent"),
	function(x, ..., na.rm=FALSE){
		e <- as.vector(x)
		x <- e[1:2]
		y <- e[3:4]
		fun <- as.character(sys.call()[[1L]])
		if (fun == "range") {
			r <- c(diff(x), diff(y))
			names(r) <- c("x", "y")
			r
		} else {
			c(callGeneric(x), callGeneric(y))
		}
	}
)

setMethod("mean", signature(x="SpatExtent"),
	function(x, ..., trim=NA, na.rm=FALSE){
		if (!is.na(trim)) {	warn("mean", "argument 'trim' is ignored") }
		e <- as.vector(x)
		c(mean(e[1:2]), mean(e[3:4]))
	}
)

setMethod("mean", signature(x="SpatRaster"),
	function(x, ..., trim=NA, na.rm=FALSE){
		if (!is.na(trim)) {	warn("mean", "argument 'trim' is ignored") }
		.summarize(x, ..., fun="mean", na.rm=na.rm)
	}
)

setMethod("mean", signature(x="SpatVector"),
	function(x, ..., trim=NA, na.rm=FALSE){
		if (!is.na(trim)) {	warn("mean", "argument 'trim' is ignored") }
		if (!is.null(list(...))) {	warn("mean", "additional arguments are ignored") }
		colMeans(values(x))
	}
)

setMethod("median", signature(x="SpatRaster"),
	function(x, na.rm=FALSE, ...){
		if (!is.logical(na.rm)) {
			error("median", "na.rm (the second argument) must be a logical value")
		}
		.summarize(x, ..., fun="median", na.rm=na.rm)
	}
)

setMethod("median", signature(x="SpatVector"),
	function(x, na.rm=FALSE){
		apply(values(x), 2, median, na.rm=na.rm)
	}
)

setMethod("Compare", signature(e1="SpatExtent", e2="SpatExtent"),
    function(e1, e2){
		oper <- as.vector(.Generic)[1]
		if (!(oper %in% c("==", "!=", ">", "<", ">=", "<="))) {
			error(oper, "is not implemented for SpatExtent")
		}
		return( e1@pntr$compare(e2@pntr, oper, 0.000001) )
	}
)


setMethod("stdev", signature(x="SpatRaster"),
	function(x, ..., pop=TRUE, na.rm=FALSE){
		if (pop) {
			.summarize(x, ..., fun="std", na.rm=na.rm)
		} else {
			.summarize(x, ..., fun="sd", na.rm=na.rm)
		}
	}
)


setMethod("modal", signature("SpatRaster"),
	function(x, ..., ties="first", na.rm=FALSE, filename="", overwrite=FALSE, wopt=list()) {
		opt <- spatOptions(filename, overwrite, wopt=wopt)
		dots <- list(...)
		add <- NULL
		if (length(dots) > 0) {
			cls <- sapply(dots, function(i) inherits(i, "SpatRaster"))
			if (any(cls)) {
				y <- c(dots[cls], x)
				x <- do.call(c, y)
			}
			if (!all(cls)) {
				dots <- dots[!cls]
				i <- sapply(dots, function(x) class(x) %in% c("logical", "integer", "numeric"))
				add <- unlist(dots[i], use.names = FALSE)
			}
		}

		if (is.null(add)) {
			add <- c(.5)[0]
		}
		x@pntr <- x@pntr$modal(add, ties[1], na.rm[1], opt)
		messages(x, "modal")
	}
)


setMethod("compare", signature(x="SpatRaster"),
    function(x, y, oper, falseNA=FALSE, filename="", overwrite=FALSE, ...){
		if (!is.character(oper)) {
			error("compare", "oper must be a character value")
		}
		oper = oper[1]
		ops <- c("==", "!=", ">", "<", ">=", "<=")
		if (!(oper %in% ops)) {
			error("compare", "oper must be a one of", ops)		
		}

		opt <- spatOptions(filename, overwrite, ...)
		if (inherits(y, "SpatRaster")) {
			x@pntr <- x@pntr$arith_rast(y@pntr, oper, falseNA[1], opt)
		} else {
			x@pntr <- x@pntr$arith_numb(y, oper, FALSE, falseNA[1], opt)
		}
		messages(x, oper)
	}
)


setMethod("logic", signature(x="SpatRaster"),
    function(x, oper, falseNA=FALSE, filename="", overwrite=FALSE, ...){
		if (!is.character(oper)) {
			error("logic", "oper must be a character value")
		}
		oper = oper[1]
		opt <- spatOptions(filename, overwrite, ...)
		falseNA <- as.logical(falseNA[1])
		
		if (oper == "is.infinite") {
			x@pntr <- x@pntr$is_wrapper("isinfinite", falseNA, opt)
		} else if (oper == "is.finite") {
			x@pntr <- x@pntr$is_wrapper("isfinite", falseNA, opt)
		} else if ((oper == "is.na") | (oper == "isNA")) {
			x@pntr <- x@pntr$is_wrapper("isnan", falseNA, opt)
		} else if (oper == "not.na") {
			x@pntr <- x@pntr$is_wrapper("isnotnan", falseNA, opt)
		} else if (oper == "isTRUE") {
			x@pntr <- x@pntr$is_wrapper("is_true", falseNA, opt)
		} else if (oper == "isFALSE") {
			x@pntr <- x@pntr$is_wrapper("is_false", falseNA, opt)
		} else if (oper == "allNA") {
			x@pntr <- x@pntr$is_wrapper("allnan", falseNA, opt)
		} else if (oper == "anyNA") {
			x@pntr <- x@pntr$is_wrapper("anynan", falseNA, opt)
		} else if ((oper == "noNA") | (oper == "noneNA")) {
			x@pntr <- x@pntr$is_wrapper("nonan", falseNA, opt)
		} else if (oper == "!") {
			x@pntr <- x@pntr$arith_numb(0, "==", FALSE, falseNA[1], opt)
		} else {
			ops <- c("!", "is.na", "not.na", "allNA", "anyNA", "noneNA", "is.infinite", "is.finite", "isTRUE", "isFALSE")
			error("compare", "oper must be a one of", ops)		
		}
		messages(x, "logic")
	}
)

.as.raster.continuous <- function(out, x, type) {

	Z <- as.matrix(x, wide=TRUE)
	Z[is.nan(Z) | is.infinite(Z)] <- NA
	Z[] <- round(Z, 12)
	
# loss of precision
#	z <- stats::na.omit(round(as.vector(Z), 12))
	z <- stats::na.omit(as.vector(Z))
	n <- length(z)
	if (n == 0) {
		#out$values = FALSE
		out$range <- c(NA, NA)
		out$legend_draw <- FALSE
		return(out)
	}

	uzi <- unique(z)

	if (type == "depends") {
		if (length(uzi) < 9) {
			return (.as.raster.classes(out, x, Z=Z))
		}
	} else if ((length(uzi) == 1) && is.null(out$range)) {
		return (.as.raster.classes(out, x, Z=Z))
	}

	if (is.null(out$range)) {
		out$range <- range(z)
#		out$fill_range <- FALSE
	} else {
		stopifnot(length(out$range) == 2)
		if (out$fill_range) {
			out$range_filled <- c(FALSE, FALSE)
			if (!is.na(out$range[1])) {
				if (out$range[1] > min(z)) {
					out$range_filled[1] <- TRUE
					Z[ Z < out$range[1] ] <- out$range[1]
				} 
			} else {
				out$range[1] <- min(z, na.rm=TRUE)
			}
			if (!is.na(out$range[2])) {
				if (out$range[2] < max(z)) {
					Z[ Z > out$range[2] ] <- out$range[2]
					out$range_filled[2] <- TRUE
				} 
			} else {
				out$range[2] <- max(z, na.rm=TRUE)
			}
		} else {
			if (all(is.na(out$range))) {
				out$range <- range(z)
			} else if (is.na(out$range[1])) {
				out$range[1] <- min(z)
			} else if (is.na(out$range[2])) {
				out$range[2] <- max(z)
			}
		}
		
		if (!any(out$range_filled)) out$fill_range <- FALSE
	}

	breaks <- .get_breaks(z, length(out$cols), "eqint", out$range)
#	if (isTRUE(out$fill_range)) {
#		zrng <- range(z)
#		breaks[1] <- zrng[1]
#		breaks[length(breaks)] <- zrng[2]
#		out$frange <- zrng
#	} else {
#		out$frange <- out$range	
#	}

	if (length(breaks) == 1) {
		Z[] <- out$cols[ceiling(length(out$cols)/2)]
	} else {
		Z[] <- out$cols[as.integer(cut(as.numeric(Z), breaks, include.lowest=TRUE, right=FALSE))]
	}
	
	out$r <- as.raster(Z)

	out$legend_type <- "continuous"

	if (is.null(out$levels)) {
		out$levels <- 5
	}
	if (is.null(out$leg$digits)) {
		dif <- diff(out$range)
		if ((dif == 0) || (length(dif) ==0)) {
			out$leg$digits <- 0;
		} else {
			out$leg$digits <- max(0, -floor(log10(dif/10)))
		}
	}
	if (is.null(out$leg$x)) out$leg$x <- "right"
	out
}


.as.raster.classes <- function(out, x, Z=NULL, ...) {

	if (is.null(Z)) {
		Z <- as.matrix(x, wide=TRUE)
		Z[is.nan(Z) | is.infinite(Z)] <- NA
	}
	if (all(is.na(Z))) {
		#out$values = FALSE
		out$range <- c(NA, NA)
		out$legend_draw <- FALSE
		return(out)
	}

	fz <- as.factor(Z)
	if (!is.null(out$levels)) {
		if (is.null(out$leg$legend)) {
			out$leg$legend <- as.character(out$levels)
		}
		levs <- out$levels
	} else {
		levs <- as.numeric(levels(fz))
		digits <- out$leg$digits
		if (is.null(digits)) {
			if (length(levs) > 1) {
				d <- ceiling(1 / min(diff(sort(levs))))
				decimals <- round(log10(d) + 1)
			} else {
				txt <- format(levs, scientific = FALSE, digits=18)
				txt <- unlist(strsplit(txt, "\\."))
				if (nchar(txt[1]) > 3) decimals <- 0
				else if (nchar(txt[1]) > 2) decimals <- 1
				else if (nchar(txt[1]) > 1) decimals <- 2
				else if (txt[1] != "0") decimals <- 3
				else if (length(txt) > 1) {
					txt <- unlist(strsplit(txt[2], ""))
					i <- which(txt != "0")[1]
					if (length(i) > 0) decimals <- i+2
					else decimals <- 9;
				} else {
					decimals <- 0
				}
			}
			levs <- round(levs, decimals)
		}
		out$levels <- levs
		if (is.null(out$leg$legend)) {
			if (!is.null(out$leg$digits)) {
				out$leg$legend <- prettyNumbs(levs, digits)
			} else {
				out$leg$legend <- levs
			}
		}
	}
	out$leg$digits <- NULL
	stopifnot(length(out$leg$legend) == length(out$levels))
	nlevs <- length(levs)

#	if (is.vector(out$cols) && !is.null(names(out$cols))) {
#		out$cols <- data.frame(value=as.numeric(names(out$cols)), col=out$cols)
#	} 

	if (NCOL(out$cols) == 2) {
		#i <- match(Z, as.numeric(levs))
		i <- match(Z, as.numeric(out$cols[,1]))
		Z[] <- out$cols[,2][i]
		i <- match(as.numeric(levs), out$cols[,1])
		out$leg$fill <- out$cols[i,2]
	} else {
		ncols <- length(out$cols)
		if (nlevs == 1) {
			cols <- out$cols[length(out$cols)]
		} else if (nlevs < ncols) {
			i <- round(seq(1, ncols, length.out = nlevs))
			cols <- out$cols[i]
		} else {
			cols <- rep_len(out$cols, nlevs)
		}
		out$leg$fill <- cols
		Z[] <- cols[as.numeric(fz)]
	}
	out$r <- as.raster(Z)
	out$legend_type <- "classes"

	if (is.null(out$leg$x)) {
		if (is.null(out$leg$ext)) {
			out$leg$x = "default"
			out$leg$y = NULL
		} else {
			if (length(out$leg$ext) == 4) {
				out$leg$x = out$leg$ext[1]
				out$leg$y = out$leg$ext[4]
			} else {
				out$leg$x = "default"
				out$leg$y = NULL
			}
		}
	}
	out
}


.as.raster.factor <- function(out, x, ...) {

	z <- round(values(x))
	#z[z<1 | z>256] <- NA
	z[is.nan(z) | is.infinite(z)] <- NA
	if (all(is.na(z))) {
		#out$values = FALSE
		out$range <- c(NA, NA)
		out$legend_draw <- FALSE
		return(out)
	}
	out$levels <- sort(stats::na.omit(unique(z)))
	if (out$all_levels) {
		ilevels <- 1:nrow(out$cats)
		out$levels <- out$cats[,1]
	} else {
		ilevels <- match(out$levels, out$cats[[1]])
		if (any(is.na(ilevels))) {
			warn("plot", "unknown categories in raster values")
		}
	}

	if (!is.null(out$coltab)) {
		# avoid multiple colors for the same category
		ilevs <- stats::na.omit(ilevels)
		ulevs <- unique(out$cats[ilevs,2])
		if (length(ulevs) < length(ilevs)) {
			z <- out$cats[match(z, out$cats[,1]),2]
			i <- match(ulevs, out$cats[ilevels,2])	
			j <- out$cats[ilevs[i],]
			z <- j[match(z, j[,2]), 1]
			out$cats <- j			
			out$levels <- sort(stats::na.omit(unique(z)))
			#out$coltabt = out$coltab[match(j[,1], out$coltab[,1]), ]
			if (out$all_levels) {
				ilevels <- 1:nrow(out$cats)
				out$levels <- out$cats[,1]
			} else {
				ilevels <- match(out$levels, out$cats[[1]])
			}
		}

		if (out$all_levels) {
			mi <- match(out$cats[[1]], out$coltab[,1])
			mi[is.na(mi)] <- 1
			mc <- out$coltab[mi, ,drop=FALSE]
			out$leg$fill <- grDevices::rgb(mc[,2], mc[,3], mc[,4], mc[,5], maxColorValue=255)
			if (is.null(out$leg$legend)) out$leg$legend <- stats::na.omit(out$cats[, 2])
		} else {	
			out$levels <- out$levels[!is.na(ilevels)]
			m <- stats::na.omit(match(out$cats[[1]][ilevels], out$coltab[,1]))
			if (is.null(out$leg$legend)) out$leg$legend <- stats::na.omit(out$cats[ilevels, 2])
			out$coltab <- out$coltab[m, ,drop=FALSE]
		}

		out$cols <- grDevices::rgb(out$coltab[,2], out$coltab[,3], out$coltab[,4], out$coltab[,5], maxColorValue=255)
		i <- match(z, out$coltab[,1])
		z <- out$cols[i]
	} else {
		if (is.null(out$leg$legend)) out$leg$legend <- unique(stats::na.omit(out$cats[ilevels, 2]))
		levlab <- data.frame(id=out$levels, lab=out$cats[ilevels, 2], stringsAsFactors=FALSE)
		leglevs <- stats::na.omit(unique(levlab[,2]))
		if (length(leglevs) == 0) {
			error("plot", "something is wrong with the categories")
		}
		nlevs <- length(leglevs)
		ncols <- length(out$cols)
		#ncats <- nrow(out$cats)
		if (nlevs < ncols) {
			i <- round(seq(1, ncols, length.out = nlevs))
			out$cols <- out$cols[i]
		} else if (nlevs > ncols) {
			out$cols <- rep_len(out$cols, nlevs)
		}
		out$leg$fill <- out$cols
		#out$cols <- out$cols[ilevels] 
		dd <- data.frame(lab=leglevs, out$cols)
		m <- merge(levlab, dd)
		z <- m$out.cols[match(z, m$id)]
	}
	if (!out$all_levels) {
		out$leg$fill <- out$cols
	}
	z <- matrix(z, nrow=nrow(x), ncol=ncol(x), byrow=TRUE)
	out$r <- as.raster(z)

	out$legend_type <- "classes"
	if (is.null(out$leg$x)) {
		if (is.null(out$leg$ext)) {
			out$leg$x = "default"
			out$leg$y = NULL
		} else {
			if (length(out$leg$ext) == 4) {
				out$leg$x = out$leg$ext[1]
				out$leg$y = out$leg$ext[4]
			} else {
				out$leg$x = "default"
				out$leg$y = NULL
			}
		}
	}
	if (!is.null(out$leg$order)) {
		ord <- match(out$leg$order, out$leg$legend)
		out$leg$legend <- out$leg$legend[ord]
		out$leg$fill <- out$leg$fill[ord]
	} else if (isTRUE(out$leg$sort)) {
		ord <- order(out$leg$legend) #, decreasing=out$leg$reverse)
		out$leg$legend <- out$leg$legend[ord]
		out$leg$fill <- out$leg$fill[ord]
	}
	out
}



.as.raster.interval <- function(out, x, ...) {

	out$legend_type <- "classes"

	if (NCOL(out$cols) == 3) {
		rcl <- cbind(as.matrix(out$cols[,1:2]), 1:nrow(out$cols))
		x <- classify(x, rcl, include.lowest=TRUE, others=NA)
		m <- apply(out$cols[,1:2], 1, function(i) paste(i, collapse=" - "))
		out$leg$legend <- m
		out$leg$fill <- out$cols[,3]
		Z <- as.matrix(x, wide=TRUE)
		Z[is.nan(Z) | is.infinite(Z)] <- NA
		Z[] <- out$leg$fill[Z]
	} else {
		Z <- as.matrix(x, wide=TRUE)
		Z[is.nan(Z) | is.infinite(Z)] <- NA
		nZ <- length(unique(na.omit(as.vector(Z))))	
		if (nZ <= 1) {
			return(.as.raster.classes(out, x, Z=Z, ...))
		}

		out <- .generic.interval(out, Z)
		Z[] <- out$leg$fill[out$vcut]
	}
	if (is.null(out$leg$x)) { # && is.null(out$leg$ext)) {
		out$leg$x <- "default"
	}
	out$r <- as.raster(Z)
	out
}

# leg.shrink=c(0,0), leg.main=NULL, leg.main.cex = 1, leg.digits=NULL, leg.loc=NULL, leg.ext=NULL, leg.levels=NULL, leg.labels=NULL, leg.at=NULL,


.as.raster.colortable <- function(out, x, ...) {
	z <- round(values(x))
	#z[z<0 | z>255] <- NA
	z[is.nan(z) | is.infinite(z)] <- NA
	if (all(is.na(z))) {
		out$values = FALSE
		return(out)
	}
	out$cols <- grDevices::rgb(out$coltab[,2], out$coltab[,3], out$coltab[,4], out$coltab[,5], maxColorValue=255)
	i <- match(z, out$coltab[,1])
	z <- out$cols[i]
	z <- matrix(z, nrow=nrow(x), ncol=ncol(x), byrow=TRUE)
	out$r <- as.raster(z)
	out
}

.plotit <- function(x) {


	if (is.null(x$r)) {
		x$values = FALSE
	}

	if (x$add) {
		reset.clip()
		x$zebra <- FALSE
	} else if (!x$legend_only) {
		old.mar <- graphics::par()$mar
		if (!any(is.na(x$mar))) { graphics::par(mar=x$mar) }
		if (x$reset) on.exit(graphics::par(mar=old.mar))
		
		if (x$zebra) {
			width <- rep(min(diff(x$lim[1:2]), diff(x$lim[3:4])) / 100, 2) * x$zebra.cex
			if (x$lonlat) {
				asp <- 1/cos((mean(x$lim[3:4]) * pi)/180)
				width[2] <- width[2] / asp
			}
			x$lim[1:2] <- x$lim[1:2] + c(-width[1], width[1])
			x$lim[3:4] <- x$lim[3:4] + c(-width[2], width[2])
		}		
		
		arglist <- c(list(x=x$lim[1:2], y=x$lim[3:4], type="n", xlab="", ylab="", asp=x$asp, xaxs=x$xaxs, yaxs=x$yaxs, axes=FALSE), x$dots)
		do.call(plot, arglist)
		if (!is.null(x$background)) {
			graphics::rect(x$lim[1], x$lim[3], x$lim[2], x$lim[4], col=x$background, border=x$box)			
		}
	}
	try(set.clip(x$lim, x$lonlat))
	if (!x$values) {
		#if (!x$add) try(set.clip(x$lim, x$lonlat))
		return(x)
	}
	if (!x$legend_only) {
		x <- .plot.axes(x)
		reset.clip()
		graphics::rasterImage(x$r, x$ext[1], x$ext[3], x$ext[2], x$ext[4], angle = 0, interpolate = x$interpolate)
	}
	
	if (x$legend_draw) {
		if (x$legend_type == "continuous") {
			x <- do.call(.plot.cont.legend, list(x=x))
#		} else if (x$legend_type == "classes") {
		} else {
			if (x$add) {
				if (x$clip) {
					x$leg$plotlim <- unlist(get.clip()[1:4])
				} else {
					x$leg$plotlim <- graphics::par("usr")
				}			
				if (is.null(x$leg$plotlim)) {
					x$leg$plotlim <- x$lim			
				}				
			} else {
				if (x$clip) {
					x$leg$plotlim <- x$lim
				} else {
					x$leg$plotlim <- graphics::par("usr")
				}				
			}
			x$leg$used <- do.call(.plot.class.legend, x$leg)
		}
	}

	if (x$zebra) {
		try(set.clip(x$lim, x$lonlat))
		zebra(width=width, x=x$axs$xat, y=x$axs$yat, col=x$zebra.col)
		x$lim[1:2] <- x$lim[1:2] + c(width[1], -width[1])
		x$lim[3:4] <- x$lim[3:4] + c(width[2], -width[2])
	}		

	if (isTRUE(x$box)) { 
		if (x$clip) {
			lines(ext(x$lim))	
		} else {
			lines(ext(graphics::par("usr")))		
		}
	}
	
	if ((!x$add) && (!x$legend_only)) {
		plot_main(x)
	}
	if (!x$add) {
		try(set.clip(x$lim, x$lonlat))
	} else {
		reset.clip()
	}	
	invisible(x)
}



.prep.plot.data <- function(x, type, cols, mar=NULL, draw=FALSE,
  interpolate=FALSE, legend=TRUE, legend.only=FALSE, pax=list(), plg=list(),
  levels=NULL, add=FALSE, range=NULL, fill_range=FALSE, breaks=NULL, breakby="eqint",
  coltab=NULL, cats=NULL, xlim=NULL, ylim=NULL, ext=NULL, colNA=NA, alpha=NULL, reset=FALSE,
  sort=TRUE, reverse=FALSE, grid=FALSE, las=0, all_levels=FALSE, decimals=NULL, background=NULL,
  xlab="", ylab="", cex.lab=0.8, line.lab=1.5, asp=NULL, yaxs="i", xaxs="i", 
  main="", cex.main=1.2, line.main=0.5, font.main=graphics::par()$font.main, col.main = graphics::par()$col.main, loc.main=NULL, 
  sub = "", font.sub=1, cex.sub=0.8*cex.main, line.sub =1.75,  col.sub=col.main, loc.sub=NULL,
  halo=FALSE, hc="white", hw=0.1, axes=TRUE, box=TRUE, zebra=FALSE, zebra.cex=1, zebra.col=c("black", "white"), 
  maxcell=500000, buffer=FALSE, clip=TRUE, 
  # for rgb 
  stretch=NULL, scale=NULL, bgalpha=NULL, zlim=NULL, zcol=NULL, overview=NULL, 
#catch and kill
  cex=1, decreasing=FALSE, font=NULL,
  ...) {


	# backwards compatibility
	reverse <- reverse | decreasing
	out <- list()
	out$lim <- out$ext <- as.vector(ext(x))
	hadWin <- hasWin <- FALSE
	if (add && is.null(ext)) {
		ext <- unlist(get.clip())[1:4]
	}

	if (ncell(x) > 1.1 * maxcell) {			
		if (is.null(overview)) {	
			if (grepl("https://", tolower(sources(x))[1])) {
				overview <- TRUE
			} else {
				overview <- FALSE
			}
		}
	
		if (inherits(alpha, "SpatRaster")) {
			if (nlyr(alpha) > 1) {
				alpha <- alpha[[1]]
			}
#			alpha <- spatSample(alpha, maxcell, method="regular", as.raster=TRUE, warn=FALSE)
			alpha <- sampleRaster(alpha, maxcell, method="regular", replace=FALSE, ext=NULL, warn=FALSE, overview=overview)
		}
#		x <- spatSample(x, maxcell, method="regular", as.raster=TRUE, warn=FALSE)
		x <- sampleRaster(x, maxcell, method="regular", replace=FALSE, ext=NULL, warn=FALSE, overview=overview)
	}

	if ((!is.null(ext)) || (!is.null(xlim)) || (!is.null(ylim))) {
		if (!is.null(ext)) {
			ext <- ext(ext)
			out$lim <- as.vector(ext)
			out$ext <- as.vector(align(ext, x, "out"))
		} 
		if (!is.null(xlim)) {
			stopifnot(length(xlim) == 2)
			out$lim[1:2] <- sort(xlim)
		}
		if (!is.null(ylim)) {
			stopifnot(length(ylim) == 2)
			out$lim[3:4] <- sort(ylim)
		}
		
		hasWin <- TRUE
		hadWin <- window(x)
		oldWin <- ext(x)
		w <- intersect(ext(x), ext(out$ext))		
		window(x) <- out$ext <- w
	} 
	
	if (buffer) {
		dx <- diff(out$lim[1:2]) / 50
		dy <- diff(out$lim[3:4]) / 50
		out$lim[1:2] <- out$lim[1:2] + c(-dx, dx)
		out$lim[3:4] <- out$lim[3:4] + c(-dy, dy)
	}

	out$add <- isTRUE(add)
	out$axs <- as.list(pax)
	if (is.null(out$axs$las)) out$axs$las <- las
	if (is.null(out$axs$cex.lab)) out$axs$cex.lab <- cex.lab
	if (is.null(out$axs$line.lab)) out$axs$line.lab <- line.lab

	out$draw_grid <- isTRUE(grid)
	out$leg$digits <- decimals

	out$leg <- as.list(plg)
	out$all_levels <- isTRUE(all_levels)

	if (is.null(asp)) {
		out$lonlat <- is.lonlat(x, perhaps=TRUE, warn=FALSE)
		if (out$lonlat) {
			out$asp <- 1/cos((mean(out$ext[3:4]) * pi)/180)
		} else {
			out$asp <- 1
		}
	} else {
		out$asp <- asp
		out$lonlat <- FALSE
	}
	out$cols <- cols
	out$rgb$stretch <- stretch
	if (is.null(scale)) {	
		out$rgb$scale <- 255
	} else {
		out$rgb$scale <- scale
	}
	if (!is.null(alpha)) {
		if (!inherits(alpha, "SpatRaster")) {
			out$alpha <- alpha[1]
			if ((alpha < 0) || (alpha > 1)) {
				warn("plot", "alpha should be between 0 and 1")
				out$alpha <- 255
			} else {
				out$alpha <- out$alpha[1] * 255
			}
			out <- hexcols(out)
		}
	} else {
		out$alpha <- 255
		out <- hexcols(out)
	}
	out$rgb$bgalpha <- bgalpha
	out$rgb$zlim <- zlim
	out$rgb$zcol <- isTRUE(zcol)
	if (is.null(colNA) || is.na(colNA)) {
		out$rgb$colNA <- "white"
	} else {
		out$rgb$colNA = colNA
	}
	out$clip <- isTRUE(clip)
	out$dots  <- list(...)
	out$reset <- reset
	out$main  <- main
	out$halo.main <- halo
	out$halo.main.hc <- hc
	out$halo.main.hw <- hw

	out$loc.main  <- loc.main
	out$cex.main  <- cex.main
	out$font.main <- font.main
	out$col.main  <- col.main
	out$line.main <- line.main

	out$sub <- sub
	out$loc.sub <- loc.sub
	out$cex.sub <- cex.sub
	out$font.sub <- font.sub
	out$col.sub <- col.sub
	out$line.sub <- line.sub

	out$axes <- axes
	out$xaxs <- xaxs
	out$yaxs <- yaxs
	out$xlab <- xlab
	out$ylab <- ylab 
	out$coltab <- coltab
	out$cats <- cats
	out$breaks <- breaks
	out$breakby <- breakby
	out$interpolate <- FALSE
	out$background <- background
	out$legend_draw <- isTRUE(legend)
	out$legend_only <- isTRUE(legend.only)
	if (!is.logical(sort)) {
		out$leg$order <- sort
		out$leg$sort <- FALSE
	} else {
		out$leg$sort <- isTRUE(sort)
	}
	out$leg$reverse <- isTRUE(reverse)
	out$box <- isTRUE(box)
	out$zebra <- isTRUE(zebra)
	out$zebra.cex <- zebra.cex
	out$zebra.col <- zebra.col
	
#	if (!is.null(out$leg$loc)) {
#		out$leg$x <- out$leg$loc
#		out$leg$loc <- NULL
#	}


	if (!hasValues(x)) {
		out$values <- FALSE
		out$legend_draw <- FALSE
		#warn("plot", "SpatRaster has no cell values")
	} else {
		out$values <- TRUE

		if (type=="factor") {
			out <- .as.raster.factor(out, x)
		} else if (type=="rgb") {
			out <- .as.raster.rgb(out, x)
			out$interpolate <- isTRUE(interpolate)
		} else if (type=="colortable") {
			out <- .as.raster.colortable(out, x)
		} else if (type=="classes") {
			out$levels <- levels
			out <- .as.raster.classes(out, x)
		} else if (type=="interval") {
			out <- .as.raster.interval(out, x)
		} else {
			out$interpolate <- isTRUE(interpolate)
			out$range <- range
			out$fill_range <- fill_range
			out <- .as.raster.continuous(out, x, type)
		}

		out$mar <- mar
		out <- get_mar(out)
		
		if (!is.null(colNA)) {
			if (!is.na(colNA) && out$values) {
				out$colNA <- grDevices::rgb(t(grDevices::col2rgb(colNA)), alpha=out$alpha, maxColorValue=255)
				out$r[is.na(out$r)] <- out$colNA
			}
		}
	}

	if (draw) {
		if (inherits(alpha, "SpatRaster")) {
			alpha <- clamp(as.vector(alpha[[1]])*255, 0, 255)
			out$r <- matrix(grDevices::rgb(t(grDevices::col2rgb(out$r)), alpha=alpha, maxColorValue=255),
			nrow=nrow(out$r), byrow=TRUE)
		}
		out <- .plotit(out)
	}
	
	if (any(hasWin)) {
		window(x) <- NULL
		if (any(hadWin)) {
			window(x) <- oldWin
		}
	}
	invisible(out)
}


setMethod("plot", signature(x="SpatRaster", y="numeric"),
	function(x, y=1, col, type=NULL, mar=NULL, legend=TRUE, axes=!add, plg=list(), pax=list(), maxcell=500000, smooth=FALSE, range=NULL, fill_range=FALSE, levels=NULL, all_levels=FALSE, breaks=NULL, breakby="eqint", fun=NULL, colNA=NULL, alpha=NULL, sort=FALSE, reverse=FALSE, grid=FALSE, zebra=FALSE, ext=NULL, reset=FALSE, add=FALSE, buffer=FALSE, background=NULL, box=axes, clip=TRUE, overview=NULL, ...) {

		old.mar <- graphics::par()$mar
		on.exit(graphics::par(mar=old.mar))

		y <- round(y)
		hasRGB <- FALSE		

		if (has.RGB(x) && ((is.null(type) && (y[1] < 0)))) {
			type <- "rgb"
			legend <- FALSE
			if (is.null(mar)) {
				mar <- 0
				axes <- FALSE
			}
			hasRGB <- TRUE
			y <- RGB(x)
		}
		nlx <- nlyr(x)
		stopifnot((min(y) > 0) & (max(y) <= nlx))

		if ((!hasRGB) && (length(y) > 1)) {

			x <- x[[y]]
			if (inherits(alpha, "SpatRaster")) {
				if (nlyr(alpha) > 1) {
					alpha <- alpha[[y]]
				}
			}
			plot(x, col=col, type=type, mar=mar, legend=legend, axes=axes, plg=plg, pax=pax, maxcell=2*maxcell/length(y), smooth=smooth, range=range, fill_range=fill_range, levels=levels, all_levels=all_levels, breaks=breaks, breakby=breakby, fun=fun, colNA=colNA, alpha=alpha, zebra=zebra, grid=grid, sort=sort, reverse=reverse, ext=ext, reset=reset, add=add, buffer=buffer, background=background, box=box, clip=clip, overview=overview, ...)
			return(invisible())
		} else {
			x <- x[[y]]
		}

		if (inherits(alpha, "SpatRaster")) {
			if (!compareGeom(x, alpha, crs=FALSE, ext=FALSE, rowcol=TRUE)) {
				error("plot", "geometry of alpha does not match x")
			}
		}

		if (is.character(legend)) {
			plg$x <- legend
			legend <- TRUE
		}

		if (missing(col)) {
			col <- .default.pal()
			#col <- rev(grDevices::terrain.colors(255))
		} else if (inherits(col, "data.frame")) {
			if (ncol(col) == 2) {
				type <- "classes"
			} else if (ncol(col) == 3) {
				type <- "interval"
			} else {
				error("plot", "number of columns of a col data.frame should be 2 or 3")
			}
			breaks <- NULL
		}
		coltab <- NULL
		cats  <- NULL
		if (!is.null(breaks)) {
			if (is.null(type)) {
				type <- "interval"
			} else {
				range <- range(breaks)
			}
		} else {
			if (is.null(type)) {
				if (has.colors(x)) {
					coltab <- coltab(x)[[1]]
					if (is.factor(x)) {
						if (activeCat(x) >= 0) {
							cats <- levels(x)[[1]] 
							type <- "factor"
						} else {
							type <- "colortable"
							legend <- FALSE
						}
					} else {
						type <- "colortable"
						legend <- FALSE
					}
				} else if (is.factor(x)) {
					type <- "factor"
					cats <- levels(x)[[1]]
				} else if (is.bool(x)) {
					type <- "factor"
					levels(x) <- data.frame(id=0:1, value=c("False", "True"))
					cats <- cats(x)[[1]]
				} else {
					type <- "depends"
				}
			} else {
				type <- match.arg(type, c("continuous", "classes", "interval", "rgb"))
			}
		}
		if ((type == "classes") && is.null(levels) && is.factor(x)) {
			type <- "factor"
			cats <- cats(x)[[1]]
			if (has.colors(x)) {
				coltab <- coltab(x)[[1]]
			}
		}

		x <- .prep.plot.data(x, type=type, cols=col, mar=mar, draw=TRUE, plg=plg, pax=pax, legend=isTRUE(legend), axes=isTRUE(axes), coltab=coltab, cats=cats, interpolate=smooth, levels=levels, range=range, fill_range=fill_range, colNA=colNA, alpha=alpha, reset=reset, grid=grid, zebra=zebra, sort=sort, reverse=reverse, ext=ext, all_levels=all_levels, breaks=breaks, breakby=breakby, add=add, buffer=buffer, background=background, box=box, maxcell=maxcell, clip=clip, overview=overview, ...)

		add_more(fun, y)
		
		invisible(x)
	}
)


setMethod("plot", signature(x="SpatRaster", y="missing"),
	function(x, y, main, mar=NULL, nc, nr, maxnl=16, maxcell=500000, add=FALSE, plg=list(), pax=list(), ...)  {

		if (has.RGB(x)) {
			if (missing(main)) main = ""
			p <- plot(x, -1, main=main, mar=mar, maxcell=maxcell, add=add, plg=plg, pax=pax, ...)
			return(invisible(p))
		}

		nl <- max(1, min(nlyr(x), maxnl))

		if (add && (nl > 1)) {
			nl <- 1
			warn("plot", "adding the first layer of x")
		}

		if (nl==1) {
			if (missing(main)) main = ""
			out <- plot(x, 1, maxcell=maxcell, main=main[1], mar=mar, add=add, plg=plg, pax=pax, ...)
			return(invisible(out))
		}

		nrnc <- .get_nrnc(nr, nc, nl)
		old.par <- graphics::par(no.readonly = TRUE)
		on.exit(graphics::par(old.par))
		if (is.null(mar)) {
			mar=c(1.5, 1, 2.5, 3)
		}
		graphics::par(mfrow=nrnc)
		maxcell= 2 * maxcell / nl

		if (missing("main")) {
			tm <- time(x)
			if ((!any(is.na(tm))) && (length(unique(tm)) > 1)) {
				main <- as.character(time(x))
			} else {
				main <- names(x)
			}
		} else {
			main <- rep_len(main, nl)
		}
		plg$title <- suppressWarnings(rep(plg$title, length.out=nl))

		for (i in 1:nl) {
			plg$leg_i <- i
			plot(x, i, main=main[i], mar=mar, maxcell=maxcell, add=add, plg=plg, pax=pax, ...)
		}
	}
)


setMethod("plot", signature(x="SpatRaster", y="character"),
	function(x, y, ...) {
		y <- match(y, names(x))
		if (any(is.na(y))) {
			error("plot", "y does not match the names in x")
		}
		plot(x, y, ...)
	}
)


setMethod("plotRGB", signature(x="SpatRaster"),
	function(x, r=1, g=2, b=3, a=NULL, scale=NULL, mar=0, stretch=NULL, smooth=TRUE, 
		colNA="white", alpha=NULL, bgalpha=NULL, zlim=NULL, zcol=FALSE, axes=FALSE, ...) {
	
	x <- x[[c(r, g, b, a)]]
	RGB(x) <- 1:nlyr(x)
	plot(x, -1, scale=scale, mar=mar, stretch=stretch, smooth=smooth, colNA=colNA,
		alpha=alpha, bgalpha=bgalpha, zlim=zlim, zcol=zcol, axes=axes, ...)
}
)

# # Author: Robert J. Hijmans
# # Date:  October 2018
# # Version 1.0
# # License GPL v3


# .rast_replace <- function(x, name, value, caller="$<-") {
	# if (inherits(value, "SpatRaster")) {
		# value <- value[[1]]
		# names(value) <- name
	# } else if (!is.null(value)) {
		# y <- rast(x, nlyrs=1)
		# test <- try(values(y) <- value, silent=TRUE)
		# if (inherits(test, "try-error")) {
			# error(caller, "the replacement value is not valid")
		# }
		# value <- y
		# names(value) <- name
	# }
	# i <- which(name == names(x))[1]
	# if (is.null(value)) {
		# if (is.na(i)) {
				# return(x)
		# } else {
			# return(subset(x, -i, NSE=FALSE))
		# }
	# }

	# if (is.na(i)) {
		# c(x, value)
	# } else if (nlyr(x) == 1) {
		# value$deepcopy()
	# } else if (i == 1) {
		# c(value, x[[2:nlyr(x)]])
	# } else if (i == nlyr(x)) {
		# c(x[[1:(nlyr(x)-1)]], value)
	# } else {
		# c(x[[1:(i-1)]], value, x[[(i+1):nlyr(x)]])
	# }
# }

# setMethod("$<-", "SpatRaster",
	# function(x, name, value) {
		# .rast_replace(x, name, value, "$<-")
	# }
# )


# setReplaceMethod("[[", c("SpatRaster", "character", "missing"),
	# function(x, i, j, value) {
		# if (inherits(value, "SpatRaster")) {
			# if (nlyr(value) != length(i)) {
				# error("`[[`", "length of names must be equal to the number of layers")
			# }
			# names(value) <- i
		# } else if (length(i) > 1) {
			# if (NCOL(value) > 1) {
				# value <- as.list(data.frame(value))
			# } else {
				# stopifnot(length(i) == length(value))
			# }
		# } else if (!is.list(value)) {
			# value <- list(value)
		# }
		# for (k in 1:length(i)) {
			# x <- .rast_replace(x, i[k], value[[k]], " [[<- ")
# #			eval(parse(text = paste0("x$", i[k], " <- value[[k]]")))
		# }
		# x
	# }
# )

# setReplaceMethod("[[", c("SpatRaster", "numeric", "missing"),
	# function(x, i, j, value) {
		# if (!inherits(value, "SpatRaster")) {
			# error("`[[<-`", "Expected a SpatRaster as replacement value")
		# }
		# if (nlyr(value) != length(i)) {
			# error("`[[`", "length of indices must be equal to the number of layers")
		# }
		# if (any(i<1) | any(i > nlyr(x))) {
			# error("`[[`", "indices must be between 1 and the number of layers")
		# }
		# if (nlyr(x) == 1) {
			# compareGeom(x, value, crs=FALSE, warncrs=TRUE)
			# return(value)
		# }
		# for (k in 1:length(i)) {
			# if (i[k] == 1) {
				# x <- c(value[[k]], x[[2:nlyr(x)]])
			# } else if (i[k] == nlyr(x)) {
				# x <- c(x[[1:(nlyr(x)-1)]], value[[k]])
			# } else {
				# x <- c(x[[1:(i[k]-1)]], value[[k]], x[[(i[k]+1):nlyr(x)]])
			# }
		# }
		# g <- gc()
		# x
	# }
# )



# setReplaceMethod("[", c("SpatRaster", "missing", "missing"),
	# function(x, i, j, value) {

		# nl <- nlyr(x)
		# if (is.matrix(value)) {
			# d <- dim(value)
			# if (!all(d == c(ncell(x), nl))) {
				# if ((d[2] == nl) && (d[1] < ncell(x))) {
					# value <- apply(value, 2, function(i) rep_len(i, ncell(x)))
				# } else {
					# error("`[`","dimensions of the matrix do not match the SpatRaster")
				# }
			# }
			# x <- try( setValues(x, value, TRUE, TRUE) )
		# } else {
			# v <- try( matrix(nrow=ncell(x), ncol=nl) )
			# if (! inherits(x, "try-error")) {
				# v[] <- value
				# x <- try( setValues(x, v, TRUE, TRUE) )
			# }
		# }
		# if (inherits(x, "try-error")) {
			# error("`[`", "cannot set values")
		# }
		# return(x)
	# }
# )



# setReplaceMethod("[", c("SpatRaster","numeric", "missing"),
	# function(x, i, j, value) {
		# theCall <- sys.call(-1)
		# narg <- length(theCall)-length(match.call(call=sys.call(-1)))
		# if (narg > 0) { # row
			# i <- cellFromRowColCombine(x, i, 1:ncol(x))
		# }
		# #if (any(is.na(i))) {
		# #	warn("`[`", "indices should not be NA")
		# #}
		# bylyr = FALSE
		# if (!is.null(dim(value))) {
			# #x@pntr <- x@pntr$replaceValues(i, value, ncol(value))
			# stopifnot(ncol(value) == nlyr(x))
			# bylyr <- TRUE
			# if (inherits(value, "data.frame")) {
				# value <- as.matrix(value)
			# }
			# value <- as.vector(value)
		# }

		# x@pntr <- x@pntr$deepcopy()
		# opt <- spatOptions()
		# if (!x@pntr$replaceCellValues(i-1, value, bylyr, opt)) {
			# messages(x, "`[<-`")
		# } else {
			# x
		# }
	# }
# )


# setMethod("set.values", signature(x="SpatRaster"),
	# function(x, cells, values, layer=0)  {

		# #if (any(is.na(cells))) {
		# #	warn("set.values", "cells should not be NA")
		# #}

		# if (is.character(layer)) {
			# layer <- match(layer, names(x))
			# if (any(is.na(layer))) {
				# error("set.values", "invalid layer")
			# }
		# }
		# layer <- round(layer)

		# if (all(layer > 0)) {
			# if (missing(cells) && missing(values)) {
				# return(invisible(TRUE));
			# }
			# if (any(is.na(layer))) { error("set.values", "layers cannot be NA")}
			# if (inherits(layer, "character")) {
				# layer <- match(layer, names(x))
				# if (any(is.na(layer))) { error("set.values", "invalid layer names")}
			# }
			# if (any((layer < 1) | (layer > nlyr(x))))  { error("set.values", "invalid layer numbers") }
			# n <- length(layer)
			# if (n > length(unique(layer)))  { error("set.values", "duplicated layers") }

			# bylyr <- FALSE
			# if (!is.null(dim(values))) {
				# if (ncol(values) != n) {
					# error("set.values", "ncol(values) does not match the `length(layer)`")
				# }
				# bylyr <- TRUE
				# #if (inherits(values, "data.frame")) {
				# #	values <- as.matrix(values)
				# #}
				# values <- as.vector(values)
			# }
			# ok <- x@pntr$replaceCellValuesLayer(layer-1, cells-1, values, bylyr, spatOptions())
			# messages(x)
			# invisible(TRUE)
		# } else {
			# if (any(layer > 0)) {
				# error("set.values", "some (but not all) layer numbers are < 1")
			# }
			# if (missing(cells) && missing(values)) {
				# x@pntr$readAll()
				# return(invisible(TRUE));
			# }
			# bylyr <- FALSE
			# if (!is.null(dim(values))) {
				# if (ncol(values) != nlyr(x)) {
					# error("set.values", "ncol(values) does not match the nlyr(x)")
				# }
				# bylyr <- TRUE
				# #if (inherits(values, "data.frame")) {
				# #	values <- as.matrix(values)
				# #}
				# values <- as.vector(values)
			# }
			# ok <- x@pntr$replaceCellValues(cells-1, values, bylyr, spatOptions())
			# messages(x)
		# }
		# invisible(TRUE)
	# }
# )

# setReplaceMethod("[", c("SpatRaster", "numeric", "numeric"),
	# function(x, i, j, value) {
		# i <- cellFromRowColCombine(x, i, j)
		# x[i] <- value
		# x
	# }
# )



# setReplaceMethod("[", c("SpatRaster","missing", "numeric"),
	# function(x, i, j, value) {
		# i <- cellFromRowColCombine(x, 1:nrow(x), j)
		# x[i] <- value
		# x
	# }
# )



# setReplaceMethod("[", c("SpatRaster", "logical", "missing"),
	# function(x, i, j, value) {
		# i <- which(rep_len(i, ncell(x)))
		# x[i] <- value
		# x
	# }
# )


# setReplaceMethod("[", c("SpatRaster", "SpatRaster", "ANY"),
	# function(x, i, j, value) {
		# theCall <- sys.call(-1)
		# narg <- length(theCall)-length(match.call(call=sys.call(-1)))
		# if (narg > 0) { # row
			# error("`[`", "you cannot use a SpatRaster as a row index")
		# }
		# if (inherits(value, "SpatRaster")) {
			# x <- mask(x, i, maskvalues=TRUE)
			# cover(x, value)
		# } else {
			# if (NCOL(value) > 1) {
				# error(" [", "cannot use a data.frame with multiple columns")
			# }
			# value <- unlist(value)
			# if (length(value) == 1) {
				# mask(x, i, maskvalues=TRUE, updatevalue=value[1])
			# } else {
				# i <- as.logical(values(i))
				# i[is.na(i)] <- TRUE
				# i <- which(i)
				# x[i] <- value
				# x
			# }
		# }
	# }
# )


# setReplaceMethod("[", c("SpatRaster", "SpatVector", "missing"),
	# function(x, i, j, value) {
		# theCall <- sys.call(-1)
		# narg <- length(theCall)-length(match.call(call=sys.call(-1)))
		# if (narg > 0) { # row
			# error("`[`", "you cannot use a SpatVector as a row index")
		# }
		# if (length(value) > 1) {
			# value <- rep_len(value, length.out=length(x))
		# }
		# rasterize(i, x, field=value, update=TRUE)
	# }
# )

# Author: Robert J. Hijmans
# Date : December 2017
# Version 1.0
# License GPL v3


.makeTextFun <- function(fun) {
	if (!inherits(fun, "character")) {
		fun <- match.fun(fun)
		if (is.primitive(fun)) {
			test <- try(deparse(fun)[[1]], silent=TRUE)
			test <- gsub('.Primitive\\(\"', "", test)
			test <- gsub('\")', "", test)
			if (test %in% c("sum", "min", "max", "prod", "any", "all")) return(test);
		} else {
			depf <- deparse(fun)
			test1 <- isTRUE(try( depf[2] == 'UseMethod(\"mean\")', silent=TRUE))
			test2 <- isTRUE(try( fun@generic == "mean", silent=TRUE))
			if (test1 | test2) return("mean")
			test1 <- isTRUE(try( depf[2] == 'UseMethod(\"median\")', silent=TRUE))
			test2 <- isTRUE(try( fun@generic == "median", silent=TRUE))
			if (test1 | test2) return("median")
			test1 <- isTRUE(try( depf[1] == "function (x, na.rm = FALSE) ", silent=TRUE))
			test2 <- isTRUE(try( depf[2] == "sqrt(var(if (is.vector(x) || is.factor(x)) x else as.double(x), ", silent=TRUE))
			test3 <- isTRUE(try( depf[3] == "    na.rm = na.rm))", silent=TRUE))
			if (test1 && test2 && test3) return("sd")
			if (isTRUE(try( fun@generic == "which.min", silent=TRUE))) return("which.min")
			if (isTRUE(try( fun@generic == "which.max", silent=TRUE))) return("which.max")
			if (isTRUE(all(depf[1] == deparse(base::which)[1]))) return("which")
			if (isTRUE(all(depf[1] == deparse(base::table)[1]))) return("table")
		}
	}
	return(fun)
}


setMethod("aggregate", signature(x="SpatRaster"),
function(x, fact=2, fun="mean", ..., cores=1, filename="", overwrite=FALSE, wopt=list())  {

	# check if fact is an integer? round fact?

	if (hasValues(x)) { 
		fun <- .makeTextFun(fun)
		toc <- FALSE
		if (inherits(fun, "character")) {
			if (fun %in% c("sum", "mean", "min", "max", "median", "modal","prod", "which.min", "which.max",
					"any", "all", "none", "sd", "std", "sdpop", "table")) {
				fun[fun == "sdpop"] <- "std"
				toc <- TRUE
			} else {
				fun <- match.fun(fun)
			}
		} else {
			fun <- match.fun(fun)
		}
	} else {
		toc = TRUE 
		fun = "mean"
	}
		
	if (toc) {
		#	fun="mean", expand=TRUE, na.rm=TRUE, filename=""
		narm <- isTRUE(list(...)$na.rm)
		opt <- spatOptions(filename, overwrite, wopt=wopt)
		x@pntr <- x@pntr$aggregate(fact, fun, narm, opt)
		return (messages(x, "aggregate"))
	} else {
		out <- rast(x)
		nl <- nlyr(out)
		opt <- spatOptions()
		out@pntr <- out@pntr$aggregate(fact, "sum", TRUE, opt)
		out <- messages(out, "aggregate")
		dims <- x@pntr$get_aggregate_dims(fact)

		vtest <- values(x, dataframe=TRUE, row=1, nrows=dims[1], col=1, ncols=dims[2])
		vtest <- as.list(vtest)
		test <- sapply(vtest, fun, ...)
		dm <- dim(test)
		do_transpose = FALSE
		if (!is.null(dm)) {
			do_transpose = TRUE
		}
		if (inherits(test, "list")) {
			error("aggregate", "fun returns a list")
		}
		fun_ret <- 1
		if (length(test) > nl) {
			if ((length(test) %% nl) == 0) {
				fun_ret <- length(test) / nl
				nlyr(out) <- nlyr(x) * fun_ret
			} else {
				error("aggregate", "cannot use this function")
			}
		}

		b <- blocks(x, 4)

		nr <- max(1, floor(b$nrows[1] / fact[1])) * fact[1]
		nrs <- rep(nr, floor(nrow(x)/nr))
		d <- nrow(x) - sum(nrs)
		if (d > 0) nrs <- c(nrs, d)
		b$row <- c(0, cumsum(nrs))[1:length(nrs)] + 1
		b$nrows <- nrs
		b$n <- length(nrs)
		outnr <- ceiling(b$nrows / fact[1]);
		outrows  <- c(0, cumsum(outnr))[1:length(outnr)] + 1
		nc <- ncol(x)


		if (inherits(cores, "cluster")) {
			doPar <- TRUE
		} else if (cores > 1) {
			doPar <- TRUE
			cores <- parallel::makeCluster(cores)
			on.exit(parallel::stopCluster(cores))
			export_args(cores, ..., caller="aggregate")
		} else {
			doPar <- FALSE
		}

		mpl <- prod(dims[5:6]) * fun_ret
		readStart(x)
		on.exit(readStop(x))
		ignore <- writeStart(out, filename, overwrite, sources=sources(x), wopt=wopt)
		if (doPar) {
			for (i in 1:b$n) {
				v <- readValues(x, b$row[i], b$nrows[i], 1, nc)
				v <- x@pntr$get_aggregates(v, b$nrows[i], dims)
				v <- parallel::parSapply(cores, v, fun, ...)
				if (length(v) != outnr[i] * mpl) {
					error("aggregate", "this function does not return the correct number of values")
				}
				if (do_transpose) {
					v <- t(v)
				}
				writeValues(out, v, outrows[i], outnr[i])
			}
		} else {
			for (i in 1:b$n) {
				v <- readValues(x, b$row[i], b$nrows[i], 1, nc)
				v <- x@pntr$get_aggregates(v, b$nrows[i], dims)
				v <- sapply(v, fun, ...)
				if (length(v) != outnr[i] * mpl) {
					error("aggregate", "this function does not return the correct number of values")
				}
				if (do_transpose) {
					v <- t(v)
				}
				writeValues(out, v, outrows[i], outnr[i])
			}
		}
		out <- writeStop(out)
		messages(out, "aggregate")
	}
}
)


.agg_uf <- function(i) {
	u <- unique(i)
	if (length(u) == 1) { u } else { NA	}
}


aggregate_attributes <- function(d, by, fun=NULL, count=TRUE, ...) {
	i <- sapply(d, is.numeric)
	i[colnames(d) %in% by] <- FALSE
	j <- 1:length(by)
	da <- db <- NULL
	if (!is.null(fun)) {
		if (any(i)) {
			if (is.character(fun)) {
				f <- match.fun(fun)
				da <- aggregate(d[, i,drop=FALSE], d[, by, drop=FALSE], f, ...)
				names(da)[-j] <- paste0(fun, "_", names(da)[-j])
			} else {
				da <- aggregate(d[, i,drop=FALSE], d[, by, drop=FALSE], fun, ...)
				names(da)[-j] <- paste0("agg_", names(da)[-j])
			}
		} else {
			da <- unique(d[, by, drop=FALSE])
		}
	} else {
		i[] <- FALSE
	}
	i[colnames(d) %in% by] <- TRUE
	if (any(!i)) {
		db <- aggregate(d[, !i,drop=FALSE], d[, by, drop=FALSE], .agg_uf)
		#db <- db[, colSums(is.na(db)) < nrow(db), drop=FALSE]
		if (NCOL(da)>1) {
			da <- merge(da, db, by=by)
		} else {
			da <- db
		}
	}

	if (count) {
		dn <- aggregate(d[, by[1],drop=FALSE], d[, by, drop=FALSE], length)
		colnames(dn)[ncol(dn)] = "agg_n"
		if (NCOL(da) > 1) {
			if (nrow(dn) > 0) {
				dn <- merge(da, dn, by=by)
			} else {
				dn <- da
				dn$agg_n <- 1
			}
		}
		dn
	} else {
		da
	}
}


setMethod("aggregate", signature(x="SpatVector"),
	function(x, by=NULL, dissolve=TRUE, fun="mean", count=TRUE, ...) {
		if (inherits(by, "SpatVector")) {
			error("use 'zonal' to aggregate a SpatVector with a SpatVector")
		}
		if (is.null(by)) {
			x$aggregate_by_variable = 1;
			x@pntr <- x@pntr$aggregate("aggregate_by_variable", dissolve)
			x$aggregate_by_variable = NULL;
		} else {
			if (is.character(by)) {
				by <- unique(by)
				iby <- match(by, names(x))
				if (any(is.na(iby))) {
					bad <- paste(by[is.na(iby)], collapse=", ")
					error("aggregate", "invalid name(s) in by: ", bad)
				}
			} else if (is.numeric(by)) {
				by <- unique(by)
				iby <- round(by)
				if (any((iby < 1) | (iby > ncol(x)))) {
					bad <- iby[(iby < 1) | (iby > ncol(x))]
					error("aggregate", "invalid column number in by: ", bad)
				}
			} else {
				error("aggregate", "by should be character or numeric")
			}

			d <- values(x)
			mvars <- FALSE
			if (length(iby) > 1) {
				cvar <- apply(d[, iby], 1, function(i) paste(i, collapse="_"))
				by <- basename(tempfile())
				values(x) <- NULL
				x[[by]] <- cvar
				mvars <- TRUE
			} else {
				by <- names(x)[iby]
			}

			x@pntr <- x@pntr$aggregate(by, dissolve)
			messages(x)

			if (mvars) {
				d[[by]] <- cvar
				a <- aggregate_attributes(d, c(by, names(d)[iby]), fun=fun, count=count, ...)
			} else {
				a <- aggregate_attributes(d, names(d)[iby], fun=fun, count=count, ...)
			}

			if (any(is.na(d[[by]]))) {
				# because NaN and NA are dropped
				i <- nrow(a)+(1:2)
				a[i,] <- c(NA, NaN)
			}
			i <- match(x[[by,drop=TRUE]], a[[by]])
			i <- i[!is.na(i)]
			if (mvars) {
				a[[by]] <- NULL
			}
			values(x) <- a[i,,drop=FALSE]
		}
		x
	}
)

# setMethod("aggregate", signature(x="SpatVector"),
	# function(x, by=NULL, dissolve=TRUE, fun="mean", ...) {
		# gt <- geomtype(x)
		# if (length(by) > 1) {
			# error("aggregate", "this method can only aggregate by one variable")
		# }
		# x <- methods::as(x, "Spatial")
		# if (is.numeric(by[1])) {
			# i <- round(by)
			# if ((i > 0) & (i <= ncol(x))) {
				# by <- names(x)[i]
			# } else {
				# error("aggregate", "invalid column number supplied: ", by)
			# }
		# }
		# r <- aggregate(x, by=by, dissolve=dissolve, ...)
		# if (!missing(fun) && !missing(by)) {
			# if (.hasSlot(x, "data")) {
				# d <- x@data
				# i <- sapply(d, is.numeric)
				# i[colnames(d) %in% by] <- FALSE
				# j <- 1:length(by)
				# if (any(i)) {
					# if (is.character(fun)) {
						# f <- match.fun(fun)
						# da <- aggregate(d[, i,drop=FALSE], d[, by, drop=FALSE], f)
						# names(da)[-j] <- paste0(fun, "_", names(da)[-j])
					# } else {
						# da <- aggregate(d[, i,drop=FALSE], d[, by, drop=FALSE], fun)
						# names(da)[-j] <- paste0("agg_", names(da)[-j])
					# }
					# r <- merge(r, da, by)
				# }
				# i[colnames(d) %in% by] <- TRUE
				# if (any(!i)) {
					# db <- aggregate(d[, !i,drop=FALSE], d[, by, drop=FALSE], .agg_uf)
					# db <- db[, colSums(is.na(db)) < nrow(db), drop=FALSE]
					# if (ncol(db) > 1) {
						# r <- merge(r, db, by)
					# }
				# }
				# dn <- aggregate(d[, by,drop=FALSE], d[, by, drop=FALSE], length)
				# colnames(dn)[2] = "agg_n"
				# r <- merge(r, dn, by)
			# }
		# }
		# vect(r)
	# }
# )

# Author: Robert J. Hijmans
# Date :  October 2017
# Version 1.0
# License GPL v3


new_rast <- function(nrows=10, ncols=10, nlyrs=1, xmin=0, xmax=1, ymin=0, ymax=1, crs, extent, resolution, vals, names, time, units) {

	ncols <- round(ncols)
	if (ncols < 1) error("rast", "ncols < 1")
	nrows <- round(nrows)
	if (nrows < 1) error("rast", "nrows < 1")
	if (nlyrs < 1) error("rast", "nlyrs < 1")

	if (missing(extent)) {
		e <- c(xmin, xmax, ymin, ymax)
	} else {
		extent <- ext(extent)
		e <- as.vector(extent)
	}
	if ((e[1] >= e[2]) || e[3] >= e[4]) {
		error("rast,missing", "invalid extent")
	}
	if (missing(crs)) {
		if (e[1] > -360.01 & e[2] < 360.01 & e[3] > -90.01 & e[4] < 90.01) {
			crs <- "OGC:CRS84"
		} else {
			crs <- ""
		}
	} else {
		crs <- character_crs(crs, "rast")
	}
	#check_proj4_datum(crs)

	r <- methods::new("SpatRaster")
	r@pntr <- SpatRaster$new(c(nrows, ncols, nlyrs), e, crs)
	r <- messages(r, "rast")

	if (!missing(resolution)) {
		res(r) <- resolution
	}
	if (!missing(vals)) {
		if (length(vals) == 1) {
			if (is.na(vals[1])) {
				vals <- as.numeric(NA)
			}
		}
		if (!is.null(ncol(vals))) {
			nms <- colnames(vals)
			if (length(nms) == nlyr(r)) {
				names(r) <- nms
			}
		}
		values(r) <- vals
	}
	if (!missing(names)) {
		names(r) <- names
	}
	if (!missing(time)) {
		time(r) <- time
	}
	if (!missing(units)) {
		time(r) <- units
	}
	r
}


setMethod("rast", signature(x="missing"),
	function(x, nrows=180, ncols=360, nlyrs=1, xmin=-180, xmax=180, ymin=-90, ymax=90, crs, extent, resolution, vals, names, time, units) {
		new_rast(nrows, ncols, nlyrs, xmin, xmax, ymin, ymax, crs, extent, resolution, vals, names, time, units)
	}
)




rast_from_image <- function(x) { 
	# list representing an "image"
	if (! all(dim(x$z) == c(length(x$x), length(x$y)))) {
		error("rast", '"z" does not have the right dimensions') 
	}
	# omitted "-1" bug fix by Barry Rowlingson 
	resx <- ( x$x[length(x$x)] - x$x[1] ) / (length(x$x)-1)
	resy <- ( x$y[length(x$y)] - x$y[1] ) / (length(x$y)-1)
	xmn <- min(x$x) - 0.5 * resx
	xmx <- max(x$x) + 0.5 * resx
	ymn <- min(x$y) - 0.5 * resy
	ymx <- max(x$y) + 0.5 * resy

	dx <- abs(max(abs((x$x[-1] - x$x[-length(x$x)])) / resx) - 1)
	dy <- abs(max(abs((x$y[-1] - x$y[-length(x$y)])) / resy) - 1)
	if (is.na(dx) | is.na(dy)) {
		error("rast", "missing values in coordinates")
	} 
	if (dx > 0.01 | dy > 0.01) {
		error("rast", "data are not on a regular grid")
	}
#	if (xmn > -360.1 & xmx < 360.1 & ymn > -90.1 & ymx < 90.1) { 
#		crs <- "+proj=longlat +datum=WGS84"
#	} else {
#		crs <- ""
#	}
	x <- t(x$z)
	x <- x[nrow(x):1, ]
	rast(x, extent=ext(xmn, xmx, ymn, ymx), crs="")
}



setMethod("rast", signature(x="list"),
	function(x, warn=TRUE) {
		i <- sapply(x, function(i) inherits(i, "SpatRaster"))
		if (!all(i)) {
			if (!any(i)) {
				if ((length(x) == 3) && all(c("x", "y", "z") %in% names(x))) {
					return(rast_from_image(x))
				}
				error("rast,list", "none of the elements of x are a SpatRaster")
			} else {
				warn("rast", sum(!i), " out of ", length(x), " elements of x are not a SpatRaster")
				x <- x[i]
			}
		}
		# start with an empty raster (alternatively use a deep copy)
		out <- deepcopy(x[[1]])
		if (length(x) == 1) {
			return(out)
		}
		opt <- spatOptions()
		for (i in 2:length(x)) {
			out@pntr$addSource(x[[i]]@pntr, warn, opt)
		}
		out <- messages(out, "rast")
		lnms <- names(x)
		if (!is.null(lnms)) {
			if (any(lnms != "") && (length(lnms) == nlyr(out))) {
				rnms <- names(out)
				rnms[lnms != ""] <- lnms[lnms != ""]
				names(out) <- rnms
			} else if (all(lnms != "")) {
				nl <- sapply(x, nlyr)
				rnms <- sapply(1:length(nl), function(i) {
							if (nl[i] > 1) paste0(lnms[i], "_", 1:nl[i]) else lnms[i]
						})
				names(out) <- unlist(rnms)
			}
		}
		out
	}
)


setMethod("rast", signature(x="SpatExtent"),
	function(x, ...) {
		dots <- list(...)
		dots$xmin=x[1]
		dots$xmax=x[2]
		dots$ymin=x[3]
		dots$ymax=x[4]
		r <- do.call(new_rast, dots)
		# re-apply extent to avoid mimute differences
		ext(r) <- x
		r
	}
)


setMethod("rast", signature(x="SpatVector"),
	function(x, type="", ...) {

		dots <- list(...)
		noCRS <- all(is.na(pmatch(names(dots), "crs")))

		if (type == "xyz") {
			if (geomtype(x) != "points") {
				error("rast", "xyz can only be used with points")
			}
			v <- data.frame(crds(x), data.frame(x))
			if (noCRS) {
				return(rast(v, type="xyz", crs=crs(x), ...))
			} else {
				return(rast(v, type="xyz", ...))			
			}
		}
	
		e <- ext(x)
		dots$xmin=e[1]
		dots$xmax=e[2]
		dots$ymin=e[3]
		dots$ymax=e[4]
		if (noCRS) {
			dots$crs <- crs(x)
		}
		do.call(new_rast, dots)
	}
)



.fullFilename <- function(x, mustExist=FALSE, vsi=FALSE) {
	x <- trimws(x)
	x <- x[x != ""]
	x <- enc2utf8(x)
	
	i <- substr(x, 1, 5) == "s3://" 
	x[i] <- paste0("/vsis3/", substr(x[i], 6, nchar(x[i])))
	if (all(i)) return(x)
	
	i <- substr(x, 1, 4) == "http" 
	if (vsi) {
		x[i] <- paste0("/vsicurl/", x[i])
	}
	if (all(i)) return(x)

	i <- grepl(":", x)
	if (all(i)) return(x)
	
	p <- normalizePath(x[!i], winslash = "/", mustWork = FALSE)
	if (mustExist) {
		j <- file.exists(dirname(p))
		x[j] <- p[j]
	} else {
		i <- !file.exists(p)
		p[i] <- x[i]
		return(p)
	}
	#if (identical(basename(x), x)) {
	#	x <- file.path(getwd(), x)
	#}
	#if (expand) {
	#	x <- path.expand(x)
	#}
	return(x)
}

clean_domains <- function(domains) {
	if (is.null(domains)) {
		domains <- ""[0]
	} else {
		domains <- unique(domains)
		domains <- as.character(domains[!is.na(domains)])
	}
	domains
}


.old_multi <- function(x, subds=0, dims=NULL, drivers=NULL, opts=NULL, win=NULL, snap="near", vsi=FALSE, raw=FALSE, noflip=FALSE, guessCRS=TRUE, domains="") {

	f <- .fullFilename(x, vsi=isTRUE(vsi))
	if (length(f) == 0) {
		error("multi", "filename is empty. Provide a valid filename")
	}

	if (is.null(opts)) opts <- ""[0]
	if (isTRUE(raw)) opts <- c(opts, "so=false")
	
	if (is.null(drivers)) drivers <- ""[0]

	domains <- clean_domains(domains)
	if (is.null(dims)) dims <- 0
		
	r <- methods::new("SpatRaster")
	if (is.character(subds)) {
		r@pntr <- SpatRaster$new(f, -1, subds, TRUE, drivers, opts, as.integer(dims-1), isTRUE(noflip), isTRUE(guessCRS), domains, 1L)
	} else {
		#if (subds < 1) subds = 1
		r@pntr <- SpatRaster$new(f, subds-1, ""[0], TRUE, drivers, opts, as.integer(dims-1), isTRUE(noflip), isTRUE(guessCRS), domains, 1L)
	}
	messages(r, "rast (multi)")
}


setMethod("rast", signature(x="character"),
	function(x, subds=0, lyrs=NULL, drivers=NULL, opts=NULL, win=NULL, snap="near", vsi=FALSE, raw=FALSE, noflip=FALSE, guessCRS=TRUE, domains="", md=NULL, dims=NULL) {
	
		if (!isTRUE(is.finite(md))) {
			md <- 2L
		} else {
			md <- as.integer(md)
		}

		
		f <- .fullFilename(x, vsi=vsi)
		if (length(f) == 0) {
			error("rast", "filename is empty. Provide a valid filename")
		}

		if ((length(f) == 1) && grepl("\\.rds$", tolower(f[1]))) {
			r <- unwrap(readRDS(x))
			if (!inherits(r, "SpatRaster")) {
				error("rast", "the rds file does not store a SpatRaster")
			}
			return(r)
		}


		d_dims <- if (is.null(dims)) integer(0) else as.integer(dims)

		domains <- clean_domains(domains)
		r <- methods::new("SpatRaster")
		#subds <- subds[1]
		if (is.null(opts)) opts <- ""[0]
		if (raw) opts <- c(opts, "so=false")
		if (is.null(drivers)) drivers <- ""[0]
		if (length(subds) == 0) subds <- 0
		if (is.character(subds)) {
			r@pntr <- SpatRaster$new(f, -1, subds, FALSE, drivers, opts, d_dims, isTRUE(noflip), isTRUE(guessCRS), domains, md)
		} else {
			r@pntr <- SpatRaster$new(f, subds-1, ""[0], FALSE, drivers, opts, d_dims, isTRUE(noflip), isTRUE(guessCRS), domains, md)
		}
		r <- messages(r, "rast")
		if (r@pntr$getMessage() == "ncdf extent") {
			# could have used opts="IGNORE_XY_AXIS_NAME_CHECKS=YES"
			test <- try(r <- .ncdf_extent(r, f), silent=TRUE)
			if (inherits(test, "try-error")) {
				warn("rast", "GDAL did not find an extent. Cells not equally spaced?")
			} else if (isTRUE(guessCRS)) {
				if (crs(r) == "") {
					e <- ext(r)
					if ((e$xmin >= -180.1) && (e$xmax <= 360.1) && (e$ymin >= -90.1) && (e$ymax <= 90.1)) {
						crs(r) <- "OGC:CRS84"
					}
				}
			}
		}
		r <- messages(r, "rast")

		
		if (!is.null(lyrs)) {
			if (length(f) > 1) {
				s <- sources(r, FALSE, TRUE)
				if (max(lyrs) <= max(s$bands[s$sid == 1])) {
					lyrs <- which(!is.na(match(s$bands, lyrs)))
				}
			}
			r <- r[[lyrs]]
		} 
		if (!is.null(win)) {
			e <- ext(win)
			e <- align(e, r, snap=snap)
			window(r) <- e
		}
		r
	}
)


setMethod("rast", signature(x="SpatRaster"),
	function(x, nlyrs=nlyr(x), names, vals, keeptime=TRUE, keepunits=FALSE, props=FALSE, tags=FALSE) {
		if (inherits(nlyrs, "SpatRaster")) {
			error("rast", "use 'c()' to combine SpatRasters")
		}
		x@pntr <- x@pntr$geometry(nlyrs, props, keeptime, keepunits, tags)
		x <- messages(x, "rast")
		if (!missing(names)) {
			if (length(names) == nlyr(x)) names(x) <- names
		}
		if (!missing(vals)) {
			values(x) <- vals
		}
		x
	}
)


setMethod("rast", signature(x="SpatRasterDataset"),
	function(x) {
		if (length(x) == 0) {
			error("rast", "empty SpatRasterDataset")
		} else if (length(x) == 1) {
			x[1]
		} else {
			r <- methods::new("SpatRaster")
			r@pntr <- x@pntr$collapse()
			nms <- names(x)
			if (any(nms != "")) {
				names(r) <- paste(rep(nms, nlyr(x)), names(r), sep="_")
			}
			r
		}
	}
)


setMethod("rast", signature(x="array"),
	function(x, crs="", extent=NULL) {
		dims <- dim(x)
		if (length(dims) < 3) {
			error("rast,array", "cannot handle an array with less than 3 dimensions")
		}
		if (length(dims) > 3) {
			if (length(dims) == 4) {
				if (dims[4] == 1) {
					x <- x[,,,1]
				} else {
					error("rast,array", "rast cannot handle an array with 4 dimensions (try 'sds')")
				}
			} else {
				error("rast,array", "cannot handle an array with more than 3 dimensions")
			}
		}
		r <- methods::new("SpatRaster")
		if (!is.null(extent)) {
			e <- as.vector(extent)
		} else {
			e <- c(0, dims[2], 0, dims[1])
		}
		crs <- character_crs(crs, "rast")
		r@pntr <- SpatRaster$new(dims, e, crs)
		values(r) <- x
		messages(r, "rast")
	}
)



setMethod("rast", signature(x="ANY"),
	function(x, ...) {
		if (inherits(x, "sf")) {
			out <- rast(ext(x), ...)
			if (is.null(list(...)$crs)) {
				sfi <- attr(x, "sf_column")
				crs(out, warn=FALSE) <- attr(x[[sfi]], "crs")$wkt
			}
		} else {
			out <- methods::as(x, "SpatRaster")
		}
		#g <- gc()
		out
	}
)


.rastFromXYZ <- function(xyz, digits=6, crs="", extent=NULL) {


	ln <- colnames(xyz)
	## xyz might not have colnames, or might have "" names
	if (is.null(ln)) ln <- rep("", ncol(xyz))
	if (any(nchar(ln) < 1)) ln <- make.names(ln)
	if (inherits(xyz, "data.frame")) {
		xyz <- as.matrix(xyz)
		xyz <- matrix(as.numeric(xyz), ncol=ncol(xyz), nrow=nrow(xyz))
	}
	
	x <- sort(unique(xyz[,1]))
#	x <- sort(unique(round(xyz[,1], digits+2)))
	
	if (length(x) == 1) {
		error("rast", "cannot create a raster geometry from a single x coordinate")
	}
	dx <- x[-1] - x[-length(x)]

	rx <- min(dx)
	for (i in 1:5) {
		rx <- rx / i
		q <- sum(round(dx / rx, digits=digits) %% 1)
		if ( q == 0 ) {
			break
		}
	}
	if ( q > 0 ) {
		error("raster,matrix(xyz)", "x cell sizes are not regular")
	}

	y <- sort(unique(xyz[,2]))
#	y <- sort(unique(round(xyz[,2], digits+2)))
	if (length(y) == 1) {
		error("rast", "cannot create a raster geometry from a single y coordinate")
	}
	dy <- y[-1] - y[-length(y)]

	ry <- min(dy)
	for (i in 1:5) {
		ry <- ry / i
		q <- sum(round(dy / ry, digits=digits) %% 1)
		if ( q == 0 ) {
			break
		}
	}
	if ( q > 0 ) {
		error("raster,matrix(xyz)", "y cell sizes are not regular")
	}

	minx <- min(x) - 0.5 * rx
	maxx <- max(x) + 0.5 * rx
	miny <- min(y) - 0.5 * ry
	maxy <- max(y) + 0.5 * ry

	d <- dim(xyz)
	r <- rast(xmin=minx, xmax=maxx, ymin=miny, ymax=maxy, crs=crs, nlyrs=max(1, d[2]-2))
	res(r) <- c(rx, ry)
	ext(r) <- round(ext(r), digits+2)
	cells <- cellFromXY(r, xyz[,1:2])
	if (d[2] > 2) {
		names(r) <- ln[-c(1:2)]
		v <- try( matrix(NA, nrow=ncell(r), ncol= nlyr(r)) )
		if (inherits(v, "try-error")) {
			error(paste("cannot make matrix with ", ncell(r), " rows"))
		}
		v[cells, ] <- xyz[, -c(1:2)]
		values(r) <- v
	}

	if (!is.null(extent)) {
		r <- extend(r, extent)
		r <- crop(r, extent)
	}

	return(r)
}


.rastFromXYLZ <- function(x, digits=6, crs="", extent=NULL) {
	if (ncol(x) != 4) {
		error("rast", "a 'xylz' structure must have 4 columns")
	}
	nms <- names(x)
	names(x)[1:3] <- c("x", "y", "l")
	x <- as.data.frame(x) # so that this also works for tibble #1582
	w <- stats::reshape(x, timevar="l", idvar=c("x", "y"), direction="wide")
	w <- rast(w, type="xyz", digits=digits, crs=crs, extent=extent)
	names(w) <- gsub(paste0(nms[4], "."), "", names(w))
	if (inherits(x[,3], "Date") || inherits(x[,3], "POSIXlt") || inherits(x[,3], "POSIXct")) {
		time(w) <- unique(x[,3])
		names(w) <- paste0(nms[4], ".", 1:nlyr(w))
	} else if (inherits(x[,3], "numeric")) {
		u <- unique(x[,3])
		if (all(u == trunc(u))) {
			su <- sort(u)
			if ((su[1] == 1) && (su[length(su)] == length(su))) {
				if (!all(su == u)) {
					w <- w[[order(u)]]
				}
			}
		}
	}
	w
}

	

setMethod("rast", signature(x="matrix"),
	function(x, type="", crs="", digits=6, extent=NULL) {
		stopifnot(prod(dim(x)) > 0)
		if (type == "xyz") {
			r <- .rastFromXYZ(x, crs=crs, digits=digits, extent=extent)
		} else if (type == "xylz") {
			r <- .rastFromXYLZ(x, crs=crs, digits=digits, extent=extent)
		} else if (type != "") {
			error("rast", 'argument type should be one of "", "xyz", or "xylz"')
		} else {
			if (is.null(extent)) {
				r <- rast(nrows=nrow(x), ncols=ncol(x), extent=ext(c(0, ncol(x), 0, nrow(x))), crs=crs)
			} else {
				r <- rast(nrows=nrow(x), ncols=ncol(x), crs=crs, extent=extent)
			}
			values(r) <- as.vector(t(x))
		}
		messages(r, "rast")
	}
)


setMethod("rast", signature(x="data.frame"),
	function(x, type="xyz", crs="", digits=6, extent=NULL) {
		if (type == "xyz") {
			.rastFromXYZ(x, crs=crs, digits=digits, extent=extent)
		} else if (type == "xylz") {
			r <- .rastFromXYLZ(x, crs=crs, digits=digits, extent=extent)
		} else if (type != "") {
			error("rast", 'argument type should be one of "", "xyz", or "xylz"')
		} else {
			rast(as.matrix(x), type=type, crs=crs, digits=digits, extent=extent)
		}
	}
)


setMethod("rast", signature(x="stars"),
	function(x) {
		x <- from_stars(x)
		if (inherits(x, "SpatRasterDataset")) {
			rast(x)
		} else {
			x
		}
	}
)

setMethod("rast", signature(x="stars_proxy"),
	function(x) {
		x <- from_stars(x)
		if (inherits(x, "SpatRasterDataset")) {
			rast(x)
		} else {
			x
		}
	}
)

setMethod("NAflag<-", signature(x="SpatRaster"),
	function(x, value)  {
		value <- as.numeric(value)
		if (!(x@pntr$setNAflag(value))) {
			error("NAflag<-", "cannot set this value")
		}
		x
	}
)

setMethod("NAflag", signature(x="SpatRaster"),
	function(x)  {
		x@pntr$getNAflag()
	}
)

get_legxy <- function(r, e, pos, yshift, nudge=NULL) {
	xy <- c(r$left, r$top)
	if (grepl("top", pos)) {
		xy[2] <- e[4]
	} else if (grepl("bottom", pos)) {
		xy[2] <- e[3] + r$h
	}

	if (grepl("left", pos)) {
		xy[1] <- e[1]
	} else if (grepl("right", pos)) {
		xy[1] <- e[2] - r$w
	}
	
	if (!is.null(yshift)) {
		hy <- (e[4] - e[3]) / 2
		xy[2] <- xy[2] - hy
	}
	.nudge_xy(xy, nudge)
}


.plot.class.legend <- function(x, y, legend, fill, xpd=NA, cex=1, geomtype="",
	lty=1, lwd=1, pch=1, angle=45, density=NULL, pt.cex = 1, pt.bg="black", pt.lwd=1, 
	bty="n", border="black", seg.len=1, plotlim, yshift=NULL, order=FALSE, sort=FALSE, reverse=FALSE,
	text.col=graphics::par("col"), nudge=c(0,0), 
	title=NULL, leg_i=1, title.x=NULL, title.y=NULL, title.adj=0.5, title.pos=NULL, 
	title.cex=cex[1], title.col=text.col[1], title.font=NULL, 
# catch and kill
	merge, trace, digits, size, at, format, title.srt,
	tick, tick.length, tick.col, tick.box.col, tick.lwd, 
	tic, tic.length, tic.col, tic.box.col, tic.lwd, ...) {

	cex <- cex * 0.8
	if (x %in% c("top", "default")) {
		#usr <- graphics::par("usr")
		x <- plotlim[2]
		y <- plotlim[4]
	}
	
	if (is.null(leg_i)) leg_i = 1
    if (leg_i <= length(title)) {
		title <- title[leg_i]
	} else {
		title <- title[1]		
	}
	
	if ((!is.null(title.x)) && (!is.null(title.y))) {
		text(x=title.x, y=title.y, labels=title, pos=title.pos, cex=title.cex, xpd=NA, adj=title.adj, font=title.font, col=title.col)
		title <- ""
	}
	
	if (reverse) {
		fill <- rev(fill)
		legend <- rev(legend)
		lty <- rev(lty)
		lwd <- rev(lwd)
		bty <- rev(bty)
		pch <- rev(pch)
		pt.cex <- rev(pt.cex)
		pt.bg <- rev(pt.bg)
		pt.lwd <- rev(pt.lwd)
		cex <- rev(cex)
		density <- rev(density*2)
		angle <- rev(angle)
		border <- rev(border)		
		seg.len <- rev(seg.len)
	}
	
	
	if (!inherits(x, "character")) {
		xy <- .nudge_xy(cbind(x, y), nudge)
		x <- xy[1,1]
		y <- xy[1,2]
	}

#points(leg$rect$left+leg$rect$w, leg$rect$top-leg$rect$h, xpd=T)	
	if ("title.cex" %in% names(as.list(args(graphics::legend)))) {
		if (grepl("points", geomtype)) {
			if (inherits(x, "character")) {
				r <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, pch=pch, pt.cex=pt.cex, pt.bg=pt.bg, pt.lwd=pt.lwd, plot=FALSE, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font,...)$rect
				xy <- get_legxy(r, plotlim, x, yshift, nudge)
				leg <- legend(xy[1], xy[2], legend, col=fill, xpd=xpd, bty=bty, cex=cex, pch=pch, pt.cex=pt.cex, pt.bg=pt.bg, pt.lwd=pt.lwd, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font,...)
			} else {
				leg <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, pch=pch, pt.cex=pt.cex, pt.bg=pt.bg, pt.lwd=pt.lwd, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)
			}
		} else if (geomtype == "lines") {
			if (inherits(x, "character")) {
				r <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, lty=lty, lwd=lwd, seg.len=seg.len, plot=FALSE, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)$rect
				xy <- get_legxy(r, plotlim, x, yshift, nudge)
				leg <- legend(xy[1], xy[2], legend, col=fill, xpd=xpd, bty=bty, cex=cex, lty=lty, lwd=lwd, seg.len=seg.len, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)
			} else {
				leg <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, lty=lty, lwd=lwd, seg.len=seg.len, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)
			}
		} else {
			if (inherits(x, "character")) {
				r <- legend(x, y, legend, fill=fill, xpd=xpd, bty=bty, cex=cex, density=density*2, angle=angle, border=border, plot=FALSE, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)$rect
				xy <- get_legxy(r, plotlim, x, yshift, nudge)
				leg <- legend(xy[1], xy[2], legend, fill=fill, xpd=xpd, bty=bty, cex=cex, density=density*2, angle=angle, border=border, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)
			} else {
				leg <- legend(x, y, legend, fill=fill, xpd=xpd, bty=bty, cex=cex, density=density*2, angle=angle, border=border, text.col=text.col, title=title, title.adj=title.adj, title.cex=title.cex, title.col=title.col, title.font=title.font, ...)
			}
		}
	} else {
		if (grepl("points", geomtype)) {
			if (inherits(x, "character")) {
				r <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, pch=pch, pt.cex=pt.cex, pt.bg=pt.bg, pt.lwd=pt.lwd, plot=FALSE, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col,...)$rect
				xy <- get_legxy(r, plotlim, x, yshift, nudge)
				leg <- legend(xy[1], xy[2], legend, col=fill, xpd=xpd, bty=bty, cex=cex, pch=pch, pt.cex=pt.cex, pt.bg=pt.bg, pt.lwd=pt.lwd, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col,...)
			} else {
				leg <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, pch=pch, pt.cex=pt.cex, pt.bg=pt.bg, pt.lwd=pt.lwd, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)
			}
		} else if (geomtype == "lines") {
			if (inherits(x, "character")) {
				r <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, lty=lty, lwd=lwd, seg.len=seg.len, plot=FALSE, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)$rect
				xy <- get_legxy(r, plotlim, x, yshift, nudge)
				leg <- legend(xy[1], xy[2], legend, col=fill, xpd=xpd, bty=bty, cex=cex, lty=lty, lwd=lwd, seg.len=seg.len, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)
			} else {
				leg <- legend(x, y, legend, col=fill, xpd=xpd, bty=bty, cex=cex, lty=lty, lwd=lwd, seg.len=seg.len, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)
			}
		} else {
			if (inherits(x, "character")) {
				r <- legend(x, y, legend, fill=fill, xpd=xpd, bty=bty, cex=cex, density=density*2, angle=angle, border=border, plot=FALSE, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)$rect
				xy <- get_legxy(r, plotlim, x, yshift, nudge)
				leg <- legend(xy[1], xy[2], legend, fill=fill, xpd=xpd, bty=bty, cex=cex, density=density*2, angle=angle, border=border, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)
			} else {
				leg <- legend(x, y, legend, fill=fill, xpd=xpd, bty=bty, cex=cex, density=density*2, angle=angle, border=border, text.col=text.col, title=title, title.adj=title.adj, title.col=title.col, ...)
			}
		}
	}
	leg
}

# Author: Robert J. Hijmans
# Date :  October 2010, January 2022
# Version 1.0
# Licence GPL v3


gdalDType <- function(dtype) {
	dps <- c("INT2S", "INT4S", "INT1U", "INT2U", "INT4U", "FLT4S", "FLT8S")
	if (!(dtype %in% dps)) {
		stop(paste(dtype, "is not a valid data type. Should be one of:", paste(dps, collapse=", ")))
	}
	bytesize <- as.integer(substr(dtype, 4, 4))
	size <- bytesize * 8
	type <- substr(dtype, 1, 3)
	if (type == "INT") {
		type <- "Int"
		if (size == 64) {
			size <- 32
			warning("8 byte integer values not supported by GDAL, changed to 4 byte integer values")
		}
		if (substr(dtype, 5, 5) == "U") {
			if (size == 8) {
				return(c("Byte", 1))
			} else {
				type <- paste("U", type, sep="")
			}
		}
	} else {
		type <- "Float"
	}
	return(c(paste0(type, size), bytesize))
}


makeVRT <- function(filename, nrow, ncol, nlyr=1, extent, xmin, ymin, xres, yres=xres, xycenter=TRUE, crs="+proj=longlat", lyrnms="", datatype, NAflag=NA, bandorder="BIL", byteorder="LSB", toptobottom=TRUE, offset=0, scale=1) {

	stopifnot(length(filename)==1)
	stopifnot(file.exists(filename))
	if (tolower(tools::file_ext(filename)) == "vrt") {
		stop("cannot (over)write a vrt header for a vrt file")
	}
	lyrnms <- rep(lyrnms, length.out=nlyr)
	fvrt <- paste0(filename, ".vrt")

	if (missing(datatype)) {
		bytes <- file.info(filename)$size / (3601 * 3601)
		if (bytes == 1) {
			datatype <- "INT1U"
		} else if (bytes == 2) {
			datatype <- "INT2U"
		} else if (bytes == 4) {
			datatype <- "FLT4S"
		} else if (bytes == 8) {
			datatype <- "FLT8S"
		}
	}

	gd <- gdalDType(datatype[1])
	datatype <- gd[1]
	pixsize <- as.integer(gd[2])

	if (bandorder[1] == "BIL") {
		pixoff <- pixsize
		lineoff <- pixsize * ncol * nlyr
		imgoff <- ((1:nlyr)-1) * ncol * pixsize
	} else if (bandorder[1] == "BSQ") {
		pixoff <- pixsize
		lineoff <- pixsize * ncol
		imgoff <- ((1:nlyr)-1) *  nrow*ncol * pixsize
	} else if (bandorder[1] == "BIP") {
		pixoff <- pixsize * nlyr
		lineoff <- pixsize * ncol * nlyr
		imgoff <- (1:nlyr)-1
	} else {
		stop("unknown bandorder")
	}

	stopifnot(byteorder[1] %in% c("LSB", "MSB"))
	if (toptobottom[1]) { rotation <- 0 } else { rotation <- 180 }
	res <- abs(c(xres, yres))
	if (missing(extent)) {
		if (xycenter) {
			xmin <- xmin - res[1]/2
			ymin <- ymin - res[2]/2
		}
		ymax <- ymin + nrow * res[2]
	} else {
		xmin <- xmin(extent)
		ymax <- ymax(extent)
	}

	f <- file(fvrt, "w")
	cat('<VRTDataset rasterXSize="', ncol, '" rasterYSize="', nrow, '">\n' , sep = "", file = f)
	cat('<GeoTransform>', xmin, ', ', res[1], ', ', rotation, ', ', ymax, ', ', 0.0, ', ', -1*res[2], '</GeoTransform>\n', sep = "", file = f)

	if (! is.na(crs) ) {
		cat('<SRS>', crs ,'</SRS>\n', sep = "", file = f)
	}

	for (i in nlyr) {
		cat('\t<VRTRasterBand dataType="', datatype, '" band="', i, '" subClass="VRTRawRasterBand">\n', sep = "" , file = f)
		cat('\t\t<Description>', lyrnms[i], '</Description>\n', sep = "", file = f)
		cat('\t\t<SourceFilename relativetoVRT="1">', basename(filename), '</SourceFilename>\n', sep = "", file = f)
		cat('\t\t<ImageOffset>', imgoff[i], '</ImageOffset>\n', sep = "", file = f)
		cat('\t\t<PixelOffset>', pixoff, '</PixelOffset>\n', sep = "", file = f)
		cat('\t\t<LineOffset>', lineoff, '</LineOffset>\n', sep = "", file = f)
		cat('\t\t<ByteOrder>', byteorder, '</ByteOrder>\n', sep = "", file = f)
		if (!is.na(NAflag)) {
			cat('\t\t<NoDataValue>', NAflag, '</NoDataValue>\n', sep = "", file = f)
		}
		if (isTRUE(offset != 0) || isTRUE(scale != 1)) {
			cat('\t\t<Offset>', offset, '</Offset>\n', sep = "", file = f)
			cat('\t\t<Scale>', scale, '</Scale>\n', sep = "", file = f)
		}
		cat('\t</VRTRasterBand>\n', sep = "", file = f)
	}
	cat('</VRTDataset>\n', sep = "", file = f)
	close(f)
	return(fvrt)
}

# a = makeVRT(ff[1], 3601, 3601, 1, xmin=37, ymin=37, xres=1/3600, lyrnms="aspect", datatype="INT2U", byteorder="MSB")

setMethod("rapp", signature(x="SpatRaster"),
function(x, first, last, fun, ..., allyrs=FALSE, fill=NA, clamp=FALSE, circular=FALSE, filename="", overwrite=FALSE, wopt=list()) {

	stopifnot(hasValues(x))
	firstval <- lastval <- NA
	if (inherits(first, "SpatRaster")) {
		first <- first[[1]]
		stopifnot(hasValues(first))
	} else {
		if (!is.numeric(first)) {
			error("rapp", "argument `first` should be numeric or SpatRaster")
		}
		firstval <- first
		stopifnot(first %in% 1:nlyr(x))
	}
	if (inherits(last, "SpatRaster")) {
		last <- last[[1]]
		stopifnot(hasValues(last))
	} else {
		if (!is.numeric(last)) {
			error("rapp", "argument `last` should be numeric or SpatRaster")
		}
		lastval <- last
		stopifnot(last %in% 1:nlyr(x))
	}
	if (!(is.na(firstval)) && (!(is.na(lastval)))) {
		error("rapp", "argument `first` or `last` must be a SpatRaster. Or use `app`")
	}
	if (!is.na(firstval)) {
		index <- last;
	} else if (!is.na(lastval)) {
		index <- first
	} else {
		index <- c(first, last)
	}
	compareGeom(x, index, lyrs=FALSE, crs=FALSE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE)

	if (!allyrs) {
		txtfun <- .makeTextFun(match.fun(fun))
		if (inherits(txtfun, "character")) {
			if (txtfun %in% .cpp_funs) {
				opt <- spatOptions(filename, overwrite, wopt=wopt)
				na.rm <- isTRUE(list(...)$na.rm)
				x@pntr <- x@pntr$rapply(index@pntr, firstval, lastval, txtfun, clamp, na.rm, circular, opt)
				return(messages(x, "rapp"))
			}
		}
	}
	out <- rast(x)
	v <- x@pntr$rappvals(index@pntr, firstval, lastval, clamp, allyrs, fill, 0, 1, circular)
	v <- sapply(v, fun, ...)
	if (is.list(v)) { error("rapp", "values returned by 'fun' do not have the same length for each cell") }
	nc <- ncol(out)
	trans = FALSE
	if (NCOL(v) == nc) {
		trans = TRUE
		nlyr(out) <- 	nrow(v)
	} else if (NROW(v) == nc) {
		nlyr(out) <- NCOL(v)
	} else if (length(v) == nc) {
		nlyr(out) <- 1
	}
	b <- writeStart(out, filename, overwrite, sources=sources(x), wopt=wopt, n=nlyr(x)*3)
	for (i in 1:b$n) {
		v <- x@pntr$rappvals(index@pntr, firstval, lastval, clamp, allyrs, fill, b$row[i]-1, b$nrows[i], circular)
		v <- sapply(v, fun, ...)
		if (trans) v = t(v)
		writeValues(out, as.vector(v), b$row[i], b$nrows[i])
	}
	out <- writeStop(out)
	return(out)
}
)

.orphanTmpFiles <- function() {

	objects <- ls(envir=globalenv())
	ftmp <- list()
	for (i in seq_along(objects)) {
		x <- get(objects[i], envir=globalenv())
		if (inherits(x, "SpatRaster")) {
			ftmp[[i]] <- sources(x)
		}
	}
	ftmp <- unique(unlist(ftmp))
	ftmp <- ftmp[ftmp != ""]
	if (length(ftmp) == 0) return(ftmp)
	pattrn <- "^spat_.*tif$"
	i <- grep(pattrn, basename(ftmp))
	ftmp <- ftmp[i]
	ff1 <- list.files(tempdir(), pattern=pattrn, full.names=TRUE)
	ff2 <- list.files(terraOptions(print=FALSE)$tempdir, pattern = pattrn, full.names = TRUE)
	ff <- unique(c(ff1, ff2))
	i <- !(basename(ff) %in% basename(ftmp))
	ff[i]

}




tmpFiles <- function(current=TRUE, orphan=FALSE, old=FALSE, remove=FALSE) {

	if (!(old | current | orphan)) {
		error("tmpFiles", "at least one of 'orphan', 'current' and 'old' must be set to TRUE")
	}

	opt <- spatOptions()
	d <- opt$tempdir
	f <- NULL
	if (old) {
		if (normalizePath(tempdir()) != normalizePath(d)) {
			warn("tmpFiles", "old files can only be found if terra uses the R tempdir")
		} else {
			f <- list.files(dirname(d), recursive=TRUE, pattern="^spat_", full.names=TRUE)
			f <- grep("Rtmp", f, value=TRUE)
			if ((length(f) > 0) && (!current)) {
				i <- grep(d, f)
				if (length(i) > 0) {
					f <- f[-i]
				}
			}
		}
	}

	if (current) {
		ff <- list.files(d, pattern="^spat", full.names=TRUE)
		f <- c(f, ff)
	} else if (orphan) {
		fo <- .orphanTmpFiles()
		f <- c(f, fo) # for if old=TRUE
	}


	if (remove) {
		file.remove(f)
		return(invisible(f))
	} else {
		return(f)
	}
}

setMethod("is.related", signature(x="SpatVector", y="SpatVector"),
	function(x, y, relation) {
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)

setMethod("is.related", signature(x="SpatVector", y="SpatExtent"),
	function(x, y, relation) {
		y <- as.polygons(y)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)

setMethod("is.related", signature(x="SpatExtent", y="SpatVector"),
	function(x, y, relation) {
		x <- as.polygons(x)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)


setMethod("is.related", signature(x="SpatVector", y="SpatRaster"),
	function(x, y, relation) {
		y <- as.polygons(y, ext=TRUE)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)

setMethod("is.related", signature(x="SpatRaster", y="SpatVector"),
	function(x, y, relation) {
		x <- as.polygons(x, ext=TRUE)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)


setMethod("is.related", signature(x="SpatExtent", y="SpatRaster"),
	function(x, y, relation) {
		x <- as.polygons(x)
		y <- as.polygons(y, ext=TRUE)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)

setMethod("is.related", signature(x="SpatRaster", y="SpatExtent"),
	function(x, y, relation) {
		x <- as.polygons(x, ext=TRUE)
		y <- as.polygons(y)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)

setMethod("is.related", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, relation) {
		x <- as.polygons(x, ext=TRUE)
		y <- as.polygons(y, ext=TRUE)
		out <- x@pntr$is_related(y@pntr, relation)
		x <- messages(x, "is.related")
		out
	}
)


setMethod("relate", signature(x="SpatVector", y="SpatVector"),
	function(x, y, relation, pairs=FALSE, na.rm=TRUE) {
		if (pairs) {
			out <- x@pntr$related_between(y@pntr, relation[1], na.rm[1])
			messages(x, "relate")
			if (length(out[[1]]) == 0) {
				cbind(id.x=0,id.y=0)[0,,drop=FALSE]
			} else {
				names(out) <- c("id.x", "id.y")
				do.call(cbind, out) + 1
			}
		} else {
			out <- x@pntr$related_between(y@pntr, relation[1], TRUE)
			messages(x, "relate")
			m <- matrix(FALSE, nrow(x), nrow(y))
			if (length(out[[1]]) > 0) {
				m[do.call(cbind, out) + 1] <- TRUE
			}
			m

#			out <- x@pntr$relate_between(y@pntr, relation, TRUE, TRUE)
#			messages(x, "relate")
#			out[out == 2] <- NA
#			matrix(as.logical(out), nrow=nrow(x), byrow=TRUE)
		}
	}
)

#setMethod("which.related", signature(x="SpatVector", y="SpatVector"),
#	function(x, y, relation) {
#		out <- x@pntr$which_related(y@pntr, relation)
#		x <- messages(x, "which.related")
#		out <- do.call(cbind, out) + 1
#		colnames(out) <- c("id.x", "id.y")
#		out
#	}
#)



setMethod("relate", signature(x="SpatVector", y="SpatExtent"),
	function(x, y, relation, ...) {
		y <- as.polygons(y)
		relate(x, y, relation, ...)
	}
)

setMethod("relate", signature(x="SpatExtent", y="SpatVector"),
	function(x, y, relation, ...) {
		x <- as.polygons(x)
		relate(x, y, relation, ...)
	}
)


setMethod("relate", signature(x="SpatVector", y="SpatRaster"),
	function(x, y, relation, ...) {
		y <- as.polygons(y, ext=TRUE)
		relate(x, y, relation, ...)
	}
)

setMethod("relate", signature(x="SpatRaster", y="SpatVector"),
	function(x, y, relation, ...) {
		x <- as.polygons(x, ext=TRUE)
		relate(x, y, relation, ...)
	}
)

setMethod("relate", signature(x="SpatExtent", y="SpatRaster"),
	function(x, y, relation, ...) {
		x <- as.polygons(x)
		y <- as.polygons(y, ext=TRUE)
		relate(x, y, relation, ...)
	}
)

setMethod("relate", signature(x="SpatRaster", y="SpatExtent"),
	function(x, y, relation, ...) {
		x <- as.polygons(x, ext=TRUE)
		y <- as.polygons(y)
		relate(x, y, relation, ...)
	}
)

setMethod("relate", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, relation, ...) {
		x <- as.polygons(x, ext=TRUE)
		y <- as.polygons(y, ext=TRUE)
		relate(x, y, relation, ...)
	}
)


setMethod("relate", signature(x="SpatExtent", y="SpatExtent"),
	function(x, y, relation, ...) {
		x <- as.polygons(x)
		y <- as.polygons(y)
		relate(x, y, relation, ...)
	}
)


setMethod("relate", signature(x="SpatVector", y="missing"),
	function(x, y, relation, pairs=FALSE, na.rm=TRUE) {

		if (pairs) {
			out <- x@pntr$related_within(relation, na.rm[1])
			messages(x, "relate")
			if (length(out[[1]]) == 0) {
				cbind(id.1=0,id.2=0)[0,,drop=FALSE]
			} else {
				names(out) <- c("id.1", "id.2")
				do.call(cbind, out) + 1
			}
		} else {
			out <- x@pntr$related_within(relation, TRUE)
			messages(x, "relate")
			out <- do.call(cbind, out) + 1
			m <- matrix(FALSE, nrow(x), nrow(x))
			m[out] <- TRUE
			m
			#if (symmetrical) {
			#	as.dist(m)
			#} else {
			#	m
			#}
		}

		#out <- x@pntr$relate_within(relation, symmetrical)
		#out[out == 2] <- NA
		#if (symmetrical) {
		#	class(out) <- "dist"
		#	attr(out, "Size") <- nrow(x)
		#	attr(out, "Diag") <- FALSE
		#	attr(out, "Upper") <- FALSE
		#} else {
		#	out <- matrix(as.logical(out), nrow=nrow(x), byrow=TRUE)
		#}
		#if (pairs) {
		#	out <- mat2wide(out, symmetrical)
		#}
		#out
	}
)



setMethod("adjacent", signature(x="SpatRaster"),
	function(x, cells, directions="rook", pairs=FALSE, include=FALSE, symmetrical=FALSE) {
		cells <- cells - 1
		if (inherits(directions, "matrix")) {
			directions[!is.finite(directions)] <- 0
			if (isTRUE(all(directions == 0))) {
				error("adjacent", "directions are all FALSE")
			}
			v <- x@pntr$adjacentMat(cells, as.logical(t(directions)), dim(directions), include)
		} else {
			#if (pairs) include <- FALSE
			v <- x@pntr$adjacent(cells,  as.character(directions)[1], include)
		}
		messages(x, "adjacent")
		if (pairs) {
			v <- cbind(from=rep(cells, each=length(v)/length(cells)), to=v)
			v <- v[!is.na(v[,2]), ]
			if (symmetrical) {
				#v <- unique(cbind(pmin(v[,1], v[,2]), pmax(v[,1], v[,2])))
				v <- .unique_symmetric_rows(v[,1], v[,2])
			}
		} else {
			v <- matrix(v, nrow=length(cells), byrow=TRUE)
			if (!include) rownames(v) <- cells
		}
		v + 1
	}
)


setMethod("adjacent", signature(x="SpatVector"),
	function(x, type="rook", pairs=TRUE, symmetrical=FALSE) {
		type <- match.arg(tolower(type), c("intersects", "touches", "queen", "rook"))
		stopifnot(geomtype(x) == "polygons")
		a <- x@pntr$relate_within(type, TRUE)
		x <- messages(x, "relate")
		a[a == 2] <- NA
		class(a) <- "dist"
		attr(a, "Size") <- nrow(x)
		attr(a, "Diag") <- FALSE
		attr(a, "Upper") <- FALSE
		a <- as.matrix(a)
		if (pairs) {
			mat2wide(a, symmetrical, 1)
		} else {
			a
		}
	}
)


setMethod("nearby", signature(x="SpatVector"),
	function(x, y=NULL, distance=0, k=1, centroids=TRUE, symmetrical=TRUE, method="geo") {
		
		k <- round(k)
		if (distance <= 0 && k < 1) {
			error("nearby", "either distance or k must be a positive number")
		}

		if (!(method %in% c("geo", "haversine", "cosine"))) {
			error("nearby", "not a valid method. Should be one of: 'geo', 'haversine', 'cosine'")
		}

		if ((geomtype(x) == "polygons") && centroids) {
			x <- centroids(x)
		}
		hasy <- !is.null(y)
		if (hasy) {
			if ((geomtype(y) == "polygons") && centroids) {
				y <- centroids(y)
			}
		}
		if (distance > 0) {
			if (hasy) {
				d <- distance(x, y, method=method)
				d <- cbind(from_id=rep(1:nrow(d), ncol(d)), to_id=rep(1:ncol(d), each=nrow(d)), distance=as.vector(d))
			} else {
				d <- distance(x, pairs=TRUE, symmetrical=symmetrical, method=method)
			}
			d[d[,3] <= distance, 1:2, drop=FALSE]
		} else {
			if (hasy) {
				k <- max(1, min(round(k), (nrow(y)-1)))
			} else {
				k <- max(1, min(round(k), (nrow(x)-1)))
			}
#			if (k > 1) {
				if (hasy) {
					d <- distance(x, y)
				} else {
					d <- as.matrix(distance(x, pairs=FALSE, method=method))
					diag(d) <- NA
				}
				d <- t(apply(d, 1, function(i) order(i)[1:k]))
				if (k==1) d <- t(d)
				d <- cbind(1:length(x), d)
#			} else {
#				d <- nearest(x)
#				d <- values(d)[, c("from_id", "to_id")]
#			}
			colnames(d) <- c("id", paste0("k", 1:k))
			d
		}
	}
)

setMethod("snapTo", signature(x="SpatVector", y="SpatVector"),
	function(x, y, paired=TRUE, ...) {
		opt <- spatOptions(...)
		x@pntr <- x@pntr$snap_to(y@pntr, paired[1], opt)
		messages(x, "snapTo")
	}
)
	

setMethod("nearest", signature(x="SpatVector"),
	function(x, y=NULL, pairs=FALSE, centroids=TRUE, lines=FALSE, method="geo") {
		if ((geomtype(x) == "polygons") && centroids) {
			x <- centroids(x)
		}
		within <- FALSE
		if (is.null(y)) {
			within <- TRUE
			y <- x
		} else if ((geomtype(y) == "polygons") && centroids) {
			y <- centroids(y)
		}
		z <- x
		if (!(method %in% c("geo", "haversine", "cosine"))) {
			error("nearest", "not a valid method. Should be one of: 'geo', 'haversine', 'cosine'")
		}
		
		if (within) {
			z@pntr <- x@pntr$near_within(method)
		} else {
			z@pntr <- x@pntr$near_between(y@pntr, pairs, method)
		}
		z <- messages(z, "nearest")
		if (geomtype(z) == "points") { 
		
			if (within) {
				names(z)[1] <- "to_id"
				z$to_id <- z$to_id + 1
				crd <- crds(x)
				X <- cbind(crd[,1], crd[z$to_id, 1])
				Y <- cbind(crd[,2], crd[z$to_id, 2])
				if (lines) {
					geom <- cbind(rep(1:nrow(x), each=2), 1, as.vector(t(X)), as.vector(t(Y)))
					z <- vect(geom, "lines", crs=crs(z), atts=values(z))
				}
				values(z) <- data.frame(from_id=1:nrow(z), from_x=X[,1], from_y=Y[,2], to_id=z$to_id, to_x=X[,2], to_y=Y[,2], distance=z$distance)
				return(z)
			}
		
			if (lines) {
				x <- z[,c(2,5), drop=TRUE]
				y <- z[,c(3,6), drop=TRUE]
				geom <- cbind(rep(1:nrow(x), each=2), 1, as.vector(t(x)), as.vector(t(y)))
				zz <- vect(geom, "lines", crs=crs(z))
				values(zz) <- values(z)
				zz$to_id = zz$to_id + 1
				zz$from_id = zz$from_id + 1
				return(zz)
			} else {
				z$to_id = z$to_id + 1
				z$from_id = z$from_id + 1
				return(z)
			}
		} else {
			if (lines) return(z)
			values(y) <- data.frame(to_id=1:nrow(y))
			dis <- perim(z)
			zz <- as.points(z)
			from <- zz[seq(1, nrow(zz), 2), ]
			to <- zz[seq(2, nrow(zz), 2), ]
			values(to) <- data.frame(id=1:nrow(to))
			to_int <- as.data.frame(intersect(to, y))
			to_int <- to_int[!duplicated(to_int[,1]), ]
			to_int <- as.data.frame(merge(to, to_int, by="id", all.x=TRUE))
			if (any(is.na(to_int$to_id))) {
				zz <- as.points(elongate(z, 1))
				from2 <- zz[seq(1, nrow(zz), 2), ]
				to2 <- zz[seq(2, nrow(zz), 2), ]
				values(to2) <- data.frame(id=1:nrow(to2))
				to_int2 <- as.data.frame(intersect(to2, y))
				colnames(to_int2)[2] <- "to_id2"
				to_int <- merge(to_int, to_int2, all.x=TRUE)
				i <- is.na(to_int$to_id)
				to_int$to_id[i] <- to_int$to_id2[i]
				to_int <- to_int[,1:2]
			}
			
			to_int <- to_int[order(to_int[["id"]]), ]

			if (nrow(to_int) > nrow(to)) {
				to_int <- aggregate(to_int[, "to_id",drop=FALSE], to_int[,"id",drop=FALSE], function(x)x[1])
#			}
#			if (nrow(to_int) < nrow(to)) {
#				to_int <- rep(NA, nrow(to))
			} else {
				to_int <- to_int[,2]
			}
			from <- geom(from)[, c("x", "y"),drop=FALSE]
			to <- geom(to)[, c("x", "y"),drop=FALSE]
			d <- data.frame(1:nrow(from), from, to_int, to, dis)
			colnames(d) <- c("from_id", "from_x", "from_y", "to_id", "to_x", "to_y", "distance")
			vect(d, c("to_x", "to_y"), crs=crs(x))
		}
	}
)

setMethod("xapp", signature(x="SpatRaster", y="SpatRaster"),
function(x, y, fun, ..., filename="", overwrite=FALSE, wopt=list())  {

	compareGeom(x, y, crs=FALSE, warncrs=TRUE)
	if (!hasValues(x)) error("xapp", "x does not have values")
	if (!hasValues(y)) error("xapp", "y does not have values")

	fun <- match.fun(fun)
	out <- rast(x)
	nc <- ncol(x)
	readStart(x)
	readStart(y)
	on.exit(readStop(x))
	on.exit(readStop(y), add=TRUE)

	dots <- list(...)
	if (length(dots) > 0) {
		test <- any(sapply(dots, function(i) inherits(i, "SpatRaster")))
		if (test) {
			error("app", "additional arguments cannot be a SpatRaster")
		}
	}
	teststart <- max(1, 0.5 * nc - 6)
	testend <- min(teststart + 12, nc)
	ntest <- 1 + testend - teststart
	vx <- readValues(x, round(0.51*nrow(x)), 1, teststart, ntest, mat=TRUE)
	vy <- readValues(y, round(0.51*nrow(y)), 1, teststart, ntest, mat=TRUE)
	test <- sapply(1:nrow(vx), function(i) fun(vx[i, ], vy[i, ], ...))
	if (is.list(test)) {
		error("xapp", "'fun' returns a list (should be numeric or matrix)")
	}
	trans <- FALSE
	if (NCOL(test) > 1) {
		if (ncol(test) == ntest) {
			nlyr(out) <- nrow(test)
			trans <- TRUE
			nms <- rownames(test)
		} else if (nrow(test) == ntest) {
			nlyr(out) <- ncol(test)
			nms <- colnames(test)
		} else {
			error("xapp", "the number of values returned by 'fun' is not appropriate\n(it should be the product of the number of cells and and a positive integer)")
		}
		if (is.null(wopt$names)) {
			wopt$names <- nms
		}
	} else {
		if ((length(test) %% ntest) != 0) {
			error("xapp", "the number of values returned by 'fun' is not appropriate")
		} else {
			nlyr(out) <- length(test) / ntest
		}
	}

	ncops <- (nlyr(x)+nlyr(y)) / nlyr(out)
	ncops <- ifelse(ncops > 1, ceiling(ncops), 1) * 4
	b <- writeStart(out, filename, overwrite, wopt=wopt, n=ncops, sources=sources(x))
	for (i in 1:b$n) {
		vx <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE)
		vy <- readValues(y, b$row[i], b$nrows[i], 1, nc, TRUE)
		r <- sapply(1:nrow(vx), function(i) fun(vx[i, ], vy[i, ], ...))
		if (trans) {
			r <- t(r)
		}
		writeValues(out, r, b$row[i], b$nrows[i])
	}
	writeStop(out)
}
)

setMethod("k_means", signature(x="ANY"),
	function(x, centers=3, ...) {
		stats::kmeans(x, centers=centers, ...)
	}
)

setMethod("k_means", signature(x="SpatRaster"),
	function(x, centers=3, ..., maxcell=1000000, filename="", overwrite=FALSE, wopt=list()) {
		stopifnot(maxcell > 0)
		if (ncell(x) <= maxcell) {
			v <- na.omit(values(x))
			omit <- as.vector(attr(v, "na.action"))
			km <- stats::kmeans(v, centers=centers, ...)
			out <- rast(x, nlyr=1)
			if (is.null(omit)) {
				values(out) <- km$cluster
			} else {
				out[-omit] <- km$cluster
			}
			if (filename != "") {
				out <- writeRaster(out, filename=filename, overwrite=overwrite, wopt=wopt)
			}
		} else {
			#pkmeans = function(x, newdata) {
			#	apply(newdata, 1, function(i) which.min(colSums((t(x$centers) - i)^2)))
			#}

			pkmeans <- function(x, newdata) {
				vec <- integer(nrow(newdata))
				newdata <- as.matrix(newdata)
				for (i in seq_len(nrow(newdata))) {
					vec[i] <- which.min(colSums((t(x) - newdata[i, ])^2))
				}
				vec
			}			
			v <- unique(na.omit(spatSample(x, maxcell, "regular")))
			km <- stats::kmeans(v, centers=centers, ...)$centers		
			out <- predict(x, km, fun=pkmeans, na.rm=TRUE, filename=filename, overwrite=overwrite, wopt=wopt)
		}
		out
	}
)



h_clust <- function(x, ngroups, dist_metric="euclidean", clust_method="complete", agfun=mean, matchfun="squared", ..., maxcell=10000, filename="", overwrite=FALSE, wopt=list()) {
	stopifnot(maxcell > 0)
	stopifnot(ngroups > 0)
	stopifnot(ngroups < maxcell)
	d <- na.omit(spatSample(x, maxcell, "regular"))
	dd <- stats::dist(d, dist_metric)
	hc <- stats::hclust(dd, clust_method)
	th <- sort(hc$height, TRUE)[ngroups]
	cls <- stats::cutree(hc, h = th)
	hc <- cut(stats::as.dendrogram(hc), h=th)$upper
	d <- aggregate(d, list(cls=cls), agfun)
	cls <- d$cls 
	d$cls <- NULL
	b <- bestMatch(x, d, fun=matchfun, ..., filename=filename, overwrite=overwrite, wopt=wopt)	
	return(list(clusters=b, dendrogram=hc))
}

setMethod("tapp", signature(x="SpatRaster"),
function(x, index, fun, ..., cores=1, filename="", overwrite=FALSE, wopt=list()) {

	stopifnot(!any(is.na(index)))

	prename <- ""
	out_time <- double()
	out_tstep <- ""
	out_tz <- "UTC"
	if (length(index) == 1) {
		if (is.character(index)) {
			choices <- c("years", "months", "dekads", "weeks", "days", "doy", "yearmonths", "yeardekads", "yearweeks", "7days", "10days", "15days")
			i <- pmatch(tolower(index), choices)
			if (is.na(i)) {
				error("tapp", paste("invalid time step. Use one of:", paste(choices, collapse=", ")))
			}
			if (!x@pntr$hasTime) {
				error("tapp", "x has no time stamps")
			}
			choice <- choices[i]
			if (choice == "doy") {
				# or POSIXlt$yday
				index <- format(time(x, "days"), "%j")
				prename <- "doy_"
			} else if (choice == "dekads") {
				index <- floor(as.integer(format(time(x, "days"), "%j")) / 10) + 1
				prename <- "dekad_"
			} else if (choice == "yeardekads") {
				year <- time(res, "years")
				year <- formatC(year, width=4, flag = "0")
				dekad <- floor(as.integer(format(time(x, "days"), "%j")) / 10) + 1
				index <- paste0(year, dekad)
				prename <- "yd_"				
			} else if (choice == "weeks") {
				index <- strftime(time(x, "days"), format = "%V")
				prename <- "week_"
			} else if (choice == "yearweeks") {
				index <- yearweek(time(x, "days"))
				prename <- "yw_"
			} else if (choice == "7days") {
				index <- as.integer(format(time(x, "days"), "%j"))
				index <- as.character((index-1) %/% 7 + 1)
				prename <- "d7_"
			} else if (choice == "10days") {
				index <- as.integer(format(time(x, "days"), "%j"))
				index <- as.character((index-1) %/% 10 + 1)
				prename <- "d10_"
			} else if (choice == "15days") {
				index <- as.integer(format(time(x, "days"), "%j"))
				index <- as.character((index-1) %/% 15 + 1)
				prename <- "d15_"
			} else { 
				index <- time(x, choice)	
				out_time <- time_as_seconds(x)[!duplicated(index)]
				out_tstep <- choice
				out_tz <- attr(index, "tzone")
				if (is.null(out_tz)) out_tz = "UTC"
				if (choice == "yearmonths") {
					year <- trunc(index)
					month <- 12 * (index - year) + 1
					year <- formatC(year, width=4, flag = "0")
					month <- formatC(month, width=2, flag = "0")
					index <- paste0(year, month)
					prename <- "ym_"
				} else {
					index <- as.character(index)
					if (choice == "months") {
						prename <- "m_"
					} else if (choice == "days") {
						prename <- "d_"
					} else if (choice == "years") {
						prename <- "y_"
					} 
				}
			}
		} else if (is.function(index)) {
			index <- as.character(index(time(x)))
		} 
	}

	nl <- nlyr(x)
	if (length(index) > nl) {
		error("tapp", "length(index) > nlyr(x)")
	} 
	# else if (length(unique(index)) == 1) {
	#	warn("tapp", "it is not sensible to a single value as index (use app instead)")	
	#}
	index <- rep_len(index, nl)
	if (!is.factor(index)) {
		index <- factor(index, levels=unique(index))
	}
	nms <- paste0(prename, as.character(index))
	ind <- as.integer(index)
	d <- unique(data.frame(nms, ind, stringsAsFactors=FALSE))
	uin <- d[,2]
	nms <- make.names(d[,1])
	nms <- nms[uin]
	txtfun <- .makeTextFun(fun)
	if (inherits(txtfun, "character")) {
		if (txtfun %in% .cpp_funs) {
			opt <- spatOptions(filename, overwrite, wopt=wopt)
			narm <- isTRUE(list(...)$na.rm)
			x@pntr <- x@pntr$apply(index, txtfun, narm, nms, out_time, out_tstep, out_tz, opt)
			return(messages(x, "tapp"))
		}
	}
	fun <- match.fun(fun)

	readStart(x)
	on.exit(readStop(x), add=TRUE)

	testnc <- min(ncol(x), 11)
	v <- readValues(x, 1, 1, 1, testnc, TRUE)

	if (any(is.factor(x))) {
		warn("app", "factors are coerced to numeric")
	}
	

	test <- apply(v, 1, FUN=fun, ...)
	transpose = FALSE
	nlout <- 1
	if (NCOL(test) > 1) {
		if (ncol(test) == testnc) {
			transpose = TRUE
			nlout <- nrow(test)
			addnms <- rownames(test)
			if (is.null(addnms)) {
				addnms <- 1:nrow(test)
			}
		} else {
			nlout <- ncol(test)
			addnms <- colnames(test)
			if (is.null(addnms)) {
				addnms <- 1:ncol(test)
			}
		}
		nms <- paste(rep(nms, each=length(addnms)), rep(addnms, length(nms)), sep="_")
	}

	out <- rast(x)
	nlyr(out) <- nlout * length(uin)
	if (length(nms) == nlyr(out)) {
		names(out) <- nms
	}
	if (out_tstep != "") {
		if (length(out_time) == nlyr(out)) {
			time(out, out_tstep) <- out_time 
		}
	}
	doclust <- FALSE
	if (inherits(cores, "cluster")) {
		doclust <- TRUE
	} else if (cores > 1) {
		doclust <- TRUE
		cores <- parallel::makeCluster(cores)
		on.exit(parallel::stopCluster(cores))
	}


	b <- writeStart(out, filename, overwrite, sources=sources(x), wopt=wopt)

	if (doclust) {
		export_args(cores, ..., caller="tapp")
		pfun <- function(x, ...) apply(x, 1, FUN=fun, ...)
		parallel::clusterExport(cores, "pfun", environment())
		for (i in 1:b$n) {
			v <- readValues(x, b$row[i], b$nrows[i], 1, ncol(out), TRUE)
			v <- lapply(uin, function(i) v[, ind==i, drop=FALSE])
			v <- parallel::parLapply(cores, v, pfun, ...)
			if (transpose) {
				v <- t(do.call(rbind, v))
			} else {
				v <- do.call(cbind, v)
			}
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	} else {
		for (i in 1:b$n) {
			v <- readValues(x, b$row[i], b$nrows[i], 1, ncol(out), TRUE)
			# like this, na.rm is not passed to FUN
			# v <- lapply(uin, function(j, ...) apply(v[, ind==uin[j], drop=FALSE], 1, FUN=fun, ...))
			# like this it works
			v <- lapply(uin, function(j) apply(v[, ind==uin[j], drop=FALSE], 1, FUN=fun, ...))
			if (transpose) {
				v <- t(do.call(rbind, v))
			} else {
				v <- do.call(cbind, v)
			}
			writeValues(out, v, b$row[i], b$nrows[i])
		}
	}
	out <- writeStop(out)
	return(out)
}
)

setMethod("makeTiles", signature(x="SpatRaster"),
	function(x, y, filename="tile_.tif", extend=FALSE, na.rm=FALSE, buffer=0, value="files", overwrite=FALSE, ...) {
	
		value <- match.arg(value, c("files", "raster", "collection"))
		filename <- trimws(filename[1])
		filename <- filename[!is.na(filename)]
		if (filename == "") error("makeTiles", "filename cannot be empty")
		opt <- spatOptions(filename="", overwrite=overwrite, ...)
		if (inherits(y, "SpatRaster")) {
			ff <- x@pntr$make_tiles(y@pntr, extend[1], buffer, na.rm[1], filename, opt)
		} else if (inherits(y, "SpatVector")) {
			ff <- x@pntr$make_tiles_vect(y@pntr, extend[1], buffer, na.rm[1], filename, opt)
		} else if (is.numeric(y)) {
			if (length(y) > 2) {
				error("makeTiles", "expected one or two numbers")
			}
			y <- rep_len(y, 2)
			y <- aggregate(rast(x), y)
			ff <- x@pntr$make_tiles(y@pntr, extend[1], buffer, na.rm[1], filename, opt)
		} else {
			error("makeTiles", "y must be numeric or a SpatRaster or SpatVector")
		}
		messages(x, "makeTiles")
		if (value == "files") {
			ff
		} else if (value == "raster") {
			filename <- gsub("_\\.", "s.", filename)
			vrt(ff, filename=filename)
		} else {
			sprc(ff)
		}
	}
)


# Choose a sensible (rows, cols) tile size for x.
#  - If x reports a GDAL block size for its source(s) (typical for tiled
#    GeoTIFFs, COGs, NetCDF, ...), align tiles to whole blocks; otherwise
#    fall back to a 256-cell square (a common GDAL block default).
#  - Cap the per-tile cell count by a memory budget, so that `cores`
#    workers running concurrently fit in `memfrac` of free RAM.
#  - Aim for a few tasks per worker (`tasks_per_worker`) to load-balance.
#  - Result is clamped to the raster's own dimensions.
.auto_tile_size <- function(x, cores=1, memfrac=NULL,
							tasks_per_worker=4, ncopies=4) {

	nr <- nrow(x); nc <- ncol(x); nl <- nlyr(x)
	cores <- max(as.integer(cores)[1], 1L)
	tasks_per_worker <- max(as.integer(tasks_per_worker)[1], 1L)

	# block size from GDAL (per source). Use the smallest reported per dim,
	# then fall back to 256 when nothing useful is reported (e.g. for
	# in-memory rasters or sources that report 0).
	fb <- tryCatch(fileBlocksize(x), error=function(e) NULL)
	if (is.null(fb) || NROW(fb) == 0) {
		br <- bc <- 0L
	} else {
		br <- as.integer(min(fb[, "rows"]))
		bc <- as.integer(min(fb[, "cols"]))
	}
	if (is.na(br) || br <= 0) br <- min(256L, nr)
	if (is.na(bc) || bc <= 0) bc <- min(256L, nc)
	br <- min(br, nr); bc <- min(bc, nc)
	one_block <- as.numeric(br) * bc

	# memory budget (bytes per cell assumes double precision and `ncopies`
	# in-flight copies, the same accounting blocks() and writeStart() use).
	bytes_per_cell <- 8 * max(nl, 1L) * max(ncopies, 1L)

	if (is.null(memfrac)) {
		memfrac <- tryCatch(spatOptions()$memfrac, error=function(e) 0.5)
		if (is.null(memfrac) || !is.finite(memfrac) || memfrac <= 0) {
			memfrac <- 0.5
		}
	}

	free_kb <- tryCatch(free_RAM(), error=function(e) NA_real_)
	if (is.na(free_kb) || !is.finite(free_kb) || free_kb <= 0) {
		# no memory info: only the parallelism constraint applies
		mem_cells <- Inf
	} else {
		free_b <- free_kb * 1024              # free_RAM returns kB
		budget <- (free_b * memfrac) / cores  # per-worker peak budget
		mem_cells <- budget / bytes_per_cell
	}

	# at least one tile per worker, and ideally a few for load balancing.
	# Avoid integer overflow on large rasters by going through `numeric`.
	total_cells <- as.numeric(nr) * nc
	target_min_tiles <- cores * tasks_per_worker
	par_cells <- total_cells / target_min_tiles

	cells_per_tile <- min(mem_cells, par_cells)
	# never go below a single block (avoids dicing tiled COGs into sub-blocks)
	cells_per_tile <- max(cells_per_tile, one_block)
	# never go above the whole raster
	cells_per_tile <- min(cells_per_tile, total_cells)

	# pick (rows, cols) as integer multiples of (br, bc), as square as possible
	side <- sqrt(cells_per_tile)
	nbr <- max(round(side / br), 1)
	nbc <- max(round(side / bc), 1)
	tile_rows <- min(as.integer(nbr * br), nr)
	tile_cols <- min(as.integer(nbc * bc), nc)

	c(tile_rows, tile_cols)
}


setMethod("getTileExtents", signature(x="SpatRaster"),
	function(x, y, extend=FALSE, buffer=0, cores=1) {

		if (missing(y) || is.null(y)) {
			y <- .auto_tile_size(x, cores=cores)
		}

		opt <- spatOptions(filename="")
		if (inherits(y, "SpatRaster")) {
			e <- x@pntr$get_tiles_ext(y@pntr, extend[1], buffer)
		} else if (inherits(y, "SpatVector")) {
			e <- x@pntr$get_tiles_ext_vect(y@pntr, extend[1], buffer)
		} else if (is.numeric(y)) {
			if (length(y) > 2) {
				error("getTileExtents", "expected one or two numbers")
			}
			y <- rep_len(y, 2)
			y <- aggregate(rast(x), y)
			e <- x@pntr$get_tiles_ext(y@pntr, extend[1], buffer)
		} else {
			error("getTileExtents", "y must be numeric or a SpatRaster or SpatVector")
		}
		messages(x, "getTileExtents")
		e <- matrix(e, ncol=4, byrow=FALSE)
		colnames(e) <- c("xmin", "xmax", "ymin", "ymax")
		e
	}
)



#		if (!hasValues(x)) error("makeTiles", "x has no values")
#		y <- rast(y)[[1]]
#		if (expand) y <- expand(y, ext(x), snap="out")
#		y <- crop(rast(y)[[1]], x, snap="out")
#		d <- 1:ncell(y)
#		if (length(filename) == 0) error("tiler", "no valid filename supplied")
#		e <- paste0(".", tools::file_ext(filename))
#		f <- tools::file_path_sans_ext(filename)
#		ff <- paste0(f, d, e)
#		for (i in d) {
#			crop(x, y[i,drop=FALSE], filename=ff[i], ...)
#		}
#		ff[file.exists(ff)]
#	}
#)


setMethod("vrt", signature(x="character"),
	function(x, filename="", options=NULL, overwrite=FALSE, set_names=FALSE, return_filename=FALSE) {
		opt <- spatOptions(filename, overwrite=overwrite)
		r <- rast()
		if (is.null(options)) {
			options=""[0]
		}
		f <- r@pntr$make_vrt(x, options, opt)
		messages(r, "vrt")
		messages(opt, "vrt")
		if (set_names) {
			v <- readLines(f)
			if ("-separate" %in% options) {
			    nms <- unlist(lapply(sprc(x), names))
			} else {
			    nms <- names(rast(x[1]))
			}
			i <- grep("band=", v)
			if (length(i) == length(nms)) {
				nms <- paste0("<Description>", nms, "</Description>")
				v[i] <- paste(v[i], nms)
				writeLines(v, f)
			}
		}
		if (return_filename) {
			f
		} else {
			rast(f)
		}
	}
)


setMethod("vrt", signature(x="SpatRasterCollection"),
	function(x, filename="", options=NULL, overwrite=FALSE, return_filename=FALSE) {
		opt <- spatOptions(filename, overwrite=overwrite)
		if (is.null(options)) {
			options=""[0]
		}
		f <- x@pntr$make_vrt(options, FALSE, opt)
		messages(x, "vrt")
		if (return_filename) {
			f
		} else {
			rast(f)
		}
	}
)


vrt_tiles <- function(x) {
	if (inherits(x, "SpatRaster")) {
		x <- sources(x)
	}
	if (!inherits(x, "character")) {
		error("vrt_sources", "x must be a filename (character) or SpatRaster)")
	}
	x <- grep(".vrt$", x, ignore.case =TRUE, value=TRUE)
	if (length(x) == 0) {
		error("vrt_sources", 'no filenames with extension ".vrt"')
	}
	tiles <- lapply(x, function(f) {
			v <- readLines(f)
			v <- v[grep("SourceFilename", v)]
			s <- strsplit(v, "\"")
			rel <- sapply(s, function(x) x[2])
			ff <- strsplit(sapply(s, function(x) x[3]), "<")
			ff <- gsub(">", "", sapply(ff, function(x) x[1]))
			ff[rel=="1"] <- file.path(dirname(f), ff[rel=="1"])
			ff
		})
	unlist(tiles)
}

.ncdf_extent <- function(x, f) {

	if (!("ncdf4" %in% rownames(utils::installed.packages()))) {
		warn("rast", "GDAL did not find an extent. installing the ncdf4 package may help")
		return(x)
	}
	fname <- f
	zvar <- varnames(x)[1]

	dims <- 1:3

	nc <- ncdf4::nc_open(fname, readunlim=FALSE, suppress_dimvals = TRUE)
	on.exit( ncdf4::nc_close(nc) )

	ncols <- nc$var[[zvar]]$dim[[dims[1]]]$len
	nrows <- nc$var[[zvar]]$dim[[dims[2]]]$len
	if (!(ncol(x) == ncols) & (nrow(x) == nrows)) {
		warn("rast", "GDAL did not find an extent. Cells not equally spaced?")
		return(x)
	}
	xx <- try(ncdf4::ncvar_get(nc, nc$var[[zvar]]$dim[[dims[1]]]$name), silent = TRUE)
	if (inherits(xx, "try-error")) {
	  xx <- seq_len(nc$var[[zvar]]$dim[[dims[1]]]$len)
	}
	rs <- xx[-length(xx)] - xx[-1]
	if (! isTRUE ( all.equal( min(rs), max(rs), tolerance=0.025, scale= abs(min(rs))) ) ) {
		warn("rast", "cells are not equally spaced; extent is not defined")
		return(x)
	}
	xrange <- c(min(xx), max(xx))
	resx <- (xrange[2] - xrange[1]) / (ncols-1)

	yy <- try(ncdf4::ncvar_get(nc, nc$var[[zvar]]$dim[[dims[2]]]$name), silent = TRUE)
	if (inherits(yy, "try-error")) {
	  yy <- seq_len(nc$var[[zvar]]$dim[[dims[2]]]$len)
	}

	rs <- yy[-length(yy)] - yy[-1]
	if (! isTRUE ( all.equal( min(rs), max(rs), tolerance=0.025, scale= abs(min(rs))) ) ) {
		warn("rast", "cells are not equally spaced; extent is not defined")
		return(x)
	}
	yrange <- c(min(yy), max(yy))
	resy <- (yrange[2] - yrange[1]) / (nrows-1)

	xrange[1] <- xrange[1] - 0.5 * resx
	xrange[2] <- xrange[2] + 0.5 * resx
	yrange[1] <- yrange[1] - 0.5 * resy
	yrange[2] <- yrange[2] + 0.5 * resy
	ext(x) <- ext(xrange[1], xrange[2], yrange[1], yrange[2])
	return(x)
}


write_tags <- function(tags, nc, varid, prefix="TAG_") {
	if (NROW(tags) > 0) {
		nms <- paste0(prefix, tags[,2])
		for(i in 1:nrow(tags)) {
			try(ncdf4::ncatt_put(nc, varid, nms[i], tags[i,3], prec="text"), silent=TRUE)
		}
	}
}


get_time_vars <- function(y) {
	zv <- y@pntr$time
	tstep <- y@pntr$timestep
	cal <- "standard"
	if (tstep == "seconds") {
		zunit <- "seconds since 1970-01-01 00:00:00"
	} else if (tstep == "days") {
		zunit <- "days since 1970-01-01"
		zv <- zv / (24 * 3600)
	} else if (tstep == "months") {
		# left as bare "months" for read-side compatibility; the read code
		# (read_gdal.cpp) treats this as month-of-year, not a CF offset.
		zunit <- "months"
		zv <- time(y)
	} else if (tstep == "yearmonths") {
		zunit <- "months since 1970-01-01"
		tm <- time(y) - 1970
		yr <- tm %/% 1
		zv <- (yr*12) + round(12 * (tm %% 1))
	} else if (tstep == "years") {
		zunit <- "years since 1970-01-01"
		zv <- time(y) - 1970
	} else {
		zunit <- "unknown"
	}
	list(zv=zv, zunit=zunit)
}


# Tag a dim variable with the CF attributes
.cf_tag_dim <- function(nc, dimname, attrs) {
	for (an in names(attrs)) {
		try(ncdf4::ncatt_put(nc, dimname, an, attrs[[an]], prec = "text"),
			silent = TRUE)
	}
}


.write_cdf <- function(x, filename, overwrite=FALSE, timename="time", atts="", gridmap="", prec="float", compression=NA, missval, tags=FALSE, force_v4=TRUE, verbose=FALSE, ...) {

	n <- length(x)
	y <- x[1]
	if (is.lonlat(y, perhaps=TRUE, warn=FALSE)) {
		xname <- "longitude"
		yname <- "latitude"
		xunit <- "degrees_east"
		yunit <- "degrees_north"
	} else {
		xname <- "easting"
		yname <- "northing"
		linunit <- linearUnits(x[1])
		if (isTRUE(linunit == 1)) {
			xunit <- yunit <- "meter"
		} else if (isTRUE(linunit == 1000)) {
			xunit <- yunit <- "km"
		} else if (isTRUE(linunit == 0.3048)) {
			xunit <- yunit <- "feet"
		} else if (isTRUE(linunit == 1609.344)) {
			xunit <- yunit <- "miles"
		} else {
			xunit <- yunit <- "unknown"		
		}
	}
	xdim <- ncdf4::ncdim_def( xname, xunit, xFromCol(y, 1:ncol(y)) )
	ydim <- ncdf4::ncdim_def( yname, yunit, yFromRow(y, 1:nrow(y)) )
	vars <- varnames(x)
	vars[vars == ""] <- paste0("var_", (1:n)[vars == ""])
	vars <- make.unique(vars)

	lvar <- longnames(x)
	units <- units(x)
	timename <- rep_len(timename, n)

	valid_prec <- c("short", "integer", "float", "double", "byte")
	if (!all(prec %in% valid_prec)) {
		error("writeCDF", paste("prec must be one of:", paste(valid_prec, collapse=", ")))
	}
	prec <- rep_len(prec, n)
	if (missing(missval)) {
		miss_vals <- c(-32768, -2147483647, -1.175494e38, -1.7976931348623157e308, 255)
		missval <- miss_vals[match(prec, valid_prec)]
	} else {
		missval <- rep_len(missval, n)
	}
	compression <- compression[1]
	nc <- ncol(x)
	nr <- nrow(x)
	nl <- nlyr(x)
	ncvars <- list()
	cal <- NA

#	depthtime <- rep(0, n)
	nudv <- rep(0, n)
	
	for (i in 1:n) {

		if ((nl[i] > 1) || (x[i]@pntr$hasTime)) {
			y <- x[i]
			if (y@pntr$hasTime && y@pntr$hasDepth) {
				tm <- time(y)
				dv <- depth(y)
				utm <- unique(tm)
				udv <- unique(dv)
				dsrt <- isTRUE(all(sort(dv, decreasing=FALSE) == dv)) || isTRUE(all(sort(dv, decreasing=TRUE) == dv))
				tsrt <- isTRUE(all(sort(tm, decreasing=FALSE) == tm)) || isTRUE(all(sort(tm, decreasing=TRUE) == tm))
				if (!(dsrt || tsrt)) {
					error("writeCDF", "neither time nor depth are sorted")						
				}
				if (dsrt) {
					mz <- matrix(tm, ncol=length(udv))
					nudv[i] <- length(udv)
				} else {
					mz <- matrix(dv, ncol=length(utm))				
					nudv[i] <- length(utm)
				}
				a <- apply(mz, 1, function(i) length(unique(i)))
				if (!isTRUE(all(a == 1))) {
					if (dsrt) {
						error("writeCDF", paste("time values not sorted within depth"))					
					} else {
						error("writeCDF", paste("depth values not sorted within time"))										
					}
				}
				
				tab <- unique(table(tm, dv))
				if (length(tab) > 1) {
					error("writeCDF", "unexpected time/depth values, combinations not balanced")
				}
				if ((length(utm) * length(udv)) != nlyr(y)) {
					error("writeCDF", "unexpected time/depth values, unbalanced combinations")				
				}
				
				zname <- depthName(y)
				zunit <- depthUnit(y) 
				if (zunit == "") zunit <- "unknown"
				zdim <- ncdf4::ncdim_def(zname, zunit, udv, unlim=FALSE, create_dimvar=TRUE)

				tvrs <- get_time_vars(y)
				timv <- unique(tvrs$zv)
				timunit <- tvrs$zunit		
				timdim <- ncdf4::ncdim_def(timename[i], timunit, timv, unlim=FALSE, create_dimvar=TRUE, calendar=cal)

				if (dsrt) {
					ncvars[[i]] <- ncdf4::ncvar_def(vars[i], units[i], list(xdim, ydim, timdim, zdim), 
											missval[i], lvar[i], prec = prec[i], compression=compression)
#					depthtime[i] <- 1
				} else {
					ncvars[[i]] <- ncdf4::ncvar_def(vars[i], units[i], list(xdim, ydim, zdim, timdim), 
											missval[i], lvar[i], prec = prec[i], compression=compression)
#					depthtime[i] <- 2
				}
				
			} else {
				if (y@pntr$hasTime) {
					tv <- get_time_vars(y)
					zv <- tv$zv
					zunit <- tv$zunit
					zname <- timename[i]
				} else if (y@pntr$hasDepth) {
					zv <- depth(y)
					zname <- depthName(y)
					if (zname == "") zname <- "depth"
					zunit <- depthUnit(y) 
					if (zunit == "") zunit <- "unknown"
				} else {
					zv <- 1:nlyr(y)
					zunit <- "unknown"
					zname <- paste0("Z", i)
				}
				zdim <- ncdf4::ncdim_def(zname, zunit, zv, unlim=FALSE, create_dimvar=TRUE, calendar=cal)
				ncvars[[i]] <- ncdf4::ncvar_def(vars[i], units[i], list(xdim, ydim, zdim), missval[i], lvar[i], prec = prec[i], compression=compression)
			}
		} else {
			ncvars[[i]] <- ncdf4::ncvar_def(name=vars[i], units=units[i], dim=list(xdim, ydim), missval=missval[i], longname=lvar[i], prec = prec[i], compression=compression)
		}
	}

	ncvars[[n+1]] <- ncdf4::ncvar_def("crs", "", list(), NULL, prec="integer")
	
	ncobj <- ncdf4::nc_create(filename, ncvars, force_v4=force_v4, verbose=verbose)
	on.exit(ncdf4::nc_close(ncobj))

	# Add CF marker attributes (standard_name / axis / long_name) to the
	# coordinate dim variables so that CF tools) recognises them as time / vertical / X / Y. 
	if (xname == "longitude") {
		.cf_tag_dim(ncobj, xname, list(standard_name = "longitude",
			long_name = "longitude", axis = "X"))
		.cf_tag_dim(ncobj, yname, list(standard_name = "latitude",
			long_name = "latitude", axis = "Y"))
	} else {
		.cf_tag_dim(ncobj, xname, list(
			standard_name = "projection_x_coordinate",
			long_name = "x coordinate of projection", axis = "X"))
		.cf_tag_dim(ncobj, yname, list(
			standard_name = "projection_y_coordinate",
			long_name = "y coordinate of projection", axis = "Y"))
	}
	for (tn in unique(timename[seq_len(n)])) {
		if (!is.null(ncobj$dim[[tn]])) {
			.cf_tag_dim(ncobj, tn, list(standard_name = "time",
				long_name = "time", axis = "T"))
		}
	}
	for (dn in names(ncobj$dim)) {
		if (dn %in% c(xname, yname)) next
		if (dn %in% timename) next
		du <- tolower(ncobj$dim[[dn]]$units)
		if (grepl("^(seconds|minutes|hours|days|months|years)( since|$)", du)) next
		# Treat any remaining non-spatial, non-time dim as a vertical (Z) axis.
		.cf_tag_dim(ncobj, dn, list(axis = "Z"))
	}

#	haveprj <- FALSE
	prj <- crs(x[1])
	prj <- gsub("\n", "", prj)
#	if (prj != "") {
		haveprj <- TRUE
		ncdf4::ncatt_put(ncobj, ncvars[[n+1]], "crs_wkt", prj, prec="text")
		# need for older gdal?
		ncdf4::ncatt_put(ncobj, ncvars[[n+1]], "spatial_ref", prj, prec="text")
		prj <- .proj4(x[1])
		if (prj != "") {
			ncdf4::ncatt_put(ncobj, ncvars[[n+1]], "proj4", prj, prec="text")
		}
		prj <- crs(x[1], describe=TRUE)[1,2:3]
		if (!any(is.na(prj))) {
			prj <- paste0(prj, collapse=":")
			ncdf4::ncatt_put(ncobj, ncvars[[n+1]], "code", prj, prec="text")
		}
#	}
	gridmap <- grep("=", gridmap, value=TRUE)
	if (length(gridmap)>0) {
		gridmap <- strsplit(gridmap, "=")
		for (i in 1:length(gridmap)) {		
			ncdf4::ncatt_put(ncobj, ncvars[[n+1]], gridmap[[i]][1], gridmap[[i]][2], prec="text")
		}
#		haveprj <- TRUE
	}

	e <- ext(x)
	rs <- res(x)
	gt <- paste(trimws(formatC(as.vector(c(e$xmin, rs[1], 0, e$ymax, 0, -1 * rs[2])), 22)), collapse=" ")
	ncdf4::ncatt_put(ncobj, ncvars[[n+1]], "geotransform", gt, prec="text")

	opt <- spatOptions()

	bsteps <- blocks(rast(x[[1]], nlyr=sum(nlyr(x))), 4)
	if (bsteps$n > opt$progress) {
		progress <- TRUE
		pb <- utils::txtProgressBar(0, bsteps$n) 
		pcnt <- 0
	} else {
		progress <- FALSE
	}
	
	for (i in 1:n) {
		y <- x[i]
		b <- blocks(y, 8)
		readStart(y)
		if (length(ncvars[[i]]$dim) == 4) {
			for (j in 1:b$n) {
				if (progress) { utils::setTxtProgressBar(pb, pcnt); pcnt <- pcnt + 1 }
				d <- readValues(y, b$row[j], b$nrows[j], 1, nc, FALSE, FALSE)
				d[is.nan(d)] <- NA
#				d <- array(d, c(nc, b$nrows[j], nudv[i], nl[i]/nudv[i]))
#				ncdf4::ncvar_put(ncobj, ncvars[[i]], d, start=c(1, b$row[j], 1, 1), count=c(nc, b$nrows[j], nudv[i], nl[i]/nudv[i]))
				d <- array(d, c(nc, b$nrows[j], nl[i]/nudv[i], nudv[i]))
				ncdf4::ncvar_put(ncobj, ncvars[[i]], d, start=c(1, b$row[j], 1, 1), count=c(nc, b$nrows[j], nl[i]/nudv[i], nudv[i]))
			}
		} else if (length(ncvars[[i]]$dim) == 3) {
			for (j in 1:b$n) {
				if (progress) { utils::setTxtProgressBar(pb, pcnt); pcnt <- pcnt + 1 }
				d <- readValues(y, b$row[j], b$nrows[j], 1, nc, FALSE, FALSE)
				d[is.nan(d)] <- NA
				d <- array(d, c(nc, b$nrows[j], nl[i]))
				ncdf4::ncvar_put(ncobj, ncvars[[i]], d, start=c(1, b$row[j], 1), count=c(nc, b$nrows[j], nl[i]))
			}
		} else {
			for (j in 1:b$n) {
				if (progress) { utils::setTxtProgressBar(pb, pcnt); pcnt <- pcnt + 1 }
				d <- readValues(y, b$row[j], b$nrows[j], 1, nc, FALSE, FALSE)
				d[is.nan(d)] <- NA
				d <- matrix(d, ncol=b$nrows[j])
				ncdf4::ncvar_put(ncobj, ncvars[[i]], d, start=c(1, b$row[j]), count=c(nc, b$nrows[j]))
			}
		}
		readStop(y)
		if (haveprj) {
			ncdf4::ncatt_put(ncobj, ncvars[[i]], "grid_mapping", "crs", prec="text")
		}
		if (tags) write_tags(metags(y), ncobj, ncvars[[i]], "")
	}
	if (progress) close(pb)
	
	ncdf4::ncatt_put(ncobj, 0, "Conventions", "CF-1.4", prec="text")
	pkgversion <- drop(read.dcf(file=system.file("DESCRIPTION", package="terra"), fields=c("Version")))
	ncdf4::ncatt_put(ncobj, 0, "created_by", paste("R packages ncdf4 and terra (version ", pkgversion, ")", sep=""), prec="text")
	ncdf4::ncatt_put(ncobj, 0, "created_date", format(Sys.time(), "%Y-%m-%d %H:%M:%S"), prec="text")

	if (tags) write_tags(metags(x), ncobj, 0, "")
	
	atts <- grep("=", atts, value=TRUE)
	if (length(atts) > 0) {
		atts <- strsplit(atts, "=")
		for (i in 1:length(atts)) {
			ncdf4::ncatt_put(ncobj, 0, atts[[i]][1], atts[[i]][2], prec="text")
		}
	}
	TRUE
}



setMethod("writeCDF", signature(x="SpatRaster"),
	function(x, filename, varname, longname="", unit="", split=FALSE, ...) {
		filename <- trimws(filename)
		if (length(filename) > 1) {
			if (length(filename) != nlyr(x)) {
				stop("either provide a single filename, or the same number as nlyr(x)")
			}
		}
		stopifnot(filename != "")
		if (split) {
			y <- sds(as.list(x))
			names(y) <- names(x)
			if (!missing(varname)) {
				varnames(y) <- varname
			}
			if (!missing(longname)) {
				longnames(y) <- longname
			}
			if (!missing(unit)) {
				units(y) <- unit
			} else {
				units(y) <- units(x)
			}
			invisible( writeCDF(y, filename=filename, ...) )
		} else {
			if (!missing(varname)) {
				varnames(x) <- varname
				longnames(x) <- longname
			} else { 
				varname <- varnames(x)[1]
				longname <- longnames(x)[1]
				if (varname == "") {
					varname <- tools::file_path_sans_ext(basename(filename))
					longname <- ""
				}
				varnames(x) <- varname
				longnames(x) <- longname
			}
			if (!missing(unit)) {
				units(x) <- unit
			}
			x <- sds(x)
			invisible( writeCDF(x, filename=filename, ...) )
		}
	}
)


setMethod("writeCDF", signature(x="SpatRasterDataset"),
	function(x, filename, overwrite=FALSE, timename="time", atts="", gridmap="", prec="float", compression=NA, missval, tags=FALSE, ...) {
		filename <- trimws(filename)
		stopifnot(filename != "")
		xt  <- tools::file_ext(filename)
		if (any(!(xt %in% c("nc", "cdf")))) {
			warn("writeCDF", "for better results use file extension '.nc' or '.cdf'\nsee: https://stackoverflow.com/a/65398262/635245")
		}
		if (file.exists(filename) & !overwrite) {
			error("writeCDF", "file exists, use 'overwrite=TRUE' to overwrite it")
		}
		ok <- .write_cdf(x, filename, timename=timename, atts=atts, gridmap=gridmap, prec=prec, compression=compression, missval=missval, tags=tags,  ...)
		if (ok) {
			if (length(x) > 1) {
				out <- sds(filename)
			} else {
				out <- rast(filename)
			}
			invisible(out)
		} else {
			error("writeCDF", "?")
		}
	}
)



.varName <- function(nc, varname="", warn=TRUE) {
	n <- nc$nvars
	dims <- vars <- vector(length=n)
	if (n > 0) {
		for (i in 1:n) {
			vars[i] <- nc$var[[i]]$name
			dims[i] <- nc$var[[i]]$ndims
		}
		vars <- vars[dims > 1]
		dims <- dims[dims > 1]
	}

	if (varname=='') {
		nv <- length(vars)
		if (nv == 0) {
			return('z')
		}

		if (nv  == 1) {
			varname <- vars
		} else {
			varname <- vars[which.max(dims)]
			if (warn) {
				if (sum(dims == max(dims)) > 1) {
					vars <- vars[dims==max(dims)]
					warning('varname used is: ', varname, '\nIf that is not correct, you can set it to one of: ', paste(vars, collapse=", ") )
				}
			}
		}
	}

	zvar <- which(varname == vars)
	if (length(zvar) == 0) {
		stop('varname: ', varname, ' does not exist in the file. Select one from:\n', paste(vars, collapse=", ") )
	}
	return(varname)
}



.getCRSfromGridMap4 <- function(g) {
	if (!is.null(g$epsg_code)) {
		crs <- g$epsg_code
		if (!grep("EPSG:", crs, ignore.case=TRUE)) {
			crs <- paste0("epsg:", crs)
		}
		return(crs)
	}

	sp <- g$standard_parallel
	if (length(sp) > 1) {
		g$standard_parallel1 <- sp[1]
		g$standard_parallel2 <- sp[2]
		g$standard_parallel <- NULL
	}

	vals <- sapply(g, function(i) i[1])
	vars <- names(vals)
	if (any(vars %in% c("proj4", "crs_wkt", "spatial_ref"))) {
		crs=vals[vars %in% c("proj4", "crs_wkt", "spatial_ref")][1]
		return(crs)
	}
# based on info at
# http://trac.osgeo.org/gdal/wiki/NetCDF_ProjectionTestingStatus
# accessed 7 October 2012
	prj <- matrix(c("albers_conical_equal_area", "aea", "azimuthal_equidistant", "aeqd", "lambert_cylindrical_equal_area", "cea", "lambert_azimuthal_equal_area", "laea", "lambert_conformal_conic", "lcc", "latitude_longitude", "longlat", "mercator", "merc", "orthographic", "ortho", "polar_stereographic", "stere", "stereographic", "stere", "transverse_mercator", "tmerc"), ncol=2, byrow=TRUE)

	m <- matrix(c("grid_mapping_name", "+proj", "false_easting", "+x_0","false_northing", "+y_0", "scale_factor_at_projection_origin", "+k_0", "scale_factor_at_central_meridian", "+k_0", "standard_parallel", "+lat_1", "standard_parallel1", "+lat_1", "standard_parallel2", "+lat_2", "longitude_of_central_meridian", "+lon_0", "longitude_of_projection_origin", "+lon_0", "latitude_of_projection_origin", "+lat_0", "straight_vertical_longitude_from_pole", "+lon_0",
	"longitude_of_prime_meridian", "+pm", "semi_major_axis", "+a", "semi_minor_axis", "+b", "inverse_flattening", "+rf",
	"earth_radius", "+a"), ncol=2, byrow=TRUE)

	# add logic that if prime merid is defined but not centr merid. centr merid is same as prime.

	i <- match(vars, m[,1])
	if (all(is.na(i))) {
		gg <- cbind(vars, vals)
		mtxt <- paste(apply(gg, 1, function(x) paste(x, collapse='=')), collapse='; ')
		warning("cannot process the crs\n", mtxt)
		return(NA)
	} else if (any(is.na(i))) {
		vr <- vars[is.na(i)]
		vl <- vals[is.na(i)]
		gg <- cbind(vr, vl)
		gg <- gg[!(gg[,1] %in% c("crs_wkt", "esri_pe_string")), ,drop=FALSE]
		if (NROW(gg) > 0) {
			mtxt <- paste(apply(gg, 1, function(x) paste(x, collapse='=')), collapse='\n')
			warning("cannot process these parts of the crs:\n", mtxt)
		}
		vars <- vars[!is.na(i)]
		vals <- vals[!is.na(i)]
		i <- stats::na.omit(i)
	}
	tab <- cbind(m[i,], vals)
	rr <- which(tab[,1] == "earth_radius")
	if (length(rr) > 0) {
		bb <- tab[rr,]
		bb[2] <- "+b"
		tab <- rbind(tab, bb)
	}
	p <- which(tab[,2] == '+proj')
	if (length(p) == 0) {
		warning("cannot create a valid crs\n", mtxt)
		return(NA)
	} else {
		tab <- rbind(tab[p, ], tab[-p, ])
	}
	j <- match(tab[1,3], prj[,1])
	tab[1,3] <- prj[j,2]
	cr <- paste(apply(tab[,2:3], 1, function(x) paste(x, collapse='=')), collapse=' ')
	crtst <- try(rast(crs=cr), silent=TRUE)
	if ( inherits(crtst, "try-error")) {
		mtxt <- paste(m, collapse='; ')
		warning("cannot create a valid crs\n", mtxt)
		return(NA)
	} else {
		return(cr)
	}
}


.ncdfTime <- function(nc, zvar, dim3, zval) {
	dodays <- TRUE
	dohours <- FALSE
	doseconds <- FALSE

	un <- nc$var[[zvar]]$dim[[dim3]]$units
	if (substr(un, 1, 10) == "days since") {
		startDate = as.Date(substr(un, 12, 22))
	} else if (substr(un, 1, 11) == "hours since") {
		dohours <- TRUE
		dodays <- FALSE
		startTime <- substr(un, 13, 30)
		mult <- 3600
	} else if (substr(un, 1, 13) == "seconds since") {
		doseconds <- TRUE
		dodays <- FALSE
		startTime = as.Date(substr(un, 15, 31))
		mult <- 1
	} else if (substr(un, 1, 12) == "seconds from") {
		doseconds <- TRUE
		dodays <- FALSE
		startTime = as.Date(substr(un, 14, 31))
		mult <- 1
	} else {
	  return(NULL)
	}
	if (!dodays) {
		start <- strptime(startTime, "%Y-%m-%d %H:%M:%OS", tz = "UTC")
		if (is.na(start)) start <- strptime(startTime, "%Y-%m-%d", tz = "UTC")
		if (is.na(start)) return(x)
		startTime <- start
		time <- startTime + as.numeric(zval) * mult
		time <- as.character(time)
		if (!is.na(time[1])) {
			return(time)
		}
	} else if (dodays) {
		# cal = nc$var[[zvar]]$dim[[dim3]]$calendar ?
		cal <- ncdf4::ncatt_get(nc, "time", "calendar")
		if (! cal$hasatt ) {
			greg <- TRUE
		} else {
			cal <- cal$value
			if (cal =='gregorian' | cal =='proleptic_gregorian' | cal=='standard') {
				greg <- TRUE
			} else if (cal == 'noleap' | cal == '365 day' | cal == '365_day') {
				greg <- FALSE
				nday <- 365
			} else if (cal == '360_day') {
				greg <- FALSE
				nday <- 360
			} else {
				greg <- TRUE
				warning('assuming a standard calender:', cal)
			}
		}
		if (greg) {
			time <- as.Date(time, origin=startDate)
		} else {
			startyear <-  as.numeric( format(startDate, "%Y") )
			startmonth <- as.numeric( format(startDate, "%m") )
			startday <- as.numeric( format(startDate, "%d") )
			year <- trunc( as.numeric(time)/nday )
			doy <- (time - (year * nday))
			origin <- paste(year+startyear, "-", startmonth, "-", startday, sep='')
			time <- as.Date(doy, origin=origin)
		}
		return(time)
	}
	return(NULL)
}



pointsCDF <- function(filename, varname, polygons=FALSE) {

	if (!("ncdf4" %in% rownames(utils::installed.packages()))) {
		warn("rast", "GDAL did not find an extent. installing the ncdf4 package may help")
		return(x)
	}

	zvar <- .varName(nc, varname, warn=TRUE)

	nc <- ncdf4::nc_open(filename, readunlim=FALSE, suppress_dimvals = TRUE)
	on.exit( ncdf4::nc_close(nc) )
	dims <- 1:3
	ncols <- nc$var[[zvar]]$dim[[dims[1]]]$len
	nrows <- nc$var[[zvar]]$dim[[dims[2]]]$len

	xx <- try(ncdf4::ncvar_get(nc, nc$var[[zvar]]$dim[[dims[1]]]$name), silent = TRUE)
	if (inherits(xx, "try-error")) {
		error("pointsCDF", "no x coordinates found")
	}
	yy <- try(ncdf4::ncvar_get(nc, nc$var[[zvar]]$dim[[dims[2]]]$name), silent = TRUE)
	if (inherits(yy, "try-error")) {
		error("pointsCDF", "no x coordinates found")
	}

	a <- ncdf4::ncatt_get(nc, zvar, "grid_mapping")
	prj <- NA
	if ( a$hasatt ) {
		try(atts <- ncdf4::ncatt_get(nc, a$value), silent=TRUE)
		try(prj <- .getCRSfromGridMap4(atts), silent=TRUE)
	}

	dim3 <- dims[3]
	dim3_vals <- try(ncdf4::ncvar_get(nc, nc$var[[zvar]]$dim[[dim3]]$name), silent = TRUE)
	if (inherits(dim3_vals, "try-error")) {
		dim3_vals <- seq_len(nc$var[[zvar]]$dim[[dim3]]$len)
	}
	nms <- NULL
	if ( nc$var[[zvar]]$dim[[dim3]]$name == "time" ) {
		try( nms <- .ncdfTime(nc, zvar, dim3, dim3_vals) )
	}

	d <- ncdf4::ncvar_get( nc, varid=zvar)
	nl <- dim(d)[3]
	v <- sapply(1:nl, function(i) d[,,i])

	natest1 <- ncdf4::ncatt_get(nc, zvar, "_FillValue")
	natest2 <- ncdf4::ncatt_get(nc, zvar, "missing_value")
	if (natest1$hasatt) {
		v[v==natest1$value] <- NA
	} else if (natest2$hasatt) {
		v[v==natest2$value] <- NA
	}
	if (!is.null(nms)) {
		colnames(v) <- nms
	}
	vect(cbind(rep(xx, length(yy)), rep(yy, each=length(xx))), atts=v, crs=prj)
}

# Author: Robert J. Hijmans
# Date : March 2009
# Version 1.0
# License GPL v3
# revised April 2011
# adapted November 2020


setMethod("crosstab", signature(x="SpatRaster", y="missing"),
	function(x, digits=0, long=FALSE, useNA=FALSE) {

		nl <- nlyr(x)
		if (nl < 2) {
			error("crosstab", "needs at least 2 layers")
		}
		nms <- names(x)
		opt <- spatOptions()

		res <- x@pntr$crosstab(digits, !useNA, opt)
		if (length(res) == 0) {
			res <- data.frame(matrix(nrow=0, ncol=nl+1))
		} else {
			res <- matrix(res, ncol=nl+1, byrow=TRUE)
			res <- as.data.frame(res)
		}
		colnames(res) <- c(nms, "Freq")

		ff <- is.factor(x)
		if (any(ff)) {
			ff <- which(ff)
			v <- levels(x)
			for (i in ff) {
				j <- match(res[,i], v[[i]][,1])
				res[,i] <- v[[i]][j,2]
			}
		}

		if (!long) {
			nms <- make.names(nms, unique=TRUE)
			colnames(res) <- c(nms, "Freq")
			f <- eval(parse(text=paste("Freq ~ ", paste(nms , collapse="+"))))
			res <- stats::xtabs(f, data=res, addNA=useNA)
		} else {
			res <- res[res$Freq > 0,  ,drop=FALSE]
			# sorting is already done in C++
			rownames(res) <- NULL
			colnames(res)[ncol(res)] <- "n"
		}
		return(res)
	}
)

# Author: Robert J. Hijmans
# Date :  October 2017
# Version 0.9
# License GPL v3

setMethod("ext", signature(x="SpatExtent"),
	function(x){
		x@pntr <- x@pntr$deepcopy()
		x
	}
)

setMethod("ext", signature(x="SpatRasterCollection"),
	function(x){
		e <- methods::new("SpatExtent")
		e@pntr <- x@pntr$extent()
		e
	}
)


setMethod("ext", signature(x="sf"),
	function(x){
		sfi <- attr(x, "sf_column")
		geom <- x[[sfi]]
		e <- attr(geom, "bbox")
		ext(e[c(1,3,2,4)])
	}
)

setMethod("ext", signature(x="missing"),
	function(x){
		e <- methods::new("SpatExtent")
		e@pntr <- SpatExtent$new()
		e
	}
)

setMethod("ext", signature(x="numeric"),
	function(x, ..., xy=FALSE){
		dots <- as.vector(unlist(list(...)))
		x <- c(x, dots)
		n <- length(x)
		if (n != 4) {
			error("ext", "expected four numbers")
		}
		names(x) <- NULL
		e <- methods::new("SpatExtent")
		if (xy) {
			e@pntr <- SpatExtent$new(x[1], x[3], x[2], x[4])
		} else {
			e@pntr <- SpatExtent$new(x[1], x[2], x[3], x[4])
		}
		if (!e@pntr$valid) {
			error("ext", "invalid extent")
		}
		e
	}
)

setMethod("ext", signature(x="matrix"),
	function(x){
		if ((ncol(x) == 2) && (nrow(x) > 2)) {
			x <- apply(x, 2, range, na.rm=TRUE)
		}
		ext(as.vector(x))
	}
)

setMethod("ext", signature(x="data.frame"),
	function(x){
		if ((ncol(x) == 2) && (nrow(x) > 2)) {
			ext(apply(x, 2, range, na.rm=TRUE))
		} else {
			ext(unlist(x))
		}
	}
)

setMethod("ext", signature(x="bbox"),
	function(x){
		ext(x[c(1,3,2,4)])
	}
)


setMethod("ext", signature(x="SpatRaster"),
	function(x, cells=NULL){
		if (!is.null(cells)) {
			cells <- stats::na.omit(unique(round(cells)))
			cells <- cells[cells > 0 & cells <= ncell(x)]
			if (length(cells) < 1) {
				stop("no valid cells")
			}
			r <- res(x)
			dx <- r[1] * c(-0.5, 0.5)
			dy <- r[2] * c(-0.5, 0.5)
			ext(range(xFromCell(x, cells)) + dx, range(yFromCell(x, cells)) + dy)
		} else {
			e <- methods::new("SpatExtent")
			e@pntr <- x@pntr$extent
			return(e)
		}
	}
)



setMethod("ext", signature(x="SpatRasterDataset"),
	function(x){
		e <- methods::new("SpatExtent")
		e@pntr <- x@pntr$ext()
		return(e)
	}
)



setMethod("ext<-", signature("SpatRaster", "SpatExtent"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		x@pntr$extent <- value@pntr
		messages(x, "ext<-")
	}
)


setMethod("ext<-", signature("SpatRaster", "numeric"),
	function(x, value) {
		e <- ext(value)
		x@pntr <- x@pntr$deepcopy()
		x@pntr$extent <- e@pntr
		messages(x, "ext<-")
	}
)

setMethod("set.ext", signature("SpatRaster"),
	function(x, value) {
		e <- ext(value)
		x@pntr$extent <- e@pntr
		messages(x, "set_ext")
		invisible(TRUE)
	}
)


setMethod("ext", signature(x="SpatVector"),
	function(x) {
		e <- methods::new("SpatExtent")
		e@pntr <- x@pntr$extent()
		e
	}
)

setMethod("ext", signature(x="SpatVectorCollection"),
	function(x) {
		e <- sapply(x, function(e) as.vector(ext(e)))
		ext(min(e[1,]), max(e[2,]), min(e[3,]), max(e[4,]))
	}
)


setMethod("ext", signature(x="SpatVectorProxy"),
	function(x) {
		e <- methods::new("SpatExtent")
		e@pntr <- x@pntr$v$extent()
		e
	}
)


setMethod("ext", signature(x="Extent"),
	function(x) {
		ext(as.vector(x))
	}
)

setMethod("ext", signature(x="Raster"),
	function(x) {
		ext(x@extent)
	}
)

setMethod("ext", signature(x="Spatial"),
	function(x) {
		ext(as.vector(t(x@bbox)))
	}
)

setMethod("ext", signature(x="SpatGraticule"),
	function(x) {
		e <- methods::new("SpatExtent")
		e@pntr <- x@pntr$extent()
		e
	}
)




setMethod("xmin", signature(x="SpatExtent"),
	function(x){
		x@pntr$vector[1]
	}
)
setMethod("xmax", signature(x="SpatExtent"),
	function(x){
		x@pntr$vector[2]
	}
)
setMethod("ymin", signature(x="SpatExtent"),
	function(x){
		x@pntr$vector[3]
	}
)
setMethod("ymax", signature(x="SpatExtent"),
	function(x){
		x@pntr$vector[4]
	}
)


setMethod("xmin<-", signature("SpatExtent", "numeric"),
	function(x, value){
		v <- as.vector(x)
		v[1] <- value
		ext(v)
	}
)
setMethod("xmax<-", signature("SpatExtent", "numeric"),
	function(x, value){
		v <- as.vector(x)
		v[2] <- value
		ext(v)
	}
)
setMethod("ymin<-", signature("SpatExtent", "numeric"),
	function(x, value){
		v <- as.vector(x)
		v[3] <- value
		ext(v)
	}
)
setMethod("ymax<-", signature("SpatExtent", "numeric"),
	function(x, value){
		v <- as.vector(x)
		v[4] <- value
		ext(v)
	}
)


setMethod("xmin", signature(x="SpatRaster"),
	function(x){
		xmin(ext(x))
	}
)
setMethod("xmax", signature(x="SpatRaster"),
	function(x){
		xmax(ext(x))
	}
)
setMethod("ymin", signature(x="SpatRaster"),
	function(x){
		ymin(ext(x))
	}
)
setMethod("ymax", signature(x="SpatRaster"),
	function(x){
		ymax(ext(x))
	}
)


setMethod("xmin<-", signature("SpatRaster", "numeric"),
	function(x, value){
		v <- as.vector(ext(x))
		v[1] <- value
		x@pntr <- x@pntr$deepcopy()
		ext(x) <- ext(v)
		x
	}
)


setMethod("xmax<-", signature("SpatRaster", "numeric"),
	function(x, value){
		v <- as.vector(ext(x))
		v[2] <- value
		x@pntr <- x@pntr$deepcopy()
		ext(x) <- ext(v)
		x
	}
)
setMethod("ymin<-", signature("SpatRaster", "numeric"),
	function(x, value){
		v <- as.vector(ext(x))
		v[3] <- value
		x@pntr <- x@pntr$deepcopy()
		ext(x) <- ext(v)
		x
	}
)

setMethod("ymax<-", signature("SpatRaster", "numeric"),
	function(x, value){
		v <- as.vector(ext(x))
		v[4] <- value
		x@pntr <- x@pntr$deepcopy()
		ext(x) <- ext(v)
		x
	}
)



setMethod("xmin", signature(x="SpatVector"),
	function(x){
		xmin(ext(x))
	}
)
setMethod("xmax", signature(x="SpatVector"),
	function(x){
		xmax(ext(x))
	}
)
setMethod("ymin", signature(x="SpatVector"),
	function(x){
		ymin(ext(x))
	}
)
setMethod("ymax", signature(x="SpatVector"),
	function(x){
		ymax(ext(x))
	}
)



setMethod("$", "SpatExtent",
	function(x, name) {
		as.vector(x)[name]
	}
)


setMethod("$<-", "SpatExtent",
	function(x, name, value) {
		e <- as.vector(x)
		e[name] <- value
		ext(e)
	}
)



setMethod("[", c("SpatExtent", "missing", "missing"),
	function(x, i, j) {
		as.vector(x)
	}
)

setMethod("[", c("SpatExtent", "numeric", "missing"),
	function(x, i, j) {
		x <- as.vector(x)
		x[i]
	}
)

setReplaceMethod("[", c("SpatExtent", "numeric", "missing"),
	function(x, i, j, value) {
		e <- as.vector(x)
		stopifnot(all(i %in% 1:4))
		e[i] <- value
		ext(e)
	}
)


setMethod("is.valid", signature(x="SpatExtent"),
	function(x) {
		x@pntr$valid
		#x@pntr$valid_notempty
	}
)


setMethod("is.empty", signature(x="SpatExtent"),
	function(x) {
		x@pntr$empty
	}
)

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

.have_TBB <- function() {
    .Call(`_terra_have_TBB`)
}

.open_file_limit <- function() {
    .Call(`_terra_open_file_lim`)
}

.proj_conf_test <- function() {
    .Call(`_terra_proj_conf_test`)
}

proj_version <- function() {
    .Call(`_terra_proj_version`)
}

hex2rgb <- function(s) {
    .Call(`_terra_hex2rgb`, s)
}

rgb2hex <- function(x) {
    .Call(`_terra_rgb2hex`, x)
}

.sameSRS <- function(x, y) {
    .Call(`_terra_sameSRS`, x, y)
}

.SRSinfo <- function(s) {
    .Call(`_terra_getCRSname`, s)
}

.getLinearUnits <- function(s) {
    .Call(`_terra_getLinearUnits`, s)
}

.geotransform <- function(fname) {
    .Call(`_terra_geotransform`, fname)
}

.gdal_setconfig <- function(option, value) {
    invisible(.Call(`_terra_gdal_setconfig`, option, value))
}

.gdal_getconfig <- function(option) {
    .Call(`_terra_gdal_getconfig`, option)
}

.gdalinfo <- function(filename, options, oo) {
    .Call(`_terra_ginfo`, filename, options, oo)
}

.gdalmdinfo <- function(filename, options) {
    .Call(`_terra_gmdinfo`, filename, options)
}

.sdinfo <- function(filename) {
    .Call(`_terra_sd_info`, filename)
}

.gdal_version <- function() {
    .Call(`_terra_gdal_version`)
}

.geos_version <- function(runtime = FALSE, capi = FALSE) {
    .Call(`_terra_geos_version`, runtime, capi)
}

.metadata <- function(filename) {
    .Call(`_terra_metatdata`, filename)
}

.sdsmetadata <- function(filename) {
    .Call(`_terra_sdsmetatdata`, filename)
}

.parsedsdsmetadata <- function(filename) {
    .Call(`_terra_sdsmetatdataparsed`, filename)
}

.gdaldrivers <- function() {
    .Call(`_terra_gdal_drivers`)
}

.set_gdal_warnings <- function(level) {
    invisible(.Call(`_terra_set_gdal_warnings`, level))
}

.seedinit <- function(seed_val) {
    invisible(.Call(`_terra_seed_init`, seed_val))
}

.gdalinit <- function(projpath, datapath) {
    invisible(.Call(`_terra_gdal_init`, projpath, datapath))
}

.precRank <- function(x, y, minc, maxc, tail) {
    .Call(`_terra_percRank`, x, y, minc, maxc, tail)
}

.clearVSIcache <- function(vsi) {
    invisible(.Call(`_terra_clearVSIcache`, vsi))
}

.setGDALCacheSizeMB <- function(x, vsi) {
    invisible(.Call(`_terra_setGDALCacheSizeMB`, x, vsi))
}

.getGDALCacheSizeMB <- function(vsi) {
    .Call(`_terra_getGDALCacheSizeMB`, vsi)
}

.get_proj_search_paths <- function() {
    .Call(`_terra_get_proj_search_paths`)
}

.set_proj_search_paths <- function(paths, with_proj = FALSE) {
    .Call(`_terra_set_proj_search_paths`, paths, with_proj)
}

.PROJ_network <- function(enable, url) {
    .Call(`_terra_PROJ_network`, enable, url)
}

.proj_pipelines <- function(source_crs, target_crs, authority, AOI, use, grid_availability, desired_accuracy, strict_containment, axis_order_authority_compliant) {
    .Call(`_terra_proj_pipelines`, source_crs, target_crs, authority, AOI, use, grid_availability, desired_accuracy, strict_containment, axis_order_authority_compliant)
}

.removeDriver <- function(d) {
    invisible(.Call(`_terra_removeDriver`, d))
}

.pearson <- function(x, y, narm) {
    .Call(`_terra_pearson_cor`, x, y, narm)
}

.weighted_pearson <- function(x, y, weights, narm = TRUE) {
    .Call(`_terra_weighted_pearson_cor`, x, y, weights, narm)
}

.unique_symmetric_rows <- function(x, y) {
    .Call(`_terra_uniqueSymmetricRows`, x, y)
}

.arnames <- function(filename, filter) {
    .Call(`_terra_arnames`, filename, filter)
}

.dimfo <- function(filename, array_name) {
    .Call(`_terra_dimfo`, filename, array_name)
}

dist2segmentPoint_geo <- function(plon, plat, lon1, lat1, lon2, lat2, ilon, ilat) {
    .Call(`_terra_dist2segmentPoint_geo`, plon, plat, lon1, lat1, lon2, lat2, ilon, ilat)
}

intermediate <- function(lon1, lat1, lon2, lat2, n, distance) {
    .Call(`_terra_intermediate`, lon1, lat1, lon2, lat2, n, distance)
}

# Author: Robert J. Hijmans
# Date :  June 2017
# Version 1.0
# License GPL v3


setMethod("show", "SpatExtent", function(object) {
#	.show_ext(object)
	cat(object@pntr$show())
} )

setMethod("show", "SpatRaster", function(object) cat(object@pntr$show(TRUE)) )

setMethod("show", "SpatRasterCollection", function(object) cat(object@pntr$show()) )

setMethod("show", "SpatRasterDataset", function(object) cat(object@pntr$show()) )

setMethod("show", "SpatVector", function(object) cat(object@pntr$show()) )

setMethod("show", "SpatVectorCollection", function(object) cat(object@pntr$show()) )

setMethod("show", "SpatVectorProxy", function(object) cat(object@pntr$show()) )


printDF <- function(x, n=6, first=FALSE) {
	n <- min(nrow(x), max(n, 0))
	old <- dim(x)
	if (old[2] == 0) { return() }
	if (old[1] > 0) {
		x <- x[1:n, ,drop=FALSE]
	}
	if (old[2] > 12) {
		x <- x[, 1:10]
	}
	d <- dim(x)

	cls <- sapply(x, function(i){ a = class(i); a[length(a)]})
	cls <- gsub("integer", "int", cls)
	cls <- gsub("numeric", "num", cls)
	cls <- gsub("character", "chr", cls)
	cls <- gsub("factor", "fact", cls)
	cls <- paste0("<", cls, ">")
	cls <- data.frame(rbind(class=cls), stringsAsFactors=FALSE)
	names(cls) <- NULL

	nms <- colnames(x)
	nc <- nchar(nms)
	mx <- max(15, 100/d[2])
	i <- nc > (mx+2)
	nms[i] <- paste0(substr(nms[i], 1, (mx-1)), "~")
	if (d[1] > 0) {
		for (i in 1:ncol(x)) {
			if (is.character(x[[i]])) {
				x[[i]][is.na(x[[i]])] <- "NA"
				n <- nchar(x[[i]])
				j <- n > (mx+2)
				x[[i]][j] <- paste0(substr(x[[i]][j], 1, (mx-1)), "~")
			} else if (is.numeric(x[[i]])) {
				x[[i]] <- formatC(x[[i]])
			}
		}
	}
	x <- data.frame(lapply(x, as.character), check.names=FALSE, stringsAsFactors=FALSE)
	x <- rbind(x[1,,drop=FALSE], x)
	x[1,] <- cls
	if (nrow(x) < d[1]) {
		x <- rbind(x, "...")
	}
	if (first) {
		x <- data.frame("", x, check.names=FALSE, stringsAsFactors=FALSE)
		colnames(x)[1] <- "names       :"
		x[1,1] <- "type        :"
		if (d[1] > 0) {
			x[2,1] <- "values      :"
		}
	}
	if (old[2] > d[2]) {
		name <- paste0("(and ", old[2] - d[2], " more)")
		x[[name]] <- ""
	}

	print(x, row.names = FALSE)
}


setMethod ("show" , "Rcpp_SpatDataFrame",
	function(object) {
		cat("class       :" , class(object), "\n")
		object <- .getSpatDF(object)
		d <- dim(object)
		cat("dimensions  : ", d[1], ", ", d[2], "  (nrow, ncol)\n", sep="" )
		n <- 6
		if (d[1] > 6) {
			cat("values (head)\n")
		} else {
			cat("values\n")
		}
		printDF(object)
	}
)

setMethod ("show" , "Rcpp_SpatCategories",
	function(object) {
		show(object$df)
	}
)


setMethod("show" , "SpatGraticule",
	function(object) {
		cat("class       :" , class(object), "\n")
		v <- vect()
		v@pntr <- object@pntr
		cat("lon         :" , stats::na.omit(v$lon), "\n")		
		cat("lat         :" , stats::na.omit(v$lat), "\n")		
		cat("coord. ref. :", .name_or_proj4(v), "\n")
		e <- as.vector(ext(v))
		cat("extent      : ", e[1], ", ", e[2], ", ", e[3], ", ", e[4], "  (xmin, xmax, ymin, ymax)\n", sep="")
	}
)

setMethod ("head" , "SpatVector",
	function(x, n=6L, ...) {
		nn <- min(n, nrow(x))
		if (nn > 0) {
			x <- x[1:nn, ]
		} else {
			x <- x[0,]
		}
		as.data.frame(x)
	}
)


setMethod ("tail" , "SpatVector",
	function(x, n=6L, ...) {
		nrx <- nrow(x)
		nn <- min(n, nrx)
		if (nn > 0) {
			start <- nrx - nn + 1
			x <- x[start:nrx, ]
		} else {
			x <- x[0,]
		}
		x <- as.data.frame(x)
		if (nn > 0) {
			rownames(x) <- start:nrx
		}
		x
	}
)


setMethod ("head" , "SpatRaster",
	function(x, n=6L, ...) {
		utils::head(x[1:n], n=n, ...)
	}
)


setMethod ("tail" , "SpatRaster",
	function(x, n=6L, ...) {
		nc = ncell(x)
		utils::tail(x[(nc-n+1):nc], n=n, ...)
	}
)



str.SpatRaster <- function(object, ...) {
	cat("S4 class 'SpatRaster' [package \"terra\"]\n")
}
setMethod("str", signature(object="SpatRaster"), str.SpatRaster)


str.SpatVector <- function(object, ...) {
	cat("S4 class 'SpatVector' [package \"terra\"]\n")
}
setMethod("str", signature(object="SpatVector"), str.SpatVector)


str.SpatExtent <- function(object, ...) {
	cat("S4 class 'SpatExtent' [package \"terra\"]\n")
}
setMethod("str", signature(object="SpatExtent"), str.SpatExtent)

str.SpatGraticule <- function(object, ...) {
	cat("S4 class 'SpatGraticule' [package \"terra\"]\n")
}
setMethod("str", signature(object="SpatGraticule"), str.SpatGraticule)

setMethod("length", signature(x="SpatRasterDataset"),
	function(x) {
		x@pntr$nsds()
	}
)


setMethod("sds", signature(x="character"),
	function(x, ids=0, opts=NULL, raw=FALSE, noflip=FALSE, guessCRS=TRUE, domains="", md=FALSE) {

		if (length(x) > 1) {
			r <- lapply(x, rast, opts=opts, raw=raw, md=md)
			s <- sds(r)
			names(s) <- tools::file_path_sans_ext(basename(x))
			return(s)
		}

		x <- trimws(x[1])
		if (nchar(x) == 0) {
			error("sds", "provide valid file name(s)")
		}
		f <- .fullFilename(x)
		r <- methods::new("SpatRasterDataset")
		ids <- round(ids)-1
		if (ids[1] < 0) {
			useids <- FALSE
		} else {
			useids <- TRUE
		}
		if (is.null(opts)) opts <- ""[0]
		if (raw) opts <- c(opts, "so=false")
		
		domains <- clean_domains(domains)

		if (!isTRUE(is.finite(md))) {
			md <- 2L
		} else {
			md <- as.integer(md)
		}
		
		r@pntr <- SpatRasterStack$new(f, ids, useids, opts, isTRUE(noflip), isTRUE(guessCRS), domains, md)
		messages(r, "sds")
	}
)

setMethod("sds", signature(x="missing"),
	function(x) {
		r <- methods::new("SpatRasterDataset")
		r@pntr <- SpatRasterStack$new()
		r
	}
)


setMethod("sds", signature(x="SpatRaster"),
	function(x, ...) {
		r <- methods::new("SpatRasterDataset")
		r@pntr <- SpatRasterStack$new()
		r@pntr$add(x@pntr, varnames(x)[1], longnames(x)[1], units(x)[1], FALSE)
		dots <- list(...)
		nms <- names(dots)
		if (is.null(nms)) nms = ""
		nms <- rep_len(nms, length(dots))
		for (i in seq_along(dots)) {
			if (inherits(dots[[i]], "SpatRaster")) {
				vname <- nms[i]
				if (vname == "") vname = varnames(dots[[i]])[1]
				r@pntr$add(dots[[i]]@pntr, vname, longnames(dots[[i]])[1], units(dots[[i]])[1], FALSE)
			}
		}
		messages(r, "sds")
	}
)

setMethod("sds", signature(x="list"),
	function(x) {
		r <- methods::new("SpatRasterDataset")
		r@pntr <- SpatRasterStack$new()
		nms <- names(x)
		if (is.null(nms)) nms <- rep("", length(x))
		for (i in seq_along(x)) {
			if (inherits(x[[i]], "SpatRaster")) {
				r@pntr$add(x[[i]]@pntr, nms[i], "", "", FALSE)
			} else if (inherits(x[[i]], "SpatRasterDataset")) {			
				y <- as.list(x[[i]])
				ynms <- NULL
				if (length(y) == 1) {
					ynms <- rep(names(x)[i], length(y))
				}
				if (is.null(ynms)) {
					ynms <- names(x[[i]])
				}
				s <- sapply(1:length(y), function(j) r@pntr$add(y[[j]]@pntr, ynms[j], "", "", FALSE))
			} else {
				name <- names(x[[i]])
				cls <- paste(class(x[[i]]), collapse=", ")
				error("sds", "list element", name, "is a: ", cls)
			}
		}
		messages(r, "sds")
	}
)



setMethod("sds", signature(x="array"),
	function(x, crs="", extent=NULL) {
		dims <- dim(x)
		if (length(dims) <= 3) {
			return(sds(rast(x, crs=crs, extent=extent)))
		}
		if (length(dims) > 4) {
			if (length(dims) == 5) {
				if (dims[5] == 1) {
					x <- x[,,,,1]
				} else {
					error("sds,array", "cannot handle an array with 5 dimensions")
				}
			} else {
				error("sds,array", "cannot handle an array with more than 4 dimensions")
			}
		}
		r <- lapply(1:dims[4], function(i) rast(x[,,,i], crs=crs, extent=extent))
		sds(r)
	}
)



setMethod("sds", signature(x="stars"),
	function(x) {
		s <- from_stars(x)
		if (inherits(s, "SpatRaster")) {
			sds(s)
		} else {
			s
		}
	}
)

setMethod("sds", signature(x="stars_proxy"),
	function(x) {
		s <- from_stars(x)
		if (inherits(s, "SpatRaster")) {
			sds(s)
		} else {
			s
		}
	}
)



setMethod("c", signature(x="SpatRasterDataset"),
	function(x, ...) {

		x@pntr <- x@pntr$subset((1:x@pntr$nsds()) -1 ) # why? make a copy?

		dots <- list(...)
		nms <- names(dots)

		for (i in seq_along(dots)) {
			if (inherits(dots[[i]], "SpatRasterDataset")) {
				sdsnms <- names(dots[[i]])
				for (j in 1:(length(dots[[i]]))) {
					if (!x@pntr$add(dots[[i]][[j]]@pntr, sdsnms[j], "", "", FALSE)) {
						messages(x, "c")
					}
				}

			} else if (inherits(dots[[i]], "SpatRaster")) {
				if (is.null(nms)) error("c", "arguments must be named")
				if (!x@pntr$add(dots[[i]]@pntr, nms[i], "", "", FALSE)) {
					messages(x, "c")
				}
			} else {
				error("c", "arguments must be SpatRaster or SpatRasterDataset")
			}
		}
		messages(x, "c")
	}
)


setReplaceMethod("[", c("SpatRasterDataset", "numeric", "missing"),
	function(x, i, j, value) {
		if (any(!is.finite(i)) | any(i<1)) {
			error("`[`", "invalid index")
		}
		stopifnot(inherits(value, "SpatRaster"))
		i <- sort(i)
		for (j in i) {
			if (j == (length(x)+1)) {
				x@pntr$add(value@pntr, "", "", "", FALSE)
			} else {
				x@pntr$replace(j-1, value@pntr, FALSE)
			}
		}
		messages(x, "`[`")
	}
)


setMethod("[", c("SpatRasterDataset", "numeric", "missing"),
function(x, i, j, drop=TRUE) {
	i <- positive_indices(i, length(x), TRUE, "`[`(i)")

	if (drop && (length(i) == 1)) {
		tptr <- x@pntr$getsds(i-1)
		x <- rast()
		x@pntr <- tptr
	} else {
		x@pntr <- x@pntr$subset(i-1)
	}
	messages(x, "`[`")
})

setMethod("[", c("SpatRasterDataset", "numeric", "numeric"),
function(x, i, j, drop=TRUE) {
	i <- positive_indices(i, length(x))
	j <- positive_indices(j, min(nlyr(x)))	
	nd <- i
	if (drop) {
		out <- lapply(nd, function(k) x[k][[j]])
		out <- rast(out)
	} else {
		out <- sds()
		nms <- x@pntr$names
		for (k in nd) {
			r <- x[k][[j]]
			out@pntr$add(r@pntr, nms[k], "", "", FALSE)
		}
	}
	messages(out, "`[`")
})

setMethod("[", c("SpatRasterDataset", "numeric", "logical"),
function(x, i, j, drop=TRUE) {
	j <- positive_indices(j, min(nlyr(x)))
	`[`(x, i=i, j=j, drop=drop)
})

setMethod("[", c("SpatRasterDataset", "missing", "numeric"),
function(x, i, j, drop=TRUE) {
	`[`(x, i=1:x@pntr$nsds(), j=j, drop=drop)
})

setMethod("[", c("SpatRasterDataset", "missing", "logical"),
function(x, i, j, drop=TRUE) {
	j <- positive_indices(j, min(nlyr(x)))
	`[`(x, i=1:x@pntr$nsds(), j=j, drop=drop)
})


setMethod("[", c("SpatRasterDataset", "logical", "missing"),
function(x, i, j,drop=TRUE) {
	i <- positive_indices(j, length(x))
	x[i, drop=drop]
})

setMethod("[", c("SpatRasterDataset", "character", "missing"),
function(x, i, j, drop=TRUE) {
	i <- match(i, names(x))
	if (any(is.na(i))) {
		error("`[`", "unknown name(s) provided")
	}
	x[i, drop=drop]
})

setMethod("[[", c("SpatRasterDataset", "ANY", "ANY"),
function(x, i, j, drop=TRUE) {
	mi <- missing(i)
	mj <- missing(j)

	if ((mi) && (mj)) {
		`[`(x, drop=drop)
	} else if (mi) {
		`[`(x, j=j, drop=drop)
	} else if (mj) {
		`[`(x, i=i, drop=drop)
	} else {
		`[`(x, i=i, j=j, drop=drop)
	}
})


setMethod("$", c("SpatRasterDataset"),
function(x, name) {
	x[name,drop=TRUE]
})


setMethod("$", "SpatRasterDataset",
	function(x, name) {
		x[name]
	}
)


setMethod("sprc", signature(x="missing"),
	function(x) {
		r <- methods::new("SpatRasterCollection")
		r@pntr <- SpatRasterCollection$new()
		r
	}
)


setMethod("sprc", signature(x="SpatRaster"),
	function(x, ...) {
		sprc(list(x, ...))
	}
)


setMethod("sprc", signature(x="list"),
	function(x) {
		n <- length(x)
		tptr <- SpatRasterCollection$new()
		if (n > 0) {
			for (i in 1:n) {
				if (inherits(x[[i]], "SpatRaster")) {
					tptr$add(x[[i]]@pntr, "")
				} else if (inherits(x[[i]], "SpatRasterCollection") | 
							inherits(x[[i]], "SpatRasterDataset")) {
					y <- as.list(x[[i]])
					s <- sapply(y, function(j) tptr$add(j@pntr, ""))
				} else {
					name <- names(x[[i]])
					cls <- paste(class(x[[i]]), collapse=", ")
					error("sprc", "list element", name, "is a: ", cls)
				}
			}
		}
		r <- new("SpatRasterCollection")
		r@pntr <- tptr
		if (length(r) == length(x)) names(r) <- names(x)
		r
	}
)

setMethod("sprc", signature(x="character"),
	function(x, ids=0, opts=NULL, raw=FALSE, noflip=FALSE, guessCRS=TRUE, domains="", group=FALSE) {

		if (length(x) > 1) {
			ff <- vapply(x, function(p) {
				if (file.exists(p)) .fullFilename(p) else p
			}, character(1))
			if (is.null(opts)) opts <- ""[0]
			if (isTRUE(raw)) opts <- c(opts, "so=false")
			domains <- clean_domains(domains)
			r <- methods::new("SpatRasterCollection")
			r@pntr <- SpatRasterCollection$new(ff, opts, isTRUE(noflip), isTRUE(guessCRS), domains, isTRUE(group))
			return(messages(r, "sprc"))
		}

		x <- trimws(x[1])
		if (nchar(x) == 0) {
			error("sprc", "provide valid file name(s)")
		}
		f <- .fullFilename(x)
		r <- methods::new("SpatRasterCollection")
		ids <- round(ids)-1
		if (ids[1] < 0) {
			useids <- FALSE
		} else {
			useids <- TRUE
		}
		if (is.null(opts)) opts <- ""[0]
		if (raw) opts <- c(opts, "so=false")		
		
		domains <- clean_domains(domains)
		r@pntr <- SpatRasterCollection$new(f, ids, useids, opts, isTRUE(noflip), isTRUE(guessCRS), domains)
		messages(r, "sprc")
	}
)


setMethod("length", signature(x="SpatRasterCollection"),
	function(x) {
		x@pntr$length()
	}
)

setMethod("[", c("SpatRasterCollection", "numeric", "missing"),
function(x, i, j, ... ,drop=TRUE) {
	i <- positive_indices(i, length(x), TRUE, "`[`(i)")
	if (drop && (length(i) == 1)) {
		tptr <- x@pntr$x[[i]]
		x <- rast()
		x@pntr <- tptr
	} else {
		s <- x@pntr$x[i]
		tptr <- SpatRasterCollection$new()
		for (i in 1:length(s)) {
			tptr$add(s[[i]], "")
		}
		x@pntr <- tptr
	}
	messages(x, "`[`")
})


setMethod("add<-", signature("SpatRasterCollection", "SpatRaster"),
	function(x, value) {
		x@pntr$add(value@pntr, "")
		messages(x, "add")
	}
)


setMethod("add<-", signature("SpatRasterDataset", "SpatRaster"),
	function(x, value) {
		x@pntr$add(value@pntr, "")
		messages(x, "add")
	}
)


setMethod("c", signature(x="SpatRasterCollection"),
	function(x, ..., warn=TRUE) {
		y <- list(...)
		sprc(c(as.list(x), ...))
	}
)


setMethod("c", signature(x="SpatRasterCollection"),
	function(x, ...) {

		x@pntr <- x@pntr$deepcopy()

		dots <- list(...)
		nms <- names(dots)
		for (i in seq_along(dots)) {
			if (inherits(dots[[i]], "SpatRasterCollection") | inherits(dots[[i]], "SpatRasterDataset")) {
				sdsnms <- names(dots[[i]])
				for (j in 1:(length(dots[[i]]))) {
					x@pntr$add(dots[[i]][[j]]@pntr, sdsnms[j])
				}
			} else if (inherits(dots[[i]], "SpatRaster")) {
				if (is.null(nms)) { 
					name <- paste0("d", i)
				} else { 
					name <- nms[i] 
				}
				x@pntr$add(dots[[i]]@pntr, name)
			} else {
				error("c", "arguments must be SpatRaster, SpatRasterCollection, or SpatRasterDataset")
			}
		}
		messages(x, "c")
	}
)

# Author: Robert J. Hijmans
# Date:  October 2018
# Version 1.0
# License GPL v3


setMethod("names", signature(x="SpatRaster"),
	function(x) {
		nms <- x@pntr$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)


setMethod("names<-", signature(x="SpatRaster"),
	function(x, value)  {
		if (is.null(value)) {
			value <- rep("", nlyr(x))
		} else {
			value <- enc2utf8(as.character(value))
			if (length(value) != nlyr(x)) {
				error("names<-", "incorrect number of names")
			}
		}
		x@pntr <- x@pntr$deepcopy()
		if (! x@pntr$setNames(value, FALSE)) {
			error("names<-", "cannot set these names")
		}
		return(x)
	}
)


.names_check <- function(x, value, index, validate, lengthfx) {
	value <- enc2utf8(as.character(value))
	if (!all(index == 1:lengthfx(x))) {
		n <- names(x)
		n[index] <- value
		value <- n
	}
	if (length(value) != lengthfx(x)) {
		error("names<-", "incorrect number of names")
	}
	if (validate) {
		value <- make.names(value, unique = TRUE)
	}
	value
}


setMethod("set.names", signature(x="SpatRaster"),
	function(x, value, index=1:nlyr(x), validate=FALSE)  {
		value <- .names_check(x, value, index, validate, nlyr)
		if (!x@pntr$setNames(value, FALSE)) {
			error("set.names", "cannot set these names")
		}
		invisible(TRUE)
	}
)


setMethod("names", signature(x="SpatRasterCollection"),
	function(x) {
		nms <- x@pntr$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)


setMethod("names<-", signature(x="SpatRasterCollection"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		if (is.null(value)) {
			value <- rep("", length(x))
		}
		x@pntr$names <- enc2utf8(as.character(value))
		x
	}
)

setMethod("set.names", signature(x="SpatRasterCollection"),
	function(x, value, index=1:length(x), validate=FALSE)  {
		value <- .names_check(x, value, index, validate, length)
		x@pntr$names <- value
		invisible(TRUE)
	}
)



setMethod("names", signature(x="SpatRasterDataset"),
	function(x) {
		nms <- x@pntr$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)


setMethod("names<-", signature(x="SpatRasterDataset"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		if (is.null(value)) {
			value <- rep("", length(x))
		}
		if (is.list(value)) {
			nl <- nlyr(x)
			if (length(value) == 1) {
				if (length(unique(nl)) > 1) {
					error("names<-", "the number of layers varies between datasets")
				}
				x@pntr$set_layernames(enc2utf8(as.character(value[[1]])), -1)
			} else {
				if (length(value) != length(x)) {
					error("names<-", "the number of list elements does not match the number of datasets")				
				}
				for (i in seq_along(length(x))) x@pntr$set_layernames(enc2utf8(as.character(value[[i]])), i-1)
			}
		} else {
			x@pntr$names <- enc2utf8(as.character(value))
		}
		messages(x, "names<-")
	}
)


setMethod("set.names", signature(x="SpatRasterDataset"),
	function(x, value, index=1:length(x), validate=FALSE)  {
		value <- .names_check(x, value, index, validate, length)
		x@pntr$names <- value
		invisible(TRUE)
	}
)


setMethod("varnames", signature(x="SpatRasterDataset"),
	function(x) {
		nms <- x@pntr$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)


setMethod("varnames<-", signature(x="SpatRasterDataset"),
	function(x, value) {
		value <- enc2utf8(as.character(value))
		x@pntr <- x@pntr$deepcopy()
		x@pntr$names <- value
		x
	}
)



setMethod("names", signature(x="SpatVector"),
	function(x) {
		nms <- x@pntr$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)

setMethod("names", signature(x="SpatVectorProxy"),
	function(x) {
		nms <- x@pntr$v$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)

setMethod("names<-", signature(x="SpatVector"),
	function(x, value)  {
		if (length(value) != ncol(x)) {
			error("names<-,SpatVector", "incorrect number of names")
		}

		value <- enc2utf8(as.character(value))
		x@pntr <- x@pntr$deepcopy()
		x@pntr$names <- value
		if (any(names(x) != value)) {
			warn("names<-", "some names were changed to make them valid and/or unique")
		}
		return(x)
	}
)

setMethod("set.names", signature(x="SpatVector"),
	function(x, value, index=1:ncol(x), validate=FALSE)  {
		value <- .names_check(x, value, index, validate, ncol)
		x@pntr$names <- value
		invisible(TRUE)
	}
)

setMethod("varnames", signature(x="SpatRaster"),
	function(x) {
		nms <- x@pntr$get_sourcenames()
		Encoding(nms) <- "UTF-8"
		nms
	}
)

setMethod("varnames<-", signature(x="SpatRaster"),
	function(x, value)  {
		value <- enc2utf8(as.character(value))
		x@pntr <- x@pntr$deepcopy()
		if (!x@pntr$set_sourcenames(value)) {
			error("varnames<-,SpatRaster", "cannot set these names")
		}
		return(x)
	}
)


setMethod("longnames", signature(x="SpatRasterDataset"),
	function(x) {
		nms <- x@pntr$long_names
		Encoding(nms) <- "UTF-8"
		nms
	}
)


setMethod("longnames", signature(x="SpatRaster"),
	function(x) {
		nms <- x@pntr$get_sourcenames_long()
		Encoding(nms) <- "UTF-8"
		nms
	}
)

setMethod("longnames<-", signature(x="SpatRasterDataset"),
	function(x, value)  {
		x@pntr <- x@pntr$deepcopy()
		x@pntr$long_names <- enc2utf8(as.character(value))
		return(x)
	}
)


setMethod("longnames<-", signature(x="SpatRaster"),
	function(x, value)  {
		x@pntr <- x@pntr$deepcopy()
		value <- enc2utf8(as.character(value))
		if (!x@pntr$set_sourcenames_long(value)) {
			error("longnames<-,SpatRaster", "cannot set these names")
		}
		return(x)
	}
)


setMethod("names", signature(x="SpatVectorCollection"),
	function(x) {
		nms <- x@pntr$names
		Encoding(nms) <- "UTF-8"
		nms
	}
)


setMethod("names<-", signature(x="SpatVectorCollection"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		if (is.null(value)) {
			value <- rep("", length(x))
		}
		x@pntr$setNames(enc2utf8(as.character(value)), FALSE)
		x
	}
)

# Visualize Directional Arrows on a SpatRaster

as.arrows <- function(x, unit=c("degrees", "radians", "flowdir"), 
			arrow_length=NA, clockwise=FALSE, angle_from_h_axis=0,
			angle_from_x_axis=angle_from_h_axis, length=0, ...) {
  
	dev <- grDevices::dev.cur()
	if (names(dev) == "null device") {
		error("as.arrows", "there is no plot to add arrows to")
	}
  
	unit <- match.arg(tolower(unit[1]), c("degrees","radians", "flowdir"))
	if (unit == "flowdir") {
		x <- classify(x, cbind(0, NA))
		clockwise <- FALSE
		x <- -log(x)/log(2)*(pi/4)
		angle_from_x_axis <- 0		 
	} else if (unit %in% c("deg","degree","degrees")) {
		x <- x/180*pi
		angle_from_x_axis <- angle_from_x_axis/180*pi
	}
	names(x) <- "angle"
	 
	if (clockwise) x <- (-x)	 
	x <- x + angle_from_x_axis
	xdf <- as.data.frame(x, xy=TRUE)
	names(xdf)[1] <- "x0"
	names(xdf)[2] <- "y0"
	dr <- (xres(x)+yres(x))/4
	
	if (is.na(arrow_length)) {
	  max_val <- pmax(abs(cos(xdf$angle)), abs(sin(xdf$angle)))
	  xdf$length <-	2*dr/max_val
	} else {
		xdf$length <- arrow_length
	}	
	xdf$x1 <- xdf$x0+xdf$length*cos(xdf$angle)
	xdf$y1 <- xdf$y0+xdf$length*sin(xdf$angle)
	
 #### y_centers, x_centers + dx, y_centers + dy, length = arrow_length, col = "black")	
	graphics::arrows(x0=xdf$x0, y0=xdf$y0, x1=xdf$x1, y1=xdf$y1, length=length,...)
}	
		
 

.one.density <- function(x, maxcells=100000, plot=TRUE, ...) {
	d <- values(x)
	d <- stats::density(stats::na.omit(d))
	if (plot) {
		plot(d, ...)
		return(invisible(d))
	} else {
		return(d)
	}
}


setMethod("density", signature(x="SpatRaster"),
	function(x, maxcells=100000, plot=TRUE, main, ...) {
		x <- spatSample(x, maxcells, method="regular", as.raster=TRUE, warn=FALSE)
		res <- list()
		nl <- nlyr(x)
		if (missing(main)) {
			main=names(x)
		} else {
			main <- rep(main, length.out=nl)
		}

		if (nl==1) {
			res[[1]] <- .one.density(x, plot=plot, maxcells=maxcells, main=main, ...)
		} else {

			if (nl > 16) {
			warn("density", "only the first 16 layers are plotted")
				nl <- 16
				x <- x[[1:16]]
			}
			nc <- ceiling(sqrt(nl))
			nr <- ceiling(nl / nc)
			mfrow <- graphics::par("mfrow")
			spots <- mfrow[1] * mfrow[2]
			if (spots < nl) {
				old.par <- graphics::par(no.readonly = TRUE)
				on.exit(graphics::par(old.par))
				graphics::par(mfrow=c(nr, nc))
			}
			for (i in 1:nlyr(x)) {
				res[[i]] <- .one.density(x[[i]], maxcells=maxcells, main=main[i], plot=plot, ...)
			}
		}
		if (plot) return(invisible(res))
		else return(res)
	}
)


setMethod("persp", signature(x="SpatRaster"),
	function(x, maxcells=100000, ...)  {
		x <- spatSample(x, size=maxcells, method="regular", as.raster=TRUE, warn=FALSE)
		value <- t(as.matrix(x, wide=TRUE)[nrow(x):1,])
		y <- yFromRow(x, nrow(x):1)
		x <- xFromCol(x, 1:ncol(x))
		graphics::persp(x=x, y=y, z=value, ...)
	}
)


.plot.filled.contour <- function(x, maxcells=100000, ...) {

	x <- spatSample(x[[1]], maxcells, method="regular", as.raster=TRUE, warn=FALSE)
	X <- xFromCol(x, 1:ncol(x))
	Y <- yFromRow(x, nrow(x):1)
	Z <- t( matrix( values(x), ncol=ncol(x), byrow=TRUE)[nrow(x):1,] )

 	if (is.null(list(...)$asp)) {
		asp <- ifelse(is.lonlat(x, perhaps=TRUE, warn=FALSE), 1/cos((mean(as.vector(ext(x))[3:4]) * pi)/180), 1)
		graphics::filled.contour(x=X, y=Y, z=Z, asp=asp, ...)
	} else {
		graphics::filled.contour(x=X, y=Y, z=Z,...)
	}
}


setMethod("contour", signature(x="SpatRaster"),
	function(x, maxcells=100000, filled=FALSE, ...)  {
		if (filled) {
			.plot.filled.contour(x, maxcells=maxcells, ...)
		} else {
			x <- spatSample(x[[1]], maxcells, method="regular", as.raster=TRUE, warn=FALSE)
			if (is.null(list(...)$asp)) {
				asp <- ifelse(is.lonlat(x, perhaps=TRUE, warn=FALSE), 1/cos((mean(as.vector(ext(x))[3:4]) * pi)/180), 1)
				graphics::contour(x=xFromCol(x,1:ncol(x)), y=yFromRow(x, nrow(x):1), z=t(as.matrix(x, wide=TRUE)[nrow(x):1,]), asp=asp, ...)
			} else {
				graphics::contour(x=xFromCol(x,1:ncol(x)), y=yFromRow(x, nrow(x):1), z=t(as.matrix(x, wide=TRUE)[nrow(x):1,]), ...)
			}
		}
	}
)


setMethod("as.contour", signature(x="SpatRaster"),
	function(x, maxcells=100000, ...) {
		x <- spatSample(x[[1]], size=maxcells, method="regular", as.raster=TRUE, warn=FALSE)
		z <- grDevices::contourLines(x=xFromCol(x,1:ncol(x)), y=yFromRow(x, nrow(x):1), z=t(as.matrix(x, wide=TRUE)[nrow(x):1,]), ...)
		y <- lapply(1:length(z), function(i) cbind(z[[i]]$level, i, z[[i]]$x, z[[i]]$y))
		y <- do.call(rbind, y)
		y[] <- as.numeric(y)
		u <- unique(y[,1])
		y[,1] <- match(y[,1], u)
		colnames(y)[3:4] <- c("x", "y")
		vect(y, "lines", atts=data.frame(level=u), crs=crs(x))
	}
)



setMethod("pairs", signature(x="SpatRaster"),
	function(x, hist=TRUE, cor=TRUE, use="pairwise.complete.obs",  maxcells=100000, ...) {

		if (nlyr(x) < 2) {
			error("x must have at least two layers")
		}
		if (nlyr(x) < 2) {
			error("x must have at least two layers")
		}

		panelhist <- function(x,...)	{
			usr <- graphics::par("usr")
			on.exit(graphics::par(usr=usr))
			graphics::par(usr = c(usr[1:2], 0, 1.5) )
			h <- hist(x, plot = FALSE)
			breaks <- h$breaks
			nB <- length(breaks)
			y <- h$counts
			y <- y/max(y)
			graphics::rect(breaks[-nB], 0, breaks[-1], y, col="green")
		}

		panelcor <- function(x, y,...) {
			usr <- graphics::par("usr")
			on.exit(graphics::par(usr=usr))
			graphics::par(usr = c(0, 1, 0, 1))
			r <- abs(stats::cor(x, y, use=use))
			txt <- format(c(r, 0.123456789), digits=2)[1]
			text(0.5, 0.5, txt, cex = max(0.5, r * 2))
		}

		if (hist) {dp <- panelhist} else {dp <- NULL}
		if (cor) {up <- panelcor} else {up <- NULL}

		d <- spatSample(x, maxcells, method="regular", as.raster=FALSE, warn=FALSE)

		dots <- list(...)
		cex <- dots$cex
		main <- dots$main
		if (is.null(cex)) cex <- 0.5
		if (is.null(main)) main <- ""

		graphics::pairs(d, main=main, cex=cex, upper.panel=up, diag.panel=dp)
	}
)

.textbox <- function(x, y=NULL, labels, col="black", hc="white", hw=0.1, ... ) {
	xy <- grDevices::xy.coords(x, y)
	hw <- hw[1]
	n <- nchar(labels)
	x0 <- hw * graphics::strwidth("A")
	y0 <- hw * graphics::strheight("A")
	x1 <- n * x0
	v <- vect(cbind(xy$x + c(0, x1), xy$y), crs="local")
	b <- buffer(v, y0)
}


.halo <- function(x, y=NULL, labels, col="black", hc="white", hw=0.1, ... ) {
	if (!is.null(y)) { # recycle
		xy <- grDevices::xy.coords(cbind(x, y))
	} else {
		xy <- grDevices::xy.coords(x, y)
	}
	hw <- hw[1]
	xo <- hw * graphics::strwidth("A")
	yo <- hw * graphics::strheight("A")
	n <- nchar(labels)
	fact <- 100 * max(1, hw*2)
	
	theta <- seq(pi/4, 2*pi, length.out=hw*fact)
	for (i in theta) {
		text( xy$x + cos(i)*xo, xy$y + sin(i)*yo, labels, col=hc, ... )
	}
	graphics::text(xy$x, xy$y, labels, col=col, ... )
}

halo <- function(x, y=NULL, labels, col="black", hc="white", hw=0.1, ... ) {
	.halo(x=x, y=y, labels=labels, col=col, hc=hc, hw=hw, ...) 
}


setMethod("text", signature(x="SpatRaster"),
	function(x, labels, digits=0, halo=FALSE, hc="white", hw=0.1, jitter=0, ...) {
		if (missing(labels)) {
			labels <- 1
		}
		if (length(labels) != ncell(x)) {
			labels <- labels[1]
			if (is.character(labels)) {
				i <- which(labels == names(x))
				if (i == 0) {
					i <- 1
				}
			}
			x <- x[[labels]]
			labels <- as.data.frame(x)[,1]
			p <- as.points(x, values=TRUE)
		} else {
			p <- as.points(x, values=FALSE, na.rm=FALSE)
		}
		xy <- geom(p)[, c("x", "y"), drop=FALSE]
        if (isTRUE(jitter > 0)) {
			xy <- jitter(xy, factor = jitter)
		}
		if (is.factor(labels)) {
			labels <- substr(as.character(labels), 1, max(1, digits))
		} else if (is.numeric(labels)) {
			labels <- as.character(round(labels, digits=digits) )
		}
		if (length(labels) < nrow(xy)) {
			labels <- rep(labels, nrow(xy))
		}
#		if (!overlap) {
#			xy <- getLabelXY(xy, labels, cex)
#		}
		if (halo && (isTRUE(hw > 0))) {
			.halo(xy[,1], xy[,2], labels, hc=hc, hw=hw, ...)
		} else {
			text(xy[,1], xy[,2], labels, ...)
		}
	}
)


setMethod("text", signature(x="SpatVector"),
	function(x, labels, halo=FALSE, inside=FALSE, hc="white", hw=0.1, jitter=0, ...) {
		if (missing(labels)) {
			labels <- 1:nrow(x)
		} else if (length(labels) == 1) {
			if (nrow(x) > 1) {
				labels <- as.data.frame(x)[,labels]
			} else {
				if (is.numeric(labels)) {
					if (labels %in% 1:ncol(x)) {
						labels <- x[[labels]][,1]
					}
				} else if (labels %in% names(x)) {
					labels <- x[[labels]][,1]
				}
			}
		}
		xy <- geom(centroids(x, inside=inside))[,c("x","y"),drop=FALSE]
        if (isTRUE(jitter > 0)) {
			xy <- jitter(xy, factor = jitter)
		}
		labels <- as.character(labels)
		if (halo && (isTRUE(hw > 0))) {
			.halo(xy[,1], xy[,2], labels, hc=hc, hw=hw, ...)
		} else {
			text(xy[,1], xy[,2], labels, ...)
		}
	}
)



setMethod("boxplot", signature(x="SpatRaster"),
	function(x, y=NULL, maxcell=100000, ...) {
		if (is.null(y)) {
			cn <- names(x)
			if ( ncell(x) > maxcell) {
				warn("boxplot", "taking a sample of ", maxcell, " cells")
				x <- spatSample(x, maxcell, method="regular", as.raster=TRUE, warn=FALSE)
			}
			names(x) <- cn
			boxplot(values(x), ...)
		} else {
			s <- c(x[[1]], y[[1]])
			if ( ncell(x) > maxcell) {
				warn("boxplot", "taking a regular sample of ", maxcell, " cells")
				s <- spatSample(s, maxcell, method="regular", as.raster=TRUE, warn=FALSE)
			}
			s <- values(s, dataframe=TRUE)
			cn <- colnames(s)
			if (is.null(cn)) cn <- c("", "")
			colnames(s)[cn==""] <- c("layer1", "layer2")[cn==""]
			f <- try(stats::as.formula(paste(cn[1], '~', cn[2])), silent=TRUE)
			if (inherits(f, "try-error")) {
				colnames(s) <- c("layer1", "layer2")
				f <- layer1 ~ layer2
			}
			boxplot(f, data=s, ...)
		}
	}
)



setMethod("barplot", "SpatRaster",
	function(height, maxcell=1000000, digits=0, breaks=NULL, col, ...) {

		if (missing(col)) {
			col=grDevices::rainbow
		}
		height <- height[[1]]
		f <- is.factor(height)
#		x <- spatSample(height[[1]], maxcell, method="regular", as.raster=FALSE, as.df=f)
		x <- spatSample(height[[1]], maxcell, method="regular", as.raster=FALSE, as.df=FALSE, warn=FALSE)
		adj <- nrow(x) / ncell(height)
		if (adj < 1) {
			warn("barplot", "a sample of ", round(100*adj, 1), "% of the raster cells were used to estimate frequencies")
		}
		if (!f) {
			if (!is.null(digits)) {
				x <- round(x, digits)
			}
			if (!is.null(breaks)) {
				x <- cut(x, breaks)
			}
		}
		x <- table(x) / adj
		if (is.function(col)) {
			col <- col(length(x))
		}
		barplot(x, col=col, ...)
	}
)



shade <- function(slope, aspect, angle=45, direction=0, normalize=FALSE, filename="", overwrite=FALSE, ...) {
	stopifnot(inherits(slope, "SpatRaster"))
	opt <- spatOptions(filename, overwrite=overwrite, ...)
	slope@pntr <- slope@pntr$hillshade(aspect@pntr, angle, direction, normalize[1], opt)
	messages(slope, "shade")
}


map.pal <- function(name, n=50, ...) { 
	n <- round(n)
	if (n < 1) {
		error("map.pal", "n should be >= 1")	
	}
	f <- system.file("colors/palettes.rds", package="terra")
	v <- readRDS(f)
	if (missing(name)) {
		return(names(v))
	}
	if (name %in% names(v)) {
		v <- v[[name]]
		if ((n > 0) && ((length(v) != n))) {
			grDevices::colorRampPalette(v, ...)(n)
		} else {
			v
		}
	} else if (name == "random") {
		if (n > 433) {
			warning("map.pal", "you cannot get > 433 random colors; using n=433 instead")
			n <- 433
		}
		s <- sample(grDevices::colors()[grep('gr(a|e)y', grDevices::colors(), invert = TRUE)], n)
		rgb(t(grDevices::col2rgb(s))/255)

	} else {
		error("map.pal", paste(name, "is not a known palette"))
	}
}

map.leg <- function(name) { 
	f <- system.file("colors/legends.rds", package="terra")
	v <- readRDS(f)
	if (name %in% names(v)) {
		v[[name]]
	} else {
		error("map.leg", paste(name, "is not a known legend"))
	}
}

# Value checks for raster spatial-context and distance helpers (see man/*.Rd).

## adjacent — rook neighbours of centre cell in a 1x5 raster
ra <- rast(nrows = 1, ncols = 5, xmin = 0, xmax = 5, ymin = 0, ymax = 1, vals = 1:5)
adj <- adjacent(ra, cells = 3, directions = "rook", pairs = TRUE)
expect_equivalent(sort(adj[, "to"]), c(2L, 4L))

## boundaries — edges between two classes (see ?boundaries)
rb <- rast(nrows = 1, ncols = 5, vals = c(1, 1, 2, 2, 2))
expect_equivalent(as.vector(boundaries(rb, classes = TRUE)[]), c(0, 1, 1, 0, 0))

## patches — 2x2 clump of 1s on NA background (four cells same patch id)
rp <- rast(nrows = 4, ncols = 4, vals = NA_real_)
rp[2:3, 2:3] <- 1
pp <- patches(rp)
expect_equal(sum(pp[] == 1, na.rm = TRUE), 4)

## sieve — isolated single cell removed (see ?sieve)
rsv <- rast(nrows = 18, ncols = 18, xmin = 0, vals = 0, crs = "local")
rsv[2, 5] <- 1
expect_equal(as.numeric(sieve(rsv, 8)[2, 5]), 0)

## cellSize + expanse (elev.tif layer)
f <- system.file("ex/elev.tif", package = "terra")
r <- rast(f)
r <- if (nlyr(r) > 1) r[[1]] else r
cs <- cellSize(r)
expect_true(all(cs[] > 0, na.rm = TRUE))
expect_true(sum(unlist(expanse(r))) > 0)

## surfArea — projected synthetic (lon/lat not supported)
rpj <- rast(
  nrows = 10, ncols = 10,
  crs = "+proj=utm +zone=32 +datum=WGS84",
  xmin = 0, xmax = 1000, ymin = 0, ymax = 1000,
  vals = runif(100)
)
sa <- surfArea(rpj)
expect_true(all(sa[] > 0, na.rm = TRUE))


## direction — ?direction example
rd <- rast(ncol = 36, nrow = 18, crs = "+proj=merc")
values(rd) <- NA
rd[306] <- 1
di <- direction(rd, degrees = TRUE)
expect_true(all(di[] >= 0 & di[] <= 360, na.rm = TRUE))

## shade — hillshade in [0, 1]
slope <- terrain(r, v = "slope", unit = "radians")
asp <- terrain(r, v = "aspect", unit = "radians")
sh <- shade(slope, asp)
expect_true(min(sh[], na.rm = TRUE) >= 0 && max(sh[], na.rm = TRUE) <= 1)

## global Moran's I in [-1, 1]
aci <- autocor(r, global = TRUE)
expect_true(all(aci >= -1 & aci <= 1, na.rm = TRUE))

## where.min / where.max — global cell for single layer (see ?where)
r9 <- rast(nrows = 3, ncols = 3, vals = 1:9)
wm <- where.min(r9)
wx <- where.max(r9)
expect_equal(as.numeric(wm[1, "cell"]), 1)
expect_equal(as.numeric(wm[1, "value"]), 1)
expect_equal(as.numeric(wx[1, "cell"]), 9)
expect_equal(as.numeric(wx[1, "value"]), 9)

## NIDP — neighbour counts from flow directions
fd <- terrain(r, v = "flowdir")
nid <- NIDP(fd)
expect_true(all(nid[] >= 0 & nid[] <= 9, na.rm = TRUE))

## as.polygons uses the correct layer (#2156)
r_m <- rast(nrows = 10, ncols = 10, nlyrs = 2, vals=c(rep(NA, 50), rep(1:5, 30)))
r_disk <- writeRaster(r_m,  tempfile(fileext = ".tif"), overwrite = TRUE)
p_mem <- as.polygons(r_m[[2]])
p_disk <- as.polygons(r_disk[[2]])
expect_equal(sort(unique(values(p_disk)[, 1])), sort(unique(values(p_mem)[, 1])))
expect_false(0 %in% values(p_disk)[, 1])

setMethod("selectHighest", signature(x="SpatRaster"),
	function(x, n, low=FALSE) {
		x <- x[[1]]
		n <- min(ncell(x), max(1, n))
		i <- order(values(x, mat=FALSE), decreasing=!low)[1:n]
		x <- rast(x)
		x[i] <- 1
		x
	}
)

# Author: Robert J. Hijmans
# Date :  June 2018
# Version 0.9
# License GPL v3

setMethod("hasValues", signature(x="SpatRaster"),
	function(x) {
		x@pntr$hasValues
	}
)

ok_int <- function(x) {
	r <- suppressWarnings(range(x, na.rm=TRUE))
	isTRUE((r[1] >= -.Machine$integer.max) && (r[2] <= .Machine$integer.max))
}

.makeDataFrame <- function(x, v, ...) {

	v <- data.frame(v, check.names=FALSE, ...)

#	factors=TRUE,
#	if (factors) {
	ff <- is.factor(x)
	if (any(ff)) {
		fs <- which(ff)
		cgs <- levels(x)
		for (f in fs) {
			cg <- cgs[[f]]
			i <- match(v[,f], cg[,1])
			if (!inherits(cg[[2]], "numeric")) {
				v[[f]] <- factor(cg[i, 2], levels=unique(cg[[2]]))
			} else {
				v[[f]] <- cg[i, 2]
			}
		}
	} 
	bb <- is.bool(x)
	if (any(bb)) {
		for (b in which(bb)) {
			v[[b]] = as.logical(v[[b]])
		}
	}
	ii <- (is.int(x) & (!ff))
	if (any(ii)) {
		for (i in which(ii)) {
			if (ok_int(v[[i]])) {
				v[[i]] = as.integer(v[[i]])
			}
		}
	}
	dd <- !(bb | ii | ff)
	if (any(dd)) {
		d <- which(dd)
		v[,d] <- replace(v[,d], is.na(v[,d]), NA)
	}
	v
}


setMethod("readValues", signature(x="SpatRaster"),
function(x, row=1, nrows=nrow(x), col=1, ncols=ncol(x), mat=FALSE, dataframe=FALSE, ...) {
	stopifnot(row > 0 && nrows > 0)
	stopifnot(col > 0 && ncols > 0)
	v <- x@pntr$readValues(row-1, nrows, col-1, ncols)
	messages(x, "readValues")
	if (dataframe) {
		v <- matrix(v, ncol = nlyr(x))
		colnames(v) <- names(x)
		return(.makeDataFrame(x, v, ...) )
	} else if (mat) {
		if (all(is.int(x))) {
			if (ok_int(v)) {
				v <- matrix(as.integer(v), ncol = nlyr(x))
			} else {
				v <- matrix(v, ncol = nlyr(x))				
			}
		} else if (all(is.bool(x))) {
			v <- matrix(as.logical(v), ncol = nlyr(x))		
		} else {
			v <- matrix(v, ncol = nlyr(x))		
		}
		colnames(v) <- names(x)
	} else if (all(is.int(x))) {
		if (ok_int(v)) {
			v <- as.integer(v)
		}
	} else if (all(is.bool(x))) {
		v <- as.logical(v)
	}
	v
}
)


setMethod("readValues", signature(x="SpatRasterDataset"),
	function(x, row=1, nrows=nrow(x), col=1, ncols=ncol(x), mat=FALSE, dataframe=FALSE, ...) {
		lapply(1:length(x), function(i) readValues(x[i], row, nrows, 1, ncols, mat=mat, dataframe=dataframe, ...))
	}
)


setMethod("values", signature(x="SpatRaster"),
function(x, mat=TRUE, dataframe=FALSE, row=1, nrows=nrow(x), col=1, ncols=ncol(x), na.rm=FALSE, ...) {
	readStart(x)
	on.exit(readStop(x))
	v <- readValues(x, row, nrows, col, ncols, mat=mat, dataframe=dataframe, ...)
	messages(x, "values")
	if (na.rm) {
		if (!is.null(dim(v))) {
			v[stats::complete.cases(v), , drop=FALSE]
		} else {
			v[!is.na(v)]
		}
	} else {
		v
	}
}
)

setMethod("values<-", signature("SpatRaster", "ANY"),
	function(x, value) {
		setValues(x, value, keepnames=TRUE)
	}
)

setMethod("focalValues", signature("SpatRaster"),
	function(x, w=3, row=1, nrows=nrow(x), fill=NA) {
		if (is.matrix(w)) {
			#m <- as.vector(t(w))
			w <- dim(w)
		} else {
			w <- rep_len(w, 2)
		}
		readStart(x)
		on.exit(readStop(x))
		opt <- spatOptions()
		m <- matrix(x@pntr$focalValues(w, fill, max(0, row-1), nrows, opt), ncol=prod(w), byrow=TRUE)
		messages(x, "focalValues")
		m
	}
)


mtrans <- function(mm, nc) {
	v <- NULL
	n <- ncol(mm) / nc
	for (i in 1:n) {
		j <- 1:nc + (i-1)*nc
		v <- c(v, as.vector(t(mm[, j])))
	}
	v
}


setMethod("setValues", signature("SpatRaster"),
	function(x, values, keeptime=TRUE, keepunits=TRUE, keepnames=FALSE, props=FALSE) {

		y <- rast(x, keeptime=keeptime, keepunits=keepunits, props=props)
		if (is.data.frame(values)) {
			# needs improvement to deal with mixed data types
			values <- as.matrix(values)
		}
		if (is.matrix(values)) {
			nl <- nlyr(x)
			d <- dim(values)
			if (!all(d == c(ncell(x), nl))) {
				ncx <- ncol(x)
				if ((d[1] == nrow(x)) && ((d[2] %% nl*ncx) == 0)) { 
					# raster-shaped matrix 
					if (ncx < d[2]) {
						values <- mtrans(values, ncx)
					} else {
						values <- as.vector(t(values))
					}
				} else if ((d[2] == nl) && (d[1] < ncell(x))) {
					if (d[1] > 1) warn("setValues", "values were recycled")
					values <- as.vector(apply(values, 2, function(i) rep_len(i, ncell(x))))
				} else {
					error("setValues","dimensions of the matrix do not match the SpatRaster")
				}
			} 
			if (!keepnames) {
				nms <- colnames(values)
				if (!is.null(nms)) names(y) <- nms
			}
		} else if (is.array(values)) {
			stopifnot(length(dim(values)) == 3)
			values <- as.vector(aperm(values, c(2,1,3)))
		}
		make_factor <- FALSE
		set_coltab <- FALSE
		if (is.character(values)) {
			if (all(substr(stats::na.omit(values), 1, 1) == "#")) {
				fv <- as.factor(values)
				if (length(levels(fv)) <= 256) {
					values <- as.integer(fv) #-1
					fv <- levels(fv)
					set_coltab <- TRUE
				} else {
					fv <- NULL
					values <- t(grDevices::col2rgb(values))
					y <- rast(y, nlyr=3, names=c("red", "green", "blue"))
					RGB(y) <- 1:3
				}
			} else {
				values <- as.factor(values)
				levs <- levels(values)
				values <- as.integer(values) # -1 not needed anymore?
				make_factor <- TRUE
			}
		} else if (is.factor(values)) {
			levs <- levels(values)
			values <- as.integer(values)# - 1
			make_factor <- TRUE
		}

		if (!(is.numeric(values) || is.integer(values) || is.logical(values))) {
			error("setValues", "values must be numeric, integer, logical, factor or character")
		}

		lv <- length(values)
		nc <- ncell(y)
		nl <- nlyr(y)
		opt <- spatOptions()

		if (lv == 1) {
			y@pntr$setValues(values, opt)
		} else {
			if (lv > (nc * nl)) {
				warn("setValues", "values is larger than the size of cells")
				values <- values[1:(nc*nl)]
			} else if (lv < (nc * nl)) {
				warn("setValues", "values were recycled")
				values <- rep(values, length.out=nc*nl)
			}
			y@pntr$setValues(values, opt)
		}
		y <- messages(y, "setValues")
		if (make_factor) {
			for (i in 1:nlyr(y)) {
				levs <- data.frame(value=1:length(levs), label=levs)
				set.cats(y, i, levs)
			}
			names(y) <- names(x)
		}
		if (set_coltab) {
			coltab(y) <- fv
		} else if (is.logical(values)) {
			if (!all(is.na(values))) y@pntr$setValueType(3)
		} else if (is.integer(values)) {
			y@pntr$setValueType(1)
		}
		y
	}
)



setMethod("inMemory", signature(x="SpatRaster"),
	function(x, bylayer=FALSE) {
		r <- x@pntr$inMemory
		if (bylayer) {
			nl <- .nlyrBySource(x)
			r <- rep(r, nl)
		}
		r
	}
)


#..hasValues <- function(x) { x@pntr$hasValues}
#..inMemory <- function(x) { x@pntr$inMemory }
#..filenames <- function(x) {	x@pntr$filenames }

subsetSource <- function(x, i) {
	x@pntr <- x@pntr$subsetSource(i-1)
	messages(x)
}

setMethod("sources", signature(x="SpatRaster"),
	function(x, nlyr=FALSE, bands=FALSE) {
		src <- x@pntr$filenames()
		Encoding(src) <- "UTF-8"
		if (bands) {
			nls <- x@pntr$nlyrBySource()
			d <- data.frame(sid=rep(1:length(src), nls),
						 source=rep(src, nls),
						 bands=x@pntr$getBands()+1, stringsAsFactors=FALSE)
			if (nlyr) {
				d$nlyr <- rep(nls, nls)
			}
			d
		} else if (nlyr) {
			data.frame(source=src, nlyr=x@pntr$nlyrBySource(), stringsAsFactors=FALSE)
		} else {
			src
		}
	}
)

setMethod("sources", signature(x="SpatRasterCollection"),
	function(x, nlyr=FALSE, bands=FALSE) {
		if (nlyr | bands) {
			x <- lapply(x, function(i) sources(i, nlyr, bands))
			x <- lapply(1:length(x), function(i) cbind(cid=i, x[[i]]))
			do.call(rbind, x)
		} else {
			sapply(x, sources)
		}
	}
)

setMethod("sources", signature(x="SpatRasterDataset"),
	function(x, nlyr=FALSE, bands=FALSE) {
		if (nlyr | bands) {
			x <- lapply(x, function(i) sources(i, nlyr, bands))
			x <- lapply(1:length(x), function(i) cbind(cid=i, x[[i]]))
			do.call(rbind, x)
		} else {
			x@pntr$filenames()
		}
	}
)


setMethod("sources", signature(x="SpatVector"),
	function(x) {
		if (x@pntr$source != "") {
			if (x@pntr$layer != tools::file_path_sans_ext(basename(x@pntr$source))) {
				paste0(x@pntr$source, "::", x@pntr$layer)
			} else {
				x@pntr$source
			}
		} else {
			""
		}
	}
)

setMethod("sources", signature(x="SpatVectorProxy"),
	function(x) {
		if (x@pntr$v$layer != tools::file_path_sans_ext(basename(x@pntr$v$source))) {
			paste0(x@pntr$v$source, "::", x@pntr$v$layer)
		} else {
			x@pntr$v$source
		}
	}
)

setMethod("hasMinMax", signature(x="SpatRaster"),
	function(x) {
		x@pntr$hasRange
	}
)

setMethod("minmax", signature(x="SpatRaster"),
	function(x, compute=FALSE) {
		have <- x@pntr$hasRange
		if (!all(have)) {
			if (compute) {
				opt <- spatOptions()
				x@pntr$setRange(opt, FALSE)
			} else {
				warn("minmax", "min and max values not available for all layers. See 'setMinMax' or 'global'")
			}
		}
		r <- rbind(x@pntr$range_min, x@pntr$range_max)
		if (!compute) {
			r[,!have] <- c(Inf, -Inf)
		}
		colnames(r) <- names(x)
		rownames(r) <- c("min", "max")
		r
	}
)


setMethod("setMinMax", signature(x="SpatRaster"),
	function(x, force=FALSE) {
		opt <- spatOptions()
		if (force) {
			x@pntr$setRange(opt, TRUE)
		} else if (!all(hasMinMax(x))) {
			x@pntr$setRange(opt, FALSE)
		}
		x <- messages(x, "setMinMax")
	}
)



setMethod("compareGeom", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, ..., lyrs=FALSE, crs=TRUE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE, stopOnError=TRUE, messages=FALSE, tolerance=NULL) {
		opt <- spatOptions("")
		if (is.null(tolerance)) tolerance <- opt$tolerance
		out <- x@pntr$compare_geom(y@pntr, lyrs, crs, tolerance, warncrs, ext, rowcol, res)
		if (stopOnError) {
			messages(x, "compareGeom")
		} else {
			m <- NULL
			if (x@pntr$has_warning()) {
				m <- x@pntr$getWarnings()
			}
			if (x@pntr$has_error()) {
				m <- c(m, x@pntr$getError())
			}
			if (!is.null(m) && messages) {
				message(paste(m, collapse="\n"))
			}
		}
		dots <- list(...)
		if (length(dots) > 0) {
			for (i in 1:length(dots)) {
				if (!inherits(dots[[i]], "SpatRaster")) {
					error("compareGeom", "all additional arguments must be a SpatRaster")
				}
				out <- out & 
					compareGeom(x, dots[[i]], lyrs=lyrs, crs=crs, warncrs=warncrs, ext=ext, rowcol=rowcol, res=res, stopOnError=stopOnError, messages=messages, tolerance=tolerance)
			}
		}
		out
	}
)


setMethod("compareGeom", signature(x="SpatRaster", y="list"),
	function(x, y, ..., lyrs=FALSE, crs=TRUE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE, stopOnError=TRUE, messages=FALSE, tolerance=NULL) {
		dots <- list(...)
		if (length(dots) > 0) {
			y <- c(y, dots)
		}
		isr <- sapply(y, inherits, "SpatRaster")
		if (!all(isr)) {
			y <- y[isr]
			if (length(y) == 0) error("compareGeom", "none of the elements of y is a SpatRaster")
			n <- sum(!isr)
			if (n > 1) {
				warn("compareGeom", paste(n, "elements of y are not a SpatRaster"))
			} else {
				warn("compareGeom", paste("1 element of y is not a SpatRaster"))
			}
		}
		out <- sapply(y, compareGeom, y=x, lyrs=lyrs, crs=crs, warncrs=warncrs, ext=ext, rowcol=rowcol, res=res, stopOnError=stopOnError, messages=messages, tolerance=tolerance)
		if (!all(isr)) {
			res <- rep(NA, length(isr))
			res[isr] <- out
			return(res)
		}
		all(out)
	}
)


setMethod("compareGeom", signature(x="SpatRasterCollection", y="missing"),
	function(x, y, ..., lyrs=FALSE, crs=TRUE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE, stopOnError=FALSE, messages=FALSE, tolerance=NULL) {
		x <- as.list(x)
		dots <- list(...)
		if (length(dots) > 0) {
			error("compareGeom", "when x is a SpatRasterCollection, additional arguments are ignored")
		}
		if (length(x) == 1) return(TRUE)
		out <- sapply(x[-1], compareGeom, y=x[1], lyrs=lyrs, crs=crs, warncrs=warncrs, ext=ext, rowcol=rowcol, res=res, stopOnError=stopOnError, messages=messages, tolerance=tolerance)
		out
	}
)


setMethod("compareGeom", signature(x="SpatRaster", y="SpatRasterCollection"),
	function(x, y, ..., lyrs=FALSE, crs=TRUE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE, stopOnError=FALSE, messages=FALSE, tolerance=NULL) {
		dots <- list(...)
		if (length(dots) > 0) {
			error("compareGeom", "when y is a SpatRasterCollection, additional arguments are ignored")
		}
		out <- sapply(as.list(y), compareGeom, y=x, lyrs=lyrs, crs=crs, warncrs=warncrs, ext=ext, rowcol=rowcol, res=res, stopOnError=stopOnError, messages=messages, tolerance=tolerance)
		all(out)
	}
)


setMethod("compareGeom", signature(x="SpatVector", y="SpatVector"),
	function(x, y, tolerance=0) {
		out <- x@pntr$equals_between(y@pntr, tolerance)
		x <- messages(x, "compareGeom")
		out[out == 2] <- NA
		matrix(as.logical(out), nrow=nrow(x), byrow=TRUE)
	}
)

setMethod("compareGeom", signature(x="SpatVector", y="missing"),
	function(x, y, tolerance=0) {
		symmetrical=FALSE # this is inefficient
		out <- x@pntr$equals_within(symmetrical, tolerance)
		x <- messages(x, "compareGeom")
		out[out == 2] <- NA
		out <- matrix(as.logical(out), nrow=nrow(x), byrow=TRUE)
		out
	}
)
setMethod("all.equal", signature(target="SpatRaster", current="SpatRaster"),
	function(target, current, maxcell=100000, ...) {
		a <- base::all.equal(rast(target), rast(current))
		maxcell <- round(maxcell)
		if (isTRUE(a) && maxcell > 0) {
			hvT <- hasValues(target)
			hvC <- hasValues(current)
			if (hvT && hvC) {
				if (maxcell < ncell(target)) {
					warn(paste("all.equal", "taking a sample of ", maxcell, "cells"))
					s1 <- spatSample(current, maxcell, "regular")
					s2 <- spatSample(target, maxcell, "regular")
				} else {
					s1 <- values(current)
					s2 <- values(target)
				}
				a <- all.equal(s1, s2, ...)
			} else if (hvT || hvC) {
				if (hvT) {
					a <- "target has cell values, current does not"
				} else {
					a <- "current has cell values, target does not"				
				}
			}
		}
		a
	}
)

setMethod("all.equal", signature(target="SpatExtent", current="SpatExtent"),
	function(target, current, ...) {
		target == current
	}
)

setMethod("all.equal", signature(target="SpatVector", current="SpatVector"),
	function(target, current, ...) {
		if (any(dim(target) != dim(current))) {
			message("different dimensions")
			return(FALSE)
		}
		if (crs(target) != crs(current)) {
			message("different crs")
			return(FALSE)
		}
		if (geomtype(target) != geomtype(current)) {
			message("different geometry type")
			return(FALSE)
		}
		if (!isTRUE(all.equal(values(target), values(current), ...))) {
			message("different values")
			return(FALSE)
		}
		if (!isTRUE(all.equal(geom(target), geom(current), ...))) {
			message("different geometry")
			return(FALSE)
		}
		TRUE
	}
)



setMethod("identical", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y) {
		a <- isTRUE(all.equal(x, y, maxcell=0))
		if (a && hasValues(x))  {
			v <- unique(unlist(unique(x - y) ))
			a <- identical(v, 0)
			if (a) {
				v <- unique(unlist(unique(is.na(x) - is.na(y)) ))
				a <- all(v == 0)
			}
		}
		a
	}
)


setMethod("identical", signature(x="SpatExtent", y="SpatExtent"),
	function(x, y) {
		identical(as.vector(x), as.vector(y))
	}
)

setMethod("identical", signature(x="SpatVector", y="SpatVector"),
	function(x, y) {
		all.equal(x, y)
	}
)

setMethod("values", signature("SpatVector"),
	function(x, ...) {
		as.data.frame(x, ...)
	}
)


setMethod("values<-", signature("SpatVector", "data.frame"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		if (ncol(value) == 0) {
			x@pntr$remove_df()
			return(x)
		}
		value <- .makeSpatDF(value)
		x@pntr$set_df(value)
		messages(x)
	}
)

setMethod("values<-", signature("SpatVector", "matrix"),
	function(x, value) {
		`values<-`(x, data.frame(value))
	}
)


setMethod("values<-", signature("SpatVector", "ANY"),
	function(x, value) {
		if (!is.vector(value)) {
			error("values<-", "the values must be a data.frame, matrix or vector")
		}
		value <- rep(value, length.out=nrow(x))
		value <- data.frame(value=value)
		`values<-`(x, data.frame(value))
	}
)



setMethod("values<-", signature("SpatVector", "NULL"),
	function(x, value) {
		x@pntr <- x@pntr$deepcopy()
		x@pntr$remove_df()
		x
	}
)

setMethod("setValues", signature("SpatVector"),
	function(x, values) {
		x@pntr <- x@pntr$deepcopy()
		`values<-`(x, values)
	}
)

# Author: Robert J. Hijmans
# Date:  October 2018
# Version 1.0
# License GPL v3


.rast_replace <- function(x, name, value, caller="$<-") {
	if (inherits(value, "SpatRaster")) {
		value <- value[[1]]
		names(value) <- name
	} else if (!is.null(value)) {
		y <- rast(x, nlyrs=1)
		test <- try(values(y) <- value, silent=TRUE)
		if (inherits(test, "try-error")) {
			error(caller, "the replacement value is not valid")
		}
		value <- y
		names(value) <- name
	}
	i <- which(name == names(x))[1]
	if (is.null(value)) {
		if (is.na(i)) {
			return(x)
		} else {
			return(subset(x, -i, NSE=FALSE))
		}
	}

	if (is.na(i)) {
		if (hasValues(x)) {
			c(x, value)
		} else if (hasValues(value)) {
			value
		} else {
			c(x, value)			
		}
	} else if (nlyr(x) == 1) {
		deepcopy(value)
	} else if (i == 1) {
		c(value, x[[2:nlyr(x)]])
	} else if (i == nlyr(x)) {
		c(x[[1:(nlyr(x)-1)]], value)
	} else {
		c(x[[1:(i-1)]], value, x[[(i+1):nlyr(x)]])
	}
}

setMethod("$<-", "SpatRaster",
	function(x, name, value) {
		.rast_replace(x, name, value, "`$<-`")
	}
)


setReplaceMethod("[[", c("SpatRaster", "character"),
	function(x, i, value) {
		if (inherits(value, "numeric")) {
			r <- rast(x, nlyr=length(i))
			value <- init(r, value)
			names(value) <- i
		} else if (inherits(value, "SpatRaster")) {
			if (nlyr(value) != length(i)) {
				error("`[[`", "length of names must be equal to the number of layers")
			}
			names(value) <- i
		} else if (length(i) > 1) {
			if (NCOL(value) > 1) {
				value <- as.list(data.frame(value))
			} else {
				stopifnot(length(i) == length(value))
			}
		} else if (!is.list(value)) {
			value <- list(value)
		}
		for (k in 1:length(i)) {
			x <- .rast_replace(x, i[k], value[[k]], "`[[<-`")
#			eval(parse(text = paste0("x$", i[k], " <- value[[k]]")))
		}
		x
	}
)

setReplaceMethod("[[", c("SpatRaster", "numeric"),
	function(x, i, value) {
		if (inherits(value, "numeric")) {
			r <- rast(x, nlyr=length(i))
			value <- init(r, value)
		} else if (!inherits(value, "SpatRaster")) {
			error("`[[<-`", "Expected a SpatRaster or numeric as replacement value")
		}
		if (nlyr(value) < length(i)) {
			if (nlyr(value) > 1) {
				j <- rep_len(1:nlyr(value), length(i))
				value <- value[[j]]
			}
		} else if (nlyr(value) > length(i)) {
			error("`[[`", "length of indices must be <= the number of layers")
		}
		if (any(i<1) | any(i > nlyr(x))) {
			error("`[[`", "indices must be between 1 and the number of layers")
		}
		if (nlyr(x) == 1) {
			compareGeom(x, value, crs=FALSE, warncrs=TRUE)
			return(value)
		}
		if (nlyr(value) == 1) {
			for (k in 1:length(i)) {
				if (i[k] == 1) {
					x <- c(value, x[[2:nlyr(x)]])
				} else if (i[k] == nlyr(x)) {
					x <- c(x[[1:(nlyr(x)-1)]], value)
				} else {
					x <- c(x[[1:(i[k]-1)]], value, x[[(i[k]+1):nlyr(x)]])
				}
			}
		} else {
			for (k in 1:length(i)) {
				if (i[k] == 1) {
					x <- c(value[[k]], x[[2:nlyr(x)]])
				} else if (i[k] == nlyr(x)) {
					x <- c(x[[1:(nlyr(x)-1)]], value[[k]])
				} else {
					x <- c(x[[1:(i[k]-1)]], value[[k]], x[[(i[k]+1):nlyr(x)]])
				}
			}
		}
		#g <- gc()
		x
	}
)

# Author: Robert J. Hijmans
# Date :  2026
# Version 1.0
# License GPL v3


# ---------------------------------------------------------------------------
# Internal builders -- not exported. All user-facing entry points
# (`netw()`, `setAs(..., "SpatNetwork")`) ultimately call these.
# ---------------------------------------------------------------------------

.netw_from_SpatVector <- function(x, snap=0, merge=TRUE, directed=FALSE, weights=TRUE) {
	gt <- geomtype(x)
	if (gt != "lines") {
		error("netw", "x must be a SpatVector of lines")
	}
	if (length(snap) != 1 || !is.numeric(snap) || is.na(snap) || snap < 0) {
		error("netw", "snap must be a single non-negative number")
	}

	# `weights` argument: TRUE/FALSE, a numeric vector (length nedges),
	# or a single character matching a numeric column of `x` (one
	# weight per source feature, looked up by source_id after noding).
	w_user_vec <- NULL
	w_colname  <- NULL
	w_flag     <- FALSE
	if (is.logical(weights)) {
		if (length(weights) != 1 || is.na(weights)) {
			error("netw", "'weights' must be TRUE/FALSE, a numeric vector, or a column name")
		}
		w_flag <- isTRUE(weights)
	} else if (is.numeric(weights)) {
		w_user_vec <- as.numeric(weights)
	} else if (is.character(weights) && length(weights) == 1 && !is.na(weights) && nzchar(weights)) {
		if (!(weights %in% names(x))) {
			error("netw", paste0("'", weights, "' is not a column of x"))
		}
		col <- x[[weights, drop=TRUE]]
		if (!is.numeric(col)) {
			error("netw", paste0("column '", weights, "' must be numeric"))
		}
		w_colname <- weights
		w_flag    <- TRUE
	} else {
		error("netw", "'weights' must be TRUE/FALSE, a numeric vector, or a column name")
	}

	n <- methods::new("SpatNetwork")
	n@pntr <- x@pntr$as_network(snap, isTRUE(merge), isTRUE(directed), w_flag)
	n <- messages(n, "netw")

	if (!is.null(w_user_vec)) {
		if (length(w_user_vec) != net_nedges(n)) {
			error("netw", "length of 'weights' must equal the number of edges")
		}
		n@pntr$setWeights(w_user_vec)
		n <- messages(n, "netw")
	} else if (!is.null(w_colname)) {
		# Look up per-edge weight via source_id (1-based; -1 = unattributed).
		eds <- net_edges(n)
		src <- eds$source_id
		col <- x[[w_colname, drop=TRUE]]
		w   <- rep(NA_real_, length(src))
		ok  <- src >= 1L & !is.na(src)
		w[ok] <- col[src[ok]]
		bad <- which(is.na(w))
		if (length(bad) > 0) {
			len <- eds$length
			w[bad] <- len[bad]
			warn("netw", paste("falling back to edge length for",
				length(bad), "edge(s) with no source attribution"))
		}
		n@pntr$setWeights(as.numeric(w))
		n <- messages(n, "netw")
	}
	n
}


.netw_from_igraph <- function(x, x_attr = "x", y_attr = "y",
                              weight_attr = "weight", crs = NULL) {
	if (!requireNamespace("igraph", quietly = TRUE)) {
		error("netw", "the 'igraph' package is required; install it first")
	}
	if (!(x_attr %in% igraph::vertex_attr_names(x)) ||
	    !(y_attr %in% igraph::vertex_attr_names(x))) {
		error("netw", paste0("the igraph object must have vertex attributes '",
			x_attr, "' and '", y_attr, "' giving node coordinates"))
	}
	nx <- as.numeric(igraph::vertex_attr(x, x_attr))
	ny <- as.numeric(igraph::vertex_attr(x, y_attr))
	if (anyNA(nx) || anyNA(ny)) {
		error("netw", "igraph node coordinates contain NA")
	}

	el <- igraph::as_edgelist(x, names = FALSE)   # 1-based vertex ids
	if (NROW(el) == 0) {
		efrom <- integer(0)
		eto   <- integer(0)
	} else {
		efrom <- as.integer(el[, 1])
		eto   <- as.integer(el[, 2])
	}

	w <- numeric(0)
	if (weight_attr %in% igraph::edge_attr_names(x)) {
		w <- as.numeric(igraph::edge_attr(x, weight_attr))
	}
	directed <- igraph::is_directed(x)

	n <- methods::new("SpatNetwork")
	n@pntr <- SpatNetwork$new()
	ok <- n@pntr$buildFromComponents(nx, ny,
	                                 as.integer(efrom - 1L),
	                                 as.integer(eto - 1L),
	                                 w, directed)
	n <- messages(n, "netw")
	if (!isTRUE(ok)) return(n)

	# CRS: prefer explicit `crs=`, then graph_attr "crs", then leave empty.
	# `.txtCRS` normalises shortcuts like "local" / EPSG codes.
	if (!is.null(crs)) {
		n@pntr$setSRS(.txtCRS(crs, warn = FALSE))
	} else if ("crs" %in% igraph::graph_attr_names(x)) {
		v <- as.character(igraph::graph_attr(x, "crs"))
		if (nzchar(v)) n@pntr$setSRS(.txtCRS(v, warn = FALSE))
	}
	messages(n, "netw")
}


.netw_to_igraph <- function(x) {
	if (!requireNamespace("igraph", quietly = TRUE)) {
		error("as,SpatNetwork,igraph", "the 'igraph' package is required; install it first")
	}
	eds <- net_edges(x)
	nds <- net_nodes(x)

	# Edge list as a 2-column integer matrix (1-based vertex ids).
	el <- cbind(eds$from_node, eds$to_node)
	g <- igraph::graph_from_edgelist(el, directed = net_directed(x))

	# Vertex attributes: coordinates plus the columns of net_nodes(x).
	xy <- crds(nds)
	g <- igraph::set_vertex_attr(g, "x", value = xy[, 1])
	g <- igraph::set_vertex_attr(g, "y", value = xy[, 2])
	for (nm in setdiff(names(nds), c("x", "y"))) {
		g <- igraph::set_vertex_attr(g, nm, value = nds[[nm, drop = TRUE]])
	}

	# Edge attributes: `weight` (when weighted) plus everything carried
	# on net_edges() except the structural columns.
	w <- net_weights(x)
	if (!is.null(w)) {
		g <- igraph::set_edge_attr(g, "weight", value = w)
	}
	for (nm in setdiff(names(eds), c("from_node", "to_node"))) {
		g <- igraph::set_edge_attr(g, nm, value = eds[[nm, drop = TRUE]])
	}

	# CRS travels along as a graph attribute so a round-trip preserves it.
	wkt <- crs(x)
	if (!is.na(wkt) && nzchar(wkt)) {
		g <- igraph::set_graph_attr(g, "crs", wkt)
	}
	g
}


# ---------------------------------------------------------------------------
# `netw()` -- the user-facing constructor, in the spirit of `vect()`.
#
# Dispatches by class:
#   netw()                      -> empty SpatNetwork
#   netw(SpatVector, ...)       -> build from line geometry (planar noding)
#   netw(igraph,     ...)       -> build from an igraph object
#   netw(<filename>, ...)       -> read a GDAL GNM dataset from disk
#   netw(SpatNetwork, ...)      -> identity (idempotent)
# ---------------------------------------------------------------------------

setMethod("netw", signature(x="missing"),
	function(x, ...) {
		n <- methods::new("SpatNetwork")
		n@pntr <- SpatNetwork$new()
		n
	}
)

setMethod("netw", signature(x="SpatVector"),
	function(x, snap=0, merge=TRUE, directed=FALSE, weights=TRUE, ...) {
		.netw_from_SpatVector(x, snap=snap, merge=merge,
		                      directed=directed, weights=weights)
	}
)

setMethod("netw", signature(x="igraph"),
	function(x, x_attr="x", y_attr="y", weight_attr="weight", crs=NULL, ...) {
		.netw_from_igraph(x, x_attr=x_attr, y_attr=y_attr,
		                  weight_attr=weight_attr, crs=crs)
	}
)

setMethod("netw", signature(x="character"),
	function(x, ...) {
		.gnm_read(x)
	}
)

setMethod("netw", signature(x="SpatNetwork"),
	function(x, ...) x
)


# ---------------------------------------------------------------------------
# Formal coercion via setAs (so `as(x, "SpatNetwork")` and
# `as(net, "igraph")` work, mirroring how other Spat* classes coerce).
# ---------------------------------------------------------------------------

setAs("SpatVector", "SpatNetwork",
	function(from) .netw_from_SpatVector(from)
)

setAs("igraph", "SpatNetwork",
	function(from) .netw_from_igraph(from)
)

setAs("SpatNetwork", "igraph",
	function(from) .netw_to_igraph(from)
)


# ---------------------------------------------------------------------------
# show / dimensions
# ---------------------------------------------------------------------------

setMethod("show", signature(object="SpatNetwork"),
	function(object) {
		cat(object@pntr$show())
	}
)

setMethod("net_nnodes", signature(x="SpatNetwork"),
	function(x, ...) {
		x@pntr$nnodes()
	}
)

setMethod("net_nedges", signature(x="SpatNetwork"),
	function(x, ...) {
		x@pntr$nedges()
	}
)


# ---------------------------------------------------------------------------
# nodes / edges (returned as SpatVectors of points / lines).
# Names use the `net_*` prefix to avoid collisions with igraph and the
# `network` package, both of which export plain `nodes`, `edges`, etc.
# ---------------------------------------------------------------------------

setMethod("net_nodes", signature(x="SpatNetwork"),
	function(x, ...) {
		v <- methods::new("SpatVector")
		v@pntr <- x@pntr$as_nodes()
		messages(v, "net_nodes")
	}
)

setMethod("net_edges", signature(x="SpatNetwork"),
	function(x, ...) {
		v <- methods::new("SpatVector")
		v@pntr <- x@pntr$as_edges()
		v <- messages(v, "net_edges")
		# C++ uses 0-based node indices, with -1 marking an unattributed
		# source feature. Translate to R-idiomatic 1-based ids and NA.
		v$from_node <- v$from_node + 1L
		v$to_node   <- v$to_node   + 1L
		sid <- v$source_id
		sid[sid < 0L] <- NA_integer_
		v$source_id <- sid + 1L
		v
	}
)


# ---------------------------------------------------------------------------
# CRS, extent, plotting
# ---------------------------------------------------------------------------

setMethod("crs", signature(x="SpatNetwork"),
	function(x, proj=FALSE, describe=FALSE, parse=FALSE) {
		wkt <- x@pntr$getSRS("wkt")
		if (describe) {
			# Reuse the SpatVector path so describe/parse behave the same
			# way as for other Spat* classes.
			v <- vect(cbind(0, 0), crs = wkt)
			return(.get_CRS(v, proj=proj, describe=describe, parse=parse))
		}
		if (proj) {
			r <- x@pntr$getSRS("proj4")
		} else {
			r <- wkt
		}
		if (parse) unlist(strsplit(r, "\n")) else r
	}
)

setMethod("ext", signature(x="SpatNetwork"),
	function(x, ...) {
		e <- methods::new("SpatExtent")
		e@pntr <- x@pntr$extent
		e
	}
)

setMethod("plot", signature(x="SpatNetwork", y="missing"),
	function(x, y, nodes=TRUE, col="black", node.col="red", node.pch=20, cex=1, ...) {
		e <- net_edges(x)
		plot(e, col=col, ...)
		if (nodes) {
			points(net_nodes(x), col=node.col, cex=cex, pch=node.pch)
		}
		invisible(x)
	}
)


# ---------------------------------------------------------------------------
# Directionality and weights. Renamed to net_* to avoid masking by
# igraph (which exports `is.directed`, `weights`, `nodes`, `edges`).
# ---------------------------------------------------------------------------

setMethod("net_directed", signature(x="SpatNetwork"),
	function(x, ...) {
		x@pntr$isDirected()
	}
)

setMethod("net_weights", signature(x="SpatNetwork"),
	function(x, ...) {
		if (!x@pntr$isWeighted()) return(NULL)
		x@pntr$getWeights()
	}
)

setReplaceMethod("net_weights", signature(x="SpatNetwork"),
	function(x, value) {
		if (is.null(value)) {
			x@pntr$clearWeights()
		} else {
			value <- as.numeric(value)
			if (length(value) != net_nedges(x)) {
				error("net_weights<-", "length of value must equal the number of edges")
			}
			x@pntr$setWeights(value)
		}
		messages(x, "net_weights<-")
	}
)


# ---------------------------------------------------------------------------
# Shortest paths between pairs of node ids.
#   from, to : integer node ids (1-based). Either may be length 1 to be
#              recycled against the other; otherwise lengths must match.
# Returns a SpatVector of lines, one feature per pair, with columns
# `from`, `to`, and `distance` (the total accumulated weight; NA when
# unreachable, 0 with empty geometry when from==to).
# ---------------------------------------------------------------------------

setMethod("shortestPath", signature(x="SpatNetwork"),
	function(x, from, to, ...) {
		if (missing(from) || missing(to)) {
			error("shortestPath", "both 'from' and 'to' must be provided")
		}
		from <- as.integer(from)
		to   <- as.integer(to)
		if (length(from) == 0 || length(to) == 0) {
			error("shortestPath", "'from' and 'to' must each have length >= 1")
		}
		if (anyNA(from) || anyNA(to)) {
			error("shortestPath", "'from' and 'to' must be integer node ids (no NAs)")
		}
		nn <- net_nnodes(x)
		if (any(from < 1L) || any(from > nn)) {
			error("shortestPath", "'from' contains an invalid node id")
		}
		if (any(to < 1L) || any(to > nn)) {
			error("shortestPath", "'to' contains an invalid node id")
		}

		v <- methods::new("SpatVector")
		# C++ side uses 0-based indices throughout.
		v@pntr <- x@pntr$shortest_paths(from - 1L, to - 1L)
		v <- messages(v, "shortestPath")
		v$from <- v$from + 1L
		v$to   <- v$to   + 1L
		v
	}
)


# ---------------------------------------------------------------------------
# Read / write the GDAL Geographic Network Model (GNM) on-disk format.
#
# `writeNetwork(net, filename, ...)` is the user-facing writer; for now it
# only knows about GNM (filetype "GNMFile" -- a directory of small
# OGR-format files -- or "GNMDatabase"), but the signature is structured
# so additional formats can be added later by dispatching on `filetype`.
#
# Reading is done through `netw(<filename>)`, which calls the internal
# `.gnm_read()`. We deliberately do not export a separate `gnm_read()`:
# users go through `netw()` for symmetry with `vect()` / `rast()`.
#
# A GNM dataset is a directory (driver "GNMFile") or a database
# (driver "GNMDatabase") containing two "class" layers (`nodes` and
# `edges`) plus the GNM system layers (`_gnm_meta`, `_gnm_graph`,
# `_gnm_features`, `_gnm_srs.prj`) that record topology, GFIDs and the
# network's spatial reference.
# ---------------------------------------------------------------------------

setMethod("writeNetwork", signature(x="SpatNetwork", filename="character"),
	function(x, filename, filetype="GNMFile", overwrite=FALSE, options=NULL, ...) {
		filename <- as.character(filename)[1]
		if (!nzchar(filename)) {
			error("writeNetwork", "'filename' must be a non-empty path")
		}
		filetype <- as.character(filetype)[1]
		if (!(filetype %in% c("GNMFile", "GNMDatabase"))) {
			error("writeNetwork",
			      paste0("unknown filetype '", filetype,
			             "'; supported: 'GNMFile', 'GNMDatabase'"))
		}
		options <- if (is.null(options)) character(0) else as.character(options)

		if (file.exists(filename)) {
			if (!isTRUE(overwrite)) {
				error("writeNetwork",
				      paste0("'", filename, "' already exists; ",
				             "set overwrite=TRUE to replace it"))
			}
			# GNM refuses to write into an existing path; remove first.
			unlink(filename, recursive = TRUE, force = TRUE)
		}

		ok <- x@pntr$write_gnm(filename, filetype, options)
		messages(x, "writeNetwork")
		invisible(isTRUE(ok))
	}
)


.gnm_read <- function(filename) {
	filename <- as.character(filename)[1]
	if (!nzchar(filename)) {
		error("netw", "'filename' must be a non-empty path")
	}
	if (!file.exists(filename)) {
		error("netw", paste0("'", filename, "' does not exist"))
	}
	n <- methods::new("SpatNetwork")
	n@pntr <- SpatNetwork$new()
	ok <- n@pntr$read_gnm(filename)
	n <- messages(n, "netw")
	if (!isTRUE(ok)) return(n)
	n
}

setMethod("rasterizeGeom", signature(x="SpatVector", y="SpatRaster"),
	function(x, y, fun="count", unit="m", filename="", ...) {
		opt <- spatOptions(filename, ...)
		y@pntr <- y@pntr$rasterizeGeom(x@pntr, unit, fun, opt)
		messages(y, "rasterizeGeom")
	}
)

# now can use
# r@pntr = r@pntr$rasterizePoints(v@pntr, "mean", 1:nrow(v), NA, opt)

.set_names <- function(wopt, cnms, fun, nc) {
	if (is.null(wopt$names)) {
		if (is.null(cnms)) {
			if (nc == 1) {
				cnms <- fun
			} else {
				cnms <- paste0(fun, "_", 1:nc)
			}
		} else {
			cnms <- paste0(cnms, "_", fun)
		}
		wopt$names <- cnms
	}
	wopt
}

rasterize_points <- function(x, y, values, fun="last", background=NA, update=FALSE, filename="", overwrite=FALSE, wopt=list(), ...) {

	if (missing(fun) || (is.null(fun))) fun <- "last"
	if (update && (!hasValues(y))) update <- FALSE
	nrx <- nrow(x)

	if (!is.data.frame(values)) {
		values <- as.data.frame(values)
	}
	if (nrow(values) == 1) {
		values <- sapply(values, function(x) rep_len(x, nrx))
		if (!is.data.frame(values)) { # dropped if nrx==1
			values <- as.data.frame(values)
		}
	} else if (nrow(values) != nrx) {
		error("rasterize", paste0("the number or rows in values is ", nrow(values), "\nThat does not match the number of points: ", nrx))
	}
	cnms <- colnames(values)
	nl <- ncol(values)
	r <- rast(y, nlyrs=nl)	
	levs <- list()
	has_levels <- FALSE
	for (i in 1:nl) {
		if (is.character(values[,i])) {
			f <- as.factor(values[,i])
			levs[[i]] <- data.frame(ID=seq_along(levels(f))-1L, category=levels(f))
			values[,i] <- as.integer(f) - 1
			has_levels <- TRUE
		} else if (is.factor(values[,i])) {
			f <- values[,i]
			levs[[i]] <- data.frame(ID=seq_along(levels(f))-1L, category=levels(f))
			values[,i] <- as.integer(f) - 1
			has_levels <- TRUE
		}
	}

	if (NCOL(values) == 1 && (!has_levels)) {
		txtfun <- .makeTextFun(fun)
		if (inherits(txtfun, "character")) {
			if (txtfun %in% c("first", "last", "pa", "sum", "mean", "count", "min", "max", "prod")) {	
				if (is.null(wopt$names)) {
					wopt$names <- txtfun
				}
				if (update) {
					ops <- spatOptions("", TRUE, wopt=wopt)	
				} else {
					ops <- spatOptions(filename, overwrite, wopt=wopt)				
				}
				narm <- isTRUE(list(...)$na.rm)
				r <- rast()
				r@pntr <- y@pntr$rasterizePointsXY(x[,1], x[,2], txtfun, values[[1]], narm, background, ops)
				messages(r)
				if (update) {
					r <- cover(r, y, filename=filename, overwrite=overwrite, wopt=wopt)
				}
				return(r)
			}
		}
	}
	if (inherits(fun, "character")) {
		if (fun == "first") {
			fun <- function(i, na.rm=FALSE) {
				if (na.rm) {
					i <- na.omit(i)
				}
				if (length(i) > 0) {
					i[i]
				} else {
					NA
				}
			}
		} else if (fun == "last") {
			fun <- function(i, na.rm=FALSE) {
				if (na.rm) {
					i <- na.omit(i)
				}
				if (length(i) > 0) {
					i[length(i)]
				} else {
					NA
				}
			}
		} else if (fun == "count") {
			fun <- function(i, na.rm=FALSE) {
				if (na.rm) {
					i <- na.omit(i)
				}
				length(i)
			}
			has_levels <- FALSE
		}
	} else {
		has_levels <- FALSE
	}

	
	g <- cellFromXY(y, x)
	i <- which(!is.na(g))
	g <- g[i]
	if (length(g) == 0) {
		return(r)
	}
	values <- values[i, ,drop=FALSE]

	values <- aggregate(values, list(g), fun, ...)
	#if (!all(values %in% ) ?
	#has_levels <- FALSE ??
	#levs <- NULL ??

	# allow for multiple fields
	#r[a[,1]] <- as.matrix(a[,-1])
	if (is.null(wopt$names)) {
		fun <- .makeTextFun(fun)
		if (inherits(fun, "character")) {
			wopt <- .set_names(wopt, cnms, fun, NCOL(values))
		} else if (!is.null(cnms)) {
			wopt$names <- cnms
		}
	}

	values <- as.matrix(values)
	nl <- max(1, ncol(values)-1)
	r <- rast(r, nlyrs=nl)	

	if (!update) {
		if (has_levels) {
			levels(r) <- levs
		}
		b <- writeStart(r, filename=filename, sources=sources(y), overwrite=overwrite, wopt=wopt)
		filename  <- ""
	} else {
		b <- writeStart(r, "")
	}
	nc <- ncol(r)
	for (i in 1:b$n) {
		w <- matrix(background, nrow=b$nrows[i] * nc, ncol=nl)
		mincell <- cellFromRowCol(r, b$row[i], 1)
		maxcell <- cellFromRowCol(r, b$row[i] + b$nrows[i]-1, nc)
		vv <- values[values[,1] >= mincell & values[,1] <= maxcell, ,drop=FALSE]
		if (nrow(vv) > 0) {
			vv[,1] <- vv[,1] - (b$row[i] - 1) * nc
			w[vv[,1],] <- vv[,-1]
		}
		writeValues(r, w, b$row[i], b$nrows[i])
	}
	r <- writeStop(r)

	if (update) {
		r <- cover(r, y, filename=filename, overwrite=overwrite, wopt=wopt)
	}

	return (r)
}


setMethod("rasterize", signature(x="matrix", y="SpatRaster"),
	function(x, y, values=1, fun, ..., background=NA, update=FALSE, by=NULL, filename="", overwrite=FALSE, wopt=list()) {

		if (!is.null(by)) {
		
			if (missing(fun)) fun <- NULL
			by <- rep_len(by, nrow(x))
			values <- rep_len(values, nrow(x))

			x <- lapply(split(data.frame(x), by), as.matrix)
			values <- split(values, by)

			out <- rast(lapply(1:length(x), function(i) rasterize(x[[i]], y, values[[i]], fun=fun, background=background, update=update)))
			names(out) <- unique(by)
			if (filename != "") {
				out <- writeRaster(out, filename, overwrite=overwrite, wopt=wopt)
			}
			return(out)
		}

		#lonlat <- .checkXYnames(colnames(x))

		if (NCOL(values) <= 1) {
			values <- unlist(values)
			if (length(values) > nrow(x)) {
				error("rasterize", "length(values) > nrow(x)")
			}
			values=rep_len(values, nrow(x))
		} else {
			if (nrow(values) > nrow(x)) {
				error("rasterize", "nrow(values) > nrow(x)")
			}
			if (nrow(values) < nrow(x)) {
				i <- rep_len(1:nrow(values), nrow(x))
				values <- values[i, ]
			}
		}
		rasterize_points(x=x, y=y, values=values, fun=fun, background=background, update=update, filename=filename, overwrite=overwrite, wopt=wopt, ...)
	}
)


setMethod("rasterize", signature(x="data.frame", y="SpatRaster"),
	function(x, y, values=1, fun, ..., background=NA, update=FALSE, by=NULL, filename="", overwrite=FALSE, wopt=list()) {
		stopifnot(ncol(x) >=2)
		x <- as.matrix(x[,1:2])
		if (missing(fun)) fun <- NULL
		rasterize(x, y, values=values, fun=fun, ..., background=background, update=update, by=by, filename=filename, overwrite=overwrite, wopt=wopt)
	}
)


setMethod("rasterize", signature(x="SpatVector", y="SpatRaster"),
	function(x, y, field="", fun, ..., background=NA, touches=FALSE, update=FALSE, cover=FALSE, by=NULL, filename="", overwrite=FALSE, wopt=list()) {

		if (!is.null(by)) {
			if (missing(fun)) fun <- NULL
			x <- split(x, by)
			uby <- names(x)
			##uby <- sapply(x, function(i) i[[by]][1])			
			out <- rast(lapply(x, function(i) rasterize(i, y, field=field, fun=fun, background=background, touches=touches, update=update, cover=cover, ...)))
			names(out) <- uby
			if (filename != "") {
				out <- writeRaster(out, filename, overwrite=overwrite, wopt=wopt)
			}
			return(out)
		}
		
		values <- 1
		if (!is.character(field)) {
			values <- as.numeric(field)
			field  <- ""
		} else if (is.na(field[1])) {
			values <- as.numeric(NA)
			field  <- ""
		} else if (is.null(field) || field[1] == "") {
			field <- ""
		} else if (!(field[1] %in% names(x))) {
			error("rasterize", paste(field, "is not a field in 'x'"))
		}

		g <- geomtype(x)
		if (grepl("points", g)) {
			nrx <- nrow(x)
			# also allow for multiple columns to multiple layers
			xy <- crds(x)
			if (field[1] == "") {
				values <- matrix(1, ncol=1, nrow=nrx)
			} else if (field[1] != "") {
				values <- x[, field, drop=TRUE]
				if (nrow(xy) != nrx) { # multi-points
					g <- geom(x)
					values <- values[g[,1], ,drop=FALSE]
				}
			}
			return(
				rasterize_points(x=xy, y=y, values=values, fun=fun, background=background, update=update, filename=filename, overwrite=overwrite, wopt=wopt, ...)
			)
		}

		opt <- spatOptions(filename, overwrite, wopt=wopt)
		pols <- grepl("polygons", g)

		dots <- list(...)
		nms <- names(dots)
		nms <- nms[!(nms %in% c("na.rm", "fun", "sum"))]
		if (length(nms) > 0) {
			warn("rasterize", paste("unexpected additional argument(s):", paste(nms, collapse=", ")))
		}

		if (cover[1] && pols) {
			y@pntr <- y@pntr$rasterize(x@pntr, "", 1, background, touches[1], "", TRUE, FALSE, TRUE, opt)
		} else {
			if (missing(fun) || is.null(fun)) {
				if (!is.null(dots$sum)) {
					# backward compatibility
					if (isTRUE(dots$sum)) fun <- "sum"
				} else {
					fun <- ""
				}
			}
			if (!inherits(fun, "character")) {
				fun <- .makeTextFun(fun)
				if (!inherits(fun, "character")) {
					error("rasterize", "'fun' must be 'min', 'max', 'mean', 'count', or 'sum'")
				}
			}
			if (fun != "") {
				fun <- tolower(fun)
				if (!(fun %in% c("sum", "mean", "min", "max", "count"))) {
					error("rasterize", "'fun' must be 'min', 'max' 'mean', 'count', or 'sum'")
				}
				if (fun == "count") {
					fun <- "sum"
					field <- ""
					values <- 1
				} else if (field != "") {
					if (fun == "min") {
						x <- sort(x[,field], field, TRUE)
						fun <- ""
					} else if (fun == "max") {
						x <- sort(x[,field], field, FALSE)
						fun <- ""
					}
				}
			}
			if ((field != "") && isTRUE(dots$na.rm)) {
				x <- x[!is.na(x[[field]]), ]
			}
			background <- as.numeric(background[1])
			if (fun == "sum") {
				xopt = spatOptions()
				y@pntr <- y@pntr$rasterize(x@pntr, field, values, background, touches[1], fun, FALSE, update[1], TRUE, xopt)
				messages(y, "rasterize")
				xopt = spatOptions()
				yy <- rast(y)
				yy@pntr <- y@pntr$rasterize(x@pntr, "", values, NA, touches[1], ""	, FALSE, update[1], TRUE, xopt)
				messages(yy, "rasterize")
				return(mask(y, yy, updatevalue=background, filename=filename, overwrite=overwrite, wopt=wopt))
			} else if (fun == "mean") {
				xopt = spatOptions()
				y@pntr <- y@pntr$rasterize(x@pntr, field, values, background, touches[1], "sum", FALSE, update[1], TRUE, xopt)
				messages(y, "rasterize")
				xopt = spatOptions()
				yy <- rast(y)
				yy@pntr <- y@pntr$rasterize(x@pntr, "", values, NA, touches[1], "sum", FALSE, update[1], TRUE, xopt)
				messages(yy, "rasterize")
				y <- y / yy
				if (filename != "") {
					y <- writeRaster(y, filename=filename, overwrite=overwrite, wopt=wopt)
				}
				return(y)
			} else {
				y@pntr <- y@pntr$rasterize(x@pntr, field, values, background, touches[1], fun, FALSE, update[1], TRUE, opt)
			}
		}	
		messages(y, "rasterize")
	}
)


setMethod("rasterize", signature(x="sf", y="SpatRaster"),
	function(x, y, ...) {
		x <- vect(x)
		rasterize(x, y, ...)
	}
)

# Author: Robert J. Hijmans, r.hijmans@gmail.com
# Date : November 2017
# Version 1
# License GPL v3

setClass("SpatRaster",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatRaster")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)

setClass("SpatRasterDataset",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatRasterStack")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)

setClass("SpatRasterCollection",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatRasterCollection")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)


setClass("SpatVector",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatVector")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)

setClass("SpatVectorProxy",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatVectorProxy")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)


setClass("SpatVectorCollection",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatVectorCollection")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)


setClass("SpatNetwork",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatNetwork")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)



setClass("SpatExtent",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatExtent")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)


setClass("SpatOptions",
	representation (
		pntr = "C++Object"
	),
	prototype (
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatOptions")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)



setClass("SpatGraticule",
	representation (
		pntr = "C++Object",
		box = "C++Object"
	),
	prototype (
		pntr = NULL,
		pntr = NULL
	),
	validity = function(object)	{
		if (is.null(object@pntr) || is(object@pntr, "Rcpp_SpatVector")){
			return(TRUE)
		} else {
			return(FALSE)
		}
	}
)


# Make igraph's S3 class visible to S4 dispatch (`setMethod("netw",
# "igraph", ...)`, `setAs("igraph", "SpatNetwork", ...)`). It is safe
# to register the name even when the (Suggested) igraph package is
# absent -- nothing here imports igraph.
setOldClass("igraph")

# these methods require the dev version of leaflet

# Per-feature colors for variable y
.cols_from_y <- function(x, y, cols=NULL, fname="points", type=NULL, breaks=NULL, 
		breakby="eqint", sort=TRUE, reverse=FALSE) {
	if (length(y) != 1) {
		error(fname, "y should be a single variable (column) name or number")
	}
	if (is.numeric(y)) {
		y <- round(y)
		if ((y < 1) || (y > ncol(x))) {
			error(fname, "y is not a valid column number")
		}
		y <- names(x)[y]
	}
	if (!(y %in% names(x))) {
		error(fname, "'", y, "' is not a variable (column name) in x")
	}
	v <- values(x[, y])[,1]
	if (is.null(cols)) cols <- .default.pal()
	.get_leg(v, type=type, dig.lab=3, cols=cols, breaks=breaks, breakby=breakby, sort=sort, reverse=reverse)
}


checkLeafLetVersion <- function() {
	v <- utils::packageVersion("leaflet")
	if (v < "2.1.2.9000") {
		error("plet", "plet needs a more recent version of leaflet")
	}
}

popUp <- function(x) {
	nms <- names(x)
	if (length(nms) > 0) {
		s <- sapply(1:length(nms), function(i) paste0(nms[i], ": ", x[[i, drop=TRUE]]))
		if (is.null(dim(s))) {
			paste(s, collapse="<br>")
		} else {
			apply(s, 1, function(i) paste(i, collapse="<br>"))		
		}
	} else {
		paste("geom", 1:nrow(x), sep="_")
	}
}

getLabel <- function(x, label) {
	if (is.null(label)) return(label)
	if ((length(label) == 1)) {
		if (is.logical(label)) {
			if (label) return(1:nrow(x))
			return(NULL)
		}
		if (label %in% names(x)) {
			return(x[[label, drop=TRUE]])
		}
	}
	label
}


makelonlat <- function(x) {
	geo <- is.lonlat(x)
	if (is.na(geo)) {
		geo <- is.lonlat(x, TRUE, TRUE)
		if (geo) return(x)
		error("plet", "coordinate reference system is unknown and does not look like lon/lat")
	} else if (!geo) {
		project(x, "+proj=longlat")
	} else {
		x
	}
}

setMethod("plet", signature(x="missing"),
	function(x) {
		leaflet::leaflet()
	}
)

#.leaflet-container {
#    background: #FFF;
#}


baselayers <- function(tiles, wrap=TRUE) {
	map <- leaflet::leaflet()
	if ((!is.null(tiles)) && (length(tiles) > 0)) {
		if ("Streets" %in% tiles) {
			map <- leaflet::addTiles(map, group="Streets", 
			       options=leaflet::tileOptions(noWrap = !wrap))
			tiles <- tiles[tiles != "Streets"]
		} 
		if (length(tiles) > 0) {
			for (i in 1:length(tiles)) {
				map <- leaflet::addProviderTiles(map, tiles[i], group=tiles[i], 
					       options=leaflet::tileOptions(noWrap = !wrap))
			}
		}
	}
	map
}


.get_leg <- function(v, type="", dig.lab=3, cols, breaks=NULL, breakby="eqint", sort=TRUE, reverse=FALSE, border="black", ...) {
	out <- list(v=v, leg=list())
		
	if (is.null(type)) type <- ""
	if (type == "continuous") {
		type <- "interval"	
	} else if (type == "") {
		if ((!is.numeric(v)) || (length(unique(v)) < 11)) {
			type <- "classes"
		} else {
			type <- "interval"
		}
	} else {
		type <- match.arg(type, c("interval", "classes"))
	}
	out$legend_type <- type

	out$uv <- unique(v)
	
	if (inherits(cols, "function")) {
		cols <- cols(100)
	}
	out$cols <- cols
	out$leg$border <- border	
	if (out$legend_type == "classes") {
		out$leg$sort <- sort[1]
		out$leg$reverse <- reverse[1]
		out <- .vect.legend.classes(out)
	} else if (out$legend_type == "interval") {
		out$breaks <- breaks
		out$breakby <- breakby
		out$range <- range(v, na.rm=TRUE)
		out <- .vect.legend.interval(out, dig.lab=dig.lab)
	}

	out
}



setMethod("plet", signature(x="SpatVector"),
	function(x, y="", col, main=y, cex=1, lwd=2, lty=NULL, border="black", alpha=c(0.3, 1), popup=TRUE, label=FALSE, split=FALSE, tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), wrap=TRUE, legend="bottomright", collapse=FALSE, type=NULL, breaks=NULL, breakby="eqint", sort=TRUE, reverse=FALSE, map=NULL, fill=NULL, ...)  {

		if (!is.null(fill)) { 
			warn("plet", "argument 'fill' will be removed. Use 'alpha' instead") 
			alpha[1] <- fill
		}

		y <- unique(y)
		if (length(y) > 1) {
			y = y[1]
#			xvc <- svc(lapply(y, function(i) x[,i]))
#			if (is.numeric(y)) {
#				names(xvc) <- names(x)[y]
#			} else {
#				names(xvc) <- y			
#			}
#			plet(xvc, col=col, fill=0.2, alpha=alpha, cex=cex, lwd=lwd, border=border, popup=popup, label=label, split=split, tiles=tiles, wrap=wrap, legend=legend, collapse=collapse,  map=map, ...)	
#type=type, breaks=breaks, breakby=breakby, sort=sort, reverse=reverse,
		}
		
		if (missing(col)) col <- function(n) grDevices::rainbow(n, start=.2)
		alpha <- pmax(0, pmin(1, rep_len(alpha, 2)))
		x <- makelonlat(x)

		if (is.null(map)) {
			tiles <- unique(as.character(tiles))
			tiles <- tiles[tiles!=""]
			map <- baselayers(tiles, wrap)
		} else {
			tiles <- NULL
		}
		g <- geomtype(x)
		leg <- NULL
		if (y == "") { # no legend
			group <- x@pntr$layer
			if (group == "") group = g
			cols <- .getCols(nrow(x), col)
			pop  <- lab <- NULL
			if (isTRUE(popup[1])) pop <- popUp(x)
			lab <- getLabel(x, label)
			if (g == "polygons") {
				map <- leaflet::addPolygons(map, data=x, label=lab, group=group, 
							fillColor=cols, fillOpacity=alpha[1], opacity=alpha[2], 
							popup=pop, color=border, weight=lwd, dashArray=lty, ...)
			} else if (g == "lines") {
				map <- leaflet::addPolylines(map, data=x, label=lab, group=group,  
							color=cols, opacity=alpha[1],  popup=pop, weight=lwd, dashArray=lty, ...)
			} else {
				map <- leaflet::addCircleMarkers(map, data=x, radius=cex, popup=pop, group=group, 
							label=lab, fillOpacity=alpha[1], opacity=alpha[2], color=cols, 
							weight=lwd, dashArray=lty, ...)
			}

			if (length(tiles) > 1) {
				map <- leaflet::addLayersControl(map, baseGroups = tiles, overlayGroups=group,
						options = leaflet::layersControlOptions(collapsed=collapse))
			} else {
				map <- leaflet::addLayersControl(map, overlayGroups = group, 
						options = leaflet::layersControlOptions(collapsed=collapse))
			}			
			map
		} else { # legend
			y <- y[1]
			if (is.numeric(y)) {
				y <- round(y)
				stopifnot((y > 0) && (y <= ncol(x)))
				y <- names(x)[y]
			}
			stopifnot(y %in% names(x))
			xy <- x[, y]
			v <- values(xy)[,1]

			if (split) { 
				u <- unique(v)
				cols <- .getCols(length(u), col)
				for (i in seq_along(u)) {
					s <- xy[v == u[i], ]
					pop <- lab <- NULL
					if (isTRUE(popup[1])) pop <- popUp(x[v == u[i], ])
					if ((length(label)==1) && isTRUE(label)) {
						lab <- u
					} else {
						lab <- getLabel(x, label)
					}
					
					if (g == "polygons") {
						map <- leaflet::addPolygons(map, data=s, label=lab[i], group=u[i], 
							fillColor=cols[i],  fillOpacity=alpha[1], opacity=alpha[2], popup=pop, 
							col=border, weight=lwd, dashArray=lty, ...)
					} else if (g == "lines") {
						map <- leaflet::addPolylines(map, data=s, label=lab[i], group=u[i], 
							col=cols[i], opacity=alpha[1], popup=pop, weight=lwd, dashArray=lty, ...)
					} else {
						map <- leaflet::addCircleMarkers(map, data=s, label=lab[i], group=u[i], 
							col=cols[i], fillOpacity=alpha[1], opacity=alpha[2], popup=pop, 
							radius=cex, weight=lwd, dashArray=lty, ...)
					}
				}
				if (length(tiles) > 1) {
					map <- leaflet::addLayersControl(map, baseGroups = tiles, overlayGroups = u, 
						options = leaflet::layersControlOptions(collapsed=collapse))
				} else {
					map <- leaflet::addLayersControl(map, overlayGroups = u, 
						options = leaflet::layersControlOptions(collapsed=collapse))
				}
			} else { # do not split
				#vcols <- cols[1:length(v)]
				leg <- .get_leg(v, type=type, dig.lab=3, cols=col, breaks=breaks, breakby=breakby, sort=sort, reverse=reverse, border=border, ...)
				pop <- lab <- NULL
				if (isTRUE(popup[1])) pop <- popUp(x)
				if ((length(label)==1) && (isTRUE(label))) {
					lab <- v
				} else {
					lab <- getLabel(x, label)
				}
				
				if (g == "polygons") {
					map <- leaflet::addPolygons(map, data=x, label=lab, group=y, 
						fillColor=leg$main_cols, opacity=alpha[2], fillOpacity=alpha[1], 
						col=leg$main_cols, popup=pop, weight=lwd, dashArray=lty, ...)
				} else if (g == "lines") {
					map <- leaflet::addPolylines(map, data=x, label=lab, group=y, 
						col=leg$main_cols, popup=pop, opacity=alpha[1], weight=lwd, dashArray=lty, ...)
				} else {
					map <- leaflet::addCircleMarkers(map, data=x, label=lab, group=y, 
						weight=lwd, dashArray=lty, col=leg$main_cols, radius=cex, 
						popup=pop, fillOpacity=alpha[1], opacity=alpha[2], ...)
				}
				if (length(tiles) > 1) {
					map <- leaflet::addLayersControl(map, baseGroups = tiles, overlayGroups=y,
						options = leaflet::layersControlOptions(collapsed=collapse))
				} else {
					map <- leaflet::addLayersControl(map, overlayGroups = y, 
						options = leaflet::layersControlOptions(collapsed=collapse))
				}

			}
			if ((!is.null(legend)) && (!is.null(leg))) {
				if (leg$legend_type != "") {
					main <- gsub("\n", "</br>", main[1])
					op = ifelse(g == "polygons", alpha[1], 1)
					map <- leaflet::addLegend(map, position=legend, colors=leg$leg$fill, 
							labels=as.character(leg$leg$legend), opacity=op, title=main)
				}
			}
			map
		}
	}
)

setMethod("plet", signature(x="data.frame"),
	function(x, ...) {
		x <- suppressWarnings(vect(x, crs="lonlat"))
		if (inherits(x, "SpatVector")) plet(x, ...)
	}
)

setMethod("plet", signature(x="SpatVectorCollection"),
	function(x, y="", col, main=y, cex=1, lwd=2, lty=NULL, border="black", alpha=c(0.3, 1), popup=TRUE, label=FALSE, tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), wrap=TRUE, legend="bottomright", collapse=FALSE, type=NULL, breaks=NULL, breakby="eqint", sort=TRUE, reverse=FALSE, map=NULL, fill=NULL, ...)  {

		if (!is.null(fill)) { 
			warn("plet", "argument 'fill' will be removed. Use 'alpha' instead") 
			alpha[1] <- fill
		}

		#checkLeafLetVersion()

		if (is.null(map)) {
			tiles <- unique(as.character(tiles))
			tiles <- tiles[tiles!=""]
			map <- baselayers(tiles, wrap)
		} else {
			tiles <- NULL
		}
		nms <- names(x)
		nms[nchar(nms) == 0] <- "X"
		nms <- make.unique(nms)
		n <- length(x)

		if (missing(col)) {
			cols <- lapply(1:n, function(...) grDevices::rainbow)
		} else if (!is.list(col)) {
			cols <- lapply(1:n, function(...) col)
		} else {
			cols <- rep_len(col, n)
		}

		lwd <- rep_len(lwd, n) 
		if (is.null(lty)) lty <- ""
		lty <- rep_len(lty, n) 
		alpha <- pmax(0, pmin(1, rep_len(alpha, 2)))
		popup <- rep_len(popup, n) 
		label <- rep_len(label, n) 
		border <- rep_len(border, n) 
		cex <- rep_len(cex, n) 

		y <- c(y, rep("", n))[1:n]

		for (i in 1:n) {
			v <- x[i]
			v <- makelonlat(v)
			g <- geomtype(v)
			pop <- NULL
			lab <- NULL
			leg <- NULL
			if (popup[i]) {
				pop <- popUp(v)
			} 
			lab <- getLabel(x, label)
			if (y[i] == "") { # no legend
				icols <- .getCols(nrow(v), cols[[i]])
				if (g == "polygons") {
					map <- leaflet::addPolygons(map, data=v, weight=lwd[i], dashArray=lty[i], 
					fillColor=icols, fillOpacity=alpha[1], col=border[i], opacity=alpha[2], 
					popup=pop, label=lab, group=nms[i], ...)
				} else if (g == "lines") {
					map <- leaflet::addPolylines(map, data=v, weight=lwd[i], dashArray=lty[i], 
					opacity=alpha[1], col=icols, group=nms[i], popup=pop, label=lab, ...)
				} else {
					map <- leaflet::addCircleMarkers(map, data=v, radius=cex[i], popup=pop, label=lab, 
					fillOpacity=alpha[1], opacity=alpha[2], col=icols, group=nms[i], weight=lwd[i], dashArray=lty[i], ...)
				}
			} else {
		
				field <- y[i]
				if (is.numeric(field)) {
					field <- round(field)
					stopifnot((field > 0) && (field <= ncol(x[i])))
					field <- names(x[i])[field]
				}
				stopifnot(field %in% names(x[i]))
				xy <- x[i][field]
				vals <- values(xy)[,1]

				main <- rep_len(main, n) 
				legend <- rep_len(legend, n) 
				if (!is.null(type)) type <- rep_len(type, n)
				if (!is.null(breaks)) breaks <- rep_len(breaks, n)
				if (!is.null(breakby)) breakby <- rep_len(breakby, n)
				if (!is.null(sort)) sort <- rep_len(sort, n)
				if (!is.null(reverse)) reverse <- rep_len(reverse, n)

				split <- FALSE
				if (split) { 
					u <- unique(v)
					for (j in seq_along(u)) {
						s <- xy[v == u[j], ]
						pop <- lab <- NULL
						if (isTRUE(popup[1])) pop <- popUp(x[v == u[j], ])
						if (isTRUE(label[1])) lab <- u

						if (g == "polygons") {
							map <- leaflet::addPolygons(map, data=s, weight=lwd[i], dashArray=lty[i], 
								label=lab[j], group=u[j], fillColor=leg$main_cols, opacity=alpha[2], fillOpacity=alpha[1], col=border[i], popup=pop, ...)
						} else if (g == "lines") {
							map <- leaflet::addPolylines(map, data=s, weight=lwd[i], dashArray=lty[i],
								label=lab[j], group=u[j], col=leg$main_cols, popup=pop, 
								opacity=alpha[1], ...)
						} else {
							map <- leaflet::addCircleMarkers(map, data=s, label=lab[j], group=u[j], 
								col=leg$main_cols, radius=cex[i], popup=pop, 
								fillOpacity=alpha[1], opacity=alpha[2], weight=lwd[i], dashArray=lty[i], ...)
						}
					}
				} else { # do not split
					leg <- .get_leg(vals, type=type, dig.lab=3, cols=cols[[i]], breaks=breaks[i], breakby=breakby[i], sort=sort[i], reverse=reverse[i], ...)
					pop <- lab <- NULL
					if (isTRUE(popup[i])) pop <- popUp(x[i])
					if (isTRUE(label[i])) lab <- vals
					if (g == "polygons") {
						map <- leaflet::addPolygons(map, data=v, weight=lwd[i], dashArray=lty[i], 
							label=lab, group=nms[i], fillColor=leg$main_cols, opacity=alpha[2], fillOpacity=alpha[1], col=border[i], popup=pop, ...)
					} else if (g == "lines") {
						map <- leaflet::addPolylines(map, data=v, weight=lwd[i], dashArray=lty[i],
							label=lab, group=nms[i], col=leg$main_cols, popup=pop, opacity=alpha[1], ...)
					} else {
						map <- leaflet::addCircleMarkers(map, data=v, label=lab, group=nms[i], 
							col=leg$main_cols, radius=cex[i], popup=pop, fillOpacity=alpha[1], 
							opacity=alpha[2], weight=lwd[i], dashArray=lty[i], ...)
					}
					if ((!is.null(legend[i])) && (!is.null(leg))) {
						if (leg$legend_type != "") {
							main <- gsub("\n", "</br>", main[i])
							op = ifelse(g == "polygons", alpha[i], max(0.5, 1))
							map <- leaflet::addLegend(map, position=legend[i], colors=leg$leg$fill, 
									labels=as.character(leg$leg$legend), opacity=op, title=main[i])
						}
					}
				}
			}
		}
		if (length(tiles) > 1) {
			map <- leaflet::addLayersControl(map, baseGroups = tiles, overlayGroups = nms, 
				options = leaflet::layersControlOptions(collapsed=collapse))
		} else {
			map <- leaflet::addLayersControl(map, overlayGroups = nms, 
				options = leaflet::layersControlOptions(collapsed=collapse))
		}
		map
	}
)



setMethod("polys", signature(x="leaflet"),
	function(x, y, field="", col, lwd=2, lty=NULL, border="black", alpha=c(.3, 1), popup=TRUE, label=NULL, legend="bottomright", fill=NULL, ...)  {


		if (!is.null(fill)) { 
			warn("plet", "argument 'fill' will be removed. Use 'alpha' instead") 
			alpha[1] <- fill
		}

		label <- getLabel(x, label)

		alpha <- pmax(0, pmin(1, rep_len(alpha, 2)))

		if (inherits(y, "SpatVector")) {
			if (nrow(y) == 0) return(x)
			y <- makelonlat(y)
			if (geomtype(y) != "polygons") {
				error("polys", "SpatVector y must have polygons geometry")
			}
			leg <- NULL
			if (!is.null(field) && (field[1] != "")) {
				# color by the values of variable (column) "field" of y
				leg <- .cols_from_y(y, field, if (missing(col)) NULL else col, fname="polys")
				col <- leg$main_cols
			} else if (missing(col)) {
				col <- "black"
			}
			map <- leaflet::addPolygons(x, data=y, weight=lwd, dashArray=lty, fillColor=col, 
					fillOpacity=alpha[1], col=border, opacity=alpha[2], popup=popup, 
					label=label, ...)			
			if ((!is.null(leg)) && (!is.null(legend))) {
				map <- leaflet::addLegend(map, position=legend, colors=leg$leg$fill, 
						labels=as.character(leg$leg$legend), opacity=alpha[1], title=field)
			}
			map
		} else if (inherits(y, "SpatVectorCollection")) {
			nms <- names(y)
			n <- length(y)
			nms[nchar(nms) == 0] <- "X"
			nms <- make.unique(nms)
			if (missing(col)) col <- "black"
			if (is.function(col)) {
				cols <- col(n)
			} else {
				cols <- rep_len(col, n) 
			}	
			lwd <- rep_len(lwd, n) 
			if (is.null(lty)) lty <- ""
			lty <- rep_len(lty, n) 
			border <- rep_len(border, n) 
			popup <- rep_len(popup, n) 
			if (!is.null(label)) label <- rep_len(label, n)

			for (i in 1:length(nms)) {
				x <- leaflet::addPolygons(x, data=y[i], weight=lwd[i], dashArray=lty[i], fillColor=cols[i], 
					fillOpacity=alpha[1], col=border[i], opacity=alpha[2], popup=popup[i], 
					label=label[i], group=nms[i], ...)			
			}
			collapse=FALSE
			leaflet::addLayersControl(x, overlayGroups = nms, options = leaflet::layersControlOptions(collapsed=collapse))
		} else {
			error("plet", "y should be a SpatVector or SpatVectorCollection")
		}	
	}
)


setMethod("lines", signature(x="leaflet"),
	function(x, y, field="", col, lwd=2, lty=NULL, alpha=1, label=NULL, popup=FALSE, legend="bottomright", ...)  {

		alpha <- max(0, min(1, alpha))
		if (popup) {
			popup=popUp(y)
		} else {
			popup <- NULL
		}		
		label <- getLabel(x, label)

		if (inherits(y, "SpatVector")) {
			if (nrow(y) == 0) return(x)
			y <- makelonlat(y)
			if (!(geomtype(y) %in% c("lines", "polygons"))) {
				error("lines", "SpatVector y must have either lines or polygons geometry")
			}
			leg <- NULL
			if (!is.null(field) && (field[1] != "")) {
				# color by the values of variable (column) "field" of y
				leg <- .cols_from_y(y, field, if (missing(col)) NULL else col, fname="lines")
				col <- leg$main_cols
			} else if (missing(col)) {
				col <- "black"
			}
			map <- leaflet::addPolylines(x, data=y, weight=lwd, dashArray=lty, popup=popup, label=label,
					opacity=alpha, col=col, ...)
			if ((!is.null(leg)) && (!is.null(legend))) {
				map <- leaflet::addLegend(map, position=legend, colors=leg$leg$fill, 
						labels=as.character(leg$leg$legend), opacity=alpha, title=field)
			}
			map
		} else if (inherits(y, "SpatVectorCollection")) {
			nms <- names(y)
			n <- length(y)
			nms[nchar(nms) == 0] <- "X"
			nms <- make.unique(nms)
			if (missing(col)) col <- "black"
			if (is.function(col)) {
				cols <- col(n)
			} else {
				cols <- rep_len(col, n) 
			}
			lwd <- rep_len(lwd, n) 
			if (is.null(lty)) lty <- ""
			lty <- rep_len(lty, n) 
			for (i in 1:length(nms)) {
				x <- leaflet::addPolylines(x, data=y[i], weight=lwd[i], dashArray=lty[i], 
						opacity=alpha, col=cols[i], group=nms[i], ...)
			}
			collapse=FALSE
			leaflet::addLayersControl(x, overlayGroups = nms, options = leaflet::layersControlOptions(collapsed=collapse))
		} else {
			error("plet", "y should be a SpatVector or SpatVectorCollection")
		}	
	}
)


setMethod("points", signature(x="leaflet"),
	function(x, y, field="", col, border=col, cex=1, lwd=2, lty=NULL, alpha=c(.3, 1), label=1:nrow(y), popup=FALSE, legend="bottomright", ...)  {
		stopifnot(inherits(y, "SpatVector"))
		if (nrow(y) == 0) return(x)
		y <- makelonlat(y)
		if (!(geomtype(y) == "points")) {
			if (geomtype(y) == "polygons") {
				y <- centroids(y)
			} else {
				y <- as.points(y)
			}
		}
		if (popup) {
			popup=popUp(y)
		} else {
			popup <- NULL
		}
		leg <- NULL
		if (!is.null(field) && (field[1] != "")) {
			# color by the values of variable (column) "field" of y
			leg <- .cols_from_y(y, field, if (missing(col)) NULL else col, fname="points")
			col <- leg$main_cols
			if (missing(border)) border <- col
		} else if (missing(col)) {
			col <- "black"
			if (missing(border)) border <- col
		}
		cols <- .getCols(nrow(y), col)
		borders <- .getCols(nrow(y), border)
		alpha <- pmax(0, pmin(1, rep_len(alpha, 2)))
		label <- getLabel(x, label)

		map <- leaflet::addCircleMarkers(x, data=y, radius=cex, popup=popup, label=label, 
			opacity=alpha[2], fillColor=cols, fillOpacity=alpha[1], col=borders, weight=lwd, 
			dashArray=lty, ...)
		if ((!is.null(leg)) && (!is.null(legend))) {
			map <- leaflet::addLegend(map, position=legend, colors=leg$leg$fill, 
					labels=as.character(leg$leg$legend), opacity=1, title=field)
		}
		map
		
		#i <- which(sapply(x$x$calls, function(i) i$method) == "addLayersControl")
		#x$x$calls[[2]]
		#group <- y@pntr$layer
		#if (group == "") group <- geomtype(y)
	}
)




make.panel <- function(x, maxcell) {

	nl <- nlyr(x)
	x <- spatSample(x, maxcell/nl, "regular", as.raster=TRUE, warn=FALSE)
	if (is.lonlat(x)) {
		asp <- 1/cos((mean(ext(x)[3:4]) * pi)/180)
	} else {
		asp <- 1
	} 
	crs(x, warn=FALSE) <- "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +wktext +no_defs"
	ext(x) = c(0,1,0,asp)
	#if (!is.null(add)) {
	#	e <- as.vector(ext(x))
	#	for (i in 1:length(add)) {
	#		v <- project(v, crs(x))
	#		add[i] <- rescale(v, fx=1/diff(e[1:2]), fy=1/diff(e[3:4]))
	#	}
	#}

	asp <- asp * nrow(x) / ncol(x)
	nc <- ceiling(2*sqrt(nl/2) * asp)
	nr <- ceiling(nl / nc)
	nc <- ceiling(nl / nr)

	e <- as.vector(ext(x))
	r <- res(x)
	skiprow <- -asp - max(1, min(10, trunc(nrow(x)/20))) *r[2]
	skipcol <- 1 + max(1, min(10, trunc(ncol(x)/20))) *r[1]
#	skipcol <- 1 + max(r[1], min(10, r[1] * trunc(nrow(x)/20)))
	labs <- data.frame(x=0, y=0, label=names(x))
	rw = cl = 0
	y <- vector(mode="list", length=nl)
	off <- 0 #.4 / nr
	for (i in 1:nl) {
		y[[i]] <- shift(x[[i]], cl * skipcol, rw * skiprow)
		e <- as.vector(ext(y[[i]]))
		labs[i,1:2] <- c(mean(e[1:2]), e[4]-off)
		cl <- cl + 1
		if (cl == nc) {
			cl <- 0
			rw <- rw + 1
		}
	}
	labs <- vect(labs, geom=c("x", "y"), crs=crs(x))
	labs <- project(labs, "+proj=longlat")
	x <- merge(sprc(y))
	list(x, labs)
}


.get_cls <- function(x, type="", dig.lab=3, cols, breaks=NULL, breakby="eqint", sort=TRUE, reverse=FALSE,  ...) {

	if (is.null(type) ||(type == "")) {
		if (all(is.factor(x)) || all(is.bool(x))) {
			type <- "classes"		
		} else if (is.null(breaks)) {
			type <- "continuous"
		} else {
			type <- "interval"
		}
	} else {
		type <- match.arg(type, c("continuous", "interval", "classes"))
	}
	if ((type == "interval") && (is.null(breaks))) {
		
	}
	if (type == "continuous") {
		if (inherits(cols, "function")) {
			if (is.null(attr(cols, "colorType"))) {
				cols <- cols(100)
			}
		}
		return(list(type=type, x=x, cols=cols))
	}
	if (type == "classes") {
		if (!is.factor(x)) {
			uv <- unique(values(x))
			uv <- sort(uv)
			uv <- uv[!is.na(uv)]
			levels(x) <- data.frame(ID=as.numeric(uv), value=uv)
		} else {
			uv <- levels(x)[[1]][,2]
		}
		ncols <- length(uv)
	} else {
		if (is.null(breaks)) breaks <- 5
		if (length(breaks) == 1) {
			breaks <- .get_breaks(values(x), n=breaks, breakby, r=NULL)
		}
		x <- classify(x, breaks)
		ncols <- length(breaks)-1
	}

	if (inherits(cols, "function")) {
		cols <- cols(ncols)
	} else {
		cols <- grDevices::colorRampPalette(cols)(ncols)		
	}
	return(list(type=type, x=x, cols=cols))

#	out$legend_type <- type
#	out$uv <- unique(v)
}



setMethod("plet", signature(x="SpatRaster"),
	function(x, y=1, col, alpha=0.8, main=names(x), tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), 
		wrap=TRUE, maxcell=500000, stretch=NULL, legend="bottomright", shared=FALSE, panel=FALSE, 
		collapse=TRUE, type=NULL, breaks=NULL, breakby="eqint", range=NULL, fill_range=FALSE, hover=FALSE, map=NULL, ...)  {

		#checkLeafLetVersion()
		
		if (is.na(crs(x)) | (grepl("^Cartesian", .name_or_proj4(x)))) {
			tiles <- ""
			e <- ext(x)
			rx <- diff(e[1:2])
			ry <- diff(e[3:4])
			m <- max(rx, ry)
			ext(x) <- c(0, rx/m, 0, ry/m)
			crs(x) <- "EPSG:3857"
			notmerc <- FALSE
		} else {
			notmerc <- isTRUE(crs(x, describe=TRUE)$code != "3857")
		}

#		if (!is.null(add)) {
#			if (inherits(add, "SpatVector")) {
#				add <- svc(makelonlat(add))
#			} else if (inherits(add, "SpatVectorCollection")) {
#				for (i in 1:length(add)) {
#					add[i] <- makelonlat(add[i])
#				}
#			} else {
#				error("plet", "add should be a SpatVector or a SpatVectorCollection")
#			}
#		}

		alpha <- max(0, min(1, alpha))
		
		hasRGB <- has.RGB(x)

		if (hasRGB) {
			y <- RGB(x)
			legend <- NULL		
		}
		# else if (!is.null(terra::coltab(x)[[1]])) {
		#	legend <- NULL		
		#}
		
		e <- ext(x)
		if (is.lonlat(x) && ((e$ymin < -85) || (e$ymax > 85))) {
			yr1 <- e$ymax - e$ymin
			e$ymin <- max(e$ymin, -85)
			e$ymax <- min(e$ymax, 85)
			yr2 <- e$ymax - e$ymin
			x <- spatSample(x[[y]], (yr1/yr2) * maxcell, "regular", as.raster=TRUE, warn=FALSE)
			x <- crop(x, e) 
		}
		
		if (panel) {
			tiles <- NULL
			p <- make.panel(x, maxcell) #, add)
			x <- p[[1]]
			p <- p[[2]]
			add <- p[[3]]
			main <- ""
		} else {
			x <- spatSample(x[[y]], maxcell, "regular", as.raster=TRUE, warn=FALSE)
		}

		if (is.null(map)) {
			tiles <- unique(as.character(tiles))
			tiles <- tiles[tiles!=""]
			if (length(tiles) > 1) {
				tiles <- tiles[1]
				#warn("plet", "only a single tileset can be used with raster data")
			}
			map <- baselayers(tiles, wrap)
		} else {
			tiles <- NULL
		}
		hover_data <- NULL
		if (isTRUE(hover) && !panel && !hasRGB) {
			hover_r <- if (is.lonlat(x)) x else project(x, "EPSG:4326", method="near")
			hover_e <- unname(as.vector(ext(hover_r)))
			hover_layers <- lapply(1:nlyr(hover_r), function(i) {
				v <- values(hover_r[[i]], mat=FALSE)
				if (is.factor(hover_r[[i]])) {
					levs <- levels(hover_r[[i]])[[1]]
					idx <- match(v, levs[,1])
					v <- levs[idx, 2]
				}
				v[is.nan(v)] <- NA
				list(name=names(hover_r)[i], values=as.list(v),
				     nrow=nrow(hover_r), ncol=ncol(hover_r))
			})
			hover_data <- list(layers=hover_layers, extent=hover_e)
		}

		if (missing(col)) {
			if (has.colors(x)[1]) {
				col <- coltab(x)[[1]][,-1]
				col <- rgb(col[,1], col[,2], col[,3], col[,4], maxColorValue=255)
			} else {
				col <- .default.pal()
			}
			#col <- rev(grDevices::terrain.colors(255))
		}

		main <- gsub("\n", "</br>", main)
		if (length(main) != length(y)) {
			main <- rep_len(main, length(x))[y]
		}

		if (hasRGB) {
			if (!is.null(stretch)) {
				if (stretch == "lin") {
					x <- stretch(x, minq=0.02, maxq=0.98)
				} else {
					x <- stretch(x, histeq=TRUE, scale=255)
				}
			}
			RGB(x) <- 1:length(y)
			x <- colorize(x, "col")
		} else {
			leg <- .get_cls(x, type=type, dig.lab=3, cols=col, breaks=breaks, breakby=breakby, ...)
			x <- leg$x
			col <- leg$cols
		}
		
		if (nlyr(x) == 1) {
			if (leg$type == "continuous") {
				if (!all(hasMinMax(x))) setMinMax(x)
				if ((inherits(col, "function")) && (!is.null(attr(col, "colorType")))) {
					pal <- col
					range <- environment(pal)$rng
				} else {
					v <- minmax(x)
					if (is.null(range)) {
						range <- c(v[1], v[2])
					} else if (fill_range) {
						x <- clamp(x, range[1], range[2], values=TRUE)
					}
					pal <- leaflet::colorNumeric(col, range, na.color=NA)
				}
				map <- leaflet::addRasterImage(map, x, colors=pal, opacity=alpha, project=notmerc)
				if (!is.null(legend)) {
					environment(pal)$reverse <- TRUE
					map <- leaflet::addLegend(map, legend, pal=pal, values=range, opacity=1, title=main[1],
					  labFormat = leaflet::labelFormat(transform = function(x) sort(x, decreasing = TRUE)))
				}
			} else {
				map <- leaflet::addRasterImage(map, x, colors=col, opacity=alpha, project=notmerc)
				if (!is.null(legend)) {
					map <- leaflet::addLegend(map, position=legend, colors=col, 
							labels=levels(x)[[1]][,2], opacity=alpha, title=main)
				}
			}
			if (panel) {
				#map <- leaflet::addCircleMarkers(map, data=p, label=p$label, radius=1, opacity=1, col="red")
				map <- leaflet::addLabelOnlyMarkers(map, label=p$label, data=p, 
                      labelOptions = leaflet::labelOptions(noHide = TRUE, textOnly = TRUE))
			}
		} else {
			nms <- make.unique(names(x))
			many_legends <- one_legend <- FALSE
			if (!all(hasMinMax(x))) setMinMax(x)
			r <- minmax(x)
			hasColFun <- FALSE
			if ((inherits(col, "function")) && (!is.null(attr(col, "colorType")))) {
				hasColFun <- TRUE
				#shared <- TRUE
			}
			if (shared) {
				#rr <- range(r)
				if (hasColFun) {
					pal <- col
					range <- environment(col)$rng
				} else {
					r <- minmax(x)
					if (is.null(range)) {
						range <- range(r)
					} else if (fill_range) {
						x <- clamp(x, range[1], range[2], values=TRUE)
					}
					pal <- leaflet::colorNumeric(col, range, na.color=NA)
				}
				v <- seq(range[1], range[2], length.out=5)
				one_legend <- TRUE
			} else {
				many_legends <- TRUE
			}
			add_legend <- !is.null(legend)
			
			for (i in 1:nlyr(x)) {
				if (one_legend) {
					map <- leaflet::addRasterImage(map, x[[i]], colors=pal, opacity=alpha, group=nms[i], project=notmerc)
				} else {
					if (hasColFun) {
						pal <- col
						range <- environment(col)$rng
					} else {
						if (is.null(range)) {
							range <- minmax(x)
						} else if (fill_range) {
							x[[i]] <- clamp(x[[i]], range[1,i], range[2,i], values=TRUE)
						}
						pal <- leaflet::colorNumeric(col, range[,i], na.color=NA)
					}
					map <- leaflet::addRasterImage(map, x[[i]], colors=pal, opacity=alpha, group=nms[i], project=notmerc)
					if (add_legend) {
						environment(pal)$reverse <- TRUE
						v <- seq(range[1,i], range[2,i], length.out=5)
						map <- leaflet::addLegend(map, position=legend, pal=pal, values=v, 
							  title=main[i], opacity=1, group=nms[i],
							  labFormat = leaflet::labelFormat(transform = function(x) sort(x, decreasing = TRUE)))
					}
				}
			}
			map <- leaflet::addLayersControl(map, baseGroups=nms,
				options = leaflet::layersControlOptions(collapsed=collapse))
			if (many_legends && add_legend) {	# show one legend at a time
				map <- htmlwidgets::onRender(map, 
					"function(el, x) {
						var updateLegend = function () {
						var selectedGroup = document.querySelectorAll('input:checked')[0].nextSibling.innerText.substr(1);
						document.querySelectorAll('.legend').forEach(a => a.hidden=true);
						document.querySelectorAll('.legend').forEach(l => {
							if (l.children[0].children[0].innerText == selectedGroup) l.hidden=false;
						});
					};
					updateLegend();
					this.on('baselayerchange', e => updateLegend());}")
			} else if (one_legend && add_legend) {
				environment(pal)$reverse <- TRUE
				map <- leaflet::addLegend(map, position=legend, pal=pal, values=v, opacity=1, group=nms[i],
						  labFormat = leaflet::labelFormat(transform = function(x) sort(x, decreasing = TRUE)))
			}
		}
		if (!is.null(hover_data)) {
			map <- htmlwidgets::onRender(map,
"function(el, x, data) {
	var map = this;
	var tip = L.DomUtil.create('div', 'raster-hover-tip');
	tip.style.cssText = 'position:absolute;background:rgba(255,255,255,0.92);padding:4px 8px;border-radius:3px;font:12px/1.4 sans-serif;pointer-events:none;z-index:9999;display:none;box-shadow:0 1px 3px rgba(0,0,0,0.3);white-space:nowrap;';
	el.style.position = 'relative';
	el.appendChild(tip);
	var layers = data.layers;
	var ext = data.extent;
	var active = 0;
	map.on('mousemove', function(e) {
		var lng = e.latlng.lng, lat = e.latlng.lat;
		if (lng < ext[0] || lng > ext[1] || lat < ext[2] || lat > ext[3]) {
			tip.style.display = 'none'; return;
		}
		var lay = layers[active];
		var col = Math.floor((lng - ext[0]) / (ext[1] - ext[0]) * lay.ncol);
		var row = Math.floor((ext[3] - lat) / (ext[3] - ext[2]) * lay.nrow);
		if (row < 0 || row >= lay.nrow || col < 0 || col >= lay.ncol) {
			tip.style.display = 'none'; return;
		}
		var val = lay.values[row * lay.ncol + col];
		if (val === null) { tip.style.display = 'none'; return; }
		var txt = (typeof val === 'number') ? (+val.toPrecision(6)).toString() : val;
		tip.innerHTML = '<b>' + lay.name + '</b>: ' + txt;
		tip.style.display = 'block';
		tip.style.left = (e.containerPoint.x + 15) + 'px';
		tip.style.top = (e.containerPoint.y - 25) + 'px';
	});
	map.on('mouseout', function() { tip.style.display = 'none'; });
	map.on('baselayerchange', function(e) {
		for (var i = 0; i < layers.length; i++) {
			if (layers[i].name === e.name) { active = i; break; }
		}
	});
}", data=hover_data)
		}
		map
	}
)



setMethod("plet", signature(x="SpatRasterCollection"),
	function(x, col, alpha=0.8, main=names(x), tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), 
		wrap=TRUE, maxcell=500000, stretch=NULL, legend="bottomright",  
		type=NULL, breaks=NULL, breakby="eqint", range=NULL, fill_range=FALSE, map=NULL, ...)  {

		if (is.null(range)) {
			mnmx <- sapply(x, function(r) minmax(r, compute=TRUE)[,1])
			range <- c(min(mnmx[1,]), max(mnmx[2,]))
		}

		
		r <- x[1][[1]]
		map <- plet(r, 1, col=col, alpha=alpha, main=names(r), tiles=tiles, wrap=wrap, maxcell=maxcell, stretch=stretch, 
			legend=legend, shared=FALSE, panel=FALSE, collapse=TRUE, type=type, breaks=breaks, breakby=breakby, 
			range=range, fill_range=fill_range, map=NULL)
		
		if (length(x) == 1) return(map)
		
		for (i in 2:length(x)) {
			r <- x[i][[1]]
			map <- plet(r, 1, col=col, alpha=alpha, main=names(r), tiles=NULL, wrap=wrap, 
				maxcell=maxcell, stretch=stretch, legend=NULL, shared=FALSE, panel=FALSE,
				collapse=TRUE, type=type, breaks=breaks, breakby=breakby, range=range, 
				fill_range=fill_range, map=map)
		}
		map
	}
)

RS_locator <- function(n, type, id=FALSE, pch=20, ...) {
# locator that also works in RStudio
# Berry Boessenkool
# https://stackoverflow.com/a/65147220/635245
	on.exit(return(cbind(x, y)))
	x <- y <- NULL
	for (i in seq_len(n)) {
		p <- graphics::locator(1)
		if (is.null(p)) break # ESC
		x <- c(x, p$x)
		y <- c(y, p$y)
		points(x, y, type=type, pch=pch, ...)
		if (id) {
			text(p$x, p$y, labels=i, pos=4, ...)
		}
	}
}

.drawPol <- function(n=1000, id=FALSE, ...) {
	#xy <- graphics::locator(n=1000, type="l", col=col, lwd=lwd, ...)
	#xy <- cbind(xy$x, xy$y)
	xy <- RS_locator(n, "l", id=id, ...)
	xy <- rbind(xy, xy[1,])
	graphics::lines(xy[(length(xy[,1])-1):length(xy[,1]),], ...)
	g <- cbind(1,1,xy,0)
	vect(g, "polygons")
}


.drawLin <- function(n=1000, ...) {
	#xy <- graphics::locator(n=1000, type="l", col=col, lwd=lwd, ...)
	#xy <- cbind(xy$x, xy$y)
	xy <- RS_locator(n, "l", ...)
	g <- cbind(1,1,xy)
	vect(g, "lines")
}


.drawPts <- function(n=1000, ...) {
	#xy <- graphics::locator(n=1000, type="p", col=col, lwd=lwd, ...)
	#xy <- cbind(xy$x, xy$y)
	xy <- RS_locator(n, "p", ...)
	g <- cbind(1:nrow(xy), 1, xy)
	vect(g, "points")
}

.drawExt <- function(...) {
	loc1 <- graphics::locator(n=1, type="p", pch="+", ...)
	loc2 <- graphics::locator(n=1, type="p", pch="+", ...)
	loc <- rbind(unlist(loc1), unlist(loc2))
	e <- c(min(loc[,'x']), max(loc[,'x']), min(loc[,'y']), max(loc[,'y']))
	if (e[1] == e[2]) {
		e[1] <- e[1] - 0.0000001
		e[2] <- e[2] + 0.0000001
	}
	if (e[3] == e[4]) {
		e[3] <- e[3] - 0.0000001
		e[4] <- e[4] + 0.0000001
	}
	p <- rbind(c(e[1], e[3]), c(e[1], e[4]), c(e[2], e[4]), c(e[2], e[3]), c(e[1], e[3]) )
	graphics::lines(p, ...)
	return(ext(e))
}

setMethod("draw", signature(x="character"),
    function(x="extent", col="red", lwd=2, id=FALSE, n=1000, xpd=TRUE, ...){
		RStudio_warning()

		x <- match.arg(tolower(x), c("extent", "polygon", "lines", "points"))
		if (x == "extent") {
			.drawExt(col=col, lwd=lwd, xpd=xpd, ...)
		} else if (x == "polygon") {
			.drawPol(n, col=col, lwd=lwd, id=id, xpd=xpd, ...)
		} else if (x == "lines") {
			.drawLin(n, col=col, lwd=lwd, id=id, xpd=xpd, ...)
		} else if (x == "points" || x == "multipoints" ) {
			.drawPts(n, col=col, id=id, xpd=xpd, ...)
		}
	}
)

setMethod("draw", signature(x="missing"),
    function(x="extent", ...){
		RStudio_warning()
		draw("extent", ...)
	}
)

# Author: Robert J. Hijmans
# Date : December 2025
# Version 1.0
# License GPL v3


setMethod("chunk", signature(x="SpatRaster"),
	function(x, fun, ..., n=NULL, buffer=0, filename="", wopt=list()) {

		if (is.null(n)) {
			m <- mem_info(x, n=6, print=FALSE)
			m <- data.frame(t(m))
			m <- pmax(2, round(m$needed / m$available))
			n <- pmax(1, round(max(dim(x)) / m))
		}
		g <- getTileExtents(x, n, extend=FALSE, buffer=buffer)

		buf <- FALSE
		if (all(buffer > 0)) {
			be <- rep(res(x) * buffer, each=2)
			buf <- TRUE
		}

		x <- deepcopy(x)
		tmpdir <- tempfile()
		dir.create(tmpdir, FALSE, FALSE)
		tmpf <- file.path(tmpdir, paste0("tmp", 1:nrow(g), ".tif"))
		rlst <- vector(mode="list", nrow(g))

		nodots <- length(list(...)) == 0

		for (i in 1:nrow(g)) {
			window(x) <- g[i,]
			if (nodots) {
				r <- fun(x)
			} else {
				r <- fun(x, ...)			
			}
			if (buf) {
				rlst[[i]] <- crop(r, ext(r) - be, filename=tmpf[i])	
			} else {
				rlst[[i]] <- writeRaster(r, tmpf[i])
			}
		}
		s <- sprc(rlst)
		m <- merge(s, filename=filename, wopt=wopt)
		try(file.remove(tmpf), silent=TRUE)
		m
	}
)

# Authors: Robert J. Hijmans
# Date :  October 2018
# Version 1.0
# License GPL v3

positive_indices <- function(i, n, na.rm=TRUE, caller="`[`") {
	i <- stats::na.omit(i)
	if (!is.logical(i)) {
		stopifnot(is.numeric(i))
		if (!(all(i <= 0) || all(i >= 0))) {
			error(caller, "you cannot mix positive and negative indices")
		}
	}
	i <- (1:n)[i]
	if (na.rm) {
		i[!is.na(i)]
	} else {
		i
	}
}


setMethod("subset", signature(x="SpatRaster"),
	function(x, subset, negate=FALSE, NSE=FALSE, filename="", overwrite=FALSE, ...) {
		if (NSE) {
			subset <- if (missing(subset)) {
				1:nlyr(x)
			} else {
				nl <- as.list(seq_along(names(x)))
				names(nl) <- nms <- names(x)
				v <- eval(substitute(subset), nl, parent.frame())
				if (!inherits(substitute(subset), "character")) {
					if (sum(nms %in% nms[v]) > length(v)) {
						warn("subset", "using a name that is not unique")
					}
				}
				v
			}
		}
		if (is.character(subset)) {
			nms <- names(x)
			if (!all(subset %in% nms)) {
				error("subset", "invalid name(s)")
			}
			if (sum(nms %in% subset) > length(subset)) {
				warn("subset", "using a name that is not unique")
			}
			subset <- unlist(lapply(subset, function(s) which(nms == s)), use.names = FALSE)
		}
		if (any(is.na(subset))) {
			error("subset", "undefined layer(s) selected")
		}
		if (negate) subset = -subset
		subset <- positive_indices(subset, nlyr(x), TRUE, "subset")
		opt <- spatOptions(filename, overwrite, ...)
		x@pntr <- x@pntr$subset(subset-1, opt)
		messages(x, "subset")
	}
)


## exact matching
setMethod("$", "SpatRaster",
	function(x, name) {
		if ((nlyr(x) == 1) && is.factor(x)) {
			factnms <- names(cats(x)[[1]])
			i <- match(name, factnms[-1])
			if (!is.na(i)) {
				activeCat(x) <- i		
				return(x)
			}
		}
		subset(x, name, NSE=FALSE)
	}
)

setMethod("[[", c("SpatRaster", "character","missing"),
function(x, i, j) {
	subset(x, i, NSE=FALSE)
})


setMethod("[[", c("SpatRaster", "logical", "missing"),
function(x, i, j) {
	subset(x, which(i), NSE=FALSE)
})


setMethod("[[", c("SpatRaster", "numeric", "missing"),
function(x, i, j) {
	subset(x, i, NSE=FALSE)
})


setMethod("[[", c("SpatRaster", "ANY", "missing"),
function(x, i, j) {
	i <- as.vector(unlist(i))
	x[[i]]
})



setMethod("subset", signature(x="SpatVector"),
	function(x, subset, select, drop=FALSE, NSE=FALSE) {
		
 		if (NSE) {
			d <- as.list(x)
			# from the subset<data.frame> method
			r <- if (missing(subset)) {
					TRUE
				} else {
					e <- substitute(subset)
					# r <- eval(e, d, parent.frame())
					# for #1600
					r <- eval(e, d, globalenv())
					if (!is.logical(r)) error("subset", "argument 'subset' must be logical")
					r & !is.na(r)
				}
			v <- if (missing(select)) {
					TRUE
				} else {
					nl <- as.list(seq_along(d))
					names(nl) <- names(d)
					# eval(substitute(select), nl, parent.frame())
					eval(substitute(select), nl, globalenv())
				}
			x <- x[r, v, drop=drop]
		} else {
			if (missing(subset)) subset <- TRUE
			spatcls <- isTRUE(substr(class(subset)[1], 1, 4) == "Spat")
			if (spatcls) {
				x <- x[subset]
				if (!missing(select)) {
					x <- x[, select, drop=drop]
				}
			} else if (missing(select)) {
				x <- x[(as.vector(subset)), drop=drop]
			} else {
				x <- x[(as.vector(subset)), select, drop=drop]
			}
		}
		#g <- gc()
		x
	}
)


.subset_cols <- function(x, subset, drop=FALSE) {
	if (is.character(subset)) {
		i <- stats::na.omit(match(subset, names(x)))
		if (length(i)==0) {
			error("subset", "no valid variable name found")
		} else if (length(i) < length(subset)) {
			warn("subset", "invalid variable name(s) excluded")
		}
	} else {
		i <- positive_indices(subset, ncol(x), TRUE, "subset")
		if (length(i)==0) {
			i <- 0
		}
	}
	x@pntr <- x@pntr$subset_cols(i-1)
	x <- messages(x, "subset")
	if (drop) {	# drop geometry
		.getSpatDF(x@pntr$df)
	} else {
		x
	}
}


setMethod("[", c("SpatVector", "numeric", "missing"),
function(x, i, j, ... , drop=FALSE) {
	i <- positive_indices(i, nrow(x), TRUE, "`[`")
	x@pntr <- x@pntr$subset_rows(i-1)
	x <- messages(x, "[")
	if (drop) {
		as.data.frame(x)
	} else {
		x
	}
})

setMethod("[", c("SpatVector", "numeric", "logical"),
function(x, i, j, drop=FALSE) {
	j <- which(rep_len(j, ncol(x)))
	x[i, j, drop=drop]
})


setMethod("[", c("SpatVector", "logical", "missing"),
function(x, i, j, drop=FALSE) {
	i <- which(rep_len(i, nrow(x)))
	x@pntr <- x@pntr$subset_rows(i-1)
	x <- messages(x, "[")
	if (drop) {
		as.data.frame(x)
	} else {
		x
	}
})

setMethod("[", c("SpatVector", "numeric", "numeric"),
function(x, i, j, drop=FALSE) {
	i <- positive_indices(i, nrow(x), TRUE, "`[`")
	j <- positive_indices(j, ncol(x), TRUE, "`[`")
	p <- x@pntr$subset_rows(i-1)
	x@pntr <- p$subset_cols(j-1)
	x <- messages(x, "'['")
	if (drop) {
		as.data.frame(x)
	} else {
		x
	}
})


setMethod("[", c("SpatVector", "missing", "numeric"),
function(x, i, j, drop=FALSE) {
	j <- positive_indices(j, ncol(x), TRUE, "`[`")
	x@pntr <- x@pntr$subset_cols(j-1)
	x <- messages(x, "[")
	if (drop) {
		as.data.frame(x)
	} else {
		x
	}
})

setMethod("[", c("SpatVector", "missing", "character"),
function(x, i, j, drop=FALSE) {
	if (j[1] == "") {
		jj <- 0
	} else {
		jj <- match(j, names(x))
		if (any(is.na(jj))) {
			mis <- paste(j[is.na(jj)], collapse=", ")
			error(" x[,j] ", paste("name(s) not in x:", mis))
		}
		if (length(jj) == 0) {
			jj <- 0
		}
	}
	x[,jj,drop=drop]
})

setMethod("[", c("SpatVector", "missing", "logical"),
function(x, i, j, drop=FALSE) {
	j <- which(rep_len(j, ncol(x)))
	x[,j,drop=drop]
})


setMethod("[", c("SpatVector", "numeric", "character"),
function(x, i, j, drop=FALSE) {
	j <- stats::na.omit(match(j, names(x)))
	if (length(j) == 0) j <- 0
	x <- x[i,j,drop=drop]
})

setMethod("[", c("SpatVector", "logical", "character"),
function(x, i, j, drop=FALSE) {
	i <- which(rep_len(i, nrow(x)))
	x[i,j,drop=drop]
})


setMethod("[", c("SpatVector", "logical", "numeric"),
function(x, i, j, drop=FALSE) {
	i <- which(rep_len(i, nrow(x)))
	x[i,j,drop=drop]
})

setMethod("[", c("SpatVector", "logical", "logical"),
function(x, i, j, drop=FALSE) {
	i <- which(rep_len(i, nrow(x)))
	j <- which(rep_len(j, ncol(x)))
	x[i,j,drop=drop]
})


setMethod("[", c("SpatVector", "missing", "missing"),
function(x, i, j,  drop=FALSE) {
	if (drop) {
		values(x)
	} else {
		x
	}
})


setMethod("[", c("SpatVector", "matrix", "missing"),
function(x, i, j, drop=FALSE) {
	if (ncol(i) > 1) warn("`[`", "using the first column of i to subset x")
	x[i[,1]]
})

setMethod("[", c("SpatVector", "data.frame", "missing"),
function(x, i, j, drop=FALSE) {
	if (ncol(i) > 1) warn("`[`", "using the first column of i to subset x")
	x[i[,1]]
})


setMethod("[", c("SpatVector", "data.frame", "ANY"),
function(x, i, j, drop=FALSE) {
	x <- x[i[,1], j]
})

setMethod("[", c("SpatVector", "character", "missing"),
function(x, i, j, ... , drop=FALSE) {
	x[, i]
})

setClass("GCP",
	representation (
		gcp = "matrix"
	),
	prototype (
		gcp = cbind(fx=0, fy=0, tx=0, ty=0)[0,]
	)
)



setMethod("show", signature(object="GCP"),
	function(object) {
		m <- object@gcp
		show(m)
		if (!is.null(grDevices::dev.list())) {
			for (i in 1:nrow(m)) {
				graphics::arrows(m[i,1], m[i,2], x1 = m[i,3], y1 = m[i,4], col="red", length = 0.1)
			}
		}
	}
)


#setMethod("add<-", signature(x="GCP"),
#	function(x, value) {
#		if (missing(value)) {
#			value <- terra:::RS_locator(2, "l")
#			value <- rbind(as.vector(t(value)))
#		}
#		if (ncol(value) == 4) {
#			x@gcp <- rbind(x@gcp, value)
#		}
#		if (!is.null(grDevices::dev.list())) {
#			graphics::arrows(value[1,1], value[1,2], x1 = value[1,3], y1 = value[1,4], col="red", length = 0.1)
#		}
#		x
#	}
#)


#gcp <- new("GCP")
#gcp <- addGCP(gcp)

#setMethod("row.names", signature(x="SpatVector"),
#	function(x) {
#		1:nrow(x)
#	}
#)

setMethod("emptyGeoms", signature(x="SpatVector"),
	function(x) {
		x@pntr$nullGeoms() + 1
	}
)


setMethod("as.vector", signature(x="SpatVector"),
	function(x, mode="any") {
		if (nrow(x) > 0) {
			lapply(1:nrow(x), function(i) x[i,])
		} else {
			x
		}
	}
)

setMethod("vect", signature(x="missing"),
	function(x) {
		p <- methods::new("SpatVector")
		p@pntr <- SpatVector$new()
		messages(p, "vect")
	}
)

setMethod("vect", signature(x="SpatExtent"),
	function(x, crs="") {
		as.polygons(x, crs=crs)
	}
)

setMethod("vect", signature(x="SpatVectorCollection"),
	function(x) {
		vect(as.list(x))
	}
)


setMethod("vect", signature(x="SpatGraticule"),
	function(x) {
		v <- vect()
		v@pntr <- x@pntr
		v
	}
)


# Remote files may need  "/vsicurl/" and "/vsizip/" 
.vect_vsify <- function(x) {
	x <- enc2utf8(trimws(x[1]))
	if (grepl("^/vsizip/", x)) {
		inner <- sub("^/vsizip/+", "", x)
		if (grepl("^(https?|ftp)://", inner, ignore.case=TRUE) && !grepl("^vsicurl/", inner, ignore.case=TRUE)) {
			return(paste0("/vsizip//vsicurl/", inner))
		}
		return(x)
	}
	if (grepl("^(https?|ftp)://", x, ignore.case=TRUE) && grepl("\\.(kml|kmz)$", x, ignore.case=TRUE)) {
		return(paste0("/vsicurl/", x))
	}
	x
}

setMethod("vect", signature(x="character"),
	function(x, layer="", query="", dialect="", extent=NULL, filter=NULL, crs="", proxy=FALSE, what="", opts=NULL, kml.extended=NULL) {

		what <- trimws(tolower(what))
		if (what != "") what <- match.arg(trimws(tolower(what)), c("geoms", "attributes"))

		s <- substr(x[1], 1, 5)
		if (s %in% c("POINT", "MULTI", "LINES", "POLYG", "EMPTY")) {
			p <- methods::new("SpatVector")
	#		if (all(grepl("\\(", x) & grepl("\\)", x))) {
			p@pntr <- SpatVector$new(gsub("\n", "", x))
			messages(p, "vect")
			crs(p, warn=FALSE) <- crs
			return(p)
		} 

		if (substr(x[1], 1, 1) == "{") { # json
			if (length(x) > 1) x <- paste(x, collapse="")
		} else {			
			x <- x[1]
			nx <- try(normalizePath(x, mustWork=TRUE), silent=TRUE)
			if (!inherits(nx, "try-error")) { # skip html
				x <- nx
				if (grepl("\\.rds$", tolower(x))) {
					v <- unwrap(readRDS(x))
					if (!inherits(v, "SpatVector")) {
						error("vect", "the rds file does not store a SpatVector")
					}
					return(v)
				}
			} else if ((substr(x, 1, 4) == "http") & (grepl("\\.shp$", x) | grepl("\\.gpkg$", x))) {
				x <- paste0("/vsicurl/", x[1])
			}
			x <- .vect_vsify(x)
		}
		
		p <- methods::new("SpatVector")
		p@pntr <- SpatVector$new()
		proxy <- isTRUE(proxy)
			if ((what=="attributes") && proxy) {
			error("vect", "you cannot use 'what==attributes' when proxy=TRUE")
		}
		#if (proxy) query <- ""
		if (is.null(filter)) {
			filter <- SpatVector$new()
		} else {
			if (!inherits(filter, "SpatVector")) {
				error("vect", "'filter' must be a SpatVector")			
			}
			if (proxy) {
				error("vect", "you cannot use 'filter' when proxy=TRUE")
			}
			filter <- filter@pntr
		}
		if (is.null(extent)) {
			extent <- double()
		} else {
			extent <- as.vector(ext(extent))
		}
		if (is.null(opts)) opts <- ""[0]
		p@pntr$read(x, layer, query, extent, filter, proxy, what, dialect, opts)
		if (isTRUE(crs != "")) {
			crs(p, warn=FALSE) <- crs
		}
		if (proxy) {
			messages(p, "vect")
			pp <- methods::new("SpatVectorProxy")
			pp@pntr <- SpatVectorProxy$new()
			pp@pntr$v <- p@pntr
			return(pp)
		}
		p <- messages(p, "vect")
		p <- .vect_kml_merge_extended(p, x, kml.extended, proxy, what)
		if (what == "attributes") {
			p <- values(p)
		}
		p
	}
)


setMethod("vect", signature(x="Spatial"),
	function(x) {
		methods::as(x, "SpatVector")
	}
)

setMethod("vect", signature(x="sf"),
	function(x) {
		methods::as(x, "SpatVector")
	}
)

setMethod("vect", signature(x="sfc"),
	function(x) {
		methods::as(x, "SpatVector")
	}
)

setMethod("vect", signature(x="XY"), #sfg
	function(x) {
		methods::as(x, "SpatVector")
	}
)



.checkXYnames <- function(x, warn=FALSE) {
	if (is.null(x)) return(TRUE)
	if (length(x) != 2) {
		error("vect", "coordinate matrix should have 2 columns")
	}
	z <- tolower(x[1:2])
	x <- substr(z, 1, 3)
	y <- substr(x, 1, 1)
	if ((y[1] == "x") && (y[2] == "y")) return(FALSE)
	if ((x[1] == "eas") && (x[2] == "nor")) return(FALSE)
	if ((x[1] == "lon") && (x[2] == "lat")) return(TRUE)
	if (grepl("lon", z[1]) && grepl("lat", z[2])) return(TRUE)

	if ((x[1] == "lat") && (x[2] == "lon")) {
		stop("vect", "longitude/latitude in the wrong order")
	} else if ((y[1] == "y") && (y[2] == "x")) {
		stop("vect", "x/y in the wrong order")
	} else if ((x[1] == "nor") && (x[2] == "eas")) {
		stop("vect", "easting/northing in the wrong order")
	} else if (warn) {
		warn("coordinate names not recognized. Expecting lon/lat, x/y, or easting/northing")
	}
	return(FALSE)
}

setMethod("vect", signature(x="matrix"),
	function(x, type="points", atts=NULL, crs="") {
		type <- tolower(type)
		type <- match.arg(tolower(type), c("points", "lines", "polygons"))
		stopifnot(NCOL(x) > 1)
		stopifnot(NCOL(x) < 7)

		crs <- character_crs(crs, "vect")
		p <- methods::new("SpatVector")
		p@pntr <- SpatVector$new()
		crs(p, warn=FALSE) <- crs

		nr <- nrow(x)
		if (nr == 0) {
			return(p)
		}
		nc <- ncol(x)
		z0 <- double(0)
		if (nc == 2) {
			lonlat <- .checkXYnames(colnames(x))
			if (type == "points") {
				p@pntr$setPointsXY(as.double(x[,1]), as.double(x[,2]))
			} else {
				p@pntr$setGeometry(type, rep(1, nr), rep(1, nr), x[,1], x[,2], rep(FALSE, nr), z0)
			}
			if (lonlat && isTRUE(crs=="")) crs <- "+proj=longlat"
		} else if (nc == 3) {
			p@pntr$setGeometry(type, x[,1], rep(1, nr), x[,2], x[,3], rep(FALSE, nr), z0)
		} else if (nc == 4) {
			p@pntr$setGeometry(type, x[,1], x[,2], x[,3], x[,4], rep(FALSE, nr), z0)
		} else if (nc == 5) {
			p@pntr$setGeometry(type, x[,1], x[,2], x[,3], x[,4], x[,5], z0)
		} else if (nc == 6) {
			# geom, part, x, y, hole, z (from geom() when has.z)
			p@pntr$setGeometry(type, x[,1], x[,2], x[,3], x[,4], x[,5], as.double(x[,6]))
		} else {
			error("vect", "not an appropriate matrix (too many columns)")
		}
		if (!is.null(atts)) {
			if ((nrow(atts) == nrow(p)) & (ncol(atts) > 0)) {
				values(p) <- atts
			}
		}
		messages(p, "vect")
	}
)


setMethod("$", "SpatVector",  function(x, name) {
	if (!(name %in% names(x))) {
		return(NULL)
		#error("$", paste(name, "is not a variable name in x"))
	}
	s <- .subset_cols(x, name, drop=TRUE)
	s[,1,drop=TRUE]
})


setMethod("[[", c("SpatVector", "numeric", "missing"),
function(x, i, j,drop=FALSE) {
	s <- .subset_cols(x, i, drop=TRUE)
	s[,,drop=drop]
})


setMethod("[[", c("SpatVector", "character", "missing"),
function(x, i, j, drop=FALSE) {
	if (!(any(i %in% names(x)))) {
		return(NULL)
	}
	s <- .subset_cols(x, i, drop=TRUE)
	s[,,drop=drop]
})



setReplaceMethod("[", c("SpatVector", "ANY", "ANY"),
	function(x, i, j, value) {
		v <- values(x)
		v[i,j] <- value
		if (nrow(v) != nrow(x)) {
			error("[<-", "this would create an invalid SpatVector")
		}
		values(x) <- v
		x
	}
)

setReplaceMethod("[", c("SpatVector", "ANY", "missing"),
	function(x, i, j, value) {
		v <- values(x)
		if (inherits(value, "SpatVector")) {
			value <- values(value)
		}
		v[i,] <- value
		if (nrow(v) != nrow(x)) {
			error("[<-", "this would create an invalid SpatVector")
		}
		values(x) <- v
		x
	}
)

setReplaceMethod("[", c("SpatVector", "missing", "ANY"),
	function(x, i, j, value) {
		v <- values(x)
		if (inherits(value, "SpatVector")) {
			value <- values(value)
		}
		v[,j] <- value
		if (nrow(v) != nrow(x)) {
			error("[<-", "this would create an invalid SpatVector")
		}
		values(x) <- v
		x
	}
)


setReplaceMethod("[[", c("SpatVector", "character"),
	function(x, i, value) {

		x@pntr <- x@pntr$deepcopy()
		if (is.null(value)) {
			for (name in i) {
				if (name %in% names(x)) {
					x@pntr$remove_column(name)
				}
			}
			return(x);
		} else if (length(value) == 0) {
			if (nrow(x) == 0) {
				d <- values(x)
				for (name in i) {
					d[[name]] <- value
				}
				values(x) <- d
				return(x)
			} else {
				values(x) <- NA
				#error("[[<-,SpatVector", "cannot use an empty value")
				return(x)
			}
		}
		if (inherits(value, "data.frame")) {
			if (ncol(value)	> 1) {
				warn("`[[<-`", "only using the first column")
			}
			value <- value[,1]
		} else if (inherits(value, "list")) {
			value <- sapply(value, function(x) if (is.null(x)) NA else x)
		}

		if (NCOL(value)	> 1) {
			warn("[[<-,SpatVector", "only using the first column")
			value <- value[,1]
		}
		name <- i[1]

		nr <- nrow(x)
		if (length(value) > nr) {
			error("$<-", paste("replacement has", length(value), "rows, data has", nr))
		}
		if ((nr %% length(value)) != 0) {
			warn("$<-", "replacement is not a multiple of the number of rows")
		}
		value <- rep(value, length.out=nrow(x))

		if (name %in% names(x)) {
			d <- values(x)
			if (all(is.na(value))) {
				#[] to keep type if NA is used
				d[[name]][] <- value
			} else {
				d[[name]] <- value			
			}
			values(x) <- d
		} else {
			if (inherits(value, "factor")) {
				v <- .makeSpatFactor(value)
				ok <- x@pntr$add_column_factor(v, name)
			} else if (inherits(value, "character")) {
				ok <- x@pntr$add_column_string(enc2utf8(value), name)
			} else if (inherits(value, "integer")) {
				# min long (should query what it is on the system?)
				value[is.na(value)] <- -2147483648
				ok <- x@pntr$add_column_long(value, name)
			} else if (inherits(value, "logical")) {
				v <- as.integer(value)
				v[is.na(v)] <- 2
				ok <- x@pntr$add_column_bool(v, name)
			} else if (inherits(value, "numeric")) {
				ok <- x@pntr$add_column_double(value, name)
			} else if (inherits(value, "Date")) {
				ok <- x@pntr$add_column_time(as.numeric(as.POSIXlt(value)), name, "days", "")
			} else if (inherits(value, "POSIXt")) {
				tz <- if (length(value) > 0) { attr(value[1], "tzone") } else { "" }
				if (is.null(tz)) tz <- ""
				ok <- x@pntr$add_column_time(as.numeric(value), name, "seconds", tz)
			} else {
				v <- try(as.character(value))
				if (!inherits(v, "try-error")) {
					ok <- x@pntr$add_column_string(enc2utf8(v), name)
				} else {
					ok <- FALSE
				}
			}
			if (!ok) {
				error("[[<-,SpatVector", "cannot add these values")
			}
		}
		x
	}
)


setReplaceMethod("[[", c("SpatVector", "numeric"),
	function(x, i, value) {
		stopifnot(i > 0 && i <= ncol(x))
		vn <- names(x)[i]
		x[[vn]] <- value
		x
	}
)



setMethod("$<-", "SpatVector",
	function(x, name, value) {
		x[[name]] <- value
		x
	}
)




setMethod("vect", signature(x="data.frame"),
	function(x, geom=NULL, crs=NULL, keepgeom=FALSE, quiet=FALSE) {
		
		guessed_geom <- FALSE; lonlat <- FALSE
		if (!is.null(geom)) {
			if (!all(geom %in% names(x))) {
				error("vect", "the variable name(s) in argument `geom` are not in `x`")
			}
		} else {
			if (all(c("lon", "lat") %in% names(x))) { 
				# backwards compatibility
				geom <- c("lon", "lat")
				# guessed_geom <- TRUE	
			} else {
				if (ncol(x) <= 2) { 
					geom <- names(x)				
				} else {
					nms <- tolower(names(x))
					m <- rbind(	match(c("longitude", "latitude"), nms),
                                match(c("decimallongitude", "decimallatitude"), nms),
								match(c("long", "lati"), nms),
								match(c("long", "lat"), nms),								
                                match(c("lon", "lat"), nms),
                                match(c("location.lon", "location.lat"), nms),
                                match(c("location.long", "location.lat"), nms),
                                match(c("location.longitude", "location.latitude"), nms),
                                match(c("location_lon", "location_lat"), nms),
                                match(c("location_long", "location_lat"), nms),
                                match(c("location_longitude", "location_latitude"), nms),
                                match(c("location-lon", "location-lat"), nms),
                                match(c("location-long", "location-lat"), nms),
                                match(c("location-longitude", "location-latitude"), nms),
								match(c("easting", "northing"), nms),
								match(c("xcoord", "ycoord"), nms),
                                match(c("x.coord", "y.coord"), nms),
                                match(c("x_coord", "y_coord"), nms),
                                match(c("x", "y"), nms))
					test <- !apply(is.na(m), 1, any) 
					if (sum(test) == 1) {
						m <- m[test, ]
						geom <- names(x)[m]
						lonlat <- which(test) < 6
					} else if (sum(test) == 0) {
						lon <- which(sapply(nms, function(n) grepl(n, "longitude")))
						lat <- which(sapply(nms, function(n) grepl(n, "latitude")))
						if ((length(lon) == 0) && (length(lat) == 0)) {
							lon <- which(sapply(nms, function(n) grepl(n, "lon")))
							lat <- which(sapply(nms, function(n) grepl(n, "lat")))
						}
						if ((length(lon) == 1) && (length(lat) == 1)) {
							geom <- names(x)[c(lon, lat)]
							lonlat <- TRUE
						} 
					} 
					if (is.null(geom) && (ncol(x) == 2) && all(sapply(x, is.numeric))) { 
						geom <- names(x)
					}
					guessed_geom <- TRUE
				}
			}
			if (is.null(geom)) {
				error("vect", "geom=NULL and no unique lon/lat or x/y variable name pairs detected")
			}
		}
		
		guessed_crs <- FALSE
		if (is.null(crs)) {
			crs <- ""
			if ((guessed_geom && lonlat) || ((!guessed_geom) && grepl("lon", geom[1]) && grepl("lat", geom[2]))) {
				xr <- range(x[,geom[1]], na.rm=TRUE)
				yr <- range(x[,geom[2]], na.rm=TRUE)
				if ((xr[1] > -181) && (xr[2] < 361)  && (yr[1] > -90.01) && (yr[2] < 90.01)) {
					guessed_crs <- TRUE
					crs <- "+proj=longlat"
				}
			}
		} else {
			crs <- character_crs(crs, "vect")
		}
		if (length(geom) == 2) {
			geom <- match(geom[1:2], names(x))
			if (inherits(x[,geom[1]], "integer")) {
				x[,geom[1]] <- as.numeric(x[,geom[1]])
			}
			if (inherits(x[,geom[2]], "integer")) {
				x[,geom[2]] <- as.numeric(x[,geom[2]])
			}
			p <- methods::new("SpatVector")
			p@pntr <- terra:::SpatVector$new()
			x <- terra:::.makeSpatDF(x)

			p@pntr$setPointsDF(x, geom-1, crs, keepgeom)

			p <- messages(p, "vect")
			if (!quiet) {
				if (guessed_geom & guessed_crs) {
					warn("vect", "guessed geom variables and crs")
				} else if (guessed_geom) {
					warn("vect", "guessed geom variables")
				} else if (guessed_crs) {
					warn("vect", "guessed crs")
				}			
			}
			return(p)
		} else if (length(geom) == 1) {
			v <- vect(unlist(x[,geom]), crs=crs)
			if (!keepgeom) {
				x[[geom]] <- NULL
			}
		} else {
			error("vect", "the length of 'geom' must be 1 or 2")
		}
		values(v) <- x
		v
	}
)

setMethod("vect", signature(x="list"),
	function(x, type="points", crs="") {
	
		v <- methods::new("SpatVector")
		if (inherits(x[[1]], "raw")) {
			v@pntr <- SpatVector$new()
			v@pntr$addWKB(x)
		} else {
			x <- lapply(x, function(i) {
				if (inherits(i, "SpatVector")) return(i)
				vect(i, type=type)
			})
			x <- svc(x)
			v@pntr <- x@pntr$append()
		}
		if (crs != "") {
			crs(v) <- crs
		}
		messages(v, "vect")
	}
)




setMethod("query", signature(x="SpatVectorProxy"),
	function(x, start=1, n=nrow(x), vars=NULL, where=NULL, extent=NULL, filter=NULL, sql=NULL, dialect="", what="") {
		f <- x@pntr$v$source
		slayer <- x@pntr$v$layer
		#1058
		layer <- paste0("\"", slayer, "\"")

		e <- x@pntr$v$read_extent
		if (is.null(extent)) {
			if (length(e) == 4) {
				extent = ext(e);
			}
		} else {
			if (length(e) == 4) {
				extent = intersect(ext(e), extent);
				if (is.null(extent)) {
					error("query", "extent does not intersect with x")
				}
			}
		}
		if (is.null(vars)) {
			vars <- "*"
		} else {
			vars <- stats::na.omit(unique(vars))
			nms <- names(x)
			if (!all(vars %in% nms)) {
				error("query", "not all vars are variable names")
			} else if (length(vars) < length(nms))  {
				vars <- paste(vars, collapse=", ")
			}
		}

		if (!is.null(sql)) {
			qy <- as.character(sql)
		
		} else {
			qy <- ""
			if (!is.null(where)) {
				qy <- paste("SELECT", vars, "FROM", layer, "WHERE", where[1])
			} else {
				qy <- paste("SELECT", vars, "FROM", layer)
			}
			nr <- nrow(x)
			start <- start-1
			if (start > 0) {
				if (n >= (nr-start)) {
					qy <- paste(qy, "OFFSET", format(start, scientific=FALSE))
				} else {
					n <- min(n, nr-start)
					qy <- paste(qy, layer, "LIMIT", n, "OFFSET", format(start, scientific=FALSE))
				}
			} else if (n < nr) {
				n <- min(n, nr)
				qy <- paste(qy, "LIMIT", n)
			}
		}
		
		if (qy != "") {
			if (x@pntr$v$read_query != "") {
				error("query", "A query was used to create 'x'; you can only subset it with extent or filter")
			}
		} else {
			layer <- slayer
		}

		p <- vect(f, layer, query=qy, extent=extent, filter=filter, crs="", FALSE, what=what, dialect=dialect)
		if (what == "attributes") {
			p <- values(p)
		}
		p
	}
)


vector_layers <- function(filename, delete="", return_error=FALSE) {
	p <- SpatVector$new()
	if (any(delete != "")) {
		delete <- trimws(delete)
		ok <- p$delete_layers(filename, delete, return_error[1])
		messages(p, "vector_layers")
		invisible(ok)
	} else {
		out <- p$layer_names(filename)
		messages(p, "vector_layers")
		out
	}
}

# Author: Robert J. Hijmans
# Date : July 2019
# Version 1.0
# License GPL v3



setMethod("buffer", signature(x="SpatRaster"),
	function(x, width, background=0, include=TRUE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$buffer(width, background, include, opt)
		messages(x, "buffer")
	}
)


#setMethod("nearest", signature(x="SpatRaster"),
#	function(x, target=NA, exclude=NULL, unit="m", method="haversine", filename="", ...) {
#
#		if (!(method %in% c("geo", "haversine", "cosine"))) {
#			error("nearest", "not a valid method. Should be one of: 'geo', 'haversine', 'cosine'")
#		}
#		opt <- spatOptions(filename, ...)
#		target <- as.numeric(target[1])
#		keepNA <- FALSE
#		if (!is.null(exclude)) {
#			exclude <- as.numeric(exclude[1])
#			if ((is.na(exclude) && is.na(target)) || isTRUE(exclude == target)) {
#				error("nearest", "'target' and 'exclude' must be different") 
#			}
#			if (is.na(exclude)) {
#				keepNA <- TRUE
#			}
#		} else {
#			exclude <- NA
#		}
#		x@pntr <- x@pntr$nearest(target, exclude, keepNA, tolower(unit), TRUE, method, opt)
#		messages(x, "nearest")
#	}
#
#)


setMethod("distance", signature(x="SpatRaster", y="missing"), 
	function(x, y, target=NA, exclude=NULL, unit="m", method="haversine", maxdist=NA, values=FALSE, filename="", ...) {

		method <- match.arg(tolower(method), c("cosine", "haversine", "geo"))
		opt <- spatOptions(filename, ...)
		target <- as.numeric(target[1])
		keepNA <- FALSE
		if (!is.null(exclude)) {
			exclude <- as.numeric(exclude[1])
			if ((is.na(exclude) && is.na(target)) || isTRUE(exclude == target)) {
				error("distance", "'target' and 'exclude' must be different") 
			}
			if (is.na(exclude)) {
				keepNA <- TRUE
			}
		} else {
			exclude <- NA
		}
		x@pntr <- x@pntr$rastDistance(target, exclude, keepNA, tolower(unit), TRUE, method, isTRUE(values), maxdist, opt)	
		messages(x, "distance")
	}
)


setMethod("costDist", signature(x="SpatRaster"),
	function(x, target=0, scale=1, maxiter=50, nearest=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		maxiter <- max(maxiter[1], 2)
		x@pntr <- x@pntr$costDistance(target[1], scale[1], maxiter, FALSE, isTRUE(nearest), opt)
		messages(x, "costDist")
	}
)


setMethod("gridDist", signature(x="SpatRaster"),
	function(x, target=0, scale=1, maxiter=50, nearest=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		if (is.na(target)) {
			x@pntr <- x@pntr$gridDistance(scale[1]	, opt)
		} else {
			maxiter <- max(maxiter[1], 2)
			x@pntr <- x@pntr$costDistance(target[1], scale[1], maxiter, TRUE, isTRUE(nearest), opt)
		}
		messages(x, "gridDist")
	}
)


setMethod("distance", signature(x="SpatRaster", y="SpatVector"),
	function(x, y, unit="m", rasterize=FALSE, method="haversine", filename="", ...) {
		opt <- spatOptions(filename, ...)
		unit <- as.character(unit[1])
		method <- match.arg(tolower(method), c("cosine", "haversine", "geo"))
		x@pntr <- x@pntr$vectDistance(y@pntr, rasterize, unit, method, opt)
		messages(x, "distance")
	}
)


setMethod("distance", signature(x="SpatRaster", y="sf"),
	function(x, y, unit="m", rasterize=FALSE, method="cosine", filename="", ...) {
		distance(x, vect(y), unit=unit, rasterize=rasterize, method=method, filename=filename, ...) 
	}
)


mat2wide <- function(m, sym=TRUE, keep=NULL) {
	if (inherits(m, "dist")) {
		# sym must be true in this case
		nr <- attr(m, "Size")
		x <- rep(1:(nr-1), (nr-1):1)
		y <- unlist(sapply(2:nr, function(i) i:nr))
		cbind(x,y, as.vector(m))
	} else {
		bool <- is.logical(m)
		if (sym) {
			m[lower.tri(m)] <- NA
		}
		m <- cbind(from=rep(1:nrow(m), each=ncol(m)), to=rep(1:ncol(m), nrow(m)), value=as.vector(t(m)))
		m <- m[!is.na(m[,3]), , drop=FALSE]
		if (!is.null(keep)) {
			m <- m[m[,3] == keep, 1:2, drop=FALSE]
		}
		m
	}
}

setMethod("furdist", signature(x="SpatVector", y="SpatVector"),
	function(x, y, pairwise=FALSE, unit="m") {
		opt <- spatOptions()	 
		out <- x@pntr$furthest_distance(y@pntr, pairwise, unit, opt)
		messages(x, "furdist")
		if (pairwise) {
			out[[1]]
		} else {
			data.frame(from=out[[1]]+1, to=out[[2]]+1, distance=out[[3]])
		}
	}
)

setMethod("distance", signature(x="SpatVector", y="ANY"),
	function(x, y, sequential=FALSE, pairs=FALSE, symmetrical=TRUE, unit="m", method="haversine", use_nodes=FALSE, names=NULL) {
		if (!missing(y)) {
			error("distance", "If 'x' is a SpatVector, 'y' should be a SpatVector or missing")
		}
		method <- match.arg(tolower(method), c("cosine", "haversine", "geo"))
		opt <- spatOptions()	 
		d <- x@pntr$distance_self(sequential, unit, method, use_nodes[1], opt)		
		messages(x, "distance")
		if (sequential) {
			return(d)
		}
		class(d) <- "dist"
		attr(d, "Size") <- nrow(x)
		attr(d, "Diag") <- FALSE
		attr(d, "Upper") <- FALSE
		attr(d, "method") <- "spatial"
		if (!is.null(names)) {
			if (inherits(names, "character") && (length(names) == 1)) {
				names <- x[[names, drop=TRUE]]
			}
			if (length(names) == nrow(x)) {
				attr(d, "Labels") <- names
			}
		}
		if (pairs) {
			d <- as.matrix(d)
			diag(d) <- NA
			d <- mat2wide(d, symmetrical)
		}
		d
	}
)


setMethod("distance", signature(x="SpatVector", y="SpatVector"),
	function(x, y, pairwise=FALSE, unit="m", method = "haversine", use_nodes=FALSE, names=NULL) {
		unit <- as.character(unit[1])
		method <- match.arg(tolower(method), c("cosine", "haversine", "geo"))
		opt <- spatOptions()
		d <- x@pntr$distance_other(y@pntr, pairwise, unit, method, use_nodes[1], opt)
		messages(x, "distance")
		if (!pairwise) {
			d <- matrix(d, nrow=nrow(x), ncol=nrow(y), byrow=TRUE)
			if ((!is.null(names)) && (length(names)<=2)) {
				names <- rep(names, length.out=2)
				if (inherits(names[1], "character")) {
					rownames(d) <- x[[names[1], drop=TRUE]]
				}
				if (inherits(names[2], "character")) {
					colnames(d) <- y[[names[2], drop=TRUE]]
				}
			}
		}
		d
	}
)

test.for.lonlat <- function(xy) {
	x <- range(xy[,1], na.rm=TRUE)
	y <- range(xy[,2], na.rm=TRUE)
	x[1] >= -180 && x[2] <= 180 && y[1] > -90 && y[2] < 90
}

setMethod("distance", signature(x="matrix", y="matrix"),
	function(x, y, lonlat, pairwise=FALSE, unit="m", method="geo") {
		if (missing(lonlat)) {
			lonlat <- test.for.lonlat(x) & test.for.lonlat(y)
			warn("distance", paste0("lonlat not set. Assuming lonlat=", lonlat))
		}
		stopifnot(ncol(x) == 2)
		stopifnot(ncol(y) == 2)
		v <- vect()
		stopifnot(unit %in% c("m", "km"))
		m <- ifelse(unit == "m", 1, 0.001)
		d <- v@pntr$point_distance(x[,1], x[,2], y[,1], y[,2], pairwise[1], m, lonlat, method=method)
		messages(v)
		if (pairwise) {
			d
		} else {
			matrix(d, nrow=nrow(x), ncol=nrow(y), byrow=TRUE)
		}
	}
)

setMethod("distance", signature(x="data.frame", y="data.frame"),
	function(x, y, lonlat, pairwise=FALSE, unit="m", method="geo") {
		distance(as.matrix(x), as.matrix(y), lonlat, pairwise=pairwise, unit=unit, method=method)
	}
)


setMethod("distance", signature(x="matrix", y="missing"),
	function(x, y, lonlat=NULL, sequential=FALSE, pairs=FALSE, symmetrical=TRUE, unit="m", method="geo") {

		if (missing(lonlat)) {
			lonlat <- test.for.lonlat(x) 
			warn("distance", paste0("lonlat not set. Assuming lonlat=", lonlat))
		}

		crs <- ifelse(isTRUE(lonlat), "+proj=longlat +datum=WGS84", "+proj=utm +zone=1 +datum=WGS84")
		x <- vect(x, crs=crs)
		distance(x, sequential=sequential, pairs=pairs, symmetrical=symmetrical, unit=unit, method=method)
	}
)

setMethod("distance", signature(x="data.frame", y="missing"),
	function(x, y, lonlat=NULL, sequential=FALSE, pairs=FALSE, symmetrical=TRUE, unit="m", method="geo") {
		distance(as.matrix(x), lonlat=lonlat, sequential=sequential, pairs=pairs, symmetrical=symmetrical, unit=unit, method=method)
	}
)


setMethod("thin", signature(x="SpatVector"),
	function(x, d, unit="m") {
		opt <- spatOptions()
		x@pntr <- x@pntr$thin_geoms(d, unit, opt)
		messages(x, "thin")
	}
)


setMethod("direction", signature(x="SpatRaster"),
	function(x, from=FALSE, degrees=FALSE, method="cosine", filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$rastDirection(from[1], degrees[1], NA, NA, method, opt)
		messages(x, "direction")
	}
)




match_abs <- function(x, y, ...) {
	d <- colMeans(abs(y - x), ...)
	which.min(d)[1]
}

match_sqr <- function(x, y, ...) {
	d <- colMeans((y - x)^2, ...)
	which.min(d)[1]
}



setMethod("bestMatch", signature(x="SpatRaster", y="matrix"),
	function(x, y, labels=NULL, fun="squared", ..., filename="", overwrite=FALSE, wopt=list()) {
		
		if (!(all(colnames(y) %in% names(x)) && (all(names(x) %in% colnames(y))))) {
			error("bestMatch", "names of x and y must match")
		}
		
		if (inherits(fun, "character")) {
			fun <- match.arg(tolower(fun), c("abs", "squared"))
			if (fun == "abs") {
				f <- match_abs
			} else {
				f <- match_sqr
			}	
			out <- app(x, f, y=t(y), ...)
		} else {
			out <- app(x, fun, y=t(y), ...)
		}

		if (!is.null(labels)) {
			levels(out) <- data.frame(ID=1:nrow(y), label=labels)
		}
		if (filename!="") {
			out <- writeRaster(out, filename, wopt=wopt)
		}
		out
	}
)


setMethod("bestMatch", signature(x="SpatRaster", y="SpatVector"),
	function(x, y, labels=NULL, fun="squared", ..., filename="", overwrite=FALSE, wopt=list()) {
		y <- as.matrix(extract(x, y, fun="mean", ..., na.rm=TRUE, ID=FALSE))
		bestMatch(x, y, labels=labels, fun=fun, filename=filename, ...)
	}
)

setMethod("bestMatch", signature(x="SpatRaster", y="data.frame"),
	function(x, y, labels=NULL, fun="squared", ..., filename="", overwrite=FALSE, wopt=list()) {
		
		if (!(all(names(y) %in% names(x)) && (all(names(x) %in% names(y))))) {
			error("bestMatch", "names of x and y must match")
		}
#		y <- y[, names(x), drop=FALSE]
		i <- unique(sapply(y, class))
		if (any(i != "numeric")) {
			error("bestMatch", "all values in y must be numeric")
		}
		y <- as.matrix(y)
		bestMatch(x, y, labels=labels, fun=fun, filename=filename, ...)
	}
)

# Author: Robert J. Hijmans
# Date : May 2019
# Version 1.0
# License GPL v3

setMethod("ifel", signature(test="SpatRaster"),
	function(test, yes, no, filename="", ...) {
		no_num <- FALSE
		yes_num <- FALSE
		if (!inherits(no, "SpatRaster")) {
			# logical includes default NA
			if (!(is.numeric(no) || is.logical(no))) {
				error("ifel", "argument 'no' must be a SpatRaster, numeric or logical")
			}
			if (length(no) > 1) warn("ifel", 'only the first element of "no" is used')
			no <- no[1]
			no_num <- TRUE
		}
		if (!inherits(yes, "SpatRaster")) {
			if (!(is.numeric(yes) || is.logical(yes))) {
				error("ifel", "argument 'yes' must be a SpatRaster, numeric or logical")
			}
			if (length(yes) > 1) warn("ifel", 'only the first element of "yes" is used')
			yes <- yes[1]
			yes_num <- TRUE
		}

		test <- as.logical(test)

		if (no_num & yes_num) {
			return (classify(test, rbind(c(1, yes), c(0, no)), filename=filename, ...))
		}

		if (no_num) {
			no <- classify(test, rbind(c(0, no), c(1, NA)))
		} else {
			no <- mask(no, test, maskvalues=c(NA, TRUE))
		}

		if (yes_num) {
			yes <- classify(test, rbind(c(1, yes), c(0, NA)))
		} else {
			yes <- mask(yes, test, maskvalues=c(NA, FALSE))
		}
		cover(no, yes, values=NA, filename=filename, ...)
	}
)

# Author: Robert J. Hijmans
# Date :  May 2019
# Version 1.0
# License GPL v3


setMethod("init", signature(x="SpatRaster"),
	function(x, fun, ..., filename="", overwrite=FALSE, wopt=list()) {
		x <- rast(x)
		if (is.character(fun)) {
			opt <- spatOptions(filename, overwrite=overwrite, wopt=wopt)
			x <- rast(x, 1)
			fun <- fun[1]
			if (fun %in% c("x", "y", "xy", "row", "col", "cell", "chess")) {
				x@pntr <- x@pntr$initf(fun, TRUE, opt)
				messages(x, "init")
			} else if (is.na(fun)) {
				x@pntr <- x@pntr$initv(as.numeric(NA), opt)
				messages(x, "init")
			} else {
				error("init", "unknown function")
			}
		} else if (is.numeric(fun) || is.logical(fun)) {
			if (is.matrix(fun) && (ncol(fun) == ncol(x))) {
				fun <- as.vector(t(fun))
			}
			opt <- spatOptions(filename, overwrite=overwrite, wopt=wopt)
			x@pntr <- x@pntr$initv(fun, opt)
			messages(x, "init")
		} else {
			nc <- ncol(x) * nlyr(x)
			b <- writeStart(x, filename, sources=sources(x), wopt=wopt)
			for (i in 1:b$n) {
				n <- b$nrows[i] * nc;
				r <- fun(n, ...)
				if (length(r) != n) {
					error("init","the number of values returned by 'fun' is not correct")
				}
				writeValues(x, r, b$row[i], b$nrows[i])
			}
			writeStop(x)
		}
	}
)

# Robert Hijmans
# Date : Nov 2021
# Version 1.0
# Licence GPL v3

# Computation of the weighted covariance and (optionally) weighted means of bands in an Raster.
# based on code for "raster" by Jonathan Greenberg and Robert Hijmans
# partly based on code by Mort Canty



setMethod("layerCor", signature(x="SpatRaster"),
	function(x, fun, w, asSample=TRUE, use="everything", maxcell=Inf, ...) {

		ops <- c("everything", "complete.obs", "pairwise.complete.obs", "masked.complete")

		# backwards compatibility 
		na.rm <- list(...)$na.rm
		if (isTRUE(na.rm) && (use == "everything")) {
			use <- "pairwise.complete.obs"
		} 

		use <- match.arg(use, ops)
		if (use != "everything") {
			na.rm <- TRUE
		} else {
			na.rm <- FALSE			
		}

		stopifnot(is.logical(asSample) & !is.na(asSample))
		
		nl <- nlyr(x)
		if (nl < 2) {
			error("layerCor", "x must have at least 2 layers")
		}
		
		if (inherits(fun, "character")) {
			fun <- tolower(fun)
			if (fun == "pearson") fun = "cor"
			if (!(fun %in% c("cov", "weighted.cov", "cor"))) {
				error("layerCor", "character function names must be one of: 'cor', 'cov', or 'weighted.cov'")
			}
			# backwards compatibility
			if (fun == "weighted.cov") {
				if (missing(w))	{
					error("layerCor", "to compute weighted covariance a weights layer should be provided")
				}
				stopifnot( nlyr(w) == 1 )
				x <- c(w, x)
			}
		} else {
			FUN <- fun
			fun <- ""
		}
		
		if (maxcell < ncell(x)) {
			x <- spatSample(x, size=maxcell, "regular", as.raster=TRUE)
		}
		n <- ncell(x)

		# for "cor" masking is done in cpp code
		if ((use == "complete.obs") && (fun != "cor")) { 
			x <- mask(x, anyNA(x), maskvalue=TRUE)
		}
		
		if (fun == "weighted.cov") {
			w <- x[[1]]
			x <- x[[-1]]

			means <- mat <- matrix(NA, nrow=nl, ncol=nl)
			colnames(means) <- rownames(means) <- colnames(mat) <- rownames(mat) <- names(x)
			sqrtw <- sqrt(w)
			for(i in 1:nl) {
				for(j in i:nl) {
					s <- c(x[[c(i,j)]])
					if (use == "pairwise.complete.obs") {
						s <- mask(c(s, w), anyNA(s), maskvalue=TRUE)
						ww <- s[[3]]
						s <- s[[1:2]]
						sumw <- unlist(global(ww, fun="sum", na.rm=TRUE) )
						avg <- unlist(global(s * ww, fun="sum", na.rm=TRUE)) / sumw
					} else {
						sumw <- unlist(global(w, fun="sum", na.rm=na.rm) )
						avg <- unlist(global(s * w, fun="sum", na.rm=na.rm)) / sumw
					}					
					sumw <- sumw - asSample
					s <- prod( (s - avg) * sqrtw )
					v <- unlist(global(s, fun="sum", na.rm=na.rm)) / sumw
					mat[j,i] <- mat[i,j] <- v
					means[i,j] <- avg[1]
					means[j,i] <- avg[2]
				}
			}
			return( list(weighted_covariance=mat, weighted_mean=means) )
		} else if (fun == "cov") {
			means <- mat <- nn <- matrix(NA, nrow=nl, ncol=nl)
			colnames(means) <- rownames(means) <- colnames(mat) <- rownames(mat) <- names(x)
			n_ij <- n
			for(i in 1:nl) {
				for(j in i:nl) {
					s <- x[[c(i,j)]]
					if (use == "pairwise.complete.obs") {
						m <- anyNA(s)
						s <- mask(s, m, maskvalue=TRUE)
						n_ij <- n - global(m, fun="sum")$sum
					}
					avg <- unlist(global(s, fun="mean", na.rm=na.rm) )
					r <- prod(s - avg)
					v <- unlist(global(r, fun="sum", na.rm=na.rm)) / (n_ij - asSample)
					mat[j,i] <- mat[i,j] <- v
					means[i,j] <- avg[1]
					means[j,i] <- avg[2]
					nn[i,j] <- nn[j,i] <- n_ij
				}
			}

			return( list(covariance=mat, mean=means, n=nn) )

		} else if (fun == "cor") {
			if (isTRUE(list(...)$old)) {
				old_pearson(x, asSample=asSample, na.rm=na.rm, nl=nl, n=n, mat=mat)
			} else {			
				opt <- spatOptions()
				m <- x@pntr$layerCor("cor", use, asSample, opt)
				x <- messages(x)
				m <- lapply(m, function(i) {
					matrix(i, nrow=nl, byrow=TRUE, dimnames=list(names(x), names(x)))
				})
				names(m) <- c("correlation", "mean", "n")
				return(m)
			}
		} else {
			v <- spatSample(x, size=maxcell, "regular", na.rm=na.rm, warn=FALSE)
			if (use %in% c("complete.obs", "complete.masked")) {
				v <- na.omit(v)
			}
			mat <- matrix(NA, nrow=nl, ncol=nl)			
			for(i in 1:nl) {
				for(j in i:nl) {
					if (use == "pairwise.complete.obs") {
						vij <- na.omit(v[,c(i,j)])
						mat[j,i] <- mat[i,j] <- FUN(vij[,1], vij[,2], ...)
					} else {
						mat[j,i] <- mat[i,j] <- FUN(v[,i], v[,j], ...)
					}
				}
			}
			mat
		}
	}
)




old_pearson <- function(x, asSample, na.rm, nl, n, mat) {
	if (na.rm) {
		means <- matrix(NA, nrow=2, ncol=nlyr(x))
		for(i in 1:(nl-1)) {
			for(j in (i+1):nl) {
				m <- anyNA(x[[c(i,j)]])
				a <- mask(x[[i]], m, maskvalue=TRUE)
				b <- mask(x[[j]], m, maskvalue=TRUE)
				xx <- c(a, b)
				mns <- unlist(global(xx, fun="mean", na.rm=na.rm) )
				means[2,i] <- mns[1]
				means[1,j] <- mns[2]						
				sds <- unlist(global(xx, fun="sd", na.rm=na.rm) )
				r <- prod(xx - mns)
				nas <- unlist(global(is.na(r), fun="sum"))
				v <- unlist(global(r, fun="sum", na.rm=na.rm))
				v <- v / ((n - nas - asSample) * sds[1] * sds[2])
				mat[j,i] <- mat[i,j] <- v
			}
		}
		colnames(means) <- names(x)
	} else {
		means <- unlist(global(x, fun="mean", na.rm=na.rm) )
		sds <- unlist(global(x, fun="sd", na.rm=na.rm) )
		x <- (x - means)
		
		for(i in 1:(nl-1)) {
			for(j in i:nl) {
				r <- x[[i]] * x[[j]]
				v <- unlist(global(r, fun="sum", na.rm=na.rm))
				v <- v / ((n - asSample) * sds[i] * sds[j])
				mat[j,i] <- mat[i,j] <- v
			}
		}
		means <- matrix(means, nrow=1)
		colnames(means) <- names(x)
	}
	diag(mat) <- 1
	covar <- list(mat, means)
	names(covar) <- c("pearson", "mean")
	return(covar)
}
	

roundtrip <- function(x, coll=FALSE) {
	if (coll) {
		p <- methods::new("SpatVectorCollection")
		p@pntr <- x@pntr$bienvenue()
		return(p)
	} else {
		x@pntr <- x@pntr$allerretour()
		return(x)
	}
}

get_invalid_coords <- function(x) {
	x <- x[!x[,1], ]
	if (nrow(x) > 0) {
		id <- as.integer(rownames(x))
		txt <- x[,2]
		txt <- gsub("Ring Self-intersection\\[", "", txt)
		txt <- gsub("Self-intersection\\[", "", txt)
		txt <- gsub("Too few points in geometry component\\[", "", txt)
		txt <- unlist(strsplit(gsub("]", "", txt), " "))
		txt <- matrix(as.numeric(txt), ncol=2, byrow=TRUE)
		v <- vect(txt)
		values(v) <- data.frame(id=id, msg=x[,2])
		v
	} else {
		vect()
	}
}

setMethod("is.valid", signature(x="SpatVector"),
	function(x, messages=FALSE, as.points=FALSE) {
		if (as.points) messages = TRUE
		if (messages) {
			r <- x@pntr$geos_isvalid_msg()
			d <- data.frame(matrix(r, ncol=2, byrow=TRUE))
			d[,1] = d[,1] == "\001"
			colnames(d) <- c("valid", "reason")
			if (as.points) {
				p <- try(get_invalid_coords(d), silent=TRUE)
				if (inherits(p, "try-error")) {
					warn("is.valid", "as.points failed, returning matrix")
					return(d)
				} else {
					return(p)
				}
			}
			d
		} else {
			x@pntr$geos_isvalid()
		}
	}
)

setMethod("makeValid", signature(x="SpatVector"),
	function(x, buffer=FALSE) {
		if (buffer && (geomtype(x) == "polygons")) {
			xc <- crs(x)
			crs(x) <- "local"
			x <- buffer(x, 0)
			crs(x) <- xc
			return(x)
		}
		x@pntr <- x@pntr$make_valid2()
		messages(x)
	}
)



setMethod("is.na", signature(x="SpatVector"),
	function(x) {
		x@pntr$naGeoms()
	}
)


setMethod("na.omit", signature("SpatVector"),
	function(object, field=NA, geom=FALSE) {
		if (geom) {
			g <- geom(object)
			g <- g[is.na(g[,"x"]) | is.na(g[,"y"]), 1]
			if (length(g) > 0) {
				object <- object[-g, ]
			}
		}
		stopifnot(is.vector(field))
		if (!is.na(field[1])) {
			field <- field[!is.na(field)]
			v <- values(object)
			if (!any(field == "")) {
				v <- v[, field, drop=FALSE]
			}
			i <- apply(v, 1, function(i) any(is.na(i)))
			if (any(i)) {
				object <- object[!i, ]
			}
		}
		object
	}
)


setMethod("deepcopy", signature("SpatVector"),
	function(x) {
		x@pntr <- x@pntr$deepcopy()
		x
	}
)


as.list.svc <- function(x) {
	v <- vect()
	out <- lapply(1:x$size(),
		function(i) {
			v@pntr <- x$get(i-1)
			v
		})
	names(out) <- x$names
	out
}



setMethod("cover", signature(x="SpatVector", y="SpatVector"),
	function(x, y, identity=FALSE, expand=TRUE) {
		x@pntr <- x@pntr$cover(y@pntr, identity[1], expand[1])
		messages(x, "cover")
	}
)


setMethod("symdif", signature(x="SpatVector", y="SpatVector"),
	function(x, y) {
		x@pntr <- x@pntr$symdif(y@pntr)
		messages(x, "symdif")
	}
)

setMethod("erase", signature(x="SpatVector", y="SpatVector"),
	function(x, y) {
		x@pntr <- x@pntr$erase_agg(y@pntr)
		messages(x, "erase")
	}
)

setMethod("erase", signature(x="SpatVector", y="missing"),
	function(x, sequential=TRUE) {
		x@pntr <- x@pntr$erase_self(sequential)
		messages(x, "erase")
	}
)

setMethod("erase", signature(x="SpatVector", y="SpatExtent"),
	function(x, y) {
		y <- as.polygons(y)
		x@pntr <- x@pntr$erase(y@pntr)
		messages(x, "erase")
	}
)

setMethod("gaps", signature(x="SpatVector"),
	function(x) {
		x@pntr <- x@pntr$gaps()
		messages(x, "gaps")
	}
)


setMethod("union", signature(x="SpatVector", y="missing"),
	function(x, y) {
		x@pntr <- x@pntr$union_self()
		messages(x, "union")
	}
)


setMethod("union", signature(x="SpatVector", y="SpatVector"),
	function(x, y) {
		if (geomtype(x) != "polygons") {
			unique(rbind(x, y))
		} else {
			x@pntr <- x@pntr$union(y@pntr)
			messages(x, "union")
		}
	}
)

setMethod("union", signature(x="SpatVector", y="SpatExtent"),
	function(x, y) {
		y <- as.vector(y)
		x@pntr <- x@pntr$union(y@pntr)
		messages(x, "union")
	}
)

setMethod("union", signature(x="SpatExtent", y="SpatExtent"),
	function(x, y) {
		x + y
	}
)


setMethod("intersect", signature(x="SpatVector", y="SpatVector"),
	function(x, y) {
		x@pntr <- x@pntr$intersect(y@pntr, TRUE)
		messages(x, "intersect")
	}
)

setMethod("intersect", signature(x="SpatExtent", y="SpatExtent"),
	function(x, y) {
		x@pntr <- x@pntr$intersect(y@pntr)
		if (!x@pntr$valid_notempty) {
			return(NULL)
		}
		x
	}
)

setMethod("intersect", signature(x="SpatVector", y="SpatExtent"),
	function(x, y) {
		#x@pntr <- x@pntr$crop_ext(y@pntr)
		#x
		crop(x, y)
	}
)

setMethod("intersect", signature(x="SpatExtent", y="SpatVector"),
	function(x, y) {
		y <- ext(y)
		x * y
	}
)

setMethod("mask", signature(x="SpatVector", mask="SpatVector"),
	function(x, mask, inverse=FALSE) {
		x@pntr <- x@pntr$mask(mask@pntr, inverse)
		messages(x, "mask")
	}
)

setMethod("mask", signature(x="SpatVector", mask="SpatExtent"),
	function(x, mask, inverse=FALSE) {
		mask <- vect(mask, crs=crs(x))
		x@pntr <- x@pntr$mask(mask@pntr, inverse)
		messages(x, "mask")
	}
)


setMethod("intersect", signature(x="SpatExtent", y="SpatRaster"),
	function(x, y) {
		x <- align(x, y, snap="near")
		intersect(x, ext(y))
	}
)

setMethod("intersect", signature(x="SpatRaster", y="SpatExtent"),
	function(x, y) {
		intersect(y, x)
	}
)




setMethod("buffer", signature(x="SpatVector"),
	function(x, width, quadsegs=10, capstyle="round", joinstyle="round", mitrelimit=NA, singlesided=FALSE) {
		if (is.character(width)) {
			if (!(width %in% names(x))) {
				error("buffer", paste(width, "is not a field in x"))
			}
			width <- x[[width, drop=TRUE]]
		}
		if (!is.numeric(width)) {
			error("buffer", "width is not numeric")
		}
		x@pntr <- x@pntr$buffer(width, quadsegs, tolower(capstyle), tolower(joinstyle), mitrelimit, singlesided)
		messages(x, "buffer")
	}
)


setMethod("crop", signature(x="SpatVector", y="ANY"),
	function(x, y, ext=FALSE) {
		if (ext) {
			y <- ext(y)
			x@pntr <- x@pntr$crop_ext(y@pntr, TRUE)
			return(x)
		}
		if (inherits(y, "SpatVector")) {
			x@pntr <- x@pntr$crop_vct(y@pntr)
		} else {
			if (!inherits(y, "SpatExtent")) {
				y <- try(ext(y), silent=TRUE)
				if (inherits(y, "try-error")) {
					stop("y does not have a SpatExtent")
				}
			}
			## crop_ext does not include points on the borders
			## https://github.com/rspatial/raster/issues/283
			#x@pntr <- x@pntr$crop_ext(y@pntr)
			if (geomtype(x) == "points") {
				y <- as.polygons(y)
				x@pntr <- x@pntr$crop_vct(y@pntr)
			} else {
				x@pntr <- x@pntr$crop_ext(y@pntr, TRUE)
			}
		}
		messages(x, "crop")
	}
)





setMethod("hull", signature(x="SpatVector"),
	function(x, type="convex", by="", param=1, allowHoles=TRUE, tight=TRUE) {
		type <- match.arg(tolower(type), c("convex", "rectangle", "circle", "concave_ratio", "concave_length"))
		if (is.na(by)) by <- "_"
		x@pntr <- x@pntr$hull(type, by[1], param, allowHoles, tight)
		messages(x, "hull")
	}
)



setMethod("disagg", signature(x="SpatVector"),
	function(x, segments=FALSE) {
		x@pntr <- x@pntr$disaggregate(segments[1])
		messages(x, "disagg")
	}
)




setMethod("flip", signature(x="SpatVector"),
	function(x, direction="vertical") {
		d <- match.arg(direction, c("vertical", "horizontal"))
		x@pntr <- x@pntr$flip(d == "vertical")
		messages(x, "flip")
	}
)



setMethod("spin", signature(x="SpatVector"),
	function(x, angle, x0, y0) {
		e <- as.vector(ext(x))
		if (missing(x0)) {
			x0 <- mean(e[1:2])
		}
		if (missing(y0)) {
			y0 <- mean(e[3:4])
		}
		angle <- angle[1]
		stopifnot(is.numeric(angle) && !is.nan(angle))
		x@pntr <- x@pntr$rotate(angle, x0, y0)
		messages(x, "spin")
	}
)


setMethod("delaunay", signature(x="SpatVector"),
	function(x, tolerance=0, as.lines=FALSE, constrained=FALSE) {
		x@pntr <- x@pntr$delaunay(tolerance, as.lines, constrained)
		messages(x, "delaunay")
	}
)



voronoi_deldir <- function(x, bnd=NULL, eps=1e-09, ...){

	xy <- crds(x)
	dat <- values(x)
	if (nrow(dat > 0)) {
		dups <- duplicated(xy)
		if (any(dups)) {
			xy <- xy[!dups, ,drop=FALSE]
			dat <- dat[!dups, ,drop=FALSE]
		}
	} else {
		xy <- stats::na.omit(xy[, 1:2])
		xy <- unique(xy)
	}

	e <- bnd
	if (!is.null(e)) {
		e <- as.vector(ext(bnd))
	}

	dd <- deldir::deldir(xy[,1], xy[,2], rw=e, eps=eps, suppressMsge=TRUE)
	g <- lapply(deldir::tile.list(dd), function(i) cbind(i$ptNum, 1, i$x, i$y))
	g <- do.call(rbind, g)
	g <- vect(g, "polygons", crs=crs(x))
	if (nrow(g) == nrow(dat)) {
		values(g) <- dat
	} else {
		values(g) <- data.frame(id=dd$ind.orig)
	}
	g
}



setMethod("voronoi", signature(x="SpatVector"),
	function(x, bnd=NULL, tolerance=0, as.lines=FALSE, deldir=FALSE) {
		if (nrow(x) ==0) {
			error("voronoi", "input has no geometries")
		}
		if (geomtype(x) != "points") {
			x <- as.points(x)
		}
		if (deldir) {
			voronoi_deldir(x, bnd, tolerance=tolerance)
		} else {
			if (is.null(bnd)) {
				bnd <- vect()
			} else {
				bnd <- as.polygons(ext(bnd))
			}
			x@pntr <- x@pntr$voronoi(bnd@pntr, tolerance, as.lines)
			messages(x, "voronoi")
		}
	}
)

setMethod("elongate", signature(x="SpatVector"),
	function(x, length=1, flat=FALSE) {
		x@pntr <- x@pntr$elongate(length, flat)
		messages(x, "elongate")
	}
)


setMethod("width", signature(x="SpatVector"),
	function(x, as.lines=FALSE) {
		x@pntr <- x@pntr$width()
		x <- messages(x, "width")
		if (!as.lines) {
			x <- perim(x)
		}
		x
	}
)


setMethod("clearance", signature(x="SpatVector"),
	function(x, as.lines=FALSE) {
		x@pntr <- x@pntr$clearance()
		x <- messages(x, "clearance")
		if (!as.lines) {
			x <- perim(x)
		}
		x
	}
)




setMethod("mergeLines", signature(x="SpatVector"),
	function(x) {
		x@pntr <- x@pntr$line_merge()
		messages(x, "line_merge")
	}
)

setMethod("makeNodes", signature(x="SpatVector"),
	function(x) {
		x@pntr <- x@pntr$make_nodes()
		messages(x, "makeNodes")
	}
)

setMethod("removeDupNodes", signature(x="SpatVector"),
	function(x, digits=-1) {
		x@pntr <- x@pntr$remove_duplicate_nodes(digits)
		messages(x, "removeDupNodes")
	}
)


setMethod("simplifyGeom", signature(x="SpatVector"),
	function(x, tolerance=0.1, preserveTopology=TRUE, makeValid=TRUE) {
		x@pntr <- x@pntr$simplify(tolerance, preserveTopology)
		x <- messages(x, "simplifyGeom")
		if (makeValid) {
			x <- makeValid(x)
		}
		x
	}
)

setMethod("thinNodes", signature(x="SpatVector"),
	function(x, d=1e-6, unit="m", makeValid=TRUE) {
		stopifnot(unit[1] %in% c("m", "km"))
		x@pntr <- x@pntr$thin_nodes(d, unit[1])
		x <- messages(x, "thinNodes")
		if (makeValid) {
			x <- makeValid(x)
		}
		x
	}
)

setMethod("sharedPaths", signature(x="SpatVector"),
	function(x, y=NULL) {
		if (is.null(y)) {
			x@pntr <- x@pntr$shared_paths(TRUE)
		} else {
			x@pntr <- x@pntr$shared_paths2(y@pntr, TRUE)
		}
		x <- messages(x, "sharedPaths")
		# sort data to ensure consistent order with spatial indices
		if (nrow(x) > 0) x <- x[order(x$id1, x$id2), ]
		x
	}
)


setMethod("snap", signature(x="SpatVector"),
	function(x, y=NULL, tolerance) {
		if (is.null(y)) {
			x@pntr <- x@pntr$snap(tolerance)
		} else {
			x@pntr <- x@pntr$snapto(y@pntr, tolerance)
		}
		messages(x, "snap")
	}
)


setMethod("combineGeoms", signature(x="SpatVector", y="SpatVector"),
	function(x, y, overlap=TRUE, boundary=TRUE, distance=TRUE, append=TRUE, minover=0.1, maxdist=Inf, dissolve=TRUE, erase=TRUE) {

		if ((geomtype(x) != "polygons") || (geomtype(y) != "polygons")) {
			error("combineGeoms", "x and y must be polygons")
		}
		if (nrow(x) == 0) {
			if (append) {
				return(rbind(x, y))
			} else {
				return(x)
			}
		}
		if (nrow(y) == 0) {
			return(x)
		}

		xcrs <- crs(x)
		ycrs <- crs(y)
		if ((xcrs == "") || (ycrs == "")) {
			error("combineGeoms", "x and y must have a crs")
		} else if (xcrs != ycrs) {
			error("combineGeoms", "x and y do not have the same crs")
		}

		dx <- values(x)
		dy <- values(y)
		values(x) = data.frame(idx=1:nrow(x))
		values(y) = data.frame(idy=1:nrow(y))
		y <- erase(y) # no self-overlaps
		if (overlap) {
			#avoid Warning message: [intersect] no intersection
 			xy <- suppressWarnings(intersect(y, x))
			if (nrow(xy) > 0) {
				xy$aint <- expanse(xy)
				a <- values(xy)
				a <- a[order(a$idy, -a$aint),]
				a <- a[!duplicated(a$idy),]
				yi <- y[a$idy,]
				atot <- expanse(yi)
				a <- a[(a$aint / atot) >= minover, ]
				if (nrow(a) > 0) {
					if (erase) {
						ye <- erase(y, x)
						i <- stats::na.omit(match(a$idy, ye$idy))
						if (length(i) > 0) {
							yi <- ye[i,]
							values(yi) <- data.frame(idx=a$idx[i])
						} else {
							yi <- vect()
						}
					} else {
						yi <- y[a$idy,]
						values(yi) <- data.frame(idx=a$idx)
					}
					if (nrow(yi) > 0) {
						x <- aggregate(rbind(x, yi), "idx", dissolve=dissolve, counts=FALSE)
					}
					y <- y[-a$idy,]
				}
			}
		}

		if (boundary && (nrow(y) > 0)) {
			ye <- erase(y, x)
			p <- sharedPaths(ye, x)
			if (nrow(p) > 0) {
				p$s <- perim(p)
				p <- values(p)
				p <- p[order(p$id1, -p$s),]
				p <- p[!duplicated(p$id1),]
				if (erase) {
					i <- p$id1
					yi <- ye[p$id1,]
					yi$idx <- p$id2
					yi$idy <- NULL
				} else {
					i <- ye$idy[p$id1]
					i <- match(i, y$idy)
					yi <- y[i,]
					yi$idx <- 0
					yi$idx[i] <- p$id2[i]
				}
				yi$idy <- NULL
				x <- aggregate(rbind(x, yi), "idx", dissolve=dissolve, counts=FALSE)
				y <- y[-i,]
			}
		}

		if (distance && (nrow(y) > 0) && (maxdist > 0)) {
			n <- nearest(y, x)
			n <- n[n$distance <= maxdist, ]
			if (nrow(n) > 0) {
				yi <- y[n$from_id, ]
				yi$idx <- n$to_id
				yi$idy <- NULL
				x <- aggregate(rbind(x, yi), "idx", dissolve=FALSE, counts=FALSE)
				y <- y[-n$from_id, ]
			}
		}

		values(x) <- dx[x$idx, ,drop=FALSE]
		if (append && (nrow(y) > 0)) {
			values(y) <- dy[y$idy, ,drop=FALSE]
			if (erase) {
				y <- erase(y, x)
			}
			x <- rbind(x, y)
		}
		x
	}
)


setMethod("split", signature(x="SpatVector", f="ANY"),
	function(x, f) {
		if (inherits(f, "list") || (length(f) > 1)) {
			if (inherits(f, "list")) {
				f <- as.data.frame(f)
				f <- apply(f, 1, function(x) paste(x, collapse="."))
			} else if ((length(f) < nrow(x)) && inherits(f, "character") && (all(f %in% names(x)))) {
				f <- apply(x[[f]], 1, function(x) paste(x, collapse="."))
			}
			x <- deepcopy(x)
			if ("f" %in% names(x)) {
				name <- make.unique(c(names(x), "f"))
				name <- name[length(name)]
			} else {
				name <- "f"
			}
			x[[name]] <- f
			f <- name
		}
		x <- messages(x@pntr$split(f), "split")
		as.list.svc(x)
	}
)


#setMethod("split", signature(x="SpatVector", f="SpatVector"),
badsplit <- function(x, f) {
		if (geomtype(x) != "polygons") error("split", "first argument must be polygons")
		if (!(geomtype(f) %in% c("lines", "polygons"))) {
			error("split", "argument 'f' must have a lines or polygons geometry")
		}
		values(f) <- NULL
		ex <- ext(x)
		r <- relate(x, f, "intersects")
		if (sum(r) == 0) {
			warn("split", "x and f do not intersect")
			return(x)
		}
		#r <- r[rowSums(r) > 0, ,drop=FALSE]
		ri <- which(rowSums(r) > 0)
		y <- x[ri,]	
		r <- r[ri, , drop=FALSE]
		values(y) <- NULL
		ss <- vector("list", nrow(y))
		if (geomtype(f) == "lines") {
			for (i in 1:nrow(y)) {
				yi <- y[i]
				yi <- disagg(yi)
				add <- NULL
				if (nrow(yi) > 1) {
					ri <- relate(yi, f, "intersects")
					if (any(!ri)) {
						add <- yi[!ri]
						yi <- yi[ri]
					}
				}
				lin <- intersect(f[r[i,],], yi)
				v <- rbind(as.lines(yi), lin)
				v <- makeNodes( aggregate(v) )
				v <- as.polygons(v)
				if (!is.null(add)) {
					v <- combineGeoms(v, add, overlap=FALSE, boundary=FALSE, distance=TRUE, dissolve=FALSE, erase=FALSE)
				}
				v$id <- i
				ss[[i]] <- v
			}
			ss <- vect(ss)
			v <- values(x)
			values(ss) <- v[ss$id, ]
			rbind(x[-i,], ss)
		} else { #if (geomtype(f) == "polygons") {
			for (i in 1:nrow(r)) {
				yi <- y[i]
				v <- rbind(intersect(yi, f[r[i,],]),
							   erase(yi, f[r[i,],]))
				v$id <- i
				ss[[i]] <- v
			}
			ss <- vect(ss)
			v <- values(x)
			values(ss) <- v[ss$id, ]
			rbind(x[-i,], ss)
		
		}
	}
#)


setMethod("split", signature(x="SpatVector", f="SpatVector"),
	function(x, f, min_node_dist=10000) {
		gt <- geomtype(x)
		if (!(gt %in% c("lines", "polygons"))) {
			error("split", "argument 'x' must have a lines or polygons geometry")
		}
		if (!(geomtype(f) %in% c("lines", "polygons"))) {
			error("split", "argument 'f' must have a lines or polygons geometry")
		}
		
		values(f) <- NULL
		f <- as.lines(f)
		if (is.lonlat(x, perhaps=TRUE)) {
			stopifnot(min_node_dist > 100)
			crs(x) <- crs(f) <- "lonlat"
			x <- densify(x, min_node_dist)
			f <- densify(f, min_node_dist)
		}
		r <- relate(x, f, "intersects")
		if (sum(r) == 0) {
			warn("split", "x and f do not intersect")
			return(x)
		}
		if (gt == "polygons") {
			e <- elongate(intersect(as.lines(f), x), 0.00001)
			k <- aggregate(rbind(as.lines(x), e))
			nds <- makeNodes(k)
			p <- as.polygons(nds)
			intersect(x, p)
		} else { # if (gt == "lines") {
			d <- values(x)
			values(x) <- data.frame(ID1=1:nrow(x))
			x <- disagg(x)
			x$ID2 <- 1:nrow(x)
			e <- erase(x, f)
			out <- disagg(e)
			b <- table(out$ID2)
			i <- as.numeric(names(b[b==1]))
			if (length(i) > 0) {
				a <- aggregate(out[out$ID2 == i, ], by="ID1")[, "ID1"]
				out <- rbind(a, out[out$ID2 != i, "ID1"])
			}
			values(out) <- d[out$ID1, ]
			out
		}
	}
)



setMethod("forceCCW", signature(x="SpatVector"),
	function(x) {
		x <- deepcopy(x)
		x@pntr$make_CCW()
		messages(x)
	}
)


setMethod("is.empty", signature(x="SpatVector"),
	function(x) {
		nrow(x) == 0
	}
)

# Author: Robert J. Hijmans
# Date : October 2018
# Version 1.0
# License GPL v3



setMethod("centroids", signature(x="SpatRaster"),
	function(x, weighted=FALSE) {
		opt <- spatOptions()
		if (nlyr(x) > 1) {
			out <- lapply(1:nlyr(x), function(i) centroids(x[[i]], weighted=weighted))
			do.call(rbind, out)
		} else {
			out <- x@pntr$centroid(weighted[1], opt)
			messages(x, "centroids")
			data.frame(x=out[1], y=out[2])
		}
	}
)


setMethod("is.rotated", signature(x="SpatRaster"),
	function(x) {
		x@pntr$is_rotated()
	}
)


setMethod("is.flipped", signature(x="SpatRaster"),
	function(x)  {
		x@pntr$is_flipped()
	}
)


setMethod("has.geoloc", signature(x="SpatRaster"),
	function(x) {
		x@pntr$has_geoloc()
	}
)


setMethod("geoloc", signature(x="SpatRaster"),
	function(x) {
		data.frame(
			geolocation = x@pntr$has_geoloc(),
			gcps = x@pntr$has_gcps(),
			srs = x@pntr$geoloc_srs(),
			x = x@pntr$geoloc_x(),
			y = x@pntr$geoloc_y(),
			stringsAsFactors = FALSE
		)
	}
)


setMethod("rangeFill", signature(x="SpatRaster"),
	function(x, limit, circular=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$fill_range(limit, circular, opt)
		messages(x, "rangeFill")
	}
)


setMethod("weighted.mean", signature(x="SpatRaster", w="numeric"),
	function(x, w, na.rm=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$wmean_vect(w, na.rm, opt)
		messages(x, "weighted.mean")
	}
)


setMethod("weighted.mean", signature(x="SpatRaster", w="SpatRaster"),
	function(x, w, na.rm=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <-x@pntr$wmean_rast(w@pntr, na.rm, opt)
		messages(x, "weighted.mean")
	}
)

setMethod("patches", signature(x="SpatRaster"),
	function(x, directions=4, values=FALSE, zeroAsNA=FALSE, allowGaps=TRUE, filename="", ...) {
		if (values) {
			opt <- spatOptions(filename, ...)
			x@pntr <- x@pntr$patches2(directions, opt)
			return(messages(x, "patches"))			
		}
		if (allowGaps) {
			opt <- spatOptions(filename, ...)
			x@pntr <- x@pntr$patches(directions[1], zeroAsNA[1], opt)
			messages(x, "patches")
		} else {
			opt <- spatOptions()
			x@pntr <- x@pntr$patches(directions[1], zeroAsNA[1], opt)
			x <- messages(x, "patches")
			f <- freq(x)
			fr <- cbind(f[,2], 1:nrow(f))
			fr <- fr[fr[,1] != fr[,2], ,drop=FALSE]
			if (nrow(fr) > 0) {
				x <- classify(x, fr, filename=filename, ...)
			} else if (filename != "") {
				x <- writeRaster(x, filename=filename, ...)
			}
			x
		}
	}
)


setMethod("origin", signature(x="SpatRaster"),
	function(x) {
		x@pntr$origin
	}
)


setMethod("origin<-", signature("SpatRaster"),
	function(x, value) {
		value <- rep(value, length.out=2)
		dif <- value - origin(x)
		res <- res(x)
		dif[1] <- dif[1] %% res[1]
		dif[2] <- dif[2] %% res[2]
		for (i in 1:2) {
			if (dif[i] < 0) {
				if ((dif[i] + res[i]) < abs(dif[i])) {
					dif[i] <- dif[i] + res[i]
				}
			} else {
				if (abs(dif[i] - res[i]) < dif[i]) {
					dif[i] <- dif[i] - res[i]
				}
			}
		}
		e <- as.vector(ext(x))
		e["xmin"] <- e["xmin"] + dif[1]
		e["xmax"] <- e["xmax"] + dif[1]
		e["ymin"] <- e["ymin"] + dif[2]
		e["ymax"] <- e["ymax"] + dif[2]
		ext(x) <- e
		return(x)
	}
)




setMethod("align", signature(x="SpatExtent", y="SpatRaster"),
	function(x, y, snap="near") {
		x@pntr <- y@pntr$align(x@pntr, tolower(snap))
		#messages(x, "align")
		x
	}
)

setMethod("align", signature(x="SpatExtent", y="numeric"),
	function(x, y) {
		x@pntr <- x@pntr$align(y, "")
		x
	}
)


setMethod("intersect", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y) {
		opt <- spatOptions() 
		x@pntr <- x@pntr$intersect(y@pntr, opt)
		messages(x)
	}
)


setMethod("cellSize", signature(x="SpatRaster"),
	function(x, mask=FALSE, lyrs=FALSE, unit="m", transform=TRUE, rcx=100, filename="", ...) {
		opt <- spatOptions(filename, ...)
		if (!lyrs) x <- x[[1]]
		x@pntr <- x@pntr$rst_area(mask, unit, transform, rcx, opt)
		messages(x, "cellSize")
	}
)


setMethod("surfArea", signature(x="SpatRaster"),
	function(x, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$surface_area(opt)
		messages(x, "surfArea")
	}
)


setMethod("atan2", signature(y="SpatRaster", x="SpatRaster"),
	function(y, x) {
		opt <- spatOptions(filename="", overwrite=TRUE)
		y@pntr <- y@pntr$atan2(x@pntr, opt)
		messages(y, "atan2")
	}
)

setMethod("atan_2", signature(y="SpatRaster", x="SpatRaster"),
	function(y, x, filename="", ...) {
		opt <- spatOptions(filename=filename, ...)
		y@pntr <- y@pntr$atan2(x@pntr, opt)
		messages(y, "atan_2")
	}
)



setMethod("boundaries", signature(x="SpatRaster"),
	function(x, classes=FALSE, inner=TRUE, directions=8, falseval=0, ignoreNA=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		type <- ifelse(inner[1], "inner", "outer")
		x@pntr <- x@pntr$boundaries(classes[1], ignoreNA, type, directions[1], falseval[1], opt)
		messages(x, "boundaries")
	}
)


.collapseSources <- function(x) {
	x@pntr <- x@pntr$collapse_sources()
	messages(x, "tighten")
}

setMethod("deepcopy", signature("SpatRaster"),
	function(x) {
		x@pntr <- x@pntr$deepcopy()
		x
	}
)



setMethod("split", signature(x="SpatRaster"),
	function(x, f) {
		stopifnot(length(f) == nlyr(x))
		stopifnot(!any(is.na(f)))
		u <- unique(f)
		lapply(u, function(i) x[[f==i]])
	}
)


setMethod("add<-", signature("SpatRaster", "SpatRaster"),
	function(x, value) {
		if (x@pntr$same(value@pntr)) {
			x@pntr <- x@pntr$deepcopy()
		}
		opt <- spatOptions()
		x@pntr$addSource(value@pntr, FALSE, opt)
		messages(x, "add")
	}
)

setMethod("tighten", signature("SpatRaster"),
	function(x) {
		x@pntr <- x@pntr$collapse_sources()
		messages(x, "tighten")
	}
)

setMethod("tighten", signature("SpatRasterDataset"),
	function(x) {
		y <- new("SpatRaster")
		y@pntr <- x@pntr$collapse()
		messages(y, "tighten")
	}
)


#setMethod("c", signature(x="SpatRaster"),
#	function(x, ...) {
#		s <- sds(list(x, ...))
#		x@pntr <- s@pntr$collapse()
#		x <- messages(x, "c")
#		try( x@pntr <- x@pntr$collapse_sources() )
#		messages(x, "c")
#	}
#)



#cbind.SpatVector <- function(x, y, ...) {
#	if (inherits(y, "SpatVector")) {
#		y <- y@pntr$df
#	} else {
#		stopifnot(inherits(y, "data.frame"))
#		y <- terra:::.makeSpatDF(y)
#	}
#	x@pntr <- x@pntr$cbind(y)
#	messages(x, "cbind")
#}

cbind.SpatVector <- function(x, y, ...) {
	dots <- list(y, ...)
	for (y in dots) {
		if (inherits(y, "SpatVector")) {
			y <- y@pntr$df
		} else {
			# stopifnot(inherits(y, "data.frame"))
			y <- as.data.frame(y)
			y <- .makeSpatDF(y)
		}
		x@pntr <- x@pntr$cbind(y)
		x <- messages(x, "cbind")
	}
	x
}

rbind.SpatVector <- function(x, y, ...) {
	skipped <- FALSE
	if (missing(y) || is.null(y)) return(x)
	stopifnot(inherits(y, "SpatVector"))
	s <- svc(x, y, ...)
	x@pntr <- s@pntr$append()
	messages(x, "rbind")

#	dots <- list(...)
#	if (is.null(dots)) {
#		x@pntr <- x@pntr$rbind(y@pntr, FALSE)
#	} else {

	#if (!is.null(dots)) {
	#	for (y in dots) {
	#		stopifnot(inherits(y, "SpatVector"))
	#		x@pntr <- x@pntr$rbind(y@pntr, FALSE)
	#		x <- messages(x, "rbind")
	#	}
	#}
	#x
}


# this way names of named arguments are used
setMethod("c", signature(x="SpatRaster"),
	function(x, ..., warn=TRUE) {
		if (missing(x)) {
			rast(list(...), warn=warn)
		} else {
			rast(list(x, ...), warn=warn)
		}
	}
)


setMethod("rep", signature(x="SpatRaster"),
	function(x, ...) {
		i <- rep(1:nlyr(x), ...)
		x[[i]]
	}
)


setMethod("clamp", signature(x="SpatRaster"),
	function(x, lower=-Inf, upper=Inf, values=TRUE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		rlow <- inherits(lower, "SpatRaster")
		rupp <- inherits(upper, "SpatRaster")
		r <- rast()
		if (rlow & rupp) {
			x@pntr <- x@pntr$clamp_raster(lower@pntr, upper@pntr, NA, NA, values[1], opt)
		} else if (rlow) {
			if (any(is.na(upper))) error("clamp", "upper limit cannot be NA")
			x@pntr <- x@pntr$clamp_raster(lower@pntr, r@pntr, NA, upper, values[1], opt)
		} else if (rupp) {
			if (any(is.na(lower))) error("clamp", "lower limit cannot be NA")
			x@pntr <- x@pntr$clamp_raster(r@pntr, upper@pntr, lower, NA, values[1], opt)
		} else {
			if (any(is.na(lower))) error("clamp", "lower limit cannot be NA")
			if (any(is.na(upper))) error("clamp", "upper limit cannot be NA")
			x@pntr <- x@pntr$clamp_raster(r@pntr, r@pntr, lower, upper, values[1], opt)
			#x@pntr <- x@pntr$clamp(lower, upper, values[1], opt)
		}
		messages(x, "clamp")
	}
)



setMethod("clamp_ts", signature(x="SpatRaster"),
	function(x, min=FALSE, max=TRUE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$clamp_ts(min, max, opt)
		messages(x, "clamp_ts")
	}
)

setMethod("clamp", signature(x="numeric"),
function(x, lower=-Inf, upper=Inf, values=TRUE, ...) {
	stopifnot(lower <= upper)
	if (values) {
		x[x < lower] <- lower
		x[x > upper] <- upper
	} else {
		x[x < lower] <- NA
		x[x > upper] <- NA
	}
	x
}
)

setMethod("classify", signature(x="SpatRaster"),
function(x, rcl, include.lowest=FALSE, right=TRUE, others=NULL, brackets=TRUE, filename="", ...) {

	bylayer = FALSE

	if (is.data.frame(rcl)) {
		rcl <- as.matrix(rcl)
	}

	if (NCOL(rcl) == 2) {
		if (is.null(others)) {
			othersValue <- NA_real_
			useOthers <- FALSE
		} else {
			othersValue <- as.numeric(others[1])
			useOthers <- TRUE
		}
		opt <- spatOptions(filename, ...)
		from_vec <- as.numeric(rcl[,1])
		to_vec <- as.numeric(rcl[,2])
		x@pntr <- x@pntr$lookup_classify(from_vec, to_vec, useOthers, othersValue, opt)
		messages(x, "classify")
		return(x)
	}

	right <- ifelse(is.na(right), 2, ifelse(isTRUE(right), 1, 0))
	include.lowest <- as.logical(include.lowest[1])

	opt <- spatOptions(filename, ...)
	if (is.null(others)) {
		others <- FALSE
		othersValue <- 0
	} else {
		othersValue <- others[1]
		others <- TRUE
	}
	keepcats <- FALSE
    x@pntr <- x@pntr$classify(as.vector(rcl), NCOL(rcl), right, include.lowest, others, othersValue, bylayer[1], brackets[1], keepcats, opt)
	messages(x, "classify")
}
)

setMethod("subst", signature(x="SpatRaster"),
function(x, from, to, others=NULL, raw=FALSE, filename="", ...) {
	opt <- spatOptions(filename, ...)

	if (inherits(from, "data.frame")) {
		from <- as.matrix(from)
	}
	if (inherits(to, "data.frame")) {
		to <- as.matrix(to)
	}
	tom <- inherits(to, "matrix")
	frm <- inherits(from, "matrix")
	if (tom && frm) {
		error("subst", "either 'to' or 'from' can be a matrix, not both")
	}

	if (NROW(from) < NROW(to)) {
		error("subst", "from is shorter than to")
	}
	fromc <- inherits(from[1], "character")
	toc <- inherits(to[1], "character")
		if (raw && fromc) {
			error("subst", "if 'raw=TRUE', 'from' cannot have character values")
		}

		if (!any(is.factor(x)) && !tom && !frm && !fromc && !toc && !raw) {
			if (is.null(others)) {
				othersValue <- NA_real_
				useOthers <- FALSE
			} else {
				othersValue <- as.numeric(others[1])
				useOthers <- TRUE
			}
			from_vec <- as.numeric(from)
			to_vec <- as.numeric(to)
			x@pntr <- x@pntr$lookup_subst(from_vec, to_vec, useOthers, othersValue, opt)
			messages(x, "subst")
			return(x)
		}

		keepcats <- FALSE
	if (any(is.factor(x))) {
		if (nlyr(x) > 1) {
			error("subst", "you can only use 'subst' with categorical layers if x has a single layer")
		}
		if (inherits(to, "matrix")) {
			if (ncol(to) > 1) {
				warn("subst", "only the first column of 'to' is used with factors")
			}
			to <- as.vector(to[,1])
		}
		levs <- levels(x)[[1]]
		if (!raw) {
			from <- levs[,1][match(from, levs[,2])]
			if (all(is.na(from))) {
				warn("subst", "all 'from' values are missing, returning a copy of 'x'")
				return(deepcopy(x))
			}
		}
		i <- is.na(from)
		if (any(i)) {
			to <- rep_len(to, length(from))
			from <- from[!i]
			to <- to[!i]
		}
		if (!raw) {
			toto <- levs[,1][match(to, levs[,2])]
			if (any(is.na(toto))) { # add new levels
				i <- which(is.na(toto))
				m <- cbind(max(levs[,1]) + 1:length(i), to[i])
				colnames(m) <- colnames(levs)
				levs <- rbind(levs, m)
				to <- levs[,1][match(to, levs[,2])]
				levels(x) <- levs
			} else {
				to <- toto
			}
		}
		keepcats <- TRUE
	} else {
		if (fromc) {
			error("subst", "from has character values but x is not categorical")
		}
		if (!tom) {
			if (toc) {
				to <- as.factor(to)
				levels(x) <- data.frame(ID=1:length(levels(to)), value=levels(to))
				keepcats <- TRUE
			} else if (is.factor(to)) {
				levels(x) <- data.frame(ID=1:length(levels(to)), value=levels(to))
				keepcats <- TRUE			
			}
		}
	}
	
	if (is.null(others)) {
		setothers <- FALSE
		others <- NA
	} else {
		setothers <- TRUE
		others <- others[1]
	}
	
	if (tom) {
		nms <- colnames(to)
		if (!is.null(nms)) 	opt$names = nms
		x@pntr <- x@pntr$replaceValues(from, to, ncol(to), setothers, others, keepcats, opt)
	} else if (frm) {
		x@pntr <- x@pntr$replaceValues(as.vector(t(from)), to, -ncol(from), setothers, others, keepcats, opt)
	} else {
		x@pntr <- x@pntr$replaceValues(from, to, 0, setothers, others, keepcats, opt)
	}
	messages(x, "subst")
}
)


.getExt <- function(y, method="crop") {
	if (!inherits(y, "SpatExtent")) {
		e <- try(ext(y), silent=TRUE)
		if (inherits(e, "try-error")) {
			e <- try(ext(vect(y)), silent=TRUE)
			if (inherits(e, "try-error")) {
				error(method, "cannot get a SpatExtent from y")
			}
		}
		y <- e
	}
	y
}


setMethod("crop", signature(x="SpatRaster", y="ANY"),
	function(x, y, snap="near", mask=FALSE, touches=TRUE, extend=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		if (mask) {
			if (inherits(y, "SpatVector")) {
				x@pntr <- x@pntr$crop_mask(y@pntr, snap[1], touches[1], extend[1], opt)
			} else if (inherits(y, "sf")) {
				y <- vect(y)
				x@pntr <- x@pntr$crop_mask(y@pntr, snap[1], touches[1], extend[1], opt)
			} else if (inherits(y, "SpatRaster")) {
				mopt <- spatOptions(filename="", ...)
				e <- ext(y)
				x@pntr <- x@pntr$crop(e@pntr, snap[1], extend[1], mopt)
				x <- messages(x, "crop")
				if (compareGeom(x, y, lyrs=FALSE, crs=FALSE, warncrs=FALSE, ext=TRUE, rowcol=TRUE, res=FALSE, stopOnError=FALSE, messages=FALSE)) {
					return(mask(x, y, filename=filename, ...))
				} else {
					warn("crop", "cannot mask with a raster that is not aligned to x")
					# should check earlier if masking will be possible to avoid writing to disk twice.
					if (filename != "") {
						x <- writeRaster(x, filename, ...)
					}
					return(x)
				}
			} else {
				y <- .getExt(y, method="crop")
				warn("crop", paste("mask=TRUE is ignored for", class(y)[1], "objects"))
				x@pntr <- x@pntr$crop(y@pntr, snap[1], extend[1], opt)
			}
		} else {
			y <- .getExt(y, method="crop")
			x@pntr <- x@pntr$crop(y@pntr, snap[1], extend[1], opt)
		}
		messages(x, "crop")
	}
)


setMethod("crop", signature(x="SpatRasterDataset", y="ANY"),
	function(x, y, snap="near", extend=FALSE) {
		opt <- spatOptions()
		y <- .getExt(y, method="crop")
		x@pntr <- x@pntr$crop(y@pntr, snap[1], extend[1], opt)
		messages(x, "crop")
	}
)

setMethod("crop", signature(x="SpatRasterCollection", y="ANY"),
	function(x, y, snap="near", extend=FALSE) {
		y <- .getExt(y, method="crop")
		opt <- spatOptions()
		x@pntr <- x@pntr$crop(y@pntr, snap[1], extend[1], double(), opt)
		messages(x, "crop")
	}
)


setMethod("selectRange", signature(x="SpatRaster"),
	function(x, y, z=1, repint=0, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$selRange(y@pntr, z, repint, opt)
		messages(x, "selectRange")
	}
)

setMethod("cover", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, values=NA, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$cover(y@pntr, values, opt)
		messages(x, "cover")
	}
)

setMethod("cover", signature(x="SpatRaster", y="missing"),
	function(x, y, values=NA, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$cover_self(values, opt)
		messages(x, "cover")
	}
)


setMethod("diff", signature(x="SpatRaster"),
	function(x, lag=1, filename="", ...) {
		n <- nlyr(x)
		lag <- round(lag)
		if ((lag < 1) | (lag >= n)) {
			error("diff", "lag must be > 0 and < nlyr(x)")
		}
		y <- x[[-((n-lag+1):n)]]
		x <- x[[-(1:lag)]]
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$arith_rast(y@pntr, "-", FALSE, opt)
		messages(x, "diff")
	}
)


setMethod("disagg", signature(x="SpatRaster"),
	function(x, fact, method="near", filename="", ...) {
		method <- match.arg(tolower(method), c("near", "bilinear"))
		if (method == "bilinear") {
			y <- disagg(rast(x), fact)
			r <- resample(x, y, "bilinear", filename=filename, ...)
			return(r)
		}
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$disaggregate(fact, opt)
		messages(x, "disagg")
	}
)


setMethod("flip", signature(x="SpatRaster"),
	function(x, direction="vertical", filename="", ...) {
		d <- match.arg(direction, c("vertical", "horizontal"))
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$flip(d == "vertical", opt)
		messages(x, "flip")
	}
)



setMethod("mask", signature(x="SpatRaster", mask="SpatRaster"),
	function(x, mask, inverse=FALSE, maskvalues=NA, updatevalue=NA, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$mask_raster(mask@pntr, inverse[1], maskvalues, updatevalue[1], opt)
		messages(x, "mask")
	}
)

setMethod("mask", signature(x="SpatRaster", mask="SpatVector"),
	function(x, mask, inverse=FALSE, updatevalue=NA, touches=TRUE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$mask_vector(mask@pntr, inverse[1], updatevalue[1], touches[1], opt)
		messages(x, "mask")
	}
)

setMethod("mask", signature(x="SpatRaster", mask="SpatExtent"),
	function(x, mask, inverse=FALSE, updatevalue=NA, touches=TRUE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		mask <- vect(mask, crs=crs(x))
		x@pntr <- x@pntr$mask_vector(mask@pntr, inverse[1], updatevalue[1], touches[1], opt)
		messages(x, "mask")
	}
)


setMethod("mask", signature(x="SpatRaster", mask="sf"),
   function(x, mask, inverse=FALSE, updatevalue=NA, touches=TRUE, filename="", ...) {
		mask <- vect(mask)
		mask(x, mask, inverse=inverse, updatevalue=updatevalue, touches=touches, filename=filename, ...)
	}
)

setMethod("project", signature(x="SpatRaster"),
	function(x, y, method, mask=FALSE, align_only=FALSE, res=NULL, origin=NULL, threads=FALSE, use_gdal=TRUE, by_util=FALSE, pipeline="", AOI=NULL, desired_accuracy=-1.0, allow_approx=TRUE, filename="", ...)  {

		xscale=0
		yscale=0
		
		if (missing(method)) {
			if (is.factor(x)[1] || isTRUE(x@pntr$rgb)) {
				method <- "near"
			} else {
				method <- "bilinear"
			}
		} else {
			method <- .makeTextFun(method)
			if (!inherits(method, "character")) {
				error("project", "not a valid method argument")
			}
			method <- match.arg(tolower(method[1]), c("near", "bilinear", "cubic", "cubicspline", "lanczos", "mean", "average", "sum", "mode", "min", "q1", "median", "q3", "max", "rms"))
			method[method == "mean"] <- "average"
		}

		opt <- spatOptions(filename, threads=threads, ...)

		if (is.list(pipeline)) {
			px <- attr(pipeline, "from")			
			py <- attr(pipeline, "to")
			if ((!is.null(px)) && crs(px) != crs(x)) {
				warn("project", "pipeline input crs does not match (crs(x))")			
			}

			if (crs(px) != crs(x)) {
				warn("project", "pipeline input crs does not match (crs(x))")			
			}
			pipeline <- pipeline$definition 
			if (missing(y)) {
				y <- py
			} else {
				if (crs(py) != crs(y)) {
					warn("project", "pipeline output crs does not match (crs(y))")
				}
			}
		} else if (!inherits(pipeline, "character")) {
			error("project", "pipeline should be data.frame, list, or character value")
		}
		if (length(pipeline) != 1) {
			error("project", "privode a single pipeline")
		}

		if (missing(y)) {
			error("project", "y (SpatRaster or output crs) cannot be missing")
		}
		if (inherits(y, "numeric")) {
			error("project", "argument y cannot be a number. For EPSG codes use format 'epsg:1234'")			
		}


		if (is.null(AOI)) {
			aoi <- numeric(0)
		} else {
			aoi <- try(ext(AOI), silent=TRUE)
			if (inherits(AOI, "try-error")) {
				error("project", "AOI must be or have a SpatExtent")
			}
			aoi <- as.vector(aoi)[c(1,3,2,4)]
		}

		bp <- isTRUE(allow_approx)

		if (inherits(y, "SpatRaster")) {
			if (use_gdal) {
				if (by_util) {
					x@pntr <- x@pntr$warp_by_util(y@pntr, "", method, mask[1], align_only[1], FALSE, pipeline, aoi, desired_accuracy, bp, xscale, yscale, opt)
				} else {
					x@pntr <- x@pntr$warp(y@pntr, "", method, mask[1], align_only[1], FALSE, pipeline, aoi, desired_accuracy, bp, xscale, yscale, opt)
				}
			} else {
				if (align_only) {
					y <- project(rast(x), y, align_only=TRUE)
				}
				x@pntr <- x@pntr$resample(y@pntr, method, mask[1], TRUE, opt)
			}
		} else {
			if (!is.character(y)) {
				y <- as.character(crs(y))
			} else {
				y <- character_crs(y, "project")
			}
			if (!is.null(res) || !is.null(origin)) {
				tmp <- project(rast(x), y)
				if (!is.null(res)) res(tmp) <- res
				if (!is.null(origin)) origin(tmp) <- origin
				return(project(x, tmp, method=method, mask=mask, align_only=align_only, filename=filename, use_gdal=use_gdal, by_util=by_util, pipeline=pipeline, AOI=AOI, desired_accuracy=desired_accuracy, allow_approx=allow_approx, ...))
			}
			if (use_gdal) {
				if (by_util) {
					x@pntr <- x@pntr$warp_by_util(SpatRaster$new(), y, method, mask, FALSE, FALSE, pipeline, aoi, desired_accuracy, bp, xscale, yscale, opt)
				} else {
					x@pntr <- x@pntr$warp(SpatRaster$new(), y, method, mask, FALSE, FALSE, pipeline, aoi, desired_accuracy, bp, xscale, yscale, opt)
				}
			} else {
				y <- project(rast(x), y)
				x@pntr <- x@pntr$resample(y@pntr, method, mask[1], TRUE, opt)
			}
		}
		messages(x, "project")
	}
)


warp_scale <- function(x, y, n=21) {
	stopifnot(inherits(x, "SpatRaster"))
	if (!inherits(y, "SpatRaster")) {
		y <- project(rast(x), as.character(y))
	}
	n <- as.integer(n)[1]
	if (is.na(n) || n < 3) n <- 3L
	v <- x@pntr$warp_scale(y@pntr, n)
	messages(x, "warp_scale")
	probs <- c("0%", "25%", "50%", "75%", "100%")
	list(
		xscale = setNames(v[1:5],  probs),
		yscale = setNames(v[6:10], probs)
	)
}


setMethod("project", signature(x="SpatVector"),
	function(x, y, partial=FALSE, pipeline="", AOI=NULL, desired_accuracy=-1, allow_approx=TRUE)  {

		if (is.list(pipeline)) {
			px <- attr(pipeline, "from")			
			py <- attr(pipeline, "to")
			pipeline <- pipeline$definition 
			if (missing(y)) {
				y <- py
				if (is.null(y)) {
					y <- ""
				}
			} else {
				if (crs(py) != crs(y)) {
					warn("project", "pipeline output crs does not match (crs(y))")
				}
			}
			if (crs(px) != crs(x)) {
				warn("project", "pipeline input crs does not match (crs(x))")			
			}
		} else if (!inherits(pipeline, "character")) {
			error("project", "pipeline should be data.frame, list, or character value")
		}
		if (length(pipeline) != 1) {
			error("project", "privode a single pipeline")
		}
		if (missing(y)) {
			error("project", "y (output crs) cannot be missing")
		}
		if (inherits(y, "numeric")) {
			error("project", "argument y cannot be a number.\nFor EPSG codes use this format 'epsg:1234'")
		}
		if (!is.character(y)) {
			y <- as.character(crs(y))
		} else {
			y <- character_crs(y, "project")
		}

		if (is.null(AOI)) {
			aoi <- numeric(0)
		} else {
			aoi <- try(ext(AOI), silent=TRUE)
			if (inherits(AOI, "try-error")) {
				error("project", "AOI must be or have a SpatExtent")
			}
			aoi <- as.vector(aoi)[c(1,3,2,4)]
		}
		x@pntr <- x@pntr$project(y, partial, pipeline, aoi, desired_accuracy, isTRUE(allow_approx))
		messages(x, "project")
	}
)


setMethod("project", signature(x="SpatVectorCollection"),
	function(x, y, partial=FALSE, pipeline=NULL, AOI=NULL, desired_accuracy=-1.0, allow_ballpark=TRUE)  {
		x <- lapply(x, function(v) project(v, y, partial=partial, pipeline=pipeline, AOI=AOI,
						desired_accuracy=desired_accuracy, allow_ballpark=allow_ballpark))
		svc(x)
	}
)



setMethod("project", signature(x="SpatExtent"),
	function(x, from, to)  {
		if (missing(from)) error("project", "'from' cannot be missing")
		if (missing(to)) error("project", "'to' cannot be missing")
		x <- as.polygons(x, crs=from)
		x <- densify(x, 10000)
		ext(project(x, to))
	}
)

setMethod("project", signature(x="matrix"),
    function(x, from, to)  {
        if (ncol(x) != 2) {
			error("project", "x must have two columns")
		}
        if (missing(from)) {
			error("project", "'from' cannot be missing")
		}
        if (missing(to)) {
			error("project", "'to' cannot be missing")
		}
        if (!is.character(from)) {
           from <- as.character(crs(from))
        }
        if (!is.character(to)) {
           to <- as.character(crs(to))
        }
		#v <- vect(x, type="line", crs=from)
        #v@pntr <- v@pntr$project(to)
        v <- vect()
		xy <- v@pntr$project_xy(x[,1], x[,2], from, to)
		messages(v, "project")
		matrix(xy, ncol=2)
    }
)


setMethod("quantile", signature(x="SpatRaster"),
	function(x, probs=seq(0, 1, 0.25), na.rm=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$quantile(probs, na.rm[1], opt)
		messages(x, "quantile")
	}
)


setMethod("quantile", signature(x="SpatVector"),
	function(x, probs=seq(0, 1, 0.25), ...) {
		x <- values(x)
		cls <- sapply(x, class)
		i <- cls != "character"
		if (!any(i)) error("quantile", "no numeric variables")
		x <- x[, i, drop=FALSE]
		apply(x, 2, function(i) quantile(i, probs=probs, ...))
	}
)


setMethod("rectify", signature(x="SpatRaster"),
	function(x, method="bilinear", aoi=NULL, snap=TRUE, threads=FALSE, filename="", ...) {
		opt <- spatOptions(filename, threads=threads, ...)
		if (!is.null(aoi)) {
			if (inherits(aoi, "SpatExtent")) {
				aoi <- rast(aoi)
				useaoi <- 1
			} else if (inherits(aoi, "SpatRaster")) {
				aoi <- rast(aoi)
				useaoi <- 2
			} else {
				error("rectify", "ext must be a SpatExtent or SpatRaster")
			}
		} else {
			aoi <- rast()
			useaoi <- 0
		}
		snap <- as.logical(snap)
		x@pntr <- x@pntr$rectify(method, aoi@pntr, useaoi, snap, opt)
		messages(x, "rectify")
	}
)


resample_method <- function(x, method) {
	if (missing(method)) {
		if (is.factor(x)[1] || isTRUE(x@pntr$rgb)) {
			method <- "near"
		} else {
			method <- "bilinear"
		}
	} else {
		mts <- c("near", "bilinear", "cubic", "cubicspline", "lanczos", "mean", "sum", "modal", "min", "q1", "median", "q3", "max", "rms")
		if (!inherits(method, "character")) {
			method <- .makeTextFun(method)
			if (!inherits(method, "character")) {
				error("resample", paste("Not a valid method. Use one of:", paste(mts, collapse=", ")))
			}
		}
		method <- match.arg(tolower(method[1]), c(mts, "average", "mode"))
		method[method == "mean"] <- "average"
		method[method == "modal"] <- "mode"
	}
	method
}
	

setMethod("resample", signature(x="SpatRaster", y="numeric"),
	function(x, y, method, threads=FALSE, by_util=FALSE, filename="", ...)  {

		stopifnot(all(y > 0))
		stopifnot(length(y) <= 2)
		fact <- rep_len(y, 2)
		r <- rast(x)
		res(r) <- res(r) * fact
		r <- crop(extend(r, c(0,1,0,1)), ext(x), snap="out") 
		if (!hasValues(x)) { 
			return(r)
		}	
		method <- resample_method(x, method)
		resample(x, r, method, threads=threads, by_util=by_util, filename=filename, ...)
	}
)


setMethod("resample", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, method, threads=FALSE, by_util=FALSE, filename="", ...)  {

		method <- resample_method(x, method)
		xcrs = crs(x)
		ycrs = crs(y)
		if ((xcrs == "") && (ycrs != "")) {
			crs(x) <- ycrs
		}
		if ((ycrs == "") && (xcrs != "")) {
			crs(y) <- xcrs
		}
		opt <- spatOptions(filename, threads=threads, ...)

		if (by_util) {
			x@pntr <- x@pntr$warp_by_util(y@pntr, "", method, FALSE, FALSE, TRUE, "", numeric(0), -1.0, TRUE, 0, 0, opt)
		} else {
			x@pntr <- x@pntr$warp(y@pntr, "", method, FALSE, FALSE, TRUE, "", numeric(0), -1.0, TRUE, 0, 0, opt)
		}
		messages(x, "resample")
	}
)



setMethod("impose", signature(x="SpatRasterCollection"),
	function(x, y, filename="", ...)  {
		stopifnot(inherits(y, "SpatRaster"))
		opt <- spatOptions(filename, ...)
		r <- rast()
		r@pntr <- x@pntr$morph(y@pntr, opt)
		messages(r, "impose")
	}
)



setMethod("rev", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions("", FALSE, list())
		x@pntr <- x@pntr$reverse(opt)
		messages(x, "rev")
	}
)

setMethod("rotate", signature(x="SpatRaster"),
	function(x, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$rotate(TRUE, opt)
		messages(x, "rotate")
	}
)

setMethod("rotate", signature(x="SpatVector"),
	function(x, longitude=0, split=TRUE, left=TRUE, normalize=FALSE) {
		if (split) {
			e <- ext(x)
			if ((longitude < e$xmin) || (longitude > e$xmax)) {
				if (left) {
					return(shift(x, -360))
				} else {
					return(shift(x, 360))
				}
			}
			e <- as.vector(floor(e) + 1)
			ew <- ext(c(e[1], longitude, e[3:4]))
			ee <- ext(c(longitude, e[2:4]))
			x$unique_id_for_aggregation <- 1:nrow(x)
			xcrs <- crs(x)
			crs(x) <- NULL  # avoid wrapping
			xw <- crop(x, ew)
			xe <- crop(x, ee)
			if (left) {
				xe <- shift(xe, -360)
			} else {
				xw <- shift(xw, 360)
			}
			out <- rbind(xe, xw)
			if (nrow(out) > nrow(x)) {
				out <- aggregate(out, "unique_id_for_aggregation", id=F)
				i <- match(out$unique_id_for_aggregation, x$unique_id_for_aggregation)
				values(out) <- values(x)[i,,drop=FALSE]
				x <- out
			} 
			x$unique_id_for_aggregation <- NULL
			crs(x) <- xcrs
		} else {
			x@pntr <- x@pntr$rotate_longitude(longitude, left)
			x <- messages(x, "rotate")
		}
		if (normalize) {
			x <- normalize.longitude(x)
		}
		x
	}
)

setMethod("segregate", signature(x="SpatRaster"),
	function(x, classes=NULL, keep=FALSE, other=0, round=FALSE, digits=0, filename="", ...) {
		opt <- spatOptions(filename, ...)
		if (is.null(classes)) classes <- 1[0]
		x@pntr <- x@pntr$separate(classes, keep[1], other[1], round[1], digits[1], opt)
		messages(x, "segregate")
	}
)


setMethod("shift", signature(x="SpatRaster"),
	function(x, dx=0, dy=0, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$shift(dx, dy, opt)
		messages(x, "shift")
	}
)


setMethod("shift", signature(x="SpatExtent"),
	function(x, dx=0, dy=0) {
		s <- c(dx[1], dx[1], dy[1], dy[1])
		ext(as.vector(x) + s)
	}
)


setMethod("shift", signature(x="SpatVector"),
	function(x, dx=0, dy=0) {
		x@pntr <- x@pntr$shift(dx, dy)
		messages(x, "shift")
	}
)

setMethod("rescale", signature(x="SpatRaster"),
	function(x, fx=0.5, fy=fx, x0, y0) {
		stopifnot(fx > 0)
		stopifnot(fy > 0)
		e <- as.vector(ext(x))
		if (missing(x0)) {
			x0 <- mean(e[1:2])
		}
		if (missing(y0)) {
			y0 <- mean(e[3:4])
		}
		ex = x0 + fx * (e[1:2] - x0);
		ey = y0 + fy * (e[3:4] - y0);
		x@pntr <- x@pntr$deepcopy()
		ext(x) <- ext(c(ex, ey))
		messages(x, "rescale")
	}
)

setMethod("rescale", signature(x="SpatVector"),
	function(x, fx=0.5, fy=fx, x0, y0) {
		stopifnot(fx > 0)
		stopifnot(fy > 0)
		e <- as.vector(ext(x))
		if (missing(x0)) {
			x0 <- mean(e[1:2])
		}
		if (missing(y0)) {
			y0 <- mean(e[3:4])
		}
		x@pntr <- x@pntr$rescale(fx, fy, x0[1], y0[1])
		messages(x, "rescale")
	}
)

setMethod("scale_linear", signature(x="SpatRaster"),
	function(x, min=0, max=1, filename="", ...) {
		opt <- spatOptions(filename=filename, ...)
		x@pntr <- x@pntr$scale_linear(min, max, opt)
		messages(x, "scale_linear")
	}
)

setMethod("scale", signature(x="SpatRaster"),
	function(x, center=TRUE, scale=TRUE) {

		opt <- spatOptions()

		if (is.logical(center)) {
			docenter = center[1];
			center = 1[0]
		} else {
			docenter = TRUE
		}
		if (is.logical(scale)) {
			doscale = scale[1]
			scale = 1[0]
		} else {
			doscale = TRUE;
		}
		x@pntr <- x@pntr$scale(center, docenter, scale, doscale, opt)
		messages(x, "scale")
	}
)



setMethod("stretch", signature(x="SpatRaster"),
	function(x, minv=0, maxv=255, minq=0, maxq=1, smin=NA, smax=NA, histeq=FALSE, scale=1, maxcell=500000, bylayer=TRUE, filename="", ...) {
		if (histeq) {
			nms <- names(x)
			wopt <- list(...)
			if (is.null(wopt$names)) {
				wopt$names <- nms
			}

			if (bylayer) {	
				if (nlyr(x) > 1) {
					x <- lapply(1:nlyr(x), function(i) stretch(x[[i]], histeq=TRUE, scale=scale, maxcell=maxcell, bylayer=TRUE))
					x <- rast(x)
					names(x) <- nms 
					if (filename != "") {
						x <- writeRaster(x, filename=filename, ...)
					}
					return(x)
				}
				scale <- scale[1]
				if (scale == 1) {
					ecdfun <- stats::ecdf(na.omit(spatSample(x, maxcell, "regular")[,1]))
				} else {
					ecdfun <- function(y) {
						f <- stats::ecdf(na.omit(spatSample(x, maxcell, "regular")[,1]))
						f(y) * scale
					}
				}
				app(x, ecdfun, filename=filename, wopt=wopt)
			} else {
				scale <- scale[1]
				ecdfun <- stats::ecdf(na.omit(unlist(spatSample(x, maxcell, "regular"))))
				if (scale == 1) {
					app(x, ecdfun, filename=filename, wopt=wopt)
				} else {
					out <- app(x, ecdfun) * scale
					names(out) <- nms
					if (filename != "") {
						x <- writeRaster(x, filename=filename, ...)
					}
					x
				}
			}
		} else {
			opt <- spatOptions(filename, ...)
			x@pntr <- x@pntr$stretch(minv, maxv, minq, maxq, smin, smax, bylayer, maxcell, opt)
			messages(x, "stretch")
		}
	}
)



setMethod("summary", signature(object="SpatRaster"),
	function(object, size=100000, warn=TRUE, ...)  {
		if (!hasValues(object)) {
			warn("summary", "SpatRaster has no values")
			return(invisible())
		}
		if (warn && (ncell(object) > size)) {
			warn("summary", "used a sample")
		}
		s <- spatSample(object, size, method="regular", warn=FALSE)
		summary(s, ...)
	}
)


setMethod("summary", signature(object="SpatVector"),
	function(object, ...)  {
		summary(as.data.frame(object), ...)
	}
)


setMethod("t", signature(x="SpatRaster"),
	function(x) {
		opt <- spatOptions()
		x@pntr <- x@pntr$transpose(opt)
		messages(x, "t")
	}
)

setMethod("t", signature(x="SpatVector"),
	function(x) {
		x@pntr <- x@pntr$transpose()
		messages(x, "t")
	}
)


setMethod("terrain", signature(x="SpatRaster"),
	function(x, v="slope", neighbors=8, unit="degrees", filename="", ...) {
		unit <- match.arg(unit, c("degrees", "radians"))
		opt <- spatOptions(filename, ...)
		seed <- ifelse("flowdir" %in% v, .seed(), 0)
		x@pntr <- x@pntr$terrain(v, neighbors[1], unit=="degrees", seed, opt)
		messages(x, "terrain")
	}
)


setMethod("viewshed", signature(x="SpatRaster"),
	function(x, loc, observer=1.80, target=0, curvcoef=6/7, output="yes/no", filename="", ...) {
		opt <- spatOptions(filename, ...)
		z <- rast()
		if (length(loc) == 1) {
			loc <- xyFromCell(x, loc)
		}
		outops <- c("yes/no", "sea", "land")
		output <- match.arg(tolower(output), outops)
		output <- match(output, outops)
		z@pntr <- x@pntr$view(c(loc[1:2], observer[1], target[1]), c(1,0,2,3), curvcoef, 2, 0, output, opt)
		messages(z, "viewshed")
	}
)

setMethod("sieve", signature(x="SpatRaster"),
	function(x, threshold, directions=8, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$sieve(threshold[1], directions[1], opt)
		messages(x, "sieve")
	}
)


setMethod("trim", signature(x="SpatRaster"),
	function(x, padding=0, value=NA, filename="", ...) {
		opt <- spatOptions(filename, ...)
		padding <- round(padding[1])
		if (padding < 0) {
			error("trim", "padding must be a non-negative integer")
		}
		x@pntr <- x@pntr$trim(value[1], padding, opt)
		messages(x, "trim")
	}
)

setMethod("trans", signature(x="SpatRaster"),
	function(x, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$transpose(opt)
		messages(x, "trans")
	}
)


setMethod("unique", signature(x="SpatRaster", incomparables="ANY"),
	function(x, incomparables=FALSE, digits=NA, na.rm=TRUE, as.raster=FALSE) {

		opt <- spatOptions()

		if (as.raster) {
			if (nlyr(x) == 1) return(x)
			incomparables = FALSE
		}
		
		u <- x@pntr$unique(incomparables, digits, na.rm[1], opt)

		if (!as.raster) {
			u <- get_labels(x, u)
		}
		
		if (!incomparables) {
			#if (!length(u)) return(u)
			u <- do.call(data.frame, u)
			colnames(u) <- names(x)
			if (nrow(u) == 0) {
				if (as.raster) {
					return(deepcopy(x))
				} else {
					return(NULL)
				}
			}
		}

		if ((!incomparables) && (na.rm || as.raster)) {
			i <- rowSums(is.na(u)) < ncol(u)
			u <- u[i, , drop=FALSE]
		}

		if (as.raster) {
			lab <- apply(get_labels(x, u), 1, function(i) paste(i, collapse="_"))
			if (!is.na(digits)) {
				x <- round(x, digits)
			} else {
				levels(x) <- NULL
			}
			uid <- 1:nrow(u)		
			x <- subst(x, u, uid-1)
			set.cats(x, 1, data.frame(ID=uid-1, label=lab, u))
			return(x)
		}
		u
	}
)


setMethod("unique", signature(x="SpatVector", incomparables="ANY"),
	function(x, incomparables=FALSE, geom=TRUE, atts=TRUE, ...) {
		if (geom && atts) {
			u <- unique(as.data.frame(x, geom="WKT"), incomparables=incomparables, ...)
			vect(u, geom="geometry", crs(x))
		} else if (geom) {
			g <- geom(x, hex=TRUE)
			i <- !duplicated(g, ...)
			x[i,]
		} else if (atts) {
			d <- data.frame(x)
			i <- !duplicated(d, ...)
			x[i,]
		} else {
			warn("unique", "geom and atts are both FALSE")
			x
		}
	}
)


setMethod("labels", signature(object="SpatRaster"),
	function(object, ...)  {
		names(object)
	}
)


setMethod("scoff", signature(x="SpatRaster"),
	function(x) {
		out <- x@pntr$getScaleOffset()
		names(out) <- c("scale", "offset")
		do.call(cbind, out)
	}
)

setMethod("scoff<-", signature("SpatRaster"),
	function(x, value) {
		if (is.null(value)) {
			x@pntr <- x@pntr$deepcopy()
			x@pntr$setScaleOffset(1, 0)
		} else {
			if (NCOL(value) != 2) {
				error("scoff<-", "value must be a 2-column matrix")
			}
			x@pntr <- x@pntr$deepcopy()
			value[is.na(value[,1]),1] <- 1
			value[is.na(value[,2]),2] <- 0
			x@pntr$setScaleOffset(value[,1], value[,2])
			x@pntr$setValueType(0)
		}
		messages(x, "scoff<-")
	}
)

setMethod("sort", signature(x="SpatRaster"),
	function (x, decreasing=FALSE, order=FALSE, filename="", ...) {
		opt <- spatOptions(filename, ...)
		x@pntr <- x@pntr$sort(decreasing[1], order[1], opt)
		messages(x, "sort")
	}
)


setMethod("sort", signature(x="SpatVector"),
	function (x, v, decreasing=FALSE) {
		if (is.logical(v)) {
			tmp <- v
			v <- decreasing 
			decreasing <- tmp
		}
		if (length(v) > 1) {
			v <- data.frame(x)[,v]
			i <- do.call(order, lapply(v, function(i) i))
		} else {
			i <- order(x[[v]][[1]], decreasing=decreasing)
		}
		x[i, ]
	}
)


setMethod("sort", signature(x="data.frame"),
	function (x, v, decreasing=FALSE) {
		if (length(v) > 1) {
			v <- data.frame(x)[, v]
			i <- do.call(order, lapply(v, function(i) i))
		} else {
			i <- order(x[[v]], decreasing=decreasing)
		}
		x[i, ]
	}
)


setMethod("merge", signature(x="SpatVector", y="data.frame"),
	function(x, y, ...) {
		v <- values(x)
		v$unique_nique_ique_que_e <- 1:nrow(v)
		m <- merge(v, y, ...)
		m <- m[order(m$unique_nique_ique_que_e), ]
		x <- x[stats::na.omit(m$unique_nique_ique_que_e), ]
		m$unique_nique_ique_que_e <- NULL
		if (nrow(m) > nrow(x)) {
			error("merge", "using 'all.y=TRUE' is not allowed. Should it be?")
		}
		values(x) <- m
		x
	}
)

setMethod("merge", signature(x="SpatVector", y="SpatVector"),
	function(x, y, ...) {
		merge(x, data.frame(y), ...)
	}
)


setMethod("merge", signature(x="SpatRasterCollection", "missing"),
	function(x, first=TRUE, na.rm=TRUE, algo=1, resample=FALSE, method="", filename="", ...) {
		opt <- spatOptions(filename, ...)
		out <- rast()
		if (is.null(method)) method = ""
		out@pntr <- x@pntr$merge(first[1], na.rm, algo, resample, method, opt)
		if (algo == 3) {
			messages(opt, "merge")
		}
		messages(x, "merge")
		messages(out, "merge")
	}
)

setMethod("merge", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, ..., first=TRUE, na.rm=TRUE, algo=1, resample=FALSE, method="", filename="", overwrite=FALSE, wopt=list()) {
		rc <- sprc(x, y, ...)
		merge(rc, first=first, na.rm=na.rm, algo=algo, resample=resample, method=method, filename=filename, overwrite=overwrite, wopt=wopt)
	}
)



setMethod("mosaic", signature(x="SpatRasterCollection", "missing"),
	function(x, fun="mean", resample=FALSE, method="", filename="", ...) {
		opt <- spatOptions(filename, ...)
		out <- rast()
		fun <- .makeTextFun(fun)
		if (!inherits(fun, "character")) {
			error("mosaic", "function 'fun' is not valid")
		}
		if (is.null(method)) method = ""
			out@pntr <- x@pntr$mosaic(fun, resample, method, opt)
		messages(out, "mosaic")
	}
)

setMethod("mosaic", signature(x="SpatRaster", y="SpatRaster"),
	function(x, y, ..., fun="mean", resample=FALSE, method="", filename="", overwrite=FALSE, wopt=list()) {
		rc <- sprc(x, y, ...)
		mosaic(rc, fun=fun, resample=resample, method=method, filename=filename, overwrite=overwrite, wopt=wopt)
	}
)



setMethod("tessellate", signature(x="ANY"),
	function(x, size, n, type="hexagon", flat_top=FALSE, align="fit", geo=NULL) {

		type <- match.arg(tolower(type), c("hexagons", "rectangles", "polyhedron"))
		globe <- missing(x)		
		if (globe) {
			e <- ext(-180, 180, -90, 90)
			crs <- "lonlat"		
		} else {
			if (inherits(x, "SpatExtent")) {
				if (isTRUE(geo)) {
					crs <- "lonlat"
				} else if (is.null(geo)) {
					if (is.lonlat(rast(x), perhaps=TRUE, warn=TRUE)) {
						crs <- "lonlat"
					} else {
						crs <- "local"					
					}
				} else {
					crs <- "local"
				}
				e <- x
			} else {
				crs <- try(crs(x), silent=TRUE)
				if (inherits(crs, "try-error")) crs <- ""
				e <- try(ext(x), silent=TRUE)
				if (inherits(e, "try-error")) {
					error("tessellate", "cannot extract a SpatExtent from x")
				}
			}
		}

		if ((type=="polyhedron") && (!missing(n))) {
			if (!isTRUE(n >= 1)) {
				error("tessellate", "n must be >= 1")			
			}
		} else if (missing(size) || length(size) != 1 || !is.finite(size) || size <= 0) {
			error("tessellate", "size must be a single positive number")
		}
		crs <- character_crs(crs, "tessellate")
		if ((crs=="") && isTRUE(geo)) crs <- "lonlat"

		v <- methods::new("SpatVector")
		v@pntr <- SpatVector$new()
		
		if (isTRUE((crs != "") && is.lonlat(crs, perhaps=TRUE))) {
			if (type=="polyhedron") {
				if (missing(n)) {
					# total cells = 10 n^2 + 2; mean cell area = 4 pi R^2 / total;
					# regular hex has area sqrt(3)/2 * size^2.
					R <- 6378137
					C_target <- 8 * pi * R^2 / (sqrt(3) * size^2)
					n <- round(sqrt(max(1, (C_target - 2) / 10)))
				} 
				max(1, n)
				v@pntr <- v@pntr$polyhedron(e@pntr, as.integer(n), isTRUE(globe))
			} else if (type == "rectangles") {
				align_mode <- match.arg(tolower(align), c("fit", "equal", "cube"))
				align_int <- match(align_mode, c("fit", "equal", "cube")) - 1L
				v@pntr <- v@pntr$rectangles_lonlat(e@pntr, size, align_int)		
			} else {
				v@pntr <- v@pntr$hexagons_lonlat(e@pntr, size, isTRUE(flat_top))
			}
		} else {
			if (type == "polyhedron") {
				error("tessellate", "polyhedron is only available for lon/lat data")
			} else if (type == "rectangles") {
				if (inherits(x, "SpatRasterDataset")) {
					if (length(sds) > 0) {
						x <- sds[1]
					}
				}
				if (!inherits(x, "SpatRaster")) {
					r <- rast(e, res=sqrt(size))
				}
				return(as.polygons(x))
			} else {
				v@pntr <- v@pntr$hexagons(e@pntr, size, crs, isTRUE(flat_top), NaN, NaN)
			}
		}
		messages(v, "tessellate")
	}
)

# Author: Robert J. Hijmans
# Date : October 2018
# Version 1.0
# License GPL v3

## from stars
#stars:::st_as_raster is used
#setAs("stars", "SpatRaster") is provided by stars via st_as_raster


from_stars <- function(from) {

	isProxy <- inherits(from, "stars_proxy")
	natts <- length(from)
	#from[i] recursion does not work with proxy
	if (!isProxy && (natts > 1)) { # not sure what attributes represent
		ra <- list()
		for (i in 1:natts) {
			ra[[i]] <- from_stars(from[i])
		}
		if (all(sapply(ra, function(i) inherits(i, "SpatRaster")))) {
			nl <- sapply(ra, nlyr)
			ra <- rast(ra)
			nms <- names(ra)
			names(ra) <- paste(rep(names(from), nl), nms, sep="_")
		} else 	if (all(sapply(ra, function(i) inherits(i, "SpatRasterDataset")))) {
			ra <- do.call(c, ra)
		} else {
			ra <- lapply(ra, function(i) if (!inherits(i, "SpatRasterDataset")) {sds(i)} else {i})
			ra <- do.call(c, ra)
		}
		return(ra)
	}

	dims <- attr(from, "dimensions")
	dd <- dim(from)

	# x, y
	hasBands <- "band" %in% names(dd)
	hasTime <- "time" %in% names(dd)
	timev <- NULL
	if (hasTime) {
		tim <- dims$time$offset
		tseq <- dims$time$from:dims$time$to
		if (dims$time$refsys == "Date") {
			timev <- as.Date(tim) + tseq
		} else { # for now
			timev <- tseq
		}
	}

	# no time or variables
	if (length(dd) - hasBands == 2) {
		return( methods::as(from, "SpatRaster"))
	}


	# time, perhaps bands or variables
	if (length(dd) - (hasTime + hasBands) == 2) {
		r <- methods::as(from, "SpatRaster")
		if (hasBands) {
			timev <- rep(timev, each=dd["band"])
		}
		time(r) <- timev
		return(r)
	}

	if (isProxy) {
		# currently not setting time dim here
		if (natts > 1) {
			ff <- sapply(from, function(i) from[i][[1]])
			s <- sds(ff)
			names(s) <- names(from)
		} else {
			f <- from[[1]]
			s <- sds(f)
			nms <- names(dd)[3+hasBands]
			if (!is.na(nms)) {
				names(s) <- paste(nms, 1:length(s), sep="-")
			}
		}
		return(s)
	}

	xmin <- dims$x$offset
	nc <- dims$x$to
	xmax <- xmin + nc * dims$x$delta
	ymax <- dims$y$offset
	nr <- dims$y$to
	ymin <- ymax + nr * dims$y$delta

	from <- from[[1]]
	rr <- list()
	if (hasTime && hasBands) {
		for (i in 1:dd[5]) {
			x <- from[,,,,i]
			r <- rast(ncols=nc, nrows=nr, xmin=xmin, xmax=xmax, ymin=ymin, ymax=ymax, crs=dims$x$refsys$wkt, nlyr=dd["band"] * dd["time"])
			time(r) <- rep(timev, each=dd["band"])
			bandnames <- rep(paste("band", 1:dd["band"], sep="-"), length(timev))
			names(r) <- paste(bandnames, rep(timev, each=dd["band"]), sep="_")
			r <- setValues(r, as.vector(x))
			rr[[i]] <- r
		}
	} else { #if (hasTime || hasBands) {
		for (i in 1:dd[4]) {
			x <- from[,,,i]
			r <- rast(ncols=nc, nrows=nr, xmin=xmin, xmax=xmax, ymin=ymin, ymax=ymax, crs=dims$x$refsys$wkt, nlyr=dim(x)[3], time=timev)
			if (hasBands) {
				names(r) <- paste("band", 1:dd["band"], sep="-")
			} else {
				names(r) <- timev
			}
			rr[[i]] <- setValues(r, x)
		}
	}
	s <- sds(rr)
	names(s) <- paste(names(dd)[4], 1:length(s), sep="-")
	s
}



setAs("stars", "SpatRasterDataset",
	function(from) {
		from_stars(from)
	}
)

setAs("ggmap", "SpatRaster",
	function(from) {
		b <- attr(from, "bb")
		e <- ext(b$ll.lon, b$ur.lon, b$ll.lat, b$ur.lat)
		r <- rast(nrows=nrow(from), ncols=ncol(from), ext=e, nlyr=3, crs="epsg:4326", names=c("red", "green", "blue"))
		values(r) <- t(grDevices::col2rgb(from))
		RGB(r) <- 1:3
		r
	}
)



as.list.SpatRaster <- function(x, geom=NULL, ...) {
	if (!is.null(geom)) {
		e <- as.vector(ext(x))
		d <- crs(x, describe=TRUE)
		if (!(is.na(d$authority) || is.na(d$code))) {
			crs <- paste0(d$authority, ":", d$code)
		} else {
			crs <- gsub("\n[ ]+", "", crs(x))
		}
		list(
			ncols=ncol(x),
			nrows=nrow(x),
			nlyrs=nlyr(x),
			xmin=e[1],
			xmax=e[2],
			ymin=e[3],
			ymax=e[4],
			xres=xres(x),
			yres=yres(x),
			nms = paste(names(x), collapse="', '"),
			units = paste(units(x), collapse="', '"),
			time = paste(time(x), collapse="', '"),
			crs=crs
		)
	} else {
		lapply(1:nlyr(x), function(i) x[[i]])
	}
}
setMethod("as.list", signature(x="SpatRaster"), as.list.SpatRaster)


as.list.SpatRasterCollection <- function(x, ...) {
	out <- lapply(1:length(x), function(i) x[i])
	names(out) <- names(x)
	out
}
setMethod("as.list", signature(x="SpatRasterCollection"), as.list.SpatRasterCollection)


as.list.SpatRasterDataset <- function(x, ...) {
	out <- lapply(1:length(x), function(i) x[i])
	names(out) <- names(x)
	out
}
setMethod("as.list", signature(x="SpatRasterDataset"), as.list.SpatRasterDataset)


as.list.SpatVectorCollection <- function(x, ...) {
	out <- lapply(1:length(x), function(i) x[i])
	names(out) <- names(x)
	out
}
setMethod("as.list", signature(x="SpatVectorCollection"), as.list.SpatVectorCollection)


# create a "grDevices::raster" (small r) object for use with the rasterImage function
# NOT a raster::Raster* object
setMethod("as.raster", signature(x="SpatRaster"),
	function(x, maxcell=500000, col) {
		if (missing(col)) {
			#col <- rev(grDevices::terrain.colors(255))
			col <- .default.pal()
		}
		
		x <- spatSample(x, maxcell, method="regular", as.raster=TRUE, warn=FALSE)
		x <- as.matrix(x, wide=TRUE)
		r <- range(x, na.rm=TRUE)
		x <- (x - r[1])/ (r[2] - r[1])
		x <- round(x * (length(col)-1) + 1)
		x[] <- col[x]
		as.raster(x)
	}
)



.as.image <- function(x, maxcells=10000) {
	x <- spatSample(x, size=maxcells, method="regular", as.raster=TRUE, warn=FALSE)
	X <- xFromCol(x, 1:ncol(x))
	Y <- yFromRow(x, nrow(x):1)
	Z <- t(as.matrix(x, wide=TRUE)[nrow(x):1,])
	list(x=X, y=Y, z=Z)
}


get_labels <- function(x, p, dissolve=FALSE) {
	ff <- is.factor(x)
	if (dissolve) {
		ff <- ff[[1]]
	}
	if (any(ff)) {
		ff <- which(ff)
		cgs <- levels(x)
		for (f in ff) {
			cg <- cgs[[f]]
			i <- match(unlist(p[[f]]), cg[,1])
			p[[f]] <- cg[i, 2]
		}
	}
	p
}


setMethod("as.polygons", signature(x="SpatRaster"),
	function(x, round=TRUE, aggregate=TRUE, values=TRUE, na.rm=TRUE, na.all=FALSE, extent=FALSE, digits=0, ...) {
		if (isFALSE(list(...)$dissolve)) {
			aggregate <- FALSE
		}
	
		p <- methods::new("SpatVector")
		if (extent) {
			p@pntr <- x@pntr$dense_extent(FALSE, FALSE)
			x <- messages(x, "as.polygons")
		} else {
			opt <- spatOptions()
			p@pntr <- x@pntr$as_polygons(round[1], aggregate[1], values[1], na.rm[1], na.all[1], digits, opt)
			x <- messages(x, "as.polygons")
			if (values) {
				p <- get_labels(x, p, aggregate[1])
			}
		}
		messages(p, "as.polygons")
	}
)

setMethod("as.lines", signature(x="SpatRaster"),
	function(x, na.rm=FALSE) {
		if (na.rm) {
			p <- as.polygons(x[[1]], round=FALSE, aggregate=FALSE, values=FALSE, na.rm=TRUE) 
			return(as.lines(p))
		}
		p <- methods::new("SpatVector")
		opt <- spatOptions()
		p@pntr <- x@pntr$as_lines(opt)
		messages(p, "as.lines")
	}
)


setMethod("as.polygons", signature(x="SpatExtent"),
	function(x, crs="") {
		p <- methods::new("SpatVector")
		crs <- character_crs(crs, "as.polygons")
		p@pntr <- SpatVector$new(x@pntr, crs)
		messages(p, "as.polygons")
	}
)

setMethod("as.lines", signature(x="SpatExtent"),
	function(x, crs="") {
		crs <- character_crs(crs, "as.lines")
		as.lines(as.polygons(x, crs))
	}
)


setMethod("as.points", signature(x="SpatExtent"),
	function(x, crs="") {
		#vect(do.call(cbind, x@pntr$as.points()), "points", crs=crs)
		as.points(as.polygons(x, crs))
	}
)


setMethod("as.lines", signature(x="SpatVector"),
	function(x) {
		x@pntr <- x@pntr$as_lines()
		messages(x, "as.lines")
	}
)


setMethod("as.lines", signature(x="matrix"),
	function(x, crs="", segments=FALSE) {
		p <- vect()
		if (ncol(x) == 2) {
			nr <- nrow(x)
			p@pntr$setGeometry("lines", rep(1, nr), rep(1, nr), x[,1], x[,2], rep(FALSE, nr), double(0))
			crs(p) <- crs
		} else if (ncol(x) == 4) {
			p@pntr$setLinesStartEnd(x, crs(crs))
		} else {
			error("expecting a two or four column matrix", "as.lines")
		}
		if (segments) {
			p <- messages(p, "vect")
			disagg(p, segments=TRUE)
		} else {
			messages(p, "vect")
		}
	}
)


setMethod("as.polygons", signature(x="SpatVector"),
	function(x, extent=FALSE) {
		if (extent) {
			as.polygons(ext(x), crs=crs(x))
		} else {
			if (geomtype(x) == "points") {
				x <- as.lines(x)
			}
			x@pntr <- x@pntr$polygonize()
			messages(x, "as.polygons")
		}
	}
)

setMethod("as.points", signature(x="SpatVector"),
	function(x, multi=FALSE, skiplast=TRUE) {
		opt <- spatOptions()
		x@pntr <- x@pntr$as_points(multi, skiplast)
		messages(x, "as.points")
	}
)


setMethod("as.points", signature(x="SpatRaster"),
	function(x, values=TRUE, na.rm=TRUE, na.all=FALSE) {
		p <- methods::new("SpatVector")
		opt <- spatOptions()
		p@pntr <- x@pntr$as_points(values, na.rm, na.all, opt)
		x <- messages(x, "as.points")

		if (values) {
			p <- get_labels(x, p, FALSE)
		}
		messages(p, "as.points")
	}
)

# mode argument is ignored as mode=mode gave an error on R-devel
setMethod("as.vector", signature(x="SpatExtent"),
	function(x, mode="any") {
		v <- x@pntr$vector
		names(v) <- c("xmin", "xmax", "ymin", "ymax")
		if (mode == "list") {
			v <- as.list(v)
		}
		v
	}
)


setMethod("as.character", signature(x="SpatExtent"),
	function(x) {
		e <- as.vector(x)
		paste0("ext(", paste(e, collapse=", "), ")")
	}
)

setMethod("as.vector", signature(x="SpatRaster"),
	function(x, mode="any") {
		values(x, FALSE)
	}
)

as.matrix.SpatRaster <- function(x, wide=FALSE, ...) {
	if (!hasValues(x)) {
		error("as.matrix", "SpatRaster has no cell values")
	}
#	wide <- isTRUE(list(...)$wide)
	if (wide) {
		if (nlyr(x) > 1) {
			m <- values(x, mat=TRUE)
			m <- lapply(1:ncol(m), function(i) {
				matrix(m[,i], nrow=nrow(x), byrow=TRUE)
				})
			m <- do.call(cbind, m)
		} else {
			m <- matrix(values(x, mat=FALSE),nrow=nrow(x),byrow=TRUE)
		}
	} else {
		m <- values(x, mat=TRUE)
	}
	m
}
setMethod("as.matrix", signature(x="SpatRaster"), as.matrix.SpatRaster)




as.matrix.SpatExtent <- function(x, ...) {
	v <- matrix(as.vector(x), ncol=2, byrow=TRUE)
	colnames(v) <- c("min", "max")
	v
}
setMethod("as.matrix", signature(x="SpatExtent"), as.matrix.SpatExtent)



as.data.frame.SpatRaster <- function(x, row.names=NULL, optional=FALSE, xy=FALSE, cells=FALSE, time=FALSE,na.rm=NA, wide=TRUE, ...) {

	d <- NULL
	if (xy) {
		d <- xyFromCell(x, 1:ncell(x))
	}
	if (cells) {
		d <- cbind(cell=1:ncell(x), d)
	}
	if (is.null(d)) {
		d <- values(x, dataframe=TRUE, ... )
	} else {
		d <- data.frame(d)
		d <- cbind(d, values(x, dataframe=TRUE), ...)
	}
	if (is.na(na.rm)) {
		cols <- (1 + cells + xy * 2):ncol(d)
		i <- rowSums(is.na(d[,cols,drop=FALSE])) < length(cols)
		d <- d[i,,drop=FALSE]
	} else if (isTRUE(na.rm)) {
		d <- stats::na.omit(d)
		attr(d, "na.action") <- NULL
	}
	if (!wide) {
		nr <- nrow(d)
		if (!(xy || cells)) {
			d <- data.frame(layer=rep(names(x), each=nr), values=as.vector(as.matrix(d)))
		} else {
			idv <- NULL
			if (xy) idv <- c("x", "y", idv)
			if (cells) idv <- c("cell", idv)
			add <- d[idv]
			rownames(add) <- NULL
			for (i in 1:length(idv)) {
				d[[idv[i]]] <- NULL
			}
			d <- data.frame(add, layer=rep(names(x), each=nr), values=as.vector(as.matrix(d)))
			nms <- names(x)
#			d <- stats::reshape(d, direction="long", idvar=idv, varying=nms, v.names="values")
#			d$time <- nms[d$time]
#			names(d)[names(d) == "time"] <- "layer"
		}
		rownames(d) <- NULL
		if (time) {
		#	d$time <- NULL
		#	vals <- d$values
		#	d$values <- NULL
			d$time <- rep(time(x), each=nr)
		#	d$values <- vals
		}
	} else if (time && has.time(x)) {
		tm <- as.character(time(x))
		nc <- ncol(d)
		colnames(d)[(1+nc-length(tm)):nc] <- tm
	}
	d
}
setMethod("as.data.frame", signature(x="SpatRaster"), as.data.frame.SpatRaster)



setAs("SpatRaster", "data.frame",
	function(from) {
		as.data.frame(from)
	}
)

setAs("SpatVector", "data.frame",
	function(from) {
		as.data.frame(from)
	}
)

setMethod("as.array", signature(x="SpatRaster"),
	function(x) {
		dm <- dim(x)
		x <- values(x, TRUE)
		a <- array(NA, dm)
		for (i in 1:dm[3]) {
			a[,,i] <- matrix(x[,i], nrow=dm[1], byrow=TRUE)
		}
		a
	}
)

setMethod("as.array", signature(x="SpatRasterDataset"),
	function(x) {
		n <- length(x)
		if (n < 2) return(as.array(x[1]))
		
		dm <- sapply(x, dim)
		udm <- apply(dm, 1, function(i)length(unique))
		if (!all(udm) == 1) {
			error("as.array", "cannot make an array from rasters with different dimensions")
		}
		
		a <- array(NA, c(dm[,1], n))
		dimnames(a) <- list(NULL, NULL, NULL, names(x))

		for (i in 1:n) {
			a[,,,i] <- as.array(x[i])
		}
		a
	}
)




# to sf from SpatVector
# available in sf
#.v2sf <- function(from) {
#	txt <- 'sf::st_as_sf(as.data.frame(from, geom=TRUE), wkt="geometry", crs=from@pntr$get_crs("wkt"))'
#	eval(parse(text = txt))
#}

# sf bbox
.ext_from_sf <- function(from) {
	sfi <- attr(from, "sf_column")
	geom <- from[[sfi]]
	e <- attr(geom, "bbox")
	ext(e[c(1,3,2,4)])
}


.from_sf <- function(from, geom, sfi) {
	crs <- attr(geom, "crs")$wkt
	if (is.na(crs)) crs <- ""
	#geom <- st_as_text(geom)
	#v <- vect(geom, crs=crs)
	v <- vect()
	v@pntr <- v@pntr$from_hex(sf::rawToHex(sf::st_as_binary(geom)), crs)
	v <- messages(v, "SpatVector from sf")
	if (ncol(from) > 1) {
		from[[sfi]] <- NULL
		values(v) <- as.data.frame(from)
	}
	v
}

.svc_from_sf <- function(from) {
	sfi <- attr(from, "sf_column")
	geom <- from[[sfi]]
	crs <- attr(geom, "crs")$wkt
	if (is.na(crs)) crs <- ""
	#geom <- st_as_text(geom)
	#v <- vect(geom, crs=crs)
	v <- svc()
	v@pntr <- v@pntr$from_hex_col(sf::rawToHex(sf::st_as_binary(geom)), crs)
	#if (ncol(from) > 1) {
	#	from[[sfi]] <- NULL
	#	values(v) <- as.data.frame(from)
	#}
	v
}

setAs("sf", "SpatRaster",
	function(from) {
		e <- ext(from)
		rast(e)
	}
)


# https://github.com/rspatial/terra/issues/2013
# sf encodes the FULL polygon (the whole sphere) as a single 2x2 matrix
# c(0, 0, -90, -90). Helpers below detect that representation in the
# three places it can appear (sf, sfc, sfg) without ever doing an
# unconditional value comparison against a 2x2 sentinel -- otherwise an
# ordinary polygon trips "non-conformable arrays".
.is_full_polygon_ring <- function(m) {
	is.matrix(m) && all(dim(m) == c(2L, 2L)) &&
		all(m == matrix(c(0, 0, -90, -90), ncol = 2L))
}

.is_sfc_full_polygon <- function(geom) {
	inherits(geom, "sfc_POLYGON") && length(geom) == 1L &&
		length(geom[[1]]) >= 1L && .is_full_polygon_ring(geom[[1]][[1]])
}

.is_sfg_full_polygon <- function(geom) {
	inherits(geom, "POLYGON") && length(geom) >= 1L &&
		.is_full_polygon_ring(geom[[1]])
}

.full_world_polygon <- function(crs_wkt) {
	if (is.null(crs_wkt) || is.na(crs_wkt) || !nzchar(crs_wkt)) {
		crs_wkt <- "lonlat"
	}
	as.polygons(ext(-180, 180, -90, 90), crs = crs_wkt)
}


setAs("sf", "SpatVector",
	function(from) {
		sfi <- attr(from, "sf_column")
		if (is.null("sfi")) {
			error("as,sf", "the object has no sf_column")
		}
		geom <- from[[sfi]]
		if (inherits(geom, "list")) {
			error("as,sf", "the geometry column is not valid (perhaps first load the sf package)")
		}
		if (.is_sfc_full_polygon(geom)) {
			return(.full_world_polygon(attr(geom, "crs")$wkt))
		}
		v <- try(.from_sf(from, geom, sfi), silent=FALSE)
		if (inherits(v, "try-error")) {
			error("as,sf", "coercion failed. You can try coercing via a Spatial* (sp) class")
		}
		v
	}
)

.from_sfc <- function(from) {
	v <- vect()
	v@pntr <- v@pntr$from_hex(sf::rawToHex(sf::st_as_binary(from)), "")
	crs(v, warn=FALSE) <- attr(from, "crs")$wkt
	v
}


setAs("sfc", "SpatVector",
	function(from) {
		if (.is_sfc_full_polygon(from)) {
			return(.full_world_polygon(attr(from, "crs")$wkt))
		}
		v <- try(.from_sfc(from), silent=TRUE)
		if (inherits(v, "try-error")) {
			error("as,sfc", "coercion failed. You can try coercing via a Spatial* (sp) class")
		}
		v
	}
)


setAs("sfg", "SpatVector",
	function(from) {
		if (.is_sfg_full_polygon(from)) {
			return(.full_world_polygon(NULL))
		}
		v <- try(.from_sfc(from), silent=TRUE)
		if (inherits(v, "try-error")) {
			error("as,sfg", "coercion failed. You can try coercing via a Spatial* (sp) class")
		}
		v
	}
)

setAs("XY", "SpatVector",
	function(from) {
		if (.is_sfg_full_polygon(from)) {
			return(.full_world_polygon(NULL))
		}
		v <- try(.from_sfc(from), silent=TRUE)
		if (inherits(v, "try-error")) {
			error("as,sfc", "coercion failed. You can try coercing via a Spatial* (sp) class")
		}
		v
	}
)

setAs("im", "SpatRaster",
	function(from) {
		r <- rast(nrows=from$dim[1], ncols=from$dim[2], xmin=from$xrange[1], xmax=from$xrange[2], ymin=from$yrange[1], ymax=from$yrange[2], crs="")
		values(r) <- from$v
		units(r) <- from$units$singular
		if (from$units$multiplier != 1) {
			r <- r * from$units$multiplier
		}
		flip(r, direction="vertical")
	}
)


setAs("SpatVector", "Spatial",
	function(from) {
		hasmethod <- suppressWarnings("geom,data.frame-method" %in% utils::methods("geom"))
		if (!hasmethod) {
			error("coerce", "first run 'library(raster)' to coerce a SpatVector to a Spatial object" )
		}
		g <- geom(from, df=TRUE)
		geom(g, values(from), geomtype(from), as.character(crs(from, proj=TRUE)))
	}
)


geom_SpatialPolygons <- function(x) {
	nobs <- length(x@polygons)
	objlist <- vector(mode = "list", length = nobs)
	for (i in 1:nobs) {
		nsubobs <- length(x@polygons[[i]]@Polygons)
		ps <- list()
		last <- 0
		for (j in 1:nsubobs) {
			if (!x@polygons[[i]]@Polygons[[j]]@hole) {
				last <- last + 1
				hole <- 0
			} else {
				hole <- max(1, last)
			}
			ps[[j]] <- cbind(j, x@polygons[[i]]@Polygons[[j]]@coords, hole)
		}
		objlist[[i]] <- cbind(i, do.call(rbind, ps))
	}
	do.call(rbind, objlist)
}

geom_SpatialLines <- function(x) {
	nobs <- length(x@lines)
	objlist <- vector(mode = "list", length = nobs)
	for (i in 1:nobs) {
		nsubobj <- length(x@lines[[i]]@Lines)
		ps <- lapply(1:nsubobj, function(j) cbind(j, x@lines[[i]]@Lines[[j]]@coords))
		objlist[[i]] <- cbind(i, do.call(rbind, ps))
	}
	do.call(rbind, objlist)
}


setAs("Spatial", "SpatVector",
	function(from) {
		if (inherits(from, "SpatialPolygons")) {
			g <- geom_SpatialPolygons(from)
			vtype <- "polygons"
		} else if (inherits(from, "SpatialLines")) {
			g <- geom_SpatialLines(from)
			vtype <- "lines"
		} else if (inherits(from, "SpatialPoints")) {
			g <- from@coords[,1:2,drop=FALSE]
			vtype <- "points"
		} else {
			error("coerce", "cannot coerce this object to a SpatVector")
		}
		#the below can change the proj-string when going back to sp
		#crs <- attr(from@proj4string, "comment")
		#if (is.null(crs)) 
		crs <- from@proj4string@projargs
		if (methods::.hasSlot(from, "data")) {
			vect(g, vtype, from@data, crs=crs)
		} else {
			vect(g, vtype, crs=crs)
		}
	}
)


setAs("SpatialGrid", "SpatRaster",
	function(from){
		prj <- attr(from@proj4string, "comment")
		if (is.null(prj)) prj <- from@proj4string@projargs
		b <- rast(ext=as.vector(t(from@bbox)), nrow=from@grid@cells.dim[2], ncol=from@grid@cells.dim[1], crs=prj)
		if (inherits(from, "SpatialGridDataFrame")) {
			cls <- sapply(from@data, function(i) class(i)[1])
			if (all(cls == "numeric")) {
				nlyr(b) <- ncol(from@data)
				b <- setValues(b, as.matrix(from@data))
			} else {
				x <- vector(mode="list", length=ncol(from@data))
				for (i in 1:ncol(from@data)) {
					x[[i]] <- setValues(b, from@data[,i])
				}
				b <- rast(x)
			}
			names(b) <- colnames(from@data)
		} else {
			dim(b) <- c(from@grid@cells.dim[2], from@grid@cells.dim[1])
		}
		b
	}
)


setAs("SpatialPixels", "SpatRaster",
	function(from){
		if (methods::.hasSlot(from, "data")) {
			as(as(from, "SpatialGridDataFrame"), "SpatRaster")
		} else {
			as(as(from, "SpatialGrid"), "SpatRaster")
		}
	}
)

r <- rast(ncols=3, nrows=3)
set.seed(68)
values(r) <- runif(ncell(r)) # from example
# all values > 0 and <= 0.25 become 1, etc.
m <- c(0, 0.25, 1,  0.25, 0.5, 2,  0.5, 1, 3) # from example
rclmat <- matrix(m, ncol=3, byrow=TRUE)

rc <- classify(r, rclmat, include.lowest=TRUE)
expect_equal(as.vector(values(rc)), c(3, 3, 2, 3, 2, 3, 3, 1, 2))

values(r) <- (1:ncell(r))-1
m <- c(0, 2, 1,  2, 3, 2,  3, 8, 3) 
rclmat <- matrix(m, ncol=3, byrow=TRUE)
rc <- classify(r, rclmat, right=FALSE)
expect_equal(as.vector(values(rc)), c(1, 1, 2, 3, 3, 3, 3, 3, 8))

rc <- classify(r, rclmat, right=TRUE)
expect_equal(as.vector(values(rc)), c(0, 1, 1, 2, 3, 3, 3, 3, 3))

rc <- classify(r, rclmat, right=TRUE, include.lowest=TRUE)
expect_equal(as.vector(values(rc)), c(1, 1, 1, 2, 3, 3, 3, 3, 3))

 

set.seed(0)
r <- rast(nrows=10, ncols=10)
values(r) <- sample(3, ncell(r), replace=TRUE)
r0 <- r * 1

# categories in a single layer
lv <- data.frame(id=1:4, cover=c("forest", "water", "urban", "other"), stringsAsFactors=FALSE)
levels(r) <- lv
names(r) <- "land cover"
v <- cats(r)[[1]]
#coltab(r) <- rainbow(4)

expect_equal(v$id, lv[,1])
expect_equal(v$cover, lv[,2])

r <- droplevels(r)
expect_equal(levels(r)[[1]][,2], c("forest", "water", "urban"))
lv <- lv[-4,]

# reading/writing categories
ftmp <- tempfile(fileext = ".tif")
z <- writeRaster(r, ftmp, overwrite=TRUE)
v <- cats(z)[[1]]
expect_equal(v$value, 1:3)
expect_equal(v$`land cover`, lv[,2])

# reading/writing subset of categories
levels(r) = cats(r)[[1]][2:3,]
zz = writeRaster(r, ftmp, overwrite=TRUE)
v <- cats(zz)[[1]]

expect_equal(v$value, 2:3)
expect_equal(v$cover, lv[-1,2])

# categories in multiple layers
r2 <- rast(list(a=r0, b=r0))

# values are numeric initially
expect_equal(values(r2)[1,], c(a = 2, b = 2))

# set layer a categories
levels(r2) <- lv
expect_equal(levels(r2), list(lv, ""))

# verify samples for layer a have categories
expect_equal( r2[c(15,3)], data.frame(cover = factor(c("forest", "urban"), levels = lv[,2]),
                                           b = c(1, 3), stringsAsFactors=FALSE ))

# set all layer categories
levels(r2) <- rep(list(lv), 2)
expect_equal(levels(r2), list(lv, lv))

# verify samples for layer a and layer b have categories
expect_equal(r2[c(15,3)], data.frame(cover = factor(c("forest", "urban"), levels = lv[,2]),
                                           cover = factor(c("forest", "urban"), levels = lv[,2]), stringsAsFactors=FALSE, check.names = FALSE))

# make sure no errors when show()ing factors
expect_silent(show(r2))

# catalyze multi-column lookup
r <- rast(nrows=10, ncols=10, vals=sample(1:5, 100, replace=TRUE))
levels(r) <- data.frame(ID=1:5, val1=101:105, val2=seq(0.1, 0.5, length.out=5))
r_cat <- catalyze(r)
expect_equal(nlyr(r_cat), 2)
expect_equal(names(r_cat), c("val1", "val2"))
expect_false(any(is.factor(r_cat)))
expect_silent(show(r_cat))
expect_equal(as.vector(values(r_cat[[1]])), as.vector(values(r)) + 100)
expect_equal(as.vector(values(r_cat[[2]])), as.vector(values(r)) * 0.1)

r_num <- as.numeric(r)
expect_false(any(is.factor(r_num)))
expect_equal(names(r_num), "val1")
expect_equivalent(as.vector(values(r_num)), as.vector(values(r)))

x <- rast(nrows=2, ncols=2, vals=1:4, names="random")
time(x) <- as.POSIXct("2000-01-02 12:12:12", tz="America/Los_Angeles")
expect_equal(timeInfo(x)$zone, "America/Los_Angeles")

# time from any source is kept if step/zone match or can be unified (#2160)
a <- rast(nrows=2, ncols=2, nlyr=1, vals=1)
b <- rast(nrows=2, ncols=2, nlyr=1, vals=2)
time(a) <- as.Date("2000-01-01")
ab <- c(a, b)
expect_true(has.time(ab))
expect_equal(as.Date(time(ab)[1]), as.Date("2000-01-01"))
expect_true(is.na(time(ab)[2]))
ba <- c(b, a)
expect_true(has.time(ba))
expect_true(is.na(time(ba)[1]))
expect_equal(as.Date(time(ba)[2]), as.Date("2000-01-01"))

# Calendar steps combine at the coarsest shared type (#2160)
time(b) <- as.POSIXct("2000-01-02 12:00:00", tz="UTC")
sd <- c(a, b)
expect_true(has.time(sd))
expect_equal(timeInfo(sd)$step, "days")

time(b, tstep="years") <- 2001
yd <- c(a, b)
expect_true(has.time(yd))
expect_equal(timeInfo(yd)$step, "years")
expect_equal(time(yd), c(2000, 2001))

time(b, tstep="yearmonths") <- as.Date("2001-06-15")
ym <- c(a, b)
expect_true(has.time(ym))
expect_equal(timeInfo(ym)$step, "yearmonths")

# months (1-12) do not share a calendar axis with days
time(b, tstep="months") <- 6
md <- suppressWarnings(c(a, b))
expect_false(has.time(md))

## Z coordinate storage and round-trips (#824)

v2 <- vect(cbind(1:3, 10:12))
expect_false(has.z(v2))

v3 <- vect()
v3@pntr$setPointsXYZ(as.double(1:3), as.double(10:12), as.double(c(100, 200, 300)))
expect_true(has.z(v3))
expect_equal(nrow(v3), 3L)
xy <- crds(v3)
expect_equivalent(xy[,1], 1:3)
expect_equivalent(xy[,2], 10:12)
expect_equivalent(xy[,3], c(100, 200, 300))

## empty / wrong-length z falls back to 2D
v4 <- vect()
v4@pntr$setPointsXYZ(as.double(1:2), as.double(3:4), as.double(numeric(0)))
expect_false(has.z(v4))

## geom() <-> vect() round-trip
g <- geom(v3)
expect_true("z" %in% colnames(g))
expect_equivalent(g[,"z"], c(100, 200, 300))
v3b <- vect(g, type="points")
expect_true(has.z(v3b))
expect_equivalent(crds(v3b)[,"z"], c(100, 200, 300))

## writeVector / vect(file) round-trip (GPKG)
f <- tempfile(fileext=".gpkg")
writeVector(v3, f, overwrite=TRUE)
v3c <- vect(f)
expect_true(has.z(v3c))
expect_equivalent(crds(v3c)[,"z"], c(100, 200, 300))

## sf coercion round-trip (if sf is available)
if (requireNamespace("sf", quietly=TRUE)) {
	s <- sf::st_as_sf(data.frame(x=1:3, y=10:12, z=c(100,200,300)),
		coords=c("x","y","z"), crs="EPSG:4326")
	vs <- vect(s)
	expect_true(has.z(vs))
	expect_equivalent(crds(vs)[,"z"], c(100, 200, 300))

	# SpatVector -> sf -> SpatVector
	s2 <- sf::st_as_sf(v3)
	vs2 <- vect(s2)
	expect_true(has.z(vs2))
	expect_equivalent(crds(vs2)[,"z"], c(100, 200, 300))
}

x <- y <- seq(0, 3, 1)
d <- terra::distance(cbind(x, y), lonlat=FALSE, sequential=TRUE)
sq2 <- sqrt(2)

expect_equal(d, c(0, rep(sq2, 3)))

d <- terra::distance(cbind(x, y), lonlat=FALSE, sequential=FALSE)
expect_equal(as.vector(d), c(sq2, 2*sq2, 3*sq2, sq2, 2*sq2, sq2))

d <- terra::distance(cbind(x, y), lonlat=TRUE, sequential=TRUE)
expect_equivalent(d, c(0.0, 156899.6, 156876.1, 156829.3), .000001)

d <- terra::distance(cbind(x, y), lonlat=TRUE, sequential=FALSE)
expect_equivalent(as.vector(d), c(156899.6, 313775.7, 470605.0, 156876.1, 313705.4, 156829.3), .000001)


# distance(SpatRaster, target=...) lon/lat fast path: must agree with the
# original implementation (gated by TERRA_DIST_SLOW=1) to within FP precision.
dist_both <- function(...) {
	old <- Sys.getenv("TERRA_DIST_SLOW", unset = NA)
	on.exit({
		if (is.na(old)) Sys.unsetenv("TERRA_DIST_SLOW")
		else Sys.setenv(TERRA_DIST_SLOW = old)
	})
	Sys.setenv(TERRA_DIST_SLOW = "0"); rf <- terra::distance(...)
	Sys.setenv(TERRA_DIST_SLOW = "1"); rs <- terra::distance(...)
	list(fast = terra::values(rf), slow = terra::values(rs))
}

set.seed(1)
rr <- terra::rast(nrows = 30, ncols = 60, xmin = -180, xmax = 180,
                  ymin = -90, ymax = 90, crs = "EPSG:4326")
terra::values(rr) <- 0
rr[c(150, 600, 1200, 1500)] <- 1

for (mth in c("haversine", "cosine")) {
	r <- dist_both(rr, target = 1, method = mth)
	expect_equal(is.na(r$fast), is.na(r$slow))
	fin <- !is.na(r$fast) & !is.na(r$slow)
	expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-4))   # < 0.1 mm
}

# target = NA path
rr2 <- terra::rast(nrows = 25, ncols = 50, xmin = -120, xmax = 120,
                   ymin = -60, ymax = 60, crs = "EPSG:4326")
terra::values(rr2) <- NA
rr2[c(40, 200, 800)] <- 5
r <- dist_both(rr2, method = "haversine")
expect_equal(is.na(r$fast), is.na(r$slow))
fin <- !is.na(r$fast) & !is.na(r$slow)
expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-4))


# maxdist: the fast path prunes in-loop using the threshold. It must produce
# the same NA pattern and the same finite values as the slow path (which
# filters after the fact).
for (md in c(5e6, 1e6, 2e5)) {
	r <- dist_both(rr, target = 1, method = "haversine", maxdist = md)
	expect_equal(is.na(r$fast), is.na(r$slow))
	fin <- !is.na(r$fast) & !is.na(r$slow)
	expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-4))
}

# maxdist in km
r <- dist_both(rr, target = 1, method = "haversine", unit = "km", maxdist = 500)
expect_equal(is.na(r$fast), is.na(r$slow))
fin <- !is.na(r$fast) & !is.na(r$slow)
expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-7))


# geo fast path: at EPSG:4326 both paths use WGS84, so they must be
# bit-equivalent (up to FP noise).
r <- dist_both(rr, target = 1, method = "geo")
expect_equal(is.na(r$fast), is.na(r$slow))
fin <- !is.na(r$fast) & !is.na(r$slow)
expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-6))

# geo + maxdist in meters
for (md in c(5e6, 1e6, 2e5)) {
	r <- dist_both(rr, target = 1, method = "geo", maxdist = md)
	expect_equal(is.na(r$fast), is.na(r$slow))
	fin <- !is.na(r$fast) & !is.na(r$slow)
	expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-6))
}

# geo + maxdist in km
r <- dist_both(rr, target = 1, method = "geo", unit = "km", maxdist = 500)
expect_equal(is.na(r$fast), is.na(r$slow))
fin <- !is.na(r$fast) & !is.na(r$slow)
expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-9))

# geo with target = NA (edges of non-NA region)
rr3 <- terra::rast(nrows = 25, ncols = 50, xmin = -120, xmax = 120,
                   ymin = -60, ymax = 60, crs = "EPSG:4326")
terra::values(rr3) <- NA
rr3[c(40, 200, 800)] <- 5
r <- dist_both(rr3, method = "geo")
expect_equal(is.na(r$fast), is.na(r$slow))
fin <- !is.na(r$fast) & !is.na(r$slow)
expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-6))


# distance(SpatRaster, SpatVector) lon/lat fast path for polygons/lines.
dist_both_v <- function(...) {
	old <- Sys.getenv("TERRA_DIST_VECTOR_SLOW", unset = NA)
	on.exit({
		if (is.na(old)) Sys.unsetenv("TERRA_DIST_VECTOR_SLOW")
		else Sys.setenv(TERRA_DIST_VECTOR_SLOW = old)
	})
	Sys.setenv(TERRA_DIST_VECTOR_SLOW = "0"); rf <- terra::distance(...)
	Sys.setenv(TERRA_DIST_VECTOR_SLOW = "1"); rs <- terra::distance(...)
	list(fast = terra::values(rf), slow = terra::values(rs))
}

rv <- terra::rast(nrows = 30, ncols = 60, xmin = -180, xmax = 180,
                  ymin = -60, ymax = 60, crs = "EPSG:4326")
poly <- terra::vect(matrix(c(-60, -10,  60, -10,  60, 40,  -60, 40,  -60, -10),
                           ncol = 2, byrow = TRUE),
                    type = "polygons", crs = "EPSG:4326")
line <- terra::vect(matrix(c(-120, -30,  -60, 0,  0, 30,  60, 0,  120, -30),
                           ncol = 2, byrow = TRUE),
                    type = "lines", crs = "EPSG:4326")

for (mth in c("haversine", "cosine", "geo")) {
	r <- dist_both_v(rv, poly, method = mth)
	expect_equal(is.na(r$fast), is.na(r$slow))
	fin <- !is.na(r$fast) & !is.na(r$slow)
	expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-4))   # < 0.1 mm

	r <- dist_both_v(rv, line, method = mth)
	expect_equal(is.na(r$fast), is.na(r$slow))
	fin <- !is.na(r$fast) & !is.na(r$slow)
	expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-4))
}

# unit = "km" branch for geo vector fast path
r <- dist_both_v(rv, poly, method = "geo", unit = "km")
expect_equal(is.na(r$fast), is.na(r$slow))
fin <- !is.na(r$fast) & !is.na(r$slow)
expect_true(all(abs(r$fast[fin] - r$slow[fin]) < 1e-7))

r <- rast(matrix(c(0,1,1,0), ncol=2))
p <- patches(r, directions = 8, zeroAsNA=TRUE)
expect_equal(as.vector(values(p)), c(NaN, 1, 1, NaN))

p <- patches(r, directions = 4, zeroAsNA=TRUE)
expect_equal(as.vector(values(p)), c(NaN, 1, 2, NaN))

r <- rast(matrix(c(1,0,0,1), ncol=2))
p <- patches(r, directions = 8, zeroAsNA=TRUE)
expect_equal(as.vector(values(p)), c(1, NaN, NaN, 1))

p <- patches(r, directions = 4, zeroAsNA=TRUE)
expect_equal(as.vector(values(p)), c(1, NaN, NaN, 2))

p <- patches(r, directions = 4, zeroAsNA=FALSE)
expect_equal(as.vector(values(p)), c(1, 1, 1, 1))


r <- rast(nrows=18, ncols=36)
r[1:2, 5:8] <- 11
r[7:8, 1:6] <- 12
r[5:6, 22:36] <- 13
r[15:16, 18:29] <- 14
p <- patches(r)
expect_equal(as.vector(unique(values(p))), c(NaN, 1:4))
p <- patches(r, directions=8)
expect_equal(as.vector(unique(values(p))), c(NaN, 1:3))

xmin(r) <- 0
p <- patches(r, directions=8)
expect_equal(as.vector(unique(values(p))), c(NaN, 1:4))

# tests for values=TRUE
m <- matrix(c(1, 1, 2, 2,
              1, 2, 2, 1,
              3, 3, 1, 1), nrow=3, byrow=TRUE)
r <- rast(m)

p4 <- patches(r, directions=4, values=TRUE)
expect_equal(as.vector(values(p4)), c(1, 1, 2, 2, 1, 2, 2, 4, 5, 5, 4, 4))

p8 <- patches(r, directions=8, values=TRUE)
expect_equal(as.vector(values(p8)), c(1, 1, 2, 2, 1, 2, 2, 3, 4, 4, 3, 3))

m_u <- matrix(c(1, 1, 1, 1,
                1, 2, 2, 1,
                1, 1, 1, 1), nrow=3, byrow=TRUE)
r_u <- rast(m_u)
p_u <- patches(r_u, directions=4, values=TRUE)
expect_equal(as.vector(values(p_u)), c(1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1))

r_large <- rast(nrows=100, ncols=100, vals=1)
r_large[50, 1:100] <- 2
p_large <- patches(r_large, directions=4, values=TRUE)
expect_equal(as.vector(unique(values(p_large))), c(1, 2, 3))

m_na <- matrix(c(1, 1, NA, 1,
                 1, NA, 1, 1,
                 1, 1, 1, 1), nrow=3, byrow=TRUE)
r_na <- rast(m_na)
p_na <- patches(r_na, directions=4, values=TRUE)
expect_equal(as.vector(values(p_na)), c(1, 1, NaN, 1, 1, NaN, 1, 1, 1, 1, 1, 1))

# zeroAsNA should be ignored if values=TRUE
r_z <- rast(matrix(c(1, 0, 0, 1), ncol=2))
p_z1 <- patches(r_z, directions=4, values=TRUE, zeroAsNA=TRUE)
expect_equal(as.vector(values(p_z1)), c(1, 2, 3, 4))
p_z2 <- patches(r_z, directions=4, values=TRUE, zeroAsNA=FALSE)
expect_equal(values(p_z1), values(p_z2))

# SpatNetwork: build a planar topological network from lines.

# Two crossing roads -> 5 nodes, 4 edges
a <- vect("LINESTRING(0 0, 10 10)", crs = "local")
b <- vect("LINESTRING(0 10, 10 0)", crs = "local")
roads <- rbind(a, b)
roads$name <- c("A", "B")

net <- netw(roads)

expect_inherits(net, "SpatNetwork")
expect_equal(net_nnodes(net), 5)
expect_equal(net_nedges(net), 4)

nds <- net_nodes(net)
eds <- net_edges(net)
expect_inherits(nds, "SpatVector")
expect_inherits(eds, "SpatVector")
expect_equal(geomtype(nds), "points")
expect_equal(geomtype(eds), "lines")

# Crossing node has degree 4; the four endpoints have degree 1.
deg <- nds$degree
expect_equal(sort(deg), c(1L, 1L, 1L, 1L, 4L))

# Edge lengths are all sqrt(50) (half-diagonal of the 10x10 box).
expect_equivalent(eds$length, rep(sqrt(50), 4), tolerance = 1e-9)

# Source attribution: 1-based index pointing back into the input,
# and the per-source attribute (`name`) is forwarded.
expect_true(all(eds$source_id %in% c(1L, 2L)))
expect_true(all(eds$name %in% c("A", "B")))
expect_equal(eds$name, roads$name[eds$source_id])

# Node ordering: from_node / to_node are valid 1-based indices.
expect_true(all(eds$from_node >= 1 & eds$from_node <= net_nnodes(net)))
expect_true(all(eds$to_node   >= 1 & eds$to_node   <= net_nnodes(net)))

# CRS is preserved end-to-end.
expect_equal(crs(nds), crs(roads))
expect_equal(crs(eds), crs(roads))

# Coercion via setAs gives the same network.
net_via_as <- as(roads, "SpatNetwork")
expect_inherits(net_via_as, "SpatNetwork")
expect_equal(net_nnodes(net_via_as), net_nnodes(net))
expect_equal(net_nedges(net_via_as), net_nedges(net))


# Single line, no crossings -> 2 nodes, 1 edge, no warnings.
single <- vect("LINESTRING(0 0, 1 1, 2 0)", crs = "local")
net1 <- netw(single)
expect_equal(net_nnodes(net1), 2)
expect_equal(net_nedges(net1), 1)
# Interior vertex (1,1) is preserved on the edge geometry.
e1 <- net_edges(net1)
expect_equal(nrow(crds(e1)), 3)


# T-junction: line C joins line A halfway along.
a2 <- vect("LINESTRING(0 0, 10 0)", crs = "local")
c2 <- vect("LINESTRING(5 0, 5 10)", crs = "local")
net2 <- netw(rbind(a2, c2))
expect_equal(net_nnodes(net2), 4)  # endpoints (0,0),(10,0),(5,10) + junction (5,0)
expect_equal(net_nedges(net2), 3)  # A is split in two; C stays whole
junction_deg <- max(net_nodes(net2)$degree)
expect_equal(junction_deg, 3L)


# Wrong geometry type -> error.
pts <- vect(cbind(c(0, 1), c(0, 1)), crs = "local")
expect_error(netw(pts))

# Negative snap -> error.
expect_error(netw(roads, snap = -1))


# Degree-2 nodes from segmented inputs are removed by default.
# A single straight road digitized as three abutting segments should
# collapse to one edge with two endpoints under merge=TRUE.
seg1 <- vect("LINESTRING(0 0, 5 0)",  crs = "local")
seg2 <- vect("LINESTRING(5 0, 10 0)", crs = "local")
seg3 <- vect("LINESTRING(10 0, 15 0)", crs = "local")
chain <- rbind(seg1, seg2, seg3)

netM <- netw(chain)              # merge = TRUE (default)
expect_equal(net_nnodes(netM), 2)
expect_equal(net_nedges(netM), 1)
# All non-extreme nodes should be gone, so degrees are exactly 1.
expect_equal(sort(net_nodes(netM)$degree), c(1L, 1L))

netU <- netw(chain, merge = FALSE)
expect_equal(net_nnodes(netU), 4)
expect_equal(net_nedges(netU), 3)
# The two interior nodes are degree-2 join points.
expect_equal(sum(net_nodes(netU)$degree == 2L), 2L)

# A real junction is still preserved under merge=TRUE.
trunk <- vect("LINESTRING(0 0, 5 0, 10 0)", crs = "local")
spur  <- vect("LINESTRING(5 0, 5 5)",       crs = "local")
netJ <- netw(rbind(trunk, spur))
expect_equal(net_nnodes(netJ), 4)  # (0,0) (5,0) (10,0) (5,5)
expect_equal(net_nedges(netJ), 3)
expect_equal(max(net_nodes(netJ)$degree), 3L)


# --- directed / weighted ---
# Default: undirected, weighted by length.
expect_false(net_directed(net))
w <- net_weights(net)
expect_true(!is.null(w))
expect_equal(length(w), net_nedges(net))
expect_equivalent(w, rep(sqrt(50), 4), tolerance = 1e-9)

# Explicitly unweighted -> net_weights() == NULL.
netU <- netw(roads, weights = FALSE)
expect_null(net_weights(netU))

# Custom numeric weights via constructor.
netCW <- netw(roads, weights = c(1, 2, 3, 4))
expect_equal(net_weights(netCW), c(1, 2, 3, 4))

# Custom weights via assignment.
netW <- netw(roads)
net_weights(netW) <- 10 * net_weights(netW)
expect_equivalent(net_weights(netW), 10 * sqrt(50) * rep(1, 4), tolerance = 1e-9)
# Wrong length is rejected.
expect_error(net_weights(netW) <- 1:3)
# Setting NULL clears weights.
net_weights(netW) <- NULL
expect_null(net_weights(netW))

# Directed networks expose in_degree / out_degree on net_nodes().
netD <- netw(roads, directed = TRUE)
expect_true(net_directed(netD))
nd <- net_nodes(netD)
expect_true(all(c("degree", "in_degree", "out_degree") %in% names(nd)))
# Sum of in_degree across nodes must equal nedges.
expect_equal(sum(nd$in_degree),  net_nedges(netD))
expect_equal(sum(nd$out_degree), net_nedges(netD))

# net_edges() exposes a "weight" column when weighted, not when unweighted.
expect_true("weight" %in% names(net_edges(net)))
expect_false("weight" %in% names(net_edges(netU)))

# Lon/lat networks: length is in meters via geodesic distance.
gll <- vect("LINESTRING(0 0, 1 0)", crs = "EPSG:4326")
netll <- netw(gll)
# 1 degree of longitude at the equator on WGS84 ~= 111319.49 m.
expect_equal(net_weights(netll), 111319.49, tolerance = 1)
expect_equal(net_edges(netll)$length, 111319.49, tolerance = 1)


# --- weights from a source column ---
roads2 <- rbind(a, b)
roads2$cost <- c(7, 100)
netCol <- netw(roads2, weights = "cost")
# Each input feature should have produced 2 edges, so the weight
# vector contains exactly two 7s and two 100s.
expect_equal(sort(net_weights(netCol)), c(7, 7, 100, 100))
# Unknown column -> error.
expect_error(netw(roads2, weights = "no_such_column"))
# Non-numeric column -> error.
roads2$nm <- c("a", "b")
expect_error(netw(roads2, weights = "nm"))


# --- shortestPath ---
# Two crossing roads, same length, undirected, weighted by length.
sp <- shortestPath(net, from = 1, to = 4)
expect_inherits(sp, "SpatVector")
expect_equal(nrow(sp), 1L)
expect_equal(sp$from, 1L)
expect_equal(sp$to,   4L)
# Path goes through the centre node and is exactly two edges.
expect_equal(sp$distance, 2 * sqrt(50), tolerance = 1e-9)
# Geometry is non-empty and traverses the centre point.
gxy <- geom(sp)[, c("x","y")]
expect_true(any(abs(gxy[,1] - 5) < 1e-9 & abs(gxy[,2] - 5) < 1e-9))

# from == to: distance 0, empty geometry.
sp0 <- shortestPath(net, from = 2, to = 2)
expect_equal(sp0$distance, 0)
expect_equal(nrow(crds(sp0)), 0L)

# Multiple destinations from one source -> recycled.
spM <- shortestPath(net, from = 1, to = 1:5)
expect_equal(nrow(spM), 5L)
expect_equal(spM$from, rep(1L, 5))
expect_equal(spM$to,   1:5)
expect_equal(spM$distance[1], 0)
# Distance from corner to opposite corner == 2*sqrt(50).
expect_equal(spM$distance[4], 2 * sqrt(50), tolerance = 1e-9)

# Custom weights via a column propagate into shortestPath.
spC <- shortestPath(netCol, from = 1, to = 4)
# The shortest cost path uses the cheap (cost=7) road -> has to reroute.
# At minimum the distance must be <= the all-expensive route.
expect_true(spC$distance <= 2 * 100 + 1e-9)

# Disconnected network -> NA distance and empty geom.
disc1 <- vect("LINESTRING(0 0, 1 1)", crs = "local")
disc2 <- vect("LINESTRING(10 10, 11 11)", crs = "local")
ndisc <- netw(rbind(disc1, disc2))
spD <- shortestPath(ndisc, from = 1, to = net_nnodes(ndisc))
expect_true(is.na(spD$distance))
expect_equal(nrow(crds(spD)), 0L)

# Directed networks respect orientation.
# Build a Y: trunk 1 -> 2 -> 3 with a spur 2 -> 4.
trunk2 <- vect("LINESTRING(0 0, 5 0, 10 0)", crs = "local")
spur2  <- vect("LINESTRING(5 0, 5 5)",       crs = "local")
ndir   <- netw(rbind(trunk2, spur2), directed = TRUE)
# Forward should work.
spF <- shortestPath(ndir, from = 1, to = 3)
expect_false(is.na(spF$distance))
# Reverse should be unreachable in a directed graph.
spR <- shortestPath(ndir, from = 3, to = 1)
expect_true(is.na(spR$distance))
# Same on the undirected version: both directions reachable.
nund <- netw(rbind(trunk2, spur2), directed = FALSE)
expect_false(is.na(shortestPath(nund, from = 3, to = 1)$distance))

# Invalid node ids -> error.
expect_error(shortestPath(net, from = 0,    to = 1))
expect_error(shortestPath(net, from = 9999, to = 1))


# --- empty network from netw() ---
empty <- netw()
expect_inherits(empty, "SpatNetwork")
expect_equal(net_nnodes(empty), 0)
expect_equal(net_nedges(empty), 0)


# --- netw() is idempotent on SpatNetwork ---
expect_identical(netw(net), net)

#https://github.com/rspatial/terra/issues/1410

r <- terra::rast(ncols=100, nrows=100)
values(r) <- 1:ncell(r)
r2 <- r*2
file_name_1 <- paste0(tempfile(), ".tif")
file_name_2 <- paste0(tempfile(), ".tif")
vrt_filename <- file.path(tempdir(),"test.vrt")
terra::writeRaster(r, file_name_1)
terra::writeRaster(r2, file_name_2)
x <- terra::vrt(c(file_name_1,file_name_2), filename = vrt_filename, overwrite=TRUE, options="-separate")

expect_equal(nlyr(x), 2)

# Value checks for SpatVector helpers documented in man/*.Rd.

f <- system.file("ex/lux.shp", package = "terra")
v <- vect(f)

## identity / size
expect_equal(unname(geomtype(v)[1]), "polygons")
expect_equal(nseg(v[1, ]), 330)
expect_equal(perim(v[1, ]), 117100.1, tolerance = 0.1)
expect_equal(expanse(v[1, ]), 312283206, tolerance = 1)
expect_equal(sum(expanse(v)), 2564810595, tolerance = 1)

## nearby — each feature has at least one neighbour within 50 km (lon/lat metres)
nb <- nearby(v, distance = 50000)
expect_true(length(nb) >= nrow(v))

## nearest — known distances (m) from first three to next set
nr <- nearest(v[1:3, ], v[4:8, ])
expect_equal(nr$distance[1], 16142.4, tolerance = 0.1)
expect_equal(nr$distance[2], 7482.58, tolerance = 0.05)

## buffer increases area
expect_true(expanse(buffer(v[1, ], width = 500))[1] > expanse(v[1, ])[1])

## simplifyGeom reduces vertices
simp <- simplifyGeom(v[1, ], tolerance = 100)
expect_true(nseg(simp) < nseg(v[1, ]))

## validity
expect_true(all(is.valid(v)))

## set operations change feature count or geometry measure predictably
e <- erase(v[1, ], v[2, ])
expect_true(expanse(e)[1] <= expanse(v[1, ])[1])
intr <- intersect(v[1:2, ], v[2:3, ])
expect_true(nrow(intr) >= 1)
un <- union(v[1:2, ])
expect_true(expanse(un)[1] >= max(expanse(v[1, ])[1], expanse(v[2, ])[1]))

## densify increases vertices
dns <- densify(v[1, ], 500)
expect_true(nseg(dns) >= nseg(v[1, ]))

## fillHoles does not increase area
fh <- fillHoles(v[1, ])
expect_true(expanse(fh)[1] <= expanse(v[1, ])[1] + 1)

## empty extent
expect_true(isTRUE(is.empty(ext(0, 0, 1, 1))))

## relate — same geometry is equal to itself
expect_true(relate(v[1, ], v[1, ], "equals"))

r <- rast(nrows=10, ncols=10, xmin=0)
values(r) <- 1:ncell(r)

w <- matrix(c(1,1,1,1,0,1,1,1,1), 3)

m1 <- autocor(r, w)
m2 <- autocor(r, w, standardize=TRUE)

expect_equal(as.numeric(m1), 0.8362573, tolerance=1e-6)
expect_equal(as.numeric(m2), 0.9330909, tolerance=1e-6)
expect_true(m2 >= -1 && m2 <= 1)

g1 <- autocor(r, w, method="geary")
g2 <- autocor(r, w, method="geary", standardize=TRUE)

expect_equal(as.numeric(g1), 0.04421053, tolerance=1e-6)
expect_equal(as.numeric(g2), 0.04384, tolerance=1e-5)

# rook case -- Moran's I
wr <- matrix(c(0,1,0,1,0,1,0,1,0), 3)
mr1 <- autocor(r, wr)
mr2 <- autocor(r, wr, standardize=TRUE)

expect_equal(as.numeric(mr1), 0.8888889, tolerance=1e-6)
expect_equal(as.numeric(mr2), 0.96, tolerance=1e-6)
expect_true(mr2 >= -1 && mr2 <= 1)

if (require(spdep, quietly=TRUE)) {

	nb <- cell2nb(nrow=10, ncol=10, type="queen")
	v <- values(r)[,1]
	n <- length(v)

	lw_B <- nb2listw(nb, style="B")
	lw_W <- nb2listw(nb, style="W")

	m_B <- moran(v, lw_B, n, Szero(lw_B))$I
	m_W <- moran(v, lw_W, n, Szero(lw_W))$I

	expect_equal(as.numeric(m1), m_B, tolerance=1e-6)
	expect_equal(as.numeric(m2), m_W, tolerance=1e-6)

	g_B <- geary(v, lw_B, n, n - 1, Szero(lw_B))$C
	g_W <- geary(v, lw_W, n, n - 1, Szero(lw_W))$C

	expect_equal(as.numeric(g1), g_B, tolerance=1e-6)
	expect_equal(as.numeric(g2), g_W, tolerance=1e-6)

	nb_r <- cell2nb(nrow=10, ncol=10, type="rook")
	lw_rB <- nb2listw(nb_r, style="B")
	lw_rW <- nb2listw(nb_r, style="W")

	mr_B <- moran(v, lw_rB, n, Szero(lw_rB))$I
	mr_W <- moran(v, lw_rW, n, Szero(lw_rW))$I

	expect_equal(as.numeric(mr1), mr_B, tolerance=1e-6)
	expect_equal(as.numeric(mr2), mr_W, tolerance=1e-6)
}

# planar hex grid: exact equal-area tessellation
e <- ext(0, 100, 0, 100)
h <- tessellate(e, size = 10)
expect_true(nrow(h) > 0)
a <- expanse(h, transform = FALSE)
# all planar cells have identical Cartesian area
expect_true((max(a) - min(a)) / mean(a) < 1e-9)


# flat-top variant
h2 <- tessellate(e, size = 12, flat_top = TRUE)
expect_true(nrow(h2) > 0)
a2 <- expanse(h2, transform = FALSE)
expect_true((max(a2) - min(a2)) / mean(a2) < 1e-9)


# global geo=TRUE: equal-area on the sphere
g <- tessellate(ext(-180, 180, -85, 85), size = 500000, geo = TRUE)
expect_true(nrow(g) == 2320)
ag <- expanse(g)
# spherical equal-area cells; spread should be small (< 2%)
expect_true(diff(range(ag)) / mean(ag) < 0.02)

# adjacent regional grids share the global anchor: cells whose
# centroids fall in the overlap region must coincide exactly
g_eu <- tessellate(ext(-10, 40, 30, 70), size = 200000, geo = TRUE)
g_af <- tessellate(ext( 10, 60, -5, 35), size = 200000, geo = TRUE)
cn_eu <- crds(centroids(g_eu, inside = FALSE))
cn_af <- crds(centroids(g_af, inside = FALSE))
in_overlap <- function(cn) {
	cn[, 1] >= 10.5 & cn[, 1] <= 39.5 & cn[, 2] >= 30.5 & cn[, 2] <= 34.5
}
sub_eu <- cn_eu[in_overlap(cn_eu), , drop = FALSE]
sub_af <- cn_af[in_overlap(cn_af), , drop = FALSE]
expect_equal(nrow(sub_eu), nrow(sub_af))
oe <- order(sub_eu[, 1], sub_eu[, 2])
oa <- order(sub_af[, 1], sub_af[, 2])
expect_equal(sub_eu[oe, , drop = FALSE], sub_af[oa, , drop = FALSE])


# antimeridian: cells that straddle +/-180 are returned as multipart
# geometries spanning lon -180 .. +180, with no duplicates and exactly
# Nx unique cells per row
h180 <- tessellate(ext(-180, 180, -80, 80), size = 500000, geo = TRUE)
cn <- crds(centroids(h180, inside = FALSE))
# count cells per latitude row (rounded centroid lat)
lat_round <- round(cn[, 2], 4)
counts <- as.integer(table(lat_round))
expect_true(all(counts == counts[1]))

# input validation
expect_error(tessellate(e, size = 0))
expect_error(tessellate(e, size = -1))
expect_error(tessellate(e, size = c(1, 2)))
expect_error(tessellate(n = 0, type="polyhedron"))
expect_error(tessellate(size = 0, type="polyh"))

# truncated dodecahedron-like base case (Goldberg G(2, 0))
g <- tessellate(n = 2, type="polyhedron")
expect_equal(nrow(g), 42)                          # 10 n^2 + 2
expect_equal(sum(g$type == "pentagon"), 12L)


# n = 10 -> 1002 cells, 12 pentagons + 990 hexagons
g10 <- tessellate(n=10, type="polyhedron")
expect_equal(nrow(g10), 1002)
expect_equal(sum(g10$type == "pentagon"), 12L)
expect_equal(sum(g10$type == "hexagon"),  990L)
expect_true(all(is.valid(g10)))


# cell areas should sum, at every resolution, to exactly the same total
ref_area <- sum(expanse(tessellate(n = 2, type="polyhedron")))
for (n in c(2L, 5L, 10L, 20L)) {
	g <- tessellate(n = n, type="polyhedron")
	expect_equal(nrow(g), 10L * n * n + 2)
	expect_true(all(is.valid(g)))
	a <- sum(expanse(g))
	expect_true(abs(a - ref_area) / ref_area < 1e-6)
}


# two of the 12 pentagons must sit on the geographic poles (their
# extent must reach lat = +/- 90).
g <- tessellate(n = 5, type="polyhedron")
pent <- g[g$type == "pentagon", ]
ymax <- vapply(seq_len(nrow(pent)), function(i) ymax(ext(pent[i, ])), numeric(1))
ymin <- vapply(seq_len(nrow(pent)), function(i) ymin(ext(pent[i, ])), numeric(1))
expect_true(any(ymax >=  90 - 1e-9))
expect_true(any(ymin <= -90 + 1e-9))


# size argument: derives n inversely from cell size
g_size <- tessellate(size = 2e6, type="polyhedron")
expect_true(nrow(g_size) > 0)
expect_true(all(g_size$type %in% c("pentagon", "hexagon")))
# smaller size -> more cells
g_small <- tessellate(size = 5e5, type="polyhedron")
expect_true(nrow(g_small) > nrow(g_size))


# extent filter selects a subset, including the polar extent edge cases
g_eq <- tessellate(ext(-30, 30, -10, 10), n = 10, type="polyhedron", geo=TRUE)
expect_true(nrow(g_eq) > 0)
expect_true(nrow(g_eq) < nrow(g10))

# Coercion tests for SpatNetwork <-> igraph.

if (!requireNamespace("igraph", quietly = TRUE)) {
	exit_file("igraph not available")
}

a <- vect("LINESTRING(0 0, 10 10)", crs = "local")
b <- vect("LINESTRING(0 10, 10 0)", crs = "local")
roads <- rbind(a, b)
roads$name <- c("A", "B")
net <- netw(roads)


# --- SpatNetwork -> igraph -------------------------------------------------
g <- as(net, "igraph")
expect_inherits(g, "igraph")
expect_equal(igraph::vcount(g), net_nnodes(net))
expect_equal(igraph::ecount(g), net_nedges(net))
expect_false(igraph::is_directed(g))

# Vertex attributes carry the coordinates.
expect_true(all(c("x", "y") %in% igraph::vertex_attr_names(g)))
xy <- crds(net_nodes(net))
expect_equivalent(igraph::vertex_attr(g, "x"), xy[, 1])
expect_equivalent(igraph::vertex_attr(g, "y"), xy[, 2])

# Edge weights land on the conventional `weight` attribute.
expect_true("weight" %in% igraph::edge_attr_names(g))
expect_equivalent(igraph::edge_attr(g, "weight"), net_weights(net))

# `length` rides along.
expect_true("length" %in% igraph::edge_attr_names(g))
expect_equivalent(igraph::edge_attr(g, "length"), net_edges(net)$length)

# CRS round-trips through the `crs` graph attribute.
expect_true("crs" %in% igraph::graph_attr_names(g))


# Forward results agree with shortestPath: a corner-to-corner shortest path
# computed by Dijkstra in terra has the same total weight as igraph's.
sp_terra  <- shortestPath(net, from = 1, to = 4)$distance
sp_igraph <- as.numeric(igraph::distances(g, v = 1, to = 4))
expect_equal(sp_terra, sp_igraph, tolerance = 1e-9)


# Directed networks transfer their orientation.
ndir <- netw(roads, directed = TRUE)
gdir <- as(ndir, "igraph")
expect_true(igraph::is_directed(gdir))


# --- igraph -> SpatNetwork -------------------------------------------------
net2 <- as(g, "SpatNetwork")
expect_inherits(net2, "SpatNetwork")
expect_equal(net_nnodes(net2), net_nnodes(net))
expect_equal(net_nedges(net2), net_nedges(net))
expect_equal(net_directed(net2), net_directed(net))

# `netw(igraph)` is an equivalent entry point.
net2b <- netw(g)
expect_equal(net_nnodes(net2b), net_nnodes(net))
expect_equal(net_nedges(net2b), net_nedges(net))

# Node coordinates survive intact.
expect_equivalent(crds(net_nodes(net2)), crds(net_nodes(net)))

# Weights survive too (within tolerance: same numeric values, possibly
# reordered if igraph reorders internally -- which it doesn't here).
expect_equivalent(sort(net_weights(net2)), sort(net_weights(net)), tolerance = 1e-9)

# CRS round-trips through the graph attribute.
expect_equal(crs(net2), crs(net))


# Building from a fresh igraph (no terra origin): need x / y vertex attrs.
g2 <- igraph::make_graph(c(1,2, 2,3, 3,1), directed = FALSE)
g2 <- igraph::set_vertex_attr(g2, "x", value = c(0, 1, 0))
g2 <- igraph::set_vertex_attr(g2, "y", value = c(0, 0, 1))
g2 <- igraph::set_edge_attr(g2,   "weight", value = c(1, 2, 3))
nfresh <- netw(g2, crs = "local")
expect_equal(net_nnodes(nfresh), 3)
expect_equal(net_nedges(nfresh), 3)
expect_equivalent(sort(net_weights(nfresh)), c(1, 2, 3))

# Missing coordinate attributes -> error.
g3 <- igraph::make_graph(c(1,2, 2,3), directed = FALSE)
expect_error(netw(g3))
expect_error(as(g3, "SpatNetwork"))


# Lossless idempotency on already-a-SpatNetwork.
expect_identical(netw(net), net)


# Shortest paths agree on a converted graph.
sp_pre  <- shortestPath(net,  from = 1, to = 4)$distance
sp_post <- shortestPath(net2, from = 1, to = 4)$distance
expect_equal(sp_pre, sp_post, tolerance = 1e-9)

r <- rast(nrows=10, ncols=10)
set.seed(2)
v <- sample(5, ncell(r), replace=TRUE)
values(r) <- v

f <- freq(r)
expect_true(is.data.frame(f))
expect_equal(colnames(f), c("layer", "value", "count"))
tbl <- table(v)
expect_equivalent(f$count, as.vector(tbl))
expect_equivalent(f$value, as.numeric(names(tbl)))

# freq bylayer=FALSE
x <- c(r, r)
f2 <- freq(x, bylayer=FALSE)
expect_equal(colnames(f2), c("value", "count"))
# Should be double the counts
expect_equivalent(f2$count, as.vector(tbl) * 2)

# freq digits
r_float <- r + 0.1
f3 <- freq(r_float, digits=0)
expect_equivalent(f3$count, as.vector(tbl))
expect_equivalent(f3$value, as.numeric(names(tbl))) # rounded values should match integers

# freq value argument
f4 <- freq(r, value=5)
expect_equal(f4$count, as.integer(tbl["5"]))

# freq zones
z <- r
values(z) <- 1
f5 <- freq(r, zones=z)
expect_true(is.data.frame(f5))

# empty spatvectors

f <- system.file("ex", "lux.shp", package="terra")
v <- vect(f)
empty_v <- v[0,]

outfile <- file.path(tempdir(), "empty.gpkg")
writeVector(empty_v, outfile, overwrite=TRUE)

read_v <- vect(outfile)
expect_equal(nrow(read_v), 0)
expect_equal(ncol(read_v), ncol(empty_v))
expect_equal(names(read_v), names(empty_v))

expect_equal(nrow(vect(outfile, proxy=TRUE)), 0)
expect_equal(names(vect(outfile, proxy=TRUE)), names(empty_v))

unlink(outfile)


# insert=TRUE with empty layer
outfile <- file.path(tempdir(), "empty.gpkg")
writeVector(v, outfile, layer="data", overwrite=TRUE)
writeVector(empty_v, outfile, layer="empty", insert=TRUE)

expect_equal(nrow(vect(outfile, layer="data")), nrow(v))
expect_equal(nrow(vect(outfile, layer="empty")), 0)
expect_equal(names(vect(outfile, layer="empty")), names(empty_v))

unlink(outfile)

outfile <- file.path(tempdir(), "schema_mismatch.gpkg")

a <- vect("POLYGON ((0 0, 0 1, 1 1, 1 0, 0 0))")
b <- vect("POLYGON ((10 10, 10 11, 11 11, 11 10, 10 10))")
a$id <- 1L
b$id <- "text"

suppressWarnings({
  empty_intersect <- intersect(a, b)
})

expect_equal(nrow(empty_intersect), 0)
expect_equal(names(empty_intersect), c("id_1", "id_2"))

writeVector(empty_intersect, outfile, overwrite=TRUE)

read_result <- vect(outfile)
expect_equal(nrow(read_result), 0)
expect_equal(names(read_result), c("id_1", "id_2"))

proxy_result <- vect(outfile, proxy=TRUE)
expect_equal(nrow(proxy_result), 0)
expect_equal(names(proxy_result), c("id_1", "id_2"))

unlink(outfile)

# Value checks for spatSample() with different methods and options (see ?spatSample).

set.seed(42)
r <- rast(
  nrows = 10, ncols = 10,
  xmin = 0, xmax = 1, ymin = 0, ymax = 1,
  crs = "local", vals = 1:100
)
nc <- ncell(r)
vv <- values(r)[, 1]

## method = "random" — row count, valid cells, no duplicates without replacement
sr <- spatSample(r, 20, method = "random", cells = TRUE)
expect_equal(nrow(sr), 20)
expect_true(all(sr[, "cell"] %in% seq_len(nc)))
expect_equal(length(unique(sr[, "cell"])), 20)

## method = "random", replace = TRUE — sample size can exceed unique cells
set.seed(1)
r5 <- rast(nrows = 5, ncols = 5, xmin = 0, xmax = 1, ymin = 0, ymax = 1, crs = "local", vals = 1:25)
srep <- spatSample(r5, 30, method = "random", replace = TRUE, cells = TRUE)
expect_equal(nrow(srep), 30)
expect_true(length(unique(srep[, "cell"])) < nrow(srep))

## method = "random", na.rm = TRUE — only non-NA cells
rna <- r
rna[1:70] <- NA
sn <- spatSample(rna, 8, method = "random", na.rm = TRUE, cells = TRUE)
expect_equal(nrow(sn), 8)
expect_true(all(!is.na(vv[sn[, "cell"]])))

## method = "regular" — coordinates inside extent, values match source raster
sreg <- spatSample(r, 9, method = "regular", cells = TRUE, xy = TRUE, values = TRUE)
expect_true(all(sreg[, "x"] >= 0 & sreg[, "x"] <= 1))
expect_true(all(sreg[, "y"] >= 0 & sreg[, "y"] <= 1))
expect_equal(sreg[, "lyr.1"], vv[sreg[, "cell"]])

## method = "regular", as.raster = TRUE — coarser grid, same extent
srast <- spatSample(r, 50, method = "regular", as.raster = TRUE)
expect_true(ncell(srast) < nc)
expect_equal(as.vector(ext(srast)), as.vector(ext(r)))

## method = "regular", exact = TRUE — requested number of rows (projected crs)
sreg25 <- spatSample(r, 25, method = "regular", cells = TRUE, exact = TRUE)
expect_equal(nrow(sreg25), 25)

## method = "regular" — size as c(nrow, ncol) grid dimensions
sgrid <- spatSample(r, c(4, 5), method = "regular", cells = TRUE)
expect_equal(nrow(sgrid), 20)

## method = "stratified", each = TRUE — size per stratum
set.seed(1)
rr <- rast(
  nrows = 10, ncols = 10,
  xmin = 0, xmax = 1, ymin = 0, ymax = 1,
  crs = "local"
)
values(rr) <- sample(1:3, ncell(rr), replace = TRUE)
st1 <- spatSample(rr, 3, method = "stratified", cells = TRUE, values = TRUE, each = TRUE)
expect_equal(nrow(st1), 9)
tb1 <- table(st1[, "lyr.1"])
expect_equal(as.vector(tb1), c(3L, 3L, 3L))

## method = "stratified", each = FALSE — total sample size across strata
st2 <- spatSample(rr, 9, method = "stratified", cells = TRUE, values = TRUE, each = FALSE)
expect_equal(nrow(st2), 9)

## method = "stratified" on categorical raster — return category names (#2159)
rrf <- rr
levels(rrf) <- data.frame(id = 1:3, labels = c("a", "b", "c"))
stf <- spatSample(rrf, 2, method = "stratified", as.points = TRUE)
expect_true(is.factor(stf$labels))
expect_equal(sort(unique(as.character(stf$labels))), c("a", "b", "c"))
stf2 <- spatSample(rrf, 2, method = "stratified", cells = TRUE)
expect_true(is.factor(stf2$labels))

## method = "weights" — draws follow cell index raster (positive weights)
rw <- init(r, "cell") / nc
sw <- spatSample(rw, 24, method = "weights", cells = TRUE)
expect_equal(nrow(sw), 24)
expect_true(all(sw[, "cell"] %in% seq_len(nc)))

## method = "spread" — approximately uniform coverage, requested count
set.seed(0)
ssp <- spatSample(r, 12, method = "spread", cells = TRUE)
expect_equal(nrow(ssp), 12)
expect_true(all(ssp[, "cell"] %in% seq_len(nc)))

## ext — samples restricted to sub-extent
sube <- ext(0, 0.5, 0, 0.5)
sext <- spatSample(r, 20, method = "random", cells = TRUE, ext = sube)
xye <- xyFromCell(r, sext[, "cell"])
expect_true(all(xye[, 1] <= 0.5 + 1e-9))
expect_true(all(xye[, 2] <= 0.5 + 1e-9))

## SpatExtent — random points in bounding box
e <- ext(r)
sm <- spatSample(e, 12, method = "random", lonlat = FALSE)
expect_equal(nrow(sm), 12)
expect_true(all(sm[, "x"] >= as.vector(e)[1] & sm[, "x"] <= as.vector(e)[2]))
expect_true(all(sm[, "y"] >= as.vector(e)[3] & sm[, "y"] <= as.vector(e)[4]))

## SpatVector — random points inside data extent
f <- system.file("ex/lux.shp", package = "terra")
v <- vect(f)
set.seed(2)
pv <- spatSample(v, 6)
expect_equal(nrow(pv), 6)
ev <- as.vector(ext(v))
cr <- crds(pv)
expect_true(all(cr[, 1] >= ev[1] & cr[, 1] <= ev[2]))
expect_true(all(cr[, 2] >= ev[3] & cr[, 2] <= ev[4]))

#######################################################################
# Regressions reported via reverse-dependency checks (terra 1.9-22):
#   - SiMRiv / raptr : as(sf, "SpatVector") -> "non-conformable arrays"
#                      because the FULL-polygon 2x2 detection compared
#                      values before checking dimensions.
#   - mapmisc        : terra::project(SpatVector, ...) raised a hard
#                      error when all points became unprojectable
#                      (e.g. projecting the poles into a tilted-
#                      perspective view); should be a warning so that
#                      callers using suppressWarnings() can recover.
#######################################################################

# ------------------------------------------------------------------ #
# Fix 1: as(sf, "SpatVector") on an ordinary polygon must not error  #
#        with "non-conformable arrays"                                #
# ------------------------------------------------------------------ #
if (requireNamespace("sf", quietly = TRUE)) {

	# A polygon whose first ring has > 2 vertices: this is the case
	# that triggered the old "non-conformable arrays" error.
	pol <- sf::st_polygon(list(rbind(
		c(0, 0), c(1, 0), c(1, 1), c(0, 1), c(0, 0)
	)))
	sfdf <- sf::st_sf(geometry = sf::st_sfc(pol, crs = 4326),
	                  id = 1L)

	v <- methods::as(sfdf, "SpatVector")
	expect_inherits(v, "SpatVector")
	expect_equal(nrow(v), 1L)
	expect_equal(geomtype(v), "polygons")

	# A second sanity check: also works inside rasterize()
	r <- rast(extent = ext(0, 1, 0, 1), nrows = 4, ncols = 4)
	rr <- rasterize(sfdf, r, field = "id")
	expect_inherits(rr, "SpatRaster")

	# ------------------------------------------------------------ #
	# sf encodes the FULL polygon (whole sphere) as a 2x2 matrix.   #
	# All three coercion paths -- sf, sfc, sfg -- must detect this  #
	# and return a global polygon (not error or compare values      #
	# blindly).                                                     #
	# ------------------------------------------------------------ #
	g_sfc <- sf::st_as_sfc("POLYGON FULL", crs = "EPSG:4326")

	# user-reported reproducer: vect(<sfc POLYGON FULL>)
	v_sfc <- vect(g_sfc)
	expect_inherits(v_sfc, "SpatVector")
	expect_equal(nrow(v_sfc), 1L)
	expect_equal(geomtype(v_sfc), "polygons")
	expect_equal(unname(as.vector(ext(v_sfc))), c(-180, 180, -90, 90))

	# wrapped in an sf data frame
	sf_full <- sf::st_sf(geometry = g_sfc, id = 1L)
	v_sf <- vect(sf_full)
	expect_inherits(v_sf, "SpatVector")
	expect_equal(nrow(v_sf), 1L)
	expect_equal(unname(as.vector(ext(v_sf))), c(-180, 180, -90, 90))

	# bare sfg (XY POLYGON)
	v_sfg <- vect(g_sfc[[1]])
	expect_inherits(v_sfg, "SpatVector")
	expect_equal(nrow(v_sfg), 1L)
	expect_equal(unname(as.vector(ext(v_sfg))), c(-180, 180, -90, 90))
}


# ------------------------------------------------------------------ #
# Fix 2: project() must not hard-error when all output coordinates   #
#        are unprojectable; emit a warning instead.                  #
# ------------------------------------------------------------------ #

# A tilted-perspective projection centered far from the poles
# is a setup that will produce NaN for the polar points.
tpers <- "+proj=tpers +h=2000000 +tilt=-15 +lat_0=15 +lon_0=130 +datum=WGS84"
poles <- vect(cbind(c(0, 0), c(90, -90)), crs = "EPSG:4326")

# Old behaviour: error stopping execution.
# New behaviour: warning, project() still returns a SpatVector.
projected <- suppressWarnings(project(poles, tpers))
expect_inherits(projected, "SpatVector")
expect_equal(nrow(projected), 2L)

# When wrapped in withCallingHandlers we should see a warning, not error.
saw_warning <- FALSE
res <- withCallingHandlers(
	project(poles, tpers),
	warning = function(w) {
		saw_warning <<- TRUE
		invokeRestart("muffleWarning")
	}
)
expect_inherits(res, "SpatVector")
expect_true(saw_warning)

library(terra)

# subst integer lookup
r <- rast(nrows=10, ncols=10, vals=sample(1:5, 100, replace=TRUE))
r_sub <- subst(r, 1:2, 21:22)
v_sub <- as.vector(values(r_sub))
v_in <- as.vector(values(r))
expect_equal(v_sub[v_in == 1], rep(21, sum(v_in == 1)))
expect_equal(v_sub[v_in == 2], rep(22, sum(v_in == 2)))
expect_equal(v_sub[v_in > 2], v_in[v_in > 2])

# subst floating point lookup
r <- rast(nrows=2, ncols=2, vals=c(0.1, 0.2, 0.5, 0.9))
r_sub <- subst(r, c(0.1, 0.5), c(99.1, 99.5))
v_sub <- as.vector(values(r_sub))
v_in <- as.vector(values(r))
expect_equal(v_sub[v_in == 0.1], 99.1)
expect_equal(v_sub[v_in == 0.5], 99.5)
expect_equal(v_sub[v_in == 0.2], 0.2)
expect_equal(v_sub[v_in == 0.9], 0.9)

# subst 'others' with non-integers
r <- rast(nrows=2, ncols=2, vals=c(1, 2, 3, 4))
r_sub <- subst(r, 1:2, 11:12, others=1.5)
v_sub <- as.vector(values(r_sub))
expect_equal(v_sub, c(11, 12, 1.5, 1.5))

# subst with recycled 'to'
r <- rast(nrows=1, ncols=10, vals=1:10)
r_sub <- subst(r, 2:10, NA)
expect_equal(values(r_sub)[, 1], c(1, rep(NA_real_, 9)))

r <- rast(nrows=10, ncols=10)
set.seed(2)
v <- sample(5, ncell(r), replace=TRUE)
values(r) <- v

s <- r
values(s) <- sample(3, ncell(s), replace=TRUE)
x_cross <- c(r, s)

ct <- crosstab(x_cross)
expect_true(inherits(ct, "table"))
tbl_cross <- table(values(r), values(s))
expect_equivalent(as.vector(ct), as.vector(tbl_cross))

# crosstab long=TRUE
ct_long <- crosstab(x_cross, long=TRUE)
expect_true(is.data.frame(ct_long))
expect_equal(ncol(ct_long), 3) # layer1, layer2, Freq/count
# Order might differ, but sum of counts should match
expect_equal(sum(ct_long[,3]), ncell(r))

# crosstab useNA
r_na <- r
r_na[1] <- NA
s_na <- s
s_na[2] <- NA
x_na <- c(r_na, s_na)

ct_na <- crosstab(x_na, useNA=TRUE)
expect_true(any(is.na(rownames(ct_na)) | rownames(ct_na) == "NA")) # depending on representation
expect_true(sum(ct_na) == ncell(r)) # Should sum to total cells if NAs included

ct_no_na <- crosstab(x_na, useNA=FALSE)
expect_true(sum(ct_no_na) < ncell(r))

m <- matrix(c(0,1,0,0,0,1), ncol=2)
v <- vect(m, type="polygons")
x <- as.vector(crds(v))

expect_equal(x, c(0,1,0,0,0,0,1,0))


r <- rast()
xy <- cbind(NA, c(NA, 0))
expect_equal(cellFromXY(r, xy), as.numeric(c(NA, NA)))

xy <- cbind(0, 0)
expect_equal(cellFromXY(r, xy), 32581)

## update meta — non-RGB raster: names, crs, extent persist
fname1 <- paste0(tempfile(), ".tif")
s <- rast(system.file("ex/logo.tif", package = "terra"))
RGB(s) <- NULL
x <- writeRaster(s, fname1)

ext(x) <- ext(x) + 1
crs(x) <- "+proj=utm +zone=1"
names(x) <- LETTERS[1:3]
update(x, names = TRUE, crs = TRUE, extent = TRUE)

y <- rast(fname1)
expect_equal(names(y), c("A", "B", "C"))
expect_equivalent(ext(y)[1], -1)
expect_equivalent(crs(y, describe = TRUE)$code, "32601")
file.remove(fname1)


## update meta — RGB raster: names persist
fname2 <- paste0(tempfile(), ".tif")
s2 <- rast(system.file("ex/logo.tif", package = "terra"))
x2 <- writeRaster(s2, fname2)

names(x2) <- c("X", "Y", "Z")
update(x2, names = TRUE)

y2 <- rast(fname2)
expect_equal(names(y2), c("X", "Y", "Z"))
aux <- paste0(fname2, ".aux.xml")
file.remove(fname2)
if (file.exists(aux)) file.remove(aux)


## update values — single layer
f3 <- paste0(tempfile(), ".tif")
x3 <- writeRaster(rast(nrows = 10, ncols = 10, vals = 1:100), f3)
update(x3, cells = c(1, 50, 100), values = c(999, 888, 777))
y3 <- rast(f3)
expect_equal(as.numeric(values(y3)[1, ]),  999)
expect_equal(as.numeric(values(y3)[50, ]), 888)
expect_equal(as.numeric(values(y3)[100,]), 777)
expect_equal(as.numeric(values(y3)[2, ]),  2)
file.remove(f3)


## update values — all layers broadcast
f4 <- paste0(tempfile(), ".tif")
x4 <- writeRaster(rast(nrows = 5, ncols = 5, nlyr = 3, vals = as.double(1:75)),
                   f4, datatype = "FLT4S")
update(x4, cells = c(1, 13), values = c(-5, -10))
y4 <- rast(f4)
v4 <- values(y4)
expect_true(all(v4[1, ]  == -5))
expect_true(all(v4[13, ] == -10))
expect_equal(as.numeric(v4[2, 1]), 2)
file.remove(f4)


## update values — specific layer only
f5 <- paste0(tempfile(), ".tif")
x5 <- writeRaster(rast(nrows = 5, ncols = 5, nlyr = 3, vals = as.double(1:75)),
                   f5, datatype = "FLT4S")
update(x5, cells = c(1, 25), values = c(0, 0), layer = 2)
y5 <- rast(f5)
v5 <- values(y5)
expect_equal(as.numeric(v5[1, ]),  c(1, 0, 51))
expect_equal(as.numeric(v5[25, ]), c(25, 0, 75))
file.remove(f5)


## update values — per-layer values (cs * nlyrs)
f6 <- paste0(tempfile(), ".tif")
x6 <- writeRaster(rast(nrows = 5, ncols = 5, nlyr = 2, vals = as.double(1:50)),
                   f6, datatype = "FLT4S")
update(x6, cells = c(1, 2), values = c(100, 200, 300, 400))
y6 <- rast(f6)
v6 <- values(y6)
expect_equal(as.numeric(v6[1, ]), c(100, 300))
expect_equal(as.numeric(v6[2, ]), c(200, 400))
file.remove(f6)


## update values — single value broadcast to multiple cells
f7 <- paste0(tempfile(), ".tif")
x7 <- writeRaster(rast(nrows = 5, ncols = 5, vals = as.double(1:25)),
                   f7, datatype = "FLT4S")
update(x7, cells = c(1, 2, 3, 4, 5), values = 0)
y7 <- rast(f7)
expect_true(all(values(y7)[1:5, ] == 0))
expect_equal(as.numeric(values(y7)[6, ]), 6)
file.remove(f7)

## costDist / gridDist — target cell distance zero (?costDist)
rc <- rast(
  ncols = 5, nrows = 5, crs = "+proj=utm +zone=1 +datum=WGS84",
  xmin = 0, xmax = 5, ymin = 0, ymax = 5, vals = 1
)
rc[13] <- 0
cd <- costDist(rc, target = 0)
gd <- gridDist(rc, 0)
expect_equal(as.numeric(cd[13]), 0)
expect_equal(as.numeric(gd[13]), 0)


## --- costDist: basic distance (no nearest) -----------------------------------
r <- rast(ncols=5, nrows=5, crs="+proj=utm +zone=1 +datum=WGS84",
		xmin=0, xmax=5, ymin=0, ymax=5, vals=1)
r[13] <- 0
d <- costDist(r)
expect_equal(nlyr(d), 1)
expect_equal(values(d)[13], 0)
expect_true(all(values(d) >= 0, na.rm=TRUE))


## --- costDist: nearest=TRUE returns 2 layers ---------------------------------
dn <- costDist(r, nearest=TRUE)
expect_equal(nlyr(dn), 2)
expect_equal(names(dn), c("distance", "nearest"))

## distance layer must be identical to costDist without nearest
expect_equivalent(values(d), values(dn[[1]]))

## target cell 13 should map to itself
expect_equal(values(dn[[2]])[13], 13)

## all non-NA cells must have a nearest target ID
v_id <- values(dn[[2]])
expect_true(all(!is.na(v_id)))
expect_true(all(v_id == 13))


## --- costDist: multiple targets ----------------------------------------------
r2 <- rast(ncols=5, nrows=5, crs="+proj=utm +zone=1 +datum=WGS84",
		xmin=0, xmax=5, ymin=0, ymax=5, vals=1)
r2[3] <- 0
r2[23] <- 0
dn2 <- costDist(r2, nearest=TRUE)
expect_equal(nlyr(dn2), 2)

## target cells must map to themselves
expect_equal(values(dn2[[2]])[3], 3)
expect_equal(values(dn2[[2]])[23], 23)

## cell 1 is closer to target 3 than to target 23
expect_equal(values(dn2[[2]])[1], 3)

## cell 25 is closer to target 23 than to target 3
expect_equal(values(dn2[[2]])[25], 23)


## --- gridDist: nearest=TRUE --------------------------------------------------
g <- rast(ncols=5, nrows=5, crs="+proj=utm +zone=1 +datum=WGS84",
		xmin=0, xmax=5, ymin=0, ymax=5, vals=1)
g[13] <- 0
gd <- gridDist(g)
gn <- gridDist(g, nearest=TRUE)
expect_equal(nlyr(gn), 2)
expect_equal(names(gn), c("distance", "nearest"))
expect_equivalent(values(gd), values(gn[[1]]))
expect_equal(values(gn[[2]])[13], 13)
expect_true(all(values(gn[[2]]) == 13))


## --- gridDist: multiple targets ----------------------------------------------
g2 <- rast(ncols=5, nrows=5, crs="+proj=utm +zone=1 +datum=WGS84",
		xmin=0, xmax=5, ymin=0, ymax=5, vals=1)
g2[3] <- 0
g2[23] <- 0
gn2 <- gridDist(g2, nearest=TRUE)
expect_equal(values(gn2[[2]])[3], 3)
expect_equal(values(gn2[[2]])[23], 23)
expect_equal(values(gn2[[2]])[1], 3)
expect_equal(values(gn2[[2]])[25], 23)


## --- costDist: with NA barriers and different friction -----------------------
r3 <- rast(ncols=5, nrows=5, crs="+proj=utm +zone=1 +datum=WGS84",
		xmin=0, xmax=5, ymin=0, ymax=5, vals=2)
r3[1] <- 0
r3[25] <- 0
r3[11:15] <- NA
dn3 <- costDist(r3, nearest=TRUE)
expect_equal(nlyr(dn3), 2)
expect_equal(values(dn3[[2]])[1], 1)
expect_equal(values(dn3[[2]])[25], 25)

## cells above the NA barrier reach target 1; cells below reach target 25
expect_true(all(values(dn3[[2]])[1:10] == 1, na.rm=TRUE))
expect_true(all(values(dn3[[2]])[16:25] == 25, na.rm=TRUE))

## NA cells stay NA in distance layer
expect_true(all(is.na(values(dn3[[1]])[11:15])))

\name{freq}

\docType{methods}

\alias{freq}
\alias{freq,SpatRaster-method}

\title{Frequency table}

\description{
Frequency table of the values of a SpatRaster. \code{NA}s are not counted unless \code{value=NA}. 

You can provide a SpatVector or additional SpatRaster to define zones for which to do tabulations.
}

\usage{
\S4method{freq}{SpatRaster}(x, digits=0, value=NULL, bylayer=TRUE, usenames=FALSE, 
		zones=NULL, wide=FALSE, touches=FALSE)
}

\arguments{
  \item{x}{SpatRaster}
  \item{digits}{integer. Used for rounding the values before tabulation. Ignored if \code{NA}}
  \item{value}{numeric. An optional single value to only count the number of cells with that value. This value can be \code{NA}}
  \item{bylayer}{logical. If \code{TRUE} tabulation is done by layer}  
  \item{usenames}{logical. If \code{TRUE} layers are identified by their names instead of their numbers Only relevant if \code{bylayer} is \code{TRUE}}
  \item{zones}{SpatRaster or SpatVector to define zones for which the tabulation should be done}
  \item{wide}{logical. Should the results by "wide" instead of "long"?}  
  \item{touches}{logical. If \code{TRUE}, all cells touched by lines or polygons will be included, not just those on the line render path, or whose center point is within the polygon. Only relevant if \code{zones} is a SpatVector}
}

\value{
A \code{data.frame} with 3 columns (layer, value, count) unless \code{bylayer=FALSE} in which case a\code{data.frame} with two columns is returned (value, count). 
}

\author{Andrew Gene Brown, Robert J. Hijmans}

\examples{
r <- rast(nrows=10, ncols=10)
set.seed(2)
values(r) <- sample(5, ncell(r), replace=TRUE)

freq(r)

x <- c(r, r/3)
freq(x, bylayer=FALSE)
freq(x)

freq(x, digits=1)
freq(x, digits=-1)

freq(x, value=5)

}

\keyword{spatial}
\keyword{univar}

\name{split}

\docType{methods}

\alias{split}
\alias{split,SpatRaster,ANY-method}
\alias{split,SpatVector,ANY-method}
\alias{split,SpatVector,SpatVector-method}


\title{Split a SpatRaster or SpatVector}

\description{ 
Split a SpatRaster by layer, or a SpatVector by attributes. You can also split the geometry of a SpatVector of polygon or lines with another SpatVector of polygon or lines. 
}

\usage{
\S4method{split}{SpatRaster,ANY}(x, f)

\S4method{split}{SpatVector,ANY}(x, f)

\S4method{split}{SpatVector,SpatVector}(x, f, min_node_dist=10000)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{f}{If \code{x} is a SpatRaster: a vector of the length \code{nlyr(x)}. If \code{x} is a SpatVector: one or more variable names, or a vector of the same length as \code{x}, or a list of such vectors. If \code{x} is a SpatVector of polygons, you can also use a SpatVector of lines or polygons to split the polygon geometries}
  \item{min_node_dist}{positive number indicating the minimum node distance to use (in m) for longitude/latitude data. To ensure this minimum distance between nodes, additional nodes are added as needed, to improve precision. See \code{\link{densify}}}
}

\value{
list or SpatVector
}

\seealso{\code{\link{segregate}}}

\examples{

## split layers
s <- rast(system.file("ex/logo.tif", package="terra"))   
y <- split(s, c(1,2,1))
sds(y)

## split attributes
v <- vect(system.file("ex/lux.shp", package="terra"))
x <- split(v, "NAME_1")

## split geometries
v <- v[1:5,]
line <- vect(matrix(c(5.79, 6.22, 5.75, 6.1, 5.8, 
	50.14, 50.05, 49.88, 49.85, 49.71), ncol=2), "line")
s <- split(v, line)
}


\keyword{methods}
\keyword{spatial}

\name{gridDist}

\alias{gridDist}
\alias{gridDist,SpatRaster-method}


\title{Distance on a grid}

\description{
The function calculates the distance to cells of a SpatRaster when the path has to go through the centers of the eight neighboring raster cells.
 
The default distance (when \code{scale=1}, is meters if the coordinate reference system (CRS) of the SpatRaster is longitude/latitude (\code{+proj=longlat}) and in the linear units of the CRS (typically meters) in other cases. 
 
Distances are computed by summing local distances between cells, which are connected with their neighbors in 8 directions.

The shortest distance to the cells with the \code{target} value is computed for all cells that are not \code{NA}. Cells that are \code{NA} cannot be traversed and are ignored, unless the target itself is \code{NA}, in which case the distance to the nearest cell that is not \code{NA} is computed for all cells that are \code{NA}. 
}

\usage{
\S4method{gridDist}{SpatRaster}(x, target=0, scale=1, maxiter=50, nearest=FALSE, filename="", ...) 
}

\arguments{
\item{x}{SpatRaster}
\item{target}{numeric. value of the target cells (where to compute distance to)}
\item{scale}{numeric. Scale factor. For longitude/latitude data 1 = "m" and 1000 = "km". For planar data that is also the case of the distance unit of the crs is "m"}
\item{maxiter}{numeric. The maximum number of iterations. Increase this number if you get the warning that \code{costDistance} did not converge. Only relevant when target is not \code{NA}}
\item{nearest}{logical. If \code{TRUE}, a second layer is returned with the cell number of the nearest target cell. Only relevant when target is not \code{NA}}
\item{filename}{character. output filename (optional)}
\item{...}{additional arguments as for \code{\link{writeRaster}}}  
}


\seealso{See \code{\link[terra]{distance}} for "as the crow flies" distance, and \code{\link{costDist}} for distance across a landscape with variable friction} 


\value{SpatRaster. If \code{nearest=TRUE}, a two-layer SpatRaster with the distance in the first layer and the cell number of the nearest target in the second layer}


\examples{
# global lon/lat raster
r <- rast(ncol=10,nrow=10, vals=1)
r[48] <- 0
r[66:68] <- NA
d <- gridDist(r) 
plot(d)


# planar
crs(r) <- "+proj=utm +zone=15 +ellps=GRS80 +datum=NAD83 +units=m +no_defs"
d <- gridDist(r) 
plot(d)

# distance to cells that are not NA 
rr <- classify(r, cbind(1, NA))
dd <- gridDist(rr, NA) 


}

\keyword{spatial}

\name{centroids}

\alias{centroids}
\alias{centroids,SpatVector-method}
\alias{centroids,SpatRaster-method}


\title{Centroids}

\description{
Get the centroids of polygons or lines, or centroid-like points that are guaranteed to be inside the polygons or on the lines.

Or get the (weighted) centroid of the cells with values (not \code{NA}) of a SpatRaster.
}

\usage{
\S4method{centroids}{SpatVector}(x, inside=FALSE, correct=FALSE)

\S4method{centroids}{SpatRaster}(x, weighted=FALSE)
}

\arguments{
\item{x}{SpatVector}
\item{inside}{logical. If \code{TRUE} the points returned are guaranteed to be inside the polygons or on the lines, but they are not the true centroids. True centroids may be outside a polygon, for example when a polygon is "bean shaped".}
\item{correct}{If \code{TRUE} corrected centroids are returned for geometries in \code{x} that have a true centroid that is not inside the geometry. If \code{inside=TRUE} it is replaced with another point that is guaranteed to be inside the geometry. If it is \code{FALSE}, it is replaced with the nearest point on the border of the geometry}
\item{weighted}{logical. If \code{TRUE} the centroids are computed as the weighted means of the coordinates of cells with values}
}

\value{SpatVector of points}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
x <- centroids(v)
y <- centroids(v, TRUE)
z <- centroids(v, correct=TRUE) ## same as z in this case


f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
centroids(r)


p <- vect("POLYGON ((5.9 50, 6.3 50, 6.5 49.8, 6.3 49.6, 5.9 49.5, 6.3 49.7, 6.3 49.9, 5.9 50))")
plot(p)
points(centroids(p), col="red", cex=2)
points(centroids(p, inside=TRUE), col="blue", cex=2)
points(centroids(p, inside=FALSE, correct=TRUE), col="green", cex=2)
}

\keyword{spatial}

\name{extract}

\docType{methods}

\alias{extract}
\alias{extract,SpatRaster,SpatVector-method}
\alias{extract,SpatRaster,sf-method}
\alias{extract,SpatRaster,SpatExtent-method}
\alias{extract,SpatRaster,matrix-method}
\alias{extract,SpatRaster,data.frame-method}
\alias{extract,SpatRaster,numeric-method}
\alias{extract,SpatVector,SpatVector-method}
\alias{extract,SpatVector,matrix-method}
\alias{extract,SpatVector,data.frame-method}
\alias{extract,SpatRasterCollection,ANY-method}
\alias{extract,SpatRasterDataset,ANY-method}


\title{Extract values from a SpatRaster or polygon SpatVector}

\description{
Extract values from a SpatRaster or a polygon SpatVector for a set of locations. The locations can be a SpatVector (points, lines, polygons), a data.frame or matrix with (x, y) or (longitude, latitude -- in that order!) coordinates, or a vector with cell numbers.  

When argument \code{y} is a \code{SpatVector} the first column has the ID (record number) of the \code{SpatVector} used (unless you set \code{ID=FALSE}).

Alternatively, you can use \code{\link{zonal}} after using \code{\link{rasterize}} with a \code{SpatVector} (this may be more efficient in some cases).
} 

\usage{
\S4method{extract}{SpatRaster,SpatVector}(x, y, fun=NULL, method="simple", cells=FALSE, xy=FALSE,
    ID=TRUE, weights=FALSE, exact=FALSE, touches=is.lines(y), small=TRUE,
	layer=NULL, bind=FALSE, raw=FALSE, search_radius=0, wide=FALSE, ...)

\S4method{extract}{SpatRaster,SpatExtent}(x, y, cells=FALSE, xy=FALSE)

\S4method{extract}{SpatRaster,matrix}(x, y, cells=FALSE, method="simple")

\S4method{extract}{SpatRaster,numeric}(x, y, xy=FALSE, raw=FALSE)

\S4method{extract}{SpatVector,SpatVector}(x, y, count=FALSE)
}

\arguments{
\item{x}{SpatRaster or SpatVector of polygons}
\item{y}{SpatVector (points, lines, or polygons). Alternatively, for points, a 2-column matrix or data.frame (x, y) or (lon, lat). Or a vector with cell numbers}
\item{fun}{function to summarize the extracted data by line or polygon geometry, such as \code{sum}, as well as terra built-in functions \code{"isNA"}, and \code{"notNA"} to get the count of cells that are (not) \code{NA}, and \code{"sum2"} (the sum of squares). You can use \code{fun=table} to tabulate raster values for each line or polygon geometry. If \code{weights=TRUE} or \code{exact=TRUE} only \code{mean}, \code{sum}, \code{min}, \code{max} and \code{table} are accepted --- and these functions consider the fraction of a cell that is covered when computing the mean or the sum). Ignored if \code{y} has point geometry. }
\item{method}{character. method for extracting values with points ("simple" or "bilinear"). With "simple" values for the cell a point falls in are returned. With "bilinear" the returned values are interpolated from the values of the four nearest raster cells}
\item{cells}{logical. If \code{TRUE} the cell numbers are also returned, unless \code{fun} is not \code{NULL}. Also see \code{\link{cells}}}
\item{xy}{logical. If \code{TRUE} the coordinates of the cells are also returned, unless \code{fun} is not \code{NULL}. See \code{\link{xyFromCell}}}
\item{ID}{logical. Should an ID column be added? If so, the first column returned has the IDs (record numbers) of \code{y}}
\item{weights}{logical. If \code{TRUE} and \code{y} has polygons, the approximate fraction of each cell that is covered is returned as well. This changes the effect of argument \code{fun}}
\item{exact}{logical. If \code{TRUE} and \code{y} has polygons, the exact fraction of each cell that is covered is returned as well. This changes the effect of argument \code{fun}}
\item{touches}{logical. If \code{TRUE}, values for all cells touched by lines or polygons are extracted, not just those on the line render path, or whose center point is within the polygon. Not relevant for points; and always considered \code{TRUE} when \code{weights=TRUE} or \code{exact=TRUE}}
\item{small}{logical. If \code{TRUE}, values for all cells in touched polygons are extracted if none of the cells center points is within the polygon; even if \code{touches=FALSE}}
\item{layer}{character or numeric to select the layer to extract from for each geometry. If \code{layer} is a character it can be a name in \code{y} or a vector of layer names. If it is numeric, it must be integer values between \code{1} and \code{nlyr(x)}}
\item{bind}{logical. If \code{TRUE}, a SpatVector is returned consisting of the input SpatVector \code{y} and the \code{cbind}-ed extracted values}
\item{raw}{logical. If \code{TRUE}, a matrix is returned with the "raw" numeric cell values. If \code{FALSE}, a data.frame is returned and the cell values are transformed to factor, logical, or integer values, where appropriate}
\item{search_radius}{positive number. A search-radius that is used when \code{y} has point geometry. If this value is larger than zero, it is the maximum distance used to find the a cell with a value that is nearest to the cell that the point falls in if that cell that has a missing (\code{NA}) value. The value of this nearest cell, the distance to the original cell, and the new cell number are returned. The radius should be expressed in m if the data have lon/lat coordinates or in the distance unit of the crs in other cases (typically also m). For lon/lat data, the mean latitude of the points is used to compute the distances, so this may be imprecise for data with a large latitudinal range}
\item{wide}{logical. Only relevant when \code{fun="table"}. If \code{TRUE}, and \code{x} has a single layer, the table is returned in the wide format}
\item{...}{additional arguments to \code{fun} if \code{y} is a SpatVector. For example \code{na.rm=TRUE}. Or arguments passed to the \code{SpatRaster,SpatVector} method if \code{y} is a matrix (such as the \code{method} and \code{cells} arguments)}
\item{count}{logical. If \code{TRUE} and \code{x} has polygons geometry and \code{y} has points geometry, the number of points in polygons is returned}
}

\value{data.frame, matrix or SpatVector}

\seealso{\code{\link{values}, \link{zonal}, \link{extractAlong}, \link{extractRange}, \link{rapp}}}

\examples{
r <- rast(ncols=5, nrows=5, xmin=0, xmax=5, ymin=0, ymax=5)
values(r) <- 1:25
xy <- cbind(lon=c(0.5,2.5), lat=c(0.5,2.5))
p <- vect(xy, crs="+proj=longlat +datum=WGS84")

extract(r, xy)
extract(r, p)

r[1,]
r[5]
r[,5]

r[c(0:2, 99:101)]

f <- system.file("ex/meuse.tif", package="terra")
r <- rast(f)

xy <- cbind(179000, 330000)
xy <- rbind(xy-100, xy, xy+1000)
extract(r, xy)

p <- vect(xy)
g <- geom(p)
g

extract(r, p)

x <- r + 10
extract(x, p)

i <- cellFromXY(r, xy)
x[i]
r[i]

y <- c(x,x*2,x*3)
y[i]

## extract with a polygon
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
v <- v[1:2,]

rf <- system.file("ex/elev.tif", package="terra")
x <- rast(rf)
extract(x, v, mean, na.rm=TRUE)

z <- rast(v, resolution=.1, names="test")
values(z) <- 1:ncell(z)
e <- extract(z, v, ID=TRUE)
e
tapply(e[,2], e[,1], mean, na.rm=TRUE)

x <- c(z, z*2, z/3)
names(x) <- letters[1:3]

e <- extract(x, v, ID=TRUE)
de <- data.frame(e)
aggregate(de[,2:4], de[,1,drop=FALSE], mean)
}

\keyword{methods}
\keyword{spatial}

\name{writeVector}

\alias{writeVector,SpatVector,character-method}

\alias{writeVector}

\title{Write SpatVector data to a file}

\description{
Write a SpatVector to a file. You can choose one of many file formats.  
}

\usage{
\S4method{writeVector}{SpatVector,character}(x, filename, filetype=NULL, layer=NULL, insert=FALSE,
    overwrite=FALSE, options="ENCODING=UTF-8")
}

\arguments{
  \item{x}{SpatVector}
  \item{filename}{character. Output filename}
  \item{filetype}{character. A file format associated with a GDAL "driver" such as "ESRI Shapefile". See \code{gdal(drivers=TRUE)} or the \href{https://gdal.org/en/latest/drivers/vector/index.html}{GDAL docs}. If \code{NULL} it is attempted to guess the filetype from the filename extension}
  \item{layer}{character. Output layer name. If \code{NULL} the filename is used}
  \item{insert}{logical. If \code{TRUE}, a new layer is inserted into the file, or an existing layer overwritten (if \code{overwrite=TRUE}), if the format supports it (e.g. GPKG allows that). See \code{\link{vector_layers}} to remove a layer}
  \item{overwrite}{logical. If \code{TRUE} and \code{insert=FALSE}, \code{filename} is overwritten if the file format and layer structure permits it. If \code{TRUE} and \code{insert=TRUE}, only the target layer is overwritten if the format supports it (e.g. GPKG).}
  \item{options}{character. Format specific GDAL options such as "ENCODING=UTF-8". Use NULL or "" to not use any options}
}

\examples{
v <- vect(cbind(1:5,1:5))
crs(v) <- "+proj=longlat +datum=WGS84"
v$id <- 1:length(v)
v$name <- letters[1:length(v)]
tmpf1 <- paste0(tempfile(), ".gpkg")
writeVector(v, tmpf1, overwrite=TRUE)
x <- vect(tmpf1)

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
tmpf2 <- paste0(tempfile(), ".gpkg")
writeVector(v, tmpf2, overwrite=TRUE)
y <- vect(tmpf2)
}



\keyword{ spatial }
\keyword{ methods }

\name{mask}

\docType{methods}

\alias{mask}
\alias{mask,SpatRaster,SpatRaster-method}
\alias{mask,SpatRaster,SpatVector-method}
\alias{mask,SpatRaster,SpatExtent-method}
\alias{mask,SpatRaster,sf-method}
\alias{mask,SpatVector,SpatVector-method}
\alias{mask,SpatVector,SpatExtent-method}
\alias{mask,SpatVector,sf-method}

\title{Mask values in a SpatRaster or SpatVector}

\description{
If \code{x} is a \code{SpatRaster}: 
Create a new SpatRaster that has the same values as SpatRaster \code{x}, except for the cells that are \code{NA} (or other \code{maskvalue}) in another SpatRaster (the 'mask'), or the cells that are not covered by a SpatVector or SpatExtent. These cells become \code{NA} (or another \code{updatevalue}).

If \code{x} is a SpatVector or SpatExtent: 
Select geometries of \code{x} that intersect, or not intersect, with the geometries of \code{y}.
} 

\usage{
\S4method{mask}{SpatRaster,SpatRaster}(x, mask, inverse=FALSE, maskvalues=NA, 
   updatevalue=NA, filename="", ...)
   
\S4method{mask}{SpatRaster,SpatVector}(x, mask, inverse=FALSE, updatevalue=NA,
	touches=TRUE, filename="", ...)

\S4method{mask}{SpatRaster,SpatExtent}(x, mask, inverse=FALSE, updatevalue=NA,
	touches=TRUE, filename="", ...)

\S4method{mask}{SpatVector,SpatVector}(x, mask, inverse=FALSE)

\S4method{mask}{SpatVector,SpatExtent}(x, mask, inverse=FALSE)
}


\arguments{
\item{x}{SpatRaster or SpatVector}
\item{mask}{SpatRaster or SpatVector}
\item{inverse}{logical. If \code{TRUE}, areas on mask that are _not_ the \code{maskvalue} are masked}
\item{maskvalues}{numeric. The value(s) in \code{mask} that indicate which cells of \code{x} should be masked (change their value to \code{updatevalue} (default = \code{NA}))}
\item{updatevalue}{numeric. The value that masked cells should become (if they are not \code{NA})}
\item{touches}{logical. If \code{TRUE}, all cells touched by lines or polygons will be masked, not just those on the line render path, or whose center point is within the polygon}
\item{filename}{character. Output filename}
\item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{SpatRaster}

\seealso{\code{\link{subst}},  \code{\link{crop}}}


\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
msk <- ifel(r < 400, NA, 1)

m <- mask(r, msk)

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)[1,]

mv1 <- mask(r, v)
mv2 <- crop(r, v, mask=TRUE)
}

\keyword{methods}
\keyword{spatial}

\name{makeVRT}

\alias{makeVRT}

\title{Make a VRT header file}

\description{ 
Create a VRT header file for a "flat binary" raster file that needs a header file to be able to read it, but does not have it. 
}

\usage{
makeVRT(filename, nrow, ncol, nlyr=1, extent, xmin, ymin, xres, yres=xres, xycenter=TRUE,
   crs="+proj=longlat", lyrnms="", datatype, NAflag=NA, bandorder="BIL", byteorder="LSB",
   toptobottom=TRUE, offset=0, scale=1)
}

\arguments{
  \item{filename}{character. raster filename (without the ".vrt" extension)}
  \item{nrow}{positive integer, the number of rows}
  \item{ncol}{positive integer, the number of columns}
  \item{nlyr}{positive integer, the number of layers}
  \item{extent}{SpatExtent or missing}
  \item{xmin}{numeric. minimum x coordinate (only used if \code{extent} is missing)}
  \item{ymin}{numeric. minimum y coordinate (only used if \code{extent} is missing)}
  \item{xres}{positive number. x resolution}
  \item{yres}{positive number. y resolution)}
  \item{xycenter}{logical. If \code{TRUE}, \code{xmin} and \code{xmax} represent the coordinates of the center of the extreme cell, instead of the coordinates of the outside corner. Only used if \code{extent} is missing}
  \item{crs}{character. Coordinate reference system description}
  \item{lyrnms}{character. Layer names}
  \item{datatype}{character. One of "INT2S", "INT4S", "INT1U", "INT2U", "INT4U", "FLT4S", "FLT8S". If missing, this is guessed from the file size (INT1U for 1 byte per value, INT2S for 2 bytes and FLT4S for 4 bytes per value). This may be wrong because, for example, 2 bytes per value may in fact be INT2U (with the U for unsigned) values}
  \item{NAflag}{numeric. The value used as the "NA flag"}
  \item{bandorder}{character. One of "BIL", "BIP", or "BSQ". That is Band Interleaved by Line, or by Pixel, or Band SeQuential}
  \item{byteorder}{character. One of "LSB", "MSB". "MSB" is common for files generated on Linux systems, whereas "LSB" is common for files generated on windows}
  \item{toptobottom}{logical. If \code{FALSE}, the values are read bottom to top}
  \item{offset}{numeric. offset to be applied}
  \item{scale}{numeric. scale to be applied}
}

\value{
character (.VRT filename)
}

\seealso{\code{\link{vrt}} to create a vrt for a collection of raster tiles}


\keyword{methods}
\keyword{spatial}

\name{patches}

\alias{patches}
\alias{patches,SpatRaster-method}
  
\title{Detect patches (clumps) of cells}

\description{
Detect patches (clumps). Patches are groups of cells that are surrounded by cells that are \code{NA}. Set \code{zeroAsNA} to \code{TRUE} to also identify patches separated by cells with values of zero. 
}

\usage{
\S4method{patches}{SpatRaster}(x, directions=4, values=FALSE, zeroAsNA=FALSE, allowGaps=TRUE, filename="", ...)
}

\arguments{
\item{x}{SpatRaster}
\item{directions}{integer indicating which cells are considered adjacent. Should be 8 (Queen's case) or 4 (Rook's case)}
  \item{values}{logical. If \code{TRUE} use cell values to distinguish patches. If \code{FALSE}, all cells that are not \code{NA} are considered identical}
  \item{zeroAsNA}{logical. If \code{TRUE} treat cells that are zero as if they were \code{NA}. Ignored if \code{values=TRUE}}
  \item{allowGaps}{logical. If \code{TRUE} there may be gaps in the patch IDs (e.g. you may have patch IDs 1, 2, 3 and 5, but not 4). If it is FALSE, these numbers will be recoded from 1 to the number of patches (4 in this example)}
  \item{filename}{character. Output filename}
  \item{...}{options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster. Cell values are patch numbers
}

\author{Andrew Gene Brown, Robert J. Hijmans}

\seealso{ \code{\link{focal}}, \code{\link{boundaries}} }

\examples{
r <- rast(nrows=18, ncols=36, xmin=0)
r[1:2, 5:8] <- 1
r[5:8, 2:6] <- 1
r[7:12, 22:36] <- 1
r[15:16, 18:29] <- 1
p <- patches(r)

# zero as background instead of NA
r <- rast(nrows=10, ncols=10, xmin=0, vals=0)
r[3, 3] <- 10
r[4, 4] <- 10
r[5, 5:8] <- 12
r[6, 6:9] <- 12

# treat zeros as NA

p4 <- patches(r, zeroAsNA=TRUE)
p8 <- patches(r, 8, zeroAsNA=TRUE)

### patches for different values
p <- patches(r, values=TRUE)

### patch ID values are not guaranteed to be consecutive
r <- rast(nrows=5, ncols=10, xmin=0)
set.seed(0)
values(r)<- round(runif(ncell(r))*0.7)
rp <- patches(r, directions=8, zeroAsNA=TRUE) 
plot(rp, type="classes"); text(rp)

## unless you set allowGaps=FALSE
rp <- patches(r, directions=8, zeroAsNA=TRUE, allowGaps=FALSE) 
plot(rp, type="classes"); text(rp)

### use zonal to remove small patches 
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
x <- classify(r, cbind(-Inf, 400, NA))
y <- patches(x)
# remove patches smaller than 100 ha
rz <- zonal(cellSize(y, unit="ha"), y, sum, as.raster=TRUE)
s <- ifel(rz < 250, NA, y)
}

\keyword{methods}
\keyword{spatial}

\name{shortestPath}

\docType{methods}

\alias{shortestPath}
\alias{shortestPath,SpatNetwork-method}

\title{Shortest paths on a SpatNetwork}

\description{
Compute shortest paths between pairs of nodes on a \code{SpatNetwork} using Dijkstra's algorithm. The path weight is the sum of \code{\link{net_weights}} along the traversed edges -- by default this is geometric length in meters (geodesic for lon/lat data, planar Euclidean otherwise), but custom weights such as travel time can be set with \code{net_weights<-} or via the \code{weights} argument of \code{\link{netw}}.

The function honours \code{net_directed(net)}: in a directed network only edges traversed in their stored \code{from_node \\eqn{\\to} to_node} orientation are allowed, which is what you want for one-way streets or stream networks.

The result is a \code{SpatVector} of lines that follow the original (sinuous) edge geometries, so that the returned features can be plotted, projected and written like any other \code{SpatVector}.
}

\usage{
\S4method{shortestPath}{SpatNetwork}(x, from, to, ...)
}

\arguments{
\item{x}{\code{SpatNetwork}}
\item{from}{integer. One or more 1-based node ids (rows of \code{net_nodes(x)}) to start from.}
\item{to}{integer. One or more 1-based node ids to reach. Either \code{from} or \code{to} may be length 1 to be recycled against the other; otherwise the two must have the same length.}
\item{...}{additional arguments (currently ignored)}
}

\details{
The implementation builds a single adjacency list from \code{net_edges(x)} and then runs one Dijkstra single-source shortest-path traversal per unique source node, caching the result so that querying many destinations from the same origin is efficient. Negative or \code{NA} edge weights are treated as zero (Dijkstra cannot handle negative cycles).

When a destination is unreachable from its source the corresponding output feature has an empty geometry and \code{NA} distance. When \code{from == to} the distance is \code{0} and the geometry is empty.
}

\value{
A \code{SpatVector} of lines with one feature per (\code{from}, \code{to}) pair, with columns
\itemize{
\item \code{from}: 1-based source node id
\item \code{to}: 1-based destination node id
\item \code{distance}: total path weight (\code{NA} if unreachable)
}
}

\seealso{\code{\link{netw}}, \code{\link{net_weights}}}

\examples{
# Two crossing roads
a <- vect("LINESTRING(0 0, 10 10)", crs = "local")
b <- vect("LINESTRING(0 10, 10 0)", crs = "local")
roads <- rbind(a, b)
roads$speed <- c(50, 100)   # km/h, used as a "cost" column

net <- netw(roads)
sp <- shortestPath(net, from = 1, to = 4)
sp$distance

# Multiple destinations from one source
shortestPath(net, from = 1, to = c(2, 3, 4, 5))$distance

# Custom weights from a column of the source SpatVector
nslow <- netw(roads, weights = "speed")
shortestPath(nslow, from = 1, to = 4)$distance
}


\keyword{methods}
\keyword{spatial}

\name{buffer}

\alias{buffer}
\alias{buffer,SpatRaster-method}
\alias{buffer,SpatVector-method}


\title{Create a buffer around vector geometries or raster patches}

\description{
Calculate a buffer around all cells that are not \code{NA} in a SpatRaster, or around the geometries of a SpatVector.

SpatRaster cells inside the buffer distance get a value of 1.

Note that the distance unit of the buffer \code{width} parameter is meters if the CRS is (\code{+proj=longlat}), and in map units (typically also meters) if not. 

If your data has a longitude/latitude CRS do \bold{not} project them to a planar CRS because that makes the results less precise (see Examples).
}

\usage{
\S4method{buffer}{SpatRaster}(x, width, background=0, include=TRUE, filename="", ...)

\S4method{buffer}{SpatVector}(x, width, quadsegs=10, capstyle="round", 
		joinstyle="round", mitrelimit=NA, singlesided=FALSE)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{width}{numeric. Unit is meter if \code{x} has a longitude/latitude CRS, or in the units of the coordinate reference system in other cases (typically also meter). The value should be > 0 if \code{x} is a SpatRaster. If \code{x} is a SpatVector, this argument is vectorized, meaning that you can provide a different value for each geometry in \code{x}; and you can also use the name of a variable in \code{x} that has the widths}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
  \item{background}{numeric. value to assign to cells outside the buffer. If this value is zero or FALSE, a boolean SpatRaster is returned}  
  \item{include}{logical. If \code{TRUE} the raster cells that are not \code{NA} are included in the buffer. Otherwise these cells get the background value}  
  \item{quadsegs}{positive integer. Number of line segments to use to draw a quart circle}  
  \item{capstyle}{character. One of "round", "square" or "flat". Ignored if \code{is.lonlat(x)}}
  \item{joinstyle}{character. One of "round", "mitre" or "bevel". Ignored if \code{is.lonlat(x)}}  
  \item{mitrelimit}{numeric. Place an upper bound on a mitre join to avoid it from extending very far from acute angles in the input geometry. Ignored if \code{is.lonlat(x)}}
  \item{singlesided}{logical. If \code{TRUE} a buffer is constructed on only one side of each input line.  Ignored if \code{is.lonlat(x)}}  
}


\value{
Same as \code{x} 
}


\seealso{
\code{\link{distance}}, \code{\link{elongate}}
}


\examples{
r <- rast(ncols=36, nrows=18)
r[500] <- 1
b <- buffer(r, width=5000000) 
plot(b)

v <- vect(rbind(c(170,10), c(0,60)), crs="+proj=merc")
b <- buffer(v, 20)
plot(b)
points(v)

crs(v) <- "+proj=longlat" 
b <- buffer(v, 1500000)
plot(b)
points(v)
}

\keyword{spatial}

\name{flip}

\docType{methods}

\alias{flip}
\alias{flip,SpatRaster-method}
\alias{flip,SpatVector-method}

\alias{rev}
\alias{rev,SpatRaster-method}
  
\title{Flip or reverse a raster}

\description{
Flip the values of a SpatRaster by inverting the order of the rows (\code{direction= "vertical"}) or the columns (\code{direction="horizontal"}).

\code{rev} is the same as a horizontal *and* a vertical flip.
}

\usage{
\S4method{flip}{SpatRaster}(x, direction="vertical", filename="", ...)

\S4method{flip}{SpatVector}(x, direction="vertical")

\S4method{rev}{SpatRaster}(x)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{direction}{character. Should (partially) match "vertical" to flip by rows, or "horizontal" to flip by columns}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{ \code{\link{trans}}, \code{\link{rotate}} }


\examples{
r <- rast(nrow=18, ncol=36)
m <- matrix(1:ncell(r), nrow=18)
values(r) <- as.vector(t(m))
rx <- flip(r, direction="h")

values(r) <- as.vector(m)
ry <- flip(r, direction="v")

v <- rev(r)
}

\keyword{spatial}

\name{boxplot}

\docType{methods}

\alias{boxplot}
\alias{boxplot,SpatRaster-method}

\title{
Box plot of SpatRaster data
}

\description{
Box plot of layers in a SpatRaster 
}

\usage{
\S4method{boxplot}{SpatRaster}(x, y=NULL, maxcell=100000, ...)
}

\arguments{
\item{x}{SpatRaster}
\item{y}{NULL or a SpatRaster. If \code{x} is a SpatRaster it used to group the values of \code{x} by "zone"}
\item{maxcell}{Integer. Number of cells to sample from datasets}
\item{...}{additional arguments passed to \code{graphics::\link[graphics]{boxplot}}}
}

\value{
boxplot returns a list (invisibly) that can be used with \code{\link{bxp}}
}

\seealso{
\code{\link{pairs}, \link{hist}}
}

\examples{
r1 <- r2 <- r3 <- rast(ncols=10, nrows=10)
set.seed(409)
values(r1) <- rnorm(ncell(r1), 100, 40)
values(r2) <- rnorm(ncell(r1), 80, 10)
values(r3) <- rnorm(ncell(r1), 120, 30)
s <- c(r1, r2, r3)
names(s) <- c("Apple", "Pear", "Cherry")

boxplot(s, notch=TRUE, col=c("red", "blue", "orange"), main="Box plot", ylab="random", las=1)

op <- par(no.readonly = TRUE)
par(mar=c(4,6,2,2))
boxplot(s, horizontal=TRUE, col="lightskyblue", axes=FALSE)
axis(1)
axis(2, at=0:3, labels=c("", names(s)), las=1, cex.axis=.9, lty=0)
par(op)

## boxplot with 2 layers
v <- vect(system.file("ex/lux.shp", package="terra"))
r <- rast(system.file("ex/elev.tif", package="terra"))
y <- rasterize(v, r, "NAME_2")
b <- boxplot(r, y)
bxp(b)
}


\keyword{spatial}

\name{not.na}

\docType{methods}

\alias{not.na}
\alias{not.na,SpatRaster-method}


\title{is not NA}

\description{
Shortcut method to avoid the two-step \code{!is.na(x)}
}

\usage{
\S4method{not.na}{SpatRaster}(x, falseNA=FALSE, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{falseNA}{logical. If \code{TRUE}, the output cell values are either \code{TRUE}, for cells that are not \code{NA} in \code{x}, or \code{NA} for the cells that are \code{NA} in \code{x}. Otherwise, the output values are either \code{TRUE} or \code{FALSE}}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\seealso{
\code{\link{Compare-methods}}
}

\value{
SpatRaster
}

\examples{
r <- rast(ncols=5, nrows=5, vals=1, ext=c(0,1,0,1))
r[10:20] <- NA
x <- not.na(r)
y <- not.na(r, falseNA=TRUE)
unique(values(c(x, y)))
}

\keyword{methods}
\keyword{spatial}

\name{Arith-methods}

\docType{methods}

\alias{Arith-methods}

\alias{Arith,SpatExtent,numeric-method}
\alias{Arith,numeric,SpatExtent-method}
\alias{Arith,SpatExtent,SpatExtent-method}

\alias{Arith,SpatRaster,SpatRaster-method}
\alias{Arith,SpatVector,SpatVector-method}
\alias{Arith,SpatRaster,missing-method}
\alias{Arith,numeric,SpatRaster-method}
\alias{Arith,SpatRaster,numeric-method}
\alias{Arith,logical,SpatRaster-method}
\alias{Arith,SpatRaster,logical-method}
\alias{Arith,missing,SpatRaster-method}
\alias{Arith,SpatRaster,matrix-method}
\alias{Arith,matrix,SpatRaster-method}


\title{Arithmetic}

\description{

Standard arithmetic operators for computations with SpatRasters. Computations are local (applied on a cell by cell basis). If multiple SpatRasters are used, these must have the same geometry (extent and resolution). These operators have been implemented:

\code{ +, -, *, /, ^, \%\%, \%/\% }

You can also use a SpatRaster and a vector or a matrix. If you use a SpatRaster with a vector of multiple numbers, each element in the vector is considered a layer (with a constant value). If you use a SpatRaster with a matrix, the number of columns of the matrix must match the number of layers of the SpatRaster. The rows are used to match the cells. That is, if there are two rows, these match cells 1 and 2, and they are recycled to 3 and 4, etc. 

The following methods have been implemented for \code{(SpatExtent, SpatExtent)}: \code{+, -}, and the following for \code{(SpatExtent, numeric)}: \code{+, -, *, /, \%\%}
}

\seealso{
\code{\link{ifel}} to conveniently combine operations and \code{\link{Math-methods}} or \code{\link{app}} to use mathematical functions not implemented by the package.
}


\value{
SpatRaster or SpatExtent
}


\examples{
r1 <- rast(ncols=10, nrows=10)
v <- runif(ncell(r1))
v[10:20] <- NA
values(r1) <- v
r2 <- rast(r1)
values(r2) <- 1:ncell(r2) / ncell(r2)
r3 <- r1 + r2
r2 <- r1 / 10
r3 <- r1 * (r2 - 1 / r2)

b <- c(r1, r2, r3)
b2 <- b * 10

### SpatExtent methods
x <- ext(0.1, 2.2, 0, 3)
y <- ext(-2, 1, -2,2)
# union
x + y
# intersection
x * y

e <- x \%\% 2
e
e * 2
e / 2
e + 1
e - 1
}

\keyword{methods}
\keyword{math}
\keyword{spatial}

\name{readwrite}

\docType{methods}

\alias{readStart}
\alias{readStop}
\alias{readValues}
\alias{writeStart}
\alias{writeStop}
\alias{writeValues}
\alias{fileBlocksize}
\alias{blocks}
\alias{readStart,SpatRaster-method}
\alias{readStop,SpatRaster-method}
\alias{readStart,SpatRasterDataset-method}
\alias{readStop,SpatRasterDataset-method}
\alias{readValues,SpatRaster-method}
\alias{readValues,SpatRasterDataset-method}
\alias{writeStart,SpatRaster,character-method}
\alias{writeStop,SpatRaster-method}
\alias{writeValues,SpatRaster,vector-method}
\alias{blocks,SpatRaster-method}

\title{Read from, or write to, file}

\description{
Methods to read from or write chunks of values to or from a file. These are low level methods for programmers. Use writeRaster if you want to save an entire SpatRaster to file in one step. It is much easier to use. 

To write chunks, begin by opening a file with \code{writeStart}, then write values to it in chunks using the list that is returned by \code{writeStart}. When writing is done, close the file with \code{writeStop}. 

\code{blocks} only returns chunk size information. This can be useful when reading, but not writing, raster data. 
}

\usage{
\S4method{readStart}{SpatRaster}(x)

\S4method{readStop}{SpatRaster}(x)

\S4method{readValues}{SpatRaster}(x, row=1, nrows=nrow(x), col=1, ncols=ncol(x), mat=FALSE, dataframe=FALSE, ...)

\S4method{writeStart}{SpatRaster,character}(x, filename="", overwrite=FALSE, n=4, sources="", ...)

\S4method{writeStop}{SpatRaster}(x)

\S4method{writeValues}{SpatRaster,vector}(x, v, start, nrows)

\S4method{blocks}{SpatRaster}(x, n=4)

fileBlocksize(x)
}

\arguments{
  \item{x}{SpatRaster}
  \item{filename}{character. Output filename}

  \item{v}{vector with cell values to be written}
  \item{start}{integer. Row number (counting starts at 1) from where to start writing \code{v}}

 \item{row}{positive integer. Row number to start from, should be between 1 and nrow(x)}
 \item{nrows}{positive integer. How many rows?}
 \item{col}{positive integer. Column number to start from, should be between 1 and ncol(x)}
 \item{ncols}{positive integer. How many columns? Default is the number of columns left after the start column}

 \item{mat}{logical. If \code{TRUE}, values are returned as a numeric matrix instead of as a vector, except when \code{dataframe=TRUE}. If any of the layers of \code{x} is a factor, the level index is returned, not the label. Use \code{dataframe=TRUE} to get the labels}
 \item{dataframe}{logical. If \code{TRUE}, values are returned as a \code{data.frame} instead of as a vector (also if matrix is \code{TRUE})}
  
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{n}{positive integer indicating how many copies the data may be in memory at any point in time. This is used to determine how many blocks (large) datasets need to be read}
  \item{sources}{character. Filenames that may not be overwritten because they are used as input to the function. Can be obtained with \code{sources(x)}}

  \item{...}{
	For \code{writeStart}: additional arguments for writing files as in \code{\link{writeRaster}}

    For \code{readValues}: additional arguments for \code{\link{data.frame}} (and thus only relevant when \code{dataframe=TRUE})
  }
}

\value{
\code{readValues} returns a vector, matrix, or data.frame 

\code{writeStart} returns a list that can be used for processing the file in chunks.

The other methods invisibly return a logical value indicating whether they were successful or not. Their purpose is the side-effect of opening or closing files. 
}

\keyword{ spatial }
\keyword{ methods }

\name{rast}

\docType{methods}

\alias{rast}
\alias{rast,missing-method}
\alias{rast,character-method}
\alias{rast,SpatRaster-method}
\alias{rast,SpatRasterDataset-method}
\alias{rast,data.frame-method}
\alias{rast,matrix-method}
\alias{rast,array-method}
\alias{rast,list-method}
\alias{rast,SpatExtent-method}
\alias{rast,SpatVector-method}
\alias{rast,ANY-method}
\alias{rast,PackedSpatRaster-method}
\alias{rast,stars-method}
\alias{rast,stars_proxy-method}

\title{Create a SpatRaster}

\description{
Methods to create a SpatRaster. These objects can be created from scratch, from a filename, or from another object.

A SpatRaster represents a spatially referenced surface divided into three dimensional cells (rows, columns, and layers). 

When a SpatRaster is created from one or more files, it does not load the cell (pixel) values into memory (RAM). It only reads the parameters that describe the geometry of the SpatRaster, such as the number of rows and columns and the coordinate reference system. The actual values will be read when needed.

Note that there are operating system level limitations to the number of files that can be opened simultaneously. Using a SpatRaster of very many files (e.g. 10,000) may cause R to crash when you use it in a computation. In situations like that you may need to split up the task or combine data into fewer (multi-layer) files. Also note that the GTiff format used for temporary files cannot store more than 65,535 layers in a single file.
}

\usage{
\S4method{rast}{character}(x, subds=0, lyrs=NULL, drivers=NULL, opts=NULL, win=NULL, 
		snap="near", vsi=FALSE, raw=FALSE, noflip=FALSE, 
		guessCRS=TRUE, domains="", md=NULL, dims=NULL)

\S4method{rast}{missing}(x, nrows=180, ncols=360, nlyrs=1, xmin=-180, xmax=180, ymin=-90,
		ymax=90, crs, extent, resolution, vals, names, time, units)

\S4method{rast}{SpatRaster}(x, nlyrs=nlyr(x), names, vals, keeptime=TRUE, 
		keepunits=FALSE, props=FALSE, tags=FALSE) 

\S4method{rast}{matrix}(x, type="", crs="", digits=6, extent=NULL)

\S4method{rast}{data.frame}(x, type="xyz", crs="", digits=6, extent=NULL)

\S4method{rast}{array}(x, crs="", extent=NULL)

\S4method{rast}{list}(x, warn=TRUE)

\S4method{rast}{SpatRasterDataset}(x)

\S4method{rast}{SpatVector}(x, type="", ...)
									  
\S4method{rast}{SpatExtent}(x, ...)
}

\arguments{
\item{x}{filename (character), missing, SpatRaster, SpatRasterDataset, SpatExtent, SpatVector, matrix, array, list of SpatRasters. For other types it will be attempted to create a SpatRaster via \code{as(x, "SpatRaster")}}
\item{subds}{positive integer or character to select a sub-dataset. If zero or "", all sub-datasets are returned (if possible)}
\item{lyrs}{positive integer or character to select a subset of layers (a.k.a. "bands"). If \code{x} has multiple filenames, the same layer numbers are selected from each of the files, unless numbers larger than the number of layers of the first data source are included}
\item{drivers}{character. GDAL drivers to consider}
\item{opts}{character. GDAL dataset open options}
\item{win}{SpatExtent to set a \code{\link{window}} (area of interest)}
\item{snap}{character. One of "near", "in", or "out", to indicate how the extent of \code{\link{window}} should be "snapped" to \code{x}}
\item{vsi}{logical. If \code{TRUE}, "/vsicurl/" is prepended to filenames that start with "http". There are many \href{https://gdal.org/en/stable/user/virtual_file_systems.html}{VSI configuration options} that can be set with \code{\link{setGDALconfig}}}
\item{raw}{logical. If \code{TRUE}, scale and offset values are ignored. See \code{\link{scoff}} to get these parameters}
\item{noflip}{logical. If \code{TRUE}, a raster (e.g. JPEG image) that is not georeferenced and that GDAL assigns a flipped extent to (\code{ymax < ymin}), is not considered flipped. This avoids the need to \code{\link{flip}} the raster vertically}
\item{guessCRS}{logical. If \code{TRUE} and the file does not specify a CRS but has an extent that is within longitude/latitude bounds, the longitude/latitude crs is assigned to the SpatRaster}
\item{domains}{character. Metadata domains to read (see \code{\link{metags}} to retrieve their values if there are any). \code{""} is the default domain}
\item{md}{logical. If \code{TRUE}, the multi-dimensional GDAL API is used for reading the file. This API can only be used for a few file formats (netCDF/HDF5) and can sometimes provide notably faster reading of data with many (time) steps in the third or higher dimension. If no subdataset is selected with \code{subds}, all usable arrays are combined into one \code{SpatRaster} (like \code{md=FALSE}); a warning reports how many variables and layers were combined when there is more than one variable.}
\item{dims}{numeric. Specify the order of the dimensions to read atypical multidimensional files. See \code{\link{ar_info}}. Not implemented yet}
\item{nrows}{positive integer. Number of rows}
\item{ncols}{positive integer. Number of columns}
\item{nlyrs}{positive integer. Number of layers}
\item{xmin}{minimum x coordinate (left border)}
\item{xmax}{maximum x coordinate (right border)}
\item{ymin}{minimum y coordinate (bottom border)}
\item{ymax}{maximum y coordinate (top border)}
\item{crs}{character. Description of the Coordinate Reference System (map projection) in \code{PROJ.4}, \code{WKT} or \code{authority:code} notation. See \code{\link{crs}}. If this argument is missing, and the x coordinates are within -360 .. 360 and the y coordinates are within -90 .. 90, longitude/latitude is assigned}
\item{keeptime}{logical. If \code{FALSE} the time stamps are discarded}
\item{keepunits}{logical. If \code{FALSE} the layer units are discarded}
\item{props}{logical. If \code{TRUE} the properties (categories and color-table) are kept}
\item{tags}{logical. If \code{TRUE} the user specified metadata tags are kept (see \code{\link{metags}}).}
\item{extent}{object of class SpatExtent. If present, the arguments xmin, xmax, ymin and ymax are ignored}
\item{resolution}{numeric vector of length 1 or 2 to set the spatial resolution (see \code{\link{res}}). If this argument is used, arguments \code{ncols} and \code{nrows} are ignored }
\item{vals}{numeric. An optional vector with cell values (if fewer values are provided, these are recycled to reach the number of cells)}
\item{names}{character. An optional vector with layer names (must match the number of layers)}
\item{time}{time or date stamps for each layer}
\item{units}{character. units for each layer}
\item{type}{character. If the value is \code{"xyz"}, \code{x} must be a SpatVector with point geometry, or a matrix or data.frame with at least two columns, the first with \code{x} (or longitude) and the second with \code{y} (or latitude) coordinates that represent the centers of raster cells. The additional columns are the values associated with the raster cells. If the value is \code{"xylz"}, \code{x} must have four columns with the third representing the layer and the fourth the cell values. If the value is \code{""}, the resulting SpatRaster will have the same number of rows and columns as \code{x}. 
}
\item{digits}{integer to set the precision for detecting whether points are on a regular grid (a low number of digits is a low precision). Only used when \code{type="xyz"}}
\item{warn}{logical. If \code{TRUE}, a warning about empty rasters may be emitted}
\item{...}{additional arguments passed on to the \code{rast,missing-method}}  
}


\value{
SpatRaster
}

\details{
Files are read with the GDAL library. GDAL guesses the file format from the name, and/or tries reading it with different "drivers" (see \code{\link{gdal}}) until it succeeds. In very few cases this may cause a file to be opened with the wrong driver, and some information may be lost. For example, when a netCDF file is opened with the HDF5 driver. You can avoid that by using argument \code{rast("filename.ncdf", drivers="NETCDF")}

These classes hold a C++ pointer to the data "reference class" and that creates some limitations. They cannot be recovered from a saved R session either or directly passed to nodes on a computer cluster. Generally, you should use \code{\link{writeRaster}} to save SpatRaster objects to disk (and pass a filename or cell values to cluster nodes). Also see \code{\link{wrap}}. 
}

\seealso{\code{\link{sds}} to create a SpatRasterDataset (SpatRasters with the same geometry representing different variables or higher dimension), \code{\link{sprc}} to create a SpatRasterCollection (to combine SpatRasters with different geometries), and \code{\link{vect}} for vector (points, lines, polygons) data}

\examples{
# Create a SpatRaster from scratch
x <- rast(nrows=108, ncols=21, xmin=0, xmax=10)

# Create a SpatRaster from a file
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)

# A file with multiple layers. This one is special as the layers are RGB color channels 
s <- rast(system.file("ex/logo.tif", package="terra"))

# remove the color channels
#plot(s)
#RGB(s) <- NULL
#plot(s)

# Create a skeleton with no associated cell values
rast(s)

# from a matrix 
m <- matrix(1:25, nrow=5, ncol=5)
rm <- rast(m)

# from a "xyz" data.frame
d <- as.data.frame(rm, xy=TRUE)
head(d)
rast(d, type="xyz")

}

\keyword{methods}
\keyword{spatial}

\name{replace_dollar}

\alias{$<-}
\alias{$<-,SpatExtent-method}
\alias{$<-,SpatVector-method}
\alias{$<-,SpatRaster-method}


\title{Replace with $<-}

\description{
Replace a layer of a SpatRaster, or an attribute variable of a SpatVector
}

\usage{
\S4method{$}{SpatRaster}(x, name) <- value

\S4method{$}{SpatVector}(x, name)<-value

\S4method{$}{SpatExtent}(x, name) <- value
}


\arguments{
  \item{x}{SpatRaster, SpatVector or SpatExtent}
  \item{name}{character. If \code{x} is a SpatRaster: layer name. If \code{x} is a SpatVector: variable name. If \code{x} is a SpatExtent: "xmin", "xmax". "ymin" or "ymax"}
  \item{value}{if \code{x} is a SpatRaster, a SpatRaster for which this \code{TRUE}: \code{nlyr(value) == length(i)}; if \code{x} is a SpatVector, a vector of new values; if \code{x} is a SpatExtent a single number}
}


\value{
Same as \code{x}
}


\seealso{
\code{ \link{[[<-}, \link{[<-}, \link{$}}
}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
v$ID_1 <- LETTERS[1:12]
v$new <- sample(12)
values(v)
}

\keyword{ spatial }

\name{catalyze}

\docType{methods}

\alias{as.numeric}
\alias{as.numeric,SpatRaster-method}
\alias{catalyze}
\alias{catalyze,SpatRaster-method}
  
  
\title{Factors to numeric}

\description{

Change a categorical layer into one or more numerical layers. With \code{as.numeric} you can transfer the active category values to cell values in a non-categorical SpatRaster. \code{catalyze} creates new layers for each category.
}

\usage{
\S4method{as.numeric}{SpatRaster}(x, index=NULL, filename="", ...)

\S4method{catalyze}{SpatRaster}(x, filename="", ...)
}


\arguments{
  \item{x}{SpatRaster}
  \item{index}{positive integer or category indicating the category to use. If \code{NULL} the active category is used}
  \item{filename}{character. Output filename}  
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}  
}  


\value{
SpatRaster
}

\author{Andrew Gene Brown, Robert J. Hijmans}

\seealso{\code{\link{activeCat}}, \code{\link{cats}}}


\examples{
set.seed(0)
r <- rast(nrows=10, ncols=10)
values(r) <- sample(3, ncell(r), replace=TRUE) + 10
d <- data.frame(id=11:13, cover=c("forest", "water", "urban"), letters=letters[1:3], value=10:12)
levels(r) <- d
catalyze(r)

activeCat(r) <- 3
as.numeric(r)
}

\keyword{methods}
\keyword{spatial}

\name{as.polygons}

\docType{methods}

\alias{as.polygons}

\alias{as.polygons,SpatRaster-method}
\alias{as.polygons,SpatVector-method}
\alias{as.polygons,SpatExtent-method}

\title{Conversion to a SpatVector of polygons}

\description{
Conversion of a SpatRaster, SpatVector or SpatExtent to a SpatVector of polygons. 
}

\usage{
\S4method{as.polygons}{SpatRaster}(x, round=TRUE, aggregate=TRUE, values=TRUE,
		na.rm=TRUE, na.all=FALSE, extent=FALSE, digits=0, ...)

\S4method{as.polygons}{SpatVector}(x, extent=FALSE)

\S4method{as.polygons}{SpatExtent}(x, crs="")
}


\arguments{
\item{x}{SpatRaster, SpatVector or SpatExtent}
\item{round}{logical; If \code{TRUE} and \code{aggregate=TRUE}, values are rounded before aggregation. If this value is \code{FALSE} the SpatVector returned can have very many polygons and can be very large}
\item{aggregate}{logical; combine cells with the same values? If \code{TRUE} only the first layer in \code{x} is processed}
\item{values}{logical; include cell values as attributes?}
\item{extent}{logical. if \code{TRUE}, a polygon for the extent of the SpatRaster or SpatVector is returned. If \code{x} is a SpatRaster, the polygon has vertices for each row and column, not just the four corners of the raster. This can be useful for more precise projection. If that is not required, it is more efficient to get the extent represented by only the four corners with \code{as.polygons(ext(x), crs=crs(x))}}
\item{na.rm}{logical. If \code{TRUE} cells that are \code{NA} are ignored}
\item{na.all}{logical. If \code{TRUE} cells are only ignored if \code{na.rm=TRUE} and their value is \code{NA} for \bold{all} layers instead of for \code{any} layer}
\item{digits}{integer. The number of digits for rounding (if \code{round=TRUE})}
\item{crs}{character. The coordinate reference system (see \code{\link{crs}})}
\item{...}{additional arguments. For backward compatibility. Will be removed in the future}
}

\value{
SpatVector
}

\seealso{
\code{\link{as.lines}}, \code{\link{as.points}}
}

\examples{
r <- rast(ncols=2, nrows=2)
values(r) <- 1:ncell(r)

p <- as.polygons(r)
p
}

\keyword{spatial}

\name{replace_layers}

\docType{methods}

\alias{[[<-}

\alias{[[<-,SpatRaster,character-method}
\alias{[[<-,SpatRaster,numeric-method}
\alias{[[<-,SpatVector,character-method}
\alias{[[<-,SpatVector,numeric-method}


\title{Replace layers or variables}

\description{
Replace the layers of SpatRaster with (layers from) another SpatRaster or replace variables of a SpatVector. You can also create new layers/variables with these methods.
}

\value{SpatRaster}

\usage{
\S4method{[[}{SpatRaster,numeric}(x, i) <- value

\S4method{[[}{SpatRaster,character}(x, i) <- value

\S4method{[[}{SpatVector,numeric}(x, i) <- value

\S4method{[[}{SpatVector,character}(x, i) <- value
}

\arguments{
  \item{x}{SpatRaster or SpatVector}

  \item{i}{if \code{x} is a SpatRaster: layer number(s) of name(s). If \code{x} is a SpatVector: variable  number(s) or name(s) (column of the attributes)}
  
  \item{value}{if \code{x} is a SpatRaster: SpatRaster for which this \code{TRUE}: \code{nlyr(value) == length(i)}. if \code{x} is a SpatVector: vector or data.frame}
}


\seealso{\code{\link{$<-}, \link{[<-}}}

\examples{
# raster
s <- rast(system.file("ex/logo.tif", package="terra"))   
s[["red"]] <- mean(s)
s[[2]] <- sqrt(s[[1]])

# vector
v <- vect(system.file("ex/lux.shp", package="terra"))
v[["ID_1"]] <- 12:1
}

\keyword{methods}
\keyword{spatial}

\name{divide}

\alias{divide}
\alias{divide,SpatRaster-method}
\alias{divide,SpatVector-method}

\title{
Subdivide a raster or polygons
}

\description{
Divide a \code{SpatRaster} into \code{n} parts with approximately the same sum of weights (cell values). 

Divides a \code{SpatVector} of polygons into \code{n} compact and approximately equal area parts. The results are not deterministic so you should use set.seed to be able to reproduce your results. If you get a warning about non-convergence, you can increase the number of iterations used with additional argument iter.max
}

\usage{
\S4method{divide}{SpatRaster}(x, n=2, start="ns", as.raster=FALSE, na.rm=TRUE)

\S4method{divide}{SpatVector}(x, n=5, w=NULL, alpha=1, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatVector of polygons}
  \item{n}{numeric. Can be a single positive integer to indicate the number of parts (SpatVector) or the number of splits (SpatRaster). 
  
  If \code{x} is a SpatRaster, it can also be a vector with values -2, -1, 1, or 2. Where 1 means one split and 2 means two splits, and the negative sign indicates an East-West (vertical) split as opposed to a North-South split. 
  
  If \code{x} is a SpatVector it can be a list with at least one of these elements: \code{horizontal} and \code{vertical} that specify the proportions of the area that splits should cover. This can either be a single fraction such as 1/3, or a sequence of fractions in ascending order such as \code{c(1/4, 1/2, 1)}}
  
  \item{start}{character. To indicate the initial direction of splitting the raster. "ns" for North-South (horizontal) or "ew" for East-West (vertical)}
  \item{as.raster}{logical. If \code{FALSE} a SpatVector is returned. If \code{FALSE}, a SpatRaster is returned. If \code{NA} a list with a SpatRaster and a SpatVector is returned}
  \item{na.rm}{logical. If \code{TRUE} cells in \code{x} that are \code{NA} are not included in the output}  

  \item{w}{SpatRaster with, for example, environmental data}
  \item{alpha}{numeric. One or two numbers that act as weights for the x and y coordinates}
  \item{...}{additional arguments such as \code{iter.max} passed on to \code{\link{kmeans}}}
}

\seealso{\code{\link{thresh}}; \code{\link{makeTiles}}}

\value{SpatVector or SpatRaster, or a list with both}


\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
x <- divide(r, 3)
# plot(r); lines(x)


f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
d <- divide(v, 3)
dv <- divide(v, list(h=.5))
}

\keyword{spatial}

\name{identical}

\docType{methods}

\alias{identical}
\alias{identical,SpatRaster,SpatRaster-method}
\alias{identical,SpatVector,SpatVector-method}
\alias{identical,SpatExtent,SpatExtent-method}

\title{Compare two SpatRaster, SpatVector or SpatExtent objects for equality}

\description{
When, comparing two SpatRasters for equality, first the attributes of the objects are compared. If these are the same, a the raster cells are compared as well. This can be time consuming, and you may prefer to use a sample instead with \code{\link{all.equal}}
}

\usage{
\S4method{identical}{SpatRaster,SpatRaster}(x, y)

\S4method{identical}{SpatVector,SpatVector}(x, y)

\S4method{identical}{SpatExtent,SpatExtent}(x, y)
}

\arguments{
  \item{x}{SpatRaster, SpatVector, or SpatExtent}
  \item{y}{object of the same class as \code{x}}
}

\seealso{\code{\link{all.equal}}, \code{\link{compareGeom}}}

\value{
single logical value
}

\examples{
x <- sqrt(1:100)
mat <- matrix(x, 10, 10)
r1 <- rast(nrows=10, ncols=10, xmin=0, vals = x)
r2 <- rast(nrows=10, ncols=10, xmin=0, vals = t(mat))

identical(r1, r2)
identical(r1, r1*1)
identical(rast(r1), rast(r2))
}

\keyword{spatial}

\name{contour}

\docType{methods}

\alias{contour}
\alias{contour,SpatRaster-method}
\alias{as.contour}
\alias{as.contour,SpatRaster-method}

\title{Contour plot}

\description{
Contour lines (isolines) of a SpatRaster. Use \code{add=TRUE} to add the lines to the current plot.  See \code{graphics::\link[graphics]{contour}} for details. 

if \code{filled=TRUE}, a new filled contour plot is made. See \code{graphics::\link[graphics]{filled.contour}} for details.

\code{as.contour} returns the contour lines as a SpatVector.
}

\usage{
\S4method{contour}{SpatRaster}(x, maxcells=100000, filled=FALSE, ...)

\S4method{as.contour}{SpatRaster}(x, maxcells=100000, ...)
}

\arguments{
  \item{x}{SpatRaster. Only the first layer is used}
  \item{maxcells}{maximum number of pixels used to create the contours}
  \item{filled}{logical. If \code{TRUE}, a \code{\link[graphics]{filled.contour}} plot is made}
  \item{...}{any argument that can be passed to \code{\link[graphics]{contour}} or  \code{\link[graphics]{filled.contour}} (graphics package)}  
}


\seealso{ 
\code{\link[terra]{plot}}
}

\examples{
r <- rast(system.file("ex/elev.tif", package="terra"))
plot(r)
contour(r, add=TRUE)

v <- as.contour(r)
plot(r)
lines(v)

contour(r, filled=TRUE, nlevels=5)

## if you want a SpatVector with contour lines
template <- disagg(rast(r), 10)
rr <- resample(r, template)
rr <- floor(rr/100) * 100
v <- as.polygons(rr)
plot(v, 1, col=terrain.colors(7))

## to combine filled contours with contour lines (or other spatial data)

br <- seq(100, 600, 100)
plot(r, breaks=br)
lines(as.contour(r, levels=br))

## or 
x <- as.polygons(classify(r,  br))
plot(x, "elevation")

}

\keyword{methods}
\keyword{spatial}

\name{impose}

\docType{methods}

\alias{impose}
\alias{impose,SpatRasterCollection-method}

\title{ 
Impose the geometry of a SpatRaster to those in a SpatRasterCollection.
}

\description{
Warp the members of a SpatRasterCollection to match the geometry of a SpatRaster.
}

\usage{
\S4method{impose}{SpatRasterCollection}(x, y, filename="", ...)
}

\arguments{
  \item{x}{SpatRasterCollection}
  \item{y}{SpatRaster}
  \item{filename}{character. Output filename}
  \item{...}{list with named options for writing files as in \code{\link{writeRaster}}}
} 

\value{
SpatRaster
}

\seealso{
\code{\link{resample}}
}


\keyword{methods}
\keyword{spatial}

\name{roll}

\alias{roll}
\alias{roll,SpatRaster-method}
\alias{roll,numeric-method}

\title{Rolling (moving) functions}

\description{
Compute "rolling" or "moving" values, such as the "rolling average" for each cell in a SpatRaster.

See \code{\link{focal}} for spatially moving averages and similar computations. And see \code{\link{cumsum}} and other cum* functions to compute cumulate values.
}

\usage{
\S4method{roll}{SpatRaster}(x, n, fun=mean, type="around", circular=FALSE,
			na.rm=FALSE, filename="", ..., wopt=list()) 

\S4method{roll}{numeric}(x, n, fun=mean, type="around", circular=FALSE, na.rm=FALSE, ...) 
}
 

\arguments{
  \item{x}{SpatRaster or numeric}
  \item{n}{integer > 1. The size of the "window", that is, the number of sequential cells to use in \code{fun}}
  \item{fun}{a function like mean, min, max, sum}
  \item{type}{character. One of "around", "to", or "from". The choice indicates which values should be used in the computation. The focal cell is always used. If type is "around", \code{(n-1)/2} before and after the focal cell are also included. If type = "from", \code{n-1} cells are after the focal cell are included. If type = "to", \code{n-1} cells before the focal cell are included. For example, when using n=3 for element 5 of a vector; "around" used elements 4,5,6; "to" used elements 3,4,5, and "from" uses elements 5,6,7}
  \item{circular}{logical. If \code{TRUE}, the data are considered to have a circular nature (e.g. days or months of the year), such that there are no missing values before first or after the last value.}
  \item{na.rm}{logical. If \code{TRUE}, \code{NA} values should be ignored (by \code{fun})}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for \code{fun}}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}


\value{
Same as \code{x}
}

\seealso{\code{\link{cumsum}}, \code{\link{focal}}}

\examples{
## numeric
roll(1:12, 3, mean)
roll(1:12, 3, mean, "to")
roll(1:12, 3, mean, circular=TRUE)

## SpatRaster
r <- rast(ncol=2, nrow=2, nlyr=10, vals=1)
r[1,2] <- 2
r[2,2] <- 4

values(roll(r, n=3, "sum", "from", na.rm=FALSE))
values(roll(r, n=3, "sum", "from", na.rm=TRUE))
values(roll(r, n=3, "sum", "from", circular=TRUE))

values(roll(r, n=3, "sum", "to", na.rm=TRUE))

values(roll(r, n=3, "sum", "around", circular=TRUE))
}

\keyword{spatial}

\name{clamp_ts}

\alias{clamp_ts}
\alias{clamp_ts,SpatRaster-method}
\alias{clamp_ts,numeric-method}

\title{clamp time series data}

\description{
clamp time-series data that are S shaped. The value in layers before the minimum value in a cell can be set to that minimum value, and the value in layers after the maximum value for a cell can be set to that maximum value.   
}

\usage{
\S4method{clamp_ts}{SpatRaster}(x, min=FALSE, max=TRUE, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{min}{logical. If \code{TRUE} the time-series is clamped to the minimum value}
  \item{max}{logical. If \code{TRUE} the time-series is clamped to the maximum value}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{
\code{\link{clamp}}, \code{\link{cummin}}, \code{\link{cummax}}
}

\examples{
sigm <- function(x) { .8 / (1 + exp(-(x-10))) + runif(length(x))/4 }
r <- rast(ncols=10, nrows=10, nlyr=50)
s <- seq(5.2, 15,.2)
set.seed(1)
values(r) <- t(replicate(100, sigm(s)))

x <- clamp_ts(r, TRUE, TRUE) 

plot(unlist(r[4]))
lines(unlist(x[4]))

}

\keyword{spatial}

\name{thresh}

\docType{methods}

\alias{thresh}
\alias{thresh,SpatRaster-method}


\title{Thresholding}

\description{
Compute a threshold to divide the values of a SpatRaster into two groups, and use that threshold to classify the raster. 
}

\usage{
\S4method{thresh}{SpatRaster}(x, method="otsu", maxcell=1000000, combine=FALSE, 
			as.raster=TRUE, filename="", ...)
}


\arguments{
\item{x}{SpatRaster}
\item{method}{character. One of "mean", "median" or "otsu" for Otsu's method}
\item{maxcell}{positive integer. Maximum number of cells to use to compute the threshold}
\item{combine}{logical. If \code{TRUE} the layers of \code{x} are combined to compute a single threshold}
\item{as.raster}{logical. If \code{TRUE} a classified SpatRaster is returned. Otherwise the threshold(s) are returned}
\item{filename}{character. Output filename}
\item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}  
}

\value{
numeric or SpatRaster
}

\references{
Otsu, N. (1979). A Threshold Selection Method from Gray-Level Histograms.
\emph{IEEE Transactions on Systems, Man, and Cybernetics}, \bold{9(1)}, 62-66.
\doi{10.1109/TSMC.1979.4310076}
}

\seealso{\code{\link{divide}}}

\examples{

s <- rast(system.file("ex/logo.tif", package="terra"))
thresh(s, "mean", as.raster=FALSE)
thresh(s, "mean", combine=TRUE, as.raster=FALSE)


plot(thresh(s, "otsu"))

}

\keyword{spatial}

\name{terra-package}

\alias{terra-package}

\alias{terra}

\docType{package}

\title{Description of the methods in the terra package}

\description{

\code{terra} provides methods to manipulate geographic (spatial) data in "raster" and "vector" form. Raster data divide space into rectangular grid cells and they are commonly used to represent spatially continuous phenomena, such as elevation or the weather. Satellite images also have this data structure, and in that context grid cells are often referred to as pixels. In contrast, "vector" spatial data (points, lines, polygons) are typically used to represent discrete spatial entities, such as a road, country, or bus stop. 

The package implements two main classes (data types): \code{SpatRaster} and \code{SpatVector}. \code{SpatRaster} supports handling large raster files that cannot be loaded into memory; local, focal, zonal, and global raster operations; polygon, line and point to raster conversion; integration with modeling methods to make spatial predictions; and more. \code{SpatVector} supports all types of geometric operations such as intersections.

Additional classes include \code{SpatExtent}, which is used to define a spatial extent (bounding box); \code{SpatRasterDataset}, which represents a collection of sub-datasets for the same area. Each sub-dataset is a SpatRaster with possibly many layers, and may, for example, represent different weather variables; and \code{SpatRasterCollection} and \code{SpatVectorCollection} that are equivalent to lists of \code{SpatRaster} or \code{SpatVector} objects. There is also a \code{SpatGraticule} class to assist in adding longitude/latitude lines and labels to a map with another coordinate reference system; and a \code{SpatNetwork} class for spatial graphs of nodes and edges (for example road or stream networks).

These classes hold a C++ pointer to the data "reference class". You should not write scripts that directly access this pointer, as its user-interface is not stable. These pointers make the code run fast, but they cannot be "serialized". That is they cannot be recovered from a saved R session, or passed to nodes on a computer cluster. Generally, you should use \code{\link{writeRaster}} to save \code{SpatRaster} objects to disk (and pass a filename or cell values to cluster nodes). Also see \code{\link{wrap}} and \code{\link{saveRDS}}. See these \href{https://rspatial.org/pkg/10-parallel.html}{guidelines} for parallelization with terra objects.

Below is a list of some of the most important methods grouped by theme. 

---------------------------------------------------------------------------------------------------------------------
}


\section{\bold{SpatRaster}}{

---------------------------------------------------------------------------------------------------------------------}

\section{I. Creating, combining and sub-setting}{

  \tabular{ll}{
    \code{\link{rast}}\tab Create a SpatRaster from scratch, file, or another object\cr
    \code{\link{c}} \tab Combine SpatRasters (multiple layers)\cr
    \code{\link{add<-}} \tab Add a SpatRaster to another one\cr
    \code{\link{subset}} \tab Select layers of a SpatRaster\cr
    \code{\link{[[}} \tab Select layers of a SpatRaster \cr
    \code{\link{$}} \tab Select a layer of a SpatRaster \cr
    \code{\link{[[<-}} \tab Replace or add a SpatRaster layer \cr
    \code{\link{$<-}} \tab Replace or add a SpatRaster layer \cr
    \code{\link{selectRange}} \tab Select cell values from different layers using an index layer\cr
    \code{\link{rep}} \tab Repeat layers or a SpatRaster \cr
    \code{\link{split}} \tab Make a list of single layer SpatRasters\cr
    \code{\link{as.character}} \tab Get a character representation of a SpatRaster geometry\cr	
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}

\section{II. Changing the spatial extent or resolution}{
Also see the methods in section VIII

  \tabular{ll}{
    \code{\link{merge}} \tab Combine SpatRasters with different extents (but same origin and resolution) \cr
    \code{\link{mosaic}} \tab Combine SpatRasters with different extents using a function for overlapping cells \cr
    \code{\link{crop}} \tab Select a geographic subset of a SpatRaster \cr
	\code{\link{window}} / \code{\link{window<-}} \tab Get or set a processing window for virtual cropping \cr
    \code{\link{extend}} \tab Add rows and/or columns to a SpatRaster \cr
    \code{\link{trim}} \tab Trim a SpatRaster by removing exterior rows and/or columns that only have NAs\cr
    \code{\link{aggregate}} \tab Combine cells of a SpatRaster to create larger cells \cr
    \code{\link{disagg}} \tab Subdivide cells \cr
    \code{\link{resample}} \tab Resample (warp) values to a SpatRaster with a different origin and/or resolution \cr 
	\code{\link{project}} \tab Project (warp) values to a SpatRaster with a different coordinate reference system \cr
    \code{\link{shift}} \tab Adjust the location of SpatRaster \cr
    \code{\link{flip}} \tab  Flip values horizontally or vertically \cr
    \code{\link{rotate}} \tab Rotate values around the date-line (for lon/lat data) \cr
    \code{\link{t}} \tab Transpose a SpatRaster\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}

  
\section{III. Local (cell based) methods}{

\subsection{Apply-like methods}{

  \tabular{ll}{
    \code{\link{app}} \tab Apply a function to all cells, across layers, typically to summarize (as in \code{base::apply}) \cr
    \code{\link{tapp}} \tab Apply a function to groups of layers (as in \code{base::tapply} and \code{stats::aggregate})\cr
    \code{\link{lapp}} \tab Apply a function to a SpatRaster, using its layers as arguments\cr
    \code{\link{sapp}} \tab Apply a function to each layer\cr
    \code{\link{rapp}} \tab Apply a function to a spatially variable range of layers\cr
    \code{\link{xapp}} \tab Apply a function across two SpatRasters layer-wise \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
	}
}

\subsection{Arithmetic, logical, and standard math methods}{

  \tabular{ll}{
    \code{\link{Arith-methods}} \tab Standard arithmetic methods (\code{+, -, *, ^, \%\%, \%/\%, /}) \cr
    \code{\link{Compare-methods}} \tab Comparison methods for SpatRaster (\code{==, !=, >, <, <=, >=, is.na, is.finite}) \cr 	
    \code{\link{not.na}} \tab a one-step equivalent to \code{!is.na} \cr
    \code{\link{Summary-methods}} \tab \code{mean, max, min, median, sum, range, prod,} \cr
    \tab \code{any, all, stdev, which.min, which.max, anyNA, noNA, allNA}\cr
    \code{\link{modal}} \tab Modal value across layers \cr
    \code{\link{Logic-methods}} \tab Boolean methods (\code{!, &, |}) \cr
	\code{\link{Math-methods}} \tab \code{abs, sign, sqrt, ceiling, floor, trunc, cummax, cummin, cumprod,} \cr
	\tab \code{cumsum, log, log10, log2, log1p, acos, acosh, asin, asinh, atan, atanh,} \cr	 
	\tab \code{exp, expm1, cos, cosh, sin, sinh, tan, tanh, round, signif}\cr
    \code{\link{scale_linear}} \tab Linear rescaling to a numeric range \cr
    \code{\link{weighted.mean}} \tab Weighted mean of raster layers \cr
    \code{\link{where.min}} / \code{\link{where.max}} \tab Layer index of min/max per cell \cr
	\code{\link{match}} / \code{\link{\%in\%}} \tab Value matching for SpatRaster \cr
    \code{\link{rowSums}} / \code{\link{rowMeans}} \tab row summaries \cr
    \code{\link{colSums}} / \code{\link{colMeans}} \tab column summaries \cr
    \code{\link{as.bool}}\tab create a Boolean (logical) SpatRaster \cr
    \code{\link{as.int}}\tab create an integer (whole numbers) SpatRaster \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
	}
}

\subsection{Other methods}{

  \tabular{ll}{
    \code{\link{approximate}} \tab Compute missing values for cells by interpolation across layers \cr
    \code{\link{roll}} \tab Rolling functions such as the rolling mean \cr
    \code{\link{clamp}} \tab Restrict cell values to a minimum and/or maximum value \cr
    \code{\link{cellSize}} \tab Compute the area of cells \cr
    \code{\link{surfArea}} \tab Surface area per raster cell considering slope\cr		
    \code{\link{classify}} \tab (Re-)classify values \cr
    \code{\link{subst}} \tab Substitute (replace) cell values \cr
    \code{\link{cover}} \tab First layer covers second layer except where the first layer is \code{NA} \cr
    \code{\link{init}} \tab Initialize cells with new values \cr
    \code{\link{mask}} \tab Replace values in a SpatRaster based on values in another SpatRaster\cr
    \code{\link{which.lyr}} \tab which is the first layer that is \code{TRUE}?\cr
    \code{\link{segregate}} \tab Make a 0/1 layer for each unique value \cr
    \code{\link{rangeFill}} \tab Make a 0/1 SpatRaster for a time series \cr
    \code{\link{extractRange}} \tab Extract min--max range across layers \cr
    \code{\link{regress}} \tab Cell-based regression models \cr
    \code{\link{selectHighest}} \tab Keep highest values across layers \cr
    \code{\link{thresh}} \tab Threshold raster layers \cr
    \code{\link{identical}} \tab Test near-identity of SpatRaster objects \cr
    \code{\link{all.equal}} \tab Compare SpatRaster objects with a degree of tolerance \cr
    \code{\link{divide}} \tab Divide rasters in areas of equal cell value sums \cr

  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
  }
}

\section{IV. Zonal and global methods}{
  \tabular{ll}{
    \code{\link{expanse}} \tab Compute the summed area of cells \cr
    \code{\link{crosstab}} \tab Cross-tabulate two SpatRasters\cr
    \code{\link{freq}} \tab Frequency table of SpatRaster cell values \cr
    \code{\link{global}} \tab Summarize SpatRaster cell values with a function \cr
    \code{\link{quantile}} \tab Quantiles \cr
    \code{\link{layerCor}} \tab Correlation between layers \cr
    \code{\link{stretch}} \tab Stretch values \cr
    \code{\link{scale}} \tab Scale values \cr
    \code{\link[terra]{summary}} \tab Summary of the values of a SpatRaster (quartiles and mean) \cr
    \code{\link{unique}} \tab Get the unique values in a SpatRaster \cr
    \code{\link{zonal}} \tab Summarize a SpatRaster by zones in another SpatRaster \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}


\section{V. Situation (spatial context) based methods}{

  \tabular{ll}{
    \code{\link{adjacent}} \tab Identify cells that are adjacent to a set of cells of a SpatRaster \cr
    \code{\link{boundaries}} \tab Detection of boundaries (edges)\cr
    \code{\link{distance}} \tab Shortest distance to a cell that is not \code{NA} or to or from a vector object\cr
    \code{\link{gridDist}} \tab Shortest distance through adjacent grid cells\cr
    \code{\link{costDist}} \tab Shortest distance considering cell-varying friction \cr
    \code{\link{direction}} \tab Direction (azimuth) to or from cells that are not \code{NA}\cr
    \code{\link{focal}} \tab Focal (neighborhood; moving window; convolution) functions \cr
    \code{\link{focal3D}} \tab Three dimensional (row, col, lyr) focal functions \cr
    \code{\link{focalCpp}} \tab Faster focal by using custom C++ functions \cr
    \code{\link{focalReg}} \tab Regression between layers for focal areas \cr
    \code{\link{focalPairs}} \tab Apply a function (e.g. a correlation coefficient) to focal values for pairs of layers \cr
    \code{\link{focalMat}} \tab Make a focal weights matrix \cr
    \code{\link{focalValues}} \tab Extract focal window values \cr
    \code{\link{patches}} \tab Find patches (clumps) \cr
    \code{\link{sieve}} \tab Sieve filter to remove small patches\cr
    \code{\link{autocor}} \tab Compute global or local spatial autocorrelation  \cr
    \code{\link{terrain}} \tab Compute slope, aspect and other terrain characteristics from elevation data \cr
    \code{\link{viewshed}} \tab Compute viewshed (showing areas that are visible from a particular location) \cr
    \code{\link{shade}} \tab Compute hill shade from slope and aspect layers \cr
    \code{\link{watershed}} \tab Watersheds from flow directions \cr
    \code{\link{flowAccumulation}} \tab Flow accumulation from flow directions \cr
    \code{\link{pitfinder}} \tab Find pits in elevation \cr
    \code{\link{NIDP}} \tab Immediate upstream flow counts \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}


\section{VI. Model predictions}{

  \tabular{ll}{
    \code{\link{predict}} \tab Predict a non-spatial (regression or classification) model to a SpatRaster \cr
    \code{\link{interpolate}} \tab Predict a spatial model to a SpatRaster \cr
    \code{\link{interpIDW}} \tab Inverse-distance-weighted interpolation \cr
    \code{\link{interpNear}} \tab Nearest neighbor interpolation \cr
    \code{\link{k_means}} \tab k-means clustering of SpatRaster data \cr
    \code{\link{princomp} and \link{prcomp}} \tab Principal Component Analysis (PCA) with raster data\cr
	
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}


\section{VII. Accessing cell values}{

Apart from the functions listed below, you can also use indexing with \code{[} with cell numbers, and row and/or column numbers \cr

\tabular{ll}{
    \code{\link{values}} \tab cell values (fails with very large rasters)\cr
    \code{\link{values<-}} \tab Set new values to the cells of a SpatRaster \cr
    \code{\link{setValues}} \tab Set new values to the cells of a SpatRaster \cr
    \code{\link{as.matrix}} \tab Get cell values as a matrix \cr
    \code{\link{as.array}} \tab Get cell values as an array \cr
	\code{\link{as.data.frame}} \tab get cell values as a data.frame (including class labels)\cr
    \code{\link{extract}} \tab Extract cell values from a SpatRaster (with cell numbers, coordinates, points, lines, or polygons)\cr
    \code{\link{extractAlong}} \tab Extract cell values along a line such that the values are in the right order\cr
    \code{\link{spatSample}} \tab Take a sample (regular, random, stratified, weighted) sample from a SpatRaster\cr
    \code{\link{minmax}} \tab Get the minimum and maximum value of the cells of a SpatRaster (if known) \cr
    \code{\link{setMinMax}} \tab Compute the minimum and maximum value of a SpatRaster if these are not known \cr

  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}


\section{VIII. Getting and setting dimensions and some other properties }{

Get or set basic parameters of SpatRasters. If there are values associated with a SpatRaster (either in memory or via a link to a file) these are lost when you change the number of columns or rows or the resolution. This is not the case when the extent is changed (as the number of columns and rows will not be affected). Similarly, with \bold{crs} you can set the coordinate reference system, but this does not transform the data (see \link{project} for that).   

  \tabular{ll}{
    \code{\link{ncol}}\tab The number of columns \cr
    \code{\link{nrow}} \tab The number of rows \cr
    \code{\link{ncell}} \tab The number of cells (can not be set directly, only via ncol or nrow) \cr
    \code{\link{res}} \tab The resolution (x and y) \cr
    \code{\link{nlyr}} \tab Get or set the number of layers \cr
    \code{\link{names}} \tab Get or set the layer names \cr
	\code{\link{varnames}} / \code{\link{varnames<-}} \tab Get or set dataset names \cr
    \code{\link{longnames}} / \code{\link{longnames<-}} \tab Get or set dataset names \cr
    \code{\link{xres}} \tab The x resolution (can be set with res) \cr
    \code{\link{yres}} \tab The y resolution (can be set with res)\cr
    \code{\link{xmin}} \tab The minimum x coordinate (or longitude) \cr
    \code{\link{xmax}} \tab The maximum x coordinate (or longitude) \cr
    \code{\link{ymin}} \tab The minimum y coordinate (or latitude) \cr
    \code{\link{ymax}} \tab The maximum y coordinate (or latitude) \cr
	\code{\link{ext}} \tab Get or set the extent (minimum and maximum x and y coordinates; "bounding box") \cr
	\code{\link{origin}} \tab The origin of a SpatRaster\cr
    \code{\link{sources}} \tab Get the filename(s) to which a SpatRaster is linked \cr
    \code{\link{inMemory}} \tab Are the data sources in memory (or on disk)? \cr
    \code{\link{toMemory}} \tab Force data sources to memory (not recommended)? \cr
    \code{\link{compareGeom}} \tab Compare the geometry of SpatRasters \cr
    \code{\link{NAflag}} \tab Set the \code{NA} value (for reading from a file with insufficient metadata) \cr
    \code{\link{units}} / \code{\link{units<-}} \tab Layer measurement units \cr
    \code{\link{is.rotated}} \tab Whether a SpatRaster is rotated \cr
    \code{\link{has.geoloc}} \tab Whether a SpatRaster has GDAL geolocation arrays / GCPs \cr
    \code{\link{geoloc}} \tab Geolocation / GCP metadata for a SpatRaster \cr
    \code{\link{is.flipped}} \tab Whether a SpatRaster is flipped \cr
    \code{\link{datatype}} \tab Storage datatype of layers \cr
    \code{\link{scoff}} / \code{\link{scoff<-}} \tab Scale-offset values \cr	
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}


\section{IX. Computing row, column, cell numbers and coordinates}{

Cell numbers start at 1 in the upper-left corner. They increase within rows, from left to right, and then row by row from top to bottom. Likewise, row numbers start at 1 at the top of the raster, and column numbers start at 1 at the left side of the raster. 

  \tabular{ll}{
    \code{\link{xFromCol}} \tab x-coordinates from column numbers \cr
    \code{\link{yFromRow}} \tab y-coordinates from row numbers \cr
    \code{\link{xFromCell}} \tab x-coordinates from cell numbers \cr
    \code{\link{yFromCell}} \tab y-coordinates from cell numbers \cr
    \code{\link{xyFromCell}} \tab x and y coordinates from cell numbers \cr
    \code{\link{colFromX}} \tab Column numbers from x-coordinates (or longitude) \cr
    \code{\link{rowFromY}} \tab Row numbers from y-coordinates (or latitude) \cr
    \code{\link{rowColFromCell}} \tab Row and column numbers from cell numbers\cr
    \code{\link{cellFromXY}} \tab Cell numbers from x and y coordinates \cr
    \code{\link{cellFromRowCol}} \tab Cell numbers from row and column numbers \cr
    \code{\link{cellFromRowColCombine}} \tab Cell numbers from all combinations of row and column numbers \cr    
	\code{\link{cells}}\tab Cell numbers for a SpatVector or SpatExtent\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}


\section{X. Depth related methods}{

\code{depth} can be used to explicitly get or set a third or fourth dimension of a SpatRaster. 

\tabular{ll}{
    \code{\link{depth}} \tab Get or set depth dimension values\cr
    \code{\link{depthName}} \tab Set or get the depth name \cr
    \code{\link{depthUnit}} \tab Set or get the depth unit \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}

\section{XI. Time related methods}{

\code{time} can be used to explicitly get or set a third or fourth dimension of a SpatRaster. 

\tabular{ll}{
    \code{\link{time}} \tab Get or set time\cr
    \code{\link{fillTime}} \tab can add empty layers in between existing layers to assure that the time step between layers is constant \cr
    \code{\link{mergeTime}} \tab combine multiple rasters, perhaps partly overlapping in time, into a single time series\cr
	\code{\link{clamp_ts}} \tab Clamp time-series values \cr

  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}


\section{XII. Methods for categorical rasters}{

\tabular{ll}{
    \code{\link{is.factor}} \tab Are there categorical layers?\cr
    \code{\link{levels}} \tab Get active categories, or set categories\cr
    \code{\link{activeCat}} \tab Get or set the active category\cr
    \code{\link{cats}} \tab Get categories (active and inactive)\cr
    \code{\link{set.cats}} \tab Set categories in place \cr
    \code{\link{concats}} \tab Combine SpatRasters with different categories\cr
    \code{\link{catalyze}} \tab Create a layer for each category \cr
    \code{\link{as.numeric}} \tab use the active category to create a non-categorical SpatRaster\cr
    \code{\link{as.factor}} \tab Make the layers of a SpatRaster categorical\cr

  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}


\section{XIII. Writing SpatRaster files}{

\subsection{Basic}{
  \tabular{ll}{
    \code{\link{writeRaster}} \tab Write all values of SpatRaster to disk. You can set the filetype, datatype, compression. \cr
    \code{\link{writeCDF}} \tab Write SpatRaster data to a netCDF file\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
 	}
}

\subsection{Advanced}{
  \tabular{ll}{
   \code{\link{readStart}} \tab Open file connections for efficient multi-chunk reading \cr
   \code{\link{readValues}} \tab Read some values from an opened file \cr
   \code{\link{readStop}} \tab Close file connections \cr
   \code{\link{writeStart}} \tab Open a file for writing \cr
   \code{\link{writeValues}} \tab Write some values to an opened file \cr
   \code{\link{writeStop}} \tab Close the file after writing \cr
   \code{\link{blocks}} \tab Get blocksize for reading files (when not writing) \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}
}


\section{XIV. Tiles}{
\tabular{ll}{
    \code{\link{chunk}} \tab Iterate over raster chunks \cr
    \code{\link{makeVRT}} \tab Build a GDAL virtual raster (VRT) from files \cr
    \code{\link{vrt}} \tab Virtual raster from filenames or a collection \cr
    \code{\link{vrt_tiles}} \tab List VRT tile sources \cr
	
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}



\section{XV. Miscellaneous SpatRaster methods}{

\tabular{ll}{
    \code{\link{terraOptions}} \tab Show, set, or get session options, mostly to control memory use and to set write options\cr
    \code{\link{sources}} \tab Show the data sources of a SpatRaster \cr
    \code{\link{tmpFiles}} \tab Show or remove temporary files \cr
    \code{\link{mem_info}} \tab memory needs and availability \cr
    \code{\link{inMemory}} \tab Are the cell values in memory? \cr
    \code{\link{deepcopy}} \tab Deep copy of SpatRaster \cr
    \code{\link{describe}} \tab Summarize raster file sources \cr
    \code{\link{same.crs}} \tab Compare two CRS strings \cr
    \code{\link{ar_info}} \tab Inspect NetCDF-like multi-array files \cr
    \code{\link{gdal}} \tab set GDAL warning level \cr
	\code{set/\link{getGDALconfig}} \tab GDAL session utilities \cr
    \code{\link{meta}} \tab Metadata from a SpatRaster \cr
    \code{\link{metags}} / \code{\link{metags<-}} \tab Arbitrary metadata tags \cr
    \code{\link{tighten}} \tab combine data sources into one \cr
	
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}


\section{XVI. SpatRasterDataset}{

A SpatRasterDataset contains SpatRasters that represent sub-datasets for the same area. They all have the same extent and resolution.

\tabular{ll}{
  \code{\link{sds}} \tab Create a SpatRasterDataset from a file with subdatasets (ncdf or hdf) or from SpatRasters \cr
  \code{[} or \code{$} \tab Extract a SpatRaster \cr
  \code{\link{names}} \tab Get the names of the sub-datasets \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}

\section{XVII. SpatRasterCollections}{
A SpatRasterCollection is a vector of SpatRaster objects. Unlike for a SpatRasterDataset, there the extent and resolution of the SpatRasters do not need to match each other. 

\tabular{ll}{
\code{\link{sprc}} \tab create a SpatRasterCollection from (a list of) SpatRasters\cr
\code{\link{length}} \tab how many SpatRasters does the SpatRasterCollection have?\cr
\code{\link{crop}} \tab crop a SpatRasterCollection\cr
\code{\link{impose}} \tab force the members of SpatRasterCollection to the same geometry\cr
\code{\link{merge}} \tab merge the members of a SpatRasterCollection\cr
\code{\link{mosaic}} \tab mosaic (merge with a function for overlapping areas) the members of a SpatRasterCollection\cr
\code{\link{[}} \tab extract a SpatRaster\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}}



\section{\bold{SpatVector}}{

---------------------------------------------------------------------------------------------------------------------}

\section{XVIII. Create SpatVector objects}{
\tabular{ll}{
  \code{\link{vect}} \tab Create a SpatVector from a file (for example a "shapefile") or from another object\cr
  \code{\link{vector_layers}} \tab list or delete layers in a vector database such as GPKG\cr
  \code{rbind} \tab append SpatVectors of the same geometry type\cr
  \code{\link{unique}} \tab remove duplicates \cr
  \code{\link{na.omit}} \tab remove empty geometries and/or fields that are \code{NA} \cr
  \code{\link{project}} \tab Project a SpatVector to a different coordinate reference system \cr
  \code{\link{writeVector}} \tab Write SpatVector data to disk \cr
  \code{\link{centroids}} \tab Get the centroids of a SpatVector\cr
  \code{\link{voronoi}} \tab Voronoi diagram \cr
  \code{\link{delaunay}} \tab Delaunay triangles\cr
  \code{\link{hull}} \tab Compute a convex, circular, or rectangular hull around the (geometries of) a SpatVector \cr  
  \code{\link{fillHoles}}\tab Remove or extract holes from polygons\cr
  \code{\link{densify}} \tab Add vertices along lines or polygons \cr
  \code{\link{thinNodes}} \tab Remove vertices along lines or polygons \cr
  \code{\link{split}} \tab Split a SpatVector based on values of an attribute\cr

  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr  
}}


\section{XIX. Properties of SpatVector objects}{
\tabular{ll}{
  \code{\link{geom}} \tab returns the geometries as matrix or WKT\cr
  \code{\link{crds}} \tab returns the coordinates as a matrix\cr
  \code{\link{ncol}}\tab The number of columns (of the attributes)\cr
  \code{\link{nrow}} \tab The number of rows (of the geometries and attributes)\cr
  \code{\link{names}} \tab Get or set the layer names \cr
  \code{\link{ext}} \tab Get the extent (minimum and maximum x and y coordinates; "bounding box") \cr
  \code{\link{crs}} \tab The coordinate reference system (map projection) \cr
  \code{\link{linearUnits}} \tab returns the linear units of the crs (in meter)\cr
  \code{\link{is.lonlat}} \tab Test if an object has (or may have) a longitude/latitude coordinate reference system\cr
  \code{\link{geomtype}} \tab Geometry type string \cr
  \code{\link{is.lines}} / \code{\link{is.points}} \tab Geometry type tests \cr
  \code{\link{has.z}} \tab Whether geometries store Z coordinates \cr
  \code{\link{is.polygons}} \tab  \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr  
}}


\section{XX. Geometric queries}{
\tabular{ll}{
  \code{\link{adjacent}} \tab find adjacent polygons\cr
  \code{\link{expanse}} \tab computes the area covered by polygons\cr
  \code{\link{nearby}} \tab find nearby geometries\cr
  \code{\link{nearest}} \tab find the nearest geometries\cr
  \code{\link{relate}} \tab geometric relationships such as "intersects", "overlaps", and "touches"\cr
  \code{\link{perim}} \tab computes the length of the perimeter of polygons, and the length of lines\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr  
}}


\section{XXI. Geometric operations}{

\tabular{ll}{
  \code{\link{erase}} or "-" \tab erase (parts of) geometries\cr
  \code{\link{intersect}} or "*"  \tab intersect geometries\cr
  \code{\link{union}} or "+" \tab Merge geometries\cr
  \code{\link{cover}} \tab update polygons\cr
  \code{\link{symdif}} \tab symmetrical difference of two polygons \cr 
  \code{\link{aggregate}} \tab dissolve smaller polygons into larger ones \cr
  \code{\link{buffer}} \tab buffer geometries \cr
  \code{\link{disagg}} \tab split multi-geometries into separate geometries \cr
  \code{\link{crop}} \tab clip geometries using a rectangle (SpatExtent) or SpatVector \cr
  \code{\link{divide}} \tab divide polygons into equal areas \cr
  \code{\link{thin}} \tab remove geometries that are too close to another \cr
  
  
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr  
}}


\section{XXII. SpatVector attributes}{
We use the term "attributes" for the tabular data (data.frame) associated with vector geometries.

\tabular{ll}{
  \code{\link{extract}} \tab spatial queries between SpatVector and SpatVector (e.g. point in polygons) \cr
  \code{\link{spatSample}} \tab Take a regular or random point sample from polygons or lines\cr
  \code{\link{sel}} \tab select - interactively select geometries\cr
  \code{\link{click}} \tab identify attributes by clicking on a map\cr
  \code{\link{merge}} \tab Join a table with a SpatVector \cr
  \code{\link{as.data.frame}} \tab get attributes as a data.frame\cr
  \code{\link{as.list}} \tab get attributes as a list\cr
  \code{\link{values}} \tab Get the attributes of a SpatVector \cr
  \code{\link{values<-}} \tab Set new attributes to the geometries of a SpatVector \cr  
  \code{\link{sort}} \tab sort SpatVector by the values in a field \cr
  \code{\link{query}} \tab Read features from a SpatVectorProxy \cr
  
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr  
}}


\section{XXIII. Change geometries (for display, experimentation)}{

\tabular{ll}{
  \code{\link{shift}} \tab change the position geometries by shifting their coordinates in horizontal and/or vertical direction\cr
  \code{\link{spin}}\tab rotate geometries around an origin\cr
  \code{\link{rescale}} \tab shrink (or expand) geometries, for example to make an inset map \cr
  \code{\link{flip}} \tab flip geometries vertically or horizontally\cr
  \code{\link{t}} \tab transpose geometries (switch x and y)\cr
  \code{\link{agitate}} \tab Randomly perturb coordinates for plotting \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr  
}}


\section{XXIV. Geometry properties and topology}{

\tabular{ll}{
  \code{\link{width}} \tab the minimum diameter of the geometries \cr
  \code{\link{clearance}} \tab the minimum clearance of the geometries \cr
  \code{\link{sharedPaths}} \tab shared paths (arcs) between line or polygon geometries\cr
  \code{\link{simplifyGeom}} \tab simplify geometries\cr
  \code{\link{gaps}} \tab find gaps between polygon geometries \cr
  \code{\link{fillHoles}} \tab get or remove the polygon holes\cr
  \code{\link{makeNodes}} \tab create nodes on lines \cr
  \code{\link{mergeLines}} \tab connect lines to form polygons  \cr
  \code{\link{removeDupNodes}} \tab remove duplicate nodes in geometries and optionally rounds the coordinates  \cr
  \code{\link{is.valid}} \tab check if geometries are valid \cr
  \code{\link{makeValid}} \tab attempt to repair invalid geometries \cr  
  \code{\link{snap}} \tab make boundaries of geometries identical if they are very close to each other  \cr
  \code{\link{erase} (single argument)} \tab remove parts of geometries that overlap \cr
  \code{\link{union} (single argument)} \tab create new polygons such that there are no overlapping polygons \cr
  \code{\link{rotate}} \tab rotate to (dis-) connect them across the date-line \cr
  \code{\link{normalize.longitude}} \tab move geometries that are outside of the -180 to 180 degrees range.  \cr
  \code{\link{elongate}} \tab make lines longer by extending both sides \cr
  \code{\link{combineGeoms}} \tab combine geometries that overlap, share a border, or are within a minimum distance of each other \cr
  \code{\link{forceCCW}} \tab force counter-clockwise polygon winding \cr 
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}}


\section{XXV. SpatVectorCollections}{
A SpatVectorCollection is a vector of SpatVector objects. 

\tabular{ll}{
\code{\link{svc}} \tab create a SpatVectorCollection from (a list of) SpatVector objects\cr
\code{\link{length}} \tab how many SpatVectors does the SpatVectorCollection have?\cr
\code{\link{[}} \tab extract a SpatVector\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}}


\section{XXVI. Coordinate reference system method}{
\tabular{ll}{
    \code{\link{crs}} \tab Get or set the coordinate reference system (map projection) of a Spat* object \cr
    \code{\link{is.lonlat}} \tab Test if an object has (or may have) a longitude/latitude coordinate reference system\cr
    \code{\link{linearUnits}} \tab returns the linear units of the crs (in meter)\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}}


\section{\bold{Other classes}}{

---------------------------------------------------------------------------------------------------------------------}


\section{XXVII. SpatExtent}{
  \tabular{ll}{
    \code{\link{ext}} \tab Create a SpatExtent object. For example to \code{\link{crop}} a Spatial dataset\cr
    \code{\link{intersect}} \tab Intersect two SpatExtent objects, same as \code{-}  \cr
    \code{\link{union}} \tab Combine two SpatExtent objects, same as \code{+} \cr
    \code{\link{Math-methods}} \tab round/floor/ceiling of a SpatExtent \cr
    \code{\link{align}} \tab Align a SpatExtent with a SpatRaster \cr
    \code{\link{draw}} \tab Create a SpatExtent by drawing it on top of a map (plot) \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}

\section{XXVIII. SpatGraticule}{
  \tabular{ll}{
    \code{\link{graticule}} \tab Create a graticule\cr
    \code{\link{crop}} \tab crop a graticule\cr
	\code{\link[=plot,SpatGraticule,missing-method]{plot<SpatGraticule>}} \tab plot a graticule \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}

\section{XXIX. SpatNetwork}{

A SpatNetwork represents a spatial graph of nodes and edges (for example a road or stream network).

\tabular{ll}{
  \code{\link{netw}} \tab Create a SpatNetwork from lines, an igraph, a file, or from scratch\cr
  \code{\link{net_nodes}} \tab Get the nodes as a SpatVector of points\cr
  \code{\link{net_edges}} \tab Get the edges as a SpatVector of lines\cr
  \code{\link{net_nnodes}} / \code{\link{net_nedges}} \tab Number of nodes or edges\cr
  \code{\link{net_directed}} \tab Is the network directed?\cr
  \code{\link{net_weights}} / \code{\link{net_weights<-}} \tab Get or set edge weights\cr
  \code{\link{shortestPath}} \tab Shortest paths between nodes (Dijkstra)\cr
  \code{\link{writeNetwork}} \tab Write a SpatNetwork to disk (GNM format)\cr
  \code{\link{crs}} / \code{\link{ext}} \tab Coordinate reference system and extent\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}


\section{\bold{General methods}}{

---------------------------------------------------------------------------------------------------------------------}

\section{XXX. Conversion between spatial data objects from different packages}{

You can coerce SpatRasters to Raster* objects, after loading the \code{raster} package, with \code{as(object, "Raster")}, or \code{raster(object)} or \code{brick(object)} or \code{stack(object)}
 
  \tabular{ll}{
    \code{\link{rast}} \tab SpatRaster from matrix and other objects\cr
    \code{\link{vect}} \tab SpatVector from \code{sf} or \code{Spatial*} vector data\cr
    \code{sf::st_as_sf} \tab sf object from SpatVector\cr
    \code{\link{rasterize}} \tab Rasterizing points, lines or polygons\cr
    \code{\link{rasterizeWin}} \tab Rasterize points with a moving window\cr
    \code{\link{rasterizeGeom}} \tab Rasterize attributes of geometries such as "count", "area", or "length"\cr
    \code{\link{as.points}} \tab Create points from a SpatRaster or SpatVector \cr
    \code{\link{as.lines}} \tab Create lines from a SpatRaster or SpatVector\cr
    \code{\link{as.polygons}} \tab Create polygons from a SpatRaster \cr
    \code{\link{as.contour}}  \tab Contour lines from a SpatRaster \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
  }
}

\section{XXXI. Plotting}{

\subsection{Maps}{
  \tabular{ll}{
    \code{\link{plot}} \tab Plot a SpatRaster or SpatVector. The main method to create a map \cr
    \code{\link{panel}} \tab Combine multiple plots \cr	
	\code{\link{points}} \tab Add points to a map\cr
	\code{\link{lines}} \tab Add lines to a map\cr
	\code{\link{polys}} \tab Add polygons to a map \cr
    \code{\link{text}} \tab Add text (such as the values of a SpatRaster or SpatVector) to a map \cr
    \code{\link{halo}} \tab Add text with a halo to a map \cr
    \code{\link{map.pal}} \tab Color palettes for mapping \cr
    \code{\link{image}} \tab Alternative to plot to make a map with a SpatRaster \cr
    \code{\link{plotRGB}} \tab Combine three layers (red, green, blue channels) into a single "real color" plot \cr
	\code{\link[=plot,SpatGraticule,missing-method]{plot<SpatGraticule>}} \tab plot a graticule \cr
    \code{\link{sbar}} \tab Add a scale bar to a map\cr
    \code{\link{north}} \tab Add a north arrow to a map\cr
    \code{\link{inset}} \tab Add a small inset (overview) map\cr
    \code{\link{add_legend}} \tab Add a legend to a map\cr
    \code{\link{add_box}} \tab Add a bounding box to a map\cr
    \code{\link{map_extent}} \tab Get the coordinates of a map's axes positions\cr
    \code{\link{dots}} \tab Make a dot-density map \cr
    \code{\link{cartogram}} \tab Make a cartogram \cr
    \code{\link{persp}} \tab Perspective plot of a SpatRaster \cr
    \code{\link{contour}} \tab Contour plot or filled-contour plot of a SpatRaster \cr
    \code{\link{colorize}} \tab Combine three layers (red, green, blue channels) into a single layer with a color-table \cr
    \code{\link{add_abline}} \tab Add \code{abline} to a map \cr
    \code{\link{add_mtext}} \tab Add margin text (\code{mtext}) \cr
    \code{\link{add_grid}} \tab Add a reference grid \cr
    \code{\link{animate}} \tab Animate raster or vector layers \cr
    \code{\link{plet}} \tab Make an interactive (\code{leaflet}) map \cr
	\code{\link[=plot,SpatRaster,SpatRaster-method]{scatter plot}} \tab Scatter plot of two SpatRasters \cr
    \code{\link{has.colors}} \tab Do layers in a SpatRaster have a color table? \cr
    \code{\link{coltab}} / \code{\link{coltab<-}} \tab Get or set color tables \cr
	
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
	}
}

\subsection{Interacting with a map}{
  \tabular{ll}{
    \code{\link{zoom}} \tab Zoom in to a part of a map by drawing a bounding box on it \cr
    \code{\link{click}} \tab Query values of SpatRaster or SpatVector by clicking on a map \cr
    \code{\link{sel}} \tab Select a spatial subset of a SpatRaster or SpatVector by drawing on a map\cr
    \code{\link{draw}} \tab Create a SpatExtent or SpatVector by drawing on a map \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
	}
}

\subsection{Other plots}{
  \tabular{ll}{
    \code{\link{plot}} \tab x-y scatter plot of the values of (a sample of) the layers of two SpatRaster objects\cr
    \code{\link{hist}} \tab Histogram of SpatRaster values \cr
    \code{\link{barplot}} \tab Bar plot of a SpatRaster \cr
    \code{\link{density}} \tab Density plot of SpatRaster values \cr
    \code{\link{pairs}} \tab Pairs plot for layers in a SpatRaster \cr
    \code{\link{boxplot}} \tab Box plot of the values of a SpatRaster\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
	}
}
}



\section{XXXII. Longitude/latitude data}{

Most methods that involve distance, area, direction, or sampling account for the Earth's shape when the coordinate reference system is longitude/latitude. Distances and lengths are then expressed in meters (unless noted otherwise), typically computed on the WGS84 ellipsoid with Karney's algorithm (GeographicLib). Areas are computed on the ellipsoid as well. For these quantities it is generally better to use lon/lat data than a planar (projected) CRS, because map projections distort distance, area and/or direction. These methods include \code{\link{distance}}, \code{\link{direction}}, \code{\link{gridDist}}, \code{\link{costDist}}, \code{\link{nearby}}, \code{\link{nearest}}, \code{\link{buffer}}, \code{\link{expanse}}, \code{\link{cellSize}}, \code{\link{perim}}, \code{\link{terrain}}, \code{\link{densify}}, \code{\link{elongate}}, \code{\link{agitate}}, \code{\link{spatSample}}, \code{\link{netw}}, \code{\link{shortestPath}}, and \code{\link{tessellate}}.

Some methods do \bold{not} use geodesic algorithms, require a planar CRS, or interpret parameters in the units of the CRS (degrees for lon/lat). 

Geometric "vector overlay" operations such as \code{\link{intersect}}, \code{\link{union}}, \code{\link{erase}}, \code{\link{symdif}}, \code{\link{crop}} do not adjust for lon/lat intersections (use \code{\link{densify}} to approximate it better if needed) 

\code{\link{voronoi}}, \code{\link{hull}}) treat longitude/latitude coordinates as if they were planar.

\tabular{ll}{
\code{\link{viewshed}} \tab Requires a planar CRS (not lon/lat)\cr
\code{\link{surfArea}} \tab Requires a planar CRS with elevation in the same units\cr
\code{\link{simplifyGeom}}, \code{\link{snap}} \tab \code{tolerance} is in CRS units (degrees for lon/lat)\cr
\code{\link{voronoi}} \tab Snapping \code{tolerance} is in CRS units; the diagram is planar\cr
\code{\link{rasterizeWin}} \tab Window size is in CRS units (no degree-to-meter conversion)\cr
\code{\link{focalMat}} \tab Filter size is in CRS units\cr
\code{\link{extract}} \tab \code{search_radius} for lon/lat uses mean latitude (approximate)\cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}



\section{\bold{Comparison with the raster package}}{

---------------------------------------------------------------------------------------------------------------------
"terra" was written to replace the "raster" package. "terra" has a very similar, but simpler, interface; it is faster, and it can do much more. This section highlights some of the differences between the two packages. 

}


\section{XXXIII. New method names}{

\code{terra} has a single class \code{SpatRaster} for which \code{raster} has three (\code{RasterLayer, RasterStack, RasterBrick}). Likewise there is a single class for vector data \code{SpatVector} that replaces six \code{Spatial*} classes. Most method names are the same, but note the following important differences in methods names with the \code{raster} package

\tabular{ll}{
\bold{raster package} \tab \bold{terra package}\cr
\code{raster, brick, stack}\tab\code{\link{rast}}\cr
\code{rasterFromXYZ}\tab\code{\link{rast}( , type="xyz")}\cr
\code{stack, addLayer}\tab\code{\link{c}}\cr
\code{addLayer} \tab\code{\link{add<-}}\cr
\code{area} \tab\code{\link{cellSize}} or \code{\link{expanse}}\cr
\code{approxNA} \tab\code{\link{approximate}}\cr
\code{calc}\tab\code{\link{app}}\cr
\code{cellFromLine, cellFromPolygon,}\tab \code{\link{cells}}\cr
\code{cellsFromExtent}\tab\code{\link{cells}}\cr
\code{cellStats}\tab\code{\link{global}}\cr
\code{clump}\tab\code{\link{patches}}\cr
\code{compareRaster}\tab\code{\link{compareGeom}}\cr
\code{corLocal}\tab\code{\link{focalPairs}}\cr
\code{coordinates}\tab\code{\link{crds}}\cr
\code{couldBeLonLat}\tab\code{\link{is.lonlat}}\cr
\code{disaggregate} \tab\code{\link{disagg}}\cr
\code{distanceFromPoints} \tab \code{\link{distance}}\cr
\code{drawExtent, drawPoly, drawLine} \tab \code{\link{draw}}\cr
\code{dropLayer}\tab\code{\link{subset}}\cr
\code{extent}\tab\code{\link{ext}}\cr
\code{getValues}\tab\code{\link{values}}\cr
\code{isLonLat, isGlobalLonLat}\tab\code{\link{is.lonlat}}\cr
\code{layerize}\tab\code{\link{segregate}}\cr
\code{layerStats}\tab\code{\link{layerCor}}\cr
\code{movingFun}\tab\code{\link{roll}}\cr
\code{NAvalue}\tab\code{\link{NAflag}}\cr
\code{nlayers}\tab\code{\link{nlyr}}\cr
\code{overlay}\tab\code{\link{lapp}}\cr
\code{unstack}\tab\code{\link{as.list}}\cr
\code{projectRaster}\tab\code{\link{project}}\cr
\code{rasterToPoints}\tab\code{\link{as.points}}\cr
\code{rasterToPolygons}\tab\code{\link{as.polygons}}\cr
\code{readAll}\tab\code{\link{toMemory}}\cr
\code{reclassify, subs, cut}\tab\code{\link{classify}}\cr
\code{sampleRandom, sampleRegular}\tab\code{\link{spatSample}}\cr
\code{shapefile}\tab\code{\link{vect}}\cr
\code{stackApply}\tab\code{\link{tapp}}\cr
\code{stackSelect}\tab\code{\link{selectRange}}\cr
}
}

\section{XXXIV. Changed behavior}{

Also note that even if function names are the same in \code{terra} and \code{raster}, their output can be different. In most cases this was done to get more consistency in the returned values (and thus fewer errors in the downstream code that uses them). In other cases it simply seemed better. Here are some examples:

\tabular{ll}{
\code{\link{resample}}\tab Results are not numerically identical when using \code{method="bilinear"}, especially at edges, and when going from a high to a low resolution\cr
\code{\link{as.polygons}}\tab By default, \code{terra} returns dissolved polygons\cr
\code{\link{quantile}}\tab computes by cell, across layers instead of the other way around\cr
\code{\link{extract}}\tab By default, \code{terra} returns a matrix, with the first column the sequential ID of the vectors. \cr
\tab \code{raster} returns a list (for lines or polygons) or a matrix (for points, but without the ID\cr
\tab column). You can use \code{list=TRUE} to get the results as a list\cr
\code{\link{values}}\tab \code{terra} always returns a matrix. \code{raster} returns a vector for a \code{RasterLayer}\cr
\code{\link{Summary-methods}}\tab With \code{raster}, \code{mean(x, y)} and \code{mean(stack(x, y)} return the same result, a single\cr
\tab layer with the mean of all cell values. This is also what \code{terra} returns with \cr
\tab \code{mean(c(x, y))}, but with \code{mean(x, y)} the parallel mean is returned -- that is, the\cr
\tab computation is done layer-wise, and the number of layers in the output is the same as\cr
\tab  that of \code{x} and \code{y} (or the larger of the two if they are not the same). This affects \cr
\tab all summary functions (\code{sum}, \code{mean}, \code{median}, \code{which.min}, \code{which.max}, \code{min}, \code{max},\cr
\tab \code{prod}, \code{any}, \code{all}, \code{stdev}), except \code{range}, which is not implemented for this case \cr
\tab (you can use \code{min} and \code{max} instead) \cr
  --------------------------- \tab ------------------------------------------------------------------------------------------ \cr
}
}

\section{Contributors}{
Except where indicated otherwise, the methods and functions in this package were written by Robert Hijmans. Andrew Gene Brown and Márcia Barbosa contributed many improvements to the code and documentation. Krzysztof Dyba contributed to documentation and github management and issues. Emanuele Cordano contributed functions for catchment related computations. The configuration scripts were written by Roger Bivand. Some of the code for using the GEOS library was adapted from code by Edzer Pebesma for \code{sf}. Michael Chirico, Barry Rowlingson, and Michael D. Sumner also made important contributions.


This package is an attempt to climb on the shoulders of giants (GDAL, PROJ, GEOS, NCDF, GeographicLib, Rcpp, R). Many people have contributed by asking questions or \href{https://github.com/rspatial/terra}{raising issues}. Feedback and suggestions by Kodi Arfer, Kendon Bell, Jean-Luc Dupouey, Sarah Endicott, Derek Friend, Alex Ilich, Agustin Lobo, Gerald Nelson, Jakub Nowosad, and Monika Tomaszewska have been especially helpful.
}


\keyword{ package }
\keyword{ spatial }

\name{union}

\docType{methods}

\alias{union}
\alias{union,SpatExtent,SpatExtent-method}
\alias{union,SpatVector,SpatVector-method}
\alias{union,SpatVector,SpatExtent-method}
\alias{union,SpatVector,missing-method}

\title{ 
Union SpatVector or SpatExtent objects
}

\description{

If you want to append polygon SpatVectors use \code{rbind} instead of \code{union}. \code{union} will also intersect overlapping polygons between, not within, objects. Union for lines and points simply combines the two data sets; without any geometric intersections. This is equivalent to \code{\link{rbind}}. Attributes are joined. 

If \code{x} and \code{y} have a different geometry type, a SpatVectorCollection is returned.

If a single SpatVector is supplied, overlapping polygons are intersected. Original attributes are lost. New attributes allow for determining how many, and which, polygons overlapped. 

SpatExtent: Objects are combined into their union; this is equivalent to \code{+}.  
}

\usage{
\S4method{union}{SpatVector,SpatVector}(x, y)

\S4method{union}{SpatVector,missing}(x, y)

\S4method{union}{SpatExtent,SpatExtent}(x, y)
}

\arguments{
  \item{x}{SpatVector or SpatExtent}
  \item{y}{Same as \code{x} or missing}
} 

\value{
SpatVector or SpatExtent
}

\seealso{
\code{\link[terra]{rbind}}

\code{\link[terra]{intersect}}

\code{\link[terra]{combineGeoms}}

\code{\link{merge}} and \code{\link{mosaic}} to union SpatRasters.

\code{\link{crop}} and \code{\link{extend}} for the union of SpatRaster and SpatExtent.

\code{\link[terra]{merge}} for merging a data.frame with attributes of a SpatVector.
  
\code{\link[terra]{aggregate}} to dissolve SpatVector objects. 
}


\examples{
e1 <- ext(-10, 10, -20, 20)
e2 <- ext(0, 20, -40, 5)
union(e1, e2)

#SpatVector
v <- vect(system.file("ex/lux.shp", package="terra"))
v <- v[,3:4]
p <- vect(c("POLYGON ((5.8 49.8, 6 49.9, 6.15 49.8, 6 49.65, 5.8 49.8))", 
"POLYGON ((6.3 49.9, 6.2 49.7, 6.3 49.6, 6.5 49.8, 6.3 49.9))"), crs=crs(v))
values(p) <- data.frame(pid=1:2, value=expanse(p))
u <- union(v, p)
plot(u, "pid")

b <- buffer(v, 1000)

u <- union(b)
u$sum <- rowSums(as.data.frame(u))
plot(u, "sum")
}

\keyword{methods}
\keyword{spatial}

\name{autocorrelation}

\alias{autocor}
\alias{autocor,numeric-method}
\alias{autocor,SpatRaster-method}


\title{Spatial autocorrelation}

\description{
Compute spatial autocorrelation for a numeric vector or a SpatRaster. You can compute standard (global) Moran's I or Geary's C, or local indicators of spatial autocorrelation (Anselin, 1995).
}

\usage{
\S4method{autocor}{numeric}(x, w, method="moran")

\S4method{autocor}{SpatRaster}(x, w=matrix(c(1,1,1,1,0,1,1,1,1),3), method="moran", 
		global=TRUE, standardize=FALSE)
}

\arguments{
  \item{x}{numeric or SpatRaster}
  \item{w}{Spatial weights defined by or a rectangular matrix. For a SpatRaster this matrix must the sides must have an odd length (3, 5, ...)}
  \item{global}{logical. If \code{TRUE} global autocorrelation is computed instead of local autocorrelation}
  \item{standardize}{logical. If \code{TRUE}, apply row standardization to the weights matrix. This divides each weight by the row sum so that the weights for each cell sum to one. For Moran's I, row standardization ensures that the result is bounded between -1 and 1. Only used when \code{global=TRUE}}
  \item{method}{character. If \code{x} is numeric or SpatRaster: "moran" for Moran's I and "geary" for Geary's C. If \code{x} is numeric also: "Gi", "Gi*" (the Getis-Ord statistics), locmor (local Moran's I) and "mean" (local mean)}
}


\value{
numeric or SpatRaster
}

\details{
The default setting uses a 3x3 neighborhood to compute "Queen's case" indices. You can use a filter (weights matrix) to do other things, such as "Rook's case", or different lags. 
}

\seealso{
The \code{spdep} package for additional and more general approaches for computing spatial autocorrelation
}


\references{
Moran, P.A.P., 1950. Notes on continuous stochastic phenomena. Biometrika 37:17-23

Geary, R.C., 1954. The contiguity ratio and statistical mapping. The Incorporated Statistician 5: 115-145

Anselin, L., 1995. Local indicators of spatial association-LISA. Geographical Analysis 27:93-115

\url{https://en.wikipedia.org/wiki/Indicators_of_spatial_association}
}

\examples{
### raster
r <- rast(nrows=10, ncols=10, xmin=0)
values(r) <- 1:ncell(r)

autocor(r)

# row-standardized (result bounded between -1 and 1)
autocor(r, standardize=TRUE)

# rook's case neighbors
f <- matrix(c(0,1,0,1,0,1,0,1,0), nrow=3)
autocor(r, f)

# local 
rc <- autocor(r, w=f, global=FALSE)

### numeric (for vector data)
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
w <- relate(v, relation="touches")

# global
autocor(v$AREA, w)

# local
v$Gi <- autocor(v$AREA, w, "Gi") 
plot(v, "Gi")
}

\keyword{spatial}

\name{crosstab}

\docType{methods}

\alias{crosstab}
\alias{crosstab,SpatRaster,missing-method}

\title{Cross-tabulate}

\description{
Cross-tabulate the layers of a SpatRaster to create a contingency table.
}

\usage{
\S4method{crosstab}{SpatRaster,missing}(x, digits=0, long=FALSE, useNA=FALSE)
}

\arguments{
  \item{x}{SpatRaster}
  \item{digits}{integer. The number of digits for rounding the values before cross-tabulation}
  \item{long}{logical. If \code{TRUE} the results are returned in 'long' format data.frame instead of a table}
  \item{useNA}{logical, indicting if the table should includes counts of \code{NA} values}
}


\value{
A table or data.frame
}

\seealso{ \code{\link{freq}}, \code{\link{zonal}} }

\author{Andrew Gene Brown, Robert J. Hijmans}


\examples{
r <- s <- rast(nc=5, nr=5)
set.seed(1)
values(r) <- runif(ncell(r)) * 2
values(s) <- runif(ncell(r)) * 3
x <- c(r, s)

crosstab(x)

rs <- r/s
r[1:5] <- NA
s[20:25] <- NA
x <- c(r, s, rs)
crosstab(x, useNA=TRUE, long=TRUE)
}

\keyword{methods}
\keyword{spatial}

\name{zonal}

\alias{zonal}

\alias{zonal,SpatRaster,SpatRaster-method}
\alias{zonal,SpatRaster,SpatVector-method}
\alias{zonal,SpatVector,SpatVector-method}

\title{Zonal statistics}

\description{
Compute zonal statistics, that is summarize values of a SpatRaster for each "zone" defined by another SpatRaster, or by a SpatVector with polygon geometry. 

If \code{fun} is a true R \code{function}, the <SpatRaster,SpatRaster> method may fail when using very large SpatRasters, except for the functions ("mean", "min", "max", "sum", "isNA", and "notNA"). 

You can also summarize values of a SpatVector for each polygon (zone) defined by another SpatVector. 
}

\usage{
\S4method{zonal}{SpatRaster,SpatRaster}(x, z, fun="mean", ..., w=NULL, wide=TRUE,
		as.raster=FALSE, filename="", overwrite=FALSE, wopt=list())

\S4method{zonal}{SpatRaster,SpatVector}(x, z, fun="mean", na.rm=FALSE, w=NULL, weights=FALSE,
		exact=FALSE, touches=FALSE, small=TRUE, as.raster=FALSE,
		as.polygons=FALSE, wide=TRUE, filename="", wopt=list())

\S4method{zonal}{SpatVector,SpatVector}(x, z, fun=mean, ..., weighted=FALSE, as.polygons=FALSE) 
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{z}{SpatRaster with cell-values representing zones or a SpatVector with each polygon geometry representing a zone. \code{z} can have multiple layers to define intersecting zones}
  \item{fun}{function to be applied to summarize the values by zone. Either as character: "mean", "min", "max", "sum", "isNA", and "notNA" (these work for zones with many cells), and, for smaller zones only, a proper function}
  \item{...}{additional arguments passed to fun, such as \code{na.rm=TRUE}}  
  \item{w}{SpatRaster with weights. Should have a single-layer with non-negative values}
  \item{wide}{logical. Should the values returned in a wide format? For the \code{SpatRaster, SpatRaster} method this only affects the results when \code{nlyr(z) == 2}. For the \code{SpatRaster, SpatVector} method this only affects the results when \code{fun=table}}
  \item{as.raster}{logical. If \code{TRUE}, a SpatRaster is returned with the zonal statistic for each zone}  
  \item{filename}{character. Output filename (ignored if \code{as.raster=FALSE}}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with additional arguments for writing files as in \code{\link{writeRaster}}}

  \item{weights}{logical. If \code{TRUE} and \code{y} has polygons, the approximate fraction of each cell that is covered is used to compute a weighted mean}
  \item{exact}{logical. If \code{TRUE} and \code{y} has polygons, the exact fraction of each cell that is covered is returned as well, for example to compute a weighted mean}
  \item{touches}{logical. If \code{TRUE}, values for all cells touched by lines or polygons are extracted, not just those on the line render path, or whose center point is within the polygon. Not relevant for points; and always considered \code{TRUE} when \code{weights=TRUE} or \code{exact=TRUE}}
  \item{small}{logical. If \code{TRUE}, values for all cells in touched polygons are extracted if none of the cells center points is within the polygon; even if \code{touches=FALSE}}
  \item{weighted}{logical. If \code{TRUE}, a weighted.mean is computed and \code{fun} is ignored. Weights are based on the length of the lines or the area of the polygons in \code{x} that intersect with \code{z}. This argument is ignored of \code{x} is a SpatVector or points}  
  \item{as.polygons}{logical. Should the zonal statistics be combined with the geometry of \code{z}?}
  \item{na.rm}{logical. If \code{TRUE}, \code{NA}s are removed}
}

\value{
A \code{data.frame} with a value for each zone, or a SpatRaster, or SpatVector of polygons.
}

\seealso{ See \code{\link{global}} for "global" statistics (i.e., all of \code{x} is considered a single zone), \code{\link{app}} for local statistics, and \code{\link{extract}} for an alternative way to summarize values of a SpatRaster with a SpatVector. With \code{\link{aggregate}} you can compute statistics for cell blocks defined by a number of rows and columns. 
}

\examples{

### SpatRaster, SpatRaster
r <- rast(ncols=10, nrows=10)
values(r) <- 1:ncell(r)
z <- rast(r)
values(z) <- rep(c(1:2, NA, 3:4), each=20)
names(z) <- "zone"
zonal(r, z, "sum", na.rm=TRUE)

# with weights 
w <- init(r, "col")
zonal(r, z, w=w, "mean", na.rm=TRUE)

# multiple layers
r <- rast(system.file("ex/logo.tif", package = "terra")) 
# zonal layer 
z <- rast(r, 1)
names(z) <- "zone"
values(z) <- rep(c(1:2, NA, c(3:4)), each=ncell(r)/5, length.out=ncell(r))

zonal(r, z, "mean", na.rm = TRUE)

# raster of zonal values
zr <- zonal(r, z, "mean", na.rm = TRUE, as.raster=TRUE)


### SpatRaster, SpatVector
x <- rast(ncol=2,nrow=2, vals=1:4, xmin=0, xmax=1, ymin=0, ymax=1, crs="+proj=utm +zone=1")
p <- as.polygons(x)
pp <- shift(p, .2)
r <- disagg(x, 4)

zonal(r, p)
zonal(r, p, sum)
zonal(x, pp, exact=TRUE)
zonal(c(x, x*10), pp, w=x)


### SpatVector, SpatVector

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)[,c(2,4)]

p <- spatSample(v, 100)
values(p) <- data.frame(b2=1:100, ssep1=100:1)

zonal(p, v, mean)
}

\keyword{spatial}

\name{rep}

\docType{methods}

\alias{rep}
\alias{rep,SpatRaster-method}

\title{Replicate layers}

\description{
Replicate layers in a SpatRaster
}

\usage{
\S4method{rep}{SpatRaster}(x, ...)

}

\arguments{
  \item{x}{SpatRaster}
  \item{...}{arguments as in \code{\link[base]{rep}}}
}



\value{
SpatRaster
}


\examples{
s <- rast(system.file("ex/logo.tif", package="terra"))   
x <- rep(s, 2)
nlyr(x)
names(x)
x
}

\keyword{spatial}

\name{princomp}

\alias{princomp}
\alias{princomp,SpatRaster-method}

\title{SpatRaster PCA with princomp}

\description{
Compute principal components for SpatRaster layers. This method can use all values to compute the principal components, even for very large rasters. This is because it computes the covariance matrix by processing the data in chunks, if necessary, using \code{\link{layerCor}}. The population covariance is used (not the sample, with \code{n-1} denominator, covariance). 

Alternatively, you can specify \code{maxcell} or sample raster values to a data.frame to speed up calculations for very large rasters (see the examples below). 

See \code{\link{prcomp}} for an alternative method that has higher numerical accuracy, but is slower, and for very large rasters can only be accomplished with a sample since all values must be read into memory.
}

\usage{
\S4method{princomp}{SpatRaster}(x, cor=FALSE, fix_sign=TRUE, use="pairwise.complete.obs", maxcell=Inf)
}

\arguments{
  \item{x}{SpatRaster}
  \item{cor}{logical. If \code{FALSE}, the covariance matrix is used. Otherwise the correlation matrix is used}   
  \item{fix_sign}{logical.  If \code{TRUE}, the signs of the loadings and scores are chosen so that the first element of each loading is non-negative}  
  \item{use}{character. To decide how to handle missing values. This must be (an abbreviation of) one of the strings "everything", "complete.obs", "pairwise.complete.obs", or "masked.complete". With "pairwise.complete.obs", the covariance between a pair of layers is computed for all cells that are not \code{NA} in that pair. Therefore, it may be that the (number of) cells used varies between pairs. The benefit of this approach is that all available data is used. Use "complete.obs", if you want to only use the values from cells that are not \code{NA} in any of the layers. By using "masked.complete" you indicate that all layers have NA values in the same cells}
  \item{maxcell}{positive integer. The maximum number of cells to be used. If this is smaller than ncell(x), a regular sample of \code{x} is used}  
}

\value{
princomp object
}

\author{Alex Ilich and Robert Hijmans, based on a similar method by Benjamin Leutner}


\seealso{ \code{\link{prcomp}} \code{\link[stats]{princomp}}}

\examples{
f <- system.file("ex/logo.tif", package = "terra")
r <- rast(f)
pca <- princomp(r)
x <- predict(r, pca)

# use "index" to get a subset of the components
p <- predict(r, pca, index=1:2)

### use princomp directly
pca2 <- princomp(values(r),  fix_sign = TRUE)
p2 <- predict(r, pca2)

### may need to use sampling with a large raster 
### here with prcomp instead of princomp
sr <- spatSample(r, 100000, "regular")
pca3 <- prcomp(sr)
p3 <- predict(r, pca3)
}

\keyword{spatial}

\name{colors}

\docType{methods}

\alias{has.colors}
\alias{has.colors,SpatRaster-method}
\alias{coltab}
\alias{coltab,SpatRaster-method}
\alias{coltab<-}
\alias{coltab<-,SpatRaster-method}
  
\title{Color table}

\description{
Get or set color table(s) associated with a SpatRaster. Color tables are used for associating colors with values, for use in mapping (plot).
}

\usage{
\S4method{coltab}{SpatRaster}(x)

\S4method{coltab}{SpatRaster}(x, ..., layer=1)<-value

\S4method{has.colors}{SpatRaster}(x)
}


\arguments{
  \item{x}{SpatRaster}
  \item{layer}{positive integer, the layer number or name}
  \item{value}{a two-column data.frame (first column the cell value, the second column the color); 
  a vector of colors (the first one is the color for value 0 and so on); or a four (value,red,green,blue) or five (including alpha) column data.frame also from 0 to n; or NULL to remove the color table. You can also supply a list of such data.frames to set a color table to all layers}
  \item{...}{additional arguments (none implemented)}
}  


\value{
data.frame
}

\examples{
r <- rast(ncols=3, nrows=2, vals=1:6)
x <- c(r, r)
names(x) <- c("A", "B")

coltb <- data.frame(value=1:6, col=rainbow(6, end=.9))
coltb

plot(r)

has.colors(r)
coltab(r) <- coltb
plot(r)
has.colors(r)

tb <- coltab(r)
class(tb)
dim(tb[[1]])

coltab(x, layer="B") <- coltb
}

\keyword{methods}
\keyword{spatial}

\name{zoom}

\docType{methods}

\alias{zoom}
\alias{zoom,SpatRaster-method}
\alias{zoom,SpatVector-method}


\title{Zoom in on a map}


\description{
Zoom in on a map (plot) by providing a new extent, by default this is done by clicking twice on the map.
}

\usage{
\S4method{zoom}{SpatRaster}(x, e=draw(), maxcell=100000, layer=1, new=FALSE, ...)

\S4method{zoom}{SpatVector}(x, e=draw(), new=FALSE, ...)
}

\arguments{
\item{x}{SpatRaster}
\item{e}{SpatExtent}
\item{maxcell}{positive integer. Maximum number of cells used for the map}
\item{layer}{positive integer to select the layer to be used}
\item{new}{logical. If \code{TRUE}, the zoomed in map will appear on a new device (window)}
\item{...}{additional arguments passed to \code{\link{plot}}}
}

\value{
SpatExtent (invisibly)
}


\seealso{ \code{\link{draw}}, \code{\link{plot}}}

\keyword{spatial}

\name{project}

\alias{project}
\alias{project,SpatVector-method}
\alias{project,SpatVectorCollection-method}
\alias{project,SpatRaster-method}
\alias{project,SpatExtent-method}
\alias{project,matrix-method}

\title{Change the coordinate reference system}

\description{
Change the coordinate reference system ("project") of a SpatVector, SpatRaster or a matrix with coordinates. 
}

\usage{
\S4method{project}{SpatRaster}(x, y, method, mask=FALSE, align_only=FALSE, res=NULL, 
	origin=NULL, threads=FALSE, use_gdal=TRUE, by_util=FALSE, pipeline="", 
	AOI=NULL, desired_accuracy=-1.0, allow_approx=TRUE, filename="", ...)

\S4method{project}{SpatVector}(x, y, partial=FALSE, pipeline="", AOI=NULL,
    desired_accuracy=-1.0, allow_approx=TRUE)

\S4method{project}{SpatExtent}(x, from, to)

\S4method{project}{matrix}(x, from, to)
}

\arguments{
  \item{x}{SpatRaster, SpatVector, SpatExtent or matrix (with x and y columns) whose coordinates to project}
  \item{y}{if \code{x} is a SpatRaster, the preferred approach is for \code{y} to be a SpatRaster as well, serving as a template for the geometry (extent and resolution) of the output SpatRaster. Alternatively, you can provide a coordinate reference system (CRS) description. 
    
  You can use the following formats to define coordinate reference systems: WKT,  PROJ.4 (e.g., \code{+proj=longlat +datum=WGS84}), or an EPSG code (e.g., \code{"epsg:4326"}). But note that the PROJ.4 notation has been deprecated, and you can only use it with the WGS84/NAD83 and NAD27 datums. Other datums are silently ignored. 
  
  If \code{x} is a SpatVector, you can provide a crs definition as discussed above, or any other object from which such a crs can be extracted with \code{\link{crs}}}

  \item{partial}{logical. If \code{TRUE}, geometries that can only partially be represented in the output crs are included in the output}

  \item{method}{character. Method used for estimating the new cell values of a SpatRaster. One of: 
  
	\code{bilinear}: bilinear interpolation (3x3 cell window). This is used by default if the first layer of \code{x} is not categorical

	\code{mean}:  This can be a good choice with continuous variables if the output cells overlap with multiple input cells. 

	\code{near}: nearest neighbor. This is used by default if the first layer of \code{x} is categorical. This method is not a good choice for continuous values.

	\code{mode}: The modal value. This can be a good choice for categorical rasters, if the output cells overlap with multiple input cells. 
  
	\code{cubic}: cubic interpolation (5x5 cell window).

	\code{cubicspline}: cubic B-spline interpolation. (5x5 cell window).

	\code{lanczos}: Lanczos windowed sinc resampling. (7x7 cell window).

	\code{sum}: the weighted sum of all non-NA contributing grid cells.

	\code{min, q1, median, q3, max}: the minimum, first quartile, median, third quartile, or maximum value. 
	
	\code{rms}: the root-mean-square value of all non-NA contributing grid cells.
  }

  \item{mask}{logical. If \code{TRUE}, mask out areas outside the input extent. For example, to avoid data wrapping around the date-line (see example with Robinson projection). To remove cells that are \code{NA} in \code{y} (if \code{y} is a SpatRaster) you can use the \code{\link{mask} method} after calling \code{project} (this function)}
  
  \item{align_only}{logical. If \code{TRUE}, and \code{y} is a SpatRaster, the template is used for the spatial resolution and origin, but the extent is set such that all of the extent of \code{x} is included}

  \item{res}{numeric. Can be used to set the resolution of the output raster if \code{y} is a CRS}

  \item{origin}{numeric. Can be used to set the origin of the output raster if \code{y} is a CRS}
  
  \item{threads}{logical or positive integer. If \code{TRUE}, multiple threads are used (faster for large files), no more than the "threads" setting of \code{\link{terraOptions}}. A number sets the thread count for this call directly}

  \item{use_gdal}{logical. If \code{TRUE} the GDAL-warp algorithm is used. Otherwise, a slower internal algorithm is used that may be more accurate if there is much variation in the cell sizes of the output raster. Only the \code{near} and \code{bilinear} algorithms are available for the internal algorithm}

  \item{by_util}{logical. If \code{TRUE} and \code{gdal=TRUE}, the GDAL warp utility is used}

  \item{pipeline}{character. A PROJ pipeline string to use for the coordinate transformation instead of letting GDAL select one automatically. You can use \code{\link{proj_pipelines}} to find available pipelines. When a pipeline is set, \code{y} is still used to set the output CRS}

  \item{AOI}{SpatExtent or object that has a SpatExtent to set the area of interest for the transformation. This is used to select the most appropriate transformation pipeline}

  \item{desired_accuracy}{numeric. Only use transformations with at least this accuracy (in metres). Use \code{-1} (the default) for no constraint. Requires GDAL >= 3.3}

  \item{allow_approx}{logical. If \code{FALSE}, only use transformations with known accuracy (no "ballpark" transformations). Requires GDAL >= 3.3}
  
  \item{filename}{character. Output filename}
  
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}

  \item{from}{character. Coordinate reference system of \code{x}}

  \item{to}{character. Output coordinate reference system}
}


\value{
SpatVector or SpatRaster
}

\seealso{\code{\link{crs}}, \code{\link{resample}}, \code{\link{warp_scale}}, \code{\link{proj_pipelines}} and \code{\link{projNetwork}} to enable or disable PROJ network access for datum grid downloads.}


\note{
The PROJ.4 notation of coordinate reference systems has been partly deprecated in the GDAL/PROJ library that is used by this function. You can still use this notation, but *only* with the WGS84 datum. Other datums are silently ignored. 

Transforming (projecting) raster data is fundamentally different from transforming vector data. Vector data can be transformed and back-transformed without loss in precision and without changes in the values. This is not the case with raster data. In each transformation the values for the new cells are estimated in some fashion. Therefore, if you need to match raster and vector data for analysis, you should generally transform the vector data. 

When using this method with a \code{SpatRaster}, the preferable approach is to provide a template \code{SpatRaster} as argument \code{y}. The template is then another raster dataset that you want your data to align with. If you do not have a template to begin with, you can do \code{project(rast(x), crs)} and then manipulate the output to get the template you want. For example, where possible use whole numbers for the extent and resolution so that you do not have to worry about small differences in the future. You can use commands like \code{dim(z) = c(180, 360)} or \code{res(z) <- 100000}. 

The output resolution should generally be similar to the input resolution, but there is no "correct" resolution in raster transformation. It is not obvious what this resolution is if you are using lon/lat data that spans a large North-South extent.
}


\examples{
## SpatRaster
\dontrun{
a <- rast(ncols=40, nrows=40, xmin=-110, xmax=-90, ymin=40, ymax=60, 
          crs="+proj=longlat +datum=WGS84")
values(a) <- 1:ncell(a)
newcrs="+proj=lcc +lat_1=48 +lat_2=33 +lon_0=-100 +datum=WGS84"
b <- rast(ncols=94, nrows=124, xmin=-944881, xmax=935118, ymin=4664377, ymax=7144377, crs=newcrs)
w <- project(a, b)


## SpatVector
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
crs(v, proj=TRUE)
cat(crs(v), "\n")

project(v, "+proj=moll")
project(v, "EPSG:2169")
}
}


\keyword{spatial}

\name{scoff}

\alias{scoff}
\alias{scoff<-}
\alias{scoff,SpatRaster-method}
\alias{scoff<-,SpatRaster-method}


\title{Scale (gain) and offset}


\description{
These functions can be used to get or set the scale (gain) and offset parameters used to transform values when reading raster data from a file. The parameters are applied to the raw values using the formula below: 

\code{value <- value * scale + offset}

The default value for scale is 1 and for offset is 0. 'scale' is sometimes referred to as 'gain'.

Note that setting the scale and/or offset are intended to be used with values that are stored in a file. When values are memory, assigning scale or offset values will lead to the immediate computation of new values; in such cases it would be clearer to use \code{\link[terra]{Arith-methods}}.
}

\usage{
\S4method{scoff}{SpatRaster}(x)

\S4method{scoff}{SpatRaster}(x)<-value
}

\arguments{
  \item{x}{SpatRaster}
  \item{value}{two-column matrix with scale (first column) and offset (second column) for each layer. Or \code{NULL} to remove all scale and offset values}
}

\value{
matrix or changed SpatRaster
}



\examples{ 
r <- rast(system.file("ex/elev.tif", package="terra"))
minmax(r)
scoff(r)
r[4603]

scoff(r) <- cbind(10, 5)
minmax(r)
scoff(r)
r[4603]
}

\keyword{ spatial }
\keyword{ methods }

\name{extractRange}

\docType{methods}

\alias{extractRange}
\alias{extractRange,SpatRaster-method}
\alias{extractRange,SpatRaster,ANY-method}

\title{Extract values for a range of layers from a SpatRaster}

\description{
Extract values from a SpatRaster for a set of locations and a range of layers. To extract values for a single or all layers, use \code{\link{extract}}
} 

\usage{
\S4method{extractRange}{SpatRaster}(x, y, first, last, lyr_fun=NULL, 
		geom_fun=NULL, ID=FALSE, na.rm=TRUE, bind=FALSE, ...)
}

\arguments{
\item{x}{SpatRaster}
\item{y}{SpatVector (points, lines, or polygons). Alternatively, for points, a 2-column matrix or data.frame (x, y) or (lon, lat). Or a vector with cell numbers}
 \item{first}{layer name of number, indicating the first layer in the range of layers to be considered}
\item{last}{layer name or number, indicating the last layer in the range to be considered}  
\item{lyr_fun}{function to summarize the extracted data across layers}
\item{geom_fun}{function to summarize the extracted data for each line or polygon geometry. Ignored if \code{y} has point geometry}
\item{ID}{logical. Should an ID column be added? If so, the first column returned has the IDs (record numbers) of \code{y}}
\item{na.rm}{logical. Should missing values be ignored?}
\item{bind}{logical. If \code{TRUE}, the extracted values are \code{cbind}-ed to \code{y}}
\item{...}{additional arguments passed to \code{extract}}
}

\value{numeric or data.frame}

\seealso{\code{\link{extract}}}

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
xy <- data.frame(x=c(50,80), y=c(30, 60))
extract(r, xy)
extract(r, xy, layer=c("red", "green"))

extractRange(r, xy, first=1:2, last=3:2)
extractRange(r, xy, first=1:2, last=3:2, lyr_fun=sum)

}

\keyword{methods}
\keyword{spatial}

\name{segregate}

\docType{methods}

\alias{segregate}
\alias{segregate,SpatRaster-method}

\title{segregate}

\description{
Create a SpatRaster with a layer for each class (value, or subset of the values) in the input SpatRaster. For example, if the input has vegetation types, this function will create a layer (presence/absence; dummy variable) for each of these classes.

This is called "one-hot encoding" or "dummy encoding" (for a dummy encoding scheme you can remove (any) one of the output layers as it is redundant).
}

\usage{
\S4method{segregate}{SpatRaster}(x, classes=NULL, keep=FALSE, other=0, round=FALSE, digits=0, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{classes}{numeric. The values (classes) for which layers should be made. If \code{NULL} all classes are used}
  \item{keep}{logical. If \code{TRUE}, cells that are of the class represented by a layer get that value, rather than a value of 1}
  \item{other}{numeric. Value to assign to cells that are not of the class represented by a layer}
  \item{round}{logical. Should the values be rounded first?}
  \item{digits}{integer. Number of digits to round the values to}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{\code{\link{split}}}

\examples{
r <- rast(nrows=5, ncols=5)
values(r) <- rep(c(1:4, NA), each=5)
b <- segregate(r)
bb <- segregate(r, keep=TRUE, other=NA)
}

\keyword{spatial}

\name{mergeTime}

\docType{methods}

\alias{mergeTime}
\alias{mergeTime,SpatRasterDataset-method}

\title{ 
merge SpatRasters by timelines to create a single timeseries
}

\description{
Combine SpatRasters with partly overlapping time-stamps to create a single time series. If there is no overlap between the SpatRasters there is no point in using this function (use \code{\link{c}} instead). 

Also note that time gaps are not filled. You can use \code{\link{fillTime}} to do that.
}

\usage{
\S4method{mergeTime}{SpatRasterDataset}(x, fun=mean, filename="", ...)
}

\arguments{
  \item{x}{SpatRasterDataset}
  \item{fun}{A function that reduces a vector to a single number, such as \code{mean} or \code{min}}
  \item{filename}{character. Output filename}
  \item{...}{list with named options for writing files as in \code{\link{writeRaster}}}
} 

\value{
SpatRaster
}


\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
s1 <- c(r, r)
time(s1) <- as.Date("2001-01-01") + 0:5
s1 <- s1/10
time(s1) <- as.Date("2001-01-07") + 0:5
s2 <- s1*10
time(s2) <- as.Date("2001-01-05") + 0:5
x <- sds(s1, s1, s2)

m <- mergeTime(x, mean)
}

\keyword{methods}
\keyword{spatial}

\name{as.list}

\alias{as.list}
\alias{as.list,SpatRaster-method}
\alias{as.list,SpatRasterDataset-method}
\alias{as.list,SpatRasterCollection-method}
\alias{as.list,SpatVector-method}
\alias{as.list,SpatVectorCollection-method}
  

\title{Coerce a Spat* object to a list}

\description{
Coerce a SpatRaster, SpatRasterCollection, SpatRasterDataset, SpatVector or SpatVectorCollection to a list. With a SpatRaster, each layer becomes a list element. With a SpatRasterCollection or SpatRasterDataset, each SpatRaster becomes a list element. With a SpatVector, each variable (attribute) becomes a list element. With a SpatVectorCollection, each SpatVector becomes a list element.
}

\usage{
\S4method{as.list}{SpatRaster}(x, geom=NULL, ...)

\S4method{as.list}{SpatRasterCollection}(x, ...)

\S4method{as.list}{SpatVector}(x, geom=NULL, ...)

\S4method{as.list}{SpatVectorCollection}(x, ...)
}

\arguments{
 \item{x}{SpatRaster, SpatRasterDataset, SpatRasterCollection, or SpatVector}
 \item{geom}{character or NULL. If not NULL, and \code{x} is a SpatVector, it should be either "WKT" or "HEX", to get the geometry included in Well-Known-Text or hexadecimal notation. If \code{x} has point geometry, it can also be "XY" to add the coordinates of each point. If \code{x} is a SpatRaster, any value that is not NULL will return a list with the parameters describing the geometry of the SpatRaster are returned}
 \item{...}{additional arguments. These are ignored}
}
  
\seealso{see \code{\link{coerce}} for \code{as.data.frame} with a SpatRaster; and \code{\link{geom}} to only extract the geometry of a SpatVector}  
  
\value{
list
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
as.list(v)


s <- rast(system.file("ex/logo.tif", package="terra")) + 1  
as.list(s)
}

\keyword{spatial}
\keyword{methods}

\name{geomtype}

\docType{methods}

\alias{geomtype}
\alias{geomtype,SpatVector-method}
\alias{geomtype,SpatVectorProxy-method}
\alias{geomtype,Spatial-method}
\alias{is.points}
\alias{is.lines}
\alias{is.polygons}
\alias{is.points,SpatVector-method}
\alias{is.lines,SpatVector-method}
\alias{is.polygons,SpatVector-method}

\title{Geometry type of a SpatVector}

\description{
Get the geometry type (points, lines, or polygons) of a SpatVector. See \code{\link{datatype}} for the data types of the fields (attributes, variables) of a SpatVector.
} 

\usage{
\S4method{geomtype}{SpatVector}(x)

\S4method{is.points}{SpatVector}(x)

\S4method{is.lines}{SpatVector}(x)

\S4method{is.polygons}{SpatVector}(x)
}

\arguments{
\item{x}{SpatVector}
}

\value{character}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)

geomtype(v)
is.polygons(v)
is.lines(v)
is.points(v)

names(v)
datatype(v)
}

\keyword{methods}
\keyword{spatial}

\name{hist}

\docType{methods}

\alias{hist}
\alias{hist,SpatRaster-method}

\title{Histogram}

\description{
Create a histogram of the values of a SpatRaster. For large datasets a sample of \code{maxcell} is used.
}

\usage{
\S4method{hist}{SpatRaster}(x, layer, maxcell=1000000, plot=TRUE, maxnl=16, main, ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{layer}{positive integer or character to indicate layer numbers (or names). If missing, all layers up to \code{maxnl} are used} 
  \item{maxcell}{integer. To regularly sample very large objects}
  \item{plot}{logical. Plot the histogram or only return the histogram values}
  \item{maxnl}{positive integer. The maximum number of layers to use. Ignored if \code{layer} is not missing}
  \item{main}{character. Main title(s) for the plot. Default is the value of \code{\link{names}}}
  \item{...}{additional arguments. See \code{\link[graphics]{hist}}}  
}


\value{
This function is principally used for plotting a histogram, but it also returns an object of class "histogram" (invisibly if \code{plot=TRUE}).
}

\seealso{ \code{\link{pairs}, \link{boxplot}} }

\examples{ 
r1 <- r2 <- rast(nrows=50, ncols=50)
values(r1) <- runif(ncell(r1))
values(r2) <- runif(ncell(r1))
rs <- r1 + r2
rp <- r1 * r2

opar <- par(no.readonly =TRUE)
par(mfrow=c(2,2))
plot(rs, main='sum')
plot(rp, main='product')
hist(rs)
a <- hist(rp)
a
x <- c(rs, rp, sqrt(rs))
hist(x)
par(opar)
}

\keyword{methods}
\keyword{spatial}

\name{rescale}

\docType{methods}

\alias{rescale}
\alias{rescale,SpatRaster-method}
\alias{rescale,SpatVector-method}

\title{rescale}

\description{
Rescale a SpatVector or SpatRaster. This may be useful to make small \code{\link{inset}} maps or for georeferencing. 
}

\usage{
\S4method{rescale}{SpatRaster}(x, fx=0.5, fy=fx, x0, y0)

\S4method{rescale}{SpatVector}(x, fx=0.5, fy=fx, x0, y0)
}

\arguments{
  \item{x}{SpatVector or SpatRaster}
  \item{fx}{numeric > 0. The horizontal scaling factor}
  \item{fy}{numeric > 0. The vertical scaling factor}
  \item{x0}{numeric. x-coordinate of the center of rescaling. If missing, the center of the extent of \code{x} is used}
  \item{y0}{numeric. y-coordinate of the center of rescaling. If missing, the center of the extent of \code{x} is used}
}
 
\value{
Same as \code{x}
}


\seealso{\code{\link{t}}, \code{\link{shift}}, \code{\link{flip}}, \code{\link{rotate}}, \code{\link{inset}}, \code{\link{cartogram}}}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
w <- rescale(v, 0.2)
plot(v)
lines(w, col="red")
}

\keyword{spatial}

\name{summarize}

\docType{methods}

\alias{Summary-methods}

\alias{median}
\alias{mean}
\alias{min}
\alias{max}
\alias{which.min}
\alias{which.max}
\alias{any}
\alias{all}
\alias{nany}
\alias{prod}
\alias{range}
\alias{sum}
\alias{anyNA}
\alias{allNA}
\alias{noNA}
\alias{countNA}

\alias{mean,SpatRaster-method}
\alias{mean,SpatVector-method}
\alias{mean,SpatExtent-method}
\alias{median,SpatRaster-method}
\alias{median,SpatVector-method}
\alias{min,SpatRaster-method}
\alias{max,SpatRaster-method}
\alias{range,SpatRaster-method}
\alias{which.min,SpatRaster-method}
\alias{which.max,SpatRaster-method}

\alias{any,SpatRaster-method}
\alias{all,SpatRaster-method}
\alias{nany,SpatRaster-method}
\alias{nany,ANY-method}
\alias{prod,SpatRaster-method}
\alias{range,SpatRaster-method}
\alias{sum,SpatRaster-method}
\alias{anyNA,SpatRaster-method}
\alias{allNA,SpatRaster-method}
\alias{noNA,SpatRaster-method}
\alias{countNA,SpatRaster-method}

\alias{stdev}
\alias{stdev,SpatRaster-method}


\title{Summarize}

\description{

Compute summary statistics for cells, either across layers or between layers (parallel summary). 

The following summary methods are available for SpatRaster: \code{any, anyNA, all, allNA, nany, noNA, max, min, mean, median, prod, range, stdev, sum, which.min, which.max}. See \code{\link{modal}} to compute the mode and \code{\link{app}} to compute summary statistics that are not included here. \code{nany} stands for "not any" or "none" and allows to do \code{!all(x)} in one computation instead of two.
 
Because generic functions are used, the method applied is chosen based on the first argument: "\code{x}". This means that if \code{r} is a SpatRaster, \code{mean(r, 5)} will work, but \code{mean(5, r)} will not work.

The \code{mean} method has an argument "trim" that is ignored.

If \code{pop=TRUE} \code{stdev} computes the population standard deviation, computed as:

\code{f <- function(x) sqrt(sum((x-mean(x))^2) / length(x))}

This is different than the sample standard deviation returned by \code{sd} (which uses \code{n-1} as denominator). 
}


\usage{
\S4method{min}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{max}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{range}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{prod}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{sum}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{any}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{all}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{nany}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{range}{SpatRaster}(x, ..., na.rm=FALSE)

\S4method{which.min}{SpatRaster}(x)

\S4method{which.max}{SpatRaster}(x)

\S4method{stdev}{SpatRaster}(x, ..., pop=TRUE, na.rm=FALSE)

\S4method{mean}{SpatRaster}(x, ..., trim=NA, na.rm=FALSE)

\S4method{median}{SpatRaster}(x, na.rm=FALSE, ...)

\S4method{anyNA}{SpatRaster}(x)

\S4method{countNA}{SpatRaster}(x, n=0)

\S4method{noNA}{SpatRaster}(x, falseNA=FALSE)

\S4method{allNA}{SpatRaster}(x, falseNA=FALSE)
}


\arguments{
  \item{x}{SpatRaster}
  \item{...}{additional SpatRasters or numeric values; and arguments \code{par} for parallel summarization (see Details), and \code{filename}, \code{overwrite} and \code{wopt} as for \code{\link{writeRaster}}}
  \item{na.rm}{logical. If \code{TRUE}, \code{NA} values are ignored. If \code{FALSE}, \code{NA} is returned if \code{x} has any \code{NA} values}
  \item{trim}{ignored}
  \item{pop}{logical. If \code{TRUE}, the population standard deviation is computed. Otherwise the sample standard deviation is computed}
  \item{falseNA}{logical. If \code{TRUE}, cells that would otherwise be \code{FALSE} are set to \code{NA}}
  \item{n}{integer. If \code{n > 0}, cell values are \code{TRUE} if at least \code{n} of its layers are \code{NA}}
}


\value{SpatRaster}

\details{
Additional argument \code{par} can be used for "parallel" summarizing a SpatRaster and a numeric or logical value. If a SpatRaster \code{x} has three layers, \code{max(x, 5)} will return a single layer (the number five is treated as a layer in which all cells have value five). In contrast \code{max(x, 5, par=TRUE)} returns three layers (the number five is treated as another SpatRaster with a single layer with all cells having the value five.
}


\seealso{\code{\link{app}}, \code{\link{Math-methods}}, \code{\link{modal}}, \code{\link{which.lyr}} }


\examples{
set.seed(0)
r <- rast(nrows=10, ncols=10, nlyrs=3)
values(r) <- runif(ncell(r) * nlyr(r))

x <- mean(r)
# note how this returns one layer
x <- sum(c(r, r[[2]]), 5)

# and this returns three layers
y <- sum(r, r[[2]], 5)

max(r)

## when adding a number, do you want 1 layer or all layers?
# 1 layer
max(r, 0.5)

# all layers
max(r, 0.5, par=TRUE)

y <- stdev(r)
# not the same as 
yy <- app(r, sd)

z <- stdev(r, r*2)

x <- mean(r, filename=paste0(tempfile(), ".tif"))


v <- values(r)
set.seed(3)
v[sample(length(v), 50)] <- NA
values(r) <- v
is.na(r)
anyNA(r)
allNA(r)
countNA(r)
countNA(r, 2)
}

\keyword{methods}
\keyword{spatial}

\name{nearest}

\docType{methods}

\alias{nearby}
\alias{nearby,SpatVector-method}
\alias{nearest}
\alias{nearest,SpatVector-method}

\title{nearby geometries}

\description{
Identify geometries that are near to each other. Either get the index of all geometries within a certain distance, or the k nearest neighbors, or (with \code{nearest}) get the nearest points between two geometries.
}

\usage{
\S4method{nearby}{SpatVector}(x, y=NULL, distance=0, k=1, centroids=TRUE, symmetrical=TRUE, method="geo")

\S4method{nearest}{SpatVector}(x, y, pairs=FALSE, centroids=TRUE, lines=FALSE, method="geo")
}

\arguments{
  \item{x}{SpatVector}
  \item{y}{SpatVector or NULL}
  \item{distance}{numeric. Maximum distance. Expressed in meters for lon/lat data (the geodesic distance is computed using \code{method}), and in the units of the CRS for projected data.}
  \item{k}{positive integer. number of neighbors. Ignored if \code{distance > 0}}
  \item{centroids}{logical. Should the centroids of polygons be used?}
  \item{symmetrical}{logical. If \code{TRUE}, a near pair is only included once. That is, if geometry 1 is near to geometry 3, the implied nearness between 3 and 1 is not reported. Ignored if \code{k} neighbors are returned}
  \item{method}{character. One of "geo", "haversine", "cosine". With "geo" the most precise but slower method of Karney (2003) is used. The other two methods are faster but less precise}  
  \item{pairs}{logical. If \code{TRUE} pairwise nearest points are returned (only relevant when using at least one SpatVector of lines or polygons}
  \item{lines}{logical. If \code{TRUE} lines between the nearest points instead of (the nearest) points }
}

\seealso{\code{\link{distance}}, \code{\link{relate}}, \code{\link{adjacent}}}

\value{
matrix
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
nearby(v, distance=12000)
}

\keyword{spatial}

\name{writeNetwork}

\docType{methods}

\alias{writeNetwork}
\alias{writeNetwork,SpatNetwork,character-method}

\title{Write a SpatNetwork to disk}

\description{
Write a \code{\link{SpatNetwork}} to disk as a GDAL Geographic Network Model (GNM) dataset. Use \code{\link{netw}(filename)} to read it back in.

A GNM dataset stores the network topology, the node and edge geometries, the edge weights, the directedness flag and the network's spatial reference in a self-contained directory (\code{filetype="GNMFile"}) or single OGR-compatible database (\code{filetype="GNMDatabase"}). It is the only widely-supported on-disk format that round-trips a topological network with both geometry and attributes.
}

\usage{
\S4method{writeNetwork}{SpatNetwork,character}(x, filename, filetype="GNMFile", overwrite=FALSE, options=NULL, ...)
}

\arguments{
\item{x}{\code{SpatNetwork}.}
\item{filename}{character. Path to write to. For \code{filetype="GNMFile"} this is the path of the network directory; the directory must not exist (or \code{overwrite=TRUE} must be passed). For \code{filetype="GNMDatabase"} this is the connection string of the underlying database.}
\item{filetype}{character. One of \code{"GNMFile"} (the default; a directory of small OGR layer files) or \code{"GNMDatabase"} (a single OGR-compatible database).}
\item{overwrite}{logical. If \code{TRUE} and \code{filename} already exists, it is removed before writing.}
\item{options}{character. Optional driver-specific creation options, formatted as \code{"NAME=VALUE"} (see the GDAL GNM driver documentation). Defaults to no options.}
\item{...}{additional arguments (currently ignored).}
}

\details{
A \code{"GNMFile"} dataset is a directory containing two "class" layers (\code{nodes} and \code{edges}) plus the GNM system layers (\code{_gnm_meta}, \code{_gnm_graph}, \code{_gnm_features}, \code{_gnm_srs.prj}). The default backend is ESRI Shapefile, so a freshly-written network is just a directory of \code{.shp}/\code{.dbf}/\code{.shx}/\code{.prj}/\code{.dbf} files plus the system files.

What round-trips through GNM and what doesn't:
\itemize{
\item Preserved exactly: node coordinates, edge geometries, the topology incidence list, the edge length cache, the edge weight cache, directedness, and the network's CRS.
\item Lost: \code{source_id} attribution and any user-attached columns on \code{net_edges()} or \code{net_nodes()} that go beyond the GNM-defined fields. (GNM has no concept of user attribute schemas on its class layers.)
}

GNM support requires GDAL \eqn{\geq} 2.4 built with the GNM component enabled. If your GDAL was built without GNM, this function fails with a message and \code{\link{netw}(filename)} cannot read GNM datasets back in.
}

\value{
Invisibly \code{TRUE} on success. On failure terra raises an error.
}

\seealso{
\code{\link{netw}}, \code{\link{shortestPath}}
}

\examples{
\dontrun{
v <- vect(rbind(
  "LINESTRING(0 0, 10 10)",
  "LINESTRING(0 10, 10 0)"
), crs = "EPSG:32633")
n <- netw(v)

dst <- file.path(tempdir(), "mynet")
writeNetwork(n, dst, overwrite = TRUE)

# Read back through netw():
n2 <- netw(dst)
}
}


\keyword{methods}
\keyword{spatial}

\name{as.character}

\docType{methods}

\alias{as.character,SpatExtent-method}
\alias{as.character,SpatRaster-method}


  
\title{Create a text representation of (the skeleton of) an object}

\description{
Create a text representation of (the skeleton of) an object
}

\usage{
\S4method{as.character}{SpatExtent}(x)

\S4method{as.character}{SpatRaster}(x)
}

\arguments{
  \item{x}{SpatRaster or SpatExtent}
}
 
\value{
character
}
  

\examples{
r <- rast()
r
as.character(r)

e <- ext(r)
e
as.character(e)
}

\keyword{spatial}

\name{has.z}

\docType{methods}

\alias{has.z}
\alias{has.z,SpatVector-method}


\title{Does a SpatVector have Z coordinates?}

\description{
Returns \code{TRUE} if any geometry part (or polygon hole) stores Z values.

Z storage is optional: empty Z means a conventional 2D geometry. When Z is
present it is included in \code{\link{geom}} and \code{\link{crds}}, preserved
by \code{\link{writeVector}} / \code{\link{vect}} file I/O (25D geometries),
and by coercion to/from \pkg{sf} (see also
\url{https://github.com/rspatial/terra/issues/824}).
}

\usage{
\S4method{has.z}{SpatVector}(x)
}

\arguments{
  \item{x}{SpatVector}
}

\value{
logical
}

\seealso{
 \code{\link{geom}, \link{crds}, \link{vect}}
}

\examples{
v <- vect(cbind(1:3, 1:3))
has.z(v)
}

\keyword{methods}
\keyword{spatial}

\name{gdal}

\alias{gdal}
\alias{libVersion}
\alias{gdalCache}
\alias{clearVSIcache}
\alias{getGDALconfig}
\alias{setGDALconfig}
\alias{unloadGDALdrivers}
\alias{proj_ok}
\alias{projNetwork}
\alias{projPaths}


\title{GDAL version, supported file formats, cache size, and PROJ coordinate transformation control}

\description{
Set the \code{GDAL} warning level or get a \code{data.frame} with the available GDAL drivers (file formats), or, if \code{warn=NA} and \code{drivers=FALSE}, you get the version numbers of one or all of the GDAL, PROJ and GEOS libraries. 

\code{GDAL} is the software library that terra builds on to read and write spatial data and for some raster data processing. \code{PROJ} is used for transformation of coordinates ("projection") and \code{GEOS} is used for geometric operations with vector data.

The current \code{GDAL} configuration options are obtained with \code{getGDALconfig} and changed with \code{setGDALconfig}. 

\code{proj_ok} checks if the PROJ database with CRS definitions can be found.

\code{projNetwork} controls whether PROJ can access network resources for coordinate transformations. By default, network access is enabled to provide high-accuracy grid-based datum transformations where available. When disabled, PROJ falls back to \href{https://proj.org/en/stable/glossary.html#term-Ballpark-transformation}{"ballpark transformations"} (of unknown accuracy) which could lead to errors of hundreds of meters in some cases. When enabled, PROJ downloads transformation grids from \code{https://cdn.proj.org}, requiring network connectivity and valid SSL certificates. After a successful run, the files are cached locally.

\code{projPaths} gets or sets the search paths that PROJ uses to find coordinate system definitions and transformation grids. This allows users to specify custom locations for PROJ data files, such as when using offline installations or custom grid files. By default, it operates on PROJ search paths, but can also set GDAL search paths when \code{with_proj=FALSE}.
}

\usage{
gdal(warn=NA, drivers=FALSE, ...)
gdalCache(size=NA)
setGDALconfig(option, value="")
getGDALconfig(option)
clearVSIcache()
libVersion(lib="all", parse=FALSE)
unloadGDALdrivers(x)
proj_ok()
projNetwork(enable, url="")
projPaths(paths, with_proj = TRUE)
}

\arguments{
  \item{warn}{If \code{NA} and \code{drivers=FALSE}, the version of the library specified by \code{lib} is returned. Otherwise, the value should be an integer between 1 and 4 representing the level of GDAL warnings and errors that are passed to R. 1 = warnings and errors; 2 = errors only (recoverable errors as a warning); 3 = irrecoverable errors only; 4 = ignore all errors and warnings. The default setting is 2}
  \item{drivers}{logical. If \code{TRUE} a data.frame with the raster and vector data formats that are available.} 
  \item{...}{additional arguments (for backwards compatibility only)}  
  \item{size}{numeric. The new cache size in MB}  
  \item{option}{character. GDAL configuration option name, or a "name=value" string (in which case the value argument is ignored}
  \item{value}{character. value for GDAL configuration option. Use "" to reset it to its default value}
  \item{lib}{character. "gdal", "proj", "geos", "TBB", or any other value to get the versions numbers of the first three and a logical value indicating whether TBB paralellization is available}
  \item{parse}{logical. Should the version be parsed into three numerical values (major, minor and sub versions)?}
  \item{x}{character. Drivers names such as "GTiff" to be unloaded. Or "" to reload all drivers}
  \item{enable}{logical. If \code{TRUE}, enable PROJ network access for high-accuracy grid-based transformations. If \code{FALSE}, disable network access and use ballpark transformations. If missing, return the current network status}
  \item{url}{character. Optional URL for PROJ network endpoint. If empty string (default), uses PROJ's default network settings (\code{https://cdn.proj.org})}
  \item{paths}{character. Vector of file paths to directories containing PROJ data files. If missing, returns the current search paths}
  \item{with_proj}{logical. If \code{TRUE} (default), set PROJ search paths. If \code{FALSE}, set GDAL search paths}
}


\seealso{\code{\link{describe}} for file-level metadata "GDALinfo"}

\value{
character vector in most cases. 
}

\examples{
gdal()
gdal(2)
#head(gdal(drivers=TRUE))
libVersion("all", TRUE)
projNetwork()
projPaths()
projPaths(c("/custom/proj/path"))
}

\note{
While some spatial analyses may not be greatly affected by PROJ network settings (ballpark vs. grid-based transformations), the differences can be significant, especially when a transformation involves a shift in datum between different coordinate reference systems. For applications requiring high positional accuracy, ensure network access is enabled or grids are locally available. Grids can be pre-downloaded using the \code{projsync} utility or installed via system packages, such as \code{proj-data} on Ubuntu/Debian systems. Downloaded grids are cached locally and then reused for subsequent transformations. 

On Windows, PROJ network access may fail with SSL certificate errors (e.g. "schannel: CertGetCertificateChain trust error"). If you see these warnings during \code{\link{project}} operations, you can use \code{projNetwork(FALSE)} to disable network access and silence them. To fix the underlying SSL issue, ensure your system's certificate store is up to date, or install the required PROJ datum grids locally.
}

\keyword{spatial}

\name{approximate}

\docType{methods}

\alias{approximate}
\alias{approximate,SpatRaster-method}

\title{Estimate values for cell values that are \code{NA} by interpolating between layers}

\description{
approximate uses the \code{stats} function \code{\link{approx}} to estimate values for cells that are \code{NA} by interpolation across layers. Layers are considered equidistant, unless argument \code{z} is used, or \code{time(x)} returns values that are not \code{NA}, in which case these values are used to determine distance between layers.

For estimation based on neighboring cells see \code{\link{focal}}
}

\usage{
\S4method{approximate}{SpatRaster}(x, method="linear", yleft, yright,
            rule=1, f=0, ties=mean, z=NULL, NArule=1,filename="",  ...) 
}

\arguments{
  \item{x}{SpatRaster}
  \item{method}{specifies the interpolation method to be used. Choices are "linear" or "constant" (step function; see the example in \code{\link{approx}}}
  \item{yleft}{the value to be returned before a non-\code{NA} value is encountered. The default is defined by the value of rule given below}
  \item{yright}{the value to be returned after the last non-\code{NA} value is encountered. The default is defined by the value of rule given below}
  \item{rule}{an integer (of length 1 or 2) describing how interpolation is to take place at for the first and last cells (before or after any non-\code{NA} values are encountered). If rule is 1 then NAs are returned for such points and if it is 2, the value at the closest data extreme is used. Use, e.g., \code{rule = 2:1}, if the left and right side extrapolation should differ}
  \item{f}{for method = "constant" a number between 0 and 1 inclusive, indicating a compromise between left- and right-continuous step functions. If y0 and y1 are the values to the left and right of the point then the value is \code{y0*(1-f)+y1*f} so that \code{f = 0)} is right-continuous and \code{f = 1} is left-continuous}
  \item{ties}{Handling of tied 'z' values. Either a function with a single vector argument returning a single number result or the string "ordered"}
  \item{z}{numeric vector to indicate the distance between layers (e.g., depth). The default is \code{time(x)} if these are not \code{NA} or else \code{1:nlys(x)}  }  
  \item{NArule}{single integer used to determine what to do when only a single layer with a non-\code{NA} value is encountered (and linear interpolation is not possible). The default value of 1 indicates that all layers will get this value for that cell; all other values do not change the cell values}  
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{ \code{ \link{focal}}, \code{\link{fillTime}} } 


\examples{
r <- rast(ncols=5, nrows=5)
r1 <- setValues(r, runif(ncell(r)))
r2 <- setValues(r, runif(ncell(r)))
r3 <- setValues(r, runif(ncell(r)))
r4 <- setValues(r, runif(ncell(r)))
r5 <- setValues(r, NA)
r6 <- setValues(r, runif(ncell(r)))
r1[6:10] <- NA
r2[5:15] <- NA
r3[8:25] <- NA
s <- c(r1,r2,r3,r4,r5,r6)
s[1:5] <- NA
x1 <- approximate(s)
x2 <- approximate(s, rule=2)
x3 <- approximate(s, rule=2, z=c(1,2,3,5,14,15))

}

\keyword{spatial}

\name{relate}

\docType{methods}

\alias{relate}
\alias{is.related}

\alias{relate,SpatVector,SpatVector-method}
\alias{relate,SpatVector,missing-method}
\alias{relate,SpatVector,SpatExtent-method}
\alias{relate,SpatExtent,SpatVector-method}
\alias{relate,SpatExtent,SpatExtent-method}
\alias{relate,SpatVector,SpatRaster-method}
\alias{relate,SpatRaster,SpatVector-method}
\alias{relate,SpatExtent,SpatRaster-method}
\alias{relate,SpatRaster,SpatExtent-method}
\alias{relate,SpatRaster,SpatRaster-method}

\alias{is.related,SpatVector,SpatVector-method}
\alias{is.related,SpatVector,SpatExtent-method}
\alias{is.related,SpatExtent,SpatVector-method}
\alias{is.related,SpatVector,SpatRaster-method}
\alias{is.related,SpatRaster,SpatVector-method}
\alias{is.related,SpatRaster,SpatRaster-method}
\alias{is.related,SpatExtent,SpatRaster-method}
\alias{is.related,SpatRaster,SpatExtent-method}


\title{ 
Spatial relationships between geometries
}

\description{
\code{relate} returns a logical matrix indicating the presence or absence of a specific spatial relationships between the geometries in \code{x} and \code{y}. 

\code{is.related} returns a logical vector indicating the presence or absence of a specific spatial relationships between \code{x} and any of the geometries in \code{y}.
}

\usage{
\S4method{relate}{SpatVector,SpatVector}(x, y, relation, pairs=FALSE, na.rm=TRUE)

\S4method{relate}{SpatVector,missing}(x, y, relation, pairs=FALSE, na.rm=TRUE)

\S4method{is.related}{SpatVector,SpatVector}(x, y, relation)
}

\arguments{
  \item{x}{SpatVector or SpatExtent}
  \item{y}{missing or as for \code{x}}
  \item{relation}{character. One of "intersects", "touches", "crosses", "overlaps", "within", "contains", "covers", "coveredby", "disjoint", or "equals". It can also be a "DE-9IM" string such as "FF*FF****". See \href{https://en.wikipedia.org/wiki/DE-9IM}{Wikipedia} or \href{https://docs.geotools.org/stable/userguide/library/jts/dim9.html}{GeoTools doc}}
  \item{pairs}{logical. If \code{TRUE} a two-column matrix is returned with the indices of the cases where the requested relation is \code{TRUE}. This is especially helpful when dealing with many geometries as the returned value is generally much smaller} 
  \item{na.rm}{logical. If \code{TRUE} and \code{pairs=TRUE}, geometries in \code{x} for which there is no related geometry in \code{y} are omitted}
} 

\value{
matrix (relate) or vector (is.related)
}

\seealso{
\code{\link{compareGeom}} to check if the geometries are identical (equivalent to the "equals" relation)

\code{\link{adjacent}}, \code{\link{nearby}}, \code{\link{intersect}}, \code{\link{crop}}
}

\examples{

# polygons
p1 <- vect("POLYGON ((0 0, 8 0, 8 9, 0 9, 0 0))")
p2 <- vect("POLYGON ((5 6, 15 6, 15 15, 5 15, 5 6))")
p3 <- vect("POLYGON ((8 2, 9 2, 9 3, 8 3, 8 2))")
p4 <- vect("POLYGON ((2 6, 3 6, 3 8, 2 8, 2 6))")
p5 <- vect("POLYGON ((2 12, 3 12, 3 13, 2 13, 2 12))")
p6 <- vect("POLYGON ((10 4, 12 4, 12 7, 11 7, 11 6, 10 6, 10 4))")

p <- rbind(p1, p2, p3, p4, p5, p6)
plot(p, col=rainbow(6, alpha=.5))
lines(p, lwd=2)
text(p)

## relate SpatVectors
relate(p1, p2, "intersects")
relate(p1, p3, "touches")
relate(p1, p5, "disjoint")
relate(rbind(p1, p2), p4, "disjoint")

## relate geometries within SpatVectors
# which are completely separated?
relate(p, relation="disjoint")

# which touch (not overlap or within)?
relate(p, relation="touches")
# which overlap (not merely touch, and not within)?
relate(p, relation="overlaps")
# which are within (not merely overlap)?
relate(p, relation="within")

# do they touch or overlap or are within?
relate(p, relation="intersects")

all(relate(p, relation="intersects") == 
  (relate(p, relation="overlaps") | 
   relate(p, relation="touches") |
   relate(p, relation="within")))

#for polygons, "coveredby" is "within"
relate(p, relation="coveredby")

# polygons, lines, and points 

pp <- rbind(p1, p2)
L1 <- vect("LINESTRING(1 11, 4 6, 10 6)")
L2 <- vect("LINESTRING(8 14, 12 10)")
L3 <- vect("LINESTRING(1 8, 12 14)")
lns <- rbind(L1, L2, L3)
pts <- vect(cbind(c(7,10,10), c(3,5,6)))

plot(pp, col=rainbow(2, alpha=.5))
text(pp, paste0("POL", 1:2), halo=TRUE)
lines(pp, lwd=2)
lines(lns, col=rainbow(3), lwd=4)
text(lns, paste0("L", 1:3), halo=TRUE)
points(pts, cex=1.5)
text(pts, paste0("PT", 1:3), halo=TRUE, pos=4)


relate(lns, relation="crosses")
relate(lns, pp, relation="crosses") 
relate(lns, pp, relation="touches") 
relate(lns, pp, relation="intersects") 

relate(lns, pp, relation="within")
# polygons can contain lines or points, not the other way around
relate(lns, pp, relation="contains") 
relate(pp, lns, relation="contains") 
# points and lines can be covered by polygons
relate(lns, pp, relation="coveredby")

relate(pts, pp, "within")
relate(pts, pp, "touches")
relate(pts, lns, "touches")

}


\keyword{methods}
\keyword{spatial}

\docType{methods}
\name{NIDP}

\alias{NIDP}
\alias{NIDP,SpatRaster-method}


\title{Number of immediate adjacent cells flowing into each cell}

\description{
Compute the number of immediate adjacent cells flowing into each cell
}

\usage{
\S4method{NIDP}{SpatRaster}(x, filename="",...) 
}

\arguments{
  \item{x}{SpatRaster with flow-direction. see \code{\link{terrain}}}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{ 
SpatRaster
}

\details{
NDIP is computed first to compute flow-accumulation with the algorithm by Zhou at al, 2019. 
}




\references{
Zhou, G., Wei, H. & Fu, S. A fast and simple algorithm for calculating flow accumulation matrices from raster digital elevation. Front. Earth Sci. 13, 317–326 (2019). https://doi.org/10.1007/s11707-018-0725-9
\url{https://link.springer.com/article/10.1007/s11707-018-0725-9}
}



\seealso{\code{\link{flowAccumulation}}}

\author{Emanuele Cordano }

\examples{

elev1 <- array(NA,c(9,9))
elev2 <- elev1
dx <- 1
dy <- 1 
for (r in 1:nrow(elev1)) {
  y <- (r-5)*dx
  for (c in 1:ncol(elev1)) {
    
    x <- (c-5)*dy
    elev1[r,c] <- 5*(x^2+y^2)
    elev2[r,c] <- 10+5*(abs(x))-0.001*y ### 5*(x^2+y^2)
  }
} 


## Elevation Raster 
elev1 <- rast(elev1)
elev2 <- rast(elev2)

t(array(elev1[],rev(dim(elev1)[1:2])))
t(array(elev2[],rev(dim(elev2)[1:2])))

plot(elev1)
plot(elev2)

## Flow Direction Raster
flowdir1<- terrain(elev1,v="flowdir")
flowdir2<- terrain(elev2,v="flowdir")


t(array(flowdir1[],rev(dim(flowdir1)[1:2])))
t(array(flowdir2[],rev(dim(flowdir2)[1:2])))

plot(flowdir1)
plot(flowdir2)

## 
nidp1 <- NIDP((flowdir1))
nidp2 <- NIDP((flowdir2))

t(array(nidp1[],rev(dim(nidp1)[1:2])))
t(array(nidp2[],rev(dim(nidp2)[1:2])))

plot(nidp1)
plot(nidp2)

}



\keyword{spatial}

\name{transpose}

\docType{methods}

\alias{t}
\alias{t,SpatRaster-method}
\alias{t,SpatVector-method}
\alias{trans}
\alias{trans,SpatRaster-method}
  
\title{Transpose}

\description{
Transpose a SpatRaster or SpatVector
}

\usage{
\S4method{t}{SpatRaster}(x)

\S4method{t}{SpatVector}(x)

\S4method{trans}{SpatRaster}(x, filename="", ...)
}

\arguments{
 \item{x}{SpatRaster or SpatVector}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{ \code{\link{flip}, \link{rotate}} }



\examples{
r <- rast(nrows=18, ncols=36)
values(r) <- 1:ncell(r)
tr1 <- t(r)
tr2 <- trans(r)
ttr <- trans(tr2)
}

\keyword{spatial}

\name{app}

\docType{methods}

\alias{app}
\alias{app,SpatRaster-method}
\alias{app,SpatRasterDataset-method}

\title{Apply a function to the cells of a SpatRaster}

\description{ 
Apply a function to the values of each cell of a SpatRaster. Similar to \code{\link[base]{apply}} -- think of each layer in a SpatRaster as a column (or row) in a matrix. 

This is generally used to summarize the values of multiple layers into one layer; but this is not required.

\code{app} calls function \code{fun} with the raster data as first argument. Depending on the function supplied, the raster data is represented as either a matrix in which each layer is a column, or a vector representing a cell. The function should return a vector or matrix that is divisible by ncell(x). Thus, both "sum" and "rowSums" can be used, but "colSums" cannot be used.

You can also apply a function \code{fun} across datasets by layer of a \code{SpatRasterDataset}. In that case, summarization is by layer across SpatRasters. 
}

\usage{
\S4method{app}{SpatRaster}(x, fun, ..., cores=1, filename="", overwrite=FALSE, wopt=list())

\S4method{app}{SpatRasterDataset}(x, fun, ..., cores=1, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
  \item{fun}{a function that operates on a vector or matrix. This can be a function that is defined in base-R or in a package, or a function you write yourself (see examples). Functions that return complex output (e.g. a list) may need to be wrapped in your own function to simplify the output to a vector or matrix. The following functions have been re-implemented in C++ for speed: "sum", "mean", "median", "modal", "which", "which.min", "which.max", "min", "max", "prod", "any", "all", "none", "sd", "std", "first". To use the base-R function for say, "min", you could use something like \code{fun=function(i) min(i)} or the equivalent \code{fun = \(i) min(i)}}
  \item{...}{additional arguments for \code{fun}. These are typically numerical constants. They should *never* be another SpatRaster}  
  \item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created and used. You can also supply a cluster object. Ignored for functions that are implemented by terra in C++ (see under fun)}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\details{
To speed things up, parallelization is supported, but this is often not helpful, and it may actually be slower. There is only a speed gain if you have many cores (> 8) and/or a very complex (slow) function \code{fun}. If you write \code{fun} yourself, consider supplying a \code{cppFunction} made with the Rcpp package instead (or go have a cup of tea while the computer works for you).
}

\seealso{ \code{\link{lapp}}, \code{\link{tapp}}, \code{\link[terra]{Math-methods}}, \code{\link{roll}}; \code{\link{global}} to summarize the values of a single SpatRaster }


\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- 1:ncell(r)
x <- c(r, sqrt(r), r+50)
s <- app(x, fun=sum)
s
# for a few generic functions like 
# "sum", "mean", and "max" you can also do
sum(x)

## SpatRasterDataset
sd <- sds(x, x*2, x/3)
a <- app(sd, max)
a
# same as 
max(x, x*2, x/3)
# and as (but slower)
b <- app(sd, function(i) max(i))


## also works for a single layer
f <- function(i) (i+1) * 2 * i + sqrt(i)
s <- app(r, f)
# same as above, but that is not memory-safe
# and has no filename argument 
s <- f(r)

\dontrun{
#### multiple cores 
test0 <- app(x, sqrt) 
test1 <- app(x, sqrt, cores=2)

testfun <- function(i) { 2 * sqrt(i) }
test2 <- app(x, fun=testfun, cores =2)

## this fails because testfun is not exported to the nodes
# test3 <- app(x, fun=function(i) testfun(i), cores=2)
## to export it, add it as argument to fun
test3 <- app(x, fun=function(i, ff) ff(i), cores =3, ff=testfun)
}
}


\keyword{methods}
\keyword{spatial}

\name{add_abline}

\alias{add_abline}

\title{add vertical and/or horizontal lines to a map made with terra}

\description{ 
Adaptation of \code{\link[graphics]{abline}} that allows adding a horizontal or vertical lines to a map. This function will place the lines in the locations within the mapped area as delineated by the axes. It is meant to be used when you specify your own tick marks, such that \code{\link{add_grid}} does not work.

Also see \code{\link{graticule}}
}

\usage{
add_abline(h=NULL, v=NULL, ...)
}

\arguments{
  \item{h}{the y-value(s) for horizontal line(s)}
  \item{v}{the x-value(s) for vertical line(s)}
  \item{...}{additional graphical parameters for drawing lines}
}

\seealso{\code{\link{add_grid}}, \code{\link{graticule}}, \code{\link{add_legend}}, \code{\link{add_box}}, \code{\link{add_grid}}, \code{\link{add_mtext}}}

\examples{
v <- vect(system.file("ex/lux.shp", package="terra"))
atx <- seq(xmin(v), xmax(v), .1)
aty <- seq(ymin(v), ymax(v), .1)
plot(v, pax=list(xat=atx, yat=aty), ext=ext(v)+.2)
add_abline(h=aty, v=atx, lty=2, col="gray")
}

\keyword{methods}
\keyword{spatial}

\name{NAflag}

\alias{NAflag<-}
\alias{NAflag}
\alias{NAflag,SpatRaster-method}
\alias{NAflag<-,SpatRaster-method}


\title{Set the NA flag}

\description{
The main purpose of this method is to allow correct reading of a SpatRaster that is based on a file that has an incorrect or missing NA flag. The file is not changed, but the flagged value is set to NA when values are read from the file. In contrast, if the cell values are in memory the change is made immediately. \code{NAflag} does *not* return the "NoData Value" that is stored in the file (use \code{\link{describe}} to find that value.

To change cell values, you can use \code{\link{classify}}
}

\usage{
\S4method{NAflag}{SpatRaster}(x)

\S4method{NAflag}{SpatRaster}(x)<-value
}

\arguments{
 \item{x}{SpatRaster}
 \item{value}{numeric. The value to be interpreted as NA; set this before reading the values from the file. This can be a single value, or multiple values, one for each data source (file / subdataset)}
}


\value{
none or numeric
}

\seealso{
 \code{\link{classify}}
}

\examples{ 
s <- rast(system.file("ex/logo.tif", package="terra"))[[1]]   
NAflag(s) <- 255
plot(s)
NAflag(s)
}

\keyword{ spatial }

\name{clamp}

\alias{clamp}
\alias{clamp,SpatRaster-method}
\alias{clamp,numeric-method}

\title{Clamp values}

\description{
Clamp values to a minimum and maximum value. That is, all values below a lower threshold value and above the upper threshold value become either \code{NA}, or, if \code{values=TRUE}, become the threshold value  
}

\usage{
\S4method{clamp}{SpatRaster}(x, lower=-Inf, upper=Inf, values=TRUE, filename="", ...)

\S4method{clamp}{numeric}(x, lower=-Inf, upper=Inf, values=TRUE, ...)
}

\arguments{
  \item{x}{SpatRaster or numeric vector}
  \item{lower}{numeric with the lowest acceptable value (you can specify a different value for each layer). Or a SpatRaster that has a single layer or the same number of layers as \code{x}}
  \item{upper}{numeric with the highest acceptable value (you can specify a different value for each layer). Or a SpatRaster that has a single layer or the same number of layers as \code{x}}
  \item{values}{logical. If \code{FALSE} values outside the clamping range become \code{NA}, if \code{TRUE}, they get the extreme values}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
object of the same class as \code{x}
}

\seealso{
\code{\link{classify}, \link{subst}}
}

\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- 1:ncell(r)
rc <- clamp(r, 25, 75) 
rc
}

\keyword{spatial}

\name{global}

\alias{global}

\alias{global,SpatRaster-method}

\title{global statistics}

\description{
Compute global statistics, that is summarized values of an entire SpatRaster. 

If \code{x} is very large \code{global} can fail, except when \code{fun} is one of these built-in functions "mean", "min", "max", "sum", "prod", "range" (min and max), "rms" (root mean square), "sd" (sample standard deviation), "std" (population standard deviation), "isNA" (number of cells that are NA), "notNA" (number of cells that are not NA), "anyNA", "anynotNA". Note that "anyNA" and "anynotNA" cannot be combined with other functions.

The reason that this can fail with large raster and a custom function is that all values need to be loaded into memory. To circumvent this problem you can run \code{global} with a sample of the cells.

You can compute a weighted mean or sum by providing a SpatRaster with weights.
}

\usage{
\S4method{global}{SpatRaster}(x, fun="mean", weights=NULL, maxcell=Inf, ...) 
}

\arguments{
  \item{x}{SpatRaster}
  \item{fun}{function to be applied to summarize the values by zone. Either as one or more of these built-in character values: "max", "min", "mean", "sum", "range", "rms" (root mean square), "sd", "std" (population sd, using \code{n} rather than \code{n-1}), "isNA", "notNA", "anyNA", "anynotNA"; or a proper R function (but these may fail for very large SpatRasters unless you specify \code{maxcell})}
  \item{...}{additional arguments passed on to \code{fun}}  
  \item{weights}{NULL or SpatRaster}  
  \item{maxcell}{positive integer used to take a regular sample of \code{x}. Ignored by the built-in functions.}  
}

\value{
A \code{data.frame} with a row for each layer
}


\seealso{\code{\link{zonal}} for "zonal" statistics, and \code{\link{app}} or \code{\link{Summary-methods}} for "local" statistics, and \code{\link{extract}} for summarizing values for polygons. Also see \code{\link{focal}} for "focal" or "moving window" operations.}


\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- 1:ncell(r)
global(r, "sum")
global(r, "mean", na.rm=TRUE)
x <- c(r, r/10)
global(x, c("sum", "mean", "sd"), na.rm=TRUE)

global(x, function(i) min(i) / max(i))
}

\keyword{spatial}

\name{scale}

\alias{scale}
\alias{scale,SpatRaster-method}


\title{Scale values}

\description{
Center and/or scale raster data. For details see \code{\link[base]{scale}} 
}

\usage{
\S4method{scale}{SpatRaster}(x, center=TRUE, scale=TRUE)
}


\arguments{
 \item{x}{SpatRaster}
 \item{center}{logical or numeric. If \code{TRUE}, centering is done by subtracting the layer means (omitting \code{NA}s), and if \code{FALSE}, no centering is done. If \code{center} is a numeric vector (recycled to \code{nlyr(x)}), then each layer of \code{x} has the corresponding value from center subtracted from it.}
  \item{scale}{logical or numeric. If \code{TRUE}, scaling is done by dividing the (centered) layers of \code{x} by their standard deviations if \code{center} is \code{TRUE}, and the root mean square otherwise. If scale is \code{FALSE}, no scaling is done. If \code{scale} is a numeric vector (recycled to \code{nlyr(x)}), each layer of \code{x} is divided by the corresponding value. Scaling is done after centering.}
}
 
\value{
SpatRaster
}


\seealso{ \code{\link{scale_linear}} }

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
s <- scale(r)

## the equivalent, computed in steps
m <- global(r, "mean")
rr <- r - m[,1]
rms <- global(rr, "rms")
ss <- rr / rms[,1]

}

\keyword{ spatial }

\name{Math-methods}

\docType{methods}

\alias{Math-methods}
\alias{Math2-methods}

\alias{Math,SpatRaster-method}
\alias{Math2,SpatRaster-method}

\alias{Math,SpatExtent-method}
\alias{Math2,SpatExtent-method}

\alias{Math2,SpatVector-method}

\alias{cumsum}
\alias{cumsum,SpatRaster-method}

\alias{log}
\alias{log,SpatRaster-method}
\alias{round}
\alias{round,SpatRaster-method}
\alias{round}
\alias{round,SpatVector-method}

\alias{sqrt}
\alias{sqrt,SpatRaster-method}

\alias{math}
\alias{math,SpatRaster-method}

\title{General mathematical methods}

\description{

Standard mathematical methods for computations with SpatRasters. Computations are local (applied on a cell by cell basis). If multiple SpatRasters are used, these must have the same extent and resolution. These have been implemented:
 
\code{abs, sign, sqrt, ceiling, floor, trunc,  cummax, cummin, cumprod, cumsum, log, log10, log2, log1p, acos, acosh, asin, asinh, atan, atanh, exp, expm1, cos, cosh, sin, sinh, tan, tanh, round, signif}

Instead of directly calling these methods, you can also provide their name to the \code{math} method. This is useful if you want to provide an output filename.

The following methods have been implemented for \code{SpatExtent}: \code{round, floor, ceiling}

\code{round} has also been implemented for \code{SpatVector}, to round the coordinates of the geometries. 

}

\usage{
\S4method{sqrt}{SpatRaster}(x)

\S4method{log}{SpatRaster}(x, base=exp(1))

\S4method{round}{SpatRaster}(x, digits=0)

\S4method{math}{SpatRaster}(x, fun, digits=0, filename="", overwrite=FALSE, ...)

\S4method{round}{SpatVector}(x, digits=4)

\S4method{cumsum}{SpatRaster}(x)
}

\seealso{
See \code{\link{app}} to use mathematical functions not implemented by the package, and \code{\link{Arith-methods}} for arithmetical operations. Use \code{\link{roll}} for rolling functions.
}


\arguments{
\item{x}{SpatRaster}
\item{base}{a positive or complex number: the base with respect to which logarithms are computed}
\item{digits}{Number of digits for rounding}
\item{fun}{character. Math function name}
\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
\item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster or SpatExtent
}



\examples{
r1 <- rast(ncols=10, nrows=10)
v <- runif(ncell(r1))
v[10:20] <- NA
values(r1) <- v
r2 <- rast(r1)
values(r2) <- 1:ncell(r2) / ncell(r2)
r <- c(r1, r2)

s <- sqrt(r)
# same as 
math(r, "sqrt")

round(s, 1)

cumsum(r)
}

\keyword{methods}
\keyword{math}
\keyword{spatial}

\name{quantile}

\docType{methods}

\alias{quantile}
\alias{quantile,SpatRaster-method}
\alias{quantile,SpatVector-method}

\title{Quantiles of spatial data}

\description{
Compute quantiles for each cell across the layers of a SpatRaster. 

You can use \code{\link{global}(x, fun=quantile)} to instead compute quantiles across cells for each layer.

You can also use this method to compute quantiles of the numeric variables of a SpatVector.
}

\usage{
\S4method{quantile}{SpatRaster}(x, probs=seq(0, 1, 0.25), na.rm=FALSE, filename="", ...) 

\S4method{quantile}{SpatVector}(x, probs=seq(0, 1, 0.25), ...) 
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{probs}{numeric vector of probabilities with values in [0,1]}  
  \item{na.rm}{logical. If \code{TRUE}, \code{NA}'s are removed from \code{x} before the quantiles are computed}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}  
}

\value{
SpatRaster with layers representing quantiles
}

\seealso{ \code{\link{app}}  }


\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
rr <- c(r/2, r, r*2)
qr <- quantile(rr)
qr

\dontrun{
# same but slower
qa <- app(rr, quantile)
}

#quantile by layer instead of by cell
qg <- global(r, quantile)
}

\keyword{methods}
\keyword{spatial}

\name{rasterize}

\docType{methods}

\alias{rasterize}
\alias{rasterize,SpatVector,SpatRaster-method}
\alias{rasterize,sf,SpatRaster-method}
\alias{rasterize,matrix,SpatRaster-method}
\alias{rasterize,data.frame,SpatRaster-method}

\title{Rasterize vector data}

\description{
Transfer values associated with the geometries of vector data to a raster
}

\usage{
\S4method{rasterize}{SpatVector,SpatRaster}(x, y, field="", fun, ..., background=NA, touches=FALSE, update=FALSE, 
	cover=FALSE, by=NULL, filename="", overwrite=FALSE, wopt=list())

\S4method{rasterize}{matrix,SpatRaster}(x, y, values=1, fun, ..., background=NA, update=FALSE, 
	by=NULL, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatVector or a two-column matrix (point coordinates) or data.frame}
  
  \item{y}{SpatRaster}
  
  \item{field}{character or numeric. If \code{field} is a character, it should be a variable name in \code{x}. If \code{field} is numeric it typically is a single number or a vector of length \code{nrow(x)}. The values are recycled to \code{nrow(x)}}

  \item{values}{typically a numeric vector of length \code{1} or \code{nrow(x)}. If the length is below \code{nrow(x)}, the values will be recycled to \code{nrow(x)}. Only used when \code{x} is a matrix. Can also be a matrix or data.frame}
  
  \item{fun}{summarizing function for when there are multiple geometries in one cell. For lines and polygons, you can only use \code{"min"}, \code{"max"}, \code{"mean"}, \code{"count"} and \code{"sum"}.
  For points you can use any function that returns a single number; for example \code{mean}, \code{length} (to get a count), \code{min} or \code{max}}
  
  \item{...}{additional arguments passed to \code{fun}}
  
  \item{background}{numeric. Value to put in the cells that are not covered by any of the features of \code{x}. Default is \code{NA}}
  
  \item{touches}{logical. If \code{TRUE}, all cells touched by lines or polygons are affected, not just those on the line render path, or whose center point is within the polygon. If \code{touches=TRUE}, \code{add} cannot be \code{TRUE}}

  \item{update}{logical. If \code{TRUE}, the values of the input SpatRaster are updated}
  
  \item{cover}{logical. If \code{TRUE} and the geometry of \code{x} is polygons, the fraction of a cell that is covered by the polygons is returned. This is estimated by determining presence/absence of the polygon in at least 100 sub-cells (more of there are very few cells)} 

  \item{by}{character or numeric value(s) to split \code{x} into multiple groups. There will be a separate layer for each group returned. If \code{x} is a SpatVector, \code{by} can be a column number or name. If \code{x} is a matrix, \code{by} should be a vector that identifies group membership for each row in \code{x}}

  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}  
  \item{wopt}{list with additional arguments for writing files as in \code{\link{writeRaster}}}
}

\seealso{
\code{\link{rasterizeGeom}}, \code{\link{rasterizeWin}}, \code{\link{mask}}
}


\value{
SpatRaster
}

\examples{
r <- rast(xmin=0, ncols=18, nrows=18)

# generate points
set.seed(1)
p <- spatSample(r, 1000, xy=TRUE, replace=TRUE)

# rasterize points as a matrix
x <- rasterize(p, r, fun=sum)
y <- rasterize(p, r, value=1:nrow(p), fun=max)

# rasterize points as a SpatVector
pv <- vect(p)
xv <- rasterize(pv, r, fun=sum)

# Polygons
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
r <- rast(v, ncols=75, nrows=100)
z <- rasterize(v, r, "NAME_2")
plot(z)
lines(v)
}

\keyword{spatial}

\name{has.geoloc}

\docType{methods}

\alias{has.geoloc}
\alias{has.geoloc,SpatRaster-method}
\alias{geoloc}
\alias{geoloc,SpatRaster-method}


\title{Geolocation arrays and GCPs}

\description{
Detect whether a SpatRaster source has GDAL geolocation arrays (e.g. satellite swath / curvilinear NetCDF) and/or Ground Control Points (GCPs), and report the associated spatial reference and array paths.

When a file has no conventional geotransform but does have a \code{GEOLOCATION} metadata domain (or GCPs), \code{\link{rast}} stores that information on the source and, if the dataset itself has no CRS, applies the geolocation/GCP CRS automatically so that \code{\link{project}} can use the arrays.
}

\usage{
\S4method{has.geoloc}{SpatRaster}(x)

\S4method{geoloc}{SpatRaster}(x)
}

\arguments{
  \item{x}{SpatRaster}
}

\value{
\code{has.geoloc}: logical, one value per raster data source.

\code{geoloc}: \code{data.frame} with one row per source and columns
\code{geolocation} (logical), \code{gcps} (logical), \code{srs} (character),
\code{x} / \code{y} (paths to the X/Y geolocation datasets when present).
}

\seealso{
 \code{\link{project}, \link{rectify}, \link{is.rotated}, \link{crs}}
}

\examples{
r <- rast(nrows=10, ncols=10)
has.geoloc(r)
geoloc(r)
}

\keyword{methods}
\keyword{spatial}

\name{netw}

\docType{methods}

\alias{SpatNetwork}
\alias{SpatNetwork-class}
\alias{netw}
\alias{netw,missing-method}
\alias{netw,SpatVector-method}
\alias{netw,igraph-method}
\alias{netw,character-method}
\alias{netw,SpatNetwork-method}
\alias{net_nodes}
\alias{net_nodes,SpatNetwork-method}
\alias{net_edges}
\alias{net_edges,SpatNetwork-method}
\alias{net_nnodes}
\alias{net_nnodes,SpatNetwork-method}
\alias{net_nedges}
\alias{net_nedges,SpatNetwork-method}
\alias{net_directed}
\alias{net_directed,SpatNetwork-method}
\alias{net_weights}
\alias{net_weights,SpatNetwork-method}
\alias{net_weights<-}
\alias{net_weights<-,SpatNetwork-method}
\alias{plot,SpatNetwork,missing-method}
\alias{show,SpatNetwork-method}
\alias{crs,SpatNetwork-method}
\alias{ext,SpatNetwork-method}
\alias{coerce,SpatVector,SpatNetwork-method}
\alias{coerce,igraph,SpatNetwork-method}
\alias{coerce,SpatNetwork,igraph-method}

\title{Build a SpatNetwork}

\description{
\code{netw} creates r a \code{SpatNetwork}, in the same spirit as \code{\link{vect}} for \code{SpatVector} or \code{\link{rast}} for \code{SpatRaster}. It dispatches on the class of its first argument:
\itemize{
  \item \code{netw()} -- an empty network.
  \item \code{netw(<SpatVector of lines>, ...)} -- builds a network by noding the input lines (every place where two lines cross becomes a node, the line pieces between consecutive nodes become edges). The full coordinate sequence between nodes is preserved.
  \item \code{netw(<igraph>, ...)} -- builds a network from an \code{igraph} object. Vertex attributes give the node coordinates; an optional \code{weight} edge attribute supplies edge weights. Edges become straight 2-point lines between their end nodes (igraph carries no edge geometry).
  \item \code{netw(<filename>, ...)} -- reads a network from disk. Currently only the GDAL Geographic Network Model (GNM) format is supported. Use \code{\link{writeNetwork}} for the write side.
  \item \code{netw(<SpatNetwork>, ...)} -- identity (returns the input unchanged).
}

The same coercions are also exposed via \code{methods::as}: \code{as(v, "SpatNetwork")}, \code{as(g, "SpatNetwork")}, \code{as(net, "igraph")}.

The accessors \code{net_nodes}, \code{net_edges}, \code{net_nnodes}, \code{net_nedges}, \code{net_directed} and \code{net_weights} return parts of the network as ordinary \code{SpatVector}s and primitives. .
}

\usage{
\S4method{netw}{missing}(x, ...)

\S4method{netw}{SpatVector}(x, snap=0, merge=TRUE, directed=FALSE, weights=TRUE, ...)

\S4method{netw}{igraph}(x, x_attr="x", y_attr="y", weight_attr="weight", crs=NULL, ...)

\S4method{netw}{character}(x, ...)

\S4method{netw}{SpatNetwork}(x, ...)

\S4method{net_nodes}{SpatNetwork}(x, ...)
\S4method{net_edges}{SpatNetwork}(x, ...)
\S4method{net_nnodes}{SpatNetwork}(x, ...)
\S4method{net_nedges}{SpatNetwork}(x, ...)
\S4method{net_directed}{SpatNetwork}(x, ...)
\S4method{net_weights}{SpatNetwork}(x, ...)
}

\arguments{
\item{x}{the input. For \code{netw}: a \code{SpatVector} of lines, an \code{igraph}, a filename pointing to a GNM dataset, an existing \code{SpatNetwork}, or missing (for an empty network). For the accessor methods: a \code{SpatNetwork}.}
\item{snap}{numeric. Snapping tolerance, in map units, for \code{netw,SpatVector-method}. If \code{> 0}, line endpoints (and other vertices) within \code{snap} of each other are coalesced before noding. Use this to repair small digitizing gaps in road centerlines. Default \code{0}.}
\item{merge}{logical. If \code{TRUE} (the default), runs of degree-2 shared endpoints are stitched back into single edges, so that only true junctions and dangling endpoints become nodes. Set \code{FALSE} to keep every endpoint of every input feature as a node (useful when the input has been pre-segmented and you want to preserve those breaks).}
\item{directed}{logical. If \code{TRUE}, the network is directed and the orientation of each edge (\code{from_node} \eqn{\to} \code{to_node}) is the legal travel direction. Use this for water flow or one-way streets. Default \code{FALSE}.}
\item{weights}{One of: \code{TRUE} (the default) to weight each edge by its geometric length (in meters when the CRS is lon/lat, otherwise in CRS units scaled to meters when the unit is known); \code{FALSE} for an unweighted network; a numeric vector of length \code{nedges} for custom edge weights; or a single character string giving the name of a numeric column of \code{x} -- in which case each output edge gets the column value of its source feature (with edges that could not be attributed falling back to their geometric length, with a warning).}
\item{x_attr, y_attr}{For \code{netw,igraph-method}: names of the vertex attributes giving node coordinates. Defaults match what \code{as(net, "igraph")} writes.}
\item{weight_attr}{For \code{netw,igraph-method}: name of the edge attribute to use as weights. Defaults to \code{"weight"} (the igraph convention).}
\item{crs}{character. For \code{netw,igraph-method}: optional CRS to assign to the \code{SpatNetwork}. If \code{NULL}, the \code{crs} graph attribute is used when present.}
\item{...}{additional arguments (currently ignored).}
}

\details{
The construction from a \code{SpatVector} uses GEOS to "node" the input: all input lines are merged and split at every interior crossing, and exactly-coincident pieces are dissolved. With \code{merge=TRUE}, runs of edges connected through degree-2 nodes are then re-fused into a single edge -- so a long road that was digitized as many short segments shows up as one edge per stretch between real junctions.

Per-edge attribute forwarding: each output edge is associated with the first input feature whose geometry covers the edge midpoint (within \code{snap}, or a small fraction of the bounding box if \code{snap == 0}). The 1-based row index of that input feature is stored as the \code{source_id} column on \code{net_edges()}, and the corresponding row of the input \code{data.frame} is copied into the edge attribute table. When \code{merge=TRUE}, an edge can span multiple source features that happened to be collinear and connected; only one source's attributes are forwarded in that case.

\code{net_nodes()} returns a \code{SpatVector} of points, one per node, with a \code{degree} column (number of incident edges). For directed networks, \code{in_degree} and \code{out_degree} columns are added.

\code{net_edges()} returns a \code{SpatVector} of lines, one per edge, with columns \code{from_node}, \code{to_node}, \code{source_id}, \code{length} (cached geometric length, in meters for lon/lat) and -- when the network is weighted -- a \code{weight} column. Any forwarded source attributes follow.

\code{net_weights(net)} returns the per-edge weights (or \code{NULL} for unweighted networks). \code{net_weights(net) <- v} replaces the weights with a numeric vector of length \code{net_nedges(net)}; setting it to \code{NULL} marks the network as unweighted.

For the \code{igraph} entry point: forward (\code{SpatNetwork -> igraph}) preserves topology, directedness, edge weights, node coordinates (as vertex attributes \code{x} and \code{y}), additional edge columns from \code{net_edges()}, and the CRS (WKT2, on the graph attribute \code{crs}). Reverse (\code{igraph -> SpatNetwork}) is intentionally lossy: each output edge becomes a straight 2-point line between its end nodes since igraph carries no edge geometry. The \code{igraph} package is a Suggested dependency of terra; install it before calling these methods.
}

\value{
A \code{SpatNetwork} for \code{netw}; a \code{SpatVector} for \code{net_nodes}/\code{net_edges}; an integer for \code{net_nnodes}/\code{net_nedges}; logical for \code{net_directed}; numeric (or \code{NULL}) for \code{net_weights}.
}

\seealso{\code{\link{shortestPath}}, \code{\link{writeNetwork}}}

\examples{
# Two crossing roads
a <- vect("LINESTRING(0 0, 10 10)", crs="local")
b <- vect("LINESTRING(0 10, 10 0)", crs="local")
roads <- rbind(a, b)
roads$name <- c("A", "B")

net <- netw(roads)
net
net_nnodes(net)   # 5: 4 ends + 1 crossing
net_nedges(net)   # 4: each road is split in two
net_weights(net)  # length-based, all sqrt(50)

# Directed network (e.g. a stream network: from_node -> to_node is downstream)
streams <- netw(roads, directed=TRUE)
net_directed(streams)
net_nodes(streams)  # in_degree, out_degree columns appear

# Custom weights
net_weights(net) <- net_weights(net) * 1.5

# Coercion via setAs
net2 <- as(roads, "SpatNetwork")

\dontrun{
# igraph round-trip (requires igraph)
g    <- as(net, "igraph")
back <- netw(g)        # or as(g, "SpatNetwork")
}

# Plot
plot(net)
}


\keyword{methods}
\keyword{spatial}

\name{mem}

\alias{mem_info}
\alias{free_RAM}


\title{Memory available and needed}

\description{
\code{mem_info} prints the amount of RAM that is required and available to process a SpatRaster. 

\code{free_RAM} returns the amount of RAM that is available
}

\usage{
mem_info(x, n=1, print=TRUE)

free_RAM()
}

\arguments{
  \item{x}{SpatRaster}
  \item{n}{positive integer. The number of copies of \code{x} that are needed}
  \item{print}{logical. print memory info?}
}


\value{
free_RAM returns the amount of available RAM in kilobytes
}

\examples{
mem_info(rast())

free_RAM()
}

\keyword{spatial}

\name{aggregate}

\docType{methods}

\alias{aggregate}
\alias{aggregate,SpatRaster-method}
\alias{aggregate,SpatVector-method}

\title{Aggregate raster or vector data}

\description{
Aggregate a SpatRaster to create a new SpatRaster with a lower resolution (larger cells). Aggregation groups rectangular areas to create larger cells. The value for the resulting cells is computed with a user-specified function. 
See \code{\link{resample}} for aggregating cells with a factor that is not an integer.

You can also aggregate ("dissolve") a SpatVector. This either combines all geometries into one geometry, or it combines the geometries that have the same value for the variable(s) specified with argument \code{by}.
}

\usage{
\S4method{aggregate}{SpatRaster}(x, fact=2, fun="mean", ..., cores=1, filename="", overwrite=FALSE, wopt=list())

\S4method{aggregate}{SpatVector}(x, by=NULL, dissolve=TRUE, fun="mean", count=TRUE, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{fact}{positive integer. Aggregation factor expressed as number of cells in each direction (horizontally and vertically). Or two integers (vertical (fact[1]) and horizontal (fact[2]) aggregation factor) or three integers (when also aggregating over layers)}  
  \item{fun}{function used to aggregate values. Either an actual function, or for the following, their name: "mean", "max", "min", "median", "sum", "modal", "any", "all", "none", "prod", "which.min", "which.max", "table", "sd" (sample standard deviation) and "std" (population standard deviation)}
  \item{...}{additional arguments passed to \code{fun}, such as \code{na.rm=TRUE}}  
  \item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created. Ignored for C++ level implemented functions that are listed under \code{fun}}  
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
  \item{by}{character. The variable(s) used to group the geometries}
  \item{dissolve}{logical. Should borders between aggregated geometries be dissolved?} 
  \item{count}{logical. If \code{TRUE} and \code{by} is not \code{NULL}, a variable "agg_n" is included that shows the number of input geometries for each output geometry}
}


\details{
Aggregation starts at the upper-left end of a SpatRaster. If a division of the number of columns or rows with \code{factor} does not return an integer, the extent of the resulting SpatRaster will be somewhat larger than that of the original SpatRaster. For example, if an input SpatRaster has 100 columns, and \code{fact=12}, the output SpatRaster will have 9 columns and the maximum x coordinate of the output SpatRaster is also adjusted.
  
The function \code{fun} should take multiple numbers, and return one or more numeric values. If multiple numbers are returned, the length of the returned vector should always be the same, also, for example, when the input is only NA values. For that reason, \code{range} works, but \code{unique} will fail in most cases. 
}

\seealso{\code{\link{disagg}} to disaggregate, and \code{\link{resample}} for more complex changes in resolution and alignment}

\value{
SpatRaster
}


\examples{
r <- rast()
# aggregated SpatRaster, no values
ra <- aggregate(r, fact=10)

values(r) <- runif(ncell(r))
# aggregated raster, max of the values
ra <- aggregate(r, fact=10, fun=max)

# aggregated raster, 'fact' parameter contains two values, max of the values
# same result as above
rb <- aggregate(r, fact=c(10,10), fun=max) 

# groups of 10 rows and 2 columns are combined into new cells
rc <- aggregate(r, fact=c(10,2), fun=max) 

# multiple layers
s <- c(r, r*2)
x <- aggregate(s, 20)


## SpatVector 
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
va <- aggregate(v, "ID_1")

plot(va, "NAME_1", lwd=5, plg=list(x="topright"), mar=rep(2,4))
lines(v, lwd=3, col="light gray")
lines(va)
text(v, "ID_1", halo=TRUE)
}

\keyword{methods}
\keyword{spatial}

\name{ifel}

\alias{ifel}
\alias{ifel,SpatRaster-method}

\title{ifelse for SpatRasters}

\description{
Implementation of \code{\link[base]{ifelse}} for SpatRasters. This method allows for a concise expression of what can otherwise be achieved with a combination of \code{\link{classify}}, \code{\link{mask}}, and \code{\link{cover}}. 

\code{ifel} is an \code{R} equivalent to the \code{Con} method in ArcGIS (arcpy). 
}

\usage{
\S4method{ifel}{SpatRaster}(test, yes, no, filename="", ...)
}

\arguments{
  \item{test}{SpatRaster with logical (TRUE/FALSE) values}
  \item{yes}{SpatRaster or numeric}
  \item{no}{SpatRaster or numeric}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\examples{
r <- rast(nrows=5, ncols=5, xmin=0, xmax=1, ymin=0, ymax=1)
values(r) <- c(-10:0, NA, NA, NA, 0:10)

x <- ifel(r > 1, 1, r)
# same as 
a <- classify(r, cbind(1, Inf, 1))
# or
b <- app(r, fun=function(i) {i[i > 1] <- 1; i})
# or 
d <- clamp(r, -Inf, 1)
# or (not recommended for large datasets)
e <- r
e[e>1] <- 1

## other examples
f <- ifel(is.na(r), 100, r)

z <- ifel(r > -2 & r < 2, 100, 0)

# nested expressions
y <- ifel(r > 1, 1, ifel(r < -1, -1, r))

k <- ifel(r > 0, r+10, ifel(r < 0, r-10, 3))
}

\keyword{spatial}

\name{as.lines}

\docType{methods}

\alias{as.lines}

\alias{as.lines,SpatRaster-method}
\alias{as.lines,SpatVector-method}
\alias{as.lines,SpatExtent-method}
\alias{as.lines,matrix-method}

\title{Conversion to a SpatVector of lines}

\description{
Conversion of a SpatRaster, SpatVector or SpatExtent to a SpatVector of lines. 
}

\usage{
\S4method{as.lines}{SpatRaster}(x, na.rm=FALSE)

\S4method{as.lines}{SpatVector}(x)

\S4method{as.lines}{SpatExtent}(x, crs="")

\S4method{as.lines}{matrix}(x, crs="", segments=FALSE)
}


\arguments{
\item{x}{SpatRaster, SpatVector, SpatExtent or matrix. If \code{x} is a matrix it should have two columns for a single line, or four columns, where each row has the start and end coordinates (x, y) for lines}
\item{na.rm}{logical. Only show lines for cells that are not \code{NA}?}
\item{crs}{character. The coordinate reference system (see \code{\link{crs}})}
\item{segments}{logical. Should (poly-)lines or polygons be disaggregated into their line-segments? See \code{\link{disagg}}}
}

\value{
SpatVector
}

\seealso{
\code{\link{as.points}}, \code{\link{as.polygons}}
}


\examples{
r <- rast(ncols=2, nrows=2)
values(r) <- 1:ncell(r)

as.lines(r)

as.lines(ext(r), crs=crs(r))

p <- as.polygons(r)
as.lines(p)


## with a matrix
s <- cbind(1:5, 1:5)
e <- cbind(1:5, 0)

as.lines(s)
as.lines(cbind(s, e), "+proj=longlat")

}

\keyword{spatial}

\name{plot}

\docType{methods}

\alias{plot}
\alias{plot,SpatRaster,missing-method}
\alias{plot,SpatRaster,numeric-method}
\alias{plot,SpatRaster,character-method}

\alias{plot,SpatVector,missing-method}
\alias{plot,SpatVector,numeric-method}
\alias{plot,SpatVector,data.frame-method}
\alias{plot,SpatVector,character-method}
\alias{plot,SpatVectorProxy,missing-method}
\alias{plot,SpatVectorCollection,missing-method}
\alias{plot,SpatVectorCollection,numeric-method}

\title{Make a map}

\description{
Plot the values of a SpatRaster or SpatVector to make a map. 

See \code{\link{points}}, \code{\link{lines}} or \code{\link{polys}} to add a SpatVector to an existing map (or use argument \code{add=TRUE}).

There is a separate help file for plotting a \code{\link[=plot,SpatGraticule,missing-method]{SpatGraticule}} or \code{\link[=plot,SpatExtent,missing-method]{SpatExtent}}.
}

\usage{
\S4method{plot}{SpatRaster,numeric}(x, y=1, col, type=NULL, mar=NULL, legend=TRUE, axes=!add, plg=list(), pax=list(), 
    maxcell=500000, smooth=FALSE, range=NULL, fill_range=FALSE, levels=NULL, 
	all_levels=FALSE, breaks=NULL, breakby="eqint", fun=NULL, colNA=NULL, alpha=NULL,
	sort=FALSE,  reverse=FALSE, grid=FALSE, zebra=FALSE, ext=NULL, reset=FALSE,
	add=FALSE, buffer=FALSE, background=NULL, box=axes, clip=TRUE, overview=NULL, ...)

\S4method{plot}{SpatRaster,missing}(x, y, main, mar=NULL, nc, nr, maxnl=16, maxcell=500000, add=FALSE, 
	plg=list(), pax=list(), ...)

\S4method{plot}{SpatRaster,character}(x, y, ...)

\S4method{plot}{SpatVector,character}(x, y, col=NULL, type=NULL, mar=NULL, legend=TRUE, axes=!add, plg=list(), pax=list(), 
    main="", range=NULL, fill_range=FALSE, breaks=NULL, breakby="eqint", fun=NULL, 
	colNA=NA, alpha=NULL, grid=FALSE, zebra=FALSE, ext=NULL, sort=TRUE, reverse=FALSE, 
	nr, nc, add=FALSE, buffer=TRUE, background=NULL, box=axes, clip=TRUE, ...)

\S4method{plot}{SpatVector,numeric}(x, y, ...)

\S4method{plot}{SpatVector,missing}(x, y, values=NULL, ...)

\S4method{plot}{SpatVectorCollection,missing}(x, y, main, mar=NULL, nc, nr, maxnl=16, col=NULL, ...)

\S4method{plot}{SpatVectorCollection,numeric}(x, y, main, mar=NULL, ext=NULL, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{y}{missing or positive integer or name indicating the layer(s) to be plotted}
  \item{col}{character vector to specify the colors to use. The default is \code{map.pal("viridis", 100)}. The default can be changed with the \code{terra.pal} option. For example: \code{options(terra.pal=terrain.colors(10))}. If \code{x} is a \code{SpatRaster} it can also be a \code{data.frame} with two columns (value, color) for a "classes" type legend or with three columns (from, to, color) for an "interval" type legend. If \code{x} is a \code{SpatVector} it can also be a \code{data.frame} with two columns (value, color) or a named vector (value=color) for a "classes" type legend. If \code{x} is a SpatVectorCollection, a list can be provided with colors for each SpatVector}
  \item{type}{character. Type of map/legend. One of "continuous", "classes", or "interval". If not specified, the type is chosen based on the data}
  \item{mar}{numeric vector of length 4 to set the margins of the plot (to make space for the legend). The default is (3.1, 3.1, 2.1, 7.1) for a single plot with a legend and (3.1, 3.1, 2.1, 2.1) otherwise. The default for a RGB raster is 0. Use \code{mar=NA} to not set the margins}
  \item{legend}{logical or character. If not \code{FALSE} a legend is drawn. The character value can be used to indicate where the legend is to be drawn. For example "topright" or "bottomleft". Use \code{plg} for more refined placement. Not supported for continuous legends (the default for raster data)}
  \item{axes}{logical. Draw axes?}
  \item{buffer}{logical. If \code{TRUE} the plotting area is made slightly larger than the extent of \code{x}}
  \item{background}{background color. Default is no color (white)}
  \item{box}{logical. Should a box be drawn around the map?}
  \item{clip}{logical. Should the axes be clipped to the extent of \code{x}?}
  \item{overview}{logical. Should "overviews" be used for fast rendering? This can result in much faster plotting of raster files that have overviews (e.g. "COG" format) and are accessed over a http connection. However, these overviews generally show aggregate values, thus reducing the range of the actual values. If \code{NULL}, the argument is set to \code{TRUE} for rasters that are accessed over http and \code{FALSE} in other cases}
 
 \item{plg}{list with parameters for drawing the legend. See the arguments for \code{\link[graphics]{legend}}. 
 
  A legend can be placed by specifying arguments \code{x} and \code{y}. For a continuous legend \code{y} can have two values. \code{x} can also be a SpatExtent. Furthermore, \code{x} can be a keyword such "topleft" and "bottomright" to place the legend at these locations inside the map rectangle. For a continuous legend, only the placement keywords "left", "right", "top", "bottom", "topright", "bottomright" are recognized; and when using these keywords, the legend is placed outside of the map rectangle. The placement of the legend can be altered with argument \code{nudge} that moves the location in the directions specified with one value (x direction) or two values (x, y). For a continuous legend it can also have four values (xmin, xmax, ymin, ymax). When supplying coordinates, use \code{horiz=TRUE} to get a horizontal legend.
    
  Additional parameters for continuous legends include: 

  \itemize{
	\item \code{digits} integer. The number of digits to print after the decimal point
    \item \code{size} to change the height and/or width; the defaults are \code{c(1,1)} 
	\item \code{at} to set the location of the tickmarks
	\item \code{format} as in \code{\link{formatC}} to format the numbers. For example, you can use \code{format="g"} for scientific notation. The default is \code{"f"}
	\item \code{tick} One of these partially matched values: "through", "in", "middle", "out", or "none", to choose a tickmark placement/length that is different from the default "throughout". 
	\item \code{tick.length} to change the tickmark length (default = 1). Only relevant when \code{tick} is "throughout" or "out".
	\item \code{tick.col}, \code{tick.box.col} and \code{tick.lwd} to change the appearance of the tickmarks
	\item \code{title} add a legend title
	\item \code{title.srt} to rotate the legend title
	\item \code{title.x} and \code{title.y} to place the legend title at specific coordinates  
	\item \code{bg} background color behind the legend (e.g. \code{"white"}) for visibility when drawn on top of a map
  }}
  
  \item{pax}{list with parameters for drawing axes. See the arguments for \code{\link{axis}}. Additional parameters include: 
  \itemize{
    \item \code{side} numeric to indicate for which of the axes to draw a line. Default is \code{1:4} (only noticeable when \code{box=FALSE}). 
    \item \code{tick} numeric to indicate for which of the axes to draw tickmarks. Default is \code{1:2} unless \code{side} is changed, in which case the default is the same as \code{side}
    \item \code{lab} numeric to indicate for which of the axes to draw labels. Default is \code{1:2} unless \code{side} is changed, in which case the default is the same as \code{side}
    \item \code{xat}/\code{yat} numeric with the values at which tickmarks are to be drawn on the horizontal/vertical axis.
    \item \code{xlabs}/\code{ylabs} this can either be a logical value specifying whether (numerical) annotations are to be made at the tickmarks, or a character or expression vector of labels to be placed at the tickmarks of the horizontal/vertical axis. 
    \item \code{retro} a logical value that can be set to \code{TRUE} to use a sexagesimal notation for the labels (degrees/minutes/hemisphere) instead of the standard decimal notation. For longitude/latitude data only. See \code{\link{graticule}} for projected data.
  }}
  
  \item{maxcell}{positive integer. Maximum number of cells to use for the plot}
  \item{smooth}{logical. If \code{TRUE} the cell values are smoothed (only if a continuous legend is used)}
  \item{range}{numeric. minimum and maximum values to be used for the continuous legend. You can use \code{NA} for one of these to only set the minimum or maximum value}
  \item{fill_range}{logical. If \code{TRUE}, values outside of \code{range} get the colors of the extreme values; otherwise they get colored as \code{NA}}
  \item{levels}{character. labels for the legend when \code{type="classes"} }
  \item{all_levels}{logical. If \code{TRUE}, the legend shows all levels of a categorical raster, even if they are not present in the data}
  \item{breaks}{numeric. Either a single number to indicate the number of breaks desired, or the actual breaks. When providing this argument, the default legend becomes "interval"}
  \item{breakby}{character or function. Either "eqint" for equal interval breaks, "cases" for equal quantile breaks. If a function is supplied, it should take a single argument (a vector of values) and create groups}
  \item{fun}{function to be called after plotting each SpatRaster layer to add something to each map (such as text, legend, lines). For example, with SpatVector \code{v}, you could do \code{fun=function() lines(v)}. The function may have one argument, representing the layer that is plotted (1 to the number of layers) }  
  \item{colNA}{character. color for the NA values}
  \item{alpha}{Either a single numeric between 0 and 1 to set the transparency for all colors (0 is transparent, 1 is opaque) or a SpatRaster with values between 0 and 1 to set the transparency by cell. To set the transparency for a given color, set it to the colors directly}
  \item{sort}{logical. If \code{TRUE} legends with categorical values are sorted. If \code{x} is a \code{SpatVector} you can also supply a vector of the unique values, in the order in which you want them to appear in the legend}
  \item{reverse}{logical. If \code{TRUE}, the legend order is reversed}
  \item{grid}{logical. If \code{TRUE} grid lines are drawn. Their properties such as type and color can be set with the \code{pax} argument. The grid is drawn first such that it is covered by \code{x}. See \code{\link{add_grid}} to add grid lines on top of the map}
  \item{zebra}{logical. If \code{TRUE} a "zebra-box" is added to the axes (ignored when \code{add=TRUE}). The width of the zebra-box can be set with additional argument \code{zebra.cex}. The colors can be changed with additional argument \code{zebra.col}}  
  \item{nc}{positive integer. Optional. The number of columns to divide the plotting device in (when plotting multiple layers)}
  \item{nr}{positive integer. Optional. The number of rows to divide the plotting device in (when plotting multiple layers)}
  \item{main}{character. Main plot titles (one for each layer to be plotted). You can use arguments \code{cex.main}, \code{font.main}, \code{col.main} to change the appearance; and \code{loc.main} to change the location of the main title (either two coordinates, or a character value such as "topleft"). You can also use \code{sub=""} for a subtitle. See \code{\link{title}}}
  \item{maxnl}{positive integer. Maximum number of layers to plot (for a multi-layer object).}
  \item{add}{logical. If \code{TRUE} add the object to the current plot}
  \item{ext}{SpatExtent or other object for which \code{\link{ext}} returns one. Can be use instead of xlim and ylim to set the extent of the plot}
  \item{reset}{logical. If \code{TRUE} the margins (see argument \code{mar}) are reset to what they were before calling plot; doing so may affect the display of additional objects that are added to the map (e.g. with  \code{\link{lines}})}
  \item{values}{Either a vector with values to be used for plotting or a two-column data.frame, where the first column matches a variable in \code{x} and the second column has the values to be plotted}
  \item{...}{arguments passed to \code{plot("SpatRaster", "numeric")} and additional graphical arguments}  
}

\seealso{
\code{\link{points}, \link{lines}, \link{polys}, \link{image}}

Add map elements: \code{\link{text}, \link{sbar}, \link{north}, \link{add_legend}, \link{add_box}}
 
plot a \code{\link[=plot,SpatGraticule,missing-method]{SpatGraticule}} or \code{\link[=plot,SpatExtent,missing-method]{SpatExtent}}, 

multiple layers: \code{\link{plotRGB}}, \code{\link{panel}}

other plot types: \code{\link[=plot,SpatRaster,SpatRaster-method]{scatterplot}, \link{hist}, \link{pairs}, \link{density}, \link{persp}, \link{contour}, \link{boxplot}, \link{barplot}} 
}

\examples{ 
## SpatRaster
f <- system.file("ex/elev.tif", package="terra") 
r <- rast(f)
plot(r)

plot(r, type="interval")

plot(r, plg=list(x=6.35, y = c(49.9, 50.1), title="Legend\nTitle", title.cex=0.9), 
		pax=list(side=1:4, retro=FALSE))
north(cbind(5.8, 50.1))	

d <- classify(r, c(100,200,300,400,500,600))
plot(d)

plot(d, type="interval", breaks=1:5) 
plot(d, type="interval", breaks=c(1,4,5), plg=list(legend=c("1-4", "4-5"))) 
plot(d, type="classes", xlim=c(5.6, 6.6), 
	plg=list(legend=c("Mr", "Xx", "As", "Zx", "Bb"), x="bottomleft"))


x <- trunc(r/200)
levels(x) <- data.frame(id=0:2, element=c("earth", "wind", "fire"))
plot(x, plg=list(x="topright"),mar=c(2,2,2,2))

oldpar <- par(no.readonly=TRUE)

# two plots with the same legend
dev.new(width=6, height=4, noRStudioGD = TRUE)
par(mfrow=c(1,2))
plot(r, range=c(50,600), mar=c(1,1,1,4))
plot(r/2, range=c(50,600), mar=c(1,1,1,4))

# as we only need one legend (also see the "panel" method):	
par(mfrow=c(1,2))
plot(r, range=c(50,600), mar=c(2, 2, 2, 2), plg=list(size=0.9, cex=.8), 
	pax=list(side=1:2, cex.axis=.6), box=FALSE)
#text(182500, 335000, "Two maps, one plot", xpd=NA)
plot(r/2, range=c(50,600), mar=c(2, 2, 2, 2), legend=FALSE, 
	pax=list(side=c(1,4), cex.axis=.6), box=FALSE)

par(oldpar)

# multi-layer with RGB
s <- rast(system.file("ex/logo.tif", package="terra"))   
s
plot(s)
# remove RGB
plot(s*1)
# or use layers
plot(s, 1)
plot(s, 1:3)

# fix legend by linking values and colors

x = rast(nrows = 2, ncols = 2, vals=1)
y = rast(nrows = 2, ncols = 2, vals=c(1,2,2,1))
cols = data.frame(id=1:2, col=c("red", "blue"))
plot(c(x,y), col=cols)

r  = rast(nrows=10, ncols=10, vals=1:100)
dr = data.frame(from=c(5,33,66,150), to=c(33, 66, 95,200), col=rainbow(4))
plot(r, col=dr)

### SpatVector 

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)

plot(v)

plot(v, "NAME_2", col=rainbow(12), border=c("gray", "blue"), lwd=3, zebra=TRUE)

plot(v, 2, pax=list(side=1:2), plg=list(x=6.16, y=50.17, cex=.8), xlim=c(5.7, 6.7))

plot(v, 4, pax=list(side=1:2), plg=list(x=6.2, y=50.2, ncol=2), main="", box=FALSE)
 
plot(v, 1, plg=list(x=5.8, y=49.37, horiz=TRUE, cex=1.1), main="", mar=c(5,2,0.5,0.5))

plot(v, density=1:12, angle=seq(18, 360, 20), col=rainbow(12))


plot(v, "AREA", type="interval", breaks=3, mar=c(3.1, 3.1, 2.1, 3.1),
  plg=list(x="topright"), main="")

plot(v, "AREA", type="interval", breaks=c(0,200,250,350), 
	mar=c(2,2,2,2), xlim=c(5.7, 6.75),
	plg=list(legend=c("<200", "200-250", ">250"), cex=1, bty="o", 
	x=6.3, y=50.15, box.lwd=2, bg="light yellow", title="My legend"))

}


\keyword{methods}
\keyword{spatial}

\name{as.raster}

\alias{as.raster}
\alias{as.raster,SpatRaster-method}
  
\title{Coerce to a "raster" object}

\description{
Implementation of the generic \code{\link[grDevices]{as.raster}} function to create a "raster" (small r) object. Such objects can be used for plotting with the \code{\link[graphics]{rasterImage}} function. NOT TO BE CONFUSED with the Raster* (big R) objects defined by the 'raster' package! 
}

\usage{
\S4method{as.raster}{SpatRaster}(x, maxcell=500000, col)
}


\arguments{
 \item{x}{ SpatRaster }
 \item{maxcell}{positive integer. Maximum number of cells to use for the plot}
 \item{col}{vector of colors. The default is \code{map.pal("viridis", 100)}}
}

 

\value{
'raster' object
}



\examples{
r <- rast(ncols=3, nrows=3)
values(r) <- 1:ncell(r)
as.raster(r)
}

\keyword{spatial}
\keyword{methods}

\name{perim}

\alias{perim}
\alias{perim,SpatVector-method}

\alias{perimeter}
\alias{perimeter,SpatVector-method}
  
\title{Perimeter or length}

\description{
This method returns the length of lines or the perimeter of polygons.

When the coordinate reference system is not longitude/latitude, you may get more accurate results by first transforming the data to longitude/latitude with \code{\link{project}}
}

\usage{
\S4method{perim}{SpatVector}(x)
}


\arguments{
  \item{x}{SpatVector}
}

\value{
numeric (m)
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
perim(v)
}

\keyword{methods}
\keyword{spatial}

\name{match}

\docType{methods}

\alias{match}
\alias{match,SpatRaster-method}
\alias{\%in\%}
\alias{\%in\%,SpatRaster-method}

\title{Value matching for SpatRasters}

\description{
\code{match} returns a SpatRaster with the position of the matched values. The cell values are the index of the table argument. 

\code{\%in\%} returns a 0/1 (FALSE/TRUE) SpatRaster indicating if the cells values were matched or not.

}

\usage{
match(x, table, nomatch = NA_integer_, incomparables = NULL)

x \%in\% table
}

\arguments{
 \item{x}{SpatRaster}
 \item{table}{vector of the values to be matched against}
 \item{nomatch}{the value to be returned in the case when no match is found. Note that it is coerced to integer}
 \item{incomparables}{a vector of values that cannot be matched. Any value in x matching a value in this vector is assigned the nomatch value. For historical reasons, FALSE is equivalent to NULL}
}

\value{
SpatRaster
}

\seealso{ \code{\link{app}, \link[base]{match}} }




\examples{
r <- rast(nrows=10, ncols=10)
values(r) <- 1:100
m <- match(r, c(5:10, 50:55))
n <- r \%in\% c(5:10, 50:55)
}

\keyword{spatial}
\keyword{methods}

\name{merge}

\docType{methods}

\alias{merge}
\alias{merge,SpatRaster,SpatRaster-method}
\alias{merge,SpatRasterCollection,missing-method}
\alias{merge,SpatVector,SpatVector-method}
\alias{merge,SpatVector,data.frame-method}

\title{ 
Merge SpatRasters, or merge a SpatVector with a data.frame
}

\description{
Merge multiple SpatRasters to create a new SpatRaster with a larger spatial extent. The SpatRasters should all have the same coordinate reference system. They should normally also have the same spatial origin and resolution, but automatic resampling can be done depending on the algorithm used (see argument \code{algo}). In areas where the SpatRasters overlap, the values of the SpatRaster that is first in the sequence of arguments (or in the SpatRasterCollection) will be retained (unless \code{first=FALSE}). 

There is also a method for merging SpatVector with a data.frame; that is, to join the data.frame to the attribute table of the SpatVector.

See \code{\link{classify}} to merge a SpatRaster with a \code{data.frame}.
}

\usage{
\S4method{merge}{SpatRaster,SpatRaster}(x, y, ..., first=TRUE, na.rm=TRUE, algo=1, resample=FALSE, method="", 
			filename="", overwrite=FALSE, wopt=list())

\S4method{merge}{SpatRasterCollection,missing}(x, first=TRUE, na.rm=TRUE, algo=1, resample=FALSE, method="", filename="", ...)

\S4method{merge}{SpatVector,data.frame}(x, y, ...)
}

\arguments{
  \item{x}{SpatRaster, SpatRasterCollection, or SpatVector}
  \item{y}{missing if \code{x} is a SpatRasterCollection. SpatRaster if \code{x} is a SpatRaster. data.frame if \code{x} is a SpatVector}
  \item{...}{if \code{x} is a SpatRaster: additional objects of the same class as \code{x}. If \code{x} is a SpatRasterCollection: options for writing files as in \code{\link{writeRaster}}. If \code{x} is a SpatVector, the same arguments as in \code{\link[base]{merge}}}
  \item{first}{logical. If \code{TRUE}, in areas where rasters overlap, the first value is used. Otherwise the last value is used}
  \item{na.rm}{logical. If \code{TRUE} missing values are are ignored. This is only used for algo 1; the other two always ignore missing values}
  \item{algo}{integer. You can use 1, 2 or 3 to pick a merge algorithm. algo 1 is generally faster than algo 2, but it may have poorer file compression. Algo 3 creates a virtual raster (see \code{\link{vrt}}). This is very quick and can be a good approach if the merge raster is used as input to a next step in the analysis. It allows any amount of misalignment and resamples without giving a warning. Otherwise its speed is similar to that of algo 2}
  \item{resample}{logical. If \code{TRUE} input rasters are resampled if they do not align (same origin and resolution) with the first raster}
  \item{method}{character. The resampling method used (only if \code{resample} is \code{TRUE} and \code{algo} is 1 or 2). One of "nearest", "bilinear", "cubic", "cubicspline", "lanczos", "average", "mode" as in \code{\link{resample}}. If the value is \code{""}, "nearest" is used for categorical rasters and "bilinear" for other rasters} 
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
} 


\value{
SpatRaster or SpatVector
}

\seealso{
Combining tiles with \code{\link{vrt}} may be more efficient than using \code{merge}. 

See \code{\link{mosaic}} for averaging or blending the values of overlapping regions.

See \code{\link{classify}} to merge a \code{SpatRaster} and a \code{data.frame} and \code{\link{union}} to combine SpatExtent objects. 
}


\examples{
x <- rast(xmin=-110, xmax=-80, ymin=40, ymax=70, res=1, vals=1)
y <- rast(xmin=-85, xmax=-55, ymax=60, ymin=30, res=1, vals=2)
z <- rast(xmin=-60, xmax=-30, ymax=50, ymin=20, res=1, vals=3)

m1 <- merge(x, y, z)
m2 <- merge(z, y, x)
m3 <- merge(y, x, z)
# panel(c(m1, m2, m3))

# if you have many SpatRasters, it may be convenient
# to make a SpatRasterCollection
# s <- sprc(list(x, y, z))
s <- sprc(x, y, z)

sm1 <- merge(s, algo=1, first=FALSE)
sm2 <- merge(s, algo=2, first=FALSE)
#sm3 <- merge(s, algo=3, first=FALSE)

## SpatVector with data.frame
f <- system.file("ex/lux.shp", package="terra")
p <- vect(f)
dfr <- data.frame(District=p$NAME_1, Canton=p$NAME_2, Value=round(runif(length(p), 100, 1000)))
dfr <- dfr[1:5, ]
pm <- merge(p, dfr, all.x=TRUE, by.x=c('NAME_1', 'NAME_2'), by.y=c('District', 'Canton'))
pm
values(pm)
}

\keyword{methods}
\keyword{spatial}

\name{query}

\docType{methods}

\alias{query}
\alias{query,SpatVectorProxy-method}


\title{Query a SpatVectorProxy object}

\description{
Query a SpatVectorProxy to extract a subset
} 

\usage{
\S4method{query}{SpatVectorProxy}(x, start=1, n=nrow(x), vars=NULL, where=NULL, 
    extent=NULL, filter=NULL, sql=NULL, dialect="", what="")
}

\arguments{
\item{x}{SpatVectorProxy}
\item{start}{positive integer. The record to start reading at}
\item{n}{positive integer. The number of records requested}
\item{vars}{character. Variable names. Must be a subset of \code{names(x)}}
\item{where}{character. expression like "NAME_1='California' AND ID > 3" , to subset records. Note that start and n are applied after executing the where statement}
\item{extent}{Spat* object. The extent of the object is used as a spatial filter to select the geometries to read. Ignored if \code{filter} is not \code{NULL}}
\item{filter}{SpatVector. Used as a spatial filter to select geometries to read (the convex hull is used for lines or points)}
\item{sql}{character. Arbitrary SQL statement. If used, arguments "start", "n", "vars" and "where" are ignored}
\item{what}{character indicating what to read. Either \code{""} for geometries and attributes, or \code{"geoms"} to only read the geometries, \code{"attributes"} to only read the attributes (that are returned as a data.frame)}
\item{dialect}{character. The SQL dialect to use (if any). For example: "SQLite"}
}

\seealso{\code{\link{vect}}}


\value{SpatVector}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f, proxy=TRUE)
v

x <- query(v, vars=c("ID_2", "NAME_2"), start=5, n=2)
x

query(v, vars=c("ID_2", "NAME_1", "NAME_2"), where="NAME_1='Grevenmacher' AND ID_2 > 6")

## with an extent
e <- ext(5.9, 6.3, 49.9, 50) 
x <- query(v, extent=e)

## with polygons
p <- as.polygons(e)
x <- query(v, filter=p)
x
}

\keyword{methods}
\keyword{spatial}

\name{agitate}

\docType{methods}

\alias{agitate}
\alias{agitate,SpatVector-method}
\alias{agitate,ANY-method}

\title{Add noise to (jitter) a SpatVector of points}

\description{
Add noise to (jitter) a SpatVector of points. Points are moved randomly within a specified distance.
}

\usage{
\S4method{agitate}{SpatVector}(x, maxdist)
}

\arguments{
  \item{x}{SpatVector. All other objects are passed to \code{\link{jitter}}}
  \item{maxdist}{positive number. The maximum distance from the original location, in meter for lon/lat, otherwise in the units of the CRS}
}

\value{
SpatVector
}

\examples{
## SpatVector
f <- system.file("ex/lux.shp", package="terra")
v <- as.points(vect(f)[1])
p <- agitate(v, 2500)
}

\keyword{spatial}

\name{snapTo}

\alias{snapTo}
\alias{snapTo,SpatVector,SpatVector-method}

\title{Snap points to the edge of lines or polygons}

\description{
Move the points in \code{x} onto the edge of the corresponding line or polygon in \code{y}.
A point that touches the the target geometry is not changed. A point that is outside the geometry is moved to the nearest location on the edge (the boundary of a polygon, or the line itself). 
}

\usage{
\S4method{snapTo}{SpatVector,SpatVector}(x, y, paired=TRUE, ...)
}

\arguments{
  \item{x}{SpatVector of points}
  \item{y}{SpatVector of lines or polygons. Either with the same number of geometries as there are points in \code{x}, or with a single geometry}
  \item{paired}{logical. If \code{TRUE} the points in \code{x} are paired with the geometries in \code{y} (point \code{i} with geometry \code{i}). \code{y} may instead have a single geometry, in which case all points are snapped to that geometry. Otherwise the points in \code{x} are snapped to any geometry in \code{y}}
  \item{...}{additional arguments. None implemented}
}

\value{
SpatVector of points
}

\seealso{\code{\link{nearest}}, \code{\link{distance}}, \code{\link{furdist}}}

\examples{
crs <- "+proj=utm +zone=1"
p <- vect("POLYGON ((0 0, 8 0, 8 9, 0 9, 0 0))", crs=crs)

# one point inside the polygon (unchanged), one outside (snapped to the edge)
pts <- vect(cbind(c(4, 12), c(4, 4)), crs=crs)
s <- snapTo(pts, p)
crds(s)

# snap to a line
L <- vect("LINESTRING (0 0, 10 0)", crs=crs)
q <- vect(cbind(c(5, 5), c(0, 3)), crs=crs)
crds(snapTo(q, L))
}

\keyword{spatial}

\name{activeCat}

\docType{methods}

\alias{activeCat}
\alias{activeCat,SpatRaster-method}
\alias{activeCat<-}
\alias{activeCat<-,SpatRaster-method}
  
  
\title{Active category}

\description{
Get or set the active category of a multi-categorical SpatRaster layer
}

\usage{
\S4method{activeCat}{SpatRaster}(x, layer=1)
\S4method{activeCat}{SpatRaster}(x, layer=1)<-value
}


\arguments{
  \item{x}{SpatRaster}
  \item{layer}{positive integer, the layer number or name}
  \item{value}{positive integer or character, indicating which column in the categories to use. Note that when a number is used this index is zero based, and "1" refers to the second column. This is because the first column of the categories has the cell values, not categorical labels}
}  

\value{
integer
}

\seealso{\code{\link{levels}}, \code{\link{cats}}}


\examples{
set.seed(0)
r <- rast(nrows=10, ncols=10)
values(r) <- sample(3, ncell(r), replace=TRUE) + 10
d <- data.frame(id=11:13, cover=c("forest", "water", "urban"), letters=letters[1:3], value=10:12)
levels(r) <- d

activeCat(r)
activeCat(r) <- 3
activeCat(r)
}

\keyword{methods}
\keyword{spatial}

\name{tmpFiles}

\alias{tmpFiles}

\title{Temporary files}

\description{
List and optionally remove temporary files created by the terra package. These files are created when an output SpatRaster may be too large to store in memory (RAM). This can happen when no filename is provided to a function and when using functions where you cannot provide a filename.

Temporary files are automatically removed at the end of each R session that ends normally. You can use \code{tmpFiles} to see the files in the current sessions, including those that are orphaned (not connect to a SpatRaster object any more) and from other (perhaps old) sessions, and remove all the temporary files. 
}

\usage{
tmpFiles(current=TRUE, orphan=FALSE, old=FALSE, remove=FALSE)
}

\arguments{
  \item{current}{logical. If \code{TRUE}, temporary files from the current R session are included}
  \item{orphan}{logical. If \code{TRUE}, temporary files from the current R session that are no longer associated with a SpatRaster (if \code{current} is \code{TRUE} these are also included)}
  \item{old}{logical. If \code{TRUE}, temporary files from other "R" sessions. Unless you are running multiple instances of R at the same time, these are from old (possibly crashed) R  sessions and should be removed}
  \item{remove}{logical. If \code{TRUE}, temporary files are removed}
}


\value{
character
}


\seealso{ \code{\link{terraOptions}} }  

\examples{
tmpFiles()
}

\keyword{ spatial }

\name{factors}

\docType{methods}

\alias{droplevels}
\alias{droplevels,SpatRaster-method}
\alias{levels}
\alias{levels,SpatRaster-method}
\alias{levels<-}
\alias{levels<-,SpatRaster-method}
\alias{cats}
\alias{cats,SpatRaster-method}
\alias{categories}
\alias{categories,SpatRaster-method}
\alias{addCats}
\alias{addCats,SpatRaster-method}
\alias{simplifyLevels}
\alias{simplifyLevels,SpatRaster-method}
\alias{combineLevels}
  
  
\title{Categorical rasters}

\description{

A SpatRaster layer can represent a categorical variable (factor). Like \code{\link{factor}}s, SpatRaster categories are stored as integers that have an associated label. 

The categories can be inspected with \code{levels} and \code{cats}. They are represented by a \code{data.frame} that must have two or more columns, the first one identifying the (integer) cell values and the other column(s) providing the category labels. 

If there are multiple columns with categories, you can set the "active" category to choose the one you want to use. 

\code{cats} returns the entire data.frame, whereas \code{levels} only return two columns: the index and the active category.

To set categories for the first layer of a SpatRaster, you can provide \code{levels<-} with a data.frame or a list with a data.frame. To set categories for multiple layers you can provide \code{levels<-} with a list with one element (that either has a \code{data.frame} or is \code{NULL}) for each layer. Use \code{categories} to set the categories for a specific layer or specific layers.

\code{droplevels} removes categories that are not used (declared but not present as values in the raster) if \code{levels=NULL}.

\code{simplifyLevels} combines duplicate levels into one.

\code{addCats} adds additional categories to a layer that already is categorical. It adds new variables, not new levels of an existing categorical variable.

\code{combineLevels} combines the levels of all layers of \code{x} and sets them to all layers. That fails if there are labeling conflicts between layers
}

\usage{
\S4method{levels}{SpatRaster}(x)

\S4method{levels}{SpatRaster}(x)<-value

\S4method{cats}{SpatRaster}(x, layer)

\S4method{categories}{SpatRaster}(x, layer=1, value, active=1, ...)

\S4method{droplevels}{SpatRaster}(x, level=NULL, layer=1)

\S4method{simplifyLevels}{SpatRaster}(x, filename="", overwrite=FALSE, ...)

\S4method{addCats}{SpatRaster}(x, value, merge=FALSE, layer=1)

combineLevels(x, assign=TRUE)
}


\arguments{
  \item{x}{SpatRaster}
  \item{layer}{the layer name or number (positive integer); or 0 for all layers}
  \item{value}{a data.frame (ID, category) that define the categories. Or \code{NULL} to remove them}
  \item{active}{positive integer, indicating the column in \code{value} to be used as the active category (zero based to skip the first column with the cell values; that is 1 is the second column in \code{value})}
  \item{level}{the categories to remove for the layer specified with \code{layer}}
  \item{merge}{logical. If \code{TRUE}, the categories are combined with \code{\link[base]{merge}} using the first column of \code{value} as ID. If \code{FALSE} the categories are combined with \code{cbind}}
  \item{assign}{logical. Assign the combined levels to all layers of \code{x}? If \code{FALSE}, the levels are returned}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}  


\value{
SpatRaster, data.frame, list of data.frames (levels, cats), or logical (is.factor)
}

\seealso{\code{\link{activeCat}}, \code{\link{catalyze}}, \code{\link{set.cats}}, \code{\link{as.factor}}, \code{\link{is.factor}}}

\examples{
set.seed(0)
r <- rast(nrows=10, ncols=10)
values(r) <- sample(3, ncell(r), replace=TRUE)
is.factor(r)

cls <- data.frame(id=1:3, cover=c("forest", "water", "urban"))
levels(r) <- cls
is.factor(r)
r

plot(r, col=c("green", "blue", "light gray"))
text(r, digits=3, cex=.75, halo=TRUE)

levels(r) <- data.frame(id=1:3, cover=c("forest", "water", "forest"))
levels(simplifyLevels(r))



# raster starts at 3
x <- r + 2
is.factor(x)

# Multiple categories
d <- data.frame(id=3:5, cover=cls[,2], letters=letters[1:3], value=10:12)
levels(x) <- d
x

# get current index
activeCat(x)
# set index 
activeCat(x) <- 3
activeCat(x)
activeCat(x) <- "letters"
plot(x, col=c("green", "blue", "light gray"))
text(x, digits=3, cex=.75, halo=TRUE)

r <- as.numeric(x)
r

p <- as.polygons(x)
plot(p, "letters", col=c("green", "blue", "light gray"))
}

\keyword{methods}
\keyword{spatial}

\name{lapp}

\docType{methods}

\alias{lapp}
\alias{lapp,SpatRaster-method}
\alias{lapp,SpatRasterDataset-method}

\title{Apply a function to layers of a SpatRaster, or sub-datasets of a SpatRasterDataset}

\description{
Apply a function to a SpatRaster, using layers as arguments.

The number of arguments in function \code{fun} must match the number of layers in the SpatRaster (or the number of sub-datasets in the SpatRasterDataset). For example, if you want to multiply two layers, you could use this function: \code{fun=function(x,y){return(x*y)}} percentage: \code{fun=function(x,y){return(100 * x / y)}}. If you combine three layers you could use \code{fun=function(x,y,z){return((x + y) * z)}}

Before you use the function, test it to make sure that it is vectorized. That is, it should work for vectors longer than one, not only for single numbers. Or if the input SpatRaster(s) have multiple layers, it should work for a matrix (multiple cells) of input data (or matrices in the case of a SpatRasterDataSet). The function must return the same number of elements as its input vectors, or multiples of that. Also make sure that the function is \code{NA}-proof: it should returns the same number of values when some or all input values are \code{NA}. And the function must return a vector or a matrix, not a \code{data.frame}. To test it, run it with \code{do.call(fun, data)} (see examples). 

Use \code{\link{app}} for summarize functions such as \code{sum}, that take any number of arguments; and \code{\link{tapp}} to do so for groups of layers. 
}

\usage{
\S4method{lapp}{SpatRaster}(x, fun, ..., usenames=FALSE, cores=1, filename="", overwrite=FALSE, wopt=list())

\S4method{lapp}{SpatRasterDataset}(x, fun, ..., usenames=FALSE, recycle=FALSE, 
		cores=1, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
  \item{fun}{a function that takes a vector and can be applied to each cell of \code{x}}
  \item{...}{additional arguments to be passed to \code{fun}} 
  \item{usenames}{logical. Use the layer names (or dataset names if \code{x} is a SpatRasterDataset) to match the function arguments? If \code{FALSE}, argument matching is by position}
  \item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created and used. You can also supply a cluster object. The benefit of using this option is often small, if it is even positive. Using a fast function \code{fun} can be a much more effective way to speed things up}
  \item{recycle}{logical. Recycle layers to match the subdataset with the largest number of layers}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{\code{ \link{app}, \link[terra]{tapp},  \link[terra]{math}} }

\note{
Use \code{\link{sapp}} or \code{lapply} to apply a function that takes a SpatRaster as argument to each layer of a SpatRaster (that is rarely necessary).
}

\examples{
s <- rast(system.file("ex/logo.tif", package="terra")) + 1  
ss <- s[[2:1]]

fvi <- function(x, y){ (x - y ) / (x + y) } 
# test the function
data <- list(c(1:5,NA), 6:1)
do.call(fvi, data)

x <- lapp(ss, fun=fvi )

# which is the same as supplying the layers to "fun"
# in some cases this will be much faster 
y <- fvi(s[[2]], s[[1]])

f2 <- function(x, y, z){ (z - y + 1) / (x + y + 1) } 
p1 <- lapp(s, fun=f2 )

p2 <- lapp(s[[1:2]], f2, z=200)

# the usenames argument

fvi2 <- function(red, green){ (red - green ) / (red + green) } 
names(s)
x1 <- lapp(s[[1:2]], fvi2, usenames=TRUE)
x2 <- lapp(s[[2:1]], fvi2, usenames=TRUE)
# x1 and x2 are the same, despite the change in the order of the layers
# x4 is also the same, but x3 is not
x3 <- lapp(s[[2:1]], fvi2, usenames=FALSE)

# these fail because there are too many layers in s
# x4 <- lapp(s, fvi2, usenames=TRUE)
# x5 <- lapp(s, fvi2, usenames=FALSE)

pairs(c(x1, x2, x3))

## SpatRasterDataset
x <- sds(s, s[[1]]+50)
fun <- function(x, y) { x/y }

# test "fun"
data <- list(matrix(1:9, ncol=3), matrix(9:1, ncol=3))
do.call(fun, data)

lapp(x, fun, recycle=TRUE)

# the same, more concisely
z <- s / (s[[1]]+50)
}
 
\keyword{methods}
\keyword{spatial}

\name{animate}

\docType{methods}

\alias{animate}
\alias{animate,SpatRaster-method}
\alias{animate,SpatVector-method}
\alias{animate,SpatVectorCollection-method}

\title{Animate a map}

\description{
Animate (sequentially plot) the layers of a SpatRaster, or a SpatVectorCollection, or the variables or geometries of a SpatVector, to create a movie.
}

\usage{
\S4method{animate}{SpatRaster}(x, pause=0.25, main, range=NULL, maxcell=50000, n=1, ...)

\S4method{animate}{SpatVector}(x, pause=0.25, main="", n=1, vars=NULL, range=NULL, add=NULL, ...)

\S4method{animate}{SpatVectorCollection}(x, pause=0.25, n=1, vars=NULL, range=NULL, ext=NULL, add=NULL, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{pause}{numeric. How long should the pause be between layers?}  
  \item{main}{title for each layer. For SpatRaster, if not supplied, the z-value is used if available. Otherwise the names are used.}  
  \item{range}{numeric vector of length 2. Range of values to plot, If \code{NULL} the range of all layers is used for rasters, or all variables for vectors if they are all numeric. If \code{NA} the range of each individual layer is used}
  \item{maxcell}{positive integer. Maximum number of cells to use for the plot. If \code{maxcell < ncell(x)}, \code{spatSample(type="regular")} is used before plotting}
  \item{n}{integer > 0. Number of plotting loops}
  \item{vars}{numeric or character to indicate the variables to animate. If this is NULL, the geometries are animated instead}
  \item{ext}{\code{SpatExtent} object (or an object for which \code{\link{ext}} returns one) setting the spatial extent of the plot.}
  \item{add}{logical. Add the geometries to the current plot? When looping over geometries: if \code{TRUE}, add all geometries to the current plot. If \code{NULL}, \code{add} is set to \code{FALSE} for the first geometry and \code{TRUE} for the remaining ones. This argument is ignored when \code{vars} is not \code{NULL}}
  \item{...}{additional arguments passed to \code{\link{plot}}}
}


\value{
None
}

\author{A. Márcia Barbosa, Robert J. Hijmans}

\seealso{ \code{\link{plot}}}

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
animate(r, n=1)

v <- vect(system.file("ex/lux.shp", package="terra"))
animate(v[1:3, ], n=1, pause=0.3)
# animate(v, vars=names(v))

s <- svc(as.lines(v[3:5,]), v, v[1:3,], as.points(v))
animate(s, col="blue", alpha=0.3, pause=0.3)

# you can save an animation to file like this
# animation::saveGIF(terra::animate(v), "animation.gif")
}

\keyword{methods}
\keyword{spatial}

\name{map_extent}

\alias{map_extent}

\title{Get the coordinates of the extent of a map}

\description{ 
Helper function for creating custom map elements that are aligned with the axes of a map (base plot created with a SpatRaster and/or SpatVector). For example, you may need to know the coordinates for the upper-left corner of a map to add some information there. 

Unlike the standard base plot, terra keeps the axis aligned with the data. For that reason you cannot use \code{par()$usr} to get these coordinates.

The coordinates returned by this function are used in, for example, \code{\link{add_legend}} such that a legend can be automatically placed in the a particular corner.

This function only returns meaningful results of the active plot (canvas) was create with a call to \code{plot} with a SpatRaster or SpatVector as first argument.
}

\usage{
map_extent()
}

\seealso{\code{\link{add_legend}}, \code{\link{add_grid}}, \code{\link{add_box}}}

\examples{
r <- rast(xmin=0, xmax=10, ymin=0, ymax=10, res=1, vals=1:100)
plot(r)

map_extent()
par()$usr
}

\keyword{methods}
\keyword{spatial}

\name{crds}

\docType{methods}

\alias{crds}
\alias{crds,SpatVector-method}
\alias{crds,SpatRaster-method}

\title{Get the coordinates of SpatVector geometries or SpatRaster cells}

\description{
Get the coordinates of a SpatVector or SpatRaster cells. A matrix or data.frame of the x (longitude) and y (latitude) coordinates is returned. 
}

\usage{
\S4method{crds}{SpatVector}(x, df=FALSE, list=FALSE)

\S4method{crds}{SpatRaster}(x, df=FALSE, na.rm=TRUE, na.all=FALSE)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{df}{logical. If \code{TRUE} a \code{data.frame} is returned instead of a matrix}  
  \item{list}{logical. If \code{TRUE} a \code{list} is returned instead of a matrix}  
  \item{na.rm}{logical. If \code{TRUE} cells that are \code{NA} are excluded. Ignored if the SpatRaster is a template with no associated cell values}  
  \item{na.all}{logical. If \code{TRUE} cells are only ignored if \code{na.rm=TRUE} and their value is \code{NA} for \bold{all} layers instead of for \code{any} layer}
}


\value{
matrix or data.frame
}

\seealso{
\code{\link{geom}} returns the complete structure of SpatVector geometries. For SpatRaster see \code{\link{xyFromCell}}
}


\examples{
x1 <- rbind(c(-175,-20), c(-140,55), c(10, 0), c(-140,-60))
x2 <- rbind(c(-125,0), c(0,60), c(40,5), c(15,-45))
x3 <- rbind(c(-10,0), c(140,60), c(160,0), c(140,-55))
x4 <- rbind(c(80,0), c(105,13), c(120,2), c(105,-13))
z <- rbind(cbind(object=1, part=1, x1), cbind(object=2, part=1, x2), 
           cbind(object=3, part=1, x3), cbind(object=3, part=2, x4))
colnames(z)[3:4] <- c('x', 'y')
z <- cbind(z, hole=0)
z[(z[, "object"]==3 & z[,"part"]==2), "hole"] <- 1

p <- vect(z, "polygons")
crds(p)

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
g <- crds(v)
head(g)

}

\keyword{spatial}

\name{pitfiller}

\alias{pitfiller}
\alias{pitfiller,SpatRaster-method}

\title{Pit Filler}

\description{
Fills pits (depressions with no outlet) in a elevation raster using the PEM4PIT terrain erosion model.
}

\usage{
\S4method{pitfiller}{SpatRaster}(x, pit, flowdir, niter = 10, lambda = 0,
                 deviation_type = "lad", max_iters=10^6, U = 1, D = 300, beta = 0.9,
                 theta_exp = 0.5, filename = "", ...)
}

\arguments{
  \item{x}{SpatRaster with elevation values}
  \item{pit}{SpatRaster with pits identified with values > 0. See \code{\link{pitfinder}}}
  \item{flowdir}{SpatRaster with flow direction. See \code{\link{flowDir}}}
  \item{niter}{Number of iterations}
  \item{lambda}{Deviation parameter}
  \item{deviation_type}{Type of deviation. See \code{\link{flowDir}}}
  \item{max_iters}{Maximum iterations for drainage path starting points detection. See \code{\link{flowDir}}}
  \item{U}{Uplift rate. See Details}
  \item{D}{Diffusion coefficient. See Details}
  \item{beta}{Erosion coefficient. See Details}
  \item{theta_exp}{Exponent for contributing area. See Details}
  \item{filename}{Character. Output filename}
  \item{...}{Additional arguments for writing files, as in \code{\link{writeRaster}}}
}

\value{
A \code{\link{SpatRaster}} with pits filled.
}

\details{
The PEM4PIT (Physical Erosion Model for PIT and flat areas correction) equation [Grimaldi at al, 2007] corrects DEMs by simulating erosion processes. It improves hydrologic modeling by enhancing flow direction and contributing area representation. Function is still experimental. 

The model is based on the steady-state sediment balance equation:

\deqn{0 = U - \beta A^{\theta} \left( \frac{z - z_d}{\Delta l} \right) + \frac{4D}{\Delta x^2} \left( \bar{z} - z \right)}

Rearranging terms to isolate \eqn{z}:

\deqn{\beta A^{\theta} \left( \frac{z - z_d}{\Delta l} \right) = U + \frac{4D}{\Delta x^2} \left( \bar{z} - z \right)}

Distributing terms:

\deqn{\beta A^{\theta} \frac{z}{\Delta l} - \beta A^{\theta} \frac{z_d}{\Delta l} = U + \frac{4D \bar{z}}{\Delta x^2} - \frac{4D z}{\Delta x^2}}

Combining like terms:

\deqn{\beta A^{\theta} \frac{z}{\Delta l} + \frac{4D z}{\Delta x^2} = U + \frac{4D \bar{z}}{\Delta x^2} + \beta A^{\theta} \frac{z_d}{\Delta l}}

Factoring out \eqn{z}:

\deqn{z \left( \beta A^{\theta} \frac{1}{\Delta l} + \frac{4D}{\Delta x^2} \right) = U + \frac{4D \bar{z}}{\Delta x^2} + \beta A^{\theta} \frac{z_d}{\Delta l}}

Solving for \eqn{z}:

\deqn{z = \frac{U \Delta l \Delta x^2 + 4D \Delta l \bar{z} + \beta A^{\theta} \Delta x^2 z_d}{\beta A^{\theta} \Delta x^2 + 4D \Delta l}}
}
\references{
Grimaldi, S., Nardi, F., Di Benedetto, F., Istanbulluoglu, E., & Bras, R. L. (2007). A physically-based method for removing pits in digital elevation models. \emph{Advances in Water Resources}, 30(10), 2151--2158. \doi{10.1016/j.advwatres.2006.11.016}

Tucker, G. E., & Bras, R. L. (1998). Hillslope processes, drainage density, and landscape morphology. \emph{Water Resources Research}, 34(10), 2751--2764. \doi{10.1029/98WR01474}

Niemann, J. D., Bras, R. L., & Veneziano, D. (2003). A physically based interpolation method for fluvially eroded topography. \emph{Water Resources Research}, 39, 1017. \doi{10.1029/2001WR001050}

Niemann, J. D., Bras, R. L., Veneziano, D., & Rinaldo, A. (2001). Impacts of surface elevation on the growth and scaling properties of simulated river networks. \emph{Geomorphology}, 40(1--2), 37--55. \doi{10.1016/S0169-555X(01)00036-8}
}

\author{
Emanuele Cordano
}

\seealso{
\code{\link{terrain}}, \code{\link{watershed}}, \code{\link{flowDir}}, \code{\link{pitfinder}}
}

\examples{
elev <- rast(system.file("ex/elev.tif", package = "terra"))
elev <- project(elev, "epsg:32632")

lambda <- 0.5 ## try also 0 (default)
flowdir <- flowDir(elev, lambda = lambda)
pits <- pitfinder(flowdir, pits_on_boundary = FALSE)
fill <- pitfiller(elev, pits, flowdir, lambda=lambda)

elev2 <- pitfiller(x = elev, pit = pits, flowdir = flowdir, lambda = lambda)
flowdir2 <- terrain(elev2, "flowdir")
flowdir2 <- flowDir(elev2, lambda = lambda)
pits2 <- pitfinder(flowdir2, pits_on_boundary = FALSE)
fill2 <- pitfiller(elev, pits2, flowdir2, lambda=lambda)
}

\keyword{spatial}

\name{sds}

\docType{methods}

\alias{sds}
\alias{sds,missing-method}
\alias{sds,character-method}
\alias{sds,list-method}
\alias{sds,array-method}
\alias{sds,SpatRaster-method}
\alias{sds,stars-method}
\alias{sds,stars_proxy-method}
\alias{[<-,SpatRasterDataset,numeric,missing-method}


\title{Create a SpatRasterDataset}

\description{
Methods to create a SpatRasterDataset. This is an object to hold "sub-datasets", each represented by a SpatRaster that may have multiple layers. All sub-datasets must have the same raster geometry (extent and resolution). You can use a SpatRasterCollection (see \code{\link{sprc}}) to combine SpatRasters with different geometries.

See \code{\link{describe}} for getting information about the sub-datasets present in a file.
}

\usage{
\S4method{sds}{missing}(x) 

\S4method{sds}{character}(x, ids=0, opts=NULL, raw=FALSE, noflip=FALSE, guessCRS=TRUE, domains="", md=FALSE)

\S4method{sds}{SpatRaster}(x, ...) 

\S4method{sds}{list}(x) 

\S4method{sds}{array}(x, crs="", extent=NULL)
}

\arguments{
\item{x}{character (filename), or SpatRaster, or list of SpatRasters, or missing. If multiple filenames are provided, it is attempted to make SpatRasters from these, and combine them into a SpatRasterDataset}
\item{ids}{optional. vector of integer subdataset ids. Ignored if the first value is not a positive integer}
\item{opts}{character. GDAL dataset open options}
\item{raw}{logical. If \code{TRUE}, scale and offset values are ignored}
\item{noflip}{logical. If \code{TRUE}, a raster (e.g. JPEG image) that is not georeferenced and that GDAL assigns a flipped extent to (\code{ymax < ymin}), is not considered flipped. This avoids the need to \code{\link{flip}} the raster vertically}
\item{guessCRS}{logical. If \code{TRUE} and the file does not specify a CRS but has an extent that is within longitude/latitude bounds, the longitude/latitude crs is assigned to the SpatRaster}
\item{domains}{character. Metadata domains to read (see \code{\link{metags}} to retrieve their values if there are any). "" is the default domain}
\item{md}{logical. If \code{TRUE}, the multi-dimensional GDAL API is used for reading the file. This API can only be used for a few file formats (netCDF/HDF5) and can sometimes provide notably faster reading of data with many (time) steps in the third or higher dimension. If no subdataset is selected with \code{subds}, all usable arrays are combined into one \code{SpatRaster} (like \code{md=FALSE}); a warning reports how many variables and layers were combined when there is more than one variable.}
\item{crs}{character. Description of the Coordinate Reference System (map projection) in \code{PROJ.4}, \code{WKT} or \code{authority:code} notation. If this argument is missing, and the x coordinates are within -360 .. 360 and the y coordinates are within -90 .. 90, longitude/latitude is assigned}
\item{extent}{\code{\link{SpatExtent}}}
\item{...}{additional \code{SpatRaster} objects} 
}


\value{
SpatRasterDataset
}

\seealso{
\code{\link{sprc}}, \code{\link{describe}}
}

\examples{
s <- rast(system.file("ex/logo.tif", package="terra"))   
x <- sds(s, s/2)
names(x) <- c("first", "second")
x
length(x)

# extract the second SpatRaster
x[2]

a <- array(1:9, c(3,3,3,3))
sds(a)
}


\keyword{methods}
\keyword{spatial}

\name{voronoi}

\alias{delaunay}
\alias{voronoi}
\alias{voronoi,SpatVector-method}
\alias{delaunay,SpatVector-method}


\title{Voronoi diagram and Delaunay triangles}

\description{
Get a Voronoi diagram or Delaunay triangles for points, or the nodes of lines or polygons
}

\usage{
\S4method{voronoi}{SpatVector}(x, bnd=NULL, tolerance=0, as.lines=FALSE, deldir=FALSE) 

\S4method{delaunay}{SpatVector}(x, tolerance=0, as.lines=FALSE, constrained=FALSE) 
}


\arguments{
\item{x}{SpatVector}
\item{bnd}{SpatVector to set the outer boundary of the voronoi diagram}
\item{tolerance}{numeric >= 0. Snapping tolerance applied to the input vertices before computing the diagram (\code{0} is no snapping). Expressed in the units of the CRS of \code{x}, i.e. meters or feet for projected data and \strong{degrees} for lon/lat data.}
\item{as.lines}{logical. If \code{TRUE}, lines are returned without the outer boundary}
\item{constrained}{logical. If \code{TRUE}, a constrained delaunay triangulation is returned}
\item{deldir}{logical. If \code{TRUE}, the \code{\link[deldir]{deldir}} is used instead of the GEOS C++ library method. It has been reported that \code{deldir} does not choke on very large data sets}
}


\value{SpatVector}


\examples{
wkt <- c("MULTIPOLYGON ( ((40 40, 20 45, 45 30, 40 40)), 
  ((20 35, 10 30, 10 10, 30 5, 45 20, 20 35),(30 20, 20 15, 20 25, 30 20)))", 
  "POLYGON ((0 -5, 10 0, 10 -10, 0 -5))")
x <- vect(wkt)
v <- voronoi(x)
v

d <- delaunay(x)
d

plot(v, lwd=2, col=rainbow(15))
lines(x, col="gray", lwd=2)
points(x)
}

\keyword{spatial}

\name{bestMatch}

\alias{bestMatch}
\alias{bestMatch,SpatRaster,SpatVector-method}
\alias{bestMatch,SpatRaster,data.frame-method}
\alias{bestMatch,SpatRaster,matrix-method}

\title{bestMatch}

\description{
Determine for each grid cell which reference it is most similar to. A reference consists of a SpatVector with reference locations, or a data.frame or matrix in which each column matches a layer name in the SpatRaster.

Similarity is computed with the mean absolute or the mean squared differences between the cell and the reference, or with an alternative function you provide. It may be important to first scale the input. 
}

\usage{
\S4method{bestMatch}{SpatRaster,SpatVector}(x, y, labels=NULL, fun="squared", ..., 
		filename="", overwrite=FALSE, wopt=list())

\S4method{bestMatch}{SpatRaster,data.frame}(x, y, labels=NULL, fun="squared", ..., 
		filename="", overwrite=FALSE, wopt=list())

\S4method{bestMatch}{SpatRaster,matrix}(x, y, labels=NULL, fun="squared", ..., 
		filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatVector, data.frame or matrix}
  \item{labels}{character. labels that correspond to each class (row in \code{y}}
  \item{fun}{character. One of "abs" for the mean absolute difference, or "squared" for the mean squared difference. Or a true function like terra:::match_sqr}
  \item{...}{additional arguments passed to \code{fun}. For the built-in functions this can be \code{na.rm=TRUE}}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}


\examples{
f <- system.file("ex/logo.tif", package = "terra")
r <- rast(f)

# locations of interest 
pts <- vect(cbind(c(25.25, 34.324, 43.003), c(54.577, 46.489, 30.905)))
pts$code <- LETTERS[1:3]

plot(r)
points(pts, pch=20, cex=2, col="red")
text(pts, "code", pos=4, halo=TRUE)

x <- scale(r)

s1 <- bestMatch(x, pts, labels=pts$code)
plot(s1)

# same result
e <- extract(x, pts, ID=FALSE)
s2 <- bestMatch(x, e, labels=c("Ap", "Nt", "Ms"))
}

\keyword{spatial}

\name{north}

\alias{north}
  
\title{North arrow}

\description{
Add a (North) arrow to a map
}

\usage{
north(xy=NULL, type=1, label="N", angle=0, d, head=0.1, xpd=TRUE, ...)

}

\arguments{
\item{xy}{numeric. x and y coordinates to place the arrow. It can also be one of following character values: "bottomleft", "bottom", "bottomright", "topleft", "top", "topright", "left", "right", or NULL}
\item{type}{integer between 1 and 12, or a character (unicode) representation of a right pointing arrow such as \code{"\u27A9"}. You may need to install the fonts for this. See here: https://stackoverflow.com/a/79747858/635245}
\item{label}{character, to be printed near the arrow}
\item{angle}{numeric. The angle of the arrow in degrees}
\item{d}{numeric. Distance covered by the arrow in plot coordinates. Only applies to \code{type=1}}
\item{head}{numeric. The size of the arrow "head", for \code{type=1}}
\item{xpd}{logical. If \code{TRUE}, the arrow can be outside the plot area}
\item{...}{graphical arguments to be passed to other methods }
}

\value{
none
}

\seealso{ \code{\link[terra]{sbar}}, \code{\link[terra]{plot}}, \code{\link[terra]{inset}} }

\examples{
f <- system.file("ex/meuse.tif", package="terra")
r <- rast(f)
plot(r)
north()
north(c(178550, 332500), d=250)

\dontrun{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
plot(r, type="interval")
north(type=3, cex=.8)
north(xy=c(6.7, 49.9), type=2, angle=45, label="NE")
north(xy=c(6.6, 49.7), type=5, cex=1.25)
north(xy=c(5.65, 49.6), type=9)
north(d=.05, xy=c(5.65, 50), angle=180, label="S", lwd=2, col="blue")


## all arrows
r <- rast(res=10)
values(r) <- 1
plot(r, col="white", axes=FALSE, legend=FALSE, mar=c(0,0,0,0), reset=TRUE)
for (i in 1:12) {
	x = -200+i*30
	north(xy=cbind(x,30), type=i)
	text(x, -20, i, xpd=TRUE)
}

}

}


\keyword{spatial}

\name{focalReg}

\alias{focalReg}
\alias{focalReg,SpatRaster-method}

\title{Focal regression}

\description{
Calculate values for a moving-window by comparing the value in one layers with the values in one to many other layers. A typical case is the computation of the coefficients for a focal linear regression model. 
}

\usage{
\S4method{focalReg}{SpatRaster}(x, w=3, fun="ols", ..., fillvalue=NA, filename="", overwrite=FALSE, wopt=list()) 
}

\arguments{
\item{x}{SpatRaster with at least two layers. The first is the "Y" (dependent) variable and the remainder are the "X" (independent) variables}

\item{w}{numeric or matrix to define the focal window. The window an be defined as one (for a square) or two numbers (row, col); or with an odd-sized weights matrix. See the Details section in \code{\link{focal}}. Note that if a matrix with numbers other than zero or one are used, the values are used as weights. For this to work, \code{fun} must have an argument \code{weights}}

\item{fun}{a function with at least two arguments (one for each layer). There is a built-in function "ols" for both the weighted and unweighted Ordinary Least Square regression. This function has an additional argument \code{na.rm=FALSE} and \code{intercept=TRUE}}

\item{...}{additional arguments for \code{fun}}

\item{fillvalue}{numeric. The value of the cells in the virtual rows and columns outside of the raster}

\item{filename}{character. Output filename}

\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}

\item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}

}

\value{SpatRaster}


\seealso{ \code{\link{focal}, \link{focal3D}}, \link{focalValues}} 


\examples{
r <- rast(ncols=10, nrows=10, ext(0, 10, 0, 10))
values(r) <- 1:ncell(r)
x <- c(r, init(r, runif) * r)
f <- focalReg(x, 3)
}


\keyword{spatial}

\name{where}

\docType{methods}

\alias{where.min}
\alias{where.min,SpatRaster-method}
\alias{where.max}
\alias{where.max,SpatRaster-method}

\title{Where are the cells with the min or max values?}

\description{
This method returns the cell numbers for the cells with the min or max values of each layer in a SpatRaster.
}


\usage{
\S4method{where.min}{SpatRaster}(x, values=TRUE, list=FALSE)

\S4method{where.max}{SpatRaster}(x, values=TRUE, list=FALSE)
}

\arguments{
  \item{x}{SpatRaster}
  \item{values}{logical. If \code{TRUE} the min or max values are also returned}
  \item{list}{logical. If \code{TRUE} a list is returned instead of a matrix}
}


\value{
matrix or list
}

\seealso{\code{\link{which}} and \code{\link{Summary-methods}} for \code{which.min} and \code{which.max}}


\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
where.min(r)
}

\keyword{spatial}

\name{resample}

\alias{resample}
\alias{resample,SpatRaster,SpatRaster-method}
\alias{resample,SpatRaster,numeric-method}

\title{Transfer values of a SpatRaster to another one with a different geometry}

\description{
resample transfers values between SpatRaster objects that do not align (have a different origin and/or resolution). See \code{\link{project}} to change the coordinate reference system (crs). 

If the origin and extent of the input and output are the same, you should consider using these other functions instead: \code{\link{aggregate}}, \code{\link{disagg}}, \code{\link{extend}} or \code{\link{crop}}.
}

\usage{
\S4method{resample}{SpatRaster,SpatRaster}(x, y, method, threads=FALSE, by_util=FALSE, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster to be resampled}
  \item{y}{SpatRaster with the geometry that \code{x} should be resampled to. You can also provide one or two positive numbers to set the resolution of the output raster relative to the input raster}
  \item{method}{character. Method used for estimating the new cell values. One of: 
    
	\code{bilinear}: bilinear interpolation (3x3 cell window). This is used by default if the first layer of \code{x} is not categorical

	\code{mean}:  This can be a good choice with continuous variables if the output cells overlap with multiple input cells. 

	\code{near}: nearest neighbor. This is used by default if the first layer of \code{x} is categorical. This method is not a good choice for continuous values.

	\code{modal}: The modal value. This can be a good choice for categorical rasters, if the output cells overlap with multiple input cells. 
  
	\code{cubic}: cubic interpolation (5x5 cell window).

	\code{cubicspline}: cubic B-spline interpolation. (5x5 cell window).

	\code{lanczos}: Lanczos windowed sinc resampling. (7x7 cell window).

	\code{sum}: the weighted sum of all non-NA contributing grid cells.

	\code{min, q1, median, q3, max}: the minimum, first quartile, median, third quartile, or maximum value. 
	
	\code{rms}: the root-mean-square value of all non-NA contributing grid cells.
  }
  
  
  \item{threads}{logical or positive integer. If \code{TRUE}, multiple threads are used (faster for large files), no more than the "threads" setting of \code{\link{terraOptions}}. A number sets the thread count for this call directly}
  
  \item{by_util}{logical. If \code{TRUE} the GDAL warp utility is used}
 
  \item{filename}{character. Output filename}

  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\value{SpatRaster }


\seealso{ \code{\link{aggregate}}, \code{\link{disagg}}, \code{\link{crop}}, \code{\link{project}}}


\examples{

r <- rast(nrows=3, ncols=3, xmin=0, xmax=10, ymin=0, ymax=10)
values(r) <- 1:ncell(r)
s <- rast(nrows=25, ncols=30, xmin=1, xmax=11, ymin=-1, ymax=11)
x <- resample(r, s, method="bilinear")

}

\keyword{spatial}

\name{scale_linear}

\alias{scale_linear}
\alias{scale_linear,SpatRaster-method}


\title{Scale values linearly}

\description{
Linear scaling of raster cell values between a specified minimum and maximum value.
}

\usage{
\S4method{scale_linear}{SpatRaster}(x, min=0, max=1, filename="", ...)
}


\arguments{
 \item{x}{SpatRaster}
 \item{min}{minimum value to scale to}
 \item{max}{maximum value to scale to}
 \item{filename}{character. Output filename}
 \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}
 
\value{
SpatRaster
}


\seealso{ \code{\link{scale}} }

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
s1 <- scale_linear(r)
s2 <- scale_linear(r, 1, 10)
}

\keyword{ spatial }

\name{sieve}

\alias{sieve}
\alias{sieve,SpatRaster-method}

\title{Sieve filter}

\description{
Apply a sieve filter. That is, remove "noise", by changing small clumps of cells with a value that is different from the surrounding cells, to the value of the largest neighboring clump.

Note that the numerical input values are truncated to integers.
}

\usage{
\S4method{sieve}{SpatRaster}(x, threshold, directions=8, filename="", ...) 
}

\arguments{
  \item{x}{SpatRaster, single layer with integer or categorical values }
 
  \item{threshold}{positive integer. Only clumps smaller than this threshold will be removed}
  
  \item{directions}{numeric to indicate which cells are connected. Either \code{4} to only consider the horizontal and vertical neighbors ("rook"), or \code{8} to consider the vertical, horizontal and diagonal neighbors}

  \item{filename}{character. Output filename}
  \item{...}{Options for writing files as in \code{\link{writeRaster}}}
}


\seealso{\code{\link{focal}}}


\examples{
r <- rast(nrows=18, ncols=18, xmin=0, vals=0, crs="local")
r[2, 5] <- 1
r[5:8, 2:3] <- 2
r[7:12, 10:15] <- 3
r[15:16, 15:18] <- 4
freq(r, bylayer=FALSE)

x <- sieve(r, 8)
y <- sieve(r, 9)
}

\keyword{spatial}

\name{deepcopy}

\docType{methods}

\alias{deepcopy}
\alias{deepcopy,SpatRaster-method}
\alias{deepcopy,SpatVector-method}


\title{Deep copy}

\description{ 
Make a deep copy of a SpatRaster or SpatVector. This is occasionally useful when using an in-place replacement function that does not make copy, such as \code{\link{set.ext}}. 
}

\usage{
\S4method{deepcopy}{SpatRaster}(x)

\S4method{deepcopy}{SpatVector}(x)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
}

\value{
Same as \code{x}
}


\examples{
r <- rast(ncols=10, nrows=10, nl=3)
x <- r
y <- deepcopy(r)
ext(r)
set.ext(x, c(0,10,0,10))
ext(x)
ext(r)
ext(y)
}


\keyword{methods}
\keyword{spatial}

\name{tapp}

\docType{methods}

\alias{tapp}
\alias{tapp,SpatRaster-method}

\title{Apply a function to subsets of layers of a SpatRaster}

\description{
Apply a function to subsets of layers of a SpatRaster (similar to \code{\link[base]{tapply}} and \code{\link[stats]{aggregate}}). The layers are combined based on the \code{index}.

The number of layers in the output SpatRaster equals the number of unique values in \code{index} times the number of values that the supplied function returns for a single vector of numbers.

For example, if you have a SpatRaster with 6 layers, you can use \code{index=c(1,1,1,2,2,2)} and \code{fun=sum}. This will return a SpatRaster with two layers. The first layer is the sum of the first three layers in the input SpatRaster, and the second layer is the sum of the last three layers in the input SpatRaster. Indices are recycled such that \code{index=c(1,2)} would also return a SpatRaster with two layers (one based on the odd layers (1,3,5), the other based on the even layers (2,4,6)). 

The index can also be one of the following values to group by time period (if \code{x} has the appropriate \code{\link{time}} values): "years", "months", "yearmonths", "dekads", "yeardekads", "weeks" (the ISO 8601 week number, see Details), "yearweeks", "days", "doy" (day of the year), "7days" (seven-day periods starting at Jan 1 of each year), "10days", or "15days". It can also be a function that makes groups from time values.

See \code{\link{app}} or \code{\link{Summary-methods}} if you want to use a more efficient function that returns multiple layers based on \bold{all} layers in the SpatRaster.
}

\usage{
\S4method{tapp}{SpatRaster}(x, index, fun, ..., cores=1, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{index}{factor or numeric (integer). Vector of length \code{nlyr(x)} (shorter vectors are recycled) grouping the input layers. It can also be one of the following values: "years", "months", "yearmonths", "days", "week" (ISO 8601 week number), or "doy" (day of the year)}
  \item{fun}{function to be applied. The following functions have been re-implemented in C++ for speed: "sum", "mean", "median", "modal", "which", "which.min", "which.max", "min", "max", "prod", "any", "all", "none", "sd", "std", "first". To use the base-R function for say, "min", you could use something like \code{fun = \(i) min(i)}}
  \item{...}{additional arguments passed to \code{fun}}
  \item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created and used. You can also supply a cluster object. Ignored for functions that are implemented by terra in C++ (see under fun)}  
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\details{
"week" follows the ISO 8601 definition. Weeks start on Monday. If the week containing 1 January has four or more days in the new year, then it is considered week "01". Otherwise, it is the last week of the previous year (week "52" or "53", and the next week is week 1.
}

\seealso{\code{\link{app}}, \code{\link{Summary-methods}}}

\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- 1:ncell(r)
s <- c(r, r, r, r, r, r)
s <- s * 1:6
b1 <- tapp(s, index=c(1,1,1,2,2,2), fun=sum)
b1
b2 <- tapp(s, c(1,2,3,1,2,3), fun=sum)
b2
}

\keyword{methods}
\keyword{spatial}

\name{makeTiles}

\docType{methods}


\alias{getTileExtents}
\alias{getTileExtents,SpatRaster-method}

\alias{makeTiles}
\alias{makeTiles,SpatRaster-method}


\title{Make tiles or get their extents}

\description{ 
Divide a SpatRaster into "tiles". The cells of another SpatRaster (normally with a much lower resolution) or a SpatVector with polygon geometry can be used to define the tiles. You can also provide one or two numbers to indicate the number of rows and columns per tile. 

\code{getTileExtents} returns the extents of the (virtual) tiles, while \code{makeTiles} creates files for the tiles and returns their filenames. 
}

\usage{
\S4method{makeTiles}{SpatRaster}(x, y, filename="tile_.tif", extend=FALSE,
		na.rm=FALSE, buffer=0, value="files", overwrite=FALSE, ...)


\S4method{getTileExtents}{SpatRaster}(x, y, extend=FALSE, buffer=0, cores=1)
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatRaster or SpatVector defining the zones; or a positive integer specifying the number of rows and columns for each zone (or 2 numbers to differentiate the number of rows and columns). For \code{getTileExtents}, \code{y} may also be missing or \code{NULL}, in which case a tile size is computed automatically (see \emph{Details})}
  \item{filename}{character. Output filename template. Filenames will be altered by adding the tile number for each tile}
  \item{extend}{logical. If \code{TRUE}, the extent of \code{y} is expanded to assure that it covers all of \code{x}}
  \item{na.rm}{logical. If \code{TRUE}, tiles with only missing values are ignored}
  \item{buffer}{integer. The number of additional rows and columns added to each tile. Can be a single number, or two numbers to specify a separate number of rows and columns. This allows for creating overlapping tiles that can be used for computing spatial context dependent values with e.g. \code{\link{focal}}. The expansion is only inside \code{x}, no rows or columns outside of \code{x} are added}
  \item{cores}{integer (only used by \code{getTileExtents} when \code{y} is missing). The number of worker processes that will consume the tiles. Larger values lead to smaller per-worker tiles so that the concurrent peak memory stays within budget. See \emph{Details}}
  \item{value}{character. The type of return value desired. Either "files" (for the filenames), "raster" (for a SpatRaster), or "collection" (for a SpatRasterCollection)}
  \item{overwrite}{logical. If \code{TRUE}, existing tiles are overwritten; otherwise they are skipped (without error or warning)}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\details{
When \code{y} is missing in \code{getTileExtents}, the tile size is chosen so that

\itemize{
  \item tiles align to whole GDAL blocks of the source file(s) (as reported by \code{\link{fileBlocksize}}). When no source block size is reported, a default of 256 rows by 256 columns is used.
  \item the per-worker peak memory (\code{cells per tile} \eqn{\times} \code{nlyr} \eqn{\times} 8 bytes \eqn{\times} a small \code{ncopies} factor) stays within \code{cores} workers' share of \code{terraOptions("memfrac")} of free RAM (see \code{\link{free_RAM}}, \code{\link{terraOptions}}).
  \item there are at least a few tiles per worker, so the work load-balances.
  \item the result never exceeds the raster's own dimensions.
}

In practice this means that for a tiled GeoTIFF / COG, tiles are an integer multiple of the file block size; for an in-memory or non-tiled raster the result is roughly square.
}

\value{
\code{makeTiles} returns a character (filenames), SpatRaster or SpatRasterCollection value. \code{getTileExtents} returns a matrix with extents
}


\seealso{
\code{\link{vrt}} to create a SpatRaster from tiles; \code{\link{crop}} for sub-setting arbitrary parts of a SpatRaster; \code{\link{divide}} to divide a SpatRaster into parts.
}



\examples{
r <- rast(ncols=100, nrows=100)
values(r) <- 1:ncell(r)
x <- rast(ncols=2, nrows=2)

getTileExtents(r, x)
getTileExtents(r, x, buffer=3)

# auto: tile size from GDAL block size and a per-worker memory budget
getTileExtents(r)            # cores = 1
getTileExtents(r, cores=4)   # smaller tiles, sized for 4 concurrent workers


filename <- paste0(tempfile(), "_.tif")
ff <- makeTiles(r, x, filename)
ff

vrt(ff)
}


\keyword{methods}
\keyword{spatial}

\name{proj_pipelines}

\alias{proj_pipelines}

\title{Find CRS transformation pipelines}

\description{
Find candidate coordinate transformation pipelines between two coordinate reference systems. This can be used to examine which transformations are available, whether they require grid files, and what accuracy they provide. You can use a selected pipeline with the \code{\link{project}} methods
}

\usage{
proj_pipelines(from, to, authority="", AOI=NULL, use="NONE", 
	grid_availability="USED", desired_accuracy=-1.0, strict_containment=FALSE)
}

\arguments{
\item{from}{character, SpatRaster, SpatVector, or any object from which \code{crs()} can extract a CRS}
\item{to}{same types as for \code{from}}
\item{authority}{character. Constrain output pipelines to those from this authority (e.g. \code{"EPSG"}). Default \code{""} means no constraint}
\item{AOI}{SpatExtent. Area of interest for the transformation in degrees. For an area of interest crossing the anti-meridian, west should be greater than east, e.g. \code{ext(150, 210, 0, 30)}}
\item{use}{character. One of \code{"NONE"}, \code{"BOTH"}, \code{"INTERSECTION"}, \code{"SMALLEST"}, indicating how areas of interest of source and target CRS are used. Ignored when \code{AOI} is specified}
\item{grid_availability}{character. One of \code{"USED"} (grid availability is used for sorting; operations with missing grids are sorted last), \code{"DISCARD"} (discard operations if a required grid is missing), \code{"IGNORED"} (ignore grid availability; results presented as if all grids were available), or \code{"AVAILABLE"} (results presented as if grids known to PROJ were available; typical when networking is enabled)}
\item{desired_accuracy}{numeric. Only return pipelines with at least this accuracy (in metres). Use \code{-1} (the default) to impose no accuracy constraint}
\item{strict_containment}{logical. If \code{FALSE} (the default), permit partial matching of the area of interest. If \code{TRUE}, the area of interest must be strictly contained}
}

\value{
A \code{data.frame} with "pipelines" and the following columns:
\describe{
  \item{description}{human-readable description}
  \item{definition}{PROJ pipeline definition string}
  \item{has_inverse}{logical; whether the pipeline has an inverse}
  \item{accuracy}{accuracy in metres; \code{-1} indicates unknown (ballpark) accuracy}
  \item{grid_count}{number of grids required by this pipeline}
  \item{instantiable}{logical; whether the pipeline can be used (all required grids are available)}
}
}

\note{
Requires PROJ >= 7.1 (inc" 3). See \code{\link{projNetwork}} to enable online grid downloading.
}

\seealso{
\code{\link{crs}}, \code{\link{project}}, \code{\link{same.crs}}, \code{\link{projNetwork}}
}

\examples{
\dontrun{
# Simple case: WGS84 to UTM zone 32N
proj_pipelines("EPSG:4326", "EPSG:32632")

# Many pipelines between NAD83/Conus Albers and WGS84
pp <- proj_pipelines("EPSG:5070", "EPSG:4326")
nrow(pp)

# Only pipelines that work without downloading grids
pp_local <- proj_pipelines("EPSG:5070", "EPSG:4326", grid_availability="DISCARD")
pp_local

# Using a SpatRaster as input
r <- rast(ncols=10, nrows=10, crs="EPSG:4326")
proj_pipelines(r, "EPSG:3857")
}
}

\keyword{spatial}

\name{SpatExtent-class}

\docType{class}

\alias{SpatExtent}
\alias{SpatExtent-class}
\alias{Rcpp_SpatExtent-class}

\alias{show,SpatExtent-method}

\title{Class "SpatExtent" }

\description{
Objects of class SpatExtent are used to define the spatial extent (extremes) of objects of the SpatRaster class. 
}

\section{Objects from the Class}{
You can use the \code{\link{ext}} function to create SpatExtent objects, or to extract them from a SpatRaster, SpatVector or related objects.
}


\section{Methods}{
  \describe{
 \item{show}{display values of a SpatExtent object }
 }
}


\examples{
e <- ext(-180, 180, -90, 90)
e
}

\keyword{classes}
\keyword{spatial}

\name{predict}

\docType{methods}

\alias{predict}
\alias{predict,SpatRaster-method}

\title{Spatial model predictions}

\description{
Make a SpatRaster with predictions from a fitted model object (for example, obtained with \code{glm} or \code{randomForest}). The first argument is a SpatRaster object with the predictor variables. The \code{\link{names}} in the SpatRaster should exactly match those expected by the model. Any regression like model for which a predict method has been implemented (or can be implemented) can be used. 

The method should work if the model's predict function returns a vector, matrix or data.frame (or a list that can be coerced to a data.frame). In other cases it may be necessary to provide a custom "predict" function that wraps the model's predict function to return the values in the required form. See the examples.

This approach of using model predictions is commonly used in remote sensing (for the classification of satellite images) and in ecology, for species distribution modeling.
}

\usage{
\S4method{predict}{SpatRaster}(object, model, fun=predict, ..., const=NULL, na.rm=FALSE,
          index=NULL, cores=1, cpkgs=NULL, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{object}{SpatRaster}
  \item{model}{fitted model of any class that has a "predict" method (or for which you can supply a similar method as \code{fun} argument. E.g. glm, gam, or randomForest}
  \item{fun}{function. The predict function that takes \code{model} as first argument. The default value is \code{predict}, but can be replaced with e.g. predict.se (depending on the type of model), or your own custom function}
  \item{...}{additional arguments for \code{fun}}    

  \item{const}{data.frame. Can be used to add a constant value as a predictor variable so that you do not need to make a SpatRaster layer for it}
  \item{na.rm}{logical. If \code{TRUE}, cells with \code{NA} values in the any of the layers of \code{x} are removed from the computation (even if the \code{NA} cell is in a layer that is not used as a variable in the model). This option prevents errors with models that cannot handle \code{NA} values when making predictions. In most other cases this will not affect the output. However, there are some models that return predicted values even if some (or all) variables are \code{NA} }
  \item{index}{integer or character. Can be used to to select a subset of the model output variables}
  \item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created and used}
  \item{cpkgs}{character. The package(s) that need to be loaded on the nodes to be able to run the model.predict function (see examples)}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
 }


\value{
SpatRaster
}

\seealso{ \code{\link{interpolate}} for spatial model prediction }

\examples{
logo <- rast(system.file("ex/logo.tif", package="terra"))   
names(logo) <- c("red", "green", "blue")
p <- matrix(c(48, 48, 48, 53, 50, 46, 54, 70, 84, 85, 74, 84, 95, 85, 
   66, 42, 26, 4, 19, 17, 7, 14, 26, 29, 39, 45, 51, 56, 46, 38, 31, 
   22, 34, 60, 70, 73, 63, 46, 43, 28), ncol=2)

a <- matrix(c(22, 33, 64, 85, 92, 94, 59, 27, 30, 64, 60, 33, 31, 9,
   99, 67, 15, 5, 4, 30, 8, 37, 42, 27, 19, 69, 60, 73, 3, 5, 21,
   37, 52, 70, 74, 9, 13, 4, 17, 47), ncol=2)

xy <- rbind(cbind(1, p), cbind(0, a))

# extract predictor values for points
e <- extract(logo, xy[,2:3])

# combine with response (excluding the ID column)
v <- data.frame(cbind(pa=xy[,1], e))

#build a model, here with glm 
model <- glm(formula=pa~., data=v)

#predict to a raster
r1 <- predict(logo, model)

plot(r1)
points(p, bg='blue', pch=21)
points(a, bg='red', pch=21)

# logistic regression
model <- glm(formula=pa~., data=v, family="binomial")
r1log <- predict(logo, model, type="response")

# to get the probability and standard error
r1se <- predict(logo, model, se.fit=TRUE)

# or provide a custom predict function

predfun <- function(model, data) {
  v <- predict(model, data, se.fit=TRUE)
  cbind(p=as.vector(v$fit), se=as.vector(v$se.fit))
}

r2 <- predict(logo, model, fun=predfun)

### principal components of a SpatRaster
pca <- prcomp(logo)

# or use sampling if you have a large raster 
# and cannot process all cell values
sr <- spatSample(logo, 100000, "regular")
pca <- prcomp(sr)

x <- predict(logo, pca)
plot(x)

## parallelization
\dontrun{
## simple case with GLM 
model <- glm(formula=pa~., data=v)
p <- predict(logo, model, cores=2)

## The above does not work with a model from a contributed
## package, as the package needs to be loaded in each core. 
## Below are three approaches to deal with that 

library(randomForest)
rfm <- randomForest(formula=pa~., data=v)

## approach 0 (not parallel) 
rp0 <- predict(logo, rfm)

## approach 1, use the "cpkgs" argument 
rp1 <- predict(logo, rfm, cores=2, cpkgs="randomForest")

## approach 2, write a custom predict function that loads the package
rfun <- function(mod, dat, ...) {
	library(randomForest)
	predict(mod, dat, ...)
}
rp2 <- predict(logo, rfm, fun=rfun, cores=2)

## approach 3, write a parallelized custom predict function 
rfun <- function(mod, dat, ...) {
	ncls <- length(cls)
	nr <- nrow(dat)
	s <- split(dat, rep(1:ncls, each=ceiling(nr/ncls), length.out=nr))
	unlist(  parallel::clusterApply(cls, s, function(x, ...) predict(mod, x, ...))  )
}

library(parallel)
cls <- parallel::makeCluster(2)
parallel::clusterExport(cls, c("rfm", "rfun", "randomForest"))
rp3 <- predict(logo, rfm, fun=rfun)
parallel::stopCluster(cls)

plot(c(rp0, rp1, rp2, rp3))


### with two output variables (probabilities for each class)
v$pa <- as.factor(v$pa)
rfm2 <- randomForest(formula=pa~., data=v)
rfp <- predict(logo, rfm2, cores=2, type="prob", cpkgs="randomForest")
}

}


\keyword{methods}
\keyword{spatial}

\name{geom}

\docType{methods}

\alias{geom}
\alias{geom,SpatVector-method}

\title{Get the geometry (coordinates) of a SpatVector}

\description{
Get the geometry of a SpatVector. If \code{wkt=FALSE}, this is a five-column matrix or data.frame: the vector object ID, the IDs for the parts of each object (e.g. five polygons that together are one spatial object), the x (longitude) and y (latitude) coordinates, and a flag indicating whether the part is a "hole" (only relevant for polygons). 

If \code{wkt=TRUE}, the "well-known text" representation is returned as a character vector.
If \code{hex=TRUE}, the "hexadecimal" representation is returned as a character vector.
If \code{wkb=TRUE}, the "well-known binary" representation is returned as a list of raw vectors.
}

\usage{
\S4method{geom}{SpatVector}(x, wkt=FALSE, hex=FALSE, wkb=FALSE, df=FALSE, list=FALSE, xnm="x", ynm="y")
}

\arguments{
  \item{x}{SpatVector}
  \item{wkt}{logical. If \code{TRUE} the WKT geometry is returned (unless \code{hex} is also \code{TRUE})}  
  \item{hex}{logical. If \code{TRUE} the hexadecimal geometry is returned}  
  \item{wkb}{logical. If \code{TRUE} the raw WKB geometry is returned (unless either of \code{hex} or \code{wkt} is also \code{TRUE})}  
  \item{df}{logical. If \code{TRUE} a \code{data.frame} is returned instead of a matrix (only if \code{wkt=FALSE}, \code{hex=FALSE}, and \code{list=FALSE})} 
  \item{list}{logical. If \code{TRUE} a nested \code{list} is returned with data.frames of coordinates}
  \item{xnm}{character. If \code{list=TRUE} the "x" column name for the coordinates data.frame }  
  \item{ynm}{character. If \code{list=TRUE} the "y" column name for the coordinates data.frame}  
}


\value{
matrix, vector, data.frame, or list
}

\seealso{
\code{\link{crds}}, \code{\link{xyFromCell}}
}


\examples{
x1 <- rbind(c(-175,-20), c(-140,55), c(10, 0), c(-140,-60))
x2 <- rbind(c(-125,0), c(0,60), c(40,5), c(15,-45))
x3 <- rbind(c(-10,0), c(140,60), c(160,0), c(140,-55))
x4 <- rbind(c(80,0), c(105,13), c(120,2), c(105,-13))
z <- rbind(cbind(object=1, part=1, x1), cbind(object=2, part=1, x2), 
           cbind(object=3, part=1, x3), cbind(object=3, part=2,  x4))
colnames(z)[3:4] <- c('x', 'y')
z <- cbind(z, hole=0)
z[(z[, "object"]==3 & z[,"part"]==2), "hole"] <- 1

p <- vect(z, "polygons")
geom(p)

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
g <- geom(v)
head(g)

w <- geom(v, wkt=TRUE)
substr(w, 1, 60)
}

\keyword{spatial}

\name{plet}

\docType{methods}

\alias{plet}
\alias{plet,missing-method}
\alias{plet,SpatRaster-method}
\alias{plet,SpatRasterCollection-method}
\alias{plet,SpatVector-method}
\alias{plet,data.frame-method}
\alias{plet,SpatVectorCollection-method}

\alias{lines,leaflet-method}
\alias{points,leaflet-method}
\alias{polys,leaflet-method}

\title{Plot with leaflet}

\description{
Plot a SpatRaster(Collection) or SpatVector(s) to make an interactive leaflet map that is displayed in your browser.

The arguments of \code{plet} are similar to those of \code{\link[terra]{plot}}, making it easier to use leaflet (if you also use plot).
}

\usage{
\S4method{plet}{SpatRaster}(x, y=1, col, alpha=0.8, main=names(x), 
	tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), 
	wrap=TRUE, maxcell=500000, stretch=NULL, legend="bottomright", 
	shared=FALSE, panel=FALSE, collapse=TRUE, type=NULL, breaks=NULL,
	breakby="eqint", range=NULL, fill_range=FALSE, hover=FALSE, map=NULL, ...) 


\S4method{plet}{SpatRasterCollection}(x, col, alpha=0.8, main=names(x), 
	tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), 
	wrap=TRUE, maxcell=500000, stretch=NULL, legend="bottomright", type=NULL, 
	breaks=NULL, breakby="eqint", range=NULL, fill_range=FALSE, map=NULL, ...)


\S4method{plet}{SpatVector}(x, y="", col, main=y, cex=1, 
	lwd=2, lty=NULL, border="black", alpha=c(0.3, 1), popup=TRUE, label=FALSE,
	split=FALSE, tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), 
	wrap=TRUE, legend="bottomright", collapse=FALSE, type=NULL, breaks=NULL,
	breakby="eqint", sort=TRUE, reverse=FALSE, map=NULL, fill=NULL, ...)

\S4method{plet}{data.frame}(x, ...)

\S4method{plet}{SpatVectorCollection}(x, y="", col, main=y, cex=1, 
	lwd=2, lty=NULL, border="black", alpha=c(0.3, 1), popup=TRUE, label=FALSE, 
	tiles=c("Streets", "Esri.WorldImagery", "OpenTopoMap"), 
	wrap=TRUE, legend="bottomright", collapse=FALSE, type=NULL, breaks=NULL, 
	breakby="eqint", sort=TRUE, reverse=FALSE, map=NULL, fill=NULL, ...)


\S4method{lines}{leaflet}(x, y, field="", col, lwd=2, lty=NULL, alpha=1, 
	label=NULL, popup=FALSE, legend="bottomright", ...)

\S4method{points}{leaflet}(x, y, field="", col, border=col, cex=1, lwd=2, lty=NULL, 
	alpha=c(.3, 1), label=1:nrow(y), popup=FALSE, legend="bottomright", ...)

\S4method{polys}{leaflet}(x, y, field="", col, lwd=2, lty=NULL, 
	border="black", alpha=c(0.3, 1), popup=TRUE, label=NULL, 
	legend="bottomright", fill=NULL, ...)
}


\arguments{
  \item{x}{SpatRaster, SpatVector, or leaflet object. If \code{x} is a data.frame, an attempt is made to create a SpatVector from it with the \code{\link{vect}} method for a data.frame}
  \item{y}{missing, or positive integer, or character (variable or layer name) indicating the layer(s) to be plotted. If \code{x} is a SpatRaster, you can select multiple layers. If \code{x} is a leaflet object, \code{y} is the SpatVector to be added to the map}
  \item{field}{character (variable name) or positive integer (column number) to color the points, lines, or polygons by the values of that variable of SpatVector \code{y} (if \code{x} is a leaflet object). Use \code{""} to not color by a variable}
  \item{col}{character. Vector of colors or a color generating function. If \code{x} is a SpatVectorCollection, you can provide a list with colors and/or functions, with one list element for each SpatVector}
  \item{alpha}{one or two numbers between 0 and 1 to set the transparency for lines (0 is transparent, 1 is opaque). The first number is to fill the points/lines/polygons, the second for the outline}
  \item{tiles}{character or NULL. Names of background tile providers}
  \item{wrap}{logical. if \code{TRUE}, tiles wrap around}
  \item{maxcell}{positive integer. Maximum number of cells to use for the plot} 
  \item{stretch}{NULL or character ("lin" or "hist") to stretch RGB rasters. See \code{\link{plotRGB}}} 
  
  \item{legend}{character to indicate the legend position ("bottomleft", "bottomright", "topleft" or "topright") or NULL to suppress the legend}
  \item{main}{character. Title for the legend. The length should be 1 if \code{x} is a SpatVector and length nlyr(x) if \code{x} is a SpatVector}
  
  \item{shared}{logical. Should the legend be the same for all rasters (if multiple layers of SpatRaster \code{x} are mapped)}  
  \item{map}{leaflet object}
  \item{...}{additional arguments for drawing points, lines, or polygons passed on the relevant leaflet function}


  \item{border}{character. Color for the polygon borders}
  \item{collapse}{logical. Should the layers "control" panel be collapsed?}
  \item{split}{logical. If \code{TRUE} a check-box is created to toggle each value in \code{y} (If \code{x} is a SpatVector)}
  \item{cex}{numeric. point size magnifier. See \code{\link{par}}}
  \item{lwd}{numeric. line-width. See \code{\link{par}}}
  \item{lty}{character to specify a "dash-array". For example "3 5" indicates three pixels lines with five pixel gaps}
  \item{popup}{logical. Should pop-ups be created?}
  \item{label}{logical. Should mouse-over labels be added?}
  \item{panel}{logical. Should SpatRaster layers be shown as a panel"}

  \item{type}{character. Type of map/legend. One of "classes", or "interval". If not specified, the type is chosen based on the data. Use "" to suppress the legend}
  \item{breaks}{numeric. Either a single number to indicate the number of breaks desired, or the actual breaks. When providing this argument, the default legend becomes "interval"}
  \item{breakby}{character or function. Either "eqint" for equal interval breaks, "cases" for equal quantile breaks. If a function is supplied it should take a single argument (a vector of values) and create groups}
    \item{sort}{logical. If \code{TRUE} legends with character values are sorted. You can also supply a vector of the unique values, in the order in which you want them to appear in the legend}
	
  \item{range}{numeric. minimum and maximum values to be used for the continuous legend. You can use \code{NA} for one of these to only set the minimum or maximum value}
  \item{fill_range}{logical. If \code{TRUE}, values outside of \code{range} get the colors of the extreme values; otherwise they get colored as \code{NA}}
  \item{hover}{logical. If \code{TRUE}, the approximate raster cell values are shown when hovering the mouse over the map. Not available for RGB rasters or panel mode}
	
  \item{reverse}{logical. If \code{TRUE}, the legends order is reversed}
  \item{fill}{do not use. Will be removed}

}

\seealso{
 \code{\link{plot}}
}


\examples{ 
\dontrun{
if (require(leaflet) && (packageVersion("leaflet") > "2.1.1")) {

v <- vect(system.file("ex/lux.shp", package="terra"))
p <- spatSample(as.polygons(v, ext=TRUE), 30)
values(p) = data.frame(id=11:40, value=rep(LETTERS[1:3], 10))

m <- plet(v, "NAME_1", tiles="", border="blue")
m <- points(m, p, col="red", cex=2, popup=TRUE)
lines(m, v, lwd=1, col="white")

# color by the values of a variable
plet(v, tiles="") |> points(p, cex=8)
plet(v, "NAME_1", tiles="") |> points(p, field="value", cex=8, alpha=.9,
				col=c("red", "blue", "yellow"), popup=TRUE)

plet(v, "NAME_1", split=TRUE, alpha=.2) |> 
  points(p, col="white", border="red", cex=12, popup=TRUE, lwd=3, lty="1 4",
   	clusterOptions = leaflet::markerClusterOptions())

# SpatVectorCollection

s <- svc(v, p)
names(s) <- c("the polys", "set of points")
plet(s, col=c("red", "blue"), lwd=1)

# SpatRaster 

r <- rast(system.file("ex/elev.tif", package="terra"))
plet(r, main="Hi\nthere", tiles=NULL) |> lines(v, lwd=1)

# hover to see raster values
plet(r, hover=TRUE)

plet(r, tiles="OpenTopoMap") |> lines(v, lwd=2, col="blue")

x <- c(r, 50*classify(r, 5))
names(x) <- c("first", "second")

# each their own legend
plet(x, 1:2, collapse=FALSE) |> lines(v, lwd=2, col="blue", lty="5,5")

# shared legend
plet(x, 1:2, shared=TRUE, collapse=FALSE) |> lines(v, lwd=2, col="blue")

}}}

\keyword{methods}
\keyword{spatial}

\name{shift}

\docType{methods}

\alias{shift}
\alias{shift,SpatRaster-method}
\alias{shift,SpatExtent-method}
\alias{shift,SpatVector-method}
  
\title{Shift}

\description{
Shift a SpatRaster, SpatVector or SpatExtent to another location.
}

\usage{
\S4method{shift}{SpatRaster}(x, dx=0, dy=0, filename="", ...)

\S4method{shift}{SpatVector}(x, dx=0, dy=0)

\S4method{shift}{SpatExtent}(x, dx=0, dy=0)
}

\arguments{
  \item{x}{SpatRaster, SpatVector or SpatExtent}
  \item{dx}{numeric. The shift in horizontal direction}
  \item{dy}{numeric. The shift in vertical direction}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}
 
\value{
Same as \code{x}
}


\seealso{ \code{\link{flip}}, \code{\link{rotate}}}

\examples{
r <- rast(xmin=0, xmax=1, ymin=0, ymax=1)
r <- shift(r, dx=1, dy=-1)

e <- ext(r)
shift(e, 5, 5)
}

\keyword{spatial}

\name{ar_info}

\alias{ar_info}

\title{Describe a multi-dimensional array file}

\description{
Describe a multi-dimensional array file (e.g., NetCDF)
}

\usage{
ar_info(x, what="describe", simplify=TRUE, filter=TRUE, array="")
}

\arguments{
  \item{x}{character. The name of a netcdf (or similar) raster file}
  \item{what}{character that (partially) matches "describe", "arrays" or "dimensions"}
  \item{simplify}{logical. If \code{TRUE} and \code{what="describe"}, simplify the output for readability}   
  \item{filter}{logical. If \code{TRUE} and \code{what="describe"} filter arrays that (probably) dimensions}   
  \item{array}{character. Required when \code{what="dimensions"}}   
}

\value{
character or data.frame
}

\seealso{\code{\link{describe}}}

\keyword{spatial}

\name{legend_cont}

\alias{legend_cont}

\title{Add a continuous legend}

\description{
Add a continuous (color gradient) legend to an existing plot. This can be used with any base plot, not just \code{\link{plot,SpatRaster,numeric-method}}. The legend is drawn as a color bar with tick marks and labels.
}

\usage{
legend_cont(x="right", y=NULL, legend, col,
    size=NULL, title=NULL, at=NULL, digits=NULL, ...)
}


\arguments{
  \item{x}{character or numeric. Position of the legend. Keywords: \code{"right"}, \code{"left"}, \code{"top"}, \code{"bottom"}, \code{"topright"}, \code{"bottomright"}. Or a numeric x-coordinate (see \code{y})}
  \item{y}{numeric. Optional y-coordinate(s) for the legend position, used when \code{x} is numeric}
  \item{legend}{SpatRaster or numeric vector. Used to determine the value range of the legend. If a SpatRaster, the range is taken from \code{\link{minmax}}. If numeric (e.g. \code{c(min, max)}), the range of the values is used}
  \item{col}{character. Vector of colors for the gradient. If missing, the default palette is used (\code{map.pal("viridis", 100)})}
  \item{size}{numeric. One or two values to control the size of the legend bar. The first value scales the length (0 to 1), the second scales the width}
  \item{title}{character. Title to display above or beside the legend bar}
  \item{at}{numeric. Specific values at which to place tick marks. If \code{NULL} (the default), ticks are placed automatically with \code{\link{pretty}}}
  \item{digits}{non-negative integer. Number of decimal places for tick labels. If \code{NULL} (the default) an appropriate number is computed from the range}
  \item{...}{Additional legend parameters: \code{bg} (background color behind the legend, e.g. \code{"white"}), \code{cex}, \code{horiz}, \code{reverse}, \code{labels}, \code{tic} (or \code{tick}), \code{tic.col}, \code{tic.lwd}, \code{tic.box.col}, and others (see the \code{plg} argument in \code{\link{plot,SpatRaster,numeric-method}} for details)}
}


\value{
Invisible list with the legend parameters (can be used for further customization).
}


\seealso{\code{\link{add_legend}}, \code{\link{add_box}}, \code{\link{plot,SpatRaster,numeric-method}}}


\examples{
# with a SpatRaster
r <- rast(ncols=40, nrows=40, xmin=0, xmax=1, ymin=0, ymax=1, vals=runif(1600))
plot(r, legend=FALSE, mar=c(3.1, 3.1, 2.1, 7.1))
legend_cont("right", legend=r)

# horizontal
plot(r, legend=FALSE, mar=c(6.1, 3.1, 2.1, 2.1))
legend_cont("bottom", legend=r, horiz=TRUE, title="values")

# on the map 
plot(r, legend=FALSE, alpha=0.1)
legend_cont(0.1, legend=r)
legend_cont(0.3, c(0.5, 0.9), legend=r, bg="white")
legend_cont(c(0.4, 0.8), 0.2, horiz=TRUE, legend=r, bg="white")


# with a numeric range and custom colors
cols <- heat.colors(100)
vals <- seq(5,95,10)
par(mar=c(3.1, 3.1, 2.1, 7.1))
plot(1:10, col=cols[vals], cex=2, pch=20)
legend_cont("right", legend=c(1, 100), col=cols)

}

\keyword{methods}
\keyword{spatial}

\name{is.empty}

\alias{is.empty}
\alias{is.empty,SpatVector-method}
\alias{is.empty,SpatExtent-method}

  
\title{Check if a SpatExtent or SpatVector is empty}

\description{
An empty SpatExtent has no area

An empty SpatVector has no geometries.
}

\usage{
\S4method{is.empty}{SpatExtent}(x)

\S4method{is.empty}{SpatVector}(x)
}

\arguments{
\item{x}{SpatVector or SpatExtent}
}

\value{
logical
}

\examples{
e <- ext(0,0,0,0)
is.valid(e)
is.empty(e)

v <- vect()
is.valid(v)
is.empty(v)
}
\keyword{spatial}

\name{summary}

\docType{methods}

\alias{summary}
\alias{summary,SpatRaster-method}
\alias{summary,SpatVector-method}
\alias{Summary,SpatExtent-method}
\alias{Summary,SpatRaster-method}
\alias{Summary,SpatVector-method}

\title{summary}

\description{
Compute summary statistics (min, max, mean, and quartiles) for SpatRaster using base \code{\link[base]{summary}} method. A sample is used for very large files. 

For single or other statistics see \code{\link{Summary-methods}}, \code{\link{global}}, and \code{\link{quantile}} 
}

\usage{
\S4method{summary}{SpatRaster}(object, size=100000, warn=TRUE, ...)

\S4method{summary}{SpatVector}(object, ...)
}

\arguments{
  \item{object}{SpatRaster or SpatVector}
  \item{size}{positive integer. Size of a regular sample used for large datasets (see \code{\link{spatSample}})}
  \item{warn}{logical. If \code{TRUE} a warning is given if a sample is used}  
  \item{...}{additional arguments passed on to the base \code{\link[base]{summary} method}}  
}


\value{matrix with (an estimate of) the median, minimum and maximum values, the first and third quartiles, and the number of cells with \code{NA} values}


\seealso{ \code{\link{Summary-methods}}, \code{\link{global}}, \code{\link{quantile}} }

\examples{
set.seed(0)
r <- rast(nrows=10, ncols=10, nlyrs=3)
values(r) <- runif(nlyr(r)*ncell(r))
summary(r)
}

\keyword{methods}
\keyword{spatial}

\name{rangeFill}

\alias{rangeFill}
\alias{rangeFill,SpatRaster-method}

\title{Fill layers with a range}

\description{
Fill layers with cell-varying ranges defined by a start and end SpatRaster. The range must start at 1 and end at a user-defined maximum. Output values are either zero (not in the range) or one (in the range).

For example, for a cell with \code{start=3}, \code{end=5} and with \code{limit=8}, the output for that cell would be \code{0,0,1,1,1,0,0,0}
}

\usage{
\S4method{rangeFill}{SpatRaster}(x, limit, circular=FALSE, filename="", ...) 
}

\arguments{
\item{x}{SpatRaster with at two layers. The cell values of the first layer indicate the start of the range (1 based); the cell values are indicate the end of the range}

\item{limit}{numeric > 1. The range size}

\item{circular}{logical. If \code{TRUE} the values are considered circular, such as the days of the year. In that case, if first > last the layers used are c(first:limit, 1:last). Otherwise, if \code{circular=FALSE}, such a range would be considered invalid and \code{NA} would be used} 

\item{filename}{character. Output filename}

\item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}

}

\value{SpatRaster}


\seealso{ \code{\link{rapp}} } 


\examples{

x <- y <- rast(ncol=2, nrow=2)
values(x) <- c(NA, 1:3)
values(y) <- c(NA, 4:6)

r <- rangeFill(c(x, y), 8)
}


\keyword{spatial}

\name{subset_single}

\alias{[}

\alias{[,SpatExtent,missing,missing-method}
\alias{[,SpatExtent,numeric,missing-method}

\alias{[,SpatRaster,ANY,ANY,ANY-method}
\alias{[,SpatRaster,ANY,ANY-method}

\alias{[,SpatRasterDataset,logical,missing-method}
\alias{[,SpatRasterDataset,character,missing-method}

\alias{[,SpatRasterDataset,numeric,missing-method}
\alias{[,SpatRasterDataset,numeric,numeric-method}
\alias{[,SpatRasterDataset,numeric,logical-method}

\alias{[,SpatRasterDataset,missing,numeric-method}
\alias{[,SpatRasterDataset,missing,logical-method}

\alias{[,SpatRasterCollection,numeric,missing-method}

\alias{[,SpatVector,missing,missing-method}
\alias{[,SpatVector,missing,numeric-method}
\alias{[,SpatVector,missing,character-method}
\alias{[,SpatVector,missing,logical-method}
\alias{[,SpatVector,character,missing-method}
\alias{[,SpatVector,numeric,missing-method}
\alias{[,SpatVector,numeric,numeric-method}
\alias{[,SpatVector,numeric,character-method}
\alias{[,SpatVector,numeric,logical-method}
\alias{[,SpatVector,logical,missing-method}
\alias{[,SpatVector,logical,character-method}
\alias{[,SpatVector,logical,numeric-method}
\alias{[,SpatVector,logical,logical-method}
\alias{[,SpatVector,data.frame,missing-method}
\alias{[,SpatVector,data.frame,ANY-method}
\alias{[,SpatVector,matrix,missing-method}

\alias{[,SpatVector,SpatVector,missing-method}
\alias{[,SpatVector,SpatExtent,missing-method}
\alias{[,SpatRaster,SpatVector,missing-method}
\alias{[,SpatRaster,missing,missing-method}
\alias{[,SpatRaster,numeric,missing-method}
\alias{[,SpatRaster,missing,numeric-method}
\alias{[,SpatRaster,numeric,numeric-method}
\alias{[,SpatRaster,data.frame,missing-method}
\alias{[,SpatRaster,matrix,missing-method}
\alias{[,SpatRaster,SpatRaster,missing-method}
\alias{[,SpatRaster,SpatExtent,missing-method}


\title{Extract values from a SpatRaster, SpatVector or SpatExtent}

\description{
Extract values from a SpatRaster; a subset of records (row) and/or variables (columns) from a SpatVector; or a number from a SpatExtent.  

You can use indices (row, column, layer or cell numbers) to extract. You can also use other Spat* objects. 
}

\usage{
\S4method{[}{SpatRaster,ANY,ANY,ANY}(x, i, j, k)

\S4method{[}{SpatVector,numeric,numeric}(x, i, j, drop=FALSE)

\S4method{[}{SpatVector,SpatVector,missing}(x, i, j)

\S4method{[}{SpatExtent,numeric,missing}(x, i, j)

}

\arguments{
  \item{x}{SpatRaster, SpatVector or SpatExtent}
  \item{i}{
  if \code{x} is a \code{SpatRaster}: numeric, logical or missing to select rows or, if \code{j} is missing, to select cells numbers.
  
  if \code{x} is a \code{SpatVector}: numeric or missing to select rows. 
  if \code{i} is another SpatVector: get a new SpatVector with the geometries that intersect.

  if \code{x} is a \code{SpatExtent}: integer between 1 and 4.
  }
  \item{j}{numeric, logical, or missing to select columns}

  \item{k}{numeric, character, or missing to select layers}

  \item{drop}{logical. If \code{FALSE} an object of the same class as \code{x} is returned}
}

\value{
numeric if \code{x} is a SpatExtent. 
Same as \code{x} if \code{drop=FALSE}. Otherwise a data.frame
}

\seealso{\code{\link{extract}}, \code{\link{subset}}, \code{\link{$}}, \code{\link{[[}}}

\examples{
### SpatRaster
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
r[3638]
rowColFromCell(r, 2638)
r[39, 28]
x <- r[39:40, 28:29, drop=FALSE] 
as.matrix(x, wide=TRUE)

### SpatVector

v <- vect(system.file("ex/lux.shp", package="terra"))
v[2:3,]
v[1:2, 2:3]
v[1:2, 2:3, drop=TRUE]
}

\keyword{ spatial }

\name{hull}

\docType{methods}

\alias{hull}
\alias{hull,SpatVector-method}
\alias{convHull}
\alias{convHull,SpatVector-method}

\title{ 
Convex, concave, rectangular and circular hulls
}

\description{
Compute hulls around SpatVector geometries. This can be the convex hull, the minimal bounding rotated rectangle, the minimal bounding circle, or a concave hull. The concaveness of the concave hull can be specified in different ways.

The old method \code{convHull} is deprecated and will be removed in a future version. 
}

\usage{
\S4method{hull}{SpatVector}(x, type="convex", by="", param=1, allowHoles=TRUE, tight=TRUE)
}

\arguments{
  \item{x}{SpatVector}
  \item{type}{character. One of "convex", "rectangle", "circle", "concave_ratio", "concave_length"}
  \item{by}{character (variable name), to get a new geometry for groups of input geometries. Use \code{""} to get a hull around all geometries combined. Use \code{NA} to get a hull around each geometry in \code{x}}
  \item{param}{numeric between 0 and 1. For the "concave_*" types only. For \code{type="concave_ratio"} this is the edge length ratio value, between 0 and 1. For \code{type="concave_length"} this the maximum edge length (a value > 0). For \code{type="concave_polygons"} this specifies the maximum Edge Length as a fraction of the difference between the longest and shortest edge lengths between the polygons. This normalizes the maximum edge length to be scale-free. A value of 1 produces the convex hull; a value of 0 produces the original polygons}
  \item{allowHoles}{logical. May the output polygons contain holes? For "concave_*" methods only}
  \item{tight}{logical. Should the hull follow the outer boundaries of the input polygons? For "concave_length" with polygon geometry only}
}

\value{
SpatVector
}


\details{
A concave hull is a polygon which contains all the points of the input. It can be a better representation of the input data (typically points) than the convex hull. There are many possible concave hulls with different degrees of concaveness. These can be created with argument \code{param}.

The hull is constructed by removing the longest outer edges of the Delaunay Triangulation of the space between the polygons, until the target criterion \code{param} is reached. If \code{type="concave_ratio"}, \code{param} expresses the ratio between the lengths of the longest and shortest edges. 1 produces the convex hull; 0 produces a hull with maximum concaveness. If \code{type="concave_length"}, \code{param} specifies the maximm edge length. A large value produces the convex hull, 0 produces the hull of maximum concaveness.
}



\examples{
p <- vect(system.file("ex/lux.shp", package="terra"))
h <- hull(p)

plot(p)
lines(h, col="orange")

hh <- hull(p, "convex", by="NAME_1")
lines(hh, col="purple")

pts <- centroids(p)
plot(pts, ext=ext(p)+0.1)
lines(hull(pts, type="convex"), col="darkgreen")
lines(hull(pts, type="rect"), col="blue")
lines(hull(pts, type="circle"), col="red")

}

\keyword{methods}
\keyword{spatial}

\name{subst}

\docType{methods}

\alias{subst}
\alias{subst,SpatRaster-method}

\title{replace cell values}

\description{
Substitute(replace) cell values of a SpatRaster with a new value. See \code{\link{classify}} for more complex/flexible replacement. 
}

\usage{
\S4method{subst}{SpatRaster}(x, from, to, others=NULL, raw=FALSE, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{from}{numeric value(s). Normally a vector of the same length as `to`. If \code{x} has multiple layers, it can also be a matrix of numeric value(s) where \code{nrow(x) == length(to)}. In that case the output has a single layer, with values based on the combination of the values of the input layers. For single-layer replacement with numeric vectors, an optimized hash-based lookup is used. Floating point values are supported and are matched exactly.}
  \item{to}{numeric value(s). Normally a vector of the same length as `from`. If \code{x} has a single layer, it can also be a matrix of numeric value(s) where \code{nrow(x) == length(from)}. In that case the output has multiple layers, one for each column in \code{to}} 
  \item{others}{numeric. If not \code{NULL} all values that are not matched are set to this value. Otherwise they retain their original value.} 
  \item{raw}{logical. If \code{TRUE}, the values in from and to are the raw cell values, not the categorical labels. Only relevant if \code{is.factor(x)}}
  \item{filename}{character. Output filename}
  \item{...}{Additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\author{Andrew Gene Brown, Robert J. Hijmans}

\seealso{\code{\link{classify}}, \code{\link{clamp}}}

\examples{
r <- rast(ncols=5, nrows=5, xmin=0, xmax=1, ymin=0, ymax=1, crs="")
r <- init(r, 1:6)
x <- subst(r, 3, 7)
x <- subst(r, 2:3, NA)
x <- subst(x, NA, 10)

# multiple output layers
z <- subst(r, 2:3, cbind(20,30))

# multiple input layers
rr <- c(r, r+1, r+2)
m <- rbind(c(1:3), c(3:5))
zz <- subst(rr, m, c(100, 200))
}

\keyword{spatial}

\name{focal3D}

\alias{focal3D}
\alias{focal3D,SpatRaster-method}

\title{Three-dimensional focal values}

\description{
Calculate focal ("moving window") values for the three-dimensional neighborhood (window) of focal cells. See \code{\link{focal}} for two-dimensional focal computation.
}

\usage{
\S4method{focal3D}{SpatRaster}(x, w=3, fun=mean, ..., na.policy="all", fillvalue=NA, pad=FALSE, 
	padvalue=fillvalue, expand=FALSE, silent=TRUE, 
	filename="", overwrite=FALSE, wopt=list()) 
}

\arguments{
\item{x}{SpatRaster}
  
\item{w}{window. A rectangular prism (cuboid) defined by three numbers or by a three-dimensional array. The values are used as weights, and are usually zero, one, NA, or fractions. The window used must have odd dimensions. If you desire to use even sides, you can use an array, and pad the values with rows and/or columns that contain only \code{NA}s.
}

\item{fun}{function that takes multiple numbers, and returns one or multiple numbers for each focal area. For example mean, modal, min or max}

\item{...}{additional arguments passed to \code{fun} such as \code{na.rm}}

\item{na.policy}{character. Can be used to determine the cells of \code{x}, in the central layer, for which focal values should be computed. Must be one of "all" (compute for all cells), "only" (only for cells that are \code{NA}) or "omit" (skip cells that are \code{NA}). Note that the value of this argument does not affect which cells around each focal cell are included in the computations (use \code{na.rm=TRUE} to ignore cells that are \code{NA} in the computation of the focal value)}

\item{fillvalue}{numeric. The value of the cells in the virtual rows and columns outside of the raster}

\item{pad}{logical. Add virtual layers before the first and after the last layer}

\item{padvalue}{numeric. The value of the cells in the virtual layers}

\item{expand}{logical. Add virtual layers before the first or after the last layer that are the same as the first or last layers. If \code{TRUE}, arguments \code{pad} and \code{padvalue} are ignored}

\item{silent}{logical. If \code{TRUE} error messages are printed that may occur when trying \code{fun} to determine the length of the returned value. This can be useful in debugging a function passed to \code{fun} that does not work}

\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}

\item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{SpatRaster}

\seealso{ \code{\link{focal}}}

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
x <- focal3D(r, c(5,5,3), na.rm=TRUE)

a <- array(c(0,1,0,1,1,1,0,1,0, rep(1,9), 0,1,0,1,1,1,0,1,0), c(3,3,3))
a[a==0] <- NA
z <- focal3D(r, a, na.rm=TRUE)
}

\keyword{spatial}

\name{tessellate}

\docType{methods}

\alias{tessellate}
\alias{tessellate,ANY-method}


\title{
Create a tessellation
}

\description{
Create a tessellation of polygons with no gaps or overlaps that cover constant area. The polygons can be hexagons or rectangles. For lon/lat coordinates it is also possible to use (Goldberg) polyhedrons with 12 pentagonal cells and 10*(n^2-1) hexagonal cells, of approximately equal size. Hexagons have constant area, but varying shape with lon/lat coordinates. 
}

\usage{
\S4method{tessellate}{ANY}(x, size, n, type="hexagon", flat_top=FALSE, align="fit", geo=NULL)
}

\arguments{
  \item{x}{SpatRaster, SpatVector or other object from which a SpatExtent can be extracted. If missing, a global lon/lat extent is used}
  \item{size}{positive number. The "across-flats" distance of a hexagon, or the center-to-center distance to the nearest neighbour in the dominant direction. The unit is the unit of the input crs, or meters for longitude/latitude data. Size is approximate for polyhedrons}
  \item{n}{positive integer. Polyhedron subdivision frequency. The output has 10*n^2 + 2 cells in total (12 pentagons + 10*(n^2 - 1) hexagons). If this is supplied, argument \code{size} is ignored}
  \item{type}{character. One of "hexagons", "rectangles", or "polyhedron"}
  \item{flat_top}{logical. If \code{TRUE}, hexagons have two horizontal (flat) edges; if \code{FALSE} (the default) they have two vertical edges and a vertex pointing up and down (pointy-top)}
  \item{align}{character. rectangle alignment, one of "fit" (all retangles fit within the extent, creating variability in size), "align" all rectangles (except perhaps the polar rectangles) have equal-area, but may stick out of the extent), or "cube" (rectangles are "cubes" in terms of naive longitude/latitude math, and may stick out of the extent)}
  \item{geo}{logical. If \code{TRUE}, and \code{x} is a SpatExtent, the coordinates of \code{x} are interpreted longitude/latitude. If it is \code{NULL} the coordinates are used to guess the CRS from the coordinates. If \code{FALSE} the CRS is set to "local" if \code{x} does not have a CRS}
}

\value{
SpatVector of polygons
}

\seealso{
\code{\link{as.polygons}}
}

\examples{
# planar hexagons (exact tiling, equal Cartesian area)
e <- ext(0, 100, 0, 100)
h <- tessellate(e, size=10)
plot(h)

# flat-top hexagons over a raster's extent
r <- rast(nrows=10, ncols=10, xmin=0, xmax=100, ymin=0, ymax=80, crs="local")
h2 <- tessellate(r, size=15, flat_top=TRUE)
plot(h2)

# rectangles
r1 <- tessellate(r, size=15, type="rect", geo=FALSE)
r2 <- tessellate(ext(r), size=1000000, type="rect", geo=TRUE)
r3 <- tessellate(ext(r), size=1000000, type="rect", align="equal", geo=TRUE)
r4 <- tessellate(ext(r), size=1000000, type="rect", align="cube", geo=TRUE)

# global lon/lat equal-area hexagon tessellation
g <- tessellate(size=1000000, geo=TRUE)
g

# global polyhedron, frequency 10 -> 12 pentagons + 990 hexagons
g1 <- tessellate(n=10, type="polyhedron")
g1$size <- expanse(g1)
plot(g1, "type", col=c("tomato", "skyblue"))
plot(g1, "size")


# the truncated icosahedron ("football"): n=1, 12 pentagons + 0 hexagons
g2 <- tessellate(n=1, type="polyhedron")

# specify cell size in meters instead of frequency
g3 <- tessellate(size=1000000, type="polyhedron")

}

\keyword{methods}
\keyword{spatial}

\name{update}

\alias{update}
\alias{update,SpatRaster-method}

  
\title{Update a raster file}

\description{
Update metadata or cell values of a file that is the data source of a SpatRaster. This modifies the file on disk directly without reading the entire raster into memory.

BE CAREFUL with this function as you are overwriting data in an existing file.
}

\usage{
\S4method{update}{SpatRaster}(object, crs=FALSE, extent=FALSE, names=FALSE,
    cells=NULL, values=NULL, layer=0)
}

\arguments{
  \item{object}{SpatRaster with a file source}
  \item{crs}{logical. Should the coordinate reference system be updated?}
  \item{extent}{logical. Should the extent be updated?}
  \item{names}{logical. Should the names be updated?}
  \item{cells}{numeric. Cell numbers to update (1-indexed). Must be used together with \code{values}}
  \item{values}{numeric. New values for the specified cells. Can be a single value (recycled), one value per cell (applied to all layers), or \code{length(cells) * length(layer)} values (one per cell per layer, in layer-major order)}
  \item{layer}{numeric or character. Layer(s) to update. Use \code{0} (default) to update all layers. Positive integers or layer names select specific layers}
}

\value{SpatRaster (invisibly)}

\details{
The \code{cells} and \code{values} arguments allow updating specific cell values on disk without loading the raster into memory. This is useful for modifying very large rasters that cannot fit in memory. See \code{\link{set.values}} for modifying values of in-memory rasters.
}

\examples{
## update metadata
s <- rast(system.file("ex/logo.tif", package="terra"))   
fname <- paste0(tempfile(), ".tif")
x <- writeRaster(s*1, fname)

ext(x) <- ext(x) + 1
crs(x) <- "+proj=utm +zone=1"
names(x) <- LETTERS[1:3]

update(x, crs=TRUE, extent=TRUE, names=TRUE)

rast(fname)

## update cell values on disk
r <- rast(nrows=10, ncols=10, vals=1:100)
f <- paste0(tempfile(), ".tif")
x <- writeRaster(r, f)
x[c(1, 2, 50, 51, 100)]
update(x, cells=c(1, 50, 100), values=c(999, 888, 777))
rast(f)[c(1, 2, 50, 51, 100)]

## update specific layer only
r <- rast(nrows=5, ncols=5, nlyr=3, vals=1:75)
f <- paste0(tempfile(), ".tif")
x <- writeRaster(r, f, datatype="FLT4S")
x[c(1, 2, 25, 26)]
update(x, cells=c(1, 25), values=c(0, 0), layer=2)
rast(f)[c(1, 2, 25, 26)]
}

\keyword{spatial}

\name{subset}

\alias{subset}
\alias{subset,SpatRaster-method}
\alias{subset,SpatVector-method}

\title{Subset a SpatRaster or a SpatVector}

\description{
Select a subset of layers from a SpatRaster or select a subset of records (row) and/or variables (columns) from a SpatVector.  
}

\usage{
\S4method{subset}{SpatRaster}(x, subset, negate=FALSE, NSE=FALSE, filename="", overwrite=FALSE, ...)

\S4method{subset}{SpatVector}(x, subset, select, drop=FALSE, NSE=FALSE)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{subset}{
  if \code{x} is a \code{SpatRaster}: integer or character to select layers

  if \code{x} is a \code{SpatVector}: logical expression indicating the rows to keep (missing values are taken as FALSE), or another \code{Spat*} object in which case the extent is used to spatially subset the intersecting geometries
  }
  \item{select}{expression, indicating columns to select} 
  \item{negate}{logical. If \code{TRUE} all layers that are \bold{not} in the subset are selected}
  \item{NSE}{logical. If \code{TRUE}, non-standard evaluation (the use of unquoted variable names) is allowed. Set this to \code{FALSE} when calling \code{subset} from a function} 
  \item{drop}{logical. If \code{TRUE}, the geometries will be dropped, and a data.frame is returned}  
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
if \code{x} is a \code{SpatRaster}: SpatRaster

if \code{x} is a \code{SpatVector}: SpatVector or, if \code{drop=TRUE}, a \code{data.frame}.
}

\seealso{\code{\link{$}}, \code{\link{[[}}, \code{\link{[}}}

\examples{
### SpatRaster
s <- rast(system.file("ex/logo.tif", package="terra"))   
subset(s, 2:3)
subset(s, c(3,2,3,1))

#equivalent to 
s[[ c(3,2,3,1) ]]

s[[c("red", "green")]]
s$red

# expression based (partial) matching of names with single brackets
s["re"]
s["^re"]

# not with double brackets
# s[["re"]]


### SpatVector

v <- vect(system.file("ex/lux.shp", package="terra"))

subset(v, v$NAME_1 == "Diekirch", c("NAME_1", "NAME_2"))

subset(v, NAME_1 == "Diekirch", c(NAME_1, NAME_2), NSE=TRUE)

# or like this
v[2:3,]
v[1:2, 2:3]
v[1:2, c("NAME_1", "NAME_2")]

# or by location, i.e. by spatial overlap with another object
poly <- as.polygons(ext(6, 6.4, 49.75, 50))
subset(v, poly)
v[poly]
}

\keyword{ spatial }

\name{plot_extent}

\docType{methods}

\alias{plot,SpatExtent,missing-method}

\title{Plot a SpatExtent}

\description{
Plot a SpatExtent. Use \code{\link{lines}} to add a SpatExtent to an existing map.

See \code{\link{plot}} for plotting other object types.
}

\usage{
\S4method{plot}{SpatExtent,missing}(x, y, ...)
}

\arguments{
  \item{x}{SpatExtent}
  \item{y}{missing}
  \item{...}{additional graphical arguments for lines}  
}

\seealso{
\code{\link{plot}}
}	

\examples{ 
r <- rast()
plot(ext(r))
}


\keyword{methods}
\keyword{spatial}

\name{depth}

\alias{depth}
\alias{depth<-}
\alias{depth,SpatRaster-method}
\alias{depth<-,SpatRaster-method}
\alias{depthName}
\alias{depthName<-}
\alias{depthName,SpatRaster-method}
\alias{depthName<-,SpatRaster-method}
\alias{depthUnit}
\alias{depthUnit<-}
\alias{depthUnit,SpatRaster-method}
\alias{depthUnit<-,SpatRaster-method}

  
\title{depth of SpatRaster layers}

\description{
Get or set the depth of the layers of a SpatRaster. Experimental. 
}

\usage{
\S4method{depth}{SpatRaster}(x)

\S4method{depth}{SpatRaster}(x)<-value

\S4method{depthName}{SpatRaster}(x)

\S4method{depthName}{SpatRaster}(x)<-value

\S4method{depthUnit}{SpatRaster}(x)

\S4method{depthUnit}{SpatRaster}(x)<-value
}

\arguments{
  \item{x}{SpatRaster}
  \item{value}{numeric vector (\code{depth}), or character (\code{depthName} and \code{depthUnit})}
}

\value{
numeric or SpatRaster
}

\seealso{\code{\link{time}}}

\examples{
s <- rast(nlyr=3)

depth(s) <- c(0, pi/2, pi)
depth(s)

depthName(s) <- "angle"
depthUnit(s) <- "radians"
s
}

\keyword{spatial}

\name{panel}

\docType{methods}

\alias{panel}
\alias{panel,SpatRaster-method}

\title{Map panel}

\description{
Show multiple maps that share a single legend. 
}

\usage{
\S4method{panel}{SpatRaster}(x, main, loc.main="topleft", nc, nr, maxnl=16, 
	maxcell=500000, box=FALSE, pax=list(), plg=list(), range=NULL, halo=TRUE, 
	type=NULL, ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{main}{character. Main plot titles (one for each layer to be plotted). You can use arguments \code{cex.main}, \code{font.main}, \code{col.main} to change the appearance}
  \item{loc.main}{numeric of character to set the location of the main title. Either two coordinates, or a character value such as "topleft")}
  \item{nc}{positive integer. Optional. The number of columns to divide the plotting device in (when plotting multiple layers)}
  \item{nr}{positive integer. Optional. The number of rows to divide the plotting device in (when plotting multiple layers)}
  \item{maxnl}{positive integer. Maximum number of layers to plot (for a multi-layer object)} 
  \item{maxcell}{positive integer. Maximum number of cells to use for the plot}
  \item{box}{logical. Should a box be drawn around the map?}
  \item{plg}{see \code{\link{plot}}}
  \item{pax}{see \code{\link{plot}}}
  \item{range}{numeric. minimum and maximum values to be used for the continuous legend }  
  \item{halo}{logical. Use a halo around main (the title)?}
  \item{type}{character. Type of map/legend. One of "continuous", "classes", or "interval". If not specified, the type is chosen based on the data}
  \item{...}{arguments passed to \code{plot("SpatRaster", "numeric")} and additional graphical arguments}  
}

\seealso{
 \code{\link{plot}} and see \code{rasterVis::levelplot} and \code{tidyterra::autoplot} for more sophisticated panel plots.
}

\examples{ 
r <- rast(system.file("ex/elev.tif", package="terra"))
v <- vect(system.file("ex/lux.shp", package="terra"))
x <- c(r, r/2, r*2, r)
names(x) <- paste0("(", LETTERS[1:4], ")")
panel(x)
panel(x, fun=function() lines(v), loc.main="topright")
}


\keyword{methods}
\keyword{spatial}

\name{sprc}

\docType{methods}

\alias{sprc}
\alias{sprc,missing-method}
\alias{sprc,list-method}
\alias{sprc,SpatRaster-method}
\alias{sprc,character-method}


\title{Create a SpatRasterCollection}

\description{
Methods to create a SpatRasterCollection. This is an object to hold a collection (list) of SpatRasters. There are no restrictions on the similarity of the SpatRaster geometry. 

They can be used to combine several SpatRasters to be used with \code{\link{merge}} or \code{\link{mosaic}}

You can create a SpatRasterCollection from a file with subdatasets.
}

\usage{
\S4method{sprc}{character}(x, ids=0, opts=NULL, raw=FALSE, noflip=FALSE, guessCRS=TRUE, domains="", group=FALSE) 

\S4method{sprc}{SpatRaster}(x, ...) 

\S4method{sprc}{list}(x) 

\S4method{sprc}{missing}(x) 

}

\arguments{
\item{x}{SpatRaster, list with SpatRasters, missing, or filename}
\item{ids}{optional. vector of integer subdataset ids. Ignored if the first value is not a positive integer}
\item{opts}{character. GDAL dataset open options}
\item{raw}{logical. If \code{TRUE}, scale and offset values are ignored}
\item{noflip}{logical. If \code{TRUE}, a raster (e.g. JPEG image) that is not georeferenced and that GDAL assigns a flipped extent to (\code{ymax < ymin}), is not considered flipped. This avoids the need to \code{\link{flip}} the raster vertically}
\item{guessCRS}{logical. If \code{TRUE} and the file does not specify a CRS but has an extent that is within longitude/latitude bounds, the longitude/latitude crs is assigned to the SpatRaster}
\item{domains}{character. Metadata domains to read (see \code{\link{metags}} to retrieve their values if there are any. "" is the default domain}
\item{group}{logical. If \code{TRUE}, files that share the same raster geometry are combined into a single multi-layer \code{SpatRaster}. Useful when tiles are split across folders with one file per band (e.g. Sentinel-2 / Landsat)}
\item{...}{additional SpatRasters} 
}

\value{
SpatRasterCollection
}

\seealso{
\code{\link{sds}}
}

\examples{
x <- rast(xmin=-110, xmax=-50, ymin=40, ymax=70, ncols=60, nrows=30)
y <- rast(xmin=-80, xmax=-20, ymax=60, ymin=30)
res(y) <- res(x)
values(x) <- 1:ncell(x)
values(y) <- 1:ncell(y)

z <- sprc(x, y)
z

}


\keyword{methods}
\keyword{spatial}

\name{wrapCache}

\alias{wrapCache}

\alias{wrapCache,SpatRaster-method}


\title{SpatRaster wrap with caching options}

\description{
Use \code{wrap} to pack a SpatRaster with caching options. See \code{\link{wrap}} for the general approach that is easier and better to use in most cases. 

This method allows for specifying a folder, or filenames, to cache all sources of a SpatRaster in a specific location (on disk).
}

\usage{
\S4method{wrapCache}{SpatRaster}(x, filename=NULL, path=NULL, overwrite=FALSE, ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{filename}{character. A single filename, or one filename per SpatRaster data source. If not \code{NULL}, the raster sources are saved in these files}
  \item{path}{character. If not \code{NULL}, the path where raster sources will be saved. Ignored if filenames is not \code{NULL}}
  \item{overwrite}{Should existing files be overwritten when \code{files} or \code{path} is not \code{NULL}? If this value is not \code{TRUE} or \code{FALSE}, only files that do not exist are created}
  \item{...}{Additional arguments for \code{writeRaster}. Only used for raster sources that are in memory, as other sources are cached by copying the files}  
}

\value{
PackedSpatRaster
}

\seealso{\code{\link{wrap}}, \code{\link{unwrap}}}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)

x <- wrapCache(r, path=tempdir())
x

}


\keyword{ spatial }
\keyword{ methods }

\name{classify}

\docType{methods}

\alias{classify}
\alias{classify,SpatRaster-method}

\title{Classify (or reclassify) cell values}

\description{
Classify values of a SpatRaster. The function (re-)classifies groups of values to other values. 

The classification is done based on the argument \code{rcl}. You can classify ranges by specifying a three-column matrix "from-to-becomes" or change specific values by using a two-column matrix "is-becomes". You can also supply a vector with "cuts" or the "number of cuts".

With "from-to-becomes" or "is-becomes" classification is done in the row order of the matrix. Thus, if there are overlapping ranges or values, the first time a number is within a range determines the reclassification value. 

With "cuts" the values are sorted, so that the order in which they are provided does not matter. 
}

\usage{
\S4method{classify}{SpatRaster}(x, rcl, include.lowest=FALSE, right=TRUE, 
     others=NULL, brackets=TRUE, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{rcl}{matrix for classification. This matrix must have 1, 2 or 3 columns. If there are three columns, the first two columns are "from" "to" of the input values, and the third column "becomes" has the new value for that range. 
  
  The two column matrix ("is", "becomes") can be useful for classifying integer values. In that case, the arguments \code{right} and \code{include.lowest} are ignored. For this case, an optimized hash-based lookup is used for improved performance. Floating point values are supported and are matched exactly.
  
  A single column matrix (or a vector) is interpreted as a set of cuts if there is more than one value. In that case the values are classified based on their location in-between the cut-values.  
  
  If a single number is provided, that is used to make that number of cuts, at equal intervals between the lowest and highest values of the SpatRaster.
  } 
  
  \item{include.lowest}{logical, indicating if a value equal to the lowest value in \code{rcl} (or highest value in the second column, for \code{right=FALSE}) should be included.}
  
 \item{right}{logical. If \code{TRUE}, the intervals are closed on the right (and open on the left). If \code{FALSE} they are open at the right and closed at the left. "open" means that the extreme value is *not* included in the interval. Thus, right-closed and left open is \code{(0,1] = {x | 0 < x <= 1}}. You can also close both sides with \code{right=NA}, that is only meaningful if you "from-to-becomes" classification with integers. For example to classify 1-5 -> 1, 6-10 -> 2, 11-15 -> 3. That may be easier to read and write than the equivalent 1-5 -> 1, 5-10 -> 2, 10-15 -> 3 with \code{right=TRUE} and \code{include.lowest=TRUE}}
 
 \item{others}{numeric. If not \code{NULL} all values that are not matched are set to this value. Otherwise they retain their original value.} 

 \item{brackets}{logical. If \code{TRUE}, intervals are have parenthesis or brackets around them to indicate whether they are open or closed. Only applies if \code{rcl} is a vector (or single column matrix)} 

 \item{filename}{character. Output filename}
 \item{...}{Additional arguments for writing files as in \code{\link{writeRaster}}}

}

\value{
SpatRaster
}

\author{Andrew Gene Brown, Robert J. Hijmans}


\seealso{\code{\link{subst}} for simpler from-to replacement, and \code{\link{clamp}}}

\note{
classify works with the "raw" values of categorical rasters, ignoring the levels (labels, categories). To change the labels of categorical rasters, use \code{\link{subst}} instead.

For model-based classification see \code{\link{predict}}
}

\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- (0:99)/99

## from-to-becomes
# classify the values into three groups 
# all values >= 0 and <= 0.25 become 1, etc.
m <- c(0, 0.25, 1,
       0.25, 0.5, 2,
       0.5, 1, 3)
rclmat <- matrix(m, ncol=3, byrow=TRUE)
rc1 <- classify(r, rclmat, include.lowest=TRUE)

## cuts
# equivalent to the above, but now a categorical SpatRaster is returned 
rc2 <- classify(r, c(0, 0.25, 0.5, 1), include.lowest=TRUE, brackets=TRUE)
freq(rc2)

## is-becomes 
x <- round(r*3)
unique(x)
# replace 0 with NA
y <- classify(x, cbind(0, NA))
unique(y)

# multiple replacements
m <- rbind(c(2, 200), c(3, 300))
m

rcx1 <- classify(x, m)
unique(rcx1)

rcx2 <- classify(x, m, others=NA)
unique(rcx2)
}

\keyword{spatial}

\name{sel}

\docType{methods}

\alias{sel}
\alias{sel,SpatRaster-method}
\alias{sel,SpatVector-method}

\title{
Spatial selection
}

\description{
Geometrically subset SpatRaster or SpatVector by drawing on a plot (map).

Note that for many installations this does not work well on the default RStudio plotting device. To work around that, you can first run \code{dev.new(noRStudioGD = TRUE)} which will create a separate window for plotting, then use \code{plot()} followed by \code{sel()} and click on the map. It may also help to set your RStudio "Tools/Global Options/Appearance/Zoom" to 100\%.
}


\usage{
\S4method{sel}{SpatRaster}(x, ...)

\S4method{sel}{SpatVector}(x, use="rec", show=TRUE, col="cyan", draw=TRUE, ...)
}

\arguments{
\item{x}{SpatRaster or SpatVector}
\item{use}{character indicating what to draw. One of "rec" (rectangle) or "pol" (polygon)}
\item{show}{logical. If \code{TRUE} the selected geometries are shown on the map}
\item{col}{color to be used for drawing if \code{draw=TRUE}}
\item{draw}{logical. If \code{TRUE} the area drawn to select geometries is shown on the map}
\item{...}{additional graphics arguments for drawing the selected geometries}
}

\seealso{
\code{\link{crop}} and \code{\link{intersect}} to make an intersection and \code{\link{click}} and \code{\link{text}} to see cell values or geometry attributes.

Use \code{\link{draw}} to draw a SpatExtent of SpatVector that you want to keep.
}


\value{
SpatRaster or SpatVector
}


\examples{
\dontrun{
# select a subset of a SpatRaster
r <- rast(nrows=10, ncols=10)
values(r) <- 1:ncell(r)
plot(r)
s <- sel(r) # now click on the map twice

# plot the selection on a new canvas:
x11()
plot(s)

# vector
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
plot(v)
x <- sel(v) # now click on the map twice
x
}
}

\keyword{spatial}

\name{viewshed}

\alias{viewshed}
\alias{viewshed,SpatRaster-method}

\title{Compute a viewshed}

\description{
Use elevation data to compute the locations that can be seen, or how much higher they would have to be to be seen, from a certain position. The raster data coordinate reference system must be planar (not lon/lat), with the elevation values in the same unit as the distance unit of the coordinate reference system. 
}

\usage{
\S4method{viewshed}{SpatRaster}(x, loc, observer=1.80, target=0, curvcoef=6/7, output="yes/no", filename="", ...) 
}

\arguments{
  \item{x}{SpatRaster, single layer with elevation values. Values should have the same unit as the map units}
  \item{loc}{location (x and y coordinates) or a cell number}
  \item{observer}{numeric. The height above the elevation data of the observer}
  \item{target}{numeric. The height above the elevation data of the targets}
  \item{curvcoef}{numeric. Coefficient to consider the effect of the curvature of the earth and refraction of the atmosphere. The elevation values are corrected with: \code{elevation = elevation - curvcoeff * (distance)^2 / (earth_diameter)}. This means that with the default value of 0.85714, you lose sight of about 1 meter of elevation for each 385 m of planar distance}
  \item{output}{character. Can be "yes/no" to get a binary (logical) output showing what areas are visible; "land" to get the height above the current elevation that would be visible; or "sea" the elevation above sea level that would be visible}
  \item{filename}{character. Output filename}
  \item{...}{Options for writing files as in \code{\link{writeRaster}}}
}

\seealso{\code{\link{terrain}}}

\references{
The algorithm used is by Wang et al.: https://www.asprs.org/wp-content/uploads/pers/2000journal/january/2000_jan_87-90.pdf.
}

\examples{

f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
x <- project(r, "EPSG:2169")
p <- cbind(70300, 96982)
v <- viewshed(x, p, 0, 0, 0.85714)
}

\keyword{spatial}

\name{rasterizeWin}

\docType{methods}

\alias{rasterizeWin}
\alias{rasterizeWin,SpatVector,SpatRaster-method}
\alias{rasterizeWin,data.frame,SpatRaster-method}

\title{Rasterize points with a moving window}

\description{
Rasterize points using a circle (or ellipse) as moving window. For each raster cell, the points (\code{x, y}) that fall within the window centered on that cell are considered. A function is used to compute a summary value (e.g. "mean") for the values (\code{z}) associated with these points.

This can result in much smoother results compared to the standard \code{\link{rasterize}} method.
}

\usage{
\S4method{rasterizeWin}{SpatVector,SpatRaster}(x, y, field, win="circle", pars, fun, ..., cvars=FALSE, 
			  minPoints=1, fill=NA, filename="", wopt=list())

\S4method{rasterizeWin}{data.frame,SpatRaster}(x, y, win="circle", pars, fun, ..., cvars=FALSE, 
		      minPoints=1, fill=NA, filename="", wopt=list())
}

\arguments{
  \item{x}{SpatVector or matrix with at least three columns ((x, y) coordinates and a variable to be rasterized)}
  \item{y}{SpatRaster}
  \item{field}{character. field name in SpatVector \code{x} with the values to rasterize}
  \item{win}{character to choose the window type. Can be "circle", "ellipse", "rectangle", or "buffer"}
  \item{pars}{parameters to define the window. If \code{win="circle"} or \code{win="buffer"}, a single number to set the radius of the circle or the width of the buffer. If \code{win="ellipse"}, either two numbers (the x and y-axis) or three numbers the axes and a rotation (in degrees). If \code{win="rectangle"}, either two (width, height) or three (width, height) and the rotation in degrees. The unit of the radius/width/height/axis parameters is that of the coordinate reference system (it is not expressed as cells). That is, if you have a lon/lat crs, there is no conversion of degrees to meters or vice-versa.}
  \item{fun}{function to summarize the values for each cell. If \code{cvars=FALSE}, functions must take a numeric vector and return (in all cases) one or more numbers. If \code{cvars=TRUE}, and multiple variables are used, the function must take a single argument (a data.frame with the names variables).   
  For \code{win="circle"} and \code{win="ellipse"} there are two additional character values that can be used: \code{"distto"} (average distance to the points from the center of the cell) and \code{"distbetween"} (average distance between the points inside the window)}
  \item{...}{additional named arguments passed to \code{fun}}
  \item{minPoints}{numeric. The minimum number of points to use. If fewer points are found in a search ellipse it is considered empty and the fill value is returned}
  \item{fill}{numeric. value to use to fill cells with empty search areas}
  \item{cvars}{logical. When using multiple fields, should \code{fun} operate on all of them at once? If not, \code{fun} is applied to each variable separately}
  \item{filename}{character. Output filename}
  \item{wopt}{list with additional arguments for writing files as in \code{\link{writeRaster}}}
}


\seealso{
\code{\link{rasterize}}, \code{\link{rasterizeGeom}}, \code{\link{interpNear}}, \code{\link{interpIDW}}
}


\value{
SpatRaster
}

\examples{

r <- rast(ncol=100, nrow=100, crs="local", xmin=0, xmax=50, ymin=0, ymax=50)
set.seed(100)
x <- runif(50, 5, 45)
y <- runif(50, 5, 45)
z <- sample(50)
xyz <- data.frame(x,y,z)

r <- rasterizeWin(xyz, r, fun="count", pars=5)

rfuns <- c("count", "min", "max", "mean")
x <- lapply(rfuns, function(f) rasterizeWin(xyz, r, fun=f, pars=5))
names(x) <- rfuns 
x <- rast(x)
#plot(x)

}

\keyword{spatial}

\name{combineGeoms}

\docType{methods}

\alias{combineGeoms}
\alias{combineGeoms,SpatVector,SpatVector-method}

\title{ 
Combine geometries
}

\description{
Combine the geometries of one SpatVector with those of another. Geometries can be combined based on overlap, shared boundaries and distance (in that order of operation). 

The typical use-case of this method is when you are editing geometries and you have a number of small polygons in one SpatVector that should be part of the geometries of the other SpatVector; perhaps because they were small holes in between the borders of two SpatVectors.

To append SpatVectors use `rbind` and see methods like \code{intersect} and \code{union} for "normal" polygons combinations. 
}

\usage{
\S4method{combineGeoms}{SpatVector,SpatVector}(x, y, overlap=TRUE, boundary=TRUE, distance=TRUE,
	append=TRUE, minover=0.1, maxdist=Inf, dissolve=TRUE, erase=TRUE)
}

\arguments{
  \item{x}{SpatVector of polygons}
  \item{y}{SpatVector of polygons geometries that are to be combined with \code{x}}
  \item{overlap}{logical. If \code{TRUE}, a geometry is combined with the geometry it has most overlap with, if the overlap is above \code{minover}}
  \item{boundary}{logical. If \code{TRUE}, a geometry is combined with the geometry it has most shared border with}
  \item{distance}{logical. If \code{TRUE}, a geometry is combined with the geometry it is nearest to}
  \item{append}{logical. Should remaining geometries be appended to the output? Not relevant if \code{distance=TRUE}}
  \item{minover}{numeric. The fraction of the geometry in \code{y} that overlaps with a geometry in \code{x}. Below this threshold, geometries are not considered overlapping}
  \item{maxdist}{numeric. Geometries further away from each other than this distance (in meters) will not be combined}
  \item{dissolve}{logical. Should internal boundaries be dissolved?}
  \item{erase}{logical. If \code{TRUE} no new overlapping areas are created}
} 

\value{
SpatVector
}

\seealso{
\code{\link{union}}, \code{\link{erase}}, \code{\link{intersect}}, 
\code{\link{sharedPaths}}, \code{\link{aggregate}}, \code{\link{rbind}}
}


\examples{
x1 <- vect("POLYGON ((0 0, 8 0, 8 9, 0 9, 0 0))")
x2 <- vect("POLYGON ((10 4, 12 4, 12 7, 11 7, 11 6, 10 6, 10 4))")

y1 <- vect("POLYGON ((5 6, 15 6, 15 15, 5 15, 5 6))")
y2 <- vect("POLYGON ((8 2, 9 2, 9 3, 8 3, 8 2))")
y3 <- vect("POLYGON ((2 6, 3 6, 3 8, 2 8, 2 6))")
y4 <- vect("POLYGON ((2 12, 3 12, 3 13, 2 13, 2 12))")

x <- rbind(x1, x2)
values(x) <- data.frame(xid=1:2)
crs(x) <- "+proj=utm +zone=1"

y <- rbind(y1, y2, y3, y4)
values(y) <- data.frame(yid=letters[1:4])
crs(y) <- "+proj=utm +zone=1"

plot(rbind(x, y), border=c(rep("red",2), rep("blue", 4)), lwd=2)
text(x, "xid")
text(y, "yid")

v <- combineGeoms(x, y)
plot(v, col=c("red", "blue"))

v <- combineGeoms(x, y, boundary=FALSE, maxdist=1, minover=.05)
plot(v, col=rainbow(4))
}


\keyword{methods}
\keyword{spatial}

\name{coerce}

\docType{methods}

\alias{as.vector}
\alias{as.matrix}
\alias{as.array}

\alias{as.vector,SpatRaster-method}
\alias{as.matrix,SpatRaster-method}
\alias{as.array,SpatRaster-method}
\alias{as.array,SpatRasterDataset-method}

\alias{as.vector,SpatExtent-method}
\alias{as.matrix,SpatExtent-method}


\title{Coercion to vector, matrix or array}

\description{
Coercion of a SpatRaster to a vector, matrix or array. Or coerce a SpatExtent to a vector or matrix
}

\usage{
\S4method{as.vector}{SpatRaster}(x, mode='any')

\S4method{as.matrix}{SpatRaster}(x, wide=FALSE, ...)

\S4method{as.array}{SpatRaster}(x)

\S4method{as.array}{SpatRasterDataset}(x)

\S4method{as.vector}{SpatExtent}(x, mode='any')

\S4method{as.matrix}{SpatExtent}(x, ...)
}


\arguments{
\item{x}{SpatRaster or SpatVector}
\item{wide}{logical. If \code{FALSE} each layer in the SpatRaster becomes a column in the matrix and each cell in the SpatRaster becomes a row. If \code{TRUE} each row in the SpatRaster becomes a row in the matrix and each column in the SpatRaster becomes a column in the matrix }
\item{mode}{this argument is ignored}
\item{...}{additional arguments (none implemented)}
}

\value{
vector, matrix, or array
}

\seealso{\code{\link{as.data.frame}} and \code{\link{as.polygons}}}


\examples{
r <- rast(ncols=2, nrows=2)
values(r) <- 1:ncell(r)

as.vector(r)
as.matrix(r)
as.matrix(r, wide=TRUE)
as.data.frame(r, xy=TRUE)
as.array(r)

as.vector(ext(r))
as.matrix(ext(r))
}

\keyword{spatial}

\docType{methods}

\name{flowdir}

\alias{flowDir}
\alias{flowDir,SpatRaster-method}

\title{Path-Based Nondisperive Flow Direction}

\description{
Computes nondispersive flow/drainage direction according to path-based methods over grid-based digital elevation models. 
This is an alternative to \code{\link{terrain}(v="flowdir")}.
}

\usage{
\S4method{flowDir}{SpatRaster}(x, lambda=0.5, deviation_type=c("ltd","lad"), max_iters=10^6, filename="", ...) 
}

\arguments{
  \item{x}{SpatRaster with elevation data}
  \item{lambda}{Parameter between 0 and 1}  
  \item{deviation_type}{Character. Available options are \code{"ltd"} (the default) and \code{"lad"}. If \code{"ltd"}, nondispersive flow directions are determined using the least transversal deviation (LTD) criterion. If \code{"lad"}, nondispersive flow directions are determined using the least angular deviation (LAD) criterion. See Orlandini et al. (2003) for details.}  
  \item{max_iters}{maximum iterations for drainage path starting points detection}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{ 
SpatRaster 
}

\details{
The algorithm is an adaptation of the one proposed by Li et al. (2022) and Orlandini et al. (2003).
This function is experimental and under development: results are to be verified. 
}

\seealso{\code{\link{terrain}}, \code{\link{watershed}}, \code{\link{flowAccumulation}}}


\author{
Emanuele Cordano
}

\references{

Orlandini, S., G. Moretti, M. Franchini, B. Aldighieri, and B. Testa (2003). Path-based methods for the determination of nondispersive drainage directions in grid-based digital elevation models, Water Resour. Res., 39, 1144, doi:10.1029/2002WR001639, 6. \url{https://agupubs.onlinelibrary.wiley.com/doi/full/10.1029/2002WR001639}

Li, Z., Shi, P., Yang, T., Wang, C., Yong, B., & Song, Y. (2022). An improved D8-LTD for the extraction of total contributing area (TCA) by adopting the strategies of path independency and local dispersion. Water Resources Research, 58, e2021WR030948. https://doi.org/10.1029/2021WR030948 \url{https://agupubs.onlinelibrary.wiley.com/doi/full/10.1029/2021WR030948}


Useful presentation: \url{http://www.idrologia.unimore.it/orlandini/web-archive/seminars/nyc-2008-2.pdf}

}


\examples{
elev1 <- array(NA,c(9,9))
elev2 <- elev1
dx <- 1
dy <- 1 
for (r in 1:nrow(elev1)) {
  y <- (r-5)*dx
  for (c in 1:ncol(elev1)) {
    x <- (c-5)*dy
    elev1[r,c] <- 5*(x^2+y^2)
    elev2[r,c] <- 10+5*(abs(x))-0.001*y 
  }
} 

## Elevation raster
elev1 <- rast(elev1)
elev2 <- rast(elev2)

t(array(elev1[],rev(dim(elev1)[1:2])))
t(array(elev2[],rev(dim(elev2)[1:2])))

plot(elev1)
plot(elev2)

## Flow direction raster
fdir1 <- flowDir(elev1, lambda=1)
fdir2 <- flowDir(elev2, lambda=1)

elev <- rast(system.file('ex/elev.tif',package="terra"))

fdirlad1 <- flowDir(elev, lambda=0.5, deviation_type="lad")
fdirlad2 <- flowDir(elev, lambda=0.5, deviation_type="lad")
}

\keyword{spatial}

\name{extend}

\alias{extend}
\alias{extend,SpatRaster-method}
\alias{extend,SpatExtent-method}


\title{Extend}

\description{
Enlarge the spatial extent of a SpatRaster. See \code{\link{crop}} if you (also) want to remove rows or columns. 

Note that you can only enlarge SpatRasters with entire rows and columns. Therefore, the extent of the output SpatRaster may not be exactly the same as the requested. Depending on argument \code{snap} it may be a bit smaller or larger. 

You can also enlarge a SpatExtent with this method, or with an algebraic notation (see examples)
}

\usage{
\S4method{extend}{SpatRaster}(x, y, snap="near", fill=NA, filename="", overwrite=FALSE, ...) 

\S4method{extend}{SpatExtent}(x, y) 
}

\arguments{
  \item{x}{SpatRaster or SpatExtent}
  \item{y}{If \code{x} is a SpatRaster, \code{y} should be a SpatExtent, or an object from which it can be extracted (such as SpatRaster and SpatVector objects). Alternatively, you can provide one, two or four non-negative integers indicating the number of rows and columns that need to be added at each side (a single positive integer when the number of rows and columns to be added is equal; or 2 number (columns, rows), or four (left column, right column, bottom row, top row).
  If \code{x} is a SpatExtent, \code{y} should likewise be a numeric vector of 1, 2, or 4 elements}
  
  \item{snap}{character. One of "near", "in", or "out". Used to align \code{y} to the geometry of \code{x}} 
  \item{fill}{numeric. The value used to for the new raster cells}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster or SpatExtent
}

\seealso{\code{\link{trim}}, \code{\link{crop}}, \code{\link{merge}}, \code{\link{ext}}, \code{\link{resample}}, \code{\link{elongate}}}

\examples{
r <- rast(xmin=-150, xmax=-120, ymin=30, ymax=60, ncols=36, nrows=18)
values(r) <- 1:ncell(r)
e <- ext(-180, -100, 40, 70)
re <- extend(r, e)

# extend with a number of rows and columns (at each side)
re2 <- extend(r, c(2,10))

# SpatExtent
e <- ext(r)
e
extend(e, 10)
extend(e, c(10, -10, 0, 20))


# add 10 columns / rows on all sides
e + 10
# double extent
e * 2
# increase extent by 25%
e * 1.25
}

\keyword{spatial}

\name{mosaic}

\docType{methods}

\alias{mosaic}
\alias{mosaic,SpatRaster,SpatRaster-method}
\alias{mosaic,SpatRasterCollection,missing-method}

\title{ 
mosaic SpatRasters
}

\description{
Combine adjacent and (partly) overlapping SpatRasters to form a single new SpatRaster. Values in overlapping cells are averaged (by default) or can be computed with another function. 

With the "blend" function, smooth gradients in overlappoing zones are created by weighting each raster's contribution by the distance from the cell to the raster's nearest edge. 

The SpatRasters must have the same origin and spatial resolution. 

If rasters do not overlap, or if their values do not need to be computed, you can use \code{\link{merge}} instead. 
}

\usage{
\S4method{mosaic}{SpatRaster,SpatRaster}(x, y, ..., fun="mean", resample=FALSE, method="",
		filename="", overwrite=FALSE, wopt=list())

\S4method{mosaic}{SpatRasterCollection,missing}(x, fun="mean", resample=FALSE, method="", filename="", ...)
}

\arguments{
  \item{x}{SpatRaster or SpatRasterCollection}
  \item{y}{SpatRaster if \code{x} is a SpatRaster, otherwise missing}
  \item{...}{additional SpatRasters}
  \item{fun}{character. One of "blend", "mean", "median", "min", "max", "modal", "sum", "first", "last"}
  \item{resample}{logical. If \code{TRUE} input rasters are resampled if they do not align (same origin and resolution) with the first raster}
  \item{method}{character. The resampling method used. One of "nearest", "bilinear", "cubic", "cubicspline", "lanczos", "average", "mode" as in \code{\link{resample}}. If \code{NULL}, "nearest" is used for categorical rasters and "bilinear" for other rasters}   
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
} 


\value{
SpatRaster
}

\seealso{
\code{\link{merge}}
}


\examples{

x <- rast(xmin=-110, xmax=-60, ymin=40, ymax=70, res=1, vals=1)
y <- rast(xmin=-95, xmax=-45, ymax=60, ymin=30, res=1, vals=2)
z <- rast(xmin=-80, xmax=-30, ymax=50, ymin=20, res=1, vals=3)

m1 <- mosaic(x, y, z)

m2 <- mosaic(z, y, x)

# with a SpatRasterCollection
spc <- sprc(list(x, y, z))

m <- mosaic(spc)

b <- mosaic(spc, fun="blend")
}

\keyword{methods}
\keyword{spatial}

\name{pairs}

\docType{methods}

\alias{pairs}
\alias{pairs,SpatRaster-method}

\title{
Pairs plot (matrix of scatterplots)
}

\description{
Pair plots of layers in a SpatRaster. This is a wrapper around graphics function \code{\link[graphics]{pairs}}.
}

\usage{
\S4method{pairs}{SpatRaster}(x, hist=TRUE, cor=TRUE, use="pairwise.complete.obs", maxcells=100000, ...)
}

\arguments{
\item{x}{SpatRaster}
\item{hist}{logical. If TRUE a histogram of the values is shown on the diagonal}
\item{cor}{logical. If TRUE the correlation coefficient is shown in the upper panels}
\item{use}{argument passed to the \code{\link[stats]{cor}} function}
\item{maxcells}{integer. Number of pixels to sample from each layer of a large SpatRaster}
\item{...}{additional arguments (graphical parameters)}
}

\seealso{
\code{\link{boxplot}, \link{hist}}
}

\examples{
r <-rast(system.file("ex/elev.tif", package="terra"))
s <- c(r, 1/r, sqrt(r))
names(s) <- c("elevation", "inverse", "sqrt") 
pairs(s)

# to make individual histograms:
hist(r)
# or scatter plots:
plot(s[[1]], s[[2]])
}


\keyword{spatial}

\name{shade}

\alias{shade}

\title{Hill shading}

\description{
Compute hill-shade from slope and aspect layers (both in radians). Slope and aspect can be computed with function \code{\link{terrain}}. 

A hill-shade layer is often used as a backdrop on top of which another, semi-transparent, layer is drawn.
}

\usage{
shade(slope, aspect, angle=45, direction=0, normalize=FALSE,
   filename="", overwrite=FALSE, ...)  
}

\arguments{
  \item{slope}{SpatRaster with slope values (in radians) }
  \item{aspect}{SpatRaster with aspect values (in radians) }
  \item{angle}{ The elevation angle(s) of the light source (sun), in degrees}
  \item{direction}{ The direction (azimuth) angle(s) of the light source (sun), in degrees}
  \item{normalize}{Logical. If \code{TRUE}, values below zero are set to zero and the results are multiplied with 255}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}  
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}  
}

\seealso{ \code{\link{terrain}} }

\references{
Horn, B.K.P., 1981. Hill shading and the reflectance map. Proceedings of the IEEE 69(1):14-47
}


\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
# disaggregating because the resolution of this raster is a bit low
# you generally should not do that with your own data
r <- disagg(r, 10, method="bilinear")

slope <- terrain(r, "slope", unit="radians")
aspect <- terrain(r, "aspect", unit="radians")
hill <- shade(slope, aspect, 40, 270)
plot(hill, col=grey(0:100/100), legend=FALSE, mar=c(2,2,1,4))
plot(r, col=rainbow(25, alpha=0.35), add=TRUE)

# A better hill shade may be achieved by combining 
# different angles and directions. For example
hh <- shade(slope, aspect, angle=30, direction=c(225, 270, 315, 360))
h1 <- Reduce(mean, hh)
h2 <- mean(hh)
}


\keyword{spatial}

\name{cells}

\docType{methods}

\alias{cells}
\alias{cells,SpatRaster,missing-method}
\alias{cells,SpatRaster,numeric-method}
\alias{cells,SpatRaster,SpatVector-method}
\alias{cells,SpatRaster,SpatExtent-method}


\title{Get cell numbers}

\description{ 
Get the cell numbers covered by a SpatVector or SpatExtent. Or that match values in a vector; or all non \code{NA} values.
}

\usage{
\S4method{cells}{SpatRaster,missing}(x, y)

\S4method{cells}{SpatRaster,numeric}(x, y, pairs=FALSE)

\S4method{cells}{SpatRaster,SpatVector}(x, y, method="simple", weights=FALSE, exact=FALSE, 
				touches=is.lines(y), small=TRUE)

\S4method{cells}{SpatRaster,SpatExtent}(x, y)
}


\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatVector, SpatExtent, 2-column matrix representing points, numeric representing values to match, or missing}
  \item{method}{character. Method for getting cell numbers for points. The default is "simple", the alternative is "bilinear". If it is "bilinear", the four nearest cells and their weights are returned}
  \item{weights}{logical. If \code{TRUE} and \code{y} has polygons, the approximate fraction of each cell that is covered is returned as well}
  \item{pairs}{logical. If \code{TRUE} the cell values matched area also returned}
  \item{exact}{logical. If \code{TRUE} and \code{y} has polygons, the exact fraction of each cell that is covered is returned as well}
  \item{touches}{logical. If \code{TRUE}, values for all cells touched by lines or polygons are extracted, not just those on the line render path, or whose center point is within the polygon. Not relevant for points}
  \item{small}{logical. If \code{TRUE}, values for all cells in touched polygons are extracted if none of the cells center points is within the polygon; even if \code{touches=FALSE}}
}

\value{
numeric vector or matrix
}


\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- 1:ncell(r)
r[c(1:25, 31:100)] <- NA
r <- ifel(r > 28, r + 10, r)

# all cell numbers of cells that are not NA
cells(r)

# cell numbers that match values
x <- cells(r, c(28,38))
x$lyr.1

# cells for points
m <- cbind(x=c(0,10,-30), y=c(40,-10,20))
cellFromXY(r, m)

v <- vect(m)
cells(r, v)
cells(r, v, method="bilinear")

# cells for polygons
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
r <- rast(v)
cv <- cells(r, v) 
}


\keyword{methods}
\keyword{spatial}

\name{values}

\docType{methods}

\alias{values}
\alias{values,SpatRaster-method}
\alias{values,SpatVector-method}
  
\title{Cell values and geometry attributes}

\description{
Get the cell values of a SpatRaster or the attributes of a SpatVector.

By default all values returned are numeric. This is because a vector or matrix can only store one data type, and a SpatRaster may consist of multiple data types. However, if all layers have integer or logical values, the returned values also have that datatype.  

Note that with \code{values(x, dataframe=TRUE)} and \code{\link[terra]{as.data.frame}(x)} the values returned match the type of each layer, and can be a mix of numeric, logical, integer, and factor.
}

\usage{
\S4method{values}{SpatRaster}(x, mat=TRUE, dataframe=FALSE, row=1, 
    nrows=nrow(x), col=1, ncols=ncol(x), na.rm=FALSE, ...)

\S4method{values}{SpatVector}(x, ...)
}


\arguments{
 \item{x}{SpatRaster or SpatVector}
 \item{mat}{logical. If \code{TRUE}, values are returned as a matrix instead of as a vector, except when dataframe is \code{TRUE}}
 \item{dataframe}{logical. If \code{TRUE}, values are returned as a \code{data.frame} instead of as a vector (also if matrix is \code{TRUE})}

 \item{row}{positive integer. Row number to start from, should be between 1 and nrow(x)}
 \item{nrows}{positive integer. How many rows?}
 \item{col}{positive integer. Column number to start from, should be between 1 and ncol(x)}
 \item{ncols}{positive integer. How many columns? Default is the number of columns left after the start column}
 \item{na.rm}{logical. Remove \code{NA}s?}

 \item{...}{additional arguments passed to \code{\link{data.frame}}}
}


\details{
If \code{x} is a \code{SpatRaster}, and \code{mat=FALSE}, the values are returned as a vector. In cell-order by layer. If \code{mat=TRUE}, a matrix is returned in which the values of each layer are represented by a column (with \code{ncell(x)} rows). The values per layer are in cell-order, that is, from top-left, to top-right and then down by row. Use \code{\link{as.matrix}(x, wide=TRUE)} for an alternative matrix representation where the number of rows and columns matches that of \code{x}.  

}


\note{
raster values that are \code{NA} (missing) are represented by \code{NaN} (not-a-number) unless argument \code{dataframe} is \code{TRUE}. 
}

\value{
matrix or data.frame
}


\seealso{\code{\link{values<-}}, \code{\link{focalValues}}, \code{\link[terra]{as.data.frame}}}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
r
x <- values(r)
x[3650:3655, ]
r[3650:3655]


ff <- system.file("ex/lux.shp", package="terra")
v <- vect(ff)
y <- values(v)
head(y)
}

\keyword{spatial}
\keyword{methods}

\name{vrt_tiles}


\alias{vrt_tiles} 

\title{filenames of VRT tiles}

\description{ 
Get the filenames of the tiles in a Virtual Raster Dataset (VRT) 
}

\usage{
vrt_tiles(x)
}

\arguments{
  \item{x}{character (filename) or SpatRaster}
}

\value{
character
}

\seealso{
\code{\link{vrt}}
}


\keyword{methods}
\keyword{spatial}

\name{terrain}

\alias{terrain}
\alias{terrain,SpatRaster-method}

\title{terrain characteristics}

\description{
Compute terrain characteristics from elevation data. The elevation values should be in the same units as the map units (typically meter) for projected (planar) raster data. They should be in meter when the coordinate reference system is longitude/latitude. 

For accuracy, always compute these values on the original data (do not first change the projection). Distances (needed for slope and aspect) for longitude/latitude data are computed on the WGS84 ellipsoid with Karney's algorithm. 
}

\usage{
\S4method{terrain}{SpatRaster}(x, v="slope", neighbors=8, unit="degrees", filename="", ...)  
}

\arguments{
  \item{x}{SpatRaster, single layer with elevation values. Values should have the same unit as the map units, or in meters when the crs is longitude/latitude}
  \item{v}{character. One or more of these options: slope, aspect, TPI, TRI, TRIriley, TRIrmsd, roughness, flowdir (see Details)}
  \item{unit}{character. "degrees" or "radians" for the output of "slope" and "aspect"}
  \item{neighbors}{integer. Indicating how many neighboring cells to use to compute slope or aspect with. Either 8 (queen case) or 4 (rook case)}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\details{
When \code{neighbors=4}, slope and aspect are computed according to Fleming and Hoffer (1979) and Ritter (1987). When \code{neighbors=8}, slope and aspect are computed according to Horn (1981). The Horn algorithm may be best for rough surfaces, and the Fleming and Hoffer algorithm may be better for smoother surfaces (Jones, 1997; Burrough and McDonnell, 1998).

If slope = 0, aspect is set to 0.5*pi radians (or 90 degrees if unit="degrees"). When computing slope or aspect, the coordinate reference system of \code{x} must be known for the algorithm to differentiate between planar and longitude/latitude data.

\code{terrain} is not vectorized over "neighbors" or "unit" -- only the first value is used.

flowdir returns the "flow direction" (of water), that is the direction of the greatest drop in elevation (or the smallest rise if all neighbors are higher). They are encoded as powers of 2 (0 to 7). The cell to the right of the focal cell is 1, the one below that is 2, and so on:
\tabular{rrr}{
32 \tab64 \tab 128\cr 
16 \tab x \tab 1 \cr 
 8 \tab 4 \tab 2 \cr }

Cells without lower neighboring cells are encoded as zero. 

If two cells have the same drop in elevation, a random cell is picked. That is not ideal as it may prevent the creation of connected flow networks. ArcGIS implements the approach of Greenlee (1987) and I might adopt that in the future. 

Most terrain indices are according to Wilson et al. (2007), as in \href{https://gdal.org/en/latest/programs/gdaldem.html}{gdaldem}. TRI (Terrain Ruggedness Index) is the mean of the absolute differences between the value of a cell and its 8 surrounding cells. TPI (Topographic Position Index, or Bathymetric Position Index if on seafloor) is the difference between the value of a cell and the mean value of its 8 surrounding cells. Roughness is the difference between the maximum and the minimum value of a cell and its 8 surrounding cells. 

TRIriley (TRI according to Riley et al., 2007) returns the square root of summed squared differences between the value of a cell and its 8 surrounding cells. TRIrmsd computes the square root of the mean of the squared differences between these cells. 

These measures can also be computed with \code{\link{focal}} functions:

TRI <- focal(x, w=3, fun=\(x) sum(abs(x[-5]-x[5]))/8)

TPI <- focal(x, w=3, fun=\(x) x[5] - mean(x[-5]))

rough <- focal(x, w=3, fun=\(x) max(x) - min(x))
}

\seealso{\code{\link{viewshed}}}

\references{
Burrough, P., and R.A. McDonnell, 1998. Principles of Geographical Information Systems. Oxford University Press.

Fleming, M.D. and Hoffer, R.M., 1979. Machine processing of Landsat MSS data and DMA topographic data for forest cover type mapping. LARS Technical Report 062879. Laboratory for Applications of Remote Sensing, Purdue University, West Lafayette, Indiana.

Horn, B.K.P., 1981. Hill shading and the reflectance map. Proceedings of the IEEE 69:14-47

Jones, K.H., 1998. A comparison of algorithms used to compute hill slope as a property of the DEM. Computers & Geosciences 24: 315-323 

Karney, C.F.F., 2013. Algorithms for geodesics, J. Geodesy 87: 43-55. doi:10.1007/s00190-012-0578-z.

Riley, S.J., De Gloria, S.D., Elliot, R. (1999): A Terrain Ruggedness that Quantifies Topographic Heterogeneity. Intermountain Journal of Science 5: 23-27.

Ritter, P., 1987. A vector-based terrain and aspect generation algorithm. Photogrammetric Engineering and Remote Sensing 53: 1109-1111

Wilson et al 2007, Multiscale Terrain Analysis of Multibeam Bathymetry Data for Habitat Mapping on the Continental Slope. Marine Geodesy 30:3-35
}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
x <- terrain(r, "slope")
}

\keyword{spatial}

\name{vector_layers}

\alias{vector_layers}

\title{List or remove layers from a vector file}

\description{
List or remove layers from a vector file that supports layers such as GPKG
}

\usage{
vector_layers(filename, delete="", return_error=FALSE)
}

\arguments{
  \item{filename}{character. filename}
  \item{delete}{character. layers to be deleted (ignored if the value is \code{""})}
  \item{return_error}{logical. If \code{TRUE}, an error occurs if some layers cannot be deleted. Otherwise a warning is given}
}



\keyword{ spatial }
\keyword{ methods }

\name{density}

\alias{density}
\alias{density,SpatRaster-method}

\docType{methods}

\title{Density plot}

\description{
Create density plots of the cell values of a SpatRaster
}

\usage{
\S4method{density}{SpatRaster}(x, maxcells=100000, plot=TRUE, main, ...)
}

\arguments{
\item{x}{SpatRaster}
\item{maxcells}{the maximum number of (randomly sampled) cells to be used for creating the plot}
\item{plot}{if \code{TRUE} produce a plot, else return a density object}
\item{main}{character. Caption of plot(s)}
\item{...}{additional arguments passed to \code{\link{plot}}}
}

\value{
density plot (and a density object, returned invisibly if \code{plot=TRUE)} 
}

\examples{
logo <- rast(system.file("ex/logo.tif", package="terra"))
density(logo)
}

\keyword{spatial}

\name{intersect}

\docType{methods}

\alias{intersect}

\alias{intersect,SpatVector,SpatVector-method}
\alias{intersect,SpatVector,SpatExtent-method}
\alias{intersect,SpatExtent,SpatVector-method}
\alias{intersect,SpatExtent,SpatExtent-method}
\alias{intersect,SpatRaster,SpatRaster-method}
\alias{intersect,SpatRaster,SpatExtent-method}
\alias{intersect,SpatExtent,SpatRaster-method}

\title{ 
Intersection
}

\description{
You can intersect SpatVectors with each other or with a SpatExtent. Intersecting points with points uses the extent of \code{y} to get the intersection. Intersecting of points and lines is not supported because of numerical inaccuracies with that. You can use \code{\link{buffer}}, to create polygons from lines and use these with intersect. 

You can also intersect two SpatExtents.

When intersecting two SpatRasters these need to be aligned (have the same origin and spatial resolution). The values of the returned SpatRaster are \code{TRUE} where both input rasters have values, \code{FALSE} where one has values, and \code{NA} in all other cells. 

When intersecting a SpatExtent and a SpatRaster, the SpatExtent is first aligned to the raster cell boundaries.

See \code{\link{crop}} for the intersection of a SpatRaster with a SpatExtent (or the extent of a SpatRaster or SpatVector) if you want a SpatRaster (not a SpatExtent) as output.

See \code{\link{is.related}(x, y, "intersects")} to find out which geometries of a SpatVector intersect. You can spatially subset a SpatVector with another one with \code{x\link{[}y]}.
}

\usage{
\S4method{intersect}{SpatVector,SpatVector}(x, y)

\S4method{intersect}{SpatVector,SpatExtent}(x, y)

\S4method{intersect}{SpatExtent,SpatVector}(x, y)

\S4method{intersect}{SpatExtent,SpatExtent}(x, y)

\S4method{intersect}{SpatRaster,SpatRaster}(x, y)

\S4method{intersect}{SpatRaster,SpatExtent}(x, y)

\S4method{intersect}{SpatExtent,SpatRaster}(x, y)
}

\arguments{
  \item{x}{SpatVector, SpatExtent, or SpatRaster}
  \item{y}{SpatVector, SpatExtent, or SpatRaster}
} 

\value{
Same as \code{x}
}

\seealso{
\code{\link{union}}, \code{\link{crop}}, \code{\link{relate}}, \code{\link{[}}
}

\examples{
e1 <- ext(-10, 10, -20, 20)
e2 <- ext(0, 20, -40, 5)
intersect(e1, e2)

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
e <- ext(5.6, 6, 49.55, 49.7)
x <- intersect(v, e)

p <- vect(c("POLYGON ((5.8 49.8, 6 49.9, 6.15 49.8, 6 49.6, 5.8 49.8))", 
"POLYGON ((6.3 49.9, 6.2 49.7, 6.3 49.6, 6.5 49.8, 6.3 49.9))"), crs=crs(v))
values(p) <- data.frame(pid=1:2, area=expanse(p))

y <- intersect(v, p)

r <- s <- rast(ncol=5, nrow=5, xmin=1, xmax=5, ymin=1, ymax=5)
r[5:20] <- 5:20
s[11:20] <- 11:20
rs <- intersect(r, s)

u <- shift(r, .8)
us <- intersect(u, s)
}


\keyword{methods}
\keyword{spatial}

\docType{methods}
\name{NIDP}

\alias{NIDP}
\alias{NIDP,SpatRaster-method}


\title{Number of immediate adjacent cells flowing into each cell}

\description{
Compute the number of immediate adjacent cells flowing into each cell
}

\usage{
\S4method{NIDP}{SpatRaster}(x, filename="",...) 
}

\arguments{
  \item{x}{SpatRaster with flow-direction. See \code{\link{terrain}}}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{ 
SpatRaster
}

\details{
NIDP is computed first to compute flow-accumulation with the algorithm by Zhou et al., 2019. 
}




\references{
Zhou, G., Wei, H. & Fu, S. A fast and simple algorithm for calculating flow accumulation matrices from raster digital elevation. Front. Earth Sci. 13, 317–326 (2019). https://doi.org/10.1007/s11707-018-0725-9
\url{https://link.springer.com/article/10.1007/s11707-018-0725-9}
}



\seealso{\code{\link{flowAccumulation}}}

\author{Emanuele Cordano }

\examples{

elev1 <- array(NA,c(9,9))
elev2 <- elev1
dx <- 1
dy <- 1 
for (r in 1:nrow(elev1)) {
  y <- (r-5)*dx
  for (c in 1:ncol(elev1)) {
    
    x <- (c-5)*dy
    elev1[r,c] <- 5*(x^2+y^2)
    elev2[r,c] <- 10+5*(abs(x))-0.001*y ### 5*(x^2+y^2)
  }
} 


## Elevation Raster 
elev1 <- rast(elev1)
elev2 <- rast(elev2)

t(array(elev1[],rev(dim(elev1)[1:2])))
t(array(elev2[],rev(dim(elev2)[1:2])))

plot(elev1)
plot(elev2)

## Flow Direction Raster
flowdir1<- terrain(elev1,v="flowdir")
flowdir2<- terrain(elev2,v="flowdir")


t(array(flowdir1[],rev(dim(flowdir1)[1:2])))
t(array(flowdir2[],rev(dim(flowdir2)[1:2])))

plot(flowdir1)
plot(flowdir2)

## 
nidp1 <- NIDP((flowdir1))
nidp2 <- NIDP((flowdir2))

t(array(nidp1[],rev(dim(nidp1)[1:2])))
t(array(nidp2[],rev(dim(nidp2)[1:2])))

plot(nidp1)
plot(nidp2)

}



\keyword{spatial}

\name{is.lonlat}

\alias{is.lonlat}
\alias{is.lonlat,SpatRaster-method}
\alias{is.lonlat,SpatVector-method}
\alias{is.lonlat,character-method}

  
\title{Check for longitude/latitude crs}

\description{
Test whether a SpatRaster or SpatVector has a longitude/latitude coordinate reference system (CRS), or perhaps has one. That is, when the CRS is unknown (\code{""}) but the x coordinates are within -181 and 181 and the y coordinates are within -90.1 and 90.1. For a SpatRaster you can also test if it has a longitude/latitude CRS and it is "global" (covers all longitudes).

A warning is given if the CRS is missing or if it is specified as longitude/latitude but the coordinates do not match that.
}

\usage{
\S4method{is.lonlat}{SpatRaster}(x, perhaps=FALSE, warn=TRUE, global=FALSE)

\S4method{is.lonlat}{SpatVector}(x, perhaps=FALSE, warn=TRUE)

\S4method{is.lonlat}{character}(x, perhaps=FALSE, warn=TRUE)
}

\arguments{
\item{x}{SpatRaster or SpatVector}
\item{perhaps}{logical. If \code{TRUE} and the CRS is unknown, the method returns \code{TRUE} if the coordinates are plausible for longitude/latitude}
\item{warn}{logical. If \code{TRUE}, a warning is given if the CRS is unknown but assumed to be lon/lat and  \code{perhaps=TRUE}}
\item{global}{logical. If \code{TRUE}, the method tests if the raster covers all longitudes (from -180 to 180 degrees) such that the extreme columns are in fact adjacent}
}

\value{
logical or NA
}

\examples{
r <- rast()
is.lonlat(r)
is.lonlat(r, global=TRUE)

crs(r) <- ""
is.lonlat(r)
is.lonlat(r, perhaps=TRUE, warn=FALSE)

crs(r) <- "+proj=lcc +lat_1=48 +lat_2=33 +lon_0=-100 +ellps=WGS84"
is.lonlat(r)
}

\keyword{spatial}

\name{rcl}

\alias{rcl}
\alias{rcl,SpatRaster-method}


\title{Combine row, column, and layer numbers}

\description{
Get a matrix with the combination of row, column, and layer numbers
}

\usage{
\S4method{rcl}{SpatRaster}(x, row=NULL, col=NULL, lyr=NULL)
}

\arguments{
  \item{x}{SpatRaster}
  \item{row}{positive integer that are row number(s), a list thereof, or NULL for all rows}
  \item{col}{as above for columns}
  \item{lyr}{as above for layers}
}

\details{
If a list is used for at least one of \code{row}, \code{col} or \code{lyr}, these are evaluated in parallel. That is combinations are made for each list element, not across list elements. If, in this case another argument is not a list it has to have either length 1 (used for all cases) or have the same length as the (longest) list, in which case the value is coerced into a list with \code{as.list}

If multiple arguments are a list but they have different lengths, they are recycled to the longest list. 
}

\value{
matrix
}


\seealso{
\code{\link{rowColCombine}}, \code{\link{cellFromRowCol}}
}



\examples{
x <- rast(ncol=5, nrow=5, nlyr=2)
values(x) <- 1:size(x)

rcl(x, 1, 2:3, 1:2)

i <- rcl(x, 1, list(1:2, 3:4), 1:2)
i

# get the values for these cells
x[i]
}

\keyword{spatial}

\name{dots}

\docType{methods}

\alias{dots}
\alias{dots,SpatVector-method}


\title{Make a dot-density map}

\description{
Create the dots for a dot-density map and add these to the current map. Dot-density maps are made to display count data. For example of population counts, where each dot represents n persons. The dots are returned as a \code{SpatVector}. It there is an active graphics device, the dots are added to it with \code{\link{points}}.
}

\usage{
\S4method{dots}{SpatVector}(x, field, size,  ...)
}

\arguments{
  \item{x}{SpatVector}
  \item{field}{character of numeric indicating field name. Or numeric vector of the same length as \code{x}}
  \item{size}{positive number indicating the number of cases associated with each dot}
  \item{...}{graphical arguments passed to \code{points}}
}


\value{
SpatVector (invisibly)
}
 
\seealso{
 \code{\link{plot}}, \code{\link{cartogram}}, \code{\link{points}}
}

\examples{ 
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
v$population <- 1000*(1:12)^2
plot(v, lwd=3, col="light gray", border="white")
d <- dots(v, "population", 1000, col="red", cex=.75)
lines(v)
d
}

\keyword{methods}
\keyword{spatial}

\name{metags}

\alias{metags}
\alias{metags,SpatRaster-method}
\alias{metags,SpatRasterDataset-method}
\alias{metags,SpatRasterCollection-method}
\alias{metags<-}
\alias{metags<-,SpatRaster-method}
\alias{metags<-,SpatRasterDataset-method}
\alias{metags<-,SpatRasterCollection-method}

  
\title{Set or get metadata}

\description{
You can set arbitrary metadata to (layers of) a SpatRaster using "name=value", or "domain:name=value" tags or a two (name, value) or three column (name, value, domain) matrix or data.frame. 
}

\usage{
\S4method{metags}{SpatRaster}(x, layer=NULL, domain="")<-value

\S4method{metags}{SpatRaster}(x, layer=NULL, name=NULL)

\S4method{metags}{SpatRasterDataset}(x, dataset=NULL)<-value

\S4method{metags}{SpatRasterDataset}(x, dataset=NULL, name=NULL)

}

\arguments{
\item{x}{SpatRaster}
\item{layer}{NULL, positive integer or character. If the value is NULL, the tags assigned or returned are for the SpatRaster. Otherwise for the layer number(s) or name(s)}
\item{domain}{character. Only used if not specified by \code{value}. Use "" for the default domain. Depending on the file format used this may the only domain supported when writing files}
\item{name}{character}
\item{value}{character of "name=value" or two-column (name, value) or three-column (name, value, domain) matrix or data.frame}
\item{dataset}{NULL, positive integer or character. If the value is NULL, the tags assigned or returned are for the SpatRasterDataset/SpatRasterCollection. Otherwise for the dataset number(s) or name(s)}
}

\value{
SpatRaster (\code{metags<-}), or data.frame
}

\examples{
r <- rast(ncol=5, nrow=5)
m <- cbind(c("one", "two", "three"), c("ABC", "123", "hello"))
metags(r) <- m
metags(r)

metags(r) <- c("another_tag=another_value", "one more=this value")
metags(r)

metags(r) <- cbind("test", "this", "mydomain")
metags(r)

metags(r, name="two")

# remove a tag
metags(r) <- cbind("one", "")
metags(r) <- "two="
metags(r)

# remove all tags
metags(r) <- NULL
metags(r)
}

\keyword{spatial}

\name{window}

\docType{methods}

\alias{window}
\alias{window<-}
\alias{window,SpatRaster-method}
\alias{window<-,SpatRaster-method}

\title{Set a window}

\description{

Assign a window (area of interest) to a SpatRaster with a \code{SpatExtent}, or set it to \code{NULL} to remove the window. This is similar to \code{\link{crop}} without actually creating a new dataset. 

The window is intersect with the extent of the SpatRaster. It is envisioned that in a future version, the window may also go outside these boundaries.
}

\usage{
\S4method{window}{SpatRaster}(x)<-value

\S4method{window}{SpatRaster}(x)
}

\arguments{
  \item{x}{SpatRaster}
  \item{value}{SpatExtent}
}

\seealso{
 \code{\link{crop}}, \code{\link{extend}}
}


\value{
none for \code{window<-} and logical for \code{window}
}

\examples{ 
f <- system.file("ex/elev.tif", package="terra") 
r <- rast(f)
global(r, "mean", na.rm=TRUE)
e <- ext(c(5.9, 6,49.95, 50))

window(r) <- e
global(r, "mean", na.rm=TRUE)
r

x <- rast(f)
xe <- crop(x, e)
global(xe, "mean", na.rm=TRUE)

b <- c(xe, r)
window(b)
b

window(r) <- NULL
r
}

\keyword{methods}
\keyword{spatial}

\name{boundaries}

\alias{boundaries}
\alias{boundaries,SpatRaster-method}
  
\title{Detect boundaries (edges)}

\description{
Detect boundaries (edges). Boundaries are cells that have more than one class in the 4 or 8 cells surrounding it, or, if \code{classes=FALSE}, cells with values and cells with \code{NA}. 
}

\usage{
\S4method{boundaries}{SpatRaster}(x, classes=FALSE, inner=TRUE, directions=8,
		falseval=0, ignoreNA=FALSE, filename="", ...)
}

\arguments{
\item{x}{SpatRaster}
\item{inner}{logical. If \code{TRUE}, "inner" boundaries are returned, else "outer" boundaries are returned}
\item{classes}{character. Logical. If \code{TRUE} all different values are (after rounding) distinguished, as well as \code{NA}. If \code{FALSE} (the default) only edges between \code{NA} and non-\code{NA} cells are considered}
\item{directions}{integer. Which cells are considered adjacent? Should be 8 (Queen's case) or 4 (Rook's case)}
\item{falseval}{numeric. The value to use for cells that are not a boundary and not \code{NA}}
\item{ignoreNA}{logical. If \code{TRUE} and \code{classes=TRUE} external boundaries (with \code{NA} cells) are ignored, only boundaries between classes are returned (and the value of argument \code{inner} is irrelevant)}
\item{filename}{character. Output filename}
\item{...}{options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster. Cell values are either 1 (a boundary) or 0 (not a boundary), or \code{NA}
}

\seealso{ \code{\link{focal}}, \code{\link{patches}} }

\examples{
r <- rast(nrows=18, ncols=36, xmin=0)
r[150:250] <- 1
r[251:450] <- 2
bi <- boundaries(r)
bo <- boundaries(r, inner=FALSE)
bc <- boundaries(r, classes=TRUE)
#plot(bc)
}

\keyword{methods}
\keyword{spatial}

\name{layerCor}

\alias{layerCor}
\alias{layerCor,SpatRaster-method}


\title{Correlation and (weighted) covariance}


\description{
Compute correlation, (weighted) covariance, or similar summary statistics that compare the values of all pairs of the layers of a SpatRaster. 
}


\usage{
\S4method{layerCor}{SpatRaster}(x, fun, w, asSample=TRUE, use="everything", maxcell=Inf, ...)
}


\arguments{
  \item{x}{SpatRaster}

  \item{fun}{character. The statistic to compute: either "cov" (covariance), "weighted.cov" (weighted covariance), or "cor" (pearson correlation coefficient). You can also supply your own function that takes two vectors as argument to compute a single number}

  \item{w}{SpatRaster with the weights  to compute the weighted covariance. It should have a single layer and the same geometry as \code{x}}

  \item{asSample}{logical. If \code{TRUE}, the statistic for a sample (denominator is \code{n-1}) is computed, rather than for the population (denominator is \code{n}). Only for the standard functions}
   
  \item{use}{character. To decide how to handle missing values. This must be (an abbreviation of) one of "everything", "complete.obs", "pairwise.complete.obs", "masked.complete". With "pairwise.complete.obs", the value for a pair of layers is computed for all cells that are not \code{NA} in that pair. Therefore, it may be that the (number of) cells used varies between pairs. The benefit of this approach is that all available data is used. Use "complete.obs", if you want to only use the values from cells that are not \code{NA} in any of the layers. By using "masked.complete" you indicate that all layers have NA values in the same cells}
    
  \item{maxcell}{positive integer. The maximum number of cells to be used. If this is smaller than ncell(x), a regular sample of \code{x} is used}

  \item{...}{additional arguments for \code{fun} (if it is a proper function)}
}


\value{
If \code{fun} is one of the three standard statistics, you get a list with three items: the correlation or (weighted) covariance matrix, the (weighted) means, and the number of data cells in each comparison. The means are also a matrix because they may depend on the combination of layers 
if different cells have missing values and these are excluded from the computation. The rows of the mean matrix represent the layer whose (weighted) mean is being calculated and the columns represent the layer it is being paired with. Only cells with non-missing observations for both layers are used in the calculation of the (weighted) mean. The diagonals of the mean and n matrices are set to missing.

If \code{fun} is a function, you get a single matrix.
}

\references{
For the weighted covariance:
\itemize{
\item {Canty, M.J. and A.A. Nielsen, 2008. Automatic radiometric normalization of multitemporal satellite imagery with the iteratively re-weighted MAD transformation. Remote Sensing of Environment 112:1025-1036.}
\item {Nielsen, A.A., 2007. The regularized iteratively reweighted MAD method for change detection in multi- and hyperspectral data. IEEE Transactions on Image Processing 16(2):463-478.} 
}
}

\seealso{
 \code{\link{global}}, \code{\link{cov.wt}}, \code{\link{weighted.mean}}
}

\examples{
b <- rast(system.file("ex/logo.tif", package="terra"))   
layerCor(b, "cor")

layerCor(b, "cov")

# weigh by column number
w <- init(b, fun="col")
layerCor(b, "weighted.cov", w=w)

# specify another function
layerCor(b, function(x, y) cor(x, y, method="spearman"))
}

	

\docType{methods}
\name{flowAccumulation}

\alias{flowAccumulation}
\alias{flowAccumulation,SpatRaster-method}


\title{Flow accumulation}

\description{
Computes flow accumulation or the total contributing area in terms of numbers of cells upstream of each cell. 
}

\usage{
\S4method{flowAccumulation}{SpatRaster}(x, weight=NULL, filename="", ...) 
}

\arguments{
  \item{x}{SpatRaster with flow direction, see \code{\link{terrain}}. }
  \item{weight}{SpatRaster with weight/score data. For example, cell area or precipitation}  
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{ 
SpatRaster
}

\details{
The algorithm is an adaptation of the one proposed by Zhou et al., 2019. 
}

\seealso{\code{\link{terrain}},\code{\link{watershed}}, \code{\link{NIDP}}}

\author{
Emanuele Cordano
}


\references{
Zhou, G., Wei, H. & Fu, S. A fast and simple algorithm for calculating flow accumulation matrices from raster digital elevation. Front. Earth Sci. 13, 317–326 (2019). doi:10.1007/s11707-018-0725-9. Also see: \url{https://ica-abs.copernicus.org/articles/1/434/2019/}
}


\examples{
elev1 <- array(NA,c(9,9))
elev2 <- elev1
dx <- 1
dy <- 1 
for (r in 1:nrow(elev1)) {
  y <- (r-5)*dx
  for (c in 1:ncol(elev1)) {
    
    x <- (c-5)*dy
    elev1[r,c] <- 5*(x^2+y^2)
    elev2[r,c] <- 10+5*(abs(x))-0.001*y 
  }
} 


## Elevation raster
elev1 <- rast(elev1)
elev2 <- rast(elev2)

t(array(elev1[],rev(dim(elev1)[1:2])))
t(array(elev2[],rev(dim(elev2)[1:2])))

plot(elev1)
plot(elev2)

## Flow direction raster
flowdir1<- terrain(elev1,v="flowdir")
flowdir2<- terrain(elev2,v="flowdir")

t(array(flowdir1[],rev(dim(flowdir1)[1:2])))
t(array(flowdir2[],rev(dim(flowdir2)[1:2])))

plot(flowdir1)
plot(flowdir2)

## 
flow_acc1 <- flowAccumulation((flowdir1))
flow_acc2 <- flowAccumulation((flowdir2))

weight <- elev1*0+10

flow_acc1w <- flowAccumulation(flowdir1,weight)
flow_acc2w <- flowAccumulation(flowdir2,weight)

t(array(flow_acc1w[],rev(dim(flow_acc1w)[1:2])))
t(array(flow_acc2w[],rev(dim(flow_acc2w)[1:2])))

plot(flow_acc1w)
plot(flow_acc2w)


## Application with example elevation data

elev <- rast(system.file('ex/elev.tif',package="terra"))
flowdir <- terrain(elev,"flowdir")

weight <- cellSize(elev,unit="km")
flowacc_weight <- flowAccumulation(flowdir,weight)
flowacc  <- flowAccumulation(flowdir)
}

\keyword{spatial}

\name{extractAlong}

\alias{extractAlong} 

\title{extract values along lines}

\description{ 
Extract raster values along a line. That is, the returned values are ordered along the line. That is not the case with \code{\link{extract}}
}

\usage{
extractAlong(x, y, ID=TRUE, cells=FALSE, xy=FALSE, online=FALSE, bilinear=TRUE)
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatVector with lines geometry}
  \item{ID}{logical. Should an ID column be added? If so, the first column returned has the IDs (record numbers) of input SpatVector \code{y}}
  \item{cells}{logical. If \code{TRUE} the cell numbers are also returned}
  \item{xy}{logical. If \code{TRUE} the coordinates of the cells traversed by \code{y} are also returned. See \code{\link{xyFromCell}}}
  \item{online}{logical. If \code{TRUE} the returned coordinates are snapped to \code{y}} 
  \item{bilinear}{logical. If \code{TRUE} the returned raster values computed with bilinear interpolation from the nearest four cells. Only relevant if \code{online=TRUE}} 
}

\value{
data.frame
}

\seealso{
\code{\link{extract}}
}


\examples{
r <- rast(ncols=36, nrows=18, vals=1:(18*36))
cds1 <- rbind(c(-50,0), c(0,60), c(40,5), c(15,-45), c(-10,-25))
cds2 <- rbind(c(80,20), c(140,60), c(160,0), c(140,-55))
lines <- vect(list(cds1, cds2), "lines")

extractAlong(r, lines)
}

\keyword{methods}
\keyword{spatial}

\name{units}

\alias{units}
\alias{units<-}
\alias{units,SpatRaster-method}
\alias{units<-,SpatRaster-method}
\alias{units,SpatRasterDataset-method}
\alias{units<-,SpatRasterDataset-method}

  
\title{units of SpatRaster or SpatRasterDataset}

\description{
Get or set the units of the layers of a SpatRaster or the datasets in a SpatRasterDataset.
}

\usage{
\S4method{units}{SpatRaster}(x)

\S4method{units}{SpatRaster}(x)<-value

\S4method{units}{SpatRasterDataset}(x)

\S4method{units}{SpatRasterDataset}(x)<-value
}

\arguments{
  \item{x}{SpatRaster}
  \item{value}{character}
}

\value{
character  
}

\seealso{\code{\link{time}, \link{names}}}

\examples{
s <- rast(system.file("ex/logo.tif", package="terra"))   

units(s) <- c("m/s", "kg", "ha")
units(s)
s

units(s) <- "kg"
units(s)
}


\keyword{spatial}

\name{writeRaster}

\alias{writeRaster,SpatRaster,character-method}

\alias{writeRaster}

\title{Write raster data to a file}

\description{
Write a SpatRaster to a file. 
}

\usage{
\S4method{writeRaster}{SpatRaster,character}(x, filename, overwrite=FALSE, ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{filename}{character. Output filename. Can be a single filename, or as many filenames as \code{nlyr(x)} to write a file for each layer}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{...}{additional arguments for writing files. See Details }
}

\value{
SpatRaster. This function is used for the side-effect of writing values to a file.
}

\seealso{
see \code{\link{writeCDF}} for writing NetCDF files.
}

\details{
In writeRaster, and in other methods that generate SpatRasters, options for writing raster files to disk can be provided as additional arguments or, in a few cases, as the \code{wopt} argument (a named list) if the additional arguments are already used for a different purpose. See \code{\link{terraOptions}} to get or set default values. The following options are available: 

\tabular{ll}{
\bold{name} \tab \bold{description}\cr

\code{datatype}\tab values accepted are "INT1U", "INT2U", "INT2S", "INT4U", "INT4S", "FLT4S", "FLT8S". With GDAL >= 3.5 you can also use "INT8U" and "INT8S". And with GDAL >= 3.7 you can also use "INT1S". See \code{\link{gdal}} to discover the GDAL version you are using.
The first three letters indicate whether the datatype is an integer (whole numbers) of a real number ("float", decimal numbers), the fourth character indicates the number of bytes used for each number. Higher values allow for storing larger numbers and/or more precision; but create larger files. The  "S" or "U" indicate whether the values are signed (both negative and positive) or unsigned (zero and positive values only).\cr

\code{filetype}\tab file format expressed as \href{https://gdal.org/en/latest/drivers/raster/index.html}{GDAL driver names}. If this argument is not supplied, the driver is derived from the filename. You can use \code{gdal(drivers=TRUE)} to see what drivers are available in your installation\cr

\code{gdal}\tab GDAL driver specific datasource creation options. See the GDAL documentation. For example, with the \href{https://gdal.org/en/latest/drivers/raster/gtiff.html}{GeoTiff file format} you can use \code{gdal=c("COMPRESS=DEFLATE", "TFW=YES")}.\cr

\code{tempdir}\tab the path where temporary files are to be written to.\cr

\code{progress}\tab positive integer. If the number of chunks is larger, a progress bar is shown.\cr

\code{memfrac}\tab numeric between 0 and 0.9 (higher values give a warning). The fraction of available RAM that terra is allowed to use.\cr

\code{memmax}\tab the maximum amount of RAM (in GB) that terra can use when processing a raster dataset. Should be less than what is detected (see \code{\link{mem_info}}), and higher values are ignored. Set it to a negative number or NA to ignore this value. \cr

\code{names}\tab output layer names.\cr

\code{NAflag}\tab numeric. value to represent missing (\code{NA} or \code{NaN}) values. See note\cr

\code{scale}\tab numeric. Cell values written to disk are divided by this value (default is 1). See \code{\link{scoff}}\cr

\code{offset}\tab numeric. Value that is subtracted from the cell values written to disk (default is 0). See 
\code{\link{scoff}} \cr

\code{verbose}\tab logical. If \code{TRUE} debugging information is printed\cr

\code{steps}\tab positive integers. In how many steps (chunks) do you want to process the data (for debugging)\cr

\code{todisk}\tab logical. If \code{TRUE} processing operates as if the dataset is very large and needs to be written to a temporary file (for debugging).\cr

\code{metadata}\tab character, see \code{\link{metags<-}} to write metadata\cr

}
}


\note{
GeoTiff files are, by default, written with LZW compression. If you do not want compression, use \code{gdal="COMPRESS=NONE"}.

When writing integer values the lowest available value (given the datatype) is used to represent \code{NA} for signed types, and the highest value is used for unsigned values. This can be a problem with byte data (between 0 and 255) as the value 255 is reserved for \code{NA}. To keep the value 255, you need to set another value as \code{NAflag}, or do not set a \code{NAflag} (with \code{NAflag=NA})
}

\examples{
r <- rast(nrows=5, ncols=5, vals=1:25)

# create a temporary filename for the example
f <- file.path(tempdir(), "test.tif")

writeRaster(r, f, overwrite=TRUE)

writeRaster(r, f, overwrite=TRUE, gdal=c("COMPRESS=NONE", "TFW=YES"), datatype='INT1U')

## Or with a wopt argument:

writeRaster(r, f, overwrite=TRUE, wopt= list(gdal=c("COMPRESS=NONE"), datatype='INT1U'))

## remove the file
unlink(f)
}

\keyword{ spatial }
\keyword{ methods }

\name{graticule}

\docType{methods}

\alias{graticule}

\title{ 
Create a graticule
}

\description{
Create a graticule. That is, a grid of lon/lat lines that can be used on a projected map.

The object returned, a SpatGraticule, can be plotted with \code{plot} and \code{lines}. There is also a \code{crop} method.
}

\usage{
graticule(lon=30, lat=30, crs="")
}

\arguments{
  \item{lon}{numeric. Either a single number (the interval between longitudes), or a vector with longitudes}
  \item{lat}{numeric. Either a single number (the interval between latitudes), or a vector with latitudes}
  \item{crs}{character. The coordinate reference system to use}
} 

\value{
SpatGraticule
}

\seealso{
\code{\link[=plot,SpatGraticule,missing-method]{plot<SpatGraticule>}}.
}

\examples{
g <- graticule(60, 30, crs="+proj=robin")
g
graticule(90, c(-90, -60, -23.5, 0, 23.5, 60, 90), crs="+proj=robin")
}

\keyword{methods}
\keyword{spatial}

\name{tighten}

\docType{methods}

\alias{tighten}
\alias{tighten,SpatRaster-method}
\alias{tighten,SpatRasterDataset-method}

\title{tighten SpatRaster or SpatRasterDataset objects}

\description{
Combines data sources within a SpatRaster (that are in memory, or from the same file) to allow for faster processing. 

Or combine sub-datasets into a SpatRaster.
}
\usage{

\S4method{tighten}{SpatRaster}(x)

\S4method{tighten}{SpatRasterDataset}(x)
}

\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
}


\value{
SpatRaster
}

\examples{
r <- rast(nrow=5, ncol=9, vals=1:45)
x <- c(r, r*2, r*3)
x
tighten(x)
}

\keyword{spatial}

\name{spatSample}

\docType{methods}

\alias{spatSample}
\alias{spatSample,SpatRaster-method}
\alias{spatSample,SpatExtent-method}
\alias{spatSample,SpatVector-method}

\title{Take a regular sample}

\description{
Take a spatial sample from a SpatRaster, SpatVector or SpatExtent. Sampling a SpatVector or SpatExtent always returns a SpatVector of points. 

With a SpatRaster, you can get cell values, cell numbers (\code{cells=TRUE}), coordinates (\code{xy=TRUE}) or (when \code{method="regular"} and \code{as.raster=TRUE}) get a new SpatRaster with the same extent, but fewer cells. 

In order to assure regularity when requesting a regular sample, the number of cells or points returned may not be exactly the same as the \code{size} requested unless you use \code{exact=TRUE} (and do not use \code{na.rm=TRUE}). Alternatively, use \code{method="spread"} to get an approximately regular sample for the cells that are not \code{NA}.
}

\usage{
\S4method{spatSample}{SpatRaster}(x, size, method="random", replace=FALSE, na.rm=FALSE, 
    as.raster=FALSE, as.df=TRUE, as.points=FALSE, as.mask=FALSE, values=hasValues(x), 
	cells=FALSE, xy=FALSE, ext=NULL, warn=TRUE, weights=NULL, exp=5, exhaustive=FALSE, 
	exact=FALSE, each=TRUE, ...)

\S4method{spatSample}{SpatVector}(x, size, method="random", strata=NULL, chess="")

\S4method{spatSample}{SpatExtent}(x, size, method="random", lonlat, as.points=FALSE, exact=FALSE)
}

\arguments{
  \item{x}{SpatRaster, SpatVector or SpatExtent}
  \item{size}{numeric. The sample size. If \code{x} is a SpatVector, you can also provide a vector of the same length as \code{x} in which case sampling is done separately for each geometry. If \code{x} is a SpatRaster, and you are using \code{method="regular"} you can specify the size as two numbers (number of rows and columns). Note that when using \code{method="stratified"}, the sample size is returned for each stratum}
  \item{method}{character. Should be one of "regular", "random", or, if \code{x} is a \code{SpatRaster}, "stratified" (each value in \code{x} is a stratum), "weights" (each value in \code{x} is a probability weight), or "spread" (an approximately regular sample, using compact zones generated with \code{\link{k_means}} clustering of the raster cell locations)}
  \item{replace}{logical. If \code{TRUE}, sampling is with replacement (if \code{method="random"})}
  \item{na.rm}{logical. If \code{TRUE}, \code{NAs} are removed. Not used with \code{method="spread"} or \code{as.raster=TRUE}}
  \item{as.raster}{logical. If \code{TRUE}, a SpatRaster is returned}
  \item{as.df}{logical. If \code{TRUE}, a data.frame is returned instead of a matrix}
  \item{as.points}{logical. If \code{TRUE}, a SpatVector of points is returned}
  \item{as.mask}{logical. If \code{TRUE} \code{x} is returned, with its values "masked" by the sample. That is, only cells that are included in the sample retain their values}
  \item{values}{logical. If \code{TRUE} raster cell values are returned}
  \item{cells}{logical. If \code{TRUE}, cell numbers are returned. If \code{method="stratified"} this is always set to \code{TRUE} if \code{xy=FALSE}}
  \item{xy}{logical. If \code{TRUE}, cell coordinates are returned}
  \item{ext}{SpatExtent or NULL to restrict sampling to a subset of the area of \code{x}}
  \item{warn}{logical. Give a warning if the sample size returned is smaller than requested}
  \item{weights}{SpatRaster. Used to provide weights when \code{method="stratified"}}

  \item{lonlat}{logical. If \code{TRUE}, sampling of a SpatExtent is weighted by \code{cos(latitude)}. For SpatRaster and SpatVector this done based on the \code{\link{crs}}, but it is ignored if \code{as.raster=TRUE}}
  
  \item{exp}{numeric >= 1. "Expansion factor" that is multiplied with \code{size} to get an initial sample used for stratified samples and random samples with \code{na.rm=TRUE} to try to get at least \code{size} samples}
  
  \item{exhaustive}{logical. If \code{TRUE} and (\code{method=="random"} and \code{na.rm=TRUE}) or \code{method=="stratified"}, all cells that are not \code{NA} are determined and a sample is taken from these cells. This is useful when you are dealing with a very large raster that is sparse (most cells are \code{NA}). Otherwise, the default approach may not find enough samples. This should not be used in other cases, especially not with large rasters that mostly have values}
  \item{exact}{logical. If \code{TRUE} and \code{method=="regular"}, the sample returned is exactly \code{size}, perhaps at the expense of some regularity. Otherwise you get at least \code{size} many samples. Ignored for lon/lat rasters}
  \item{each}{logical. If \code{TRUE} and \code{method=="stratified"}, the sample returned is \code{size} for each stratum. Otherwise \code{size} is the total sample size}
  \item{...}{additional arguments passed to \code{\link{k_means}} when \code{method="kmeans"}}

  \item{strata}{if not NULL, stratified random sampling is done, taking \code{size} samples from each stratum. If \code{x} has polygon geometry, \code{strata} must be a field name (or index) in \code{x}. If \code{x} has point geometry, \code{strata} can be a SpatVector of polygons or a SpatRaster}
  \item{chess}{character. One of "", "white", or "black". For stratified sampling if \code{strata} is a SpatRaster. If not "", samples are only taken from alternate cells, organized like the "white" or "black" fields on a chessboard}

}

\value{
numeric matrix, data.frame, SpatRaster or SpatVector
}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
s <- spatSample(r, 10, as.raster=TRUE)
spatSample(r, 5)
spatSample(r, 5, na.rm=TRUE)
spatSample(r, 5, "regular")

## if you require cell numbers and/or coordinates
size <- 6
spatSample(r, 6, "random", cells=TRUE, xy=TRUE, values=FALSE)

# regular, with values 
spatSample(r, 6, "regular", cells=TRUE, xy=TRUE)

# stratified
rr <- rast(ncol=10, nrow=10, names="stratum")
set.seed(1)
values(rr) <- round(runif(ncell(rr), 1, 3))
spatSample(rr, 2, "stratified", xy=TRUE)

s <- spatSample(rr, 5, "stratified", as.points=TRUE, each=FALSE)
plot(rr, plg=list(title="raster"))
plot(s, 1, add=TRUE, plg=list(x=185, y=1, title="points"), col=rainbow(5))
 
# spread 
s <- spatSample(r, 10, "spread", as.points=TRUE)
plot(r); points(s)
  
## SpatExtent 
e <- ext(r)
spatSample(e, 10, "random", lonlat=TRUE)

## SpatVector
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)

# sample the geometries 
i <- sample(v, 3)

# sample points in geometries
p <- spatSample(v, 3)

}

\keyword{spatial}

\name{topology}

\docType{methods}

\alias{topology}

\alias{makeNodes}
\alias{mergeLines}
\alias{removeDupNodes}
\alias{emptyGeoms}
\alias{snap}

\alias{makeNodes,SpatVector-method}
\alias{mergeLines,SpatVector-method}
\alias{snap,SpatVector-method}
\alias{removeDupNodes,SpatVector-method}
\alias{emptyGeoms,SpatVector-method}

\title{ 
Vector topology methods
}

\description{

\code{makeNodes} create nodes on lines

\code{mergeLines} connect lines to form polygons

\code{removeDupNodes} removes duplicate nodes in geometries and optionally rounds the coordinates

\code{emptyGeoms} returns the indices of empty (null) geometries. \code{\link{is.na}} also checks if any of the coordinates is \code{NA}.

\code{snap} makes boundaries of geometries identical if they are very close to each other. The \code{tolerance} is expressed in the coordinate reference system's units: meters (or feet, etc.) for projected data, and \strong{degrees} for lon/lat data. To snap lon/lat geometries with a tolerance expressed in meters, project the data to a metric CRS first with \code{\link{project}}, snap, then project back. \code{\link{simplifyGeom}} uses the same convention.
}

\usage{
\S4method{mergeLines}{SpatVector}(x)
\S4method{snap}{SpatVector}(x, y=NULL, tolerance)
\S4method{removeDupNodes}{SpatVector}(x, digits = -1)
\S4method{makeNodes}{SpatVector}(x)
}

\arguments{
\item{x}{SpatVector of lines or polygons}
\item{y}{SpatVector of lines or polygons to snap to. If \code{NULL} snapping is to the other geometries in \code{x}}
\item{tolerance}{numeric. Snapping tolerance, expressed in the units of the CRS of \code{x} (i.e. meters or feet for projected data, \strong{degrees} for lon/lat data). One degree of latitude is approximately 111 km.}
\item{digits}{numeric. Number of digits used in rounding. Ignored if < 0}
} 

\value{
SpatVector
}


\seealso{\code{\link{sharedPaths}}, \code{\link{gaps}}, \code{\link{simplifyGeom}}, \code{\link{forceCCW}}, \code{\link{fillHoles}}}




\examples{
p1 <- as.polygons(ext(0,1,0,1))
p2 <- as.polygons(ext(1.1,2,0,1))

p <- rbind(p1, p2)

y <- snap(p, tol=.15)
plot(p, lwd=3, col="light gray")
lines(y, col="red", lwd=2)
}

\keyword{methods}
\keyword{spatial}

\name{describe}

\alias{describe}
\alias{describe,character-method}
\alias{describe,SpatRaster-method}

\title{describe}

\description{
Describe the properties of spatial data in a file as generated with the "GDALinfo" tool.
}

\usage{
\S4method{describe}{character}(x, sds=FALSE, meta=FALSE, parse=FALSE, options="", print=FALSE, open_opt="")

\S4method{describe}{SpatRaster}(x, source, ...)
}

\arguments{
  \item{x}{character. The name of a file with spatial data. Or a fully specified subdataset within a file such as \code{"NETCDF:\"AVHRR.nc\":NDVI"}}
  \item{sds}{logical. If \code{TRUE} the description or metadata of the subdatasets is returned (if available)}
  \item{meta}{logical. Get the file level metadata instead}
  \item{parse}{logical. If \code{TRUE}, metadata for subdatasets is parsed into components (if \code{meta=TRUE})}
  \item{options}{character. A vector of valid options (if \code{meta=FALSE}) including "json", "mm", "stats", "hist", "nogcp", "nomd", "norat", "noct", "nofl", "checksum", "proj4", "listmdd", "mdd <value>" where <value> specifies a domain or 'all', "wkt_format <value>" where value is one of 'WKT1', 'WKT2', 'WKT2_2015', or 'WKT2_2018', "sd <subdataset>" where <subdataset> is the name or identifier of a sub-dataset. See \url{https://gdal.org/en/latest/programs/gdalinfo.html}. Ignored if \code{sds=TRUE}}  
  \item{print}{logical. If \code{TRUE}, print the results}
  \item{open_opt}{character. Driver specific open options}   
  \item{source}{positive integer between 1 and \code{nsrc(x)}}   
  \item{...}{additional arguments passed to the \code{describe<character>} method}
}

\value{
character (invisibly, if \code{print=FALSE})
}

\seealso{\code{\link{ar_info}}}

\examples{
f <- system.file("ex/elev.tif", package="terra")
describe(f)
describe(f, meta=TRUE)
#g <- describe(f, options=c("json", "nomd", "proj4"))
#head(g)
}

\keyword{spatial}

\name{wrap}

\alias{wrap}
\alias{unwrap}

\alias{wrap,SpatExtent-method}
\alias{wrap,SpatVector-method}
\alias{wrap,SpatRaster-method}
\alias{wrap,SpatRasterDataset-method}
\alias{wrap,SpatRasterCollection-method}
\alias{unwrap,ANY-method}
\alias{unwrap,PackedSpatExtent-method}
\alias{unwrap,PackedSpatRaster-method}
\alias{unwrap,PackedSpatRasterDC-method}
\alias{unwrap,PackedSpatVector-method}


\title{wrap and unwrap}

\description{
Use \code{wrap} to pack a SpatVector or SpatRaster* to create a Packed* object. Packed objects can be passed over a connection that serializes (e.g. to nodes on a computer cluster). At the receiving end they need to be unpacked with \code{unwrap}.
}

\usage{
\S4method{wrap}{SpatRaster}(x, proxy=FALSE)

\S4method{wrap}{SpatRasterDataset}(x, proxy=FALSE)

\S4method{wrap}{SpatRasterCollection}(x, proxy=FALSE)

\S4method{wrap}{SpatVector}(x)

\S4method{unwrap}{ANY}(x)
}

\arguments{
  \item{x}{SpatVector, SpatRaster, SpatRasterDataset or SpatRasterCollection}
  \item{proxy}{logical. If \code{FALSE} raster cell values are forced to memory if possible. If \code{TRUE}, a reference to source filenames is stored for data sources that are not in memory}
}

\value{
\code{wrap}: Packed* object

\code{unwrap}: SpatVector, SpatRaster, SpatRasterCollection, SpatRasterDataset
}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
p <- wrap(v)
p
vv <- vect(p)
vv
}


\keyword{ spatial }
\keyword{ methods }

\name{sapp}

\docType{methods}

\alias{sapp}
\alias{sapp,SpatRaster-method}
\alias{sapp,SpatRasterDataset-method}

\title{Apply a terra function that takes only a single layer and returns a SpatRaster to all layers of a SpatRaster}

\description{
Apply to all layers of a SpatRaster a function that only takes a single layer SpatRaster and returns a SpatRaster (these are rare). In most cases you can also use \code{lapply} or \code{sapply} for this. 

Or apply the same method to each sub-dataset (SpatRaster) in a SpatRasterDataset
}

\usage{
\S4method{sapp}{SpatRaster}(x, fun, ..., filename="", overwrite=FALSE, wopt=list())

\S4method{sapp}{SpatRasterDataset}(x, fun, ..., filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
  \item{fun}{if \code{x} is a \code{SpatRaster}: a function that takes a SpatRaster argument and can be applied to each layer of \code{x} (e.g. \code{\link{terrain}}. 
  if \code{x} is a \code{SpatRasterDataset}: a function that is applied to all layers of the SpatRasters in \code{x} (e.g. \code{mean}}
  \item{...}{additional arguments to be passed to \code{fun}} 
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{\code{ \link{lapp}, \link{app}, \link[terra]{tapp}, \link{lapply}} }


\examples{
s <- rast(system.file("ex/logo.tif", package="terra")) + 1  

#SpatRasterDataset
sd <- sds(s*2, s/2)
y <- sapp(sd, mean)
z <- sapp(sd, function(i) 2 * mean(i))

}
 
\keyword{methods}
\keyword{spatial}

\name{simplifyGeom}

\docType{methods}

\alias{simplifyGeom}

\alias{simplifyGeom,SpatVector-method}

\title{ 
simplifyGeom geometries
}

\description{
Reduce the number of nodes used to represent geometries.
}

\usage{
\S4method{simplifyGeom}{SpatVector}(x, tolerance=0.1, preserveTopology=TRUE, makeValid=TRUE)
}

\arguments{
  \item{x}{SpatVector of lines or polygons}
  \item{tolerance}{numeric. The minimum distance between nodes in units of the crs (i.e. degrees for long/lat)}
  \item{preserveTopology}{logical. If \code{TRUE} the topology of output geometries is preserved}
  \item{makeValid}{logical. If \code{TRUE}, \code{\link{makeValid}} is run after simplification to assure that the output polygons are valid}
} 

\value{
SpatVector
}


\seealso{\code{\link{densify}}, \code{\link{sharedPaths}}, \code{\link{gaps}}, \code{\link{is.valid}}}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
w <- simplifyGeom(v, .02, makeValid=FALSE)
e <- erase(w)
g <- gaps(e)
plot(e, lwd=5, border="light gray")
polys(g, col="red", border="red")
}


\keyword{methods}
\keyword{spatial}

\name{expanse}

\alias{area}
\alias{area,SpatRaster-method}
\alias{area,SpatVector-method}

\alias{expanse}
\alias{expanse,SpatRaster-method}
\alias{expanse,SpatVector-method}

  
\title{Get the expanse (area) of individual polygons or for all (summed) raster cells}

\description{
Compute the area covered by polygons or for all raster cells that are not \code{NA}. 

This method computes areas for longitude/latitude rasters, as the size of the cells is constant in degrees, but not in square meters. But it can also be important if the coordinate reference system is planar, but not equal-area. 

For vector data, the best way to compute area is to use the longitude/latitude CRS. This is contrary to (erroneous, but popular) belief that you should use a planar coordinate reference system. Where applicable, the transformation to lon/lat is done automatically, if \code{transform=TRUE}.

Note that it is important that polygon geometries are valid. If they are not valid, the computed area may be wrong. You can check for validity with \code{\link{is.valid}} and fix some problems with \code{\link{makeValid}}
}

\usage{
\S4method{expanse}{SpatRaster}(x, unit="m", transform=TRUE, byValue=FALSE,
			zones=NULL, wide=FALSE, usenames=FALSE)

\S4method{expanse}{SpatVector}(x, unit="m", transform=TRUE)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{unit}{character. Output unit of area. One of "m", "km", or "ha"}
  \item{transform}{logical. If \code{TRUE}, planar CRS are transformed to lon/lat for accuracy}
  \item{byValue}{logical. If \code{TRUE}, the area for each unique cell value is returned}
  \item{zones}{NULL or SpatRaster with the same geometry identifying zones in \code{x}}
  \item{wide}{logical. Should the results be in "wide" rather than "long" format?}
  \item{usenames}{logical. If \code{TRUE} layers are identified by their names instead of their numbers}
}  

\value{
\bold{SpatRaster}: \code{data.frame} with at least two columns ("layer" and "area") and possibly also "value" (if \code{byValue} is \code{TRUE}), and "zone" (if \code{zones} is \code{TRUE}). If \code{x} has no values, the total area of all cells is returned. Otherwise, the area of all cells that are not \code{NA} is returned. 

\bold{SpatVector}: numeric (one value for each (multi-) polygon geometry.
}

\seealso{
\code{\link{cellSize}} for a the size of individual cells of a raster, that can be summed with \code{\link{global}} or with \code{\link{zonal}} to get the area for different zones; \code{\link{surfArea}} for a raster with elevation values, taking into account the sloping nature of the surface.
}

\examples{

### SpatRaster 
r <- rast(nrows=18, ncols=36)
v <- 1:ncell(r)
v[200:400] <- NA
values(r) <- v

# summed area in km2
expanse(r, unit="km")

# all cells 
expanse(rast(r), unit="km")

r <- rast(ncols=90, nrows=45, ymin=-80, ymax=80)
m <- project(r, "+proj=merc")

expanse(m, unit="km")
expanse(m, unit="km", transform=FALSE)

m2 <- c(m, m)
values(m2) <- cbind(c(1,2,NA,NA), c(11:14))
expanse(m2, unit="km", byValue=TRUE, wide=TRUE)


v <- vect(system.file("ex/lux.shp", package="terra"))
r <- rast(system.file("ex/elev.tif", package="terra"))
r <- round((r-50)/100)
levels(r) <- data.frame(id=1:5, name=c("forest", "water", "urban", "crops", "grass"))
expanse(r, byValue=TRUE)

g <- rasterize(v, r, "NAME_1")
expanse(r, byValue=TRUE, zones=g, wide=TRUE)


### SpatVector
v <- vect(system.file("ex/lux.shp", package="terra"))

a <- expanse(v)
a
sum(a)
}

\keyword{methods}
\keyword{spatial}

\name{thin}

\docType{methods}

\alias{thin}
\alias{thin,SpatVector-method}

\alias{thinNodes}
\alias{thinNodes,SpatVector-method}

\title{Subset geometries by minimum distance}

\description{
\code{thin} return a subset of geometries such that all remaining geometries are at least \code{d} apart from each other. This uses greedy spatial thinning: the first geometry is always kept, and subsequent geometries are only kept if they are at least \code{d} away from all previously kept geometries.

\code{thinNodes} reduces the number of nodes to represent line or polygon geometries
}

\usage{
\S4method{thin}{SpatVector}(x, d, unit="m")

\S4method{thinNodes}{SpatVector}(x, d, unit="m", makeValid=TRUE)
}

\arguments{
  \item{x}{SpatVector}
  \item{d}{positive numeric. The minimum distance between geometries or nodes}
  \item{unit}{character. \code{"m"} (meter, the default) or \code{"km"} (kilometer)}
  \item{makeValid}{logical. If \code{TRUE} an attempt is made to assure that thinned polygon geometries are valid (e.g., not self intersecting)}
}

\value{
SpatVector
}

\seealso{\code{\link{densify}}, \code{\link{distance}}, \code{\link{nearby}}, \code{\link{nearest}}}

\examples{
p <- vect( matrix(c(0, .5, .6, 5, 5.5, 50), ncol=2, nrow=6), crs="lonlat")
values(p) <- data.frame(id=1:6)
nrow(p)

# points that are at least 200 km apart
p2 <- thin(p, 200000)
nrow(p2)

# same, using km
p3 <- thin(p, 200, unit="km")
nrow(p3)
}

\keyword{spatial}

\name{add_mtext}

\alias{add_mtext}

\title{add a margin text}

\description{ 
Similar to \code{\link[graphics]{mtext}} allowing adding a text to the margins of a map. This function uses the margins around the mapped area; not the margins that R would use.
}

\usage{
add_mtext(text, side=3, line=0, adj=0.5, ...)
}

\arguments{
  \item{text}{character or expression vector specifying the text to be written}
  \item{side}{ integer indicating the margin to use (1=bottom, 2=left, 3=top, 4=right)}
  \item{line}{ numeric to move the text in or outwards}
  \item{adj}{numeric between 0 and 1 to align the text along the margin. Use 0 for left (sides 1 and 3) or bottom (sides 2 and 4), 1 for right or top, and 0.5, the default, to center it}
  \item{...}{arguments passed to \code{\link{text}}}
}


\seealso{\code{\link{add_legend}}, \code{\link{add_grid}}, \code{\link{add_box}}}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)

plot(r, axes=FALSE, legend=FALSE)
add_box()
for (i in 1:4) add_mtext("margin text", i, cex=i, col=i, line=2-i)

# align the text along the margin
plot(r, axes=FALSE, legend=FALSE)
add_box()
for (i in 1:4) {
	add_mtext("start", i, adj=0, col="blue")
	add_mtext("middle", i, adj=0.5, cex=1.5)
	add_mtext("end", i, adj=1, col="red")
}

}

\keyword{methods}
\keyword{spatial}

\name{sbar}

\alias{sbar}
  
\title{scale bar}

\description{
Add a scale bar to a map
}

\usage{
sbar(d, xy=NULL, type="line", divs=2, below="", lonlat=NULL, labels,
	adj=c(0.5, -1), lwd=2, xpd=TRUE, ticks=FALSE, scaleby=1, halo=TRUE,
	col="black", fill=c("black", "white"), border="black", bg=NULL, ...)
}

\arguments{
\item{d}{numeric. Distance covered by the scale bar. It should be in the units of the coordinates of the plot (map), or in km for angular (longitude/latitude) coordinates; see argument \code{lonlat}. It can also be missing}
\item{xy}{numeric. x and y coordinates to place the scale bar. It can also be one of following character values: "bottomleft", "bottom", "bottomright", "topleft", "top", "topright", "left", "right", or NULL}
\item{type}{one of "line" or "bar"}
\item{divs}{number of divisions for a bar: 2 or 4}
\item{below}{character. Text to go below the scale bar (e.g., "kilometers")}
\item{lonlat}{logical or NULL. If logical, \code{TRUE} indicates if the plot is using longitude/latitude coordinates. If \code{NULL} this is guessed from the plot's coordinates}
\item{labels}{vector of three numbers to label the scale bar (beginning, midpoint, end)}
\item{adj}{adjustment for text placement}
\item{lwd}{line width for the "line" type of the scale bar}
\item{xpd}{logical. If \code{TRUE}, the scale bar can be outside the plotting area}
\item{ticks}{logical or numeric. If not \code{FALSE}, tick marks are added to a "line" scale bar. The length of the tick marks can be specified}
\item{scaleby}{numeric. If \code{labels} is not provided. The labels are divided by this number. For example, use 1000 to go from m to km}
\item{halo}{logical. If \code{TRUE} the "line" type scale bar gets a white background}
\item{col}{the font color for the labels}
\item{fill}{the fill color(s) for the bar}
\item{border}{the color of the border around the bar}
\item{bg}{background color behind the scale bar (e.g. \code{"white"} or \code{rgb(1,1,1,0.7)}) for visibility on complex maps. Default is \code{NULL} (no background)}
\item{...}{graphical arguments to be passed to other methods }
}

\value{
none
}

\seealso{ \code{\link[terra]{north}}, \code{\link[terra]{plot}}, \code{\link[terra]{inset}} }

\examples{
f <- system.file("ex/meuse.tif", package="terra")
r <- rast(f)
plot(r)
sbar()
sbar(1000, xy=c(178500, 333500), type="bar", divs=4, cex=.8)
sbar(1000, xy="bottomright", divs=3, cex=.8, ticks=TRUE)


f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
plot(r, type="interval")
sbar(20, c(6.2, 50.1), type="bar", cex=.8, divs=4)
sbar(15, c(6.3, 50), type="bar", below="km", label=c(0,7.5,15), cex=.8)
sbar(15, c(6.6, 49.8), cex=.8, label=c(0,"km",15))
sbar(15, c(6.6, 49.7), cex=.8, label="15 kilometer", lwd=5)
sbar(15, c(6.6, 49.6), divs=4, cex=.8, below="km")
}


\keyword{spatial}

\name{image}

\docType{methods}

\alias{image}
\alias{image,SpatRaster-method}

\title{SpatRaster image method}

\description{
Plot (make a map of) the values of a SpatRaster via \code{\link[graphics]{image}}. See \code{\link[terra]{plot}} if you need more fancy options such as a legend.
}

\usage{
\S4method{image}{SpatRaster}(x, y=1, maxcell=500000, ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{positive integer indicating the layer to be plotted, or a character indicating the name of the layer}
  \item{maxcell}{positive integer. Maximum number of cells to use for the plot}
  \item{...}{additional arguments as for \code{graphics::\link[graphics]{image}} }
}


\seealso{
 \code{\link[terra]{plot}}  
}

\examples{ 
f <- system.file("ex/elev.tif", package="terra") 
r <- rast(f)
image(r)
image(r, col=rainbow(24))
}

\keyword{methods}
\keyword{spatial}

\name{rotate}

\docType{methods}

\alias{rotate}
\alias{rotate,SpatRaster-method}
\alias{rotate,SpatVector-method}

\title{Rotate data along longitude}

\description{
Rotate a SpatRaster that has longitude coordinates from 0 to 360, to standard coordinates between -180 and 180 degrees (or vice-versa). Longitude between 0 and 360 is frequently used in global climate models.

Rotate a SpatVector as for a SpatRaster with, or with \code{split=FALSE} to correct for coordinates that are connected across the date line (and end up at the "other side" of the longitude scale).
}

\usage{
\S4method{rotate}{SpatRaster}(x, filename="", ...)

\S4method{rotate}{SpatVector}(x, longitude=0, split=TRUE, left=TRUE, normalize=FALSE)
}

\arguments{
 \item{x}{SpatRaster or SpatVector}
 \item{filename}{character. Output filename}
 \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}

 \item{longitude}{numeric. The longitude around which to rotate}
 \item{split}{logical. Should geometries be split at \code{longitude}?}
 \item{left}{logical. Rotate to the left or to the right?}
 \item{normalize}{logical. Should the output be normalized to longitudes between -180 and 180? See \code{\link{normalize.longitude}}}
}

\value{
SpatRaster
}

\seealso{\code{\link{shift}} and \code{\link{spin}}}

\examples{
x <- rast(nrows=9, ncols=18, nl=3, xmin=0, xmax=360)
v <- rep(as.vector(t(matrix(1:ncell(x), nrow=9, ncol=18))), 3)
values(x) <- v
z <- rotate(x)

\dontrun{
#SpatVector
p <- rbind(c(3847903, 1983584 ), c(3847903, 5801864), c(8301883, 5801864), c(8301883, 1983584 ))
p <- vect(p, "polygons", crs="+init=EPSG:3347")
d <- densify(p, 100000)
g <- project(d, "+proj=longlat")

x <- rotate(g, 50)
plot(g)
lines(x, col="red")
}

## rotate countries to 0-360 longitude
#w <- geodata::world(path=".")
#x <- rotate(w, long=0, split=TRUE, left=FALSE)

}

\keyword{spatial}

\name{meta}

\docType{methods}

\alias{meta}
\alias{meta,SpatRaster-method}

\title{meta}

\description{ 
Get metadata associated with the sources or layers of a SpatRaster 
}

\usage{
\S4method{meta}{SpatRaster}(x, layers=FALSE)
}

\arguments{
  \item{x}{SpatRaster}
  \item{layers}{logical. Should the layer level metadata be returned?}
}

\value{
list
}


\keyword{methods}
\keyword{spatial}

\name{lines}

\docType{methods}

\alias{points}
\alias{lines}
\alias{polys}

\alias{lines,SpatVector-method}
\alias{lines,SpatRaster-method}
\alias{lines,SpatGraticule-method}
\alias{lines,SpatExtent-method}
\alias{lines,sf-method}

\alias{points,SpatVector-method}
\alias{points,SpatRaster-method}
\alias{points,SpatExtent-method}
\alias{points,sf-method}

\alias{polys,SpatVector-method}
\alias{polys,SpatRaster-method}
\alias{polys,SpatExtent-method}
\alias{polys,sf-method}


\title{Add points, lines, or polygons to a map}

\description{
Add a vector geometries to a plot (map) with \code{points}, \code{lines}, or \code{polys}. 

These are simpler alternatives for \code{\link[terra:plot]{plot(x, add=TRUE)}}

These methods also work for a small(!) SpatRaster. Only cells that are not NA in the first layer are used.
}

\usage{
\S4method{points}{SpatVector}(x, y=NULL, col, cex=0.7, pch=16, alpha=1, jitter=0, legend=FALSE, ...)

\S4method{lines}{SpatVector}(x, y=NULL, col, lwd=1, lty=1, arrows=FALSE, alpha=1, legend=FALSE, ...)

\S4method{polys}{SpatVector}(x, y=NULL, col, border="black", lwd=1, lty=1, alpha=1, legend=FALSE, ...)

\S4method{points}{SpatRaster}(x, ...)

\S4method{lines}{SpatRaster}(x, mx=10000, ...)

\S4method{polys}{SpatRaster}(x, mx=10000, dissolve=TRUE, ...)

\S4method{points}{SpatExtent}(x, col="black", alpha=1, ...)

\S4method{lines}{SpatExtent}(x, col="black", alpha=1, ...)

\S4method{polys}{SpatExtent}(x, col, alpha=1, ...)
}

\arguments{
  \item{x}{SpatVector or SpatExtent}
  \item{y}{missing, or a character (variable name) or positive integer (column number) to color the geometries by the values of that variable of \code{x}. With \code{lines}, \code{y} can also be a SpatVector; if both \code{x} and \code{y} have point geometry and the same number of rows, lines are drawn between pairs of points}
  \item{col}{character. Colors}
  \item{legend}{logical. If \code{TRUE} and \code{y} is a variable name/number, a legend is shown}
  \item{border}{character. color(s) of the polygon borders. Use \code{NULL} or \code{NA} to not draw a border}
  \item{cex}{numeric. point size magnifier. See \code{\link{par}}}
  \item{pch}{positive integer, point type. See \code{\link{points}}. On some (linux) devices, the default symbol "16" is a not a very smooth circle. You can use "20" instead (it takes a bit longer to draw) or "1" for an open circle}
  \item{alpha}{number between 0 and 1 to set transparency}
  \item{jitter}{numeric. The amount of random noise used to adjust label positions, possibly avoiding overlaps. See argument 'factor' in \code{\link{jitter}}}
  \item{lwd}{numeric, line-width. See \code{\link{par}}}
  \item{lty}{positive integer, line type. See \code{\link{par}}}
  \item{arrows}{logical. If \code{TRUE} and \code{y} is a SpatVector, arrows are drawn instead of lines. See \code{\link[graphics]{arrows}} for additional arguments}
  \item{mx}{positive number. If the number of cells of SpatRaster \code{x} is higher, the method will fail with an error message}
  \item{dissolve}{logical. Should boundaries between cells with the same value be removed?} 
  \item{...}{additional graphical arguments such as \code{lwd}, \code{cex} and \code{pch}}  
}


\examples{ 
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)

r <- rast(v)
values(r) <- 1:ncell(r)
plot(r)
lines(v)
points(v)

# color by the values of a variable
plot(v, col="light gray", border="white")
lines(v, "NAME_1", lwd=5)
points(centroids(v), "AREA", cex=2, legend="topright")
}

\keyword{methods}
\keyword{spatial}

\name{origin}

\alias{origin}
\alias{origin,SpatRaster-method}
\alias{origin<-}
\alias{origin<-,SpatRaster-method}

 
\title{Origin}

\description{
Get or set the coordinates of the point of origin of a SpatRaster. This is the point closest to (0, 0) that you could get if you moved towards that point in steps of the x and y resolution.
}

\usage{
\S4method{origin}{SpatRaster}(x)

\S4method{origin}{SpatRaster}(x)<-value
}

\arguments{
  \item{x}{SpatRaster}
  \item{value}{numeric vector of length 1 or 2}
}


\value{
A vector of two numbers (x and y coordinates)
}


\examples{
r <- rast(xmin=-0.5, xmax = 9.5, ncols=10)
origin(r)
origin(r) <- c(0,0)
r
}

\keyword{spatial}

\name{rectify}

\alias{rectify}
\alias{rectify,SpatRaster-method}


\title{Rectify a SpatRaster}


\description{
Rectify a rotated SpatRaster into a non-rotated object
}

\usage{
\S4method{rectify}{SpatRaster}(x, method="bilinear", aoi=NULL, snap=TRUE,
         threads=FALSE, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster to be rectified}
  \item{method}{character. Method used to for resampling. See \code{\link{resample}}}
  \item{aoi}{SpatExtent or SpatRaster to crop \code{x} to a smaller area of interest; Using a SpatRaster allowing to set the exact output extent and output resolution}
  \item{snap}{logical. If \code{TRUE}, the origin and resolution of the output are the same as would the case when \code{aoi = NULL}. Only relevant if \code{aoi} is a \code{SpatExtent}}
  \item{threads}{logical or positive integer. If \code{TRUE}, multiple threads are used (faster for large files), no more than the "threads" setting of \code{\link{terraOptions}}. A number sets the thread count for this call directly}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\seealso{\code{\link{is.rotated}}}

\value{
SpatRaster
}


\keyword{spatial}

\name{focalValues}

\docType{methods}

\alias{focalValues}
\alias{focalValues,SpatRaster-method}
  
\title{Get focal values}

\description{
Get a matrix in which each row had the focal values of a cell. These are the values of a cell and a rectangular window around it.
}

\usage{
\S4method{focalValues}{SpatRaster}(x, w=3, row=1, nrows=nrow(x), fill=NA)
}

\arguments{
 \item{x}{SpatRaster or SpatVector}
 \item{w}{window. The window can be defined as one (for a square) or two odd numbers (row, col); or with an odd sized matrix}
 \item{row}{positive integer. Row number to start from, should be between 1 and nrow(x)}
 \item{nrows}{positive integer. How many rows?}
 \item{fill}{numeric used as values for imaginary cells outside the raster}
}

\value{
matrix
}


\examples{
r <- rast(ncol=4, nrow=4, crs="+proj=utm +zone=1 +datum=WGS84")
values(r) <- 1:ncell(r)
focalValues(r)
}

\keyword{spatial}
\keyword{methods}

\name{datatype}

\docType{methods}

\alias{datatype}
\alias{datatype,SpatVector-method}
\alias{datatype,SpatRaster-method}

\title{Data type of a SpatRaster or SpatVector}

\description{
Get the data types of the fields (attributes, variables) of a SpatVector or of the file(s) associated with a SpatRaster. A (layer of a) SpatRaster has no datatype if it has no values, or if the values are in memory. 
} 

\usage{
\S4method{datatype}{SpatRaster}(x, bylyr=TRUE)

\S4method{datatype}{SpatVector}(x)
}

\arguments{
\item{x}{SpatRaster or SpatVector}

\item{bylyr}{logical. If \code{TRUE} a value is returned for each layer. Otherwise, a value is returned for each data source (such as a file)}
}


\details{
Setting the data type is useful if you want to write values to disk with \code{\link{writeRaster}}. In other cases you can use functions such as \code{round} and \code{floor}, or \code{\link{as.bool}}

raster datatypes are described by 5 characters. The first three indicate whether the values are integer or decimal values. The fourth character indicates the number of bytes used to save the values on disk, and the last character indicates whether the numbers are signed (that is, can be negative and positive values) or not (only zero and positive values allowed)

The following raster datatypes are available:

\tabular{lll}{
\bold{Datatype definition} \tab \bold{minimum possible value} \tab \bold{maximum possible value} \cr
\code{INT1U} \tab 0 \tab  255 \cr
\code{INT2U} \tab 0 \tab  65,535 \cr
\code{INT4U} \tab 0 \tab 4,294,967,296 \cr
\code{INT8U} \tab 0 \tab  18,446,744,073,709,551,616\cr
\code{INT1S} \tab -128 \tab  128 \cr
\code{INT2S} \tab -32,767\tab  32,767 \cr
\code{INT4S} \tab -2,147,483,647 \tab 2,147,483,647 \cr
\code{INT8S} \tab -9,223,372,036,854,775,808 \tab 9,223,372,036,854,775,808 \cr
\code{FLT4S} \tab -3.4e+38 \tab  3.4e+38 \cr
\code{FLT8S} \tab -1.7e+308 \tab   1.7e+308 \cr
}

For all integer and byte types the lowest (signed) or highest (unsigned) value is used to store \code{NA}. For float types \code{NaN} is used (following the IEEE 754 standard). 

Note that very large integer numbers may be imprecise as they are internally represented as decimal numbers. 

Also note that \code{NaN} may not be equally supported by all implementations. For example OGR SQL and SQLite queries generally convert \code{NaN} values to \code{NULL}.

\code{INT4U} and \code{INT8U} are available but they are best avoided as R does not support 32-bit or 64-bit unsigned integers. \code{INT8U} is a special case where the NA store value is \code{18446744073709549568} (\code{UINT64_MAX - 1101}) because of precision in decimal representation.

\code{INT8U} and \code{INT8S} require GDAL version 3.5 or higher. \code{INT1S} requires GDAL version 3.7 or higher.

}


\value{character}

\seealso{
 \code{\link[=is.bool]{Raster data types}} to check / set the type of SpatRaster values.
}




\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
datatype(v)

f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
datatype(r)

# no data type
datatype(rast()) 
}

\keyword{methods}
\keyword{spatial}

\name{crs}

\docType{methods}

\alias{crs}
\alias{crs<-}

\alias{crs,SpatExtent-method}

\alias{crs,SpatRaster-method}
\alias{crs,SpatRasterDataset-method}
\alias{crs<-,SpatRaster-method}
\alias{crs<-,SpatRaster,ANY-method}

\alias{crs,SpatVector-method}
\alias{crs,SpatVectorProxy-method}
\alias{crs,SpatVectorCollection-method}
\alias{crs<-,SpatVector-method}
\alias{crs<-,SpatVector,ANY-method}

\alias{crs,sf-method}
\alias{crs,character-method}

\title{ Get or set a coordinate reference system }

\description{
Get or set the coordinate reference system (CRS), also referred to as a "projection", of a SpatRaster or SpatVector. 

Setting a new CRS does not change the data itself, it just changes the label. So you should only set the CRS of a dataset (if it does not come with one) to what it *is*, not to what you would *like it to be*. See \code{\link{project}} to *transform* an object from one CRS to another.
}

\usage{
\S4method{crs}{SpatRaster}(x, proj=FALSE, describe=FALSE, parse=FALSE)

\S4method{crs}{SpatVector}(x, proj=FALSE, describe=FALSE, parse=FALSE)

\S4method{crs}{character}(x, proj=FALSE, describe=FALSE, parse=FALSE)

\S4method{crs}{SpatRaster}(x, warn=FALSE)<-value

\S4method{crs}{SpatVector}(x, warn=FALSE)<-value
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{proj}{logical. If \code{TRUE} the crs is returned in PROJ-string notation}
  \item{describe}{logical. If \code{TRUE} the name, EPSG code, and the name and extent of the area of use are returned if known}
  \item{warn}{logical. If \code{TRUE}, a message is printed when the object already has a non-empty crs}
  \item{value}{character string describing a coordinate reference system. This can be in a WKT format, as a <authority:number> code such as "EPSG:4326", or a PROJ-string format such as "+proj=utm +zone=12" (see Note)}
  \item{parse}{logical. If \code{TRUE}, wkt parts are parsed into a vector (each line becomes an element)}
}


\note{
Projections are handled by the PROJ/GDAL libraries. The PROJ developers suggest to define a CRS with the WKT2 or <authority>:<code> notation. It is not practical to define one's own custom CRS with WKT2, and the <authority>:<code> system only covers a handful of (commonly used) CRSs. To work around this problem it is still possible to use the deprecated PROJ-string notation (\code{+proj=...}) with one major caveat: the datum should be WGS84 (or the equivalent NAD83) -- if you want to transform your data to a coordinate reference system with a different datum. Thus as long as you use WGS84, or an ellipsoid instead of a datum, you can safely use PROJ-strings to represent your CRS; including to define your own custom CRS.

You can also set the crs to "local" to get an informal coordinate system on an arbitrary Euclidean (Cartesian) plane with units in meter.
}


\value{
character or modified SpatRaster/Vector
}

\seealso{
\code{\link{same.crs}}, {\code{\link{is.lonlat}}}
}

\examples{ 
r <- rast()
crs(r)
cat( crs(r) )
crs(r, describe=TRUE, proj=TRUE)

crs(r) <- "+proj=lcc +lat_1=48 +lat_2=33 +lon_0=-100 +ellps=WGS84"
cat(crs(r))

# You can use epsg codes
crs(r)  <- "epsg:25831"
crs(r, describe=TRUE)$area

crs("epsg:25831", describe=TRUE)
}

\keyword{ spatial }

\name{interpNear}

\docType{methods}

\alias{interpNear}
\alias{interpNear,SpatRaster,SpatVector-method}
\alias{interpNear,SpatRaster,matrix-method}

\title{Nearest neighbor interpolation}

\description{
Nearest neighbor interpolation of points, using a moving window
}

\usage{
\S4method{interpNear}{SpatRaster,SpatVector}(x, y, field, radius, interpolate=FALSE, fill=NA, filename="", ...)

\S4method{interpNear}{SpatRaster,matrix}(x, y, radius, interpolate=FALSE, fill=NA, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatVector or matrix with three columns (x,y,z)}
  \item{field}{character. field name in SpatVector \code{y}}
  \item{radius}{numeric. The radius of the circle (single number). If \code{interpolate=FALSE} it is also possible to use two or three numbers. Two numbers are interpreted as the radii of an ellipse (x and y-axis). A third number should indicated the desired, counter clockwise, rotation of the ellipse (in degrees)}  
  \item{interpolate}{logical. Should the nearest neighbor values be linearly interpolated between points?}
  \item{fill}{numeric. value to use to fill empty cells}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\seealso{
\code{\link{rasterizeWin}, \link{rasterize}, \link{interpIDW}, \link{interpolate}}
}


\value{
SpatRaster
}

\examples{

r <- rast(ncol=100, nrow=100, crs="local", xmin=0, xmax=50, ymin=0, ymax=50)
set.seed(100)
x <- runif(25, 5, 45)
y <- runif(25, 5, 45)
z <- sample(25)
xyz <- cbind(x,y,z)

x <- interpNear(r, xyz, radius=5)

p <- vect(data.frame(xyz), geom=c("x", "y")) 
v <- voronoi(p)

plot(x, col=rainbow(25))
lines(v)

# plot(v, col=rainbow(25)); points(p)
}

\keyword{spatial}

\name{headtail}

\docType{methods}

\alias{head}
\alias{head,SpatRaster-method}
\alias{head,SpatVector-method}
\alias{tail}
\alias{tail,SpatRaster-method}
\alias{tail,SpatVector-method}

\title{head and tail of a SpatRaster or SpatVector}

\description{
Show the head (first values) or tail (last values) of a SpatRaster or of the attributes of a SpatVector. 
}

\usage{
head(x, ...) 
tail(x, ...) 
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{...}{additional arguments passed on to other methods}
}

\value{
matrix (SpatRaster) or data.frame (SpatVector)
}

\seealso{
\code{\link{show}}, \code{\link{geom}}
}



\examples{
r <- rast(nrows=25, ncols=25)
values(r) <- 1:ncell(r)
head(r)
tail(r)
}

\keyword{methods}
\keyword{spatial}

\name{warp_scale}

\alias{warp_scale}

\title{Compute warp resampling scale}

\description{
Compute the ratio between source and destination pixel sizes for use with \code{\link{project}}. These values correspond to the GDAL warp options XSCALE and YSCALE. By default, GDAL computes them independently for each processing chunk, which can produce visible block-boundary artifacts when the ratio varies across the raster (particularly in projections with significant deformation). Setting fixed values via \code{project(..., xscale=, yscale=)} eliminates these artifacts.

The function samples a grid of points in the source raster, projects them to the destination CRS, and returns summary statistics of the local resampling ratios.
}

\usage{
warp_scale(x, y, n=21)
}

\arguments{
  \item{x}{SpatRaster. The source raster}
  \item{y}{SpatRaster or character. A template raster or a CRS description for the destination}
  \item{n}{integer. Number of sample points along each axis (the total number of sample points is \code{n*n})}
}

\value{
A list with two named numeric vectors (\code{xscale} and \code{yscale}), each containing the quantiles (0\%, 25\%, 50\%, 75\%, 100\%) of the local resampling ratio across the sampled points. The median (\code{"50\%"}) is typically the best choice for a global fixed scale. Values equal one for no resampling, below one for downsampling, and above one for upsampling.
}

\seealso{\code{\link{project}}}

\examples{
\dontrun{
a <- rast(ncols=360, nrows=180, xmin=-180, xmax=180, ymin=-90, ymax=90,
          crs="+proj=longlat +datum=WGS84")
values(a) <- 1:ncell(a)

sc <- warp_scale(a, "+proj=robin")
sc
# Use the median values
b <- project(a, "+proj=robin", xscale=sc$xscale["50\%"], yscale=sc$yscale["50\%"])
}
}

\keyword{spatial}

\name{stretch}

\alias{stretch}
\alias{stretch,SpatRaster-method}
  
\title{Stretch}

\description{
Linear or histogram equalization stretch of values in a SpatRaster. 

For linear stretch, provide the desired output range (\code{minv} and \code{maxv}) and the lower and upper bounds in the original data, either as quantiles (\code{minq} and \code{maxq}), or as cell values (\code{smin} and \code{smax}). If \code{smin} and \code{smax} are both not \code{NA}, \code{minq} and \code{maxq} are ignored.

For histogram equalization, these arguments are ignored, but you can provide the desired scale of the output and the maximum number of cells that is used to compute the histogram (empirical cumulative distribution function). 
}

\usage{
\S4method{stretch}{SpatRaster}(x, minv=0, maxv=255, minq=0, maxq=1, smin=NA, smax=NA,
		histeq=FALSE, scale=1, maxcell=500000, bylayer=TRUE, filename="", ...)
}

\arguments{
\item{x}{SpatRaster} 
\item{minv}{numeric >= 0 and smaller than maxv. lower bound of stretched value}
\item{maxv}{numeric <= 255 and larger than maxv. upper bound of stretched value}
\item{minq}{numeric >= 0 and smaller than maxq. lower quantile bound of original value. Ignored if smin is supplied}
\item{maxq}{numeric <= 1 and larger than minq. upper quantile bound of original value. Ignored if smax is supplied}
\item{smin}{numeric < smax. user supplied lower value for the layers, to be used instead of a quantile computed by the function itself}
\item{smax}{numeric > smin. user supplied upper value for the layers, to be used instead of a quantile computed by the function itself}

\item{histeq}{logical. If \code{TRUE} histogram equalization is used instead of linear stretch}
\item{scale}{numeric. The scale (maximum value) of the output if \code{histeq=TRUE}}

\item{maxcell}{positive integer. The size of the regular sample used to compute the histogram or quantiles}

\item{bylayer}{logical. If \code{TRUE} stretching is done for each layer individually}

\item{filename}{character. Output filename}
\item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}
 
 
\value{
SpatRaster
}
  
\examples{
r <- rast(nc=10, nr=10)
values(r) <- rep(1:25, 4)
rs <- stretch(r)
s <- c(r, r*2)
sr <- stretch(s)
}

\keyword{spatial}

\name{same.crs}

\alias{same.crs}

  
\title{Compare coordinate reference systems}

\description{
The function takes two coordinate reference system descriptions and compares them for equality.
}

\usage{
same.crs(x, y)
}

\arguments{
\item{x}{character, SpatRaster, SpatVector, CRS, or other object that returns something intelligible with\code{crs(x)}}
\item{y}{same types as for \code{x}}
}

\value{
logical
}

\examples{
r <- rast()
same.crs(r, "+proj=longlat")

same.crs(r, "+proj=utm +zone=1")
}

\keyword{spatial}

\name{concats}

\docType{methods}

\alias{concats}
\alias{concats,SpatRaster-method}
  
  
\title{Concatenate categorical rasters}

\description{
Combine two categorical rasters by concatenating their levels.
}

\usage{
\S4method{concats}{SpatRaster}(x, y, filename="", ...)
}


\arguments{
  \item{x}{SpatRaster (with a single, categorical, layer)}
  \item{y}{SpatRaster (with a single, categorical, layer)}
  \item{filename}{character. Output filename}  
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}  
}  


\value{
SpatRaster
}

\seealso{\code{\link{cats}}}


\examples{
set.seed(0)
r <- rast(nrows=10, ncols=10)
values(r) <- sample(3, ncell(r), replace=TRUE)
levels(r) <- data.frame(id=1:3, cover=c("forest", "water", "urban"))

rr <- rast(r)
values(rr) <- sample(1:3, ncell(rr), replace=TRUE)
levels(rr) <- data.frame(id=c(1:3), color=c("red", "green", "blue"))

x <- concats(r, rr)
x
levels(x)[[1]]
}

\keyword{methods}
\keyword{spatial}

\name{sort}

\docType{methods}

\alias{sort}
\alias{sort,SpatRaster-method}
\alias{sort,SpatVector-method}
\alias{sort,data.frame-method}


\title{Sort a SpatRaster or SpatVector}

\description{
Sort the cell values of a SpatRaster across layers. You can also compute the sorting order. 

Or sort the records of SpatVector (or data.frame) by specifying the column number(s) or names(s) to sort on.
}

\usage{
\S4method{sort}{SpatRaster}(x, decreasing=FALSE, order=FALSE, filename="", ...)

\S4method{sort}{SpatVector}(x, v, decreasing=FALSE)
}

\arguments{
  \item{x}{SpatRaster}
  \item{decreasing}{logical. If \code{TRUE}, sorting is in decreasing order}
  \item{order}{logical. If \code{TRUE} the sorting order is returned instead of the sorted values}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
  \item{v}{character or numeric indicating the column(s) to sort on}
}


\value{
SpatRaster
}


\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
r <- c(r, r/2, r*2)
sort(r)

ord <- sort(r, order=TRUE)
# these two are the same 
ord[[1]]
which.min(r)
}

\keyword{spatial}

\name{click}

\alias{click}
\alias{click,SpatRaster-method}
\alias{click,SpatVector-method}
\alias{click,missing-method}

\title{Query by clicking on a map}

\description{
Click on a map (plot) to get the coordinates or the values of a SpatRaster or SpatVector at that location. For a SpatRaster you can also get the coordinates and cell number of the location. 

Note that for many installations this does not work well on the default RStudio plotting device. To work around that, you can first run \code{dev.new(noRStudioGD = TRUE)} which will create a separate window for plotting, then use \code{plot()} followed by \code{click()} and click on the map. It may also help to set your RStudio "Tools/Global Options/Appearance/Zoom" to 100\%.
}


\usage{
\S4method{click}{SpatRaster}(x, n=10, id=FALSE, xy=FALSE, cell=FALSE, type="p", show=TRUE, ...)

\S4method{click}{SpatVector}(x,  n=10, id=FALSE, xy=FALSE, type="p", show=TRUE, ...)

\S4method{click}{missing}(x, n=10, id=FALSE, type="p", show=TRUE, ...)
}


\arguments{
  \item{x}{SpatRaster or SpatVector, or missing}
  \item{n}{number of clicks on the plot (map)}
  \item{id}{logical. If \code{TRUE}, a numeric ID is shown on the map that corresponds to the row number of the output}
  \item{xy}{logical. If \code{TRUE}, xy coordinates are included in the output}
  \item{cell}{logical. If \code{TRUE}, cell numbers are included in the output}
  \item{type}{one of "n", "p", "l" or "o". If "p" or "o" the points are plotted; if "l" or "o" they are joined by lines. See \code{\link[graphics]{locator}}}
  \item{show}{logical. Print the values after each click?}
  \item{...}{additional graphics parameters used if type != "n" for plotting the locations. See \code{\link[graphics]{locator}}}   
 }
 
\value{
The value(s) of \code{x} at the point(s) clicked on (or touched by the box drawn).
A \code{data.frame} with the value(s) of all layers of SpatRaster \code{x} for the cell(s) clicked on; or with the attributes of the geometries of SpatVector \code{x} that intersect with the box drawn).
} 

\note{
The plot only provides the coordinates for a spatial query, the values are read from the SpatRaster or SpatVector that is passed as an argument. Thus, you can extract values from an object that has not been plotted, as long as it spatially overlaps with the extent of the plot.
  
Unless the process is terminated prematurely values at most \code{n} positions are determined. The identification process can be terminated, depending on how you interact with R, by hitting Esc, or by clicking the right mouse button and selecting "Stop" from the menu, or from the "Stop" menu on the graphics window. 
}


\seealso{\link{draw}}


\examples{
\dontrun{
r <-rast(system.file("ex/elev.tif", package="terra"))
plot(r)
click(r, n=1)
## now click on the plot (map)
}}

\keyword{ spatial }

\name{xmin}

\docType{methods}

\alias{xmin}
\alias{xmax}
\alias{ymin}
\alias{ymax}
\alias{xmin<-}
\alias{xmax<-}
\alias{ymin<-}
\alias{ymax<-}
\alias{xmin,SpatExtent-method}
\alias{xmin,SpatRaster-method}
\alias{xmin,SpatVector-method}
\alias{xmax,SpatExtent-method}
\alias{xmax,SpatRaster-method}
\alias{xmax,SpatVector-method}
\alias{ymin,SpatExtent-method}
\alias{ymin,SpatRaster-method}
\alias{ymin,SpatVector-method}
\alias{ymax,SpatExtent-method}
\alias{ymax,SpatRaster-method}
\alias{ymax,SpatVector-method}

\alias{xmin<-,SpatExtent,numeric-method}
\alias{xmin<-,SpatRaster,numeric-method}
\alias{xmax<-,SpatExtent,numeric-method}
\alias{xmax<-,SpatRaster,numeric-method}
\alias{ymin<-,SpatExtent,numeric-method}
\alias{ymin<-,SpatRaster,numeric-method}
\alias{ymax<-,SpatExtent,numeric-method}
\alias{ymax<-,SpatRaster,numeric-method}

  
\title{Get or set single values of an extent}

\description{
Get or set single values of an extent. Values can be set for a SpatExtent or SpatRaster, but not for a SpatVector)
}

\usage{
\S4method{xmin}{SpatExtent}(x)

\S4method{xmax}{SpatExtent}(x)

\S4method{ymin}{SpatExtent}(x)

\S4method{ymax}{SpatExtent}(x)

\S4method{xmin}{SpatRaster}(x)

\S4method{xmax}{SpatRaster}(x)

\S4method{ymin}{SpatRaster}(x)

\S4method{ymax}{SpatRaster}(x)

\S4method{xmin}{SpatVector}(x)

\S4method{xmax}{SpatVector}(x)

\S4method{ymin}{SpatVector}(x)

\S4method{ymax}{SpatVector}(x)

\S4method{xmin}{SpatRaster,numeric}(x)<-value

\S4method{xmax}{SpatRaster,numeric}(x)<-value

\S4method{ymin}{SpatRaster,numeric}(x)<-value

\S4method{ymax}{SpatRaster,numeric}(x)<-value
}

\arguments{
  \item{x}{SpatRaster, SpatExtent, or SpatVector}
  \item{value}{numeric}  
}
 
\value{
SpatExtent or numeric coordinate
}

\seealso{
\code{\link{ext}}
}

\examples{
r <- rast()
ext(r)
ext(c(0, 20, 0, 20))

xmin(r)
xmin(r) <- 0
xmin(r)
}

\keyword{spatial}

\name{svc}

\docType{methods}

\alias{svc}
\alias{svc,missing-method}
\alias{svc,character-method}
\alias{svc,list-method}
\alias{svc,sf-method}
\alias{svc,SpatVector-method}
\alias{[<-,SpatVectorCollection,numeric,missing-method}
\alias{[,SpatVectorCollection,numeric,missing-method}
\alias{[[,SpatVectorCollection,numeric,missing-method}

\seealso{
\code{\link{sprc}}
}

\title{Create a SpatVectorCollection}

\description{
Methods to create a SpatVectorCollection. This is an object to hold "sub-datasets", each a SpatVector, perhaps of different geometry type. 
}

\usage{
\S4method{svc}{missing}(x) 

\S4method{svc}{SpatVector}(x, ...) 

\S4method{svc}{list}(x) 

\S4method{svc}{character}(x, layer="", query="", dialect="", extent=NULL, filter=NULL)
}

\arguments{
\item{x}{SpatVector, character (filename), list with SpatVectors, or missing}
\item{...}{Additional \code{SpatVector}s} 
\item{layer}{character. layer name to select a layer from a file (database) with multiple layers}
\item{query}{character. A query to subset the dataset}
\item{dialect}{character. The SQL dialect to use (if any). For example: "SQLite". "" refers to the default \href{https://gdal.org/en/latest/user/ogr_sql_dialect.html}{OGR-SQL dialect}}
\item{extent}{Spat* object. The extent of the object is used as a spatial filter to select the geometries to read. Ignored if \code{filter} is not \code{NULL}}
\item{filter}{SpatVector. Used as a spatial filter to select geometries to read (the convex hull is used for lines or points). It is guaranteed that all features that overlap with the extent of filter will be returned. It can happen that additional geometries are returned}
}


\value{
SpatVectorCollection
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
x <- svc()
x <- svc(v, v[1:3,], as.lines(v[3:5,]), as.points(v))
length(x)
x

# extract
x[3]

# replace
x[2] <- as.lines(v[1,])


}


\keyword{methods}
\keyword{spatial}

\name{forceCCW}

\alias{forceCCW}
\alias{forceCCW,SpatVector-method}


\title{force counter-clockwise polygons}


\description{
Assure that the nodes of outer rings of polygons are in counter-clockwise order.
}

\usage{
\S4method{forceCCW}{SpatVector}(x)
}

\arguments{
  \item{x}{SpatVector of polygons}
}

\value{
SpatVector
}

\examples{
p <- vect("POLYGON ((2 45, 2 55, 18 55, 18 45, 2 45))")
pcc <- forceCCW(p)
geom(pcc, wkt=TRUE)
}

\keyword{spatial}

\name{add_legend}

\alias{add_legend}

\title{add a custom legend}

\description{ 
Wrapper around \code{\link[graphics]{legend}} that allows adding a custom legend to a map using a keyword such as "topleft" or "bottomright". This function will place the legend in the locations within the mapped area as delineated by the axes.
}

\usage{
add_legend(x, y, xpd=TRUE, ...)
}


\arguments{
  \item{x}{The keyword to be used to position the legend (or the x coordinate)}
  \item{y}{The y coordinate to be used to position the legend (is x is also a coordinate)}
  \item{xpd}{logical. If \code{TRUE}, the legend can be added outside the map area}
  \item{...}{arguments passed to \code{\link[graphics]{legend}}}
}


\seealso{\code{\link{add_box}}, \code{\link{add_grid}}, \code{\link{add_mtext}}}


\examples{
v <- vect(system.file("ex/lux.shp", package="terra"))
plot(v)
points(centroids(v), col="red")
legend("topleft", legend = "centroids", pch = 20, xpd=NA, bg="white", col="red")
add_legend("topright", legend = "centroids", pch = 20, col="red")
}

\keyword{methods}
\keyword{spatial}

\name{extremes}

\alias{minmax}
\alias{hasMinMax}
\alias{setMinMax}
\alias{minmax,SpatRaster-method}
\alias{hasMinMax,SpatRaster-method}
\alias{setMinMax,SpatRaster-method}

\title{Get or compute the minimum and maximum cell values}

\description{
The minimum and maximum value of a SpatRaster are returned or computed (from a file on disk if necessary) and stored in the object. 
}

\usage{
\S4method{minmax}{SpatRaster}(x, compute=FALSE)
\S4method{hasMinMax}{SpatRaster}(x)
\S4method{setMinMax}{SpatRaster}(x, force=FALSE)
}

\arguments{
  \item{x}{ SpatRaster }
  \item{compute}{logical. If \code{TRUE} min and max values are computed if they are not available}
  \item{force}{logical. If \code{TRUE} min and max values are recomputed even if already available}
}

\value{
minmax: numeric matrix of minimum and maximum cell values by layer

hasMinMax: logical indicating whether the min and max values are available.

setMinMax: nothing. Used for the side-effect of computing the minimum and maximum values of a SpatRaster
}

\seealso{\code{\link{where.min}}, \code{\link{where.max}}}

\examples{ 
r <- rast(system.file("ex/elev.tif", package="terra"))
minmax(r)
}

\keyword{ spatial }
\keyword{ methods }

\name{is.valid}

\alias{is.valid}
\alias{is.valid,SpatVector-method}
\alias{is.valid,SpatExtent-method}
\alias{makeValid}
\alias{makeValid,SpatVector-method}

  
\title{Check or fix polygon or extent validity}

\description{
Check the validity of polygons or attempt to fix it. Or check the validity of a SpatExtent.
}

\usage{
\S4method{is.valid}{SpatVector}(x, messages=FALSE, as.points=FALSE)

\S4method{makeValid}{SpatVector}(x, buffer=FALSE)

\S4method{is.valid}{SpatExtent}(x)
}

\arguments{
\item{x}{SpatVector or SpatExtent}
\item{messages}{logical. If \code{TRUE} the error messages are returned}
\item{as.points}{logical. If \code{TRUE}, it is attempted to return locations where polygons are invalid as a SpatVector or points}
\item{buffer}{logical. If \code{TRUE} the zero-width buffer method is used to create valid polygons. Be careful when  using this method because it may result in data loss. For example, only a single part of a self-intersecting may be preserved. See the example below}
}

\value{
logical
}

\seealso{\code{\link{topology}}}

\examples{
w <- vect("POLYGON ((0 -5, 10 0, 10 -10, 0 -5))")
is.valid(w)

w <- vect("POLYGON ((0 -5, 10 0, 10 -10, 4 -2, 0 -5))")
is.valid(w)
is.valid(w, TRUE)
v1 <- makeValid(w)
is.valid(v1)
v2 <- makeValid(w, buffer=TRUE)

plot(disagg(v1), col=c("light blue", "gray"))
# valid but incomplete
lines(v2, col="red", lwd=3)

plot(w)
points(cbind(4.54, -2.72), cex=2, col="red")

e <- ext(0, 1, 0, 1)
is.valid(e)

ee <- ext(0, 0, 0, 0)
is.valid(ee)

}
\keyword{spatial}

\name{focal}

\alias{focal}
\alias{focal,SpatRaster-method}


\title{Focal values}

\description{
Calculate focal ("moving window") values for each cell.
}

\usage{
\S4method{focal}{SpatRaster}(x, w=3, fun="sum", ..., na.policy="all", fillvalue=NA, 
		expand=FALSE, silent=TRUE, cores=1, cpkgs=NULL,
		filename="", overwrite=FALSE, wopt=list())
}

\arguments{
\item{x}{SpatRaster}
  
\item{w}{window. The window can be defined as one (for a square) or two numbers (row, col); or with an odd-sized weights matrix. See Details.}

\item{fun}{function that takes multiple numbers, and returns a numeric vector (one or multiple numbers). For example, mean, modal, min or max}

\item{...}{additional arguments passed to \code{fun} such as \code{na.rm}}

\item{na.policy}{character. Can be used to determine the cells of \code{x} for which focal values should be computed. Must be one of "all" (compute for all cells), "only" (only for cells that are \code{NA}) or "omit" (skip cells that are \code{NA}). Note that the value of this argument does not affect which cells around each focal cell are included in the computations (use \code{na.rm=TRUE} to ignore cells that are \code{NA} for that)}

\item{fillvalue}{numeric. The value of the cells in the virtual rows and columns outside of the raster}

\item{expand}{logical. If \code{TRUE}, the value of the cells in the virtual rows and columns outside of the raster are set to be the same as the value on the border. Only available for "built-in" \code{fun}s such as mean, sum, min and max}

\item{silent}{logical. If \code{FALSE} error messages are printed that may occur when trying \code{fun} to determine the length of the returned value. This can be useful in debugging a \code{fun} that does not work}

\item{cores}{controls per-block parallelism when \code{fun} is a user-supplied R function (the "built-in" \code{fun}s such as "mean" and "sum" are already multi-threaded via TBB and ignore \code{cores}). Can be a positive integer (the number of local PSOCK workers), an existing \code{parallel::cluster}, the string \code{"future"} to use the currently registered \code{\link[future:plan]{future plan}}, or a future strategy itself (e.g. \code{future::multisession}). The per-block focal-values matrix is split into row-chunks and dispatched across workers}

\item{cpkgs}{character. Names of R packages to load on each worker when \code{cores > 1} -- pass any package that \code{fun} depends on}

\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}

\item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\details{
\code{focal} 
The window used must have odd dimensions. If you need even sides, you can use a matrix and add a column or row of \code{NA}'s to mask out values.

Window values are typically 1 or \code{NA} to indicate whether a value is used or ignored in computations, respectively. \code{NA} values in \code{w} can be useful for creating non-rectangular (e.g. circular) windows. 

A weights matrix of numeric values can also be supplied to \code{w}. In the case of a weights matrix, cells with \code{NA} weights will be ignored, and the rest of the values in the focal window will be multiplied by the corresponding weight prior to `fun` being applied. Note, \code{na.rm} does not need to be \code{TRUE} if \code{w} contains \code{NA} values as these cells are ignored in computations. 

The "mean" function is a special case, where supplying weights to \code{w} will instead calculate a weighted mean.

The "sum" function returns \code{NA} if all focal cells are \code{NA} and \code{na.rm=TRUE}. R would normally return a zero in these cases. See the difference between \code{focal(x, fun=sum, na.rm=TRUE)} and \code{focal(x, fun=\(i) sum(i, na.rm=TRUE))}


Example weight matrices

Laplacian filter: \code{filter=matrix(c(0,1,0,1,-4,1,0,1,0), nrow=3)}

Sobel filters (for edge detection):

\code{fx=matrix(c(-1,-2,-1,0,0,0,1,2,1), nrow=3)}

\code{fy=matrix(c(1,0,-1,2,0,-2,1,0,-1), nrow=3)}
}

\note{
When using global lon/lat rasters, the focal window "wraps around" the date-line.
}

\value{SpatRaster}


\seealso{ \code{\link{focalMat}}, \code{\link{focalValues}}, \code{\link{focal3D}}, \code{\link{focalPairs}}, \code{\link{focalReg}}, \code{\link{focalCpp}} }


\examples{
r <- rast(ncols=10, nrows=10, ext(0, 10, 0, 10))
values(r) <- 1:ncell(r)

f <- focal(r, w=3, fun=function(x, ...) quantile(x, c(.25, .5, .75), ...), na.rm=TRUE) 

f <- focal(r, w=3, fun="mean") 

# the following two statements are equivalent:
a <- focal(r, w=matrix(1/9, nc=3, nr=3))
b <- focal(r, w=3, fun=mean, na.rm=FALSE)

# but this is different
d <- focal(r, w=3, fun=mean, na.rm=TRUE)

## illustrating the effect of different 
## combinations of na.rm and na.policy
v <- vect(system.file("ex/lux.shp", package="terra"))
r <- rast(system.file("ex/elev.tif", package="terra"))
r[45:50, 45:50] <- NA

# also try "mean" or "min"
f <- "sum" 
# na.rm=FALSE
plot(focal(r, 5, f), fun=lines(v))

# na.rm=TRUE
plot(focal(r, 5, f, na.rm=TRUE), fun=lines(v))

# only change cells that are NA
plot(focal(r, 5, f, na.policy="only", na.rm=TRUE), fun=lines(v))

# do not change cells that are NA
plot(focal(r, 5, f, na.policy="omit", na.rm=TRUE), fun=lines(v))

# does not do anything
# focal(r, 5, f, na.policy="only", na.rm=FALSE)

\donttest{
# parallel apply for a user-supplied R function (no effect on built-in funs)
r <- rast(ncols=200, nrows=200, ext(0, 200, 0, 200), vals=runif(40000))
f <- focal(r, w=5, fun=function(x) quantile(x, 0.9, na.rm=TRUE), cores=2)
}
}


\keyword{spatial}

\name{xapp}

\docType{methods}

\alias{xapp}
\alias{xapp,SpatRaster,SpatRaster-method}

\title{Apply a function to the cells of two SpatRasters}

\description{ 
Apply a function to the values of each cell of two (multilayer) SpatRasters. 
}

\usage{
\S4method{xapp}{SpatRaster,SpatRaster}(x, y, fun, ..., filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatRaster with the same geometry as \code{x}}
  \item{fun}{a function that operates on two vectors}
  \item{...}{additional arguments for \code{fun}. These are typically numerical constants. They should *never* be another SpatRaster}  
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}


\seealso{\code{\link{app}}, \code{\link{lapp}}, \code{\link{tapp}}, \code{\link[terra]{Math-methods}}, \code{\link{roll}} }


\examples{
r <- rast(ncols=10, nrows=10, nlyr=5)
set.seed(1)
r <- init(r, runif)
s <- init(r, runif)
x <- xapp(r, s, fun=cor)
}


\keyword{methods}
\keyword{spatial}

\name{cartogram}

\docType{methods}

\alias{cartogram}
\alias{cartogram,SpatVector-method}

\title{Cartogram}

\description{ 
Make a cartogram, that is, a map where the area of polygons is made proportional to another variable. This can be a good way to map raw count data (e.g. votes).
}

\usage{
\S4method{cartogram}{SpatVector}(x, var, type="nc", inside=FALSE, exp=1)
}

\arguments{
  \item{x}{SpatVector}
  \item{var}{character. A variable name in \code{x}}
  \item{type}{character. Cartogram type, one of "nc" (non-contiguous) or "circles" (dorling)}  
  \item{inside}{logical to compute the centroids. See \code{centroids}}
  \item{exp}{positive numeric that can be used to scale the output polygons}
}

\value{
SpatVector
}

\seealso{ \code{\link{plot}}, \code{\link{rescale}} }


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
v$value <- 1:12
pnc <- cartogram(v, "value", "nc")
pcirc <- cartogram(v, "value", "circles")
plot(v, col="light gray", border="gray")
lines(pnc, col="red", lwd=2)
lines(pcirc, col="blue", lwd=2)

}


\keyword{methods}
\keyword{spatial}

\name{Compare-methods}

\docType{methods}

\alias{Compare-methods}
\alias{Logic-methods}
\alias{logic}
\alias{compare}

\alias{Compare,SpatRaster,SpatRaster-method}
\alias{Compare,numeric,SpatRaster-method}
\alias{Compare,SpatRaster,numeric-method}
\alias{Compare,SpatRaster,character-method}
\alias{Compare,SpatRaster,matrix-method}
\alias{Compare,matrix,SpatRaster-method}


\alias{Logic,SpatRaster,SpatRaster-method}
\alias{Logic,SpatRaster,numeric-method}
\alias{Logic,numeric,SpatRaster-method}
\alias{Logic,SpatRaster,logical-method}
\alias{Logic,logical,SpatRaster-method}

\alias{Compare,SpatExtent,SpatExtent-method}

\alias{is.na,SpatRaster-method}
\alias{is.nan,SpatRaster-method}
\alias{!,SpatRaster-method}
\alias{is.finite,SpatRaster-method}
\alias{is.infinite,SpatRaster-method}
\alias{is.finite,SpatExtent-method}

\alias{logic,SpatRaster-method}
\alias{compare,SpatRaster-method}

\title{Compare and logical methods}

\description{

Standard comparison and logical operators for computations with SpatRasters. Computations are local (applied on a cell by cell basis). If multiple SpatRasters are used, these must have the same geometry (extent and resolution). These operators have been implemented:

\bold{Logical}: \code{!, &, |, isTRUE, isFALSE}

\bold{Compare}: \code{ ==, !=, >, <,  <=, >=, is.na, is.nan, is.finite, is.infinite}

See \code{\link{not.na}} for the inverse of \code{is.na}, and \code{\link{noNA}} to detect cells with missing value across layers.

The \code{compare} and \code{logic} methods implement these operators in a method that can return \code{NA} instead of \code{FALSE} and allows for setting an output filename.

The terra package does not distinguish between \code{NA} (not available) and \code{NaN} (not a number). In most cases this state is represented by \code{NaN}.  

If you use a SpatRaster with a vector of multiple numbers, each element in the vector is considered a layer (with a constant value). If you use a SpatRaster with a matrix, the number of columns of the matrix must match the number of layers of the SpatRaster. The rows are used to match the cells. That is, if there are two rows, these match cells 1 and 2, and they are recycled to 3 and 4, etc. 

The following method has been implemented for \bold{(SpatExtent, SpatExtent)}: \code{==}
}


\usage{
\S4method{compare}{SpatRaster}(x, y, oper, falseNA=FALSE, filename="", overwrite=FALSE, ...)

\S4method{logic}{SpatRaster}(x, oper, falseNA=FALSE, filename="", overwrite=FALSE, ...)
}

\arguments{
\item{x}{SpatRaster}
\item{y}{SpatRaster or numeric}
\item{oper}{character. Operator name. For \code{compare} this can be one of \code{"==", "!=", ">", "<", ">=", "<="} and for \code{logic} it can be one of \code{"!", "is.na", "not.na", "allNA", "anyNA", "noneNA", "is.infinite", "is.finite", "isTRUE", "isFALSE"}}
\item{falseNA}{logical. Should the result be \code{TRUE, NA} instead of \code{TRUE, FALSE}?}
\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
\item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\seealso{
\code{\link{all.equal}}, \link{Arith-methods}. See \code{\link{ifel}} to conveniently combine operations and \code{\link{Math-methods}} or \code{\link{app}} to apply any R function to a SpatRaster. 
}


\value{
SpatRaster or SpatExtent
}


\examples{
r1 <- rast(ncols=10, nrows=10)
values(r1) <- runif(ncell(r1))
r1[10:20] <- NA
r2 <- rast(r1)
values(r2) <- 1:ncell(r2) / ncell(r2)

x <- is.na(r1)
!x
r1 == r2 
compare(r1, r2, "==")
compare(r1, r2, "==", TRUE)
}

\keyword{methods}
\keyword{math}
\keyword{spatial}

\name{xyRowColCell}

\alias{xFromCol}
\alias{xFromCol,SpatRaster,numeric-method}
\alias{xFromCol,SpatRaster,missing-method}
\alias{yFromRow}
\alias{yFromRow,SpatRaster,numeric-method}
\alias{yFromRow,SpatRaster,missing-method}
\alias{xyFromCell}
\alias{xyFromCell,SpatRaster,numeric-method}
\alias{xFromCell}
\alias{xFromCell,SpatRaster,numeric-method}
\alias{yFromCell}
\alias{yFromCell,SpatRaster,numeric-method}
\alias{cellFromRowCol}
\alias{cellFromRowCol,SpatRaster,numeric,numeric-method}
\alias{cellFromRowColCombine}
\alias{cellFromRowColCombine,SpatRaster,numeric,numeric-method}
\alias{rowColCombine}
\alias{rowColCombine,SpatRaster,numeric,numeric-method}
\alias{colFromX}
\alias{colFromX,SpatRaster,numeric-method}
\alias{rowFromY}
\alias{rowFromY,SpatRaster,numeric-method}
\alias{cellFromXY}
\alias{cellFromXY,SpatRaster,matrix-method}
\alias{cellFromXY,SpatRaster,data.frame-method}
\alias{rowFromCell}
\alias{rowFromCell,SpatRaster,numeric-method}
\alias{colFromCell}
\alias{colFromCell,SpatRaster,numeric-method}
\alias{rowColFromCell}
\alias{rowColFromCell,SpatRaster,numeric-method}


\title{Coordinates from a row, column or cell number and vice versa}

\description{
Get coordinates of the center of raster cells for a row, column, or cell number of a SpatRaster.
Or get row, column, or cell numbers from coordinates or from each other.

Cell numbers start at 1 in the upper left corner, and increase from left to right, and then from top to bottom.
The last cell number equals the number of cells of the SpatRaster (see \code{\link{ncell}}).
Row numbers start at 1 at the top, column numbers start at 1 at the left.

When computing row, column, or cell numbers from coordinates, and coordinates fall on the edge of two or four cells, they are assigned to the right-most and/or lowest cell. That is, in these cases of ambiguity, the highest row, column, or cell number is returned.
}

\usage{
\S4method{xFromCol}{SpatRaster,numeric}(object, col)

\S4method{yFromRow}{SpatRaster,numeric}(object, row)

\S4method{xyFromCell}{SpatRaster,numeric}(object, cell)

\S4method{xFromCell}{SpatRaster,numeric}(object, cell)

\S4method{yFromCell}{SpatRaster,numeric}(object, cell)

\S4method{colFromX}{SpatRaster,numeric}(object, x)

\S4method{rowFromY}{SpatRaster,numeric}(object, y)

\S4method{cellFromRowCol}{SpatRaster,numeric,numeric}(object, row, col)

\S4method{cellFromRowColCombine}{SpatRaster,numeric,numeric}(object, row, col)

\S4method{rowColCombine}{SpatRaster,numeric,numeric}(object, row, col)

\S4method{rowFromCell}{SpatRaster,numeric}(object, cell)

\S4method{colFromCell}{SpatRaster,numeric}(object, cell)

\S4method{rowColFromCell}{SpatRaster,numeric}(object, cell)

\S4method{cellFromXY}{SpatRaster,matrix}(object, xy)
}


\arguments{
  \item{object}{SpatRaster}
  \item{cell}{integer. cell number(s)}
  \item{col}{integer. column number(s) or missing (equivalent to all columns)}
  \item{row}{integer. row number(s) or missing (equivalent to all rows)}
  \item{x}{x coordinate(s)}
  \item{y}{y coordinate(s)}
  \item{xy}{matrix of x and y coordinates}
}


\value{
xFromCol, yFromCol, xFromCell, yFromCell: vector of x or y coordinates

xyFromCell: matrix(x,y) with coordinate pairs

colFromX, rowFromY, cellFromXY, cellFromRowCol, rowFromCell, colFromCell: vector of row, column, or cell numbers

rowColFromCell, rowColCombine: matrix of row and column numbers
}


\seealso{
\code{\link{crds}}
}



\examples{
r <- rast()

xFromCol(r, c(1, 120, 180))
yFromRow(r, 90)
xyFromCell(r, 10000)
xyFromCell(r, c(0, 1, 32581, ncell(r), ncell(r)+1))

cellFromRowCol(r, 5, 5)
cellFromRowCol(r, 1:2, 1:2)
cellFromRowCol(r, 1, 1:3)

# all combinations
cellFromRowColCombine(r, 1:2, 1:2)

colFromX(r, 10)
rowFromY(r, 10)
xy <- cbind(lon=c(10,5), lat=c(15, 88))
cellFromXY(r, xy)

# if no row/col specified all are returned
range(xFromCol(r))
length(yFromRow(r))
}

\keyword{spatial}

\name{selectRange}

\alias{selectRange}
\alias{selectRange,SpatRaster-method}


\title{Select the values of a range of layers, as specified by cell values in another SpatRaster}

\description{
Use a single layer SpatRaster to select cell values from different layers in a multi-layer SpatRaster. The values of the SpatRaster to select layers (\code{y}) should be whole numbers between \code{1} and \code{nlyr(x)} (values outside this range are ignored). 

See \code{\link{rapp}} for applying a function to a range of variable size.

See \code{\link{extract}} for extraction of values by cell, point, or otherwise.
}

\usage{
\S4method{selectRange}{SpatRaster}(x, y, z=1, repint=0, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatRaster. Cell values must be positive integers. They indicate the first layer to select for each cell}
  \item{z}{positive integer. The number of layers to select}
  \item{repint}{integer > 1 and < nlyr(x) allowing for repeated selection at a fixed interval. For example, if \code{x} has 36 layers, and the value of a cell in \code{y}=2 and \code{repint} = 12, the values for layers 2, 14 and 26 are returned}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{\code{\link{rapp}}, \code{\link{tapp}}, \code{\link{extract}}}


\examples{
r <- rast(ncols=10, nrows=10)
values(r) <- 1
s <- c(r, r+2, r+5)
s <- c(s, s)
set.seed(1)
values(r) <- sample(3, ncell(r), replace=TRUE)
x <- selectRange(s, r)

x <- selectRange(s, r, 3)
}

\keyword{methods}
\keyword{spatial}

\name{sources}

\docType{methods}

\alias{sources}
\alias{sources,SpatRaster-method}
\alias{sources,SpatRasterCollection-method}
\alias{sources,SpatRasterDataset-method}
\alias{sources,SpatVector-method}
\alias{sources,SpatVectorProxy-method}

\alias{hasValues}
\alias{hasValues,SpatRaster-method}
\alias{inMemory}
\alias{inMemory,SpatRaster-method}


\title{Data sources of a SpatRaster}

\description{
Get the data sources of a SpatRaster or SpatVector or related object. Sources are either files (or similar resources) or "", meaning that they are in memory. You can use \code{hasValues} to check if in-memory layers actually have cell values. 
}

\usage{
\S4method{sources}{SpatRaster}(x, nlyr=FALSE, bands=FALSE)

\S4method{sources}{SpatVector}(x)

\S4method{hasValues}{SpatRaster}(x)

\S4method{inMemory}{SpatRaster}(x, bylayer=FALSE)
}

\arguments{
\item{x}{SpatRaster, SpatRasterCollection, SpatVector or SpatVectorProxy}
\item{nlyr}{logical. If \code{TRUE} for each source, the number of layers is returned}
\item{bands}{logical. If \code{TRUE} for each source, the "bands" used, that is, the layer number in the source file, are returned}
\item{bylayer}{logical. If \code{TRUE} a value is returned for each layer instead of for each source}
}

\value{
A vector of filenames, or \code{""} when there is no filename, if \code{nlyr} and \code{bands} are both \code{FALSE}. Otherwise a \code{data.frame}
}

\seealso{ \code{\link{toMemory}} }

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
s <- rast(r)
values(s) <- 1:ncell(s)
rs <- c(r,r,s,r)
sources(rs)
hasValues(r)
x <- rast()
hasValues(x)
}


\keyword{methods}
\keyword{spatial}

\docType{methods}
\name{pitfinder}

\alias{pitfinder}
\alias{pitfinder,SpatRaster-method}


\title{Find pits (depressions with no outlet)}

\description{
find pits (depressions with no outlet) using a flow direction raster, to support the delineation of catchments.
}

\usage{
\S4method{pitfinder}{SpatRaster}(x,pits_on_boundary=TRUE,filename="",...) 
}

\arguments{
  \item{x}{SpatRaster with flow-direcion. See \code{\link{flowDir}}}
   \item{pits_on_boundary}{logical if \code{TRUE} (default) pits are considered also on the boundary. If \code{FALSE} pits are considered only within the terrain domain.}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}  
}

\value{ 
\code{SpatRaster} with positive integers (1, 2, 3, ...) to identify pits and zero elsewhere. 
}


\author{
Emanuele Cordano
}

\seealso{\code{\link{terrain}}, \code{\link{watershed}}, \code{\link{flowAccumulation}}, \code{\link{NIDP}}}
\examples{
## example elevation data

elev <- array(NA,c(9,9))
dx <- 1
dy <- 1 
for (r in 1:nrow(elev)) {
	x <- (r-5)*dx
	for (c in 1:ncol(elev)) {
		y <- (c-5)*dy
		elev[r,c] <- 10+5*(x^2+y^2)
    }
} 
  
elev <- cbind(elev,elev,elev,elev) 
elev <- rbind(elev,elev,elev,elev) 
elev <- rast(elev)

## Flow Directions

flowdir<- terrain(elev,v="flowdir")
t(array(flowdir[],rev(dim(flowdir)[1:2])))

## detect pits
pits <- pitfinder(flowdir)

## Application with example DEM

elev <- rast(system.file('ex/elev.tif',package="terra"))
flowdir <- terrain(elev, "flowdir")

pits <- pitfinder(flowdir)
pits2 <- pitfinder(flowdir, pits_on_boundary=FALSE)
plot((pits>0)==(pits2>0))
}

\keyword{spatial}

\name{toMemory}

\docType{methods}

\alias{toMemory}
\alias{toMemory,SpatRaster-method}
\alias{toMemory,SpatRasterDataset-method}

\title{Read all cell values into memory}

\description{
Reads all cell values of a SpatRaster or SpatRasterDataset into memory.

Using this method is discouraged as it is not necessary for processing the data and may lead to excessive memory use that will slow down your computer or worse. It cannot be used for SpatRasters that are based on very large files.

The method may be useful if a relatively small dataset is used repeatedly, such that efficiency gains are made because the values only need to be read from disk once.
}

\usage{
\S4method{toMemory}{SpatRaster}(x)

\S4method{toMemory}{SpatRasterDataset}(x)
}

\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
}

\value{
Same as \code{x}
}


\seealso{ \code{\link{values}, \link{as.data.frame}, \link{readValues}, \link{inMemory}} }


\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
sources(r)
inMemory(r)
x <- toMemory(r)
inMemory(x)
}

\keyword{ spatial }
\keyword{ methods }

\name{distance}

\alias{distance}
\alias{distance,SpatRaster,missing-method}
\alias{distance,SpatRaster,SpatVector-method}
\alias{distance,SpatRaster,sf-method}
\alias{distance,SpatVector,ANY-method}
\alias{distance,SpatVector,SpatVector-method}
\alias{distance,matrix,matrix-method}
\alias{distance,matrix,missing-method}
\alias{distance,data.frame,data.frame-method}
\alias{distance,data.frame,missing-method}

\title{Geographic distance}

\description{

If \code{x} is a \bold{SpatRaster}:

If \code{y} is \code{missing} this method computes the distance, for all cells that are \code{NA} in SpatRaster \code{x} to the nearest cell that is not \code{NA} (or other values, see arguments "target" and "exclude"). 

If \code{y} is a numeric value, the cells with that value are ignored. That is, distance to or from these cells is not computed.

If \code{y} is a SpatVector, the distance to that SpatVector is computed for all cells, optionally after rasterization.

The distance is always expressed in meter if the coordinate reference system is longitude/latitude, and in map units otherwise. Map units are typically meter, but inspect \code{crs(x)} if in doubt.

Results are more precise, sometimes much more precise, when using longitude/latitude rather than a planar coordinate reference system, as these distort distance. 

If \code{x} is a \bold{SpatVector}:

If \code{y} is \code{missing}, a distance matrix between all objects in \code{x} is computed. A distance matrix object of class "dist" is returned. 

If \code{y} is a SpatVector, the geographic distance between all objects is computed (and a matrix is returned). If both sets have the same number of points, and \code{pairwise=TRUE}, the distance between each pair of objects is computed, and a vector is returned.

If \code{x} is a \bold{matrix}:

\code{x} should consist of two columns, the first with "x" (or longitude) and the second with "y" coordinates (or latitude). If \code{y} is a also a matrix, the distance between each point in \code{x} and all points in \code{y} is computed, unless \code{pairwise=TRUE}

If \code{y} is missing, the distance between each point in \code{x} with all other points in \code{x} is computed, unless \code{sequential=TRUE}
}



\usage{
\S4method{distance}{SpatRaster,missing}(x, y, target=NA, exclude=NULL, unit="m", method="haversine", 
			maxdist=NA, values=FALSE, filename="", ...)

\S4method{distance}{SpatRaster,SpatVector}(x, y, unit="m", rasterize=FALSE, method="haversine", filename="", ...)

\S4method{distance}{SpatVector,SpatVector}(x, y, pairwise=FALSE, unit="m", method="haversine",
			use_nodes=FALSE, names=NULL)

\S4method{distance}{SpatVector,ANY}(x, y, sequential=FALSE, pairs=FALSE, symmetrical=TRUE, unit="m",
			method="haversine", use_nodes=FALSE, names=NULL)

\S4method{distance}{matrix,matrix}(x, y, lonlat, pairwise=FALSE, unit="m", method="geo")

\S4method{distance}{matrix,missing}(x, y, lonlat, sequential=FALSE, pairs=FALSE, symmetrical=TRUE,
			unit="m", method="geo")
}

\arguments{
  \item{x}{SpatRaster, SpatVector, or two-column matrix with coordinates (x,y or lon,lat)}
  \item{y}{missing, numeric, SpatVector, or two-column matrix}
  \item{target}{numeric. The value of the cells for which distances to cells that are not \code{NA} should be computed}
  \item{exclude}{numeric. The value of the cells that should not be considered for computing distances}
  \item{unit}{character. Can be either "m" or "km"}
  \item{method}{character. One of "geo", "cosine" or "haversine". With "geo" the most precise but slower method of Karney (2003) is used. The other two methods are faster but less precise}
  \item{maxdist}{numeric. Distances above this value are set to \code{NA}}
  \item{values}{logical. If \code{TRUE}, the value of the nearest non-target cell is returned instead of the distance to that cell}
  \item{rasterize}{logical. If \code{TRUE} distance is computed from the cells covered by the geometries after rasterization. This can be much faster in some cases}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
  \item{sequential}{logical. If \code{TRUE}, the distance between sequential geometries is returned}
  \item{pairwise}{logical. If \code{TRUE} and if x and y have the same size (number of rows), the pairwise distances are returned instead of the distances between all elements} 
  \item{lonlat}{logical. If \code{TRUE} the coordinates are interpreted as angular (longitude/latitude). If \code{FALSE} they are interpreted as planar}
  \item{pairs}{logical. If \code{TRUE} a "from", "to", "distance" matrix is returned} 
  \item{symmetrical}{logical. If \code{TRUE} and \code{pairs=TRUE}, the distance between a pair is only included once. The distance between geometry 1 and 3 is included, but the (same) distance between 3 and 1 is not}
  \item{use_nodes}{logical. If \code{TRUE} and the crs is longitude/latitude, the nodes (vertices) of lines or polygons are used to compute distances, instead of the lines that connect them. This is faster, but can be less precise if the nodes are far apart}
  \item{names}{character. One (or two) variable names in \code{x} (and \code{y}) to label the distance matrix} 
}

\value{
SpatRaster, numeric, matrix, or a distance matrix (object of class "dist")
}

\note{
A distance matrix can be coerced into a regular matrix with \code{as.matrix}
}

\seealso{\code{\link{nearest}}, \code{\link{nearby}}, \code{\link{gridDist}}, \code{\link{costDist}}}

\references{
Karney, C.F.F., 2013. Algorithms for geodesics, J. Geodesy 87: 43-55. doi:10.1007/s00190-012-0578-z.
}

\examples{
#lonlat
r <- rast(ncols=36, nrows=18, crs="+proj=longlat +datum=WGS84")
r[500] <- 1
d <- distance(r, unit="km") 
plot(d / 1000)

#planar
rr <- rast(ncols=36, nrows=18, crs="+proj=utm +zone=1 +datum=WGS84")
rr[500] <- 1
d <- distance(rr) 

rr[3:10, 3:10] <- 99
e <- distance(rr, exclude=99) 

p1 <- vect(rbind(c(0,0), c(90,30), c(-90,-30)), crs="lonlat")
values(p1) <- data.frame(ID=LETTERS[1:3])
dp <- distance(r, p1) 

d <- distance(p1)
d
as.matrix(d)

p2 <- vect(rbind(c(30,-30), c(25,40), c(-9,-3)), crs="+proj=longlat +datum=WGS84")
values(p2) <- data.frame(ID=letters[1:3])
dd <- distance(p1, p2, names=c("ID", "ID"))
dd
pd <- distance(p1, p2, pairwise=TRUE)
pd
pd == diag(dd)


# polygons, lines
crs <- "+proj=utm +zone=1"
p1 <- vect("POLYGON ((0 0, 8 0, 8 9, 0 9, 0 0))", crs=crs)
p2 <- vect("POLYGON ((5 6, 15 6, 15 15, 5 15, 5 6))", crs=crs)
p3 <- vect("POLYGON ((2 12, 3 12, 3 13, 2 13, 2 12))", crs=crs)
p <- rbind(p1, p2, p3)
L1 <- vect("LINESTRING(1 11, 4 6, 10 6)", crs=crs)
L2 <- vect("LINESTRING(8 14, 12 10)", crs=crs)
L3 <- vect("LINESTRING(1 8, 12 14)", crs=crs)
lns <- rbind(L1, L2, L3)
pts <- vect(cbind(c(7,10,10), c(3,5,6)), crs=crs)

distance(p1,p3)
distance(p)
distance(p,pts)
distance(p,lns)
distance(pts,lns)
}

\keyword{spatial}

\name{cellSize}

\alias{cellSize}
\alias{cellSize,SpatRaster-method}
  
\title{Area covered by each raster cell}

\description{

Compute the area covered by individual raster cells. 

Computing the surface area of raster cells is especially relevant for longitude/latitude rasters. 

But note that for both angular (longitude/latitude) and for planar (projected) coordinate reference systems raster cells sizes are generally not constant, unless you are using an equal-area coordinate reference system. For planar CRSs, the area is therefore not computed based on the linear units of the coordinate reference system, but rather by transforming cells to longitude/latitude. If you do not want that correction, you can use \code{transform=FALSE} or \code{init(x, prod(res(x)))}
}

\usage{
\S4method{cellSize}{SpatRaster}(x, mask=FALSE, lyrs=FALSE, unit="m", transform=TRUE, rcx=100, filename="", ...)
}


\arguments{
  \item{x}{SpatRaster}
  \item{mask}{logical. If \code{TRUE}, cells that are \code{NA} in \code{x} are also \code{NA} in the output}
  \item{lyrs}{logical. If \code{TRUE} and \code{mask=TRUE}, the output has the same number of layers as \code{x}. That is only useful in cases where the layers of \code{x} have different cells that are \code{NA}}
  \item{unit}{character. One of "m", "km", or "ha"}
  \item{transform}{logical. If \code{TRUE}, planar CRS data are transformed to lon/lat for accuracy}
  \item{rcx}{positive integer. The maximum number of rows and columns to be used to compute area of planar data if \code{transform=TRUE}. If \code{x} has more rows and/or columns, the raster is aggregated to match this limit, and values for the original cells are estimated by bilinear interpolation (see \code{resample}). This can save a lot of time}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{\code{\link{expanse}}, \code{\link{surfArea}}}

\examples{

# SpatRaster 
r <- rast(nrows=18, ncols=36)
v <- 1:ncell(r)
v[200:400] <- NA
values(r) <- v

# size of each raster cell
a <- cellSize(r)

# illustration of distortion
r <- rast(ncols=90, nrows=45, ymin=-80, ymax=80)
m <- project(r, "+proj=merc")

bad <- init(m, prod(res(m)) / 1000000, wopt=list(names="naive"))
good <- cellSize(m, unit="km", names="corrected")
plot(c(good, bad), nc=1, mar=c(2,2,1,6))
}

\keyword{methods}
\keyword{spatial}

\name{vect}

\docType{methods}

\alias{vect}
\alias{vect,character-method}
\alias{vect,list-method}
\alias{vect,SpatVector-method}
\alias{vect,SpatVectorCollection-method}
\alias{vect,SpatExtent-method}
\alias{vect,data.frame-method}
\alias{vect,matrix-method}
\alias{vect,missing-method}
\alias{vect,Spatial-method}
\alias{vect,sf-method}
\alias{vect,sfc-method}
\alias{vect,XY-method}
\alias{vect,PackedSpatVector-method}
\alias{vect,SpatGraticule-method}


\title{Create SpatVector objects}

\description{
Methods to create a SpatVector from a filename or other R object. 

A filename can be for a Shapefile, GeoPackage, GeoJSON, Keyhole Markup Language (KML) or any other spatial vector file format. 

You can use a data.frame to make a SpatVector of points. If the variables to be used are not specified with argument \code{geom}, the method looks for candidate variables. If variables are found and these appear to be longitude/latitude, the "+proj=longlat" crs is assigned unless another crs is specified.  

You can also use a two-column matrix to make a SpatVector of points, or a "geom" matrix to make a SpatVector of any supported geometry (see examples and \code{\link{geom}}). 

You can supply a list of SpatVectors to append them into a single SpatVector. 

SpatVectors can also be created from "Well Known Text", and from spatial vector data objects defined in the \code{sf} or \code{sp} packages.
} 

\usage{
\S4method{vect}{character}(x, layer="", query="", dialect="", extent=NULL, filter=NULL, 
		crs="", proxy=FALSE, what="", opts=NULL, kml.extended=NULL)

\S4method{vect}{matrix}(x, type="points", atts=NULL, crs="")

\S4method{vect}{data.frame}(x, geom=NULL, crs=NULL, keepgeom=FALSE, quiet=FALSE)

\S4method{vect}{list}(x, type="points", crs="")

\S4method{vect}{SpatExtent}(x, crs="")

\S4method{vect}{SpatVectorCollection}(x)

\S4method{vect}{sf}(x)
}

\arguments{
\item{x}{character. A filename; or a "Well Known Text" or GeoJSON string; SpatExtent, data.frame (to make a SpatVector of points); a "geom" matrix to make a SpatVector of any supported geometry (see examples and \code{\link{geom}}); a spatial vector data object defined in the \code{sf} or \code{sp} packages; or a list with either matrices with coordinates, or raw "Well Known Binary" (WKB) blobs}
\item{layer}{character. layer name to select a layer from a file (database) with multiple layers}
\item{query}{character. A query to subset the dataset}
\item{dialect}{character. The SQL dialect to use (if any). For example: "SQLite". "" refers to the default \href{https://gdal.org/en/latest/user/ogr_sql_dialect.html}{OGR-SQL dialect}}
\item{extent}{Spat* object. The extent of the object is used as a spatial filter to select the geometries to read. Ignored if \code{filter} is not \code{NULL}}
\item{filter}{SpatVector. Used as a spatial filter to select geometries to read (the convex hull is used for lines or points). It is guaranteed that all features that overlap with the extent of filter will be returned. It can happen that additional geometries are returned}
\item{type}{character. Geometry type. Must be "points", "lines", or "polygons". Ignored if \code{x} is a WKB list}
\item{atts}{data.frame with the attributes. The number of rows must match the number of geometrical elements}
\item{crs}{character. The coordinate reference system in one of the following formats: WKT/WKT2, <authority>:<code>, or PROJ-string notation (see \code{\link{crs}}). If \code{x} is a data.frame, \code{crs==NULL}, and \code{geom} is c("lon", "lat") or a variation thereof, "+proj=longlat" is assigned}
\item{proxy}{logical. If \code{TRUE} a SpatVectorProxy is returned}
\item{what}{character indicating what to read. Either \code{""} for geometries and attributes, or \code{"geoms"} to only read the geometries, \code{"attributes"} to only read the attributes (that are returned as a data.frame)}
\item{opts}{character. GDAL dataset open options. For example "ENCODING=LATIN1"}
\item{kml.extended}{logical or \code{NULL}. For \code{.kml} and \code{.kmz} files: GDAL's \code{KML} driver (common on Windows) often reads only \code{Name} and \code{Description}, while the \code{LIBKML} driver (common on Linux) may add many KML structure fields as columns (often empty). With \code{NULL} (default) or \code{TRUE}, if the suggested \code{XML} package is available, \code{terra} parses \verb{ExtendedData} and replaces the attribute table when the placemark count matches the vector's feature count (same order as \verb{<Placemark>} elements with geometry). For \code{.kmz}, the archive is unpacked to a temporary directory, preferring \code{doc.kml} if present. With \code{FALSE}, GDAL fields are kept. Ignored when \code{proxy=TRUE} or \code{what != ""}.}
\item{geom}{character. The field name(s) with the geometry data. Either two names for x and y coordinates of points, or a single name for a single column with WKT geometries. If \code{NULL} the function will use or c("x", "y"), c("lon", "lat"), c("longitude", "latitude") and a few variations thereof, if one of these pairs is in the data}
\item{keepgeom}{logical. If \code{TRUE} the geom variable(s), e.g. spatial coordinates, is (are) also included in the attributes table}
\item{quiet}{logical. If \code{FALSE} a warning is given when \code{x} is a data.frame and the values for geom and/or the crs are guessed from the data}
}

\seealso{\code{\link{geom}}, \code{\link{vector_layers}}}


\value{SpatVector}


\examples{
### SpatVector from file
f <- system.file("ex/lux.shp", package="terra")
f
v <- vect(f)
v

## subsetting (large) files
## with attribute query 
v <- vect(f, query="SELECT NAME_1, NAME_2, ID_2 FROM lux WHERE ID_2 < 4")

## with an extent
e <- ext(5.9, 6.3, 49.9, 50) 
v <- vect(f, extent=e)

## with polygons
p <- as.polygons(e)
v <- vect(f, filter=p)


### SpatVector from a geom matrix
x1 <- rbind(c(-180,-20), c(-140,55), c(10, 0), c(-140,-60))
x2 <- rbind(c(-10,0), c(140,60), c(160,0), c(140,-55))
x3 <- rbind(c(-125,0), c(0,60), c(40,5), c(15,-45))
hole <- rbind(c(80,0), c(105,13), c(120,2), c(105,-13))
z <- rbind(cbind(object=1, part=1, x1, hole=0), cbind(object=2, part=1, x3, hole=0),
			cbind(object=3, part=1, x2, hole=0), cbind(object=3, part=1, hole, hole=1))
colnames(z)[3:4] <- c('x', 'y')

p <- vect(z, "polygons")
p

z[z[, "hole"]==1, "object"] <- 4
lns <- vect(z[,1:4], "lines")
plot(p)
lines(lns, col="red", lwd=2)

### from wkt
v <- vect("POLYGON ((0 -5, 10 0, 10 -10, 0 -5))")

wkt <- c("MULTIPOLYGON ( ((40 40, 20 45, 45 30, 40 40)), 
((20 35, 10 30, 10 10, 30 5, 45 20, 20 35),(30 20, 20 15, 20 25, 30 20)))", 
"POLYGON ((0 -5, 10 0, 10 -10, 0 -5))")
w <- vect(wkt)

# combine two SpatVectors 
vw <- rbind(w, v)

# add a data.frame
d <- data.frame(id=1:2, name=c("a", "b"))
values(w) <- d

# add data.frame on creation, here from a geom matrix
g <- geom(w)
d <- data.frame(id=1:2, name=c("a", "b"))
m <- vect(g, "polygons", atts=d, crs="+proj=longlat +datum=WGS84")

### SpatVector from a data.frame
d$wkt <- wkt
x <- vect(d, geom="wkt")

d$wkt <- NULL
d$lon <- c(0,10)
d$lat <- c(0,10)
x <- vect(d, geom=c("lon", "lat"))

# SpatVector to sf
#sf::st_as_sf(x)
}

\keyword{methods}
\keyword{spatial}

\name{focalPairs}

\alias{focalCor}
\alias{focalCor,SpatRaster-method}
\alias{focalPairs}
\alias{focalPairs,SpatRaster-method}


\title{Focal function across two layers}

\description{
Calculate values such as a correlation coefficient for focal regions in two neighboring layers. A function is applied to the first and second layer, then to the second and third layer, etc.
}

\usage{
\S4method{focalPairs}{SpatRaster}(x, w=3, fun, ..., fillvalue=NA, 
		filename="", overwrite=FALSE, wopt=list()) 
}

\arguments{
\item{x}{SpatRaster with at least two layers}

\item{w}{numeric or matrix to define the focal window. The window an be defined as one (for a square) or two numbers (row, col); or with an odd-sized weights matrix. See the Details section in \code{\link{focal}}. Note that if a matrix with numbers other than zero or one are used, the values are used as weights. For this to work, \code{fun} must have an argument \code{weights}}

\item{fun}{a function with at least two arguments (one for each layer). There is a built-in function "pearson" (for both the weighted and the unweighted Pearson correlation coefficient. This function has an additional argument \code{na.rm=FALSE}}

\item{...}{additional arguments for \code{fun}}

\item{fillvalue}{numeric. The value of the cells in the virtual rows and columns outside of the raster}

\item{filename}{character. Output filename}

\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}

\item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{SpatRaster}


\seealso{ \code{\link{layerCor}}, \code{\link{focalReg}}, \code{\link{focal}}, \code{\link{focal3D}}}


\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))
set.seed(0)
r[[1]] <- flip(r[[1]], "horizontal")
r[[2]] <- flip(r[[2]], "vertical") + init(rast(r,1), runif)
r[[3]] <- init(rast(r,1), runif)

x <- focalPairs(r, w=5, "pearson", na.rm=TRUE)
plot(x)


# suppress warning "the standard deviation is zero"
suppressWarnings(x <- focalPairs(r, w=5, "pearson", use="complete.obs"))

z <- focalPairs(r, w=9, function(x, y) mean(x) + mean(y))
}



\keyword{spatial}

\name{furdist}

\alias{furdist}
\alias{furdist,SpatVector,SpatVector-method}

\title{Distance to the furthest location on a geometry}

\description{
For each point in \code{x}, compute the distance to the \emph{furthest} location on the edge of the geometries in \code{y}. This is the counterpart of \code{\link{distance}}, which returns the distance to the \emph{nearest} location.

The "edge" is the boundary of polygons, the line itself for lines, and the points for a points geometry.
}

\usage{
\S4method{furdist}{SpatVector,SpatVector}(x, y, pairwise=FALSE, unit="m")
}

\arguments{
  \item{x}{SpatVector of points. The location(s) from which the distance is measured}
  \item{y}{SpatVector of points, lines, or polygons. The geometries whose furthest edge location is measured}
  \item{pairwise}{logical. If \code{TRUE} and if \code{x} and \code{y} have the same number of geometries (or one of them has a single geometry), the pairwise distances (point \code{i} of \code{x} with geometry \code{i} of \code{y}) are returned. If \code{FALSE}, the distances for all combinations are returned}
  \item{unit}{character. Can be either "m" or "km"}
}

\value{
If \code{pairwise=TRUE} a numeric vector with one distance for each pair. Otherwise a data.frame with columns "from" (the index of the point in \code{x}), "to" (the index of the geometry in \code{y}) and "distance".
}

\seealso{\code{\link{distance}}, \code{\link{nearest}}, \code{\link{snapTo}}}

\examples{
# planar
crs <- "+proj=utm +zone=1"
p <- vect("POLYGON ((0 0, 8 0, 8 9, 0 9, 0 0))", crs=crs)
pts <- vect(cbind(c(1, 5), c(1, 5)), crs=crs)

furdist(pts, p)
furdist(pts, p, unit="km")

# longitude/latitude
pp <- vect("POLYGON ((0 0, 10 0, 10 10, 0 10, 0 0))", crs="lonlat")
q <- vect(cbind(5, 5), crs="lonlat")
furdist(q, pp, unit="km")
}

\keyword{spatial}

\name{modal}

\alias{modal}
\alias{modal,SpatRaster-method}

\title{modal value}

\description{
Compute the mode for each cell across the layers of a SpatRaster. The mode, or modal value, is the most frequent value in a set of values. 
}

\usage{
\S4method{modal}{SpatRaster}(x, ..., ties="first", na.rm=FALSE, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{...}{additional argument of the same type as \code{x} or numeric}
  \item{ties}{character. Indicates how to treat ties. Either "random", "lowest", "highest", "first", or "NA"}
  \item{na.rm}{logical. If \code{TRUE}, \code{NA} values are ignored. If \code{FALSE}, \code{NA} is returned if \code{x} has any \code{NA} values}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}  
}

\value{
SpatRaster
}

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
r <- c(r/2, r, r*2)
m <- modal(r)
}

\keyword{univar}
\keyword{math}

\name{as.arrows}

\alias{as.arrows}

\title{Add directional arrows from a SpatRaster to a plot}

\description{
Create directional arrows and add these to a plot, typically used to represent vector fields such as wind directions, drainage flow directions, or other angular data.
}

\usage{
as.arrows(x, unit=c("degrees", "radians", "flowdir"),
       arrow_length=NA,clockwise=FALSE, angle_from_h_axis=0,
       angle_from_x_axis=angle_from_h_axis, length=0,...)
}

\arguments{
  \item{x}{SpatRaster with values representing angles or directions}
  \item{unit}{Character. Unit of the angle values in \code{x}. One of \code{"degrees"}, \code{"radians"} or \code{"flowdir"}. See \code{\link{terrain}} for \code{flowdir}}
  \item{arrow_length}{Numeric. Length of the arrows to be plotted}
  \item{clockwise}{Logical. Default is \code{FALSE}. If \code{TRUE}, angles measured in radians or degrees are considered clockwise}
  \item{angle_from_x_axis}{Anti-clockwise angle from x (or horizontal) axis to the reference direction}
  \item{angle_from_h_axis}{Anti-clockwise angle from x (or horizontal) axis to the reference direction. In the case of northing wind direction it is often used \code{angle_from_x_axis=90, unit="deg", clockwise=TRUE}}
  \item{length,...}{Additional graphical parameters passed to \code{\link[graphics]{arrows}}}
}


\author{
Emanuele Cordano
}

\examples{

r <- rast(system.file("ex/elev_vinschgau.tif", package="terra"))
r <- aggregate(r, fact=2,fun=min)
d <- terrain(r, "flowdir")

plot(r,col=terrain.colors(10))
as.arrows(d, unit="flowdir", col="black")
}

\seealso{
\code{\link[graphics]{arrows}}, \code{\link[terra]{terrain}}
}

\name{spin}

\docType{methods}

\alias{spin}
\alias{spin,SpatVector-method}

\title{spin a SpatVector}

\description{
Spin (rotate) the geometry of a SpatVector. 
}

\usage{
\S4method{spin}{SpatVector}(x, angle, x0, y0)
}

\arguments{
 \item{x}{SpatVector}
 \item{angle}{numeric. Angle of rotation in degrees}
 \item{x0}{numeric. x-coordinate of the center of rotation. If missing, the center of the extent of \code{x} is used}
 \item{y0}{numeric. y-coordinate of the center of rotation. If missing, the center of the extent of \code{x} is used}
}

\value{
SpatVector
}

\seealso{\code{\link{rescale}}, \code{\link{t}}, \code{\link{shift}}}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
w <- spin(v, 180)
plot(v)
lines(w, col="red")

# lower-right corner as center
e <- as.vector(ext(v))
x <- spin(v, 45, e[1], e[3])
}

\keyword{spatial}

\name{serialize}

\alias{serialize}
\alias{saveRDS}
\alias{unserialize}
\alias{readRDS}

\alias{serialize,SpatExtent-method}
\alias{serialize,SpatVector-method}
\alias{serialize,SpatRaster-method}
\alias{serialize,SpatRasterDataset-method}
\alias{serialize,SpatRasterCollection-method}
\alias{unserialize,ANY-method}

\alias{saveRDS,SpatExtent-method}
\alias{saveRDS,SpatVector-method}
\alias{saveRDS,SpatRaster-method}
\alias{saveRDS,SpatRasterCollection-method}
\alias{saveRDS,SpatRasterDataset-method}
\alias{readRDS,character-method}


\title{saveRDS and serialize for SpatVector and SpatRaster*}

\description{
serialize and saveRDS for SpatVector, SpatRaster, SpatRasterDataset and SpatRasterCollection. Note that these objects will first be "packed" with \code{\link{wrap}}, and after unserialize/readRDS they need to be unpacked with \code{rast} or \code{vect}.

Extensive use of these functions is not recommended. Especially for SpatRaster it is generally much more efficient to use \code{\link{writeRaster}} and write, e.g., a GTiff file. 
}

\usage{
\S4method{saveRDS}{SpatRaster}(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL)

\S4method{saveRDS}{SpatRasterDataset}(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL)

\S4method{saveRDS}{SpatRasterCollection}(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL)

\S4method{saveRDS}{SpatVector}(object, file="", ascii = FALSE, version = NULL, compress=TRUE, refhook = NULL)

\S4method{serialize}{SpatRaster}(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL)

\S4method{serialize}{SpatVector}(object, connection, ascii = FALSE, xdr = TRUE, version = NULL, refhook = NULL)
}

\arguments{
  \item{object}{SpatVector, SpatRaster, SpatRasterDataset or SpatRasterCollection}
  \item{file}{file name to save object to}
  \item{connection}{see \code{\link{serialize}}}
  \item{ascii}{see \code{\link{serialize}} or \code{\link{saveRDS}}}
  \item{version}{see \code{\link{serialize}} or \code{\link{saveRDS}}}
  \item{compress}{see \code{\link{serialize}} or \code{\link{saveRDS}}}
  \item{refhook}{see \code{\link{serialize}} or \code{\link{saveRDS}}}
  \item{xdr}{see \code{\link{serialize}} or \code{\link{saveRDS}}}
}

\value{
Packed* object 
}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
p <- serialize(v, NULL)
head(p)
x <- unserialize(p)
x
}


\keyword{ spatial }
\keyword{ methods }

\name{fillHoles}

\docType{methods}

\alias{fillHoles}
\alias{fillHoles,SpatVector-method}
\alias{fillHoles,SpatRaster-method}


\title{Remove or extract holes from polygons, or fill holes in raster data}

\description{
Remove the holes in SpatVector polygons. If \code{inverse=TRUE} the holes are returned (as polygons).

Or remove "holes" in SpatRasters.
} 

\usage{
\S4method{fillHoles}{SpatVector}(x, inverse=FALSE)

\S4method{fillHoles}{SpatRaster}(x, nearest=FALSE)
}

\arguments{
\item{x}{SpatVector}
\item{inverse}{logical. If \code{TRUE} the holes are returned as polygons}
\item{nearest}{logical. If \code{FALSE} only holes that are surrounded by cells with the same value are filled. Otherwise, the values of the nearest cell that is not \code{NA} is assigned}
}

\value{SpatVector}

\seealso{\code{\link{snap}}, \code{\link{gaps}}}

\examples{
x <- rbind(c(50,0), c(140,60), c(160,0), c(140,-55))
hole <- rbind(c(80,0), c(105,13), c(120,2), c(105,-13))

z <- rbind(cbind(object=1, part=1, x, hole=0), 
		   cbind(object=1, part=1, hole, hole=1))
colnames(z)[3:4] <- c('x', 'y')
p <- vect(z, "polygons", atts=data.frame(id=1), crs="local")
p

f <- fillHoles(p)
g <- fillHoles(p, inverse=TRUE)

plot(p, lwd=16, border="gray", col="light yellow")
polys(f, border="blue", lwd=3, density=4, col="orange")
polys(g, col="white", lwd=3)


## SpatRaster
v <- vect(c("POLYGON ((81.572 36.629, 98.508 9.624, 80 0, 99.902 -10.349, 
	84.662 -34.709, 50 0, 81.572 36.629))", "POLYGON ((140 60, 160 0, 
	140 -55, 84.662 -34.709, 99.902 -10.349, 105 -13, 120 2, 105 13, 
	98.508 9.624, 81.572 36.629, 140 60))"))
v <- rbind(v, shift(p ,-120))
v$ID <- 1:nrow(v)
r <- rasterize(v, rast(xmin=-80, crs="local"), "ID")

f1 <- fillHoles(r)
f2 <- fillHoles(r, nearest=TRUE)
}


\keyword{methods}
\keyword{spatial}

\name{as.points}

\docType{methods}

\alias{as.points}

\alias{as.points,SpatRaster-method}
\alias{as.points,SpatVector-method}
\alias{as.points,SpatExtent-method}

\title{Conversion to a SpatVector of points}

\description{
Conversion of a SpatRaster, SpatVector or SpatExtent to a SpatVector of points.
}

\usage{
\S4method{as.points}{SpatRaster}(x, values=TRUE, na.rm=TRUE, na.all=FALSE)

\S4method{as.points}{SpatVector}(x, multi=FALSE, skiplast=TRUE)

\S4method{as.points}{SpatExtent}(x, crs="")
}


\arguments{
\item{x}{SpatRaster, SpatVector or SpatExtent}
\item{values}{logical; include cell values as attributes?}
\item{multi}{logical. If \code{TRUE} a multi-point geometry is returned}
\item{skiplast}{logical. If \code{TRUE} the last point of a polygon (which is the same as the first point) is not included}
\item{na.rm}{logical. If \code{TRUE} cells that are \code{NA} are ignored}
\item{na.all}{logical. If \code{TRUE} cells are only ignored if \code{na.rm=TRUE} and their value is \code{NA} for \bold{all} layers instead of for \code{any} layer}
\item{crs}{character. The coordinate reference system (see \code{\link{crs}})}
}

\value{
SpatVector
}

\seealso{
\code{\link{as.lines}}, \code{\link{as.points}}
}


\examples{
r <- rast(ncols=2, nrows=2)
values(r) <- 1:ncell(r)

as.points(r)

p <- as.polygons(r)
as.points(p)
}

\keyword{spatial}

\name{initialize}

\alias{init}
\alias{init,SpatRaster-method}

\title{Initialize a SpatRaster with values}

\description{
Create a SpatRaster with values reflecting a cell property: "x", "y", "xy", "col", "row", "cell" or "chess". Alternatively, a function can be used. In that case, cell values are initialized without reference to pre-existing values. E.g., initialize with a random number (\code{fun=\link{runif}}). While there are more direct ways of achieving this for small objects (see examples) for which a vector with all values can be created in memory, the \code{init} function will also work for SpatRasters with many cells.
}

\usage{
\S4method{init}{SpatRaster}(x, fun, ..., filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{fun}{function to be applied. This must be a either single number, multiple numbers, a function, or one of a set of known character values. A function must take the number of cells as a single argument to return a vector of values with a length equal to the number of cells, such as \code{fun=runif}. Allowed character values are "x", "y", "row", "col", "cell", and "chess" to get the x or y coordinate or both, row, col or cell number or a chessboard pattern (alternating 0 and 1 values)}
  \item{...}{additional arguments passed to \code{fun}}
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}    
  \item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\value{
SpatRaster
}

\examples{
r <- rast(ncols=10, nrows=5, xmin=0, xmax=10, ymin=0, ymax=5)
x <- init(r, fun="cell")
y <- init(r, fun=runif)

# initialize with a single value 
z <- init(r, fun=8)
}

\keyword{spatial}

\name{is.bool}

\docType{methods}

\alias{is.num}
\alias{is.num,SpatRaster-method}
\alias{is.bool}
\alias{is.bool,SpatRaster-method}
\alias{as.bool}
\alias{as.bool,SpatRaster-method}
\alias{isTRUE,SpatRaster-method}
\alias{isFALSE,SpatRaster-method}
\alias{as.logical,SpatRaster-method}
\alias{is.int}
\alias{is.int,SpatRaster-method}
\alias{as.int}
\alias{as.int,SpatRaster-method}
\alias{as.integer,SpatRaster-method}
\alias{is.factor}
\alias{is.factor,SpatRaster-method}
\alias{as.factor}
\alias{as.factor,SpatRaster-method}

  
\title{Raster value types}

\description{
The values in a SpatRaster layer are by default numeric, but they can also be set to be logical (Boolean), integer, or categorical (factor). 

For a \code{SpatRaster}, \code{as.logical} and \code{isTRUE} is equivalent to \code{as.bool}. \code{isFALSE} is equivalent to \code{!as.bool}, and \code{as.integer} is the same as \code{as.int}.

\code{as.bool} and \code{as.int} force the values into the correct range (e.g. whole integers) but in-memory cell values are still stored as numeric. They will behave like the assigned types, though, and will be written to files with that data type (if the file type supports it). 

See \code{\link{levels}} and \code{\link{cats}} to create categorical layers by setting labels. 
}

\usage{
\S4method{is.num}{SpatRaster}(x)

\S4method{is.bool}{SpatRaster}(x)

\S4method{as.bool}{SpatRaster}(x, filename, ...)

\S4method{is.int}{SpatRaster}(x)

\S4method{as.int}{SpatRaster}(x, filename, ...)

\S4method{is.factor}{SpatRaster}(x)

\S4method{as.factor}{SpatRaster}(x)
}


\arguments{
  \item{x}{SpatRaster}
  \item{filename}{character. Output filename}
  \item{...}{list with named options for writing files as in \code{\link{writeRaster}}}
}  

\seealso{
\code{\link{levels}} and \code{\link{cats}} to create categorical layers (and set labels). 
}


\value{
The \code{as.*} methods return a new \code{SpatRaster}, whereas the \code{is.*} methods return a \code{logical} value for each layer in \code{x}. 
}


\examples{
r <- rast(nrows=10, ncols=10, vals=1:100)
is.bool(r)
z <- as.bool(r)
is.bool(z)

x <- r > 25
is.bool(x)

rr <- r/2
is.int(rr)
is.int(round(rr))
}

\keyword{methods}
\keyword{spatial}

\name{scatterplot}

\docType{methods}

\alias{plot,SpatRaster,SpatRaster-method}


\title{Scatterplot of two SpatRaster layers}

\description{
Scatterplot of the values of two SpatRaster layers
}

\usage{
\S4method{plot}{SpatRaster,SpatRaster}(x, y, maxcell=100000, warn=TRUE, nc, nr, 
   maxnl=16, smooth=FALSE, gridded=FALSE, ncol=25, nrow=25, ...)

}

\arguments{
  \item{x}{SpatRaster}
  \item{y}{SpatRaster}
  \item{maxcell}{positive integer. Maximum number of cells to use for the plot}
  \item{nc}{positive integer. Optional. The number of columns to divide the plotting device in (when plotting multiple layers)}
  \item{nr}{positive integer. Optional. The number of rows to divide the plotting device in (when plotting multiple layers)}
  \item{maxnl}{positive integer. Maximum number of layers to plot (for multi-layer objects)}
  \item{smooth}{logical. If \code{TRUE} show a smooth scatterplot (see \code{\link[graphics]{smoothScatter}}}
  \item{gridded}{logical. If \code{TRUE} the scatterplot is gridded (counts by cells)}
  \item{warn}{boolean. Show a warning if a sample of the pixels is used (for scatterplot only)}

  \item{ncol}{positive integer. Number of columns for gridding}
  \item{nrow}{positive integer. Number of rows for gridding}
  \item{...}{additional graphical arguments}  
}


\examples{ 
s <- rast(system.file("ex/logo.tif", package="terra"))   
plot(s[[1]], s[[2]])
plot(s, sqrt(s[[3:1]]))
}

\keyword{methods}
\keyword{spatial}

\name{text}

\docType{methods}

\alias{text}
\alias{text,SpatRaster-method}
\alias{text,SpatVector-method}

\title{Add labels to a map}

\description{
Plots labels, that is a textual (rather than color) representation of values, on top an existing plot (map). 
}

\usage{
\S4method{text}{SpatRaster}(x, labels, digits=0, halo=FALSE, hc="white", hw=0.1, jitter=0, ...)

\S4method{text}{SpatVector}(x, labels, halo=FALSE, inside=FALSE, hc="white", hw=0.1, jitter=0, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{labels}{character. Optional. Vector of labels with \code{length(x)} or a variable name from \code{names(x)}}
  \item{digits}{integer. How many digits should be used?}
  \item{halo}{logical. If \code{TRUE} a "halo" is printed around the text}
  \item{hc}{character. The halo color}
  \item{hw}{numeric. The halo width}
  \item{inside}{logical. Should the text always be placed inside one the sub-geometries?}
  \item{jitter}{numeric. The amount of random noise used to adjust label positions, possibly avoiding overlaps. See argument 'factor' in \code{\link{jitter}}}
  \item{...}{additional arguments to pass to graphics function \code{\link[graphics]{text}} }
}

\seealso{
\code{\link[graphics]{text}, \link{plot}, \link{halo}}
}



\examples{ 
r <- rast(nrows=4, ncols=4)
values(r) <- 1:ncell(r)

plot(r)
text(r)

set.seed(123)
text(r, jitter = 2, col = "red", halo = TRUE)

plot(r)
text(r, halo=TRUE, hc="blue", col="white", hw=0.2)

plot(r, col=rainbow(16))
text(r, col=c("black", "white"), vfont=c("sans serif", "bold"), cex=2)
}

\keyword{methods}
\keyword{spatial}

\name{ext}

\docType{methods}

\alias{ext}
\alias{ext<-}
\alias{ext,SpatExtent-method}
\alias{ext,SpatRaster-method}
\alias{ext,SpatVector-method}
\alias{ext,SpatVectorCollection-method}
\alias{ext,SpatVectorProxy-method}
\alias{ext,SpatRasterDataset-method}
\alias{ext,SpatRasterCollection-method}
\alias{ext,SpatRasterGraticule-method}
\alias{ext<-,SpatRaster,SpatExtent-method}
\alias{ext<-,SpatRaster,numeric-method}
\alias{ext,numeric-method}
\alias{ext,matrix-method}
\alias{ext,data.frame-method}
\alias{ext,missing-method}
\alias{ext,Spatial-method}
\alias{ext,Raster-method}
\alias{ext,Extent-method}
\alias{ext,sf-method}
\alias{ext,bbox-method}
\alias{ext,PackedSpatExtent-method}
\alias{ext,SpatGraticule-method}

\title{Create, get or set a SpatExtent}

\description{
Get a SpatExtent of a SpatRaster, SpatVector, or other spatial objects. Or create a SpatExtent from four numbers (xmin, xmax, ymin, ymax).

You can set the extent of a SpatRaster, but you cannot set the extent of a SpatVector (see \code{\link{rescale}} for that). See \code{\link{set.ext}} to set the extent in place.
}

\usage{
\S4method{ext}{SpatRaster}(x, cells=NULL)

\S4method{ext}{SpatVector}(x)

\S4method{ext}{numeric}(x, ..., xy=FALSE)

\S4method{ext}{SpatRaster,SpatExtent}(x)<-value

\S4method{ext}{SpatRaster,numeric}(x)<-value
}

\arguments{
  \item{x}{SpatRaster, SpatVector, a numeric vector of length four (xmin, xmax, ymin, ymax), a single numeric (xmin; see additional arguments under \code{...}), or missing (in which case the output is the global extent in lon-lat coordinates)}
  \item{cells}{positive integer (cell) numbers to subset the extent to area covered by these cells}
  \item{value}{SpatExtent, or numeric vector of length four (xmin, xmax, ymin, ymax)}  
  \item{...}{if \code{x} is a single numeric value, additional numeric values for xmax, ymin, and ymax}  
  \item{xy}{logical. Set this to \code{TRUE} to indicate that coordinates are in (xmin, ymin, xmax, ymax) order, instead of in the terra standard order of (xmin, xmax, ymin, ymax)}
}
 
\value{
A \code{\link{SpatExtent}} object. 
}

\seealso{
\code{\link{xmin}}, \code{\link{xmax}}, \code{\link{ymin}}, \code{\link{ymax}}
}

\examples{
ext()

r <- rast()
e <- ext(r)
as.vector(e)
as.character(e)

ext(r) <- c(0, 2.5, 0, 1.5)
r
er <- ext(r)

round(er)
# go "in"
floor(er)
# go "out"
ceiling(er)

ext(r) <- e

}

\keyword{spatial}

\name{regress}

\docType{methods}

\alias{regress}
\alias{regress,SpatRaster,SpatRaster-method}
\alias{regress,SpatRaster,numeric-method}
\alias{regress,SpatRaster,data.frame-method}

\title{Cell level regression}

\description{
Run a regression model for each cell of a SpatRaster. The independent variable can be defined either by:
\itemize{
  \item a \code{numeric} vector of length \code{nlyr(y)} -- one covariate that varies across the layers but is constant across cells (e.g. time);
  \item a \code{SpatRaster} of the same number of layers as \code{y} -- one covariate that varies both across layers and across cells;
  \item a \code{data.frame} with one row per layer of \code{y} and one column per predictor -- multiple covariates that vary across layers but are constant across cells (e.g. an experimental design like NPK fertilizer levels).
}
}

\usage{

\S4method{regress}{SpatRaster,numeric}(y, x, formula=y~x, na.rm=FALSE, cores=1, filename="", overwrite=FALSE, ...)

\S4method{regress}{SpatRaster,SpatRaster}(y, x, formula=y~x, na.rm=FALSE, cores=1, filename="", overwrite=FALSE, ...)

\S4method{regress}{SpatRaster,data.frame}(y, x, formula=NULL, na.rm=FALSE, cores=1, filename="", overwrite=FALSE, ...)
}


\arguments{
\item{y}{SpatRaster. The dependent variable. Each layer is one observation per cell.}
\item{x}{The independent variable(s):
\itemize{
  \item \code{SpatRaster} of the same number of layers as \code{y};
  \item \code{numeric} vector of length \code{nlyr(y)};
  \item \code{data.frame} with \code{nlyr(y)} rows and one column per predictor (no \code{NA}s allowed).
}}
\item{formula}{regression formula. For the \code{numeric} and \code{SpatRaster} methods the default is \code{y ~ x}; you can add additional terms such as \code{I(x^2)}. For the \code{data.frame} method the default (when \code{formula=NULL}) is \code{y ~ .}, expanding to all columns of \code{x}; you can also pass a custom formula whose right-hand side references the column names of \code{x} (the left-hand side is ignored).}
\item{na.rm}{logical. If \code{TRUE}, layers with \code{NA} response in a given cell are dropped before fitting. A cell whose remaining row count drops below the number of regression coefficients yields all \code{NA}s.}
\item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created and used. You can also supply a cluster object.}
\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
\item{...}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{SpatRaster. One layer per regression coefficient, named after the corresponding column of \code{model.matrix(formula, x)} (e.g. \code{(Intercept)}, the names of the predictors, and any interaction or polynomial terms).}


\examples{
s <- rast(system.file("ex/logo.tif", package="terra"))
x <- regress(s, 1:nlyr(s))

# data.frame method: a small NPK fertilizer experiment.
# Suppose `y` has one layer per (N, P, K) treatment.
\dontrun{
NPK <- data.frame(
    N = c(0, 0, 0, 50, 50, 50, 100, 100, 100),
    P = c(0, 25, 50, 0, 25, 50, 0, 25, 50),
    K = c(0, 0, 0, 10, 10, 10, 20, 20, 20)
)
y <- rast(ncol=2, nrow=2, nlyr=nrow(NPK))
values(y) <- rep(1:nrow(NPK) * 200, each=4)

# Default formula y ~ N + P + K:
fit <- regress(y, NPK)

# Custom formula with interactions and a quadratic term:
fit2 <- regress(y, NPK, formula = yield ~ N + P + K + I(N^2) + N:P)
}
}

\keyword{methods}
\keyword{spatial}

\name{vrt}

\docType{methods}

\alias{vrt}
\alias{vrt,character-method}
\alias{vrt,SpatRasterCollection-method}

\title{Virtual Raster Dataset}

\description{
Create a Virtual Raster Dataset (VRT) from a collection of file-based raster datasets (tiles). See
\href{https://gdal.org/en/latest/programs/gdalbuildvrt.html}{gdalbuildvrt} for details.
}

\usage{
\S4method{vrt}{character}(x, filename="", options=NULL, overwrite=FALSE, set_names=FALSE, return_filename=FALSE)

\S4method{vrt}{SpatRasterCollection}(x, filename="", options=NULL, overwrite=FALSE, return_filename=FALSE)
}

\arguments{
  \item{x}{SpatRasterCollection or character vector with filenames of raster "tiles". That is, files that have data for, typically non-overlapping, sub-regions of a raster. See \code{\link{makeTiles}}}
  \item{filename}{character. output VRT filename}
  \item{options}{character. All arguments as separate vector elements. Options as for \href{https://gdal.org/en/latest/programs/gdalbuildvrt.html}{gdalbuildvrt}}
  \item{overwrite}{logical. Should \code{filename} be overwritten if it exists?}
  \item{set_names}{logical. Add the layer names of the first tile to the vrt? If \code{options} includes \code{"-separate"} the name of each source file is added, and each input goes into a separate band in the VRT dataset}
  \item{return_filename}{logical. If \code{TRUE} the filename is returned, otherwise a SpatRaster is returned}
}

\value{
SpatRaster
}

\note{
A VRT can reference very many datasets. These are not all opened at the same time. The default is to open not more than 100 files. To increase performance, this maximum limit can be increased by setting the GDAL_MAX_DATASET_POOL_SIZE configuration option to a bigger value with \code{\link{setGDALconfig}}. Note that a typical user process on Linux is limited to 1024 simultaneously opened files.
}

\seealso{
\code{\link{makeTiles}} to create tiles; \code{\link{makeVRT}} to create a .vrt file for a binary raster file that does not have a header file. \code{\link{vrt_tiles}} to get the filenames of the tiles in a VRT.
}

\examples{
r <- rast(ncols=100, nrows=100)
values(r) <- 1:ncell(r)
x <- rast(ncols=2, nrows=2)
filename <- paste0(tempfile(), "_.tif")
ff <- makeTiles(r, x, filename)
ff

#vrtfile <- paste0(tempfile(), ".vrt")
#v <- vrt(ff, vrtfile)


## output in lower resolution
#vrtfile <- paste0(tempfile(), ".vrt")
#v <- vrt(ff, vrtfile, options = c("-tr", 5, 5))
#head(readLines(vrtfile))
#v
}


\keyword{methods}
\keyword{spatial}

\name{RGB}

\docType{methods}

\alias{RGB}
\alias{RGB,SpatRaster-method}
\alias{RGB<-}
\alias{RGB<-,SpatRaster-method}
\alias{colorize}
\alias{colorize,SpatRaster-method}
\alias{has.RGB}
\alias{has.RGB,SpatRaster-method}

  
\title{Layers representing colors}

\description{
With \code{RGB} you can get or set the layers to be used as Red, Green and Blue when plotting a SpatRaster. Currently, a benefit of this is that \code{\link[terra]{plot}} will send the object to \code{\link{plotRGB}}. You can also associated the layers with another color space (HSV, HSI or HSL)

With \code{colorize} you can convert a three-layer RGB SpatRaster into other color spaces. You can also convert it into a single-layer SpatRaster with a color-table.
}

\usage{
\S4method{RGB}{SpatRaster}(x, value=NULL, type="rgb")

\S4method{RGB}{SpatRaster}(x, ..., type="rgb")<-value

\S4method{colorize}{SpatRaster}(x, to="hsv", alpha=FALSE, stretch=NULL, 
	grays=FALSE, NAzero=FALSE, filename="", overwrite=FALSE, ...)

\S4method{has.RGB}{SpatRaster}(x, strict=TRUE)
}


\arguments{
  \item{x}{SpatRaster}
  
  \item{value}{three (or four) positive integers indicating the layers that are red, green and blue (and optionally a fourth transparency layer). Or \code{NULL} to remove the RGB settings}
  
  \item{type}{character. The color space. One of "rgb" "hsv", "hsi" and "hsl"}

  \item{to}{character. The color space to transform the values to. If \code{x} has RGB set, you can transform these to "hsv", "hsi" and "hsl", or use "col" to create a single layer with a color table. You can also use "rgb" to back transform to RGB}

  \item{alpha}{logical. Should an alpha (transparency) channel be included? Only used if \code{x} has a color-table and \code{to="rgb"}}

  \item{stretch}{character. Option to stretch the values to increase contrast: "lin" (linear) or "hist" (histogram). Only used for transforming RGB to col}
  
  \item{grays}{logical. If \code{TRUE}, a gray-scale color-table is created. Only used for transforming RGB to col}

  \item{NAzero}{logical. If \code{TRUE}, NAs are treated as zeros such that a color can be returned if at least one of the three channels has a value. Only used for transforming RGB to (\code{"col"})}

  \item{strict}{logical. If \code{TRUE}, the function returns \code{FALSE} if a color space such as "hsv", "hsi" and "hsl" is used}
  
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}  
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}  


\seealso{\code{\link{make.RGB}, \link{set.RGB}}}

\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
RGB(r)
plot(r)
has.RGB(r)
RGB(r) <- NULL
has.RGB(r)
plot(r)
RGB(r) <- c(3,1,2)
# same as 
# r <- RGB(r, c(3,1,2))

plot(r)

RGB(r) <- 1:3
x <- colorize(r, "col")
y <- colorize(r, "hsv")
z <- colorize(y, "rgb")
}

\keyword{methods}
\keyword{spatial}

\name{time}

\alias{time}
\alias{time,SpatRaster-method}
\alias{time,SpatRasterDataset-method}
\alias{has.time}
\alias{has.time,SpatRaster-method}
\alias{has.time,SpatRasterDataset-method}
\alias{time<-}
\alias{time<-,SpatRaster-method}
\alias{time<-,SpatRasterDataset-method}
\alias{timeInfo}
\alias{timeInfo,SpatRaster-method}
\alias{timeInfo,SpatRasterDataset-method}

  
\title{time of SpatRaster layers}

\description{
Get or set the time of the layers of a SpatRaster. Time can be stored as \code{\link{POSIXlt}} (date and time, with  a resolution of seconds, and a time zone), \code{\link{Date}}, "months", "years", or "yearmonths". 

\code{timeInfo} and \code{has.time} are helper functions to understand what a time data a SpatRaster has.
}

\usage{
\S4method{has.time}{SpatRaster}(x)

\S4method{time}{SpatRaster}(x, format="")

\S4method{time}{SpatRaster}(x, tstep="")<-value

\S4method{timeInfo}{SpatRaster}(x)
}

\seealso{\code{\link{depth}}}


\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
  \item{format}{One of "", "seconds" (POSIXlt), "days" (Date), "yearmonths" (decimal years), "years", "months". If "", the returned format is (based on) the format that was used to set the time}
  \item{value}{\code{Date}, \code{POSIXt}, \code{yearmon} (defined in package zoo), or numeric}
  \item{tstep}{One of "years", "months", "yearmonths". Used when \code{value} is numeric. Ignored when \code{value} is of type \code{Date}, \code{POSIXt}, or \code{yearmon}}
}

\value{
\code{time}: POSIXlt, Date, or numeric
\code{timeInfo}: data.frame with time step and time zone information (if available)
\code{has.time}: logical
}


\examples{
s <- rast(system.file("ex/logo.tif", package="terra"))   

# Date"
d <- as.Date("2001-05-04") + 0:2
time(s) <- d
time(s)

# POSIX (date/time with a resolution of seconds)
time(s) <- as.POSIXlt(d)
time(s)

# with time zone
time(s) <- as.POSIXlt(Sys.time(), "America/New_York") + 0:2
time(s)
timeInfo(s)

# years
time(s, tstep="years") <- 2000 + 0:2
s

time(s, tstep="months") <- 1:3
s 
}

\keyword{spatial}

\name{tile_apply}

\alias{tile_apply}

\title{Parallelize a SpatRaster function}

\description{
The function splits a \code{SpatRaster} into virtual tiles and applies a user supplied function to each tile, and assembles the per-tile results back into a single \code{SpatRaster}. The work can be distributed over a cluster of worker processes.
}

\usage{
tile_apply(x, fun, cores=1, cpkgs=NULL, tiles=NULL, buffer=0, ...,
	filename="", overwrite=FALSE, wopt=list(), overlap_fun=NULL)
}

\arguments{
  \item{x}{\code{SpatRaster}. Preferably backed by a file so that workers can re-open it cheaply; in-memory rasters are shipped to the workers via \code{\link{wrap}}}
  \item{fun}{function. Takes a \code{SpatRaster} as its first argument and must return a \code{SpatRaster}. It is called once per tile, with the windowed \code{x} as the first argument and any extra \code{...} arguments appended}
  \item{cores}{one of: an integer (\code{> 1} creates a PSOCK cluster of that size, torn down at the end of the call); a \code{cluster} object created with \code{parallel::makeCluster}; the string \code{"future"} (use \code{\link[future.apply]{future_lapply}} with the currently-active \code{future::\link[future]{plan}}); or a future strategy object (e.g. \code{future::multisession()}), which is set as the plan for the duration of the call. The \code{"future"} and plan-object paths require the \pkg{future} and \pkg{future.apply} packages}
  \item{cpkgs}{character. Names of packages that must be loaded on each worker before \code{fun} is called (e.g. \code{"randomForest"})}
  \item{tiles}{specification of the tiles. If \code{NULL} (the default), the tile size is chosen automatically and a per-worker memory budget that depends on \code{cores} (see \code{\link{getTileExtents}}. Otherwise one of: a \code{SpatExtent}; a list of \code{SpatExtent}s; a 4-column matrix of extents \code{(xmin, xmax, ymin, ymax)} as returned by \code{\link{getTileExtents}}; a \code{SpatRaster} or \code{SpatVector} that defines the tile geometry; or one or two integers specifying the number of rows and columns \emph{per tile} (passed on to \code{\link{getTileExtents}})}
  \item{buffer}{integer. Number of additional rows and columns (one number, or two for separate row/column buffers) of \code{x} to read on each side of every tile, so that \code{fun} can compute neighbourhood-dependent values (e.g. \code{\link{focal}}) without edge artefacts. The result of \code{fun} is then cropped back to the un-buffered tile extent before it is written, so the per-tile outputs are non-overlapping. Only used when \code{tiles = NULL}; ignored with a warning otherwise (when supplying \code{tiles} explicitly, build the overlap into the tiles yourself with \code{getTileExtents(..., buffer=)} and pick an \code{overlap_fun})}
  \item{...}{additional arguments passed to \code{fun}. When \code{cores > 1} these are serialized and shipped to each worker; \code{SpatRaster}, \code{SpatVector} and other \pkg{terra} objects in \code{...} are automatically wrapped and unwrapped}
  \item{filename}{character. Output filename for the assembled result. When empty (the default) and \code{overlap_fun = NULL}, a virtual raster (VRT) is returned that references the per-tile files (see \emph{Details})}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten if it exists}
  \item{wopt}{list. Writing options as in \code{\link{writeRaster}}}
  \item{overlap_fun}{character or \code{NULL}. The function name used by \code{\link{mosaic}} to combine overlapping cells (e.g. \code{"mean"}, \code{"min"}, \code{"max"}, \code{"sum"}, \code{"first"}). Use this when \code{tiles} was built with overlap (e.g. \code{getTileExtents(..., buffer=)}). When \code{NULL} (the default), tiles are assembled with \code{\link{vrt}}, which is correct for non-overlapping tiles (including the auto path with \code{buffer}, which crops away the overlap) and is essentially free}
}

\details{
\strong{Buffered tiles for focal-style operations.} When \code{tiles = NULL} and \code{buffer > 0}, each tile is read on an expanded extent of (\code{buffer} cells on each side, clamped to \code{x}'s extent), \code{fun} is applied, and the result is cropped back to the un-buffered tile extent before it is written. This avoids the edge effects that operations like \code{\link{focal}} would otherwise produce at tile boundaries.

The per-tile files are then assembled into the final \code{SpatRaster}:
\itemize{
  \item When \code{overlap_fun = NULL} (the default), the assembly is a virtual raster (\code{\link{vrt}}). This is fast and correct as long as the tiles do not overlap. If they do, the value of the last tile in the overlapping regions is used.
  \item When \code{overlap_fun} is set (e.g. \code{"mean"}), the assembly uses \code{\link{mosaic}} and applies the function to the values of overlapping cells.
}

If \code{filename} is empty and a VRT is returned, the tiled data files are kept for the rest of the R session, but they are lost after the session.

Extra arguments passed via \code{...} must be named when \code{cores > 1}.

}

\value{
A \code{SpatRaster}.
}

\seealso{
\code{\link{getTileExtents}}, \code{\link{makeTiles}}, \code{\link{mosaic}}, \code{\link{vrt}}, \code{\link{window}}, \code{\link{wrap}}
}

\examples{
\donttest{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)

# not parallel
# Returned object is a VRT backed by per-tile files in tempdir().
out1 <- tile_apply(r, function(x) x * 2)

# focal, use a buffer wide enough for the focal window
out3 <- tile_apply(r, function(x) focal(x, w=5, fun="mean", 
		na.rm=TRUE), buffer=2)

# parallel on 2 workers
\dontrun{
out4 <- tile_apply(r, function(x) x * 2, cores=2)

# pass extra arguments by name; nested terra objects are auto-wrapped
out5 <- tile_apply(r, function(x, k) x * k, cores=2, tiles=50, k=10)

# use a future plan instead of a cluster
if (requireNamespace("future", quietly=TRUE) &&
    requireNamespace("future.apply", quietly=TRUE)) {
    future::plan(future::multisession, workers=2)
    out6 <- tile_apply(r, function(x) x * 2, cores="future")
    future::plan(future::sequential)
}
}
}
}

\keyword{spatial}

\name{is.flipped}

\docType{methods}

\alias{is.flipped}
\alias{is.flipped,SpatRaster-method}
  
  
\title{Is a SpatRaster flipped?}

\description{
Check if a SpatRaster is "flipped" vertically, and may need to be adjusted with \code{\link{flip}} before it can be used. 
}

\usage{
\S4method{is.flipped}{SpatRaster}(x)
}


\arguments{
  \item{x}{SpatRaster}
}  


\value{
logical. One value for each raster data *source*
}


\seealso{
 \code{\link{flip}, \link{is.rotated}, \link{has.geoloc}}
}

\examples{
r <- rast(nrows=10, ncols=10)
is.flipped(r)
}

\keyword{methods}
\keyword{spatial}

\name{interpolation}

\docType{methods}

\alias{interpolate}
\alias{interpolate,SpatRaster-method}

\title{Spatial interpolation}

\description{
Make a SpatRaster with interpolated values using a fitted model object of classes such as "gstat" (gstat package) or "Krige" (fields package), or any other model that has location (e.g., "x" and "y", or "longitude" and "latitude") as predictors (independent variables). If x and y are the only predictors, it is most efficient if you provide an empty (no associated data in memory or on file) SpatRaster for which you want predictions. If there are more spatial predictor variables, provide these as a SpatRaster in the first argument of the function. If you do not have x and y locations as implicit predictors in your model you should use \code{\link[terra]{predict}} instead.
}

\usage{
\S4method{interpolate}{SpatRaster}(object, model, fun=predict, ..., xyNames=c("x", "y"), 
       factors=NULL, const=NULL, index = NULL, cores=1, cpkgs=NULL, 
	   na.rm=FALSE, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
\item{object}{SpatRaster}
\item{model}{model object}
\item{fun}{function. Default value is "predict", but can be replaced with e.g. "predict.se" (depending on the class of \code{model}), or a custom function (see examples)}
\item{...}{additional arguments passed to \code{fun}}
\item{xyNames}{character. variable names that the model uses for the spatial coordinates. E.g., \code{c("longitude", "latitude")}}
 \item{factors}{list with levels for factor variables. The list elements should be named with names that correspond to names in \code{object} such that they can be matched. This argument may be omitted for some models from which the levels can be extracted from the \code{model} object}
\item{const}{data.frame. Can be used to add a constant for which there is no SpatRaster for model predictions. This is particularly useful if the constant is a character-like factor value}
  \item{index}{positive integer or NULL. Allows for selecting of the variable returned if the model returns multiple variables}
 \item{cores}{positive integer. If \code{cores > 1}, a 'parallel' package cluster with that many cores is created and used}
  \item{cpkgs}{character. The package(s) that need to be loaded on the nodes to be able to run the model.predict function (see examples in \code{\link{predict}})}  
 \item{na.rm}{logical. If \code{TRUE}, cells with \code{NA} values in the predictors are removed from the computation. This option prevents errors with models that cannot handle \code{NA} values. In most other cases this will not affect the output. An exception is when predicting with a model that returns predicted values even if some (or all!) variables are \code{NA} }

\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
\item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{ \code{\link{predict}}, \code{\link{interpIDW}}, \code{\link{interpNear}}}


\examples{

r <- rast(system.file("ex/elev.tif", package="terra"))
ra <- aggregate(r, 10)
xy <- data.frame(xyFromCell(ra, 1:ncell(ra)))
v <- values(ra)
i <- !is.na(v)
xy <- xy[i,]
v <- v[i]

\dontrun{
library(fields) 
tps <- Tps(xy, v)
p <- rast(r)

# use model to predict values at all locations
p <- interpolate(p, tps)
p <- mask(p, r)
plot(p)

### change "fun" from predict to fields::predictSE to get the TPS standard error
## need to use "rast(p)" to remove the values
se <- interpolate(rast(p), tps, fun=predictSE)
se <- mask(se, r)
plot(se)

### another predictor variable, "e"
e <- (init(r, "x") * init(r, "y")) / 100000000
names(e) <- "e"

z <- as.matrix(extract(e, xy)[,-1])

## add as another independent variable
xyz <- cbind(xy, z)
tps2 <- Tps(xyz, v)
p2 <- interpolate(e, tps2, xyOnly=FALSE)

## as a linear covariate
tps3 <- Tps(xy, v, Z=z)

## Z is a separate argument in Krig.predict, so we need a new function
## Internally (in interpolate) a matrix is formed of x, y, and elev (Z)

pfun <- function(model, x, ...) {
   predict(model, x[,1:2], Z=x[,3], ...)
}
p3 <- interpolate(e, tps3, fun=pfun)


#### gstat examples
library(gstat)
library(sp)
data(meuse)

### inverse distance weighted (IDW)
r <- rast(system.file("ex/meuse.tif", package="terra"))
mg <- gstat(id = "zinc", formula = zinc~1, locations = ~x+y, data=meuse, 
            nmax=7, set=list(idp = .5))
z <- interpolate(r, mg, debug.level=0, index=1)
z <- mask(z, r)

## with a model built with an `sf` object you need to provide custom function

library(sf)
sfmeuse <- st_as_sf(meuse, coords = c("x", "y"), crs=crs(r))
mgsf <- gstat(id = "zinc", formula = zinc~1, data=sfmeuse,  nmax=7, set=list(idp = .5))

interpolate_gstat <- function(model, x, crs, ...) {
	v <- st_as_sf(x, coords=c("x", "y"), crs=crs)
	p <- predict(model, v, ...)
	as.data.frame(p)[,1:2]
}

zsf <- interpolate(r, mgsf, debug.level=0, fun=interpolate_gstat, crs=crs(r), index=1)
zsf <- mask(zsf, r)

### kriging

### ordinary kriging
v <- variogram(log(zinc)~1, ~x+y, data=meuse)
mv <- fit.variogram(v, vgm(1, "Sph", 300, 1))
gOK <- gstat(NULL, "log.zinc", log(zinc)~1, meuse, locations=~x+y, model=mv)
OK <- interpolate(r, gOK, debug.level=0)

## universal kriging
vu <- variogram(log(zinc)~elev, ~x+y, data=meuse)
mu <- fit.variogram(vu, vgm(1, "Sph", 300, 1))
gUK <- gstat(NULL, "log.zinc", log(zinc)~elev, meuse, locations=~x+y, model=mu)
names(r) <- "elev"
UK <- interpolate(r, gUK, debug.level=0)

## co-kriging
gCoK <- gstat(NULL, 'log.zinc', log(zinc)~1, meuse, locations=~x+y)
gCoK <- gstat(gCoK, 'elev', elev~1, meuse, locations=~x+y)
gCoK <- gstat(gCoK, 'cadmium', cadmium~1, meuse, locations=~x+y)
gCoK <- gstat(gCoK, 'copper', copper~1, meuse, locations=~x+y)
coV <- variogram(gCoK)
plot(coV, type='b', main='Co-variogram')
coV.fit <- fit.lmc(coV, gCoK, vgm(model='Sph', range=1000))
coV.fit
plot(coV, coV.fit, main='Fitted Co-variogram')
coK <- interpolate(r, coV.fit, debug.level=0)
plot(coK)
}
}

\keyword{methods}
\keyword{spatial}

\name{nseg}

\alias{nseg}
\alias{nseg,SpatVector-method}

  
\title{Number of segments}

\description{
Count the number of segments in a SpatVector of lines or polygons
}

\usage{
\S4method{nseg}{SpatVector}(x)
}


\arguments{
  \item{x}{SpatVector}
}

\value{
numeric
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
nseg(v)
}

\keyword{methods}
\keyword{spatial}

\name{adjacent}

\docType{methods}

\alias{adjacent}
\alias{adjacent,SpatRaster-method}
\alias{adjacent,SpatVector-method}

\title{Adjacent cells or polygons}

\description{
Identify cells that are adjacent to a set of raster cells. Or identify adjacent polygons
}

\usage{
\S4method{adjacent}{SpatRaster}(x, cells, directions="rook", pairs=FALSE, include=FALSE, symmetrical=FALSE)

\S4method{adjacent}{SpatVector}(x, type="rook", pairs=TRUE, symmetrical=FALSE)
}

\arguments{
  \item{x}{SpatRaster, or SpatVector of polygons}
  \item{cells}{vector of cell numbers for which adjacent cells should be found. Cell numbers start with 1 in the upper-left corner and increase from left to right and from top to bottom}
  \item{directions}{character or matrix to indicated the directions in which cells are considered connected. The following character values are allowed: "rook" or "4" for the horizontal and vertical neighbors; "bishop" to get the diagonal neighbors; "queen" or "8" to get the vertical, horizontal and diagonal neighbors; or "16" for knight and one-cell queen move neighbors. If \code{directions} is a matrix it should have odd dimensions and have logical (or 0, 1) values}
  \item{pairs}{logical. If \code{TRUE}, a two-column matrix of pairs of adjacent cells is returned. If \code{x} is a \code{SpatRaster} and \code{pairs} is \code{FALSE}, an \code{n*m} matrix is returned where the number of rows \code{n} is \code{length(cells)} and the number of columns \code{m} is the number of neighbors requested with \code{directions}}
  \item{include}{logical. Should the focal cells be included in the result?}
  \item{type}{character. One of "rook", "queen", "touches", or "intersects". "queen" and "touches" are synonyms. "rook" exclude polygons that touch at a single node only. "intersects" includes polygons that touch or overlap}
  \item{symmetrical}{logical. If \code{TRUE} and \code{pairs=TRUE}, an adjacent pair is only included once. For example, if polygon 1 is adjacent to polygon 3, the implied adjacency between 3 and 1 is not reported}
}

\note{
When using global lon/lat rasters, adjacent cells at the other side of the date-line are included.
}


\seealso{\code{\link{relate}, \link{nearby}, \link{nearest}}}

\value{
matrix
}

\examples{
r <- rast(nrows=10, ncols=10)
adjacent(r, cells=c(1, 5, 55), directions="queen") 
r <- rast(nrows=10, ncols=10, crs="+proj=utm +zone=1 +datum=WGS84")
adjacent(r, cells=11, directions="rook") 

#same as 
rk <- matrix(c(0,1,0,1,0,1,0,1,0), 3, 3)
adjacent(r, cells=11, directions=rk) 

## note that with global lat/lon data the E and W connect
r <- rast(nrows=10, ncols=10, crs="+proj=longlat +datum=WGS84")
adjacent(r, cells=11, directions="rook") 

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
a <- adjacent(v, symmetrical=TRUE)
head(a)
}

\keyword{spatial}

\name{costDist}

\alias{costDist}
\alias{costDist,SpatRaster-method}

\title{Cost-distance}

\description{

Use a friction (cost) surface to compute the cost-distance from any cell to the border of one or more target cells. 

Distances are computed by summing local distances between cells, which are connected with their neighbors in 8 directions, and assuming that the path has to go through the centers of one of the neighboring raster cells. 

Distances are multiplied with the friction, thus to get the cost-distance, the friction surface must express the cost per unit distance (speed) of travel. 
}

\usage{
\S4method{costDist}{SpatRaster}(x, target=0, scale=1, maxiter=50, nearest=FALSE, filename="", ...) 
}

\arguments{
\item{x}{SpatRaster}
\item{target}{numeric. value of the target cells (where to compute cost-distance to)}
\item{scale}{numeric. Scale factor. The cost distance is divided by this number}
\item{maxiter}{numeric. The maximum number of iterations. Increase this number if you get the warning that \code{costDistance did not converge}}
\item{nearest}{logical. If \code{TRUE}, a second layer is returned with the cell number of the nearest target cell}
\item{filename}{character. output filename (optional)}
\item{...}{additional arguments as for \code{\link{writeRaster}}}  
}


\seealso{\code{\link{gridDist}, \link[terra]{distance}} } 


\value{SpatRaster. If \code{nearest=TRUE}, a two-layer SpatRaster with the cost-distance in the first layer and the cell number of the nearest target in the second layer}


\examples{
r <- rast(ncols=5, nrows=5, crs="+proj=utm +zone=1 +datum=WGS84", 
		xmin=0, xmax=5, ymin=0, ymax=5, vals=1)
r[13] <- 0
d <- costDist(r)
plot(d)
text(d, digits=1)

r <- rast(ncols=10, nrows=10,  xmin=0, xmax=10, ymin=0, ymax=10, 
		   vals=10, crs="+proj=utm +zone=1 +datum=WGS84")
r[4:5, c(1,10)] <- -10
r[2:3, 1] <- r[1, 2:4] <- r[2, 5] <- 0
r[3, 6] <- r[2, 7] <- r[1, 8:9] <- 0
r[, 4] <- 30
r[6, 6:10] <- NA
r[6:9, 6] <- NA

d <- costDist(r, -10, nearest=TRUE)
plot(d)
}

\keyword{spatial}

\name{trim}

\alias{trim}
\alias{trim,SpatRaster-method}

\title{Trim a SpatRaster}

\description{
Trim (shrink) a SpatRaster by removing outer rows and columns that are \code{NA} or another value.
}

\usage{
\S4method{trim}{SpatRaster}(x, padding=0, value=NA, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster}
  \item{padding}{integer. Number of outer rows/columns to keep}
  \item{value}{numeric. The value of outer rows or columns that are to be removed}
   \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\value{
SpatRaster
}

\seealso{
\code{\link{extend}}
}

\examples{
r <- rast(ncols=10, nrows=10, xmin=0,xmax=10,ymin=0,ymax=10)
v <- rep(NA, ncell(r))
v[c(12,34,69)] <- 1:3
values(r) <- v
s <- trim(r) 
}

\keyword{spatial}

\name{linearUnits}

\alias{linearUnits}
\alias{linearUnits,SpatRaster-method}
\alias{linearUnits,SpatVector-method}

  
\title{Linear units of the coordinate reference system}

\description{
Get the linear units of the coordinate reference system (crs) of a SpatRaster or SpatVector expressed in m. The value returned is used internally to transform area and perimeter measures to meters. The value returned for longitude/latitude crs is zero.
}

\usage{
\S4method{linearUnits}{SpatRaster}(x)

\S4method{linearUnits}{SpatVector}(x)

}

\arguments{
  \item{x}{SpatRaster or SpatVector}
}

\value{
numeric (meter)
}

\seealso{\code{\link{crs}}}

\examples{
x <- rast()
crs(x) <- ""
linearUnits(x)

crs(x) <- "+proj=longlat +datum=WGS84"
linearUnits(x)

crs(x) <- "+proj=utm +zone=1 +units=cm"
linearUnits(x)

crs(x) <- "+proj=utm +zone=1 +units=km"
linearUnits(x)

crs(x) <- "+proj=utm +zone=1 +units=us-ft"
linearUnits(x)
}


\keyword{spatial}

\name{as.data.frame}

\alias{as.data.frame}
\alias{as.data.frame,SpatRaster-method}
\alias{as.data.frame,SpatVector-method}
  

\title{SpatRaster or SpatVector to data.frame}

\description{
Coerce a SpatRaster or SpatVector to a data.frame
}

\usage{
\S4method{as.data.frame}{SpatVector}(x, row.names=NULL, optional=FALSE, geom=NULL, ...)

\S4method{as.data.frame}{SpatRaster}(x, row.names=NULL, optional=FALSE, xy=FALSE, 
	cells=FALSE, time=FALSE, na.rm=NA, wide=TRUE, ...)
}

\arguments{
 \item{x}{SpatRaster or SpatVector}
 \item{geom}{character or NULL. If not NULL, either "WKT" or "HEX", to get the geometry included in Well-Known-Text or hexadecimal notation. If \code{x} has point geometry, it can also be "XY" to add the coordinates of each point}
 \item{xy}{logical. If \code{TRUE}, the coordinates of each raster cell are included}
 \item{time}{logical. If \code{TRUE}, the time data is included (if available)}
 \item{na.rm}{logical. If \code{TRUE}, cells that have a \code{NA} value in at least one layer are removed. If the argument is set to \code{NA} only cells that have \code{NA} values in all layers are removed}
 \item{cells}{logical. If \code{TRUE}, the cell numbers of each raster cell are included}
 \item{wide}{logical. If \code{FALSE}, the data.frame returned has a "long" format}
 \item{...}{Additional arguments passed to the \code{\link{data.frame}}}
 \item{row.names}{This argument is ignored}
 \item{optional}{This argument is ignored}
}
  
\seealso{\code{\link{as.list}, \link{as.matrix}}. See \code{\link{geom}} to only extract the geometry of a SpatVector}  
  
\value{
data.frame
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
as.data.frame(v)
}

\keyword{spatial}
\keyword{methods}

\name{draw}

\alias{draw}
\alias{draw,character-method}
\alias{draw,missing-method}


\title{ Draw a polygon, line, extent, or points }

\description{
Draw on a plot (map) to get a SpatVector or SpatExtent object for later use. After calling the function, start clicking on the map. When you are done, press \code{ESC}. You can also preset the maximum number of clicks.

Note that for many installations this does not work well on the default RStudio plotting device. To work around that, you can first run \code{dev.new(noRStudioGD = TRUE)} which will create a separate window for plotting, then use \code{plot()} followed by \code{draw()} and clicking on the map. It may also help to set your RStudio "Tools/Global Options/Appearance/Zoom" to 100\%.
}

\usage{
\S4method{draw}{character}(x="extent", col="red", lwd=2, id=FALSE, n=1000, xpd=TRUE, ...)
}

\arguments{
  \item{x}{character. The type of object to draw. One of "extent", "polygon", "line", or "points"}
  \item{col}{the color to be used}
  \item{lwd}{the width of the lines to be drawn}
  \item{id}{logical. If \code{TRUE}, a numeric ID is shown on the map}
  \item{n}{the maximum number of clicks (does not apply when \code{x=="extent"} in which case \code{n} is always 2)}  
  \item{xpd}{logical. If \code{TRUE}, you can draw outside the current plotting area}
  \item{...}{additional graphics arguments for drawing}
}
 
\value{
SpatVector or SpatExtent 
}

\seealso{ \code{\link{click}} }
 

\keyword{ spatial }

\name{SpatVector-class}

\docType{class}

\alias{SpatVector}
\alias{SpatVector-class}

\alias{SpatVectorCollection}
\alias{SpatVectorCollection-class}

\alias{SpatVectorProxy}
\alias{SpatVectorProxy-class}

\alias{Rcpp_SpatVector-class}
\alias{PackedSpatVector-class}

\alias{show,SpatVector-method}

\title{Class "SpatVector" }

\description{
\code{SpatVector} can represent points, lines or polygons.

\code{SpatVectorCollection} can hold a collection of SpatVectors

\code{SpatVectorProxy} is a SpatVector for which the data are on-disk instead of in memory. 
}

\keyword{classes}
\keyword{spatial}

\name{crop}

\docType{methods}

\alias{crop}
\alias{crop,SpatRaster-method}
\alias{crop,SpatRasterDataset-method}
\alias{crop,SpatRasterCollection-method}
\alias{crop,SpatVector-method}
\alias{crop,SpatGraticule-method}


\title{Cut out a geographic subset}

\description{
Cut out a part of a SpatRaster or SpatVector. 

You can crop a SpatRaster with a SpatExtent, or with another object from which an extent can be obtained. Note that the SpatRaster returned may not have exactly the same extent as the SpatExtent supplied because you can only select entire cells (rows and columns), and you cannot add new areas. See methods like \code{\link{resample}} and \code{\link{disagg}} to force SpatRasters to align and \code{\link{extend}} to add rows and/or columns.

You can only crop rectangular areas of a SpatRaster, but see argument \code{mask=TRUE} for setting cell values within SpatRaster to \code{NA}; or use the \code{\link{mask}} method after crop for additional masking options.

You can crop a SpatVector with another SpatVector. If these are not polygons, the minimum convex hull is used. Unlike with \code{\link{intersect}} the geometries and attributes of \code{y} are not transferred to the output. You can also crop a SpatVector with a rectangle (SpatRaster, SpatExtent).
}

\usage{
\S4method{crop}{SpatRaster}(x, y, snap="near", mask=FALSE, touches=TRUE, extend=FALSE, filename="", ...)

\S4method{crop}{SpatRasterDataset}(x, y, snap="near", extend=FALSE)

\S4method{crop}{SpatRasterCollection}(x, y, snap="near", extend=FALSE)

\S4method{crop}{SpatVector}(x, y, ext=FALSE)

\S4method{crop}{SpatGraticule}(x, y)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{y}{SpatRaster, SpatVector, SpatExtent, or any other object that has a SpatExtent (\code{\link{ext}} returns a \code{SpatExtent})}
  \item{snap}{character. One of "near", "in", or "out". Used to align \code{y} to the geometry of \code{x}} 
  \item{mask}{logical. Should \code{y} be used to mask? Only used if \code{y} is a SpatVector, SpatRaster or sf}  
  \item{touches}{logical. If \code{TRUE} and \code{mask=TRUE}, all cells touched by lines or polygons will be masked, not just those on the line render path, or whose center point is within the polygon}
  \item{extend}{logical. Should rows and/or columns be added if \code{y} is beyond the extent of \code{x}? Also see \code{\link{extend}}}  
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
  \item{ext}{logical. Use the extent of \code{y} instead of \code{y}. This also changes the behavior when \code{y} is an extent in two ways: (1) points that are on the extent boundary are removed and (2) lon/lat extents that go beyond -180 or 180 degrees longitude are wrapped around the earth to include areas at the other end of the dateline}
}

\value{
SpatRaster
}

\seealso{
\code{\link{intersect}}, \code{\link{subset}}, \code{\link{extend}}, \code{\link{window}} for a virtual and sometimes more efficient way to crop a raster.
}

\examples{
r <- rast(xmin=0, xmax=10, ymin=0, ymax=10, nrows=25, ncols=25)
values(r) <- 1:ncell(r)
e <- ext(-5, 5, -5, 5)
rc <- crop(r, e)

# crop and mask
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
cm <- crop(r, v[9:12,], mask=TRUE)
plot(cm)
lines(v)

# crop vector
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
e <- ext(6.15, 6.3, 49.7, 49.8)
x <- crop(v, e)
plot(x, "NAME_1")
}

\keyword{spatial}

\name{sharedPaths}

\docType{methods}

\alias{sharedPaths}

\alias{sharedPaths,SpatVector-method}

\title{ 
Shared paths
}

\description{
Get shared paths of line or polygon geometries. This can for geometries in a single SpatVector, or between two SpatVectors
}

\usage{
\S4method{sharedPaths}{SpatVector}(x, y=NULL)
}

\arguments{
  \item{x}{SpatVector of lines or polygons}
  \item{y}{missing or SpatVector of lines or polygons}
} 

\value{
SpatVector
}

\seealso{
\code{\link{gaps}}, \code{\link{topology}}
}


\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
plot(v, col="light gray")
text(v, halo=TRUE)

x <- sharedPaths(v)
lines(x, col="red", lwd=2)
text(x, col="blue", halo=TRUE, cex=0.8)
head(x)

z <- sharedPaths(v[3,], v[12,])

}


\keyword{methods}
\keyword{spatial}

\name{plot_graticule}

\docType{methods}

\alias{plot,SpatGraticule,missing-method}
\alias{lines,SpatGraticule,missing-method}

\title{Plot a graticule}

\description{
Plot a SpatGraticule. You can create a SpatGraticule with \code{\link{graticule}}.
}

\usage{
\S4method{plot}{SpatGraticule,missing}(x, y, background=NULL, col="black", mar=NULL, labels=TRUE,
	retro=FALSE, lab.loc=c(1,1), lab.lon=NULL, lab.lat=NULL, lab.cex=0.65, 
	lab.col="black", off.lat=0.25, off.lon=0.25, box=FALSE, box.col="black",
	tickmarks=FALSE, add=FALSE, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{y}{missing or positive integer or name indicating the layer(s) to be plotted}  
  \item{background}{background color. If NULL, no background is drawn}
  \item{mar}{numeric vector of length 4 to set the margins of the plot. To make space for the legend you may use something like \code{c(3.1, 3.1, 2.1, 7.1)}. To fill the plotting canvas, you can use \code{c(0,0,0,0}. Use \code{NA} to not set the margins}
  \item{col}{character. Color for the graticule lines} 
  \item{labels}{logical. If \code{TRUE}, show graticule labels}
  \item{retro}{logical. If \code{TRUE}, show "retro" instead of decimal labels with the graticule}
  \item{lab.loc}{numeric. The first number indicates where the longitude graticule labels should be drawn (1=bottom, 2=top, NA=not drawn, any other number=top and bottom). The second number indicates where the latitude graticule labels should be drawn (1=left, 2=right, NA=not drawn, any other number=left and right)}	
  \item{lab.lon}{positive integers between 1 and the number of labels, indicating which longitude graticule labels should be included}
  \item{lab.lat}{positive integers between 1 and the number of labels, indicating which latitude graticule labels should be included}
  \item{lab.cex}{double. size of the label font}
  \item{lab.col}{character. color of the labels}
  \item{off.lon}{numeric. longitude labels offset}
  \item{off.lat}{numeric. latitude labels offset}
  \item{box}{logical. If \code{TRUE}, the outer lines of the graticule are drawn on top with a sold line \code{lty=1}}
  \item{box.col}{character. color of the outer lines of the graticule if \code{box=TRUE}}
  \item{tickmarks}{logical. If \code{TRUE}, tickmarks are added}
  \item{add}{logical. Add the graticule to the current plot?}
  \item{...}{additional graphical arguments passed to \code{\link{lines}}}
}

\seealso{
 \code{\link{graticule}}, \code{\link{plot}}, 
 \code{\link{points}}, \code{\link{lines}}, \code{\link{polys}}, \code{\link{image}}, \code{scatter\link[terra:scatter]{plot}}, 
 scale bar: \code{\link{sbar}}, north arrow: \code{\link{north}}

}

\examples{
g <- graticule(60, 30, crs="+proj=robin")

#plot(g, background="azure", col="red", lty=2, box=TRUE)
#plot(g, background="azure", col="light gray", lab.loc=c(1,2), 
#		lab.lon=c(2,4,6), lab.lat=3:5, lty=3, retro=TRUE)
}


\keyword{methods}
\keyword{spatial}

\name{halo}

\alias{halo}

\title{Add halo-ed text to a plot}

\description{
Add text to a plot that has a "halo". That is, a buffer around it to enhance visibility. 
}

\usage{
halo(x, y=NULL, labels, col="black", hc="white", hw=0.1, ...)
}

\arguments{
  \item{x,y}{numeric. coordinates where the text labels should be written}
  \item{labels}{character. The text to be written}
  \item{col}{character. The main color to be used}
  \item{hc}{character. The halo color}
  \item{hw}{numeric. The halo width}
  \item{...}{additional arguments to pass to \code{\link[graphics]{text}} }
}

\seealso{
\code{\link{text}, \link{plot}}
}


\examples{ 
r <- rast(nrows=4, ncols=4)
values(r) <- 1:ncell(r)
plot(r, col="blue", legend=FALSE)

text(-100, 20, "hello", cex=2)
halo(50, 20, "hello", cex=2)

halo(0, -20, "world", font=3, hc="light blue", cex=2, hw=.2)
halo(0, 90, "world", font=2, cex=2, hw=.2, xpd=TRUE, pos=2)
halo(0, 90, "world", col="white", font=2, hc="blue", cex=2, hw=.2, xpd=TRUE, pos=4)
}

\name{options}

\alias{terraOptions}

\title{Options}

\description{
Get or set general options.
}

\usage{
terraOptions(..., print=TRUE)
}

\arguments{
  \item{...}{option names and values (see Details). Or missing, to get or show the current options}  
  \item{print}{logical. If \code{TRUE} the option names and values are printed }  
} 

\details{
The following options are available. 

\bold{memfrac} - value between 0 and 0.9 (larger values give a warning). The fraction of RAM that may be used by the program.

\bold{memmin} - if memory required is below this threshold (in GB), the memory is assumed to be available. Otherwise, terra checks if it is available.

\bold{memmax} - the maximum amount of RAM (in GB) that terra is allowed to use when processing a raster dataset. Should be less than what is detected (see \code{\link{mem_info}}), and higher values are ignored. Set it to a negative number or NA to not set this option. \code{terraOptions} only shows the value of \code{memmax} if it is set.

\bold{tempdir} - directory where temporary files are written. The default what is returned by \code{tempdir()}.

\bold{datatype} - default data type. See \code{\link{writeRaster}}.

\bold{todisk} - logical. If \code{TRUE} write all raster data to disk (temp file if no file name is specified). For debugging.

\bold{progress} - non-negative integer. A progress bar is shown if the number of chunks in which the data is processed is larger than this number. No progress bar is shown if the value is zero.

\bold{verbose} - logical. If \code{TRUE} debugging info is printed for some functions.

\bold{tolerance} - numeric. Difference in raster extent (expressed as the fraction of the raster resolution) that can be ignored when comparing alignment of rasters.

\bold{parallel} - logical. If \code{TRUE} multiple threads are used (using the TBB library) where that was implemented (including distance calculations on \code{SpatVector} and some \code{focal} computations. Use \code{libVersion} to check whether TBB support is available.

\bold{threads} - non-negative integer. Cap on the number of threads used by parallel computation (when \code{parallel=TRUE}), by GDAL warp (in \code{project} and \code{resample} when \code{threads=TRUE}), and for compressed GeoTIFF writing. The default is \code{16}. This cap avoids run-away thread counts on machines with very many cores; more threads rarely help as most parallel computations are limited by memory bandwidth. No more threads than the number of available CPUs are used on machines with fewer CPUs. Set it to \code{0} to remove the cap ("use all CPUs"). Lower values are useful to leave room for other processes, or when running multiple R processes at the same time).
}

\note{
It is possible to set your own default options in "etc/.Rprofile.site" of your R installation like this

\code{options(terra_default=list(tempdir="d:/temp", memfrac=.4))}

But that may not be a good practice. It is clearer to set your favorite options at the beginning of each script.
}

\value{
list. Invisibly if \code{print=TRUE}
}

\examples{
terraOptions()
terraOptions(memfrac=0.5, tempdir = "c:/temp")
terraOptions(progress=10)
terraOptions(parallel=TRUE, threads=4)   # use TBB, capped at 4 threads
terraOptions()
}

\keyword{classes}
\keyword{spatial}

\name{plotRGB}

\docType{methods}

\alias{plotRGB}
\alias{plotRGB,SpatRaster-method}

\title{Red-Green-Blue plot of a multi-layered SpatRaster}

\description{
Make a Red-Green-Blue plot based on three layers in a SpatRaster. The layers (sometimes referred to as "bands" because they may represent different bandwidths in the electromagnetic spectrum) are combined such that they represent the red, green and blue channel. This function can be used to make "true" (or "false") color images from Landsat and other multi-spectral satellite images. 

Note that the margins of the plot are set to zero (no axes or titles are visible) but can be set with the \code{mar} argument. 

An alternative way to plot RGB images is to first use \code{\link{colorize}} to create a single layer SpatRaster with a color-table and then use \code{\link[terra]{plot}}.

}
\usage{
\S4method{plotRGB}{SpatRaster}(x, r=1, g=2, b=3, a=NULL, scale=NULL, mar=0, 
		stretch=NULL, smooth=TRUE, colNA="white", alpha=NULL, bgalpha=NULL, 
		zlim=NULL, zcol=FALSE, axes=FALSE ,...)
}


\arguments{
  \item{x}{SpatRaster}
  \item{r}{integer between 1 and \code{nlyr(x)}. Layer to use as the Red channel}
  \item{g}{integer between 1 and \code{nlyr(x)}. Layer to use as the Green channel}
  \item{b}{integer between 1 and \code{nlyr(x)}. Layer to use as the Blue channel}
  \item{a}{NULL or integer between 1 and \code{nlyr(x)}. Layer to use as the alpha (transparency) channel. If not NULL, argument \code{alpha} is ignored}
  \item{scale}{integer. Maximum (possible) value in the three channels. Defaults to 255 or to the maximum value of \code{x} if that is known and larger than 255}
  \item{mar}{numeric vector recycled to length 4 to set the margins of the plot. Use \code{mar=NULL} or \code{mar=NA} to not set the margins}
  \item{stretch}{character. Option to stretch the values to increase contrast: "lin" (linear) or "hist" (histogram). The linear stretch uses \code{\link{stretch}} with arguments \code{minq=0.02} and \code{maxq=0.98}}
  \item{smooth}{logical. If \code{TRUE}, smooth the image when drawing to get the appearance of a higher spatial resolution}
  \item{colNA}{color. The color used for cells that have NA values}
  \item{alpha}{transparency. Integer between 0 (transparent) and 255 (opaque)}
  \item{bgalpha}{Background transparency. Integer between 0 (transparent) and 255 (opaque)}
  \item{zlim}{numeric vector of length 2. Range of values to plot (optional). If this is set, and \code{stretch="lin"} is used, then the values are stretched within the range of \code{zlim}. This allows creating consistent coloring between SpatRasters with different cell-value ranges, even when stretching the colors for improved contrast}
  \item{zcol}{logical. If \code{TRUE} the values outside the range of zlim get the color of the extremes of the range. Otherwise, the values outside the zlim range get the color of \code{NA} values (see argument "colNA")}
  \item{axes}{logical. If \code{TRUE} axes are drawn (and arguments such as \code{main="title"} will be honored)}
  \item{...}{graphical parameters as in \code{\link{plot}}<SpatRaster-method>}
}


\seealso{ \code{\link{plot}}, \code{\link{colorize}}, \code{\link{RGB}} }

\examples{
b <- rast(system.file("ex/logo.tif", package="terra"))   
plotRGB(b)
plotRGB(b, mar=2)
plotRGB(b, 3, 2, 1)

b[1000:2000] <- NA
plotRGB(b, 3, 2, 1, stretch="hist")
}

\keyword{methods}
\keyword{spatial}

\name{names}

\alias{name}
\alias{name<-}
\alias{names}
\alias{names<-}

\alias{names,SpatRaster-method}
\alias{names<-,SpatRaster-method}

\alias{names,SpatRasterDataset-method}
\alias{names<-,SpatRasterDataset-method}

\alias{names,SpatRasterCollection-method}
\alias{names<-,SpatRasterCollection-method}

\alias{names,SpatVector-method}
\alias{names,SpatVectorCollection-method}
\alias{names,SpatVectorProxy-method}
\alias{names<-,SpatVector-method}
\alias{names<-,SpatVectorCollection-method}
  
\title{Names of Spat* objects}

\description{
Get or set the names of the layers of a SpatRaster or the attributes of a SpatVector. 

See \code{\link{set.names}} for in-place setting of names.
}

\usage{
\S4method{names}{SpatRaster}(x)

\S4method{names}{SpatRaster}(x)<-value

\S4method{names}{SpatRasterDataset}(x)

\S4method{names}{SpatRasterDataset}(x)<-value

\S4method{names}{SpatVector}(x)

\S4method{names}{SpatVector}(x)<-value
}

\arguments{
  \item{x}{SpatRaster, SpatRasterDataset, or SpatVector}
  \item{value}{character (vector)}
}

\value{
character 
}

\note{
terra enforces neither unique nor valid names. See \code{\link{make.unique}} to create unique names and \code{\link{make.names}} to make syntactically valid names.
}

\examples{
s <- rast(ncols=5, nrows=5, nlyrs=3)
nlyr(s)
names(s)
names(s) <- c("a", "b", "c")
names(s)

# SpatVector names
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
names(v)
names(v) <- paste0(substr(names(v), 1, 2), "_", 1:ncol(v))
names(v)
}

\keyword{spatial}

\name{add_grid}

\alias{add_grid}

\title{add a grid to a map made with terra}

\description{ 
Adaptation of \code{\link[graphics]{grid}} that allows adding a grid to a map. This function will place the grid in the locations within the mapped area as delineated by the axes.

If you set the tick marks yourself, you can use \code{\link{add_abline}} to create a grid.

Also see \code{\link{graticule}}
}

\usage{
add_grid(nx=NULL, ny=nx, col="lightgray", lty="dotted", lwd=1)
}

\arguments{
  \item{nx, ny}{number of cells of the grid in x and y direction. When NULL, as per default, the grid aligns with the tick marks on the corresponding default axis (i.e., tickmarks as computed by axTicks). When NA, no grid lines are drawn in the corresponding direction}
  \item{col}{character or (integer) numeric; color of the grid lines}
  \item{lty}{character or (integer) numeric; line type of the grid lines}
  \item{lwd}{non-negative numeric giving line width of the grid lines}
}

\seealso{\code{\link{graticule}}, \code{\link{add_abline}}, \code{\link{add_legend}}, \code{\link{add_box}}, \code{\link{add_mtext}}}

\examples{
v <- vect(system.file("ex/lux.shp", package="terra"))
plot(v)
add_grid()
}

\keyword{methods}
\keyword{spatial}

\name{all.equal}

\docType{methods}

\alias{all.equal}
\alias{all.equal,SpatRaster,SpatRaster-method}
\alias{all.equal,SpatVector,SpatVector-method}
\alias{all.equal,SpatExtent,SpatExtent-method}

\title{Compare two SpatRaster, SpatVector, or SpatExtent objects for equality}

\description{

Compare two objects for (near) equality

In the case of SpatRasters, first the attributes of the objects are compared. If these are the same, a (perhaps small) sample of the raster cells is compared as well. 

The sample size used can be increased with the \code{maxcell} argument. You can set it to \code{Inf}, but for large rasters your computer may not have sufficient memory. See the examples for a safe way to compare all values. 
}

\usage{
\S4method{all.equal}{SpatRaster,SpatRaster}(target, current, maxcell=100000, ...)

\S4method{all.equal}{SpatVector,SpatVector}(target, current, ...)

\S4method{all.equal}{SpatExtent,SpatExtent}(target, current, ...)
}

\arguments{
  \item{target}{SpatRaster, SpatVector, or SpatExtent}
  \item{current}{object of the same class as \code{target}}
  \item{maxcell}{positive integer. The size of the regular sample used to compare cell values}
  \item{...}{additional arguments passed to \code{\link{all.equal.numeric}} to compare cell values for SpatRaster and geometry and attribute values for SpatVectors}
}

\seealso{\code{\link{identical}}, \code{\link{compareGeom}}}

\value{
Either \code{TRUE} or a character vector describing the differences between target and current.
}

\examples{
x <- sqrt(1:100)
mat <- matrix(x, 10, 10)
r1 <- rast(nrows=10, ncols=10, xmin=0, vals = x)
r2 <- rast(nrows=10, ncols=10, xmin=0, vals = mat)

all.equal(r1, r2)
all.equal(r1, r1*1)
all.equal(rast(r1), rast(r2))

# compare geometries 
compareGeom(r1, r2)

# Compare all cell values for near equality
# as floating point number imprecision can be a problem
m <- minmax(r1 - r2)
all(abs(m) < 1e-7)

# comparison of cell values to create new SpatRaster
e <- r1 == r2
}

\keyword{spatial}

\name{is.rotated}

\docType{methods}

\alias{is.rotated}
\alias{is.rotated,SpatRaster-method}
  
\title{Check for rotation}

\description{
Check if a SpatRaster is "rotated" and needs to be rectified before it can be used 

See \code{\link{rectify}} 
}

\usage{
\S4method{is.rotated}{SpatRaster}(x)
}


\arguments{
  \item{x}{SpatRaster}
}  


\value{
logical. One value for each raster data *source*
}


\seealso{
 \code{\link{rectify}, \link{is.flipped}, \link{has.geoloc}}
}

\examples{
r <- rast(nrows=10, ncols=10, vals=1:100)
is.rotated(r)
}

\keyword{methods}
\keyword{spatial}

\name{normalize.longitude}

\docType{methods}

\alias{normalize.longitude}
\alias{normalize.longitude,SpatVector-method}

\title{normalize vector data that crosses the dateline}

\description{
Normalize the longitude of geometries, move them if they are outside of the -180 to 180 degrees range. 
} 

\usage{
\S4method{normalize.longitude}{SpatVector}(x)
}

\arguments{
  \item{x}{SpatVector}
}

\value{SpatVector}

\seealso{\link{rotate} for SpatRaster}


\examples{
p <- vect("POLYGON ((120 10, 230 75, 230 -75, 120 10))")
normalize.longitude(p)
}

\keyword{methods}
\keyword{spatial}

\name{chunk}

\alias{chunk}
\alias{chunk,SpatRaster-method}

\title{Make a SpatRaster method memory-safe}

\description{
This method allows for running a function that takes a SpatRaster as first argument in chunks (tiles). This can be useful if the function is not memory-safe, typically because it reads all the raster cell values into memory. 

This method is not designed to be especially efficient, and there might be more efficient ways to accomplish what the goal of the function that is not memory-safe.

Also, some functions must have access to all cells at once to be valid. In those cases, chunk would return incorrect results.
}

\usage{
\S4method{chunk}{SpatRaster}(x, fun, ..., n=NULL, buffer=0, filename="", wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{fun}{function that takes a SpatRaster as first argument}
  \item{...}{additional arguments for fun}
  \item{n}{NULL or positive integer to specifying the number of rows and columns for each chunk (or 2 numbers for a different number of rows and columns, as in \code{\link{getTileExtents}}}
  \item{buffer}{integer. The number of additional rows and columns added to each tile. Can be a single number, or two numbers to specify a separate number of rows and columns. This allows for creating overlapping tiles that can be used for computing spatial context dependent values with e.g. \code{\link{focal}}. The expansion is only inside \code{x}, no rows or columns outside of \code{x} are added}
  \item{filename}{character. Output filename}
  \item{wopt}{list with additional arguments for writing files as in \code{\link{writeRaster}}}
}


\value{SpatRaster }


\examples{
s <- rast(system.file("ex/logo.tif", package="terra"))
f <- function(x, a = 0) {
	print("chunk")
	sum(x) + a
}

x <- chunk(s, f, a=100)

}

\keyword{spatial}

\name{map.pal}

\alias{map.pal}
  
\title{color palettes for mapping}

\description{
Get a color palette for mapping. These palettes were copied from GRASS r.colors
}

\usage{
map.pal(name, n=50, ...)

}

\arguments{
\item{name}{character (name of a palette, see Details), or missing (to get the available names)}
\item{n}{numeric. The number of colors}
\item{...}{additional arguments that are passed to \code{\link{colorRamp}}}
}

\value{
none
}

\details{

\tabular{ll}{
Name \tab Description \cr
aspect \tab aspect oriented grey colors\cr
bcyr \tab blue through cyan through yellow to red\cr
bgyr \tab blue through green through yellow to red\cr
blues \tab white to blue\cr
byg \tab blue through yellow to green\cr
byr \tab blue through yellow to red\cr
curvature \tab for terrain curvatures\cr
differences \tab differences oriented colors\cr
elevation \tab maps relative ranges of raster values to elevation color ramp\cr
grass \tab GRASS GIS green (perceptually uniform)\cr
greens \tab white to green\cr
grey \tab grey scale\cr
gyr \tab green through yellow to red\cr
haxby \tab relative colors for bathymetry or topography\cr
inferno \tab perceptually uniform sequential colors inferno\cr
magma \tab perceptually uniform sequential colors\cr
oranges \tab white to orange\cr
plasma \tab perceptually uniform sequential colors\cr
rainbow \tab rainbow colors\cr
ramp \tab color ramp\cr
random \tab random colors\cr
reds \tab white to red\cr
roygbiv \tab \cr
rstcurv \tab terrain curvature\cr
ryb \tab red through yellow to blue\cr
ryg \tab red through yellow to green\cr
sepia \tab yellowish-brown through to white\cr
viridis \tab perceptually uniform sequential colors\cr
water \tab water depth\cr
wave \tab color wave\cr
}
}

\seealso{ \code{\link{terrain.colors}} }

\examples{
map.pal("elevation", 10)

r <- rast(system.file("ex/elev.tif", package="terra"))
plot(r, col=map.pal("elevation"))

map.pal()
}


\keyword{spatial}

\name{replace_values}

\docType{methods}

\alias{[<-}
\alias{[<-,SpatRaster,ANY,ANY,ANY-method}
\alias{[<-,SpatRaster,ANY,ANY-method}
\alias{[<-,SpatExtent,numeric,missing-method}

\alias{[<-,SpatVector,ANY,ANY-method}
\alias{[<-,SpatVector,ANY,missing-method}
\alias{[<-,SpatVector,missing,ANY-method}

\title{Replace values of a SpatRaster}

\description{
Replace values of a SpatRaster. These are convenience functions for smaller objects only. For larger rasters see \code{\link{classify}} or \code{\link{subst}}
} 

\usage{
\S4method{[}{SpatRaster,ANY,ANY,ANY}(x, i, j, k) <- value

\S4method{[}{SpatVector,ANY,ANY}(x, i, j) <- value

\S4method{[}{SpatExtent,numeric,missing}(x, i, j) <- value
}

\arguments{
  \item{x}{SpatRaster}
  \item{i}{row numbers. numeric, logical, or missing for all rows. Can also be a SpatRaster or SpatVector}
  \item{j}{column numbers. numeric, logical or missing for all columns}
  \item{k}{layer number. numeric, logical or missing for all layers}
  \item{value}{numeric, matrix, or data.frame}
}
 
\value{SpatRaster}

\seealso{\code{\link{classify}, \link{subst}, \link{set.values}, \link{values}, \link{[[<-}}}

\examples{
## SpatRaster
r <- rast(ncols=5, nrows=5, xmin=0, xmax=5, ymin=0, ymax=5)
r[] <- 1:25
r[1,] <- 5
r[,2] <- 10
r[r>10] <- NA

## SpatVector
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
v[2,2] <- "hello"
v[1,] <- v[10,]
v[,3] <- v[,1]
v[2, "NAME_2"] <- "terra"
head(v, 3)
}

\keyword{methods}
\keyword{spatial}

\docType{methods}
\name{watershed}

\alias{watershed}
\alias{watershed,SpatRaster-method}


\title{Catchment delineation}

\description{
delineate the area covered by a catchment from a SpatRaster with flow direction and a pour-point (catchment outlet).
}

\usage{
\S4method{watershed}{SpatRaster}(x, pourpoint, filename="",...) 
}

\arguments{
  \item{x}{SpatRaster with flow direction. See \code{\link{terrain}}. }
  \item{pourpoint}{matrix or SpatVector with the pour point location}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{ 
SpatRaster 
}

\author{
Ezio Crestaz, Emanuele Cordano, Roman Seliger
}

\examples{
elev <- rast(system.file('ex/elev_vinschgau.tif', package="terra"))
flowdir <- terrain(elev, "flowdir")
## pour point at Naturns 
pp <- cbind(653358.3, 5168222)
w <- watershed(flowdir, pp)
}

\keyword{spatial}

\name{inplace}

\alias{set.ext}
\alias{set.ext,SpatRaster-method}
\alias{set.ext,SpatVector-method}

\alias{set.values}
\alias{set.values,SpatRaster-method}
\alias{set.values,SpatRasterDataset-method}

\alias{set.RGB}
\alias{set.RGB,SpatRaster-method}

\alias{set.cats}
\alias{set.cats,SpatRaster-method}

\alias{set.names}
\alias{set.names,SpatRaster-method}
\alias{set.names,SpatRasterDataset-method}
\alias{set.names,SpatRasterCollection-method}
\alias{set.names,SpatVector-method}
\alias{set.names,SpatVectorCollection-method}

\alias{set.crs}
\alias{set.crs,SpatRaster-method}
\alias{set.crs,SpatVector-method}

\alias{set.window}
\alias{set.window,SpatRaster-method}
  
  
\title{Change values in-place}

\description{
These "in-place" replacement methods assign new value to an object without making a copy. That is efficient, but if there is a copy of the object that you made by standard assignment (e.g. with \code{y <- x}), that copy is also changed.

\code{set.names} is the in-place replacement version of \code{\link{names<-}}.
 
\code{set.ext} is the in-place replacement version of \code{\link{ext<-}}

\code{set.values} is the in-place replacement version of \code{\link{[<-}}.

\code{set.cats} is the in-place replacement version of \code{\link{categories}}

\code{set.crs} is the in-place replacement version of \code{\link{crs<-}}

\code{set.window} is the in-place replacement version of \code{\link{window<-}}
}

\usage{
\S4method{set.names}{SpatRaster}(x, value, index=1:nlyr(x), validate=FALSE)
\S4method{set.names}{SpatRasterDataset}(x, value, index=1:length(x), validate=FALSE)
\S4method{set.names}{SpatVector}(x, value, index=1:ncol(x), validate=FALSE)

\S4method{set.ext}{SpatRaster}(x, value)
\S4method{set.ext}{SpatVector}(x, value)

\S4method{set.crs}{SpatRaster}(x, value)
\S4method{set.crs}{SpatVector}(x, value)

\S4method{set.values}{SpatRaster}(x, cells, values, layer=0)
\S4method{set.values}{SpatRasterDataset}(x)

\S4method{set.cats}{SpatRaster}(x, layer=1, value, active=1)

\S4method{set.RGB}{SpatRaster}(x, value, type="rgb")
}

\arguments{
  \item{x}{SpatRaster}
  \item{value}{character for \code{set.names}. For \code{set.cats}: a data.frame with columns (value, category) or vector with category names. For \code{set.RGB} 3 or 4 numbers indicating the RGB(A) layers}
  \item{index}{positive integer indicating layer(s) to assign a name to}
  \item{validate}{logical. Make names valid and/or unique?}

  \item{cells}{cell numbers or missing}
  \item{values}{replacement values or missing to load all values into memory}

  \item{layer}{positive integer(s) indicating to which layer(s) to you want to assign these categories or to which you want to set these values. A number < 1 indicates "all layers"}
  
  \item{active}{positive integer indicating the active category (column number in \code{value}, but not counting the first column}
  
  \item{type}{character. The color space. One of "rgb" "hsv", "hsi" and "hsl"}  
}

\value{logical (invisibly)}

\examples{
s <- rast(ncols=5, nrows=5, nlyrs=3)
x <- s
names(s)
names(s) <- c("a", "b", "c")
names(s)
names(x)

x <- s
set.names(s, c("e", "f", "g"))
names(s)
names(x)

set.ext(x, c(0,180,0,90))

f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)

#values from file to memory
set.values(r)

# change values
set.values(r, 1:1000, 900)
}

\keyword{spatial}

\name{inset}

\docType{methods}

\alias{inset}
\alias{inset,SpatVector-method}
\alias{inset,SpatRaster-method}

\alias{inext}
\alias{inext,SpatVector-method}

\title{Make an inset map}

\description{
Make an inset map or scale the extent of a SpatVector
}

\usage{
\S4method{inset}{SpatVector}(x, e, loc="", scale=0.2, background="white", 
	perimeter=TRUE, box=NULL, pper, pbox, offset=0.1, add=TRUE, ...)

\S4method{inset}{SpatRaster}(x, e, loc="", scale=0.2, background="white", 
	perimeter=TRUE, box=NULL, pper, pbox, offset=0.1, add=TRUE, ...)

\S4method{inext}{SpatVector}(x, e, y=NULL, gap=0)
}

\arguments{
  \item{x}{SpatVector, SpatRaster}
  \item{e}{SpatExtent to set the size and location of the inset. Or missing}
  \item{loc}{character. One of "bottomright", "bottom", "bottomleft", "left", "topleft", "top", "topright", "right", "center"}
  \item{scale}{numeric. The relative size of the inset, used when x is missing}
  \item{background}{color for the background of the inset. Use \code{NA} for no background color}
  \item{perimeter}{logical. If \code{TRUE} a perimeter (border) is drawn around the inset}
  \item{box}{SpatExtent or missing, to draw a box on the inset, e.g. to show where the map is located in a larger area}
  \item{pper}{list with graphical parameters (arguments) such as \code{col} and \code{lwd} for the perimeter line}
  \item{pbox}{list with graphical parameters (arguments) such as \code{col} and \code{lwd} for the box (line)}
  \item{offset}{numeric. Value between 0.1 and 1 to indicate the relative distance between what is mapped and the bounding box}
  \item{add}{logical. Add the inset to the map?}
  \item{...}{additional arguments passed to plot for the drawing of \code{x}}
  \item{y}{SpatVector. If not NULL, \code{y} is scaled based with the parameters for \code{x}. This is useful, for example, when \code{x} represent boundaries, and \code{y} points within these boundaries}
  \item{gap}{numeric to add space between the SpatVector and the SpatExtent}
}


\seealso{\code{\link{sbar}}, \code{\link{rescale}}, \code{\link{shift}}}


\value{scaled and shifted SpatVector or SpatRaster (returned invisibly)}

\examples{ 
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
x <- v[v$NAME_2 == "Diekirch", ]

plot(x, density=10, col="blue")
inset(v)

# more elaborate
plot(x, density=10, col="blue")
inset(v, col = "brown", border="lightgrey", perimeter=TRUE, 
		pper=list(col="orange", lwd=3, lty=2), 
		box=ext(x), pbox=list(col="blue", lwd=2))

cols <- rep("light grey", 12)
cols[2] <- "red"
e <- ext(c(6.2, 6.3, 49.9, 50))
b <- ext(x)+0.02
inset(v, e=e, col=cols, box=b)

# with a SpatRaster
ff <- system.file("ex/elev.tif", package="terra")
r <- rast(ff)
r <- crop(r, ext(x) + .01)
plot(r, type="int", mar=c(2,2,2,2), plg=list(x="topright"))
lines(v, lwd=1.5)
lines(x, lwd=2.5)
inset(v, col=cols, loc="topleft", scale=0.15)

# a more complex one
plot(r, plg=list(title="meter\n", shrink=.2, cex=.8))
lines(v, lwd=4, col="white")
lines(v, lwd=1.5)
lines(x, lwd=2.5)
text(x, "NAME_2", cex=1.5, halo=TRUE)
sbar(6, c(6.04, 49.785), type="bar", below="km", label=c(0,3,6), cex=.8)
s <- inset(v, col=cols, box=b, scale=.2, loc="topright", background="light yellow",
	pbox=list(lwd=2, lty=5, col="blue"))

# note the returned inset SpatVector
s
lines(s, col="orange")
}

\keyword{methods}
\keyword{spatial}

\name{make.RGB}

\alias{make.RGB}

\title{Create a RGB SpatRaster}

\description{
Make a Red-Green-Blue SpatRaster from a single layer
}


\usage{
make.RGB(x, col=grDevices::rainbow(25), breaks=NULL, alpha=FALSE, colNA="white", 
		zlim=NULL, zlimcol=NULL, ext=NULL, filename="", ...)
}

\value{SpatRaster}

\arguments{
  \item{x}{RasterLayer}
  \item{col}{A color palette, that is a vector of n contiguous colors generated by functions like \link{rainbow}, \link{heat.colors}, \link{topo.colors}, \link[sp]{bpy.colors} or one or your own making, perhaps using \code{\link{colorRampPalette}}. If none is provided, \code{rev(terrain.colors(255))} is used unless \code{x} has a 'color table'}
  \item{breaks}{numeric. A set of finite numeric breakpoints for the colours: must have one more breakpoint than colour and be in increasing order}  
  \item{alpha}{If \code{TRUE} a fourth layer to set the background transparency is added}
  \item{colNA}{color for the background (\code{NA} values)}
  \item{zlim}{vector of lenght 2. Range of values to plot}
  \item{zlimcol}{If \code{NULL} the values outside the range of zlim get the color of the extremes of the range. If zlimcol has any other value, the values outside the zlim range get the color of \code{NA} values (see colNA)}
  \item{ext}{SpatExtent. Can be used to spatially subset the area covered to a region of interest}
  \item{filename}{character. Output filename}
  \item{...}{options for writing files as in \code{\link{writeRaster}}}
}


\seealso{ \code{\link{RGB}}}

\examples{
r <- rast(system.file("ex/elev.tif", package="terra"))
x <- make.RGB(r)
plot(x)
}

\keyword{spatial}

\name{writeCDF}

\alias{writeCDF}
\alias{writeCDF,SpatRasterDataset-method}
\alias{writeCDF,SpatRaster-method}

\title{Write raster data to a NetCDF file}

\description{
Write a SpatRaster or SpatRasterDataset to a NetCDF file. 

When using a SpatRasterDataset, the varname, longname, and unit should be set in the object (see examples).

Always use the \code{".nc"} or \code{".cdf"} file extension to assure that the file can be properly read again by GDAL

You can write multiple rasters (variables) that are two (x, y), three (x, y, z or x, y, time) or four dimensional (x, y, z, time).

See \code{\link{depth}} and \code{\link{time}} for specifying the axes of the third and/or fourth dimension(s).
}

\usage{
\S4method{writeCDF}{SpatRaster}(x, filename, varname, longname="", unit="", split=FALSE, ...)

\S4method{writeCDF}{SpatRasterDataset}(x, filename, overwrite=FALSE, timename="time", atts="", 
    gridmap="", prec="float", compression=NA, missval, tags=FALSE, ...)
}

\arguments{
  \item{x}{SpatRaster or SpatRasterDataset}
  \item{filename}{character. Output filename}
  \item{varname}{character. Name of the dataset}
  \item{longname}{character. Long name of the dataset}
  \item{unit}{character. Unit of the data}
  \item{split}{logical. If \code{TRUE} each layer of \code{x} is treated as a sub-dataset}
  \item{atts}{character. A vector of additional global attributes to write. They must be formatted like \code{c("x=a value", "y=abc")}}
  \item{gridmap}{character. The crs is always written to the file in standard formats. With this argument you can also write the format commonly used in netcdf files. Something like \code{c("grid_mapping_name=lambert_azimuthal_equal_area", "longitude_of_projection_origin=10", "latitude_of_projection_origin=52", "false_easting=4321000", "false_northing=3210000")}}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{timename}{character. The name of the "time" dimension}
  \item{prec}{character. One of "double", "float", "integer", "short", "byte" or "char"}
  \item{compression}{Can be set to an integer between 1 (least compression) and 9 (most compression)}
  \item{missval}{numeric, the number used to indicate missing values}
  \item{tags}{logical. If \code{TRUE} the values returned by \code{\link{metags}} are written to the file as attributes}
  \item{...}{additional arguments passed on to the SpatRasterDataset method, and from there possibly to \code{\link[ncdf4]{ncvar_def}}}
}

\value{
SpatRaster or SpatDataSet
}

\seealso{
see \code{\link{writeRaster}} for writing other file formats
}

\examples{

f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
fname <- paste0(tempfile(), ".nc")
rr <- writeCDF(r, fname, overwrite=TRUE, varname="alt", 
      longname="elevation in m above sea level", unit="m")

a <- rast(ncols=5, nrows=5, nl=50)
values(a) <- 1:prod(dim(a))
time(a) <- as.Date("2020-12-31") + 1:nlyr(a)
aa <- writeCDF(a, fname, overwrite=TRUE, varname="power", 
      longname="my nice data", unit="U/Pa")

b <- sqrt(a)
s <- sds(a, b)
names(s) <- c("temp", "prec")
longnames(s) <- c("temperature (C)", "precipitation (mm)")
units(s) <- c("°C", "mm")
ss <- writeCDF(s, fname, overwrite=TRUE)

# four dimensional 
r1 <- rast(nrow=5, ncol=5, vals=1:100, nlyr=4)
depth(r1) <- c(0, 2, 0, 2)
time(r1) <- c(as.Date("2012-12-12") + c(1,1,2,2))
depthName(r1) <- "angle"

r2 <- rast(nrow=5, ncol=5, vals=1:150, nlyr=6)
depth(r2) <- c(10, 10, 20, 20, 30, 30)
time(r2) <- c(as.Date("2012-12-12") + c(1:2, 1:2, 1:2))
depthName(r2) <- "height"
depthUnit(r2) <- "cm"

s <- sds(r1, r2)
names(s) <- c("TH", "DBZH")
units(s) <- c("-", "Pa")
x <- writeCDF(s, filename = fname, overwrite=TRUE)
x[1]
time(x[1])
depth(x[1])

x[2]
time(x[2])
depth(x[2])

# for CRAN
file.remove(fname)
}

\keyword{ spatial }
\keyword{ methods }

\name{focalCpp}

\alias{focalCpp}
\alias{focalCpp,SpatRaster-method}


\title{Compute focal values with an iterating C++ function}

\description{
Calculate focal values with a C++ function that iterates over cells to speed up computations by avoiding an R loop (with apply).

See \code{\link{focal}} for an easier to use method. 
}

\usage{
\S4method{focalCpp}{SpatRaster}(x, w=3, fun, ..., fillvalue=NA, 
		silent=TRUE, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
\item{x}{SpatRaster}
\item{w}{window. The window can be defined as one (for a square) or two numbers (row, col); or with an odd-sized weights matrix. See the Details section in \code{\link{focal}}}

\item{fun}{\code{\link[Rcpp]{cppFunction}} that iterates over cells. For C++ functions that operate on a single focal window, or for R functions use \code{\link{focal}} instead. The function must have at least three arguments. The first argument can have any name, but it must be a \code{Rcpp::NumericVector}, \code{Rcpp::IntegerVector} or a \code{std::vector<double>}. This is the container that receives the focal values. The other two arguments \code{ni} and \code{wi} must be of type \code{size_t}. \code{ni} represents the number of cells and \code{nw} represents the size of (number of elements in) the window}

\item{...}{additional arguments to \code{fun}}

\item{fillvalue}{numeric. The value of the cells in the virtual rows and columns outside of the raster}

\item{silent}{logical. If \code{TRUE} error messages are printed that may occur when trying \code{fun} to determine the length of the returned value. This can be useful in debugging a \code{fun} that does not work}

\item{filename}{character. Output filename}
\item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}

\item{wopt}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{SpatRaster}


\seealso{ \code{\link{focal}}, \code{\link{focalValues}} }


\examples{
\dontrun{
library(Rcpp)
cppFunction( 
	'NumericVector sum_and_multiply(NumericVector x, double m, size_t ni, size_t nw) {
		NumericVector out(ni);
		// loop over cells
		size_t start = 0;
		for (size_t i=0; i<ni; i++) {
			size_t end = start + nw;
			// compute something for a window
			double v = 0;
			// loop over the values of a window
			for (size_t j=start; j<end; j++) {
				v += x[j];
			}
			out[i] = v * m;
			start = end;
		}
		return out;
	}'
)

nr <- nc <- 10
r <- rast(ncols=nc, nrows=nr, ext= c(0, nc, 0, nr))
values(r) <- 1:ncell(r)

raw <- focalCpp(r, w=3, fun=sum_and_multiply, fillvalue=0, m=10)

# same as
f1 <- focal(r, w=3, fun=sum, fillvalue=0) *10
all(values(f1) == values(raw))

# and as
ffun <- function(x, m) { sum(x) * m }
f2 <- focal(r, w=3, fun=ffun, fillvalue=0, m=10)


# You can also use an R function with focalCpp but this
# is not recommended 

R_sm_iter <- function(x, m, ni, nw) {
	out <- NULL
	for (i in 1:ni) {
		start <- (i-1) * nw + 1
		out[i] <- sum(x[start:(start+nw-1)]) * m
	}
	out
}

fr <- focalCpp(r, w=3, fun=R_sm_iter, fillvalue=0, m=10)

}
}


\keyword{spatial}

\name{selectHighest}

\docType{methods}

\alias{selectHighest}
\alias{selectHighest,SpatRaster-method}

\title{select cells with high or low values}

\description{
Identify n cells that have the highest or lowest values in the first layer of a SpatRaster. 
}

\usage{
\S4method{selectHighest}{SpatRaster}(x, n, low=FALSE)
}

\arguments{
  \item{x}{SpatRaster. Only the first layer is processed}
  \item{n}{The number of cells to select}
  \item{low}{logical. If \code{TRUE}, the lowest values are selected instead of the highest values}
}


\value{
SpatRaster
}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
x <- selectHighest(r, 1000)
y <- selectHighest(r, 1000, TRUE)

m <- merge(y-1, x)
levels(m) <- data.frame(id=0:1, elevation=c("low", "high"))
plot(m)
}

\keyword{spatial}

\name{setValues}

\docType{methods}

\alias{values<-}
\alias{values<-,SpatRaster,ANY-method}

\alias{setValues}
\alias{setValues,SpatRaster-method}
\alias{setValues,SpatRaster,ANY-method}

\alias{values<-,SpatVector,data.frame-method}
\alias{values<-,SpatVector,matrix-method}
\alias{values<-,SpatVector,ANY-method}
\alias{values<-,SpatVector,NULL-method}

\alias{setValues,SpatVector-method}
\alias{setValues,SpatVector,ANY-method}

  
\title{Set the values of raster cells or of geometry attributes}

\description{
Set cell values of a SpatRaster or the attributes of a SpatVector. For large SpatRasters use \code{\link{init}} instead to set values. 
}

\usage{
\S4method{values}{SpatRaster,ANY}(x)<-value

\S4method{setValues}{SpatRaster,ANY}(x, values, keeptime=TRUE, keepunits=TRUE, keepnames=FALSE, props=FALSE)

\S4method{values}{SpatVector,ANY}(x)<-value
}


\arguments{
 \item{x}{SpatRaster or SpatVector}
 \item{value}{For SpatRaster: numeric, matrix or data.frame. The length of the numeric values must match the total number of cells (ncell(x) * nlyr(x)), or be a single value. The number of columns of the matrix or data.frame must match the number of layers of \code{x}, and the number of rows must match the number of cells of \code{x}. It is also possible to use a matrix with the same number of rows as \code{x} and the number of columns that matches \code{ncol(x) * nlyr(x)}. 

 For SpatVector: data.frame, matrix, vector, or NULL}
 \item{values}{Same as for \code{value}}
 \item{keeptime}{logical. If \code{TRUE} the time stamps are kept}
 \item{keepunits}{logical. If \code{FALSE} the units are discarded}
 \item{keepnames}{logical. If \code{FALSE} the layer names are replaced by the column names in \code{y} (if present)}
 \item{props}{logical. If \code{TRUE} the properties (categories and color-table) are kept}
}


\value{
The same object type as \code{x}
}


\seealso{\code{\link{values}}, \code{\link{init}}}

\examples{
f <- system.file("ex/elev.tif", package="terra")
r <- rast(f)
x <- setValues(r, 1:ncell(r))
x
values(x) <- runif(ncell(x))
x
head(x)

f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
values(v) <- data.frame(ID=1:12, name=letters[1:12])
head(v)
}

\keyword{spatial}
\keyword{methods}

\name{rapp}

\docType{methods}

\alias{rapp}
\alias{rapp,SpatRaster-method}

\title{Range-apply}

\description{
Apply a function to a range of the layers of a SpatRaster that varies by cell. The range is specified for each cell with one or two SpatRasters (arguments \code{first} and \code{last}). For either \code{first} or \code{last} you can use a single number instead. 

You cannot use single numbers for both \code{first} and \code{last} because in that case you could use \code{\link{app}} or \code{\link{Summary-methods}}, perhaps \code{\link{subset}}ting the layers of a SpatRaster.

See \code{\link{selectRange}} to create a new SpatRaster by extracting one or more values starting at a cell-varying layer.
}

\usage{
\S4method{rapp}{SpatRaster}(x, first, last, fun, ..., allyrs=FALSE, fill=NA, 
        clamp=FALSE, circular=FALSE, filename="", overwrite=FALSE, wopt=list())
}

\arguments{
  \item{x}{SpatRaster}
  \item{first}{SpatRaster or positive integer between 1 and nlyr(x), indicating the first layer in the range of layers to be considered}
  \item{last}{SpatRaster or positive integer between 1 and nlyr(x), indicating the last layer in the range to be considered}  
  \item{fun}{function to be applied}
  \item{...}{additional arguments passed to \code{fun}} 
  \item{allyrs}{logical. If \code{TRUE}, values for all layers are passed to \code{fun} but the values outside of the range are set to \code{fill}}
  \item{fill}{numeric. The fill value for the values outside of the range, for when \code{allyrs=TRUE}} 
  \item{clamp}{logical. If \code{FALSE} and the specified range is outside \code{1:nlyr(x)} all cells are considered \code{NA}. Otherwise, the invalid part of the range is ignored} 
  \item{circular}{logical. If \code{TRUE} the values are considered circular, such as the days of the year. In that case, if first > last the layers used are c(first:nlyr(x), 1:last). Otherwise, the range would be considered invalid and \code{NA} would be returned} 
  \item{filename}{character. Output filename}
  \item{overwrite}{logical. If \code{TRUE}, \code{filename} is overwritten}
  \item{wopt}{list with named options for writing files as in \code{\link{writeRaster}}}
}

\value{
SpatRaster
}

\seealso{\code{\link{selectRange}}, \code{\link{app}}, \code{\link{Summary-methods}}, \code{\link{lapp}}, \code{\link{tapp}}}

\examples{
r <- rast(ncols=9, nrows=9)
values(r) <- 1:ncell(r)
s <- c(r, r, r, r, r, r)
s <- s * 1:6
s[1:2] <- NA
start <- end <- rast(r)
start[] <- 1:3
end[]   <- 4:6
a <- rapp(s, start, end, fun="mean")
b <- rapp(s, start, 2, fun="mean")

# cumsum from start to nlyr(x). return all layers
r <- rapp(s, start, nlyr(s), cumsum, allyrs=TRUE, fill=0)
# return only the final value
rr <- rapp(s, start, nlyr(s), function(i) max(cumsum(i)))
}

\keyword{methods}
\keyword{spatial}

\name{unique}

\docType{methods}

\alias{unique}
\alias{unique,SpatRaster-method}
\alias{unique,SpatRaster,ANY-method}
\alias{unique,SpatVector-method}
\alias{unique,SpatVector,ANY-method}

\title{Unique values}

\description{
This method returns the unique values in a SpatRaster, or removes duplicates records (geometry and attributes) in a SpatVector. 
}

\usage{
\S4method{unique}{SpatRaster}(x, incomparables=FALSE, digits=NA, na.rm=TRUE, as.raster=FALSE) 

\S4method{unique}{SpatVector}(x, incomparables=FALSE, geom=TRUE, atts=TRUE, ...) 
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{incomparables}{logical. If \code{FALSE} and \code{x} is a SpatRaster: the unique values are determined for all layers together, and the result is a matrix. If \code{TRUE}, each layer is evaluated separately, and a list is returned. If \code{x} is a SpatVector this argument is as for a \code{data.frame}}
  \item{digits}{integer. The number of digits for rounding the values before finding the unique values. Use \code{NA} means to not do any rounding}
  \item{na.rm}{logical. If \code{TRUE}, \code{NaN} is included if there are any missing values}  
  \item{as.raster}{logical. If \code{TRUE}, a single-layer categorical SpatRaster with the unique values is returned}  
  \item{...}{additional arguments passed on to \code{\link[base]{unique}} or \code{\link[base]{identical}}}  
  \item{geom}{logical. If \code{TRUE} the geometries are considered to determine uniqueness}  
  \item{atts}{logical. If \code{TRUE} the attribute values are considered to determine uniqueness}  
}


\value{
If \code{x} is a SpatRaster: data.frame or list (if \code{incomparables=FALSE})

If \code{x} is a SpatVector: SpatVector
}


\examples{
r <- rast(ncols=5, nrows=5)
values(r) <- rep(1:5, each=5)
unique(r)
s <- c(r, round(r/3))
unique(s)
unique(s,TRUE)

unique(s, as.raster=TRUE)


v <- vect(cbind(x=c(1:5,1:5), y=c(5:1,5:1)), 
		crs="+proj=utm +zone=1 +datum=WGS84")
nrow(v)
u <- unique(v)
nrow(u)

values(v) <- c(1:5, 1:3, 5:4)
unique(v)
}

\keyword{spatial}

\name{width}

\docType{methods}

\alias{width}
\alias{clearance}

\alias{width,SpatVector-method}
\alias{clearance,SpatVector-method}

\title{ 
SpatVector geometric properties
}

\description{
\code{width} returns the minimum diameter of the geometry, defined as the smallest band that contains the geometry, where a band is a strip of the plane defined by two parallel lines. This can be thought of as the smallest hole that the geometry can be moved through, with a single rotation.

\code{clearance} returns the minimum clearance of a geometry. The minimum clearance is the smallest amount by which a vertex could be moved to produce an invalid polygon, a non-simple linestring, or a multipoint with repeated points. If a geometry has a minimum clearance of 'mc', it can be said that "no two distinct vertices in the geometry are separated by less than "mc". No vertex is closer than "mc" to a line segment of which it is not an endpoint". 

If the minimum clearance cannot be defined for a geometry (such as with a single point), \code{NA} is returned.
}

\usage{
\S4method{width}{SpatVector}(x, as.lines=FALSE)
\S4method{clearance}{SpatVector}(x, as.lines=FALSE)
}

\arguments{
  \item{x}{SpatVector of lines or polygons}
  \item{as.lines}{logical. If \code{TRUE} lines are returned that define the width or clearance}
} 

\value{
numeric or SpatVector
}

\seealso{
\code{\link{hull}}
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)

width(v)
clearance(v)

width_lines <- width(v, as.lines=TRUE)
plot(v)
lines(width_lines, col="blue")
}

\keyword{methods}
\keyword{spatial}

\name{disagg}

\docType{methods}

\alias{disagg}
\alias{disagg,SpatRaster-method}
\alias{disagg,SpatVector-method}

\title{Disaggregate raster cells or vector geometries}

\description{
\code{SpatRaster}: Create a SpatRaster with a higher resolution (smaller cells). The values in the new SpatRaster are the same as in the larger original cells.

\code{SpatVector}: Separate multi-objects (points, lines, polygons) into single objects; or further into segments (for lines or polygons).
}

\usage{
\S4method{disagg}{SpatRaster}(x, fact, method="near", filename="", ...)

\S4method{disagg}{SpatVector}(x, segments=FALSE)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{fact}{positive integer. Aggregation factor expressed as number of cells in each direction (horizontally and vertically). Or two integers (horizontal and vertical aggregation factor) or three integers (when also aggregating over layers)}  
  \item{method}{character. Either "near" for nearest or "bilinear" for bilinear interpolation}
  \item{segments}{logical. Should (poly-)lines or polygons be disaggregated into their line-segments?}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}


\seealso{\code{\link{aggregate}}, \code{\link{resample}}}

\value{
SpatRaster
}


\examples{
r <- rast(ncols=10, nrows=10)
rd <- disagg(r, fact=c(10, 2))
ncol(rd)
nrow(rd)
values(r) <- 1:ncell(r)
rd <- disagg(r, fact=c(4, 2))

}


\keyword{methods}
\keyword{spatial}

\name{surfArea}

\alias{surfArea}
\alias{surfArea,SpatRaster-method}

\title{
Compute surface area from elevation data
}

\description{
It is often said that if Wales was flattened out it would have an area bigger than England. This function computes the surface area for a raster with elevation values, taking into account the sloping nature of the surface.
}

\usage{
\S4method{surfArea}{SpatRaster}(x, filename="", ...)
}

\arguments{
  \item{x}{SpatRaster with elevation values. Currently the raster CRS must be planar and have the same distance units (e.g. m) as the elevation values}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link{writeRaster}}}
}

\value{SpatRaster}

\seealso{\code{\link{expanse}}, \code{\link{cellSize}}}

\references{
Jenness, Jeff S., 2004. Calculating Landscape Surface Area from Digital Elevation Models. Wildlife Society Bulletin 32(3): 829-839
}

\author{
Barry Rowlingson 
}

\examples{
v <- rast(volcano, crs="local")
x <- terra::surfArea(v)
}

\keyword{spatial}

\name{varnames}

\alias{varnames}
\alias{varnames<-}
\alias{longnames}
\alias{longnames<-}

\alias{varnames,SpatRaster-method}
\alias{varnames<-,SpatRaster-method}

\alias{longnames,SpatRaster-method}
\alias{longnames<-,SpatRaster-method}

\alias{varnames,SpatRasterDataset-method}
\alias{varnames<-,SpatRasterDataset-method}
\alias{longnames,SpatRasterDataset-method}
\alias{longnames<-,SpatRasterDataset-method}

 
\title{variable and long variable names}

\description{
Set or get names for each dataset (variable) in a SpatRasterDataset. 

Each SpatRaster \emph{data source} can also have a variable name and a long variable name. They are set when reading a file with possibly multiple sub-datasets (e.g. NetCDF or HDF5 format) into a single SpatRaster. Each sub-dataset is a separate "data-source" in the SpatRaster. Note that newly created or derived SpatRasters always have a single variable (data source), and therefore the variable names are lost when processing a multi-variable SpatRaster. Thus the variable names are mostly useful to understand a SpatRaster created from some files and for managing SpatRasterDatasets.

See \code{\link{names}} for the more commonly used \emph{layer} names.

}

\usage{
\S4method{varnames}{SpatRaster}(x)

\S4method{varnames}{SpatRaster}(x)<-value

\S4method{longnames}{SpatRaster}(x)

\S4method{longnames}{SpatRaster}(x)<-value

\S4method{varnames}{SpatRasterDataset}(x)

\S4method{varnames}{SpatRasterDataset}(x)<-value

\S4method{longnames}{SpatRasterDataset}(x)

\S4method{longnames}{SpatRasterDataset}(x)<-value
}

\arguments{
  \item{x}{SpatRaster, SpatRasterDataset}
  \item{value}{character (vector)}
}

\value{
character 
}

\note{
terra enforces neither unique nor valid names. See \code{\link{make.unique}} to create unique names and \code{\link{make.names}} to make syntactically valid names.
}

\examples{
s <- rast(ncols=5, nrows=5, nlyrs=3)
names(s) <- c("a", "b", "c")
x <- sds(s, s)
varnames(x) <- c("one", "two")
x
}

\keyword{spatial}

\name{densify}

\docType{methods}

\alias{densify}
\alias{densify,SpatVector-method}

\title{ 
Add additional nodes to lines or polygons
}

\description{
Add additional nodes to lines or polygons. This can be useful to do prior to using \code{project} such that the path does not change too much.
}

\usage{
\S4method{densify}{SpatVector}(x, interval, equalize=TRUE, flat=FALSE)
}

\arguments{
  \item{x}{SpatVector}
  \item{interval}{positive number, specifying the desired minimum distance between nodes. The unit is meter for lonlat data, and in the linear unit of the crs for planar data}
  \item{equalize}{logical. If \code{TRUE}, new nodes are spread at equal intervals between old nodes}
  \item{flat}{logical. If \code{TRUE}, the earth's curvature is ignored for lonlat data, and the distance unit is degrees, not meter}
} 

\value{
SpatVector
}

\seealso{\code{\link{simplifyGeom}}, \code{\link{thinNodes}}}

\examples{
v <- vect(rbind(c(-120,-20), c(-80,5), c(-40,-60), c(-120,-20)), 
  type="polygons", crs="+proj=longlat")
vd <- densify(v, 200000)

p <- project(v, "+proj=robin")
pd <- project(vd, "+proj=robin")

# good 
plot(pd, col="gray", border="red", lwd=10)
points(pd, col="gray")

# bad
lines(p, col="blue", lwd=3)
points(p, col="blue", cex=2)
plot(p, col="blue", alpha=.1, add=TRUE)
legend("topright", c("good", "bad"), col=c("red", "blue"), lty=1, lwd=3)

## the other way around does not work
## unless the original data was truly planar (e.g. derived from a map)
x <- densify(p, 250000)
y <- project(x, "+proj=longlat")
# bad
plot(y)
# good
lines(vd, col="red")
}

\keyword{methods}
\keyword{spatial}

\name{compareGeom}

\alias{compareGeom}
\alias{compareGeom,SpatRaster,SpatRaster-method}
\alias{compareGeom,SpatRaster,SpatRasterCollection-method}

\alias{compareGeom,SpatRaster,list-method}
\alias{compareGeom,SpatRasterCollection,missing-method}

\alias{compareGeom,SpatVector,SpatVector-method}
\alias{compareGeom,SpatVector,missing-method}
  
\title{Compare geometries}

\description{
Evaluate whether two SpatRasters have the same extent, number of rows and columns, projection, resolution, and origin (or a subset of these comparisons). 

Or evaluate whether two SpatVectors have the same geometries, or whether a SpatVector has duplicated geometries. 
}

\usage{
\S4method{compareGeom}{SpatRaster,SpatRaster}(x, y, ..., lyrs=FALSE, crs=TRUE, warncrs=FALSE, ext=TRUE,
	rowcol=TRUE, res=FALSE, stopOnError=TRUE, messages=FALSE, tolerance=NULL)

\S4method{compareGeom}{SpatVector,SpatVector}(x, y, tolerance=0)

\S4method{compareGeom}{SpatVector,missing}(x, y, tolerance=0)
}

\arguments{
  \item{x}{SpatRaster or SpatVector}
  \item{y}{Same as \code{x}. If \code{x} is a SpatRaster, \code{y} can also be a list of SpatRasters. If \code{x} is a SpatVector, \code{y} can be missing}
  \item{...}{Additional SpatRasters}
  \item{lyrs}{logical. If \code{TRUE}, the number of layers is compared}
  \item{crs}{logical. If \code{TRUE}, coordinate reference systems are compared}
  \item{warncrs}{logical. If \code{TRUE}, a warning is given if the crs is different (instead of an error)}
  \item{ext}{logical. If \code{TRUE}, bounding boxes are compared}
  \item{rowcol}{logical. If \code{TRUE}, number of rows and columns of the objects are compared}
  \item{res}{logical. If \code{TRUE}, resolutions are compared (redundant when checking extent and rowcol)}
  \item{stopOnError}{logical. If \code{TRUE}, code execution stops if raster do not match}
  \item{messages}{logical. If \code{TRUE}, warning/error messages are printed even if \code{stopOnError=FALSE}}
  \item{tolerance}{numeric. For \code{SpatRaster} objects this is the difference in raster extent (expressed as the fraction of the raster resolution) that can be ignored when comparing alignment of rasters. If \code{NULL} the value shown by \code{\link{terraOptions}} is used}
}

\value{
logical (SpatRaster) or matrix of logical (SpatVector)
} 

\examples{
r1 <- rast()
r2 <- rast()
r3 <- rast()
compareGeom(r1, r2, r3)
nrow(r3) <- 10


\dontrun{
# this fails because the number of rows is different
try(compareGeom(r1, r3))
}
}

\keyword{spatial}
